// jQuery File Tree Plugin
//
// Version 1.01
//
// Cory S.N. LaViska
// A Beautiful Site (http://abeautifulsite.net/)
// 24 March 2008
//
// Visit http://abeautifulsite.net/notebook.php?article=58 for more information
//
// Usage: $('.fileTreeDemo').fileTree( options, callback )
//
// Options:  root           - root folder to display; default = /
//           script         - location of the serverside AJAX file to use; default = jqueryFileTree.php
//           folderEvent    - event to trigger expand/collapse; default = click
//           expandEasing   - easing function to use on expand (optional)
//           collapseEasing - easing function to use on collapse (optional)
//           multiFolder    - whether or not to limit the browser to one subfolder at a time
//
// History:
//
// 1.01 - updated to work with foreign characters in directory/file names (12 April 2008)
// 1.00 - released (24 March 2008)
//
// TERMS OF USE
// 
// This plugin is dual-licensed under the GNU General Public License and the MIT License and
// is copyright 2008 A Beautiful Site, LLC. 
//
if(jQuery) (function($){
	
	$.extend($.fn, {
		mozyTree: function(o, h) {
			// Defaults
			if( !o ) var o = {};
			if( o.root == undefined ) o.root = 'share_root_path';
			if( o.script == undefined ) o.script = '/cgi-bin/filemanager/utilRequest.cgi?func=get_tree&generic=yes&sid='+sid;
			if( o.folderEvent == undefined ) o.folderEvent = 'click';
			if( o.folderEventCallback == undefined ) o.folderEventCallback = function(obj){};
			if( o.expandEasing == undefined ) o.expandEasing = null;
			if( o.collapseEasing == undefined ) o.collapseEasing = null;
			if( o.multiFolder == undefined ) o.multiFolder = true;
			if(o.postProcessing == undefined ) o.postProcessing = function(input){return input;};
			
			$(this).each( function() {
				
				function showTree(c, t, isRoot) {
					global_obj.ajaxLock = true;
					
					$(c).addClass('wait');                 
					
                    $.post(o.script, { node: t }, function(data) {
                        
                        $(c).find('UL').remove();
                        
                        var item = false;
                        var isCheckedText = '';
                        var isCheckedText2 = '';
						var parentCheckbox = $(c).children('div').children('a.checkbox');
						var isParentChecked = parentCheckbox.hasClass('checked') || parentCheckbox.hasClass('partial') || isRoot === true;
                        if(parentCheckbox.hasClass('checked')){
                            isCheckedText = ' checked="checked"';
                            isCheckedText2 = ' checked';
                        }
                        var directories = JSON.parse(data);
                        
                        if(!isRoot && (typeof directories == 'undefined' || directories == '' || directories.length == 0 || directories.status=='4')){                        
                            $(c).removeClass('wait');
                            $(c).addClass('emptyDirectory');
                            return;
                        }
                        
                        var index=0;
                        var newTree = $j('<ul class="mozyFileTree"></ul>');
                        var rootState = '';
                        
                        setTimeout(function(){
            
                            var start = +new Date();
                            
                            do{
								if(directories.length == 0) break;
							
                                var dText = directories[index].text;
                                var directory = directories[index++].id.replace('//', '/');
								
								if(directory.indexOf('/share/external/') == 0){
									//this is a usb mounted share
									if(isRoot){
										//create a mapping link
										var symLink = '/'+dText;
										global_obj.usbFolders.push({link:symLink, path:directory});
										
										//scan selected path
										var target = directory.replace(/^\/.*?\/.*?\//, '/');
										for(i=0, j=global_obj.selectedFilesList.length; i<j; i++){
											if(global_obj.selectedFilesList[i].indexOf(target)==0){
												global_obj.selectedFilesList[i] = global_obj.selectedFilesList[i].replace(target, symLink);
											}
										}
										
										directory = symLink;
									}else{
										for(i=0, j=global_obj.usbFolders.length; i<j; i++){
											var item = global_obj.usbFolders[i];
											if(directory.indexOf(item.path)==0){
												directory = directory.replace(item.path, item.link);
												break;
											}
										}
									}
								}else{                            
									if(isRoot===true){
										global_obj.rootFolders.push(directory);
										directory = directory.replace(/^\/.*?\/.*?\//, '/');
									}
								}
                                
                                var liContainer = $('<li class="directory collapsed"><img class="folderIcon" src="/ajax_obj/extjs/resources/images/default/s.gif"><div><img class="folderDisplay" src="/ajax_obj/images/directory.png"><a href="#" class="checkbox'+isCheckedText2+'">directories</a><input type="checkbox"'+isCheckedText+' name="directories" style="display: none;" value="' + directory + '/" />&nbsp;<label unselectable="on" rel="' + directory + '/" style="clear: right; text-align: left; width: auto; font-weight: normal;">' + dText + '</label></div></li>');
                                
                                var divContainer = liContainer.find('div');
                                divContainer.hover(function(){$(this).addClass('hover');}, function(){$(this).removeClass('hover');});
                                var $checkbox = divContainer.children('input:checkbox');
                                var $item = divContainer.children('a.checkbox');
                                var newPath = $checkbox.val();
                                $j.each(global_obj.selectedPath, function(index, selectedPath){
									if(selectedPath.indexOf('/share/external/') == 0){
										for(i=0, j=global_obj.usbFolders.length; i<j; i++){
											var item = global_obj.usbFolders[i];
											if(selectedPath.indexOf(item.path)==0){
												selectedPath = selectedPath.replace(item.path, item.link);
												break;
											}
										}
									}else{
										selectedPath = selectedPath.replace(/^\/.*?\/.*?\//, '/');
									}
                                    if(isParentChecked && newPath == selectedPath){
                                        $item.attr('class', 'checkbox checked');
                                        $checkbox.attr('checked', 'checked');
                                        rootState = ' partial';
                                        return false;
                                    }else if(isParentChecked && newPath != '' && selectedPath.indexOf(newPath) == 0){
                                        $item.attr('class', 'checkbox partial');
                                        rootState = ' partial';
                                        return false;
                                    }
                                });   
                                $item=null;
                                $checkbox=null;
                                
                                divContainer.bind('click', function(){
                                    var label = $(this).children('label');
                                    var rel = label.attr('rel');
                                    if(typeof rel == 'undefined'){
                                        return false;
                                    } 
									
                                    var labelParent = label.parent().parent();
                                    if( labelParent.hasClass('directory') ) {
                                            
                                        if( labelParent.hasClass('collapsed') ) {
                                            // Expand
                                            if( !o.multiFolder ) {
                                                labelParent.parent().find('UL').hide();
                                                labelParent.parent().find('LI.directory').removeClass('expanded').addClass('collapsed');
                                                updateSelection();
                                            }
                                            showTree( labelParent, label.attr('rel').match( /.*\// ) );
                                            labelParent.removeClass('collapsed').addClass('expanded');   
                                        } else {
                                            // Collapse              
                                            labelParent.find('UL').hide();
                                            labelParent.removeClass('expanded').addClass('collapsed');
                                            updateSelection();
                                        }   
                                            
                                    }
									
                                    o.folderEventCallback(label);
                                });
                                
                                liContainer.children('img.folderIcon').bind(o.folderEvent, function(e){                                
                                    var label = $(this).siblings('div').children('label');
                                    var rel = label.attr('rel');
                                    if(typeof rel == 'undefined'){
                                        return false;
                                    } 
                                    
                                    var labelParent = label.parent().parent();
                                    if( labelParent.hasClass('directory') ) {
                                            
                                        if( labelParent.hasClass('collapsed') ) {
                                            // Expand
                                            if( !o.multiFolder ) {
                                                labelParent.parent().find('UL').hide();
                                                labelParent.parent().find('LI.directory').removeClass('expanded').addClass('collapsed');
                                                updateSelection();
                                            }
                                            showTree( labelParent, label.attr('rel').match( /.*\// ) );
                                            labelParent.removeClass('collapsed').addClass('expanded');   
                                        } else {
                                            // Collapse              
                                            labelParent.find('UL').hide();
                                            labelParent.removeClass('expanded').addClass('collapsed');
                                            updateSelection();
                                        }   
                                            
                                    }
                                    return false;
                                });
                                
                                newTree.append(liContainer);
                                
                                divContainer = null;
                                liContainer = null;
                            }while(directories.length > index && (+new Date() - start < 50));
                
                            if(index < directories.length){
                                setTimeout(arguments.callee, 100);
                            }else{
                        
                                /**********************************************************************************************/
                                if(isRoot){
                                    var rootItem = $j('<ul class="mozyFileTree"><li class="directory expanded" style="background: none;" id="share_root" rel="share_root"><img class="folderIcon" src="/ajax_obj/extjs/resources/images/default/s.gif"><div><img class="folderDisplay" src="/ajax_obj/images/directory.png"><a href="#" class="checkbox shareRoot'+rootState+'">Heading</a><label><span class="label">&nbsp;Share Root</span><a href="#" style="padding: 0 6px; position: absolute;" onclick=" this.blur(); refreshBackupTree();"><img src="/cgi-bin/filemanager/images/common/refresh.gif" /></a></label></div></li></ul>');
                                    rootItem.find('li').append(newTree);
                                    item = rootItem;
                                }else{
                                    item = newTree;
                                }                  
                                newTree = null;
                                
                                if(item === false){
                                    $(c).removeClass('wait');
                                    $(c).addClass('emptyDirectory');
                                    return;
                                }
                                
                                item.tristate({
                                    app: 'local',
                                    labelCallBack: function(label, state, position){
                                        if(global_obj.filePanelObj == '') return;
                                        var rel = label.attr('rel');
                                        
                                        switch(position){
                                            case 'ancestor':                                
                                                //do nothing
                                            break;
                                            
                                            case 'origin':                                        
                                            case 'descendant':                  
                                                if(rel && rel == global_obj.filePanelObj.attr('rel')){
                                                    $j('#filePanel').find('input:checkbox').each(function(){
                                                        $j(this).attr('checked', ((state) ? 'checked' : ''));
                                                        $j(this).triggerHandler('click');
                                                    });
                                                }else{                                        
                                                    if(!state){
                                                        var tmp = global_obj.selectedFilesList;
                                                        global_obj.selectedFilesList = new Array();
                                                        for(index=0; index<tmp.length; index++){
                                                            if(tmp[index].indexOf(rel) == -1){
                                                                global_obj.selectedFilesList.push(tmp[index]);
                                                            }
                                                        }
                                                        tmp = null;
                                                    }
                                                }
                                            break;                                        
                                        }

                                    }
                                });
                                
                                if(isRoot) $j('#directoryTreeLoading').hide();
                                
                                $(c).removeClass('wait').append(item);     

								global_obj.ajaxLock = false;
                                
                                item = null;
                                c = null;
                                directories = null;
                                
                                /*************************************************************************************************/
                            }
                        }, 25);
                        
                        

                    });
				}
                
				// Get the initial file list
				showTree( $(this), escape(o.root), true );
			});
		}
	});
    
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//      MOZY RESTORE TREE
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
    
	$.extend($.fn, {
		mozyRestoreTree: function(o, h) {
			// Defaults
			if( !o ) var o = {};
			if( o.root == undefined ) o.root = '/share/%';
			if( o.script == undefined ) o.script = '/cgi-bin/backup/appMozy.cgi?action=7&sid='+sid;
			if( o.folderEvent == undefined ) o.folderEvent = 'click';
			if( o.folderEventCallback == undefined ) o.folderEventCallback = function(obj){};
			if( o.expandEasing == undefined ) o.expandEasing = null;
			if( o.collapseEasing == undefined ) o.collapseEasing = null;
			if( o.multiFolder == undefined ) o.multiFolder = true;
			if(o.postProcessing == undefined ) o.postProcessing = function(input){return input;};
			
			$(this).each( function() {
				
				function showTree(c, t, isRoot) {
					global_obj.ajaxLock = true;
					
					$(c).addClass('wait');
					
                    $.post(o.script, { node: t, param2: global_obj.restoreTimeFilter, param3: $j('#showDeletedRestore').attr('checked')?1:0 }, function(data) {
                        
                        $(c).find('UL').remove();
                        
                        var jsonObj = getJSON('json', data);
                        var directories = jsonObj.datas;
                        
                        if(!isRoot && (typeof directories == 'undefined' || directories == '' || directories.length == 0)){                        
                            $(c).removeClass('wait');
                            $(c).addClass('emptyDirectory');
                            return;
                        }
                        
                        var isCheckedText = '';
                        var isCheckedText2 = '';
						var parentCheckbox = $(c).children('div').children('a.checkbox');
						var isParentChecked = parentCheckbox.hasClass('checked') || parentCheckbox.hasClass('partial');
                        if(parentCheckbox.hasClass('checked')){
                            isCheckedText = ' checked="checked"';
                            isCheckedText2 = ' checked';
                        }
                        
                        var item = false;                        
                        
                        var index=0;
                        var newTree = $j('<ul class="mozyFileTree"></ul>');
                        
                        setTimeout(function(){
            
                            var start = +new Date();
                            
                            do{
								if(directories.length == 0) break;
								
                                var folderID = '';
								if(isRoot) folderID = 'folder'+index;
								
                                var isFolder = directories[index].isfolder;
                                var fullPath = directories[index].filename;
                                var directory = fullPath.substr(0, fullPath.length-1);
                                directory = directory.substr(directory.lastIndexOf('/')+1);
								if(isRoot && fullPath.indexOf('/share/external/')==0){
									directory = 'USBDisk';									
									var data = {
										action: 19, 
										param: fullPath.substr(0, fullPath.length-1),
										param2: folderID
									};
									$j.post(global_obj.appMozy, data, function(res){
										var usbName = $j(res).find("shareName").text();
										var usbID = $j(res).find("folderID").text();
										$j('#'+usbID).text(usbName);
										global_obj.usbRoots.push({"path":fullPath, "name":usbName, "id":usbID});
									});
								}
                                
                                if(isFolder == '1'){                                    
                                    var liContainer = $('<li class="directory collapsed"><img class="folderIcon" src="/ajax_obj/extjs/resources/images/default/s.gif"><div><img class="folderDisplay" src="/ajax_obj/images/directory.png"><a href="#" class="checkbox'+isCheckedText2+'">directories</a><input type="checkbox"'+isCheckedText+' name="directories" style="display: none;" value="' + fullPath + '" />&nbsp;<label unselectable="on" id="'+folderID+'" rel="' + fullPath + '">' + directory + '</label></div></li>');

                                    newTree.append(liContainer);
                                    
                                    var divContainer = liContainer.children('div');
                                    divContainer.hover(function(){$(this).addClass('hover');}, function(){$(this).removeClass('hover');});
                                    var $checkbox = divContainer.children('input:checkbox');
                                    var $item = divContainer.children('a.checkbox');
                                    var newPath = $checkbox.val();
                                    $j.each(global_obj.selectedRestorePath, function(index, selectedPath){
                                        if(isParentChecked && newPath == selectedPath.path){
                                            $item.attr('class', 'checkbox checked');
                                           $checkbox.attr('checked', 'checked');
                                            return false;
                                        }else if(isParentChecked&& newPath != '' && selectedPath.path.indexOf(newPath) != -1){
                                            $item.attr('class', 'checkbox partial');
                                            return false;
                                        }
                                        divContainer.children('input:checkbox').data('patch', selectedPath.patch);
                                    });
                                    
                                    divContainer.bind('click', function() {
                                        var label = $(this).children('label');
                                        var rel = label.attr('rel');
                                        if(typeof rel == 'undefined'){
                                            return false;
                                        } 
										
                                        var labelParent = label.parent().parent();
                                        if( labelParent.hasClass('directory') ) {
                                            if( labelParent.hasClass('collapsed') ) {
                                                // Expand
                                                if( !o.multiFolder ) {
                                                    labelParent.parent().find('UL').hide();
                                                    labelParent.parent().find('LI.directory').removeClass('expanded').addClass('collapsed');
                                                    updateRestoreSelection();
                                                }
                                                showTree( labelParent, label.attr('rel').match( /.*\// ));
                                                labelParent.removeClass('collapsed').addClass('expanded');
                                            } else {
                                                // Collapse
                                                labelParent.find('UL').hide();
                                                labelParent.removeClass('expanded').addClass('collapsed');
                                                updateRestoreSelection();
                                            }
                                        }
                                        
                                        o.folderEventCallback(label);
                                    });
                                    
                                    liContainer.children('img.folderIcon').bind(o.folderEvent, function(e) {
                                        var label = $(this).siblings('div').children('label');
                                        var rel = label.attr('rel');
                                        if(typeof rel == 'undefined'){
                                            return false;
                                        } 
                                        var labelParent = label.parent().parent();
                                        if( labelParent.hasClass('directory') ) {
                                            if( labelParent.hasClass('collapsed') ) {
                                                // Expand
                                                if( !o.multiFolder ) {
                                                    labelParent.parent().find('UL').hide();
                                                    labelParent.parent().find('LI.directory').removeClass('expanded').addClass('collapsed');
                                                    updateRestoreSelection();
                                                }
                                                showTree( labelParent, label.attr('rel').match( /.*\// ));
                                                labelParent.removeClass('collapsed').addClass('expanded');
                                            } else {
                                                // Collapse
                                                labelParent.find('UL').hide();
                                                labelParent.removeClass('expanded').addClass('collapsed');
                                                updateRestoreSelection();
                                            }
                                        }
                                        return false;
                                    });
                                }
                                
                                index++;
                                
                            }while(directories.length > index && (+new Date() - start < 50));
                
                            if(index < directories.length){
                                setTimeout(arguments.callee, 100);
                            }else{   
                                /*****************************************************/
                                
                                if(isRoot){
                                    var rootItem = $j('<ul class="mozyFileTree"><li class="directory expanded" style="background: none;" id="restore_share_root" rel="share_root"><img class="folderIcon" src="/ajax_obj/extjs/resources/images/default/s.gif"><div><img class="folderDisplay" src="/ajax_obj/images/directory.png"><a href="#" class="checkbox shareRoot">Heading</a><label><span class="label">&nbsp;Share Root</span></label></div></li></ul>');
                                    rootItem.find('li').append(newTree);
                                    item = rootItem;
                                }else{
                                    item = newTree;
                                }
                                newTree = null;
                                
                                if(item === false){
                                    $(c).removeClass('wait');
                                    $(c).addClass('emptyDirectory');
                                    return;
                                }
                                
                                item.tristate({
                                    app: 'mozy',
                                    labelCallBack: function(label, state, position){
                                        if(global_obj.fileRestorePanelObj == '') return;
                                        var rel = label.attr('rel');
                                        
                                        switch(position){
                                            case 'ancestor':                                
                                                //do nothing
                                            break;
                                            
                                            case 'origin':                                        
                                            case 'descendant':                  
                                                if(rel && rel == global_obj.fileRestorePanelObj.attr('rel')){
                                                    $j('#mozyRestoreFiles').find('input:checkbox').each(function(){
                                                        $j(this).attr('checked', ((state) ? 'checked' : ''));
                                                        $j(this).triggerHandler('click');
                                                    });
                                                }else{                                        
                                                    if(!state){
                                                        var tmp = global_obj.selectedRestoreFilesList;
                                                        global_obj.selectedRestoreFilesList = new Array();
                                                        for(index=0; index<tmp.length; index++){
                                                            if(tmp[index].indexOf(rel) == -1){
                                                                global_obj.selectedRestoreFilesList.push(tmp[index]);
                                                            }
                                                        }
                                                        tmp = null;
                                                    }
                                                }
                                            break;                                        
                                        }                                
                                        
                                    }
                                });
                                
                                $(c).removeClass('wait').append(item);
                                
                                if(isRoot){
									$j('#mozyRestoreTreeLoading').hide();
									for(var i=0, y=global_obj.usbRoots.length; i<y; i++){
										$j('#'+global_obj.usbRoots[i].id).text(global_obj.usbRoots[i].name);
									}
								}
								
								global_obj.ajaxLock = false;
                                
                                item = null;
                                c = null;
                                directories = null;
                                
                                /*****************************************************/
                            }
                        }, 25);
                    });
				}

				// Get the initial file list
				showTree( $(this), o.root, true);
			});
		}
	});
    
	$.extend($.fn, {
		normalTree: function(o, h) {
			// Defaults
			if( !o ) var o = {};
			if( o.root == undefined ) o.root = 'share_root_path';
			if( o.script == undefined ) o.script = '/cgi-bin/filemanager/utilRequest.cgi?func=get_tree&generic=yes&sid='+sid;
			if( o.folderEvent == undefined ) o.folderEvent = 'click';
			if( o.folderEventCallback == undefined ) o.folderEventCallback = function(obj){};
			if( o.expandEasing == undefined ) o.expandEasing = null;
			if( o.collapseEasing == undefined ) o.collapseEasing = null;
			if( o.multiFolder == undefined ) o.multiFolder = true;
			if(o.postProcessing == undefined ) o.postProcessing = function(input){return input;};
			
			$(this).each( function() {
				
				function showTree(c, t, isRoot) {
					global_obj.ajaxLock = true;
					
					$(c).addClass('wait');              
					
                    $.post(o.script, { node: t }, function(data) {
                        
                        $(c).find('UL').remove();
                        
                        var item = false;                        
                        
                        var index=0;
                        var newTree = $j('<ul class="mozyFileTree"></ul>');
                        var directories = JSON.parse(data);
                        
                        if(!isRoot && (typeof directories == 'undefined' || directories == '' || directories.length == 0)){                        
                            $(c).removeClass('wait');
                            $(c).addClass('emptyDirectory');
                            return;
                        }
                        
                        var isCheckedText = '';
                        if($(c).children('div').children('a.checkbox').hasClass('checked')){
                            isCheckedText = ' checked="checked"';
                        }
                        
                        setTimeout(function(){
            
                            var start = +new Date();
                            
                            do{	
								if(directories.length == 0) break;
                               
                                var directory = directories[index].id.replace('//', '/');
                                
                                if(isRoot===true){
                                    directory = directory.replace(/^\/.*?\/.*?\//, '/');
                                }
                                
                                newTree.append('<li class="directory collapsed"><img class="folderIcon" src="/ajax_obj/extjs/resources/images/default/s.gif"><div><img class="folderDisplay" src="/ajax_obj/images/directory.png"><input type="checkbox"'+isCheckedText+' name="directories" style="display: none;" value="' + directory + '/" />&nbsp;<label unselectable="on" rel="' + directory + '/" style="clear: right; text-align: left; width: auto; font-weight: normal;">' + directories[index].text + '</label></div></li>');
                                
                                index++;
                                
                            }while(directories.length > index && (+new Date() - start < 50));
                
                            if(index < directories.length){
                                setTimeout(arguments.callee, 100);
                            }else{  
                                
                                if(isRoot){
                                    var rootItem = $j('<ul class="mozyFileTree"><li class="directory expanded" style="background: none;" id="share_root" rel="share_root"><img class="folderIcon" src="/ajax_obj/extjs/resources/images/default/s.gif"><div><img class="folderDisplay" src="/ajax_obj/images/directory.png"><span class="label">&nbsp;Share Root</span></div></li></ul>');
                                    rootItem.find('li').append(newTree);
                                    item = rootItem;
                                }else{
                                    item = newTree;
                                }   
                                                        
                                bindTree(item);
                                if(isRoot) $j('#mozyBrowserLoading').hide();
                                $(c).removeClass('wait').append(item);
                            }
                            
                        }, 25);
                        
                        
                    });
				}
				
				function bindTree(t) {
                    $(t).find('li').each(function(){
                        var divContainer = $(this).children('div');
                        divContainer.hover(function(){$(this).addClass('hover');}, function(){$(this).removeClass('hover');});
                    
                        divContainer.bind('click', function() {
                            var label = $(this).children('label');
                            var rel = label.attr('rel');
                            if(typeof rel == 'undefined'){
                                return false;
                            }                      
                            o.folderEventCallback(label);
                            var labelParent = label.parent().parent();
                            if( labelParent.hasClass('directory') ) {
                                    
                                if( labelParent.hasClass('collapsed') ) {
                                    // Expand
                                    if( !o.multiFolder ) {
                                        labelParent.parent().find('UL').hide();
                                        labelParent.parent().find('LI.directory').removeClass('expanded').addClass('collapsed');
                                    }
                                    showTree( labelParent, label.attr('rel').match( /.*\// ) );
                                    labelParent.removeClass('collapsed').addClass('expanded');   
                                } else {
                                    // Collapse              
                                    labelParent.find('UL').hide();
                                    labelParent.removeClass('expanded').addClass('collapsed');
                                }   
                                    
                            }
                        });
                    
                        $(this).find('img.folderIcon').bind(o.folderEvent, function(e) {
                                    
                            var label = $(this).siblings('div').children('label');
                            var rel = label.attr('rel');
                            if(typeof rel == 'undefined'){
                                return false;
                            } 
                            var labelParent = label.parent().parent();
                            if( labelParent.hasClass('directory') ) {
                                    
                                if( labelParent.hasClass('collapsed') ) {
                                    // Expand
                                    if( !o.multiFolder ) {
                                        labelParent.parent().find('UL').hide();
                                        labelParent.parent().find('LI.directory').removeClass('expanded').addClass('collapsed');
                                    }
                                    showTree( labelParent, label.attr('rel').match( /.*\// ) );
                                    labelParent.removeClass('collapsed').addClass('expanded');   
                                } else {
                                    // Collapse              
                                    labelParent.find('UL').hide();
                                    labelParent.removeClass('expanded').addClass('collapsed');
                                }   
                                    
                            }
                            return false;
                        });
                    });

				}
				// Get the initial file list
				showTree( $(this), escape(o.root), true );
			});
		}
	});
	
})(jQuery);