//QNAP JS Library 
//Required yahoo-dom-event.js and ext-all.js

Ext.namespace('QNAP.data');

QNAP.data.languages = Ext.exampledata.languages ;

if (typeof DOMParser == "undefined" || !DOMParser) {
	var DOMParser = function (){}
	DOMParser.prototype.parseFromString = function (str, contentType) {
		if (typeof ActiveXObject != "undefined") {
			var d = new ActiveXObject("MSXML.DomDocument");
			d.loadXML(str);
			return d;
		  } else if (typeof XMLHttpRequest != "undefined") {
			var req = new XMLHttpRequest;	
			req.open("GET", "data:" + (contentType || "application/xml") +
								";charset=utf-8," + encodeURIComponent(str), false);
			if (req.overrideMimeType) {
				req.overrideMimeType(contentType);
			}
			req.send(null);
			return req.responseXML;
		}
	}
}

if(typeof QNAP == "undefeind" || !QNAP){
	var QNAP = {};		
}

QNAP.util = {
	validchar: ' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz~`!@#$%^&()-_+={}[];?.,',
	invalidUserGroupName: '\/|\\:=\+?\"<>*[];,%\'\`',
	invalidUserGroupName_2: '-#',
	invalidUserGroupName_3: '\/|\\:?\"<>',
	invalidUserGroupName_4: '`*|\\;:?,"\'<>',
	//invalidUserGroupName_5: '+=[],;\/:|?<>',
	invalidUserGroupName_5: '"/\\:|?<>',
	
	validSystemName: '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-',
	validName: '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-_.',
	validAppleServerName: '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-.()',	
	validEmailServerName: "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz@/.!#$%&'*+-=?^_`{|}~", 
	validEmailUserName: "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz@/.!#$%&'*+-=?^_`{|}~",	
	numbers: '0123456789',	
	reservedPort: [20, 21, 22, 25, 79, 80, 87, 137, 138, 139, 161, 443, 445, 587, 873, 1723, 3306, 3689, 6000, 8080, 8097, 9000, 13131],
	Setting_Error: -1,
	Setting_Success: 0,
	isErrorFree:function(){
		if($j('span.x-form-invalid-icon:not(.correct-icon)').size() > 0){
			return false;
		}
		return true;
	},
	isValidName:function(id, name, fieldName){
		var flag = true;
		var rule = /[^a-zA-Z0-9]+/;
		QNAP.util.Error.hideInputError(id);
		if(rule.test(name)){
			QNAP.util.Error.showInputError(id, IEI_NAS_ALERT94.replace(/#ITEM#/, fieldName));
			$j('#'+id).click(function(){
					QNAP.util.Error.hideInputError($j(this).attr('id'));
					$j(this).unbind('click');
			});
			flag = false;
		}
		return flag;
	},
	isFlashInstalled:function(){
		var result = false;
		if ($j.browser.msie)
		{
			try 
			{ 
				var swf = new ActiveXObject("ShockwaveFlash.ShockwaveFlash"); 
				result = true;
			} 
			catch(e) 
			{ 
			} 
		}
		else
		{
			var swf=navigator.plugins["Shockwave Flash"]; 
			result = (swf==undefined) ? false : true;
		}

		return result;	
	},
	isRequiredFieldsEmpty:function(id){
		var emptyFieldsDetected = false;
		var msg = ISCSI_REQUIRED_FIELD;
		var idArray = id.split(",");
		for(key=0; key<idArray.length; key++){
			var idKey = $j.trim(idArray[key]);
			if($j.trim($j('#'+idKey).val()) == ''){
				QNAP.util.Error.showInputError(idKey, msg);
				emptyFieldsDetected=true;
				$j('#'+idKey).click(function(){
					QNAP.util.Error.hideInputError($j(this).attr('id'));
					$j(this).unbind('click');
				});
			}
		}
		return emptyFieldsDetected;
	},
	isValidSystemName: function(string) {
		for (var i=0; i< string.length; i++){
			if (QNAP.util.validSystemName.indexOf(string.charAt(i)) == -1)
				return false;
		}
		return true;		
	}, 
	isNumber: function(num) {
		for (var i=0; i< num.length; i++){
			if (QNAP.util.numbers.indexOf(num.charAt(i)) == -1)
				return false;
		}
		return true;		
	}, 
	isValidServerName: function(string) {
		for (var i=0; i< string.length; i++){
			if (QNAP.util.validName.indexOf(string.charAt(i)) == -1)
				return false; 
			if (string.charAt(0) == '.')
				return false;
		}
		return true;
	},
	isValidAppleServerName: function(string) {
		for (var i=0; i< string.length; i++){
			if (QNAP.util.validAppleServerName.indexOf(string.charAt(i)) == -1)
				return false; 
			if (string.charAt(0) == '.')
				return false;
		}
		return true;
	},
	isValidEmailServerName: function(string) {
		var reg_result = string.match(/[A-Za-z0-9/!#$%&'*+=?^_`{|}~-]+(?:\.[A-Za-z0-9/!#$%&'*+=?^_`{|}~-]+)*@(?:[A-Za-z0-9/!#$%&'*+=?^_`{|}~-](?:[A-Za-z0-9/!#$%&'*+=?^_`{|}~-]*[A-Za-z0-9/!#$%&'*+=?^_`{|}~-])?\.)+(?:[A-Za-z0-9/!#$%&'*+=?^_`{|}~-](?:[A-Za-z0-9/!#$%&'*+=?^_`{|}~-]*[A-Za-z0-9/!#$%&'*+=?^_`{|}~-]))\b/);

		for (var i=0; i< string.length; i++){
			if (QNAP.util.validEmailServerName.indexOf(string.charAt(i)) == -1)
				return false; 
			if (string.charAt(0) == '.')
				return false;
		}
		if(reg_result != string)
		{
			
			return false;
		}
		return true;
	},
	isValidEmailUserName: function(string) {
		for (var i=0; i< string.length; i++){
			if (QNAP.util.validEmailUserName.indexOf(string.charAt(i)) == -1)
				return false; 
			if (string.charAt(0) == '.')
				return false;
		}
		return true;
	},
	isReservedPort:function(sysport) {
		for(var i=0; i < QNAP.util.reservedPort.length; i++) {
			if (sysport == QNAP.util.reservedPort[i])
				return true;
		}
		return false;
	},
	isReservedShareName:function(s) {
    if (s.substring(0,7).toLowerCase() == 'usbdisk' || s.substring(0,9).toLowerCase() == 'esatadisk')
      return true;
    else
      return false;  
  },
	isValidIP:function(pos, ip) { 
		if (ip == "" || isNaN(ip))
			return false;
		if ( pos == 1 && ((parseInt(ip) > 223) || (parseInt(ip) <= 0)) )
			return false;
		else if ((pos > 1 && pos < 5) && ((parseInt(ip) > 255) || (parseInt(ip) < 0)))
			return false;
		return true;
	},
	isValidCompleteIP: function(ip){
		//validates both IPv4 and IPv6 addresses
		var IPv4Pattern = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
		var IPv6Pattern = /^\s*((([0-9A-Fa-f]{1,4}:){7}(([0-9A-Fa-f]{1,4})|:))|(([0-9A-Fa-f]{1,4}:){6}(:|((25[0-5]|2[0-4]\d|[01]?\d{1,2})(\.(25[0-5]|2[0-4]\d|[01]?\d{1,2})){3})|(:[0-9A-Fa-f]{1,4})))|(([0-9A-Fa-f]{1,4}:){5}((:((25[0-5]|2[0-4]\d|[01]?\d{1,2})(\.(25[0-5]|2[0-4]\d|[01]?\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(([0-9A-Fa-f]{1,4}:){4}(:[0-9A-Fa-f]{1,4}){0,1}((:((25[0-5]|2[0-4]\d|[01]?\d{1,2})(\.(25[0-5]|2[0-4]\d|[01]?\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(([0-9A-Fa-f]{1,4}:){3}(:[0-9A-Fa-f]{1,4}){0,2}((:((25[0-5]|2[0-4]\d|[01]?\d{1,2})(\.(25[0-5]|2[0-4]\d|[01]?\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(([0-9A-Fa-f]{1,4}:){2}(:[0-9A-Fa-f]{1,4}){0,3}((:((25[0-5]|2[0-4]\d|[01]?\d{1,2})(\.(25[0-5]|2[0-4]\d|[01]?\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(([0-9A-Fa-f]{1,4}:)(:[0-9A-Fa-f]{1,4}){0,4}((:((25[0-5]|2[0-4]\d|[01]?\d{1,2})(\.(25[0-5]|2[0-4]\d|[01]?\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(:(:[0-9A-Fa-f]{1,4}){0,5}((:((25[0-5]|2[0-4]\d|[01]?\d{1,2})(\.(25[0-5]|2[0-4]\d|[01]?\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(((25[0-5]|2[0-4]\d|[01]?\d{1,2})(\.(25[0-5]|2[0-4]\d|[01]?\d{1,2})){3})))(%.+)?\s*$/;
		if(IPv4Pattern.test(ip) || IPv6Pattern.test(ip)){ //no ipv6 pattern is found or it's an ipv4 address
			return true;
		}
		return false;
		
	},
	isValidHostname: function(hostname){
		var hostnamePattern = /^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])$/;
		if(hostnamePattern.test(hostname)){
			return true;
		}
		return false;
	},
	isValidChar: function(string, allowed, where){
		for (var i=where; i< string.length; i++){
			if (allowed.indexOf(string.charAt(i)) == -1)
				return false;
		}
		return true;
	},
	isNotValidChar: function(string){
		for (var i=0;i<string.length;i++){
			if (QNAP.util.invalidUserGroupName.indexOf(string.charAt(i))!=-1)
				return false;
		}
		return true;
	},
	isNotValidChar_2: function(string){
		for (var i=0;i<string.length;i++){
			if (QNAP.util.invalidUserGroupName_2.indexOf(string.charAt(i))!=-1)
				return false;
		}
		return true;
	},
	isNotValidChar_3: function(string){
		for (var i=0;i<string.length;i++){
			if (QNAP.util.invalidUserGroupName_3.indexOf(string.charAt(i))!=-1)
				return false;
		}
		return true;
	},
	isNotValidChar_4: function(string){
		for (var i=0;i<string.length;i++){
			if (QNAP.util.invalidUserGroupName_4.indexOf(string.charAt(i))!=-1)
				return false;
		}
		return true;
	},
	isNotValidChar_5: function(string){
		for (var i=0;i<string.length;i++){
			if (QNAP.util.invalidUserGroupName_5.indexOf(string.charAt(i))!=-1)
				return false;
		}
		return true;
	},
	isSubfuncMatch: function(orig_sub){
		var page_subfunc = $j('#subfunc_name').html();
//		alert(orig_sub + ' ' + page_subfunc);
		if(page_subfunc){
			if(orig_sub!=page_subfunc)
				return false;
			else
				return true;
		}
		else
			return false;
	},
	validateTextInput:function(did, fn){
		$j('#'+did).blur(function(event){
			if(event.keyCode != 9)	//keycode = 9: TAB
				fn(did);	
		});
		$j('#'+did).keyup(function(event){
			if(event.keyCode != 9)	//keycode = 9: TAB
				fn(did);	
		});
	},
	enableButton: function(el){
		var o = YAHOO.util.Dom.get(el);
		YAHOO.util.Dom.removeClass(el, 'button_disable');
		YAHOO.util.Dom.addClass(el, 'button');
		$j(o).unbind();
	},
	disableButton: function(el){
		var o = YAHOO.util.Dom.get(el);
		YAHOO.util.Dom.removeClass(el, 'button');
		YAHOO.util.Dom.addClass(el, 'button_disable');
		$j('#'+el).unbind();
	},
	convToHtml:	function(s){ 
		return $j('<span />').text(s).html().replace(/ /g, '&nbsp;'); 
	},
	RefreshString: function (rep_str, cid) {
		try { // fix IE error when leaving system monitor page
			var conr;
			if(cid==null){
				conr = $j('body').find('.qnapstr');
			}
			else{
				if(typeof cid == 'string') {
					conr = $j('#'+cid).find('.qnapstr');
				}
				else{
					conr = $j(cid).find('.qnapstr');
				}
				if($j.browser.msie==true){
					$j(':radio,:checkbox').each(function(i){
						$j(this).css('border', '0')
					});	
				}
			}
			conr.each(function(i){
				var aname = $j(this).attr('name');
				var astr = window[aname];
				var par = $j(this).parent();
				$j(this).empty();
				$j(this).append(astr);
				if(par.attr('class').indexOf('button')!=-1){
					//If it's button remove and append again to re-draw for Safari and Chrome to solve button width problem.
					$j(this).remove();
					par.append($j(this));
				}
			})
			
			var sel = $j('select').find('option').each(function(i){
				var op_lang = $j(this).attr('lang');
				if(op_lang!=''){
					$j(this).text(window[op_lang]);	
				}	
			});

			$j('.qnapimg').each(function()
			{
				var langId = $j(this).attr('lang');
				if(langId !='' && !!window[langId])
				{
					//$j(this).attr('title', window[langId]);	
					//$j(this).attr('alt', window[langId]);	
					$j(this).attr('ext:qtip', window[langId]);	
				}	
			});
            // refresh input[type=button]
            $j("input[type=button]").each(function(){
				var langId = $j(this).attr('lang');
				if(langId !='' && !!window[langId])
				{
                    $j(this).val(window[langId]);  
                }
            });
		}
		catch (e) {}
	},
	getExternalIP: function(el){
		$j('#external_ip').html("<img src='/ajax_obj/img/running.gif'>");
		var exip_callback={
			success: function(o){
				var xmlobject = o.responseXML;
				if (QNAP.util.auth.CheckIfAuthPassed(xmlobject) == 0) {			
		      			QNAP.util.data_loading(0);
		      			QNAP.util.auth.GotoLoginPage();
		      			return;
				}
				var root1 = xmlobject.getElementsByTagName('QDocRoot')[0];
				if(root1){
					var ddnsfunc1 = root1.getElementsByTagName('func')[0];
					var ddnsown1 = ddnsfunc1.getElementsByTagName('ownContent')[0];
					if(ddnsown1){
						if(ddnsown1.getElementsByTagName('externalIP')[0].firstChild == null)
						{
							$j('#'+el).html(location_hostname_for_ipv6(parent.location.hostname));
						}
						else
						{
							if(ddnsown1.getElementsByTagName('externalIP')[0].firstChild.nodeValue == 'cannot get external ip')
							{
								$j('#'+el).html("<span class='qnapstr' name='DDNS_DEF_STR36'></span>");
							}else{
								var ddns_ex_ip = ddnsown1.getElementsByTagName('externalIP')[0].firstChild.nodeValue;
								$j('#'+el).html(ddns_ex_ip);								
							}
						}
						QNAP.util.RefreshString('qnapstr');
					}
				}
			},
			failure:function(o){
//				alert('get external ip failure');	
			}	
		}
		var sUrl = '/cgi-bin/sys/sysRequest.cgi?subfunc=' + $j('#subfunc_name').html() + '&count=' + Math.random()+'&sid='+sid+'&action=get_external_ip';
		var request = YAHOO.util.Connect.asyncRequest('POST', sUrl, exip_callback);	
	},
	whichBrs: function(){
		// Browser Detection Javascript
		// copyright 1 February 2003, by Stephen Chapman, Felgall Pty Ltd
		// You have permission to copy and use this javascript provided that
		// the content of the script is not changed in any way.
		var agt=navigator.userAgent.toLowerCase();
		if (agt.indexOf("opera") != -1) return 'Opera';
		if (agt.indexOf("staroffice") != -1) return 'Star Office';
		if (agt.indexOf("webtv") != -1) return 'WebTV';
		if (agt.indexOf("beonex") != -1) return 'Beonex';
		if (agt.indexOf("chimera") != -1) return 'Chimera';
		if (agt.indexOf("netpositive") != -1) return 'NetPositive';
		if (agt.indexOf("phoenix") != -1) return 'Phoenix';
		if (agt.indexOf("firefox") != -1) return 'Firefox';
		if (agt.indexOf("chrome") != -1) return 'Chrome';
		if (agt.indexOf("safari") != -1) return 'Safari';
		if (agt.indexOf("skipstone") != -1) return 'SkipStone';
		if (agt.indexOf("msie") != -1) return 'Internet Explorer';
		if (agt.indexOf("netscape") != -1) return 'Netscape';
		if (agt.indexOf("mozilla/5.0") != -1) return 'Mozilla';
		if (agt.indexOf('\/') != -1) {
		if (agt.substr(0,agt.indexOf('\/')) != 'mozilla') {
			return navigator.userAgent.substr(0,agt.indexOf('\/'));}
		else return 'Netscape';} else if (agt.indexOf(' ') != -1)
			return navigator.userAgent.substr(0,agt.indexOf(' '));
		else return navigator.userAgent;
	},
	get_lang_lowercase: function(hUrl, tURL, default_lang) {
		var visitordata = QNAP.util.Cookie.getCookie('nas_lang');
		ret_lang =Ext.exampledata.languages[0][4];
		 if (default_lang != null) 
		 {
			for(var i =0 ;i< Ext.exampledata.languages.length;i++)
			{	
				//alert("Ext.exampledata.languages["+i+"][3]=="+Ext.exampledata.languages[i][3]+" visitordata=="+visitordata );
				if(default_lang == Ext.exampledata.languages[i][3])
				{
					ret_lang = Ext.exampledata.languages[i][4];
				}			
			}	
		 }
		 else
		 {
			for(var i =0 ;i< Ext.exampledata.languages.length;i++)
			{	
				// alert("Ext.exampledata.languages["+i+"][3]=="+Ext.exampledata.languages[i][3]+" visitordata=="+visitordata );
				if(visitordata == Ext.exampledata.languages[i][3])
				{
					ret_lang = Ext.exampledata.languages[i][4];
				}
				
			}	
		}
		return ret_lang;
	},
	fixCrossBrowser: function(){
		/*  END   */
	},
	data_loading: function(show){
		var panel = YAHOO.util.Dom.get('d_loading');
		if(panel){
			if(show==1)
				panel.style.visibility='visible';
		//		panel.style.display='inline-block';
			else
				panel.style.visibility='hidden';	
		//		panel.style.display='none';
		}
	},
	deployIP: function(ip_obj, f1, f2,f3, f4){
		var field1 = $j('input[@name=' + f1 + ']');
		if(field1==undefined)
			field1 = $j('input[@id=' + f1 + ']');
			
		var field2 = $j('input[@name=' + f2 + ']');
		if(field2==undefined)
			field2 = $j('input[@id=' + f2 + ']');
			
		var field3 = $j('input[@name=' + f3 + ']');
		if(field3==undefined)
			field3 = $j('input[@id=' + f3 + ']');
			
		var field4 = $j('input[@name=' + f4 + ']');
		if(field4==undefined)
			field4 = $j('input[@id=' + f4 + ']');
			
		field1.val($j(ip_obj).find('IP1').text());
		field2.val($j(ip_obj).find('IP2').text());
		field3.val($j(ip_obj).find('IP3').text());
		field4.val($j(ip_obj).find('IP4').text());
	},
	getModel: function(qdoc){
		var modelobj = qdoc.getElementsByTagName('model')[0];
		return modelobj.getElementsByTagName('modelName')[0].firstChild.nodeValue;
	},
	
	DynamicRemoveLangJS: function(){
		var y = document.getElementsByTagName("head")[0].getElementsByTagName('script');
		for(var j=0;j<y.length;j++){
			if(y[j].src.match(/ext-lang-/i) || y[j].src.match(/lang_/i) || y[j].src.match(/tools/i)){
				document.getElementsByTagName("head")[0].removeChild(y[j]);
				j--;
				continue;
			} 
		}		
	},
	DynamicLoadLangJS: function(){
		var params = Ext.urlDecode(window.location.hash.substring(1));
		if (params.lang) {
	    var s = document.createElement("script");
	    s.type = 'text/javascript';
	    s.src = "/ajax_obj/extjs/source/locale/ext-lang-"+params.lang+".js";
	    s.charset = params.charset;
	    document.getElementsByTagName("head")[0].appendChild(s);
	    
		}
	},
	GenVolumeSelect: function(el, vol_xml, none_vdd){
		var default_option = 0, 
			hidden_vdd = false;
			
		$j(vol_xml).find('volume').each(function(i){
			var thisVolume = $j(this);
			var vol_stat = thisVolume.find('volumeStat').text();
			var vol_disks =	thisVolume.find('volumeDisks').text();
			var vol_fstype = thisVolume.find('fstype').text();
			var vol_no = thisVolume.find('volumeValue').text();
			var str = '';
			
			//HAL SUPPORT
			var HAL_FORM = /([0-9a-z]{1,4}:[0-9a-z]{1,4})+/i;	//0001:0001 - Enclosure 1 Disk 1
			var enclosure_id = '0';
			var tempDisplay = '';
			var ellipsis = false;
			//only do the convertion if the format matches
			if(HAL_FORM.test(vol_disks) || vol_stat == 'aggregate'){
				var vol_label = thisVolume.find('volumeLabel').text();
				var diskList = vol_disks.split(',');
				var count = diskList.size();
				if(count>1){
					ellipsis = true;
					count = 1; //only displays the first disk
				}
				for(var index=0; index<count; index++){
					if(diskList[index].indexOf('...') > -1){
						ellipsis = true;
						diskList[index] = diskList[index].replace('...','');
					}
					var thisEnclosureID = HAL_FUNCTIONS.GetEnclosureID(diskList[index]);
					var thisPortID = HAL_FUNCTIONS.GetPortID(diskList[index]);
					if(tempDisplay == ''){
						tempDisplay += HAL_FUNCTIONS.GetDeviceName(thisEnclosureID)+': Drive '+thisPortID; //need translation
					}else{
						tempDisplay += ' '+thisPortID;
					}
				}
				vol_disks = tempDisplay;
				if(ellipsis) vol_disks += '...';
				/*
				if(vol_stat == 'single'){
					str = IEI_NAS_STORAGE33;
				}else if(vol_stat == 'linear'){
					str = IEI_NAS_STORAGE15;
				}else if(vol_stat == 'strip'){
					str = IEI_NAS_STORAGE16;
				}else if(vol_stat == 'mirror'){
					str = IEI_NAS_STORAGE17;
				}else if(vol_stat == 'raid5'){
					str = IEI_NAS_STORAGE18;
				}else if(vol_stat == 'raid6'){
					str = IEI_NAS_STORAGE171;	
				}else if(vol_stat == 'raid10'){
					str = IEI_NAS_STORAGE_RAID10_DRIVES;	
				}else
					str = "Unknown";
				*/
				
				if(vol_label==''){
					vol_label = "--";
					// str += vol_label + ' <' + vol_disks + '>';
					str += vol_label;
				}else{
					str += vol_label;
				}
				
				if(vol_stat == 'vdd'){
					if (typeof none_vdd !== 'undefined' && none_vdd === true){
						hidden_vdd = true;
					
					} else {
						str = thisVolume.find('volumeDisks').text();
						if(thisVolume.find('spare').text()=='1'){
							str += ' ' + thisVolume.find('spareDisk').text();
						}
					}
				}
					
				if (hidden_vdd === false){
					$j('#'+el).addOption(thisVolume.find('volumeValue').text(), str);
					$j('option[@value='+thisVolume.find('volumeValue').text()+']').attr('fstype', vol_fstype);
					if(i == 0){
						default_option = parseInt(thisVolume.find('volumeValue').text());
					}				
				}
			}
			//HAL SUPPORT ended
			else{
				if(vol_stat == 'single'){
					str = IEI_NAS_STORAGE33;
				}
				else if(vol_stat == 'linear'){
					str = IEI_NAS_STORAGE15;
				}
				else if(vol_stat == 'strip'){
					str = IEI_NAS_STORAGE16;
				}
				else if(vol_stat == 'mirror'){
					str = IEI_NAS_STORAGE17;
				}
				else if(vol_stat == 'raid5'){
					str = IEI_NAS_STORAGE18;
				}
				else if(vol_stat == 'raid6'){
					str = IEI_NAS_STORAGE171;	
				}
				else if(vol_stat == 'raid10'){
					str = IEI_NAS_STORAGE_RAID10_DRIVES;	
				}
				else
					str = "Unknown";
				
				str += ' ' + vol_disks;
				
				if(vol_stat == 'vdd'){
					if (typeof none_vdd !== 'undefined' && none_vdd === true){
						hidden_vdd = true;
					
					} else {
						str = thisVolume.find('volumeDisks').text();
						if(thisVolume.find('spare').text()=='1'){
							str += ' ' + thisVolume.find('spareDisk').text();
						}
					}
				}
					
				if (hidden_vdd === false){
					$j('#'+el).addOption(thisVolume.find('volumeValue').text(), str);
					$j('option[@value='+thisVolume.find('volumeValue').text()+']').attr('fstype', vol_fstype);
					if(i == 0){
						default_option = parseInt(thisVolume.find('volumeValue').text());
					}				
				}
			}

		});
		if (hidden_vdd === false){
			$j('#'+el).val(default_option);
		}
	},
	AddHiddenInputToForm: function(fieldname, fieldvalue, sform){
		$j('<input type="HIDDEN" name="' + fieldname + '" value="'+fieldvalue+ '">').appendTo(sform);	
	},
	KeypressIsNum: function(evt){
		var keyNum = window.event?window.event.keyCode:evt.which; 
	 
		//alert(keyNum); 
		if( (keyNum < 48 && keyNum != 8 && keyNum != 0) || keyNum > 57 ){
			return false;
		}	
		return true;
	},
	isPortLegal: function(portNum, exceptionPort) {
		exceptionPort = exceptionPort+'';
		var portNumReg = new RegExp('(^'+portNum+'$)|([ ]{1}'+portNum+'$)|(^'+portNum+'[ ]{1})|([ ]{1}'+portNum+'[ ]{1})','');   
		var SystemPreservePort = new Array(20,21,22,23,25,79,80,87,137,138,139,161,443,445,514,587,873,1723,3306,3689,6000,8008,8080,8081,8090,8097,9000,13131);
        
    	if(portNum>=6881 && portNum<=6999 && exceptionPort!=-1)	return false;		//BitTorrent
    	if(portNum>=55536 && portNum<=56559 && exceptionPort!=-2)	return false;	//PASV FTP

    	for(i=0; i<SystemPreservePort.length; i++){
    		if( !portNumReg.test(exceptionPort) && portNum == SystemPreservePort[i] ) return false;
    	}    
    	return true;
	},
		CheckSettingResult: function(xmlobject) {			
		var setting_result = $j(xmlobject).find('QDocRoot setting_result').text();
		if (parseInt(setting_result) == QNAP.util.Setting_Error) {
			q_alert_error(ERROR_SETTING_ERROR);
			return QNAP.util.Setting_Error;
		}
		return QNAP.util.Setting_Success;
	},
	showModel: function(xmlobject){
		var internalModelName = $j(xmlobject).find('QDocRoot model internalModelName').text();
		var modelname = $j(xmlobject).find('QDocRoot model modelName').text();
		var showList = new Array();
		
		if (internalModelName == "TS-101") {
			if (modelname == "TS-109 PRO" || modelname == "TS-109 PRO II") {
				showList.push('.TS-109PRO');
			}
			else if (modelname == "TS-109") {
				showList.push('.TS-109');
			}
			else {
				showList.push('.TS-101');
			}
		}
		else if (internalModelName == "TS-201") {
			if (modelname == "TS-209 PRO" || modelname == "TS-209 PRO II") {
				showList.push('.TS-209PRO');
			}
			else if (modelname == "TS-209") {
				showList.push('.TS-209');
			}
			else {
				showList.push('.TS-201');
			}
		}
		else if (internalModelName == "TS-239") {
			if (modelname == "NSS322") {
				showList.push('.'+modelname);
				showList.push('.'+internalModelName);
				$j('.'+modelname+'_HIDE').hide();
			}
			else {
				showList.push('.'+internalModelName);
			}
		}
		else if (internalModelName == "TS-639") {
			if (modelname == "NSS326") {
				showList.push('.'+modelname);
				showList.push('.'+internalModelName);
				$j('.'+modelname+'_HIDE').hide();
			}
			else {
				showList.push('.'+internalModelName);
			}
		}
		else if (internalModelName == "TS-439") {
			if (modelname == "NSS324") {
				showList.push('.'+modelname);
				showList.push('.'+internalModelName);
				$j('.'+modelname+'_HIDE').hide();
			}
			else if (modelname == "TS-439U" || modelname == "TS-CN439U" || modelname == "TS-439U-G") {
				showList.push('.TS-439U');
				$j('.TS-439U_HIDE').hide();
			}
			else {
				showList.push('.TS-439');
			}
		}
		else if (internalModelName == "TS-809") {
			if (modelname == "TS-809U" || modelname == "TS-CN809U" || modelname == "TS-809U-G") {
				showList.push('.TS-809U');
                        }
                        else {
				showList.push('.TS-809');
                        }
                }
		else if (internalModelName == "TS-839") {
                        if (modelname == "SS-839") {
				showList.push('.SS-839');
                        }
                        else {
				showList.push('.TS-839');
                        }
                }
		else if (internalModelName == "TS-119") {
			if (modelname == "Q600") {
				showList.push('.Q600');
				showList.push('.'+internalModelName);
			}
			else if (modelname == "TS-110") {
				showList.push('.TS-110');
				showList.push('.'+internalModelName);
			}
			if (modelname == "TS-129") {
				showList.push('.TS-129');
				showList.push('.'+internalModelName);
			}
			else {
				showList.push('.'+internalModelName);
			}
		}
		else if (internalModelName == "TS-419") {
			if (modelname == "TS-420U") {
				showList.push('.'+modelname);
				showList.push('.'+internalModelName);
				$j('.'+modelname+'_HIDE').hide();
			}
			if (modelname == "TS-421U") {
				showList.push('.'+modelname);
				showList.push('.'+internalModelName);
				$j('.'+modelname+'_HIDE').hide();
			}
			else{
				showList.push('.TS-419');
					if (modelname.indexOf("TS-419U") == 0 || modelname.indexOf("TS-410U") == 0 || modelname.indexOf("TS-412U") == 0) {
					$j('.TS-419U_HIDE').hide();
				}
			}
		}
		else if (internalModelName == "TS-259") {
			if (modelname == "NSS322") {
				showList.push('.'+modelname);
				showList.push('.'+internalModelName);
				$j('.'+modelname+'_HIDE').hide();
			}
			else {
				showList.push('.'+internalModelName);
			}
		}
		else if (internalModelName == "TS-459") {
			if (modelname == "NSS324" || modelname == "NSS324R") {
				showList.push('.'+modelname);
				showList.push('.'+internalModelName);
				$j('.'+modelname+'_HIDE').hide();
			}
			else if (modelname == "TS-459U" || modelname == "TS-459U-G" || modelname == "TS-CN459U" || modelname == "TS-459U Pro II" || modelname == "TS-459U+"||modelname == "TS-459U-G+") {
				showList.push('.TS-459U');
				showList.push('.'+internalModelName);
				$j('.TS-459U_HIDE').hide();
			}
			else {
				showList.push('.TS-459');
			}
		}
		else if (internalModelName == "TS-559") {
			showList.push('.'+internalModelName);
		}
		else if (internalModelName == "TS-659") {
			if (modelname == "NSS326") {
				showList.push('.'+modelname);
				showList.push('.'+internalModelName);
				$j('.'+modelname+'_HIDE').hide();
			}
			else if (modelname == "TS-659-G") {
				showList.push('.TS-659');
				showList.push('.'+internalModelName);
			}
			else {
				showList.push('.'+internalModelName);
			}
		}
		else if (internalModelName == "TS-859") {
			if (modelname == "TS-859U" || modelname == "TS-859U-G" || modelname == "TS-CN859U" || modelname == "TS-859U+") {
				showList.push('.TS-859U');
				showList.push('.'+internalModelName);
				$j('.TS-859U_HIDE').hide();
			}
			else
				showList.push('.TS-859');
		}
		else if (internalModelName == "TS-879") {
			if (modelname == "TS-879U") {
				showList.push('.TS-879U');
				showList.push('.'+internalModelName);
				$j('.TS-879U_HIDE').hide();
			}
			else if (modelname == "TS-870U") {
				showList.push('.TS-870U');
				showList.push('.'+internalModelName);
				$j('.TS-870U_HIDE').hide();
			}
			else
				showList.push('.TS-879');
		}
		else if (internalModelName == "TS-1079") {
				showList.push('.'+internalModelName);
		}
		else if (internalModelName == "TS-1279") {
			if (modelname == "TS-1279U") {
				showList.push('.TS-1279U');
				showList.push('.'+internalModelName);
				$j('.TS-1279U_HIDE').hide();
			}
			else if (modelname == "TS-1270U") {
				showList.push('.TS-1270U');
				showList.push('.'+internalModelName);
				$j('.TS-1270U_HIDE').hide();
			}
			else
				showList.push('.TS-1279');
		}
		else if (internalModelName == "TS-1679") {
			if (modelname == "TS-1679U") {
				showList.push('.TS-1679U');
				showList.push('.'+internalModelName);
				$j('.TS-1679U_HIDE').hide();
			}
			else
				showList.push('.TS-1679');
		}
        else if (internalModelName == "TS-269") {
                showList.push('.'+internalModelName);
        }
        else if (internalModelName == "TS-269H") {
                showList.push('.'+internalModelName);
        }
        else if (internalModelName == "HS-200") {
                showList.push('.'+internalModelName);
        }
		else if (internalModelName == "TS-469") {
            if (modelname == "TS-469U") {
                showList.push('.TS-469U');
                showList.push('.'+internalModelName);
                $j('.TS-469U_HIDE').hide();
            }
            else if (modelname == "QR802") {
                showList.push('.QR802');
                showList.push('.'+internalModelName);
                $j('.QR802_HIDE').hide();
            }
            else
                showList.push('.TS-469');
        }
        else if (internalModelName == "TS-569") {
                showList.push('.'+internalModelName);
        }
        else if (internalModelName == "TS-669") {
                showList.push('.'+internalModelName);
        }
        else if (internalModelName == "TS-869") {
            if (modelname == "TS-869U") {
                showList.push('.TS-869U');
                showList.push('.'+internalModelName);
                $j('.TS-869U_HIDE').hide();
            }
            else
                showList.push('.TS-869');
        }
        else if (internalModelName == "TS-1269") {
            if (modelname == "TS-1269U") {
                showList.push('.TS-1269U');
                showList.push('.'+internalModelName);
                $j('.TS-1269U_HIDE').hide();
            }
            else
                showList.push('.TS-1269');
        }
		else {
			showList.push('.'+internalModelName);
		}

		var isMozilla = false;
		$j.each($j.browser, function(i, val) {
			if(i=='mozilla' && val){
				isMozilla = true;
			}
		});
		if(isMozilla){
			//only changes those written inside an <tr> tag
			$j(showList.join(',')).each(function(){
				if(this.tagName == 'TR'){
					$j(this).css('display', 'table-row');
				}
			});
			$j(showList.join(',')).show();
		}else{
			$j(showList.join(',')).show();
		}
		
	},
	countStrLen: function(str){
    var count_len=0,c_unit=3;
    var str_len=str.length;
  
    for (i=0;i<str_len;i++)
    {
      if(str.charCodeAt(i) > 255)
        count_len+=3;
      else
        count_len+=1;
    } 
    return count_len;
  },
  getCusLenStr: function(str,n){
    var count_len=0,i=0;c_unit=3;
    var str_len=str.length,tmp_str='';
    
    while(count_len<=n)
    {
      c=str.substr(i,1);
      
      if(str.charCodeAt(i++) > 255)
        count_len+=3;
      else
        count_len+=1;    
      
      if (count_len<=n)
        tmp_str+=String(c);
    }
    return tmp_str;
  },
	countStrLen_ex: function(str){
	    var count_len=0;
	    var str_len=str.length;
	  
	    for (i=0;i<str_len;i++)
	    {
	    	var charcode = str.charCodeAt(i) 
	      if(charcode < 0x80)
			count_len+=1;
	      else if (charcode < 0x800)
		        count_len+=2;
		else if (charcode < 0x10000) 
	       	 count_len+=3;
		else 
		        count_len+=4;
	    } 
	    return count_len;
	  },
	  getCusLenStr_ex: function(str,n){
	    var count_len=0,i=0;
	    var str_len=str.length,tmp_str='';
	    
	    while(count_len<=n)
	    {
	      c=str.substr(i,1);
	      var charcode = str.charCodeAt(i++) ;
		if(charcode < 0x80)
			count_len+=1;	  	
		else if (charcode < 0x800)
		    count_len+=2;
		else if (charcode < 0x10000) 
			 count_len+=3;
		else 
			count_len+=4;
		  
	      
	      if (count_len<=n)
	        tmp_str+=String(c);
	    }
	    return tmp_str;
	  },
	getSizeWithUnit: function(size) {
		// base on MB
		if (isNaN(size))
			return size;
			
		size = parseFloat(size);
		
		if (size > 1024 || size < -1024)
			return this.getFloatNumber((size / 1024),2) + ' GB';
		else
			return this.getFloatNumber(size,2) + ' MB';
	},
	getFloatNumber: function(v,n) {
		if (typeof n == 'undefined')
			n = 2;
			
		var baseNumber = Math.pow(10,n);
		var tmpFloat = Math.round(v * baseNumber) / baseNumber;
	
	  return tmpFloat;
	},

	getParamString: function(paramObj, needToEncode)
	{
		var param_list = [];
		if (!needToEncode)
			for (var item in paramObj)
				param_list.push(item + '=' + paramObj[item]);
		else
			for (var item in paramObj)
				param_list.push(item + '=' + encodeURIComponent(paramObj[item]));

		return param_list.join('&');
	},

	getScrollerWidth : function()
	{
		var scrollbarWidth = 0;
		if ( $j.browser.msie ) {
			var $jtextarea1 = $j('<textarea cols="10" rows="2"></textarea>')
					.css({ position: 'absolute', top: -1000, left: -1000 }).appendTo('body'),
				$jtextarea2 = $j('<textarea cols="10" rows="2" style="overflow: hidden;"></textarea>')
					.css({ position: 'absolute', top: -1000, left: -1000 }).appendTo('body');
			scrollbarWidth = $jtextarea1.width() - $jtextarea2.width();
			$jtextarea1.add($jtextarea2).remove();
		} else {
			var $jdiv = $j('<div />')
				.css({ width: 100, height: 100, overflow: 'auto', position: 'absolute', top: -1000, left: -1000 })
				.prependTo('body').append('<div />').find('div')
					.css({ width: '100%', height: 200 });
			scrollbarWidth = 100 - $jdiv.width();
			$jdiv.parent().remove();
		}
		return scrollbarWidth;

	}
	
  
};

Math.dec2hex = function(val)
{
    return Number(val).toString(16);
//    var h = {
//        '10' : 'a',
//        '11' : 'b',
//        '12' : 'c',
//        '13' : 'd',
//        '14' : 'e',
//        '15' : 'f'
//    }, i, j;
//
//    i = Math.floor(val/16);
//    j = (val%16);
//    if (j >= 10) j = h[j];
//
//    return i+''+j;
    
};

String.prototype.big5len = function() {   
    var len = 0;   
    for (var i=0; i<this.length; i++) {   
        if (this.charCodeAt(i)>127 || this.charCodeAt(i)==94) {   
            len += 2;   
        } else {   
            len ++;   
        }   
    }   
    return len;   
}   

String.prototype.big5trim = function(len, s) {   
	var str = '';   
	var sp  = s || '';   
	var len2 = 0;   
	for (var i=0; i<this.length; i++) {   
		if (this.charCodeAt(i)>127 || this.charCodeAt(i)==94) {   
			len2 += 2;   
		} else {   
			len2 ++;   
		}   
	}   
	if (len2 <= len) {   
		return this;   
	}   
	len2 = 0;   
	len  = (len > sp.length) ? len-sp.length: len;   
	for (var i=0; i<this.length; i++) {   
		if (this.charCodeAt(i)>127 || this.charCodeAt(i)==94) {   
			len2 += 2;   
		} else {   
			len2 ++;   
		}   
		if (len2 > len) {   
			str += sp;   
			break;   
		}   
		str += this.charAt(i);   
	}   
	return str;   
}; 

// Load -- Need include yahoo-dom-event.js, utilities.js, container-min.js and before this header
// Required build/container/assets/skins/sam/container.css, build/container/assets/container-core.css

$D = YAHOO.util.Dom;
$E = YAHOO.util.Event;

QNAP.util.Error = {
	default_container: 'err_div',
	default_container_class: 'err_div',
	show: function(str, el,csel){
		var container=null;
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				container=el;
			}
			if (typeof el === 'string') {//id
				container=document.getElementById(el);
			}	
		}
		if(!container){
			container=document.getElementById(this.default_container);
		}
		else{
			if(csel)
				el.className=csel;
			else
				YAHOO.util.Dom.addClass(el,this.default_container_class);	
		}
		container.innerHTML=str;
		container.style.display='block';
	},
	hide: function(el){
		var container=null;
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				container=el;
			}
			if (typeof el === 'string') {//id
				container=document.getElementById(el);
			}	
		}
		if(!container){
			container=document.getElementById(this.default_container);
		}
		
		if(container)
			container.style.display='none';
	},
	isInputErrorExist: function(el){
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				container=el;
			}
			if (typeof el === 'string') {//id
				container=document.getElementById(el);
			}	
		}
		if(container.className.indexOf('x-form-invalid')!=-1)
			return true;
		else
			return false;
	},
	showInputError: function(el, error_str, err_div){
		var current_node;
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				current_node=el;
			}
			if (typeof el === 'string') {//id
				current_node=document.getElementById(el);
			}	
		}
		var root = current_node.parentNode;
		var error_exist=false;
		var err_container=null;
		if(err_div){
			if (err_div.nodeType || err_div.item) { // Node, or NodeList
				err_container=$j(err_div);
			}
			if (typeof err_div === 'string') {//id
				err_container=$j('#'+ err_div);
			}
		}
		if(err_container){
			$j(err_container).children('span').each(function(i){
				if(this.className.indexOf('x-form-invalid-icon')!=-1)
				error_exist=true;
			});
		}
		else
			error_exist=this.isInputErrorExist(current_node);
			
		if(error_exist){
			return;
		}
		YAHOO.util.Dom.addClass(current_node, 'x-form-invalid');
		var error_span = $j('<span></span>');
//		container.appendChild(error_span);
		if(err_container){
			$j(err_container).append(error_span);
		}
		else{
			error_span.insertAfter(current_node);
		}
		YAHOO.util.Dom.addClass(error_span, 'x-form-invalid-icon');
		error_span.css('display', 'inline-block');
		error_span.css('left', '5px');
		error_span.css('visibility', 'visible');
		
		error_span.attr('qtip', error_str);
		error_span.attr('qclass', 'x-form-invalid-tip');
	},
	hideInputError: function(el, err_div){
		var current_node;
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				current_node=el;
			}
			if (typeof el === 'string') {//id
				current_node=document.getElementById(el);
			}	
		}
		var root = current_node.parentNode;
		var container;
		var error_exist=false;
		var err_container=null;
		if(err_div){
			if (err_div.nodeType || err_div.item) { // Node, or NodeList
				container=$j(err_div);
			}
			if (typeof err_div === 'string') {//id
				container=$j('#'+ err_div);
			}
			err_container = container;
		}
		else{	
			container=$j(YAHOO.util.Dom.getNextSibling(current_node));
		}
		if(err_container){
			$j(err_container).children('span').each(function(i){
				if(this.className.indexOf('x-form-invalid-icon')!=-1)
				error_exist=true;
			});
		}
		else{
			error_exist=this.isInputErrorExist(current_node);
		}
		if(!error_exist){
			return;
		}
		YAHOO.util.Dom.removeClass(current_node, 'x-form-invalid');
//		container.removeChild(YAHOO.util.Dom.getNextSibling(current_node));
		if(err_container){
			err_container.html(''); // Not to remove whole div just empty it.
		}
		else
			container.remove(); // Remove whole div
//		var rem = root.getElementsByTagName('span')[0];
//		container.removeChild(rem);
	},
	showInputCorrect: function(el, correct_str, correct_div){
		var current_node;
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				current_node=el;
			}
			if (typeof el === 'string') {//id
				current_node=document.getElementById(el);
			}	
		}
		var root = current_node.parentNode;
		var correct_exist=false;
		var correct_container=null;
		if(correct_div){
			if (correct_div.nodeType || correct_div.item) { // Node, or NodeList
				correct_container=$j(correct_div);
			}
			if (typeof correct_div === 'string') {//id
				correct_container=$j('#'+ correct_div);
			}
	//		alert(err_container.html());
		}
		if(correct_container){
			$j(correct_container).find('span').each(function(i){
				if(this.className.indexOf('x-form-invalid-icon')!=-1)
				correct_exist=true;
			});
		}
		else{
			correct_exist=this.isInputCorrectExist(current_node);
		}
			
		if(correct_exist){
			return;
		}
//		YAHOO.util.Dom.addClass(current_node, 'x-form-invalid');
		var correct_span = $j('<span></span>');
//		container.appendChild(error_span);
		if(correct_container){
			$j(correct_container).append(correct_span);
		}
		else{
			correct_span.insertAfter(current_node);
		}
		correct_span.addClass('x-form-invalid-icon');
		correct_span.addClass('correct-icon');
		correct_span.css('display', 'inline-block');
		correct_span.css('left', '5px');
		correct_span.append('&nbsp;');
		correct_span.css('visibility', 'visible');
/*		
		correct_span.attr('qtip', corrct_str);
		correct_span.attr('qclass', 'x-form-invalid-tip');
		*/
	},
	hideInputCorrect: function(el, correct_div){
		var current_node;
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				current_node=el;
			}
			if (typeof el === 'string') {//id
				current_node=document.getElementById(el);
			}	
		}
		var root = current_node.parentNode;
		var container;
		var correct_exist=false;
		var correct_container=null;
		if(correct_div){
			if (correct_div.nodeType || correct_div.item) { // Node, or NodeList
				container=$j(correct_div);
			}
			if (typeof correct_div === 'string') {//id
				container=$j('#'+ correct_div);
			}
			correct_container = container;
	//		alert(err_container.html());
		}
		else{	
			container=$j(YAHOO.util.Dom.getNextSibling(current_node));
		}
		
		if(correct_container){
			$j(correct_container).find('span').each(function(i){
				if(this.className.indexOf('correct-icon')!=-1)
				correct_exist=true;
			});
		}
		else{
			correct_exist=this.isInputCorrectExist(current_node);
		}
		if(!correct_exist){
			return;
		}
//		YAHOO.util.Dom.removeClass(current_node, 'x-form-invalid');
//		container.removeChild(YAHOO.util.Dom.getNextSibling(current_node));
		if(correct_container){
			correct_container.html(''); // Not to remove whole div just empty it.
		}
		else
			container.remove(); // Remove whole div
//		var rem = root.getElementsByTagName('span')[0];
//		container.removeChild(rem);
	},
	isInputCorrectExist: function(el){
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				container=el;
			}
			if (typeof el === 'string') {//id
				container=document.getElementById(el);
			}	
		}
		var span = YAHOO.util.Dom.getNextSibling(container);
		if(span){
			if(span.className.indexOf('correct-icon')!=-1)
				return true;
			else
				return false;
		}
		else
			return false;
	},
	showInputWarning: function(el, warning_str, warning_div){
		var current_node;
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				current_node=el;
			}
			if (typeof el === 'string') {//id
				current_node=document.getElementById(el);
			}	
		}
		var root = current_node.parentNode;
		var warning_exist=false;
		var warning_container=null;
		if(warning_div){
			if (warning_div.nodeType || warning_div.item) { // Node, or NodeList
				warning_container=$j(warning_div);
			}
			if (typeof warning_div === 'string') {//id
				warning_container=$j('#'+ warning_div);
			}
	//		alert(err_container.html());
		}
		if(warning_container){
			$j(warning_container).find('span').each(function(i){
				if(this.className.indexOf('x-form-invalid-icon')!=-1)
				warning_exist=true;
			});
		}
		else{
			warning_exist=this.isInputWarningExist(current_node);
		}
			
		if(warning_exist){
			return;
		}
//		YAHOO.util.Dom.addClass(current_node, 'x-form-invalid');
		var warning_span = $j('<span></span>');
//		container.appendChild(error_span);
		if(warning_container){
			$j(warning_container).append(warning_span);
		}
		else{
			warning_span.insertAfter(current_node);
		}
		warning_span.addClass('x-form-invalid-icon');
		warning_span.addClass('warning-icon');
		warning_span.css('display', 'inline-block');
		warning_span.css('left', '5px');
		warning_span.append('&nbsp;');
		warning_span.css('visibility', 'visible');
		
		warning_span.attr('qtip', warning_str);
		warning_span.attr('qclass', 'x-form-invalid-tip x-form-warning-tip');
		
	},
	hideInputWarning: function(el, warning_div){
		var current_node;
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				current_node=el;
			}
			if (typeof el === 'string') {//id
				current_node=document.getElementById(el);
			}	
		}
		var root = current_node.parentNode;
		var container;
		var warning_exist=false;
		var warning_container=null;
		if(warning_div){
			if (warning_div.nodeType || warning_div.item) { // Node, or NodeList
				container=$j(warning_div);
			}
			if (typeof warning_div === 'string') {//id
				container=$j('#'+ warning_div);
			}
			warning_container = container;
	//		alert(err_container.html());
		}
		else{	
			container=$j(YAHOO.util.Dom.getNextSibling(current_node));
		}
		
		if(warning_container){
			$j(warning_container).find('span').each(function(i){
				if(this.className.indexOf('warning-icon')!=-1)
				warning_exist=true;
			});
		}
		else{
			warning_exist=this.isInputWarningExist(current_node);
		}
		if(!warning_exist){
			return;
		}
//		YAHOO.util.Dom.removeClass(current_node, 'x-form-invalid');
//		container.removeChild(YAHOO.util.Dom.getNextSibling(current_node));
		if(warning_container){
			warning_container.html(''); // Not to remove whole div just empty it.
		}
		else
			container.remove(); // Remove whole div
//		var rem = root.getElementsByTagName('span')[0];
//		container.removeChild(rem);
	},	
	isInputWarningExist: function(el){
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				container=el;
			}
			if (typeof el === 'string') {//id
				container=document.getElementById(el);
			}	
		}
		var span = YAHOO.util.Dom.getNextSibling(container);
		if(span){
			if(span.className.indexOf('warning-icon')!=-1)
				return true;
			else
				return false;
		}
		else
			return false;
	},
	showInputNotice: function(el, warning_str, warning_div){
		var current_node;
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				current_node=el;
			}
			if (typeof el === 'string') {//id
				current_node=document.getElementById(el);
			}	
		}
		var root = current_node.parentNode;
		var warning_exist=false;
		var warning_container=null;
		if(warning_div){
			if (warning_div.nodeType || warning_div.item) { // Node, or NodeList
				warning_container=$j(warning_div);
			}
			if (typeof warning_div === 'string') {//id
				warning_container=$j('#'+ warning_div);
			}
		}
		if(warning_container){
			$j(warning_container).find('span').each(function(i){
				if(this.className.indexOf('x-form-invalid-icon')!=-1)
				warning_exist=true;
			});
		}
		else{
			warning_exist=this.isInputWarningExist(current_node);
		}
			
		if(warning_exist){
			return;
		}
		var warning_span = $j('<span></span>');
		if(warning_container){
			$j(warning_container).append(warning_span);
		}
		else{
			warning_span.insertAfter(current_node);
		}
		warning_span.addClass('x-form-invalid-icon');
		warning_span.addClass('warning-icon');
		warning_span.css('display', 'inline-block');
		warning_span.css('left', '5px');
		warning_span.append('&nbsp;');
		warning_span.css('visibility', 'visible');
		
		warning_span.attr('qtip', warning_str);
		warning_span.attr('qclass', 'x-form-warning-tip x-form-notice-tip');
		
	},
	hideInputNotice: function(el, warning_div){
		var current_node;
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				current_node=el;
			}
			if (typeof el === 'string') {//id
				current_node=document.getElementById(el);
			}	
		}
		var root = current_node.parentNode;
		var container;
		var warning_exist=false;
		var warning_container=null;
		if(warning_div){
			if (warning_div.nodeType || warning_div.item) { // Node, or NodeList
				container=$j(warning_div);
			}
			if (typeof warning_div === 'string') {//id
				container=$j('#'+ warning_div);
			}
			warning_container = container;
		}
		else{	
			container=$j(YAHOO.util.Dom.getNextSibling(current_node));
		}
		
		if(warning_container){
			$j(warning_container).find('span').each(function(i){
				if(this.className.indexOf('warning-icon')!=-1)
				warning_exist=true;
			});
		}
		else{
			warning_exist=this.isInputWarningExist(current_node);
		}
		if(!warning_exist){
			return;
		}
		if(warning_container){
			warning_container.html(''); // Not to remove whole div just empty it.
		}
		else
			container.remove(); // Remove whole div
	}
};

QNAP.data = {
	encode: [
		['936', 'IEI_IDS_STRING936'],
		['950', 'IEI_IDS_STRING950'],
		['866', 'IEI_IDS_STRING866'],
		['437', 'IEI_IDS_STRING437'],
		['737', 'IEI_IDS_STRING737'],
		['861', 'IEI_IDS_STRING861'],
		['932', 'IEI_IDS_STRING932'],
		['949', 'IEI_IDS_STRING949'],
		['852', 'IEI_IDS_STRING852'],
		['850', 'IEI_IDS_STRING850']
	]
};

//QNAP.util.Share Package.
QNAP.util.Share = {
	IsItInList: function(name, slist){
		if (slist == undefined) {
			return false;
		}
		var index = 0;
		while (slist[index]) {
			if (name == slist[index].firstChild.nodeValue)
				return true;
			index ++;
		}
		return false;
	},
	AddNASShareList: function(oSelectList, strSelectedShare, oExcludeList, onGetShareList){
		var handleSuccess = function(o){
			if(o.responseText !== undefined){
				var xmlobject = (new DOMParser()).parseFromString(o.responseText, "text/xml");
				var shareList = xmlobject.getElementsByTagName('NASShareList');
				var nas_share_xml = shareList[0].getElementsByTagName('shareName');
				if (oSelectList != undefined) {
					var xIndex = 0, sIndex = 0, selIndex = -1;
					while (nas_share_xml[xIndex]) {
						var selected;
						var share_name = nas_share_xml[xIndex].firstChild.nodeValue;
						xIndex ++;
						if (share_name == strSelectedShare) 
							selected = true;
						else
							selected = false;
	
						if (!QNAP.util.Share.IsItInList(share_name, oExcludeList)) {
							var oOption = document.createElement("OPTION");
							oSelectList.options.add(oOption);
							oOption.setAttribute("title", share_name);
							oOption.value=share_name;
							oOption.text=share_name;
							if (selected)
								selIndex = sIndex;
							sIndex ++;
						}
					}
					if (selIndex>=0) oSelectList.options[selIndex].selected = true;
				}
				if (onGetShareList != undefined) {
					onGetShareList(nas_share_xml);
				}
			}
		}
		
		var handleFailure = function(o) {
			if (onGetShareList != undefined) {
				onGetShareList(undefined);
			}
		}
		
		var callback =
		{
			success:handleSuccess,
			failure:handleFailure,
			argument: {}
		};
		
		var sUrl = "/cgi-bin/genNasShareXML.cgi"+"?count="+Math.random();
		var request = YAHOO.util.Connect.asyncRequest('POST', sUrl, callback);
	}	
};

//Share package ends.

QNAP.util.Cookie = {
	//Cookie
	getCookies: function(){
		var trim = function(text) {return(text||"").replace(/^\s+|\s+$/g,"");};
		var c = document.cookie, 
			dic = {}, 
			list = [],
			i, len, key, value;
		list = c.split(';');
		for (i=0,len=list.length;i<len;i++)
		{
			key = trim(list[i].split('=')[0]);
			value = trim(list[i].split('=')[1]);
			dic[key] = value;
		}
		return dic;
	},
	getCookie: function(name){
		var trim = function(text) {return(text||"").replace(/^\s+|\s+$/g,"");};
		var c = document.cookie, 
			dic = {}, 
			list = [],
			i, len, key, value;
		list = c.split(';');
		for (i=0,len=list.length;i<len;i++)
		{
			key = trim(list[i].split('=')[0]);
			value = trim(list[i].split('=')[1]);
			dic[key] = value;
		}
		return !!dic[name] ? dic[name] : undefined;
//		var cname = name + "=";
//		var dc = document.cookie;
//		
//		if (dc.length > 0) {
//	    begin = dc.indexOf(cname);
//	    if (begin != -1) {
//	      begin += cname.length;
//	      end = dc.indexOf(";", begin);
//	      if (end == -1)
//	        end = dc.length;
//	      return unescape(dc.substring(begin, end));
//	    }
//		}
//		return null;
	},
	setCookie: function(name, value, expires){
	  document.cookie = name + "=" + escape(value) + "; path=/" + ((expires == null) ? "" : "; expires=" + expires.toGMTString());
	 	if (QNAP.util.Cookie.getCookie(name) == null) {
	    alert("You must enable the cookies to keep the language setting.");
	  }
	},
	delCookie: function(name){
  	document.cookie = name + "=; expires=Thu, 01-Jan-70 00:00:01 GMT" + "; path=/";
	},
	setSSLCookie: function(name, value, expires){
  	document.cookie = name + "=" + escape(value) + "; path=/" + ((expires == null) ? "" : "; expires=" + expires.toGMTString());
	}
};

QNAP.util.auth = {
	CheckIfAuthPassed: function(xmlObject){
		var auth = parseInt($j(xmlObject).find('QDocRoot authPassed').text());
		if(auth == 1){
			// auth passed
			return 1;
		}else{
			// auth failed
			return 0;
		}
/*		var root = xmlObject.getElementsByTagName('QDocRoot')[0];
		if (root.getElementsByTagName('authPassed')[0].firstChild.nodeValue == 0) {
			// auth failed
			return 0;
		}
		else {
			// auth passed
			return 1;
		}
*/
	},
	GotoLoginPage: function(port){
		if (port != null && location.protocol == "http:") {
			location.href = 'http://'+location_hostname_for_ipv6(location.hostname) +':'+ port ;
		}
		else {
			location.href = location.protocol + '//' + location_hostname_for_ipv6(location.hostname) +':'+ location.port ;
		}
	},
	Logout: function(port){
        var handleSuccess = function(o) {
                QNAP.util.auth.GotoLoginPage(port);
        }
        var handleFailure = function(o){
                QNAP.util.auth.GotoLoginPage(port);
        }
        var callback =
        {
                success:handleSuccess,
                failure:handleFailure
        };

		var sUrl = '/cgi-bin/authLogout.cgi?logout=1&count=' + Math.random()+'&sid=' + sid;
        var request = YAHOO.util.Connect.asyncRequest('POST', sUrl, callback);
        QNAP.util.Cookie.delCookie('NAS_SID','');
        QNAP.util.Cookie.delCookie('QFS_SID','');
        QNAP.util.Cookie.delCookie('QDS_SID','');
        QNAP.util.Cookie.delCookie('QMS_SID','');
        QNAP.util.Cookie.delCookie('QPS_SID','');
        QNAP.util.Cookie.delCookie('QMS_SID','');
        QNAP.util.Cookie.delCookie('QMMS_SID','');
        QNAP.util.Cookie.delCookie('home','');
	}

}

QNAP.util.headerLogo = {
	id_fm : "link_fm",
	id_ps : "link_ps",
	id_ds : "link_ds",
	id_nvr : "link_nvr",
	id_class_fm : "link_fm_class",
	id_class_ps : "link_ps_class",
	id_class_ds : "link_ds_class",
	id_class_nvr : "link_nvr_class",
	class_fm : "header_st_fm",
	class_fm_d : "header_st_fm_disabled",
	class_ps : "header_st_multi",
	class_ps_d : "header_st_multi_disabled",
	class_ds : "header_st_dl",
	class_ds_d : "header_st_dl_disabled",
	class_nvr : "header_st_sv",
	class_nvr_d : "header_st_sv_disabled",
	setTopLinks: function() {
		GetDSLink(sid)
	},
	enableFMLink: function(sid) {
		$j('#'.concat(this.id_fm)).attr('href', QNAP.util.link.GetFMLink(sid));
		$j('#'.concat(this.id_class_fm)).removeClass(this.class_fm_d);
		$j('#'.concat(this.id_class_fm)).addClass(this.class_fm);
		
		if ($j(root).children('QDocRoot').children('WFM2').text() != '')
		{
			$j('#'.concat(this.id_class_fm)).click(function(){
				var exp = new Date();
      	exp.setTime(exp.getTime() + (24 * 60 * 60 * 1000 * 3650));
				QNAP.util.Cookie.setCookie('nas_sid',sid, exp);			
			});
		}
	},
	disableFMLink: function() {
		$j('#'.concat(this.id_fm)).removeAttr('href');
		$j('#'.concat(this.id_class_fm)).removeClass(this.class_fm);
		$j('#'.concat(this.id_class_fm)).addClass(this.class_fm_d);
	},
	enablePSLink: function() {
		var link = QNAP.util.link.GetPSLink();
		$j('#'.concat(this.id_ps)).attr('href', '#');
		$j('#'.concat(this.id_class_ps)).removeClass(this.class_ps_d);
		$j('#'.concat(this.id_class_ps)).addClass(this.class_ps);
		$j('#'+this.id_ps).unbind('click');
		$j('#'+this.id_ps+'1').unbind('click'); //for cisco
		if(link == 'noweb'){
			$j('#'+this.id_ps).attr('href', '#');
			$j('#'+this.id_ps).click(function(e){
				e.preventDefault();
				q_confirm_run_post(QPKG_WEBSERVER_REMINDER, 
				function(){
					setMenuByUrl('/cgi-bin/net/html/web_srv.html');
				});
			});
			//for cisco started
			$j('#'+this.id_ps+'1').attr('href', '#');
			$j('#'+this.id_ps+'1').click(function(e){
				e.preventDefault();
				q_confirm_run_post(QPKG_WEBSERVER_REMINDER, 
				function(){
					setMenuByUrl('/cgi-bin/net/html/web_srv.html');
				});
			});
			//for cisco ended
		}else if(link == 'nossl'){
			$j('#'+this.id_ps).attr('href', '#');
			$j('#'+this.id_ps).click(function(e){
				e.preventDefault();
				q_confirm_run_post(QPKG_SSL_REMINDER, 
				function(){
					setMenuByUrl('/cgi-bin/net/html/web_srv.html');
				});
			});
			//for cisco started
			$j('#'+this.id_ps+'1').attr('href', '#');
			$j('#'+this.id_ps+'1').click(function(e){
				e.preventDefault();
				q_confirm_run_post(QPKG_SSL_REMINDER, 
				function(){
					setMenuByUrl('/cgi-bin/net/html/web_srv.html');
				});
			});
			//for cisco ended
		}else{
			$j('#'.concat(this.id_ps)).attr('href', link);
		}
	},
	disablePSLink: function() {
		$j('#'.concat(this.id_ps)).removeAttr('href');
		$j('#'.concat(this.id_class_ps)).removeClass(this.class_ps);
		$j('#'.concat(this.id_class_ps)).addClass(this.class_ps_d);
	},
	enableDSLink: function(sid) {
		$j('#'.concat(this.id_ds)).attr('href', QNAP.util.link.GetDSLink(sid));
		$j('#'.concat(this.id_class_ds)).removeClass(this.class_ds_d);
		$j('#'.concat(this.id_class_ds)).addClass(this.class_ds);
	},
	disableDSLink: function() {
		$j('#'.concat(this.id_ds)).removeAttr('href');
		$j('#'.concat(this.id_class_ds)).removeClass(this.class_ds);
		$j('#'.concat(this.id_class_ds)).addClass(this.class_ds_d);
	},
	enableNVRLink: function() {
		// 2012_04_19 Johntsai modify for ssv2 ===== start
		$j('#link_nvr').click(function()
		{
			if ( $j.browser.msie && navigator.userAgent.indexOf("Win64") == -1) 
			{
				window.open(QNAP.util.link.GetNVRLink());
			} 
			else 
			{
				q_alert(QLICENSE_WIZARD_STR70);
			}
			return false;
		});
		
		$j('#'.concat(this.id_nvr)).attr('href', QNAP.util.link.GetNVRLink());
		// 2012_04_19 Johntsai modify for ssv2 ===== end
		$j('#'.concat(this.id_class_nvr)).removeClass(this.class_nvr_d);
		$j('#'.concat(this.id_class_nvr)).addClass(this.class_nvr);
	},
	disableNVRLink: function() {
		$j('#'.concat(this.id_nvr)).removeAttr('href');
		$j('#'.concat(this.id_class_nvr)).removeClass(this.class_nvr);
		$j('#'.concat(this.id_class_nvr)).addClass(this.class_nvr_d);
	},
	hiddenNVRLink: function() {
		$j('#'.concat(this.id_nvr)).hide();                             
		$j('#'.concat(this.id_class_nvr)).hide();
	},
	hiddenDSLink: function() {
		$j('#'.concat(this.id_ds)).hide();                             
		$j('#'.concat(this.id_class_ds)).hide();
	},
	hiddenPSLink: function() {
		$j('#'.concat(this.id_ps)).hide();                             
		$j('#'.concat(this.id_class_ps)).hide();
	}
	
}

QNAP.util.link = {
	GetFMLink: function(sid) {
		if (sid != "" && sid != null) {		
			if ($j(root).children('QDocRoot').children('WFM2').text() != '')
				if(location.protocol == 'https:')
					if(wfmPortEnabled == "1")
						return "https://" + location_hostname_for_ipv6(location.hostname) + ":" + wfmPort + "/cgi-bin/filemanager/";
					else
						return "https://" + location_hostname_for_ipv6(location.hostname) + ":" + window.document.location.port + "/cgi-bin/filemanager/";
				else
					if(wfmPortEnabled == "1")
						return "http://" + location_hostname_for_ipv6(location.hostname) + ":" + wfmPort + "/cgi-bin/filemanager/";
					else
						return "http://" + location_hostname_for_ipv6(location.hostname) + ":" + window.document.location.port + "/cgi-bin/filemanager/";
			else
				return "/cgi-bin/filemanager/filemanager.cgi?folder=/home/httpd/cgi-bin/filemanager/share&ComboBox=ON&lang=eng&sid="+sid;
		}
	},
	GetPSLink: function() {
		if(multimediaStation.MSV2Supported == '1'){
			if(multimediaStation.webServerEnabled == '1'){
				if(location.protocol == 'http:'){
					return "http://" + location_hostname_for_ipv6(location.hostname) +":"+ multimediaStation.webServerPort + "/MSV2/";
				}else if(multimediaStation.sslServerEnabled == '1'){
					return "https://" + location_hostname_for_ipv6(location.hostname) +":"+ multimediaStation.sslServerPort + "/MSV2/";
				}else{
					return "nossl";
				}
			}else{
				if(location.protocol == 'http:'){
					return "noweb";
				}else{
					return "nossl";
				}
			}
		}else{
			return "/Qmultimedia";
		}
	},
	GetDSLink: function(sid) {
		if (sid != "" && sid != null) {
			if (($j(root).children('QDocRoot').children('DSV2Supported').text() == '1') || ($j(root).children('QDocRoot').children('DSV3Supported').text() == '1'))
			return location.protocol +"//"+ location_hostname_for_ipv6(location.hostname) +":"+ location.port +"/cgi-bin/Qdownload/qdownloadindex.cgi?rt_sid="+sid;
			else
			return location.protocol +"//"+ location_hostname_for_ipv6(location.hostname) +":"+ location.port +"/cgi-bin/Qdownload/qdownloadindex.cgi?sid="+sid;
			//return location.protocol +"//"+ location_hostname_for_ipv6(location.hostname) +":"+ location.port +"/cgi-bin/Qdownload/";
		}
		return "";
	},
	GetNVRLink: function() {
		return "/nssindex.html";
	},
	GotoFileManager: function(sid) {
		if (sid != "" && sid != null) {
			if ($j(root).children('QDocRoot').children('WFM2').text() != '')
				location.href = '/cgi-bin/filemanager/';
			else
				location.href = "/cgi-bin/filemanager/filemanager.cgi?folder=/home/httpd/cgi-bin/filemanager/share&ComboBox=ON&lang=eng&sid="+sid;
		}
	},
	GotoPhotoStation: function() {
		location.href = "/Qmultimedia";
	},
	GotoDownloadStation: function(sid) {
		if (sid != "" && sid != null) {
			location.href = location.protocol +"//"+ location_hostname_for_ipv6(location.hostname) +":"+ location.port +"/cgi-bin/Qdownload/qdownloadindex.cgi?sid="+sid;
			//location.href = location.protocol +"//"+ location_hostname_for_ipv6(location.hostname) +":"+ location.port +"/cgi-bin/Qdownload/";
		}
	},
	GotoNVRStation: function() {
		location.href = "/nssindex.html";
	}
}

//Wizard Package begin
QNAP.util.Wizard = {
	callback: null,
	subcallback: [],
	quit_callback: null,
	loaddata_callback: null,
	loaddatafinish_callback: null,
	wizard_title: null,
	qarguments: {},
	finish_str: QUICK_DEF_NAME11,
	cancel_on_finish: 0,
	back_on_finish:0,
	customCallbackAfterFinish: null,
	customCallbackAfterFinish_args: null,
	showStep: true,
	wizard: {
		message: null,
		open: function (dialog) {
//			$('#wizard-container .wizard-title').html('Loading...');
			//temp for import user function in import_user.js
			QNAP.tmpDialog = dialog;
			if($j.browser.msie){
				$j('.modalData').css('width', '600px');
			}
			QNAP.util.RefreshString('qnapstr');
			QNAP.util.Wizard.setup_steps(dialog);
			$j('.simplemodal-data').addClass('wizardData');
			
			if(QNAP.util.Wizard.loaddata_callback){
				QNAP.util.Wizard.loaddata_callback(QNAP.util.Wizard.qarguments);
			}
			
			dialog.overlay.fadeIn(100, function () {
				dialog.data.show();
				dialog.container.fadeIn(200, function () {	
					if(QNAP.util.Wizard.loaddatafinish_callback){
						QNAP.util.Wizard.loaddatafinish_callback();
					}
	
				/*
					dialog.data.fadeIn(200, function () {
						$j('#wizard-container').animate({
							height: 400
						}, function () {
							$j('#wizard-container').fadeIn(200, function () {
								$('#wizard-container').focus();
	
								// fix png's for IE 6
								if ($.browser.msie && $.browser.version < 7) {
									$('#wizard-container .wizard-button').each(function () {
										if ($(this).css('backgroundImage').match(/^url[("']+(.*\.png)[)"']+$/i)) 
										{
											var src = RegExp.$1;
											$(this).css({
												backgroundImage: 'none',
												filter: 'progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' +  src + '", sizingMethod="crop")'
											});
										}
									});
								}
							});
							
						});
					});
					*/
					
				});
			});
		},
		show: function (dialog) {
		},
		close: function (dialog) {
			if(QNAP.util.Wizard.quit_callback){
				QNAP.util.Wizard.quit_callback();
			}
			dialog.data.fadeOut(200, function () {
				dialog.container.fadeOut(200, function () {
					dialog.overlay.fadeOut(200, function () {
						$j.modal.close();
					});
				});
			});
		},
		error: function (xhr) {
			alert(xhr.statusText);
		}
	},	
	next_step: function(idx, opt){
		if(opt!=null){
			if(opt==2){
				var op1 = YAHOO.util.Dom.get('step'+(idx+1));
				if(op1){
					if(op1.className.indexOf('option')!=-1){
//						alert('op1 exist');	
					}
					else
						alert('bug');
				}
			}
			else if(opt==3){
				var op2 = YAHOO.util.Dom.get('step'+(idx+2));
				if(op2){
					if(op2.className.indexOf('option')!=-1){
//						alert('op2 exist');	
					}
					else
						alert('bug');
				}
			}
			else
				alert('bug');
		}
		var o = YAHOO.util.Dom.get('step'+idx);
		var ob=YAHOO.util.Dom.get('step'+idx+'_bn');
		if(opt==null){
			//Get next non-option page.
			var op;
			idx++;
			while(op = YAHOO.util.Dom.get('step'+(idx))){
				if(op.className.indexOf('option')!=-1)
					idx++;
				else
					break;
			}
		}
		else{
			if(opt==2)
				idx+=1;
			else if(opt==3)
				idx+=2;	
		}
		var o_next = YAHOO.util.Dom.get('step'+idx);
		var o_nextb=YAHOO.util.Dom.get('step'+idx+'_bn');
		o.style.display='none';
		ob.style.display='none';
		if(o_next.className.indexOf('noleftimg')!=-1){
			$j('#leftimg').hide();
		}
		else{
			$j('#leftimg').show();
		}
		o_next.style.display='inline';
		o_nextb.style.display='block';
				
	},
	pre_step: function(idx){
		var o = YAHOO.util.Dom.get('step'+idx);
		var ob=YAHOO.util.Dom.get('step'+idx+'_bn');
		idx--;
		//Find the previous non-option page
		var op;
		while(op = YAHOO.util.Dom.get('step'+(idx))){
			if(op.className.indexOf('option')!=-1)
				idx--;
			else
				break;
		}
		
		var o_pre = YAHOO.util.Dom.get('step'+idx);
		var o_preb=YAHOO.util.Dom.get('step'+idx+'_bn');
		o.style.display='none';
		ob.style.display='none';
		
		if(o_pre.className.indexOf('noleftimg')!=-1){
			$j('#leftimg').hide();
		}
		else{
			$j('#leftimg').show();
		}
		
		o_pre.style.display='inline';
		o_preb.style.display='block';
	},
	close_wiz: function(dialog){
		dialog.data.fadeOut(200, function () {
						dialog.container.fadeOut(200, function () {
							dialog.overlay.fadeOut(200, function () {
								$j.modal.close();
							});
						});
					});
	},
	setup_steps: function(dialog){
		var tit = document.createElement('div');
		var container = YAHOO.util.Dom.get('wizard-container');	
//		container.appendChild(tit);
		YAHOO.util.Dom.insertBefore(tit, container.firstChild);
		YAHOO.util.Dom.addClass(tit, 'wizard_title_bar');
		if($j.browser.msie){
			tit.style.width='600px';
		}
		if(QNAP.util.Wizard.wizard_title)
			tit.appendChild(document.createTextNode(QNAP.util.Wizard.wizard_title));
		else
			tit.appendChild(document.createTextNode('Wizard'));

		var steps = YAHOO.util.Dom.getElementsByClassName('step');

		var modaldata = YAHOO.util.Dom.getElementsByClassName('simplemodal-data')[0];
		var leftpanel = $j('<div></div>');
		leftpanel.attr('id','leftimg');
		leftpanel.css('float', 'left');
		leftpanel.css('display', 'inline');
//		leftpanel.css({float:'left', display:'inline'});
//		leftpanel.insertBefore(($j('#wiz_whole_body:first-child')));
		leftpanel.insertBefore(modaldata.firstChild);
		var img = document.createElement('img');
		img.src='/ajax_obj/images/wizard_box.jpg';
		img.title='Setup Wizard';
		img.alt='Setup Wizard';
//		leftpanel.appendChild(img);	
		leftpanel.append(img);
		for(var i=0;i<steps.length;i++){
			var buttom = document.createElement('div');
			container.appendChild(buttom);
			buttom.id='step'+i+'_bn';
			YAHOO.util.Dom.addClass(buttom, 'wizard_buttom_bar');
			var w_step = document.createElement('div');
			buttom.appendChild(w_step);
			YAHOO.util.Dom.addClass(w_step, 'wizard_step');
			if(QNAP.util.Wizard.showStep==true)
				w_step.appendChild(document.createTextNode(NIC_MS_AD_QUICK_STEP01+' ' + (i+1) + ' / ' + steps.length));
		
			var w_button = document.createElement('div');
			buttom.appendChild(w_button);
			YAHOO.util.Dom.addClass(w_button, 'wizard_buttom_div');
			
			steps[i].id='step' + i;
			YAHOO.util.Dom.addClass(steps[i],'wizard_content');
			
			if(i==0){
				buttom.style.display='block';
				steps[i].style.display='inline';
				if(steps[i].className.indexOf('noleftimg')!=-1){
					leftpanel.hide();
				}else{
					leftpanel.show();
				}
			}
			else{
				steps[i].style.display='none';
				buttom.style.display='none';	
			}
			
			if(i!=0 && ( (i != steps.length-1) || (QNAP.util.Wizard.back_on_finish == 1) ) ){
				var pre_button = document.createElement('a');
				YAHOO.util.Dom.addClass(pre_button, 'wizard_button');
				w_button.appendChild(pre_button);
				var span = document.createElement('span');
				span.appendChild(document.createTextNode(QUICK09_STR08));
				pre_button.appendChild(span);
				pre_button.id=steps[i].id+'_button_pre';
				pre_button.style.cursor='pointer';
				
				$j(pre_button).click(function (e) {
					e.preventDefault();
					var idx = parseInt(this.id.substring(4,this.id.indexOf('_')));
					QNAP.util.Wizard.pre_step(idx);
/*
					if(idx>0){ 
						if(steps[idx-1].className.indexOf('noleftimg')!=-1){
							leftpanel.hide();
						}
						else{
							leftpanel.show();
						}
					}
					*/
				});
			}		
			
			var next_button = document.createElement('a');
			next_button.id=steps[i].id+'_button_next';
			YAHOO.util.Dom.addClass(next_button, 'wizard_button');
			w_button.appendChild(next_button);
			var span = document.createElement('span');
			if(i==steps.length-1){
				span.appendChild(document.createTextNode(QNAP.util.Wizard.finish_str));
				$j(next_button).click(function (e) {
					e.preventDefault();
					if(QNAP.util.Wizard.callback)
						QNAP.util.Wizard.callback(dialog, QNAP.util.Wizard.customCallbackAfterFinish, QNAP.util.Wizard.customCallbackAfterFinish_args);
						if(QNAP.util.Wizard.quit_callback){
							QNAP.util.Wizard.quit_callback();
						}
				});
			}
			else{			
				span.appendChild(document.createTextNode(QUICK09_STR09));

				$j(next_button).click(function (e) {
					e.preventDefault();
					var idx = parseInt(this.id.charAt(4));
					var option=null;
					if(QNAP.util.Wizard.subcallback[idx]){
						var ret=null;
						ret = QNAP.util.Wizard.subcallback[idx]();
						if(ret==false)
							return;
						if(ret==2|| ret==3)
							option=ret;
					}
	/*				
					if(idx<steps.length){ 
						if(steps[idx+1].className.indexOf('noleftimg')!=-1){
							leftpanel.hide();
						}
						else{
							leftpanel.show();
						}
					}
					*/
					QNAP.util.Wizard.next_step(idx,option);
				});
			}		
			next_button.style.cursor='pointer';
			next_button.appendChild(span);	
				
			if(QNAP.util.Wizard.cancel_on_finish==1 || i!=steps.length-1){
				var cancel_button = document.createElement('a');
				YAHOO.util.Dom.addClass(cancel_button, 'wizard_button');
				w_button.appendChild(cancel_button);
				var cspan=document.createElement('span');
				cspan.appendChild(document.createTextNode(IEI_NAS_BUTTON_CANCEL));
				cancel_button.appendChild(cspan);
				cancel_button.style.cursor='pointer';
		
				$j(cancel_button).click(function (e) {
					e.preventDefault();
					//Close
					QNAP.util.Wizard.close_wiz(dialog);
					//End
				});
			}
		}
	},
	OpenWizard: function(options , w_callback){
	//OpenWizard: function(str, tit, finish_str, cancel_on_finish, loaddata, quit_callback, w_callback){
		/*
		 *	str: wizard html path.
		 *	tit: title for wizard title field
		 *	loaddata: load data callback function
		 *	quit_callback: call back when pushing cancel or finish button.
		 *	w_callback: finish callback function
		 *
		 */
		var defaults = {
			url:'html/user_create_wizard',
			isUrl:true,
			wiz_title:'',
			finish_str: QUICK_DEF_NAME11,
			cancel_on_finish: false,
			back_on_finish:false,
			onLoad: null,
			qarguments:{},
			onQuit:null,
			onFinish:null,
			onLoadFinish:null,
			customCallbackAfterFinish:null,
			customCallbackAfterFinish_args:{},
			showStep: true
		};
		var opts = $j.extend({}, defaults, options);
		
		QNAP.util.Wizard.subcallback=[];
		QNAP.util.Wizard.callback=null;
		QNAP.util.Wizard.wizard_title='';
		QNAP.util.Wizard.quit_callback=null;
		QNAP.util.Wizard.loaddata_callback=null;
		QNAP.util.Wizard.customCallbackAfterFinish_args=opts.customCallbackAfterFinish_args;
		for(var i=1;i<arguments.length; i++){
			QNAP.util.Wizard.subcallback[i-1] = arguments[i];
//			alert(i-2 + ' ' + QNAP.util.Wizard.subcallback[i-2]);
		}
		QNAP.util.Wizard.callback=opts.onFinish;
		QNAP.util.Wizard.wizard_title=opts.wiz_title;
		if(opts.finish_str)
			QNAP.util.Wizard.finish_str=opts.finish_str;
		QNAP.util.Wizard.cancel_on_finish=opts.cancel_on_finish;
		QNAP.util.Wizard.back_on_finish=opts.back_on_finish;
		QNAP.util.Wizard.quit_callback = opts.onQuit;
		QNAP.util.Wizard.loaddata_callback=opts.onLoad;
		QNAP.util.Wizard.loaddatafinish_callback=opts.onLoadFinish;
		QNAP.util.Wizard.customCallbackAfterFinish=opts.customCallbackAfterFinish;
		QNAP.util.Wizard.qarguments = opts.qarguments;
		QNAP.util.Wizard.showStep= opts.showStep;
		var sUrl=opts.url;
			
		// load the wizard form using ajax
		if(opts.isUrl){
			$j.ajaxSetup({cache:false});
			
			if (/Chrome/.test(navigator.appVersion) &&
					location.protocol == 'https:')
			{
	      $j.get(sUrl, function(data){
					$j(data).modal({
						close: true,
						overlayId: 'wizard-overlay',
						containerId: 'wizard-container',
						onOpen: QNAP.util.Wizard.wizard.open,
						onShow: QNAP.util.Wizard.wizard.show,
						onClose: QNAP.util.Wizard.wizard.close
					});
				});			
			} else {
				$j.ajax({
	        type: "get",
	        async: false,
	        url: sUrl,
	        success:function(data, textStatus){
	          $j(data).modal({
	  					close: true,
	  					overlayId: 'wizard-overlay',
	  					containerId: 'wizard-container',
	  					onOpen: QNAP.util.Wizard.wizard.open,
	  					onShow: QNAP.util.Wizard.wizard.show,
	  					onClose: QNAP.util.Wizard.wizard.close
					  });
	        }
	      });  
			}	  	
		}else{
			$j(opts.url).modal({
					close: true,
					overlayId: 'wizard-overlay',
					containerId: 'wizard-container',
					onOpen: QNAP.util.Wizard.wizard.open,
					onShow: QNAP.util.Wizard.wizard.show,
					onClose: QNAP.util.Wizard.wizard.close
			});
		}
	},
	/*****************************************************************
		adjust wizard heights after the wizard has been loaded
	******************************************************************/
	adjustHeight: function(newHeight){
		var winW = 0, winH = 0;
		if (document.body && document.body.offsetWidth) {
		 winW = document.body.offsetWidth;
		 winH = document.body.offsetHeight;
		}
		if (document.compatMode=='CSS1Compat' &&
			document.documentElement &&
			document.documentElement.offsetWidth ) {
		 winW = document.documentElement.offsetWidth;
		 winH = document.documentElement.offsetHeight;
		}
		if (window.innerWidth && window.innerHeight) {
		 winW = window.innerWidth;
		 winH = window.innerHeight;
		}
		var maxWizardHeight = winH-130;
		var topOffset = 15;
		if(typeof(newHeight) == 'undefined' || newHeight=='max' || newHeight > maxWizardHeight) 
			newHeight = maxWizardHeight;
		else
			topOffset = parseInt((winH - (newHeight + 100))/2);
		$j('#wiz_whole_body').css('height', newHeight+'px');
		$j('#wizard-container').css('top', topOffset+'px');
	},
	addPanelHelp: function(el, path){
		var wc = YAHOO.util.Dom.get(el);
		var con = wc.getElementsByTagName('div')[0];
		var help_icon = document.createElement('div');
		con.appendChild(help_icon);
		help_icon.appendChild(document.createTextNode('  '));
		help_icon.id='wizard_help';
		YAHOO.util.Dom.addClass(help_icon,'x-tool');
		YAHOO.util.Dom.addClass(help_icon,'x-tool-help');
		$j(help_icon).hover(function(){
				YAHOO.util.Dom.addClass(help_icon,'x-tool-help-over');
		}, function(){YAHOO.util.Dom.removeClass(help_icon,'x-tool-help-over');});
	},
	addPanelRSS: function(el, path){
		var wc = YAHOO.util.Dom.get(el);
		var con = wc.getElementsByTagName('div')[0];
		var help_icon = document.createElement('div');
		con.appendChild(help_icon);
		help_icon.appendChild(document.createTextNode('  '));
		help_icon.id='rss_link';
		YAHOO.util.Dom.addClass(help_icon,'rss_link');
	},
	setPauseRun: function(el, run){
		var obj = $j('#'+el);
		if(run==0){
			obj.addClass('x-tool');
			obj.addClass('x-tool-pin');
			
			obj.attr('title', 'Pause');
			obj.unbind('mouseover mouseout');
			obj.bind('mouseover', function(e){
				e.preventDefault();
				obj.addClass('x-tool-pin-over');
			});
			
			obj.bind('mouseout', function(e){
				e.preventDefault();
				obj.removeClass('x-tool-pin-over');
			});
		}else{
			obj.attr('title', 'Run');
			obj.unbind('mouseover mouseout');
			obj.bind('mouseover', function(e){
				e.preventDefault();
				obj.addClass('x-tool-run-over');
			}); 
			obj.bind('mouseout', function(e){
				e.preventDefault();
				obj.removeClass('x-tool-run-over');
			});
			obj.removeClass('x-tool-pin-over');
			obj.removeClass('x-tool-pin');
			obj.addClass('x-tool-run');
		}
		obj = null;
	},
	addPanelPause: function(el){
		var wc = YAHOO.util.Dom.get(el);
		var con = wc.getElementsByTagName('div')[0];
		var help_icon = document.createElement('div');
		con.appendChild(help_icon);
		help_icon.appendChild(document.createTextNode('  '));
		help_icon.id='cpumem_pin';
		QNAP.util.Wizard.setPauseRun(help_icon.id, 0);
		
		$j(help_icon).click(function(e){	
			e.preventDefault();
			var obj = $j(help_icon);
			if(help_icon.className.indexOf('x-tool-pin')!=-1){
				if(sysinfo){
					sysinfo.stopRequest();	
				}
				QNAP.util.Wizard.setPauseRun(help_icon.id, 1);
/*				obj.attr('title', 'Run');
				obj.unbind('mouseover mouseout');
				obj.bind('mouseover', function(e){
					e.preventDefault();
					$j(help_icon).addClass('x-tool-run-over');
				}); 
				obj.bind('mouseout', function(e){
					e.preventDefault();
					$j(help_icon).removeClass('x-tool-run-over');
				});
				obj.removeClass('x-tool-pin-over');
				obj.removeClass('x-tool-pin');
				obj.addClass('x-tool-run');
				*/
			}else{
				if(sysinfo){
					sysinfo.getSysInfo(3000);	
				}
				QNAP.util.Wizard.setPauseRun(help_icon.id, 0);
				/*
				obj.attr('title', 'Pause');
				obj.unbind('mouseover mouseout');
				obj.bind('mouseover', function(e){
					e.preventDefault();
					$j(help_icon).addClass('x-tool-pin-over');
				});
				
				obj.bind('mouseout', function(e){
					e.preventDefault();
					$j(help_icon).removeClass('x-tool-pin-over');
				});
				obj.removeClass('x-tool-run-over');
				obj.removeClass('x-tool-run');
				obj.addClass('x-tool-pin');
				*/
			}
		});
	}
};


//Wizard package end.

QNAP.util.ThreeColumeAccessTable = function(el, list, type_str){
	this.list = list;
	
	if(el){
		if (el.nodeType || el.item) { // Node, or NodeList
			this.el=el;
		}
		if (typeof el === 'string') {//id
			this.el=document.getElementById(el);
		}	
	}
	this.typeStr = type_str;
	this.setList = function(list){
		this.list = list;		
	}
	this.setEl = function(el){
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				this.el=el;
			}
			if (typeof el === 'string') {//id
				this.el=document.getElementById(el);
			}	
		}	
	}
	this.setType = function(type_str){
		this.typeStr = type_str;
	};
	this.getCurrentPage = function(type_str){
		return parseInt(YAHOO.util.Dom.get(type_str+'_current_page').innerHTML);
	};

	this.setCurrentPage = function(type_str, page_no){
		YAHOO.util.Dom.get(type_str+'_current_page').innerHTML = page_no;
	};
	
	this.showSPage = function(body,Items, prev_no, page_no, entry_perpage){
		var s_pc = $j('<div></div>').attr('id', this.typeStr+'_page_content').addClass(this.typeStr+'_page_content').css('display', 'none').appendTo('body');	
		var total_pages = parseInt(Items.length/entry_perpage);
		if((Items.length%entry_perpage)!=0)
			total_pages++;
	
		var mlen; 
		var start=entry_perpage*(page_no-1);
		
		//Button setup begin
		if(page_no!=total_pages && page_no!=1){
			mlen = start+entry_perpage;
			YAHOO.util.Dom.get(this.typeStr+'_next').style.display='block';
			YAHOO.util.Dom.get(this.typeStr+'_prev').style.display='block';
		}else if(page_no==1){
			mlen = start+entry_perpage;
			if(total_pages>1){
				YAHOO.util.Dom.get(this.typeStr+'_next').style.display='block';
				YAHOO.util.Dom.get(this.typeStr+'_prev').style.display='none';
			}
		}
		else{
			mlen = Items.length; 	
			YAHOO.util.Dom.get(this.typeStr+'_prev').style.display='block';
			YAHOO.util.Dom.get(this.typeStr+'_next').style.display='none';
		}
		//Button setup end
		
		var c_page_obj = YAHOO.util.Dom.get(this.typeStr+'_page'+page_no);
		if(c_page_obj){
			if(prev_no != 0){
				var tb = YAHOO.util.Dom.get(this.typeStr+'_page'+prev_no);
				if(tb==null){
					var tb = document.createElement('tbody');
					tb.id='share_page'+prev_no;
	//				s_pc.appendChild(tb);
					s_pc.append(tb);
				}
				var old_tr = body.getElementsByTagName('tr');
				for(var j=0;j<old_tr.length;j++){
					tb.appendChild(old_tr[j]);
					j--;
				}
			}
			var new_tr = c_page_obj.getElementsByTagName('tr');
			for(var k=0;k<new_tr.length;k++){
				body.appendChild(new_tr[k]);
				k--;
			}
			
		}else{
			if(prev_no != 0){
				var tb = YAHOO.util.Dom.get(this.typeStr+'_page'+prev_no);
				if(tb==null){
					tb = document.createElement('tbody');
					tb.id=this.typeStr+'_page'+prev_no;
					//s_pc.appendChild(tb);
					s_pc.append(tb);
				}
				
				var old_tr = body.getElementsByTagName('tr');
				for(var j=0;j<old_tr.length;j++){
					tb.appendChild(old_tr[j]);
					j--;
				}
			}
			for(var i=start;i<mlen;i++){
				var tr = document.createElement('tr');
				body.appendChild(tr);
				if(i%2==0){
					YAHOO.util.Dom.addClass(tr, 'box_content_tr1');	
				}else{
					YAHOO.util.Dom.addClass(tr, 'box_content_tr2');	
				}
				var td_sname = document.createElement('td');
				td_sname.style.overflow = "hidden";
				td_sname.noWrap = "true";
				td_sname.title = Items[i].getElementsByTagName('name')[0].firstChild.nodeValue;
				tr.appendChild(td_sname);
				td_sname.appendChild(document.createTextNode(Items[i].getElementsByTagName('name')[0].firstChild.nodeValue));
				var td_cmt = document.createElement('td');
				td_cmt.style.overflow = "hidden";
				td_cmt.noWrap = "true";
				var td_box = document.createElement('td');
				tr.appendChild(td_box);
				tr.appendChild(td_box);
				td_box.setAttribute('align',"center");
				var ck_rd = document.createElement('input');
				ck_rd.setAttribute('type','checkbox');
				ck_rd.setAttribute('value', Items[i].getElementsByTagName('name')[0].firstChild.nodeValue);
				ck_rd.setAttribute('name',this.typeStr+'_rd'+i);
				ck_rd.setAttribute('id',this.typeStr+'_rd'+i);
				var str = this.typeStr;
				$j(ck_rd).click(function(){
					var idx=this.id.substr(8);
					$j('input[@name='+str+'_rw'+idx+']').attr("checked", false); 
					$j('input[@name='+str+'_no'+idx+']').attr("checked", false); 
				});
				
				td_box.appendChild(ck_rd);
				
				var td_box1 = document.createElement('td');
				tr.appendChild(td_box1);
				tr.appendChild(td_box1);
				td_box1.setAttribute('align',"center");
				var ck_rw = document.createElement('input');
				ck_rw.setAttribute('type','checkbox');
				ck_rw.setAttribute('value', Items[i].getElementsByTagName('name')[0].firstChild.nodeValue);
				ck_rw.setAttribute('id',this.typeStr+'_rw'+i);
				ck_rw.setAttribute('name',this.typeStr+'_rw'+i);
				$j(ck_rw).click(function(){
					var idx=this.id.substr(8);
					$j('input[@name='+str+'_rd'+idx+']').attr("checked", false); 
					$j('input[@name='+str+'_no'+idx+']').attr("checked", false); 
				});
		
				td_box1.appendChild(ck_rw);
				
				var td_box2 = document.createElement('td');
				tr.appendChild(td_box2);
				tr.appendChild(td_box2);
				td_box2.setAttribute('align',"center");
				YAHOO.util.Dom.addClass(td_box2, 'box_td_end');
				
				var ck_no = document.createElement('input');
				ck_no.setAttribute('type','checkbox');
				ck_no.setAttribute('value', Items[i].getElementsByTagName('name')[0].firstChild.nodeValue);
				ck_no.setAttribute('name',this.typeStr+'_no'+i);
				ck_no.setAttribute('id',this.typeStr+'_no'+i);
				$j(ck_no).click(function(){
					var idx=this.id.substr(8);
					$j('input[@name='+str+'_rd'+idx+']').attr("checked", false); 
					$j('input[@name='+str+'_rw'+idx+']').attr("checked", false); 
				});
				
				td_box2.appendChild(ck_no);
			}
		}
		this.setCurrentPage(this.typeStr, page_no);
	}	
	
	this.init = function(){
		var _self=this;
		var obody = this.el.getElementsByTagName('table')[0].getElementsByTagName('tbody')[0];
		
		if(this.list){
  		var maxentry_perpage = 6;
  		var Items = this.list.getElementsByTagName(this.typeStr);	
  	
  		if(Items.length>maxentry_perpage){
  			var end_box = document.createElement('div');
	  		YAHOO.util.Dom.addClass(end_box, 'box_end_div');
	  		YAHOO.util.Dom.get(this.typeStr+'_box').appendChild(end_box);
	  		
	  		var next_div = document.createElement('div');
	  		end_box.appendChild(next_div);
	  		next_div.id=this.typeStr+'_next';
	  		YAHOO.util.Dom.addClass(next_div, this.typeStr+'_func_li next');
	  		var next_a = document.createElement('a');
	  		next_div.appendChild(next_a);
				next_a.style.cursor='pointer';
				$j(next_a).click(function(){
					var c_page=_self.getCurrentPage(_self.typeStr);
					var c_page_obj = YAHOO.util.Dom.get(_self.typeStr+'_page'+c_page);
					if(c_page_obj)
						c_page_obj.style.display='none';

					_self.showSPage(obody, Items, c_page, ++c_page, maxentry_perpage);
				});
	  		var next_img = document.createElement('img');
	  		next_a.appendChild(next_img);
	  		next_img.setAttribute('src','/ajax_obj/images/icon_next.gif');
	  		next_img.setAttribute('border', '0');
	  		
	  		var prev_div = document.createElement('div');
	  		end_box.appendChild(prev_div);
	  		prev_div.id=this.typeStr+'_prev';
	  		YAHOO.util.Dom.addClass(prev_div, this.typeStr+'_func_li prev');
	  		var prev_a = document.createElement('a');
	  		prev_div.appendChild(prev_a);
	  		$j(prev_a).click(function(){
						var c_page=_self.getCurrentPage(_self.typeStr);
						var c_page_obj = YAHOO.util.Dom.get(_self.typeStr+'_page'+c_page);
						if(c_page_obj)
							c_page_obj.style.display='none';
						
						_self.showSPage(obody, Items, c_page, --c_page, maxentry_perpage);
					});
	  		var prev_img = document.createElement('img');
	  		prev_a.appendChild(prev_img);
	  		prev_img.setAttribute('src','/ajax_obj/images/icon_prev.gif');
	  		prev_img.setAttribute('border', '0');
	  		prev_img.setAttribute('alt', 'previous page');
	  		
			}
			var c_page = document.createElement('div');
			this.el.appendChild(c_page);
			c_page.style.display='none';
			c_page.id=this.typeStr+'_current_page';
			c_page.innerHTML=1;
    	
    	var total_pages = parseInt(Items.length/maxentry_perpage);
			if((Items.length%maxentry_perpage)!=0)
				total_pages++;
				
			for(var l=total_pages; l>=1; l--){
    		this.showSPage(obody, Items, l+1, l, maxentry_perpage);
    	}
    	
  	}
	};
}



QNAP.util.AccessTable = function(el, list, type_str){
	this.list = list;
	
	if(el){
		if (el.nodeType || el.item) { // Node, or NodeList
			this.el=el;
		}
		if (typeof el === 'string') {//id
			this.el=document.getElementById(el);
		}	
	}
	this.typeStr = type_str;
	this.setList = function(list){
		this.list = list;		
	}
	this.setEl = function(el){
		if(el){
			if (el.nodeType || el.item) { // Node, or NodeList
				this.el=el;
			}
			if (typeof el === 'string') {//id
				this.el=document.getElementById(el);
			}	
		}	
	}
	this.setType = function(type_str){
		this.typeStr = type_str;
	};
	this.getCurrentPage = function(type_str){
		return parseInt(YAHOO.util.Dom.get(type_str+'_current_page').innerHTML);
	};

	this.setCurrentPage = function(type_str, page_no){
		YAHOO.util.Dom.get(type_str+'_current_page').innerHTML = page_no;
	};
	
	this.showPage = function(body,Items, prev_no, page_no, entry_perpage){

		var pc = $j('<div></div>').attr('id', this.typeStr+'_page_content').addClass(this.typeStr+'_page_content').css('display','none').appendTo('body');
		
		var total_pages = parseInt(Items.length/entry_perpage);
		if((Items.length%entry_perpage)!=0)
			total_pages++;
	
		var mlen; 
		var start=entry_perpage*(page_no-1);
		
		//Button setup begin
		if(page_no!=total_pages && page_no!=1){
			mlen = start+entry_perpage;
			var nexto = YAHOO.util.Dom.get(this.typeStr+'_next');
			if(nexto)
				nexto.style.display='block';
				
			var prevo = YAHOO.util.Dom.get(this.typeStr+'_prev');
			if(prevo)
				prevo.style.display='block';
		}
		else if(page_no==1){
			mlen = start+entry_perpage;
			if(mlen>Items.length)
				mlen = Items.length;
			var nexto = YAHOO.util.Dom.get(this.typeStr+'_next');
			if(nexto)
				nexto.style.display='block';
			var prevo = YAHOO.util.Dom.get(this.typeStr+'_prev');
			if(prevo)
				prevo.style.display='none';
		}
		else{
			mlen = Items.length; 	
			var prevo = YAHOO.util.Dom.get(this.typeStr+'_prev');
			if(prevo)
				prevo.style.display='block';
			var nexto = YAHOO.util.Dom.get(this.typeStr+'_next');
			if(nexto)
				nexto.style.display='none';
		}
		//Button setup end
		
		var c_page_obj = YAHOO.util.Dom.get(this.typeStr+'_page'+page_no);
		if(c_page_obj){
			if(prev_no != 0){
				var tb = YAHOO.util.Dom.get(this.typeStr+'_page'+prev_no);
				if(tb==null){
					var tb = document.createElement('tbody');
					tb.id=this.typeStr+'_page'+prev_no;
//					pc.appendChild(tb);
					pc.append(tb);
				}
				var old_tr = body.getElementsByTagName('tr');
				for(var j=0;j<old_tr.length;j++){
					tb.appendChild(old_tr[j]);
					j--;
				}
			}
			var new_tr = c_page_obj.getElementsByTagName('tr');
			for(var k=0;k<new_tr.length;k++){
				body.appendChild(new_tr[k]);
				k--;
			}
			
		}
		else{
			if(prev_no != 0){
				var tb = YAHOO.util.Dom.get(this.typeStr+'_page'+prev_no);
				if(tb==null){
					tb = document.createElement('tbody');
					tb.id=this.typeStr+'_page'+prev_no;
//					pc.appendChild(tb);
					pc.append(tb);
				}
				
				var old_tr = body.getElementsByTagName('tr');
				for(var j=0;j<old_tr.length;j++){
					tb.appendChild(old_tr[j]);
					j--;
				}
			}
			for(var i=start;i<mlen;i++){
				var tr = document.createElement('tr');
				body.appendChild(tr);
				if(i%2==0){
					YAHOO.util.Dom.addClass(tr, 'box_content_tr1');	
				}else{
					YAHOO.util.Dom.addClass(tr, 'box_content_tr2');	
				}
				var td_sname = document.createElement('td');
				tr.appendChild(td_sname);
				td_sname.appendChild(document.createTextNode(Items[i].getElementsByTagName('name')[0].firstChild.nodeValue));
				var td_cmt = document.createElement('td');
				tr.appendChild(td_cmt);
				if(Items[i].getElementsByTagName('comment')[0].firstChild)
					td_cmt.appendChild(document.createTextNode(Items[i].getElementsByTagName('comment')[0].firstChild.nodeValue));
				else
					td_cmt.appendChild(document.createTextNode('---'));
				var td_box = document.createElement('td');
				tr.appendChild(td_box);
				tr.appendChild(td_box);
				td_box.setAttribute('align',"center");
				var ck_rd = document.createElement('input');
				ck_rd.setAttribute('type','checkbox');
				ck_rd.setAttribute('value', Items[i].getElementsByTagName('name')[0].firstChild.nodeValue);
				ck_rd.setAttribute('name',this.typeStr+'_rd'+i);
				ck_rd.setAttribute('id',this.typeStr+'_rd'+i);
				$j(ck_rd).click(function(){
					var idx=this.id.substr(8);
					$j('input[@name=' + this.typeStr+ + '_rw'+idx+']').attr("checked", false); 
					$j('input[@name=' + this.typeStr+ + '_no'+idx+']').attr("checked", false); 
				});
				
				td_box.appendChild(ck_rd);
				
				var td_box1 = document.createElement('td');
				tr.appendChild(td_box1);
				tr.appendChild(td_box1);
				td_box1.setAttribute('align',"center");
				var ck_rw = document.createElement('input');
				ck_rw.setAttribute('type','checkbox');
				ck_rw.setAttribute('value', Items[i].getElementsByTagName('name')[0].firstChild.nodeValue);
				ck_rw.setAttribute('id',this.typeStr+'_rw'+i);
				ck_rw.setAttribute('name',this.typeStr+'_rw'+i);
				$j(ck_rw).click(function(){
					var idx=this.id.substr(8);;
					$j('input[@name=' + this.typeStr+ + '_rd'+idx+']').attr("checked", false); 
					$j('input[@name=' + this.typeStr+ + '_no'+idx+']').attr("checked", false); 
				});
		
				td_box1.appendChild(ck_rw);
				
				var td_box2 = document.createElement('td');
				tr.appendChild(td_box2);
				tr.appendChild(td_box2);
				td_box2.setAttribute('align',"center");
				YAHOO.util.Dom.addClass(td_box2, 'box_td_end');
				
				var ck_no = document.createElement('input');
				ck_no.setAttribute('type','checkbox');
				ck_no.setAttribute('value', Items[i].getElementsByTagName('name')[0].firstChild.nodeValue);
				ck_no.setAttribute('name',this.typeStr+'_no'+i);
				ck_no.setAttribute('id',this.typeStr+'_no'+i);
				$j(ck_no).click(function(){
					var idx=this.id.substr(8);;
					$j('input[@name=' + this.typeStr+ + '_rd'+idx+']').attr("checked", false); 
					$j('input[@name=' + this.typeStr+ + '_rw'+idx+']').attr("checked", false); 
				});
				
				td_box2.appendChild(ck_no);
			}
		}
		this.setCurrentPage(this.typeStr, page_no);
	}	
	
	this.init = function(){
		var _self=this;
		var obody = this.el.getElementsByTagName('table')[0].getElementsByTagName('tbody')[0];
		if(this.list){
  		var maxentry_perpage = 6;
  		var Items = this.list.getElementsByTagName(this.typeStr);	
  		
  		if(Items.length>maxentry_perpage){
  			var end_box = document.createElement('div');
	  		YAHOO.util.Dom.addClass(end_box, 'box_end_div');
	  		YAHOO.util.Dom.get(this.typeStr+'_box').appendChild(end_box);
	  		
	  		var next_div = document.createElement('div');
	  		end_box.appendChild(next_div);
	  		next_div.id=this.typeStr+'_next';
	  		YAHOO.util.Dom.addClass(next_div, this.typeStr+'_func_li next');
	  		var next_a = document.createElement('a');
	  		next_div.appendChild(next_a);
				next_a.style.cursor='pointer';
				$j(next_a).click(function(){
					var c_page=_self.getCurrentPage(_self.typeStr);
					var c_page_obj = YAHOO.util.Dom.get(_self.typeStr+'_page'+c_page);
					if(c_page_obj)
						c_page_obj.style.display='none';

					_self.showPage(obody, Items, c_page, ++c_page, maxentry_perpage);
				});
	  		var next_img = document.createElement('img');
	  		next_a.appendChild(next_img);
	  		next_img.setAttribute('src','/ajax_obj/images/icon_next.gif');
	  		next_img.setAttribute('border', '0');
	  		
	  		var prev_div = document.createElement('div');
	  		end_box.appendChild(prev_div);
	  		prev_div.id=this.typeStr+'_prev';
	  		YAHOO.util.Dom.addClass(prev_div, this.typeStr+'_func_li prev');
	  		var prev_a = document.createElement('a');
	  		prev_div.appendChild(prev_a);
	  		$j(prev_a).click(function(){
						var c_page=_self.getCurrentPage(_self.typeStr);
						var c_page_obj = YAHOO.util.Dom.get(_self.typeStr+'_page'+c_page);
						if(c_page_obj)
							c_page_obj.style.display='none';
						
						_self.showPage(obody, Items, c_page, --c_page, maxentry_perpage);
					});
	  		var prev_img = document.createElement('img');
	  		prev_a.appendChild(prev_img);
	  		prev_img.setAttribute('src','/ajax_obj/images/icon_prev.gif');
	  		prev_img.setAttribute('border', '0');
	  		prev_img.setAttribute('alt', 'previous page');
	  		
			}
			var c_page = document.createElement('div');
			this.el.appendChild(c_page);
			c_page.style.display='none';
			c_page.id=this.typeStr+'_current_page';
			c_page.innerHTML=1;
    	
    	var total_pages = parseInt(Items.length/maxentry_perpage);
			if((Items.length%maxentry_perpage)!=0)
				total_pages++;
				
			for(var l=total_pages; l>=1; l--){
    		this.showPage(obody, Items, l+1, l, maxentry_perpage);
    	}
  	}
	};
}
/*
Need excanvas.js for IE, and prototype-1.6.0.2.js, flotr.debug-0.1.0alpha.js for all
*/

QNAP.util.SysInfo = function(slice_no){
	this.sid=0;
	this.running=true;
	this.total_slice=200;
	if(slice_no){
		this.total_slice=slice_no;
	}
	this.cpu_usage = [];
//	this.mem_usage = [];
	this.time_slice=this.total_slice;
	this.cpu_container = null;
	this.cpuRenderTo = function(el){
		this.cpu_container = el;
		this.drawInit(null,null,slice_no);
	};
	this.isRunning = function(){
		return this.running;	
	}
	this.setSlice = function(slice_no){
		this.total_slice=slice_no;	
	};
	this._getSysInfo = function(){
		this.running=false;
		var _self = this;
		
		var handleSuccess = function(o){
			if(o.responseXML !== undefined){
				var xmlobject = o.responseXML;
				if (QNAP.util.auth.CheckIfAuthPassed(xmlobject) == 0) {
	        QNAP.util.data_loading(0);
	        QNAP.util.auth.GotoLoginPage();
	        return;
	      }
				
				if(_self.time_slice==_self.total_slice){
			_self.cpu_usage.push([_self.time_slice, 1]);
//			_self.mem_usage.push([_self.time_slice, 1]);
			_self.time_slice--;
			_self.drawGraph(_self.cpu_usage, null, _self.total_slice);
			//drawGraph(cpu_usage, mem_usage);
		}
				
				var QDoc = xmlobject.getElementsByTagName('QDocRoot')[0];
				var usage = QDoc.getElementsByTagName('cpuUsage')[0].firstChild.nodeValue;
//				var musage=QDoc.getElementsByTagName('memUsage')[0].firstChild.nodeValue;
				var clen = _self.cpu_usage.length;
//			var mlen = _self.mem_usage.length
//				if(clen>=200 && mlen>=200){
				if(clen>=_self.total_slice){
					_self.cpu_usage.shift();	
//					_self.mem_usage.shift();
				}
				clen--;
				var i=0;
				try {
//				for(var i = 0 ;i< clen && i < mlen;i++){
					
					for(i = 0 ;i<clen;i++){
//					if(_self.cpu_usage[i][0]>0 && _self.mem_usage[i][0]>0){
						if(_self.cpu_usage[i][0]>0){
							_self.cpu_usage[i][0]--;
//						_self.mem_usage[i][0]--;
						}	
					}
				}
				catch (e){
					alert(e + '    ' + i)
				}
				_self.cpu_usage.push([_self.total_slice, parseFloat(usage)]);
//				_self.mem_usage.push([200, parseFloat(musage)]);
				_self.drawGraph(_self.cpu_usage, null, _self.total_slice);
				//drawGraph(cpu_usage, mem_usage);
			}
			_self = null;
			xmlobject = null;
			QDoc = null;
			usage = null;
			clen = null;
		};
		
		var handleFailure = function(o){
		};
		var callback =
		{
			success:handleSuccess,
			failure:handleFailure
		};
		var sUrl = '/cgi-bin/sysinfoReq.cgi?item_no=2&item1=cpu_usage&item2=mem_usage&count=' + Math.random() + '&sid='+sid;
		var request = QNAP.util.Connect.asyncRequest('POST', sUrl, callback);
	};
	
	this.getSysInfo = function(timeout){
		var _self=this;
		if(this.sid==0){
			QNAP.util.Wizard.setPauseRun('cpumem_pin', 0);
			this.sid = setInterval(function(){_self._getSysInfo();}, timeout);
		}
	};
	
	this.drawGraph = function(cpuData, memData, total_slice){
		// Draw the graph.
		var slice = 200;
		if(total_slice){
			slice = total_slice;	
		}

		var axis = {
			xaxis:{
				noTicks: 10,	// Display 7 ticks.
	//		tickFormatter: function(n){ return '('+n+')'; }, // => displays tick values between brackets.
				tickFormatter: function(n){ return ''; },
				min: 1,		// => part of the series is not displayed.
				max: slice// => part of the series is not displayed.
			},
			yaxis:{
				ticks: [[ 1, '0'], [30, '30' ], [60,'60'], [100,'100'] ],
	//		noTicks: 10,
				min: 0,
				max: 100
			},
			colors: ['#50B432', '#C0D800', '#cb4b4b', '#4da74d', '#9440ed']
		};
		
		var drawData;
		if(memData && !cpuData){
			drawData = [{data:memData, lines:{lineWidth:1, fill:true}}];
		}
		else if(cpuData && !memData){
			drawData = [{data:cpuData, lines:{lineWidth:1, fill:true}}];	
		}
		else{
			drawData = [	
					{data:cpuData, lines:{lineWidth:1, fill:true}},
					{data:memData, lines:{lineWidth:1, fill:true}}
				];	
		}
	
		if($j('#'+this.cpu_container)){
			try{
				var f = Flotr.draw(
				$(this.cpu_container), drawData, axis);	
			}
			catch(e){
			}
		};
		drawData = null;
	};
	this.drawInit=function(cpuData, memData, total_slice){
		// Draw the graph.
		var slice = 200;
		if(total_slice){
			slice = total_slice;	
		}

		var axis = {
			xaxis:{
				noTicks: 10,	// Display 7 ticks.
	//		tickFormatter: function(n){ return '('+n+')'; }, // => displays tick values between brackets.
				tickFormatter: function(n){ return ''; },
				min: 1,		// => part of the series is not displayed.
				max: slice// => part of the series is not displayed.
			},
			yaxis:{
				ticks: [[ 1, '0'], [30, '30' ], [60,'60'], [100,'100'] ],
	//		noTicks: 10,
				min: 0,
				max: 100
			},
			colors: ['#50B432', '#C0D800', '#cb4b4b', '#4da74d', '#9440ed']
		};
		var drawData;
		if(memData && !cpuData){
			drawData = [{data:memData, lines:{lineWidth:1, fill:true}}];
		}
		else if(cpuData && !memData){
			drawData = [{data:cpuData, lines:{lineWidth:1, fill:true}}];	
		}
		else{
			drawData = [	
					{data:cpuData, lines:{lineWidth:1, fill:true}},
					{data:memData, lines:{lineWidth:1, fill:true}}
				];	
		}
	
		if($j('#'+this.cpu_container)){
			try{
				var f = Flotr.draw(
				$j(this.cpu_container), drawData, axis);	
			}
			catch(e){
			}
		};
	};
	this.stopRequest = function(){
		if(this.sid != 0){
			clearInterval(this.sid);
			this.sid=0;
			this.running=false;
			QNAP.util.Wizard.setPauseRun('cpumem_pin', 1);
		}	
	};
}


QNAP.BLANK_IMAGE_URL = '/ajax_obj/extjs/resources/images/default/s.gif';

(function ($) {
	var ie6 = $.browser.msie && parseInt($.browser.version) == 6 && !window['XMLHttpRequest'],
		ieQuirks = $.browser.msie && !$.boxModel,
		w = [];
	
	$.prompt = function (data, options) {
		return $.impl.init(data, options);
	};
	$.prompt.close = function () {
		$.impl.close();
	};
	$.fn.prompt = function (options) {
		return $.impl.init(this, options);
	};
	
	$.defaults = {
		opacity: 50,
		overlayId: 'qMessage-overlay',
		overlayCss: {},
		overlayClass: 'qMessage-overlay',
		containerId: 'qMessage-container',
		containerCss: {},
		dataCss: {},
		buttonClass: 'button_msg',
		zIndex: 5000,
		close: false,
		closeHTML: '<a class="qMessageCloseImg" title="Close"></a>',
		closeClass: 'qMessage-close',
		position: null,
		persist: false,
		onOpen: null,
		onShow: null,
		onClose: null,
		buttons: {OK:'OK'},
		custom_button_evt: false
	};
	
	$.impl = {
		opts: null,
		dialog: {},
		init: function(data, options) {
			
			this.opts = $.extend({}, $.defaults, options);
			
			if (typeof data == 'object') {
				// convert DOM object to a jQuery object
				data = data instanceof jQuery ? data : $(data);

				// if the object came from the DOM, keep track of its parent
				if (data.parent().parent().size() > 0) {
					this.dialog.parentNode = data.parent();

					// persist changes? if not, make a clone of the element
					if (!this.opts.persist) {
						this.dialog.orig = data.clone(true);
					}
				}
			}
			else if (typeof data == 'string' || typeof data == 'number') {
				// just insert the data as innerHTML
				data = $('<div/>').html(data);
			}
			else {
				// unsupported data type!
				alert('Error: Unsupported data type: ' + typeof data);
				return false;
			}
			this.dialog.data = data.addClass('qMessage-data').css(this.opts.dataCss);;
			data = null;
			this.create();
			this.open();

			if ($.isFunction(this.opts.onShow)) {
				this.opts.onShow.apply(this, [this.dialog]);
			}

			// don't break the chain =)
			return this;
		},
		create: function () {
			w = this.getDimensions();

			// add an iframe to prevent select options from bleeding through
			if (ie6) {
				this.dialog.iframe = $('<iframe src="javascript:false;"/>')
					.css($.extend(this.opts.iframeCss, {
						display: 'none',
						opacity: 0, 
						position: 'fixed',
						height: w[0],
						width: w[1],
						zIndex: this.opts.zIndex,
						top: 0,
						left: 0
					}))
					.appendTo('body');
			}
			
			// create the overlay
			this.dialog.overlay = $('<div/>')
				.attr('id', this.opts.overlayId)
				.addClass(this.opts.overlayClass)
				.css($.extend(this.opts.overlayCss, {
					display: 'none',
					opacity: this.opts.opacity / 100,
					height: w[0],
					width: w[1],
					position: 'fixed',
					left: 0,
					top: 0,
					zIndex: this.opts.zIndex + 1
				}))
				.appendTo('body');
				
				// create the container
			this.dialog.container = $('<div/>')
				.attr('id', this.opts.containerId)
				.css($.extend(this.opts.containerCss, {
					display: 'none',
					position: 'fixed',
					zIndex: this.opts.zIndex + 2
				}))
				.append(this.opts.close 
					? $(this.opts.closeHTML).addClass(this.opts.closeClass)
					: '')
				.appendTo('body');
			this.setPosition();

			// fix issues with IE
			if (ie6 || ieQuirks) {
				this.fixIE();
			}

			// hide the data and add it to the container
			this.dialog.container.append(this.dialog.data.hide());	
		},
		fixIE: function () {
			var p = this.opts.position;

			// simulate fixed position - adapted from BlockUI
			$.each([this.dialog.iframe || null, this.dialog.overlay, this.dialog.container], function (i, el) {
				if (el) {
					var bch = 'document.body.clientHeight', bcw = 'document.body.clientWidth',
						bsh = 'document.body.scrollHeight', bsl = 'document.body.scrollLeft',
						bst = 'document.body.scrollTop', bsw = 'document.body.scrollWidth',
						ch = 'document.documentElement.clientHeight', cw = 'document.documentElement.clientWidth',
						sl = 'document.documentElement.scrollLeft', st = 'document.documentElement.scrollTop',
						s = el[0].style;

					s.position = 'absolute';
					if (i < 2) {
						s.removeExpression('height');
						s.removeExpression('width');
						s.setExpression('height','' + bsh + ' > ' + bch + ' ? ' + bsh + ' : ' + bch + ' + "px"');
						s.setExpression('width','' + bsw + ' > ' + bcw + ' ? ' + bsw + ' : ' + bcw + ' + "px"');
					}
					else {
						var te, le;
						if (p && p.constructor == Array) {
							if (p[0]) {
								var top = typeof p[0] == 'number' ? p[0].toString() : p[0].replace(/px/, '');
								te = top.indexOf('%') == -1 
									? top + ' + (t = ' + st + ' ? ' + st + ' : ' + bst + ') + "px"'
									: parseInt(top.replace(/%/, '')) + ' * ((' + ch + ' || ' + bch + ') / 100) + (t = ' + st + ' ? ' + st + ' : ' + bst + ') + "px"';
							}
							if (p[1]) {
								var left = typeof p[1] == 'number' ? p[1].toString() : p[1].replace(/px/, '');
								le = left.indexOf('%') == -1 
									? left + ' + (t = ' + sl + ' ? ' + sl + ' : ' + bsl + ') + "px"'
									: parseInt(left.replace(/%/, '')) + ' * ((' + cw + ' || ' + bcw + ') / 100) + (t = ' + sl + ' ? ' + sl + ' : ' + bsl + ') + "px"';
							}
						}
						else {
							te = '(' + ch + ' || ' + bch + ') / 2 - (this.offsetHeight / 2) + (t = ' + st + ' ? ' + st + ' : ' + bst + ') + "px"';
							le = '(' + cw + ' || ' + bcw + ') / 2 - (this.offsetWidth / 2) + (t = ' + sl + ' ? ' + sl + ' : ' + bsl + ') + "px"';
						}
						s.removeExpression('top');
						s.removeExpression('left');
						s.setExpression('top', te);
						s.setExpression('left', le);
					}
				}
			});
		},
		bindEvents: function () {
			var self = this;
			$.each(self.opts.buttons, function(k,v){
				$('a.' + self.opts.buttonClass + ' #'+k).html(v);
				if(self.opts.custom_button_evt==false){
					$('a.' + self.opts.buttonClass + ' span').bind('click.qMessage'+k, function (e) {
						e.preventDefault();
						self.close();
					});
				}
			});
			// bind the close event to any element with the closeClass class
/*			$('.' + this.opts.closeClass).bind('click.qMessage', function (e) {
				e.preventDefault();
				self.close();
			});
*/
			// update window size
			$(window).bind('resize.qMessage', function () {
				// redetermine the window width/height
				w = self.getDimensions();

				// reposition the dialog
				self.setPosition();
	
				if (ie6 || ieQuirks) {
					self.fixIE();
				}
				else {
					// update the iframe & overlay
					self.dialog.iframe && self.dialog.iframe.css({height: w[0], width: w[1]});
					self.dialog.overlay.css({height: w[0], width: w[1]});
				}
			});
		},
		/*
		 * Unbind events
		 */
		unbindEvents: function () {
			var self = this;
			if(this.opts.custom_button_evt==false){
				$.each(self.opts.buttons, function(k,v){
					$('a.' + self.opts.buttonClass + ' span').unbind('click.qMessage'+k);
				});
			}
//			$('.' + this.opts.closeClass).unbind('click.qMessage');
			$(window).unbind('resize.qMessage');
		},
		getDimensions: function () {
			var el = $(window);

			// fix a jQuery/Opera bug with determining the window height
			var h = $.browser.opera && $.browser.version > '9.5' && $.fn.jquery <= '1.2.6' ?
				document.documentElement['clientHeight'] : 
				el.height();

			return [h, el.width()];
		},
		setPosition: function () {
			var top, left,
				hCenter = (w[0]/2) - ((this.dialog.container.height() || this.dialog.data.height())/2),
				vCenter = (w[1]/2) - ((this.dialog.container.width() || this.dialog.data.width())/2);

			if (this.opts.position && this.opts.position.constructor == Array) {
				top = this.opts.position[0] || hCenter;
				left = this.opts.position[1] || vCenter;
			} else {
				top = hCenter;
				left = vCenter;
			}
			this.dialog.container.css({left: left, top: top});
		},
		open: function () {
			// display the iframe
			this.dialog.iframe && this.dialog.iframe.show();

			if ($.isFunction(this.opts.onOpen)) {
				// execute the onOpen callback 
				this.opts.onOpen.apply(this, [this.dialog]);
			}
			else {
				// display the remaining elements
				this.dialog.overlay.show();
				this.dialog.container.show();
				this.dialog.data.show();
			}

			// bind default events
			this.bindEvents();
		},
		close: function () {
			// prevent close when dialog does not exist
			if (!this.dialog.data) {
				return false;
			}

			if ($.isFunction(this.opts.onClose) && !this.occb) {
				// set the onClose callback flag
				this.occb = true;

				// execute the onClose callback
				this.opts.onClose.apply(this, [this.dialog]);
			}
			else {
				// if the data came from the DOM, put it back
				if (this.dialog.parentNode) {
					// save changes to the data?
					if (this.opts.persist) {
						// insert the (possibly) modified data back into the DOM
						this.dialog.data.hide().appendTo(this.dialog.parentNode);
					}
					else {
						// remove the current and insert the original, 
						// unmodified data back into the DOM
						this.dialog.data.remove();
						this.dialog.orig.appendTo(this.dialog.parentNode);
					}
				}
				else {
					// otherwise, remove it
					this.dialog.data.remove();
				}

				// remove the remaining elements
				this.dialog.container.remove();
				this.dialog.overlay.remove();
				this.dialog.iframe && this.dialog.iframe.remove();

				// reset the dialog object
				this.dialog = {};
			}

			// remove the default events
			this.unbindEvents();
		}
	};
})(jQuery);

QNAP.messageBox = {};

QNAP.messageBox.Topbox = function(){
	this.timeout=0
	this.msgCt=null;
	this.disSts=0;//0: hide, 1: show
	this.container_id='message_box';
	this.createBox = function(s){
		return ['<img id="close_message" style="float:right;cursor:pointer" src="/ajax_obj/images/12-em-cross.png" />', s].join('');	
	}
	this.init = function(){
		if(!this.msgCt){
			var msgContainer = $j('<div></div>');
			msgContainer.attr('id', this.container_id);
			msgContainer.html('test');
			msgContainer.css('opacity', 0);
			msgContainer.css('z-index', 3500);
			msgContainer.appendTo(document.body);
			$j('#message_box').animate(
				{top:'-=15px'},
				100
			);
			this.disSts=0;
		}
//			var s = String.str.apply(String, Array.prototype.slice.call(arguments, 1));
		//var m = $j(this.container_id).append(this.createBox('empty'));
	}
	this.show = function(str, stay_min) {	
		if(this.disSts==0){
			this.disSts=1;
			var _self=this;
			clearTimeout(this.timeout);
			$j('#message_box').animate(
				{top:$j(window).scrollTop()+"px" ,opacity:100 },
				{queue: false, duration: 350},
				"slow"
			);
			$j('#message_box').html(this.createBox(str));
			$j(window).bind('scroll', function(){
		  	$j('#message_box').animate(
					{top:$j(window).scrollTop()+"px" },
					{queue: false, duration: 350}
		  	);  
			});
		  //when the close button at right corner of the message box is clicked 
			
			$j('#close_message').bind('click', function(){
		  	_self.hide();
			});
			if(stay_min>0){
				this.timeout = setTimeout(function(){_self.hide();}, stay_min);	
			}
		}
	}
	this.hide = function(){
		var _self=this;
		if(this.disSts==1){
			this.disSts=0;
			$j('#message_box').animate(
				{top:"-=15px",opacity:0 },
				"slow"
			);	
			$j(window).unbind('scroll', function(){
		  	$j('#message_box').animate(
					{top:$j(window).scrollTop()+"px" },
					{queue: false, duration: 350}
		  	);  
			});
			$j('#close_message').unbind('click', function(){
		  	_self.hide();
			});
		}
	}
	
	this.init();
	return this;
}

QNAP.util.LoadingPanel = function(conf){
	this.loadingPanel=null;
	conf = conf == undefined ? new Array() : conf;
	conf.id = conf.id == undefined ? 'yuiLoadingPanel':confi.id;
	conf.header = conf.header == undefined ? NIC_MYSQL_STR13:conf.header;
	conf.header = '<font class=\"blue-12\">' + conf.header + '</font>';
	conf.width = conf.width == undefined ? '240px':conf.width;
	this.conf = conf;
//    this.cancelEvent = new YAHOO.util.CustomEvent("cancelEvent", this);
	this.init();
};

QNAP.util.LoadingPanel.prototype = {
	init:function(){
		var loadingPanel = new YAHOO.widget.Panel(this.conf.id,{
								width:this.conf.width,
								fixedcenter:true,
								close:false,
								draggable:false,
								modal:true,
								visible:false
								});
    
		loadingPanel.setBody(this.conf.header + '<img src="/ajax_obj/img/running.gif" />');
//	loadingPanel.setBody(this.conf.header);
		loadingPanel.render(document.body);
		$D.addClass(loadingPanel.id, 'tcc_lightboxLoader');
		var cancelLink = document.createElement('a');
		$D.setStyle(cancelLink, 'cursor', 'pointer');
		cancelLink.appendChild(document.createTextNode('Cancel'));
		$E.on(cancelLink, 'click', function(e, o){
		   o.self.loadingPanel.hide();
		   o.self.cancelEvent.fire();
		}, {self:this});
		loadingPanel.appendToBody(document.createElement('br'));
		loadingPanel.appendToBody(cancelLink);
		$D.setStyle(loadingPanel.body, 'text-align', 'center');
		$D.addClass(document.body, 'yui-skin-sam');
		this.loadingPanel = loadingPanel;
	},
	defaultHeight: 35,
	getDimensions: function(element) {
		element = $(element);
		var display = $(element).getStyle('display');
		if (display != 'none' && display != null) // Safari bug
			return {width: element.offsetWidth, height: element.offsetHeight};
		var els = element.style;
		var originalVisibility = els.visibility;
		var originalPosition = els.position;
		var originalDisplay = els.display;
		els.visibility = 'hidden';
		els.position = 'absolute';
		els.display = 'block';
		var originalWidth = element.clientWidth;
		var originalHeight = element.clientHeight;
		els.display = originalDisplay;
		els.position = originalPosition;
		els.visibility = originalVisibility;
		return {width: originalWidth, height: originalHeight};
	},
	setBoxHeight:function() {
		this.loadingPanel.body.style.height = 'auto';
		if (this.getDimensions(this.loadingPanel.body).height < this.defaultHeight) {
			this.loadingPanel.body.style.height = this.defaultHeight;
		}
	},
	show:function(text){
		if(text != undefined){
			this.loadingPanel.setHeader(text);
			this.loadingPanel.setBody(text + '<img src="/ajax_obj/img/running.gif" />');
		}else{
			this.loadingPanel.setHeader(this.conf.header);
			this.loadingPanel.setBody(this.conf.header + '<img src="/ajax_obj/img/running.gif" />');
		}
		this.loadingPanel.show();
		this.setBoxHeight();
		var width = $j('.yui-skin-sam .yui-panel-container.shadow').css('width')
		$j('.yui-skin-sam .yui-panel-container.shadow .underlay').css('width', width);
		$j('#yuiLoadingPanel_mask').css('z-index', 3200);
		$j("#yuiLoadingPanel_c").css('z-index', 3201);
	},
	hide:function(){
		this.loadingPanel.hide();
	},
	showProgress:function(text){
		this.loadingPanel.setHeader("");
		this.loadingPanel.setBody('<div id="uploadprobressstr" style="line-height:2em;">' + text + '</div><div class="progressbar" id="uploadprogressbar">0</div>');
		this.loadingPanel.show();
		this.setBoxHeight();
		$j("#uploadprogressbar").progressBar();
		$j("#uploadprogressbar").fadeIn();
	},
	updateProgressStr:function(text){
		$j("uploadprobressstr").html(text);
	},
	updateProgressPercent:function(percent){
		$j("#uploadprogressbar").progressBar(percent);	
	},
	hideProgress:function(){
		this.hide();	
	}
};

QNAP.util.TimeoutTimer = function() {
	this.secs = 0;
	this.ID = null;
	this.running = false;
	this.delay = 1000;
	this.InitTimer = function() {
		if(typeof timeoutValue != 'undefined'){
			this.secs = parseInt(timeoutValue);
		}else{
			this.secs = 3600; // 60 min
		}
		this.Stop();
	}
	this.Stop = function() {
		if (this.running)
			clearTimeout(this.ID);
		this.running = false;
	}
	this.Start = function() {
		var _self=this;
		if (this.secs == 0) {
			// do something
			var expires = new Date();
			expires.setTime(expires.getTime()+(24*60*60*1000));
			QNAP.util.Cookie.setCookie('LoginTimeoutflag','true',expires);
			QNAP.util.auth.GotoLoginPage();
		}
		else {
			this.secs = this.secs - 1;
			this.running = true;
			this.ID = self.setTimeout(function() {_self.Start();}, _self.delay);
		}
	}
	this.Refresh = function() {
		this.InitTimer();
		this.Start();
	}
};

QNAP.util.Connect = {};
QNAP.util.Connect.asyncRequest = function(p1, p2, p3, p4) {
	var request = YAHOO.util.Connect.asyncRequest(p1, p2, p3, p4);
	if (timer) timer.Refresh();
	return request;
};

QNAP.messageBox.alert_scroll = function(title, content, info_or_error){
    if ($j("#qMessage-container").length != 0)
        return;
	this.error = info_or_error;
	function createBox(t, s){
		var img_url = '/ajax_obj/images/message_warning.gif';
		if(this.error && this.error==1){	// error
			img_url = '/ajax_obj/images/message_error.gif';
		}
		else{
			// info	
			img_url = '/ajax_obj/images/message_info.gif';
		}
		return ["<center>", 
						"<div class='msg_box' id='alert_box'>",
						"<div class='msg_bar'><div class='msg_title'>" + title + "</div></div>",
						"<div class='msg_body'>",
						"<div class='msg_img'><img src='" + img_url + "' width='70 'height='70' border='0' alt='Warning' title='Warning'></div>",
						"<div class='msg_content'><div style='width:100%;height:190px;overflow-y:scroll;overflow-x:hidden;border-bottom:1px solid #ccc;'>" + content + "</div>",
						"<div class='msg_end'><a class='button_msg' href='#' onclick='this.blur();'><span id='OK'>OK</span></a></div></div>",
						"<div style='clear:both;'></div>",
						"</div>",
						"</center>"].join('');
	}
	
	var box = createBox(title, content);
//	$j(box).appendTo('body');
	$j(box).prompt({
		opacity: 20,
		containerCss:{width: '400', height:'300'},
		overlayCss: {
			backgroundColor:'#eee', 
			cursor: 'wait'
		},
		buttons: {OK: IEI_NAS_BUTTON_OK}
	});
}

QNAP.messageBox.alert = function(title, content, info_or_error){
    if ($j("#qMessage-container").length != 0)
        return;
	this.error = info_or_error;
	function createBox(t, s){
		var img_url = '/ajax_obj/images/message_warning.gif';
		if(this.error && this.error==1){	// error
			img_url = '/ajax_obj/images/message_error.gif';
		}
		else{
			// info	
			img_url = '/ajax_obj/images/message_info.gif';
		}
		return ["<center>", 
						"<div class='msg_box' id='alert_box'>",
						"<div class='msg_bar'><div class='msg_title'>" + title + "</div></div>",
						"<div class='msg_body'>",
						"<div class='msg_img'><img src='" + img_url + "' width='70 'height='70' border='0' alt='Warning' title='Warning'></div>",
						"<div class='msg_content'><div>" + content + "</div>",
						"<div class='msg_end'><a class='button_msg' href='#' onclick='this.blur();'><span id='OK'>OK</span></a></div></div>",
						"<div style='clear:both;'></div>",
						"</div>",
						"</center>"].join('');
	}
	
	var box = createBox(title, content);
//	$j(box).appendTo('body');
	$j(box).prompt({
		opacity: 20,
		containerCss:{width: '400', height:'300'},
		overlayCss: {
			backgroundColor:'#eee', 
			cursor: 'wait'
		},
		buttons: {OK: IEI_NAS_BUTTON_OK}
	});
}

QNAP.messageBox.alert_ex = function(title, content, ok_callback, cancel_callback,chk_box,chk_str){
	this.ok_callback = ok_callback;
	this.cancel_callback = cancel_callback;
	function createBox(t, s){
		return ["<center>", 
						"<div class='msg_box' id='alert_box'>",
						"<div class='msg_bar'><div class='msg_title'>" + title + "</div></div>",
						"<div class='msg_body'>",
						"<div class='msg_img'><img src='/ajax_obj/images/message_info.gif' width='70 'height='70' border='0' alt='Warning' title='Warning'></div>",
						"<div class='msg_content'><div style='line-height:1.5em;'>" + content + "</div>"+"<br><div style='display:none' id='del_content'><input type='checkbox' value='1' id='chk_delrealpath'/><label for='chk_delrealpath' style='margin-left:5px;'>"+chk_str+"</label></div>",
						"<div class='msg_end'><a id='OK_A' class='button_msg' href='#' onclick='this.blur();'><span id='OK'>OK</span></a><a id='CANCEL_A' class='button_msg' href='#' onclick='this.blur();' style='display:none;'><span id='CANCEL'>Cancel</span></a></div></div>",
						"<div style='clear:both;'></div>",
						"</div>",
						"</center>"].join('');
	}
	
	var box = createBox(title, content);
	var self = this;
	
		$j(box).prompt({
			opacity: 20,
			containerCss:{width: '400', height:'300'},
			overlayCss: {
				backgroundColor:'#eee', 
				cursor: 'wait'
			},
			custom_button_evt: true,
			buttons: {OK: IEI_NAS_BUTTON_OK, CANCEL: IEI_NAS_BUTTON_CANCEL},
			onShow:function(dialog) {
				if(chk_box != undefined && chk_str != undefined )
				{
					
					dialog.data.find('#del_content').show();
				}
				dialog.data.find('#OK_A').focus();
				dialog.data.find('#OK_A').click(function () {
					if(chk_box != undefined && chk_str != undefined )
					{
						
						if(dialog.data.find('#chk_delrealpath').ischecked())
						{
							
							$j("#chk_delete_share_realpath").html("checked");
						}
						else
						{
							$j("#chk_delete_share_realpath").html("unchecked");
						}
					}
					$j.prompt.close();
					// call the callback
					if ($j.isFunction(self.ok_callback) && (dialog.data.find('#chk_delrealpath').ischecked())) {
						self.ok_callback.apply();
					}
					else
					{

					}	
				});
			}
		});
};

QNAP.messageBox.confirm = function(title, content, callback){
	this.callback = callback;
	function createBox(t, s){
		return ["<center>", 
						"<div class='msg_box' id='alert_box'>",
						"<div class='msg_bar'><div class='msg_title'>" + title + "</div></div>",
						"<div class='msg_body'>",
						"<div class='msg_img'><img src='/ajax_obj/images/message_warning.gif' width='70 'height='70' border='0' alt='Warning' title='Warning'></div>",
						"<div class='msg_content'><div>" + content + "</div>",
						"<div class='msg_end'><a id='OK_A' class='button_msg' href='#' onclick='this.blur();'><span id='OK'>OK</span></a><a id='CANCEL_A' class='button_msg' href='#' onclick='this.blur();'><span id='CANCEL'>Cancel</span></a></div></div>",
						"<div style='clear:both;'></div>",
						"</div>",
						"</center>"].join('');
	}
	
	var box = createBox(title, content);
	var self = this;
	$j(box).prompt({
		opacity: 20,
		containerCss:{width: '400', height:'300'},
		overlayCss: {
			backgroundColor:'#eee', 
			cursor: 'wait'
		},
		custom_button_evt: true,
		buttons: {OK: IEI_NAS_BUTTON_OK, CANCEL: IEI_NAS_BUTTON_CANCEL},
		onShow:function(dialog) {
			dialog.data.find('#OK_A').focus();
			dialog.data.find('#OK_A').click(function () {
				// call the callback
				if ($j.isFunction(self.callback)) {
					self.callback.apply();
				}
				// close the dialog
				$j.prompt.close();
			});
			dialog.data.find('#CANCEL_A').click(function () {
				$j.prompt.close();
			});
		}
	});
};
QNAP.messageBox.confirm_run_post = function(title, content, ok_callback, cancel_callback,chk_box,chk_str, params){
	this.ok_callback = ok_callback;
	this.cancel_callback = cancel_callback;
	function createBox(t, s){
		return ["<center>", 
						"<div class='msg_box' id='alert_box'>",
						"<div class='msg_bar'><div class='msg_title'>" + title + "</div></div>",
						"<div class='msg_body'>",
						"<div class='msg_img'><img src='/ajax_obj/images/message_warning.gif' width='70 'height='70' border='0' alt='Warning' title='Warning'></div>",
						"<div class='msg_content'><div>" + content + "</div>"+"<br><div style='display:none' id='del_content'><input type='checkbox' value='1' id='chk_delrealpath'/>&nbsp;"+chk_str+"</div>",
						"<div class='msg_end'><a id='OK_A' class='button_msg' href='#' onclick='this.blur();'><span id='OK'>OK</span></a><a id='CANCEL_A' class='button_msg' href='#' onclick='this.blur();'><span id='CANCEL'>Cancel</span></a></div></div>",
						"<div style='clear:both;'></div>",
						"</div>",
						"</center>"].join('');
	}
	
	var box = createBox(title, content);
	var self = this;
	var ok_str = IEI_NAS_BUTTON_OK;
	var cancel_str = IEI_NAS_BUTTON_CANCEL;
	if (params)
		if (params.YESNO == 1)
		{
			ok_str = IEI_NAS_BUTTON_YES;
			cancel_str = IEI_NAS_BUTTON_NO;
		}
	
		$j(box).prompt({
			opacity: 20,
			containerCss:{width: '400', height:'300'},
			overlayCss: {
				backgroundColor:'#eee', 
				cursor: 'wait'
			},
			custom_button_evt: true,
			buttons: {OK: ok_str, CANCEL: cancel_str},
			onShow:function(dialog) {
				if(chk_box != undefined && chk_str != undefined )
				{
					
					dialog.data.find('#del_content').show();
				}
				dialog.data.find('#OK_A').focus();
				dialog.data.find('#OK_A').click(function () {
					if(chk_box != undefined && chk_str != undefined )
					{
						
						if(dialog.data.find('#chk_delrealpath').ischecked())
						{
							
							$j("#chk_delete_share_realpath").html("checked");
						}
						else
						{
							$j("#chk_delete_share_realpath").html("unchecked");
						}
					}
					if (chk_box != undefined && chk_str != undefined && chk_box == "globalsparechkbox" && !dialog.data.find('#chk_delrealpath').ischecked()){
						dialog.data.find('#chk_delrealpath').focus();
					}
					else{
						$j.prompt.close();
						// call the callback
						if ($j.isFunction(self.ok_callback)) {
							self.ok_callback.apply();
						}
						// close the dialog
					}
				});
				dialog.data.find('#CANCEL_A').click(function () {
					$j.prompt.close();
					// call the callback
					if ($j.isFunction(self.cancel_callback)) {
						self.cancel_callback.apply();
					}
					
				});
			}
		});
	
	
	
};
QNAP.messageBox.confirm_ex = function(title, content, ok_callback, cancel_callback, params){
	this.ok_callback = ok_callback;
	this.cancel_callback = cancel_callback;
	function createBox(t, s){
		return ["<center>", 
						"<div class='msg_box' id='alert_box'>",
						"<div class='msg_bar'><div class='msg_title'>" + title + "</div></div>",
						"<div class='msg_body'>",
						"<div class='msg_img'><img src='/ajax_obj/images/message_warning.gif' width='70 'height='70' border='0' alt='Warning' title='Warning'></div>",
						"<div class='msg_content'><div>" + content + "</div>",
						"<div class='msg_end'><a id='OK_A' class='button_msg' href='#' onclick='this.blur();'><span id='OK'>OK</span></a><a id='CANCEL_A' class='button_msg' href='#' onclick='this.blur();'><span id='CANCEL'>Cancel</span></a></div></div>",
						"<div style='clear:both;'></div>",
						"</div>",
						"</center>"].join('');
	}
	var ok_str = IEI_NAS_BUTTON_OK;
	var cancel_str = IEI_NAS_BUTTON_CANCEL;
	if (params)
		if (params.YESNO == 1)
		{
			ok_str = IEI_NAS_BUTTON_YES;
			cancel_str = IEI_NAS_BUTTON_NO;
		}
	
	var box = createBox(title, content);
	var self = this;
	$j(box).prompt({
		opacity: 20,
		containerCss:{width: '400', height:'300'},
		overlayCss: {
			backgroundColor:'#eee', 
			cursor: 'wait'
		},
		custom_button_evt: true,
		buttons: {OK: ok_str, CANCEL: cancel_str},
		onShow:function(dialog) {
			dialog.data.find('#OK_A').focus();
			dialog.data.find('#OK_A').click(function () {
				// call the callback
				if ($j.isFunction(self.ok_callback)) {
					self.ok_callback.apply();
				}
				// close the dialog
				$j.prompt.close();
			});
			dialog.data.find('#CANCEL_A').click(function () {
				// call the callback
				if ($j.isFunction(self.cancel_callback)) {
					self.cancel_callback.apply();
				}
				$j.prompt.close();
			});
		}
	});
};
QNAP.messageBox.confirm_ex2 = function(title, content, yes_callback,no_callback, cancel_callback){
	this.yes_callback = yes_callback;
	this.no_callback = no_callback;
	this.cancel_callback = cancel_callback;
	function createBox(t, s){
		return ["<center>", 
						"<div class='msg_box' id='alert_box'>",
						"<div class='msg_bar'><div class='msg_title'>" + title + "</div></div>",
						"<div class='msg_body'>",
						"<div class='msg_img'><img src='/ajax_obj/images/message_warning.gif' width='70 'height='70' border='0' alt='Warning' title='Warning'></div>",
						"<div class='msg_content'><div>" + content + "</div>",
						"<div class='msg_end'><a id='YES_A' class='button_msg' href='#' onclick='this.blur();'><span id='YES'>Yes</span></a><a id='NO_A' class='button_msg' href='#' onclick='this.blur();'><span id='NO'>No</span></a><a id='CANCEL_A' class='button_msg' href='#' onclick='this.blur();'><span id='CANCEL'>Cancel</span></a></div></div>",
						"<div style='clear:both;'></div>",
						"</div>",
						"</center>"].join('');
	}
	
	var box = createBox(title, content);
	var self = this;
	$j(box).prompt({
		opacity: 20,
		containerCss:{width: '400', height:'300'},
		overlayCss: {
			backgroundColor:'#eee', 
			cursor: 'wait'
		},
		custom_button_evt: true,
		buttons: {YES: IEI_NAS_BUTTON_YES,NO:IEI_NAS_BUTTON_NO, CANCEL: IEI_NAS_BUTTON_CANCEL},
		onShow:function(dialog) {
			dialog.data.find('#YES_A').focus();
			dialog.data.find('#YES_A').click(function () {
				// call the callback
				if ($j.isFunction(self.yes_callback)) {
					self.yes_callback.apply();
				}
				// close the dialog
				$j.prompt.close();
			});
			dialog.data.find('#NO_A').click(function () {
				// call the callback
				if ($j.isFunction(self.no_callback)) {
					self.no_callback.apply();
				}
				// close the dialog
				$j.prompt.close();
			});			
			dialog.data.find('#CANCEL_A').click(function () {
				// call the callback
				if ($j.isFunction(self.cancel_callback)) {
					self.cancel_callback.apply();
				}
				$j.prompt.close();
			});
		}
	});
};
QNAP.messageBox.confirm_with_pass = function(title, content, pass_id, ok_callback){
	this.ok_callback = ok_callback;
	function createBox(t, s){
		return ["<center>", 
						"<div class='msg_box' id='alert_box'>",
						"<div class='msg_bar'><div class='msg_title'>" + title + "</div></div>",
						"<div class='msg_body'>",
						"<div class='msg_img'><img src='/ajax_obj/images/message_info.gif' width='70 'height='70' border='0' alt='Warning' title='Warning'></div>",
						"<div class='msg_content'><div>" + content + "</div>",
						"<div><br><input id='" + pass_id +"' type='password' style='width:100px'></div>",
						"<div class='msg_end'><a id='OK_A' class='button_msg' href='#' onclick='this.blur();'><span id='OK'>OK</span></a><a id='CANCEL_A' class='button_msg' href='#' onclick='this.blur();'><span id='CANCEL'>Cancel</span></a></div></div>",
						"<div style='clear:both;'></div>",
						"</div>",
						"</center>"].join('');
	}
	
	var box = createBox(title, content);
	var self = this;
	$j(box).prompt({
		opacity: 20,
		containerCss:{width: '400', height:'300'},
		overlayCss: {
			backgroundColor:'#eee', 
			cursor: 'wait'
		},
		custom_button_evt: true,
		buttons: {OK: IEI_NAS_BUTTON_OK, CANCEL: IEI_NAS_BUTTON_CANCEL},
		onShow:function(dialog) {
			dialog.data.find('#OK_A').focus();
			dialog.data.find(pass_id).focus();
			dialog.data.find('#OK_A').click(function () {
				// call the callback
				if ($j.isFunction(self.ok_callback)) {
					self.ok_callback.apply();
				}
				// close the dialog
				$j.prompt.close();
			});
			dialog.data.find('#CANCEL_A').click(function () {
				$j.prompt.close();
			});
		}
	});
};
QNAP.messageBox.prompt = function(title, content, pass_id, ok_callback){
	this.ok_callback = ok_callback;
	function createBox(t, s){
		return ["<center>", 
						"<div class='msg_box' id='alert_box'><div class='msg_bar'><div style='font-family: Trebuchet MS,Verdana,Arial,Helvetica,sans-serif;font-weight: bold;font-size:14px;text-align:center;padding-top:3px;'>" + title + "</div></div>",
						"<div>",
						"<div style='display: inline;float: right;margin:15px;width: 370px;'>",
						"<div style='padding:12px 0;'><div style='font-size:12px;width:150px;float:left;padding:1px 5px 0 0;text-align:left;'>" + content + "</div><div style='text-align:left;'><input id='" + pass_id +"' style='width:160px'></div></div>",
						"<div class='msg_end'><a id='OK_A' class='button_msg' href='#' onclick='this.blur();'><span id='OK'>OK</span></a><a id='CANCEL_A' class='button_msg' href='#' onclick='this.blur();'><span id='CANCEL'>Cancel</span></a></div></div>",
						"<div style='clear:both;'></div>",
						"</div>",
						"</center>"].join('');
	}
	
	var box = createBox(title, content);
	var self = this;
	$j(box).prompt({
		opacity: 20,
		containerCss:{width: '400', height:'126'},
		overlayCss: {
			backgroundColor:'black', 
			cursor: 'wait'
		},
		custom_button_evt: true,
		buttons: {OK: QUICK_DEF_NAME11, CANCEL: IEI_NAS_BUTTON_CANCEL},
		onShow:function(dialog) {
			dialog.data.find('#OK_A').focus();
			dialog.data.find(pass_id).focus();
			dialog.data.find('#OK_A').click(function () {
				// call the callback
				var chk_close = false;
				if ($j.isFunction(self.ok_callback)) {
					chk_close = self.ok_callback.apply();
				} else {
					chk_close = true;
				}
				// close the dialog
				if (chk_close) $j.prompt.close();
			});
			dialog.data.find('#CANCEL_A').click(function () {
				$j.prompt.close();
			});
		}
	});
};
QNAP.messageBox.alert_with_callback = function(title, content, callback, info_or_error){
        this.callback = callback;
	this.error = info_or_error;
        function createBox(t, s){
		var img_url = '/ajax_obj/images/message_warning.gif';
                if(this.error && this.error==1){        // error
                        img_url = '/ajax_obj/images/message_error.gif';
                }
                else{
                        // info
                       img_url = '/ajax_obj/images/message_info.gif';
		}
                return ["<center>",
                                                "<div class='msg_box' id='alert_box'>",
                                                "<div class='msg_bar'><div class='msg_title'>" + title + "</div></div>",
                                                "<div class='msg_body'>",
                                                "<div class='msg_img'><img src='" + img_url + "' width='70 'height='70' border='0' alt='Warning' title='Warning'></div>",
                                                "<div class='msg_content'><div>" + content + "</div>",
                                                "<div class='msg_end'><a id='OK_A' class='button_msg' href='#' onclick='this.blur();'><span id='OK'>OK</span></a></div></div>",
                                                "<div style='clear:both;'></div>",
                                                "</div>",
                                                "</center>"].join('');
        }

        var box = createBox(title, content);
        var self = this;
        $j(box).prompt({
                opacity: 20,
                containerCss:{width: '400', height:'300'},
                overlayCss: {
                        backgroundColor:'#eee',
                        cursor: 'wait'
                },
                custom_button_evt: true,
                buttons: {OK: IEI_NAS_BUTTON_OK},
                onShow:function(dialog) {
                        dialog.data.find('#OK_A').focus();
                        dialog.data.find('#OK_A').click(function () {
				if ($j.isFunction(self.callback)) {
					self.callback.apply();
                        	}
				$j.prompt.close();
                        });
		}
	});
}

QNAP.messageBox.flybox = function(){
	var msgCt;

	function createBox(t, s){
		return ['<div class="msg">',
			'<div class="x-box-tl"><div class="x-box-tr"><div class="x-box-tc"></div></div></div>',
			'<div class="x-box-ml"><div class="x-box-mr"><div class="x-box-mc"><h3>', t, '</h3>', s, 
			'</div></div></div>',
			'<div class="x-box-bl"><div class="x-box-br"><div class="x-box-bc"></div></div></div>',
			'</div>'].join('');
	}
	return {
		msg : function(title, format, stay_min, position){
			if(!msgCt){
				msgCt = Ext.DomHelper.insertFirst(document.body, {id:'msg-div'}, true);
			}
			if(position=='t-r')
				msgCt.alignTo(document, 't-r', [-200, 0]);
			else
				msgCt.alignTo(document, 't-t');
			var s = String.format.apply(String, Array.prototype.slice.call(arguments, 1));
			var m = Ext.DomHelper.append(msgCt, {html:createBox(title, s)}, true);
       
			if(stay_min)
				m.slideIn('t').pause(stay_min).ghost("t", {remove:true});
			else
				m.slideIn('t').pause(1).ghost("t", {remove:true});
		},
		init : function(){
			var t = Ext.get('exttheme');
			if(!t){ // run locally?
				return;
			}
			var theme = Cookies.get('exttheme') || 'aero';
			if(theme){
				t.dom.value = theme;
				Ext.getBody().addClass('x-'+theme);
			}
			t.on('change', function(){
				Cookies.set('exttheme', t.getValue());
				setTimeout(function(){window.location.reload();}, 250);
			});

			var lb = Ext.get('lib-bar');
			if(lb){
				lb.show();
			}
		}
	};
}();

Ext.onReady(QNAP.messageBox.flybox.init, QNAP.messageBox.flybox);

//jQuery plugin for QNAP
if(jQuery) (function($){
	$.extend($.fn, {
		check: function(){
			$(this).attr('checked', true);
		},
		uncheck: function(){
			$(this).removeAttr('checked');
		},
		ischecked: function(){
			return $(this).attr('checked');	
		},
		disable: function(){
			$(this).attr('disabled', true);	
		},
		enable: function(){
			$(this).removeAttr('disabled');
		}
	});
})(jQuery);

function q_alert(message, error){
	QNAP.messageBox.alert('&nbsp;', message, error);	
	window.focus();
}

function q_alert_info(message){
	q_alert(message, 0);	
}

function q_alert_error(message){
	q_alert(message, 1);	
}

function q_alert_scroll(message, error){
	QNAP.messageBox.alert_scroll('&nbsp;', message, error);
	window.focus();
}

function q_alert_scroll_info(message){
	q_alert_scroll(message, 0);
}

function q_alert_scroll_error(message){
	q_alert_scroll(message, 1);
}

function q_alert_with_callback(message, callback, error){
	QNAP.messageBox.alert_with_callback('&nbsp;', message, callback, error);
	window.focus();
}

function q_confirm(message,callback){
	QNAP.messageBox.confirm('&nbsp;', message,callback );	
	window.focus();
}

function q_confirm_run_post(message, ok_callback , cancel_callback,chk_box,chk_str, params){
	QNAP.messageBox.confirm_run_post('&nbsp;', message, ok_callback , cancel_callback,chk_box,chk_str, params);	
	window.focus();
}

function q_confirm_ex(message, ok_callback, cancel_callback, p){
	QNAP.messageBox.confirm_ex('&nbsp;', message, ok_callback, cancel_callback,p);
	window.focus();
}
function q_confirm_ex2(message, yes_callback,no_callback, cancel_callback){
	QNAP.messageBox.confirm_ex2('&nbsp;', message, yes_callback, no_callback,cancel_callback);
	window.focus();
}
function q_confirm_with_pass(message, pass_id, ok_callback) {
	QNAP.messageBox.confirm_with_pass('&nbsp;', message, pass_id, ok_callback);
	window.focus();
}
function q_prompt(title, content, pass_id, ok_callback) {
	QNAP.messageBox.prompt(title, content, pass_id, ok_callback);
	window.focus();
}

function q_check_port(el, is_apply, except_port, is_ftp_passive)
{
	var s_val = $j('input[@name='+el+']').val();
	QNAP.util.Error.hideInputError(el);
	if (s_val == '') {
		if (is_apply)
			q_alert_error(NIC_WAN_ALERT07);
		QNAP.util.Error.showInputError(el, NIC_WAN_ALERT07);
		return false;
	}

	n_port = parseInt(s_val);
	if (is_ftp_passive ) {
		if (n_port > 65535 || n_port < 1025) {
			if (is_apply)
				q_alert_error(FTP_STR22);
			QNAP.util.Error.showInputError(el, FTP_STR22);
			return false;
		}
	}
	
	if (n_port > 65535 || n_port < 1) {
		if (is_apply)
			q_alert_error(NIC_WAN_ALERT07);
		QNAP.util.Error.showInputError(el, NIC_WAN_ALERT07);
		return false;
	}
	if (!QNAP.util.isPortLegal(n_port, except_port)) {
		if (is_apply)
			q_alert_error(IEI_DEVICE_MSG160);
		QNAP.util.Error.showInputError(el, IEI_DEVICE_MSG160);
		return false;
	}
	return true;
	
	
}

var arVersion = navigator.appVersion.split("MSIE")
var ieVersion = parseFloat(arVersion[1])

function fixPNG(myImage) 
{
    if ((ieVersion >= 5.5) && (ieVersion < 7) && (document.body.filters)) 
    {
			var imgID = (myImage.id) ? "id='" + myImage.id + "' " : ""
			var imgClass = (myImage.className) ? "class='" + myImage.className + "' " : ""
			var imgTitle = (myImage.title) ? 
		             "title='" + myImage.title  + "' " : "title='" + myImage.alt + "' "
			var imgStyle = "display:inline-block;" + myImage.style.cssText
			if (myImage.align == "left") imgStyle = "float:left;" + imgStyle
			if (myImage.align == "right") imgStyle = "float:right;" + imgStyle
			var strNewHTML = "<span " + imgID + imgClass + imgTitle
                  + " style=\"" + "width:" + myImage.width 
                  + "px; height:" + myImage.height 
                  + "px;" + imgStyle + ";"
                  + "filter:progid:DXImageTransform.Microsoft.AlphaImageLoader"
                  + "(src=\'" + myImage.src + "\', sizingMethod='scale');\"></span>"
			myImage.outerHTML = strNewHTML	  
    }
}

//check the disk volume ,if num_volume==0 :The sysytem have no disk ,and num_volume > 0 :The sysytem have disk.
//is_home_page==1:is home page 0: not home page
//is_iso = 1: create ISO share 0: create normal share
//is_encrypt = 1: create encrypted share 0: create normal share
var check_volume = function(e, is_home_page, is_iso, is_encrypt){
	var num_volume=0;
	e.preventDefault();//Stop original link action.
	var handleSuccess = function(o){
		if(o.responseXML !== undefined){
			var xmlobject = o.responseXML;
			
			if (QNAP.util.auth.CheckIfAuthPassed(xmlobject) == 0) {			
		        QNAP.util.data_loading(0);
		        QNAP.util.auth.GotoLoginPage();
				return;
			}
			var QDoc = xmlobject.getElementsByTagName('QDocRoot')[0];
		    var func = QDoc.getElementsByTagName('func')[0];
			var ownContent = func.getElementsByTagName('ownContent')[0];
			var volList = ownContent.getElementsByTagName('volumeList')[0];
			if(volList){				
				num_volume = volList.getElementsByTagName("volume").length;
			}
			
// if (is_iso == 1)
	// alert("create iso");
	
			if(num_volume == 0)
			{
				q_alert(SHARE_CREATE_WIZ_STR24);
			}
			else
			{		
				if(is_home_page==0)
				{
					if (is_iso) {
						QNAP.util.Wizard.OpenWizard({
							url: '/cgi-bin/html/iso_share_create_wizard.html',
							wiz_title: SHARE_CREATE_WIZ_STR27,
							onQuit: iso_share_create_quit,
							onFinish: iso_share_create_finish,
							customCallbackAfterFinish: share_page_reload
						}, iso_share_create_step1, iso_share_create_step2, iso_share_create_step3, iso_share_create_step4_op1, iso_share_create_step4_op2, iso_share_create_step45);
						iso_add_win_set_height = false;
						iso_share_loaddata();
					}
					else if (is_encrypt) {
						QNAP.util.Wizard.OpenWizard({
							url: '/cgi-bin/html/encrypted_share_create_wizard.html',
							wiz_title: SHARE_CREATE_WIZ_STR31,
							onQuit: encrypted_share_create_quit,
							onFinish: encrypted_share_create_finish,
							customCallbackAfterFinish: share_page_reload
						}, encrypted_share_create_step1, encrypted_share_create_step2, encrypted_share_create_step3, encrypted_share_create_step4, encrypted_share_create_step5_op1, encrypted_share_create_step5_op2, encrypted_share_create_step6);
						encrypted_add_win_set_height = false;
						encrypted_share_loaddata();
					}
					else {
						QNAP.util.Wizard.OpenWizard({
							url: '/cgi-bin/html/share_create_wizard.html',
							wiz_title: SHARE_CREATE_WIZ,
							//onLoad: share_loaddata,
							onQuit: share_create_quit,
							onFinish: share_create_finish,
							customCallbackAfterFinish: share_page_reload
						}, share_create_step1, share_create_step2, share_create_step3, share_create_step4_op1, share_create_step4_op2, share_create_step45);		
						share_add_win_set_height = false;
						share_loaddata();
					}
				}
				else
				{					
					QNAP.util.Wizard.OpenWizard({
						url: 'html/share_create_wizard.html',
						wiz_title: HOME_STR04,
						onLoad: share_loaddata(),
						onQuit: share_create_quit,
						onFinish: share_create_finish
					}, share_create_step1, share_create_step2, share_create_step3, share_create_step4_op1, share_create_step4_op2, share_create_step45);
					share_add_win_set_height = false;
				}
			}
		}
	};
	var handleFailure = function(o){
	};
	var callback ={
		success:handleSuccess,
		failure:handleFailure
	};
	var sUrl = '/cgi-bin/wizReq.cgi?wiz_func=share_create&count=' + Math.random() + '&sid='+sid;
	var request = QNAP.util.Connect.asyncRequest('POST', sUrl, callback);	
}
function location_hostname_for_ipv6(location_hostname)
{
	var ret_url = '';
	if(location_hostname.indexOf(':') == -1){
		ret_url = location_hostname;
	}else{
		ret_url = '['+location_hostname.replace(/[\[\]]/g, '') +']';
	}
	return ret_url;
}

/***********************************************************************************

	HAL FUNCTIONS

************************************************************************************/

var HAL_FUNCTIONS = {};

HAL_FUNCTIONS.GetAggregatePool = function($volumes){
	var aggregatePool = [];
	$volumes.children('row').each(function(index){
		var thisVolume = $j(this);
		var aggItem = {"id": '', "volumes": []};
		
		aggregate_member = thisVolume.find("aggre_member").text()=='yes'?true:false;
		aggregate_parent = thisVolume.find("parent").text();		
		
		if(!aggregate_member) return true;
		
		var found = false;
		for(var i=0, length=aggregatePool.size(); i<length; i++){
			if(aggregatePool[i].id == aggregate_parent){
				//found the item, add this volume into the list
				aggregatePool[i].volumes.push(thisVolume);
				return true;
			}
		}

		//this volume is not in the aggregate pool yet, so add it in
		aggItem.id = aggregate_parent;
		aggItem.volumes.push(thisVolume);
		aggregatePool.push(aggItem);
	});
	return aggregatePool;
};

HAL_FUNCTIONS.GetAggregateMembers = function(pool, id){
	for(var i=0,max=pool.length;i<max;i++){
		if(pool[i].id == id){
			return pool[i].volumes;
		}
	}
	return [];
};

HAL_FUNCTIONS.GetDiskDisplay = function(diskID){
	var display = '';
	display = HAL_FUNCTIONS.GetDeviceName(HAL_FUNCTIONS.GetEnclosureID(diskID))+': Drive '+HAL_FUNCTIONS.GetPortID(diskID); //need translation
	return display;
};

HAL_FUNCTIONS.GetDrivesDisplay = function(drivesList, sparesList, faultyList, raidLevel, withLink){
	
	if(drivesList == ''){
		return '';
	}
	
	var faultyArray = [];
	if(typeof(faultyList) != 'undefined'){
		faultyArray = faultyList.split(',');
	}
	
	var display = '';
	var listArray = drivesList.split(',');
	var hdListArray = [];
	var misplacedListArray = [];
	var home_enclosure_id = '';
	
	for(var i=0, max=listArray.length; i<max; i++){
		var enclosure_id = HAL_FUNCTIONS.GetEnclosureID(listArray[i]);	
		var port_id = HAL_FUNCTIONS.GetPortID(listArray[i]);
		
		var isFaulty = false;
		var isMisplaced = false;
		
		if(home_enclosure_id === ''){
			home_enclosure_id = enclosure_id;
		} 
		
		if(enclosure_id != home_enclosure_id){
			isMisplaced = true;
		}
		
		for(var j=0, count=faultyArray.length; j<count; j++){
			if(faultyArray[j] == listArray[i]){
				isFaulty = true;
				break;
			}
		}
		
		if(isFaulty){
			hdListArray.push('<span class="faulty diskID" style="color: red;" diskID="'+listArray[i]+'">'+port_id+'</span>');
		}else if(isMisplaced){
			misplacedListArray.push('<span class="faulty diskID" style="color: red;" diskID="'+listArray[i]+'"> '+HAL_FUNCTIONS.GetDeviceName(enclosure_id)+':&nbsp;Drive&nbsp;'+port_id+'</span>');
		}else{
			hdListArray.push('<span class="diskID" diskID="'+listArray[i]+'">'+port_id+'</span>');
		}
	}	
	
	//need to take care of raid10 display	
	if(raidLevel == '10'){
		var tempArray = [];
		var tempString = '';
		for(var i=0, count=hdListArray.length; i<count; i++){
			if(i%2==0){
				tempString = hdListArray[i]+'-';
			}else{
				tempString += hdListArray[i];
				tempArray.push(tempString);
				tempString = '';
			}
		}
		hdListArray = tempArray;
	}
	
	var deviceDisplay = HAL_FUNCTIONS.GetDeviceName(home_enclosure_id);
	if(home_enclosure_id > 0 && withLink){ //only creates the link for enclosures
		deviceDisplay = '<a href="#" style="color:black;" onClick="javascript:setMenuByUrl(\'/cgi-bin/disk/html/enclosure_mgmt.html\', {selected:\''+home_enclosure_id+'\'})">'+deviceDisplay+'</a>'
	}
	
	display += '&nbsp;&lt;'+deviceDisplay+':&nbsp;Drive&nbsp;'+hdListArray.join('&nbsp;'); //need translation
	
	if(sparesList.length > 0){
		var listArray = sparesList.split(',');
		var shdListArray = [];
		for(var i=0, max=listArray.length; i<max; i++){
			var isFaulty = false;
			for(var j=0, count=faultyArray.length; j<count; j++){
				if(faultyArray[j] == listArray[i]){
					isFaulty = true;
					break;
				}
			}
			if(isFaulty){
				shdListArray.push('<span class="faulty diskID" diskID="'+listArray[i]+'" style="color: red;">'+HAL_FUNCTIONS.GetPortID(listArray[i])+'</span>');
			}else{
				shdListArray.push('<span class="diskID" diskID="'+listArray[i]+'">'+HAL_FUNCTIONS.GetPortID(listArray[i])+'</span>');
			}
		}
		display += '&nbsp;' + IEI_NAS_STORAGE96 + '&nbsp;' + shdListArray.join('&nbsp;');
	}
	
	if(misplacedListArray.length > 0){
		display += misplacedListArray.join('&nbsp;') + '&gt;';
	}else{
		display += '&gt;';
	}
		
	return display;
};

HAL_FUNCTIONS.IsAggregateVolume = function(raidLevel){
	if(raidLevel == '20')
		return true;
	else
		return false;
};

HAL_FUNCTIONS.SetDiskSelection = function(destinationID, id){
	var $diskList = $j('#'+destinationID);
	
	if(!$diskList) return;
	
	$diskList.append('<option value="'+id+'">'+MISC_SMART_STR37+' '+HAL_FUNCTIONS.GetPortID(id)+'</option>');
};

HAL_FUNCTIONS.SetDeviceSelection = function(destinationID, id){
	var $selection = $j('#'+destinationID);
	var exist = false;
	
	if(!$selection) return;
	
	$selection.find('option').each(function(i){
		if($j(this).val() == id) exist=true;
	});
	if(!exist){
		$selection.append('<option value="'+id+'">'+HAL_FUNCTIONS.GetDeviceName(id)+'</option>');
		id++;
	}
};

HAL_FUNCTIONS.GetEnclosureID = function(diskID){
	if(!diskID) return '';
	if(diskID.indexOf(':')==-1) return diskID;
	var components = diskID.split(':');
	return parseInt(components[0], 16);
};

HAL_FUNCTIONS.GetPortID = function(diskID){
	if(!diskID) return '';
	if(diskID.indexOf(':')==-1) return diskID;
	var components = diskID.split(':');
	return parseInt(components[1], 16);
};

//returns the size in MB
HAL_FUNCTIONS.GetNormalizedSize = function(input){
	if(typeof(input) == 'undefined') return 0;
	if(typeof(input) == 'number') return input;
	input = input.toLowerCase();
	if(input.indexOf('mb') != -1){
		return parseFloat(input);
	}else if(input.indexOf('gb') != -1){
		return parseFloat(input)*1024;
	}else if(input.indexOf('tb') != -1){
		return parseFloat(input)*1024*1024;
	}else{
		//if there is no size indicator, treat it as 'kb'
		return parseFloat(input)/1024;
	}
};

HAL_FUNCTIONS.FormatSize = function(size){
	if(typeof(size)=='string') size = size.toLowerCase();
	else size = parseFloat(size) + ' mb';
	if(size=='--') return size;	
	if(isNaN(parseFloat(size))) return '0 MB';
	if(size.indexOf('mb') != -1){
		size = parseFloat(size);
		if(size < 1024){
			return size.toFixed(2) + ' MB';
		}else{
			size = size / 1024;
		}
		if(size < 1024){
			return size.toFixed(2) + ' GB';
		}else{
			size = size / 1024;
		}
		return size.toFixed(2) + ' TB';
	}else if(size.indexOf('kb') != -1){
		size = parseFloat(size);
		if(size < 1024){
			return size.toFixed(2) + ' KB';
		}else{
			size = size / 1024;
		}
		if(size < 1024){
			return size.toFixed(2) + ' MB';
		}else{
			size = size / 1024;
		}
		if(size < 1024){
			return size.toFixed(2) + ' GB';
		}else{
			size = size / 1024;
		}
		return size.toFixed(2) + ' TB';
	}else if(size.indexOf('gb') != -1){
		size = parseFloat(size);
		if(size < 1024){
			return size.toFixed(2) + ' GB';
		}else{
			size = size / 1024;
		}
		return size.toFixed(2) + ' TB';
	}
	else if(size.indexOf('tb') != -1){
		size = parseFloat(size);
		if(size < 1024){
			return size.toFixed(2) + ' TB';
		}else{
			size = size / 1024;
		}
		return size.toFixed(2) + ' PB';
	}
};

HAL_FUNCTIONS.GetDeviceName = function(id){
	var ret = '';
	if(id == 0){
		ret = 'Host';
	}else{
		ret = 'REXP#'+parseInt(id);
	}
	return ret;
};

HAL_FUNCTIONS.GetMinimumDisksRequirement = function(level){
	switch(level){
		case '0':
		case '1':
		case '-1':
			return 2;
		case '5':
			return 3;
		case '6':
		case '10':
			return 4;
		default:
			return 1;
	}
};

HAL_FUNCTIONS.GenUID = function(){
	return Math.random().toString(36).substr(2,9);
};

/************************************************************************************

	DEBUGGING TOOL

************************************************************************************/

function debug(msg){
	if($j.browser.msie) return false;
	
	if (window.console) {
		e = window.console.log;
		h = window.console;
	} else if (window.log) {
		e = window.log;
		h = window;
	}
	try {
		e.apply(h, arguments);
	} catch (c) {
		// d.apply(window, arguments);
	}
}
