	/***********************************************
    *
    *   Multimedia Plugins Wizard
    *
    ************************************************/
    global_obj.firmwareAvailable = false;

    function processInstallQueue(){
        //cgi-bin/application/appRequest.cgi?subfunc=qpkg&apply=1&getstatus=1&sid=z35kegmi
        if(global_obj.installQueue.length == 0){
            //finished installations, show QPKG icon images
            var imagebox = $j('#qimagebox');
            for(i=0; i<global_obj.successQueue.length; i++){
                var item = global_obj.successQueue[i];
                imagebox.append('<div style="width:100px; height: 100px; vertical-align: middle; text-align:center; float: left;"><img src="/RSS/images/'+item.id+'_80.gif" /><div>'+item.name+'</div></div>');
            }
            if(global_obj.failureQueue.length > 0){
                var failedList = global_obj.failureQueue.join(', ');
                q_alert(MPLUGINS_INSTALL_ERROR+' ('+failedList+')');
            }
            $j('#installPanel').hide();
            $j('#resultPanel').show();
            global_obj.installInProgress = false;
            return true;
        }

        var item = global_obj.installQueue.shift();
        doRemoteInstall(item);
    }

    function monitorRemoteProgress(itemID, itemName){
        var data = {
            "subfunc":"qpkg",
            "apply": 1,
            "getstatus": 1
        };
        $j.post('/cgi-bin/application/appRequest.cgi?sid='+sid, data, function(response){
            var updateStatus = $j(response).find('updateStatus').text();
            var downloadStatus = $j(response).find('downloadStatus').text();
            var downloadPercent = $j(response).find('downloadPercent').text();

            if(updateStatus == '99'){
                switch(downloadStatus){
                    case '1':
                        if (parseInt(downloadPercent) > 0)
			$j('#pkg-'+itemID).find('td:first').html(MPLUGINS_DOWNLOADING + '..' + downloadPercent + '%');
                        else
                        $j('#pkg-'+itemID).find('td:first').html(IEI_NAS_STORAGE182);
                        break;
                    case '2':
                        $j('#pkg-'+itemID).find('td:first').html(MPLUGINS_UNZIPPING);
                        break;
                    case '3':
                        $j('#pkg-'+itemID).find('td:first').html(MPLUGINS_INSTALLING);
                        break;
                    default:
                        $j('#pkg-'+itemID).find('td:first').html('<img src="/ajax_obj/images/err_icon.gif" style="display: inline;" />&nbsp;'+MPLUGINS_FAILED);
                        global_obj.failureQueue.push(itemName);
                        processInstallQueue();
                        return true;
                }
            }else if(updateStatus == '0'){
                $j('#pkg-'+itemID).find('td:first').html(MPLUGINS_INSTALLING+' [20%]');
            }else if(updateStatus == '1'){
                $j('#pkg-'+itemID).find('td:first').html(MPLUGINS_INSTALLING+' [50%]');
            }else if(updateStatus == '2'){
                $j('#pkg-'+itemID).find('td:first').html(MPLUGINS_INSTALLING+' [80%]');
            }else if(updateStatus == '3'){
                $j('#pkg-'+itemID).find('td:first').html('<img src="/ajax_obj/images/msg_ok.gif" style="display: inline;" />&nbsp;'+MPLUGINS_INSTALLED);
                global_obj.successQueue.push({"id":itemID, "name":itemName});
                processInstallQueue();
                return true;
            }else{
                $j('#pkg-'+itemID).find('td:first').html('<img src="/ajax_obj/images/err_icon.gif" style="display: inline;" />&nbsp;'+MPLUGINS_FAILED);
                global_obj.failureQueue.push(itemName);
                processInstallQueue();
                return true;
            }

            var timeout = setTimeout(function(){monitorRemoteProgress(itemID, itemName);}, 5000);
        }, 'xml');
    }

    function doRemoteInstall(item){
	
		var server = 'http://download.qnap.com/~qnap/Storage/';	//default server
		var serverList = global_obj.pluginsServer.find('server').each(function(index){
			var str = $j.trim($j(this).text());
			if(str != '') server = str;
		});

        var data = {
            "subfunc":"qpkg",
            "apply": 5,
            "location": server+item.location,
            "qname": item.id
        };
        $j.post('/cgi-bin/application/appRequest.cgi?sid='+sid, data, function(response){}, 'xml');

        var timeout = setTimeout(function(){monitorRemoteProgress(item.id, item.name);}, 1500);

    }

    function getPlugin(pluginName){
        var thisItem = '';
        global_obj.pluginsList.each(function(index){
            if($j(this).find('internalName').text() == pluginName){
                thisItem = $j(this);
                return false;
            }
        });
        return thisItem;
    }

    function showLiveUpdateWizard(event, internalModel, firmwareVersion, buildNumber, platform, model){
        if(event!='') event.preventDefault();
        var multimedia_plugins_quit = function(){
        }
        var multimedia_plugins_finish = function(dialog){
            if(global_obj.installInProgress) return 0;
            QNAP.util.Wizard.close_wiz(dialog);
        };
        var live_update_step1 = function(){
            global_obj.selectedPlugins = new Array();
            if($j('#firmwareUpdateSelected').attr('checked')){
                $j('a.modalCloseImg').trigger('click');
                document.cookie = "live_update=1";
                setMenuByUrl('/cgi-bin/sys/html/firm_update.html');
                return 0;
            }else{
                //add mandatory plugins first
                $j('#pluginsTable').find('input:checked.pluginSelection.mandatory').each(function(){
                    global_obj.selectedPlugins.push($j(this).val());
                });

                //now add user selected plugins
                $j('#pluginsTable').find('input:checked.pluginSelection:not(.mandatory)').each(function(){
                    //now add the real application to the queue
                    global_obj.selectedPlugins.push($j(this).val());
                });
            }

            if(global_obj.firmwareAvailable){
                if(global_obj.selectedPlugins.length == 0 && $j('#firmwareUpdateSelected').attr('checked') != true){
                    q_alert_info(MPLUGINS_REMINDER1);
                    return 0;
                }
            }else{
                if($j('#pluginsTable').find('tr.noplugins').size() == 1){
                    q_alert_info(MPLUGINS_REMINDER3);
                    return 0;
                }else{
                    if(global_obj.selectedPlugins.length == 0 && $j('#firmwareUpdateSelected').attr('checked') != true){
                        if($j('#pluginsTable').find('input.pluginSelection:enabled').size() == 0){
                            //all plugins are up to date already
                            q_alert_info(MPLUGINS_REMINDER4);
                        }else{
                            q_alert_info(MPLUGINS_REMINDER1);
                        }
                        return 0;
                    }
                }
            }
        }
        var live_update_step2 = function(){
            if($j('#tocAgreement').attr('checked') == false){
                q_alert_info(MPLUGINS_REMINDER2);
                return 0;
            }

            var installTable = $j('#installTable');
            installTable.find('tr:not(tr:first)').remove();
            global_obj.installQueue = new Array();
            for(i=0; i<global_obj.selectedPlugins.length; i++){
                var thisPlugin = getPlugin(global_obj.selectedPlugins[i]);

                if(thisPlugin == ''){
                    q_alert(MPLUGINS_PKG_NOT_FOUND+' ['+global_obj.selectedPlugins[i]+']');
                    return 0;
                }

                global_obj.installQueue.push({"id":thisPlugin.find('internalName').text(), "location":thisPlugin.find('location').text(), "name":thisPlugin.find('name').text()});

                var row = $j('<tr></tr>');
                row.attr('id', 'pkg-'+thisPlugin.find('internalName').text());
                if(i%2==0){
                    row.addClass('box_content_tr1');
                }else{
                    row.addClass('box_content_tr2');
                }
                row.append('<td>Pending</td>');
                row.append('<td>'+thisPlugin.find('name').text()+'</td>');
                row.append('<td>'+thisPlugin.find('version').text()+'</td>');
                row.append('<td style="border-right: 0;">'+thisPlugin.find('size').text()+'</td>');
                installTable.append(row);
            }

            global_obj.installInProgress = true;
            global_obj.successQueue = new Array();
            global_obj.failureQueue = new Array();
            processInstallQueue();
        }

        if(internalModel!='' && firmwareVersion!='' && buildNumber!=''){
            QNAP.util.Wizard.OpenWizard({
                    url:'html/live_update_wizard.html',
                    wiz_title: MPLUGINS_WIZARD_TITLE2,
                    onLoad: function(){live_update_loaddata(internalModel, firmwareVersion, buildNumber, platform, model);},
                    onQuit: multimedia_plugins_quit,
                    onFinish: multimedia_plugins_finish
                }, live_update_step1, live_update_step2
            );
        }else{
            QNAP.util.Wizard.OpenWizard({
                    url:'html/multimedia_plugins_wizard.html',
                    wiz_title: MPLUGINS_WIZARD_TITLE1,
                    onLoad: function(){live_update_loaddata(internalModel, firmwareVersion, buildNumber, platform, model);},
                    onQuit: multimedia_plugins_quit,
                    onFinish: multimedia_plugins_finish
                }, live_update_step1, live_update_step2
            );
        }
    }

    function isPackageInstalled(packageName){
        for(i=0; i<global_obj.installedPackages.length; i++){
            if(global_obj.installedPackages[i] == packageName) return true;
        }
        return false;
    }

    function getPackageStatus(thisPackage, firmwareAvailable){
        var isMandatory = false;
        var data = {
            "subfunc":'qpkg',
            "item_name": thisPackage.find('internalName').text(),
            "sid": sid
        };
        if(thisPackage.find('mandatory').text() == 'true') isMandatory = true;
        $j.post('/cgi-bin/application/appRequest.cgi', data, function(response){

            var version = $j(response).find('qItem attr version').text();
            var internalName = thisPackage.find('internalName').text();

            if($j.trim(version) == ''){
                version = ' -&nbsp;-';
                if(isMandatory){
                    if(!$j('#firmwareUpdateSelected').attr('checked')) $j('#'+internalName+'_status').parent().parent().find('input:checkbox').attr('checked', 'checked');
                }else{
                    if(!$j('#firmwareUpdateSelected').attr('checked')){
                        if(firmwareAvailable){
                            $j('#'+internalName+'_status').parent().parent().find('input:checkbox').enable();
                        }else{
                            $j('#'+internalName+'_status').parent().parent().find('input:checkbox').attr('checked', 'checked').enable();
                        }
                    }
                }
            }else if(thisPackage.find('version').text() != $j.trim(version)){
                version = '<i><b>'+version+'</b></i>';
                global_obj.installedPackages.push(internalName);
                if(isMandatory){
                    if(!$j('#firmwareUpdateSelected').attr('checked')) $j('#'+internalName+'_status').parent().parent().find('input:checkbox').attr('checked', 'checked');
                }else{
                    if(!$j('#firmwareUpdateSelected').attr('checked')) {
                        if(firmwareAvailable){
                            $j('#'+internalName+'_status').parent().parent().find('input:checkbox').enable();
                        }else{
                            $j('#'+internalName+'_status').parent().parent().find('input:checkbox').attr('checked', 'checked').enable();
                        }
                    }
                }
            }else{
                $j('#'+internalName+'_status').parent().parent().find('input:checkbox').addClass('alwaysDisable');
            }
            $j('#'+internalName+'_status').html(version);

        }, 'xml');
        return '<img src="/ajax_obj/img/running.gif" />';
    }

    function live_update_loaddata(modelName, firmwareVersion, buildNumber, platform, model){
        var data = {
            "subfunc":'getPackageXML',
            "sid": sid
        };
        $j.post('/cgi-bin/application/appRequest.cgi', data, function(response){

            if($j(response).find('docRoot').size() == 0){
                q_alert(MPLUGINS_XML_ERROR);
                return;
            }

            var pluginsTable = $j('#pluginsTable');

            //check firmware version
            if(modelName!='' && modelName != 'null' && firmwareVersion!='null' && buildNumber !='null'){
                //display firmware option
                global_obj.firmwareAvailable = true;
                $j(response).find('storage model').each(function(){
                    var thisModelName = $j(this).find('modelName').text();
                    if(modelName == thisModelName){
                        var thisFirmwareVersion = $j(this).find('firmware version').text();
                        var thisBuildNumber = $j(this).find('firmware buildNumber').text();
                        var thisNote = $j(this).find('firmware description').text();

                        var row = $j('<tr class="box_content_tr2"></tr>');
                        row.append('<td valign="top"><input checked="checked" type="checkbox" id="firmwareUpdateSelected" name="firmwareUpdateSelected" class="firmwareSelection" value="1" /></td>');
                        row.append('<td valign="top">NAS Firmware&nbsp;&nbsp;<a class="showInfo moreInfo" style="cursor: pointer;"><img border=0 src="/ajax_obj/images/maximize.gif" style="vertical-align:middle"></a><div style="display: none; padding: 10px;">'+$j(this).find('description').text()+'</div></td>');
                        row.append('<td>'+thisFirmwareVersion+'</td>');
                        row.append('<td> - -</td>');
                        row.append('<td style="border-right: 0;">'+firmwareVersion+'&nbsp;'+buildNumber+'</td>');

                        pluginsTable.append(row);
                        return false; //breaks out of the jquery loop
                    }
                });
            }

            //list qpkg packages list
            var isMandatory = false;
            global_obj.installedPackages = new Array();
            global_obj.pluginsServer = $j(response).find('plugins pluginsServer');
            global_obj.pluginsList = $j(response).find('plugins item');

            var rowIndex = 0;
            global_obj.pluginsList.each(function(index){
                var row = $j('<tr></tr>');
                var item = $j(this);

                var modelMatch = false;
                var platformMatch = false;

                var thisPlatform = item.find('platform').text();
                if(thisPlatform == '') platformMatch = true;
                else{
                    var platformArray = thisPlatform.split(',');
                    for(i=0; i< platformArray.length; i++){
                        if(platform == $j.trim(platformArray[i])){
                            platformMatch = true;
                        }
                    }
                }

                var thisModel = item.find('model').text();
                if(thisModel == '') modelMatch = true;
                else{
                    var modelArray = thisModel.split(',');
                    for(i=0; i< modelArray.length; i++){
                        if(model == $j.trim(modelArray[i])){
                            modelMatch = true;
                        }
                    }
                }

                //skips this item if it's not a match with either model or platform
                if(!modelMatch || !platformMatch) return true;

                if(rowIndex++%2==0){
                    row.addClass("box_content_tr1");
                }else{
                    row.addClass("box_content_tr2");
                }

                var pluginDependencies = new Array();
                item.find('dependency entry').each(function(){
                    pluginDependencies.push($j(this).text());
                });

                if(item.find('mandatory').text() == 'true') isMandatory = true;

                row.append('<td valign="top"><input disabled="disabled" dependency="'+pluginDependencies.join(',')+'" type="checkbox" id="'+item.find('internalName').text()+'" name="plugin'+index+'" class="pluginSelection'+(isMandatory?' mandatory':'')+'" value="'+item.find('internalName').text()+'" /></td>');
                row.append('<td valign="top">'+item.find('name').text()+'&nbsp;&nbsp;<a class="showInfo moreInfo" style="cursor: pointer;"><img border=0 src="/ajax_obj/images/maximize.gif" style="vertical-align:middle"></a><div style="display: none; padding: 10px;">'+item.find('description').text()+'</div></td>');
                row.append('<td>'+item.find('version').text()+'</td>');
                row.append('<td>'+item.find('size').text()+'</td>');
                row.append('<td style="border-right: 0;"><span class="q napstr" name="" id="'+item.find('internalName').text()+'_status">'+getPackageStatus($j(this), global_obj.firmwareAvailable)+'</span></td>');

                pluginsTable.append(row);
            });

            if(!global_obj.firmwareAvailable && (pluginsTable.find('tr').size()<1)){
                var row = $j('<tr></tr>');
                row.addClass("box_content_tr1");
                row.addClass("noplugins");
                row.append('<td colspan="5" style="text-align: center; height: 50px;">'+MPLUGINS_REMINDER3+'</td>');
                pluginsTable.append(row);
            }

            $j('#goToQPKG').click(function(e){
                e.preventDefault();
                $j('#step2_button_next').trigger('click');
                setMenuByUrl('application/html/qpkg.html');
            });

            pluginsTable.find('input:checkbox.firmwareSelection').click(function(e){
                if($j(this).attr('checked')){
                    pluginsTable.find('input:checkbox.pluginSelection').attr('checked', '').disable();
                }else{
                    pluginsTable.find('input:checkbox:not(.alwaysDisable, .mandatory).pluginSelection').attr('checked', '').enable();
                    pluginsTable.find('input:checkbox:not(.alwaysDisable).pluginSelection.mandatory').attr('checked', 'check');
                }
            });

            pluginsTable.find('a.showInfo').click(function(e){
                e.preventDefault();
                var thisItem = $j(this);
                if(thisItem.hasClass('moreInfo')){
                    thisItem.parent().find('div').show();
                    thisItem.removeClass('moreInfo').addClass('lessInfo');
                    thisItem.text('');
					thisItem.append("<img border=0 src=\"/ajax_obj/images/minimize.gif\" style=\"vertical-align:middle\">");
                }else{
                    thisItem.parent().find('div').hide();
                    thisItem.removeClass('lessInfo').addClass('moreInfo');
                    thisItem.text('');
					thisItem.append("<img border=0 src=\"/ajax_obj/images/maximize.gif\" style=\"vertical-align:middle\">");
                }
            });
        }, 'xml');
    };


	/***********************************************
    *
    *   end of Multimedia Plugins Wizard
    *
    ************************************************/

var chk_enable_disable_button = function(val)
{
	var en_a = $j('#qpkg_enable');   //get enable button
	var en_b = $j('#qpkg_disable'); //get disable button
	var en_c = $j('#qpkg_configuration'); //get disable button
	if(val=='TRUE')
	{

		val='Enable';
		en_a.removeClass();
		en_a.addClass('button_disable');
		en_a.unbind('click');
		en_a.removeAttr('href');

		en_b.removeClass();
		en_b.addClass('button_2');
		en_b.click(function(e){
			var qname=$(this).name;
			disableQpkg(qname);
		});
		en_b.attr('href','#');

        configToggle(en_c);

	}
	else if(val=='FALSE')
	{

		val='Disable';

		en_a.removeClass();
		en_a.addClass('button_2');
		en_a.click(function(e){
			var qname=$(this).name;
			enableQpkg(qname);
		});
		en_a.attr('href','#');


		en_b.removeClass();
		en_b.addClass('button_disable');
		en_b.removeAttr('href');
		en_b.unbind('click');

        configToggle(en_c);

	}
	else
	{

		val='UNKNOWN';
		en_a.removeClass();
		en_a.addClass('button_2');
		en_a.click(function(e){
			var qname=$(this).name;
			enableQpkg(qname);
		});

		en_b.removeClass();
		en_b.addClass('button_2');
		en_b.click(function(e){
			var qname=$(this).name;
			disableQpkg(qname);
		});

        configToggle(en_c);

	}
	return val;
};
var configToggle = function(en_c){
    if(en_c.css('display') == 'none'){
        en_c.remove();
    }else{
        en_c.removeClass();
        en_c.addClass('button_2');
        en_c.click(function(e){
            e.preventDefault();
            $j('#infoPanel').hide();
            $j('#configPanel').show();
        });

        $j('#qpkg_configuration_submit').click(function(e){
            showLoading(1);
            //cgi submission
            var data = {
                "username":$j('input[name=skiftaUsername]').val(),
                "password":$j('input[name=skiftaPassword]').val(),
                "itemName":"Skifta"
            };
            $j.post("/cgi-bin/application/appRequest.cgi?subfunc=qpkg&apply=6&sid="+sid, data, function(response){
                if($j(response).find('retValue').text() == '0'){
                    showLoading(0);
                    $j('#step0_button_next').trigger('click');
                    q_alert_info(MPLUGINS_SKIFTA_INSTALLED);
                    enableQpkg('Skifta');
                }else{
                    showLoading(0);
                    q_alert_info(MPLUGINS_CUSTOM_INSTALL_ERROR);
                }
            }, 'xml');
        });

        $j('#qpkg_configuration_cancel').click(function(e){
            e.preventDefault();
            $j('#configPanel').hide();
            $j('#infoPanel').show();
        });
    }
};
var qpkginfoClose = function(dialog){
	QNAP.util.Wizard.close_wiz(dialog);
};
var qpkginfoQuit = function(){

};
var qpkginfoLoad = function(argus){

	$j('<div></div>').append('loading...').attr('id', 'wiz_loading').appendTo('.wizardData');
	var handleSuccess = function(o){
		$j('#wiz_loading').remove();
		if(o.responseXML !== undefined){
			var xmlobject = o.responseXML;
			if (QNAP.util.auth.CheckIfAuthPassed(xmlobject) == 0) {
  			QNAP.util.data_loading(0);
  			QNAP.util.auth.GotoLoginPage();
  			return;
			}

			if($j(xmlobject).find('genericModel').text() == 'yes'){
				$j('.qpkg_title').append('PKG - ' + argus.qItem);
			}else{
				$j('.qpkg_title').append('QPKG - ' + argus.qItem);
			}
			$j('.qpkg_table').attr('cellspacing', '6');
			var limg = $j('#leftimg');
			limg.addClass('qpkg_logo');
			limg.find('img').remove();
			$j('<img>').attr('src', '/RSS/images/' +  argus.qItem + '_80.gif').appendTo(limg);
			limg.show();

			var result = $j(xmlobject);
			var webServerEnable = result.find('webServerEnable').text();
			var webServerPort = result.find('webServerPort').text();
			var sslEnable = result.find('sslEnable').text();
			var sslPort = result.find('sslPort').text();
			var projectName = result.find('projectlName').text();
			var isDefaultServerUsed = false;

			var item_attr = result.find('QDocRoot func ownContent qItem attr');
			//tagName*:xml tag name textName*:web
			//databased format
			//note :nokey mean donot get xml data
			var att_a = [
							{tagName: 'QPKGFile',tagName2: 'nokey', tagName3: 'nokey', textName: MISC_QPKG_STRING07+':'},
							{tagName: 'date', tagName2: 'nokey', tagName3: 'nokey', textName: MISC_QPKG_STRING02+':'},
							{tagName: 'version', tagName2: 'nokey',tagName3: 'nokey',textName: IEI_NAS_SERVER4_VER+':'},
							{tagName: 'installPath', tagName2: 'nokey',tagName3: 'nokey',textName: MISC_QPKG_STRING03+':'},
							{tagName: 'enable', tagName2: 'shell',tagName3: 'nokey',textName: IEI_DEVICE_MSG04},
							{tagName: 'servPort',tagName2: 'nokey',tagName3: 'nokey', textName:MISC_QPKG_STRING04+':'} ,
							{tagName: 'webUI',tagName2: 'webPort', tagName3: 'webServerPort',textName: MISC_QPKG_STRING06+':',textName2:'http://'+location_hostname_for_ipv6(location.hostname)},
							{tagName: 'author', tagName2: 'nokey',tagName3: 'nokey',textName: MISC_QPKG_STRING15+':'},
							{tagName: 'shell', tagName2: 'needConfiguration',tagName3: 'nokey',textName: 'shell: '}
						];
			var bt_tr = $j('.qpkg_table').find('tr:first');

			$j(att_a).each(function(i){
				var val = item_attr.find(this.tagName).text();
				var val2 = item_attr.find(this.tagName2).text();
				var val3 = item_attr.find(this.tagName3).text();

				var en_a = $j('#qpkg_enable');   //get enable button
				var en_b = $j('#qpkg_disable'); //get disable button
        var en_c = $j('#qpkg_configuration'); //get configuration button
				var processing=$j('<span></span>');
				processing.attr('id','processing');
				processing.append('<span class="qnapstr" name="NIC_MYSQL_STR13"></span> &nbsp;<img src="/ajax_obj/img/running.gif" /> ');

				var remove_success=$j('<span></span>');
				remove_success.attr('class','qnapstr');
				remove_success.attr('name','MISC_QPKG_MSG22');
				remove_success.attr('id','remove_success');

				var noshell=$j('<span></span>');
				noshell.attr('class','qnapstr');
				noshell.attr('name','IEI_NAS_STORAGE160');
				noshell.attr('id','noshell');

				var enable_disable=$j('<span></span>');
				enable_disable.attr('id','enable_disable');

				if(this.tagName=='shell')
				{
					if(val=='null')
					{
						en_a.hide();
						en_b.hide();
            en_c.hide();
					}
					else
					{
            //checking configuration option
            if(val2=='1'){
                en_a.hide();
                en_b.hide();
                en_c.show();
            }else{
                en_a.show();
                en_b.show();
                en_c.hide();
            }
					}

				}

				if(this.tagName=='installPath' && (projectName == "Athens"))
				{
					if (val.search(/\/share\/[A-Z0-9]{3}_DATA\/.qpkg/) >= 0)
						val = val.replace(/.qpkg/, ".pkg");
				}

				if(this.tagName=='enable')
				{
					val=chk_enable_disable_button(val);
				}


				//show shell is not null
				if(val!='' && val != '0' && this.tagName!='shell' )
				{
					var info=$j('<tr></tr>');
					var info_col1=$j('<td></td>');
					var info_col2=$j('<td></td>');

					//info_col1 conetnt
					info_col1.addClass('qpkg_left');
					info_col1.append(this.textName);
					//info_col2 content
					if(this.tagName=='webUI')
					{
						//hyperlink tagName="webUI" use
						var hyperlink=$j('<a></a>');
						var sslLink = $j('<a></a>');
						hyperlink.attr('id','qpkgWeburl');
						sslLink.attr('id', 'qpkgSSL');
						if(val2!='' && val2 != '0' && val2 != '80')
						{
							hyperlink.html(this.textName2+':'+val2+val);
							hyperlink.attr('target','_blank');
							if(item_attr.find('shell').text()!='null'){
								if(item_attr.find('enable').text()=='TRUE'){
									hyperlink.attr('href',this.textName2+':'+val2+val);
								}else{
									hyperlink.attr('disable', 'true');
								}
							}else{
								hyperlink.attr('href',this.textName2+':'+val2+val);
							}

							if(val2 == webServerPort){
								isDefaultServerUsed = true;
								//it's using the default webserver, so setup SSL links for it as well
								var sslLinkHref = this.textName2.replace('http://', 'https://');
								sslLink.html(sslLinkHref+':'+sslPort+val);
								sslLink.attr('target','_blank');
								if(item_attr.find('enable').text()=='TRUE') { // || item_attr.find('enable').text()=='UNKNOWN'){
									sslLink.attr('href',sslLinkHref+':'+sslPort+val);
								}else{
									sslLink.attr('linkHref',sslLinkHref+':'+sslPort+val);
									sslLink.attr('disable', 'true');
								}
							}

						}
						else if(val == 'null')
						{
							hyperlink.html('N/A');
						}
						else
						{
							isDefaultServerUsed = true;

							hyperlink.html(this.textName2+':'+val3+val);
							hyperlink.attr('target','_blank');
							hyperlink.attr('href',this.textName2+':'+val3+val);

							var sslLinkHref = this.textName2.replace('http://', 'https://');
							sslLink.html(sslLinkHref+':'+sslPort+val);
							sslLink.attr('target','_blank');
							sslLink.attr('href',sslLinkHref+':'+sslPort+val);
							if(item_attr.find('shell').text()!='null')
								if(item_attr.find('enable').text()!='TRUE'){
									sslLink.removeAttr('href');
									hyperlink.removeAttr('href');
								}
						}


						if(isDefaultServerUsed && webServerEnable==0){
							hyperlink.click(function(e){
								e.preventDefault();
								if($j(this).attr('disable') == 'true') return;
								q_confirm_run_post(QPKG_WEBSERVER_REMINDER,
								function(){
									setMenuByUrl('/cgi-bin/net/html/web_srv.html');
									$j('#step0_button_next').trigger('click');
								});
							});

							sslLink.click(function(e){
								e.preventDefault();
								if($j(this).attr('disable') == 'true') return;
								q_confirm_run_post(QPKG_SSL_REMINDER,
								function(){
									setMenuByUrl('/cgi-bin/net/html/web_srv.html');
									$j('#step0_button_next').trigger('click');
								});
							});
						}
						if(!isDefaultServerUsed || projectName != "Athens"){
							info_col2.append(hyperlink);
						}
						if(sslLink.html() != ''){
							if(projectName != "Athens"){
								info_col2.append('<br>');
							}
							info_col2.append(sslLink);
							if(webServerEnable==1 && sslEnable==0){
								sslLink.click(function(e){
									e.preventDefault();
									if($j(this).attr('disable') == 'true') return;
									q_confirm_run_post(QPKG_SSL_REMINDER,
									function(){
										setMenuByUrl('/cgi-bin/net/html/web_srv.html');
										$j('#step0_button_next').trigger('click');
									});
								});
							}
						}
					}
					else if(this.tagName=='enable')
					{

						if(val2=='null')
						{
							info_col2.append(noshell).append(processing).append(remove_success);

						}
						else
						{
							if(val=='Enable')
							{
								enable_disable.html('<span class="qnapstr" name="IEI_NAS_STORAGE160">Enabled</span>');

							}
							else if(val=='Disable')
							{
								enable_disable.html('<span class="qnapstr" name="IEI_NAS_STORAGE161">Disabled</span>');
							}
							else
							{
								enable_disable.html('<span class="qnapstr" name="MISC_QPKG_MSG25">Unknown</span>');
							}

							info_col2.append(enable_disable).append(processing).append(remove_success);

						}
					}
					else
					info_col2.append(val);
					//hide element id=#*
					$j('#processing').hide();
					$j('#remove_success').hide();
					info.append(info_col1).append(info_col2);
					info.insertBefore(bt_tr);
				}
			});
			$j('#qpkg_remove').click(function()
			{
				removeall(argus.qItem);
			});

		}
		//multilanguage refresh
		QNAP.util.RefreshString('qnapstr', 'step0');
	}
	var handleFailure = function(o){
		//data_loading(0);
		if(o.responseText != undefined){
			div.innerHTML = "<li>Transaction id: " + o.tId + "</li>";
			div.innerHTML += "<li>HTTP status: " + o.status + "</li>";
			div.innerHTML += "<li>Status code message: " + o.statusText + "</li>";
    }
	}
	var callback = {
		success:handleSuccess,
		failure:handleFailure
	};
	//var sUrl = '/cgi-bin/disk/diskRequest.cgi?todo=get_disk&subfunc=' + sub_func + '&count=' + Math.random()+ '&sid='+sid;
	var sUrl = '/cgi-bin/application/appRequest.cgi?subfunc=qpkg&item_name='+encodeURIComponent(argus.qItem)+'&count=' + Math.random() + '&sid='+sid;
	var request = QNAP.util.Connect.asyncRequest('POST', sUrl, callback);

};
