if(typeof QNAP == "undefeind" || !QNAP){
	var QNAP = {};		
}
(function ($) {
	var ie6 = $.browser.msie && parseInt($.browser.version) == 6 && !window['XMLHttpRequest'],
		ieQuirks = $.browser.msie && !$.boxModel,
		w = [];
	
	$.prompt = function (data, options) {
		return $.impl.init(data, options);
	};
	$.prompt.close = function () {
		$.impl.close();
	};
	$.fn.prompt = function (options) {
		return $.impl.init(this, options);
	};
	
	$.defaults = {
		opacity: 50,
		overlayId: 'qMessage-overlay',
		overlayCss: {},
		overlayClass: 'qMessage-overlay',
		containerId: 'qMessage-container',
		containerCss: {},
		dataCss: {},
		buttonClass: 'button_msg',
		zIndex: 5000,
		close: false,
		closeHTML: '<a class="qMessageCloseImg" title="Close"></a>',
		closeClass: 'qMessage-close',
		position: null,
		persist: false,
		onOpen: null,
		onShow: null,
		onClose: null,
		buttons: {OK:'OK'},
		custom_button_evt: false
	};
	
	$.impl = {
		opts: null,
		dialog: {},
		init: function(data, options) {
			
			this.opts = $.extend({}, $.defaults, options);
			
			if (typeof data == 'object') {
				// convert DOM object to a jQuery object
				data = data instanceof jQuery ? data : $(data);

				// if the object came from the DOM, keep track of its parent
				if (data.parent().parent().size() > 0) {
					this.dialog.parentNode = data.parent();

					// persist changes? if not, make a clone of the element
					if (!this.opts.persist) {
						this.dialog.orig = data.clone(true);
					}
				}
			}
			else if (typeof data == 'string' || typeof data == 'number') {
				// just insert the data as innerHTML
				data = $('<div/>').html(data);
			}
			else {
				// unsupported data type!
				q_alert('Error: Unsupported data type: ' + typeof data);
				return false;
			}
			this.dialog.data = data.addClass('qMessage-data').css(this.opts.dataCss);;
			data = null;
			this.create();
			this.open();

			if ($.isFunction(this.opts.onShow)) {
				this.opts.onShow.apply(this, [this.dialog]);
			}

			// don't break the chain =)
			return this;
		},
		create: function () {
			w = this.getDimensions();

			// add an iframe to prevent select options from bleeding through
			if (ie6) {
				this.dialog.iframe = $('<iframe src="javascript:false;"/>')
					.css($.extend(this.opts.iframeCss, {
						display: 'none',
						opacity: 0, 
						position: 'fixed',
						height: w[0],
						width: w[1],
						zIndex: this.opts.zIndex,
						top: 0,
						left: 0
					}))
					.appendTo('body');
			}
			
			// create the overlay
			this.dialog.overlay = $('<div/>')
				.attr('id', this.opts.overlayId)
				.addClass(this.opts.overlayClass)
				.css($.extend(this.opts.overlayCss, {
					display: 'none',
					opacity: this.opts.opacity / 100,
					height: w[0],
					width: w[1],
					position: 'fixed',
					left: 0,
					top: 0,
					zIndex: this.opts.zIndex + 1
				}))
				.appendTo('body');
				
				// create the container
			this.dialog.container = $('<div/>')
				.attr('id', this.opts.containerId)
				.css($.extend(this.opts.containerCss, {
					display: 'none',
					position: 'fixed',
					zIndex: this.opts.zIndex + 2
				}))
				.append(this.opts.close 
					? $(this.opts.closeHTML).addClass(this.opts.closeClass)
					: '')
				.appendTo('body');
			this.setPosition();

			// fix issues with IE
			if (ie6 || ieQuirks) {
				this.fixIE();
			}

			// hide the data and add it to the container
			this.dialog.container.append(this.dialog.data.hide());	
		},
		fixIE: function () {
			var p = this.opts.position;

			// simulate fixed position - adapted from BlockUI
			$.each([this.dialog.iframe || null, this.dialog.overlay, this.dialog.container], function (i, el) {
				if (el) {
					var bch = 'document.body.clientHeight', bcw = 'document.body.clientWidth',
						bsh = 'document.body.scrollHeight', bsl = 'document.body.scrollLeft',
						bst = 'document.body.scrollTop', bsw = 'document.body.scrollWidth',
						ch = 'document.documentElement.clientHeight', cw = 'document.documentElement.clientWidth',
						sl = 'document.documentElement.scrollLeft', st = 'document.documentElement.scrollTop',
						s = el[0].style;

					s.position = 'absolute';
					if (i < 2) {
						s.removeExpression('height');
						s.removeExpression('width');
						s.setExpression('height','' + bsh + ' > ' + bch + ' ? ' + bsh + ' : ' + bch + ' + "px"');
						s.setExpression('width','' + bsw + ' > ' + bcw + ' ? ' + bsw + ' : ' + bcw + ' + "px"');
					}
					else {
						var te, le;
						if (p && p.constructor == Array) {
							if (p[0]) {
								var top = typeof p[0] == 'number' ? p[0].toString() : p[0].replace(/px/, '');
								te = top.indexOf('%') == -1 
									? top + ' + (t = ' + st + ' ? ' + st + ' : ' + bst + ') + "px"'
									: parseInt(top.replace(/%/, '')) + ' * ((' + ch + ' || ' + bch + ') / 100) + (t = ' + st + ' ? ' + st + ' : ' + bst + ') + "px"';
							}
							if (p[1]) {
								var left = typeof p[1] == 'number' ? p[1].toString() : p[1].replace(/px/, '');
								le = left.indexOf('%') == -1 
									? left + ' + (t = ' + sl + ' ? ' + sl + ' : ' + bsl + ') + "px"'
									: parseInt(left.replace(/%/, '')) + ' * ((' + cw + ' || ' + bcw + ') / 100) + (t = ' + sl + ' ? ' + sl + ' : ' + bsl + ') + "px"';
							}
						}
						else {
							te = '(' + ch + ' || ' + bch + ') / 2 - (this.offsetHeight / 2) + (t = ' + st + ' ? ' + st + ' : ' + bst + ') + "px"';
							le = '(' + cw + ' || ' + bcw + ') / 2 - (this.offsetWidth / 2) + (t = ' + sl + ' ? ' + sl + ' : ' + bsl + ') + "px"';
						}
						s.removeExpression('top');
						s.removeExpression('left');
						s.setExpression('top', te);
						s.setExpression('left', le);
					}
				}
			});
		},
		bindEvents: function () {
			var self = this;
			$.each(self.opts.buttons, function(k,v){
				$('a.' + self.opts.buttonClass + ' #'+k).html(v);
				if(self.opts.custom_button_evt==false){
					$('a.' + self.opts.buttonClass + ' span').bind('click.qMessage'+k, function (e) {
						e.preventDefault();
						self.close();
					});
				}
			});
			// bind the close event to any element with the closeClass class
/*			$('.' + this.opts.closeClass).bind('click.qMessage', function (e) {
				e.preventDefault();
				self.close();
			});
*/
			// update window size
			$(window).bind('resize.qMessage', function () {
				// redetermine the window width/height
				w = self.getDimensions();

				// reposition the dialog
				self.setPosition();
	
				if (ie6 || ieQuirks) {
					self.fixIE();
				}
				else {
					// update the iframe & overlay
					self.dialog.iframe && self.dialog.iframe.css({height: w[0], width: w[1]});
					self.dialog.overlay.css({height: w[0], width: w[1]});
				}
			});
		},
		/*
		 * Unbind events
		 */
		unbindEvents: function () {
			var self = this;
			if(this.opts.custom_button_evt==false){
				$.each(self.opts.buttons, function(k,v){
					$('a.' + self.opts.buttonClass + ' span').unbind('click.qMessage'+k);
				});
			}
//			$('.' + this.opts.closeClass).unbind('click.qMessage');
			$(window).unbind('resize.qMessage');
		},
		getDimensions: function () {
			var el = $(window);

			// fix a jQuery/Opera bug with determining the window height
			var h = $.browser.opera && $.browser.version > '9.5' && $.fn.jquery <= '1.2.6' ?
				document.documentElement['clientHeight'] : 
				el.height();

			return [h, el.width()];
		},
		setPosition: function () {
			var top, left,
				hCenter = (w[0]/2) - ((this.dialog.container.height() || this.dialog.data.height())/2),
				vCenter = (w[1]/2) - ((this.dialog.container.width() || this.dialog.data.width())/2);

			if (this.opts.position && this.opts.position.constructor == Array) {
				top = this.opts.position[0] || hCenter;
				left = this.opts.position[1] || vCenter;
			} else {
				top = hCenter;
				left = vCenter;
			}
			this.dialog.container.css({left: left, top: top});
		},
		open: function () {
			// display the iframe
			this.dialog.iframe && this.dialog.iframe.show();

			if ($.isFunction(this.opts.onOpen)) {
				// execute the onOpen callback 
				this.opts.onOpen.apply(this, [this.dialog]);
			}
			else {
				// display the remaining elements
				this.dialog.overlay.show();
				this.dialog.container.show();
				this.dialog.data.show();
			}

			// bind default events
			this.bindEvents();
		},
		close: function () {
			// prevent close when dialog does not exist
			if (!this.dialog.data) {
				return false;
			}

			if ($.isFunction(this.opts.onClose) && !this.occb) {
				// set the onClose callback flag
				this.occb = true;

				// execute the onClose callback
				this.opts.onClose.apply(this, [this.dialog]);
			}
			else {
				// if the data came from the DOM, put it back
				if (this.dialog.parentNode) {
					// save changes to the data?
					if (this.opts.persist) {
						// insert the (possibly) modified data back into the DOM
						this.dialog.data.hide().appendTo(this.dialog.parentNode);
					}
					else {
						// remove the current and insert the original, 
						// unmodified data back into the DOM
						this.dialog.data.remove();
						this.dialog.orig.appendTo(this.dialog.parentNode);
					}
				}
				else {
					// otherwise, remove it
					this.dialog.data.remove();
				}

				// remove the remaining elements
				this.dialog.container.remove();
				this.dialog.overlay.remove();
				this.dialog.iframe && this.dialog.iframe.remove();

				// reset the dialog object
				this.dialog = {};
			}

			// remove the default events
			this.unbindEvents();
		}
	};
})(jQuery);
QNAP.messageBox = {};
QNAP.messageBox.alert = function(title, content, info_or_error){
	this.error = info_or_error;
	function createBox(t, s){
		var img_url = '/ajax_obj/images/message_warning.gif';
		if(this.error && this.error==1){	// error
			img_url = '/ajax_obj/images/message_error.gif';
		}
		else{
			// info	
			img_url = '/ajax_obj/images/message_info.gif';
		}
		return ["<center>", 
						"<div class='msg_box' id='alert_box'>",
						"<div class='msg_bar'><div class='msg_title'>" + title + "</div></div>",
						"<div class='msg_body'>",
						"<div class='msg_img'><img src='" + img_url + "' width='70 'height='70' border='0' alt='Warning' title='Warning'></div>",
						"<div class='msg_content'><div>" + content + "</div>",
						"<div class='msg_end'><a class='button_msg' href='#' onclick='this.blur();'><span id='OK'>OK</span></a></div></div>",
						"<div style='clear:both;'></div>",
						"</div>",
						"</center>"].join('');
	}
	
	var box = createBox(title, content);
//	$j(box).appendTo('body');
	$j(box).prompt({
		opacity: 20,
		containerCss:{width: '400', height:'300'},
		overlayCss: {
			backgroundColor:'#eee', 
			cursor: 'wait'
		},
		buttons: {OK: IEI_NAS_BUTTON_OK}
	});
}

QNAP.messageBox.confirm = function(title, content, callback){
	this.callback = callback;
	function createBox(t, s){
		return ["<center>", 
						"<div class='msg_box' id='alert_box'>",
						"<div class='msg_bar'><div class='msg_title'>" + title + "</div></div>",
						"<div class='msg_body'>",
						"<div class='msg_img'><img src='/ajax_obj/images/message_warning.gif' width='70 'height='70' border='0' alt='Warning' title='Warning'></div>",
						"<div class='msg_content'>" + content + "</div>",
						"<div class='msg_end'><a id='OK_A' class='button_msg' href='#' onclick='this.blur();'><span id='OK'>OK</span></a><a id='CANCEL_A' class='button_msg' href='#' onclick='this.blur();'><span id='CANCEL'>Cancel</span></a></div>",
						"<div style='clear:both;'></div>",
						"</div>",
						"</center>"].join('');
	}
	
	var box = createBox(title, content);
	var self = this;
	$j(box).prompt({
		opacity: 20,
		containerCss:{width: '400', height:'300'},
		overlayCss: {
			backgroundColor:'#eee', 
			cursor: 'wait'
		},
		custom_button_evt: true,
		buttons: {OK: IEI_NAS_BUTTON_OK, CANCEL: IEI_NAS_BUTTON_CANCEL},
		onShow:function(dialog) {
			dialog.data.find('#OK_A').focus();
			dialog.data.find('#OK_A').click(function () {
				// call the callback
				if ($j.isFunction(self.callback)) {
					self.callback.apply();
				}
				// close the dialog
				$j.prompt.close();
			});
			dialog.data.find('#CANCEL_A').click(function () {
				$j.prompt.close();
			});
			
		}
	});
};

QNAP.util = {};
QNAP.util.Error = {
	validSystemName: '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-',
	isInputErrorExist: function(el){
                if(el){
                        if (el.nodeType || el.item) { // Node, or NodeList
                                container=el;
                        }
                        if (typeof el === 'string') {//id
                                container=document.getElementById(el);
                        }
                }
                if(container.className.indexOf('x-form-invalid')!=-1)
                        return true;
                else
                        return false;
        },
	showInputError: function(el, error_str, err_div){
                var current_node;
                if(el){
                        if (el.nodeType || el.item) { // Node, or NodeList
                                current_node=el;
                        }
                        if (typeof el === 'string') {//id
                                current_node=document.getElementById(el);
                        }
                }
                var root = current_node.parentNode;
                var error_exist=false;
                var err_container=null;
                if(err_div){
                        if (err_div.nodeType || err_div.item) { // Node, or NodeList
                                err_container=$j(err_div);
                        }
                        if (typeof err_div === 'string') {//id
                                err_container=$j('#'+ err_div);
                        }
                }
                if(err_container){
                        $j(err_container).children('span').each(function(i){
                                if(this.className.indexOf('x-form-invalid-icon')!=-1)
                                error_exist=true;
                        });
                }
                else
                        error_exist=this.isInputErrorExist(current_node);

                if(error_exist){
                        return;
                }
		YAHOO.util.Dom.addClass(current_node, 'x-form-invalid');
                var error_span = $j('<span></span>');
                if(err_container){
                        $j(err_container).append(error_span);
                }
                else{
                        error_span.insertAfter(current_node);
                }
                YAHOO.util.Dom.addClass(error_span, 'x-form-invalid-icon');
                error_span.css('display', 'inline-block');
                error_span.css('left', '5px');
                error_span.css('visibility', 'visible');

                error_span.attr('qtip', error_str);
                error_span.attr('qclass', 'x-form-invalid-tip');
        },
	hideInputError: function(el, err_div){
                var current_node;
                if(el){
                        if (el.nodeType || el.item) { // Node, or NodeList
                                current_node=el;
                        }
                        if (typeof el === 'string') {//id
                                current_node=document.getElementById(el);
                        }
                }
                var root = current_node.parentNode;
                var container;
                var error_exist=false;
                var err_container=null;
                if(err_div){
                        if (err_div.nodeType || err_div.item) { // Node, or NodeList
                                container=$j(err_div);
                        }
                        if (typeof err_div === 'string') {//id
                                container=$j('#'+ err_div);
                        }
                        err_container = container;
                }
                else{
                        container=$j(YAHOO.util.Dom.getNextSibling(current_node));
                }
		if(err_container){
                        $j(err_container).children('span').each(function(i){
                                if(this.className.indexOf('x-form-invalid-icon')!=-1)
                                error_exist=true;
                        });
                }
                else{
                        error_exist=this.isInputErrorExist(current_node);
                }
                if(!error_exist){
                        return;
                }
                YAHOO.util.Dom.removeClass(current_node, 'x-form-invalid');
                if(err_container){
                        err_container.html(''); // Not to remove whole div just empty it.
                }
                else
                        container.remove(); // Remove whole div
        },
	isValidSystemName: function(string) {
		for (var i=0; i< string.length; i++){
			if (this.validSystemName.indexOf(string.charAt(i)) == -1)
				return false;
		}
		return true;		
	}, 
	validateTextInput: function(did, fn){
		$j('#'+did).blur(function(event){
			if(event.keyCode != 9)	//keycode = 9: TAB
				fn(did);	
		});
		$j('#'+did).keyup(function(event){
			if(event.keyCode != 9)	//keycode = 9: TAB
				fn(did);	
		});
	}
};

function q_alert(message, error){
	QNAP.messageBox.alert('&nbsp;', message, error);	
	window.focus();
}

function q_confirm(message, callback){
	QNAP.messageBox.confirm('&nbsp;', message, callback);	
	window.focus();
}

function q_alert_error(message){
	q_alert(message, 1);	
}

