var config = {
	max_play_list:100,
	max_criteria: 10, // set to 0 for no limit
	sort_fields_by_name: false,
	debug: false
}

var criteria = {
	PART_FIELD:    1,
	PART_OPERATOR: 2,
	PART_VALUE:    3,

	FIELD_BOOL:    4,
	FIELD_INT:     5,
	FIELD_STRING:  6,
	FIELD_DATE:    7,

	VALUE_INPUT:   8, // (int, string) a text input
	VALUE_LIST:    9, // (int, string) a limited list of values (codectype, for example)
	VALUE_SPAN:   10, // (date)        a text input and a unit (day, week, ...)

	count: 0,
	new_count: 0,
	old_types: new Array(),

	fields:    null, // an array of fields
	operators: null  // an array of operators for each field type
}

var field_options = ''; // the field <option> tag HTML
var old_value = '';     // the original value of target

/**
* initialization
*
* @return void
*/
function main() {
criteria.fields = new Array(

	{ value: 'bitrate',      label: NIC_ITUNES_STR022 , label2: "NIC_ITUNES_STR022" , type: criteria.FIELD_INT, index: 5 },
	{ value: 'year',         label: NIC_ITUNES_STR021 , label2: "NIC_ITUNES_STR021" , type: criteria.FIELD_INT, index: 4 },

	{ value: 'album',        label: NIC_ITUNES_STR017 , label2: "NIC_ITUNES_STR017" , type: criteria.FIELD_STRING, index: 0 },
	{ value: 'artist',       label: NIC_ITUNES_STR018 , label2: "NIC_ITUNES_STR018" , type: criteria.FIELD_STRING, index: 1 },
	{ value: 'genre',        label: NIC_ITUNES_STR019 , label2: "NIC_ITUNES_STR019" , type: criteria.FIELD_STRING, index: 2 },
	{ value: 'path',         label: NIC_ITUNES_STR020 , label2: "NIC_ITUNES_STR020" , type: criteria.FIELD_STRING, index: 3 },

	/*		{ value: 'codectype',    label: 'Codec Type',  type: criteria.FIELD_STRING,
	values: new Array(
	{ value: 'alac', label: 'Apple Lossless' },
	{ value: 'flac', label: 'FLAC'           },
	{ value: 'mp4a', label: 'AAC'            },
	{ value: 'mpc',  label: 'Musepack'       },
	{ value: 'mpeg', label: 'MP3'            },
	{ value: 'ogg',  label: 'OGG'            },
	{ value: 'wav',  label: 'WAV'            },
	{ value: 'wma',  label: 'WMA'            }
	) },
	*/
	{ value: 'time_added',    label: NIC_ITUNES_STR023 , label2: "NIC_ITUNES_STR023" ,type: criteria.FIELD_DATE, index: 6 }
);

	criteria.operators = new Array();
	criteria.operators[ criteria.FIELD_BOOL ] = new Array(
	{ value: 'is 1', label: 'is true',  type: null },
	{ value: 'is 0', label: 'is false', type: null }
	);
	criteria.operators[ criteria.FIELD_INT ] = new Array(
	{ value: 'is',     label: NIC_ITUNES_STR009 , label2: "NIC_ITUNES_STR009" , type: criteria.VALUE_LIST },
	{ value: '>',     label: NIC_ITUNES_STR011 , label2: "NIC_ITUNES_STR011" , type: criteria.VALUE_INPUT },
	{ value: '<',     label: NIC_ITUNES_STR012 , label2: "NIC_ITUNES_STR012" , type: criteria.VALUE_INPUT }
	);
	criteria.operators[ criteria.FIELD_STRING ] = new Array(
	{ value: 'includes',     label: NIC_ITUNES_STR007 , label2: "NIC_ITUNES_STR007" , type: criteria.VALUE_INPUT},
	{ value: 'not includes', label: NIC_ITUNES_STR008 , label2: "NIC_ITUNES_STR008" , type: criteria.VALUE_INPUT},
	{ value: 'is',            label: NIC_ITUNES_STR009 , label2: "NIC_ITUNES_STR009" , type: criteria.VALUE_LIST},
	{ value: 'not is',        label: NIC_ITUNES_STR010 , label2: "NIC_ITUNES_STR010" , type: criteria.VALUE_LIST}
	);
	criteria.operators[ criteria.FIELD_DATE ] = new Array(
	{ value: '>',    label: NIC_ITUNES_STR013, label2: "NIC_ITUNES_STR013" , type: criteria.VALUE_INPUT },
	{ value: '<',    label: NIC_ITUNES_STR014, label2: "NIC_ITUNES_STR014" ,type: criteria.VALUE_INPUT },
	{ value: 'after',    label: NIC_ITUNES_STR015, label2: "NIC_ITUNES_STR015" , type: criteria.VALUE_SPAN },
	{ value: 'before',    label: NIC_ITUNES_STR016, label2: "NIC_ITUNES_STR016" , type: criteria.VALUE_SPAN }
	);

	criteria.fields = criteria.fields.sort( field_sort_callback_ex );
	/*
	for( var i in criteria.fields ) {
	if( ! criteria.fields[i].label ) {

	if( criteria.fields[i].value.match( /_/ ) ) {
	var words = criteria.fields[i].value.split( "_" );
	for( var j in words ) {
	words[j] = words[j].substring( 0, 1 ).toUpperCase() + words[j].substring( 1 );
	}
	criteria.fields[i].label = words.join( " " );
	} else {
	criteria.fields[i].label = criteria.fields[i].value.substring( 0, 1 ).toUpperCase() + criteria.fields[i].value.substring( 1 );
	}
	}

	if( criteria.fields[i].values ) {
	criteria.fields[i].values = criteria.fields[i].values.sort( field_sort_callback );
	}
	}

	if( config.sort_fields_by_name ) {
	criteria.fields = criteria.fields.sort( field_sort_callback );
	}
	*/
	//alert("main()==>criteria.fields.length=="+criteria.fields.length);
	field_options ="";
	for( var i=0;i<criteria.fields.length;i++ ) 
	{
		//alert("i=="+i)
		field_options += '<option lang="'+criteria.fields[i].label2+'" value="' + criteria.fields[i].value + '" >' + criteria.fields[i].label + '</option>';
	}

	/*	target = ( window.opener ? window.opener : window ).document.getElementsByName( "playlist_spec" )[0];
	if( ! target ) {
	alert( "The playlist criteria textarea could not be found.  (That's bad.)" );
	} else {
	old_value = target.value;
	}
	*/
	if( ! window.addEventListener && document.attachEvent ) 
	{ // an IE fix
		window.addEventListener = function( type, listener, useCapture ) { this.attachEvent( "on" + type, listener ); }
	}
	return true;
}
function chkAvail_rules(id,div)
{
	var criteria_div = document.getElementById( div );
	var criterion_div_Body = criteria_div.tBodies[0];
	var num_criteria = criterion_div_Body.childNodes.length;
	if(num_criteria==1)
	{
		criterion_div_Body.getElementsByTagName("td").item(4).getElementsByTagName("input")[0].disabled=true;
	}
	else
	{
		for(var i=0;i<num_criteria;i++)
		{
			criterion_div_Body.getElementsByTagName("tr")[i].getElementsByTagName("td").item(4).getElementsByTagName("input")[0].disabled=false;
		}
	}
}
/**
* add a new criterion line to the builder form (triggered by a click of the '+' button)
*
* @param string the ID of a criterion DIV that the new DIV will be inserted after
*
* @return bool success
*/
function addCriterion( id , add_div) 
{
	var criteria_div = document.getElementById( add_div );
	var criterion_div_Body = criteria_div.tBodies[0];
	if( ! criteria_div ) 
	{
		return false;
	}

	if( id && id.match && id.match( /c[0-9]+/ ) )
	{
		var ref_criterion_div = document.getElementById( id );
	}
	
	
	var num_criteria = criterion_div_Body.childNodes.length;  //detect the  limit of number of criterion rules
	if( config.max_criteria && num_criteria >= config.max_criteria ) 
	{
		return false;
	}

	if(add_div=="criteria")
	{
		criteria.count++;
		var id = 'c' + ( criteria.count );
	}
	else if(add_div=="criteria_new")
	{
		criteria.new_count++;
		var id = 'ec' + ( criteria.new_count );
	}
	var criterion_div=criterion_div_Body.insertRow(0);
	criterion_div.id = id;
	criterion_div.className = "td_5 td_align_c";
	
	td1=criterion_div.insertCell(0);
	td2=criterion_div.insertCell(1);
	td3=criterion_div.insertCell(2);
	td4=criterion_div.insertCell(3);
	td5=criterion_div.insertCell(4);
		
	//criterion_div.insertCell(0).innerHTML='121';
	td1.innerHTML='<select id="' + id + 'p' + criteria.PART_FIELD + 's" name="'+id+'p'+criteria.PART_FIELD+'s" onchange="populateCriterionOperators(\'' + id + '\');" class="playlist_select2">' + field_options + '</select>';
	td2.innerHTML='<span id="' + id + 'p' + criteria.PART_OPERATOR + '" class="p_field"></span>';
	td3.innerHTML='<span id="' + id + 'p' + criteria.PART_VALUE + '" class="p_field"></span>';
	//new button
	//td4.innerHTML='<a id="'+id+'plusb" onclick="addCriterion(\'' + id + '\', \'' + add_div + '\');" href="#"> <img src="/ajax_obj/images/playlist_add.gif" alt="add" title="add" style="margin-bottom: 0px;padding-bottom: 0px;flat: bottom;"></a>';
	//td5.innerHTML='<a id="'+id+'minorb" onclick="delCriterion(\'' + id + '\', \'' + add_div + '\');" href="#"><img src="/ajax_obj/images/playlist_del.gif" alt="add" title="add" style="margin-bottom: 0px;padding-bottom: 0px;flat: bottom;"></a>';
	td4.innerHTML='<input type="button" id="' + id + 'plusb" value=" + " class="button" onclick="addCriterion(\'' + id + '\', \'' + add_div + '\');"/>';
	td5.innerHTML='<input type="button" id="' + id + 'minorb" value=" -  "  class="button" onclick="delCriterion(\'' + id + '\', \'' + add_div + '\');"/>&nbsp;';	
	
	
	if( ref_criterion_div ) 
	{
	
		criterion_div_Body.insertBefore( criterion_div, ref_criterion_div.nextSibling );
	}
	else
	{
	
		criterion_div_Body.appendChild( criterion_div );
	}
	
	populateCriterionOperators( id );
	
	chkAvail_rules(id,add_div);
	if(add_div == "criteria")
	{
		var divop = document.getElementById('crit_op');
		var divops = document.getElementById('crit_op_single');
	}
	else if(add_div == "criteria_new")
	{
		var divop = document.getElementById('crit_op_new');
		var divops = document.getElementById('crit_op_single_new');
	}
	if(divop)
	{

		if(num_criteria==0)
		{
			divop.style.display='none';
			divops.style.display='block';
			
		}
		if( num_criteria > 0 ) 
		{
			divop.style.display='block';
			divops.style.display='none';
		}
		else
		{
			divop.style.display='none';
		}
	}
	//alert("hello!");
	//multilanguage refresh	
	QNAP.util.RefreshString('lang', 'tab2');
	
	return id;
	
}

/**
* delete an existing criterion
*
* @param string the id of the criterion being deleted
*
* @return bool success
*/
function delCriterion( id, del_div) 
{
	var criterion_div = document.getElementById( id );
	
	if( ! criterion_div )
	{
		return false;
	}
	var criteria_div = criterion_div.parentNode;
	//criteria_div.deleteRow( criterion_div );
	criteria_div.removeChild( criterion_div );
	var num_criteria = criteria_div.childNodes.length;
	chkAvail_rules(id,del_div);
	if(num_criteria == 1)
	{
		if(del_div == "criteria")
		{
			var divop = document.getElementById('crit_op');
			var divops = document.getElementById('crit_op_single');
		}
		else if(del_div == "criteria_new")
		{
			var divop = document.getElementById('crit_op_new');
			var divops = document.getElementById('crit_op_single_new');
		}

		divop.style.display="none";
		divops.style.display="block";
	}
return true;
}

/**
* update the operator <select> of a given criterion based on the field type
*
* @param string the id of the criterion form div (it'll be in the form c[0-9]+)
*
* @return bool success
*/
function populateCriterionOperators( id ) 
{

	var field_type = getCriterionType( id, criteria.PART_FIELD );
	var criterion_operator = document.getElementById( id + 'p' + criteria.PART_OPERATOR );

	if( ! field_type || ! criterion_operator || ! criteria.operators[ field_type ] ) 
	{
		return false;
	}

	if( field_type != criteria.old_types[ id + 'p' + criteria.PART_OPERATOR ] )
	{
		var operator_html = '<select id="' + id + 'p' + criteria.PART_OPERATOR +'s" name="'+id+'p'+criteria.PART_OPERATOR +'s" onchange="populateCriterionValue(\'' + id + '\');" class="p_operator">';
		for( var i =0;i<criteria.operators[ field_type ].length;i++ ) 
		{
			operator_html += '<option lang="'+criteria.operators[ field_type ][i].label2+'" value="' + criteria.operators[ field_type ][i].value + '" >' + criteria.operators[ field_type ][i].label + '</option>';
		}
		operator_html += '</select>';
		criterion_operator.innerHTML = operator_html;
	}

	criteria.old_types[ id + 'p' + criteria.PART_OPERATOR ] = field_type;

	return populateCriterionValue( id );
}

/**
* update the value field(s) of a given criterion based on the operator type
*
* @param string the id of the criterion form div (it'll be in the form c[0-9]+)
*
* @return bool success
*/
function populateCriterionValue( id ) 
{
	var operator_type = getCriterionType( id, criteria.PART_OPERATOR );
	var criterion_value_span = document.getElementById( id + 'p' + criteria.PART_VALUE );
	var value_html = '';

	if( ! operator_type || ! criterion_value_span ) 
	{
		if( ! operator_type ) 
		{
			criteria.old_types[ id + 'p' + criteria.PART_VALUE ] = null;
			criterion_value_span.innerHTML = '';
		}
		return false;
	}
	var isyear = 0;
	var istimeadded = 0;
	var isbitrate = 0;
	switch( operator_type ) 
	{
		case criteria.VALUE_LIST:
		var field_values = getCriterionValues( id );
		if( field_values && field_values.length ) 
		{
			var value_html = '<select class="p_value">';
			for( var i=0;i<field_values.length;i++ ) 
			{
				value_html += '<option lang="'+field_values[i].label2+'" value="' + field_values[i].value + '" >' + field_values[i].label + '</option>';
			}
			value_html += '</select>&nbsp;';
			break;
		}
		else
		{
			operator_type = criteria.VALUE_INPUT;
		}
		case criteria.VALUE_INPUT:
			var mycriterion = document.getElementById( id + 'p' + criteria.PART_FIELD + 's' );
			if(mycriterion.options[ mycriterion.selectedIndex ].value.toString()=="time_added")
			{
				var mycritop = document.getElementById( id + 'p' + criteria.PART_OPERATOR + 's' );
				if(mycritop.options[ mycritop.selectedIndex ].value.toString() == "<" ||
				mycritop.options[ mycritop.selectedIndex ].value.toString() == ">")
				{
					istimeadded=1;
					var mDate = new Date();
					var month = mDate.getMonth()+1
					var aDate = mDate.getDate();
					if(month<10)
					month = '0'+month;
					if(aDate < 10)
					aDate = '0'+aDate;
					var value_html = '<input type="text" id="' + id + 'p' + criteria.PART_VALUE + 't" name="' + id + 'p' + criteria.PART_VALUE + 't" value="'+ mDate.getFullYear() + '-' + month + '-'+ aDate + '"maxlength=64 class="p_text p_value" style="WIDTH:110px;" />';
				}
			}
			else if(mycriterion.options[ mycriterion.selectedIndex ].value.toString()=="year")
			{
				isyear=1;
				var mDate = new Date();
				var value_html = '<input type="text" id="' + id + 'p' + criteria.PART_VALUE + 't" name="' + id + 'p' + criteria.PART_VALUE + 't" value="'+ mDate.getFullYear() + '" class="p_text p_value" />';
			}
			else if(mycriterion.options[ mycriterion.selectedIndex ].value.toString()=="bitrate")
			{
				isbitrate=1;
				var value_html = '<input type="text" maxlength=64 id="' + id + 'p' + criteria.PART_VALUE + 't" name="' + id + 'p' + criteria.PART_VALUE + 't"  class="p_text p_value" style="WIDTH:110px;" />&nbsp; kbps';
			}
			else
			{
				var value_html = '<input type="text" id="' + id + 'p' + criteria.PART_VALUE + 't" name="' + id + 'p' + criteria.PART_VALUE + 't" maxlength=64 class="p_text p_value" />';
			}
			break;
		case criteria.VALUE_SPAN:
			var value_html =
			'<input type="text" id="' + id + 'p' + criteria.PART_VALUE + 't" name="' + id + 'p' + criteria.PART_VALUE + 't" maxlength=64 class="p_sm_text p_value" />' +
			'<select class="sm_p_value p_value" id="' + id + 'p' + criteria.PART_VALUE + 's" name="' + id + 'p' + criteria.PART_VALUE + 's" >' +
			'<option value="day">day</option>' +
			'<option value="week">week</option>' +
			'<option value="month">month</option>' +
			'<option value="year">year</option>' +
			'</select> &nbsp;';
			break;
			/*			case criteria.VALUE_RANGE:
			var value_html =
			'<input type="text" maxlength=64 name="' + id + '" class="sm_text p_value"  />' +
			'<span class="p_value_spacer">to</span>' +
			'<input type="text" maxlength=64 name="' + id + '" class="sm_text p_value" />';
			break;
			*/		
			case null:
			var value_html = '';
			break;
			default:
			config.debug && q_alert( 'unknown operator type: ' + operator_type );
			break;
	}
	if( operator_type != criteria.old_types[ id + 'p' + criteria.PART_VALUE ] || isyear || istimeadded || isbitrate) 
	{
		criterion_value_span.innerHTML = value_html;
	}
		criteria.old_types[ id + 'p' + criteria.PART_VALUE ] = operator_type;
	
	
	return true;
}

/**
* get a field object by value
*
* @param string the value of the criterion field
*
* @return bool|object either false on error or an item from the critera.fields array
*/
function getCriterionFieldByLabel( value ) 
{
	for( var i =0;i<criteria.fields.length;i++ ) 
	{
		if( criteria.fields[i].value.toLowerCase() == value.toLowerCase() ) 
		{
			return criteria.fields[i];
		}
	}
	return false;
}

/**
* get the list of values for a given criterion
*
* @param string the id of the criterion form div (it'll be in the form c[0-9]+)
*
* @return bool|array either false on error, or an array of values
*/
function getCriterionValues( id )
{
	var criterion_select = document.getElementById( id + 'p' + criteria.PART_FIELD + 's' );

	if( ! criterion_select ) {
	return false;
	}

	var field = getCriterionFieldByLabel( criterion_select.value );
	if( field && field.values ) {
	return field.values;
	}
	return false;
}

/**
* get a field or operator type for a given criterion
*
* @param string the id of the criterion form div (it'll be in the form c[0-9]+)
* @param int the part to get the type of (one of the criteria.PART_* constants)
*
* @return bool|int either false on error, or one of the criteria.(FIELD|OPERATOR)_* type constants
*/
function getCriterionType( id, part )
{
	var criterion_select = document.getElementById( id + 'p' + part + 's' );

	if( ! criterion_select ) 
	{
		return false;
	}

	return getPartTypeByLabel( id, part, criterion_select.options[ criterion_select.selectedIndex ].text );
}

/**
* get the the type of a criterion part by one of the <select> box labels
*
* @param string the id of the criterion form div (it'll be in the form c[0-9]+)
* @param int the part to get the type of (one of the criteria.PART_* constants)
* @param string the label of the part
*
* @return bool|int either false on error, or one of the criteria.(FIELD|OPERATOR)_* type constants
*/
function getPartTypeByLabel( id, part, label ) 
{
	
	if( part == criteria.PART_FIELD ) 
	{
		for( var i=0;i<criteria.fields.length;i++ )
		{
			if( criteria.fields[i].label == label ) 
			{
				return criteria.fields[i].type;
			}
		}
		return false;
	} 
	else if( part == criteria.PART_OPERATOR && criteria.operators[ getCriterionType( id, criteria.PART_FIELD ) ] ) 
	{
		var field_type = getCriterionType( id, criteria.PART_FIELD );
		for( var i =0;i<criteria.operators[ field_type ].length;i++ )
		{
			if( criteria.operators[ field_type ][i].label == label ) 
			{
				return criteria.operators[ field_type ][i].type;
			}
		}
	}
	
	return false;
}

/**
*
*/
function field_sort_callback( a, b ) 
{
	if( a.label < b.label ) 
	{
		return -1
	} 
	else if( a.label > b.label ) 
	{
		return 1;
	} 
	else
	{
		return 0;
	}
}

/**
*
*/
function field_sort_callback_ex( a, b ) 
{
	if( a.index < b.index ) 
	{
		return -1
	} 
	else if( a.index > b.index ) 
	{
		return 1;
	} 
	else
	{
		return 0;
	}
}

/**
* update the target (probably a <textarea> with the current playlist as text
*/

function updatePlaylist() 
{
	q_alert("UpdatePlaylist");
}

/**
* convert the builder form into daapd playlist format
*
* @return string the playlist text
*/
/*
function generatePlaylist() {
var playlist_text = "";

if( document.getElementById( "and_or" ) ) {
var and_or = " " + ( document.getElementById( "and_or" ).value == "and" ? "AND" : "OR" );
}

var criteria_divs = document.getElementById( 'criteria' ).getElementsByTagName( 'div' );

for( var i = 0, j = 0; i < criteria_divs.length; i++ ) {
if( criteria_divs[i].id && criteria_divs[i].id.match( /^c[0-9]+$/ ) ) {
playlist_text += ( j++ > 0 ? and_or + "\n" : "" );

var criterion_id = criteria_divs[i].id;

playlist_text += getElementsByClassName( criteria_divs[i], "p_field" )[0].value;
playlist_text += " " + getElementsByClassName( criteria_divs[i], "p_operator" )[0].value;

switch( getCriterionType( criteria_divs[i].id, 1 ) ) {
case criteria.FIELD_BOOL:
break;
case criteria.FIELD_DATE:
switch( getCriterionType( criteria_divs[i].id, 2 ) ) {
case criteria.VALUE_INPUT:
playlist_text += " " + getElementsByClassName( criteria_divs[i], "p_value" )[0].value;
break;
case criteria.VALUE_SPAN:
var value = getElementsByClassName( criteria_divs[i], "p_value" )[0].value;
var unit = getElementsByClassName( criteria_divs[i], "p_value" )[1].value
playlist_text += " " + value + " " + unit + ( value == 0 || value > 1 ? "s" : "" ) + " before today";
break;
}
break;
case criteria.FIELD_INT:
playlist_text += " " + getElementsByClassName( criteria_divs[i], "p_value" )[0].value;
break;
case criteria.FIELD_STRING:
playlist_text += " \"" + getElementsByClassName( criteria_divs[i], "p_value" )[0].value + "\"";
break;
}
}
}

return playlist_text;
}
*/
/**
* recursively get elements that of a certain CSS class
*
* @param element the node at which to start searching
* @param string the CSS class name
*
* @return Array an array of nodes
*/
function getElementsByClassName( node, className ) 
{
	if( typeof node != "object" || ! node.nodeType || node.nodeType != 1 || ! node.childNodes )
	{
		return matches;
	}
	var children = node.getElementsByTagName( '*' );
	var elements = new Array();

	for( var i = 0; i < children.length; i++ ) 
	{
		var child = children[i];
		var classNames = child.className.split( ' ' );
		for( var j = 0; j < classNames.length; j++ ) 
		{
			if( classNames[j].toLowerCase() == className.toLowerCase() ) 
			{
				elements.push( child );
				break;
			}
		}
	}

return elements;
}

/**
* reset the critera back to a single criterion
*
* @return bool success
*/
function resetCriteria(div)
{
	return ( clearCriteria(div) && addCriterion('c1',div) );
}

/**
* clear all criteria
*/
function clearCriteria(clear_div) 
{
	var criteria_div = document.getElementById( clear_div );
	if( ! criteria_div ) 
	{
		return false;
	} 
	else 
	{
		
		var ocriteria_div_bodies = criteria_div.tBodies[0];
		//alert("ocriteria_div_bodies=="+ocriteria_div_bodies.rows.length);
		try { // Firefox
				ocriteria_div_bodies.innerHTML = "";
			} 
		catch (e) 
		{ // IE
			while (ocriteria_div_bodies.rows.length > 0)
				ocriteria_div_bodies.deleteRow(0);
		}
		if(clear_div=="criteria")
		{
			criteria.count = 0;
		}
		else if(clear_div=="criteria_new")
		{
			criteria.new_count = 0;
		}

		criteria.old_types = new Array();
		return true;
	}
}

/**
* load a playlist from it's text definition
*
* @param string the playlist definition to parse
*
* @return bool success
*/
/*
function loadPlaylist( playlist_text ) {
if( ! playlist_text || ! clearCriteria() ) {
return false;
}

var criteria_text = playlist_text.split( /\s+(?:AND|OR|&&|\|\|)\s+/ );

var success = true;
for( i in criteria_text ) {
var criterion_id = addCriterion();

var field = criteria_text[i].replace( /^([^\s]+).*$/, '$1' );
var operator = criteria_text[i].replace( /^[^\s+]+\s([^0-9"]+).*$/, '$1' ).replace( /(^\s+|\s+$)/, '' );

if( ! field ||
! setCriterionField( criterion_id, field ) ||
! populateCriterionOperators( criterion_id ) ||
! setCriterionOperator( criterion_id, operator ) ) {
success = false;
} else {

}
}

updatePlaylist();

return success;
}
*/
/**
* set a criterion's field by field name
*
* @param string the id of the criterion to set
* @param string the field to select
*
* @return bool success
*/
function setCriterionField( id, field )
{
	var criterion_select = document.getElementById( id + 'p' + criteria.PART_FIELD + 's' );
	if( ! criterion_select || ! criterion_select.options ) 
	{
		return false;
	}

	for( i in criterion_select.options ) 
	{
		if( criterion_select.options[i].value.toLowerCase() == field.toLowerCase() ) 
		{
			criterion_select.options[i].selected = true;
			return true;
		}
	}

	return false;
}

/**
* set a criterion's operator by value
*
* @param string the id of the criterion to set
* @param string the operator value to select
*
* @return bool success
*/
function setCriterionOperator( id, operator ) 
{
	var criterion_select = document.getElementById( id + 'p' + criteria.PART_OPERATOR + 's' );
	if( ! criterion_select || ! criterion_select.options ) 
	{
		return false;
	}
	for( i in criterion_select.options ) 
	{
		if( typeof criterion_select.options[i] == "object" &&
		criterion_select.options[i].value.toLowerCase() == operator.toLowerCase() ) 
		{
			criterion_select.options[i].selected = true;
		return true;
		}
	}
	return false;
}

/**
* reset the target (probably a <textarea>) with the original playlist text and close the popup
*/
/*
function cancel() {
target.value = old_value;
window.opener && window.close();
}
*/
/**
* update the target with the playlist text and close the window
*/
/*
function save() {
updatePlaylist();
window.opener && window.close();
}*/