<?php

$AS_Setting = array(
	conf => '/etc/config/androidstation.conf',
	enable => 0,
	resolution => 'Auto',
	dpi => 'Theater',
	enable_as_share => 0,
	as_share => 'android',
	sid => '',
	credential => 'local',
	account => '',
	usr_id => 0,
	is_admin => 0,
	ip => '',
	login_user => ''
);

$ret_array = array(
	ret_code => 0,
	msg => '',
	authPassed => 0
);

function getClientIP()
{
	static $realip = NULL;

	if ($realip !== NULL )
    	return $realip;

	if (isset($_SERVER))
  	{
	    if (isset($_SERVER['HTTP_X_FORWARDED_FOR']))
	    {
	      $arr = explode(',', $_SERVER['HTTP_X_FORWARDED_FOR']);

	      foreach ($arr AS $ip)
	      {
	        $ip = trim($ip);

	        if ($ip != 'unknown')
	        {
	          $realip = $ip;
	          break;
	        }
	      }
	    } else if (isset($_SERVER['HTTP_CLIENT_IP'])) {
	      	$realip = $_SERVER['HTTP_CLIENT_IP'];
	    } else {
	      if (isset($_SERVER['REMOTE_ADDR']))
	        $realip = $_SERVER['REMOTE_ADDR'];
	      else
	        $realip = '0.0.0.0';
	    }
  	} else {
	    if (getenv('HTTP_X_FORWARDED_FOR'))
	      $realip = getenv('HTTP_X_FORWARDED_FOR');
	    elseif (getenv('HTTP_CLIENT_IP'))
	      $realip = getenv('HTTP_CLIENT_IP');
	    else
	      $realip = getenv('REMOTE_ADDR');
  	}

  preg_match("/[\d\.]{7,15}/", $realip, $onlineip);
  $realip = !empty($onlineip[0]) ? $onlineip[0] : '0.0.0.0';

  return $realip;
}

function getHTTPValue($n, $default='')
{
	if(isset($_POST[$n]))
		return $_POST[$n];
	if(isset($_GET[$n]))
		return $_GET[$n];

	return $default;
}

function isG()
{
	return file_exists("/etc/IS_G")? true:false;
}

function filesize_ex($filename)
{
	$filename = escapeshellarg($filename);
	return trim(`stat -c%s -L $filename`);
}

//converts "/uxxxx" strings back to its UTF-8 characters
//if we ever upgrade to 5.4, we can use option 'JSON_UNESCAPED_UNICODE' instead
function qnap_json_encode($config)
{
	$version = explode('.', PHP_VERSION);
	$PHP_VERSION_ID = ($version[0] * 10000 + $version[1] * 100 + $version[2]);

	if($PHP_VERSION_ID > 50400) {
		if(DEBUG){
			return json_encode($config, JSON_UNESCAPED_UNICODE|JSON_PRETTY_PRINT);
		}else{
			return json_encode($config, JSON_UNESCAPED_UNICODE);
		}
	}else{
		return preg_replace("/\\\\u([a-f0-9]{4})/e", "iconv('UCS-4LE','UTF-8',pack('V', hexdec('U$1')))", json_encode($config));
	}
}

function printOutput($input)
{
	if(!DEBUG){
		unset($input['Queries']);
		unset($input['commands']);
	}

	$version = getHTTPValue('api', 'v1');
	if($version=='v2'){
		_style_normalization($input, $normalizedOutput);
		$input = $normalizedOutput;
	}

	$json = getHTTPValue('json','0');

	if($json){
		$jsonCallback = getHTTPValue('callback','');
		if(!empty($jsonCallback) && preg_match('/[^0-9a-zA-Z\$_]+/', $jsonCallback)){
			headerUnauthorized('Invalid callback name - alpha numeric values only');
			exit();
		}

		if(empty($jsonCallback)){
			header('Content-type: application/json;charset=utf-8');
			echo qnap_json_encode($input);
		}else{
			header('Content-type: application/javascript;charset=utf-8');
			echo $jsonCallback.'('.qnap_json_encode($input).')';
		}
	}else{
		header('Content-type: text/xml;charset=utf-8');
		$output = new SimpleXMLElement('<QDocRoot version="1.0"></QDocRoot>');
		_array_to_xml($input, $output);
		echo $output->asXML();
	}
}

function _style_normalization(&$arrayInput, &$output)
{
	foreach($arrayInput as $key => $value) {
		$key = strtolower(preg_replace('/(?<!^)([A-Z])/', '_$1', $key));
		if(is_array($value)) {
			$output[$key] = array();
			_style_normalization($value, $output[$key]);
		}else{
			$output[$key] = $value;
		}
	}
}

function _array_to_xml(&$arrayInput, &$xml)
{
	foreach($arrayInput as $key => &$value) {
		if(is_array($value)) {
			if(!is_numeric($key)){
				$subnode = $xml->addChild("$key");
				_array_to_xml($value, $subnode);
			}else{
				_array_to_xml($value, $xml);
			}
		}else{
			if(is_numeric($value)){
				$xml->addChild("$key", "$value");
			}else{
				$value = str_replace('&', '&amp;', $value);
				if($value != '') $xml->addChild("$key", "$value");
			}
		}
	}
}

/**
* Send a GET requst using cURL
* @param string $url to request
* @param array $get values to send
* @param array $options for cURL
* @return string
*/
function curl_get($url)
{
	$opts = array(
	CURLOPT_URL => $url. (strpos($url, '?') === FALSE ? '?' : ''),
	CURLOPT_HEADER => 0,
	CURLOPT_RETURNTRANSFER => TRUE,
	CURLOPT_TIMEOUT => 5,
	CURLOPT_HTTPHEADER => array('X-Forwarded-For: '.$_SESSION['ip'].', '.$_SERVER['SERVER_ADDR'])
	);

	$ch = curl_init();
	curl_setopt_array($ch, $opts);
	if( ! $result = curl_exec($ch))
	{
		trigger_error(curl_error($ch));
	}
	curl_close($ch);
	return $result;
}

function sid_is_valid($sid)
{
	global $AS_Setting;
	
	$AS_Setting['ip'] = getClientIP();
	$port = exec('/bin/cat /var/lock/._thttpd_.port');
	if(isset($sid)){
		$auth_by = 'qts';
		$loginURL = "http://127.0.0.1:".$port."/cgi-bin/authLogin.cgi?sid=".$sid."&service=100&remote_ip=".$AS_Setting['ip'];
	}
	else{
		$ret[STATUS_TAG] = STATUS_FAIL;
		$ret['msg'] = 'session failed.';
		return $ret;
	}

	$result = curl_get($loginURL);
	$xml = simplexml_load_string($result);
	$namespaces = $xml->getNameSpaces(true);
	$root = $xml->children($namespaces['QDocRoot']);
	if((int)$root->authPassed == 1 && (int)$root->userid >= 0){
		$AS_Setting['credential'] = 'local';
		$AS_Setting['account'] = (string)$root->username;
		$AS_Setting['usr_id'] = (int)$root->userid;
		$AS_Setting['is_admin'] = (int)$root->isAdmin;
		$ret[STATUS_TAG] = STATUS_SUCCESS;
	}else{
		$ret[STATUS_TAG] = STATUS_FAIL;
		$ret['msg'] = 'authentication failed.';
	}
	return $ret;
}

function cmd_to_android_station($action, $in2='', $in3='')
{
	$cmd = '/etc/init.d/AS.sh';
	if(file_exists($cmd)){
		$command = $cmd.' '.$action.' '.$in2.' '.$in3;
		$ret = exec( $command );
	}
	return $ret;
}

function restore_to_default()
{
	$ret = exec( '(/etc/rcK.d/K44android_serv.sh stop; /bin/sleep 1; /etc/init.d/android_serv.sh reset) &' );
	return 0;
}

function restart_as()
{
	if(is_android_ready() == 0){
		exec('/sbin/setcfg "AndroidStation" "Enable" "1"');
		sleep(1);
	}
	else {
		$ret = exec( '/etc/rcK.d/K44android_serv.sh stop' );
		sleep(5);
	}
	$ret = exec( '/etc/init.d/android_serv.sh start &' );
	sleep(15);
	return 0;
}

function enable_as()
{
	$ret = exec( '/sbin/setcfg "AndroidStation" "Enable" "1"');
	if(is_android_ready() == 0){
		$ret = exec( '/etc/init.d/android_serv.sh start &' );
		sleep(15);
	}
	return 0;
}

function disable_as()
{
	$ret = exec( '/sbin/setcfg "AndroidStation" "Enable" "0"');
	if(is_android_ready() == 1){
		$ret = exec( '/etc/rcK.d/K44android_serv.sh stop &' );
		sleep(5);
	}
	return 0;
}

function is_android_ready()
{
	return  file_exists("/tmp/android_ready") ? 1 : 0;
}

function get_android_login_user()
{
	$cmd = '/usr/sbin/chroot /android /system/bin/getprop rtk.tas.api.username';
	return exec($cmd);
}

function get_as_settings()
{
	global $AS_Setting, $ret_array;
	$AS_Setting['enable'] = is_android_ready();
	$cmd = '/usr/sbin/chroot /android /system/bin/getprop rtk.tas.tv_system';
	$return_resolution = exec($cmd);
	switch($return_resolution){
		case "3":
			$AS_Setting['resolution'] = "480p";
			break;
		case "4":
			$AS_Setting['resolution'] = "576p";
			break;
		case "5":
			$AS_Setting['resolution'] = "720p@50Hz";
			break;
		case "6":
			$AS_Setting['resolution'] = "720p@60Hz";
			break;
		case "7":
			$AS_Setting['resolution'] = "1080i@50Hz";
			break;
		case "8":
			$AS_Setting['resolution'] = "1080i@60Hz";
			break;
		case "9":
			$AS_Setting['resolution'] = "1080p@50Hz";
			break;
		case "10":
			$AS_Setting['resolution'] = "1080p@60Hz";
			break;
		case "0":
		default:
			$AS_Setting['resolution'] = "Auto";
			break;
	}
	$cmd = '/usr/sbin/chroot /android /system/bin/getprop ro.sf.lcd_density';
	$return_dpi = exec($cmd);
	switch($return_dpi){
		case "240":
			$AS_Setting['dpi'] = "Desktop";
			break;
		case "160":
		default:
			$AS_Setting['dpi'] = "Theater";
			break;
	}
	$cmd = ' /usr/sbin/chroot /android /system/bin/getprop android.runtime.sharefolder';
	$AS_Setting['as_share'] = exec($cmd);
	if($AS_Setting['as_share'] == ""){
		$AS_Setting['as_share'] = "Android";
	}
	$AS_Setting['enable_as_share'] = 1;
	$AS_Setting['login_user'] = get_android_login_user();

	$ret_array['enable'] = $AS_Setting['enable'];
	$ret_array['resolution'] = $AS_Setting['resolution'];
	$ret_array['dpi'] = $AS_Setting['dpi'];
	$ret_array['enable_as_share'] = $AS_Setting['enable_as_share'];
	$ret_array['as_share'] = $AS_Setting['as_share'];
	$ret_array['login_user'] = $AS_Setting['login_user'];
	return 0;
}

function conf_to_as()
{
	global $AS_Setting;
	get_as_settings();
	if($AS_Setting['enable'] == 0)
		cmd_to_android_station('start');
	else
		cmd_to_android_station('stop');
	cmd_to_android_station('ch_resolution', $AS_Setting['resolution']);
	cmd_to_android_station('ch_dpi', $AS_Setting['dpi']);
	if($AS_Setting['enable_as_share'] != 0){
		cmd_to_android_station('as_share_folder', $AS_Setting['as_share']);
	}
	return 0;
}

function set_as_settings()
{
	global $AS_Setting, $ret_array;

	$enable_as = getHTTPValue('enable_as', '');
	if($enable_as != ''){
		$AS_Setting['enable'] = (int)$enable_as;
		$cmd = '/sbin/setcfg "AndroidStation" "Enable" '.$AS_Setting['enable'].' -f '.$AS_Setting['conf'];
		exec($cmd);
		if((is_android_ready() == 1) && ($AS_Setting['enable'] == 0))
			cmd_to_android_station('stop');
		else if((is_android_ready() == 0) && ($AS_Setting['enable'] == 1))
			cmd_to_android_station('start');
	}
	return;
}

function is_permission_allow($user)
{
	$out_str = array();
	$out_ret = -1;
	$disable_str = array();
	$disable_ret = 1;
	$user_arg = escapeshellarg($user);
	$cmd = "/sbin/appriv -C -r 1 -n $user_arg";
	exec($cmd, $out_str, $out_ret);
	$cmd = '/sbin/user_status show "'.$user_arg.'" | cut -d":" -f 2';
	exec($cmd, $disable_str, $disable_ret);
	if($disable_str[0] == "0"){
		$out_ret = -1;
	}
	return $out_ret;
}

function get_user_list()
{
	global $AS_Setting, $ret_array;
	$as_user_count = 0;
	$as_user_list = array();

	$cmd = '/sbin/user_cmd -u';
	exec($cmd, $nas_user_list, $out_ret);
	$user_count = count($nas_user_list);

	foreach($nas_user_list as $key => $value) {
		$out_ret = is_permission_allow($value);
		if($out_ret == 0){
			$as_user_list[]['user'] = $value;
			$as_user_count++;
		}
	}
	$ret_array['as_user_count'] = $as_user_count;
	$ret_array['user_list'] = $as_user_list;
	return $as_user_count;
}

function update_user_to_list()
{
	$login_user = get_android_login_user();
	$do_retart = 0;
	$_ret = 0;
	$auser = getHTTPValue('auser','');
	if(is_array($auser)){
		foreach($auser as $oneuser){
			$out_ret = is_permission_allow($oneuser);
			if($out_ret != 0){
				$oneuser_arg = escapeshellarg($oneuser);
				$cmd = "/sbin/appriv -U -r 1 -n $oneuser_arg";
				$out_str = array();
				$out_ret = -1;
				exec($cmd, $out_str, $out_ret);
				$_ret = $out_ret;
			}
		}
	}
	else if($auser != ''){
		$out_ret = is_permission_allow($auser);
		if($out_ret != 0){
			$auser_arg = escapeshellarg($auser);
			$cmd = "/sbin/appriv -U -r 1 -n $auser_arg";
			$out_str = array();
			$out_ret = -1;
			exec($cmd, $out_str, $out_ret);
			$_ret = $out_ret;
		}
	}
	$duser = getHTTPValue('duser','');
	if(is_array($duser)){
		foreach($duser as $oneuser){
			$oneuser_arg = escapeshellarg($oneuser);
			$cmd = "/sbin/appriv -U -r 0 -n $oneuser_arg";
			$out_str = array();
			$out_ret = -1;
			exec($cmd, $out_str, $out_ret);
			$_ret = $out_ret;
			if(($login_user != '')&&($login_user == $oneuser)&&($oneuser != 'admin')){
				$do_retart = 1;
			}
		}
	}
	else if($duser != ''){
		$duser_arg = escapeshellarg($duser);
		$cmd = "/sbin/appriv -U -r 0 -n $duser_arg";
		$out_str = array();
		$out_ret = -1;
		exec($cmd, $out_str, $out_ret);
		$_ret = $out_ret;
		if(($login_user != '')&&($login_user == $duser)&&($duser != 'admin')){
			$do_retart = 1;
		}
	}
	if((is_android_ready()==1)&&($do_retart == 1)){
		restart_as();
	}
	return $_ret;
}

function add_user_to_list()
{
	$user = getHTTPValue('user','');
	if(is_array($user)){
		foreach($user as $oneuser){
			$out_ret = is_permission_allow($oneuser);
			if($out_ret != 0){
				$oneuser_arg = escapeshellarg($oneuser);
				$cmd = "/sbin/appriv -A -r 1 -n $oneuser_arg";
				$out_str = array();
				$out_ret = -1;
				exec($cmd, $out_str, $out_ret);
			}
		}
	}
	return $out_ret;
}

function del_user_from_list()
{
	$login_user = get_android_login_user();
	$do_retart = 0;
	$user = getHTTPValue('user','');
	if(is_array($user)){
		foreach($user as $oneuser){
			$oneuser_arg = escapeshellarg($oneuser);
			$cmd = "/sbin/appriv -U -r 0 -n $oneuser_arg";
			$out_str = array();
			$out_ret = -1;
			exec($cmd, $out_str, $out_ret);
			if(($login_user == $oneuser)&&($oneuser != 'admin')){
				$do_retart = 1;
			}
		}
	}
	if((is_android_ready()==1)&&($do_retart == 1)){
		restart_as();
	}
	return $out_ret;
}

function cgi_main()
{
	global $AS_Setting, $ret_array;

	$AS_Setting['sid'] = getHTTPValue('sid','');
	$ret = sid_is_valid($AS_Setting['sid']);
	if($ret[STATUS_TAG] == STATUS_FAIL){
		$ret_array['ret_code'] = $ret[STATUS_TAG];
		$ret_array['msg'] = $ret['msg'];
		$ret_array['authPassed'] = 0;
		printOutput($ret_array);
		exit(1);
	}

	$action = getHTTPValue('action','get_settings');
	switch($action){
		case 'get_user_list':
		$ret_array['ret_code'] = get_user_list();
		break;
		case 'user_update':
		$ret_array['ret_code'] = update_user_to_list();
		break;
		case 'add_user':
		$ret_array['ret_code'] = add_user_to_list();
		break;
		case 'del_user':
		$ret_array['ret_code'] = del_user_from_list();
		break;
		case 'restart':
		$ret_array['ret_code'] = restart_as();
		break;
		case 'enable_as':
		$ret_array['ret_code'] = enable_as();
		break;
		case 'disable_as':
		$ret_array['ret_code'] = disable_as();
		break;
		case 'set_settings':
		$ret_array['ret_code'] = set_as_settings();
		break;
		case 'get_settings':
		$ret_array['ret_code'] = get_as_settings();
		break;
		case 'restore_to_default':
		$ret_array['ret_code'] = restore_to_default();
		break;
		default:
		$ret_array['ret_code'] = STATUS_FAIL;
		$ret_array['msg'] = 'Invaild action.';
		break;
	}
	$ret_array['authPassed'] = 1;
	printOutput($ret_array);
}

cgi_main();
?>
