var PARENT_WIN = window.opener || window.parent;
window.app = PARENT_WIN.os.getAppInstancesByAppId('MediaViewer')[0];
window.URL_RANDOM_NUM = PARENT_WIN.URL_RANDOM_NUM;

function domLoaded() {
if (window.opener) {
UI.addEvent(window.opener, 'beforeunload', function() {
window.close();
});
UI.addEvent(window.opener, 'unload', function() {
window.close();
});
UI.addEvent(window, 'focus', function() {
UI.testFlash();
});
}
window.qMessageClient = new QMessageClient();
window.UBUNTU_HOME_PATH = PARENT_WIN.os.file.getSysSetting().ubuntu_home_path;
UI.initUI();
UI.initEvent();
UI.updateUITip();
var app = window.app;
var cfg = app.viewerCfg;

if (!cfg) {
return;
}

var sid = Ext.util.Cookies.get('TMP_SID') || UI.getCookie('NAS_SID') || UI.getCookie('QFS_SID');
if (PARENT_WIN.os.desktop){
cfg.isSinglePage = false;
}else{
cfg.isSinglePage = true;
}
UI.setSinglePage(cfg.isSinglePage);
if (cfg.list){
UI.setListPath(cfg.list);
}
if (cfg.jsonp){
UI.useJsonp();
}

UI.setRttString(PARENT_WIN._S._SFE_LANG_ON_THE_FLY_TRANSCODING);
UI.setSid(sid);
UI.setPath(cfg.path);
UI.setFile(cfg.file);
if (cfg.filePath){
var tmpPath = cfg.filePath.split('/');
cfg.file = tmpPath.pop();
cfg.path = tmpPath.join('/');
UI.setFile(cfg.file);
UI.setPath(cfg.path);
}

UI.setSupportRTT(cfg.supportRTT && PARENT_WIN.QNAP.QOS.user.isAdminGroup);
UI.setSupportNMP(PARENT_WIN.QNAP.QOS.user.isAdminGroup);
UI.setSort(cfg.sort);
UI.setSortDir(cfg.dir);
UI.showHdMenu(cfg.hideQtMenu !== true);

if (cfg.force_vq) {
UI.setDefaultQuilty(cfg.force_vq, false);
} else if (window.localStorage) {
UI.setDefaultQuilty(window.localStorage['video_play_res'] || '');
}

UI.setMmCodex(cfg.mmCodex);

switch (cfg.type) {
case 'isAudio':
UI.setType(Viewer.MEDIA_TYPE.AUDIO);
break;
case 'isVideo':
UI.setType(Viewer.MEDIA_TYPE.VIDEO);
break;
case 'isPhoto':
UI.setType(Viewer.MEDIA_TYPE.PHOTO);
break;
}

/**
* FOLDER = folder path
* FILE   = file path
* LOCAL_LIST_L = local file list, files in local nas, get file meta dat by file station cgi
* URL_LIST = internet file list, need all path, like thumb content download ..etc
*/
UI.setDataSrc(cfg.dataSrc);
app.viewerCfg.viewerIsOpened=true;
}

UI = (function() {
var MEDIA_TYPE = Viewer.MEDIA_TYPE;

/**
* List type
* @type {String}
* FOLDER - file station
* FILE -
* LOCAL_LIST_L - List load path at the same domain and use file station cgi get media info of list files
* LOCAL_LIST_U - List load path at the same domain and media info include in list data
* URL_LIST_L - List load path at different domain and use file station cgi get media info of list files
* URL_LIST_U - List load path at different domain and media info include in list data
*/
var FOLDER = 'FOLDER',
FILE = 'FILE',
LOCAL_LIST_L = 'LOCAL_LIST_L',
LOCAL_LIST_U = 'LOCAL_LIST_U',
URL_LIST_L = 'URL_LIST_L',
URL_LIST_U = 'URL_LIST_U';

var IMG = {
PAUSE: '/cgi-bin/apps/mediaViewer/images/pause.png',
PLAY: '/cgi-bin/apps/mediaViewer/images/play_icon.png',
DEF_VIDEO_THUMB: '/v3_menu/pic/s100video.png',
DEF_AUDIO_THUMB: '/v3_menu/pic/s100music.png',
DEF_PHOTO_THUMB: '/v3_menu/pic/s100photo.png'
};

var supportAddEventListener = window.addEventListener,
supportAttachEvent = window.attachEvent,
supportJSONParse = JSON.parse,
supportFlash = DetectFlashVer(9),
supportNMP = false;

var notify = new(Ext.extend(Ext.util.Observable, {
constructor: function(config) {
this.addEvents({
"startautoplay": true,
"stopautoplay": true
});
this.superclass.constructor.call(this, config)
}
}));

var userAgent = window.navigator.userAgent.toLowerCase(),
isIE = /msie /i.test(userAgent) || (/trident\/7\.0;/i.test(userAgent) && / rv:11/i.test(userAgent)),
app = window.app;

var CGI_PATH = '/cgi-bin/filemanager/utilRequest.cgi';

var ID = {
CURTAIN: 'curtain',
MEDIA_CONTAINER: 'mediacontainer',
INSTALL_EL: 'flashInsatll',
CTRL_BAR: 'controlBar',
BACK_BTN: 'backward',
PLAY_BTN: 'play',
FORW_BTN: 'forward',
TOP_TOOL: 'topTool',
BOTTOM_TOOL: 'bottomTool',
PREV_BTN: 'prevPage',
NEXT_BTN: 'nextPage',
HIDE_LIST_BTN: 'hideList',
STREAM_BTN: 'streamBtn',
DEVICE_LIST_MENU: 'deviceListMenu',
DEVICE_LIST_MENU_HEAD: 'deviceListMenuHead',

PLAY_BTN_2: 'play-id',
PAUSE_BTN_2: 'pause-id',
ROT_LEFT_BTN: 'rotLeftBtn', // rotate left
ROT_RIGHT_BTN: 'rotRightBtn', // rotate right
MENU_ROT_LEFT_BTN: 'menu-rotLeftBtn', // topbar more menu rotate left
MENU_ROT_RIGHT_BTN: 'menu-rotRightBtn', // topbar more menu rotate right
PREV_BTN_2: 'prevBtn',
NEXT_BTN_2: 'nextBtn',
DOWNLOAD_BTN: 'downloadBtn',
DEL_BTN: 'delBtn',
TOGGLE_BTN: 'toggleBtn',
CC_BTN: 'ccBtn',
CC_ON:'ccOn',
CC_OFF:'ccOff',
SLIDE_BTN: 'slideBtn',
FULL_SCRN_BTN: 'fullScrn-id',
EXIT_FULL_BTN: 'exitFullScrn-id',
SLIDESHOW_BTN: 'slideBtn',
LIST_BOX: 'list-box',
NAV_AUTOPLAY: 'navAutoPlay',
NAV_NEXT: 'navNext',
STREAMING_COMBO:'streamingCombo',
TRANSCODING_COMBO:'transcodingCombo',
RESOLUTION_MENU:'resolutionMenu',
SUBTITLE_MENU:'subtitleMenu',
VOLUME_MENU:'volumeMenu'
},
IMG_MAP = {};
var listMap = [],
list = {
items: [{
fileName: 'abc.avi',
thumbnail: IMG.DEF_VIDEO_THUMB,
size: '999',
length: '555'
}]
},
maskMap = {},
qualityMap = {
'1080': 0,
'720': 1,
'480': 2,
'360': 3,
'240': 4,
'original': 5,
'rtt': 6
},
resolutionList = ['1080', '720', '480', '360', '240'],
qualityLevel = [];

list = {
items: []
};

var path, sort, direction, sid, player, mmCodex,
/**
* 目前檢查中的檔案index
* --
*/
currentPlay = '--',
file,
/**
* 檔案總數
*/
totalCount,
totalPage,
currentPage,
pageLimit = 10,
type, supportRTT, hideListDelay,
idCount = 0,
lastPlayEl, currentIndeNum, isAutoPlay, fileData,
upDateCount = 0,
defaultQuilty = '1080',
currentQuilty = '1080',
rttString, loading = false,
listVisible = false,
/**
* 記錄目前清單中最大的編號
* @type {Number}
*/
maxNode = 0,
/**
* 記錄目前清單中最小的編號
* @type {Number}
*/
minNode = 0,
/**
* scroll animation
*/
scrollAnim,
/**
* setTimeout flag
*/
autoPlayFlag,
os = PARENT_WIN.os,
/**
* jwplayer is ready flag
*/
jwplayerIsready,
showHdMenu,
/**
* jwplayer last postition
* @type {Number}
*/
lastPosition = 0,
/**
* subtitlePosition
* @type {Number}
*/
subtitlePosition = 0,
/**
* jwplayer last volume, 0-100
* @type {Number}
*/
lastVolume = false,
firstTimePlay = false,
isSinglePage = false,
dataSrc = '',
/**
* remote list path
* @type {String}
*/
listPath='',
method = 'ajax';

/**
* Ext conpoment
*/
var playerControlBar;

var streamCfg = {
max: 10
};

var listStore = new Ext.data.ArrayStore({
autoDestroy: true,
fields: [
{
name: 'fn',
convert: null
}, {
name: 'tl',
convert: null
}, {
name: 'ts',
convert: null
},{
name : 'width',
convert: null
},
{
name: 'height',
convert: null
},
{
name: 'du',
convert: null
},
{
/**
* [file type] type : Number
* 1 = Audio
* 2 = Video
* 3 = Photo
*/
name: 'ft',
convert: null
},
{
name: 'url',
convert: null
},
{
name: 'caption',
convert: null
},
{
/**
* data source
* local or external url
* - LOCAL
* - EXTERNAL
*/
name: 'ds',
convert: null
}
],
listeners: {
load: fillList
}
});

function hasClass(el, clsName) {
return el.className && new RegExp("(^|\\s)" + clsName + "(\\s|$)").test(el.className);
}

function addClass(el, clsName) {
if (el && !hasClass(el, clsName)) {
el.className = ((el.className || '') + ' ' + clsName).replace(/\s{2,}/g, " ");
}
}

function addEvent(target, eventName, eventFn) {
try {
if (supportAddEventListener) {
target.addEventListener(eventName, eventFn, false);
} else if (supportAttachEvent) {
target.attachEvent('on' + eventName, eventFn);
}
} catch (e) {
}
}

function checkListAllLoaded(loadNext) {
var playlist = document.getElementById('list'),
nodeLength = playlist.childNodes.length,
lastNode = playlist.childNodes[nodeLength - 1],
firstNode = playlist.childNodes[0];
if (playlist.childNodes.length < totalCount) {
if (loadNext &&
lastNode.getBoundingClientRect().right - getNode('list-box').getBoundingClientRect().right < 0 &&
maxNode < totalCount) {
loadList(path, maxNode, pageLimit, false, false);
} else if ((!loadNext) &&
firstNode.getBoundingClientRect().left > 0 &&
minNode > 0) {
loadList(path, minNode - pageLimit, pageLimit, false, false);
}
}
}

function formatTime(second) {
var timeStr = '',
h = 0,
m = 0;
if (second > 3600) {
h = Math.floor(second / 3600);
second -= (h * 3600);
}
if (second > 60) {
m = Math.floor(second / 60);
second -= (m * 60);
}
timeStr = (h > 10 ? h : '0' + h) +
':' + (m > 10 ? m : '0' + m) +
':' + (second > 10 ? second : '0' + second);
return timeStr;
}

function getCookie(name) {
var arg = name + "=";
var alen = arg.length;
var clen = document.cookie.length;
var i = 0,
j;
while (i < clen) {
j = i + alen;
if (document.cookie.substring(i, j) === arg) {
return getCookieVal(j);
}

i = document.cookie.indexOf(" ", i) + 1;
if (i === 0) {
break;
}
}
return null;
}

function getCookieVal(offset) {
var endstr = document.cookie.indexOf(";", offset);
if (endstr === -1) {
endstr = document.cookie.length;
}
return window.unescape(document.cookie.substring(offset, endstr));
}

function getEventTarget(e) {
var targ;
if (!e) {
e = window.event;
}
if (e.target) {
targ = e.target;
} else if (e.srcElement) {
targ = e.srcElement;
}
if (targ.nodeType === 3) {
targ = targ.parentNode;
}
return targ;
}

function getId(preFix) {
return preFix || 'el' + '-' + idCount++;
}

function setItemData(index, itemData) {
listMap[index].data = itemData;
}

function getItemData(el) {
var itemData = null;
if (typeof el === 'number') {
if (el === -1) {
return itemData;
}
el = getItemEl(el);
}

while (!hasClass(el, 'item')) {
el = el.parentNode;
if (el === null) {
break;
}
}
var i, map;
for (i = 0; i < listMap.length; i++) {
map = listMap[i];
if (map.el === el) {
itemData = map.data;
break;
}
}
return itemData;
}

function getItemIndex(el) {
var index = -1;
if (typeof el === 'number') {
el = getItemEl(el);
}
if (!el) {
return index;
}
while (!hasClass(el, 'item')) {
el = el.parentNode;
}
var itemEls = document.getElementById('list').childNodes;
var i;
for (i = 0; i < itemEls.length; i++) {
if (itemEls[i].getAttribute('data-id') === el.getAttribute('data-id')) {
index = i;
}
}
return index;
}

function getItemEl(index) {
if (listMap[index]) {
return listMap[index].el;
}
return null;
}

function getNode(id) {
var el = document.getElementById(id);
var els = document.getElementsByName(id);
if (els.length === 0) {
els = document.getElementsByTagName(id);
}
if (els.length === 1) {
el = els[0];
}
return el || els;
}

function getParamsStr(params) {
var str = '',
key, i;
if (typeof params === 'object') { // object
for (key in params) {
if (params.hasOwnProperty(key)) {
if (Array.isArray(params[key])) { // object
for (i = 0; i < params[key].length; i++) {
str += key + '=' + encodeURIComponent(params[key][i]) + '&';
}
} else {
str += key + '=' + encodeURIComponent(params[key]) + '&';
}
}
}
} else if (typeof params === 'string') {
str += params;
}
return str;
}

/**
*
* @param  {[type]} el [description]
* @return [left,top]
*/
function getPosition(el) {
var top = 0,
left = 0;
while (el) {
top += el.offsetTop;
left += el.offsetLeft;
el = el.offsetParent;
}
return [left, top];
}

function hideControlBar() {
var cb = getNode(ID.CTRL_BAR);
removeClass(cb, 'show');
addClass(cb, 'hide');
}

function hideList() {
addClass(getNode(ID.SHOW_LIST_BTN), 'show');
}

function updateRefreshIcon() {
var headItem = Ext.getCmp(ID.DEVICE_LIST_MENU_HEAD);
if (headItem) {
headItem.updateRefreshIcon();
}
resetImageSize();
}

function onLoadDevice() {
refreshDevicesList();
updateRefreshIcon();
}

function onBeforeLoadDevice() {
updateRefreshIcon();
}

function reloadDevices() {
UI.deviceListStore.reload();
}

function refreshDevicesList() {
var menu = UI.DeviceListMenu;

if (!menu.rendered) {
return false;
}

var devices = [],
removes = [];


if (!UI.deviceItemTpl) {
UI.deviceItemTpl = new Ext.XTemplate(
'<a id="{id}" class="{cls} x-unselectable" hidefocus="true" unselectable="on" href="{href}"',
'<tpl if="hrefTarget">',
' target="{hrefTarget}"',
'</tpl>',
'>',
'<img alt="{altText}" src="{icon}" class="x-menu-item-icon {iconCls}"/>',
'<img alt="{altText}" src="{icon}" class="deviceIcon {iconCls}"/>',
'<span class="x-menu-item-text">{text}</span>',
'</a>'
);
}

UI.deviceListStore.each(function(record) {
var recordData = record.data,
isWorking = recordData.isWorking && recordData.appType === 'FileStation';

devices.push({
isDevice: true,
itemId: recordData.deviceId||'tmp-'+Math.random(),
iconCls: recordData.deviceType,
cls : isWorking?'highlight-item x-menu-item--height':'x-menu-item--height',
itemTpl: UI.deviceItemTpl,
text: recordData.deviceName,
group: 'MediaViewer-resolution',
deviceId: recordData.deviceId,
deviceType: recordData.deviceType,
installed: recordData.installed,
handler: setTargetDevice,
scope: UI
});
});

menu.items.each(function(item) {
if (item.isDevice) {
removes.push(item);
}
});

Ext.each(removes, function(item) {
menu.remove(item);
});

Ext.each(devices, function(device) {
menu.addMenuItem(device);
});
if (menu.rendered) {
if (menu.isVisible()) {
UI.topBar.streamBtn.hideMenu();
UI.topBar.streamBtn.showMenu();
}
}
}

function onUpdateDevice(store, record){
var menu = UI.DeviceListMenu,
cls = 'highlight-item',
deviceId = record.get('deviceId'),
isWorking = record.get('isWorking'),
appType = record.get('appType');

var item = menu.getComponent(deviceId);

if (!item) {
return;
}

if (isWorking && appType === 'FileStation') {
item.addClass(cls);
} else {
item.removeClass(cls);
}
}

function setTargetDevice(item) {
UI.streamCfg.targetDevice = item.deviceId;
streamToDevice(UI.streamCfg.targetDevice);
}

function streamToDevice(deviceId) {
var targetFileInfo;
switch (dataSrc) {
case URL_LIST_L:
case LOCAL_LIST_L:
targetFileInfo = getItemData(0);
break;
case FILE:
case FOLDER:
targetFileInfo = getItemData(currentPlay);
break;
}
var _config = {
deviceId: deviceId,
path: UI.getPath(),
file: UI.getFile(),
supportRTT: supportRTT,
sort: UI.getSort(),
sortDir: UI.getSortDir(),
showUI: 'StreamCtrl',
keepAppend: true,
viewerIsOpened: true,
dataSrc: dataSrc,
list: listPath
};

if (_config.path.indexOf(window.UBUNTU_HOME_PATH)===0){
_config.src_flag='ubuntu';
}

if (jwplayer()) {
jwplayer().pause(true);
}
showStreamUI(_config);
}

function onScroll() {
var listEl = getNode('list').parentNode;
var lastScroll = listEl['data-lastScrollLeft'] || 0;
checkListAllLoaded(lastScroll - listEl.scrollLeft < 0);
listEl['data-lastScrollLeft'] = listEl.scrollLeft;
if (!listEl['data-jsScroll']) {
var playlist = getNode('list');
var item = playlist.childNodes[playlist['data-index']];
if (item) {
var itemRect = item.getBoundingClientRect();
var center = (getNode('body').getBoundingClientRect().width - itemRect.width) / 2;
playlist['data-index'] = Math.floor((listEl.scrollLeft - center + center) / 130);
}
}
listEl['data-lastScrollByJs'] = false;
}

function DOMMouseScrollList(e) {
var index = getNode('list')['data-index'];
if (e.detail < 0) {
UI.scrollList('r');
} else {
UI.scrollList('l');
}
}

function scrollList(e) {
var index = getNode('list')['data-index'];
if (e.wheelDelta / 120 > 0) {
UI.scrollList('r');
} else {
UI.scrollList('l');
}
}

function fixXSS(text){
return text.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;').replace(/'/g, '&apos;');
}

/*-----------------------------------------------------------------------------*\
**	##        #######     ###    ########     ########     ###    ########    ###
**	##       ##     ##   ## ##   ##     ##    ##     ##   ## ##      ##      ## ##
**	##       ##     ##  ##   ##  ##     ##    ##     ##  ##   ##     ##     ##   ##
**	##       ##     ## ##     ## ##     ##    ##     ## ##     ##    ##    ##     ##
**	##       ##     ## ######### ##     ##    ##     ## #########    ##    #########
**	##       ##     ## ##     ## ##     ##    ##     ## ##     ##    ##    ##     ##
**	########  #######  ##     ## ########     ########  ##     ##    ##    ##     ##
\*-----------------------------------------------------------------------------*/
function setListPath(_listPath){
listPath = _listPath;
}

function loadLocalList(){
var info = {
url: listPath,
success: function (res){
res = parserJSON(res.responseText);
parserLocalList(res);
},
failure: function (){
showLoadListError();
},
callback: parserListFinish
};
UI.tools.ajax(info);
}

function parserLocalList(res) {
if (res.status && res.status != 1) {
return;
}
totalCount = res.total;
currentPage = res.page;

var i, data, filename, path, tmpPath,
itemData, itemId,
listItem;

var itemDiv,
thumbEl,
fakeThumbEl,
thumbBoxEl;
var listEl = getNode('list');
for (i = 0; i < res.datas.length && i < 500; i++) {
/**
* init file Data
*/
data = res.datas[i];
tmpPath = data.file_path.split('/');
filename = tmpPath.pop();
path = tmpPath.join('/');
itemId = getId();
itemData = {
id: itemId,
fileName: filename,
path: path,
scr_type: LOCAL_LIST_L,
ids: {
size: itemId
}
};
if (itemData.path.indexOf(window.UBUNTU_HOME_PATH) === 0 ){
itemData.src_flag = 'ubuntu';
}
list.items.push(itemData);

/**
* init html element
*/
itemDiv = document.createElement('div');
thumbEl = document.createElement('img');
fakeThumbEl = document.createElement('img');
thumbBoxEl = document.createElement('div');

itemDiv.title = itemData.fileName;
itemDiv.appendChild(thumbBoxEl);
itemDiv.setAttribute('data-id', itemId);

fakeThumbEl.title = itemData.fileName;
fakeThumbEl.src = Ext.BLANK_IMAGE_URL;
fakeThumbEl.className = 'fake';

thumbEl.title = itemData.fileName;
thumbEl.className += " hide";

thumbBoxEl.className = "img-box";
thumbBoxEl.appendChild(fakeThumbEl);
thumbBoxEl.appendChild(thumbEl);

addClass(itemDiv, "item");

if (isIE) {
fakeThumbEl.removeAttribute('width');
fakeThumbEl.removeAttribute('height');
}

listEl.appendChild(itemDiv);
listMap.push({
el: itemDiv,
data: itemData
});
statSingleFile(filename, path, itemId, i === 0);
}
updateListPosition();
listItem = listMap[0];
if (listItem) {
itemData = listItem.data
UI.setFile(itemData.fileName);
UI.setFileData(itemData);
if (res.page) {
minNode = (res.page - 1) * pageLimit;
maxNode = res.page * pageLimit;
}

/**
* html element
*/
addClass(listItem.el, "current-item");
}

var __tmpEl = getItemEl(currentPlay);
if (currentPlay !== '--' && currentPlay > 0 && __tmpEl) {
currentPlay = getItemIndex(__tmpEl);
}
UI.setCurrentIndex(currentPlay);

if (totalCount < maxNode) {
maxNode = totalCount;
}
updateListPosition();
}

/***************\
* URL List
\***************/
function loadURLList(){
var info = {
url: listPath,
success: function (res){
res = parserJSON(res.responseText);
parserURLList(res);
},
failure: function (){
showLoadListError();
},
callback: parserListFinish
};
UI.tools.ajax(info);
}

function parserURLList(res) {
if (res.status && res.status != 1) {
return;
}
totalCount = res.total;
currentPage = res.page;
var datas = [],
thumbLarge = '',
thumbSmall = '';

Ext.each(res.datas, function(data) {

thumbnail = data.thumbnail;
switch (typeof thumbnail) {
case 'string':
thumbLarge = thumbSmall = thumbnail;
break;
case 'object':
thumbLarge = thumbnail.large;
thumbSmall = thumbnail.small;
break;
default:
thumbLarge = '';
thumbSmall = '';
break;
}

datas.push([
fixXSS(data.filename),
thumbLarge,
thumbSmall,
data.width,
data.height,
data.duration,
data.type,
data.URL||thumbLarge,
data.caption,
'EXTERNAL'
]);
});
listStore.loadData(datas);
}

function fillList(store, records) {
var currentIndex = UI.getCurrentIndex();
var tmp = new Ext.XTemplate('<tpl for=".">{[this.getItem(values,xindex)]}</tpl>', {
getItem: function(record, index) {
var imgCls = '',
itemCls = 'item',
itemStyle = '',
tplStr = '<div class="item {3}" id="{6}" data-id="{6}" {0} ><div class="img-box" {0} ><img src="{1}" class="fake" {0} ><img src="{2}" {0} style="{5}" ></div></div>';

var height = record.get('height'),
width = record.get('width'),
fileType = record.get('ft');
var defThumb = '';

switch (fileType) {
case Viewer.MEDIA_TYPE.AUDIO:
defThumb = IMG.DEF_AUDIO_THUMB;
break;
case Viewer.MEDIA_TYPE.VIDEO:
defThumb = IMG.DEF_VIDEO_THUMB;
break;
case Viewer.MEDIA_TYPE.PHOTO:
defThumb = IMG.DEF_PHOTO_THUMB;
break;
}

if (height === 0 || width === 0) {
imgCls = 'no-thumb';
}

if (index === 1 + currentIndex) {
itemCls += ' current-item';
}

if (width > height) {
itemStyle = 'max-height:50px';
} else {
itemStyle = 'max-width:50px';
}

return String.format(tplStr, ['ext:qtip="', record.get('fn'), '"'].join(''), // {0} filename
Ext.BLANK_IMAGE_URL, // {1} blank image
defThumb, // {2} thumb, prevent XSS don't direct use record.get('ts')
itemCls, // {3} item class
imgCls, // {4} images class
itemStyle, // {5} itemStyle
record.id // {6}
);
}
});

Ext.get('list').insertHtml('beforeEnd', tmp.apply(records));

var thumb, tmpImg, itemDiv, itemData, itemId;
Ext.each(records, function(record) {
thumb = record.get('ts');
itemId = getId();
itemDiv = Ext.get(record.id);
listMap.push({
el: itemDiv.dom,
data: {
recordId: record.id,
id: itemId,
fileName: record.get('fn'),
path: 'path',
scr_type: LOCAL_LIST_U,
type: record.get('ft'),
thumb: record.get('tl'),
width: record.get('width'),
height: record.get('height'),
downloadPath: record.get('url'),
duration: record.get('du'),
captions: record.get('caption'),
ids: {
size: itemId
}
}
});

tmpImg = new Image();
Ext.EventManager.on(tmpImg, 'load', updateThumbPosition, tmpImg, {
record: record
});
tmpImg.src = thumb;
});
minNode = 0;
totalCount = maxNode = store.getCount();
updateListPosition();
setPageInfo(minNode + 1, totalCount);
loadItem({target:Ext.select('#list>div:nth-child('+(currentIndex+1)+')').first().dom});
}

/**
* [parserURLListFinish description]
* @return {[type]} [description]
*/
function parserListFinish(){
unmask(document.body);
loading = false;
UI.resetImageSize();
if (window.AFTER_RESIZE) {
/*
*	After app maximize or restore window,
*	will set AFTER_RESIZE = true in 300ms.
*/
UI.setListPosition(UI.getCurrentIndex());
window.AFTER_RESIZE = false;
}
}

function statSingleFile(filename, path, id, loadFile){
var listEl = getNode('list'),
listElFirstNode = listEl.childNodes[0],
linkParams = {
func: 'get_viewer',
source_path: path,
sid: sid
},
imgLinkParams = {
sid: sid,
func: 'get_thumb',
path: path,
option: 1
},
statParams = {
func: 'stat',
sid: sid,
path: path,
media: 1,
file_name: []
},
captionParams = {
sid: sid,
func: 'subtitle',
subfunc: 'list',
path: path,
index: 0
},
trackParams = {
func: 'subtitle',
sid: sid,
path: path,
index: 0,
offset: 0 // second
},
playlist = {};
if (path.indexOf(window.UBUNTU_HOME_PATH)===0){
linkParams.src_flag='ubuntu';
imgLinkParams.src_flag='ubuntu';
statParams.src_flag='ubuntu';
captionParams.src_flag='ubuntu';
trackParams.src_flag='ubuntu';
}
var fphck,
mediaType,
source;

totalPage = Math.ceil(totalCount / pageLimit);

function getLoadItemFn(_fphck) {
return function() {
loadItem({
target: _fphck,
skipPlay: true
});
};
}

statParams.file_name.push(filename);
statParams.file_total = statParams.file_name.length;

captionParams.file_name = filename;

function preloadImg(thumbEl, fakeThumbEl, imgPath){
var img = new Image();
thumbEl.src = imgPath;
thumbEl['data-src'] = imgPath;
addEvent(img, 'load', getThumbLoadEventFn(thumbEl, fakeThumbEl));
addEvent(img, 'error', getThumbErrorEventFn(thumbEl, fakeThumbEl));
img.src = imgPath;
}

function palyItem(listItem){
loadItem({target: listItem.el});
}

var info = {
url: CGI_PATH,
params: statParams,
success: function(res) {
res = parserJSON(res.responseText);
var resData, listItem, itemEl, itemData,imgurl, thumbEl, fakeThumbEl;

if (res === false) {
return;
}

for (var j = 0; j < listMap.length; j++) {
if (listMap[j].data.id === id) {
listItem = listMap[j];
break;
}
}

if (res.status && res.status!=1){
if (listItem) {
itemData = listItem.data;
itemEl = listItem.el;
itemData.access_deny = true;
switch(UI.getMultiMediaType(itemData.fileName)){
case 'isAudio':
itemData.type = itemData.fileType = Viewer.MEDIA_TYPE.AUDIO;
break;
case 'isVideo':
itemData.type = itemData.fileType = Viewer.MEDIA_TYPE.VIDEO;
break;
case 'isPhoto':
itemData.type = itemData.fileType = Viewer.MEDIA_TYPE.PHOTO;
break;
}

if (itemData.type === Viewer.MEDIA_TYPE.AUDIO && (itemData.width === 0 || itemData.height===0)){
itemData.noThumb = true;
Ext.fly(itemEl).select('.img-box').addClass('no-thumb');
}

fakeThumbEl = Ext.fly(itemEl).child('img.fake',true);
thumbEl = Ext.fly(itemEl).child('img:not(.fake)',true);
switch (itemData.type) {
case Viewer.MEDIA_TYPE.AUDIO:
imgurl = fakeThumbEl.src = IMG.DEF_AUDIO_THUMB;
thumbEl['data-type']='audio';
break;
case Viewer.MEDIA_TYPE.VIDEO:
imgurl = fakeThumbEl.src = IMG.DEF_VIDEO_THUMB;
thumbEl['data-type']='video';
break;
case Viewer.MEDIA_TYPE.PHOTO:
imgurl = fakeThumbEl.src = IMG.DEF_PHOTO_THUMB;
thumbEl['data-type']='photo';
break;
}

preloadImg(thumbEl, fakeThumbEl, imgurl);
if (loadFile){
palyItem(listItem);
}
}
return ;
}

UI.setSupportRTT(res.rtt_support===1 && PARENT_WIN.QNAP.QOS.user.isAdminGroup);

for (var i = 0; i < 1; i++) {
resData = res.datas[i];
if (listItem) {
itemData = listItem.data;
itemEl = listItem.el;
node = getNode(itemData.ids.size);
node.innerHTML = formatTime(resData.duration);
node.title = formatTime(resData.duration);
itemData.flv1080 = resData.mp4_1080;
itemData.flv720 = resData.mp4_720;
itemData.flv480 = resData.mp4_480;
itemData.flv360 = resData.mp4_360;
itemData.flv240 = resData.mp4_240;
itemData.height = resData.height;
itemData.width = resData.width;
itemData.type = itemData.fileType = resData.filetype;
itemData.mt = resData.width;
itemData.filesize = resData.filesize;
itemData.duration = resData.duration;
itemData.subtitle = resData.subtitle;
itemData.fileExist = resData.exist;
if (itemData.type === Viewer.MEDIA_TYPE.AUDIO && (itemData.width === 0 || itemData.height===0)){
itemData.noThumb = true;
Ext.fly(itemEl).select('.img-box').addClass('no-thumb');
}
imgurl = getThumbPath(itemData);
fakeThumbEl = Ext.fly(itemEl).child('img.fake',true);
thumbEl = Ext.fly(itemEl).child('img:not(.fake)',true);
switch (itemData.type) {
case Viewer.MEDIA_TYPE.AUDIO:
fakeThumbEl.src = IMG.DEF_AUDIO_THUMB;
thumbEl['data-type']='audio';
break;
case Viewer.MEDIA_TYPE.VIDEO:
fakeThumbEl.src = IMG.DEF_VIDEO_THUMB;
thumbEl['data-type']='video';
break;
case Viewer.MEDIA_TYPE.PHOTO:
fakeThumbEl.src = IMG.DEF_PHOTO_THUMB;
thumbEl['data-type']='photo';
break;
}

preloadImg(thumbEl, fakeThumbEl, imgurl);
if (loadFile){
palyItem(listItem);
}
}
}
},
callback: function() {}
};

var capInfo = {
url: CGI_PATH,
params: captionParams,
success: function(res) {
res = parserJSON(res.responseText);
var targetFile, itemData;
if (res.datas.length > 0) {
targetFile = res.datas[0];
for (var j = 0; j < listMap.length; j++) {
if (listMap[j].data.id === id) {
itemData = listMap[j];
break;
}
}

trackParams.file_name = targetFile.name;
trackParams.mtime = targetFile.m_time;
var tracks = [{
file: CGI_PATH + '?' + getParamsStr(trackParams),
label: 'on',
kind: "captions",
'default': true
}];
itemData.data.tracks = tracks;
}
},
callback: function() {}
};

(function() {
var ajaxList = arguments;

function loadend(e) {
e.target.loaded = true;
var allLoaded = true;
Ext.each(ajaxList, function(_ajax) {
allLoaded = allLoaded & _ajax.loaded;
});
if (allLoaded) {
if (!mediaType || mediaType === Viewer.MEDIA_TYPE.PHOTO) {
return;
}
if (jwplayer() && jwplayer().remove) {
jwplayer().pause(true);
Ext.fly('qDisplayIcon').removeClass('show');
jwplayer().stop();
try {
jwplayer().remove();
} catch (ex) {

}
player = undefined;
}
if (playlist.sources.length === 0) {
updateToolbar();
updateQualityMenu([playlist]);
showPlayerErrorMsg();
return;
}
setupPlayer([playlist], type);
}
}
Ext.each(ajaxList, function(ajax) {
ajax.addEventListener('loadend', loadend, false);
});
}(UI.tools.ajax(info), UI.tools.ajax(capInfo)));
}

function setlist4MediaList(){
var listEl = getNode('list'),
listElFirstNode = listEl.childNodes[0],
linkParams = {
func: 'get_viewer',
source_path: path,
sid: sid
},
imgLinkParams = {
sid: sid,
func: 'get_thumb',
path: path,
option: 1
},
statParams = {
func: 'stat',
sid: sid,
path: path,
media: 1,
file_name: []
},
captionParams = {
sid: sid,
func: 'subtitle',
subfunc: 'list',
path: path,
index: 0
},
trackParams = {
func: 'subtitle',
sid: sid,
path: path,
index: 0,
offset: 0 // second
},
playlist = {};
if (path.indexOf(window.UBUNTU_HOME_PATH)===0){
linkParams.src_flag='ubuntu';
imgLinkParams.src_flag='ubuntu';
statParams.src_flag='ubuntu';
captionParams.src_flag='ubuntu';
trackParams.src_flag='ubuntu';
}
var fphck,
mediaType,
source;

totalPage = Math.ceil(totalCount / pageLimit);

function getLoadItemFn(_fphck) {
return function() {
loadItem({
target: _fphck,
skipPlay: true
});
};
}

for (var i = 0, startIndex = listMap.length; i < list.items.length; i++) {
if (getItemEl(i)) {
continue;
}
var itemData = list.items[i],
itemDiv = document.createElement('div'),
thumbEl = document.createElement('img'),
fakeThumbEl = document.createElement('img'),
thumbBoxEl = document.createElement('div');

var sources = [],
streamType = '';

imgLinkParams.name = linkParams.source_file = itemData.fileName;
imgLinkParams.size = 100;
linkParams.ss = 0;
var imgLink = CGI_PATH + '?' + getParamsStr(imgLinkParams),
radno = itemData.fileSize + itemData.mt;
imgLink += 'radno=' + radno;
linkParams.radno = radno;
statParams.file_name.push(itemData.fileName);
if (itemData.fileName === file) {
captionParams.file_name = file;
var mType = UI.getMultiMediaType(itemData.fileName);
mediaType = itemData.type;
if (mType !== 'isPhoto') {
switch (itemData.type) {
case Viewer.MEDIA_TYPE.AUDIO:
fakeThumbEl.src = IMG.DEF_AUDIO_THUMB;
if (/\.mp3$/i.test(itemData.fileName)) {
streamType = 'mp3'; // mp3
currentQuilty = defaultQuilty;
} else {
streamType = 'flv'; // mp3
linkParams.rtt = 1; //mp3 stream
currentQuilty = 'RTT';
}
delete linkParams.format;

linkParams.r = new Date().getTime();
sources.push({
file: CGI_PATH + '?' + getParamsStr(linkParams),
type: streamType
});
break;
case Viewer.MEDIA_TYPE.VIDEO:
UI.setRttString(PARENT_WIN._S._SFE_LANG_ON_THE_FLY_TRANSCODING);
var origFileRTTStr = PARENT_WIN._S._SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION;
fakeThumbEl.src = IMG.DEF_VIDEO_THUMB;
streamType = supportFlash ? 'flv' : 'mp4';
var hasTargetQuilty = false;

trackParams.file_name = itemData.fileName;

if (supportRTT) {
delete linkParams.format;
delete linkParams.s;
linkParams.rtt = 1;
source = {
file: CGI_PATH + '?' + getParamsStr(linkParams),
label: origFileRTTStr+' ',
type: streamType,
quality: 'rtt'
};
if (defaultQuilty === 'rtt') {
hasTargetQuilty = true;
source["default"] = true;
}
sources.push(source);
qualityLevel.push('rtt');
qualityMap['rtt'] = source.label+' ';
}

if (defaultQuilty === 'original' || /.*\.mp4$/i.test(linkParams.source_file)) {
delete linkParams.format;
delete linkParams.s;
source = {
file: app.getOpenFileURL(linkParams.source_path, linkParams.source_file),
label: origFileRTTStr,
type: 'mp4',
quality: 'original'
};
if (defaultQuilty === 'original'){
hasTargetQuilty = true;
source["default"] = true;
}

sources.push(source);
qualityLevel.push('original');
qualityMap['original'] = source.label;
}
var l = resolutionList.length,
j, resolution;
var rcdQuiltyRTT, rcdQuiltyOffline;
for (j = 0; j < l; j++) {
resolution = resolutionList[j];
if (itemData['flv' + resolution] === 1) {
linkParams.format = 'mp4_' + resolution;
delete linkParams.rtt;
delete linkParams.s;
source = {
file: CGI_PATH + '?' + getParamsStr(linkParams),
label: resolution + 'p',
type: 'mp4',
quality: resolution
};
rcdQuiltyOffline = resolution;
if (new RegExp(resolution).test(defaultQuilty)) {
hasTargetQuilty = true;
source["default"] = true;
}
sources.push(source);
qualityLevel.push(resolution);
if (new RegExp('R').test(defaultQuilty)) {
qualityMap[resolution + '-R'] = source.label;
} else {
qualityMap[resolution] = source.label;
}
} else if (supportRTT) {
linkParams.s = resolution + 'p';
delete linkParams.rtt;
delete linkParams.format;
source = {
file: CGI_PATH + '?' + getParamsStr(linkParams),
label: resolution + 'p',
type: streamType,
quality: resolution + '-R'
};
rcdQuiltyRTT = resolution + '-R';
if (defaultQuilty === resolution + '-R') {
hasTargetQuilty = true;
source["default"] = true;
}
sources.push(source);
qualityLevel.push(resolution + '-R');
qualityMap[resolution + '-R'] = source.label;
}
}
if (!hasTargetQuilty) {
currentQuilty = rcdQuiltyOffline || rcdQuiltyRTT;
} else {
currentQuilty = defaultQuilty;
}
break;
case Viewer.MEDIA_TYPE.PHOTO:
fakeThumbEl.src = IMG.DEF_PHOTO_THUMB;
delete linkParams.format;
delete linkParams.rtt;
break;
}
currentPlay = i;

itemData.thumbnail = imgLink;

imgLinkParams.size = 800;
imgLinkParams.radno = itemData.fileSize + itemData.mt;
playlist.image = CGI_PATH + '?' + getParamsStr(imgLinkParams);
playlist.sources = sources;

if (streamType === 'mp3') { //mp3
playlist.file = CGI_PATH + '?' + getParamsStr(linkParams);
playlist.type = streamType;
}
if (itemData.type === Viewer.MEDIA_TYPE.AUDIO) {
playlist.setupBg = true;
}
addClass(itemDiv, "current-item");
}
fphck = fakeThumbEl;
setTimeout(getLoadItemFn(fphck), 1000);
}
itemData.ids = {
size: getId()
};

itemDiv.title = itemData.fileName;
fakeThumbEl.title = itemData.fileName;
thumbEl.title = itemData.fileName;

switch (itemData.type) {
case Viewer.MEDIA_TYPE.AUDIO:
fakeThumbEl.src = IMG.DEF_AUDIO_THUMB;
thumbEl['data-type']='audio';
break;
case Viewer.MEDIA_TYPE.VIDEO:
fakeThumbEl.src = IMG.DEF_VIDEO_THUMB;
thumbEl['data-type']='video';
break;
case Viewer.MEDIA_TYPE.PHOTO:
fakeThumbEl.src = IMG.DEF_PHOTO_THUMB;
thumbEl['data-type']='photo';
break;
}

thumbBoxEl.appendChild(fakeThumbEl);
thumbBoxEl.appendChild(thumbEl);

itemDiv.appendChild(thumbBoxEl);

fakeThumbEl.className = 'fake';
thumbEl.className += " hide";
addClass(itemDiv, "item");

thumbBoxEl.className = "img-box";

if (isIE) {
fakeThumbEl.removeAttribute('width');
fakeThumbEl.removeAttribute('height');
}

if (insertBefore) {
listEl.insertBefore(itemDiv, listElFirstNode);
listMap.splice(i - startIndex, 0, {
el: itemDiv,
data: itemData
});
} else {
listEl.appendChild(itemDiv);
listMap.push({
el: itemDiv,
data: itemData
});
}

var img = new Image();
thumbEl.src = imgLink;
thumbEl['data-src'] = imgLink;
addEvent(img, 'load', getThumbLoadEventFn(thumbEl, fakeThumbEl));
addEvent(img, 'error', getThumbErrorEventFn(thumbEl, fakeThumbEl));
img.src = imgLink;
updateListPosition();
}
statParams.file_total = statParams.file_name.length;
var info = {
url: CGI_PATH,
params: statParams,
success: function(res) {
res = parserJSON(res.responseText);
if (res === false) {
return;
}
for (var i = 0; i < res.datas.length; i++) {
var resData = res.datas[i],
itemData = null;
for (var j = 0; j < listMap.length; j++) {
if (listMap[j].data.fileName === resData.filename) {
itemData = listMap[j];
break;
}
}
if (itemData) {
node = getNode(itemData.data.ids.size);
node.innerHTML = formatTime(resData.duration);
node.title = formatTime(resData.duration);

itemData.data.height = resData.height;
itemData.data.width = resData.width;

if (itemData.data.type === Viewer.MEDIA_TYPE.AUDIO && (itemData.data.width === 0||itemData.data.height===0)){
itemData.data.noThumb = true;
Ext.fly(itemData.el).select('.img-box').addClass('no-thumb');
}

if (itemData.data.fileName === file) {

if (itemData.data.type !== Viewer.MEDIA_TYPE.PHOTO) {
playlist.duration = resData.duration;
}

if (UI.getMultiMediaType(file) === 'isVideo') {
itemData.data.subtitle = resData.subtitle;
}
}
}
}
},
callback: function() {}
};
var capInfo = {
url: CGI_PATH,
params: captionParams,
success: function(res) {
res = parserJSON(res.responseText);
var targetFile;
if (res.datas.length > 0) {
targetFile = res.datas[0];
trackParams.file_name = targetFile.name;
trackParams.mtime = targetFile.m_time;
var tracks = [{
file: CGI_PATH + '?' + getParamsStr(trackParams),
label: 'on',
kind: "captions",
'default': true
}];
playlist.tracks = tracks;
} else {
delete playlist.tracks;
}

},
callback: function() {}
};

(function() {
var ajaxList = arguments;

function loadend(e) {
e.target.loaded = true;
var allLoaded = true;
Ext.each(ajaxList, function(_ajax) {
allLoaded = allLoaded & _ajax.loaded;
});
if (allLoaded) {
if (!mediaType || mediaType === Viewer.MEDIA_TYPE.PHOTO) {
return;
}
if (jwplayer() && jwplayer().remove) {
jwplayer().pause(true);
Ext.fly('qDisplayIcon').removeClass('show');
jwplayer().stop();
try {
jwplayer().remove();
} catch (ex) {

}
player = undefined;
}
if (playlist.sources.length === 0) {
updateToolbar();
updateQualityMenu([playlist]);
showPlayerErrorMsg();
return;
}
setupPlayer([playlist], type);
}
}
Ext.each(ajaxList, function(ajax) {
ajax.addEventListener('loadend', loadend, false);
});
}(UI.tools.ajax(info), UI.tools.ajax(capInfo)));
}

function loadFilePathWithoutSid(filename, fileType) {
totalCount = 1;
currentPage = 1;
minNode = 1;
maxNode = 1;

var data = {
fileName: filename,
timeLength: '--:--:--', //音樂OR影片長度
fileSize: 0,
fileType: fileType,
flv1080: 0,
flv720: 0,
flv480: 0,
flv360: 0,
flv240: 0,
mt: 0,
type: fileType
};

switch(fileType){
case MEDIA_TYPE.AUDIO:
data.thumbnail= IMG.DEF_AUDIO_THUMB;
break;
case MEDIA_TYPE.VIDEO:
data.thumbnail = IMG.DEF_VIDEO_THUMB;
break;
case MEDIA_TYPE.PHOTO:
data.thumbnail = IMG.DEF_PHOTO_THUMB;
break;
}

list.items.push(data);

UI.setFile(filename);
UI.setFileData(data);
UI.setCurrentIndex(1);
updateListPosition();

for (var i = 0, startIndex = listMap.length; i < list.items.length; i++) {
if (getItemEl(i)) {
continue;
}
var itemData = list.items[i],
itemDiv = document.createElement('div'),
thumbEl = document.createElement('img'),
fakeThumbEl = document.createElement('img'),
thumbBoxEl = document.createElement('div');

var sources = [],
streamType = '';

imgLinkParams.name = linkParams.source_file = itemData.fileName;
imgLinkParams.size = 100;
if (itemData.fileName.indexOf(window.UBUNTU_HOME_PATH) === 0){
imgLinkParams.src_flag = 'ubuntu';
}
linkParams.ss = 0;
var imgLink = CGI_PATH + '?' + getParamsStr(imgLinkParams),
radno = itemData.fileSize + itemData.mt;
imgLink += 'radno=' + radno;
linkParams.radno = radno;
statParams.file_name.push(itemData.fileName);

if (itemData.fileName === file) {
captionParams.file_name = file;
var mType = UI.getMultiMediaType(itemData.fileName);
mediaType = itemData.type;
if (mType !== 'isPhoto') {
switch (itemData.type) {
case Viewer.MEDIA_TYPE.AUDIO:
fakeThumbEl.src = IMG.DEF_AUDIO_THUMB;
if (/\.mp3$/i.test(itemData.fileName)) {
streamType = 'mp3'; // mp3
currentQuilty = defaultQuilty;
} else {
streamType = 'flv'; // mp3
linkParams.rtt = 1; //mp3 stream
currentQuilty = 'RTT';
}
delete linkParams.format;

linkParams.r = new Date().getTime();
sources.push({
file: CGI_PATH + '?' + getParamsStr(linkParams),
type: streamType
});
break;
case Viewer.MEDIA_TYPE.VIDEO:
UI.setRttString(PARENT_WIN._S._SFE_LANG_ON_THE_FLY_TRANSCODING);
var origFileRTTStr = PARENT_WIN._S._SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION;
fakeThumbEl.src = IMG.DEF_VIDEO_THUMB;
streamType = supportFlash ? 'flv' : 'mp4';
var hasTargetQuilty = false;

trackParams.file_name = itemData.fileName;

if (supportRTT) {
delete linkParams.format;
delete linkParams.s;
linkParams.rtt = 1;
source = {
file: CGI_PATH + '?' + getParamsStr(linkParams),
label: origFileRTTStr+' ',
type: streamType,
quality: 'rtt'
};
if (defaultQuilty === 'rtt') {
hasTargetQuilty = true;
source["default"] = true;
}
sources.push(source);
qualityLevel.push('rtt');
qualityMap['rtt'] = source.label+' ';
}

if (defaultQuilty === 'original' || /.*\.mp4$/i.test(linkParams.source_file)) {
delete linkParams.format;
delete linkParams.s;
source = {
file: app.getOpenFileURL(linkParams.source_path, linkParams.source_file),
label: origFileRTTStr,
type: 'mp4',
quality: 'original'
};
if (defaultQuilty === 'original'){
hasTargetQuilty = true;
source["default"] = true;
}

sources.push(source);
qualityLevel.push('original');
qualityMap['original'] = source.label;
}
var l = resolutionList.length,
j, resolution;
var rcdQuiltyRTT, rcdQuiltyOffline;
for (j = 0; j < l; j++) {
resolution = resolutionList[j];
if (itemData['flv' + resolution] === 1) {
linkParams.format = 'mp4_' + resolution;
delete linkParams.rtt;
delete linkParams.s;
source = {
file: CGI_PATH + '?' + getParamsStr(linkParams),
label: resolution + 'p',
type: 'mp4',
quality: resolution
};
rcdQuiltyOffline = resolution;
if (new RegExp(resolution).test(defaultQuilty)) {
hasTargetQuilty = true;
source["default"] = true;
}
sources.push(source);
qualityLevel.push(resolution);
if (new RegExp('R').test(defaultQuilty)) {
qualityMap[resolution + '-R'] = source.label;
} else {
qualityMap[resolution] = source.label;
}
} else if (supportRTT) {
linkParams.s = resolution + 'p';
delete linkParams.rtt;
delete linkParams.format;
source = {
file: CGI_PATH + '?' + getParamsStr(linkParams),
label: resolution + 'p',
type: streamType,
quality: resolution + '-R'
};
rcdQuiltyRTT = resolution + '-R';
if (defaultQuilty === resolution + '-R') {
hasTargetQuilty = true;
source["default"] = true;
}
sources.push(source);
qualityLevel.push(resolution + '-R');
qualityMap[resolution + '-R'] = source.label;
}
}
if (!hasTargetQuilty) {
currentQuilty = rcdQuiltyOffline || rcdQuiltyRTT;
} else {
currentQuilty = defaultQuilty;
}
break;
case Viewer.MEDIA_TYPE.PHOTO:
fakeThumbEl.src = IMG.DEF_PHOTO_THUMB;
delete linkParams.format;
delete linkParams.rtt;
break;
}
currentPlay = i;

itemData.thumbnail = imgLink;

imgLinkParams.size = 800;
imgLinkParams.radno = itemData.fileSize + itemData.mt;
playlist.image = CGI_PATH + '?' + getParamsStr(imgLinkParams);
playlist.sources = sources;

if (streamType === 'mp3') { //mp3
playlist.file = CGI_PATH + '?' + getParamsStr(linkParams);
playlist.type = streamType;
}
if (itemData.type === Viewer.MEDIA_TYPE.AUDIO) {
playlist.setupBg = true;
}
addClass(itemDiv, "current-item");
}
fphck = fakeThumbEl;
setTimeout(getLoadItemFn(fphck), 1000);
}
itemData.ids = {
size: getId()
};

itemDiv.title = itemData.fileName;
fakeThumbEl.title = itemData.fileName;
thumbEl.title = itemData.fileName;

switch (itemData.type) {
case Viewer.MEDIA_TYPE.AUDIO:
fakeThumbEl.src = IMG.DEF_AUDIO_THUMB;
thumbEl['data-type']='audio';
break;
case Viewer.MEDIA_TYPE.VIDEO:
fakeThumbEl.src = IMG.DEF_VIDEO_THUMB;
thumbEl['data-type']='video';
break;
case Viewer.MEDIA_TYPE.PHOTO:
fakeThumbEl.src = IMG.DEF_PHOTO_THUMB;
thumbEl['data-type']='photo';
break;
}

thumbBoxEl.appendChild(fakeThumbEl);
thumbBoxEl.appendChild(thumbEl);

itemDiv.appendChild(thumbBoxEl);

fakeThumbEl.className = 'fake';
thumbEl.className += " hide";
addClass(itemDiv, "item");

thumbBoxEl.className = "img-box";

if (isIE) {
fakeThumbEl.removeAttribute('width');
fakeThumbEl.removeAttribute('height');
}

if (insertBefore) {
listEl.insertBefore(itemDiv, listElFirstNode);
listMap.splice(i - startIndex, 0, {
el: itemDiv,
data: itemData
});
} else {
listEl.appendChild(itemDiv);
listMap.push({
el: itemDiv,
data: itemData
});
}
var img = new Image();
thumbEl.src = imgLink;
thumbEl['data-src'] = imgLink;
addEvent(img, 'load', getThumbLoadEventFn(thumbEl, fakeThumbEl));
addEvent(img, 'error', getThumbErrorEventFn(thumbEl, fakeThumbEl));
img.src = imgLink;
updateListPosition();
}
statParams.file_total = statParams.file_name.length;
var info = {
url: CGI_PATH,
params: statParams,
success: function(res) {
res = parserJSON(res.responseText);
if (res === false) {
return;
}
for (var i = 0; i < res.datas.length; i++) {
var resData = res.datas[i],
itemData = null;
for (var j = 0; j < listMap.length; j++) {
if (listMap[j].data.fileName === resData.filename) {
itemData = listMap[j];
break;
}
}
if (itemData) {
node = getNode(itemData.data.ids.size);
node.innerHTML = formatTime(resData.duration);
node.title = formatTime(resData.duration);

itemData.data.height = resData.height;
itemData.data.width = resData.width;

if (itemData.data.type === Viewer.MEDIA_TYPE.AUDIO && (itemData.data.width === 0||itemData.data.height===0)){
itemData.data.noThumb = true;
Ext.fly(itemData.el).select('.img-box').addClass('no-thumb');
}

if (itemData.data.fileName === file) {

if (itemData.data.type !== Viewer.MEDIA_TYPE.PHOTO) {
playlist.duration = resData.duration;
}

if (UI.getMultiMediaType(file) === 'isVideo') {
itemData.data.subtitle = resData.subtitle;
}
}
}
}
},
callback: function() {}
};
}

function loadList(_path, start, limit, lastItemData) {
if (loading) {
return false;
}
loading = true;
if (_path) {
path = _path;
}
if (limit) {
pageLimit = limit;
}
var listEl = getNode('list');
var params = {
sid: sid,
func: 'get_list',
limit: pageLimit,
sort: sort,
dir: direction,
path: path,
type: 5
};
if (path.indexOf(window.UBUNTU_HOME_PATH) === 0){
params.src_flag = 'ubuntu';
}
params.check_rtt = 1;
if (showHdMenu === false && defaultQuilty === 'original') {
delete params.check_rtt;
}

if (!supportRTT) {
params.mp4_1080 = 1; 	// transcoded 1080p
params.mp4_720 = 1; 	// transcoded 720p
params.mp4_480 = 1; 	// transcoded 480p
params.mp4_360 = 1; 	// transcoded 360p
params.mp4_240 = 1; 	// transcoded 240p
params.mp4 = 1; 		// Filename Extension .mp4
}

if (start !== undefined) {
params.start = start;
} else {
params.filename = file;
}

var info = {
url: CGI_PATH,
params: params,
success: function(res) {
res = parserJSON(res.responseText);

totalCount = res.total;
currentPage = res.page || currentPage;
if (res.status && res.status!=1){
if (res.status === PARENT_WIN.FileAPI.STATUS.PERMISSION_DENY){
showDenyMsg(false);
}
return ;
}
UI.setSupportRTT(res.rtt_support===1 && PARENT_WIN.QNAP.QOS.user.isAdminGroup);
if (dataSrc === window.FILE){
totalCount = 1;
}
if (lastItemData) {
list.items.push(lastItemData);
}
var i, data;
for (i = 0; i < res.datas.length; i++) {
data = res.datas[i];
list.items.push({
id : getId(),
fileName: data.filename,
timeLength: '--:--:--', //音樂OR影片長度
fileSize: data.filesize,
fileType: data.filetype,
flv1080: data.mp4_1080,
flv720: data.mp4_720,
flv480: data.mp4_480,
flv360: data.mp4_360,
flv240: data.mp4_240,
mt: data.mt,
type: data.filetype,
thumbnail: IMG.DEF_VIDEO_THUMB
});
if (data.filename === file) {
UI.setFile(data.filename);
UI.setFileData(data);
if (res.page) {
minNode = (res.page - 1) * pageLimit;
maxNode = res.page * pageLimit;
}
}
}

var __tmpEl = getItemEl(currentPlay);
setList(start < minNode);
if (currentPlay !== '--' && currentPlay > 0 && __tmpEl) {
currentPlay = getItemIndex(__tmpEl);
}
UI.setCurrentIndex(currentPlay);
if (start < minNode) {
listEl['data-index'] += pageLimit;
if (limit) {
listEl.parentNode.scrollLeft = listEl.parentNode.scrollLeft + (limit * 130);
}
}

if (start !== undefined) {
minNode = Math.min(start, minNode);
maxNode = Math.max(start + pageLimit, maxNode);
}
if (totalCount < maxNode) {
maxNode = totalCount;
}

updateListPosition();
},
failure: function (res){

},
callback: function() {
unmask(document.body);
loading = false;
UI.resetImageSize();
checkListAllLoaded(true); // after
checkListAllLoaded(false); // before
if (window.AFTER_RESIZE) {
/*
*	After app maximize or restore window,
*	will set AFTER_RESIZE = true in 300ms.
*/
UI.setListPosition(UI.getCurrentIndex());
window.AFTER_RESIZE = false;
}

}
};
UI.tools.ajax(info);
mask(document.body);
}

function loadItem(e) { //點了list的縮圖之後
var target = getEventTarget(e),
data = getItemData(target);
console.log('loadItem....');
if (data === null) {
return false;
}

var index = getItemIndex(target),
el = getItemEl(index),
_lastPlayEl = document.getElementsByClassName('current-item')[0];

setPageInfo((index + minNode + 1), totalCount);

currentPlay = index;
var imageView = document.getElementById('imageView'),
loadingMsg;
UI.setCurrentIndex(currentPlay);

updateToolbar();
removeClass(_lastPlayEl, 'current-item');
addClass(el, 'current-item');
UI.setListPosition(index);
UI.setFile(data.fileName);
UI.setFileData(data);
clearTimeout(autoPlayFlag);
autoPlayFlag = setTimeout(function() {
UI.autoPlay();
}, 5000);

if (data.access_deny){
showDenyMsg();
return;
}else if (data.fileExist===0){
showMsg('_SFE_LANG_ACTION_UPLOAD_RESPONSE_MSG_5',false);
}else{
hideMsg();
}

if (data.type !== Viewer.MEDIA_TYPE.PHOTO) {
UI.setType(data.type); //指定flash播放媒體的類型，1:music 2:vieo 3:photo
document.getElementById('mediacontainer').style.display = "inline";
document.getElementById('photoArea-id').style.display = "none";
if (e.skipPlay !== true) {
getNode(ID.CURTAIN).innerHTML = '';
loadingMsg = Ext.get('loadingMsg2');
if (loadingMsg) {
loadingMsg.addClass('show');
loadingMsg.update(PARENT_WIN._S._SFE_LANG_COMMON_LOADING_MSG + '...');
} else {
loadingMsg = document.createElement('div');
loadingMsg.setAttribute('id', 'loadingMsg2');
loadingMsg.innerHTML = PARENT_WIN._S._SFE_LANG_COMMON_LOADING_MSG + '...';
addClass(loadingMsg, 'loadingMsg show');
document.getElementById('mediacontainer').appendChild(loadingMsg);
}
if (player && supportFlash) {
jwplayer().pause(true);
Ext.fly('qDisplayIcon').removeClass('show');
jwplayer().stop();
if (jwplayerIsready) {
jwplayer().stop().remove();
}
player = undefined;
}
lastPosition = 0;
subtitlePosition = 0;
jwplayerIsready = false;
playIt(data);
}
if (imageView) {
imageView.src = IMG.DEF_PHOTO_THUMB;
}
} else {
getNode('playmode').style.display = 'none';
if (player) {
jwplayer().pause(true);
Ext.fly('qDisplayIcon').removeClass('show');
jwplayer().stop();
}
removeClass(getNode('body'), 'show-hdBtn');
document.getElementById('mediacontainer').style.display = "none";
var photoArea = document.getElementById('photoArea-id');
photoArea.style.display = "table-cell";

var imgurl = getThumbPath(data);
if (imageView) {
loadingMsg = Ext.fly('loadingMsg');
loadingMsg.addClass('show').update(PARENT_WIN._S._SFE_LANG_COMMON_LOADING_MSG + '...');

if (imageView.getAttribute('data-src') === imgurl) {
loadingMsg.removeClass('show');
}
var tmpImg = new Image();
addEvent(tmpImg, 'load', function (){
imageView.src = imgurl
resetImageSize();
});
addEvent(tmpImg, 'error', function (){
imageView.src = IMG.DEF_PHOTO_THUMB;
});
tmpImg.src = imgurl;
document.getElementById('photoArea-id').title = data.fileName;
} else {
var imageEl = document.createElement('img');
loadingMsg = document.createElement('div');
imageEl.setAttribute('src', imgurl);
imageEl.setAttribute('id', 'imageView');
imageEl.style.width = 'auto';
imageEl.style.height = 'auto';
imageEl.style.visibility ='hidden';
addEvent(imageEl, 'load', function() {
Ext.fly(loadingMsg).removeClass('show');
resetImageSize();
window.qMessageClient.fireEvent(window.qMessageClient.EVENT_NAME.BROADCAT,{image_loaded:1})
});
addEvent(imageEl, 'error', function() {
Ext.fly(loadingMsg).removeClass('show');
imageEl.src = IMG.DEF_PHOTO_THUMB;
imageEl.style.visibility ='visible';
});
addEvent(imageEl, 'transitionend', updateImgMinSize);
addEvent(imageEl, 'webkitTransitionEnd', updateImgMinSize);
addEvent(imageEl, 'oTransitionEnd', updateImgMinSize);
addEvent(imageEl, 'MSTransitionEnd', updateImgMinSize);
imageEl.setAttribute('data-src', imgurl);
loadingMsg = document.createElement('div');
loadingMsg.setAttribute('id', 'loadingMsg');
loadingMsg.innerHTML = PARENT_WIN._S._SFE_LANG_COMMON_LOADING_MSG + '...';
addClass(loadingMsg, 'loadingMsg show');

photoArea.appendChild(imageEl);
photoArea.title = data.fileName;
photoArea.appendChild(loadingMsg);

}
}


}

function cleanCurtain(){
getNode('playmode').style.display = 'none';
document.getElementById('mediacontainer').style.display = "none";
document.getElementById('photoArea-id').style.display = "none";
var topBar = UI.topBar,
bottomBar = UI.bottomBar;
topBar.itemName.update('');
bottomBar.itemName.update('');
bottomBar.pageInfo.setText('<span class="current-index"></span><span class="slash" ></span><span class="total-items" ></span>');
}

function statFile(filename, path, callback){
var statParams = {
func: 'stat',
sid: sid,
path: path,
media: 1,
file_name: []
};
if (path.indexOf(window.UBUNTU_HOME_PATH) === 0){
statParams.src_flag = 'ubuntu';
}
statParams.file_name.push(filename);
statParams.file_total = statParams.file_name.length;

var info = {
url: CGI_PATH,
params: statParams,
success: Ext.emptyFn,
callback: callback
};

UI.tools.ajax(info)
}

function resetImageSize() {
var imageView = document.getElementById('imageView'),
bodyBox = getNode('body').getBoundingClientRect(),
photoArea = Ext.get('photoArea-id'),
mediacontainer = Ext.get('mediacontainer');

var listBox = getNode('list').getBoundingClientRect(),
naviBar = getNode('naviBar').getBoundingClientRect();

if (Ext.fly('curtain_wrapper')) {
Ext.fly('curtain_wrapper').setWidth('100%');
}

Ext.get('controlBarCt').setWidth(Ext.getBody().getWidth());

if (imageView && photoArea.getStyle('display') !== 'none') {
var maxW = photoArea.getWidth(),
maxH = photoArea.getHeight();
imageView.style.maxWidth = maxW + 'px';
imageView.style.maxHeight = maxH + 'px';
imageView.style.minHeight = '';
imageView.style.minWidth = '';
clearTimeout(updateImgMinSizeFlag);
updateImgMinSizeFlag = setTimeout(updateImgMinSize,600);
}
}

var updateImgMinSizeFlag = 0;

function updateImgMinSize(){
clearTimeout(updateImgMinSizeFlag);
var imageView = Ext.get('imageView');
var fileData = getItemData(currentPlay);
var photoArea = Ext.get('photoArea-id');
var maxW = photoArea.getWidth(),
maxH = photoArea.getHeight(),
imgW = imageView.getWidth(),
imgH = imageView.getHeight();

if (Ext.isNumber(fileData.width)){
if (imgW<fileData.width && imgW<maxW){
imageView.dom.style.minHeight = maxH+'px';
imageView.dom.style.minWidth = '';
}else if (imgH<fileData.height && imgH<maxH){
imageView.dom.style.minWidth = maxW+'px';
imageView.dom.style.minHeight = '';
}else{
imageView.dom.style.minHeight = '';
imageView.dom.style.minWidth = '';
}
imageView.dom.style.visibility ='visible';
}else{
var statParams = {
func: 'stat',
sid: sid,
path: path,
file_total: 1,
media: 1,
file_name: fileData.fileName
};
if (path.indexOf(window.UBUNTU_HOME_PATH) === 0){
statParams.src_flag = 'ubuntu';
}
var info = {
url: CGI_PATH,
params: statParams,
success: function(res) {
res = parserJSON(res.responseText);
if (res === false) {
return;
}
var fileData = getItemData(currentPlay);
for (var i = 0; i < res.datas.length; i++) {
var resData = res.datas[i],
statData = null;
for (var j = 0; j < res.datas.length; j++) {
if (fileData.fileName === resData.filename) {
statData = listMap[j];
break;
}
}
if (statData) {
fileData.height = resData.height;
fileData.width = resData.width;
}
updateImgMinSize();
}
},
callback: function() {}
};
UI.tools.ajax(info);
}
}

function mask(el) {
var h = el.offsetHeight,
w = el.offsetWidth,
XY = getPosition(el),
l = XY[0],
t = XY[1];

var maskEl;
if (maskMap[el]) {

maskEl = maskMap[el];
} else {
maskEl = document.createElement('div');
}
addClass(maskEl, 'mask');
maskEl.style.position = "absolute";
maskEl.style.top = t + 'px';
maskEl.style.left = l + 'px';
maskEl.style.width = w + 'px';
maskEl.style.height = h + 'px';
maskMap[el] = maskEl;
getNode('body').appendChild(maskEl);
}

function parserJSON(JSONtext) {
try {
if (supportJSONParse) {
return JSON.parse(JSONtext);
}
/*jslint evil: true */
return eval('(' + JSONtext + ')');
} catch (e) {
return false;
}
/*jslint evil: false */
}

function resetQuiltyMap() {
qualityMap = {};
qualityLevel = [];
}

function playIt(mediaItem, rttFirst, keepPlayer) {
var isURLFile = false;
var radno = mediaItem.fileSize + mediaItem.mt;
var tmpPath = mediaItem.path || path;
var linkParams = {
func: 'get_viewer',
source_path: tmpPath,
sid: sid,
source_file: mediaItem.fileName,
ss: parseInt(lastPosition),
radno: radno
},
imgLinkParams = {
sid: sid,
func: 'get_thumb',
path: tmpPath,
name: mediaItem.fileName,
size: 800,
option: 1
},
captionParams = {
sid: sid,
func: 'subtitle',
subfunc: 'list',
path: tmpPath,
file_name: mediaItem.fileName,
index: 0
},
trackParams = {
func: 'subtitle',
sid: sid,
path: tmpPath,
index: 0,
offset: subtitlePosition * 1000 // second
},
sources = [],
mediaType, targetType, source, playlist;

if (tmpPath.indexOf(window.UBUNTU_HOME_PATH) === 0){
linkParams.src_flag = 'ubuntu';
imgLinkParams.src_flag = 'ubuntu';
captionParams.src_flag = 'ubuntu';
trackParams.src_flag = 'ubuntu';
}

var imgLink = CGI_PATH + '?' + getParamsStr(imgLinkParams);

switch(mediaItem.scr_type){
case LOCAL_LIST_U:
case URL_LIST_U:
isURLFile = true;
break;
}
resetQuiltyMap();
switch (mediaItem.type) {
case Viewer.MEDIA_TYPE.AUDIO:
if (/\.mp3$/i.test(mediaItem.fileName) || isURLFile) {
targetType = mediaType = 'mp3';
currentQuilty = defaultQuilty;
} else {
targetType = mediaType = 'flv';
linkParams.rtt = 1;
currentQuilty = 'RTT';
}
delete linkParams.format;
linkParams.r = new Date().getTime();
if (isURLFile){
sources.push({
file: mediaItem.downloadPath,
type: mediaType
});
}else{
sources.push({
file: CGI_PATH + '?' + getParamsStr(linkParams),
type: mediaType
});
}
getNode('playmode').style.display = 'inline-block';
break;
case Viewer.MEDIA_TYPE.VIDEO:
UI.setRttString(PARENT_WIN._S._SFE_LANG_ON_THE_FLY_TRANSCODING);
var origFileRTTStr = PARENT_WIN._S._SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION;
mediaType = supportFlash ? 'flv' : 'mp4';
linkParams.rtt = 1;

var hasTargetQuilty = false;

if (supportRTT & !isURLFile) {
linkParams.rtt = 1;
linkParams.ss = parseInt(lastPosition);
delete linkParams.format;
source = {
file: CGI_PATH + '?' + getParamsStr(linkParams),
type: mediaType,
label: origFileRTTStr+' ',
quality: 'rtt'
};
if (rttFirst) {
defaultQuilty = 'rtt';
}
if (defaultQuilty === 'rtt') {
hasTargetQuilty = true;
source["default"] = true;
}

sources.push(source);
qualityLevel.push('rtt');
qualityMap['rtt'] = source.label+' ';
}

if (defaultQuilty === 'original' || /.*\.mp4$/i.test(linkParams.source_file) || isURLFile) {
linkParams.ss = parseInt(lastPosition);
delete linkParams.format;
delete linkParams.s;
if (isURLFile){
source = {
file: mediaItem.downloadPath,
label: origFileRTTStr,
type: 'mp4',
quality: 'original'
};
}else{
source = {
file: app.getOpenFileURL(linkParams.source_path, linkParams.source_file),
label: origFileRTTStr,
type: 'mp4',
quality: 'original'
};
}

if (defaultQuilty === 'original'){
hasTargetQuilty = true;
source["default"] = true;
}

targetType = source.type;
sources.push(source);
qualityLevel.push('original');
qualityMap['original'] = source.label;
}

var l = resolutionList.length,
i;
var rcdQuiltyRTT, rcdQuiltyOffline, resolution;
for (i = 0; i < l; i++) {
resolution = resolutionList[i];
if (mediaItem['flv' + resolution] === 1) {
linkParams.format = 'mp4_' + resolution;
delete linkParams.rtt;
delete linkParams.s;
linkParams.ss = 0;
source = {
file: CGI_PATH + '?' + getParamsStr(linkParams),
label: resolution + 'p',
type: 'mp4',
quality: resolution
};
rcdQuiltyOffline = resolution;
if (new RegExp(resolution).test(defaultQuilty)) {
hasTargetQuilty = true;
source["default"] = true;
targetType = source.type;
}
sources.push(source);
qualityLevel.push(resolution);
if (new RegExp('R').test(defaultQuilty)) {
qualityMap[resolution + '-R'] = source.label;
} else {
qualityMap[resolution] = source.label;
}
} else if (supportRTT) {
linkParams.s = resolution + 'p';
delete linkParams.format;
delete linkParams.rtt;
linkParams.ss = parseInt(lastPosition);
source = {
file: CGI_PATH + '?' + getParamsStr(linkParams),
label: resolution + 'p',
type: mediaType,
quality: resolution + '-R'
};
rcdQuiltyRTT = resolution + '-R';
if (defaultQuilty === resolution + '-R') {
hasTargetQuilty = true;
source["default"] = true;
targetType = source.type;
}
sources.push(source);
qualityLevel.push(resolution + '-R');
qualityMap[resolution + '-R'] = source.label;
}
}
if (!hasTargetQuilty) {
currentQuilty = rcdQuiltyOffline || rcdQuiltyRTT;
} else {
currentQuilty = defaultQuilty;
if (/^\d*$/.test(currentQuilty)) {
trackParams.offset = 0;
}
}
break;
case Viewer.MEDIA_TYPE.PHOTO:
getNode('playmode').style.display = 'none';
clearTimeout(autoPlayFlag);
autoPlayFlag = setTimeout(function() {
UI.autoPlay();
}, 5000);
break;
}

if (!isURLFile){
mediaItem.thumbnail = imgLink;
}else{
imgLink = mediaItem.thumb;
}

if (lastPlayEl) {
removeClass(lastPlayEl, 'paused');
}

var playlist = {
image: imgLink,
sources: sources,
currentQuality: qualityMap[currentQuilty],
type: targetType,
fallback: false
};

if (keepPlayer && type !== Viewer.MEDIA_TYPE.AUDIO) {
delete playlist.image;
keepPlayer = false;
}

if (isURLFile){
if (type !== Viewer.MEDIA_TYPE.PHOTO){
playlist.duration = mediaItem.duration;
if (mediaItem.captions){
playlist.tracks =[{
file: mediaItem.captions,
label: 'on',
kind: "captions",
'default': true
}];
}else{
delete playlist.tracks;
}
preSetupPlalyer(playlist, type, keepPlayer);
}
return ;
}

var statParams = {
func: 'stat',
sid: sid,
path: tmpPath,
file_total: 1,
media: 1,
file_name: mediaItem.fileName
};

if (tmpPath.indexOf(window.UBUNTU_HOME_PATH) === 0){
statParams.src_flag = 'ubuntu';
}

var info = {
url: CGI_PATH,
params: statParams,
success: function(res) {
res = parserJSON(res.responseText);

if (res.status && res.status!=1){
showDenyMsg();
return;
}
for (var i = 0; i < res.datas.length; i++) {
var resData = res.datas[i];
if (mediaItem.fileName === resData.filename) {
playlist.duration = resData.duration;
if (UI.getMultiMediaType(mediaItem.fileName) !== 'isVideo') {
break;
}
mediaItem.subtitle = resData.subtitle;
break;
}
}
},
callback: function() {}
};

var capInfo = {
url: CGI_PATH,
params: captionParams,
success: function(res) {
res = parserJSON(res.responseText);
var targetFile;
if (res.datas.length > 0) {
targetFile = res.datas[0];
trackParams.file_name = targetFile.name;
trackParams.mtime = targetFile.m_time;
var tracks = [{
file: CGI_PATH + '?' + getParamsStr(trackParams),
label: 'on',
kind: "captions",
'default': true
}];
playlist.tracks = tracks;
} else {
delete playlist.tracks;
}

},
callback: function() {}
};


(function() {
var ajaxList = arguments;

function loadend(e) {
e.target.loaded = true;
var allLoaded = true;
Ext.each(ajaxList, function(_ajax) {
allLoaded = allLoaded & _ajax.loaded;
});
if (allLoaded) {
preSetupPlalyer(playlist, type, keepPlayer);
}
}
Ext.each(ajaxList, function(ajax) {
ajax.addEventListener('loadend', loadend, false);
});
}(UI.tools.ajax(info), UI.tools.ajax(capInfo)));
}

function removeClass(el, clsName) {
if (el && el.className) {
el.className = el.className.replace(new RegExp(clsName, 'g'), '');
el.className = el.className.replace(/\s{2,}/g, " ");
}
}

function setCookie(name, value, days) {
var expires;
if (days) {
var date = new Date();
date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
expires = "";
expires = date.toGMTString();
} else {
expires = "";
}
document.cookie = name + "=" + value + "; expires=" + expires + "; path=/";
}

function getThumbLoadEventFn(thumbEl, fakeThumbEl) {
return function(e) {
showListImg(thumbEl, fakeThumbEl, e.target);
};
}

function getThumbErrorEventFn(thumbEl, fakeThumbEl) {
return function() {
if (IMG_MAP[thumbEl.src]) {
return;
}
thumbEl.className = "hide";
removeClass(fakeThumbEl, 'hide');
};
}

function setList(insertBefore) {
var listEl = getNode('list'),
listElFirstNode = listEl.childNodes[0],
linkParams = {
func: 'get_viewer',
source_path: path,
sid: sid
},
imgLinkParams = {
sid: sid,
func: 'get_thumb',
path: path,
option: 1
},
statParams = {
func: 'stat',
sid: sid,
path: path,
media: 1,
file_name: []
},
captionParams = {
sid: sid,
func: 'subtitle',
subfunc: 'list',
path: path,
index: 0
},
trackParams = {
func: 'subtitle',
sid: sid,
path: path,
index: 0,
offset: 0 // second
},
playlist = {};
if (path.indexOf(window.UBUNTU_HOME_PATH) === 0){
linkParams.src_flag = 'ubuntu';
imgLinkParams.src_flag = 'ubuntu';
statParams.src_flag = 'ubuntu';
captionParams.src_flag = 'ubuntu';
trackParams.src_flag = 'ubuntu';
}
var fphck,
mediaType,
source;

totalPage = Math.ceil(totalCount / pageLimit);

function getLoadItemFn(_fphck) {
return function() {
loadItem({
target: _fphck,
skipPlay: true
});
};
}

for (var i = 0, startIndex = listMap.length; i < list.items.length; i++) {
if (getItemEl(i)) {
continue;
}
var itemData = list.items[i],
itemDiv = document.createElement('div'),
thumbEl = document.createElement('img'),
fakeThumbEl = document.createElement('img'),
thumbBoxEl = document.createElement('div');

var sources = [],
streamType = '';

imgLinkParams.name = linkParams.source_file = itemData.fileName;
imgLinkParams.size = 100;
linkParams.ss = 0;
var imgLink = CGI_PATH + '?' + getParamsStr(imgLinkParams),
radno = itemData.fileSize + itemData.mt;
imgLink += 'radno=' + radno;
linkParams.radno = radno;
statParams.file_name.push(itemData.fileName);
if (itemData.fileName === file) {
captionParams.file_name = file;
var mType = UI.getMultiMediaType(itemData.fileName);
mediaType = itemData.type;
if (mType !== 'isPhoto') {
switch (itemData.type) {
case Viewer.MEDIA_TYPE.AUDIO:
fakeThumbEl.src = IMG.DEF_AUDIO_THUMB;
if (/\.mp3$/i.test(itemData.fileName)) {
streamType = 'mp3'; // mp3
currentQuilty = defaultQuilty;
} else {
streamType = 'flv'; // mp3
linkParams.rtt = 1; //mp3 stream
currentQuilty = 'RTT';
}
delete linkParams.format;

linkParams.r = new Date().getTime();
sources.push({
file: CGI_PATH + '?' + getParamsStr(linkParams),
type: streamType
});
break;
case Viewer.MEDIA_TYPE.VIDEO:
UI.setRttString(PARENT_WIN._S._SFE_LANG_ON_THE_FLY_TRANSCODING);
var origFileRTTStr = PARENT_WIN._S._SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION;
fakeThumbEl.src = IMG.DEF_VIDEO_THUMB;
streamType = supportFlash ? 'flv' : 'mp4';
var hasTargetQuilty = false;

trackParams.file_name = itemData.fileName;

if (supportRTT) {
delete linkParams.format;
delete linkParams.s;
linkParams.rtt = 1;
source = {
file: CGI_PATH + '?' + getParamsStr(linkParams),
label: origFileRTTStr+' ',
type: streamType,
quality: 'rtt'
};
if (defaultQuilty === 'rtt') {
hasTargetQuilty = true;
source["default"] = true;
}
sources.push(source);
qualityLevel.push('rtt');
qualityMap['rtt'] = source.label+' ';
}

if (defaultQuilty === 'original' || /.*\.mp4$/i.test(linkParams.source_file)) {
delete linkParams.format;
delete linkParams.s;
source = {
file: app.getOpenFileURL(linkParams.source_path, linkParams.source_file),
label: origFileRTTStr,
type: 'mp4',
quality: 'original'
};
if (defaultQuilty === 'original'){
hasTargetQuilty = true;
source["default"] = true;
}

sources.push(source);
qualityLevel.push('original');
qualityMap['original'] = source.label;
}
var l = resolutionList.length,
j, resolution;
var rcdQuiltyRTT, rcdQuiltyOffline;
for (j = 0; j < l; j++) {
resolution = resolutionList[j];
if (itemData['flv' + resolution] === 1) {
linkParams.format = 'mp4_' + resolution;
delete linkParams.rtt;
delete linkParams.s;
source = {
file: CGI_PATH + '?' + getParamsStr(linkParams),
label: resolution + 'p',
type: 'mp4',
quality: resolution
};
rcdQuiltyOffline = resolution;
if (new RegExp(resolution).test(defaultQuilty)) {
hasTargetQuilty = true;
defaultQuilty = resolution;
source["default"] = true;
}
sources.push(source);
qualityLevel.push(resolution);
if (new RegExp('R').test(defaultQuilty)) {
qualityMap[resolution + '-R'] = source.label;
} else {
qualityMap[resolution] = source.label;
}
} else if (supportRTT) {
linkParams.s = resolution + 'p';
delete linkParams.rtt;
delete linkParams.format;
source = {
file: CGI_PATH + '?' + getParamsStr(linkParams),
label: resolution + 'p',
type: streamType,
quality: resolution + '-R'
};
rcdQuiltyRTT = resolution + '-R';
if (defaultQuilty === resolution + '-R') {
hasTargetQuilty = true;
source["default"] = true;
defaultQuilty = resolution + '-R';
}
sources.push(source);
qualityLevel.push(resolution + '-R');
qualityMap[resolution + '-R'] = source.label;
}
}
if (!hasTargetQuilty) {
currentQuilty = rcdQuiltyOffline || rcdQuiltyRTT;
} else {
currentQuilty = defaultQuilty;
}
break;
case Viewer.MEDIA_TYPE.PHOTO:
fakeThumbEl.src = IMG.DEF_PHOTO_THUMB;
delete linkParams.format;
delete linkParams.rtt;
break;
}
currentPlay = i;

itemData.thumbnail = imgLink;

imgLinkParams.size = 800;
imgLinkParams.radno = itemData.fileSize + itemData.mt;
playlist.image = CGI_PATH + '?' + getParamsStr(imgLinkParams);
playlist.sources = sources;
if (streamType === 'mp3') { //mp3
playlist.file = CGI_PATH + '?' + getParamsStr(linkParams);
playlist.type = streamType;
}
if (itemData.type === Viewer.MEDIA_TYPE.AUDIO) {
playlist.setupBg = true;
}
addClass(itemDiv, "current-item");
}
fphck = fakeThumbEl;
}
itemData.ids = {
size: getId()
};

itemDiv.title = itemData.fileName;
itemDiv.setAttribute('data-id', itemData.id);

fakeThumbEl.title = itemData.fileName;
thumbEl.title = itemData.fileName;

switch (itemData.type) {
case Viewer.MEDIA_TYPE.AUDIO:
fakeThumbEl.src = IMG.DEF_AUDIO_THUMB;
thumbEl['data-type']='audio';
break;
case Viewer.MEDIA_TYPE.VIDEO:
fakeThumbEl.src = IMG.DEF_VIDEO_THUMB;
thumbEl['data-type']='video';
break;
case Viewer.MEDIA_TYPE.PHOTO:
fakeThumbEl.src = IMG.DEF_PHOTO_THUMB;
thumbEl['data-type']='photo';
break;
}

thumbBoxEl.appendChild(fakeThumbEl);
thumbBoxEl.appendChild(thumbEl);

itemDiv.appendChild(thumbBoxEl);

fakeThumbEl.className = 'fake';
thumbEl.className += " hide";
addClass(itemDiv, "item");

thumbBoxEl.className = "img-box";

if (isIE) {
fakeThumbEl.removeAttribute('width');
fakeThumbEl.removeAttribute('height');
}

if (insertBefore) {
listEl.insertBefore(itemDiv, listElFirstNode);
listMap.splice(i - startIndex, 0, {
el: itemDiv,
data: itemData
});
} else {
listEl.appendChild(itemDiv);
listMap.push({
el: itemDiv,
data: itemData
});
}

if (fphck){
getLoadItemFn(fphck)();
}

var img = new Image();
thumbEl.src = imgLink;
thumbEl['data-src'] = imgLink;
addEvent(img, 'load', getThumbLoadEventFn(thumbEl, fakeThumbEl));
addEvent(img, 'error', getThumbErrorEventFn(thumbEl, fakeThumbEl));
img.src = imgLink;
updateListPosition();
}
statParams.file_total = statParams.file_name.length;
var info = {
url: CGI_PATH,
params: statParams,
success: function(res) {
res = parserJSON(res.responseText);
if (res === false) {
return;
}
for (var i = 0; i < res.datas.length; i++) {
var resData = res.datas[i],
itemData = null;
for (var j = 0; j < listMap.length; j++) {
if (listMap[j].data.fileName === resData.filename) {
itemData = listMap[j];
break;
}
}
if (itemData) {
node = getNode(itemData.data.ids.size);
node.innerHTML = formatTime(resData.duration);
node.title = formatTime(resData.duration);

itemData.data.height = resData.height;
itemData.data.width = resData.width;

if (itemData.data.type === Viewer.MEDIA_TYPE.AUDIO && (itemData.data.width === 0||itemData.data.height===0)){
itemData.data.noThumb = true;
Ext.fly(itemData.el).select('.img-box').addClass('no-thumb');
}

if (itemData.data.fileName === file) {

if (itemData.data.type !== Viewer.MEDIA_TYPE.PHOTO) {
playlist.duration = resData.duration;
}

if (UI.getMultiMediaType(file) === 'isVideo') {
itemData.data.subtitle = resData.subtitle;
}
}
}
}
},
callback: function() {}
};
var capInfo = {
url: CGI_PATH,
params: captionParams,
success: function(res) {
res = parserJSON(res.responseText);
var targetFile;
if (res.datas.length > 0) {
targetFile = res.datas[0];
trackParams.file_name = targetFile.name;
trackParams.mtime = targetFile.m_time;
var tracks = [{
file: CGI_PATH + '?' + getParamsStr(trackParams),
label: 'on',
kind: "captions",
'default': true
}];
playlist.tracks = tracks;
} else {
delete playlist.tracks;
}

},
callback: function() {}
};

(function() {
var ajaxList = arguments;

function loadend(e) {
e.target.loaded = true;
var allLoaded = true;
Ext.each(ajaxList, function(_ajax) {
allLoaded = allLoaded & _ajax.loaded;
});
if (allLoaded) {
if (!mediaType || mediaType === Viewer.MEDIA_TYPE.PHOTO) {
return;
}
if (jwplayer() && jwplayer().remove) {
jwplayer().pause(true);
Ext.fly('qDisplayIcon').removeClass('show');
jwplayer().stop();
try {
jwplayer().remove();
} catch (ex) {

}
player = undefined;
}
if (playlist.sources.length === 0) {
updateToolbar();
updateQualityMenu([playlist]);
showPlayerErrorMsg();
return;
}
setupPlayer([playlist], type);
}
}
Ext.each(ajaxList, function(ajax) {
ajax.addEventListener('loadend', loadend, false);
});
}(UI.tools.ajax(info), UI.tools.ajax(capInfo)));
}

function setPageInfo(currentIndex, total) {
UI.bottomBar.pageInfo.setText('<span class="current-index">'+currentIndex + '</span><span class="slash" > / </span><span class="total-items" >' + total+'</span>');
}

function updatePlayMode() {
var playmodeEl = Ext.get('playmode');
var modeStr = '';
var quilityMap = {
'1080': '1080p',
'1080-R': '1080p',
'720': '720p',
'720-R': '720p',
'480': '480p',
'480-R': '480p',
'360': '360p',
'360-R': '360p',
'240': '240p',
'240-R': '240p',
'rtt': PARENT_WIN._S._SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION,
'original': 'original'
};
var itemData = getItemData(currentPlay);
if (itemData == null) {
return;
}
if (itemData.type !== 2) {
return;
}

var streamingCombo = Ext.getCmp(ID.STREAMING_COMBO);
var transcodingCombo = Ext.getCmp(ID.TRANSCODING_COMBO);

if (/-R|rtt/.test(currentQuilty)) {
modeStr = PARENT_WIN._S._SFE_LANG_ON_THE_FLY_TRANSCODING;
streamingCombo.setValue('--');
transcodingCombo.setValue(currentQuilty);
} else {
modeStr = PARENT_WIN._S._SFE_LANG_MEDIA_02;
streamingCombo.setValue(currentQuilty);
transcodingCombo.setValue('--');
}
}

function jwplayerComplete() {
clearTimeout(autoPlayFlag);
setTimeout(function() {
UI.autoPlay(true);
}, 1000);
}

function showList() {
var listBox = getNode('list-box'),
showBtn = getNode(ID.SHOW_LIST_BTN);
removeClass(showBtn, 'show');
removeClass(listBox, 'move-left');
}
/**
* for listStore only
* @return {[type]} [description]
*/
function updateThumbPosition(event,el,options){
var item = Ext.get(options.record.id),
imgEl = item.select('img:nth-child(2)').first(),
imgDom = imgEl.dom;
imgDom.src = options.record.get('ts');
var width = imgDom.width,
height = imgDom.height;

if (width >50){
imgDom.style.marginLeft = ((50 - width) / 2) + 'px';
}else{
imgDom.style.marginLeft = '';
}
}

function showListImg(imgEl, fakeImgEl, tmpImg) {
if (tmpImg.complete) {
IMG_MAP[imgEl.src] = true;
addClass(fakeImgEl, "hide");
removeClass(imgEl, "hide");
var imgCt = imgEl.parentNode;
var height = imgCt.clientHeight;

imgEl.style.maxWidth = '';
imgEl.style.maxHeight = '';
if (tmpImg.width > tmpImg.height) {
imgEl.style.maxHeight = '50px';
} else {
imgEl.style.maxWidth = '50px';
}
var rect = imgEl.getBoundingClientRect();
if (rect.width > 50) {
imgEl.style.marginLeft = ((50 - rect.width) / 2) + 'px';
}else{
imgEl.style.marginLeft = '';
}
imgEl.parentNode.className+=[' ',imgEl['data-type']].join('');
} else {
setTimeout(function() {
showListImg(imgEl, fakeImgEl, tmpImg);
}, 300);
}
}

function showInstallFlash() {
Ext.fly('.loadingMsg').removeClass('show');
addClass(getNode(ID.CURTAIN), 'hide');
removeClass(getNode(ID.INSTALL_EL), 'hide');
hideList();
}

function showPlayerErrorMsg() {
var style = "text-align: center;position: absolute;top: 0;margin: auto;bottom: 0;left: 0;right: 0;line-height: 60px;height: 60px;width: 300px;color: red;";
var msg = PARENT_WIN._S._SFE_LANG_PS_NOT_PLAYING;

var node = getNode('curtain_wrapper');
if (node.tagName) {
} else {
node = getNode('curtain');
node.style.position = "relative";
node.style.display = "block";
node.style.width = "100%";
node.style.height = "100%";
}
var mediacontainer = getNode('mediacontainer');
if (mediacontainer) {
mediacontainer.style.backgroundImage = 'none';
}
node.innerHTML = '<DIV style="' + style + '" >' + msg + '</DIV>';
addClass(getNode(ID.INSTALL_EL), 'hide');
}

function testFlash() {
supportFlash = DetectFlashVer(9);
}

function unmask(el) {
var maskEl = maskMap[el];
if (maskEl) {
var body = getNode('body');
body.removeChild(maskEl);
maskEl = null;
delete maskMap[el];
}
}

function updateListPosition() {
var listEl = Ext.get('list');
var itemWidth = 74;
var listWidth = itemWidth * (maxNode - minNode);
var leftRightSpace = (listEl.parent().getWidth()-itemWidth)/2
listEl.setStyle({
'width': listWidth +'px',
'margin-left':leftRightSpace+'px',
'margin-right':(leftRightSpace + (itemWidth * (totalCount > maxNode ? 1 : 0)))+'px'
});
}

function getThumbPath(fileData, size) {
switch(fileData.scr_type){
case LOCAL_LIST_U:
case URL_LIST_U:
return fileData.thumb;
break;
}
var imgPath = "/cgi-bin/filemanager/utilRequest.cgi?func=get_thumb" +
"&size=" + (size||800)+
"&sid=" + sid +
"&path=" + encodeURIComponent(fileData.path || path) +
"&name=" + encodeURIComponent(fileData.fileName) +
"&radno=" + fileData.mt + fileData.fileSize+
"&option=1";
if ((fileData.path || path).indexOf(window.UBUNTU_HOME_PATH) === 0){
imgPath+= '&src_flag=ubuntu';
}
return imgPath;
}

/*-----------------------------------------------------------------------------*\
**	#### ##    ## #### ########
**	 ##  ###   ##  ##     ##
**	 ##  ####  ##  ##     ##
**	 ##  ## ## ##  ##     ##
**	 ##  ##  ####  ##     ##
**	 ##  ##   ###  ##     ##
**	#### ##    ## ####    ##
\*-----------------------------------------------------------------------------*/

function initUI() {
if (!PARENT_WIN.QNAP.QOS.user.isAdminGroup) {
Ext.fly(ID.STREAM_BTN).setDisplayed(false);
} else {
Ext.fly(ID.STREAM_BTN).setDisplayed(true);
}

var refreshDeviceItemTpl = new Ext.XTemplate(
'<a id="{id}" class="{cls} x-unselectable" hidefocus="true" unselectable="on" href="{href}"',
'<tpl if="hrefTarget">',
' target="{hrefTarget}"',
'</tpl>',
'>',
'<img alt="{altText}" src="{icon}" class="x-menu-item-icon {iconCls}"/>',
'<span class="x-menu-item-text">{text}</span>',
'<img alt="{altText}" src="{icon}" class="deviceIcon refresh"/>',
'</a>'
);

this.DeviceListMenu = new Ext.menu.Menu({
id: ID.DEVICE_LIST_MENU,
cls: 'desktop-window mediaviewer-menu qnap-menu-v2 qnap-block--black topbar-menu',
defaultOffsets: [0, 0],
enableScrolling: false,
shadow:false,
defaults: {
xtype: 'menucheckitem',
group: 'MediaViewer-resolution'
},
items: [{
id: ID.DEVICE_LIST_MENU_HEAD,
xtype: 'menuitem',
text: PARENT_WIN._S._SFE_LANG_LAN_DEVICES ,
qInternational:true,
qInternationalKey:'_SFE_LANG_LAN_DEVICES',
ctCls: 'menu-head',
width: 170,
hideOnClick: false,
handler: reloadDevices,
scope: this,
itemTpl: refreshDeviceItemTpl,
updateRefreshIcon: function() {
var cmp = this,
deviceListStore = os.initStore('streamDeviceStore');
if (cmp.rendered) {
var refImg = cmp.el.child('img.refresh');
if (deviceListStore.isLoading) {
refImg.addClass('loading');
} else {
refImg.removeClass('loading');
}
} else {
cmp.on('afterrender', cmp.updateRefreshIcon, null, {
single: true
});
}
},
listeners: {
single: true,
afterrender: function(cmp) {
var refImg = cmp.el.child('img.refresh');
refImg.addClassOnOver('mouse-over');
refImg.on('click', reloadDevices);
}
}
},
'-'
],
plugins: [{
init: function(cmp) {
cmp.on('afterrender', this.afterRender);
},
afterRender: function(cmp) {
cmp.scrollBar = new QNAP.CMP.Plugin.QTSScrollBar({
target: cmp.el,
cls: 'x-menu dark',
startDrag: function() {
cmp.mun(cmp.ul, 'mouseover', cmp.onMouseOver, cmp);
cmp.mun(cmp.ul, 'mouseout', cmp.onMouseOut, cmp);
},
endDrag: function() {
cmp.mon(cmp.ul, 'mouseover', cmp.onMouseOver, cmp);
cmp.mon(cmp.ul, 'mouseout', cmp.onMouseOut, cmp);
}
});
cmp.on('show',function (){
cmp.scrollBar.updateSize();
cmp.scrollBar.show();
});
cmp.on('add',function (){
cmp.scrollBar.updateSize();
});
cmp.on('hide', cmp.scrollBar.hide);
}
}],
listeners: {
single: true,
show: function(menu) {
var itemFlag = new Date().getTime();
refreshDevicesList();
menu.tiemFlag = itemFlag;
}
}
});

this.fileOPMenu = new Ext.menu.Menu({
cls: 'desktop-window mediaviewer-menu qnap-menu-v2 qnap-block--black topbar-menu',
shadow:false,
items: [{
xtype: 'menubaseitem',
autoEl: {
tag: 'div',
cls: 'rotate-op',
cn: [{
tag: 'div',
cls: 'rotate-left',
'ext:qtip': '_SFE_LANG_MSSTR_061',
id: ID.MENU_ROT_LEFT_BTN
}, {
tag: 'div',
cls: 'rotate-right',
'ext:qtip': '_SFE_LANG_MSSTR_062',
id: ID.MENU_ROT_RIGHT_BTN
}]
},
listeners: {
click: function(menuItem, e) {
if (e.within(ID.MENU_ROT_LEFT_BTN)) {
rotate(-90);
} else if (e.within(ID.MENU_ROT_RIGHT_BTN)) {
rotate(90);
}
}
}
}, '-',{
text: PARENT_WIN._S._SFE_LANG_PS_SET_AS_QTS_DESKTOP,
qInternational:true,
qInternationalKey:'_SFE_LANG_PS_SET_AS_QTS_DESKTOP',
tooltip:'_SFE_LANG_PS_SET_AS_QTS_DESKTOP',
menu: {
cls: 'desktop-window mediaviewer-menu qnap-menu-v2 qnap-block--black topbar-menu',
items: [{
text: PARENT_WIN._S._SFE_LANG_WALLPAPPER_POS_CENTER,
wpType: 'Center',
qInternational:true,
qInternationalKey: '_SFE_LANG_WALLPAPPER_POS_CENTER'
}, {
text: PARENT_WIN._S._SFE_LANG_WALLPAPPER_POS_FILL,
wpType: 'Fill',
qInternational:true,
qInternationalKey: '_SFE_LANG_WALLPAPPER_POS_FILL'
}, {
text: PARENT_WIN._S._SFE_LANG_WALLPAPPER_POS_STRETCH,
wpType: 'Stretch',
qInternational:true,
qInternationalKey: '_SFE_LANG_WALLPAPPER_POS_STRETCH'
}, {
text: PARENT_WIN._S._SFE_LANG_WALLPAPPER_POS_FIT,
wpType: 'Fit',
qInternational:true,
qInternationalKey: '_SFE_LANG_WALLPAPPER_POS_FIT'
}, {
text: PARENT_WIN._S._SFE_LANG_WALLPAPPER_POS_TILE,
wpType: 'Tile',
qInternational:true,
qInternationalKey: '_SFE_LANG_WALLPAPPER_POS_TILE'
}],
listeners: {
click: function(menu, menuItem, e) {
setupWallpaper(menuItem.wpType);
}
}
}
}, {
text: PARENT_WIN._S._SFE_LANG_ACTION_DEL_TITLE,
qInternational:true,
qInternationalKey:'_SFE_LANG_ACTION_DEL_TITLE',
handler: delItem,
tooltip: '_SFE_LANG_ACTION_DEL_TITLE'
}]
});

this.deviceListStore = os.initStore('streamDeviceStore');

if (this.deviceListStore.getCount() === 0) {
this.deviceListStore.reload();
}

var btnTemplate = new Ext.Template('<div id="{4}" class="x-btn {3}">',
'<em class="{2} x-unselectable" unselectable="on"><button class="account-btn-text" type="{0}"></button></em>',
'</div>');

this.topBar = new Ext.Toolbar({
renderTo: document.body,
cls: 'top-bar toolbar hide-anim',
items: [{
xtype: 'box',
ref: 'itemName',
cls: 'item-name'
}, '->', {
xtype: 'button',
cls: 'qts-button',
iconCls: 'slice-img download',
tooltip: '_SFE_LANG_ACTION_DOWNLOAD_TITLE',
handler: download,
template: btnTemplate
}, {
xtype: 'button',
cls: 'qts-button',
iconCls: 'slice-img share',
tooltip: 'share',
template: btnTemplate,
hidden: true
}, '-', {
xtype: 'button',
cls: 'qts-button',
iconCls: 'slice-img slideshow',
tooltip: '_SFE_LANG_MSSTR_153',
ref:'slideShowBtn',
handler: slideshow,
template: btnTemplate,
hidden:true
}, {
xtype: 'button',
cls: 'qts-button',
iconCls: 'slice-img DLNA',
tooltip: '_SFE_LANG_LAN_DEVICES',
ref:'streamBtn',
menu: this.DeviceListMenu,
template: btnTemplate,
handler: showInstallMediaAddOnConfirm,
scope: this,
hidden: !supportNMP
}, '-', {
xtype: 'button',
cls: 'qts-button',
iconCls: 'slice-img info',
tooltip: 'info',
template: btnTemplate,
hidden: true
}, {
xtype: 'button',
cls: 'qts-button',
iconCls: 'slice-img more',
tooltip: '_SFE_LANG_COMMON_MORE_ACTION',
ref:'fileBtn',
template: btnTemplate,
menu: this.fileOPMenu
}, {
xtype: 'button',
cls: 'qts-button',
iconCls: 'slice-img setup',
tooltip: 'setup',
template: btnTemplate,
hidden: true
}, {
xtype: 'button',
cls: 'qts-button',
iconCls: 'slice-img fullscreen',
tooltip: '_SFE_LANG_PS_FULL_STARAT',
ref: 'fullscreenBtn',
handler: toggleFullScreen,
template: btnTemplate
}, {
xtype: 'button',
cls: 'qts-button',
iconCls: 'slice-img',
tooltip: 'setupWallpaper',
handler: setupWallpaper,
template: btnTemplate,
hidden: true
}, {
xtype: 'box',
cls: 'right-space'
}],
listeners:{
afterlayout:function (cmp){
var separator = cmp.streamBtn.nextSibling();
if (cmp.streamBtn.hidden && cmp.slideShowBtn.hidden){
separator.hide();
}else{
separator.show();
}
}
}
});

playerControlBar = new PlayerControlBar({
applyTo: 'controlBarCt',
});

this.bottomBar = new Ext.Container({
renderTo: document.body,
cls: 'bottom-bar toolbar hide-anim',
items: [{
xtype: 'box',
ref: 'itemName',
cls: 'item-name'
}, {
xtype: 'container',
cls: 'tools',
items: [{
xtype: 'button',
cls: 'qts-button toggle-bottom-bar',
iconCls: 'slice-img icon',
tooltip: '_SFE_LANG_COMMON_PREVIEW',
toggleGroup: 'thumblist',
width: 30,
enableToggle: true,
handler: toggleBars,
template: btnTemplate
}, {
xtype: 'tbtext',
cls: 'page-info',
ref: '../pageInfo',
text: ''
}]
}, {
xtype: 'container',
layout: 'hbox',
layoutConfig: {
align: 'middle'
},
cls: 'thumb-ct',
ref: 'thumbCt',
items: [{
xtype: 'box',
cls: 'space-box',
width: 150
}, {
xtype: 'button',
cls: 'left-arrow',
margins: '0 6 0 0',
template: btnTemplate,
handler: prevPage,
width: 24
}, {
xtype: 'container',
applyTo: 'list-box',
flex: 1
}, {
xtype: 'button',
cls: 'right-arrow',
margins: '0 0 0 6',
template: btnTemplate,
handler: nextPage,
width: 24
}, {
xtype: 'box',
cls: 'space-box',
width: 150
}]
}, playerControlBar, {
xtype: 'container',
cls: 'tools player-tools',
ref: 'playerTools',
hidden:true,
items: [{
xtype: 'button',
cls: 'qts-button',
iconCls: 'slice-img subtitle',
tooltip: '_SFE_LANG_SUBTITLE',
width: 30,
id:ID.CC_BTN,
template: btnTemplate,
handler: showCaptionMsg,
menu: {
cls: 'desktop-window mediaviewer-menu qnap-menu-v2 qnap-block--black video-menu',
hideOnClick: false,
defaultOffsets: [-1, -30],
id: ID.SUBTITLE_MENU,
items: [{
xtype: 'menutextitem',
ctCls:'x-menu-list-label',
text: PARENT_WIN._S._SFE_LANG_SUBTITLE
},{
xtype: 'menucheckitem',
group: 'subtitle',
ccIndex:1,
id:ID.CC_ON,
text: PARENT_WIN._S._SFE_LANG_SWITCH_ON,
},{
xtype: 'menucheckitem',
group: 'subtitle',
ccIndex:0,
id:ID.CC_OFF,
text: PARENT_WIN._S._SFE_LANG_SWITCH_OFF,
}],
listeners:{
itemclick: function(item){
captionChange(item.ccIndex);
},
beforeshow: function (cmp){
if (cmp.disabled){
return false;
}
}
}
}
}, {
xtype: 'button',
cls: 'qts-button',
iconCls: 'slice-img video-setting',
tooltip: '_SFE_LANG_COMMON_PLAY',
ref:'../resolutionBtn',
width: 30,
template: btnTemplate,
menu: {
id:ID.RESOLUTION_MENU,
cls: 'desktop-window mediaviewer-menu qnap-menu-v2 qnap-block--black video-menu',
hideOnClick: false,
defaultOffsets: [-1, -30],
items: [{
xtype: 'menutextitem',
ctCls:'x-menu-list-label',
text: PARENT_WIN._S._SFE_LANG_MEDIA_02
}, {
xtype: 'combo',
triggerAction: 'all',
mode: 'local',
valueField: 'value',
displayField: 'displayText',
value:'--',
id:ID.STREAMING_COMBO,
lazyRender: true,
editable :false,
plugins: {
init : function(cmp) {
cmp.listClass = 'desktop-window';
cmp.on('expand', this.onExpand);
cmp.on('collapse', this.onCollapse);
},

onExpand:function(cmp) {
cmp.addClass('expand');
},
onCollapse: function(cmp) {
cmp.removeClass('expand');
}
},
store: new Ext.data.ArrayStore({
id: 0,
fields: [
'value','displayText'
]
}),
listeners:{
afterrender: function (cmp){
var prevCmp = cmp.previousSibling();
prevCmp.mon(cmp,'show',prevCmp.show,prevCmp);
prevCmp.mon(cmp,'hide',prevCmp.hide,prevCmp);
var nextCmp = cmp.nextSibling();
nextCmp.mon(cmp,'show',prevCmp.show,nextCmp);
nextCmp.mon(cmp,'hide',prevCmp.hide,nextCmp);
if (cmp.hidden){
prevCmp.hide();
nextCmp.hide();
}
},
select: qualityChange
}
}, '-', {
xtype: 'menutextitem',
ctCls:'x-menu-list-label',
text: PARENT_WIN._S._SFE_LANG_ON_THE_FLY_TRANSCODING
}, {
xtype: 'combo',
triggerAction: 'all',
mode: 'local',
valueField: 'value',
displayField: 'displayText',
value:'--',
id:ID.TRANSCODING_COMBO,
lazyRender: true,
editable :false,
store: new Ext.data.ArrayStore({
id: 0,
fields: [
'value','displayText'
]
}),
listeners:{
afterrender: function (cmp){
var prevCmp = cmp.previousSibling();
prevCmp.mon(cmp,'show',prevCmp.show,prevCmp);
prevCmp.mon(cmp,'hide',prevCmp.hide,prevCmp);
if (cmp.hidden){
prevCmp.hide() // label
.previousSibling().hide(); // separator
}
},
select:qualityChange
}
}, '-', {
xtype: 'menutextitem',
ctCls:'x-menu-list-label',
text: PARENT_WIN._S._SFE_LANG_MEDIA_06
}, {
cls:'open-option',
text: PARENT_WIN._S._SFE_LANG_COMMON_OPEN,
handler:openFile,
}, {
cls:'open-option',
text: PARENT_WIN._S._SFE_LANG_COMMON_OPEN_WITH_VLC,
hidden: PARENT_WIN.Ext.isMac||PARENT_WIN.Ext.isChrome||PARENT_WIN.Ext.isSafari||PARENT_WIN.QNAP.QOS.lib.isMobileBrowser,
handler: openFileWithVLC,
}]
}
}, { // Volume btn
xtype: 'button',
cls: 'icon none-bg-btn',
iconCls: 'slice-img volume',
menuAlign: 'b-t',
tooltip: '_SFE_LANG_COMMON_VOLUME',
id: playerControlBar.cmpId.VOLUME_BTN,
template: btnTemplate,
menu: {
cls: 'mediaviewer-menu volume-menu qnap-block--black',
hideOnClick: false,
defaultOffsets: [-1, 19],
id:ID.VOLUME_MENU,
items: [{
xtype: 'slider',
id: playerControlBar.cmpId.VOLUME_BAR,
height: 100,
vertical: true,
minValue: 0,
maxValue: 100,
value: parseInt(Ext.util.Cookies.get('jwplayer.volume')),
tooltip: '_SFE_LANG_COMMON_VOLUME',
plugins: [new playerControlBar.sliderPlugin()],
listeners: {
scope: playerControlBar,
change: playerControlBar.changeVolume,
buffer: 50
}
}, {
xtype: 'button',
cls: 'icon none-bg-btn mute-btn',
iconCls: 'volume-icon no-icon',
handler: playerControlBar.pressMute,
id: playerControlBar.cmpId.MUTE_BTN,
scope: playerControlBar,
tooltip: '_SFE_LANG_COMMON_MUTE',
enableToggle: Ext.util.Cookies.get('jwplayer.mute') === 'true'
}
],
listeners: {
mouseover: function() {
playerControlBar.stopFadeout = true;
},
mouseout: function() {
playerControlBar.stopFadeout = false;
}
}
}
}]
}],
listeners: {
single: true,
afterrender: function(cmp) {
playerControlBar.getEl().appendTo(cmp.getEl());
}
}
});

this.nextArrow = new Ext.Container({
renderTo: document.body,
cls: 'nav-btn btn-next hide-anim',
autoEl: {
tag: 'div',
cn: [{
tag: 'div',
id: ID.NAV_NEXT,
cls: 'nav-next',
'ext:qtip': '_SFE_LANG_COMMON_NEXT'
}, {
tag: 'div',
id: ID.NAV_AUTOPLAY,
cls: 'auto-play',
'ext:qtip': '_SFE_LANG_COMMON_PLAY_2'
}]
}
});

this.prevArrow = new Ext.Container({
renderTo: document.body,
cls: 'nav-btn btn-prev hide-anim',
autoEl: {
tag: 'div',
cn: [{
tag: 'div',
cls: 'nav-prev',
'ext:qtip': '_SFE_LANG_COMMON_PREVIOUS'
}]
}
});

onMute({mute: Ext.util.Cookies.get('jwplayer.mute')==='true'});
}

function initEvent() {
var listEl = getNode('list');

addEvent(listEl, 'click', loadItem);

var streamBtn = getNode(ID.STREAM_BTN),
listBox = getNode('list-box'),
qualityMenu = getNode('q_curtain_controlbar_hd');

addEvent(streamBtn, 'click', function() {
showStreamMenu();
});
addEvent(listBox, 'DOMMouseScroll', DOMMouseScrollList);
addEvent(listBox, 'mousewheel', scrollList);
addEvent(listEl.parentNode, 'scroll', onScroll);

addEvent(window, 'resize', function() {
window.AFTER_RESIZE = true;
setTimeout(function() {
window.AFTER_RESIZE = false;
}, 300);
});

Ext.EventManager.onWindowResize(function() {
resetImageSize();
updateToolbar();
UI.bottomBar.doLayout();
updateListPosition();
updatePlayMode();


var scrnBtn = Ext.get(ID.FULL_SCRN_BTN),
exitBtn = Ext.get(ID.EXIT_FULL_BTN),
listBtn = Ext.get(ID.LIST_BOX);
if (window.app.isFullScreen()) {
exitBtn.setDisplayed('');
scrnBtn.setDisplayed('none');
} else {
exitBtn.setDisplayed('none');
scrnBtn.setDisplayed('');
}

}, null, {buffer:16,delay:16});

Ext.get(ID.SLIDE_BTN).on('click', slideshow);
Ext.get(ID.FULL_SCRN_BTN).on('click', requestFullScreen);
Ext.get(ID.EXIT_FULL_BTN).on('click', exitFullscreen);
Ext.get(ID.SLIDESHOW_BTN).on('click', slideshow);

new Ext.KeyNav(Ext.getBody(), {
"up": function() {
UI.previousItem();
},
"down": function() {
UI.nextItem();
},
"left": function() {
UI.previousItem();
},
"right": function() {
UI.nextItem();
},
"enter": function() {
UI.nextItem();
},
scope: this
});


Ext.getBody().on({
buffer:500,
mousemove: function (e){
var el = Ext.get(this);
var eventXY = e.getXY();
if (eventXY[0] === el.lastMouseXY[0] &&
eventXY[1] === el.lastMouseXY[1]){
return ;
}
showWindowFrame();
el.lastMouseXY=eventXY;
},
click: showWindowFrame
});

Ext.getBody().lastMouseXY=[-1,-1];

Ext.getBody().on({
mousemove: hideWindowFrame,
click: hideWindowFrame,
buffer: 5000
});

this.prevArrow.getEl().on('click', function() {
UI.previousItem();
});
this.nextArrow.getEl().on('click', function(e) {
if (e.within(ID.NAV_AUTOPLAY)) {
UI.setIsAutoPlay(!isAutoPlay);
} else if (e.within(ID.NAV_NEXT)) {
UI.nextItem();
}
});
Ext.getBody().addClassOnOver('show-tools');
notify.on('startautoplay', function() {
UI.autoPlay();
Ext.getBody().addClass('playmode');
Ext.getBody().addClass('autoPlay');
Ext.get(ID.NAV_AUTOPLAY).set({
'ext:qtip': '_SFE_LANG_COMMON_PAUSE'
});
document.getElementById('pause-id').style.display = "";
document.getElementById('play-id').style.display = "none";
});
notify.on('stopautoplay', function() {
Ext.getBody().removeClass('playmode');
Ext.getBody().removeClass('autoPlay');
Ext.get(ID.NAV_AUTOPLAY).set({
'ext:qtip': '_SFE_LANG_COMMON_PLAY_2'
});
qMessageClient.fn.showWindowFrame();
fadeInNaviBar();
document.getElementById('pause-id').style.display = "none";
document.getElementById('play-id').style.display = "";
});
qMessageClient.on('filechange',filechange);
}

function filechange(appId, opt, e){
var source = opt.source,
target = opt.target,
fileNames = opt.fileName,
action = opt.action;

if (source !== path && target !== path){
return ;
}
if (action !== 'delete' ){
return;
}
if (Ext.isString(fileNames)){
fileNames = [fileNames];
}
totalCount = totalCount - fileNames.length;
Ext.each(fileNames, function(fileName) {
Ext.each(listMap, function(item, index) {
if (item.data.fileName === fileName) {
Ext.get(item.el).remove();
list.items.splice(index, 1); //移除資料
listMap.splice(index, 1); //移除資料
if (currentPlay === index) {
if (currentPlay === listMap.length) { //最後一筆或只有一筆
currentPlay--;
}
}
return false;
}
});
});
UI.nextItem(currentPlay);

maxNode = minNode + listMap.length;
app.load_file_list_with_filename(path, fileData.fileName, pageLimit, sort, direction, function(options, success, response) {
var list_data;
if (success) {
list_data = parserJSON(response.responseText);
totalCount = list_data.total;
}
});
checkListAllLoaded(true); // after
checkListAllLoaded(false); // before
}

function hideWindowFrame() {
if (isAutoPlay){
qMessageClient.fn.hideWindowFrame();
}
fadeOutNaviBar();
}

function showWindowFrame() {
if (qMessageClient.fn.showWindowFrame){
qMessageClient.fn.showWindowFrame();
}
fadeInNaviBar();
}

function initDisplayIcon() {
if (Ext.fly('qDisplayIcon')) {
Ext.fly('qDisplayIcon').removeClass('replay');
return true;
}
var displayIcon = Ext.DomHelper.createDom({
tag: 'div',
cls: 'displayIconCt',
id: 'qDisplayIcon',
children: [{
tag: 'div',
cls: 'displayIconBg',
style: {
display: 'table',
left: '0.5px',
cursor: 'pointer',
'background-size': '10px 100%, 40px 100%, 10px 100%'
},
children: {
tag: 'div',
cls: 'displayIcon',
style: {
float: 'none'
}
}
}]
});
document.getElementById('mediacontainer').appendChild(displayIcon);
Ext.fly('qDisplayIcon').on('click', function() {
jwplayer().play();
});
}
/*-----------------------------------------------------------------------------*\
* 	##     ## #### ######## ##      ## ######## ########
*	##     ##  ##  ##       ##  ##  ## ##       ##     ##
*	##     ##  ##  ##       ##  ##  ## ##       ##     ##
*	##     ##  ##  ######   ##  ##  ## ######   ########
*	 ##   ##   ##  ##       ##  ##  ## ##       ##   ##
*	  ## ##    ##  ##       ##  ##  ## ##       ##    ##
*	   ###    #### ########  ###  ###  ######## ##     ##
\*-----------------------------------------------------------------------------*/

function resizeCurtain() {
if (Ext.get('curtain_wrapper')) {
var w = Ext.get('curtain_wrapper').getWidth();
Ext.get('curtain_wrapper').setWidth(w - 1);
setTimeout(function() {
var w = Ext.get('curtain_wrapper').getWidth();
Ext.get('curtain_wrapper').setWidth(w + 1);
}, 10);
}
}

/*-----------------------------------*\
**	Caption functions
\*-----------------------------------*/
function updateCaption() {
var ccIndex = jwplayer().getCurrentCaptions().toString();
switch(ccIndex){
case '1':
Ext.getCmp(ID.CC_ON).setChecked(true);
break;
case '0':
default:
Ext.getCmp(ID.CC_OFF).setChecked(true);
break;
}
}

function showCaptionMsg() {
var ccBtn = Ext.getCmp(ID.CC_BTN);
if (ccBtn.menu.disabled){
window.app.showCaptionMsg();
}
}

function captionChange(ccIndex) {
jwplayer().setCurrentCaptions(ccIndex);
updateCaption();
}

function showControlBar() {
var player = jwplayer();
if (Ext.isNumber(lastVolume)) {
player.setVolume(lastVolume);
}
firstTimePlay = true;
setTimeout(function() {
resizeCurtain();
}, 1000);
Ext.get('mediacontainer').removeClass('hide-cursor');
jwplayerIsready = true;
playerControlBar.setTime(lastPosition);
playerControlBar.onPause();
playerControlBar.hide();
if (player.getPlaylist()[0].type === 'mp4') {
player.seek(lastPosition);
}
initDisplayIcon();
Ext.fly('qDisplayIcon').hide();
}

/*-----------------------------------*\
**	Full Screen functions
\*-----------------------------------*/
function toggleFullScreen() {
if (isFullScreen()) {
exitFullscreen();
UI.topBar.fullscreenBtn.setTooltip('_SFE_LANG_PS_FULL_STARAT');
} else {
requestFullScreen();
UI.topBar.fullscreenBtn.setTooltip('_SFE_LANG_PS_FULL_EXIT');
}
}

function requestFullScreen() {
app.requestFullScreen('viewer');
Ext.get(ID.FULL_SCRN_BTN).setDisplayed('none');
Ext.get(ID.EXIT_FULL_BTN).setDisplayed('');
}

function exitFullscreen() {
if (isFullScreen()) {
window.app.exitFullScreen();
Ext.get(ID.EXIT_FULL_BTN).setDisplayed('none');
Ext.get(ID.FULL_SCRN_BTN).setDisplayed('');
}
}

/*-----------------------------------*\
**	Slide Show functions
\*-----------------------------------*/
function slideshow() {
app.viewerCfg.file = getItemData(currentPlay).fileName;
app.startSlideShow();
}

/*-----------------------------------*\
**	Quality functions
\*-----------------------------------*/
function updateQualityMenu(playlist) {
var sources = playlist[0].sources,
l = sources.length,
i, source;

var streaming = [],
transcoding = [];

/**
* 先將 On-line Streaming 及 On-the-fly transcoding 分類
* @type {Number}
*/
for (i = 0; i < l; i++) {
source = sources[i];
if (/-R|rtt/.test(source.quality)) {
transcoding.push([source.quality, source.label]);
} else {
streaming.push([source.quality, source.label]);
}
}

var streamingCombo = Ext.getCmp(ID.STREAMING_COMBO);
if (streaming.length > 0){
streamingCombo.show().getStore().loadData(streaming);
streamingCombo.nextSibling().show();
}else{
streamingCombo.hide();
streamingCombo.nextSibling().hide();
}

var transcodingCombo = Ext.getCmp(ID.TRANSCODING_COMBO);
if (transcoding.length > 0){
transcodingCombo.getStore().loadData(transcoding);
transcodingCombo.show()
.previousSibling().show();  // label
transcodingCombo.nextSibling().show(); // separator
}else{
transcodingCombo.hide()
.previousSibling().hide();  // label
transcodingCombo.nextSibling().hide(); // separator
}
}

function openFile(fileName){
if (player) {
player.stop();
}
fileName = Ext.isString(fileName)? fileName : getItemData(currentPlay).fileName;
app.openFile(getItemData(currentPlay).path || path, fileName);
}

function openFileWithVLC(fileName){
if (player) {
player.stop();
}
fileName = Ext.isString(fileName)? fileName : getItemData(currentPlay).fileName;
app.openFileWithVLC(getItemData(currentPlay).path || path, fileName);
}

function qualityChange(combo, record, index ) {
var quality = record.get('value'),
itemData = getItemData(currentPlay),
player = jwplayer(),
newPosition = playerControlBar.progressBar.getValue(1);
if (!quality) {
return;
}
if (player.isCompleted) {
newPosition = 0;
}
if (/r/i.test(quality)) {
lastVolume = player.getVolume();
lastPosition = newPosition;
currentQuilty = quality;
UI.setDefaultQuilty(quality);
seek(newPosition);
} else if (/open-vlc/i.test(quality)) {
openFileWithVLC(itemData.fileName);
} else if (/open/i.test(quality)) {
openFile(itemData.fileName);
} else {
resetQuilty(quality, newPosition, player.getVolume());
}
}

function syncSelectedQuality(label) {
var qualityMenu = getNode('q_curtain_controlbar_hd');
var options = qualityMenu.childNodes;
var l = options.length,
i, option;
for (i = 0; i < l; i++) {
option = options[i];
if (options[i].textContent === label) {
addClass(options[i], "active");
break;
}
}
}

function resetQuilty(quality, newPosition, newVolume, keepPlayer) {
lastVolume = Ext.isNumber(newVolume) ? newVolume : lastVolume;
lastPosition = Ext.isNumber(newPosition) ? newPosition : lastPosition;
quality = quality || currentQuilty;

UI.setDefaultQuilty(quality);
clearTimeout(autoPlayFlag);
if (keepPlayer !== true) {
jwplayer().pause(true);
Ext.fly('qDisplayIcon').removeClass('show');
}
playIt(getItemData(currentPlay), false, keepPlayer);
autoPlayFlag = setTimeout(function() {
UI.autoPlay();
}, 5000);
}

function seek(newPosition) {
var itemData = getItemData(currentPlay),
radno = itemData.fileSize + itemData.mt,
linkParams = {
func: 'get_start_second',
source_path: itemData.path || path,
sid: sid,
source_file: itemData.fileName,
rtt: '1',
ss: parseInt(newPosition),
radno: radno
};
if (linkParams.source_path.indexOf(window.UBUNTU_HOME_PATH) === 0){
linkParams.src_flag = 'ubuntu';
}
var info = {
url: CGI_PATH,
params: linkParams,
success: function(res) {
res = parserJSON(res.responseText);
subtitlePosition = Math.round(res.start_second * 1000) / 1000;
},
callback: function() {
resetQuilty(null, newPosition, null, true);
playerControlBar.setTime(newPosition);
playerControlBar.startSec = newPosition;
}
};

UI.tools.ajax(info);
}


/*-----------------------------------------------------------------------------*\
**	########  #######   #######  ##       ########     ###    ########
**	   ##    ##     ## ##     ## ##       ##     ##   ## ##   ##     ##
**	   ##    ##     ## ##     ## ##       ##     ##  ##   ##  ##     ##
**	   ##    ##     ## ##     ## ##       ########  ##     ## ########
**	   ##    ##     ## ##     ## ##       ##     ## ######### ##   ##
**	   ##    ##     ## ##     ## ##       ##     ## ##     ## ##    ##
**	   ##     #######   #######  ######## ########  ##     ## ##     ##
\*-----------------------------------------------------------------------------*/

function setupWallpaper(wpType) {
var data = getItemData(currentPlay);
statFile(data.fileName,data.path||path, function (res){
res = parserJSON(res.responseText);
if (res.status && res.status!=1){
showDenyMsg();
return;
}
for (var i = 0; i < res.datas.length; i++) {
resData = res.datas[i];
if (resData.exist === 0){
showMsg('_SFE_LANG_ACTION_UPLOAD_RESPONSE_MSG_5');
return;
}
}

qMessageClient.fn.setupWallpaper({
path: (data.path||path) + '/' + data.fileName,
type: wpType
});
});
}

function download() {

var downloadPath = '',
filename = UI.getFile(),
dlForm = document.getElementById('downloadForm-id');
var itemData = getItemData(currentPlay);

switch(itemData.scr_type){
case LOCAL_LIST_U:
case URL_LIST_U:
donwload4URLFile(itemData);
return;
break;
}

downloadPath = [CGI_PATH, '/', encodeURIComponent(filename),
'?&isfolder=0',
'&func=download',
'&source_total=1',
'&sid=', UI.getSid(),
'&source_path=', encodeURIComponent(itemData.path || path),
'&source_file=', encodeURIComponent(itemData.fileName)
].join('');

if ((itemData.path || path).indexOf(window.UBUNTU_HOME_PATH) === 0){
downloadPath +='&src_flag=ubuntu';
}
dlForm.action = downloadPath;
dlForm.submit();
}

function donwload4URLFile(itemData){

var downloadPath = '',
dlForm = document.getElementById('downloadForm-id');
if (!itemData){
itemData = getItemData(currentPlay);
}
dlForm.action = itemData.downloadPath;
dlForm.submit();
}

/**
* delete file
* @return {[type]} [description]
*/
function delItem() {
var itemData = getItemData(currentPlay);
if (itemData.access_deny){
showDenyMsg();
return;
}
app.delFile(itemData.path || path, itemData.fileName);
}

function createMsg(){
var autoHideMsg = document.createElement('div');
autoHideMsg.setAttribute('id', 'autoHideMsg');
Ext.getBody().appendChild(autoHideMsg);
}

function showRotateFailedMsg() {
showMsg('_SFE_LANG_ACTION_ROTATE_FAILED');
}

function showDenyMsg(autoHide){
showMsg('_SFE_LANG_COMMON_MSG_PERMISSION_DENY2', autoHide);
}

function hideMsg(){
var autoHideMsg = document.getElementById('autoHideMsg');
if (autoHideMsg) {
Ext.fly(autoHideMsg).removeClass(['show-3-sec','show-always']);
}else{
createMsg();
hideMsg();
}
}

function showMsg(msg, autoHide){
var autoHideMsg = document.getElementById('autoHideMsg');
if (autoHideMsg) {
unmask(document.body);
var el = Ext.fly(autoHideMsg);
el
.update(PARENT_WIN._S[msg] || msg)
.removeClass(['show-3-sec','show-always']);
autoHideMsg.offsetWidth = autoHideMsg.offsetWidth;
if (autoHide === false){
el.addClass('show-always');
}else{
el.addClass('show-3-sec');
}

} else {
createMsg();
showMsg(msg, autoHide);
}
}

function showLoadListError(){
showMsg('_SFE_LANG_ERROR_OCCURRED_IN_THE_SOURCE');
}

function reloadThumb() {
var itemData = getItemData(currentPlay),
itemIndex = getItemIndex(currentPlay);

itemData.mt = new Date().getTime();
setItemData(itemIndex, itemData);

var imgPath = getThumbPath(itemData),
imageView = getNode('imageView'),
listItme = getItemEl(currentPlay),
tmpImage = new Image();

var thumbEl = listItme.childNodes[0].childNodes[1],
fakeThumbEl = listItme.childNodes[0].childNodes[0];

tmpImage.onload = function() {
imageView.src = imgPath;

unmask(document.body);
};
tmpImage.onerror = function() {
imageView.src = IMG.DEF_PHOTO_THUMB;
unmask(document.body);
};
addEvent(thumbEl, 'load', getThumbLoadEventFn(thumbEl, fakeThumbEl));
thumbEl.src = imgPath;
tmpImage.src = imgPath;
}

function rotate(angle) {
mask(document.body);
var params = {};
var itemData = getItemData(currentPlay);

params.QUERY_STRING = '';
params.func = 'rotate';
params.sid = UI.getSid();
params.dest_path = itemData.path || UI.getPath();
params.source_total = 1;
params.source_path = itemData.path || UI.getPath();
params.rotate_angle = angle;
params.source_file = UI.getFile();
if (params.source_path.indexOf(window.UBUNTU_HOME_PATH) === 0){
params.src_flag = 'ubuntu';
}
if (params.dest_path.indexOf(window.UBUNTU_HOME_PATH) === 0){
params.dest_flag = 'ubuntu';
}
function getPercent(ppid, isCancel) {
if (isCancel) { // 如果已經取消就不再要進度。
return;
}
var pTimeout = '';
var params2 = {};
params2.func = 'get_rotate_status';
params2.sid = UI.getSid();
params2.pid = ppid;
UI.tools.ajax({
params: params2,
url: CGI_PATH,
success: function(o) {
if (pTimeout) {
clearTimeout(pTimeout);
}
if (o.responseText) {
var r = parserJSON(o.responseText);
if (r.status === 1) { //SUCCESS
if (r.copying === 4){
reloadThumb();
showRotateFailedMsg();
}else if (r.percent === 100) {
reloadThumb();
} else {
pTimeout = setTimeout(function() {
getPercent(ppid);
}, 500);
}
} else {
reloadThumb();
showRotateFailedMsg();
}
} else {
reloadThumb();
showRotateFailedMsg();
}

},
failure: function() {
}
});
}

var info = {
url: CGI_PATH,
params: params,
success: function(res) {
var rs = parserJSON(res.responseText);
var pid = rs.pid;
if (rs.status === 1) {
getPercent(pid);
}else{
showDenyMsg();
}
},
callback: function() {
}
};
UI.tools.ajax(info);

}
/**
* media type 1:music 2:vieo 3:photo
*/
function updateToolbar() {
if (currentPlay === '--') {
return;
}
var data = getItemData(currentPlay),
rotLeftBtn = getNode(ID.ROT_LEFT_BTN), // rotate left
rotRightBtn = getNode(ID.ROT_RIGHT_BTN), // rotate right
ccBtn = Ext.getCmp(ID.CC_BTN),
resolutionBtn = UI.bottomBar.resolutionBtn,
body = getNode('body'),
pageInfo = getNode('pageInfo'),
playMode = getNode('playmode'),
toolbar = Ext.get('toolbar');

if (data === null) {
return;
}
if (data.type !== MEDIA_TYPE.PHOTO) { 	// video, music
UI.bottomBar.playerTools.show();
playerControlBar.show();

UI.fileOPMenu.getComponent(0).hide();
UI.fileOPMenu.getComponent(1).hide();
UI.fileOPMenu.getComponent(2).hide();
UI.topBar.slideShowBtn.hide();
} else { 				// photo
UI.bottomBar.playerTools.hide();
playerControlBar.hide();

UI.fileOPMenu.getComponent(0).show();
UI.fileOPMenu.getComponent(1).show();
UI.fileOPMenu.getComponent(2).show();
UI.topBar.slideShowBtn.show();
}

UI.topBar.doLayout();

if (showHdMenu && data && data.type === MEDIA_TYPE.VIDEO) {
addClass(body, 'show-hdBtn');
} else {
removeClass(body, 'show-hdBtn');
}

if (data.type === MEDIA_TYPE.VIDEO) {
ccBtn.show();
resolutionBtn.show();
if (data.subtitle >= 1) {
ccBtn.menu.setDisabled(false);
} else {
ccBtn.menu.setDisabled(true);
}
} else {
ccBtn.hide();
resolutionBtn.hide();
}

switch(data.scr_type){
case LOCAL_LIST_U:
case URL_LIST_U:
UI.topBar.streamBtn.hide();
UI.topBar.fileBtn.hide();
resolutionBtn.hide();
if (data.captions){
ccBtn.menu.setDisabled(false);
}else{
ccBtn.menu.setDisabled(true);
}
break;
default:
UI.topBar.fileBtn.show();
if (supportNMP){
UI.topBar.streamBtn.show();
}else{
UI.topBar.streamBtn.hide();
}
break;
}

var w = UI.topBar.getWidth();
if (UI.topBar.getLayout().rightTr){
w -=Ext.fly(UI.topBar.getLayout().rightTr).getWidth();
w -=UI.topBar.itemName.getEl().getMargins('l')*2;
}

UI.topBar.itemName.setWidth(w);

toolbar.setStyle({
visibility: 'visible',
left: '0px'
});
toolbar.show()
.center('list-box')
.setStyle({
top: 'auto',
bottom: 0
});

var toolBarWidth = toolbar.getWidth();

var left = (getNode('naviBar').getBoundingClientRect().width - toolBarWidth - 20) / 2;

if (left - 15 <= 0) {
getNode('fileNameDisp-id').style.width = '0px';
} else {
getNode('fileNameDisp-id').style.width = (left - 15) + 'px';
}

var bodyWidth = body.getBoundingClientRect().width;

if (left + toolBarWidth + playMode.offsetWidth + pageInfo.offsetWidth + 30 >= bodyWidth) {
playMode.style.visibility = 'hidden';
} else {
playMode.style.visibility = 'visible';
}
if (left + toolBarWidth + pageInfo.offsetWidth + 30 >= bodyWidth) {
pageInfo.style.visibility = 'hidden';
} else {
pageInfo.style.visibility = 'visible';
}
}

function prevPage() {
var listCt = Ext.get('list').parent(),
offset = listCt.getWidth();
if (listCt.getScroll().left-offset<0){
offset = listCt.getScroll().left;
}
listCt.scroll('l', -offset, true);
}

function nextPage() {
Ext.get('list').parent().scroll('l', +Ext.get('list-box').getWidth(), true);
}

function toggleBottomBar() {
Ext.getBody().toggleClass('hide-thumb');
}

function toggleBars(){
Ext.getBody().toggleClass('hide-bar-bg');
}
var fadeOutFlag = 0;
function fadeInNaviBar() {
Ext.getBody().removeClass('only-show-item');
clearTimeout(fadeOutFlag);
fadeOutFlag = setTimeout(fadeOutNaviBar, 5000);
}

function fadeOutNaviBar() {
if (Ext.getCmp(ID.RESOLUTION_MENU).isVisible() ||
Ext.getCmp(ID.DEVICE_LIST_MENU).isVisible() ||
Ext.getCmp(ID.SUBTITLE_MENU).isVisible() ||
Ext.getCmp(ID.VOLUME_MENU).isVisible() ||
UI.fileOPMenu.isVisible()
) {
return true;
}

Ext.getBody().addClass('only-show-item');
Ext.menu.MenuMgr.hideAll();
}

function resetItemLang(cmp) {
var xtype = cmp.getXType();
switch (xtype) {
case 'list':
case 'grid':
case 'editorgrid':
case 'form':
case 'panel':
case 'tabpanel':
case 'fieldset':
doLayoutList.push(cmp);
}
var _S = PARENT_WIN._S;
if (cmp.qInternational) {
switch (xtype) {
case 'paging':
case 'hidden':
return true;
break;
case 'list':
case 'grid':
case 'editorgrid':
if (cmp.colModel.config) {
Ext.each(cmp.colModel.config, function(col) {
if (col.qInternational) {
col.header = _S[col.qInternationalKey];
if (col.qInternationalFn)
col.qInternationalFn(col);
}
});
}
if (cmp.rendered) {
cmp.getView().refresh(true);
}
case 'form':
case 'panel':
case 'fieldset':
cmp.setTitle(_S[cmp.qInternationalKey]);
break;
case 'label':
if (cmp.initialConfig.html) {
if (cmp.rendered) {
cmp.update(_S[cmp.qInternationalKey]);
}
cmp.html = _S[cmp.qInternationalKey], true;
break;
}
case 'menucheckitem':
case 'menuitem':
cmp.setText(_S[cmp.qInternationalKey]);
break;
case 'radio':
case 'radiogroup':
case 'checkbox':
case 'checkboxgroup':
case 'qtscheckbox':
if (Ext.isString(cmp.qInternationalKey)) {
var key = {};
if (cmp.hideLabel) {
key.boxLabel = cmp.qInternationalKey;
} else {
key.fieldLabel = cmp.qInternationalKey;
}
cmp.qInternationalKey = key;
}
case 'button':
case 'copybtn':
if (Ext.isString(cmp.qInternationalKey)) {
var key = {
text: cmp.qInternationalKey
};
cmp.qInternationalKey = key;
}
case 'combo':
case 'compositefield':
case 'textfield':
case 'textarea':
case 'numberfield':
case 'textfieldSNMPpc':
case 'textfieldSNMPpr':
case 'textfieldSNMPpa':
case 'displayfield':
case 'fileuploadfield':
case 'container':
if (Ext.isString(cmp.qInternationalKey)) {
var key = {};
if (cmp.hideLabel) {
key.value = cmp.qInternationalKey;
} else {
key.fieldLabel = cmp.qInternationalKey;
}
cmp.qInternationalKey = key;
}
for (var key in cmp.qInternationalKey) {
cmp[key] = _S[cmp.qInternationalKey[key]];
}
if (cmp.rendered && Ext.isObject(cmp.qInternationalKey)) {
cmp.el.hasClass(cmp.emptyClass) ? cmp.reset() : null;

cmp.qInternationalKey.boxLabel ?
cmp.wrap.child('.x-form-cb-label').update(_S[cmp.qInternationalKey.boxLabel]) : null;

if (cmp.emptyText && cmp.applyEmptyText) {
cmp.applyEmptyText();
}

if (cmp.qInternationalKey.text) {
cmp.setText(_S[cmp.qInternationalKey.text]);
}

if (cmp.qInternationalKey.value) {
cmp.setValue(_S[cmp.qInternationalKey.value]);
cmp.originalValue = cmp.getValue();
}

if (cmp.label) {
cmp.qInternationalKey.fieldLabel ? cmp.label.update(_S[cmp.qInternationalKey.fieldLabel] + (Ext.isString(cmp.labelSeparator) ? cmp.labelSeparator : cmp.ownerCt.layout.labelSeparator)) : null;
}
}
break;
case 'treepanel':
cmp.getRootNode().findChildBy(function(c) {
if (c.attributes.qInternational) {
c.setText(_S[c.attributes.qInternationalKey]);
}
}, null, true);
break;
case 'treegrid':
cmp.setTitle(_S[cmp.qInternationalKey]);
Ext.each(cmp.columns, function(column) {
column.qInternational ? column.header = _S[column.qInternationalKey] : null;
if (column.qInternationalFn) {
column.qInternationalFn(column);
}
});
cmp.refresh();
break;
case 'QShortcutsViewV2':
case 'QSideMenu':
case 'dataview':
case 'listview':
case 'shortcutsview':
cmp.rendered ? cmp.refresh() : null;
break;
default:
_D(cmp.getXType(), cmp.id);
break;
}
if (cmp.qInternationalFn) {
cmp.qInternationalFn(cmp);
}
if (cmp.validate) {
cmp.validate();
}
}
}

function resetLang() {
Ext.ComponentMgr.all.each(function(cmp) {
try {
resetItemLang(cmp);
} catch (e) {
_D('[Err] changeLangs faile', cmp, e);
}
});
updateUITip();
}

function updateUITip() {
var _S = PARENT_WIN._S;
var playBtn = getNode(ID.PLAY_BTN_2),
pauseBtn = getNode(ID.PAUSE_BTN_2),
rotLeftBtn = getNode(ID.ROT_LEFT_BTN), // rotate left
rotRightBtn = getNode(ID.ROT_RIGHT_BTN), // rotate right
prevBtn = getNode(ID.PREV_BTN_2),
nextBtn = getNode(ID.NEXT_BTN_2),
downloadBtn = getNode(ID.DOWNLOAD_BTN),
delBtn = getNode(ID.DEL_BTN),
toggleBtn = getNode(ID.TOGGLE_BTN);



playBtn.title = _S._SFE_LANG_COMMON_PLAY_2;
pauseBtn.title = _S._SFE_LANG_COMMON_PAUSE;

rotLeftBtn.title = _S._LANG_MSSTR_061;
rotRightBtn.title = _S._LANG_MSSTR_062;

prevBtn.title = _S._SFE_LANG_COMMON_PREVIOUS;
nextBtn.title = _S._SFE_LANG_COMMON_NEXT;

downloadBtn.title = _S._SFE_LANG_ACTION_DOWNLOAD_TITLE;
delBtn.title = _S._SFE_LANG_ACTION_DEL_TITLE;

toggleBtn.title = _S._SFE_LANG_COMMON_PREVIEW;

Ext.get('rotLeftBtn').set({
'title': _S._SFE_LANG_MSSTR_061
});
Ext.get('rotRightBtn').set({
'title': _S._SFE_LANG_MSSTR_062
});
Ext.get('fullScrn-id').set({
'title': _S._SFE_LANG_PS_FULL_STARAT
});
Ext.get('exitFullScrn-id').set({
'title': _S._SFE_LANG_PS_FULL_EXIT
});
Ext.get('slideBtn').set({
'title': _S._SFE_LANG_MSSTR_153
});
Ext.get('streamBtn').set({
'title': _S._SFE_LANG_LAN_DEVICES
});
Ext.select('.del-cls').set({
'title': _S._SFE_LANG_ACTION_DEL_TITLE
});
Ext.select('.download-cls').set({
'title': _S._SFE_LANG_ACTION_DOWNLOAD_TITLE
});
Ext.select('.pre-cls').set({
'title': _S._SFE_LANG_COMMON_PREVIOUS
});
Ext.select('.next-cls').set({
'title': _S._SFE_LANG_COMMON_NEXT
});

var qKey = '';
Ext.select('[data-qKey]').each(function(el) {
qKey = el.getAttribute('data-qKey');
el.title = _S['_SFE' + qKey] || qKey;
el.update(el.title);
});


}
/*-----------------------------------------------------------------------------*\
**	      ## ##      ## ########  ##          ###    ##    ## ######## ########
**	      ## ##  ##  ## ##     ## ##         ## ##    ##  ##  ##       ##     ##
**	      ## ##  ##  ## ##     ## ##        ##   ##    ####   ##       ##     ##
**	      ## ##  ##  ## ########  ##       ##     ##    ##    ######   ########
**	##    ## ##  ##  ## ##        ##       #########    ##    ##       ##   ##
**	##    ## ##  ##  ## ##        ##       ##     ##    ##    ##       ##    ##
**	 ######   ###  ###  ##        ######## ##     ##    ##    ######## ##     ##
\*-----------------------------------------------------------------------------*/

function preSetupPlalyer(playlist, type, keepPlayer) {
if (jwplayer() && jwplayer().remove) {
try {
if (keepPlayer !== true) {
jwplayer().pause(true);
Ext.fly('qDisplayIcon').removeClass('show');
jwplayer().stop();
jwplayer().remove();
}
} catch (ex) {

}
player = undefined;
}
if (playlist.sources.length === 0) {
updateToolbar();
updateQualityMenu([playlist]);
showPlayerErrorMsg();
return;
}
setupPlayer([playlist], type, keepPlayer);
}

function setupPlayer(playlist, mediaType, keepPlayer) {
clearTimeout(autoPlayFlag);
document.getElementById('photoArea-id').style.display = "none";
playlist[0].sources.reverse();
qualityLevel.reverse();

UI.setCookie('jwplayer.qualityLabel', '');
var itemData = getItemData(currentPlay);
if (showHdMenu && itemData && itemData.type === 2) {
addClass(getNode('body'), 'show-hdBtn');
} else {
removeClass(getNode('body'), 'show-hdBtn');
}

updateQualityMenu(playlist);
updateToolbar();
updatePlayMode();
var primaryRender = /rtt|-R/i.test(currentQuilty) ? 'flash' : 'html5';// rtt, 1080-R, etc...
if (playlist[0].type === 'mp3'){
primaryRender = 'html5';
}
var playerCfg = {
logo: IMG.DEF_THUMB,
width: '100%',
height: '100%',
playlist: playlist,
bgcolor: '#636363',
wmode: 'transparent',
primary: primaryRender,
fallback: false,
flashplayer: '/cgi-bin/apps/mediaViewer/jwplayer/jwplayer.flash.swf?' + URL_RANDOM_NUM,
fullscreen: true,
controls: false,
autostart: true,
analytics: {
enabled: false,
cookies: false
},
captions: {
back: false,
color: "EEEEEE",
fontsize: 13,
fontfamily: "Verdana,Tahoma,Arial,Helvetica,sans-serif",
edgeStyle: "dropshadow" //none, dropshadow, raised, depressed, uniform
}
};

if (mediaType === Viewer.MEDIA_TYPE.AUDIO) {
playerCfg.skin = '/cgi-bin/apps/mediaViewer/jwplayer/skin/audio.xml?' + URL_RANDOM_NUM;
getNode('mediacontainer').style.backgroundImage = "url('" + playlist[0].image + "')";
} else {
playerCfg.skin = '/cgi-bin/apps/mediaViewer/jwplayer/skin/video.xml?' + URL_RANDOM_NUM;
getNode('mediacontainer').style.backgroundImage = "none";
}

player = Viewer.getPlayer(ID.CURTAIN);
firstTimePlay = true;
if (keepPlayer === true) {
player.load(playlist);
} else if (!player.getState()) {
if (!/(webkit|Mozilla|MSIE)/i.test(navigator.userAgent.toLowerCase()) && !supportFlash) {
showInstallFlash();
return;
}
jwplayerIsready = false;

removeClass(getNode(ID.CURTAIN), 'hide');
addClass(getNode(ID.INSTALL_EL), 'hide');

Viewer.setPlayerCfg(ID.CURTAIN, playerCfg);
player = jwplayer();
playerControlBar.setDuration(playlist[0].duration, true);
playerControlBar.isRTT = /rtt|-R/i.test(currentQuilty);

if (playlist[0].type === 'mp3'){
playerControlBar.isRTT = false;
}

if (playerControlBar.isRTT) {
playerControlBar.startSec = lastPosition;
} else {
playerControlBar.startSec = 0;
}
playerControlBar.onPause();
player.onReady(showControlBar);

if (player.onSetupError) {
player.onSetupError(function() {
jwplayerIsready = true;
if (!supportFlash) {
showInstallFlash();
}
});
}

player.onError(function() {
jwplayerIsready = true;
var playList = player.getPlaylist(),
quality = player.getCurrentQuality(),
filePath = playList[0].sources[quality].file;

if (/rtt=3/.test(filePath)) {
showPlayerErrorMsg();
} else if (!/(rtt=1|s=)/.test(filePath) && supportFlash && supportRTT) {
UI.setCookie('jwplayer.qualityLabel', '');
playIt(getItemData(currentPlay), true);
} else {
showPlayerErrorMsg();
}
});

player.onPlay(function() {

if (firstTimePlay) {
resizeCurtain();
firstTimePlay = false;
if (player.getPlaylist()[0].type === 'mp4') {
player.seek(lastPosition);
}
}

onMute({mute: player.getMute()});

Ext.get('curtain').on({
buffer:500,
mousemove: function( e, t, o) {
var el = Ext.get(this);
var eventXY = e.getXY();
if (eventXY[0] === el.lastMouseXY[0] &&
eventXY[1] === el.lastMouseXY[1]){
return ;
}
playerControlBar.fadeIn();
el.lastMouseXY=eventXY;
}
});

Ext.get('curtain').lastMouseXY=[-1,-1];

Ext.fly('loadingMsg2').removeClass('show');

playerControlBar.show();
Ext.fly('qDisplayIcon')
.addClass('pause')
.show()
.child('.displayIcon')
.set({
'ext:qtip':'_SFE_LANG_COMMON_PAUSE'
});

if (currentPlay) {
var newEl = getItemEl(currentPlay);
removeClass(newEl, 'paused');
lastPlayEl = newEl;
}
hideListDelay = setTimeout(function() {
hideList();
}, 2000);
var playList = this.getPlaylist();
var mediaItem = playList[0];
/**
* get CurrentQuality label
*/
var label = player.getPlaylist()[0].sources[player.getCurrentQuality()].label;
syncSelectedQuality(label);
if (mmCodex === 0 && mediaItem.type === 'sound' && !/.*\.mp3$/i.test(mediaItem.title)) {
var app = PARENT_WIN.os.getAppInstancesByAppId('MediaViewer')[0];

var msg = PARENT_WIN._S._SFE_LANG_COMMON_MMCODEX;
msg = msg.replace('</qtag>', '</a>').replace('<qtag>', '<a href="#" class="qpkg-mmcodex">');
var alertWin = app._alert(null, msg, null, null, function() {});
alertWin.el.child('a.qpkg-mmcodex').on('click', function() {
qMessageClient.fn.installCodexPack();
});
this.stop();
}
playerControlBar.onPlay.apply(playerControlBar, arguments);
updateCaption();
Ext.fly('qDisplayIcon').removeClass('show');
Ext.QuickTips.getQuickTip().hide();
});

player.onPause(function() {
if (currentPlay) {
var el = getItemEl(currentPlay);
lastPlayEl = el;
addClass(el, 'paused');
}
initDisplayIcon();
Ext.fly('qDisplayIcon')
.removeClass('pause')
.child('.displayIcon')
.set({
'ext:qtip':'_SFE_LANG_COMMON_PLAY'
});
clearTimeout(hideListDelay);
setTimeout(function() {
showList();
}, 200);
playerControlBar.onPause.apply(playerControlBar, arguments);
Ext.QuickTips.getQuickTip().hide();
});

player.onMute(function(mute) {
playerControlBar.onMute.apply(playerControlBar, arguments);
onMute(mute);
});

player.onBuffer(function() {
playerControlBar.onBuffer.apply(playerControlBar, arguments);
});

player.onBufferChange(function() {
playerControlBar.onBuffer.apply(playerControlBar, arguments);
});

player.onPlaylistItem(function() {
if (player.getPlaylist()[0].type === 'mp4') {
player.seek(lastPosition);
}
Ext.fly('loadingMsg2').removeClass('show');
});

player.onQualityChange(function(e) {
defaultQuilty = String(qualityLevel[e.currentQuality]);
playIt(getItemData(currentPlay), true);
});

player.onBeforePlay(function() {
if (player.isCompleted && playerControlBar.isRTT) {
player.pause(true);
UI.resetQuilty(null, lastPosition, null, true);
}
player.isCompleted = false;
});

player.onPlaylistComplete(function() {
player.isCompleted = true;
lastPosition = 0;
subtitlePosition = 0;
playerControlBar.startSec = 0;
playerControlBar.onPause.apply(playerControlBar, arguments);
Ext.get('mediacontainer').setStyle('backgroundImage', "url('" + getThumbPath(getItemData(currentPlay)) + "')");
Ext.fly('qDisplayIcon')
.removeClass('pause')
.child('.displayIcon')
.set({
'ext:qtip':'_SFE_LANG_COMMON_PLAY'
});
playerControlBar.onPlaylistComplete.apply(playerControlBar, arguments);
});

player.onTime(function(e) {
if (++upDateCount === 500) {
PARENT_WIN.os.pingNas();
upDateCount = 0;
}
playerControlBar.onTime.apply(playerControlBar, arguments);
});

player.onSeek(function() {});

player.onComplete(jwplayerComplete);

player.onVolume(function(volume) {
playerControlBar.onVolume.apply(playerControlBar, arguments);
if (volume>50){
Ext.getBody().replaceClass('volume-s','volume-l');
}else{
Ext.getBody().replaceClass('volume-l','volume-s');
}
});

var loadingMsg = Ext.get('loadingMsg2');
if (loadingMsg) {
loadingMsg.addClass('show');
loadingMsg.update(PARENT_WIN._S._SFE_LANG_COMMON_LOADING_MSG + '...');
} else {
loadingMsg = document.createElement('div');
loadingMsg.setAttribute('id', 'loadingMsg2');
loadingMsg.innerHTML = PARENT_WIN._S._SFE_LANG_COMMON_LOADING_MSG + '...';
addClass(loadingMsg, 'loadingMsg show');
document.getElementById('mediacontainer').appendChild(loadingMsg);
}
}
resetImageSize();
UI.setListPosition(UI.getCurrentIndex());
autoPlayFlag = setTimeout(function() {
UI.autoPlay();
}, 5000);
}

function onMute(e){
if (e.mute){
Ext.getBody().addClass('volume-mute');
}else{
Ext.getBody().removeClass('volume-mute');
}

}
/*-----------------------------------------------------------------------------*\
**	########  ##       ##    ##    ###
**	##     ## ##       ###   ##   ## ##
**	##     ## ##       ####  ##  ##   ##
**	##     ## ##       ## ## ## ##     ##
**	##     ## ##       ##  #### #########
**	##     ## ##       ##   ### ##     ##
**	########  ######## ##    ## ##     ##
\*-----------------------------------------------------------------------------*/
function showStreamMenu() {
}

function showStreamUI(config) {
var appCfg = {
appId: 'MediaViewer',
config: config
};
switch (dataSrc) {
case LOCAL_LIST_L:
case URL_LIST_L:
break;
case FOLDER:
break;
case FILE:
appCfg.config.keepAppend = false;
break;
}
if (isSinglePage){
app.activeApp(appCfg.config);
}else{
qMessageClient.fn.openApp(appCfg);
}
}

/*-----------------------------------------------------------------------------*\
**	   ###    ########  ########     ######## ##    ##
**	  ## ##   ##     ## ##     ##    ##       ###   ##
**	 ##   ##  ##     ## ##     ##    ##       ####  ##
**	##     ## ########  ########     ######   ## ## ##
**	######### ##        ##           ##       ##  ####
**	##     ## ##        ##           ##       ##   ###
**	##     ## ##        ##           ##       ##    ##
\*-----------------------------------------------------------------------------*/

function isFullScreen() {
return window.app.isFullScreen();
}

function showInstallMediaAddOnConfirm() {
var _S, title, msg;
var alertWin, items, fbar;

_S = PARENT_WIN._S;
title = _S._SFE_LANG_MEDIA_09;
msg = _S._SFE_LANG_MSG_INSTALL_STREAMING_ADD_ON;
if (!isSinglePage) {
msg = msg.replace('</qtag>', '</a>').replace('<qtag>', '<a href="#" class="qpkg-mmcodex">');
}
if (!PARENT_WIN.os.getQPKG('QDMS') && window.localStorage.FS_QDMSHinted !== 'true') {
items = {
xtype: 'container',
layout: 'qts-form',
items: [{
xtype: 'label',
ref: '../messageLabel',
html: msg,
qInternational: true,
qInternationalFn: function () {
var msg = PARENT_WIN._S._SFE_LANG_MSG_INSTALL_STREAMING_ADD_ON;
if (!isSinglePage) {
msg = msg.replace('</qtag>', '</a>').replace('<qtag>', '<a href="#" class="qpkg-mmcodex">');
}
this.setText(msg, false);
},
}, {
xtype: 'qtscheckbox',
ref: '../dontShowChk',
hideLabel: true,
qInternational: true,
qInternationalKey: {
boxLabel: '_SFE_LANG_ACL_ALERT_MSG02'
},
boxLabel: _S._SFE_LANG_ACL_ALERT_MSG02,
inputValue: '1'
}],
listeners: {
afterrender: function () {
this.initQDMSLink();
},
single: true
},
initQDMSLink: function () {
this.el.on({
click: function () {
qMessageClient.fn.openApp({
appId: 'qpkg',
config: {
config: {
install: 'QDMS',
all: true,
runMore: true
}
}
});
},
delegate: '.qpkg-mmcodex'
});
}
};

fbar = [{
xtype: 'qtsbutton',
text: _S._SFE_LANG_COMMON_OK,
qInternational: true,
qInternationalFn: function () {
this.setText(PARENT_WIN._S._SFE_LANG_COMMON_OK);
},
handler: function (btn) {
var win = btn.ownerCt.ownerCt;
win.close();
},
scope: this
}];

alertWin = app._msgWindow('_SFE_LANG_MEDIA_09', items, fbar).show();
alertWin.on({
beforeclose: function (win) {
if (win.dontShowChk.getValue()) {
window.localStorage.FS_QDMSHinted = true;
}
}
});
}
}

return {
fadeInNaviBar: fadeInNaviBar,
fadeOutNaviBar: fadeOutNaviBar,
resetQuilty: resetQuilty,
seek: seek,
updateUITip: updateUITip,
resetLang:resetLang,
getMultiMediaType: function(fileName) {
var isPhoto = /\.(jpg|jpeg|gif|png|tif|tiff|bmp)$/i.test(fileName);
var isVideo = /\.(avi|m2ts|mpg|mp4|wmv|ts|tp|asf|m2t|mov|mod|m2v|mpeg|3gp|mkv|mts|tod|trp|m1v|m4v|rmp4|divx|flv|rmvb|rm)$/i
.test(fileName);
var isAudio = /\.(mp3|aac|wav|wma|flac|ape|dts|m4a|ogg|ac3|aiff|au)$/i
.test(fileName);
if (isVideo) {
return 'isVideo';
} else if (isAudio) {
return 'isAudio';
} else if (isPhoto) {
return 'isPhoto';
} else {
return 'notMultiMedia';
}
},
setListPosition: function(index) { //index:第幾個item
var playlist = document.getElementById('list');
if (index >= playlist.childNodes.length || index < 0) {
return false;
}

var itemRect = playlist.childNodes[index].getBoundingClientRect();
var center = (getNode('body').getBoundingClientRect().width - itemRect.width) / 2;

var scrollTarget = playlist.parentNode.scrollLeft + itemRect.left - center;
var scrollOrigin = playlist.parentNode.scrollLeft;

var timeGap = 300;
var endTime = new Date().getTime() + timeGap;
var startTime = new Date().getTime();
clearInterval(scrollAnim);
scrollAnim = setInterval(function() {
var currentTime = new Date().getTime();
playlist.parentNode['data-jsScroll'] = true;
if (currentTime > endTime) {
clearInterval(scrollAnim);
playlist.parentNode.scrollLeft = scrollTarget;
setTimeout(function() {
playlist.parentNode['data-jsScroll'] = false;
playlist.parentNode['data-lastScrollByJs'] = true;
}, 10);

} else {
playlist.parentNode.scrollLeft = scrollOrigin + (scrollTarget - scrollOrigin) * ((currentTime - startTime) / timeGap);
}
}, 10);

playlist['data-index'] = index;
return true;
},
scrollList: function(dir) { //index:第幾個item
var playlist = document.getElementById('list');
var itemRect = playlist.childNodes[0].getBoundingClientRect();
var center = (getNode('body').getBoundingClientRect().width - itemRect.width) / 2;

var scrollOrigin = playlist.parentNode.scrollLeft;
var scrollTarget = scrollOrigin;
if(dir==='l'){
scrollTarget+=itemRect.width*4;
}else{
scrollTarget-=itemRect.width*4;
}

var timeGap = 300;
var endTime = new Date().getTime() + timeGap;
var startTime = new Date().getTime();
clearInterval(scrollAnim);
scrollAnim = setInterval(function() {
var currentTime = new Date().getTime();
playlist.parentNode['data-jsScroll'] = true;
if (currentTime > endTime) {
clearInterval(scrollAnim);
playlist.parentNode.scrollLeft = scrollTarget;
setTimeout(function() {
playlist.parentNode['data-jsScroll'] = false;
playlist.parentNode['data-lastScrollByJs'] = true;
}, 10);
} else {
playlist.parentNode.scrollLeft = scrollOrigin + (scrollTarget - scrollOrigin) * ((currentTime - startTime) / timeGap);
}
}, 10);
return true;
},
setCurrentIndex: function(index) {
currentIndeNum = index;
},
getCurrentIndex: function() {
return currentIndeNum;
},
setList: setList,
setPath: function(_path) {
path = _path;
},
getPath: function() {
return path;
},
setSid: function(_sid) {
sid = _sid;
},
getSid: function() {
return sid;
},
setFile: function(_file) {
var node = getNode('fileNameDisp-id');
node.title = node.innerHTML = _file;
file = _file;
this.topBar.itemName.update(_file);
this.bottomBar.itemName.update(_file);
},
getFile: function() {
return file;
},
/**
* only load filepath content
*/
setFilePath: function (){

},
setFileData: function(_fileData) {
fileData = _fileData;
},
getFileData: function() {
return fileData;
},
setType: function(_type) {
type = _type;
},
getType: function() {
return type;
},
setSupportRTT: function(_supportRTT) {
supportRTT = supportFlash && _supportRTT;
},
setSupportNMP: function (_supportNMP){
supportNMP = _supportNMP;
UI.topBar.streamBtn.setVisible(supportNMP);
},
setSort: function(_sort) {
sort = _sort || "mt";
},
getSort: function() {
return sort;
},
setSortDir: function(_dir) {
direction = _dir || "ASC";
},
getSortDir: function() {
return direction;
},
setMmCodex: function(_mmCodex) {
mmCodex = _mmCodex || 0;
},
isSupportRTT: function() {
return supportRTT;
},
setSinglePage: function (_isSinglePage){
isSinglePage = !!_isSinglePage;
},
download: download,
updateListPosition: updateListPosition,
showControlBar: showControlBar,
hideControlBar: hideControlBar,
getCookie: getCookie,
setCookie: setCookie,
initEvent: initEvent,
loadList: loadList,
addEvent: addEvent,
initUI: initUI,
showInstallFlash: showInstallFlash,
testFlash: testFlash,
setDefaultQuilty: function(_defaultQuilty, save) {
defaultQuilty = String(_defaultQuilty);
if (save !== false) {
if (window.localStorage) {
window.localStorage['video_play_res'] = defaultQuilty;
}
}
},
setRttString: function(_rttString) {
rttString = _rttString;
},
setIsAutoPlay: function(autoPlay) {
if (isAutoPlay != autoPlay){
if (autoPlay) {
notify.fireEvent('startautoplay');
} else {
notify.fireEvent('stopautoplay');
}
}
isAutoPlay = autoPlay
},
showHdMenu: function(_showHdMenu) {
showHdMenu = _showHdMenu;
},
getIsAutoPlay: function() {
return isAutoPlay;
},
autoPlay: function() {
var me = this,
cidx = this.getCurrentIndex(),
nextItem = document.getElementById('list').childNodes[cidx + 1],
skipAutoPlay = false;
clearTimeout(autoPlayFlag);
if (player) {
switch (jwplayer().getState()) {
case 'BUFFERING':
case 'PLAYING':
case 'PAUSED':
skipAutoPlay = true;
break;
}
}

if (nextItem && me.getIsAutoPlay() && !skipAutoPlay) {
loadItem({
target: nextItem
});
}
if (!nextItem) {
if (totalCount-1>cidx){
checkListAllLoaded(true); // after
}else{
this.setIsAutoPlay(false);
}
}

autoPlayFlag = setTimeout(function() {
me.autoPlay();
}, 5000);
},
rotate: rotate,
nextItem: function(index) {
var itemEls = document.getElementsByClassName('item');
if (itemEls.length === 0){
cleanCurtain();
return;
}
if (index >= 0) {
itemEls[index].click();
UI.setCurrentIndex(index);
} else {
var nextItem = document.getElementsByClassName('current-item')[0].nextElementSibling;
if (nextItem) {
var node = nextItem.childNodes[0].childNodes[1];
loadItem({
target: node
});
}
}
fadeInNaviBar();
},
previousItem: function() {
var preItem = document.getElementsByClassName('current-item')[0].previousSibling;
try {
var node = preItem.childNodes[0].childNodes[1];
loadItem({
target: node
});
} catch (e) {
}
fadeInNaviBar();
},
del: delItem,
toggleList: function() {
var btn = getNode('toggleBtn'),
thumbList = getNode('list');

if (listVisible) {
addClass(btn, 'showList-cls');
removeClass(btn, 'hideList-cls');
thumbList.parentNode.style.height = 0;
} else {
addClass(btn, 'hideList-cls');
removeClass(btn, 'showList-cls');
thumbList.parentNode.style.height = thumbList.offsetHeight + 'px';
}
listVisible = !listVisible;
resetImageSize();
},
resetImageSize: resetImageSize,
streamCfg: streamCfg,
onLoadDevice: onLoadDevice,
onUpdateDevice:onUpdateDevice,
onBeforeLoadDevice: onBeforeLoadDevice,
tools: {
getAjaxReq: function() {
var ajaxReq = false;
if (window.XMLHttpRequest) {
ajaxReq = new XMLHttpRequest();
} else {
ajaxReq = new ActiveXObject("Microsoft.XMLHTTP");
}
return ajaxReq;
},
ajaxResponse: function(option) {
var success = option.success;
var failure = option.failure;
var callback = option.callback;
if (this.readyState === 4) {
try {
if (this.status === 200) {
if (typeof(success) === 'function') {
success.call(this, this);
}
} else {
if (typeof(failure) === 'function') {
failure.call(this, this);
}
}
} catch (e) {
console.error("ajax err: ", e.message);
}
if (typeof(callback) === 'function') {
callback.call(this, this);
}
}
},
ajax: function(opt) {
var ajaxReq = UI.tools.getAjaxReq();
var url = opt.url;
var method = opt.method === 'GET' ? 'GET' : 'POST';
var params = opt.params || '';
params = getParamsStr(params);
if (method === 'GET') {
url += '?' + params + '&r=' + Math.random();
ajaxReq.open(method, url, true);
ajaxReq.onreadystatechange = function() {
UI.tools.ajaxResponse.call(ajaxReq, opt);
};
ajaxReq.send();
} else {
ajaxReq.open(method, url, true);
ajaxReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
ajaxReq.onreadystatechange = function() {
UI.tools.ajaxResponse.call(ajaxReq, opt);
};
ajaxReq.send(params + 'r=' + Math.random());
}
return ajaxReq;
},
getMainThumb: function(fileSize) {
var fileData = UI.getFileData();
var imgurl = 'sid=' +
UI.getSid() +
'&func=get_thumb&path=' + encodeURIComponent(UI.getPath()) +
'&name=' + encodeURIComponent(fileData.fileName) +
'&size=' + fileSize +
'&radno=' + fileData.fileSize + fileData.mt +
'&r=' + Math.random()+
'&option=1';
if (UI.getPath().indexOf(window.UBUNTU_HOME_PATH) === 0){
imgurl+= '&src_flag=ubuntu';
}
var maxValue = 'max-width: ' + (document.width - 30).toString() + 'px;max-height: ' + (document.height - 200).toString() + 'px;';
return '<img src="' + CGI_PATH + '?' + imgurl + '" style="width: auto; height:auto;' + maxValue + '"/>';
}
},
/**
* FILE_STATION = File Sataion
* FILE_PATH    = file path
* LIST         = list path
*/
setDataSrc: function (_src){
switch(_src){
case LOCAL_LIST_L:
case LOCAL_LIST_U:
case URL_LIST_L:
case FOLDER:
case FILE:
dataSrc = _src;
break;
default:
return;
}

/**
* if data source is frome FOLDER or FILE,
* I will load file data by File staiton CGI.
*
* if data source is from remote list, list content must incloude
* file mate data, like width, height, tanscode info.
*
*/
switch (dataSrc) {
case LOCAL_LIST_U:
UI.setCurrentIndex(0);
if (method==='ajax'){
loadURLList();
}else if (method==='jsonp'){
Ext.Loader.load([listPath],parserListFinish,this);
}
break;
case LOCAL_LIST_L:
if (method==='ajax'){
loadLocalList();
}else if (method==='jsonp'){
Ext.Loader.load([listPath],parserListFinish,this);
}
break;
case FOLDER:
loadList();
break;
case FILE:
loadList(null, undefined, 1);
Ext.getBody().addClass('single-file-view');
toggleBars();
break;
}
},
setListPath:setListPath,
loadFilePathWithoutSid:loadFilePathWithoutSid,
parserLocalList:parserLocalList,
useJsonp: function (){
method = 'jsonp';
}
};
})();
window.parserLocalList = UI.parserLocalList;
Ext.onReady(function() {
domLoaded();
});
Ext.ns('QNAP.CMP.Plugin');
QNAP.CMP.Plugin.QTSScrollBar = function (cfg){
var target = cfg.target;
function updateSize(){
var targetDom = target.dom;
target.scrollScale = targetDom.clientHeight / targetDom.scrollHeight;
scrollBar.setDisplayed(target.scrollScale !== 1);
scrollBar.alignTo(target,'tr-tr');
scrollBar.setHeight(target.getHeight());
scrollThumb.setHeight(Math.floor(target.scrollScale * targetDom.clientHeight));
scrollThumb.setHeight(scrollThumb.getHeight());
scrollBar.maxTop = scrollBar.getHeight() - scrollThumb.getHeight();
scrollBar.setStyle('z-index',target.getStyle('z-index'));
onScroll();
}

function initEvent(){
target.on('mouseenter', function() {
scrollBar.addClass('scrollbar-over');
});
target.on('mouseleave',function (){
scrollBar.removeClass('scrollbar-over');
});
target.on('touchstart',function (){
scrollBar.addClass('scrollbar-over');
});
target.on('touchend',function (){
scrollBar.removeClass('scrollbar-over');
});
target.on('resize', updateSize);
target.on('scroll', onScroll);
if (Ext.isMac){
target.on('wheel', onWheel, null, {normalized:false});
}else if (Ext.isIE){
target.on('mousewheel', onIEWheel, null, {normalized:false});
}else if (Ext.isGecko){
target.on('wheel', onFFWheel, null, {normalized:false});
}else{
target.on('wheel', onWheel, null, {normalized:false});
}

scrollBar.on('click', function(e) {
e.stopEvent();
mouseClick(e);
});
}

function onScroll(){
var scroll = target.getScroll();
var newTop = Math.min(Math.floor(target.scrollScale * scroll.top), scrollBar.maxTop);
scrollThumb.setTop(newTop);
}

function onIEWheel (event) {
var scroll = target.getScroll();
target.scrollTo('Top', scroll.top + (-event.wheelDelta));
}

function onFFWheel (event){
var scroll = target.getScroll();
target.scrollTo('Top', scroll.top + event.deltaY*33);
}

function onWheel(event){
var scroll = target.getScroll();
target.scrollTo('Top', scroll.top + event.deltaY);
}

function mouseClick(e) {
if (!e.within(scrollThumb)) {
var thumbTop = scrollThumb.getTop(true),
thumbHeight = scrollThumb.getHeight();

var cursorY = e.getPageY()-scrollBar.getTop();
var offset = Math.ceil(Math.abs(thumbTop-cursorY)/thumbHeight);
if (thumbTop<cursorY){
offset = (offset-1)*-1;
}else{
offset = offset*1;
}
var scrollOffset  =  offset * thumbHeight / target.scrollScale;
target.scroll('t', scrollOffset);
}
}

function initDD(){
var dd = new Ext.dd.DD(scrollThumb.id, scroll);
dd.setXConstraint(0, 0, 0);
dd.onDrag = function(e) {

var scrollT = parseInt((target.getHeight()) *
scrollThumb.getTop(true) / scrollThumb.getHeight());

var scrollT2=target.dom.scrollHeight * (scrollThumb.getTop(true)/target.getHeight())

target.scrollTo('Top', scrollT2);
};

dd.startDrag = function() {
this.constrainTo(scrollBar,1);
scrollBar.addClass('drag');
if (Ext.isFunction(cfg.startDrag)){
cfg.startDrag();
}
}
dd.endDrag = function (){
scrollBar.removeClass('drag');
if (Ext.isFunction(cfg.endDrag)){
cfg.endDrag();
}
}
this.dd = dd;
}

function hide(){
scrollBar.hide();
}

function show(){
scrollBar.show();
}

var target = cfg.target;
target.addClass('overflow-hidden');

var id = Ext.id(null,'qts-scrollbar-');
var scrollTpl = new Ext.XTemplate(
'<div class="qts-scrollbar scrollbar-track ' + (cfg.cls?cfg.cls:'') + '" id="'+ id +'" >' +
'<div class="scrollbar-thumb " id="'+id+'-thubm'+'" ></div>' +
'</div>');
var scrollBar   = scrollTpl.insertAfter(target, null, true);
var scrollThumb = scrollBar.child('.scrollbar-thumb');
scrollBar.addClassOnOver('scrollbar-over');

updateSize();
initDD();
initEvent();
this.target = target;
this.scrollBar = scrollBar;
this.updateSize = updateSize;
this.hide=hide;
this.show=show;
}
Ext.override(Ext.menu.Item,{
onRender : function(container, position){
if (Ext.isEmpty(this.iconCls)) {
this.itemCls += ' x-menu-item--no-icon';
}
if (!this.itemTpl) {
this.itemTpl = Ext.menu.Item.prototype.itemTpl = new Ext.XTemplate(
'<a id="{id}" class="{cls} x-unselectable" hidefocus="true" unselectable="on" href="{href}"',
'<tpl if="hrefTarget">',
' target="{hrefTarget}"',
'</tpl>',
'>',
'<img src="{Ext.BLANK_IMAGE_URL}" class="q-menu-item-sataus-icon "/><img alt="{altText}" src="{icon}" class="x-menu-item-icon {iconCls}"/>',
'<span class="x-menu-item-text">{text}</span>',
'</a>'
);
}
var a = this.getTemplateArgs();
this.el = position ? this.itemTpl.insertBefore(position, a, true) : this.itemTpl.append(container, a, true);
this.iconEl = this.el.child('img.x-menu-item-icon');
this.textEl = this.el.child('.x-menu-item-text');
if(!this.href) { // if no link defined, prevent the default anchor event
this.mon(this.el, 'click', Ext.emptyFn, null, { preventDefault: true });
}
Ext.menu.Item.superclass.onRender.call(this, container, position);
},
setIconClass : function(cls){
var oldCls = this.iconCls;
this.iconCls = cls;
if(this.rendered){
this.iconEl.replaceClass(oldCls, this.iconCls);
if (this.iconCls!==''){
this.el.addClass('x-menu-item--no-icon');
}else{
this.el.removeClass('x-menu-item--no-icon');
}
}
},
initComponent : function(){
Ext.menu.Item.superclass.initComponent.call(this);
if(this.menu){
if (Ext.isArray(this.menu)){
this.menu = { items: this.menu };
}

if (Ext.isObject(this.menu)){
this.menu.ownerCt = this;
}
this.menu = Ext.menu.MenuMgr.get(this.menu);
this.menu.ownerCt = undefined;
this.mon(this.menu,'show',function (){
if (this.container){
this.container.addClass('x-menu-item-expand');
}
},this);
this.mon(this.menu,'hide',function (){
if (this.container){
this.container.removeClass('x-menu-item-expand');
}
},this);
}
}
});
Ext.override(Ext.menu.Menu, {
shadow: false,
cls:'qnap-menu-v2 qnap-block--white',
afterRender: function() {
Ext.menu.Menu.superclass.afterRender.call(this);
var target = this.getEl();
if (Ext.isMac) {
target.on('wheel', this.onWheel, this, {
normalized: false,
buffer:{
delay:100,
throttle:100
}
});
} else if (Ext.isIE) {
target.on('mousewheel', this.onIEWheel, this, {
normalized: false,
buffer:{
delay:100,
throttle:100
}
});
} else if (Ext.isGecko) {
target.on('wheel', this.onFFWheel, this, {
normalized: false,
buffer:{
delay:100,
throttle:100
}
});
} else {
target.on('wheel', this.onWheel, this, {
normalized: false,
buffer:{
delay:100,
throttle:100
}
});
}
},
onIEWheel :function(event) {
this._onWheel(event.deltaY>0);
},
onFFWheel:function(event) {
this._onWheel(event.deltaY<0);
},
onWheel:function(event) {
this._onWheel(event.deltaY<0);
},
_onWheel: function (up){
var ul = this.ul.dom;
ul.scrollTop += this.scrollIncrement * (up ? -1 : 1);
}
});
