/**************************************************************************************
檔名: EditUserGroup.js

說明: 1. 此檔案定義ADDC EditUserGroup精靈實做.

歷史: 2013/07/23 Created by Lucifer.
**************************************************************************************/

/**************************************************************************************
ADDC EditUserGroup 約定呼叫界面.
**************************************************************************************/

QNAP.QOS.systemPreferencesCore.domainController.wizardEditUserGroup = {
'ShowWizard': function(_app, _username, _callback, _bReadOnly){
_D('[ADDC EditUserGroup wizard]', 'ShowWizard(...) executed.');

if('object' !== typeof(_app)){
Ext.MessageBox.alert(_S.DC_EDIT_USER_GROUP_STR02, 'ShowWizard(...) failed: Referance of APP must be passed in.');
return false;
}

var wizard = new QNAP.QOS.systemPreferencesCore.domainController.wizardEditUserGroup.wizardControl(_app, _username, _callback, _bReadOnly);

wizard.Show();
}
};

/**************************************************************************************
ADDC EditUserGroup 精靈.
**************************************************************************************/

QNAP.QOS.systemPreferencesCore.domainController.wizardEditUserGroup.wizardControl = function(_app, _username, _callback, _bReadOnly){

var DEBUG_MODE = false;                                      // 是否輸出這個類別的除錯訊息.
var CGI_PATH   = QNAP.QOS.config.sitePath + 'disk/smb4.cgi'; // CGI命令路徑.


this.Show = function(){};

var me       = this; // 紀錄對自己  的參考.
var m_app    = _app; // 紀錄APP層   的參考.
var m_wizard = null; // 紀錄精靈實體的參考.

var selectGrid   = null;
var editGroupAry = [];
/*
function _D         (){} // 類別自身除錯訊息輸出.
function Constructor(){} // 建構子.
function CreateItems(){} // 建立頁面所有的資料.
function BeforeShow (){} // 載入時期要做的事.
function BindEvents (){} // 綁定所有的事件.
*/



(function Constructor(){
_D('[ADDC EditUserGroup wizard]', 'Constructor(...) executed.');

if(undefined === m_app){
_D('[ADDC EditUserGroup wizard]', 'Construct failed, undefined APP layer.');
return false;
}

m_wizard = m_app._createWizard(CreateItems());

m_wizard.on('afterrender', BeforeShow, me, {'single': true});
})();


function _D(){
if(DEBUG_MODE){
console.log(arguments);
}
}


function CreateItems(){
_D('[ADDC EditUserGroup wizard]', 'CreateItems(...) executed.');


var pageCtrl = new QNAP.QOS.systemPreferencesCore.domainController.formGroups.pageControl(
m_app
, {
'isLite': true
, 'baseParams': {
'func'    : 'editUser'
, 'subfunc' : 'getGrp'
, 'username': _username
, 'limit'   : m_app.fn.maxGrp
}
}
);

var EditUserGroupStep1 = Ext.create({
'xtype'            : 'form'
, 'itemId'           : 'step1'
, 'nextId'           : 'step2'
, 'headerTitle'      : _S['IEI_NAS_SECURITY2']
, 'qInternationalKey':    'IEI_NAS_SECURITY2'
, 'qInternational'   : true
, 'bodyBorder'       : false
, 'autoScroll'       : false
, 'labelWidth'       : 140
, 'items'            : [
{
'ref'              : 'addc_username'
, 'xtype'            : 'displayfield'
, 'fieldLabel'       : _S['LDAP_SERVER_STR12']
, 'qInternationalKey':    'LDAP_SERVER_STR12'
, 'qInternational'   : true
, 'value'            : _username
, 'labelStyle'       : 'margin-top: -3px;'
}
, pageCtrl.GetPanel()
]
});


var EditUserGroupStep2 = Ext.create({
'xtype'            : 'form'
, 'itemId'           : 'step2'
, 'headerTitle'      : _S['LDAP_SERVER_STR61']
, 'qInternationalKey':    'LDAP_SERVER_STR61'
, 'qInternational'   : true
, 'bodyBorder'       : false
, 'autoScroll'       : true
, 'labelWidth'       : 140
, 'defaults'         : {
'xtype'        : 'displayfield'
}
, 'items'            : [
{
'ref'              : 'addc_username'
, 'fieldLabel'       : _S['LDAP_SERVER_STR12']
, 'qInternationalKey':    'LDAP_SERVER_STR12'
, 'qInternational'   : true
, 'value'            : _username
}
, {
'ref'              : 'addc_user_groups'
, 'fieldLabel'       : _S['USER_MANAGEMENT_STR01']
, 'qInternationalKey':    'USER_MANAGEMENT_STR01'
, 'qInternational'   : true
}
]
});


var wizardTitle = _S.DC_EDIT_USER_GROUP_STR02;
var config = {
'title'            : wizardTitle
,  'qInternationalKey': 'DC_EDIT_USER_GROUP_STR02'
,  'qInternational'   : true
,  'height'           : 540
,  'winHeight'        : 540
,  'ver'              : 2
,  'cls'              : 'utility-window win-form'
,  'steps'            : [
EditUserGroupStep1
, EditUserGroupStep2
]
};

return config;

}


function BeforeShow(){
_D('[ADDC EditUserGroup wizard]', 'BeforeShow(...) executed.');

BindEvents();

if( _bReadOnly ){
m_wizard.getFooterToolbar().getComponent('next').disable();
}
m_wizard.fbar.doLayout();
}


function BindEvents(){
_D('[ADDC EditUserGroup wizard]', 'BindEvents executed.');



m_wizard.steps[0].onNext = Step1to2Check;

selectGrid = m_wizard.steps[0].items.itemAt(1).groupGrid;
selectGrid.selModel.on('rowdeselect',rowdeselect);
selectGrid.selModel.on('rowselect',rowselect);
selectGrid.store.on('load',dataLoad);

m_wizard.steps[1].on('activate', function(){
setTimeout(function(){
m_wizard.cancelBtn.show();
},0);
});

m_wizard.onFinish = Finish;

}

function rowdeselect(sm, rowIndex, record) {
Ext.each(editGroupAry, function (data) {
if (data.groupname == record.id && record.data.default < 2) {
data.default = record.data.default = 0;
}
});
}
function rowselect(sm, rowIndex, record) {
Ext.each(editGroupAry, function (data) {
if (data.groupname == record.id && record.data.default < 2) {
data.default = record.data.default = 1;
}
});
}
function dataLoad(store) {
var tmpSel = [];
store.each(function (record, index) {
var chkValue = false;
Ext.each(editGroupAry, function (data) {
if (data.groupname == record.id) {
record.data.default = data.default;
chkValue = true;
store.data.items[index].afterEdit();
}
});
if (!chkValue) {
var o =
{   'groupname' : record.data.groupname
,   'default'   : record.data.default
};
editGroupAry.push(o);
}
if (record.data.default > 0 ) tmpSel.push(index);
});
selectGrid.selModel.selectRows(tmpSel);
}

function Step1to2Check(){
_D('[ADDC EditUserGroup wizard]', 'Step1to2Check(...) executed.');


var groupList = [];
for(var i = 0; i < editGroupAry.length; ++i){
if( editGroupAry[i].default > 0 )
groupList.push( editGroupAry[i].groupname );
}

m_wizard.steps[1].addc_user_groups.setValue(groupList.join(', '));

return true;

}


function Finish(){
_D('[ADDC EditUserGroup wizard]', 'Finish(...) executed.');


var param = {};

param['func'] = 'editUser';

param['subfunc'] = 'setGrp';

param['username'] = _username;

var groupList = [];
for(var i = 0; i < editGroupAry.length; ++i){
if( editGroupAry[i].default > 0 )
groupList.push( editGroupAry[i].groupname );
}
param['newGrp'] = groupList.join(',');

param['count'] = Math.random();


function Success(_res, _opts){
m_app.unmask();

var result   = Ext.DomQuery.selectValue('result', _res.responseXML);

if(result != '0'){
Ext.MessageBox.alert(_S.DC_EDIT_USER_GROUP_STR02, _S.DC_EDIT_USER_GROUP_STR01);
}

(_callback && typeof(_callback) === 'function') && _callback();
}

function Failure(){
m_app.unmask();

Ext.MessageBox.alert(_S.DC_EDIT_USER_GROUP_STR02, _S.ISCSI_UNKNOWN_ERROR + ': Ajax request failed.');
}

var callBack = {
'url'    : QNAP.QOS.lib.getCgiUrl(CGI_PATH)
, 'params' : param
, 'method' : 'POST'
, 'success': Success
, 'failure': Failure
};

QNAP.QOS.ajax(callBack);


m_wizard.destroy();


m_app.mask(_S.APPLY_MSG);

}


this.Show = function(){
if(null !== m_wizard){
m_wizard.show();
}
else{
_D('[ADDC EditUserGroup wizard]', 'Show wizard failed, uninitialized wizard.');
}
}

}
