<?php
setlocale(LC_CTYPE, "en_US.UTF-8");
include('class_upload.php');

$port = exec('cat /var/lock/._thttpd_.port');

$sid = $_REQUEST['sid'];
$dest = $_REQUEST['dest_path'];
$modifiedTime = $_REQUEST['mtime'];
$accessTime = $_REQUEST['atime'];

if (!is_array($dest)) {
  $dest = array($dest);
}

$uploadfolder = array();
$pathToVerify = array_unique($dest);

foreach ($pathToVerify as &$path) {
  $uri = "http://127.0.0.1:$port/cgi-bin/filemanager/utilRequest.cgi?func=qbox_check_upload&sid=$sid&dest_path=" . rawurlencode($path);
  $json = json_decode(file_get_contents($uri));
  switch ($json->status) {
    case '1': //success
      if ( empty($json->username) || !is_numeric($json->userid) ){
        print_json(array('status'=>'99', 'msg'=>'missing user information'));
        exit();
      } else {
        $userid = $json->userid;
        $username = $json->username;
	$realpath = $json->realpath;
      }
      break;

    case '4': //access denied
      print_json(array('status'=>'4', 'msg'=>'authentication failed', 'url'=>$uri));
      exit();

    case '5': //path does not exist
      print_json(array('status'=>'5', 'msg'=>'path does not exist', 'url'=>$uri));
      exit();

    case '12':  //invalid path
      print_json(array('status'=>'12', 'msg'=>'invalid path', 'url'=>$uri));
      exit();

    case '3': //invalid sid
    default:
      print_json(array('status'=>'3', 'msg'=>'authentication failed', 'url'=>$uri));
      exit();
  }
}

//conver home path to its repective full path
foreach ($dest as &$path) {
  if(substr($realpath,-1,1) == '/')
    $path = $realpath;
  else
    $path = $realpath . '/';
}

$upload_handler = new UploadHandler(array('upload_dir'=>$dest));

switch ($_SERVER['REQUEST_METHOD']) {
  case 'PUT':
  case 'POST':
    $info = $upload_handler->post();

    $fileCount = count($info);

    $ret = array('status'=>'1', 'files'=>array());
    $qsyncLogs = array();

    foreach ($info as $index=>$entry) {

      $filepath = $entry->path;
      $mediaType = $entry->type;

      if (!empty($entry->error)) {
        $ret['files'][] = array('status'=>'-1', 'name'=>$entry->name,'type'=>$entry->type, 'size'=>0, 'fullPath'=>$filepath, 'error'=>$entry->error);
        continue;
      }

      inheritFolderACL($filepath);

      $qsyncLogs[] = 'filepath='.rawurlencode($filepath);

      //change owner/group for non-admin users
      if ($username != 'admin') {
        chown($filepath, $userid);
        chgrp($filepath, 'everyone');
      }

      //change modified time
      if (!empty($modifiedTime[$index]) && !empty($accessTime[$index])) {
        if (is_numeric($modifiedTime[$index])) {
          $modifiedTime[$index] = '@'.$modifiedTime[$index];
        }
        if (is_numeric($accessTime[$index])) {
          $accessTime[$index] = '@'.$accessTime[$index];
        }
        touch($filepath, strtotime($modifiedTime[$index]), strtotime($accessTime[$index]));
      } else if (!empty($modifiedTime[$index])) {
        if (is_numeric($modifiedTime[$index])) {
          $modifiedTime[$index] = '@'.$modifiedTime[$index];
        }
        touch($filepath, strtotime($modifiedTime[$index]));
      }

      $ret['files'][] = array(
        'status'=>'1',
        'name'=>$entry->name,
        'type'=>$entry->type,
        'size'=>$entry->size,
        'fullPath'=>$filepath
      );

    }

    $uri = "http://127.0.0.1:$port/cgi-bin/filemanager/utilRequest.cgi?func=qbox_write_log&sid=$sid&remote_ip=" . $_SERVER['REMOTE_ADDR'] . '&' . implode('&',$qsyncLogs);
    $json = json_decode(file_get_contents($uri), true);
    $ret['log'] = $json;

    print_json($ret);

    break;
  case 'HEAD':
  case 'GET':
  case 'DELETE':
  default:
    header('HTTP/1.0 405 Method Not Allowed');
}


function inheritFolderACL($f){
	$_acl = trim(exec(CMD_PATH_GETCFG . ' System "ACL Enable" -u -d FALSE -f /etc/config/uLinux.conf'));
	if($_acl == 'TRUE'){
		$ret = shell_exec('/usr/bin/getfacl ' . escapeshellarg(dirname($f)) . ' 2>/dev/null | /usr/bin/setfacl -b -M - ' . escapeshellarg($f) . ' 2>/dev/null');
	}
}

function print_json($input) {
  header('Content-Type: application/json');
  echo json_encode($input);
}

?>
