CREATE DATABASE IF NOT EXISTS `qnote`;
USE `qnote`;

DELIMITER $$

CREATE PROCEDURE transform(tbName VARCHAR(50)) 
BEGIN
	SET @SQL := CONCAT('ALTER TABLE ', tbName, ' ENGINE = MyISAM');

	IF EXISTS(SELECT NULL 
	            FROM INFORMATION_SCHEMA.TABLES
	           WHERE table_schema = 'qnote'
	             AND table_name LIKE tbName)
	THEN  
	   PREPARE stmt FROM @SQL;
	   EXECUTE stmt;
	   DEALLOCATE PREPARE stmt;
	END IF;
END;
$$

DELIMITER ;

CALL transform('qn_activity_log');
CALL transform('qn_address');
CALL transform('qn_author');
CALL transform('qn_book');
CALL transform('qn_book_sort');
CALL transform('qn_calendar');
CALL transform('qn_calendar_user');
CALL transform('qn_coauthor');
CALL transform('qn_color_tag');
CALL transform('qn_common_description');
CALL transform('qn_config');
CALL transform('qn_config_backup');
CALL transform('qn_device');
CALL transform('qn_editing');
CALL transform('qn_file');
CALL transform('qn_gen_sub_type');
CALL transform('qn_gen_type');
CALL transform('qn_location');
CALL transform('qn_msg');
CALL transform('qn_note');
CALL transform('qn_page');
CALL transform('qn_page_tag');
CALL transform('qn_rss');
CALL transform('qn_sid');
CALL transform('qn_snapshot');
CALL transform('qn_snapshot_file');
CALL transform('qn_tags');
CALL transform('qn_task');
CALL transform('qn_temp_file');
CALL transform('qn_user');
CALL transform('qn_user_config');

DROP PROCEDURE transform;