#!/bin/sh
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin
mode=$1
retval=0
val=3306
ret=0
param3=null

. /etc/init.d/functions
FindDefVol
old_datadir="${DEF_VOLMP}/.@mysql"

bindir="/usr/local/mysql/bin"
datadir="/usr/local/mysql/var"
Project_Name=`/sbin/getcfg Project Name -d null -f /var/default`
pid_file="/var/lock/qmysql.pid"
mysqld_sh="/etc/init.d/mysqld.sh"
upgradelog="$datadir/upgrade.log"
confdir="/etc/config/my.cnf"

if [ $2 ]; then
	val=$2;
fi
if [ $3 ]; then
	param3=$3;
fi

log_success_msg()
{
echo " SUCCESS! $@"
}
log_failure_msg()
{
echo " ERROR! $@"
}

wait_for_pid () {
  i=0
  while test $i -lt 35 ; do
    sleep 1
    case "$1" in
      'created')
        test -s $pid_file && i='' && break
        ;;
      'removed')
        test ! -s $pid_file && i='' && break
        ;;
      *)
        echo "wait_for_pid () usage: wait_for_pid created|removed"
        exit 1
        ;;
    esac
    echo $echo_n ".$echo_c"
    i=`expr $i + 1`
  done

  if test -z "$i" ; then
    log_success_msg
  else
    log_failure_msg
  fi
}

kill_mysqld()
{
  if test -s "$pid_file" ; then
    mysqlmanager_pid=`cat $pid_file`
    kill $mysqlmanager_pid
    wait_for_pid removed
  fi
}
migrate_innodb()
{
	boot_conf=`/bin/cat /etc/default_config/BOOT.conf 2>/dev/null`
	ns_conf="/mnt/ext/opt/NotesStation/web/application/config"
	ns_exist=`/sbin/getcfg NotesStation Name -d null -f /etc/config/qpkg.conf`
	/bin/echo System is $boot_conf $ns_exist
	if [ "x${boot_conf}" = "xTS-NASARM" ] && [ "x${ns_exist}" != "xnull" ]; then
	if [ -f "${ns_conf}/user.ini" ]; then
		export _user=`cat ${ns_conf}/user.ini | sed -n '1p'`
		export _pwd=`cat ${ns_conf}/user.ini | sed -n '2p'`
		/bin/echo get $_user from DB
		if [ -f /usr/local/mysql/migration_for_arm_QTS.sql ]; then
			/bin/echo execute migration script...
			/usr/local/mysql/bin/mysql -hlocalhost -u${_user} -p${_pwd} < /usr/local/mysql/migration_for_arm_QTS.sql
		fi
	fi
	fi
}
case "$mode" in
  '--reset_pwd')
		if [ -d $datadir ]; then
			/bin/ls /tmp/mysql.sock
			if [ $? = 0 ]; then
				#/usr/local/mysql/share/mysql/mysql.server stop --user=admin
				ret=$?
			fi
			kill_mysqld
			/bin/pidof mysqld
			if [ $? = 0 ]; then
				#kill `ps | grep "/usr/local/mysql/libexec/mysqld" | grep -v grep | /bin/awk '{print $1}'`
				sleep 1
			fi
			#/usr/local/mysql/share/mysql/mysql.server start --skip-grant-table --user=admin
			$bindir/mysqld_safe --skip-grant-table --pid-file=$pid_file --user=admin &
			wait_for_pid created
			[ $? = 0 ] && /usr/local/mysql/bin/mysql mysql < /usr/local/mysql/reset_pwd.sql
			sleep 1
			kill_mysqld
			sleep 1
			[ `/sbin/getcfg MySQL Enable -u -d FALSE` = TRUE ] && $mysqld_sh start --user=admin
			retval=$?
			sleep 2
		fi
    ;;

  '--init_db')
		/bin/echo "init_db..."
		#[ -f $upgradelog ] && exit 0	# already done
		[ -d $datadir ] || exit 1		# datadir not created yet
		
		upgrade_ready=`/sbin/getcfg MySQL DB_Upgrade -d FALSE`
		olddata_ready=`/sbin/getcfg MySQL DB_Init -d FALSE`
		#[ ! -d $old_datadir ] && olddata_ready='FALSE'
		if [ $olddata_ready != 'FALSE' ] && [  $upgrade_ready = 'FALSE' ] && [ -d $old_datadir ]; then
			/bin/echo "mysql_upgrade..."
			cp -rf $old_datadir/* $datadir
			/usr/local/mysql/bin/mysqld --datadir=$datadir --skip-grant-tables --pid-file=$pid_file --user=admin &
			wait_for_pid created
			migrate_innodb
			/usr/local/mysql/bin/mysql_upgrade > $upgradelog
			/sbin/setcfg MySQL DB_Upgrade TRUE	
		else
			/bin/echo "mysql_install_db..."
			/usr/local/mysql/scripts/mysql_install_db --datadir=$datadir --user=admin
			/usr/local/mysql/bin/mysqld_safe --datadir=$datadir --pid-file=$pid_file --user=admin &
			wait_for_pid created
			/usr/local/mysql/bin/mysqladmin -uroot password 'admin' --skip-password
			sleep 1
			/sbin/setcfg MySQL DB_Upgrade TRUE
		fi
		kill_mysqld
		/sbin/setcfg MySQL DB_Init TRUE
    ;;

  '--reset_db')
		if [ -d $datadir ]; then
			/bin/ls /tmp/mysql.sock >>/dev/null 2>>/dev/null
			if [ $? = 0 ]; then
				#/usr/local/mysql/share/mysql/mysql.server stop --user=admin
				ret=$?
			fi
			[ $ret = 0 ] || exit 1
			kill_mysqld
			/bin/pidof mysqld >>/dev/null 1>>/dev/null 2>>/dev/null
			#if [ $? = 0 ]; then
			#	kill `ps | grep "/usr/local/mysql/libexec/mysqld" | grep -v grep | /bin/awk '{print $1}'`
			#fi
			sleep 2
			/bin/rm -rf $datadir/*
			/bin/rm -rf /usr/local/mysql/tmp/*
			cd /usr/local/mysql
			/usr/local/mysql/scripts/mysql_install_db --datadir=$datadir --user=admin
			if [ $? = 0 ]; then
				/usr/local/mysql/bin/mysqld_safe --pid-file=$pid_file --user=admin &
				wait_for_pid created
				/usr/local/mysql/bin/mysqladmin password admin
				sleep 1
				$mysqld_sh stop --user=admin
				sleep 1
				if [ `/sbin/getcfg MySQL Enable -u -d FALSE` = TRUE ];then
					$mysqld_sh start --user=admin
				sleep 2
				fi
#
			fi
		fi		
    ;;

 '--enable_tcpip')
		if [ -d $datadir ]; then
			/bin/grep "#skip-networking" $confdir > /dev/null 2>&1
			if [ $? != 0 ]; then
				/bin/sed -i 's/skip-networking/\#skip-networking/' $confdir
			fi
			/sbin/setcfg MySQL skip-networking FALSE
			/bin/sync
			if [ $val = "restart" ]; then
				/bin/ls /tmp/mysql.sock >>/dev/null 2>>/dev/null
				[ $? != 0 ] || $mysqld_sh stop
				$mysqld_sh start
			fi
		fi		
    ;;

 '--disable_tcpip')
		if [ -d $datadir ]; then
			/bin/grep "#skip-networking" $confdir > /dev/null 2>&1
			if [ $? = 0 ]; then
				/bin/sed -i 's/^#.*skip-networking/skip-networking/' $confdir
			fi
			/sbin/setcfg MySQL skip-networking TRUE
			/bin/sync
			if [ $val = "restart" ]; then
				/bin/ls /tmp/mysql.sock >>/dev/null 2>>/dev/null
				[ $? != 0 ] || $mysqld_sh stop
				$mysqld_sh start
			fi
		fi		
    ;;
    
 '--port')
		if [ -d $datadir ]; then
			/sbin/setcfg MySQL Port $val
			#/bin/sed -i s/port\=$val_ori/port\=$val/ $confdir
			/sbin/setcfg -f $confdir client port $val
			/sbin/setcfg -f $confdir mysqld port $val
			/bin/sync
			val_ori=`/sbin/getcfg MySQL Port -u -d 3306`
			[ $val_ori -eq $val ] && exit 1
			if [ $param3 = "restart" ]; then
				/bin/ls /tmp/mysql.sock >>/dev/null 2>>/dev/null
				[ $? != 0 ] || $mysqld_sh stop
				$mysqld_sh start
			fi
		fi		
    ;;

  *)
    # usage
    echo "Usage: $0  {--reset_pwd|--init_db|--reset_db|--port [number]|--enable_tcpip|--disable_tcpip}  [ MySQL Util options ]"
    exit 1
    ;;
esac

/bin/sync
exit $retval
