#!/bin/sh

INSTALLED=`/sbin/getcfg -f /etc/config/medialibrary.conf -d 0 "OPTIONS" "samplesInstalled"`
if [ "$INSTALLED" = "1" ]; then
	exit 0
fi
PACKAGE_PATH=/usr/local/medialibrary
export MYMEDIADB_PATH=$PACKAGE_PATH/bin
export LD_LIBRARY_PATH=$PACKAGE_PATH/lib:$LD_LIBRARY_PATH
MULTIMEDIA_PATH=`/sbin/getcfg -f /etc/config/smb.conf "Multimedia" "path"`
if [ "x${MULTIMEDIA_PATH}" = "x" ]; then
        MULTIMEDIA_PATH=`/sbin/getcfg -f /etc/config/smb.conf "Qmultimedia" "path"`
fi
if [ "x${MULTIMEDIA_PATH}" = "x" ]; then
        echo "I cannot find multimedia folder"
        exit 0
fi
if [ ! -d "$PACKAGE_PATH/bin/Samples" ]; then
				echo "No Samples files"
				exit 0
fi
MOUNT_PATH=`dirname $MULTIMEDIA_PATH`
MULTIMEDIA_NAME=`basename $MULTIMEDIA_PATH`

[ -d "$MOUNT_PATH/$MULTIMEDIA_NAME/Samples" ] || /bin/mkdir $MOUNT_PATH/$MULTIMEDIA_NAME/Samples
/bin/cp -f $PACKAGE_PATH/bin/Samples/* $MOUNT_PATH/$MULTIMEDIA_NAME/Samples/
MUSICFILES=$PACKAGE_PATH/bin/Samples/*.mp3
for f in $MUSICFILES
do
	TARGETFILE=`basename "$f"`
	MUSICID=`$PACKAGE_PATH/bin/mymediadbcmd createfile "$MOUNT_PATH/$MULTIMEDIA_NAME/Samples/$TARGETFILE"`
	$PACKAGE_PATH/bin/mymediadbcmd addDBIDtoplaylist $MOUNT_PATH 0 $MUSICID "Samples Playlist" 0 2
done
/bin/touch /etc/config/medialibrary.conf
/sbin/setcfg OPTIONS samplesInstalled 1 -f /etc/config/medialibrary.conf

