<?php

function svc_log($msg, $extra = 0) {
    $s = array("title" => $msg);
    $s["extra"] = $extra;
    deploy_command(array("c" => "log", "s" => $s), 0);
}

function on_error($errno, $errstr, $errfile, $errline, $errcontext) {
    $ex = array($errno, $errstr, $errfile, $errline);
    svc_log("on_error", $ex);
}

set_error_handler("on_error");
ini_set("display_errors", "On");
require_once(__DIR__ . "/../inc/airplay.inc.php");
require_once(__DIR__ . "/../api_interface.inc.php");
@detectSystemSettings();
extract(array_merge($_GET, $_POST), EXTR_PREFIX_ALL, "rvar");
$seg = isset($rvar_s) ? intval($rvar_s) : 0;
$did = isset($rvar_d) ? $rvar_d : "";
@$r = deploy_command(array("c" => "hls_status", "d" => $did), 0);
if (is_string($r))
    $r = json_decode($r, 1);
if (!isset($r, $r["status"]) or $r["status"] < 0) {
    header('Content-type: text/plain');
    header("HTTP/1.0 404 Not Found");
    die($r["message"]);
} $content_type = "application/x-mpegURL";
header("Content-Type: $content_type");
header('Content-Disposition: attachment; filename="qaplay.m3u8"');
$s = <<< EOM3U8
#EXTM3U
#EXT-X-VERSION:3
#EXT-X-TARGETDURATION:10
#EXT-X-MEDIA-SEQUENCE:0

EOM3U8;
$target_dur = 10;
$dur_left = intval(round($r["duration"]));
$i = 0;
while (1) {
    $dur = ($dur_left > $target_dur) ? $target_dur : $dur_left;
    $s = $s . "#EXTINF:{$dur},\r\nhls_ts.php?d={$did}&s={$i}\r\n";
    $dur_left = $dur_left - $dur;
    if ($dur_left <= 0)
        break;
    $i++;
} $s = $s . "#EXT-X-ENDLIST\r\n\r\n";
echo $s;
svc_log("m3u8 output", $s);
