<?php

function on_error($errno, $errstr, $errfile, $errline, $errcontext) {
    $ex = array($errno, $errstr, $errfile, $errline);
    svc_log("on_error", $ex);
}

set_error_handler("on_error");
ini_set("display_errors", "On");
require_once(__DIR__ . "/../inc/airplay.inc.php");
require_once(__DIR__ . "/../api_interface.inc.php");
@detectSystemSettings();
extract($_GET, EXTR_PREFIX_ALL, "rvar");
$seg = isset($rvar_s) ? intval($rvar_s) : 0;
$did = isset($rvar_d) ? $rvar_d : "";
@$msg = array("hls_ts called", "s" => $rvar_s, "d" => $rvar_d);
deploy_command(array("c" => "log", "s" => $msg), 0);
@$key = "469590";
if (!function_exists('sem_get')) {
    @$key = "469{$did}590";

    function sem_get($key) {
        return fopen("/tmp/hls_ts.sem.{$key}", 'w+');
    }

    function sem_acquire($sem_id) {
        return flock($sem_id, LOCK_EX);
    }

    function sem_release($sem_id) {
        return flock($sem_id, LOCK_UN);
    }

} $sk = sem_get($key);
sem_acquire($sk);
$opt = array("c" => "hls_seek", "d" => $did, "s" => $seg);
$r_seek = deploy_command($opt, 0);
if (is_string($r_seek))
    $r_seek = json_decode($r_seek, 1);
svc_log("r_seek", $r_seek);
if (!isset($r_seek, $r_seek["status"]) or $r_seek["status"] < 0) {
    svc_log("seek fail", $r_seek);
    sem_release($sk);
    header('Content-type: text/plain');
    header("HTTP/1.0 404 Not Found");
    die($r_seek["message"]);
} $seek_sn = $r_seek["seek_sn"];
$timeout = time() + 60;
while (1) {
    $now = time();
    if ($now > $timeout) {
        svc_log("exit due to timeout");
        sem_release($sk);
        header('Content-type: text/plain');
        header("HTTP/1.0 404 Not Found");
        exit;
    } $r_status = deploy_command(array("c" => "hls_status", "d" => $did), 0);
    if (is_string($r_status))
        $r_status = json_decode($r_status, 1);
    if (isset($r_status, $r_status["status"]) and $r_status["status"] !== 0) {
        svc_log("hls_status failed", $r_status["message"]);
        sem_release($sk);
        header('Content-type: text/plain');
        header("HTTP/1.0 404 Not Found");
        die($r_status["message"]);
    } if ($seek_sn != $r_status["seek_sn"]) {
        $extra = array("expecting_seek_sn" => $seek_sn, "got_seek_sn" => $r_status["seek_sn"]);
        svc_log("seek_sn STALLed", $extra);
        sem_release($sk);
        header('Content-type: text/plain');
        header("HTTP/1.0 404 Not Found");
        exit;
    } if (isset($r_status, $r_status["status"], $r_status["segments"]) and $r_status["status"] == 0 and in_array($seg, $r_status["segments"])) {
        $fn = __DIR__ . "/hls/ts_{$did}/qaplay{$seg}.ts";
        $r_file = file_get_contents($fn);
        $fsize = filesize($fn);
        $read = strlen($r_file);
        $exists = file_exists($fn);
        svc_log("hls_ts.php RETURNED A FILE", array("fn" => $fn, "filesize" => $fsize, "read" => $read, "file_exists" => $exists));
        if (!is_string($r_file)) {
            svc_log("hls_ts failed get file content", $fn);
        } if (1) {
            header("Content-Length: {$fsize}");
            header("Content-Type: video/mp2t");
            echo $r_file;
        } else {
            header("Location: hls/ts_{$did}/qaplay{$seg}.ts");
        } sem_release($sk);
        exit;
    } sleep(2);
}

function svc_log($msg, $extra = 0) {
    $s = array("title" => $msg);
    $s["extra"] = $extra;
    deploy_command(array("c" => "log", "s" => $s), 0);
}
