<?php  require_once('../inc/get_version.inc.php'); ?>
<!DOCTYPE html>
<html>
<head>
	<title>Qairplay&Chromecast</title>
	<meta name="viewport" content="width=device-width,height=device-height,initial-scale=0.5,maximum-scale=1,minimum-scale=1,user-scalable=no">
	<meta name="apple-mobile-web-app-capable" content="yes">
	<meta http-equiv="EXPIRES" content="0">
	<meta http-equiv="content-type" content="text/html;charset=UTF-8">
	<meta name="description" content="QNAP AirPlay Controller">
	<meta name="keywords" content="QNAP, AirPlay, Apple TV, Chromecast, Qairplay">
	<link rel="SHORTCUT ICON" href="../favicon.ico">
	<link rel="stylesheet" type="text/css" href="css/airplay.css?v=201304021803">
	<script type="text/javascript" src="../public_js/lib/jquery-1.9.1.min.js"></script>
	<script type="text/javascript" src="../public_js/lib/jquery-ui-1.10.1.custom.min.js"></script>
	<script type="text/javascript" src="../public_js/lib/jquery.placeholder.min.js"></script>
	<script type="text/javascript" src="../public_js/lib/jquery.cookie.js"></script>
	<script type="text/javascript" src="../public_js/lib/jquery.blockUI.js"></script>
	<script type="text/javascript" src="../public_js/lib/doT.min.js"></script>
	<script type="text/javascript" src="../public_js/lib/detectmobilebrowser.js"></script>
	
	<script type="text/javascript" src="../public_js/common_func.js?v=201407151536"></script>
	<script type="text/javascript" src="../public_js/index.js?v=201407151622"></script>
	<script type="text/javascript" src="../public_js/player_operation.js?v=201408121112"></script>
	<script type="text/javascript" src="../public_js/get_file.js?v=201406031639"></script>
	
	<script type="text/javascript" src="js/airplay.pc.js?v=201409051808"></script>
</head>
<body>
	<div class="BLOCK_PAGE">
		<div id="block_appletv">
			<script id="appletv_item_template" type="text/x-dot-template">
				{{for(var i=0, l=it.length; i<l; i++){ }}
					<div class="FILE_ITEM" onclick="set_appletv('{{= it[i].device_id}}')">
						<div class="FILE_ITEM_PART ICON">
							{{ switch(it[i].type){ }}
								{{ case "chromecast": }}
									<img class="APPLETV_ICON {{= it[i].type}}" src="../img/page/icon/chromecast.png" />
									{{ break; }}
								{{ case "raop": }}
									<img class="APPLETV_ICON {{= it[i].type}}" src="../img/page/icon/AirPort.png" />
									{{ break; }}
								{{ case "airplay": }}
								{{ default: }}
									<img class="APPLETV_ICON {{= it[i].type}}" src="../img/page/icon/appletv.png?v=201401091732" />
							{{ } }}
						</div>
						<div class="FILE_ITEM_PART TITLE">
							<div class="TITLE_TEXT">{{= it[i].device_name}}</div>
						</div>
						<div class="FILE_ITEM_PART BUTTON">
							<input id="rdo_{{= it[i].device_id}}" type="radio" name="rdo_appletv" onclick="set_appletv('{{= it[i].device_id}}')" />
						</div>
					</div>
				{{ } }}
			</script>
		</div>
		<div id="btn_appletv" class="BTN s52x30" style="background-image: url('../img/page/appletv.png')" onclick="show_appletv()"></div>
		<div id="btn_back" class="BTN s52x30" style="background-image: url('../img/page/back.png')" onclick="go_back(event)"></div>
		<div class="BLOCK_HEADER">
			<img id="logo" src="../img/page/qairplay.png">
			<div id="lab_version"><?php echo QAIRPLAY_V ?></div>
		</div>
		<div class="BLOCK_MAIN" id="block_main">
			<div class="BLOCK_FILE">
				<div class="BLOCK_FILE_HEADER">File On NAS</div>
				<div class="BLOCK_FILE_CONTENT" id="block_file_content">
					<script id="file_item_template" type="text/x-dot-template">
						{{for(var i=0, l=it.files.length; i<l; i++){ }}
							{{ if(it.files[i].a=="dir"){ }}
								<div class="FILE_ITEM" onclick="item_enter('{{= i }}')">
									<div class="FILE_ITEM_PART ICON">
										<img class="FILE_ICON" src="../img/page/icon/folder.png" />
									</div>
							{{ }else{ }}
								<div class="FILE_ITEM {{= it.files[i].a}}" onclick="item_append_play(event, this, {{= i}})">
									<div class="FILE_ITEM_PART ICON">
										<img class="FILE_ICON" src="../img/page/icon/{{= it.files[i].ext}}.png" />
									</div>
							{{ } }}
							<div class="FILE_ITEM_PART TITLE" title="{{= it.files[i].desc}}">
								<div class="TITLE_TEXT">{{= it.files[i].desc}}</div>
							</div>
							<div class="FILE_ITEM_PART BUTTON">
								<div class="FILE_BUTTON ADD" onclick="item_add(event, this, {{= i}})"></div>
							</div>
							{{ if(it.files[i].a=="dir"){ }}
								<div class="FILE_ITEM_PART BUTTON">
									<div class="FILE_BUTTON PLAY" onclick="play_folder(event, this, {{= i}})"></div>
								</div>
							{{ }else{ }}
								<div class="FILE_ITEM_PART BUTTON">
									<div class="FILE_BUTTON PLAY" onclick="play_file(event, this, {{= i}})"></div>
								</div>
							{{ } }}
							</div>
						{{ } }}
					</script>
				</div>
				<div class="BLOCK_FILE_FILTER">
					<div id="btn_filter_video" class="BTN s100x30 checked" style="background-image: url('../img/page/pc_video_btn.png')" onclick="set_filter(event, this, 'video')"></div>
					<div id="btn_filter_music" class="BTN s100x30 checked" style="background-image: url('../img/page/pc_music_btn.png')" onclick="set_filter(event, this, 'music')"></div>
					<div id="btn_filter_photo" class="BTN s100x30 checked" style="background-image: url('../img/page/pc_photo_btn.png')" onclick="set_filter(event, this, 'photo')"></div>
				</div>
			</div>
			<div class="BLOCK_PLAYING" id="block_playing">
				<div class="BLOCK_PLAYING_HEADER">
					<div class="CONTROLLER">
						<div id="btn_previous" class="BTN s26x30" style="background-image: url('../img/page/pc_prev_btn.png')" onclick="previous(event, this)"></div>
						<div id="btn_play" class="BTN s36x30" onclick="play(event, this)"></div>
						<div id="btn_next" class="BTN s26x30" style="background-image: url('../img/page/pc_next_btn.png')" onclick="next(event, this)"></div>
						<div id="btn_clear" class="BTN s33x29" style="background-image: url('../img/page/clear.png')" onclick="clear_playlist(event, this)"></div>
					</div>
					<span>Qairplay&Chromecast Playlist</span>
				</div>
				<div class="BLOCK_PLAYING_CONTENT" id="block_playing_content">
					<script id="playing_item_template" type="text/x-dot-template">
						{{for(var i=0, l=it.length; i<l; i++){ }}
							<div id="pl_{{= it[i].id}}" pid="{{= it[i].meta.pid}}" a="{{= it[i].meta.a}}" ext="{{= it[i].meta.ext}}" desc={{= it[i].meta.name}} class="FILE_ITEM PLAYING"  onclick="goto_item(event, this, '{{= it[i].id}}')">
								<div class="FILE_ITEM_PART ICON">
									<img class="PLAYING_ICON" src="../img/page/icon/{{= it[i].meta.ext}}.png" />
								</div>
								<div class="FILE_ITEM_PART TITLE">
									<div class="TITLE_TEXT">{{= it[i].meta.name}}</div>
								</div>
								<div class="FILE_ITEM_PART BUTTON">
									<div class="FILE_BUTTON DEL" onclick="item_del(event, this, '{{= it[i].id}}')"></div>
								</div>
							</div>
						{{ } }}
					</script>
				</div>
			</div>
		</div>
		<div class="BLOCK_FOOTER"></div>
	</div>
</body>
</html>