<?php

function check_login(&$username, &$sid) {
    session_name(AIRPLAY_SESSION_NAME);
    if (isset($sid) and $sid != "")
        session_id($sid);
    if (session_start()) {
        $sid = session_id();
        if (isset($_SESSION["user_name"]))
            $_username = $_SESSION["user_name"];
        session_write_close();
    } if (!isset($_username)) {
        return -1;
    } $username = $_username;
    return 0;
}

function getReadableRoots($username) {
    $readable_roots = array();
    exec("/sbin/user_cmd -sa {$username}", $r_exec);
    foreach ($r_exec as $line) {
        $r = explode(":", $line, 2);
        if (is_array($r) and substr($r[1], 0, 1) == "R") {
            if (strpos($r[0], "Network Recycle Bin") === 0)
                continue;
            $path = $r[0];
            if ($path)
                $readable_roots[] = $path;
        }
    } return $readable_roots;
}

function rescan_iface() {
    global $eth_list;
    $eth_list = array();
    exec("/sbin/ifconfig", $r_exec);
    $r_exec_string = implode("\r\n", $r_exec);
    $r = preg_match_all("/(^|\r\n)([a-z]+[0-9:]+)\s+.*\r\n\s*inet addr:([0-9.]+)/", $r_exec_string, $m);
    for ($i = 0; $i < $r; $i++) {
        list($eth, $ip) = array($m[2][$i], $m[3][$i]);
        $eth_list[$eth] = $ip;
    }
}

function detectSystemSettings() {
    $debug = file_exists(__DIR__ . "/../debug");
    $default_port = "80";
    $r = @exec("/sbin/getcfg -d 80 QWEB Port 2>/dev/null");
    if ($r) {
        $default_port = trim($r);
    } exec("/sbin/route -n", $r);
    $default_router = $default_if = "";
    foreach ($r as $v) {
        $_v = trim($v);
        $r = preg_match("/([0-9.]+)\s+([0-9.]+)\s+([0-9.]+).*\s+(.*)$/", $v, $m);
        if ($r == 1 and $m[1] == "0.0.0.0") {
            $default_router = $m[2];
            $default_if = $m[4];
            break;
        }
    } define("DEFAULT_ROUTER", $default_router);
    define("DEFAULT_IF", $default_if);
    rescan_iface();
    global $eth_list;
    $default_ip = "127.0.0.1";
    if (count($eth_list) > 0) {
        $eths_ = array_values($eth_list);
        $default_ip = $eths_[0];
    } $_port = ($default_port == 80) ? "" : ":{$default_port}";
    $_web_host = "http://{$default_ip}{$_port}";
    define("DEFAULT_IP", $default_ip);
    define("DEFAULT_WEB_HOST", $_web_host);
    $curl_path = "/sbin/curl";
    if (!file_exists($curl_path))
        $curl_path = "/usr/bin/curl";
    if (file_exists($curl_path))
        define("CURL_PATH", $curl_path);
    $php_path = "/mnt/ext/opt/apache/bin/php";
    if (!file_exists($php_path))
        $php_path = exec("which php");
    if (file_exists($php_path))
        define("PHP_PATH", $php_path);
    $ffmpeg_path = realpath(__DIR__ . "/../bin/ffmpeg");
    if (file_exists($ffmpeg_path))
        define("FFMPEG_PATH", $ffmpeg_path);
    if (!defined("AIRPLAY_SESSION_NAME")) {
        define("AIRPLAY_SESSION_NAME", "qnap_airplay_service_session");
    } define("AP_SOCK", "/tmp/airplay_svc_qnap_qts_sw2");
    define("AP_DEV", 0);
}

function obj2assoc($o, array $properties) {
    $r = array();
    foreach ($properties as $p) {
        if (isset($o->$p))
            $r[$p] = $o->$p;
    } return $r;
}

function stat_ex($fname, &$is_file = NULL, &$is_dir = NULL, &$filesize = NULL) {
    $escfn = escapeshellarg($fname);
    $_r = exec("/usr/bin/stat {$escfn} 2>&1", $r);
    if (count($r) < 2)
        return FALSE;
    $r = $r[1];
    $pat = "/Size: ([0-9]+)[ \t]*Blocks: [0-9]+[ \t]*IO Block: ([0-9]+)[ \t]*([a-z ]*)/";
    preg_match($pat, $r, $m);
    if (count($m) !== 4)
        return FALSE;
    $filetype = $m[3];
    $is_file = ($m[3] == "regular file");
    $is_dir = ($m[3] == "directory");
    $filesize = $m[1];
    return array("filesize" => $filesize, "is_file" => $is_file, "is_dir" => $is_dir, "filetype" => $filetype);
}

$eth_bind_ip = array();

function get_eth_ip($eth) {
    global $eth_bind_ip;
    if (array_key_exists($eth, $eth_bind_ip)) {
        return $eth_bind_ip[$eth];
    } $cmd = "/sbin/ifconfig $eth";
    exec($cmd, $r_exec, $retv);
    if ($retv !== 0) {
        return FALSE;
    } array_shift($r_exec);
    foreach ($r_exec as $line) {
        $inet_addr = strstr($line, "inet addr:");
        if (is_string($inet_addr)) {
            list($ip) = explode(" ", substr($inet_addr, 10), 2);
            $eth_bind_ip[$eth] = $ip;
            return $ip;
        }
    }
}
