<?php

function set_range($range, $filesize, &$first, &$last) {
    $dash = strpos($range, '-');
    $first = trim(substr($range, 0, $dash));
    $last = trim(substr($range, $dash + 1));
    if ($first == '') {
        $suffix = $last;
        $last = $filesize - 1;
        $first = $filesize - $suffix;
        if ($first < 0)
            $first = 0;
    } else {
        if ($last == '' || $last > $filesize - 1)
            $last = $filesize - 1;
    } if ($first > $last) {
        header("Status: 416 Requested range not satisfiable");
        header("Content-Range: */$filesize");
        exit;
    }
}

function buffered_read($file, $bytes, $buffer_size = 4096) {
    global $filesize;
    if ($filesize > 2147483647) {
        header_remove("Content-Length");
    } @ob_end_clean();
    @set_magic_quotes_runtime(0);
    @set_time_limit(10);
    $bytes_left = $bytes;
    while ($bytes_left > 0 && !feof($file)) {
        if ($bytes_left > $buffer_size)
            $bytes_to_read = $buffer_size;
        else
            $bytes_to_read = $bytes_left;
        $bytes_left-=$bytes_to_read;
        $contents = fread($file, $bytes_to_read);
        echo $contents;
        flush();
        @set_time_limit(10);
    }
}

function buffered_read_old($file, $bytes, $buffer_size = 1024) {
    $bytes_left = $bytes;
    while ($bytes_left > 0 && !feof($file)) {
        if ($bytes_left > $buffer_size)
            $bytes_to_read = $buffer_size;
        else
            $bytes_to_read = $bytes_left;
        $bytes_left-=$bytes_to_read;
        $contents = fread($file, $bytes_to_read);
        echo $contents;
        flush();
    }
}

function header_callback() {
    $h = headers_list();
    var_dump($h);
    die("test");
}

function byteserve($filename, $content_type = "application/octet-stream") {
    global $filesize;
    $filesize = my_filesize($filename);
    $file = fopen($filename, "rb");
    $ranges = NULL;
    @$req_method = $_SERVER['REQUEST_METHOD'];
    if ($req_method == 'GET' && isset($_SERVER['HTTP_RANGE']) && $range = stristr(trim($_SERVER['HTTP_RANGE']), 'bytes=')) {
        $range = substr($range, 6);
        $boundary = 'qetrg4547ZBFFfdhFPIJLKNMV';
        $ranges = explode(',', $range);
    } if ($ranges && count($ranges)) {
        header("HTTP/1.1 206 Partial content");
        header("Accept-Ranges: bytes");
        if (count($ranges) > 1) {
            $content_length = 0.0;
            foreach ($ranges as $range) {
                set_range($range, $filesize, $first, $last);
                $content_length+=strlen("\r\n--$boundary\r\n");
                $content_length+=strlen("Content-Type: $content_type\r\n");
                $content_length+=strlen("Content-range: bytes $first-$last/$filesize\r\n\r\n");
                $content_length+=$last - $first + 1;
            } $content_length+=strlen("\r\n--$boundary--\r\n");
            header("Content-Length: $content_length");
            header("Content-Type: multipart/x-byteranges; boundary=$boundary");
            foreach ($ranges as $range) {
                set_range($range, $filesize, $first, $last);
                echo "\r\n--$boundary\r\n";
                echo "Content-Type: $content_type\r\n";
                echo "Content-range: bytes $first-$last/$filesize\r\n\r\n";
                my_fseek($file, $first);
                buffered_read($file, $last - $first + 1);
            } echo "\r\n--$boundary--\r\n";
        } else {
            $range = $ranges[0];
            set_range($range, $filesize, $first, $last);
            header("Content-Length: " . ($last - $first + 1));
            header("Content-Range: bytes $first-$last/$filesize");
            header("Content-Type: $content_type");
            my_fseek($file, $first);
            buffered_read($file, $last - $first + 1);
        }
    } else {
        header("Accept-Ranges: bytes");
        header("Content-Length: $filesize");
        header("Content-Type: $content_type");
        buffered_read($file, $filesize);
    } fclose($file);
}

function serve($filename, $content_type = "application/octet-stream", $download = 0) {
    die("xxxxxxx");
    $filesize = my_filesize($filename);
    header("Content-Length: $filesize");
    header("Content-Type:$content_type");
    $filename_parts = pathinfo($filename);
    if ($download)
        header('Content-disposition: attachment; filename=' . $filename_parts['basename']);
    $left = $size = my_filesize($filename);
    $fp = fopen($filename, "r");
    if (!is_resource($fp))
        return -1;
    do {
        $r = fread($fp, 4096);
        echo $r;
        flush();
        if (feof($fp))
            break;
    } while (1);
    fclose($fp);
    return 0;
}

function my_fseek($file, $first) {
    $left = $first;
    $seek_max = 2000000000;
    fseek($file, 0, SEEK_SET);
    do {
        if ($left <= $seek_max) {
            $seek = intval($left);
            fseek($file, $left, SEEK_CUR);
            break;
        } $seek = intval($seek_max);
        $left -= $seek_max;
        fseek($file, $seek_max, SEEK_CUR);
    } while (1);
}

function my_filesize($filename) {
    $r = exec("/usr/bin/stat -c %s " . escapeshellarg($filename));
    @$filesize = floatval($r);
    return $filesize;
}
