<?php

class extern_proc {

    function parse_output($s, $type) {
        
    }

    var $cmd;
    var $proc;
    var $pid;
    var $pipes;
    var $rval;

    function open($cmd) {
        $ds = array(0 => array("pipe", "r"), 1 => array("pipe", "w"), 2 => array("pipe", "w"));
        $p = proc_open($cmd, $ds, $pipes);
        if (!is_resource($p)) {
            return -1;
        } 
        stream_set_blocking($pipes[0], 0);
        stream_set_blocking($pipes[1], 0);
        stream_set_blocking($pipes[2], 0);
        $status = proc_get_status($p);
        $this->pid = $status["pid"];
        $this->cmd = $cmd;
        $this->pipes = $pipes;
        $this->proc = $p;
        unset($this->rval);
        return 0;
    }

    function isRunning() {
        return isset($this->proc);
    }

    function close($send_sigterm) {
        if (!isset($this->proc))
            return 1;
        if ($send_sigterm) {
            self::proc_kill_all($this->proc);
        } 
        
        do {
            if (feof($this->pipes[1]) and feof($this->pipes[2]))
                break;
            fwrite($this->pipes[0], "\n");
            usleep(1000000 / 10);
            $this->flush_pipe();
        } while (1);
        $status = proc_get_status($this->proc);
        $exitCode = proc_close($this->proc);
        if (!$status["running"]) {
            $this->rval = $status["exitcode"];
        } else {
            $this->rval = $exitCode;
        } 
        unset($this->proc, $this->pipes);
        return 0;
    }

    private function flush_pipe() {
        if (!isset($this->proc))
            return 1;
        foreach (array(2, 1) as $pipe) {
            do {
                $line = fgets($this->pipes[$pipe]);
                if (!is_string($line)) {
                    break;
                } 
                $this->parse_output($line, $pipe);
            } while (1);
        } 
        return 0;
    }

    function tick() {
        if (!isset($this->proc))
            return 1;
        $this->flush_pipe();
        $status = proc_get_status($this->proc);
        if (!is_array($status))
            return -1;
        if (!$status["running"]) {
            $this->close(0);
            $this->rval = $status["exitcode"];
            return 1;
        } 
        return 0;
    }

    static function proc_kill_all($process) {
        $status = proc_get_status($process);
        if ($status['running'] != true)
            return -1;
        $ppid = $status['pid'];
        self::pid_kill_all($ppid);
    }

    static function pid_kill_all($ppid_to_kill) {
        $proc_items = scandir("/proc");
        $pids = array();
        foreach ($proc_items as $pid) {
            if (!is_numeric($pid))
                continue;
            $status = file_get_contents("/proc/$pid/status");
            if (!is_string($status))
                continue;
            $r = preg_match("/PPid:\s*(\d*)/", $status, $m);
            if ($r != 1)
                continue;
            $ppid = intval($m[1]);
            if ($ppid != $ppid_to_kill)
                continue;
            $pids[] = $pid;
        } 
        $pids[] = $ppid_to_kill;
        foreach ($pids as $pid) {
            posix_kill($pid, SIGINT);
        }
    }
}
