<?php

function make_resp($status, $message) {
    return array("status" => $status, "message" => $message);
}

function ok() {
    return make_resp(0, "");
}

function device_not_found() {
    return make_resp(-1, "device id not found");
}

function unsupported_command() {
    return make_resp(-2, "unsupported command");
}

function missing_required_parameter() {
    return make_resp(-3, "missing required parameter");
}

function error_parameter() {
    return make_resp(-4, "error parameter");
}

function error_communicating_device() {
    return make_resp(-5, "error communicating device");
}

function error_path_not_readable() {
    return make_resp(-6, "root path not readable");
}

function error_directory_not_exists() {
    return make_resp(-7, "directory not exists");
}

function error_need_login() {
    return make_resp(-8, "need login");
}

function error_appletv_need_auth() {
    return make_resp(-9, "apple tv needs authentication");
}

function error_appletv_http() {
    return make_resp(-10, "error when communicating apple tv");
}

function error_function_not_supported() {
    return make_resp(-11, "function not supported by this device");
}

function error_svc_not_found() {
    return make_resp(-12, "qairplay service not found (qpkg not started?)");
}

function error_not_loaded() {
    return make_resp(-13, "not playing a media");
}

function error_unknown() {
    return make_resp(-999, "undefined error");
}
