<?php

require_once("socket.inc.php");

class unix_socket_server {

    var $svr_socket = NULL;
    var $socket_name = "";

    public function unix_socket_server($socket_name) {
        $this->socket_name = $socket_name;
    }

    public function on_accept($s, $cb_on_message_arrived) {
        $peer = socket_accept($s);
        if (!is_resource($peer)) {
            echo "fail socket_accept(\$s);\n";
            return 1;
        } $recv_buffer = socket_read_all($peer);
        $shutdown_ok = socket_shutdown($peer, 0);
        $r_cb = $cb_on_message_arrived($recv_buffer);
        if (is_string($r_cb))
            socket_write($peer, $r_cb);
        socket_shutdown($peer, 2);
        socket_close($peer);
        return 0;
    }

    public function check_message($cb_on_message_arrived, $timeout = 1.0, $skip_select = 0) {
        $s = $this->svr_socket;
        $r_listen = 1;
        if ($skip_select == 0) {
            $read_fd = array($s);
            $write_fd = $except_fd = NULL;
            $sec = intval(floor($timeout));
            $usec = intval(($timeout - $sec) * 1000000);
            $r_listen = @socket_select($read_fd, $write_fd, $except_fd, $sec, $usec);
        } if ($r_listen != 0) {
            $r = $this->on_accept($s, $cb_on_message_arrived);
            return $r;
        } return 1;
    }

    function tearDown() {
        socket_close($this->svr_socket);
        unlink($this->socket_name);
        return TRUE;
    }

    function setUp() {
        @unlink($this->socket_name);
        $s = socket_create(AF_UNIX, SOCK_STREAM, 0);
        if (!is_resource($s)) {
            echo "fail socket_create(AF_UNIX, SOCK_STREAM, 0);\n";
            return FALSE;
        } $bind_ok = socket_bind($s, $this->socket_name);
        if (!$bind_ok) {
            echo "fail socket_bind(\$s, \"/tmp/test_sock\");\n";
            return FALSE;
        } $listen_ok = socket_listen($s, 5);
        $this->svr_socket = $s;
        return TRUE;
    }

}
