<?php

require_once(__DIR__ . "/inc/airplay.inc.php");

class PlayItem {

    var $item_md5;
    var $meta;
    var $type;
    var $id;
    var $url;
    var $transition;

    function PlayItem($pl) {
        $this->item_md5 = md5(print_r($pl, TRUE));
        $this->id = $pl->id;
        $bind_ip = "127.0.0.1";
        $this->url = $pl->url;
        $this->type = $pl->type;
        @$this->dur = $pl->dur;
        @$this->transition = $pl->transition;
        @$this->meta = $pl->meta;
    }

    var $load_failed = 0;
    var $loaded = 0;
    var $loaded_time = 0;
    var $start_time = 0;

    function start($dev) {
        print_r($this);
        $dev->loaded = $dev->load_failed = 0;
        $this->loaded = $this->load_failed = $this->loaded_time = 0;
        $this->start_time = microtime(TRUE);
        if ($this->type == "hls_play" and method_exists($dev, "hls_play")) {
            $dev->hls_play($this->url);
        } else if ($this->type == "play" and method_exists($dev, "play")) {
            $dev->play($this->url, $r);
        } else if ($this->type == "photo" and method_exists($dev, "play_photo_url")) {
            $r = $dev->play_photo_url($this->url, $this->transition);
        } else if (($this->type == "play" or $this->type == "rtsp") and method_exists($dev, "play_rtsp")) {
            $this->type = "rtsp";
            $r = $dev->play_rtsp($this->url);
        } else {
            return -1;
        } return 0;
    }

    function tick($dev) {
        if (0 == $this->start_time)
            return(0);
        if ($this->load_failed)
            return 1;
        if (!$this->load_failed and $dev->load_failed) {
            echo "playitem({$this->item_md5}) failed.\n";
            $this->load_failed = 1;
            $this->start_time = 0;
            return 1;
        } if (!$this->loaded and $dev->loaded) {
            $this->loaded = 1;
            $this->loaded_time = (isset($dev->loaded_time) and $dev->loaded_time !== 0) ? $dev->loaded_time : microtime(TRUE);
            return 0;
        } if (!$this->loaded and ! $this->load_failed) {
            return 0;
        } if ("play" == $this->type or "rtsp" == $this->type) {
            if ($dev->completed) {
                $this->load_failed = $this->loaded = 0;
                $this->loaded_time = $this->start_time = 0;
                echo "playitem::dev->completed\n";
                return(1);
            }
        } else if ($this->type == "photo") {
            $dur = isset($this->dur) ? $this->dur : 10;
            if ($dur === 0)
                return(0);
            $now = microtime(TRUE);
            $due = $this->loaded_time + $dur;
            if ($now >= $due) {
                $this->load_failed = $this->loaded = 0;
                $this->loaded_time = $this->start_time = 0;
                return(1);
            }
        } return(0);
    }

    function serialize() {
        return obj2assoc($this, array("id", "type", "url", "meta", "dur", "transition"));
    }

}
