#!/bin/sh
# this script return the complete % of transcoding
# this script will return complete % 
# $1: ffmpeg log file

LOG_DEST="$1"
CAL_FILE=$(mktemp /tmp/tmp.XXXXXX) # make a temp file, we base on this file to get duration, current time and judge whether transcoding finish or not
CAL_FILE_COUNT=0
DURATION=0
CURRENT_TIME=0
TEMP_TIME=0

DURATION_SEC=0 # total video duration
CURRENT_TIME_SEC=0 # current video time

if [ "$#" != 1 ]; then
	echo "$0: input log destnation please"
	rm $CAL_FILE
	exit 200
fi

if [ ! -f "$LOG_DEST" ];then
	echo "$LOG_DEST is not a exist file"
	rm $CAL_FILE
	exit 200
fi

# use head&tail to prevent parsing time too long
#DURATION=$(cat "$LOG_DEST" | grep "Duration:" | sed 's/^.*Duration: //g' | sed 's/\..*$//g')
#TEMP_TIME=$(cat "$LOG_DEST" | grep "time=" | sed 's/^.*time=//g' | sed 's/\..*$//g')
DURATION=$(head "$LOG_DEST" -n 500| grep "Duration:" | sed 's/^.*Duration: //g' | sed 's/\..*$//g')
TEMP_TIME=$(tail "$LOG_DEST" -n 500| grep "time=" | sed 's/^.*time=//g' | sed 's/\..*$//g')
if [ "$DURATION" != "" ];then
	echo "$DURATION" > "$CAL_FILE"
fi

if [ "$TEMP_TIME" != "" ];then
	# we may get many value in TEMP_TIME, we simply get the last one
	for TEMP in $TEMP_TIME
	do
		CURRENT_TIME=$TEMP
	done
	echo "$CURRENT_TIME" >> "$CAL_FILE"
fi

# use tail to prevent parsing time too long
#cat "$LOG_DEST" | grep "global headers" >> "$CAL_FILE" # it will grep this info if transcoding finish 
tail "$LOG_DEST" -n 500| grep "global headers" >> "$CAL_FILE" # it will grep this info if transcoding finish 

#echo "duration = $DURATION"
#echo "current = $CURRENT_TIME"

TEMP=$(wc -l $CAL_FILE)
CAL_FILE_COUNT=$(echo $TEMP | cut -d ' ' -f 1)


#echo "cal line count = $CAL_FILE_COUNT"
#cat $CAL_FILE # show tmp log file content

case $CAL_FILE_COUNT in	
	2)
		#transcoding now, cal %
		#echo "doing transcoding..."
		i=1;
		while [ $i -le 4 ]
			do
				DURATION_TEMP=$(echo "$DURATION" | cut -d ':' -f $i)
				CURRENT_TEMP=$(echo "$CURRENT_TIME" | cut -d ':' -f $i)
				case $i in
					1)
						DURATION_TEMP=$(expr $DURATION_TEMP \* 60)
						DURATION_TEMP=$(expr $DURATION_TEMP \* 60)
						DURATION_SEC=$(expr $DURATION_SEC +  $DURATION_TEMP)
						
						CURRENT_TEMP=$(expr $CURRENT_TEMP \* 60)
						CURRENT_TEMP=$(expr $CURRENT_TEMP \* 60)
						CURRENT_TIME_SEC=$(expr $CURRENT_TIME_SEC +  $CURRENT_TEMP);;
					2)
						DURATION_TEMP=$(expr $DURATION_TEMP \* 60)					
						DURATION_SEC=$(expr $DURATION_SEC +  $DURATION_TEMP)			
						
						CURRENT_TEMP=$(expr $CURRENT_TEMP \* 60)					
						CURRENT_TIME_SEC=$(expr $CURRENT_TIME_SEC +  $CURRENT_TEMP);;		
					3)				
						DURATION_SEC=$(expr $DURATION_SEC +  $DURATION_TEMP)
						
						CURRENT_TIME_SEC=$(expr $CURRENT_TIME_SEC +  $CURRENT_TEMP);;
					*)
						;;
				esac
									
				i=$(expr $i + 1)
			done
			
		#echo "total sec = $DURATION_SEC"		
		#echo "current sec = $CURRENT_TIME_SEC"			
		
		TEMP=$(expr "$CURRENT_TIME_SEC" "*" 100 )
		PERCENT=$(expr "$TEMP" "/" "$DURATION_SEC" )
		
		if [ "$PERCENT" = "" ];then
			PERCENT=0			
		fi
		#echo echo "percent = $PERCENT %, exit"	
		
		rm $CAL_FILE
		exit $PERCENT	
		;;
	3)
		#transcode over, return 100%
		#echo "transcode over."
		rm $CAL_FILE
		exit 200	
		;;
		
	*)
		#just start transcoding, log doesn't have current yet
		#echo "starting transcode"
		rm $CAL_FILE
		exit 0
		;;
esac

rm $CAL_FILE
exit 200