<?php
	header("Content-type: text/xml; charset=utf-8");
	$commandPath = "/usr/local/medialibrary/bin/qRPlayerAgent";
	$p = popen('/sbin/getcfg -f /etc/config/qpkg.conf QDMS Install_Path', 'r');
	if($p != false) {
		$path = trim(fgets($p));
		if(strlen($path) != 0){
			$commandPath = '/mnt/ext/opt/QDMS/bin/qRPlayerAgent';
		}
	}
	pclose($p);
	$xml_declare = '<?xml version="1.0" encoding="UTF-8" ?>';
	class ErrorNumber
	{		
		const ERROR_COMMAND = -100;
		const ERROR_ARGUMENT = -101;
		const FILE_NOT_FOUND = -102;
		const CREATE_FILE_FAILED = -103;
	}
	
	class PlayerAgentException extends Exception
	{
		public function printErrorMessage()
		{
			$errorMessage = $this->getCode() . ":" . $this->getMessage();
			echo $this->genErrorMessage($errorMessage);
		}
		
		private function genErrorMessage($errorMessage)
		{
			$message = $xml_declare;
			$message = $message . '<root>' . '<status>' .
				$errorMessage . 
				'</status>' . '</root>';
			return $message;
		}
	}
	$errorMessage = Array
	(
		ErrorNumber::FILE_NOT_FOUND=>"File" . $commandPath . "not found.",
		ErrorNumber::ERROR_COMMAND=>"We got error command.",
		ErrorNumber::ERROR_ARGUMENT=>"Error argument for playerAgent.",
		ErrorNumber::CREATE_FILE_FAILED=>"Create file failed."
	);	
	$commandType = Array
	(
		"General command",
		"Player control command",
		"Playlist edit command"
	);	
	$commandStruct = Array
	(
		$commandType[0]=>Array(),
		$commandType[1]=>Array(),
		$commandType[2]=>Array()
	);
	$nowStructNumber = -1;
	$result = popen($commandPath, 'r');
	try{
		if($result == false)
			throw new PlayerAgentException($errorMessage[ErrorNumber::FILE_NOT_FOUND], ErrorNumber::FILE_NOT_FOUND);
	}catch(PlayerAgentException $e){
		$e->printErrorMessage();
	}
	while(!feof($result))
	{
		$line = fgets($result);
		trim($line);
		if(strncasecmp($line, $commandType[0], strlen($commandType[0])) == 0){
			$nowStructNumber = 0;
		}elseif(strncasecmp($line, $commandType[1], strlen($commandType[1])) == 0){
			$nowStructNumber = 1;
		}elseif(strncasecmp($line, $commandType[2], strlen($commandType[2])) == 0){
			$nowStructNumber = 2;
		}else{
			if($nowStructNumber == -1){
				continue;
			}
			$token = strtok($line, ' ');
			$commandArray = Array();
			$optionCommand = false;
			while($token !== false){
				
				if(strncmp($token, "-c", 2) == 0){
					$token = strtok(' ');
					trim($token);
					array_push($commandArray, $token);
				}elseif(strncmp($token, "--", 2) == 0){
					if($optionCommand)
						array_push($commandArray, '[' . trim(substr($token, 2)) . ']');
					else
						array_push($commandArray, trim(substr($token, 2)));
				}elseif(strncmp($token, "[--", 3) == 0){
					$optionCommand = true;
					array_push($commandArray, '[' . trim(substr($token, 3)) . ']');
				}elseif(stristr($token, ']') != false){
					$optionCommand = false;
				}
				$token = strtok(' ');
			}
			$optionCommand = false;
			if(count($commandArray, 1) == 0){
				continue;
			}
			array_push($commandStruct[$commandType[$nowStructNumber]], $commandArray);
		}
	}
	pclose($result);
	$_COMMAND = getParam('cmd');
	if(strcmp($_COMMAND, 'BatchAddPlaylist') == 0 ||
	   strcmp($_COMMAND, 'BatchDelPlaylist') == 0){
		batchProcedure($_COMMAND);
	}else{
		try{
			processGetArgument($_COMMAND);
		}catch(PlayerAgentException $e){
			$e->printErrorMessage();
		}
	}
	
	function getParam($tag)
	{
		return isset($_GET[$tag])?$_GET[$tag]:(isset($_POST[$tag])?$_POST[$tag]:null);
	}

	function processGetArgument($cmd)
	{
		global $commandType, $commandStruct, $errorMessage;
		if(strlen($cmd) == 0)
		{
			throw new PlayerAgentException($errorMessage[ErrorNumber::ERROR_COMMAND], ErrorNumber::ERROR_COMMAND);
		}		
		$cmdFound = false;
		for($i = 0;$i < 3;$i++){
			for($j = 0;$j < count($commandStruct[$commandType[$i]], 0);$j++){
				if(strncmp($cmd, $commandStruct[$commandType[$i]][$j][0], strlen($cmd)) == 0){
					excute($commandStruct[$commandType[$i]][$j]);
					$cmdFound = true;
					break;
				}
			}
			if($cmdFound)
				break;				
		}
		if(!$cmdFound){
			throw new PlayerAgentException($errorMessage[ErrorNumber::ERROR_COMMAND], ErrorNumber::ERROR_COMMAND);
		}
	}
	
	function excute($commandArray)
	{	
		global $errorMessage, $xml_declare;
		$checkArgument = true;
		$argumentArray = Array();
		//var_dump($_GET);
		//echo "</br>";
		for($i = 1;$i < count($commandArray, 0);$i++)
		{
			if(strncmp($commandArray[$i], '[', 1) != 0  && strlen($_GET[$commandArray[$i]]) != 0){
				array_push($argumentArray, $_GET[$commandArray[$i]]);				
			}elseif(strncmp($commandArray[$i], '[', 1) == 0){
				$argument = substr($commandArray[$i], 1, strlen($commandArray[$i])-2);
				if(strlen($_GET[$argument]) != 0){
					array_push($argumentArray, $_GET[$argument]);
				}else{
					array_push($argumentArray, "");
				}
			}else{
				//too few argument or no necessary argument or error argument
				throw new PlayerAgentException($errorMessage[ErrorNumber::ERROR_ARGUMENT], ErrorNumber::ERROR_ARGUMENT);
			}
		}
		if($checkArgument)
		{
			global $commandPath;
			$cmd = $commandPath . " -c " . $commandArray[0];
			for($i = 0;$i < count($argumentArray, 0);$i++)
			{
				$argumentArray[$i] = quotemeta($argumentArray[$i]);				
				$argumentArray[$i] = addcslashes($argumentArray[$i],' ');
				if(Strncmp($commandArray[$i+1], '[', 1) !=0){
					$cmd = $cmd . " --" . $commandArray[$i+1] . " " . $argumentArray[$i];
				}
				else{
					if(strlen($argumentArray[$i]) != 0){
						$cmd = $cmd . " --" . substr($commandArray[$i+1], 1, strlen($commandArray[$i+1])-2) . " " . $argumentArray[$i];
					}
				}
			}
			trim($cmd);
			$result = popen($cmd, 'r');
			echo $xml_declare;
			while(!feof($result)){
				echo fgets($result);				
			}  	
			pclose($result);
		}
	}
	
	//To handle batch procedure
	function batchProcedure($cmd) {
		global $xml_declare, $commandPath;
		$data = json_decode(stripslashes(getParam('data')), true);
		//var_dump($data);
		$filePath = '/tmp/' . $cmd . '.' . rand();
		//var_dump($file);
		$p = fopen($filePath, 'w');
		try{
			if($p == false)
				throw new PlayerAgentException($errorMessage[ErrorNumber::CREATE_FILE_FAILED], ErrorNumber::CREATE_FILE_FAILED);
		}catch(PlayerAgentException $e){
			$e->printErrorMessage();
		}
		//don't add xml_declare
		//$xml = $xml_declare . "\n";
		$xml = $xml . "<root>\n";
		if(strcmp($cmd, 'BatchAddPlaylist') == 0) {
			$keys = array_keys($data);
			//var_dump($keys);
			for($i = 0;$i < count($data);$i++) {
				//var_dump($keys[$i]);
				//var_dump($data[$keys[$i]]);
				if(strcmp($keys[$i], 'items') == 0){
					$items = $data[$keys[$i]];
					//var_dump($items);
					for($j = 0;$j < count($items);$j++) {
						$item = $items[$j]['item'];
						unset($items[$j]['item']);
						$xml = $xml . "\t" . genXMLItem('item', $items[$j], $item) . "\n";
					}
				}else if(strcmp($keys[$i], 'playlist') == 0) {
					$playlist = $data[$keys[$i]];
					$title = $data[$keys[$i]]['playlist'];
					unset($data[$keys[$i]]['playlist']);
					$xml = $xml . "\t" . genXMLItem($keys[$i], $data[$keys[$i]], $title) . "\n";
				}else{
					$xml = $xml . "\t" . genXMLItem($keys[$i], false, $data[$keys[$i]]) . "\n";
				}
			}
		}else if(strcmp($cmd, 'BatchDelPlaylist') == 0) {
			$keys = array_keys($data);
			for($i = 0;$i < count($data);$i++) {
				//var_dump($keys[$i]);
				//var_dump($data[$keys[$i]]);
				if(strcmp($keys[$i], 'items') == 0) {
					$items = $data[$keys[$i]];
					for($j = 0;$j < count($items);$j++) {
						$item = $items[$j]['uuid'];
						$xml = $xml . "\t" . genXMLItem('uuid', false, $item) . "\n";
					}
				}else {
					//echo 'key = ' . $keys[$i] . "\n";
					//echo 'data = ' . $data[$keys[$i]] . "\n";
					$xml = $xml . "\t" . genXMLItem($keys[$i], false, $data[$keys[$i]]) . "\n";
				}
			}
		}
		$xml = $xml . "</root>\n";
		//echo $xml;
		fputs($p, $xml);
		fclose($p);
		$exeCmd = $commandPath . ' -c ' . $cmd . ' --filePath ' . $filePath;
		//echo $exeCmd;
		$p = popen($exeCmd, 'r');
		//echo $xml_declare . "\n";
		while(!feof($p)){
			echo fgets($p);				
		}
		pclose($p);
		unlink($filePath);
	}
	
	function genXMLItem($tag, $attribute, $value) {
		//var_dump('genXMLItem');
		$ret = '<' . $tag;
		if($attribute != false) {
			$keys = array_keys($attribute);
			for($i = 0;$i < count($attribute);$i++) {
				$ret = $ret . ' ' . $keys[$i] . '="' . $attribute[$keys[$i]] . '"';
			}			
		}
		if($value != false) {
			$ret = $ret . '>' . $value . '</' . $tag . '>';
		}else{
			$ret = $ret . '/>';
		}
		//var_dump($ret);
		return $ret;
	}
?>