<?php
	header('Content-Type: text/plain; charset=UTF-8');
	$commandPath = "/usr/bin/qDmcAgent";
	$p = popen('/sbin/getcfg -f /etc/config/qpkg.conf QDMS Install_Path', 'r');
	if($p != false) {
		$path = trim(fgets($p));
		if(strlen($path) != 0){
			$commandPath = '/mnt/ext/opt/QDMS/bin/qDmcAgent';
		}
	}
	pclose($p);
	class ErrorNumber
	{		
		const ERROR_COMMAND = -100;
		const ERROR_ARGUMENT = -101;
		const FILE_NOT_FOUND = -102;
	}
	
	class PlayerAgentException extends Exception
	{
		public function printErrorMessage()
		{
			$errorMessage = $this->getCode() . ":" . $this->getMessage();
			echo $this->genErrorMessage($errorMessage);
		}
		
		private function genErrorMessage($errorMessage)
		{
			$message = '<?xml version="1.0" encoding="UTF-8" ?>';
			$message = $message . '<root>' . '<status>' .
				$errorMessage . 
				'</status>' . '</root>';
			return $message;
		}
	}
	$errorMessage = Array
	(
		ErrorNumber::FILE_NOT_FOUND=>"File" . $commandPath . "not found.",
		ErrorNumber::ERROR_COMMAND=>"We got error command.",
		ErrorNumber::ERROR_ARGUMENT=>"Error argument for serverAgent."
	);	
	$commandType = Array
	(
		"General command",
		"UPnP ContentDirectory comand",
		"Rander Contorl command",
		"Connection Manager command",
		"AV Transport command",
		"Extended command"
	);	
	$commandStruct = Array
	(
		$commandType[0]=>Array(),
		$commandType[1]=>Array(),
		$commandType[2]=>Array(),
		$commandType[3]=>Array(),
		$commandType[4]=>Array(),
		$commandType[5]=>Array()
	);
	
	$nowStructNumber = -1;
	$result = popen($commandPath, 'r');
	try{
		if($result == false)
			throw new PlayerAgentException($errorMessage[ErrorNumber::FILE_NOT_FOUND], ErrorNumber::FILE_NOT_FOUND);
	}catch(PlayerAgentException $e){
		$e->printErrorMessage();
	}
	while(!feof($result))
	{
		$line = fgets($result);
		trim($line);
		if(strncasecmp($line, $commandType[0], strlen($commandType[0])) == 0){
			$nowStructNumber = 0;
		}elseif(strncasecmp($line, $commandType[1], strlen($commandType[1])) == 0){
			$nowStructNumber = 1;
		}elseif(strncasecmp($line, $commandType[2], strlen($commandType[2])) == 0){
			$nowStructNumber = 2;
		}elseif(strncasecmp($line, $commandType[3], strlen($commandType[3])) == 0){
			$nowStructNumber = 3;
		}elseif(strncasecmp($line, $commandType[4], strlen($commandType[4])) == 0){
			$nowStructNumber = 4;
		}elseif(strncasecmp($line, $commandType[5], strlen($commandType[5])) == 0){
			$nowStructNumber = 5;
		}else{
			if($nowStructNumber == -1){
				continue;
			}
			$token = strtok($line, ' ');
			$commandArray = Array();
			$optionCommand = false;
			while($token !== false){				
				if(strncmp($token, "-c", 2) == 0){
					$token = strtok(' ');
					trim($token);
					array_push($commandArray, $token);
				}elseif(strncmp($token, "--", 2) == 0){
					if($optionCommand)
						array_push($commandArray, '[' . trim(substr($token, 2)) . ']');
					else
						array_push($commandArray, trim(substr($token, 2)));
				}elseif(strncmp($token, "[--", 3) == 0){
					$optionCommand = true;
					array_push($commandArray, '[' . trim(substr($token, 3)) . ']');
				}elseif(stristr($token, ']') != false){
					$optionCommand = false;
				}
				$token = strtok(' ');
			}
			$optionCommand = false;
			if(count($commandArray, 1) == 0){
				continue;
			}
			array_push($commandStruct[$commandType[$nowStructNumber]], $commandArray);
		}
	}
	pclose($result);
	$_COMMAND = $_GET[cmd];
	try{
		processGetArgument($_COMMAND);
	}catch(PlayerAgentException $e){
		$e->printErrorMessage();
	}
	

	function processGetArgument($cmd)
	{
		global $commandType, $commandStruct, $errorMessage;
		if(strlen($cmd) == 0)
		{
			throw new PlayerAgentException($errorMessage[ErrorNumber::ERROR_COMMAND], ErrorNumber::ERROR_COMMAND);
		}		
		$cmdFound = false;
		for($i = 0;$i < 3;$i++){
			for($j = 0;$j < count($commandStruct[$commandType[$i]], 0);$j++){
				if(strncmp($cmd, $commandStruct[$commandType[$i]][$j][0], strlen($cmd)) == 0){
					excute($commandStruct[$commandType[$i]][$j]);
					$cmdFound = true;
					break;
				}
			}
			if($cmdFound)
				break;				
		}
		if(!$cmdFound){
			throw new PlayerAgentException($errorMessage[ErrorNumber::ERROR_COMMAND], ErrorNumber::ERROR_COMMAND);
		}
	}
	
	function excute($commandArray)
	{	
		global $errorMessage;
		$checkArgument = true;
		$argumentArray = Array();
		for($i = 1;$i < count($commandArray, 0);$i++)
		{
			if(strncmp($commandArray[$i], '[', 1) != 0  && strlen($_GET[$commandArray[$i]]) != 0){
				array_push($argumentArray, $_GET[$commandArray[$i]]);
			}elseif(strncmp($commandArray[$i], '[', 1) == 0){
				$argument = substr($commandArray[$i], 1, strlen($commandArray[$i])-2);
				if(strlen($_GET[$argument]) != 0){
					$str = stripslashes($_GET[$argument]);
					array_push($argumentArray, $str);
				}else{
					array_push($argumentArray, "");
				}
			}else{
				//too few argument or no necessary argument or error argument
				throw new PlayerAgentException($errorMessage[ErrorNumber::ERROR_ARGUMENT], ErrorNumber::ERROR_ARGUMENT);
			}
		}
		if($checkArgument)
		{
			global $commandPath;
			$cmd = $commandPath . " -c " . $commandArray[0];
			for($i = 0;$i < count($argumentArray, 0);$i++)
			{
				$argumentArray[$i] = quotemeta($argumentArray[$i]);
				$argumentArray[$i] = addcslashes($argumentArray[$i],' ');
				//for searchObject
				$argumentArray[$i] = addcslashes($argumentArray[$i],'"');
				if(Strncmp($commandArray[$i+1], '[', 1) !=0){
					$cmd = $cmd . " --" . $commandArray[$i+1] . " " . $argumentArray[$i];
				}
				else{
					if(strlen($argumentArray[$i]) != 0){
						$cmd = $cmd . " --" . substr($commandArray[$i+1], 1, strlen($commandArray[$i+1])-2) . " " . $argumentArray[$i];
					}
				}
			}
			trim($cmd);
			$result = popen($cmd, 'r');
			while(!feof($result)){
				echo fgets($result);
			}
			pclose($result);
		}
	}
?>
