#!/bin/sh
[ -z $1 ] && exit 1
#d=delay
#m=mixer
speaker_cli=$0
audioNum=`/sbin/getcfg "System" "usbAudioDevNum" -d 0 -f /var/.system.info`
QDMS_Enable=`/sbin/getcfg QDMS Enable -d FALSE -u -f /etc/config/qpkg.conf`
Model=`/sbin/getcfg Enclosure_0 model -f /etc/hal.conf`
uModel=`/sbin/getcfg System Model -f /etc/default_config/uLinux.conf`
builtin_speaker=
[ x"$Model" = x"TBS-453A" -o x"$uModel" = x"TS-X82" -o x"$uModel" = x"TS-X35" ] && builtin_speaker="PCH_ALC262-Analog_0"

get_mute()
{
	mute=off
	ret=0
	if [ x"$QDMS_Enable" = xTRUE ] && [ ! -z $builtin_speaker ]; then
		mute=`/usr/local/medialibrary/bin/qRPlayerAgent -c GetMute --dev $builtin_speaker 2>/dev/null | /bin/grep mute | /bin/cut -d '>' -f 2 | /bin/cut -d '<' -f 1`
		[ "x$mute" = "xon" ] && ret=1
	else
		[ -f /tmp/.vol.audio${audioNum}.pre ] && ret=1
	fi
	
	return $ret
}

get_vol()
{
	vol=0
	if [ x"$QDMS_Enable" = xTRUE ] && [ ! -z $builtin_speaker ]; then
		vol=`/usr/local/medialibrary/bin/qRPlayerAgent -c GetVolume --dev $builtin_speaker 2>/dev/null | /bin/grep volume | /bin/cut -d '>' -f 2 | /bin/cut -d '<' -f 1`
		[ x"$vol" = x ] && vol=0
	else
		vol=`/bin/cat /tmp/.vol.audio${audioNum} 2>/dev/null`
		[ x"$vol" != x ] || vol=`/usr/bin/aumix -d /dev/mixer${audioNum} -q 2>/dev/null | /bin/grep "vol " | /bin/cut -d " " -f 3`
		[ x"$vol" != x ] || vol=0
	fi
	[ $vol -gt 100 ] && vol=100
	[ $vol -lt 0 ] && vol=0
	
	return $vol
}

if [ ! -z $builtin_speaker ]; then
if [ ! -z $1 ] && [ $1 = "getvol" ]; then
	get_mute
	g_mute=$?
	get_vol
	g_vol=$?
	[ $g_vol -eq 0 ] && g_mute=1 #show mute when vol==0
	echo $g_mute,$g_vol
	exit 0
elif [ ! -z $1 ] && [ $1 = "mute" ]; then
	if [ x"$QDMS_Enable" = xTRUE ]; then
		/usr/local/medialibrary/bin/qRPlayerAgent -c SetMute --dev $builtin_speaker --mute on 1>/dev/null 2>/dev/null
	else
		#[ ! -f /tmp/.vol.audio${audioNum}.pre ] || exit 0 #had been muted
		/usr/bin/aumix -f /tmp/.aumix.audio${audioNum} -S 1>/dev/null 2>/dev/null
		/bin/mv /tmp/.vol.audio${audioNum} /tmp/.vol.audio${audioNum}.pre 2>/dev/null
		/bin/echo 0 > /tmp/.vol.audio${audioNum}
		/bin/chmod 666 /tmp/.vol.audio${audioNum}
		/usr/bin/aumix -v 0 1>/dev/null 2>/dev/null
	fi
	exit 0
elif [ ! -z $1 ] && [ $1 = "unmute" ]; then
	if [ x"$QDMS_Enable" = xTRUE ]; then
		/usr/local/medialibrary/bin/qRPlayerAgent -c SetMute --dev $builtin_speaker --mute off 1>/dev/null 2>/dev/null
	else
		/usr/bin/aumix -f /tmp/.aumix.audio${audioNum} -L 1>/dev/null 2>/dev/null
		/bin/rm -f /tmp/.aumix.audio${audioNum}
		/bin/mv /tmp/.vol.audio${audioNum}.pre /tmp/.vol.audio${audioNum} 2>/dev/null
	fi
	get_vol
	[ $? -eq 0 ] && $speaker_cli 1
	
	exit 0
fi
fi

if [ ! -z $1 ] && [ ! -z $2 ] && [ $1 = "d" ]; then
	sleep $2
	l=$3
	[ -z $l ] && exit 1
	if [ "x$4" = "xm" ] && [ ! -z $5 ]; then
		audioNum=$5
		r=$l
	else
		r=$4
		[ ! -z $r ] || r=$l	
	fi
else
	l=$1
	[ -z $l ] && exit 1
	if [ "x$2" = "xm" ] && [ ! -z $3 ]; then
		audioNum=$3
		r=$l
	else
		r=$2
		[ ! -z $r ] || r=$l
	fi
fi

[ -f /usr/bin/aumix ] || /bin/ln -sf /usr/local/sbin/aumix /usr/bin/
if [ ! -z $builtin_speaker ] && [ x"$QDMS_Enable" = xTRUE ] && [ "$audioNum" = "0" ] && [ -x /usr/local/medialibrary/bin/qRPlayerAgent ]; then
	vol_plus_prefix=`/usr/bin/expr substr "$l" 1 1`
	vol_plus_val=`/usr/bin/expr substr "$l" 2 3`
	get_vol
	pre_vol=$?
	if [ $vol_plus_prefix = "+" ]; then
		now_vol=$(($pre_vol+$vol_plus_val))
	elif [ $vol_plus_prefix = "-" ]; then
		now_vol=`/usr/bin/expr $(($pre_vol)) - $vol_plus_val`
	else
		now_vol=$l
	fi
	/bin/rm -f /tmp/.aumix.audio${audioNum}
	/bin/rm -f /tmp/.vol.audio${audioNum}.pre
	#qRPlayerAgent will set mixer vol
	echo "vol:$now_vol:$now_vol:P" > /tmp/aumix.conf; echo "speaker:100:100:P" >> /tmp/aumix.conf ; echo "phout:100:$100:P" >> /tmp/aumix.conf; echo "dig1:100:100:P" >> /tmp/aumix.conf; /usr/bin/aumix -d /dev/mixer${audioNum} -f /tmp/aumix.conf -L 1>/dev/null 2>/dev/null
	/usr/local/medialibrary/bin/qRPlayerAgent -c SetVolume --dev $builtin_speaker --vol $now_vol | /bin/grep '<status>0<' >/dev/null
else
	get_vol
	pre_vol=$?
	vol_plus_prefix=`/usr/bin/expr substr "$l" 1 1`
	vol_plus_val=`/usr/bin/expr substr "$l" 2 3`
	if [ $vol_plus_prefix = "+" ]; then
		now_vol=$(($pre_vol+$vol_plus_val))
		l=$now_vol
		r=$l
	elif [ $vol_plus_prefix = "-" ]; then
		now_vol=`/usr/bin/expr $(($pre_vol)) - $vol_plus_val`
		l=$now_vol
		r=$l
	fi
	[ $l -gt 100 ] && l=100
	[ $l -lt 0 ] && l=0
	[ $r -gt 100 ] && r=100
	[ $r -lt 0 ] && r=0

	sl=$l; sr=$r
	pl=$l; pr=$r
	dl=$l; dr=$r
	pcml=$l; pcmr=$r
	/usr/bin/aumix -d /dev/mixer${audioNum} -q 2>/dev/null | /bin/grep "^vol" 1>/dev/null 2>/dev/null
	if [ $? = 0 ]; then
		sl=100; sr=100; pl=100; pr=100; dl=100; dr=100; pcml=100; pcmr=100
	else
		/usr/bin/aumix -d /dev/mixer${audioNum} -q 2>/dev/null | /bin/grep "^speaker" 1>/dev/null 2>/dev/null
		if [ $? = 0 ]; then
			pl=100; pr=100
		fi
	fi

	/bin/rm -f /tmp/.aumix.audio${audioNum}
	/bin/rm -f /tmp/.vol.audio${audioNum}.pre
	/bin/echo $l > /tmp/.vol.audio${audioNum}
	/bin/chmod 666 /tmp/.vol.audio${audioNum}
	if [ ! -z $builtin_speaker ]; then
	echo "vol:$l:$r:P" > /tmp/aumix.conf; echo "mic:0:0:R" >> /tmp/aumix.conf; echo "speaker:$sl:$sr:P" >> /tmp/aumix.conf ; echo "phout:$pl:$pr:P" >> /tmp/aumix.conf; echo "dig1:$dl:$dr:P" >> /tmp/aumix.conf; /usr/bin/aumix -d /dev/mixer${audioNum} -f /tmp/aumix.conf -L 1>/dev/null 2>/dev/null
	else
	echo "vol:$l:$r:P" > /tmp/aumix.conf; echo "pcm:$pcml:$pcmlr:P" >> /tmp/aumix.conf; echo "pcm2:$pcml:$pcmr:P" >> /tmp/aumix.conf; echo "mic:0:0:R" >> /tmp/aumix.conf; echo "speaker:$sl:$sr:P" >> /tmp/aumix.conf ; echo "phout:$pl:$pr:P" >> /tmp/aumix.conf; echo "dig1:$dl:$dr:P" >> /tmp/aumix.conf; /usr/bin/aumix -d /dev/mixer${audioNum} -f /tmp/aumix.conf -L 1>/dev/null 2>/dev/null
	fi
	/bin/chmod 666 /tmp/aumix.conf 2>/dev/null
fi
