#load json data
geoip_json_path=/tmp/geoip.json
geoip_xml_path=/tmp/geoip.xml

CURL=/sbin/curl

[ "$1" != "" ] && geoip_json_path=$1
[ "$2" != "" ] && geoip_xml_path=$2
[ "$3" != "" ] && query_str="?public_ip=$3"

function jsonval() {
    temp=`echo $json_data | sed 's/\\\\\//\//g' | sed 's/[{}]//g' | awk -v k="text" '{n=split($0,a,","); for (i=1; i<=n; i++) print a[i]}' | sed 's/\"\:\"/\|/g' | sed 's/[\,]/ /g' | sed 's/\"//g' | grep $1 | awk -F ":" '{print $NF}'`
    echo ${temp##*|}
}

function printxml() {
    if [ -z $2 ]; then
        echo "<$1><![CDATA[$(jsonval $1)]]></$1>" >> $geoip_xml_path
    else
        echo "<$1><![CDATA[$(jsonval $2)]]></$1>" >> $geoip_xml_path
    fi
}

function generate_geoxml() {
    #load json data
    json_data=$(cat $geoip_json_path)
    #generate xml data
    echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" > $geoip_xml_path
    echo "<GeoIP>" >> $geoip_xml_path
    #echo "<ip><![CDATA[$(jsonval "public_ip")]]></ip>" >> $geoip_xml_path
    printxml "ip" "public_ip"
    printxml "continent_code" "continent"
    printxml "country_code"
    printxml "country_code3"
    printxml "country_name"
    printxml "region_name" "region"
    printxml "city"
    printxml "postal_code"
    printxml "latitude"
    printxml "longitude"
    printxml "dma_code"
    printxml "area_code"
    echo "</GeoIP>" >> $geoip_xml_path
}

#translate to xml format

/usr/bin/qcloud_cli -g "$3" > ${geoip_json_path} 2>/dev/null

generate_geoxml

#cat $geoip_xml_path
