Ext.ns('QNAP.QOS.fileExplorer');//422
QNAP.QOS.fileExplorer = Ext.extend(QNAP.QOS.BorderApp, {
defaultTitle : 'File manager',
config:QNAP.QOS.fileExplorer.config,
defaultWidth : 1024,
defaultHeight : 590,
isReady : true,
keepMask : false,
layout : "border",
cls : 'fm-css',
cloudDrives: [],
remeberSelectionsPlugin : function() {
var remSelectionRecMap, lastPath, cmp;
function remeberSelect() {
Ext.each(cmp.getSelectionModel().getSelections(), function(r) {
remSelectionRecMap[r.get('filepath') + '/' + r.get('filename')] = r;
})
}
function getSelections(checkFlag) {
var records = [];
Ext.iterate(remSelectionRecMap, function(key, value) {
var oldRecPath = value.get('filepath') + '/'
+ value.get('filename');
if (checkFlag) {
cmp.store.findBy(function(r) {
var newRecPath = r.get('filepath')
+ '/' + r.get('filename');
if (newRecPath == oldRecPath) {
records.push(r);
}
return false;
});
} else {
records.push(value);
}
});
return records;
}
function resumeSelect() {
var records = getSelections(true);
cmp.getSelectionModel().selectRecords(records);
}
function clearSelections(records) {
cmp.store.each(function(r) {
var keyPath = r.get('filepath') + '/'
+ r.get('filename');
remSelectionRecMap[keyPath] = null;
delete remSelectionRecMap[keyPath];
});
}
function clearAllSelections() {
remSelectionRecMap = {};
}
return {
/**
* 移除已選取項目
*
* @return {String||[Record||String]} key
*/
removePluginSelection : function(keyPaths) {
var keys = [];
if (Ext.isString(keyPaths)) {
keys.push(keyPaths);
}
if (Ext.isArray(keyPaths)) {
Ext.each(keyPaths, function(keyPath) {
if (keyPath instanceof Ext.data.Record) {
keys.push(keyPath.get('filepath') + '/'
+ keyPath.get('filename'));
} else if (Ext.isString(keyPath)) {
keys.push(keyPaths);
}
})

}
Ext.each(keys, function(key) {
remSelectionRecMap[key] = null;
delete remSelectionRecMap[key];
});
delete keys;
},
init : function(_cmp) {
cmp = _cmp;
cmp.removePluginSelection = this.removePluginSelection;
Ext.apply(_cmp, this);
cmp.store.on('load', function(store) {
if (lastPath != store.baseParams.path) {
remSelectionRecMap = {};
} else {
resumeSelect();
}
lastPath = store.baseParams.path;
resumeSelect();
});
cmp.store.on('beforeload', function(store) {
if (lastPath != cmp.store.baseParams.path) {
remSelectionRecMap = {};
} else {
remeberSelect();
}
});
cmp.on('beforerender', function(cmp) {
var sm = cmp.getSelectionModel();
sm.getSelections = function(addPluginSelect) {
if (addPluginSelect === false) {
return [].concat(this.selections.items);
} else {
return [].concat(sm.selections.items,
getSelections());
}
};
sm.getCount = function() {
return sm.selections.length
+ getSelections().length;
};
sm.clearAllSelections = clearAllSelections;
sm.onHdMouseDown = Ext.createInterceptor(
sm.onHdMouseDown, function(e, t) {
if(cmp.store.totalLength>0){
var view = cmp.getView();
view.focusRow(0);
}
if (/x-grid3-hd-checker/
.test(t.className)) {
var hd = Ext.fly(t.parentNode);
var isChecked = hd
.hasClass('x-grid3-hd-checker-on');
if (isChecked) {
clearSelections();
}
}
return true;
});
});
cmp.on('destroy', function() {
resumeSelect = null;
getSelections = null;
remeberSelect = null;
remSelectionRecMap = null;
lastPath = null;
cmp = null;
delete resumeSelect;
delete getSelections;
delete remeberSelect;
delete remSelectionRecMap;
delete lastPath;
});
cmp.on('afterrender', this.afterrender);
},
afterrender : function() {
var sm = cmp.getSelectionModel();
sm.on('rowdeselect', function(sm, rowIndex, record) {
var key = record.get('filepath') + '/'
+ record.get('filename');
this.removePluginSelection(key);
}, this);
sm.selectAll = Ext.createSequence(sm.selectAll, function() {
var index = this.grid.store
.find('parentLink', true);
this.deselectRow(index);
}, sm);
}
}
},
initWindowEvents : function(win) {
var FM = this;
win.on('beforeshow', function(fsWin) {
QNAP.QOS.fileExplorerTools.tool.pureGetQsyncSid(FM);
if(!FM.isInited){
FM.initMask = new Ext.LoadMask(
fsWin.id, {msg : (_S._SFE_LANG_COMMON_PLEASE_WAIT + '...')}
);
FM.initMask.show();
}
});
win.on('afterrender', function(fsWin) {

FM.initApplet();
FM.bindEvents();
FM.fsWinId=fsWin.id;
if (Ext.isIE10 || !Ext.isIE) {
document.getElementById(fsWin.id).addEventListener('dragenter',function(e) {

FM.showHtml5UPloadArea(FM.centerPanel.el);
}, false);
document.getElementById(fsWin.id).addEventListener('drop',function(e) {
e.preventDefault();
}, false);
document.getElementById(fsWin.id).addEventListener('dragover', function(e) {
e.preventDefault();
e.dataTransfer.dropEffect = 'none';
}, false);
document.getElementById(fsWin.id).addEventListener('dragleave',function(e) {
var FSL=fsWin.getPosition()[0],
FST=fsWin.getPosition()[1];
var FSR=fsWin.getPosition()[0]+fsWin.getSize().width,
FSB=fsWin.getPosition()[1]+fsWin.getSize().height;

if(e.clientX<=FSL || e.clientY<=FST || e.clientX>=FSR || e.clientY>=FSB ||
e.clientX>=document.documentElement.clientWidth ||
e.clientY>=document.documentElement.clientHeight
){
if(FM.html5DropWin){
FM.html5DropWin.hide();
}
}
}, false);
}
var task = new Ext.util.DelayedTask(function() {
FM.initMask.hide();
FM.isInited=true;
});
task.delay(5000);
}, null, {
single : true,
delay : 1500
});
},
onClipBoardUpdate : function() {
var FM = this;
FM.showActionBtn();
},
bindEvents : function() {
var FM = this;
QNAP.QOS.FileClipBoard.on('update', FM.onClipBoardUpdate, FM);
FM.on('destroy', function() {
QNAP.QOS.FileClipBoard.un('update', FM.onClipBoardUpdate,
FM);
});
FM.gridPanel.on('activate', function() {
Ext.getCmp(FM.IDS.FAV_START_BTN).show();
});
FM.fileListStore.on('load', function(store) {
FM.updatePathBarN(FM.fileListStore.baseParams.path);
});

FM.fileListStore.on('loadexception', function(store) {
Ext.getCmp(FM.IDS.PATH_BAR).doLayout();
FM.fileListStore.removeAll();
});

Ext.getCmp(FM.IDS.FAV_START_BTN).on('hide', function() {
});
Ext.getCmp(FM.IDS.FAV_START_BTN).on('show', function() {
});

FM.gridPanel.getView().on('refresh', function() {
var selections = FM.gridPanel.getSelectionModel().getSelections();
if (FM.eastTab.getComponent('propertyPanel').isVisible()) {
if (selections.length > 0) {
FM.setPropertyPanelInfo(selections);
} else {
FM.setPropertyPanelInfo();
}
}
}, FM, {
buffer : 50
});
FM.pathPanel.on('show', function() {
FM.getCenterCmp().doLayout();
}, null, {
buffer : 50
});
FM.pathPanel.on('hide', function() {
FM.getCenterCmp().doLayout();
}, null, {
buffer : 50
});
FM.streamDeviceMenu.updateRenderList = function (store){
var menu = this;
var mix=new Ext.util.MixedCollection();
var devices = [];
menu.items.each(function(item,index) {
if (item.isDevice) {
mix.add(index, item);
}
});
store.each(function (record){
var recordData = record.data,
isWorking = recordData.isWorking && recordData.appType === 'FileStation';

devices.push({
isDevice: true,
itemId: recordData.deviceId,
iconCls: 'streamDeviceIcon '+recordData.deviceType,
cls : isWorking?'highlight-item':'',
text: recordData.deviceName,
deviceId:recordData.deviceId,
installed:recordData.installed,
deviceType:recordData.deviceType,
handler: QNAP.QOS.fileExplorerAction.openDeviceStream,
scope: FM
});
});

mix.each(function(item) {
menu.remove(item);
});

Ext.each(devices, function(device) {
menu.addMenuItem(device);
});
if (menu && menu.rendered) {
if (menu.isVisible()) {
var owner=menu.ownerCt;
var parentMenu=menu.parentMenu;
if (owner) menu.ownerCt=owner;
if (parentMenu) menu.parentMenu=parentMenu;
}
}
var headerItem=menu.getComponent(0);
try{
headerItem.el.child('.refresh').removeClass('loading');
}catch(e){
}
};

FM.streamDeviceMenu.on('beforeshow',function (menu){
FM.streamDeviceMenu.updateRenderList(FM.streamDeviceStore);
},FM,{single:true});

FM.streamDeviceMenu.on('beforeshow',function (menu){
var headerItem=menu.getComponent(0);
if (this.streamDeviceStore.isLoading){
headerItem.el.child('.refresh').addClass('loading');
}else{
headerItem.el.child('.refresh').removeClass('loading');
}
},FM);
FM.streamDeviceMenu.mon(FM.streamDeviceStore,'beforeload',function (){
var menu = this;
var headerItem=menu.getComponent(0);
try{
headerItem.el.child('.refresh').addClass('loading');
}catch(e){
}
},FM.streamDeviceMenu);

FM.streamDeviceMenu.mon(FM.streamDeviceStore,'load',FM.streamDeviceMenu.updateRenderList,FM.streamDeviceMenu);

FM.streamDeviceMenu.mon(FM.streamDeviceStore,'update',function (store,record){
var menu = this,
cls = 'highlight-item',
deviceId = record.get('deviceId'),
isWorking = record.get('isWorking'),
appType = record.get('appType');

var item = menu.getComponent(deviceId);

if (!item){
return;
}

if (isWorking && appType === 'FileStation'){
item.addClass(cls);
}else{
item.removeClass(cls);
}
},FM.streamDeviceMenu);

FM.treePanel.getSelectionModel().on('selectionchange',
function(treePanel, node) {
if (Ext.isEmpty(node)) {
return;
}
switch (node.id) {
case 'recycleBin' :
node.attributes.onSelect();
break;
}
});
},
initApp : function(config) {
var FM = this;
FM.acl = FM.createAcl();
FM.isWFM = (document.getElementsByTagName("body")[0].id == 'WFMBody');
if(FM.isWFM)
FM.isFirstOpenFM=1;//用來註記獨立頁面的視窗進入以後是否已經執行過進入時要執行的程式。

FM.act;
FM.QsyncError;
FM.QsyncSid;
FM.createContextMenu();
FM.currentPath = '';
FM.currentHost = '';
FM.currentGrid = '';
FM.lastPath = '';
FM.treeNode;// 新複製功能用，用來存放按COPY時的tree Node
FM.unmountId = '';
FM.searchFlag = '';
FM.initStore(config);
FM.initNasFileGrid();
FM.initDropMenu();
FM.getMediaFolderStat();
FM.searchSpace = Ext.id();
FM.eastPanelId = Ext.id();
FM.northPanelId = Ext.id();
FM.copyShareBtnId = Ext.id();
FM.ufileId = Ext.id();
FM.ufolderId = Ext.id();
FM.shareAccess = [];
FM.searchMode = false;
FM.isFromSearch = false;
FM.advSrBtnId = 'advSrBtnId' + Ext.id();
FM.isTextClick;// 點選file Grid的文字使用
FM.isVideoMenuClick;// 點選video選單
FM.stayFlag;// 若停留在該檔案上超過0.3秒才去取縮圖使用
FM.playVideoFile;
FM.advPPPanel;
FM.acl_grid;
FM.isGettingACL = false;
this.callApplet = QNAP.QOS.lib.callApplet;
FM.isOpenMediaLib;
FM.destPath='';
FM.goFirstPage=false;
FM.isAllowAllShare;
FM.sysSetting={};
FM.sysSetting.thumbnail=1;
FM.RTT=false;//supportRTT的總開關，在特殊狀況下視同不支援RTT，例如遠端資料夾、沒裝flash
FM.memPthsArr=[];
FM.stepIndex=0;
FM.isOfficeExtInst=false;
FM.filefilter=QNAP.QOS.user.filefilter;
FM.currentVolTreeNode;
FM.defineds=QNAP.QOS.fileExplorerTools.config;
FM.thumbnailSizes={
small:100,
middle:200,
large:400
};
FM.IDS = {
SEARCH_PAGGING_BAR : 'search-bbar-' + Ext.id(),
SEARCH_PAGGING_BAR_MSG : 'search-msg-' + Ext.id(),
BASIC_SEARCH_CT : 'basic-search-' + Ext.id(),
FAV_START_BTN : 'fav-start-btn-' + Ext.id(),
PATH_BAR : 'pathbar-' + Ext.id(),
PATH_BAR_SPACE : Ext.id(),
QUOTA : 'QUOTA-' + Ext.id(),
BOTTOM_SELECTION_COUNT : 'selection' + Ext.id()
};
FM.ClientTreeLoader = Ext.extend(Ext.tree.TreeLoader, {
load : function(node, callback, scope) {
if (this.clearOnLoad) {
while (node.firstChild) {
node.removeChild(node.firstChild);
}
}

if (this.doPreload(node) || !QNAP.QOS.config.isAppletReady) { // preloaded
this.runCallback(callback, scope || node, [node]);
} else {
this.requestData(node, callback, scope || node);
}
},
requestData : function(node, callback, scope) {
if (this.fireEvent("beforeload", this, node, callback) !== false
&& node.id != 'clientRoot') {
var param = {
PATH : node.id,
TREE_PATH : node.getPath(),
CALLBACK : 'appletCallback',
SHOW_HIDDEN_FILE : QNAP.QOS.user.fe_isShowHideFile,
callbackJs : ''
};
FM.callApplet(FM.getId(), 'qUploadApplet', 'getDirList',
param);
} else {
this.runCallback(callback, scope || node, []);
}
}
});
FM.clientTreeLoader = new FM.ClientTreeLoader();
FM.ClientTreeNode = Ext.extend(Ext.tree.TreeNode, {
loader : FM.clientTreeLoader,
iconCls : 'ClientLeafNode',
constructor : function(config) {
this.loaded = config && config.loaded === true;
this.loading = false;
FM.ClientTreeNode.superclass.constructor.apply(this, arguments);
/**
* @event beforeload Fires before this node is loaded, return
*        false to cancel
* @param {Node}
*            this This node
*/
this.addEvents('beforeload', 'load');
},
expand : function(deep, anim, callback, scope) {
if (this.loading) { // if an async load is already running,
var timer;
var f = function() {
if (!this.loading) { // done loading
clearInterval(timer);
this.expand(deep, anim, callback, scope);
}
}.createDelegate(this);
timer = setInterval(f, 200);
return;
}
if (!this.loaded) {
if (this.fireEvent("beforeload", this) === false) {
return;
}
this.loading = true;
this.ui.beforeLoad(this);
var loader = this.loader || this.attributes.loader
|| this.getOwnerTree().getLoader();
if (loader) {
loader.load(this, this.loadComplete.createDelegate(
this, [deep, anim, callback, scope]),
this);
return;
}
}
FM.ClientTreeNode.superclass.expand.call(this, deep, anim,
callback, scope);
if (this.attributes.data.autoSelect) {
var child = this.findChild('id',
this.attributes.data.autoSelect)
this.attributes.data.autoSelect = false;
if (child)
child.select();
}
},

/**
* Returns true if this node is currently loading
*
* @return {Boolean}
*/
isLoading : function() {
return this.loading;
},

loadComplete : function(deep, anim, callback, scope) {
this.loading = false;
this.loaded = true;
this.ui.afterLoad(this);
this.fireEvent("load", this);
this.expand(deep, anim, callback, scope);
},

/**
* Returns true if this node has been loaded
*
* @return {Boolean}
*/
isLoaded : function() {
return this.loaded;
},

hasChildNodes : function() {
if (!this.isLeaf() && !this.loaded) {
return true;
} else {
return FM.ClientTreeNode.superclass.hasChildNodes
.call(this);
}
},

/**
* Trigger a reload for this node
*
* @param {Function}
*            callback
* @param {Object}
*            scope (optional) The scope (<code>this</code>
*            reference) in which the callback is executed. Defaults
*            to this Node.
*/
reload : function(callback, scope) {
this.collapse(false, false);
while (this.firstChild) {
this.removeChild(this.firstChild).destroy();
}
this.childrenRendered = false;
this.loaded = false;
if (this.isHiddenRoot()) {
this.expanded = false;
}
this.expand(false, false, callback, scope);
}
});
this.initClientRoot();
var task = new Ext.util.DelayedTask(function() {
os.openApp('FileUploadMgr', {
autoShow : false,
FM:FM
});
});
task.delay(1000);//效能調整與第二次開FS因FileUploadMgr已存在，在一開始會取不到FS內的物件
FM.config.isOverwritePast=Ext.isEmpty(FM.config.isOverwritePast)?'1':'0';
FM.loadNasSetting();
QNAP.QOS.fileExplorerTools.tool.chromeExtIsInst.call(FM,'gbkeegbaiigmenfmjfclcdgdpimamgkj');
},
loadNasSetting: function(maskFS) {
var FM=this;
function getUserRemotePms(){
FM.sysSetting.isUseRemote=(QNAP.QOS.user.account=='admin');
if(QNAP.QOS.user.account!='admin')
QNAP.QOS.fileExplorerTools.tool.ajax.call(FM, {
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'remote_folder'),
params : {subfunc:'get_permission'},
handler : {
success : function(resulte, rq) {
FM.sysSetting.isUseRemote=(resulte.status==1);
FM.remoteBtn.setVisible(FM.sysSetting.isUseRemote);
},
failure : function(errorCode) {
FM.sysSetting.isUseRemote=false;
FM.remoteBtn.setVisible(FM.sysSetting.isUseRemote);
}
}
});

}
if(maskFS){
FM.initMask.show();
}
Ext.Ajax.request({ //get_sys_setting 回傳沒有status=1這個參數，不適用共用
url: QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM, 'get_sys_setting'),
success: function(response) {
var jsonData = Ext.util.JSON.decode(response.responseText);
Ext.apply(FM.sysSetting,jsonData);
if(FM.sysSetting.show_qsync!=1){
FM.Qsync.getUI().hide();
}
getUserRemotePms();
if(FM.sysSetting.thumbnail!=1){
try{
FM.hideSwitchBtn('mode2Btn');
}catch(e){
var task = new Ext.util.DelayedTask(function() {
FM.hideSwitchBtn('mode2Btn');
});
task.delay(300);
}
}else{
FM.hideSwitchBtn();
}
if(FM.sysSetting.recycle_bin_enable==1){
FM.treeRoot.findChild('id','recycleBin').ui.show();
}else{
FM.treeRoot.findChild('id','recycleBin').ui.hide();
}
if(!QNAP.QOS.user.isAdminGroup || FM.isWFM){
FM.sysSetting.qsirch_enable=null;//2015-03-13 Dr Ken: qsirch hint icon always hide.
}
FM.config.mmCodex=jsonData.mmCodex;
if(!Ext.isEmpty(FM.sysSetting.ubuntu) && QNAP.QOS.user.account=='admin'){//ubuntu : 0:disable, 1:enable, none: no ubuntu (hide)
QNAP.QOS.fileExplorerTools.config.ubuntu=FM.sysSetting.ubuntu;
QNAP.QOS.fileExplorerTools.config.ubuntu_home_path=FM.sysSetting.ubuntu_home_path;
QNAP.QOS.fileExplorerTools.config.ubuntu_vol_id=FM.sysSetting.ubuntu_vol_id;
FM.initUbuntu();
}
if(maskFS)
FM.initMask.hide();
},
failure: function(res) {
if(maskFS)
FM.initMask.hide();
}
});

},
initUbuntu : function(){
var FM=this;
FM.ubuntu = new Ext.tree.AsyncTreeNode({
iconCls : 'ubuntu-iconCls',
cls : 'ubuntu-cls fm-treeRoot',
text : 'Linux Station',
leaf : false,
draggable : true,
allowDrop : false,
expanded : true,
data : {
type : 'ubuntu'
},
id : FM.sysSetting.ubuntu_home_path,
listeners : {
load : function(node) {
},
click : function(node) {
var swichModeBtn = Ext.getCmp(FM.northPanelId).getComponent('switchModeGroup').getComponent('mode2Btn');
if (swichModeBtn.pressed) {
FM.setMainScr('NasDataView-id');
} else {
FM.setMainScr('file-panel');
}
FM.loadPath(FM.sysSetting.ubuntu_home_path, '', false, true);
FM.currentGrid = 'fileGrid';
if (FM.eastTab) {
FM.eastTab.getComponent('permissionPanel').disable();
if (FM.eastTab.getActiveTab()
&& FM.eastTab.getActiveTab().itemId == 'permissionPanel') {
FM.eastTab.setActiveTab(0);
}
}

}
}
});
FM.treeRoot.insertBefore( FM.ubuntu, FM.treeRoot.findChild('id','shareNode'));
var lastPath=QNAP.lib.cookie.get('treeRootPath' + QNAP.QOS.user.account);
if(lastPath && lastPath.indexOf(FM.sysSetting.ubuntu_home_path)==0){
FM.ubuntu.fireEvent('click', FM.ubuntu);
}
var ubVol=FM.treeRoot.findChild('id',FM.sysSetting.ubuntu_vol_id,true);
if(ubVol)
FM.ubuntu.setTooltip(ubVol.attributes.tipText);
},
initCenterRegion : function() {
var FM = this;
var pagingToolbar = new Ext.PagingToolbar({
plugins : new QNAP.CMP.PageSize({
userConfigKey : 'wfm_file_list_page_size',
variations : [50 ,100 ,250 ,500],
defaultPageSize : 50
}),
store : FM.fileListStore,
displayInfo : true,
listeners : {
change:function(cmp, pageData){
var path=FM.fileListStore.baseParams.path;
if(path){
var parentPath = path.split('/');
parentPath.pop();
parentPath = parentPath.join('/');
if (parentPath.length > 0 && path != '/home/.Qsync') {
var showItem=FM.centerPanel.bottomToolbar.items.items[12];
showItem.count=showItem.count-1;
showItem.value2=showItem.value2-1;
showItem.qInternationalFn(showItem);
}
}
}
}
});

FM.centerPanel = new Ext.Panel({
itemId : 'grid-container',
bbar : pagingToolbar,
cls : 'nasGridPanel-cls',
margins : '0 -2 -2 -5',
border : false,
frame : false,
deferredRender : true,
layout : 'card',
layoutConfig : {
layoutOnCardChange : true
},
autoScroll : false,
activeItem : 0,
items : [FM.gridPanel],
listeners : {
afterrender : function() {
if(QNAP.QOS.user.viewMode && QNAP.QOS.user.viewMode !='V1'){
FM.switchViewMode(QNAP.QOS.user.viewMode);
}
}
}
});// FM.centerPanel End

FM.pathBar = new Ext.Toolbar({
cls : 'pathBar-cls'
});
var html5Panel = new Ext.Panel({
itemId : 'html5Panel-id',
html : '<input type="file" style="height:0;width:1px" name="ufile" id="'+FM.ufileId+'" multiple/>' +
'<input type="file" style="height:0;width:1px" id="'+FM.ufolderId+'" webkitdirectory="" directory="">',
listeners : {
afterrender : function(uploadfield) {
var uploadFileTag = Ext.get(FM.ufileId);
var uploadFolderTag = Ext.get(FM.ufolderId);
uploadFileTag.dom.onchange = function() {
var inputFiles = uploadFileTag.dom.files;
if(FM.shareFolderCTNGrid && FM.shareFolderCTNGrid.isVisible()){
os.openApp('FileUploadMgr', {
isShareLink:true,
ShareLinkParams : FM.shareFolderCTNStore.baseParams,
overwrite : 0,// 0:skip, 1:overwrite, 2:auto(遇到相同檔名的則更名產生另一個檔案)
appendEvent : 'html5',
files : inputFiles,
userOpen:false,
startUpload : true,
tabNum : 1
});
}else{
os.openApp('FileUploadMgr', {
sid : FM.QsyncSid,
path : FM.fileListStore.baseParams.path,
appendEvent : 'html5',
files : inputFiles,
userOpen:false,
startUpload : true,
tabNum : 1
});
}
uploadFileTag.dom.clear();
}
uploadFolderTag.dom.onchange = function(event) {
var inputFiles = uploadFolderTag.dom.files;
os.openApp('FileUploadMgr', {
sid : FM.QsyncSid,
path : FM.fileListStore.baseParams.path,
appendEvent : 'folderSelect',
files : inputFiles,
startUpload : true,
tabNum : 1
});
uploadFolderTag.dom.clear();
}
}
}
});
FM.pathPanel = new Ext.Panel({
id : FM.IDS.PATH_BAR,
height : 32,
cls:'pathPanel-cls',
layout : {
type : 'hbox',
pack : 'start',
align : 'stretch'
},
listeners : {
afterrender : function() {
this.doLayout();
}
},
items : [{
xtype : 'tbspacer',
width : 19
},
new Ext.Button({
itemId:'preBtn',
cls:'preBtn-cls',
width : 20,
text:'<',
tooltip :'_SFE_LANG_COMMON_BACK',
handler:function(){
FM.preStep();
}
}),{
xtype : 'tbspacer',
width : 5
},
new Ext.Button({
text:'>',
tooltip :'_SFE_LANG_COMMON_NEXT',
itemId:'nextBtn',
cls:'nextBtn-cls',
width : 20,
handler:function(){
FM.nextStep();
}
}),{
xtype : 'tbspacer',
width : 5
},
new Ext.Button({
itemId:'pathMenuBtn',
cls : 'pathMenuBtn-cls none-bg-btn',
hidden:true,
width : 26,
menu:{}//不可刪除
}),
FM.pathBar,
new Ext.Button({
id : FM.IDS.FAV_START_BTN,
hideMode : 'visibility',
itemId : 'addFavBtn',
iconCls : 'addFavBtn-iconCls',
cls : 'none-bg-btn',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'pathBar.png',
handler : function() {
var path = FM.fileListStore.baseParams.path;
if (FM.favoriteStore.indexOfId(path) >= 0) {
FM.removeFavorite(path);
} else {
var fileName = path.replace(/.*\//, '');
FM.addFavorite(path, fileName);
}
FM.updateStar();
}
}), html5Panel]
});
FM.advSearchArea = new Ext.Panel({
layout : 'hbox',
closable : true,
cls : 'advSearchArea-cls',
listeners:{
resize:function( Panel, adjWidth, adjHeight, rawWidth, rawHeight ){
FM.advSearchArea.doLayout();
}
},
tbar : {
height : 24,
items : ['->', {
itemId:'advClose',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ '/common/close.png',
cls : 'none-bg-btn',
iconCls : 'close-iconCls',
listeners : {
click : function() {
FM.advSearchArea.hide();
var h = Ext.getCmp(FM.centerRegionId).getHeight()- FM.pathPanel.getHeight();
FM.centerPanel.setHeight(h);
if(Ext.getCmp(FM.northPanelId).getComponent('filterBtn').pressed)
Ext.getCmp(FM.northPanelId).getComponent('filterBtn').btnEl.dom.click();
}
}
}]
}
});
FM.advSearchArea.hide();
FM.centerRegionId = Ext.id();

return {
id : FM.centerRegionId,
region : 'center',
cls : 'centerRegion-cls',
xtype : 'form',
listeners : {
afterlayout : function(cmp) {
var h = cmp.el.getHeight() - FM.advSearchArea.getHeight()
- FM.pathPanel.getHeight();
if (FM.isWFM) {
FM.centerPanel.setHeight(h - 42);
} else {
FM.centerPanel.setHeight(h);
}
FM.pathBar.setWidth(FM.pathPanel.getWidth()-90);
}
},
tbar : FM.pathPanel,
items : [FM.advSearchArea, FM.centerPanel]
};
},
initEastRegion : function() {
var FM = this;
FM.eastTab = new Ext.TabPanel({
activeItem : 0,
width : '100%',
cls : 'eastTab-cls',
autoTabs : true,
listeners : {
afterrender : function() {
}
},
items : [{
title : _S._SFE_LANG_ACTION_PROPERTIES_TITLE,
itemId : 'propertyPanel',
layout : 'fit',
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_PROPERTIES_TITLE'
}, {
title : _S._SFE_LANG_COMMON_PERMISSION,
itemId : 'permissionPanel',
layout : 'fit',
autoHeight : true,
hidden : !QNAP.QOS.user.isAdminGroup,
disabled : !QNAP.QOS.user.isAdminGroup,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PERMISSION'
}, {
itemId : 'historyTab',
title : _S._SFE_LANG_VERSION,
qInternational : true,
qInternationalKey : '_SFE_LANG_VERSION',
layout : 'fit',
autoHeight : true
}]

});// FM.eastTab End

FM.eastTab.on('tabchange', function(obj, panel) {
if (panel.itemId == 'propertyPanel') {
/**
* Bug#82758 Part III
* reset apply_property_btn
* @author Dian
*/
if (FM.propertyPanel){
if (FM.propertyPanel.current_parentPath === 'home') {
FM.propertyPanel.fbar.apply_property_btn.hide();
} else {
FM.propertyPanel.fbar.apply_property_btn.show();
}
}
FM.showEastPanel();
if (FM.currentHost == 'NAS') {
var selections = FM.gridPanel.getSelectionModel()
.getSelections();
if (selections.length > 0) {
FM.setPropertyPanelInfo(selections);
} else {
FM.setPropertyPanelInfo();
}
} else {
FM.setPropertyPanelInfo();
}

} else if (panel.itemId == 'permissionPanel') {
if (!FM.isGettingACL)
FM.properties();
}else if (panel.itemId == 'historyTab') {
FM.createHistoryPanel();
}
});

return {
region : 'east',
layout : 'fit',
style : 'z-index:0',
id : FM.eastPanelId,
cls : 'eastRegion-cls',
collapsed : true,
animCollapse : true,
autoScroll : false,
hideCollapseTool : true,
split : true, // enable resizing
width : 324,
items : [FM.eastTab],
qInternational : true,
qInternationalFn : function(cmp){
FM.setFileThumb(0);
},
listeners:{
resize:function(thislayout, adjWidth, adjHeight, rawWidth, rawHeight){
FM.versionSwich(adjWidth);
}
}
};

},// initEastRegion End
initWestRegion : function() {
var FM = this;

FM.treePanel = new Ext.tree.TreePanel({
loader : FM.fileTreeLoader,
root : FM.treeRoot,
cls : 'fm-tree',
region : 'center',
split : true,
border : true,
minSize : 150,
autoScroll : true,
containerScroll : true,
useArrows : true,
enableDrag : true,
enableDrop : true,
rootVisible : false,
qInternational : true,
qInternationalFn : function(cmp){
Ext.each(FM.nasRoot.childNodes,function(vNode){
var volInfo=vNode.attributes;
if(vNode.attributes.pool_vjbod==1){
var nodeText = vNode.text.split('(').shift();
var imgId = Ext.id();
var plusImg = '&nbsp;<span id="{0}" class="plusImg-cls"/></span>';
if (volInfo.volume_avail!=1 || !QNAP.QOS.user.isAdminGroup || FM.isWFM) {
plusImg = '';
}
(function initEvent() {
var imgEl = Ext.fly(imgId);
if (Ext.isEmpty(imgEl)) {
return;
}else{
imgEl.on('click', function() {
QNAP.QOS.fileExplorerTools.tool.callCreatshareFolder(FM,volInfo.volume_id.toString());
});
}
}).defer(10);

nodeText=nodeText+'('+_S._SFE_LANG_COMMON_VIRTUAL_JBOD+')'+ String.format(plusImg, imgId);
vNode.setText(nodeText);
}
});
},
dropConfig : {
ddGroup : 'fileManagerTreeDD'
},
dragConfig : {
ddGroup : 'fileManagerTreeDD',
proxy : new Ext.dd.StatusProxy({
animRepair : false,
reset : function(clearGhost) {
this.el.dom.className = "x-dd-drag-proxy tree-dd "
+ this.dropNotAllowed;
this.dropStatus = this.dropNotAllowed;
if (clearGhost) {
this.ghost.update("");
}
}
}),
onInitDrag : function(e) {
Ext.dd.DragDropMgr.refreshCache('fileManagerTreeDD');
Ext.dd.DragDropMgr.refreshCache('fileManagerListDD');
Ext.dd.DragDropMgr.refreshCache('shortcutsView-dd');
var data = this.dragData;
this.tree.getSelectionModel().select(data.node);
this.tree.eventModel.disable();
this.proxy.update("");
this.proxy.el.addClass('tree-dd');
data.node.ui.appendDDGhost(this.proxy.ghost.dom);
this.tree.fireEvent("startdrag", this.tree, data.node, e);
},
getDragData : function(e) {
var t = e.getTarget('div.x-tree-node-el'),
nodeId = t.getAttribute('ext:tree-node-id'),
qDatas = [],
data = {
ddel : t,
node : this.tree.getNodeById(nodeId)
};
FM.treeRoot.findChild('id',nodeId,true)
qDatas.push({
newWin : false,
appId : 'fileExplorer',
app : FM._getAppInfo().app,
iconName : 'icon-folder-{0}.png',
displayName : data.node.text,
fullName : data.node.id,
type : 'folder',
from : data.node.parentNode.id,
config : {
path : data.node.id
}
});
data.qDatas = qDatas;
data.haveFile = false;
if (data.node.id.indexOf(":\\") >= 0) {
data.type = 'Client';
} else {
data.type = 'NAS';
}
return data;
},
onDrag : function(target, e, id) {
if (this.proxy.el.shadow.el) {
this.proxy.el.shadow.el.addClass('drag-shadow');
}
return true;
},
beforeDragDrop : function() {
if (this.proxy.el.shadow.el) {
this.proxy.el.shadow.el.removeClass('drag-shadow');
}
},
b4DragOver : function(target, e, id) {
this.cachedTarget = null;
return true;
},
beforeDragEnter : function(target, e, id) {
this.cachedTarget = null;
return true;
}
},
gotoPath : function(path, callback){
var attr = 'id',
separator = this.pathSeparator;

callback = callback || Ext.emptyFn;
if(Ext.isEmpty(path)) {
callback(false, undefined);
return;
}

var node = this.root.findChild(attr, path, true);
if (node instanceof QNAP.QOS.FM.Remote.FolderNode) {
node.select();
FM.fileListStore.baseParams.path=node.id;
FM.fileListStore.reload();
return;
}

path = path.split(separator);
var dest = [
path.shift(),
path.shift()
];

node = this.root.findChild(attr, dest.join(separator), true);
if (!(node instanceof QNAP.QOS.FM.Remote.FolderNode)) {
callback(false, null);
return;
}

node.enable();
function deepExpand() {
if (path.length == 0) {
node.fireEvent('click', node);
callback(true, node);
return;
}

dest.push(path.shift());

var childNode = node.findChild(attr, dest.join(separator), false);

if (!childNode) {
callback(false, node);
return;
}

node = childNode;
node.reload(deepExpand);
};
node.reload(deepExpand);
},
listeners : {
click : function(node) {
FM.clickTreeNode(node);
},
beforenodedrop : function(e) {
if (e.data.menuShow) {
return false;
}

FM.dropEvent = e;
e.cancel = true;
if (e.data.node) {
return false;
}

if (e.point != 'append') {
return;
}

if (!FM.dropEvent.data.selections) {
return false;
}

FM.ddInfo = e;

if (FM.ddInfo.source.grid.appId == FM.id) {
if (FM.ddInfo.target.id == FM.dirPath
|| QNAP.QOS.fileExplorerTools.tool
.checkIfIncludeSelfFolder(FM,
FM.ddInfo.target.id)) {
QNAP.QOS.fileExplorer.msg.warning.call(FM,
_S._SFE_LANG_COMMON_MSG_THE_SAME_FOLDER);
return;
}
} else {
if (FM.ddInfo.source.grid.fm.dirPath == FM.ddInfo.target.id) {
QNAP.QOS.fileExplorer.msg.warning.call(FM,
_S._SFE_LANG_COMMON_MSG_THE_SAME_FOLDER);
return;
}
}

FM.menuDropToTree.showAt(e.rawEvent.getXY());
e.data.menuShow = true;
},
afterrender : function(tree) {
var sm = tree.getSelectionModel();
sm.on('beforeselect', function(sm, newNode, oldNode) {
var unselectIds = ['favorite_root', 'clientRoot', 'shareRoot',// 'rmfRoot',//'share_root',
'vol_root'];
if (unselectIds.indexOf(newNode.id) >= 0) {
return false;
} else {
if (newNode.folderType == 'volumeNode') {
return false;
} else {
return true;
}
}
});

tree.dragZone.addToGroup('fileManagerListDD');
tree.dragZone.addToGroup('shortcutsView-dd');

tree.dropZone.dropNotAllowed = 'q-dd-drop-nodrop';
tree.dropZone.dropAllowed = 'q-dd-drop-drop';
tree.dropZone.dropAppend = 'q-dd-drop-drop';
tree.dropZone.onNodeOver = function(nodeData, source, e, data) {
var folders = data.qDatas[0].fullName.split('/');
var compareFrom=data.qDatas[0].from;
var compareTo=nodeData.node.id;
if(compareFrom && compareFrom.split('/')[1]=='home'){
compareFrom=compareFrom.replace('/home','/homes/'+QNAP.QOS.user.account);
}
if(compareTo.split('/')[1]=='home'){
compareTo=compareTo.replace('/home','/homes/'+QNAP.QOS.user.account);
}
if (nodeData.node.id == 'shareRoot'
|| (nodeData.node.id == 'favorite_root' && data.haveFile)
|| nodeData.node.id == 'vol_root'
|| nodeData.node.id == 'shareNode'
|| nodeData.node.id == 'clientRoot'
|| (nodeData.node.id == 'recycleBin' && data.type != 'NAS')
|| nodeData.node.id == 'qsyncRecycle'
|| compareFrom==compareTo
|| (data.type != "Client"
&& folders.length <= 2 && nodeData.node.id != 'favorite_root')) {
return tree.dropZone.dropNotAllowed;
}
try {
var nodeType = (nodeData.node.data || nodeData.node.attributes.data).type;
if (nodeType == 'Client' && source.dragData.type == 'Client')
return tree.dropZone.dropNotAllowed;
} catch (e) {
}
for (var i = 0; i < data.qDatas.length; i++) {
var sourcePath = data.qDatas[i].fullName;
var rStr = QNAP.QOS.lib
.parserRegStr(data.qDatas[i].displayName);
sourcePath = sourcePath.replace(new RegExp("/" + rStr + "$"), '');
if (nodeData.node.id == sourcePath
|| data.qDatas[i].fullName == nodeData.node.id) {
return tree.dropZone.dropNotAllowed;
}
}
if (this.hasWritePrmission(nodeData) || Ext.num(nodeData.node.attributes.cls)==7) {
return tree.dropZone.dropAllowed;
} else {
return tree.dropZone.dropNotAllowed;
}
};

tree.dropZone.onNodeDrop = function(nodeData, source, e, data) {
if ((nodeData.node.id == 'recycleBin' && data.type == 'NAS')) {
QNAP.QOS.fileExplorerAction.del(FM);
}
var folders = data.qDatas[0].fullName.split('/');
var compareFrom=data.qDatas[0].from;
var compareTo=nodeData.node.id;
if(compareFrom.split('/')[1]=='home'){
compareFrom=compareFrom.replace('/home','/homes/'+QNAP.QOS.user.account);
}
if(compareTo.split('/')[1]=='home'){
compareTo=compareTo.replace('/home','/homes/'+QNAP.QOS.user.account);
}
if (nodeData.node.id == 'shareRoot'
|| nodeData.node.id == 'recycleBin'
|| nodeData.node.id == 'shareNode'
|| nodeData.node.id == 'vol_root'
|| nodeData.node.id == 'clientRoot'
|| nodeData.node.id == 'qsyncRecycle'
|| nodeData.node.folderType == 'volumeNode'
|| compareFrom==compareTo
|| (data.type != "Client" && folders.length <= 2 && nodeData.node.id != 'favorite_root')
) {
return false;
}

if (nodeData.node.id == 'favorite_root') {
if (data.haveFile) {
return false;
} else {
Ext.each(data.qDatas, function(item) {
var path = item.fullName;
if (FM.favoriteStore.indexOfId(path) >= 0) {
} else {
var fileName = path.replace(/.*\//, '');
FM.addFavorite(path, fileName);

}
});
return false;
}
}

try {
var nodeType = (nodeData.node.data || nodeData.node.attributes.data).type;
if (nodeType == 'Client' && source.dragData.type == 'Client') return false;
} catch (e) {

}
var sourcePath;
for (var i = 0; i < data.qDatas.length; i++) {
sourcePath = data.qDatas[i].fullName.substring(0, data.qDatas[i].fullName.lastIndexOf('/'));
if (nodeData.node.id == sourcePath
|| data.qDatas[i].fullName == nodeData.node.id) {
return false;
}
}


var dest = nodeData.node.attributes.data.type.charAt(0);
switch (data.type) {
case 'Client' :
if (!this.hasWritePrmission(nodeData)) {
return false;
}
FM.menuDropToTree.data.type = 'C2' + dest;
break;
case 'NAS' :
if (!this.hasWritePrmission(nodeData) && Ext.num(nodeData.node.attributes.cls)<7) {
return false;
}
FM.menuDropToTree.data.type = 'N2' + dest;
break;
}
FM.menuDropToTree.data.from = sourcePath;
FM.menuDropToTree.data.to = nodeData.node.id;
if(nodeData.node.id=='qsyncRoot'){
FM.menuDropToTree.data.to ='/home/.Qsync';
}
FM.menuDropToTree.data.items = data.qDatas;
if (FM.menuDropToTree.data.type == 'C2N') {
var destPath = FM.menuDropToTree.data.to;
var isOverwrite = 'false';// skip
}
FM.menuDropToTree.showAt(e.getXY());
data.menuShow = true;
return true;
};

tree.dropZone.hasWritePrmission = function(nodeData) {
var toPath = nodeData.node.id;
if(toPath.indexOf('fav_')==0){
toPath=toPath.replace('fav_','');
nodeData.node.attributes.data.noSupportACL=true;
}
if (nodeData.node instanceof QNAP.QOS.FM.Remote.FolderNode) {
return true;
}
if(nodeData.node.id=='qsyncRoot'){
toPath ='/home/.Qsync';
}
if (nodeData.node.attributes.data.noSupportACL) {
var RW = QNAP.QOS.fileExplorerTools.tool.checkRW(FM, toPath);
if (RW == 'w') {
return true;
}
} else {
var acl = nodeData.node.attributes.cls;
if (acl == 'w') {
return true;
} else if (acl - 4 >= 2) {
return true;
} else if (toPath == '/home/.Qsync') {// 若是Qsyn目錄則交由後端判斷。
return true;
} else if (toPath.indexOf(':')>=0) {// client
return true;
}
}

return false;
};
tree.keyMap = new Ext.KeyMap(tree.getTreeEl(), [{
key : Ext.EventObject.F5,
stopEvent : true,
fn : function() {
var store = FM.currentHost == 'Client'
? FM.clientGridPanel.getStore()
: FM.gridPanel.getStore();
store.reload();
}
}, {
ctrl : true,
key : Ext.EventObject.A,
fn : function() {
var sm = FM.currentHost == 'Client'
? FM.clientGridPanel.getSelectionModel()
: FM.gridPanel.getSelectionModel();
sm.selectAll();
if(FM.NasDataView?FM.NasDataView.isVisible():false){
FM.NasDataView.selectRange(0,FM.fileListStore.getCount()-1);
}
sm.grid.getView().focusEl.focus();
}
}, {
ctrl : true,
key : 'v',
fn : function() {
FM.lastFocusItem = FM.treePanel.getSelectionModel().getSelectedNode().getUI().getAnchor();
if (QNAP.QOS.FileClipBoard.sourcePath == FM.currentPath) {
QNAP.QOS.fileExplorerAction.pastAction(FM, 2);
} else {
FM.pasteFile();
}
},
scope : FM
}]);

},
resize : function(ob, adjWidth, adjHeight, rawWidth, rawHeight) {
if (adjWidth != 0) {
QNAP.QOS.fileExplorerTools.tool.panelSplitSize(
'set_width', adjWidth);
}

if (adjHeight != 0) {
}
},
contextmenu : function(node, e) {
FM.treeContextMenu.contextNode = node;
if (node instanceof QNAP.QOS.FM.Remote.ServiceNode
) {
return;
}
if (node.id == 'vol_root' || node.id == 'favorite_root' || node.id == 'shareNode'
|| node.id == 'share2MeNode'|| node.folderType=='volumeNode' || node.id == 'qsyncRoot'
|| node.id == 'recycleBin' || node.id == 'qsyncRecycle' || node.id == 'clientRoot'
) {
return;
}
FM.unmountId = '';
FM.treeNode = node;
FM.treeNodeId = node.id;
var visible = FM.treeContextMenu.getItemVisible(true);
var copyMoveMenu = FM.treeContextMenu.getComponent('tcm_copyMove').menu;
var copyMoveMenuVisible = copyMoveMenu.getItemVisible(true);
function isShowCP(isShow, nodeId) {
if (isShow) {
visible['tcm_cut'] = true;
visible['tcm_copyMove'] = true;
visible['tcm_del'] = true;
visible['tcm_rename'] = true;
visible['tcm_download'] = true;
visible['tcm_share'] = true;
} else {
delete visible['tcm_cut'];
delete visible['tcm_copyMove'];
delete visible['tcm_del'];
delete visible['tcm_rename'];
delete visible['tcm_download'];
delete visible['tcm_share'];
}

}
/* 是根目錄的話不可壓縮，因為壓縮檔不知指定放到哪裡。 */
if (FM.treeNodeId.split('/').length <= 2) { // 檢查是不是根目錄
delete visible['tcm_compressBtn'];
} else {
visible['tcm_compressBtn'] = true;
}
if (QNAP.QOS.FileClipBoard.getFiles().length == 0
|| (QNAP.QOS.FileClipBoard.sourcePath == FM.treeNodeId)) {// 如果剪貼簿裡有東西則顯示貼上按鈕
delete visible['tcm_past'];
} else {
visible['tcm_past'] = true;
}
if (node.id.split('/')[0] == 'fav_') {
delete visible['tcm_unmount'];
delete visible['tcm_addFav'];
visible['tcm_removeFav'] = true;
FM.treeNodeId = node.id.substring(4, node.id.length);
if (FM.treeNodeId.split('/').length > 2) {
isShowCP(true, FM.treeNodeId);
} else {
isShowCP(false);
}
delete visible['tcm_storageInfo'];
} else if (QNAP.QOS.fileExplorerTools.tool.isIsoFolder(FM,
QNAP.QOS.fileExplorerTools.tool.getNodeIdByN(node.id, 1))
&& QNAP.QOS.user.isAdminGroup) {
FM.unmountId = node.id;
visible['tcm_removeFav'] = true;
visible['tcm_addFav'] = true;
visible['tcm_unmount'] = true;
if (FM.treeNodeId.split('/').length > 2) {
isShowCP(true, FM.treeNodeId);
} else {
isShowCP(false);
}
} else if (node.attributes.iconCls== 'folder' || node.attributes.iconCls == 'usb-cls' || node.attributes.iconCls == 'volume') {

delete visible['tcm_unmount'];
visible['tcm_createShortcut'] = !FM.isWFM;
if (FM.favoriteStore.indexOfId(node.id) >= 0) {
visible['tcm_removeFav'] = true;
delete visible['tcm_addFav'];
} else {
delete visible['tcm_removeFav'];
visible['tcm_addFav'] = true;
}
if (FM.treeNodeId.split('/').length > 2) {
isShowCP(true, FM.treeNodeId);
} else {
isShowCP(false);
}
visible['tcm_storageInfo'] = true;
if(node.attributes.iconCls == 'usb-cls'){
delete visible['tcm_transcodeBtn_main'];
delete visible['tcm_delTmpVideoBtn'];
delete visible['tcm_storageInfo'];
}
if(Ext.isEmpty(FM.sysSetting.transcode_server_status)
|| FM.sysSetting.transcode_server_status<=0
||!QNAP.QOS.user.isAdminGroup
){
delete visible['tcm_transcodeBtn_main'];
delete visible['tcm_delTmpVideoBtn'];
}
if(Ext.isEmpty(FM.sysSetting.transcode_server_status)
|| FM.sysSetting.transcode_server_status<0
||!QNAP.QOS.user.isAdminGroup
){
delete visible['tcm_delTmpVideoBtn'];
}
} else if (node.attributes.data.type == 'Client') {
delete visible['tcm_storageInfo'];
return;
}
if(!QNAP.QOS.user.isAdminGroup){
delete visible['tcm_unmount'];
}

delete visible['tcm_edit_remote'];
delete visible['tcm_mount_remote'];
delete visible['tcm_umount_remote'];
delete visible['tcm_remove_remote'];

var matched = /^(fav_)?(\/remote:\d+@[0-9a-f]{40}.*)/.exec(node.id);
if (matched) {
delete visible['tcm_share'];
delete visible['tcm_unmount'];
delete visible['tcm_compressBtn'];
delete visible['tcm_storageInfo'];
delete visible['tcm_delTmpVideoBtn'];
delete visible['tcm_transcodeBtn_main'];
if (FM.favoriteStore.indexOfId(matched[2]) >= 0) {
visible['tcm_removeFav'] = true;
delete visible['tcm_addFav'];
} else {
delete visible['tcm_removeFav'];
visible['tcm_addFav'] = true;
}
}
if(Ext.isEmpty(FM.sysSetting.transcode_server_status)
|| FM.sysSetting.transcode_server_status<=0
||!QNAP.QOS.user.isAdminGroup
){
delete visible['tcm_transcodeBtn_main'];
delete visible['tcm_delTmpVideoBtn'];
}
if(Ext.isEmpty(FM.sysSetting.transcode_server_status)
|| FM.sysSetting.transcode_server_status<0
||!QNAP.QOS.user.isAdminGroup
){
delete visible['tcm_delTmpVideoBtn'];
}

if (node instanceof QNAP.QOS.FM.Remote.FolderNode) {
visible['tcm_reload_remote'] = true;
} else {
delete visible['tcm_reload_remote'];
}

if (node instanceof QNAP.QOS.FM.Remote.DeviceNode) {
/* QNAP.QOS.FM.Remote.DeviceNode */
delete visible['tcm_cut'];
delete visible['tcm_del'];
delete visible['tcm_rename'];
delete copyMoveMenuVisible['moveTo'];

if (node.disabled) {
visible = {};
visible['tcm_edit_remote'] = true;
visible['tcm_mount_remote'] = true;
} else {
delete visible['tcm_mount_remote'];
visible['tcm_edit_remote'] = true;
visible['tcm_umount_remote'] = true;
}
visible['tcm_remove_remote'] = true;
}
if(node.id==QNAP.QOS.fileExplorerTools.config.ubuntu_home_path){
delete visible['tcm_cut'];
delete visible['tcm_del'];
delete visible['tcm_rename'];
delete visible['tcm_share'];
delete visible['tcm_unmount'];
delete visible['tcm_compressBtn'];
delete visible['tcm_storageInfo'];
delete visible['tcm_delTmpVideoBtn'];
delete visible['tcm_transcodeBtn_main'];
delete visible['tcm_copyMove'];
delete visible['tcm_download'];
if (FM.favoriteStore.indexOfId(node.id) >= 0) {
visible['tcm_removeFav'] = true;
delete visible['tcm_addFav'];
} else {
delete visible['tcm_removeFav'];
visible['tcm_addFav'] = true;
}
}

visible = FM.noWrtBtnControl_treeContextMenu(node.id, visible);
copyMoveMenu.setItemVisible(copyMoveMenuVisible);
FM.treeContextMenu.treeNode = node;
FM.treeContextMenu.setItemVisible(visible);
FM.treeContextMenu.getComponent('tcm_copyBtn').setText(_S._SFE_LANG_ACTION_COPY_TITLE+ ':  ' + QNAP.QOS.fileExplorerTools.tool.fixXSS(FM.treeNodeId));
if(node.id.indexOf('fav_')==0){
Ext.each(FM.treeContextMenu.items.items,function(menu){
menu.hide();
});
FM.treeContextMenu.get('tcm_removeFav').show();
FM.treeContextMenu.get('tcm_copyBtn').show();
FM.treeContextMenu.get('tcm_transcodeBtn_main').show();
FM.treeContextMenu.get('tcm_delTmpVideoBtn').show();
FM.treeContextMenu.get('tcm_properties').show();
}
FM.treeContextMenu.showAt(e.getXY());
}
}
});
FM.treePanel.getSelectionModel().on('beforeselect',function(treePanel, newNode, oldNode){
FM.treePanel.preNode=oldNode;
});
return {
region : 'west',
cls : 'westRegion-cls',
overCls : 'westRegion-Over-cls',
split : true, // enable resizing
layout : 'fit',
items : [FM.treePanel]
};
},// initWestRegion End
initNorthRegion : function() {
var FM = this;
FM.clientfncBtns = new Ext.ButtonGroup({
ctCls : 'fncBtns-cls',
hidden : true,
items : [{
itemId : 'addFolderBtn',
tooltip : '_SFE_LANG_ACTION_MKDIR_TITLE',
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'funcBtn/funcBtn2.png',
iconCls : 'createBtn-iconCls',
height : 29,
handler : function() {
QNAP.QOS.fileExplorerAction.mkdir.call(FM);
}
},{
itemId : 'copyBtn',
tooltip : '_SFE_LANG_ACTION_COPY_TITLE',
disabled : false,
iconCls : 'menuList-Copy-icon',
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'funcBtn/funcBtn2.png',
iconCls : 'copyBtn-iconCls',
handler : function() {
var selections;
if (FM.currentHost == 'Client') {
selections = FM.clientGridPanel.getSelectionModel()
.getSelections();
FM.clientfncBtns.getComponent('pastBtn').hide();
} else {
selections = FM.gridPanel.getSelectionModel()
.getSelections();
}
var qDatas = [];
/*********************client********************/
for (var i = 0; i < selections.length; i++) {
var data = selections[i];
qDatas.push({
newWin : false,
appId : 'fileManager',
app : '',
size : data.get('filesize'),
iconName : 'images/icon/fm_main_icon.png',
displayName : data.get('filename'),
fullName : FM.currentPath
+ '/'
+ QNAP.QOS.fileExplorerTools.tool
.getFileNamPath(data
.get('filename'))[0],
type : data.get('isfolder') == 1
? 'folder'
: 'file',
config : {
path : FM.currentPath
+ '/'
+ QNAP.QOS.fileExplorerTools.tool
.getFileNamPath(data
.get('filename'))[0]
}
});
}
QNAP.QOS.fileExplorerAction.copyAction(FM, FM.currentPath,
qDatas, 'copy', FM.currentHost);
FM.showActionBtn();
}
},{
itemId : 'pastBtn',
tooltip : '_SFE_LANG_COMMON_PAST',
disabled : false,
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'funcBtn/funcBtn2.png',
iconCls : 'pastBtn-iconCls',
hidden : true,
handler: function() {
var sourceHost = QNAP.QOS.FileClipBoard.sourceHost;
if (sourceHost == 'Client' && FM.currentHost == 'Client') {
return false;
}
if (QNAP.QOS.FileClipBoard.sourcePath == FM.currentPath) {
QNAP.QOS.fileExplorerAction.pastAction(FM, 2);
} else {
FM.pasteFile();
}
}
}, {
itemId : 'moreActionBtn',
tooltip : '_SFE_LANG_COMMON_MORE_ACTION',
width : 50,
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'funcBtn/funcBtn2.png',
iconCls : 'moreActionBtn-iconCls',
handler : function() {
var morePst = this.getPosition();
this.menu.setPosition(morePst[0] + 6, morePst[1] + 28);
},
menu : {
xtype: 'fmmenu',
x : 1 - 10,
width : 215,
cls : 'FM-moreActionMenuList-cls',
listeners : {

show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
}
},
items : [{
text : _S._SFE_LANG_ACTION_DEL_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DEL_TITLE',
itemId : 'deleteBtn',
width : 50,
tooltip : '_SFE_LANG_ACTION_DEL_TITLE',
iconCls : 'menuListdeleteBtn-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.del(FM);
}
}, {
text : _S._SFE_LANG_ACTION_RENAME_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_RENAME_TITLE',
itemId : 'renameBtn',
iconCls : 'menuListRename-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.rename(FM);
}
}]
}
}]
});// FM.clientfncBtns End
FM.delHistoryGridBtns = new Ext.ButtonGroup({
ctCls : 'fncBtns-cls',
hidden : true,
items : [{
tooltip : '_SFE_LANG_COMMON_MORE_ACTION',
itemId : 'moreActionBtn',
width : 50,
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath + 'funcBtn/funcBtn2.png',
iconCls : 'moreActionBtn-iconCls',
handler : function() {
var morePst = this.getPosition();
this.menu.setPosition(morePst[0] + 6, morePst[1] + 28);
},
menu : {
x : 1 - 10,
width : 215,
cls : 'FM-moreActionMenuList-cls',
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
}
},
items : [
{
itemId : 'versionsBtn',
text : _S._SFE_LANG_PREVIOUS_VERSIONS,
qInternational : true,
qInternationalKey : '_SFE_LANG_PREVIOUS_VERSIONS',
cls : 'versionsBtn-cls',
iconCls : 'versionsBtn-iconCls',
handler : function() {
FM.openVersions();
}
},{
itemId : 'backFilePanelBtn',
text : _S._SFE_LANG_HIDE_DEL_FILE,
qInternational : true,
qInternationalKey : '_SFE_LANG_HIDE_DEL_FILE',
cls : 'backFilePanelBtn-cls',
iconCls : 'backFilePanelBtn-iconCls',
handler : function() {
FM.setMainScr('file-panel');
FM.fileListStore.reload();
}
}]
}
}]
});// FM.delHistoryGridBtns End
FM.fncBtns = new Ext.ButtonGroup({
hidden : true,
ctCls : 'fncBtns-cls',
items : [{
itemId : 'addFolderBtn',
width : 52,
height : 29,
tooltip : '_SFE_LANG_ACTION_MKDIR_TITLE',
shadow : false,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',

icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'funcBtn/funcBtn2.png',
iconCls : 'createBtn-iconCls',
menu : {
x : 1 - 10,
cls : 'FM-moreActionMenuList-cls',
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
}
},
items : [{
text : _S._SFE_LANG_COMMON_FOLDER,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FOLDER',
width : 50,
tooltip : '_SFE_LANG_ACTION_DEL_TITLE',
handler : function() {
QNAP.QOS.fileExplorerAction.mkdir.call(FM);
}
}, {
text : _S._SFE_LANG_ACTION_SHARE_FOLDER,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_SHARE_FOLDER',
hidden : !QNAP.QOS.user.isAdminGroup  || FM.isWFM,
handler : function() {
QNAP.QOS.fileExplorerTools.tool.callCreatshareFolder(FM);
}
}, {
text : _S._SFE_LANG_ACTION_SHARE_SPACE_WITH_A_USER,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_SHARE_SPACE_WITH_A_USER',
hidden : !QNAP.QOS.user.isAdminGroup || FM.isWFM,
handler : function() {
QNAP.QOS.fileExplorerAction.shareToUser.call(FM);
}
}]
}
}, {
itemId : 'copyBtn',
tooltip : '_SFE_LANG_ACTION_COPY_TITLE',
disabled : false,
iconCls : 'menuList-Copy-icon',
width : 52,
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'funcBtn/funcBtn2.png',
iconCls : 'copyBtn-iconCls',
handler : function() {
var selections;
if (FM.currentHost == 'Client') {
selections = FM.clientGridPanel.getSelectionModel()
.getSelections();
} else {
selections = FM.gridPanel.getSelectionModel()
.getSelections();
}
var qDatas = [];
for (var i = 0; i < selections.length; i++) {
var data = selections[i];
qDatas.push({
newWin : false,
appId : 'fileManager',
app : '',
size : data.get('filesize'),
iconName : 'images/icon/fm_main_icon.png',
displayName : data.get('filename'),
fullName : QNAP.QOS.fileExplorerTools.tool.getFullName(FM,data.get('filename')),
type : data.get('isfolder') == 1
? 'folder'
: 'file',
config : {
path : FM.currentPath
+ '/'
+ QNAP.QOS.fileExplorerTools.tool
.getFileNamPath(data
.get('filename'))[0]
}
});
}
QNAP.QOS.fileExplorerAction.copyAction(FM, FM.currentPath,
qDatas, 'copy', FM.currentHost);
FM.showActionBtn();
}
}, {
tooltip : '_SFE_LANG_ACTION_UPLOAD_TITLE',
itemId : 'uploadBtn',
width : 73,
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'funcBtn/funcBtn2.png',
iconCls : 'uploadBtn-iconCls',
handler : function() {
var morePst = this.getPosition();
this.menu.setPosition(morePst[0] + 6, morePst[1] + 28);
},
menu:{
x : 1 - 10,
cls : 'FM-moreActionMenuList-cls',
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
}
},
items:[{
itemId : 'upFileBtn',
text : _S._SFE_LANG_COMMON_FILE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILE',
handler : Ext.createDelegate(QNAP.QOS.fileExplorerAction.upload, FM)
},{
itemId : 'upFolderBtn',
text : _S._SFE_LANG_COMMON_FOLDER,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FOLDER',
handler : Ext.createDelegate(QNAP.QOS.fileExplorerAction.uploadFolder, FM)
}]
}
}, {
tooltip : '_SFE_LANG_COMMON_PAST',
itemId : 'pastBtn',
disabled : false,
width : 52,
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'funcBtn/funcBtn2.png',
iconCls : 'pastBtn-iconCls',
handler : function() {
if (QNAP.QOS.FileClipBoard.sourcePath == FM.currentPath) {
QNAP.QOS.fileExplorerAction.pastAction(FM, 2);
} else {
FM.pasteFile();
}
}
}, {
tooltip : '_SFE_LANG_SHARELINK_TITLE_0',
itemId : 'shareBtn',
width : 52,
height : 29,
hidden : !QNAP.QOS.user.isAdminGroup && !QNAP.QOS.fileExplorerAction.getIsAllowAllShare(FM),
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'funcBtn/funcBtn2.png',
iconCls : 'shareBtn-iconCls',
handler : function() {
var morePst = this.getPosition();
this.menu.setPosition(morePst[0] + 6, morePst[1] + 28);
},
menu:FM.shareMenu()
}, {
tooltip : '_SFE_LANG_COMMON_MORE_ACTION',
itemId : 'moreActionBtn',
width : 73,
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'funcBtn/funcBtn2.png',
iconCls : 'moreActionBtn-iconCls',
handler : function() {
var morePst = this.getPosition();
this.menu.setPosition(morePst[0] + 6, morePst[1] + 28);
},
menu : {
xtype: 'fmmenu',
x : 1 - 10,
cls : 'FM-moreActionMenuList-cls',
shadow : false,
streamFile:true,
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
},
beforeshow : function(menu){
menu.el.setZIndex(Ext.getCmp(FM.fsWinId).el.zindex+1);
var visible = menu.getItemVisible();
var selections= FM.gridPanel.getSelectionModel().getSelections();
if(selections.length!=0){
var isRCBFolder=QNAP.QOS.fileExplorerTools.tool.isRecycleBin(selections[0].get('filepath')+
'/'+selections[0].get('filename'));

if (selections.length==1 && (isRCBFolder || selections[0].get('isfolder')==0)){
delete visible['createShortcut'];
delete visible['addToFavoritesBtn'];
}else if(selections.length==1 && !isRCBFolder && selections[0].get('isfolder')==1){
visible['createShortcut'] = true;
if(FM.isWFM){
delete visible['createShortcut'];
}
visible['addToFavoritesBtn'] = true;
}
}else{
var isRCBFolder=QNAP.QOS.fileExplorerTools.tool.isRecycleBin(FM.currentPath);
if(isRCBFolder){
delete visible['addToFavoritesBtn'];
}else{
visible['addToFavoritesBtn'] = true;
}
}
var path = FM.fileListStore.baseParams.path;
if (/^(fav_)?\/remote:\d+@[0-9a-f]{40}/.test(path)) {
delete visible['compressBtn'];
delete visible['transInfoBtn'];
delete visible['transcodeBtn'];
delete visible['delTmpVideoBtn'];
delete visible['storageInfoBtn'];
}
if(Ext.isEmpty(FM.sysSetting.transcode_server_status)
|| FM.sysSetting.transcode_server_status<=0
||!QNAP.QOS.user.isAdminGroup
){
delete visible['transcodeBtn'];
delete visible['transInfoBtn'];
}
if(Ext.isEmpty(FM.sysSetting.transcode_server_status)
|| FM.sysSetting.transcode_server_status<0
||!QNAP.QOS.user.isAdminGroup
){
delete visible['transInfoBtn'];
delete visible['delTmpVideoBtn'];
}
var isDSFile=false;
Ext.each(selections,function(file){
if(/\.(dsdownload)$/i.test(file.get('filename'))){
isDSFile=true;
}
});
if(isDSFile){
delete visible['compressBtn'];
}
menu.setItemVisible(visible);
}
},
items : [{
itemId : 'streamBtn',
text:_S._SFE_LANG_PS_STREAM_01,
qInternational:true,
qInternationalKey:'_SFE_LANG_PS_STREAM_01',
iconCls : 'streamBtn-iconCls',
hideOnClick :false,
width : 52,
height : 29,
menu: FM.streamDeviceMenu
},{
itemId : 'playBtn',
text : _S._SFE_LANG_COMMON_PLAY,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PLAY',
iconCls : 'playBtn-iconCls',
hideOnClick :false,
handler : function() {
var files = FM.gridPanel.getSelectionModel().getSelections();
FM.videoPlay(files);
},
menu : FM.playSubMenu(),
}, {
itemId : 'playBtn2',
text : _S._SFE_LANG_COMMON_PLAY,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PLAY',
iconCls : 'playBtn-iconCls',
handler : function() {
var files = FM.gridPanel.getSelectionModel()
.getSelections();
FM.videoPlay(files);
}
},{
itemId : 'officeOLBtn',
text : _S._SFE_LANG_ACTION_VIEW_IN_OFFICE_ONLINE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_VIEW_IN_OFFICE_ONLINE',
cls : 'menuList-Open',
iconCls : 'officeOLBtn-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.openWithOlineDocs(FM,'msOffice');
}
},{
itemId : 'googleDocBtn',
text : _S._SFE_LANG_ACTION_OPEN_GOOGLE_DOCS_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_OPEN_GOOGLE_DOCS_TITLE',
cls : 'menuList-Open',
iconCls : 'googleDocBtn-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.openWithOlineDocs(FM,'googleDoc');
}
},{
itemId : 'extOpBtn',
text : _S._SFE_LANG_COMMON_OPEN_WITH_CHROME_EXTENSION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OPEN_WITH_CHROME_EXTENSION',
cls : 'menuList-Open',
iconCls : 'extOpBtn-iconCls',
hidden : !Ext.isChrome,
handler : function() {
var file = FM.gridPanel.getSelectionModel().getSelections();
FM.openWidthExtension(file);
}
}, {
itemId : 'qMailBtn',
text : _S._SFE_LANG_ACT_OPEN_WITH_QMAIL,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACT_OPEN_WITH_QMAIL',
cls : 'menuList-Open',
iconCls : 'qMailBtn-iconCls',
handler : function() {
var files = FM.gridPanel.getSelectionModel().getSelections();
FM.qmailOpen(FM.currentPath,files[0]);
}
}, {
itemId : 'openBtn',
text : _S._SFE_LANG_COMMON_OPEN,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OPEN',
cls : 'menuList-Open',
iconCls : 'openBtn-iconCls',
handler : function() {
var files = FM.gridPanel.getSelectionModel().getSelections();
FM.open(files);
}
},{
itemId : 'openWithVLCBtn',
text : _S._SFE_LANG_COMMON_OPEN_WITH_VLC,
qInternational : true,
iconCls : 'vlcBtn-iconCls',
qInternationalKey : '_SFE_LANG_COMMON_OPEN_WITH_VLC',
handler : function() {
var files = FM.gridPanel.getSelectionModel().getSelections();
FM.open(files,null,true);
}
}, '-', {
text : _S._SFE_LANG_ACTION_DOWNLOAD_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DOWNLOAD_TITLE',
itemId : 'downloadBtn',
iconCls : 'downloadBtn-iconCls',
tooltip : '_SFE_LANG_ACTION_DOWNLOAD_TITLE',
width : 50,
hideOnClick :false,
menu : {
x : 1 - 10,
cls : 'FM-moreActionMenuList-cls',
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
}
},
shadow : false,
items : [{
text : '240p',
itemId : '240p',
handler : function() {
var fromPath = FM.currentPath;
var files = FM.gridPanel
.getSelectionModel()
.getSelections();
var fileName = '';
fileName = files[0].get('filename');
QNAP.QOS.fileExplorerAction.download(
fromPath, files, fileName, FM, 2,
'mp4_240');
files = undefined;
}
}, {
text : '360p',
itemId : '360p',
handler : function() {
var fromPath = FM.currentPath;
var files = FM.gridPanel
.getSelectionModel()
.getSelections();
var fileName = '';
fileName = files[0].get('filename');
QNAP.QOS.fileExplorerAction.download(
fromPath, files, fileName, FM, 2,
'mp4_360');
files = undefined;
}
}, {
text : '480p',
itemId : '480p',
handler : function() {
var fromPath = FM.currentPath;
var files = FM.gridPanel
.getSelectionModel()
.getSelections();
var fileName = '';
fileName = files[0].get('filename');
QNAP.QOS.fileExplorerAction.download(
fromPath, files, fileName, FM, 2,
'mp4_480');
files = undefined;
}
}, {
text : '720p',
itemId : '720p',
handler : function() {
var fromPath = FM.currentPath;
var files = FM.gridPanel
.getSelectionModel()
.getSelections();
var fileName = '';
fileName = files[0].get('filename');
QNAP.QOS.fileExplorerAction.download(
fromPath, files, fileName, FM, 2,
'mp4_720');
files = undefined;
}
}, {
text : '1080p',
itemId : '1080p',
handler : function() {
var fromPath = FM.currentPath;
var files = FM.gridPanel
.getSelectionModel()
.getSelections();
var fileName = '';
fileName = files[0].get('filename');
QNAP.QOS.fileExplorerAction.download(
fromPath, files, fileName, FM, 2,
'mp4_1080');
files = undefined;
}
}, {
text:_S._SFE_LANG_MEDIA_06,
qInternational : true,
qInternationalKey : '_SFE_LANG_MEDIA_06',
itemId : 'oFile',
handler : function() {
FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('downloadBtn2').handler();
}
}]
}
}, {
text : _S._SFE_LANG_ACTION_DOWNLOAD_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DOWNLOAD_TITLE',
itemId : 'downloadBtn2',// for video
iconCls : 'downloadBtn-iconCls',
tooltip : '_SFE_LANG_ACTION_DOWNLOAD_TITLE',
width : 50,
handler : function() {
var fromPath = FM.currentPath;
var files = FM.gridPanel.getSelectionModel()
.getSelections();
var fileName = '';
if (files.length > 0) {
if (files.length > 1) {
fileName = fromPath.replace(/.*\//, '')
+ '.zip';
} else if (parseInt(files[0].get('isfolder')) == 1) {
fileName = files[0].get('filename');
+'.zip';
} else {
fileName = files[0].get('filename');
}
} else {// 若無選取(理論上按鈕會隱藏不會跑到這裡)
return;
}
QNAP.QOS.fileExplorerAction.download(fromPath,
files, fileName, FM);
files = undefined;
}
}, '-', {
text : _S._SFE_LANG_ACTION_RENAME_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_RENAME_TITLE',
itemId : 'renameBtn',
cls : 'menuListRename-cls',
iconCls : 'menuListRename-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.rename(FM);
}
}, {
itemId : 'moveBtn',
text :_S._SFE_LANG_ACTION_COPY_TITLE_COPY_TO+'/'+ _S._SFE_LANG_ACTION_MOVE_TITLE_MOVE_TO,
qInternational : true,
qInternationalFn : function(cmp){
cmp.setText(_S._SFE_LANG_ACTION_COPY_TITLE_COPY_TO+'/'+ _S._SFE_LANG_ACTION_MOVE_TITLE_MOVE_TO);
},
hideOnClick :false,
iconCls : 'menuListMoveBtn-iconCls',
menu :{
cls : 'FM-moreActionMenuList-cls',
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
}
},
items:[{
itemId : 'copyTo',
text :_S._SFE_LANG_ACTION_COPY_TITLE_COPY_TO,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_COPY_TITLE_COPY_TO',
handler : function() {
var paramsObj = QNAP.QOS.fileExplorerTools.tool.getCopyMoveToObj.call(FM,'copy');
QNAP.QOS.fileExplorerTools.tool.showPopTreeWin.call(FM,paramsObj,QNAP.QOS.fileExplorerAction.copyMove);
}
},{
itemId : 'moveTo',
text :_S._SFE_LANG_ACTION_MOVE_TITLE_MOVE_TO,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_MOVE_TITLE_MOVE_TO',
handler : function() {
var paramsObj = QNAP.QOS.fileExplorerTools.tool.getCopyMoveToObj.call(FM,'move');
QNAP.QOS.fileExplorerTools.tool.showPopTreeWin.call(FM,paramsObj,QNAP.QOS.fileExplorerAction.copyMove);
}
}
]}
}, {
text : _S._SFE_LANG_ACTION_DEL_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DEL_TITLE',
itemId : 'deleteBtn',
width : 50,
iconCls : 'menuListdeleteBtn-iconCls',

tooltip : '_SFE_LANG_ACTION_DEL_TITLE',
handler : function() {
QNAP.QOS.fileExplorerAction.del(FM);
}
}, {
text : _S._SFE_LANG_COMMON_CUT,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CUT',
itemId : 'CutBtn',
cls : 'menuListCutBtn-cls',
disabled : false,
iconCls : 'menuListCutBtn-iconCls',
handler : function() {
var selections;
if (FM.currentHost == 'Client') {
selections = FM.clientGridPanel
.getSelectionModel().getSelections();
} else {
selections = FM.gridPanel.getSelectionModel()
.getSelections();
}
var qDatas = [];

for (var i = 0; i < selections.length; i++) {
var data = selections[i];
qDatas.push({
newWin : false,
appId : 'fileManager',
app : '',
size : data.get('filesize'),
iconName : 'images/icon/fm_main_icon.png',
displayName : data.get('filename'),
fullName : QNAP.QOS.fileExplorerTools.tool.getFullName(FM,data.get('filename')),
type : data.get('isfolder') == 1
? 'folder'
: 'file',
config : {
path : FM.currentPath
+ '/'
+ QNAP.QOS.fileExplorerTools.tool
.getFileNamPath(data
.get('filename'))[0]
}
});
}
QNAP.QOS.fileExplorerAction.copyAction(FM,
FM.currentPath, qDatas, 'move',
FM.currentHost);
}
}, '-',{
itemId : 'createShortcut',
text : _S._SFE_LANG_ACTION_CREATE_SHORTCUT_TO_DESKTOP,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_CREATE_SHORTCUT_TO_DESKTOP',
iconCls : 'menuListAddFav-iconCls',
handler : function() {
var selections = FM.gridPanel.getSelectionModel().getSelections();
FM.shortcutToDesk(selections[0]);
}
}, {
itemId : 'addToFavoritesBtn',
text : _S._SFE_LANG_ACTION_Add_To_Favorites,
cls : 'menuListAddFav-cls',
iconCls : 'menuListAddFav-iconCls',
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_Add_To_Favorites',
listeners : {
show:function(btn){
var path = FM.fileListStore.baseParams.path;
var selections = FM.gridPanel.getSelectionModel().getSelections();
if(selections.length!=0){
path = path+'/'+ selections[0].get('filename');
}
if (FM.favoriteStore.indexOfId(path) >= 0) {
btn.setIconClass('menuListRemoveFav-iconCls');
btn.setText(_S._SFE_LANG_ACTION_REMOVE_FROM_FAVORITES);
btn.qInternationalKey='_SFE_LANG_ACTION_REMOVE_FROM_FAVORITES';
} else {
btn.setIconClass('menuListAddFav-iconCls');
btn.setText(_S._SFE_LANG_ACTION_Add_To_Favorites);
btn.qInternationalKey='_SFE_LANG_ACTION_Add_To_Favorites';
}
}
},
handler : function(btn) {
var path = FM.fileListStore.baseParams.path;
var selections = FM.gridPanel.getSelectionModel().getSelections();
if(selections.length!=0 && selections[0].get('isfolder')){
path = path+'/'+ selections[0].get('filename');
}
if (FM.favoriteStore.indexOfId(path) >= 0) {
FM.removeFavorite(path);
btn.setIconClass('menuListAddFav-iconCls');
btn.setText(_S._SFE_LANG_ACTION_Add_To_Favorites);
btn.qInternationalKey='_SFE_LANG_ACTION_Add_To_Favorites';
} else {
var fileName = path.replace(/.*\//, '');
FM.addFavorite(path, fileName);
btn.setIconClass('menuListRemoveFav-iconCls');
btn.setText(_S._SFE_LANG_ACTION_REMOVE_FROM_FAVORITES);
btn.qInternationalKey='_SFE_LANG_ACTION_REMOVE_FROM_FAVORITES';
}
FM.updateStar();
}
}, '-', {
itemId : 'extractBtn',
text : _S._SFE_LANG_ACTION_EXTRACT_TITLE,
iconCls : 'menuListExtract-iconCls',
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_EXTRACT_TITLE',
hideOnClick:false,
menu : new Ext.menu.Menu({
cls : 'FM-moreActionMenuList-cls',
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
},
beforeshow : function(menu) {
var file = FM.gridPanel.getSelectionModel().getSelections()[0];
var extractName=file.get('filename').substring(0, file.get('filename').lastIndexOf('.'));
menu.getComponent('gcm_extract_to').setText(_S._SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_TO+ ' /'+extractName+'/');
}
},
items : [{
itemId : 'gcm_extract',
text : _S._SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_FILES
+ '...',
qInternational : true,
qInternationalFn : function(cmp) {
cmp
.setText(_S._SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_FILES
+ '...');
},
handler : function() {
QNAP.QOS.fileExplorerAction.extract(FM);
}
}, {
itemId : 'gcm_extract_here',
text : _S._SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_HERE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_HERE',
handler : function() {
QNAP.QOS.fileExplorerAction.extractDo(FM,
'here');
}
}, {
itemId : 'gcm_extract_to',
text : _S._SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_TO,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_TO',
handler : function() {
QNAP.QOS.fileExplorerAction.extractDo(FM, 'to');
}
}]
})
}, {
itemId : 'compressBtn',
text : _S._SFE_LANG_COMMON_COMPRESS,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_COMPRESS',
cls : 'menuList-compressBtn-cls',
iconCls : 'menuListCompressBtn-iconCls',
handler : function() {
FM.Compress();
}
}, '-', {
itemId : 'mountBtn',
text : _S._SFE_LANG_ACTION_MOUNT_TITLE,
iconCls : 'menuListMount-iconCls',
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_MOUNT_TITLE',
handler : function() {
QNAP.QOS.fileExplorerAction.mount(FM);
}
}, '-', {

itemId : 'recycleDelBtn',
text : _S._SFE_LANG_ACTION_DEL_FROM_RECYCLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DEL_FROM_RECYCLE',
cls : 'menuList-recycleDelBtn-cls',
iconCls : 'menuListRecycleDelBtn-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.del(FM);
}
}, {
itemId : 'recycleRcvBtn',
text : _S._SFE_LANG_COMMON_RECOVER,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_RECOVER',
cls : 'menuList-recycleRcvBtn-cls',
iconCls : 'menuListRecycleRcvBtn-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.recycleRcv(FM);
}
}, {
itemId : 'recycleEmptyBtn',
text : _S._SFE_LANG_ACTION_EMPTY_RECYCLE_BIN,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_EMPTY_RECYCLE_BIN',
cls : 'menuList-recycleEmptyBtn-cls',
iconCls : 'menuListRecycleEmptyBtn-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.recycleEmpty(FM);
}
}, '-', {
itemId : 'propertiesBtn',
text : _S._SFE_LANG_ACTION_PROPERTIES_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_PROPERTIES_TITLE',
cls : 'menuList-fileProperties',
iconCls : 'menuListPropertiesBtn-iconCls',
handler : function() {
var northPanel = Ext.getCmp(FM.northPanelId);
var eastPanelBtn = northPanel.items.items[northPanel.items.items.length
- 1];
var eastcmp = FM._getMainWindow().layout.east;
if (!eastcmp.isVisible()) {
eastPanelBtn.btnEl.dom.click();
}
}
}, '-', {
itemId : 'transcodeBtn',
text : _S._SFE_LANG_ACTION_TRANSCODE_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_TRANSCODE_TITLE',
iconCls : 'menuListShareFolderBtn-iconCls',
hidden : !QNAP.QOS.user.isAdminGroup,
handler : function() {
FM.addToTransCode()
}
}, {
itemId : 'delTmpVideoBtn',// delete transcoded
text : _S._SFE_LANG_ACTION_DELETE_TRANSCODED,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DELETE_TRANSCODED',
iconCls : 'menuListRecycleDelBtn-iconCls',
hidden : !QNAP.QOS.user.isAdminGroup,
handler : function() {
FM.delTransCode();
}
}, {
itemId : 'transInfoBtn',
text : _S._SFE_LANG_ACTION_TRANSCODE_INFORMATION_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_TRANSCODE_INFORMATION_TITLE',
iconCls : 'menuListTransInfoBtn-iconCls',
hidden : FM.isWFM || !QNAP.QOS.user.isAdminGroup,
handler : function() {
os.openApp('systemPreferences', {
fn : 'transcodeInfo'
});
}
}, {
itemId : 'cpMvListBtn',
text : _S._SFE_LANG_COMMON_BACKGROUND_TASK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_BACKGROUND_TASK',
cls : 'cpMvListBtn-cls',
iconCls : 'cpMvListBtn-iconCls',
handler : function(btn) {
os.openApp('FileUploadMgr', {
autoShow : true,
userOpen:true
});
}
}
, {
itemId : 'versionsBtn',
text : _S._SFE_LANG_PREVIOUS_VERSIONS,
qInternational : true,
qInternationalKey : '_SFE_LANG_PREVIOUS_VERSIONS',
cls : 'versionsBtn-cls',
iconCls : 'versionsBtn-iconCls',
handler : function(btn) {
FM.openVersions();
}
}, {
itemId : 'showHDFGBtn',
text : _S._SFE_LANG_SHOW_DELETED_FILES,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHOW_DELETED_FILES',
cls : 'showHDFGBtn-cls',
iconCls : 'showHDFGBtn-iconCls',
handler : function(btn) {
FM.showHistoryGrid();
}
}, {
itemId : 'storageInfoBtn',
text : _S._SFE_LANG_MSG_STORAGE_INFO,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_STORAGE_INFO',
cls : 'storageInfoBtn-cls',
iconCls : 'storageInfoBtn-iconCls',
handler : function(btn) {
FM.showStorageInfoWin();
}
}
]
}
}]
});// FM.fncBtns End
var cpMvListwin;// 傳輸狀態的彈出視窗。

FM.shareBtns = new Ext.ButtonGroup({
hidden : true,
ctCls : 'shareBtns-ctCls fncBtns-cls',
items : [{
itemId : 'mailShareBtn',
tooltip : '_SFE_LANG_COMMON_RESHARE',
iconCls : 'mailShareBtn-iconCls',
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
height : 29,
handler :  function() {
QNAP.QOS.fileExplorerAction.getShareWin15.call(FM,0,null, FM.shareGrid);
}
}, {
itemId : 'deleteShareBtn',
iconCls : 'deleteShareBtn-iconCls',
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
tooltip : '_SFE_LANG_SHARELINK_STOP_SHARE',
height : 29,
handler : function() {// Ext.createDelegate(
var isQsyncLink=FM.checkQsyncLink();
if(isQsyncLink){
return;
}
QNAP.QOS.fileExplorerAction.delShare(FM);
}
}, {
xtype : 'copybtn',
itemId : 'copyShareBtn',
tooltip : '_SFE_LANG_SHARELINK_COPY',
id : FM.copyShareBtnId,
iconCls : 'copyBtn-iconCls',
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
hidden : !DetectFlashVer(9),
height : 29,
overCls : ['copy-share-btn-over', 'x-btn-over'],
flexCallBack : function(a,b,c) {
var clipboardHint=FM.shareBtns.getComponent('clipboardHint');
clipboardHint.show();
FM.shareBtns.doLayout();
clipboardHint.el.dom.style.opacity=1;
var i=0;
var opacityTask= new Ext.util.DelayedTask(function() {
if(i<20){
i++;
clipboardHint.el.dom.style.opacity=clipboardHint.el.dom.style.opacity-0.05;
opacityTask.delay(50);
}
});
opacityTask.delay(1000);
var task = new Ext.util.DelayedTask(function() {
clipboardHint.hide();
});
task.delay(2000);
},
listeners : {
afterrender : function(cmp) {
cmp.el.select('div.x-btn')
.setSize(cmp.getWidth() - 3,
cmp.getHeight() - 3);
var task = new Ext.util.DelayedTask(function() {
var flexDiv = Ext.get(cmp.swfId + '-div');
flexDiv.dom.tabIndex=0;
});
task.delay(100);
},
mousemove : function(cmp) {
cmp.data = FM.shareGrid.data;
var flexDiv = Ext.get(cmp.swfId + '-div');
flexDiv.dom.focus();
}
}
},{
xtype : 'tbspacer',
width : 17
}, {
xtype : 'displayfield',
itemId : 'clipboardHint',
value : _S._SFE_LANG_SHARELINK_COPIED_MSG,
style : 'color:blue',
hidden : true,
qInternational : true,
qInternationalFn : function(cmp) {
cmp.hide();
cmp.setValue(_S._SFE_LANG_SHARELINK_COPIED_MSG);
}
}]
});// FM.shareBtns End
FM.share2MeBtns = new Ext.ButtonGroup({
hidden : true,
ctCls : 'shareBtns-ctCls fncBtns-cls',
allowTrans : false,
getGrid : function() {
var grid;
if (FM.shareFolderCTNGrid.isVisible()) {
grid = FM.shareFolderCTNGrid;
}
if (FM.shareSubListGrid.isVisible()) {
grid = FM.shareSubListGrid;
}
if (FM.share2MeGrid.isVisible()) {
grid = FM.share2MeGrid;
}
return grid;
},
playTrans : function(resolution) {
if(!resolution)
return;
var grid = FM.share2MeBtns.getGrid();
var selections = grid.getSelectionModel().getSelections();
var file = selections[0];
var parmsStr = location.protocol+'//'+location.host+'/share.cgi?';
var ep='LS0tLQ==';
if (grid.itemId == 'share2MeGrid') {
if(!Ext.isEmpty(file.get('access_code').replace('----',''))){
ep=QNAP.lib.encryption.ezEncode(file.get('access_code'));
}
parmsStr = parmsStr+'ssid=' + file.get('ssid') + '&ep='+ep+'&open=normal';
} else if (grid.itemId == 'shareSubListGrid') {
if(FM.shareSubListStore.pwd){
ep=QNAP.lib.encryption.ezEncode(FM.shareSubListStore.pwd);
}
parmsStr = parmsStr+'ssid=' + file.get('ssid') + '&fid=' + file.get('fid')
+ '&ep='+ep+'&open=normal';
} else if (grid.itemId == 'shareFolderCTNGrid') {
var fid = '';
if (!Ext.isEmpty(FM.shareFolderCTNStore.baseParams.fid)) {
fid = '&fid=' + FM.shareFolderCTNStore.baseParams.fid;
}
if(FM.shareFolderCTNStore.baseParams.pwd){
ep=QNAP.lib.encryption.ezEncode(FM.shareFolderCTNStore.baseParams.pwd);
}
parmsStr = parmsStr+'ssid=' + FM.shareFolderCTNStore.baseParams.ssid + fid
+ '&path='
+ encodeURIComponent(FM.shareFolderCTNStore.baseParams.path)
+ '&filename=' + encodeURIComponent(file.get('filename'))
+ '&ep='+ep+'&open=normal';
}
if(resolution.indexOf('mp4_')==0){
parmsStr = parmsStr+'&open=normal&mode='+resolution;//&dur=0
}else{
parmsStr = parmsStr+'&open=normal&s='+resolution;//&dur=0
}
parmsStr = parmsStr+'&dur='+file.get('duration');
var dlForm = Ext.DomHelper.append(document.body, {
tag : 'form',
id : Ext.id(),
frameBorder : 0,
method : 'post',
action : '/cgi-bin/apps/fileManager/ShareLkJWP.html?' + encodeURIComponent(parmsStr),
target : '_blank',
width : 0,
height : 0,
css : 'display:none;visibility:hidden;height:1px;'
}, false);
dlForm.submit();
},
items : [{
itemId : 'copyBtn',
tooltip : '_SFE_LANG_ACTION_COPY_TITLE',
disabled : false,
iconCls : 'menuList-Copy-icon',
width : 52,
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath + 'funcBtn/funcBtn2.png',
iconCls : 'copyBtn-iconCls',
handler : function() {
var grid;
if(FM.shareFolderCTNGrid.isVisible()){
grid=FM.shareFolderCTNGrid;
}
if(FM.shareSubListGrid.isVisible()){
grid=FM.shareSubListGrid;
}
if(FM.share2MeGrid.isVisible()){
grid=FM.share2MeGrid;
}

var selections=grid.getSelectionModel().getSelections();
var qDatas=[];
for (var i = 0; i < selections.length; i++) {
var data = selections[i];
var fileName=data.get('filename');
if(grid.itemId=='share2MeGrid' || grid.itemId=='shareSubListGrid'){
fileName='/';
}
qDatas.push({
newWin : false,
appId : 'fileManager',
app : '',
size : data.get('filesize'),
iconName : 'images/icon/fm_main_icon.png',
displayName : fileName,
fullName : '/',
type : data.get('isfolder') == 1 ? 'folder' : 'file',
ssid : data.get('ssid') || grid.store.baseParams.ssid,
fid : data.get('fid') || grid.store.baseParams.fid,
config : {
path : data.get('filename')
}
});
}
var sharePath='';
if(grid.itemId=='share2MeGrid' || grid.itemId=='shareSubListGrid'){
sharePath='/';
}else{
sharePath=FM.shareFolderCTNStore.baseParams.path;
}
QNAP.QOS.fileExplorerAction.copyAction(FM, sharePath, qDatas, 'copy', FM.currentHost);
}
}, {
itemId : 'pastBtn',
tooltip : '_SFE_LANG_COMMON_PAST',
disabled : false,
width : 52,
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath + 'funcBtn/funcBtn2.png',
iconCls : 'pastBtn-iconCls',
handler: function() {
QNAP.QOS.fileExplorerAction.pastAction(FM, 1);
}
},{
itemId : 'playShareBtn',
tooltip : '_SFE_LANG_COMMON_PLAY',
width : 73,
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath + 'funcBtn/funcBtn2.png',
iconCls : 'playBtn-iconCls',
hideOnClick:false,
menu : FM.playShareMenu
}, {
itemId : 'openBtn',
tooltip : '_SFE_LANG_COMMON_OPEN',
width : 52,
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath + 'funcBtn/funcBtn2.png',
iconCls : 'openBtn-iconCls',
handler : function() {
var grid = FM.share2MeBtns.getGrid();
var selections = grid.getSelectionModel().getSelections();
var file = selections[0];
var parmsStr = '';
if (grid.itemId == 'share2MeGrid') {
if(file.get('isfolder')==1 || file.get('multiple')==1){
FM.share2MeGridDblclick(grid);
}else{
var ep='LS0tLQ==';
if(!Ext.isEmpty(file.get('access_code').replace('----',''))){
ep=QNAP.lib.encryption.ezEncode(file.get('access_code'));
}
parmsStr = 'ssid=' + file.get('ssid') + '&ep='+ep+'&open=normal';
}
} else if (grid.itemId == 'shareSubListGrid') {
if(selections.length==1 && file.get('isfolder')==1){
FM.share2MeGridDblclick(grid);
}else{
var ep='LS0tLQ==';
if(FM.shareSubListStore.pwd){
ep=QNAP.lib.encryption.ezEncode(FM.shareSubListStore.pwd);
}
parmsStr = 'ssid=' + file.get('ssid') + '&fid=' + file.get('fid')
+ '&ep='+ep+'&open=normal';
}
} else if (grid.itemId == 'shareFolderCTNGrid') {
if(selections.length==1 && file.get('isfolder')==1){
FM.share2MeGridDblclick(grid);
}else{
var fid = '';
if (!Ext.isEmpty(FM.shareFolderCTNStore.baseParams.fid)) {
fid = '&fid=' + FM.shareFolderCTNStore.baseParams.fid;
}
var ep='LS0tLQ==';
if(FM.shareFolderCTNStore.baseParams.pwd){
ep=QNAP.lib.encryption.ezEncode(FM.shareFolderCTNStore.baseParams.pwd);
}
parmsStr = 'ssid='
+ FM.shareFolderCTNStore.baseParams.ssid
+ fid
+ '&path='
+ encodeURIComponent(FM.shareFolderCTNStore.baseParams.path)
+ '&filename=' + encodeURIComponent(file.get('filename'))
+ '&ep='+ep+'&open=normal';
}
}

var dlForm = Ext.DomHelper.append(document.body, {
tag : 'form',
id : Ext.id(),
frameBorder : 0,
method : 'post',
action : '/share.cgi?' + parmsStr,
target : '_blank',
width : 0,
height : 0,
css : 'display:none;visibility:hidden;height:1px;'
}, false);
if(parmsStr!='')
dlForm.submit();
}
}, {
itemId : 'downloadBtn',
tooltip : '_SFE_LANG_ACTION_DOWNLOAD_TITLE',
iconCls : 'downloadBtn-iconCls',
width : 52,
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath + 'funcBtn/funcBtn2.png',
handler : function() {
var grid = FM.share2MeBtns.getGrid();
var selections = grid.getSelectionModel().getSelections();
var file = selections[0];
var parmsStr = '';
var ep='LS0tLQ==';
if (grid.itemId == 'share2MeGrid') {
if(!Ext.isEmpty(file.get('access_code').replace('----',''))){
ep=QNAP.lib.encryption.ezEncode(file.get('access_code'));
}
parmsStr = 'ssid=' + file.get('ssid') + '&ep='+ep+'&openfolder=forcedownload';
} else if (grid.itemId == 'shareSubListGrid') {
if(FM.shareSubListStore.pwd){
ep=QNAP.lib.encryption.ezEncode(FM.shareSubListStore.pwd);
}
parmsStr = 'ssid=' + file.get('ssid') + '&fid=' + file.get('fid')
+ '&ep='+ep+'&openfolder=forcedownload';
} else if (grid.itemId == 'shareFolderCTNGrid') {
var fid = '';
if (!Ext.isEmpty(FM.shareFolderCTNStore.baseParams.fid)) {
fid = '&fid=' + FM.shareFolderCTNStore.baseParams.fid;
}
if(FM.shareFolderCTNStore.baseParams.pwd){
ep=QNAP.lib.encryption.ezEncode(FM.shareFolderCTNStore.baseParams.pwd);
}
parmsStr = 'ssid='
+ FM.shareFolderCTNStore.baseParams.ssid
+ fid
+ '&path='
+ encodeURIComponent(FM.shareFolderCTNStore.baseParams.path)
+ '&filename=' + encodeURIComponent(file.get('filename'))
+ '&ep='+ep+'&openfolder=forcedownload';
}
var dlForm = Ext.DomHelper.append(document.body, {
tag : 'form',
id : Ext.id(),
frameBorder : 0,
method : 'post',
action : '/share.cgi?' + parmsStr,
target : '_blank',
width : 0,
height : 0,
css : 'display:none;visibility:hidden;height:1px;'
}, false);
dlForm.submit();
}
},{
tooltip : '_SFE_LANG_ACTION_UPLOAD_TITLE',
itemId : 'uploadBtn',
width : 52,
height : 29,
ctCls : 'fmFunBtn-cCtls',
cls : 'fmFunBtn-cls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath + 'funcBtn/funcBtn2.png',
iconCls : 'uploadBtn-iconCls',
handler : Ext.createDelegate(QNAP.QOS.fileExplorerAction.upload, FM)
}]
});// FM.share2MeBtns End
FM.initShareActionBtns();

FM.searchComboBox = new Ext.form.TextField({
ctCls : 'searchComboBox-ctCls',
cls : 'searchComboBox-cls',
emptyText : _S._SFE_LANG_COMMON_SEARCH,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_SEARCH',
width : 126,
enableKeyEvents : true,
hideTrigger : true,
listeners : {
keypress : function(event) {
if (Ext.EventObject.keyCode == 13) {
FM.advSearch('smp');
}
}
}
});
var switchModeBtn = new Ext.ButtonGroup({
itemId : 'switchModeGroup',
cls : 'switchModeGroup-cls',
items : [{
itemId : 'mode2Btn',
width : 33,
hieght : 29,
allowDepress : false,
toggleGroup : 'switchMode'+FM.id,
pressed : QNAP.QOS.user.viewMode=='V2',
tooltip : '_SFE_LANG_SHOW_ITEMS_AS_ICONS',
cls : 'switchModeBtnL-cls',
iconCls : 'mode2Btn-iconCls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'common/toolbar_icon.png',
handler : function() {
FM.switchViewMode('V2',true);
}
}, {
itemId : 'mode1Btn',
width : 33,
hieght : 29,
allowDepress : false,
pressed : getV1mode(),
toggleGroup : 'switchMode'+FM.id,
tooltip : '_SFE_LANG_SHOW_ITEMS_IN_A_LIST',
cls : 'switchModeBtnM-cls',
iconCls : 'mode1Btn-iconCls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'common/toolbar_icon.png',
handler : function() {
FM.switchViewMode('V1',true);
}
}, {
itemId : 'mode3Btn',
width : 33,
hieght : 29,
allowDepress : false,
pressed : QNAP.QOS.user.viewMode=='V3',
toggleGroup : 'switchMode'+FM.id,
tooltip : '_SFE_LANG_SHOW_ITEMS_IN_A_DETAIL_LIST',
cls : 'switchModeBtnR-cls',
iconCls : 'mode3Btn-iconCls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'common/toolbar_icon.png',
handler : function() {
FM.switchViewMode('V3',true);
}
}]
});
function getV1mode(){
if(QNAP.QOS.user.viewMode && QNAP.QOS.user.viewMode == 'V1'){
return true;
}else if(!QNAP.QOS.user.viewMode){
return true;
}else{
return false;
}
}
FM.searchMenuBtn = new Ext.Button({
itemId : 'searchBtn',
ctCls : 'fmFunBtn-cCtls',
cls : 'searchBtn-cls none-bg-btn',
width : 52,
height :25,
menu : {
x : 1 - 10,
cls : 'FM-moreActionMenuList-cls searchMenuBtn-cls',
shadow : false,
width : 200,
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
}
},
items : [{
text : _S._SFE_LANG_COMMON_MUSIC,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_MUSIC',
itemId : 'Music',
handler : function(thisBtn, isChecked) {
clickSeachMenu(thisBtn, isChecked);
}
}, {
text : _S._SFE_LANG_COMMON_VIDEO,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_VIDEO',
itemId : 'Video',
handler : function(thisBtn, isChecked) {
clickSeachMenu(thisBtn, isChecked);
}
}, {
text : _S._SFE_LANG_COMMON_PHOTO,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PHOTO',
itemId : 'Photo',
handler : function(thisBtn, isChecked) {
clickSeachMenu(thisBtn, isChecked);
}
}, {
text : _S._SFE_LANG_COMMON_ADVANCE_SEARCH,
itemId : 'advSearch',
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_ADVANCE_SEARCH',
handler : function(thisBtn, isChecked) {
clickSeachMenu(thisBtn, isChecked);
FM.createAdvSearch();
}
}]
},
handler : function() {
}
});
function clickSeachMenu(thisBtn, isChecked) {
if(FM.advSearchArea){
FM.advSearchArea.topToolbar.getComponent('advClose').btnEl.dom.click();
}
if (thisBtn.itemId == 'Music')
FM.advSearch('smp', 4);
if (thisBtn.itemId == 'Video')
FM.advSearch('smp', 5);
if (thisBtn.itemId == 'Photo')
FM.advSearch('smp', 6);

FM.searchMenuBtn.menu.hide();
}
return {
region : 'north',
id : FM.northPanelId,
cls : 'northRegion-cls',
listeners : {
afterrender : function() {
}
},
items : [FM.searchComboBox, FM.searchMenuBtn,{
xtype : 'tbspacer',
id : FM.searchSpace,
hidden : true,
width : 192
}, {
xtype : 'tbspacer',
width : 7
}, switchModeBtn,{
xtype : 'tbspacer',
width : 10
},
FM.fncBtns, FM.shareBtns,FM.share2MeBtns,
FM.clientfncBtns,FM.delHistoryGridBtns,
(FM.remoteBtn = new QNAP.QOS.FM.Remote.ManagmentButton({hidden: true}, FM)),
'->',
{
xtype : 'button',
itemId:'bgTaskBtn',
icon : '/cgi-bin/apps/fileManager/images/funcBtn/bgTask.gif',
iconCls : 'bgTaskBtn-cls',
width : 27,
hieght : 27,
style:'height:21px',
hidden : true,
handler : function() {
os.openApp('FileUploadMgr', {
autoShow : true,
userOpen:true
});
},
listeners : {
show : function(btn) {
if(btn.tooltip.el){
btn.tooltip.el.dom.style.zIndex=Ext.getCmp(FM.fsWinId).el.zindex+5;
}
},
afterrender : function(btn) {
btn.tooltip=new Ext.ToolTip({
target: btn.el,
title : '1',
autoHide : false,
anchor : 'top',
cls: 'fsTip-cls'
});
FM.getBgTaskStatus();
}
}
}, {
itemId : 'stDeviceBtn',
hidden: !QNAP.QOS.user.isAdminGroup,
tooltip : '_SFE_LANG_LAN_DEVICES',
iconCls : 'stDeviceBtn-cls',
ctCls : 'stDeviceBtn-ctCls',
cls : 'none-bg-btn',
hideOnClick:false,
streamFile:false,
menu : FM.streamDeviceMenu
}, {
xtype : 'button',
itemId:'filterBtn',
tooltip : '_SFE_LANG_FILE_FILTER',
iconCls : 'filterBtn-cls',
ctCls : 'setting-ctCls',
cls : 'none-bg-btn',
width : 27,
hieght : 23,
enableToggle:true,
listeners:{
afterrender:function( btn ){
FM.setFilterStatus();
}
},
handler : function() {
if(this.pressed){
FM.createAdvSearch('filter');
}else{
FM.advSearchArea.hide();
var h = Ext.getCmp(FM.centerRegionId).getHeight()- FM.pathPanel.getHeight();
FM.centerPanel.setHeight(h);
}

}
},{
itemId : 'refreshBtn',
tooltip : '_SFE_LANG_COMMON_REFRESH',
ctCls : 'refreshBtn-ctCls',
cls : 'fmBgBtn-cls',
icon : '/v3_menu/panel/toolbar_icon.png',
iconCls : 'refreshBtn-iconCls',
handler : function() {
var selNode = FM.treePanel.getSelectionModel().selNode;
if (FM.shareGrid && FM.shareGrid.isVisible()) {
FM.shareStore.reload();
} else if (FM.clientGridPanel && FM.clientGridPanel.isVisible()) {
FM.clientFileStore.reload();
if(selNode)
selNode.reload();
} else if ((FM.gridPanel && FM.gridPanel.isVisible()) || (FM.NasDataView && FM.NasDataView.isVisible())) {
if(FM.searchMode){
Ext.getCmp(FM.advSrBtnId).btnEl.dom.click();
}else if (!selNode || (selNode.id != 'qsyncRoot' && selNode.id!='recycleBin' && selNode.id != 'qsyncRecycle')) {

FM.initNasShareFolder(FM.currentPath);
FM.reloadCloudList();
}else if (selNode.id == 'qsyncRoot' || selNode.id == 'qsyncRecycle'){
FM.fileListStore.reload();
}
} else if (FM.recycleBinGrid && FM.recycleBinGrid.isVisible()) {
FM.recycleBinGrid.store.reload();
} else if (FM.share2MeGrid && FM.share2MeGrid.isVisible()) {
FM.share2MeGrid.store.reload();
} else if (FM.shareSubListGrid && FM.shareSubListGrid.isVisible()) {
FM.shareSubListGrid.store.reload();
} else if (FM.shareFolderCTNGrid && FM.shareFolderCTNGrid.isVisible()) {
FM.shareFolderCTNGrid.store.reload();
}



}
}, {
xtype : 'button',
tooltip : '_SFE_LANG_COMMON_SETTINGS',
iconCls : 'setting-cls',
ctCls : 'setting-ctCls',
cls : 'none-bg-btn',
width : 27,
hieght : 23,
handler : function() {
FM.showSettingWin(0);
}
}, {
xtype : 'button',
tooltip : '_SFE_LANG_COMMON_HELP',
iconCls : 'helpwin-cls',
ctCls : 'helpwin-ctCls',
cls : 'none-bg-btn',
width : 27,
hieght : 23,
handler : function(cmp) {
var paramsStr='?';
var helpUrl='/cgi-bin/apps/fileManager/help.html';
paramsStr=paramsStr+'sptTrans='+FM.sysSetting.transcode_server_status;
var position=cmp.getPosition();
var aboutMenu = new Ext.menu.Menu({
items : [{
itemId:'helpBtn',
text : _S._SFE_LANG_COMMON_HELP,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_HELP',
tooltip : '_SFE_LANG_COMMON_HELP',
handler : function() {
if (FM.isWFM) {
var helpwin = FM._createModalWindow({
title : 'File Station -Help',
layout : 'fit',
width : 700,
height : 530,
cls : 'WFMhelpwin-cls',
closeAction : 'close',
html : '<iframe frameborder="0" ' +
'style="position:relative;top:0px;bordr: 0px solid #AAA;" width="100%" height="100%" ' +
'src="' + helpUrl+paramsStr+'"></iframe>',
closable : true,
resizable : true
});
helpwin.show();
} else {
os.openURL(helpUrl+paramsStr);
}
}
}, {
itemId : 'aboutWFM',
text : _S._SFE_LANG_COMMON_ABOUT,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_ABOUT',
scope : this,
handler : function() {
var buildYear = QNAP.QOS.config.build.substr(0, 4);
var aboutWin ;
var FWVer=URL_RANDOM_NUM.replace('.'+QNAP.QOS.config.build,'');
var iconPath = [String.format(FM.icon,68), URL_RANDOM_NUM].join('?');
if(!aboutWin){
aboutWin= FM._createModalWindow({
text : _S._SFE_LANG_COMMON_ABOUT,
cls : 'FM-popup-cls',
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_ABOUT',
style : 'font-size:12px;',
padding : 0,
layout : {
type : 'hbox',
pack : 'start',
borber : 0,
align : 'stretch'
},
items : [{
bodyStyle : 'text-align: center;padding-top: 20px;',
html : '<img src="'+iconPath+'" class="wfmAbout-icon-cls">',
width : 130,
cls : 'wfmAbout-cls'
}, {
html : '<b>File Station</b><br><br>'
+ _S._SFE_LANG_VERSION
+ ' '
+ FWVer
+ ' ('
+ QNAP.QOS.config.build
+ ')'
+ '<br><br>'
+ ((QNAP.QOS.config.isGenericModel == false)
? ('<a target="_blank"  href="http://www.qnap.com/">www.qnap.com</a><br><br>'
+ '&copy;' + buildYear + ' QNAP Systems, Inc. All Rights Reserved.')
: ''),
cls : 'wfmAbout-cls',
padding : 30,
flex : 1
}],
width : 480,
height : 300,
buttons : [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
cls : 'capsule-btn',
handler : function() {
aboutWin.close();
}
}]
});
}
aboutWin.show();
}
}]
});
if(FM.isWFM){
aboutMenu.getComponent('helpBtn').handler();
}else{
aboutMenu.showAt([position[0],position[1]+25]);
}
}
}]
};
},// initNorthRegion End
helpArgs : {
fn : '',
items : ''
},// helpArgs End
initStore : function(config) {
var FM = this;
if(!FM.isWFM && QNAP.QOS.user.isAdminGroup){
FM.userStore = new Ext.data.Store({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privRequest.cgi', {
subfunc: "user"
}, {
getdata: 1,
sort: 13
}),
remoteSort: true,
method: 'POST',
baseParams: {
filter: '',
type: 0,
lower: 0,
refresh: 0,
upper: QNAP.QOS.user.pageSize.usersPSCookie || 10
},
defaultParamNames: {
limit: 'upper',
start: 'lower',
refresh: 'refresh'
},
reader: new Ext.data.XmlReader({
root: 'data',
totalProperty: 'userroot > count',
record: 'user'
}, [{
name: 'checkbox',
mapping: 'checkbox'
}, {
name: 'username',
mapping: 'username'
}, {
name: 'description',
mapping: 'description'
}, {
name: 'QuotaSize',
mapping: 'QuotaSize'
}, {
name: 'user_enable',
mapping: 'user_enable',
defaultValue: '1'
}, {
name: 'action',
mapping: 'action'
}]),
getFloatNumber: function (v, n) {
if (typeof n == 'undefined') n = 3;
var baseNumber = Math.pow(10, n);
return Math.round(v * baseNumber) / baseNumber;
},
listeners: {
beforeload: function (store, o) {
},
load: function (store) {
var xmlData = store.reader.xmlData;
store.each(function (r) {
if (r.data.QuotaSize != '--') {
var a = parseFloat(r.data.QuotaSize);
r.data.QuotaSize = a >= 1024 ? store.getFloatNumber((a / 1024), 3) + " GB" : a + " MB";
}
r.afterEdit();
});
FM.UserHomeVolumn = Ext.DomQuery.selectValue("UserHomeVolume", xmlData);
FM.UserHomeEnabled = Ext.DomQuery.selectValue("UserHomeEnabled", xmlData) == "1";
}
}
});
FM.userStore.reload();
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privRequest.cgi', {
subfunc: 'usr_quota'
}, {
init:1
}),
method: 'POST',
success: function (response, opts) {
var xmlData = response.responseXML;
if (Ext.DomQuery.selectNode('QDocRoot', xmlData)) {
FM.UserQuotaEnabled = Ext.DomQuery.selectValue('EnableQuotaValue', xmlData) == '1';
} else {
}
},
failure: function () {
}
});
}
FM.streamDeviceStore = os.initStore('streamDeviceStore');
FM.streamDeviceStore.reload();
FM.treeRoot = new Ext.tree.TreeNode({
text : 'Server',
draggable : false, // disable root node dragging
allowDrop : false,
expanded : true,
id : 'tree_root'
});
FM.domainStore = new Ext.data.JsonStore({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'get_domain_ip_list'),
autoLoad : true,
root : 'domains',
fields : ['value', 'index','display'],
idProperty : 'value',
data : {
domains : [{
value : QNAP.QOS.config.serverHost
}]
},
listeners : {
beforeload:function(){
},
loadexception : function() {
var store = this;
var domains = [];
var json = store.reader.jsonData;
FM.domainStore.domainData = store.reader.jsonData;
QNAP.QOS.fileExplorerAction.domainData = store.reader.jsonData;

var ipMap = {};
ipMap['All available links'] = 0; //index number is used for sort.
if (!Ext.isEmpty(json.link_url)) {
ipMap[json.link_url] = 1;
}
if (!Ext.isEmpty(json.mycloudnas_hn)) {
ipMap[json.mycloudnas_hn] = 2;
}
if (!Ext.isEmpty(json.ddns_hn)) {
ipMap[json.ddns_hn] = 3;
}
if (!Ext.isEmpty(json.external_ip)) {
ipMap[json.external_ip] = 4;
}
if (!Ext.isEmpty(json.local_ip)) {
ipMap[json.local_ip] = 5;
}
if (!Ext.isEmpty(json.host_ip)) {
var host_ip=json.host_ip.split(':')[0];
ipMap[host_ip] = 6;
}

var ipArr = json.local_ip_list.split(',');
if (!Ext.isEmpty(json.local_ip_list)) {
for (var i = 0; i < ipArr.length; i++) {
if(ipArr[i]!='')
ipMap[ipArr[i]] = 7 + i;
}
}
if(FM.sysSetting.cloud_link_enable==1){
ipMap['CloudLink'] = 99;//Bug 60127:CloudLink always at the last.
}
Ext.iterate(ipMap, function(key, value) {
var display = key;
if(value==0){//'All available links'
display=_S._SFE_LANG_COMMON_ALL_AVAILABLE_LINKS;
}
domains.push({
value : key,
index : value,
display : display
});
});
store.loadData({
domains : domains
});
store.sort('index', 'ASC');
if(FM.sysSetting.cloud_link_enable!=1){//0 : installed, but does not enable; 2 : support model but not installed

}else{
}
}
}
});
FM.domainStore.load();
FM.favRoot = new Ext.tree.TreeNode({
text : _S._SFE_LANG_COMMON_FAVORITES,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FAVORITES',
iconCls : 'favRoot-iconCls',
cls : 'fm-treeRoot favRoot-cls',
ctCls : 'favRoot-ctCls',
draggable : true,
allowDrop : true,
id : 'favorite_root',
expanded : true,
data : {
type : 'NAS'
},
listeners : {
click : function(node, event) {
}

}
});
FM.nasRoot = new Ext.tree.TreeNode({
iconCls : 'NASRoot-cls',
cls : 'fm-treeRoot',
draggable : true, // disable root node dragging
allowDrop : true,
expanded : true,
data : {
type : 'NAS'
},
id : 'vol_root',
listeners : {
beforeappend : function( tree, nasRoot, node, refNode) {
}
}
});
FM.fileTreeLoader = new Ext.tree.TreeLoader({
baseParams : {
is_iso : '0'
},
dataUrl : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'get_tree'),
preloadChildren : true,
listeners : {
beforeload : function(treeLoader, node, cb) {
this.baseParams = {
is_iso : node.attributes.iconCls == 'iso' ? 1 : 0,
hidden_file : QNAP.QOS.user.fe_isShowHideFile == 'true' ? 1 : 0,
recycle: QNAP.QOS.user.fe_isShowNetworkRecycleBin == 'false'? 1: 0
}
if(node.folderType=='volumeNode'){
this.baseParams.vol_id=node.id;
}
if(node.id.indexOf(FM.sysSetting.ubuntu_home_path)==0){
this.baseParams.src_flag='ubuntu';
}else{
delete this.baseParams['src_flag'];
}
},
load : function(treeLoader, parentNode, response) {
var r = Ext.decode(response.responseText);

var fixXSS=QNAP.QOS.fileExplorerTools.tool.fixXSS;
if(response.argument.node.id== 'vol_root'){
Ext.each(r,function(vol){
vol.id= vol.volume_id.toString();
});
}
if(r[0] && r[0].real_total>QNAP.QOS.fileExplorerTools.config.getTree_MaxLimit){//2000
var tip=parentNode.attributes.qtip;
parentNode.setText(parentNode.text)
parentNode.setTooltip(_S._SFE_LANG_MSG_TREE_MORE_2000,tip);
parentNode.more2KNode=true;
}

if(r.datas && r.datas.length==0 && response.argument.node.id== 'vol_root'){//如果沒有掛載任何資料夾
FM.hideAllActBtn();
FM.nasRoot.disable();
FM.Qsync.disable();
FM.treeRoot.findChild('id','clientRoot').disable();
FM.treeRoot.findChild('id','shareNode').disable();
FM.treeRoot.findChild('id','recycleBin').disable();

var task = new Ext.util.DelayedTask(function() {
Ext.getCmp(FM.id).disable();
});
task.delay(50);
var msgObj = {
text : _S._SFE_LANG_ERROR_NO_AVAILABLE_VOLUMES
.replace('<qtag>','<br><a href="#" onClick="os.openApp(\'storageManagerV2\')">')
.replace('</qtag>','</a>'),
key : '_SFE_LANG_ERROR_NO_AVAILABLE_VOLUMES'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
Ext.getCmp(FM.id).close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg
.call(FM, 'error', msgObj, btns);
MsgWin.show();
}
var parentAttributes = parentNode.attributes;
QNAP.QOS.fileExplorerTools.tool.checkStatus(response);


var i = 0;
var parentIsISO = parentAttributes.iconCls == 'iso'
|| parentAttributes.data.isoFolder;
parentNode.eachChild(function(node) {

if(response.argument.node.id== 'vol_root'){
var data = node.attributes;
var vlmName = '';
var htmltip = document.createAttribute("data-htmltip");
htmltip.value =true;
node.ui.textNode.attributes.setNamedItem(htmltip);//tip改為 支援HTML與法
if(!Ext.isEmpty(data.pool_id)){
if(Ext.isEmpty(data.volume_name) && data.iconCls == 'usb-cls'){
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + data.id.replace('/','');
}else{
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + data.volume_name;
}
}else {
if (Ext.isEmpty(data.volume_name)) {
if(data.iconCls == 'usb-cls'){
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + data.id.replace('/','');
}else{
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': '
+ _S._SFE_LANG_COMMON_DRIVE + ' ' + data.raid_disk_list;
}
} else {
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + data.volume_name;
}
}
var tipStr = '' ;
if(!Ext.isEmpty(data.pool_id) && data.pool_id>0){
tipStr=tipStr+_S._SFE_LANG_COMMON_STORAGE_POOL+':'+data.pool_id+ '<br>'
}
tipStr=tipStr+vlmName + '<br>';
if(data.volume_lock==1 || data.iconCls=='iso'){
node.setTooltip(node.id.replace('/',''));
}else{
tipStr +=  _S._SFE_LANG_COMMON_CAPACITY + ': '
+ data.capacity + ' ' + data.volume_unit + ' '
+ _S._SFE_LANG_COMMON_FREE_SIZE + ': ' + data.free_size
+ ' ' + data.volume_unit;
node.setTooltip(tipStr);
}

}else{
node.setText(fixXSS(node.text));
if(node.id.indexOf('<')>=0 && node.id.indexOf('>')>0){
if(!node.ui.ctNode){
var ctEl=Ext.DomHelper.append(node.ui.wrap,{
tag:'ul',
cls:'x-tree-node-ct',
style:'display:none;'
});
node.ui.ctNode=ctEl;
}
Ext.get(node.ui.elNode).dom.attributes[0].value=node.id;
}
node.setTooltip(node.id.replace('/',''));
}
if(parentNode.folderType && parentNode.folderType!=	'volumeNode'){
node.folderType = parentNode.folderType;
}else if(parentNode.folderType && parentNode.folderType =='volumeNode'){
node.folderType ='shareFolder';
}
if(response.argument.node.id!= 'vol_root'){
node.attributes.data = {
dirPath : node.id,
access : r[i].cls || 0,
type : 'NAS',//parentAttributes.data.type,
isoFolder : parentIsISO || r[i].iconCls == 'iso'
? 1
: 0,
noSupportACL : r[i].noSupportACL == '0'
? false
: true
};
}
if(node.text=='@Recycle'){
Ext.get(node.ui.iconNode).addClass('recycle-cls');
}
node.on('click', function(node) {
FM.nasTreeNodeClick(node);
});
i++;
});
if(response.argument.node.id== 'vol_root'){
FM.sysSetting.isHAL = !Ext.isEmpty(r[0].pool_id);
}

FM.showTreeRecycle(QNAP.QOS.user.fe_isShowNetworkRecycleBin!='false');

if (r.status == QNAP.QOS.fileExplorerTools.status.WFM_CLOSE) {//Web File Manager尚未啟用
}
}
}
});

FM.checkFileTreeLoader = new Ext.tree.TreeLoader({
baseParams : {
is_iso : '0'
},
dataUrl : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM, 'get_tree'),
listeners : {
load : function() {
},
beforeload : function(treeLoader, node, cb) {
this.baseParams = {
is_iso : node.attributes.iconCls == 'iso' ? 1 : 0,
hidden_file : QNAP.QOS.user.fe_isShowHideFile == 'true' ? 1 : 0
}
}
}
});

FM.Qsync = new Ext.tree.TreeNode({
iconCls : 'Qsync-iconCls',
cls : 'Qsync-cls fm-treeRoot',
text : 'Qsync',
leaf : false,
draggable : true,
allowDrop : false,
expanded : true,
hidden:!FM.config.supportQsync,
data : {
type : 'Qsync'
},
id : 'qsyncRoot',
listeners : {
load : function(node) {
},
click : function(node) {
var swichModeBtn=Ext.getCmp(FM.northPanelId).getComponent('switchModeGroup').getComponent('mode2Btn');
if (swichModeBtn.pressed) {
FM.setMainScr('NasDataView-id');
} else {
FM.setMainScr('file-panel');
}
if (FM.couldQsync) {
FM.loadPath('/home/.Qsync', '', false, true);
} else {
QNAP.QOS.fileExplorerTools.tool
.checkQboxInfo(FM);
}
FM.currentGrid = 'fileGrid';
if (FM.eastTab) {
FM.eastTab.getComponent('permissionPanel').disable();
if (FM.eastTab.getActiveTab()&& FM.eastTab.getActiveTab().itemId == 'permissionPanel') {
FM.eastTab.setActiveTab(0);
}
}
}
}
});

var Qrecycle = new Ext.tree.TreeNode({
itemId : 'Qrecycle',
id : 'qsyncRecycle',
text : _S._SFE_LANG_COMMON_RECYCLE_BIN,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_RECYCLE_BIN',
cls : 'Qrecycle-cls',
hidden : QNAP.QOS.user.fe_isShowNetworkRecycleBin == 'false',
data : {
type : 'Qrecycle'
},
listeners : {
click : function() {
Ext.Ajax.request({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM, 'qbox_get_recycle_bin_status'),
success : function(RS, RQ) {
var rs = Ext.decode(RS.responseText);
if (rs.recycle_bin_enable != 1) {
FM.treePanel.preNode.select();
var msg = _S._SFE_LANG_NETWORK_RECYCLE_BIN_IS_NOT_ENABLED;
var reB = _S._SFE_LANG_COMMON_NETWORK_RECYCLE_BIN;
if (!FM.isWFM && QNAP.QOS.user.isAdminGroup) {
reB = '<a href="#" onclick="os.openApp(\'systemPreferences\', {fn: \'recycleBin\'});">'
+ _S._SFE_LANG_COMMON_NETWORK_RECYCLE_BIN
+ '</a>';
}
var msgObj = {
text : msg.replace(_S._SFE_LANG_COMMON_NETWORK_RECYCLE_BIN,reB),
key : '_SFE_LANG_NETWORK_RECYCLE_BIN_IS_NOT_ENABLED'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg
.call(FM, 'error', msgObj, btns);
MsgWin.show();
} else {
QNAP.QOS.fileExplorerTools.tool.checkQboxInfo(FM, true);
if (FM.couldQsync) {
FM.setMainScr('file-panel');
FM.loadPath('/home/@Recycle/.Qsync', '',
false, true);
} else {

}
}
},
failure : function(RS, RQ) {
}
});
FM.currentGrid = 'fileGrid';
}
}
});

Qrecycle.select = function() {
var t = this.getOwnerTree();
if (t) {
t.getSelectionModel().select(this);
}
Qrecycle.ui.elNode.click();
}
FM.Qsync.appendChild(Qrecycle);
Ext.Ajax.request({
url : '/cgi-bin/filemanager/utilRequest.cgi?sid='
+ QNAP.QOS.user.sid + '&func=qbox_get_qbox_info',
success : function(o) {
if (!QNAP.QOS.fileExplorerTools.tool
.checkResponseIfEmpty(o.responseText)) {
var rs = Ext.util.JSON.decode(o.responseText);
if (rs.qbox_function_enable == 1) {// Qsync有啟動,顯示Qsync結點 (Qsync預設值隱藏)
FM.Qsync.ui.show();
}else{
FM.Qsync.ui.hide();
}

}
},
failure : function(o) {
}
});
FM.treeRoot.appendChild(FM.nasRoot);
FM.initNasShareFolder();
FM.nasRootStore = new Ext.data.JsonStore({
root : 'root',
fields : ['text', 'path', 'type','iconCls']
});
var fnClick = 0;
FM.fileListStore = new Ext.data.JsonStore({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,
'get_list'),
baseParams : {
list_mode : 'all'
},
status : 'status',
totalProperty : 'total',
root : 'datas',
acl : 'acl',
singleSort : function(fieldName, dir) {

FM.goFirstPage=true;
var field = this.fields.get(fieldName);
if (!field) {
return false;
}

var name = field.name, sortInfo = this.sortInfo || null, sortToggle = this.sortToggle
? this.sortToggle[name]
: null;

if (!dir) {
if (sortInfo && sortInfo.field == name) { // toggle sort dir
dir = (this.sortToggle[name] || 'DESC').toggle('DESC', 'ASC');
} else {
dir = (field.sortDir || 'DESC').toggle('DESC', 'ASC');
}
}
os.saveConfig('sortField', fieldName);
os.saveConfig('sortA_Z', dir);
QNAP.QOS.user.sortField=fieldName;
QNAP.QOS.user.sortA_Z=dir;
var fnHeader = Ext.get(FM.gridPanel.view.getHeaderCell(2));
if (name == 'filename') {
name = 'natural';
if (fnClick % 2 == 0) {
field.sortDir = 'DESC';
fnHeader.removeClass('sort-asc');
fnHeader.addClass('sort-desc');
} else {
field.sortDir = 'ASC';
fnHeader.removeClass('sort-desc');
fnHeader.addClass('sort-asc');
}
dir = field.sortDir;
fnClick++;
} else {
fnHeader.removeClass('sort-asc');
fnHeader.removeClass('sort-desc');
}
this.sortToggle[name] = dir;
this.sortInfo = {
field : name,
direction : dir
};
this.hasMultiSort = false;
if (this.remoteSort) {
FM.centerPanel.bottomToolbar.changePage(1); //直接在這邊返回第一頁
} else {
this.applySort();
this.fireEvent('datachanged', this);
}
return true;
},
fields : ['icon', 'natural', 'filename', 'filesize', 'filetype',
'filepath', 'mt', 'privilege', 'owner', 'group',
'isfolder', 'iscompressed', 'qbox_type', //, 'isFavorite'
'trans', 'play', 'mp4_240', 'mp4_360', 'mp4_480',
'mp4_1080', 'mp4_720', 'thumbIcon','thumbFilename','content','thumb_folder',
'sticky_bit','randno',
'versioning_support',{
name : 'parentLink',
type : 'boolean'
}],
listeners : {
beforeload : function(store, options) {
if(FM.fileListStore.baseParams.path.indexOf(FM.sysSetting.ubuntu_home_path)==0){
FM.fileListStore.baseParams.src_flag='ubuntu';
}else{
delete FM.fileListStore.baseParams['src_flag'];
}
if(FM.fileListStore.baseParams.path.indexOf('/remote:')==0){
FM.searchComboBox.hide();
FM.searchMenuBtn.hide();
Ext.getCmp(FM.searchSpace).show();
}else{
FM.searchComboBox.show();
FM.searchMenuBtn.show();
Ext.getCmp(FM.searchSpace).hide();
}


if(FM.fileListStore.baseParams.path=='qsyncRoot'){
FM.fileListStore.baseParams.path='/home/.Qsync';
}

FM.fileListStore.baseParams.limit = FM.centerPanel.bottomToolbar.items.items[15].getValue();
var sid = QNAP.QOS.user.sid;
if(FM.isWFM && FM.isFirstOpenFM==1){
FM.isFirstOpenFM=0;
var urlprms='';
var params={};

if(location.href.indexOf('?')>0){
urlprms = location.href.split('?')[1];
var pArr=urlprms.split('&');
Ext.each(pArr,function(p){
var ppp=p.split('=');
params[ppp[0]]=ppp[1];
});
if(params.act){
FM.WFMDefaultAct(params);
}else if(params.path && params.path!='qsyncRecycle'){
FM.fileListStore.baseParams.path=decodeURIComponent(params.path);
}
}
}
if(!Ext.isEmpty(FM.openAppFileName)){
FM.fileListStore.baseParams.filename = FM.openAppFileName;
}
if(FM.fileListStore.baseParams.path=='qsyncRecycle'){
FM.fileListStore.baseParams.path='/home/@Recycle/.Qsync';
}

if(!Ext.isEmpty(FM.filefilter)){
FM.fileListStore.baseParams.list_mode='adfilter';
var parms=Ext.decode(FM.filefilter);
for (var key in parms) {
FM.fileListStore.baseParams[key]=parms[key];
}
}
if(QNAP.QOS.user.fe_isShowNetworkRecycleBin!='false'){//是否顯示資源回收桶
FM.fileListStore.baseParams.recycle=0;//顯示
}else{
FM.fileListStore.baseParams.recycle=1;//不顯示
}


if (FM.fileListStore.baseParams.path
.indexOf('/home/.Qsync') >= 0) {
sid = FM.QsyncSid;
if (!FM.QsyncSid && !FM.QsyncError) {
QNAP.QOS.fileExplorerTools.tool.checkQboxInfo(FM);
}
if (FM.QsyncSid) {
sid = FM.QsyncSid;
} else {
sid = QNAP.QOS.user.sid;
}
}

if (FM.searchMode) {
store.proxy
.setUrl(QNAP.QOS.fileExplorerTools.tool.getActionUrl
.call(FM, 'search_ext&v=1'));
} else {
var showHidden = 0;
if (QNAP.QOS.user.fe_isShowHideFile == 'true') {
showHidden = 1;
}
var params = {
'func': 'get_list',
'sid': sid
};

if (/^(fav)?\/remote:\d+@[0-9a-f]/.test(FM.fileListStore.baseParams.path)) {
params['check_thumb_folder'] = 1;
}
var url = QNAP.QOS.fileExplorerTools.config.cgiPath + 'utilRequest.cgi?' + Ext.urlEncode(params);
store.proxy.setUrl(url);
}
if(FM.eastTab.isVisible()){
FM.versionSwich(FM.eastTab.getWidth());
}else if(FM.gridPanel.isVisible()){
}
if(FM.NasDataView&& FM.NasDataView.isVisible()){
FM.thumbMask.show();
}
if(!FM.isFromSearch){
FM.fileListStore.removeAll();
}
if(FM.gridPanel.isVisible()){
FM.gridPanel.view.emptyText='';
FM.gridPanel.view.refresh();
}
if(FM.NasDataView && FM.NasDataView.isVisible()){
FM.NasDataView.emptyText='';
FM.NasDataView.refresh();
}
FM.fileListStore.baseParams.hidden_file = QNAP.QOS.user.fe_isShowHideFile == 'true' ? 1 : 0;
FM.currentPath = store.baseParams.path;
},
load : function(store, records, opt) {
Ext.getCmp(FM.northPanelId).getComponent('refreshBtn').show();
var path = store.baseParams.path;
var countA = 0, countB = FM.favoriteStore.getCount();
if (/^\/remote:\d+@[0-9a-f]{40}/.test(path)) {
FM.fireEvent('listremotetree', path);
}
Ext.each(records, function(record) {
var fixXSS=QNAP.QOS.fileExplorerTools.tool.fixXSS;
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(record.get('filename'))) {
var filename = record.get('filename').substring(record.get('filename').lastIndexOf('/') + 1);
record.set('thumbFilename', fixXSS(filename));
}else{
record.set('thumbFilename', fixXSS(record.get('filename')));
}
record.commit();
});
var parentPath = path.split('/');
parentPath.pop();
parentPath = parentPath.join('/');
if (parentPath.length > 0 && path != '/home/.Qsync') {
var parentFolder = {
filename : '..',
filesize : 0,
filetype : '',
filepath : parentPath,
mt : '',
privilege : '',
owner : '',
group : '',
isfolder : '',
parentLink : true,
iscompressed : ''
};
var parentRecord = new store.recordType(parentFolder);
store.insert(0, [parentRecord]);
store.data.items[0].qInternational = true;
store.data.items[0].qInternational = '_SFE_LANG_COMMON_RETURN';

}

if (store.reader.jsonData.is_winacl_support == "1"
&& store.reader.jsonData.is_winacl_enable == "1") {
QNAP.QOS.fileExplorerTools.config.enableWinACL = true;
}
FM.lastPath = FM.fileListStore.baseParams.path;
FM.updateStar();
FM.currentGrid = 'fileGrid';
FM.showActionBtn();
/**
* Dian: path 應該在 beforeload 時就改變，等 load 回來時User 可能已經改選其他項目了
*/
QNAP.QOS.fileExplorerTools.config.isOpenMediaLib = store.reader.jsonData.medialib == 1;
if (FM.searchMode) {
FM.RTT = QNAP.QOS.fileExplorerTools.config.supportRTT && DetectFlashVer(9);
}else{
FM.RTT = (store.reader.jsonData.rtt_support == 1) && DetectFlashVer(9);
}
QNAP.QOS.fileExplorerTools.config.supportRTT = store.reader.jsonData.rtt_support == 1;

if(Ext.isEmpty(FM.isOpenMediaLib)){
FM.isOpenMediaLib=QNAP.QOS.fileExplorerTools.config.isOpenMediaLib;
}
var funMenuBtn = FM.fncBtns.getComponent('moreActionBtn').menu;
if (FM.isOpenMediaLib && !FM.isWFM && QNAP.QOS.user.isAdminGroup && FM.currentPath.indexOf('@Recycle') <= 0) {
funMenuBtn.getComponent('transInfoBtn').show();
}else{
funMenuBtn.getComponent('transInfoBtn').hide();
}
if(store.reader.jsonData.page && store.reader.jsonData.page!=0){
var filename= FM.fileListStore.baseParams.filename;
delete FM.fileListStore.baseParams['filename'];
var j;
for(var i=0;i<records.length;i++){
if(records[i].get('filename')==filename){
j=i;
}
}

var task = new Ext.util.DelayedTask(function() {
if(store.data.items.length>0 && store.data.items[0].get('filename')=='..'){
j++;
}
FM.gridPanel.getSelectionModel().selectRow(j);
FM.gridPanel.view.focusRow(j);
if(FM.act=='versioning'){
FM.openVersions();
}
});
task.delay(1000);

}
FM.openAppFileName=null;
if(Ext.getCmp(FM.advSrBtnId)){//因filter功能加的
Ext.getCmp(FM.advSrBtnId).setDisabled(false);
}
if(FM.NasDataView&& FM.NasDataView.isVisible()){
FM.thumbMask.hide();
}
FM.isFromSearch = false;

QNAP.QOS.fileExplorerAction.getVersionList.call(FM);
if(records.length==0){
if(FM.gridPanel.isVisible()){
FM.gridPanel.view.emptyText='<div style="text-align: center;">'+_S._SFE_LANG_COMMON_THIS_FOLDER_IS_EMPTY+'</div>';
FM.gridPanel.view.refresh();
}
if(FM.NasDataView && FM.NasDataView.isVisible()){
FM.NasDataView.emptyText='<div style="text-align: center;">'+_S._SFE_LANG_COMMON_THIS_FOLDER_IS_EMPTY+'</div>';
FM.NasDataView.refresh();
}
}
FM.setCopyMoveCls();
var pBar=FM.centerPanel.bottomToolbar,isAdded=false;
if(store.reader.jsonData.total<store.reader.jsonData.real_total){
Ext.each(pBar.displayItem.displayMsg,function(msg){
if(msg.indexOf('<img ext:qtip="')>=0){
isAdded=true;
}
});
if(!isAdded){
var msg=_S._SFE_LANG_MSG_DISPLAY_MAX_ITEMS
.replace('<qtag/>',store.reader.jsonData.total)
.replace('<qtag2/>',store.reader.jsonData.real_total);
if(pBar.displayItem.displayMsg.length>=7){
pBar.displayItem.displayMsg.pop();
}
pBar.displayItem.displayMsg.push('<img data-htmltip="true" ext:qtip="'+msg+'" '+
'width="16px" height="16px" '+
'src="/cgi-bin/apps/fileManager/images/common/warning.png" ' +
'class="warningIcon-cls"/>');
}
}else{
Ext.each(pBar.displayItem.displayMsg,function(msg){
if(msg.indexOf('<img ext:qtip="')>=0){
isAdded=true;
}
});
if(isAdded){
pBar.displayItem.displayMsg.pop();
}

}
FM.initMask.hide();
FM.isInited=true;
if((FM.gridPanel && FM.gridPanel.isVisible()) || (FM.NasDataView && FM.NasDataView.isVisible())){
FM.setFileThumb(0);
FM.setFileThumb(1);
}
},
loadexception : function(ds, o, response) {
var errorCode = Ext.decode(response.responseText).status;
Ext.getCmp(FM.northPanelId).getComponent('refreshBtn').show();
if (errorCode == QNAP.QOS.fileExplorerTools.status.PERMISSION_DENY) {
if(FM.fileListStore.baseParams.path!='/home/.Qsync'){ //Qsync有自己的錯誤訊息
var msgObj = {
text : _S._SFE_LANG_COMMON_MSG_PERMISSION_DENY,
key : '_SFE_LANG_COMMON_MSG_PERMISSION_DENY'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(
FM, 'error', msgObj, btns);
MsgWin.show();
var path = FM.fileListStore.baseParams.path;
path=path.substring(0, path.lastIndexOf('/'));
FM.openPath(path);
}else{
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,errorCode);
}

} else if (errorCode == QNAP.QOS.fileExplorerTools.status.AUTH_FAIL) {
QNAP.lib.cookie.set('QSYNC_SID', '', 0);
QNAP.QOS.fileExplorerTools.tool.getQsyncSid(FM);
if (FM.fileListStore.baseParams.path !== '/home/.Qsync'){
FM.fileListStore.reload();
}
}else if(FM.fileListStore.baseParams.path=='/home/@Recycle/.Qsync' && errorCode==5){
FM.fileListStore.removeAll();
FM.fncBtns.hide();
FM.shareBtns.hide();
FM.clientfncBtns.hide();
FM.searchComboBox.hide();
FM.searchMenuBtn.hide();
Ext.getCmp(FM.searchSpace).show();
Ext.getCmp(FM.northPanelId).getComponent('switchModeGroup').hide();
Ext.getCmp(FM.northPanelId).getComponent('filterBtn').hide();
Ext.getCmp(FM.northPanelId).getComponent('refreshBtn').hide();
FM.updatePathBarN('/home/@Recycle/.Qsync');
if(FM.gridPanel && FM.gridPanel.isVisible()){
FM.gridPanel.view.emptyText='<div style="text-align: center;">'+_S._SFE_LANG_COMMON_THIS_FOLDER_IS_EMPTY+'</div>';
FM.gridPanel.view.refresh();
}
if(FM.NasDataView && FM.NasDataView.isVisible()){
FM.thumbMask.hide();
FM.NasDataView.emptyText='<div style="text-align: center;">'+_S._SFE_LANG_COMMON_THIS_FOLDER_IS_EMPTY+'</div>';
FM.NasDataView.refresh();
}
}else{
var path = FM.fileListStore.baseParams.path;
if (FM.lastPath !== path){
path = FM.lastPath;
}else{
path = path || (FM.nasRoot.findChild('id', '/Multimedia')||{}).id;
path = path || (FM.nasRoot.childNodes[0]||{}).id;
}
var childNode = FM.nasRoot.findChild('id', path);
if(errorCode==QNAP.QOS.fileExplorerTools.status.FILE_NOT_EXIST){
var folderRoot=FM.currentPath.split('/')[1];
var shareFolder = FM.nasRoot.findChild('id', '/'+folderRoot,true);
if(shareFolder && shareFolder.attributes.volume_lock==1){
FM.gridPanel.view.emptyText='<div style="text-align: center; height:'+
(FM.gridPanel.getHeight()-68) +'px" class="FS-lock-cls">' +
'<img src="/cgi-bin/apps/fileManager/images/common/lock.png?rad='+QNAP.QOS.config.build+'">' +
'</div>';
FM.gridPanel.isLock=1;
if (FM.NasDataView){
FM.NasDataView.isLock=1;
FM.NasDataView.emptyText='<div style="display: table;width: 100%;" class="FS-lock-cls">' +
'<div style="display: table-cell;vertical-align: middle;">' +
'<img style="max-width:150px !important; max-height:150px !important;" src="/cgi-bin/apps/fileManager/images/common/lock.png?rad='+QNAP.QOS.config.build+'">' +
'</div></div>';
}
FM.lockStatusBtns();
}else{
var selNode = FM.treePanel.getSelectionModel().selNode;
if(selNode && selNode.id.indexOf('fav_')==0){
var msgObj = {
text : _S._SFE_LANG_ACTION_UPLOAD_RESPONSE_MSG_5,
key : '_SFE_LANG_ACTION_UPLOAD_RESPONSE_MSG_5'
};
var btns = [{text : _S._SFE_LANG_ACTION_REMOVE_FROM_FAVORITES,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_REMOVE_FROM_FAVORITES',
handler : function() {
FM.removeFavorite(selNode.id.replace('fav_',''));
MsgWin.close();
}
},{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,
'error', msgObj, btns);
MsgWin.show();
}else{
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,errorCode);
}
}
}else{
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,errorCode);
if(childNode){//如果有錯了則會跳回上一次選取的路徑
childNode = childNode|| FM.favRoot.findChild('id', 'fav_'+ path);
childNode.select();
FM.loadPath(path,'',true,true);
}
}
}
if (FM.NasDataView && FM.NasDataView.isVisible()){
FM.thumbMask.hide();
}
}
},
remoteSort : true,
sortInfo : {
field : QNAP.QOS.user.sortField || 'mt',
direction : QNAP.QOS.user.sortA_Z || 'DESC'//'ASC'
}
});

FM.userListStore = new Ext.data.JsonStore({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,
'get_all_list_out'),
baseParams : {
filter : ''
},
paramNames : {
start : 'lower',
limit : 'upper'
},
totalProperty : 'count',
root : 'list',
fields : ['name'],
listeners : {
beforeload : function(store, options) {
var params = options.params;
params.upper = params.lower + params.upper;
return true;
}
}
});
FM.groupListStore = new Ext.data.JsonStore({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,
'get_all_list_out'),
baseParams : {
filter : ''
},
paramNames : {
start : 'lower',

limit : 'upper'
},
totalProperty : 'count',
root : 'list',
fields : ['name'],
listeners : {
beforeload : function(store, options) {
var params = options.params;
params.upper = params.lower + params.upper;
return true;
}
}
});
var defaultData = {
favorites : []
};
FM.favoriteStore = new Ext.data.JsonStore({
data : {
favorites : Ext.decode(QNAP.QOS.user.myFavorite)
},
root : 'favorites',
idProperty : 'path',
fields : ['path', 'name', 'qtip'],
listeners : {
datachanged : function(store) {
store.each(function(record) {
var node = new Ext.tree.TreeNode({
qtip : (record.get('qtip') || record.get('path')),
text : record.get('name'),
cls : 'leafNode-cls',
iconCls : 'folder-cls',
draggable : false,
allowDrop : true,
id : 'fav_' + record.get('path'),
data : {
type : 'Favorite',
path : record.get('path')
}
});
FM.favRoot.appendChild(node);
});
if (store.data.length == 0) {
FM.favRoot.ui.hide();
}
var data = [];
store.each(function(record) {
data.push(record.data);
});
os.saveConfig('myFavorite', Ext.encode(data));
},
load : function(store) {
var data = [];
store.each(function(record) {
data.push(record.data);
});
os.saveConfig('myFavorite', Ext.encode(data));
},
add : function(store, records, index) {
Ext.each(records, function(record) {
var node = new Ext.tree.TreeNode({
qtip: (record.get('qtip') || record.get('path')),
text : record.get('name'),
draggable : false,
allowDrop : true,
iconCls : 'folder-cls',
id : 'fav_'
+ record
.get('path'),
data : {
type : 'NAS'
}
});
FM.favRoot.appendChild(node);
});
var data = [];
store.each(function(record) {
data.push(record.data);
});
os.saveConfig('myFavorite', Ext.encode(data));
},
remove : function(store, records, index) {
Ext.each(records, function(record) {
var childNode = FM.favRoot.findChild(
'id', 'fav_'
+ record.get('path'))
FM.favRoot.removeChild(childNode);
});
var data = [];
store.each(function(record) {
data.push(record.data);
});
os.saveConfig('myFavorite', Ext.encode(data));
}
}
});


FM.adStore = new Ext.data.JsonStore({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,
'get_ad_info'),
root : 'datas',
fields : ['domain', 'netbios']
});

FM.shareStore = new Ext.data.JsonStore({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,
'get_share_list'),
status : 'status',
totalProperty : 'total',
root : 'datas',
fields : ['filename', 'filesize', 'download_link',
'expire_time', 'addressee', 'start_time',
'access_code', 'ssid', 'creator', 'isfolder','smart_link',
'all_available','option','multiple','link_name','ht'],//ht:host type, 11:smart link
remoteSort : true,
sortInfo : {
field : 'natural',
direction : 'ASC'
},
listeners : {
load : function(){
FM.shareStore.notloaded=false;
}
}
});

FM.clientFileStore = new Ext.data.JsonStore({
singleSort : function(fieldName, dir) {
var field = this.fields.get(fieldName);
if (!field) {
return false;
}

var name = field.name, sortInfo = this.sortInfo || null, sortToggle = this.sortToggle
? this.sortToggle[name]
: null;

if (!dir) {
if (sortInfo && sortInfo.field == name) { // toggle sort
dir = (this.sortToggle[name] || 'ASC').toggle('ASC',
'DESC');
} else {
dir = field.sortDir;
}
}

this.sortToggle[name] = dir;
this.sortInfo = {
field : name,
direction : dir
};
this.hasMultiSort = false;
if (this.remoteSort) {
this.load(this.lastOptions)
} else {
this.applySort();
this.fireEvent('datachanged', this);
}
return true;
},
paramNames : {
start : 'START',
limit : 'LIMIT',
sort : 'SORT',
dir : 'DIR'
},
baseParams : {
start : '0'

},
status : 'status',
totalProperty : 'total',
root : 'datas',
fields : ['filename', 'filesize', 'filetype', 'filepath', 'mt',
'privilege', 'owner', 'group', 'isfolder', 'iscompressed',
{
name : 'parentLink',
type : 'boolean'
}],
remoteSort : true,
sortInfo : {
field : 'natural',
direction : 'ASC'
},
loadData : function(o, option) {
var r = this.reader.readRecords(o);
this.loadRecords(r, option, true);
},
load : function(options) {
options = Ext.apply({}, options);
this.storeOptions(options);
if (this.sortInfo && this.remoteSort) {
var pn = this.paramNames;
options.params = Ext.apply({}, options.params);
options.params[pn.sort] = this.sortInfo.field;
options.params[pn.dir] = this.sortInfo.direction;
}
Ext.applyIf(options.params, this.baseParams);
options.params.CALLBACK = 'appletCallback';
options.params.SHOW_HIDDEN_FILE = QNAP.QOS.user.fe_isShowHideFile
? QNAP.QOS.user.fe_isShowHideFile
: 'false';
options.params.LIMIT = QNAP.QOS.user.pageSize.wfm_file_list_page_size;
if (this.fireEvent('beforeload')===false){
return ;
}
var clientFS = FM.callApplet(FM.getId(), 'qUploadApplet',
'loadFileInfo', options.params);
},
listeners : {
beforeload : function() {
if (FM.clientFileStore.baseParams.path){
FM.updatePathBarC(FM.clientFileStore.baseParams.path);
return true;
}
return false;
}
}
});
FM.fileTreeLoader.on('load', initNASRoot, null, {
single : true
});
function initNASRoot(loader, node, response) {
if (node.id != "vol_root") {
return true;
}

if (FM.treePanel.getSelectionModel().getSelectedNode()) {
return;
}
var subNode = node.childNodes[0];
var initTreeRootPath = QNAP.lib.cookie.get('treeRootPath' + QNAP.QOS.user.account);

if(FM.isWFM && FM.isFirstOpenFM==1){//如果是從獨立頁面指定檔案及路徑進來

var params = {};
if (location.href.indexOf('?') > 0) {
urlprms = location.href.split('?')[1];
pArr = urlprms.split('&');
Ext.each(pArr, function(p) {
var ppp = p.split('=');
params[ppp[0]] = ppp[1];
});
initTreeRootPath=decodeURIComponent(params.path);
}
}

if (initTreeRootPath == 'recycleBin' || initTreeRootPath == 'shareNode') {
var node= FM.treeRoot.findChild('id', initTreeRootPath, true);
if (node) {
node.select();
node.fireEvent('click',node);
}
initTreeRootPath = '';
FM.isFirstOpenFM=0;
return
}
if (node.findChild('id', '/Multimedia')) {
subNode = node.findChild('id', '/Multimedia');
}
if(!Ext.isEmpty(FM.activeAppPath)){//active App
FM.openPath(FM.activeAppPath,FM.openAppFileName);
}else if (initTreeRootPath=='qsyncRecycle' || initTreeRootPath.indexOf('/home/@Recycle/.Qsync') >= 0) {
subNode = FM.treeRoot.findChild('id', 'qsyncRoot').findChild('id', 'qsyncRecycle');
FM.currentPath = '/home/@Recycle/.Qsync';
FM.currentHost = 'NAS';
subNode.select();
FM.fileListStore.baseParams.path = '/home/@Recycle/.Qsync';
FM.fileListStore.load({
params: {
start: 0,
limit: QNAP.QOS.user.pageSize.wfm_file_list_page_size || 50
}
});
} else if (initTreeRootPath=='qsyncRoot' || initTreeRootPath.indexOf('/home/.Qsync') >= 0) {
subNode = FM.treeRoot.findChild('id', 'qsyncRoot');
FM.currentPath = '/home/.Qsync';
FM.currentHost = 'NAS';
subNode.select();
FM.fileListStore.baseParams.path = '/home/.Qsync';
FM.fileListStore.load({
params: {
start: 0,
limit: QNAP.QOS.user.pageSize.wfm_file_list_page_size || 50
}
});
} else if (initTreeRootPath != ''){
if(initTreeRootPath.indexOf('{')==0){//from cookie
var obj=Ext.decode(initTreeRootPath);
initTreeRootPath=obj.path;
FM.openPath(initTreeRootPath,null,obj.volId);
}else{
FM.openPath(initTreeRootPath);
}
FM.currentPath = initTreeRootPath;
FM.currentHost = 'NAS';
}
FM.isFirstOpenFM=0;
if (config.path) {
FM.fileListStore.baseParams.path = config.path;
FM.fileListStore.reload();
FM.addMemPath(config.path);
} else if (subNode) {
}
if (!subNode) {
FM.keepMask = false;
FM.unmask();;
}
}
},// initStore End
goInitPath : function(){
var FM = this;
var initTreeRootPath = QNAP.lib.cookie.get('treeRootPath' + QNAP.QOS.user.account);
if(Ext.isEmpty(initTreeRootPath)){
var node = FM.treeRoot.findChild('id', '/Multimedia', true);
if(Ext.isEmpty(node)){
initTreeRootPath=FM.treeRoot.firstChild.firstChild.firstChild.id;
}else{
initTreeRootPath=node.id;
}
}
var subNode;
if (!Ext.isEmpty(FM.activeAppPath)) {// active App
FM.openPath(FM.activeAppPath, FM.openAppFileName);
} else if (initTreeRootPath == 'qsyncRecycle'
|| initTreeRootPath.indexOf('/home/@Recycle/.Qsync') >= 0) {
subNode = FM.treeRoot.findChild('id', 'qsyncRoot').findChild('id',
'qsyncRecycle');
FM.currentPath = '/home/@Recycle/.Qsync';
FM.currentHost = 'NAS';
subNode.select();
FM.fileListStore.baseParams.path = '/home/@Recycle/.Qsync';
FM.fileListStore.load({
params : {
start : 0,
limit : QNAP.QOS.user.pageSize.wfm_file_list_page_size
|| 50
}
});
} else if (initTreeRootPath == 'qsyncRoot'
|| initTreeRootPath.indexOf('/home/.Qsync') >= 0) {
subNode = FM.treeRoot.findChild('id', 'qsyncRoot');
FM.currentPath = '/home/.Qsync';
FM.currentHost = 'NAS';
subNode.select();
FM.fileListStore.baseParams.path = '/home/.Qsync';
FM.fileListStore.load({
params : {
start : 0,
limit : QNAP.QOS.user.pageSize.wfm_file_list_page_size
|| 50
}
});
} else if (initTreeRootPath != '') {
if (initTreeRootPath.indexOf('{') == 0) {// from cookie
var obj = Ext.decode(initTreeRootPath);
initTreeRootPath = obj.path;
FM.openPath(initTreeRootPath, null, obj.volId);
} else {
FM.openPath(initTreeRootPath);
}
FM.currentPath = initTreeRootPath;
FM.currentHost = 'NAS';
}
FM.isFirstOpenFM = 0;
if (!subNode) {
FM.initMask.hide();
}
},//goInitPath
clickTreeNode : function(node) {
if(node.id=='vol_root' || node.id=='favorite_root' || node.folderType == 'volumeNode'){
return;
}
var FM = this;
var path = node.id;
FM.currentPath = node.id;
var type = node.attributes.data.type;

/***********************************************************************
* 如果是sharelist或share_root則回傳true
**********************************************************************/
if (FM.searchMode) {
QNAP.QOS.fileExplorerTools.tool.clearSearch(FM);
}

if (node.parentNode.id == 'favorite_root') {
type = 'Favorite';
}
switch (type) {
case 'NAS' :
FM.fncBtns.show();
FM.shareBtns.hide();
FM.clientfncBtns.hide();
FM.currentHost = 'NAS';
FM.pathPanel.show();
if (FM.eastTab.getComponent('permissionPanel').isVisible()) {
FM.properties(node);
}
break;
case 'Client' :
FM.fncBtns.hide();
FM.shareBtns.hide();
FM.clientfncBtns.show();
if(QNAP.QOS.FileClipBoard.sourceHost=='NAS' && QNAP.QOS.FileClipBoard.fileList.length>0){
FM.clientfncBtns.getComponent('pastBtn').show();
}
FM.clientfncBtns.getComponent('moreActionBtn').hide();
FM.clickClientNode(node);
FM.pathPanel.show();
break;
case 'Favorite' :
FM.currentHost = 'NAS';
FM.clickFavorite(node);
FM.pathPanel.show();
break;
case 'Qsync' :
FM.currentHost = 'NAS';
FM.fncBtns.show();
FM.shareBtns.hide();
FM.clientfncBtns.hide();
FM.pathPanel.show();
break;
case 'recycleBin' :
FM.currentHost = 'NAS';
FM.fncBtns.hide();
FM.shareBtns.hide();
FM.clientfncBtns.hide();
break;
}
},// clickTreeNode End
initClientRoot : function() {
var FM = this;
var clientName = FM.callApplet(FM.getId(), 'qUploadApplet', 'getHostName');
var imgId = Ext.id();
var reloadImg = QNAP.QOS.fileExplorerTools.config.imgPath
+ 'common/refresh.gif';
var refreshImg = '&nbsp;<img src="{0}" id="{1}" class="refresh-img" />';

var clientRoot = new FM.ClientTreeNode({
id : 'clientRoot',
text : (clientName || _S._SFE_LANG_COMMON_COMPUTER),
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_COMPUTER',
iconCls : 'clientRoot-icon-cls',
cls : 'clientRoot-cls fm-treeRoot',
hidden : (QNAP.QOS.user.fe_isShowFileFolder != 'true'),
expanded : true,
draggable : false, // disable root node
allowDrop : false,
data : {
type : 'ClientRoot'
}
});
FM.treeRoot.appendChild(clientRoot);
FM.treeRoot.appendChild(FM.favRoot);
if (FM.config.supportQsync){ FM.treeRoot.appendChild(FM.Qsync);}

FM.createShareRoot();
FM.treeRoot.appendChild(new QNAP.QOS.FM.Remote.ServiceNode({
cls : 'fm-treeRoot',
text: _S._SFE_LANG_REMOTE_CIFS,
hidden: true,
protocol: 'cifs',
qInternational: true,
qInternationalKey: '_SFE_LANG_REMOTE_CIFS'
}, FM));
FM.treeRoot.appendChild(new QNAP.QOS.FM.Remote.ServiceNode({
cls: 'fm-treeRoot',
text: _S._SFE_LANG_REMOTE_FTPFS,
hidden: true,
protocol: 'ftpfs',
qInternational: true,
qInternationalKey: '_SFE_LANG_REMOTE_FTPFS'
}, FM));
FM.treeRoot.appendChild(new QNAP.QOS.FM.Remote.ServiceNode({
cls: 'fm-treeRoot',
text: _S._SFE_LANG_REMOTE_DAVFS,
hidden: true,
protocol: 'davfs',
qInternational: true,
qInternationalKey: '_SFE_LANG_REMOTE_DAVFS'
}, FM));
FM.createRecycleBinNode();

if (!deployJava.versionCheck('1.6+')) {
QNAP.QOS.user.fe_isShowFileFolder = 'false';
}
if (QNAP.QOS.user.fe_isShowFileFolder === 'true'
&& deployJava.versionCheck('1.6+')) {
FM.treeRoot.findChild('id', 'clientRoot').ui.show();
} else {
var rootNode = FM.treeRoot.findChild('id', 'clientRoot');
rootNode.ui.hide();
}
(function initEvent() {
var imgEl = Ext.fly(imgId);
if (Ext.isEmpty(imgEl)) {
return;
}
imgEl.on('click', function() {
FM.loadClientRoot();
});
}).defer(10);
function onRemoteDeviceLost(path) {
if (FM.fileListStore.baseParams.path.substr(0, path.length) == path) {
FM.fileListStore.removeAll();
FM.pathBar.removeAll();
Ext.util.Cookies.clear('treeRootPath' + QNAP.QOS.user.account);
}
}
FM.on('remoteremoved', onRemoteDeviceLost);
FM.on('remoteumounted', onRemoteDeviceLost);
},
appletCallback : function(event, eventInfo) {
var FM = this;
var EVENT_CREATE_FOLDER_SUCCESS = 3;
var EVENT_CREATE_FOLDER_FAILED = -3;
var EVENT_CREATE_FOLDER = 3;
var DELETE_SUCCESS = 4;
var DELETE_FAILED = -4;
var RENAME_SUCCESS = 7;
var RENAME_FAILED = -7;
var UPDATE_FILE_LIST = 1;
var UPDATE_DIR_LIST = 2;
var DROP_UPLOAD_START = 105;
var DROP_UPLOAD_FINISH = 106;
var DROP_UPLOAD_FAILED = 107;
var DROP_UPDATE_RATE = 108;
var DROP_DOWNLOAD_FILE_EXISTS = 205;
var DROP_DOWNLOAD_START = 206;
var DROP_DOWNLOAD_FINISH = 207;
var DROP_DOWNLOAD_FAILED = 208;
var PATH_NOT_EXIST = 209;
var DROP_DOWNLOAD_RATE_UPDATE = 210;
var FILENAME_OVER_MAXIMUM = 211;
var PARENT_FOLDER_NOT_EXIST = 212;
var DUCmName = QNAP.QOS.fileExplorerTools.tool.showDUCmName(eventInfo);
switch (event) {
case EVENT_CREATE_FOLDER_FAILED :
var msgObj = {
text : _S._SFE_LANG_ACTION_MKDIR_MSG_EXIST,
key : '_SFE_LANG_ACTION_MKDIR_MSG_EXIST'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,
'error', msgObj, btns);
MsgWin.show();
break;
case RENAME_FAILED :
var msgObj = {
text : _S._SFE_LANG_ACTION_RENAME_MSG_RENAME_FAIL,
key : '_SFE_LANG_ACTION_RENAME_MSG_RENAME_FAIL'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,
'error', msgObj, btns);
MsgWin.show();
break;
case UPDATE_FILE_LIST :
FM.loadClientFilelist(eventInfo.JSON_DATA, eventInfo.OPTION);
break;
case EVENT_CREATE_FOLDER :
if (FM.clientFileStore.baseParams.path == eventInfo) {
var param = {
PATH : eventInfo
};
FM.clientFileStore.reload();
FM.unmask();
}
break;
case UPDATE_DIR_LIST :
FM.laodClientTreeList(eventInfo.JSON_DATA, eventInfo.TREE_PATH);
break;
case DROP_UPLOAD_START :
var win = FM.getDropUploadWin();
win.currentIndex++;
win.totoCount = eventInfo.TOTAL_COUNT;
win.setInfoValue(String.format('{0} {1} ({2})',
_S._SFE_LANG_ACTION_FANCY_UPLOADING + ': ',
eventInfo.FILE_NAME, QNAP.QOS.fileExplorerTools.tool
.transformFileSize(eventInfo.FILE_SIZE)));
break;
case DROP_UPLOAD_FINISH :
case DROP_UPLOAD_FAILED :

var win = FM.getDropUploadWin();
win.totoCount = eventInfo.TOTAL_COUNT;
if (win.totoCount == win.currentIndex) {
win.updateProgress(1,
_S._SFE_LANG_ACTION_FANCY_UPLOAD_MSG_COMPLETE);
FM.openPath(FM.treeDropPath);

FM.dropUploadWin.fbar.getComponent('uploadCancel').hide();
FM.dropUploadWin.fbar.getComponent('uploadFinish').show();
FM.gridPanel.store.reload();
}
var statusWord = '';
if (event == 106) {
statusWord = _S._SFE_LANG_COMMON_UPLOADED;
var percent = win.currentIndex / win.totoCount;
} else if (event == 107) {
statusWord = '<font color="red">'
+ _S._SFE_LANG_ACTION_FANCY_UPLOAD_MSG_FILEERROR
+ '</font>';
}

var data = {
files : [{
name : DUCmName,// eventInfo.FILE_NAME,
fullName : '',
status : statusWord
}]
};
win.store.loadData(data, true);
break;
case DROP_UPDATE_RATE :
var win = FM.getDropUploadWin();
var percent = (win.currentIndex - 1) / win.totoCount;
var flt = 1 / win.totoCount;
percent = percent
+ (eventInfo.TRANFERED_SIZE / eventInfo.FILE_SIZE)
* flt;
win.updateProgress(percent, parseInt(percent * 100) + ' % '
+ _S._SFE_LANG_COMMON_PROGRESS_COMPLETED
+ '...');
win.setRateValue(_S._SFE_LANG_ADVUPLOAD_TRANS_RATE + ' : '
+ Ext.util.Format.fileSize(eventInfo.TRANFERED_RATE));
win.setFileSizeValue(_S._SFE_LANG_COMMON_FILESIZE + ' : '
+ Ext.util.Format.fileSize(eventInfo.FILE_SIZE));
win.setUploadSizeValue(_S._SFE_LANG_COMMON_UPLOADED + ' : '
+ Ext.util.Format.fileSize(eventInfo.TRANFERED_SIZE));
break;
case DROP_DOWNLOAD_START :
var win = FM.getDropDownloadWin();
win.currentIndex++;
win.totoCount = eventInfo.TOTAL_COUNT;
win.setInfoValue(String.format('{0} {1} ({2})',
_S._SFE_LANG_ACTION_COPY_MSG_COPYING + ': ',
eventInfo.FILE_NAME, QNAP.QOS.fileExplorerTools.tool
.transformFileSize(eventInfo.FILE_SIZE)));
break;
case FILENAME_OVER_MAXIMUM:
case PARENT_FOLDER_NOT_EXIST:
case DROP_DOWNLOAD_FAILED :
case DROP_DOWNLOAD_FINISH :
case DROP_DOWNLOAD_FILE_EXISTS :
var win = FM.getDropDownloadWin();
win.totoCount = eventInfo.TOTAL_COUNT;
if (win.totoCount == win.currentIndex) {
win.updateProgress(1, _S._SFE_LANG_COMMON_DOWNLOADED
+ _S._SFE_LANG_COMMON_PROGRESS_COMPLETED);
}

var statusWord = '';
if (event == DROP_DOWNLOAD_FINISH) {
statusWord = _S._SFE_LANG_COMMON_DOWNLOADED;
} else if (event == DROP_DOWNLOAD_FAILED || event == FILENAME_OVER_MAXIMUM || event==PARENT_FOLDER_NOT_EXIST) {
statusWord = '<font color="red">'
+ _S._SFE_LANG_ACTION_FANCY_DOWNLOAD_MSG_FILEERROR
+ '</font>';
}else if (event == DROP_DOWNLOAD_FILE_EXISTS){
}
var data = {
files : [{
name : DUCmName,// eventInfo.FILE_NAME,
fullName : '',
status : statusWord
}]
};
win.store.loadData(data, true);
break;
case PATH_NOT_EXIST :
var win = FM.getDropDownloadWin();
break;
case DROP_DOWNLOAD_RATE_UPDATE :
var win = FM.getDropDownloadWin();
var percent = (win.currentIndex - 1) / win.totoCount;
var flt = 1 / win.totoCount;
percent = percent
+ (eventInfo.DOWNLOAD_SIZE / eventInfo.FILE_SIZE) * flt;
percent = (percent > 1) ? 1 : percent;
win.updateProgress(percent, parseInt(percent * 100) + ' % '
+ _S._SFE_LANG_COMMON_PROGRESS_COMPLETED
+ '...');

win.setRateValue(_S._SFE_LANG_ADVUPLOAD_TRANS_RATE + ' : '
+ Ext.util.Format.fileSize(eventInfo.RATE));
win.setFileSizeValue(_S._SFE_LANG_COMMON_FILESIZE + ' : '
+ Ext.util.Format.fileSize(eventInfo.FILE_SIZE));
win.setUploadSizeValue(_S._SFE_LANG_ACTION_DOWNLOAD_TITLE
+ ' : '
+ Ext.util.Format.fileSize(eventInfo.DOWNLOAD_SIZE));
break;
case DELETE_SUCCESS :
break;
}
},
initNasFileGrid : function() {
var FM = this;
if (!QNAP.QOS.user.pageSize.wfm_file_list_page_size
|| (QNAP.QOS.user.pageSize.wfm_file_list_page_size != 50
&& QNAP.QOS.user.pageSize.wfm_file_list_page_size != 100
&& QNAP.QOS.user.pageSize.wfm_file_list_page_size != 250
&& QNAP.QOS.user.pageSize.wfm_file_list_page_size != 500))
{
QNAP.QOS.user.pageSize.wfm_file_list_page_size = 50;
}
var sm = new Ext.grid.CheckboxSelectionModel({
width : 50,
singleSelect : false,
onMouseEvent : function(e, t, isMouseUp) {
var row = e.getTarget('.x-grid3-row');
if (e.shiftKey || e.ctrlKey) {
if (isMouseUp) {
return;
}
var view = this.grid.getView();
var rowIndex = row.rowIndex;
if (e.shiftKey && !this.singleSelect && this.last !== false) {
var last = this.last;
this.selectRange(last, rowIndex, e.ctrlKey);
this.last = last; // reset the last
view.focusRow(rowIndex);
} else {
var isSelected = this.isSelected(rowIndex);
if (e.ctrlKey && isSelected) {
this.deselectRow(rowIndex);
} else if (!isSelected || this.getCount() > 1) {
this.selectRow(rowIndex, e.ctrlKey || e.shiftKey);
view.focusRow(rowIndex);
}
}
return;
}

if (e.button === 0
&& /(x-grid3-col-checker|x-grid3-row-checker)/
.test(t.className)) {
if (!isMouseUp) {
e.stopEvent();
}
if (row) {
var index = row.rowIndex;
if (this.lastMouseDown === index) {
if (isMouseUp) {
this.lastMouseDown = false;
}
return;
}
if (this.isSelected(index)) {
this.deselectRow(index);
} else {
this.selectRow(index, true);
this.grid.getView().focusRow(index);
}
this.lastMouseDown = index;
}
} else if (e.button === 0) {
if (isMouseUp) {
this.clearSelections();
this.clearAllSelections();// plugin function
}
if (row) {
var index = row.rowIndex;
if (this.isSelected(index) || isMouseUp) {
this.selectRow(index, true);
} else {
this.selectRow(index, false);
}
this.last = index; // reset the last
this.grid.getView().focusRow(index);
}
}
},

onMouseDown : function(e, t) {
this.onMouseEvent(e, t, false);
},
renderer : function(v, p, record) {
if (record.data.parentLink) {
return '<div class="parentLink">&#160;</div>';
}
return '<div class="x-grid3-row-checker">&#160;</div>';
},
listeners : {
buffer : 50,
beforerowselect : function(cmp, index, keepExisting, record) {
return !record.get('parentLink');
},
rowselect : function(SelectionModel, rowIndex, record) {
FM.showActionBtn();
FM.currentHost = 'NAS';
var grid = SelectionModel.grid;
if (FM.eastTab.getComponent('permissionPanel').isVisible() && record.get('filename') != '..') {
if (!FM.isGettingACL) {
FM.properties();
}
}

var store = grid.store;
var selections = grid.getSelectionModel().getSelections();
if(selections.length==1){
QNAP.QOS.fileExplorerAction.getVersionList.call(FM);
}
QNAP.QOS.fileExplorerTools.tool.updateActionBtn(selections, FM);
FM.ctrVerPanelBtn();
},
rowdeselect : function(SelectionModel) {
FM.showActionBtn();
var selections = SelectionModel.getSelections();
if (FM.eastTab.getComponent('permissionPanel').isVisible()) {
FM.properties();
}
if (FM.eastTab.getComponent('propertyPanel').isVisible()) {
if (SelectionModel.getSelections().length == 0) {
FM.setPropertyPanelInfo(null, FM.treeNodeId);
} else {

}
}
FM.ctrVerPanelBtn();
}
}
});

sm.on('selectionchange', function(selectionModel) {
var selections = selectionModel.getSelections();
var propertyPanelExist=FM.propertyPanel?true:false;
if (!propertyPanelExist){
return ;
}

var fImg = FM.propertyPanel.getComponent('fImg');

if (selections.length == 1) {
var record = selections[0];
var name_path = QNAP.QOS.fileExplorerTools.tool.getFileNamPath(record.get('filename'));
var filename = name_path[0];
var path = record.get('filepath');
var mediaType = QNAP.QOS.fileExplorerTools.tool.getMultiMediaType(filename);
if (mediaType != 'notMultiMedia' && record.get('thumb_folder')!==0) {
var imgurl = 'utilRequest.cgi?sid=' + QNAP.QOS.user.sid + '&func=get_thumb&path=' + encodeURIComponent(path) + '&name=' + encodeURIComponent(filename) + '&size=400&radno=' + record.get('filesize') + record.get('mt');
if(path.indexOf(FM.sysSetting.ubuntu_home_path)==0){
imgurl=imgurl+'&src_flag=ubuntu';
}
var imgTag2 = '<img src="/cgi-bin/filemanager/' + imgurl + '" style="width: auto; height:auto;max-width: 200px;max-height: 200px;margin:15px;margin-left:0">';
fImg.show();
fImg.setValue(imgTag2);
} else {
fImg.hide();
}
} else {
fImg.hide();
}

}, null, {
buffer: 100
});


FM.fileListStore.on('load', function() {
sm.lastMouseDown = false;
});
var nameColumnId = Ext.id();
FM.fileGridColumnModel = new Ext.grid.ColumnModel([sm, {
dataIndex : 'icon',
sortable : false,
width : 30,
align : 'center',
renderer : {
fn : QNAP.QOS.fileExplorerTools.tool.showIcon2,
scope : FM
}
}, {
id : nameColumnId,
header : _S._SFE_LANG_COMMON_FILENAME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILENAME',
dataIndex : 'natural',// 將'filename'改成'natural'因為配合自然排序，排序後要顯示箭頭
sortable : true,
renderer : {
fn : QNAP.QOS.fileExplorerTools.tool.showCmName2,
scope : FM
}
}, {
header : _S._SFE_LANG_COMMON_MODIFIED_TIME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_MODIFIED_TIME',
dataIndex : 'mt',
width : 205,
sortable : true,
resizable :false,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmMt
}, {
header : _S._SFE_LANG_COMMON_FILETYPE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILETYPE',
dataIndex : 'filetype',
width : 116,
sortable : true,
resizable :false,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmFileType
}, {
header : _S._SFE_LANG_COMMON_FILESIZE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILESIZE',
dataIndex : 'filesize',
width : 105,
align : 'right',
sortable : true,
resizable :false,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmFileSize
}, {
header : _S._SFE_LANG_COMMON_PERMISSION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PERMISSION',
dataIndex : 'privilege',
width : 120,
hidden : true,
sortable : true,
resizable :false,
renderer : QNAP.QOS.fileExplorerTools.tool.showPermission
}, {
header : _S._SFE_LANG_COMMON_OWNER,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OWNER',
dataIndex : 'owner',
width : 110,
hidden : true,
sortable : true

}, {
header : _S._SFE_LANG_COMMON_GROUP,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_GROUP',
dataIndex : 'group',
width : 110,
hidden : true,
sortable : true
},{
dataIndex : 'thumbIcon',
sortable : false,
width : 30,
align : 'center',
hidden : true,
renderer : {
fn : QNAP.QOS.fileExplorerTools.tool.thumbIcon,
scope : FM
}
}]);

var oldSelectionIDs = '';// 多選之後點一筆變單選功能使用
FM.gridPanel = new Ext.grid.GridPanel({
minColumnWidth : 30,
enableColumnMove : false,
cm : FM.fileGridColumnModel,
sm : sm,
store : FM.fileListStore,
itemId : 'file-panel',
width : 'auto',
stripeRows : true,
autoExpandColumn : nameColumnId,
autoExpandColumnMinWidth : 196,
ddGroup : 'fileManagerListDD',
enableHdMenu : false,
parent : FM,
qInternational : true,
qInternationalFn : function(cmp) {
cmp.loadMask.msg=_S._SFE_LANG_COMMON_LOADING_MSG;
},
loadMask : {
msg : ('_SFE_LANG_COMMON_LOADING_MSG')
},
data : {
dirPath : '/',
type : 'NAS'
},
viewConfig : {
columnsText : _S._SFE_LANG_COMMON_DISPLAY_COLUMN,
sortAscText : 'A->Z',
sortDescText : 'Z->A'
},
keys : [{
key : Ext.EventObject.F5,
stopEvent : true,
fn : function(e) {
FM.gridPanel.getStore().reload();
}
}, {
key : Ext.EventObject.F2,
fn : function() {
QNAP.QOS.fileExplorerAction.rename(FM);
}
}, {
key : Ext.EventObject.DELETE,
fn : function() {
QNAP.QOS.fileExplorerAction.del(FM);
}
}, {
ctrl : true,
key : Ext.EventObject.A,
fn : function() {
FM.gridPanel.getSelectionModel().selectAll();

}
}, {
ctrl : true,
key : Ext.EventObject.C,
fn : function() {
FM.fncBtns.getComponent('copyBtn').handler();
}
}, {
ctrl : true,
key : 'v',
fn : function() {
if (QNAP.QOS.FileClipBoard.sourcePath == FM.currentPath) {
QNAP.QOS.fileExplorerAction.pastAction(FM, 2);
} else {
FM.pasteFile();
}
},
scope : FM
}, {
ctrl : true,
key : Ext.EventObject.X,
fn : function() {
var selections = FM.gridPanel.getSelectionModel()
.getSelections(), qDatas = [];

for (var i = 0; i < selections.length; i++) {
var data = selections[i];
qDatas.push({
displayName : data.get('filename'),
fullName : QNAP.QOS.fileExplorerTools.tool.getFullName(FM,data.get('filename'))
});
}
QNAP.QOS.fileExplorerAction.copyAction(FM,
FM.currentPath, qDatas, 'move',
FM.currentHost);
}
}],
plugins : new FM.remeberSelectionsPlugin(),
listeners : {
containerclick : function(grid) {
grid.getView().focusRow(0);
},
rowmouseup : function(grid, row, e) {
var target = e.getTarget(), sm = grid.getSelectionModel();
sm.onMouseEvent(e, target, true);
},
rowclick : {
fn : FM.NasFileGridOnRowClick,
scope : FM
},
rowdblclick : {
fn : FM.NasFileGridOnRowDblClick,
scope : FM
},
rowcontextmenu : function(grid, index, e) {
e.stopEvent();
var sm = grid.getSelectionModel();
if (!sm.isSelected(index)) {
sm.selectRow(index);
}
var selections = sm.getSelections(), contextMenu = FM.gridContextMenu;
if(selections.length==1 && selections[0].get('filename')=='..'){
sm.deselectRow(0);
return;
}
FM.showNasGridContextMenu(e);
},
containercontextmenu : function(grid, event) {
event.stopEvent();
var selections = sm.getSelections();
FM.showNasGridContextMenu(event);
},
afterrender : function(grid) {
grid.getView().dragZone = new Ext.grid.GridDragZone(grid, {
ddGroup : grid.ddGroup,
proxy : new Ext.dd.StatusProxy({
reset : function(clearGhost) {
this.el.dom.className = "x-dd-drag-proxy grid-dd "
+ this.dropNotAllowed;
this.dropStatus = this.dropNotAllowed;
if (clearGhost) {
this.ghost.update("");
}
}
}),
onDrag : function(e) {
if (this.proxy.el.shadow.el) {
this.proxy.el.shadow.el.addClass('drag-shadow');
}
},
beforeDragDrop : function() {
if (this.proxy.el.shadow.el) {
this.proxy.el.shadow.el
.removeClass('drag-shadow');
}
return true;
},
onInitDrag : function(e) {
var data = this.dragData;
this.ddel.innerHTML = this.grid.getDragDropText();
this.proxy.update(this.ddel);
this.proxy.el.addClass('grid-dd');
},
getQdata : function(selections) {
var qDatas = [];
for (var i = 0; i < selections.length; i++) {
var data = selections[i];
var path = data.get('filepath') + '/'
+ data.get('filename');
qDatas.push({
from : grid.store.baseParams.path,
newWin : false,
appId : 'fileExplorer',
size : data.get('filesize'),
iconName : 'images/icon/fm_main_icon.png',
displayName : data.get('filename'),
fullName : path,
type : data.get('isfolder') == 1
? 'folder'
: 'file',
config : {
path : path
}
});
}
return qDatas;
},
onBeforeDrag : function(data, e) {
if (data.selections==0){
return false;
}
var qDatas = this.getQdata(data.selections);
data.qDatas = qDatas;
var haveFile = false;// 判斷檔案不能拖入我的最愛使用
for (var i = 0; i < data.selections.length; i++) {
var record = data.selections[i];
if (record.get('isfolder') != 1) {
haveFile = true;
}
}
data.haveFile = haveFile;
data.from = grid.store.baseParams.path;
data.type = "NAS";
return true;
}
});

var dragZone = grid.getView().dragZone;
dragZone.addToGroup('fileManagerTreeDD');
dragZone.addToGroup('shortcutsView-dd');

grid.getView().dragZone.beforeDragEnter = function(target,
e, id) {
this.cachedTarget = null;
return true;
};
grid.getView().dragZone.b4DragOver = function() {
this.cachedTarget = null;
}

var firstGridDropTargetEl = grid.getView().el;
FM.firstGridDropTarget = new Ext.dd.DropZone(
firstGridDropTargetEl, {
dropNotAllowed : 'q-dd-drop-nodrop',
dropAllowed : 'q-dd-drop-drop',
dropAppend : 'q-dd-drop-drop',
ddGroup : 'feListDD',
getTargetFromEvent : function(e) {
var view = grid.getView();
var rowEl = e.getTarget(view.rowSelector);
var index = view.findRowIndex(rowEl);
return grid.getStore().getAt(index);
},
onNodeOver : function(nodeData, ddSource, e, data) {
var formGrid = data.grid;
var toGrid = grid;
if(data.node){//from tree
var compareFrom=data.node.id;
var compareTo=FM.currentPath;
if(nodeData.data.isfolder==1){
compareTo=compareTo+'/'+nodeData.data.filename;
}
if(compareFrom.split('/')[1]=='home'){
compareFrom=compareFrom.replace('/home','/homes/'+QNAP.QOS.user.account);
}
if(compareTo.split('/')[1]=='home'){
compareTo=compareTo.replace('/home','/homes/'+QNAP.QOS.user.account);
}
if(compareFrom==compareTo){
return FM.firstGridDropTarget.dropNotAllowed;
}
if(nodeData.data.isfolder==0){
var compareFrom2=compareFrom.split('/');
compareFrom2.pop();
compareFrom2=compareFrom2.join('/');
if(compareFrom2==compareTo){
return FM.firstGridDropTarget.dropNotAllowed;
}
}
}
var fromDV = false;
if (FM.NasDataView
&& FM.NasDataView.isVisible()) {
nodeData = FM.NasDataView
.getRecord(nodeData);
formGrid = FM.gridPanel;
fromDV = true;
}

if (formGrid || fromDV) {// if data is
if (nodeData
&& nodeData.data.isfolder == 1) {
var toPath = toGrid.store.baseParams.path
+ '/'
+ nodeData.data.filename;
if (data.qDatas[0].fullName == toPath) {
return FM.firstGridDropTarget.dropNotAllowed;
} else {
return FM.firstGridDropTarget.dropAppend;
}
} else if (formGrid.store.baseParams.path != toGrid.store.baseParams.path) {
return FM.firstGridDropTarget.dropAppend;
} else {
return FM.firstGridDropTarget.dropNotAllowed;
}
} else {// data from tree
var folders = data.qDatas[0].fullName
.split('/');
if (folders.length <= 2
&& data.type != 'Client') {// not
return FM.firstGridDropTarget.dropNotAllowed;
}

if (nodeData
&& nodeData.data.isfolder == 1) {
var toPath = toGrid.store.baseParams.path
+ '/'
+ nodeData.data.filename;
if (data.qDatas[0].fullName == toPath) {
return FM.firstGridDropTarget.dropNotAllowed;
} else {
return FM.firstGridDropTarget.dropAppend;
}
} else if (data.qDatas[0].from != toGrid.store.baseParams.path) {
return FM.firstGridDropTarget.dropAppend;
} else {
return FM.firstGridDropTarget.dropNotAllowed;
}
}
},
onNodeDrop : function(nodeData, ddSource, e,
data) {
var formGrid;
var isShowDropMenu = true;
var toGrid = grid;
var toPath = toGrid.store.baseParams.path;
if(data.node){//from tree
var compareFrom=data.node.id;
var compareTo=FM.currentPath;
if(nodeData.data.isfolder==1){
compareTo=compareTo+'/'+nodeData.data.filename;
}
if(compareFrom.split('/')[1]=='home'){
compareFrom=compareFrom.replace('/home','/homes/'+QNAP.QOS.user.account);
}
if(compareTo.split('/')[1]=='home'){
compareTo=compareTo.replace('/home','/homes/'+QNAP.QOS.user.account);
}
if(compareFrom==compareTo){
return ;
}
if(nodeData.data.isfolder==0){
var compareFrom2=compareFrom.split('/');
compareFrom2.pop();
compareFrom2=compareFrom2.join('/');
if(compareFrom2==compareTo){
return ;
}
}
}
if (FM.NasDataView
&& FM.NasDataView.isVisible()) {
nodeData = FM.NasDataView
.getRecord(nodeData);
}
if (!data.grid) {
formGrid = data;
FM.menuDropToTree.data.from = data.qDatas[0].from;
} else {
formGrid = data.grid;
FM.menuDropToTree.data.from = data.from;
}

var dropTarget = FM.gridPanel;
if (nodeData.data.isfolder == 1) {
toPath = toGrid.store.baseParams.path
+ '/' + nodeData.data.filename;

dropTarget = {
dirPath : toGrid.store.baseParams.path
+ '/'
+ nodeData.data.filename,
data : {
dirPath : toGrid.store.baseParams.path
+ '/'
+ nodeData.data.filename
}
};
FM.dropEvent = {
source : data,
target : dropTarget
};

FM.ddInfo = {
source : data,
target : dropTarget
};

e.cancel = true;
if (!data.grid) {

var folders = data.qDatas[0].fullName
.split('/');
if (folders.length <= 2
&& data.type != 'Client') {
return;
}
if (formGrid.qDatas[0].fullName == toPath) {
isShowDropMenu = false;
}
} else {

if (data.qDatas[0].fullName == toPath) {
isShowDropMenu = false;
}

if (formGrid.store.baseParams.path == dropTarget.data.dirPath) {
isShowDropMenu = false;
}

if (formGrid.appId == FM.id) {
if (dropTarget.dirPath == FM.dirPath
|| QNAP.QOS.fileExplorerTools.tool
.checkIfIncludeSelfFolder(
FM,
dropTarget.data.dirPath)) {
isShowDropMenu = false;
}
} else {
if (formGrid.store.baseParams.path == dropTarget.data.dirPath) {
isShowDropMenu = false;
}
}
}

var from = data.type.charAt(0);
FM.menuDropToTree.data.type = from
+ '2N';

FM.menuDropToTree.data.to = toPath;
FM.menuDropToTree.data.items = data.qDatas;
if (isShowDropMenu)
FM.menuDropToTree.showAt(e.getXY());
data.menuShow = true;
return true;
} else {
var folders = data.qDatas[0].fullName
.split('/');
if (data.type != "Client"
&& folders.length <= 2) {// not
return;
}
var formGrid = data.grid;
if (formGrid) {
FM.menuDropToTree.data.from = data.from;
if (formGrid.id == toGrid.id) {
return false;
}
if (formGrid.store.baseParams.path == toGrid.store.baseParams.path) {
return false;
}
var formPath = formGrid.store.baseParams.path;

FM.ddInfo = {
source : data,
target : grid
};
if (formGrid.appId == FM.id) {
if (QNAP.QOS.fileExplorerTools.tool
.checkIfIncludeSelfFolder(
FM, toGrid.id)) {
QNAP.QOS.fileExplorer.msg.warning
.call(
FM,
_S._SFE_LANG_COMMON_MSG_THE_SAME_FOLDER);
return;
}
} else {
if (formPath == toPath) {
QNAP.QOS.fileExplorer.msg.warning
.call(
FM,
_S._SFE_LANG_COMMON_MSG_THE_SAME_FOLDER);
return;
}
}
var from = data.type.charAt(0);
FM.menuDropToTree.data.type = from
+ '2N';
FM.menuDropToTree.data.items = data.qDatas;
FM.menuDropToTree.data.to = toPath;
FM.menuDropToTree.showAt(e.getXY());
data.menuShow = true;
return true;
} else {
if (data.qDatas[0].from != toGrid.store.baseParams.path) {
var from = data.type.charAt(0);
FM.menuDropToTree.data.type = from
+ '2N';
FM.menuDropToTree.data.items = data.qDatas;
FM.menuDropToTree.data.to = toPath;
FM.menuDropToTree.showAt(e
.getXY());
data.menuShow = true;
return true;
} else {
var msgObj = {
text : _S._SFE_LANG_COMMON_MSG_THE_SAME_FOLDER,
key : '_SFE_LANG_COMMON_MSG_THE_SAME_FOLDER'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,
'warning', msgObj, btns);
MsgWin.show();
return;
}
}
}
},
onContainerOver : function(ddSource, e, data) {
var formGrid = data.grid;
var toGrid = grid, toPath = toGrid.store.baseParams.path;
if ((data.qDatas[0].from==toPath) || !FM.firstGridDropTarget
.hasWritePrmission()) {
return;
}
if(data.node){//from tree
var compareFrom=data.node.id;
var compareTo=FM.currentPath;
if(compareFrom.split('/')[1]=='home'){
compareFrom=compareFrom.replace('/home','/homes/'+QNAP.QOS.user.account);
}
if(compareTo.split('/')[1]=='home'){
compareTo=compareTo.replace('/home','/homes/'+QNAP.QOS.user.account);
}
if(compareFrom==compareTo){
return FM.firstGridDropTarget.dropNotAllowed;
}
var compareFrom2=compareFrom.split('/');
compareFrom2.pop();
compareFrom2=compareFrom2.join('/');
if(compareFrom2==compareTo){
return FM.firstGridDropTarget.dropNotAllowed;
}
}

if (!formGrid) {
var folders = data.qDatas[0].fullName
.split('/');
if (folders.length <= 2
&& data.type != 'Client') {
return FM.firstGridDropTarget.dropNotAllowed;
} else
return FM.firstGridDropTarget.dropAllowed;
} else {

if (formGrid.id == toGrid.id) {
return FM.firstGridDropTarget.dropNotAllowed;
}

if (formGrid.store.baseParams.path == toPath) {
return FM.firstGridDropTarget.dropNotAllowed;
}
return FM.firstGridDropTarget.dropAllowed;
}
},
onContainerDrop : function(ddSource, e, data) {
var toGrid = grid;
var toPath = toGrid.store.baseParams.path;
var formGrid;
if ((data.qDatas[0].from==toPath) || !FM.firstGridDropTarget
.hasWritePrmission()) {
return;
}
if(data.node){//from tree
var compareFrom=data.node.id;
var compareTo=FM.currentPath;
if(compareFrom.split('/')[1]=='home'){
compareFrom=compareFrom.replace('/home','/homes/'+QNAP.QOS.user.account);
}
if(compareTo.split('/')[1]=='home'){
compareTo=compareTo.replace('/home','/homes/'+QNAP.QOS.user.account);
}
if(compareFrom==compareTo){
return ;
}
var compareFrom2=compareFrom.split('/');
compareFrom2.pop();
compareFrom2=compareFrom2.join('/');
if(compareFrom2==compareTo){
return ;
}
}
if (!data.grid) {
var folders = data.qDatas[0].fullName
.split('/');

if (folders.length <= 2
&& data.type != 'Client') {
return;
} else {
formGrid = data;
FM.menuDropToTree.data.from = data.qDatas[0].from;
}

} else {
formGrid = data.grid;
FM.menuDropToTree.data.from = data.from;
var formPath = formGrid.store.baseParams.path;
if (formGrid.id == toGrid.id) {
return false;
}
if (formPath == toPath) {
return false;
}

FM.ddInfo = {
source : data,
target : grid
};
if (formGrid.appId == FM.id) {
if (QNAP.QOS.fileExplorerTools.tool
.checkIfIncludeSelfFolder(
FM, toGrid.id)) {
return;
}
} else {
if (formPath == toPath) {
return;
}
}
}
var from = data.type.charAt(0);
FM.menuDropToTree.data.type = from + '2N';
FM.menuDropToTree.data.items = data.qDatas;
FM.menuDropToTree.data.to = toPath;
FM.menuDropToTree.showAt(e.getXY());
data.menuShow = true;
FM.checkToPath = FM.menuDropToTree.data.to;
return true;
},
hasWritePrmission : function() {
var toPath = grid.store.baseParams.path;
var RW = QNAP.QOS.fileExplorerTools.tool
.checkRW(FM, toPath);
if (RW == 'w') {
return true;
}
return false;
}
});
FM.firstGridDropTarget.addToGroup('fileManagerListDD');
if (Ext.isIE10 || !Ext.isIE) {
document.getElementById(FM.gridPanel.id)
.addEventListener('dragover', function(e) {
e.preventDefault();
e.dataTransfer.dropEffect = 'copy';
}, false);
}

Ext.get(FM.gridPanel.id).dom.ondrop = function(event) {// html5_upload
event.preventDefault();
event.dataTransfer.dropEffect = 'copy';
var inputFiles = event.dataTransfer.files;
var inputItems = event.dataTransfer.items;
var files = [];
if(inputFiles.length==0){
return;
}


os.openApp('FileUploadMgr', {
sid : FM.QsyncSid,
path : FM.fileListStore.baseParams.path,
appendEvent : 'html5',
files : inputItems || inputFiles,
e : event,
startUpload : true,
tabNum : 1,
autoShow:false
});
}
}
}
});
},// initNasFileGrid End
initNasDataView : function() {
var FM = this;
if (!FM.NasDataView) {
var tpl = new Ext.XTemplate(
'<tpl for=".">',
'<div class="thumb-wrap">',
'<div class="thumb-ct"><div class="thumb">{thumbIcon}</div></div>',
'<span class="x-editable">{thumbFilename}</span></div>',
'</tpl>', '<div class="x-clear"></div>');
FM.NasDataView = new Ext.DataView({
itemId : 'NasDataView-id',
cls : 'NasDataView-cls',
store : FM.fileListStore,
tpl : tpl,
emptyText:'<a href="#" class="x-grid3-focus" tabindex="-1" style="left: 0px; top: 0px;"></a>',
multiSelect : true,
autoScroll : true,
overClass : 'x-view-over',
itemSelector : 'div.thumb-wrap',
style:'padding: 11px 0 0 31px;border-top: 1px solid;border-top-color: #719CAD;color: gray;text-align: center;',
plugins : [new Ext.DataView.DragSelector()],
height : FM.centerPanel.getHeight(),
refreshFn: function (){

this.focusEl = FM.pathBar.el.createChild({
tag: 'a',
href: '#',
cls: 'x-grid3-focus',
tabindex: '-1',
style: 'left: 0px; top: 0px;'
});
this.focusEl.swallowEvent('click', true);
this.focusEl.focus();
var focusEl=this.focusEl;
},
listeners : {
show : function(DataView) {
var selections=FM.gridPanel.getSelectionModel().getSelections();
FM.NasDataView.select(selections);
if(DataView.focusEl){
DataView.focusEl.focus();
}
},
selectionchange : function(DataView, selections) {
FM.showActionBtn();
FM.currentHost = 'NAS';
var selIndexArr = [];
Ext.each(selections, function(item) {
var icon;
if(item){
icon=item.childNodes[0].childNodes[0].childNodes[0].src;
}
if(icon){
icon=icon.split('/').pop();
}
if(icon && icon=='back.png'){
Ext.get(item).removeClass('x-view-selected');
}else{
if(item)
selIndexArr.push(item.viewIndex);
}
});
if(FM.NasDataView.isVisible()){
FM.gridPanel.getSelectionModel().selectRows(selIndexArr);
}
},
dblclick : function(DataView, index, node, e) {
FM.NasFileGridOnRowDblClick(FM.gridPanel, index, e);
},
click : function(DataView, index, node, e) {
FM.NasFileGridOnRowClick(FM.gridPanel, index, e);
DataView.dragging = false;
},
containercontextmenu : function(dv, event) {
event.stopEvent();
var selections = FM.gridPanel.getSelectionModel().getSelections();
FM.showNasGridContextMenu(event);
},
contextmenu : function(dv, index, node, event) {
event.stopEvent();
dv.select(node,true);
var selections = FM.gridPanel.getSelectionModel().getSelections();
FM.showNasGridContextMenu(event);
},
afterrender : function(dv) {
dv.el.on('mousedown',function (){
dv.focusEl.focus();
},dv);
dv.on('beforeclick', function(dv, index, node, e) {
if (dv.dragZone.dragging) {
return false;
}
});
dv.dragZone = new Ext.dd.DragZone(dv.getEl(), {
dropAllowed : 'q-dd-drop-drop',
dropNotAllowed : 'q-dd-drop-nodrop',
ddGroup : 'fileManagerTreeDD',
proxy : new Ext.dd.StatusProxy({
reset : function(clearGhost) {
this.el.dom.className = "x-dd-drag-proxy grid-dd "
+ this.dropNotAllowed;
this.dropStatus = this.dropNotAllowed;
if (clearGhost) {
this.ghost.update("");
}
}
}),
getDragData : function(e) {
var sourceEl = e.getTarget(dv.itemSelector, 10);
var qDatas = [];
var selections;
if (sourceEl && dv.getSelectionCount() == 0) {
selections = [dv.getRecord(sourceEl)];
} else {
selections = FM.gridPanel
.getSelectionModel()
.getSelections();
}

var haveFile = false;// 判斷檔案不能拖入我的最愛使用
for (var i = 0; i < selections.length; i++) {
var data = selections[i];
var path = data.get('filepath') + '/'
+ data.get('filename');
if (data.get('isfolder') == 0) {
haveFile = true;
}
qDatas.push({
from : FM.gridPanel.store.baseParams.path,
newWin : false,
appId : 'fileExplorer',
size : data.get('filesize'),
iconName : 'images/icon/fm_main_icon.png',
displayName : data.get('filename'),
fullName : path,
type : data.get('isfolder') == 1
? 'folder'
: 'file',
config : {
path : path
}
});
}
if (sourceEl) {
var cloneNode = sourceEl.cloneNode(true);
return dv.dragData = {
haveFile : haveFile,
type : 'NAS',
from : FM.gridPanel.store.baseParams.path,
ddel : cloneNode,
sourceEl : sourceEl,
qDatas : qDatas
}
}
},
onDrag : function(e) {
if (this.proxy.el.shadow.el) {
this.proxy.el.shadow.el
.addClass('drag-shadow');
}
},
onBeforeDrag : function(data, e) {
e.stopEvent();
dv.dragging = true;
return true;
},
onStartDrag : function(x, y) {
if (dv.getSelectionCount() == 0) {
var sourceEl = dv.dragData.sourceEl;
dv.select(sourceEl);
}
},
endDrag : function(e) {
this.dragging = true;// this=dragZone
var fn = function() {
this.dragging = false;
};
fn.defer(1, this);
dv.dragging = false;
return true;
}
});
dv.dropZone = new Ext.dd.DropZone(dv.getEl(), {
insertB4Cls : '',
dropAllowed : 'q-dd-drop-drop',
dropNotAllowed : 'q-dd-drop-nodrop',
ddGroup : 'fileManagerTreeDD',
getTargetFromEvent : function(e, f, g) {
var t = e.getTarget(dv.itemSelector);
return t ? t : null;
},
onContainerOver : FM.firstGridDropTarget.onContainerOver,
onContainerDrop : FM.firstGridDropTarget.onContainerDrop,
onNodeDrop : FM.firstGridDropTarget.onNodeDrop,
onNodeOver : FM.firstGridDropTarget.onNodeOver
});
Ext.get(FM.NasDataView.id).dom.ondragover=function(event){
event.preventDefault();
event.dataTransfer.dropEffect = 'copy';
}
document.getElementById(FM.NasDataView.id).ondrop =function(event){// html5_upload
event.preventDefault();
event.dataTransfer.dropEffect = 'copy';
var inputFiles = event.dataTransfer.files;
var inputItems = event.dataTransfer.items;
if (inputFiles.length == 0) {
return;
}
os.openApp('FileUploadMgr', {
sid : FM.QsyncSid,
path : FM.fileListStore.baseParams.path,
appendEvent : 'html5',
files : inputItems || inputFiles,
e : event,
startUpload : true,
tabNum : 1
});
return;

};
var Kmap = new Ext.KeyMap(FM.pathBar.getEl(), [{
key : Ext.EventObject.F5,
stopEvent : true,
fn : function(e) {
FM.gridPanel.getStore().reload();
}
}, {
key : Ext.EventObject.F2,
fn : function() {
QNAP.QOS.fileExplorerAction.rename(FM);
}
}, {
key : Ext.EventObject.DELETE,
fn : function() {
QNAP.QOS.fileExplorerAction.del(FM);
}
}, {
ctrl : true,
key : Ext.EventObject.A,
fn : function() {
FM.NasDataView.selectRange(0,FM.fileListStore.getCount()-1);
}
}, {
ctrl : true,
key : Ext.EventObject.C,
fn : function() {
FM.fncBtns.getComponent('copyBtn').handler();
}
}, {
ctrl : true,
key : 'v',
fn : function() {
if (QNAP.QOS.FileClipBoard.sourcePath == FM.currentPath) {
QNAP.QOS.fileExplorerAction.pastAction(FM, 2);
} else {
FM.pasteFile();
}
},
scope : FM
}, {
ctrl : true,
key : Ext.EventObject.X,
fn : function() {
var selections = FM.gridPanel.getSelectionModel()
.getSelections(), qDatas = [];

for (var i = 0; i < selections.length; i++) {
var data = selections[i];
qDatas.push({
displayName : data.get('filename'),
fullName : QNAP.QOS.fileExplorerTools.tool.getFullName(FM,data.get('filename'))
});
}
QNAP.QOS.fileExplorerAction.copyAction(FM,
FM.currentPath, qDatas, 'move',
FM.currentHost);
}
}]);
dv.getEl().dom.tabIndex=0;
}
}// listeners end
});
FM.thumbMask = new Ext.LoadMask(
FM.centerPanel.id, {msg : ('_SFE_LANG_COMMON_LOADING_MSG')}
);
FM.centerPanel.items.add(FM.NasDataView);
}
},
NasFileGridOnRowClick : function(grid, index, e) {
var FM = this;
var record = grid.store.getAt(index);
var textEl = e.getTarget('span.fileNameText-cls');
var listEl = e.getTarget('img.list-play-icon');
var extDocEl = e.getTarget('img.list-extDoc-icon');
if (textEl) {
FM.isTextClick = true;
}
if (listEl) {
FM.isVideoMenuClick = true;
}else if(extDocEl){
FM.openWidthExtension([record]);
}
if (FM.isTextClick) {//into here by click the text
if (record.get('isfolder') == 1) {
if (/^\/remote:\d+[0-9a-f]{40}/.test(record.data.filepath)) {
FM.gotoPath(record.data.filepath + '/' + record.data.filename);
} else {
FM.open(false, record);
}
}
FM.isTextClick = false;
}
if (!FM.vFuncMenu) {
FM.initVFuncMenu();
}
if (FM.isVideoMenuClick) {// 如果是點選影片play圖片進來的
FM.playVideoFile = record;
if (record.get('mp4_240') == 1) {
FM.vFuncMenu.getComponent('240p').show();
} else {
FM.vFuncMenu.getComponent('240p').hide();
}
if (record.get('mp4_360') == 1) {
FM.vFuncMenu.getComponent('360p').show();
} else {
FM.vFuncMenu.getComponent('360p').hide();
}
if (record.get('mp4_480') == 1) {
FM.vFuncMenu.getComponent('480p').show();
} else {
FM.vFuncMenu.getComponent('480p').hide();
}
if (record.get('mp4_720') == 1) {
FM.vFuncMenu.getComponent('720p').show();
} else {
FM.vFuncMenu.getComponent('720p').hide();
}
if (record.get('mp4_1080') == 1) {
FM.vFuncMenu.getComponent('1080p').show();
} else {
FM.vFuncMenu.getComponent('1080p').hide();
}
if ((record.get('trans') == 1 || record.get('mp4_240') == 1
|| record.get('mp4_360') == 1 || record.get('mp4_480') == 1
|| record.get('mp4_720') == 1 || record.get('mp4_1080') == 1)
&& QNAP.QOS.user.isAdminGroup) {
FM.vFuncMenu.getComponent('vcm_delTmpVideoBtn').show();
} else {
FM.vFuncMenu.getComponent('vcm_delTmpVideoBtn').hide();
}

if (!QNAP.QOS.fileExplorerTools.tool.couldBeTrans(record.data)
|| !QNAP.QOS.user.isAdminGroup ||FM.sysSetting.transcode_server_status<=0) {
FM.vFuncMenu.getComponent('vcm_transcodeBtn').hide();
} else {
FM.vFuncMenu.getComponent('vcm_transcodeBtn').show();
}

if (FM.sysSetting.transcode_server_status <=0 ){
FM.vFuncMenu.getComponent('vcm_delTmpVideoBtn').hide();
}

if (FM.RTT && QNAP.QOS.user.isAdminGroup) {
FM.vFuncMenu.getComponent('vcm_on_the_fly_transcoding').show();
} else {
FM.vFuncMenu.getComponent('vcm_on_the_fly_transcoding').hide();
}
if (record.get('play') == 1) {
FM.vFuncMenu.getComponent('vcm_play').show();
FM.vFuncMenu.getComponent('vcm_on_the_fly_transcoding').hide();
FM.vFuncMenu.getComponent('vcm_transcodeBtn').hide();
} else {
FM.vFuncMenu.getComponent('vcm_play').hide();
}
var listEl = Ext.fly(listEl);
FM.vFuncMenu.showAt([listEl.getX(), listEl.getY() + 16]);
FM.isVideoMenuClick = false;
}
if (record.get('parentLink')) {// 點選回上一層目錄
var parent = grid.store.baseParams.path;
var remote;
if (/^\/remote:\d+@[0-9a-f]{40}\//.test(parent)) {
FM.treePanel.gotoPath(parent.substring(0, parent.lastIndexOf('/')));
return;
}

parent = parent.substring(0, parent.lastIndexOf('/'));
var selNode = FM.treePanel.getSelectionModel().selNode;
/*如果點選樹狀選單的垃圾桶進入則不回到該share Folder的根目錄*/
if((selNode.id=='recycleBin' || selNode.parentNode.id=='qsyncRoot') && FM.currentPath.split('/')[2]=='@Recycle'){
if(FM.currentPath.split('/').length>3 || selNode.parentNode.id=='qsyncRoot'){
if(parent=='/home/@Recycle' && selNode.id=='qsyncRecycle'){
FM.loadPath('/home/.Qsync', '', false, true);
}else{
FM.loadPath(parent, '', false, true);
}
}else{
FM.showRecycleBinGrid();
}
}else{
if(selNode.id=='qsyncRoot'){
FM.loadPath(parent, '', false, true);
}else if(FM.currentVolTreeNode){
var treeNode=FM.currentVolTreeNode.findChild('id', parent, true);
treeNode.select();
treeNode.fireEvent('click',treeNode);
}else{//other folder: iso, usb......
var treeNode=FM.nasRoot.findChild('id', parent, true);
if(parent.indexOf(FM.sysSetting.ubuntu_home_path)==0){
treeNode=FM.treeRoot.findChild('id', parent, true);
}
treeNode.select();
treeNode.fireEvent('click',treeNode);
}
}

FM.searchMode = false;
}
var eastcmp = FM._getMainWindow().layout.east;
if (eastcmp.isVisible()) {
FM.showEastPanel();
}
},
NasFileGridOnRowDblClick : function(grid, index, e) {
var FM = this;
var selected = grid.getSelectionModel().getSelected();
var files = grid.getSelectionModel().getSelections();
if (files.length == 0){
return ;
}
var parent = grid.store.baseParams.path;
var record = grid.store.fields;// grid.store.getAt(index);
var child = selected.data.filename;
if (e && e.getTarget('td.x-grid3-td-checker')) {
return;
}
if (files.length == 1 && selected.data.parentLink) {
child = '';
parent = grid.store.baseParams.path;// record.data.filepath;
FM.loadPath(parent, child, true, false);
FM.searchMode = false;
} else if (files.length == 1 && parseInt(selected.get('isfolder')) == 1) {
var record = files[0];
if (/^\/remote:\d+[0-9a-f]{40}/.test(record.data.filepath)) {
FM.gotoPath(record.data.filepath + '/' + record.data.filename);
return;
}
var fn = selected.get('filename');
var newPath = QNAP.QOS.fileExplorerTools.tool
.getDirPath(FM.currentPath)
+ fn;
FM.currentPath = newPath;
FM.currentHost = 'NAS';
/*如果點選樹狀選單的垃圾桶進入則不回到該share Folder的根目錄*/
var selNode = FM.treePanel.getSelectionModel().selNode;
if((selNode.id=='recycleBin' || selNode.parentNode.id=='qsyncRoot') && FM.currentPath.split('/')[2]=='@Recycle'){
if(FM.currentPath.split('/').length>3){
FM.loadPath(parent+'/'+child, '', false, true);
}else{
FM.showRecycleBinGrid();
}
}else{
FM.loadPath(parent, child, true, false);
}
FM.addMemPath(FM.currentPath);
FM.searchMode = false;
} else {
var fileName = '';
if (files.length > 1) {
fileName = parent.replace(/.*\//, '') + '.zip';
QNAP.QOS.fileExplorerAction.download(parent, files, fileName,
FM);
} else {
fileName = files[0].get('filename');
}
var mediaType = QNAP.QOS.fileExplorerTools.tool.getMultiMediaType(fileName);
var noTransed=false;
if(files[0].get('mp4_240')==0 &&
files[0].get('mp4_360')==0 &&
files[0].get('mp4_480')==0 &&
files[0].get('mp4_720')==0 &&
files[0].get('mp4_1080')==0){
noTransed=true;
}

var matched = /^(fav_)?(\/remote:\d+@[0-9a-f]{40})/.exec(FM.currentPath);
if (matched) {
var deviceNode = FM.treePanel.root.findChild('id', matched[2], true);
if (deviceNode.attributes.configure.thumbnail) {
FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('playBtn').handler();
} else {
FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('openBtn').handler();
}
} else if (mediaType == 'isVideo') {
if (Ext.isMac && noTransed && (!FM.RTT || !QNAP.QOS.user.isAdminGroup)) {
FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('openBtn').handler();
}else{
FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('playBtn').handler();
}
}else if(mediaType=='isPhoto' || mediaType=='isAudio'){
FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('playBtn').handler();
}else if(/\.(eml)$/i.test(fileName) && !FM.isWFM){
FM.qmailOpen(FM.currentPath,files[0]);
} else {
FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('openBtn').handler();
}

}
},// NasFileGridOnRowDblClick End
ClientGridOnDblRowClick : function(grid, index, e) {
var FM = this;
var selected = grid.getSelectionModel().getSelected();
var parent = grid.store.baseParams.path;
var record = grid.store.getAt(index);
var child = grid.store.getAt(index).get('filename');
var separator = FM.clientFileStore.separator;
var checkerEl = e.getTarget('td.x-grid3-td-checker');
if (checkerEl) {
return;
}
if (record.get('parentLink')) {
child = '';
parent = record.get('filepath');
FM.loadClientPath(parent, child, true, true, separator);
} else if (parseInt(record.get('isfolder')) == 1) {
var pathLastChar = parent.charAt(parent.length - 1);
if (pathLastChar == '\\') {// 統一格式：最後一碼不可以為'\'
parent = parent.substring(0, parent.length - 1);
}
FM.loadClientPath(parent, child, true, true, separator);
} else {
var param = {
PATH : FM.clientFileStore.baseParams.path + '\\' + child
};
FM.callApplet(FM.getId(), 'qUploadApplet', 'openFile', param);
}

},// ClientGridOnDblRowClick End

initClientGrid : function() {
var FM = this;
var clientSm = new Ext.grid.CheckboxSelectionModel({
width : 50,
singleSelect : false,
onMouseEvent : function(e, t, isMouseUp) {
var row = e.getTarget('.x-grid3-row');
if (e.shiftKey || e.ctrlKey) {
if (isMouseUp) {
return;
}
var view = this.grid.getView();
var rowIndex = row.rowIndex;
if (e.shiftKey && !this.singleSelect && this.last !== false) {
var last = this.last;
this.selectRange(last, rowIndex, e.ctrlKey);
this.last = last; // reset the last
view.focusRow(rowIndex);
} else {
var isSelected = this.isSelected(rowIndex);
if (e.ctrlKey && isSelected) {
this.deselectRow(rowIndex);
} else if (!isSelected || this.getCount() > 1) {
this.selectRow(rowIndex, e.ctrlKey || e.shiftKey);
view.focusRow(rowIndex);
}
}
return;
}
if (e.button === 0
&& /(x-grid3-col-checker|x-grid3-row-checker)/
.test(t.className)) {
if (!isMouseUp) {
e.stopEvent();
}
if (row) {
var index = row.rowIndex;
if (this.lastMouseDown === index) {
if (isMouseUp) {
this.lastMouseDown = false;
}
return;
}
if (this.isSelected(index)) {
this.deselectRow(index);
} else {
this.selectRow(index, true);
this.grid.getView().focusRow(index);
}
this.lastMouseDown = index;
}
} else if (e.button === 0) {
if (isMouseUp) {
this.clearSelections();
this.clearAllSelections();// plugin function
}
if (row) {
var index = row.rowIndex;
if (this.isSelected(index) || isMouseUp) {
this.selectRow(index, true);
} else {
this.selectRow(index, false);
}
this.last = index; // reset the last
this.grid.getView().focusRow(index);
}
}
},
onMouseDown : function(e, t) {
this.onMouseEvent(e, t, false);
},
renderer : function(v, p, record) {
if (record.data.parentLink) {
return '<div class="parentLink">&#160;</div>';
}
return '<div class="x-grid3-row-checker">&#160;</div>';
},
listeners : {
buffer : 50,
beforerowselect : function(cmp, rowIndex, keepExisting, record) {
return !record.get('parentLink');
}
}
});
FM.clientFileStore.on('load', function() {
clientSm.lastMouseDown = false;
});
var nameColumnId = Ext.id();
FM.clientGridColumnModel = new Ext.grid.ColumnModel([clientSm, {
id : nameColumnId,
header : _S._SFE_LANG_COMMON_FILENAME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILENAME',
dataIndex : 'filename',
sortable : true,
renderer : {
fn : QNAP.QOS.fileExplorerTools.tool.showCmName,
scope : FM
}
}, {
header : _S._SFE_LANG_COMMON_FILESIZE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILESIZE',
dataIndex : 'filesize',
width : 80,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmFileSize
}, {
header : _S._SFE_LANG_COMMON_FILETYPE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILETYPE',
dataIndex : 'filetype',
width : 70,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmFileType
}, {
header : _S._SFE_LANG_COMMON_MODIFIED_TIME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_MODIFIED_TIME',
dataIndex : 'mt',
width : 150,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmMt
}]);
var clientGridPagingBar = new Ext.PagingToolbar({
plugins : new QNAP.CMP.PageSize({
userConfigKey : 'wfm_file_list_page_size',
variations : [50 ,100 ,250 ,500],
defaultPageSize : 50
}),
store : FM.clientFileStore,
displayInfo : true,
doLoad : function(start) {
var o = {}, pn = this.getParams();
o.START = start;
o.LIMIT = this.pageSize;
o.PATH = FM.clientFileStore.baseParams.path;
if (this.fireEvent('beforechange', this, o) !== false) {
this.store.reload({
params : o
});
}
},
onLoad : function(store, r, o) {
if (!this.rendered) {
this.dsLoaded = [store, r, o];
return;
}
var p = this.getParams();

this.cursor = (o && o[p.start]) ? o[p.start] : 0;
var d = this.getPageData(), ap = d.activePage, ps = d.pages;
this.afterTextItem.setText(String.format(
this.afterPageText, d.pages));
this.inputItem.setValue(ap);
this.first.setDisabled(ap == 1);
this.prev.setDisabled(ap == 1);
this.next.setDisabled(ap == ps);
this.last.setDisabled(ap == ps);
this.refresh.enable();
this.updateInfo();
this.fireEvent('change', this, d);
}
});
var oldSelectionIDs = '';
FM.clientGridPanel = new Ext.grid.GridPanel({
itemId : 'clientGridPanel',
qInternational : true,
enableColumnMove : false,
cm : FM.clientGridColumnModel,
sm : clientSm,
store : FM.clientFileStore,
width : '100%',
region : 'center',
stripeRows : true,
autoExpandColumn : nameColumnId,
ddGroup : 'fileManagerListDD',
plugins : new FM.remeberSelectionsPlugin(),
loadMask : {
msg : ('_SFE_LANG_COMMON_LOADING_MSG')
},
data : {
dirPath : '/',
type : 'Client'
},
enableHdMenu : false,
viewConfig : {
columnsText : _S._SFE_LANG_COMMON_DISPLAY_COLUMN,
sortAscText : 'A->Z',
sortDescText : 'Z->A'
},
bbar : clientGridPagingBar,
keys : [{
key : Ext.EventObject.F5,
stopEvent : true,
fn : function(e) {
FM.clientGridPanel.getStore().reload();
}
}, {
key : Ext.EventObject.F2,
fn : function() {
QNAP.QOS.fileExplorerAction.rename(FM);
}
}, {
key : Ext.EventObject.DELETE,
fn : function() {
QNAP.QOS.fileExplorerAction.del(FM);
}
}, {
ctrl : true,
key : Ext.EventObject.A,
fn : function(e) {
FM.clientGridPanel.getSelectionModel().selectAll();
}
}, {
ctrl : true,
key : Ext.EventObject.C,
fn : function() {
var selections = FM.clientGridPanel.getSelectionModel().getSelections(),
qDatas = [];
var FMTool=QNAP.QOS.fileExplorerTools.tool;
for (var i = 0; i < selections.length; i++) {
var data = selections[i];
qDatas.push({
displayName : data.get('filename'),
fullName : data.get('filepath')
});
}
QNAP.QOS.fileExplorerAction.copyAction(FM, FM.currentPath, qDatas, 'copy', FM.currentHost);
FM.showActionBtn();
}
}, {
ctrl : true,
key : Ext.EventObject.V,
fn : function() {
if (QNAP.QOS.FileClipBoard.sourcePath == FM.currentPath) {
QNAP.QOS.fileExplorerAction.pastAction(FM, 2);
} else {
FM.pasteFile();
}
}
}],
listeners : {
containerclick : function(grid) {
grid.getView().focusRow(0);
},
rowmouseup : function(grid, row, e) {
var target = e.getTarget(), sm = grid.getSelectionModel();
sm.onMouseEvent(e, target, true);
},
rowclick : function(grid, index, e) {
var record = grid.store.getAt(index);
var textEl = e.getTarget('span.fileNameText-cls');
if (textEl) {
FM.isTextClick = true;
}
if (FM.isTextClick) {// 如果是點選文字進來的
if (record.get('isfolder') == 1) {
FM.ClientGridOnDblRowClick(grid, index, e);
}
FM.isTextClick = false;
}
FM.clientfncBtns.getComponent('moreActionBtn').show();
FM.clientfncBtns.doLayout();
FM.currentGrid = 'clientGrid';
FM.currentHost = 'Client';
var selections = grid.getSelectionModel().getSelections();
if (selections.length > 1) {
var totalSize = 0;
Ext.each(selections, function(file) {
totalSize += parseInt(file.get('filesize'));
});
var fileInfo = {
selectCount : selections.length,
totalSize : Ext.util.Format.fileSize(totalSize)
};
} else {
var record = grid.store.getAt(index);
var separator = FM.clientFileStore.separator;
if (record.get('parentLink')) {
var child = '';
var parent = record.get('filepath');
FM.loadClientPath(parent, child, true, true,
separator);
}
var fileInfo = {
name : record.get('filename'),
size : Ext.util.Format.fileSize(record
.get('filesize')),
permission : '',
owner : record.get('owner'),
group : record.get('group'),
modifiedTime : record.get('mt')
};
}
/* 多選之後點一筆變單選 Start */
var seletionIDs = '';
var selections = grid.getSelectionModel().getSelections();
Ext.each(selections, function(selections) {
seletionIDs = seletionIDs + selections.id + ','
});
if (grid.selModel.isSelected(index)
&& oldSelectionIDs == seletionIDs
&& selections.length > 1) {
Ext.each(selections, function(selection) {
if (selection.id != record.id) {
grid.selModel.deselectRow(grid.store
.indexOfId(selection.id));
}
});
}
oldSelectionIDs = seletionIDs;
/* 多選之後點一筆變單選 End */
},
rowdblclick : {
fn : FM.ClientGridOnDblRowClick,
scope : FM
},
rowcontextmenu : function(grid, index, e) {
e.stopEvent();
var sm = grid.getSelectionModel();
if (!sm.isSelected(index)) {
sm.selectRow(index);
}
var selections = sm.getSelections(), contextMenu = FM.clientGridContextMenu;
QNAP.QOS.fileExplorerTools.tool.updateActionBtn(selections,
FM);
contextMenu.showAt(e.getXY());
},
afterrender : function(grid) {
grid.getView().dragZone = new Ext.grid.GridDragZone(grid, {
ddGroup : grid.ddGroup,
proxy : new Ext.dd.StatusProxy({
reset : function(clearGhost) {
this.el.dom.className = "x-dd-drag-proxy grid-dd "
+ this.dropNotAllowed;
this.dropStatus = this.dropNotAllowed;
if (clearGhost) {
this.ghost.update("");
}
}
}),
onDrag : function(e) {
if (this.proxy.el.shadow.el) {
this.proxy.el.shadow.el.addClass('drag-shadow');
}
},
beforeDragDrop : function() {
if (this.proxy.el.shadow.el) {
this.proxy.el.shadow.el
.removeClass('drag-shadow');
}
},
onInitDrag : function(e) {
var data = this.dragData;
this.ddel.innerHTML = this.grid.getDragDropText();
this.proxy.update(this.ddel);
this.proxy.el.addClass('grid-dd');
},
getQdata : function(selections) {
var qDatas = [];
for (var i = 0; i < selections.length; i++) {
var data = selections[i];
var path = data.get('filepath');
qDatas.push({
newWin : false,
appId : 'fileManager',
size : data.get('filesize'),
iconName : 'images/icon/fm_main_icon.png',
displayName : data.get('filename'),
fullName : path,
type : data.get('isfolder') == 1
? 'folder'
: 'file',
config : {
path : path
}
});
}
return qDatas;
},
onBeforeDrag : function(data, e) {
var qDatas = this.getQdata(data.selections);
data.qDatas = qDatas;
var haveFile = false;// 判斷檔案不能拖入我的最愛使用
for (var i = 0; i < data.selections.length; i++) {
var record = data.selections[i];
if (record.get('isfolder') != 1) {
haveFile = true;
}
}
data.haveFile = haveFile;
data.from = grid.store.baseParams.path;
data.type = "Client";
return true;
}
});
grid.getView().dragZone.dropNotAllowed = 'q-dd-drop-nodrop';
grid.getView().dragZone.dropAllowed = 'q-dd-drop-drop';
grid.getView().dragZone.proxy.dropNotAllowed = 'q-dd-drop-nodrop';
grid.getView().dragZone.addToGroup('fileManagerTreeDD');

grid.getView().dragZone.beforeDragEnter = function(target,
e, id) {
this.cachedTarget = null;
return true;
};
grid.getView().dragZone.b4DragOver = function() {
this.cachedTarget = null;
};

var firstGridDropTargetEl = grid.getView().el;
var firstGridDropTarget = new Ext.dd.DropZone(
firstGridDropTargetEl, {
dropNotAllowed : 'q-dd-drop-nodrop',
dropAllowed : 'q-dd-drop-drop',
dropAppend : 'q-dd-drop-drop',
ddGroup : 'feListDD',
getTargetFromEvent : function(e) {
var view = grid.getView();
var rowEl = e.getTarget(view.rowSelector);
var index = view.findRowIndex(rowEl);
return grid.getStore().getAt(index);
},
onNodeOver : function(nodeData, ddSource, e,
data) {
if (data.type.charAt(0) + '2C' != 'N2C') {
return this.dropNotAllowed;
}
if (nodeData && nodeData.data.isfolder == 1) {
return this.dropAppend;
} else {
return this.dropAllowed;
}
},
onContainerOver : function(ddSource, e, data) {
var formGrid = data.grid;
var node = data.node;
var fromPath;
if (formGrid) {
fromPath = formGrid.data.dirPath;
} else {
fromPath = node.id;
}

var toGrid = grid;
if (data.type.charAt(0) + '2C' != 'N2C') {
return this.dropNotAllowed;
}
if (fromPath == toGrid.data.dirPath) {
return this.dropAllowed;
}
return this.dropAppend;
},
onNodeDrop : function(nodeData, ddSource, e,
data) {
var formGrid = data.grid;
var toGrid = grid;
var dropTarget = Ext.getCmp(e
.getTarget('div.x-grid-panel').id);
var toPath = toGrid.store.baseParams.path;

if (nodeData.data.isfolder == 1) {
toPath = toGrid.store.baseParams.path
+ '/' + nodeData.data.filename;
dropTarget = {
dirPath : toGrid.store.baseParams.path
+ '/'
+ nodeData.data.filename,
data : {
dirPath : toGrid.store.baseParams.path
+ '/'
+ nodeData.data.filename
}
};
}

FM.dropEvent = {
source : data,
target : dropTarget
};

FM.ddInfo = {
source : data,
target : dropTarget
};

e.cancel = true;

if (formGrid) {// data from grid
if (formGrid.store.baseParams.path == dropTarget.data.dirPath) {
return this.dropNotAllowed;
}

if (formGrid.appId == FM.id) {
if (dropTarget.dirPath == FM.dirPath
|| QNAP.QOS.fileExplorerTools.tool
.checkIfIncludeSelfFolder(
FM,
dropTarget.data.dirPath)) {
QNAP.QOS.fileExplorer.msg
.warning(_S._SFE_LANG_COMMON_MSG_THE_SAME_FOLDER);
return this.dropNotAllowed;
}
} else {
if (formGrid.store.baseParams.path == dropTarget.data.dirPath) {
QNAP.QOS.fileExplorer.msg
.warning(_S._SFE_LANG_COMMON_MSG_THE_SAME_FOLDER);
return this.dropNotAllowed;
}
}
FM.menuDropToTree.data.from = data.from;
} else {// data from tree
FM.menuDropToTree.data.from = data.node.parentNode.id;
}
var from = data.type.charAt(0)
FM.menuDropToTree.data.type = from + '2C';
if (FM.menuDropToTree.data.type != 'N2C') {
return false;
}
FM.menuDropToTree.data.to = toPath;
FM.menuDropToTree.data.items = data.qDatas;
FM.menuDropToTree.showAt(e.getXY());
data.menuShow = true;
return true;
},
onContainerDrop : function(ddSource, e, data) {
var formGrid = data.grid;
var node = data.node;
var fromPath;
if (formGrid) {
fromPath = formGrid.store.baseParams.path;
} else {
fromPath = node.id;
}
var toGrid = grid;
var target = grid;
var dropTarget = e
.getTarget('div.x-grid-panel');

if (Ext.isEmpty(dropTarget)
|| !Ext.fly(dropTarget)
.child('div[id='
+ this.el.id + ']')) {
return false;
}

FM.dropEvent = {
source : data,
target : grid
};
e.cancel = true;

if (formGrid && (formGrid.id == toGrid.id)) {
return false;
}

if (fromPath == toGrid.data.dirPath) {
return false;
}

FM.ddInfo = {
source : data,
target : grid
};
if (formGrid && (formGrid.appId == FM.id)) {
if (toGrid.dirPath == FM.dirPath
|| QNAP.QOS.fileExplorerTools.tool
.checkIfIncludeSelfFolder(
FM, toGrid.id)) {
QNAP.QOS.fileExplorer.msg
.warning(_S._SFE_LANG_COMMON_MSG_THE_SAME_FOLDER);
return;
}
} else {
if (formGrid
&& (formGrid.store.baseParams.path == toGrid.dirPath)) {
QNAP.QOS.fileExplorer.msg
.warning(_S._SFE_LANG_COMMON_MSG_THE_SAME_FOLDER);
return;
}
}
FM.menuDropToTree.data.to = toGrid.store.baseParams.path;
FM.menuDropToTree.data.from = data.qDatas[0].from;
if (node) {

var dataItem = {
appId : "fileExplorer",
config : {
path : data.qDatas[0].fullName
},
displayName : data.qDatas[0].displayName,
from : data.qDatas[0].from,
fullName : data.qDatas[0].fullName,
iconName : "images/icon/fm_main_icon.png",
newWin : data.qDatas[0].newWin,
size : "4096",
type : "folder"
};
FM.menuDropToTree.data.items = [dataItem];

} else {
FM.menuDropToTree.data.items = data.qDatas;
}
var from = data.type.charAt(0);
FM.menuDropToTree.data.type = from + '2C';
if (FM.menuDropToTree.data.type != 'N2C') {
return false;
}

FM.menuDropToTree.showAt(e.getXY());
data.menuShow = true;
return true;
}
});
firstGridDropTarget.addToGroup('fileManagerListDD');
}
}
});// FM.clientGridPanel End
FM.centerPanel.items.add(FM.clientGridPanel);
FM.clientGridPanel.on('activate', function() {
Ext.getCmp(FM.IDS.FAV_START_BTN).hide();
});
FM.clientGridPanel.on('load', function() {
Ext.getCmp(FM.IDS.PATH_BAR).doLayout();
});
},// initClientGrid End
initShare2MeGrid : function() {
var FM = this;
if (FM.share2MeGrid) {
return false;
}
var columnId = Ext.id();
var share2meCm = new Ext.grid.ColumnModel([{
header : '',
dataIndex : 'icon',
sortable : true,
width : 30,
sortable : false,
align : 'center',
renderer : {
fn : QNAP.QOS.fileExplorerTools.tool.showLlinkIcon,
scope : FM
}
}, {
header : _S._SFE_LANG_COMMON_FILENAME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILENAME',
dataIndex : 'link_name',
sortable : true,
width : 120,
id : columnId,
sortable : false,
renderer : QNAP.QOS.fileExplorerTools.tool.showLlinkName
}, {
header : _S._SFE_LANG_COMMON_FILESIZE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILESIZE',
dataIndex : 'filesize',
width : 80,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmFileSize
}, {
header : _S._SFE_LANG_SHARELINK_FROM_COL,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_FROM_COL',
dataIndex : 'creator'
}]);
FM.share2MeStore = new Ext.data.JsonStore({
itemId:'share2MeStore',
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'get_shared_with_me'),
status : 'status',
totalProperty : 'total',
root : 'datas',
fields : ['filename', 'filesize', 'download_link','duration',
'expire_time', 'addressee', 'start_time',
'access_code', 'ssid', 'creator', 'isfolder',
'all_available','option','multiple','link_name','ht','creator',
'mp4_240','mp4_360','mp4_480','mp4_720','mp4_1080','thumbStatus'
],//ht:host type, 11:smart link
remoteSort : true,
sortInfo : {
field : 'natural',
direction : 'ASC'
},
listeners : {
load : function(store, records, opt) {
FM.share2MeBtns.hide();
FM.setShareThumb(0,FM.share2MeGrid);
}
}
});
FM.share2MeStore.load();
FM.share2MeGrid = new Ext.grid.GridPanel({
itemId : 'share2MeGrid',
height : 500,
enableColumnMove : false,
autoExpandColumn : columnId,
autoExpandColumnMinWidth : 200,
cm : share2meCm,
store : FM.share2MeStore,
region : 'center',
stripeRows : true,
qInternational : true,
clicksToEdit : 1,
selModel : new Ext.grid.RowSelectionModel({singleSelect:true}),
loadMask : {
msg : ('_SFE_LANG_COMMON_LOADING_MSG')
},
enableDragDrop : false,
enableHdMenu : false,
viewConfig : {
columnsText : _S._SFE_LANG_COMMON_DISPLAY_COLUMN,
sortAscText : 'A->Z',
sortDescText : 'Z->A',

groupKey : '',
groupColorIndex : 0,
groupColors : ['group-1', 'group-2'],
getRowClass : function(record, index, rowParams, store) {
var newGroupKey = record.data.expire_time;
if (newGroupKey != this.groupKey) {
this.groupColorIndex++;
this.groupKey = newGroupKey;
}
return this.groupColors[this.groupColorIndex % 2];
}
},
bShiftCtrlPressed : false,
listeners : {
show : function(grid) {
FM.showShareActionBtns(grid);
},
rowclick : function(grid, rowIndex, e) {
var selections=grid.getSelectionModel().getSelections();
FM.share2MeBtns.allowTrans=false;
if(selections.length==1){
var optionBin=QNAP.QOS.fileExplorerTools.tool.toBin(selections[0].get('option'));
FM.share2MeBtns.allowTrans=optionBin.charAt(0)=='1';
}
var textEl = e.getTarget('span.enter-cls');
if(textEl){
FM.share2MeGridDblclick(grid, rowIndex, e);
}else{
FM.showShareActionBtns(grid, rowIndex, e);
}
},
rowdblclick : function(grid, rowIndex, e) {
FM.share2MeGridDblclick(grid, rowIndex, e);
},
rowcontextmenu : function(grid, index, e) {
e.stopEvent();
var sm = grid.getSelectionModel();
if (!sm.isSelected(index)) {
sm.selectRow(index);
}
FM.showShare2MeRMenu(grid, index, e);
}
}
});
FM.share2MeGrid.on('activate', function() {
FM.pathPanel.hide();
});
FM.share2MeGrid.on('deactivate', function() {
FM.pathPanel.show();
});
FM.centerPanel.items.add(FM.share2MeGrid);
},//initShare2MeGrid End
initShareActionBtns : function(){
var FM = this;
Ext.each(FM.share2MeBtns.items.items,function(btn){
btn.hide();
})
},
showShareActionBtns : function(grid, rowIndex, e) {
var FM = this;
var selections=grid.getSelectionModel().getSelections();
var store=grid.store;
var file=selections[0];
Ext.each(FM.share2MeBtns.items.items,function(btn){
btn.hide();
});
if(selections.length==0){
if (grid.itemId == 'shareFolderCTNGrid') {
FM.share2MeBtns.show();
}else{
FM.share2MeBtns.hide();
}
}else if(selections.length==1){
FM.share2MeBtns.show();
FM.share2MeBtns.getComponent('copyBtn').show();
FM.share2MeBtns.getComponent('openBtn').show();
FM.share2MeBtns.getComponent('downloadBtn').show();
var mediaType = QNAP.QOS.fileExplorerTools.tool.getMultiMediaType(file.get('filename'));
if(mediaType == 'isVideo' && file.get('multiple')!=1) {
FM.share2MeBtns.getComponent('playShareBtn').show();
}else{
FM.share2MeBtns.getComponent('playShareBtn').hide();
}
}else{

}
if (grid.itemId == 'shareFolderCTNGrid') {
if(store.reader.jsonData){
var optionBin=QNAP.QOS.fileExplorerTools.tool.toBin(store.reader.jsonData.option);
}
}
FM.share2MeBtns.doLayout();
},
share2MeGridDblclick : function(grid, rowIndex, e) {
var FM = this;
var rcd=grid.getSelectionModel().getSelections()[0];
if(rcd.get('multiple')==1){
FM.shareSubListStore.pwd=false;
if(!Ext.isEmpty(rcd.get('access_code').replace('----',''))){
FM.shareSubListStore.pwd=QNAP.lib.encryption.ezEncode(rcd.get('access_code'));
}
FM.shareSubListStore.baseParams.ssid=rcd.get('ssid');
FM.shareSubListStore.reload();
FM.setMainScr('shareSubListGrid');
}else if(rcd.get('isfolder')==1){
if(!Ext.isEmpty(rcd.get('ssid')))

if(!Ext.isEmpty(rcd.get('access_code')) && rcd.get('access_code')!='----'){
FM.shareFolderCTNStore.baseParams.pwd=QNAP.lib.encryption.ezEncode(rcd.get('access_code'));
}else if(grid.itemId == 'shareSubListGrid' && FM.shareSubListStore.pwd){
FM.shareFolderCTNStore.baseParams.pwd=FM.shareSubListStore.pwd;
}else{
delete FM.shareFolderCTNStore.baseParams.pwd;
}
if (grid.itemId == 'shareSubListGrid' || grid.itemId == 'share2MeGrid') {
delete FM.shareFolderCTNStore.baseParams.ssid;
delete FM.shareFolderCTNStore.baseParams.fid;
delete FM.shareFolderCTNStore.baseParams.path;
FM.shareFolderCTNStore.baseParams.path = '/';
FM.shareFolderCTNStore.baseParams.fid = rcd.get('fid');
FM.shareFolderCTNStore.baseParams.ssid=rcd.get('ssid');
FM.shareFolderCTNStore.from=grid.itemId;
} else if (grid.itemId == 'shareFolderCTNGrid') {
if(rcd.get('filename')=='..'){

}else{
if(FM.shareFolderCTNStore.baseParams.path=='/'){
FM.shareFolderCTNStore.baseParams.path='/'+rcd.get('filename');
}else{
FM.shareFolderCTNStore.baseParams.path=FM.shareFolderCTNStore.baseParams.path+'/'+rcd.get('filename');
}
}
} else {

}

FM.shareFolderCTNStore.baseParams.sort=rcd.get('filename');
FM.shareFolderCTNStore.baseParams.dir=rcd.get('ASC');
FM.shareFolderCTNStore.reload();
FM.setMainScr('shareFolderCTNGrid');
}else{
FM.share2MeBtns.getComponent('openBtn').handler();
}
},//share2MeGridDblclick end
initshareSubListGrid : function() {
var FM = this;
if (FM.shareSubListGrid) {
return false;
}
var columnId = Ext.id();
var shareSubListCm = new Ext.grid.ColumnModel([{
header : '',
dataIndex : 'icon',
sortable : true,
width : 30,
sortable : false,
align : 'center',
renderer : {
fn : QNAP.QOS.fileExplorerTools.tool.showLlinkIcon,
scope : FM
}
}, {
header : _S._SFE_LANG_COMMON_FILENAME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILENAME',
dataIndex : 'filename',
sortable : true,
width : 120,
id : columnId,
sortable : false,
renderer : QNAP.QOS.fileExplorerTools.tool.showLlinkName
}, {
header : _S._SFE_LANG_COMMON_FILESIZE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILESIZE',
dataIndex : 'filesize',
width : 80,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmFileSize
}]);
FM.shareSubListStore = new Ext.data.JsonStore({
itemId:'shareSubListStore',
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,
'get_share_sublist'),
status : 'status',
totalProperty : 'total',
root : 'datas',
fields : ['ssid', 'fid', 'filename', 'isfolder', 'filesize','thumbStatus',
'mp4_240','mp4_360','mp4_480','mp4_720','mp4_1080','duration'],
remoteSort : true,
sortInfo : {
field : 'natural',
direction : 'ASC'
},
listeners : {
load : function(store, records, opt) {
FM.share2MeBtns.hide();
var parentFolder = {
filename : '..',
filesize : 0,
filetype : '',
filepath : 'share2MeGrid',//parentPath,
mt : '',
privilege : '',
owner : '',
group : '',
isfolder : '',
parentLink : true,
iscompressed : ''
};
var parentRecord = new store.recordType(parentFolder);
store.insert(0, [parentRecord]);
store.data.items[0].qInternational = true;
store.data.items[0].qInternational = '_SFE_LANG_COMMON_RETURN';
FM.setShareThumb(0,FM.shareSubListGrid);
}
}
});
var pagingToolbar = new Ext.PagingToolbar({
plugins : new QNAP.CMP.PageSize({
userConfigKey : 'wfm_file_list_page_size',
variations : [50, 100, 250, 500],
defaultPageSize : 50
}),
store : FM.shareSubListStore,
displayInfo : true
});
FM.shareSubListGrid = new Ext.grid.GridPanel({
itemId : 'shareSubListGrid',
height : 500,
enableColumnMove : false,
autoExpandColumn : columnId,
autoExpandColumnMinWidth : 200,
cm : shareSubListCm,
store : FM.shareSubListStore,
region : 'center',
stripeRows : true,
qInternational : true,
clicksToEdit : 1,
bbar : pagingToolbar,
selModel : new Ext.grid.RowSelectionModel({singleSelect:true}),
loadMask : {
msg : ('_SFE_LANG_COMMON_LOADING_MSG')
},
enableDragDrop : false,
enableHdMenu : false,
bShiftCtrlPressed : false,
listeners : {
show : function(grid) {
FM.showShareActionBtns(grid);
},
rowclick : function(grid, rowIndex, e) {
var textEl = e.getTarget('span.enter-cls');
if(rowIndex==0){//
FM.setMainScr('share2MeGrid');
}else if(textEl){
FM.share2MeGridDblclick(grid, rowIndex, e);
}else{
FM.showShareActionBtns(grid, rowIndex, e);
}
},
rowdblclick : function(grid, rowIndex, e) {
FM.share2MeGridDblclick(grid, rowIndex, e);
},
rowcontextmenu : function(grid, index, e) {
e.stopEvent();
var sm = grid.getSelectionModel();
if (!sm.isSelected(index)) {
sm.selectRow(index);
}
FM.showShare2MeRMenu(grid, index, e);
}
}
});
FM.shareSubListGrid.on('activate', function() {
FM.pathPanel.hide();
});
FM.shareSubListGrid.on('deactivate', function() {
FM.pathPanel.show();
});
FM.centerPanel.items.add(FM.shareSubListGrid);
},//initshareSubListGrid End
initshareFolderCTNGrid : function() {
var FM = this;
if (FM.shareFolderCTNGrid) {
return false;
}
var columnId = Ext.id();
var cgiPath='/share.cgi';
var shareFolderCTNCm = new Ext.grid.ColumnModel([{
header : '',
dataIndex : 'icon',
sortable : true,
width : 30,
sortable : false,
align : 'center',
renderer : {
fn : QNAP.QOS.fileExplorerTools.tool.showLlinkIcon,
scope : FM
}
}, {
header : _S._SFE_LANG_COMMON_FILENAME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILENAME',
dataIndex : 'filename',
sortable : true,
width : 120,
id : columnId,
sortable : false,
renderer : QNAP.QOS.fileExplorerTools.tool.showLlinkName
}, {
header : _S._SFE_LANG_COMMON_FILESIZE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILESIZE',
dataIndex : 'filesize',
width : 80,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmFileSize
}]);

FM.shareFolderCTNStore = new Ext.data.JsonStore({
itemId:'shareFolderCTNStore',
url : cgiPath+'?func=get_list',
status : 'status',
totalProperty : 'total',
root : 'datas',
fields : ['ssid','fid','filename','isfolder','filesize','mt','epochmt','url',
'mp4_240','mp4_360','mp4_480','mp4_720','mp4_1080','duration',
'thumbStatus'],
remoteSort : true,
sortInfo : {
field : 'natural',
direction : 'ASC'
},
listeners : {
load : function(store, records, opt) {

if(store.reader.jsonData.option==3 && QNAP.QOS.FileClipBoard.sourceHost=='NAS'){
FM.share2MeBtns.getComponent('pastBtn').show();
}else{
FM.share2MeBtns.getComponent('pastBtn').hide();
}

var parentFolder = {
filename : '..',
filesize : 0,
filetype : '',
filepath : FM.shareFolderCTNStore.baseParams.path,//parentPath,
mt : '',
privilege : '',
owner : '',
group : '',
isfolder : '',
parentLink : true,
iscompressed : ''
};
var parentRecord = new store.recordType(parentFolder);
store.insert(0, [parentRecord]);
store.data.items[0].qInternational = true;
store.data.items[0].qInternational = '_SFE_LANG_COMMON_RETURN';
FM.showShareActionBtns(FM.shareFolderCTNGrid);

FM.setShareThumb(0,FM.shareFolderCTNGrid);
}
}
});
var pagingToolbar = new Ext.PagingToolbar({
plugins : new QNAP.CMP.PageSize({
userConfigKey : 'wfm_file_list_page_size',
variations : [50, 100, 250, 500],
defaultPageSize : 50
}),
store : FM.shareFolderCTNStore,
displayInfo : true
});
FM.shareFolderCTNGrid = new Ext.grid.GridPanel({
itemId : 'shareFolderCTNGrid',
height : 500,
enableColumnMove : false,
autoExpandColumn : columnId,
autoExpandColumnMinWidth : 200,
cm : shareFolderCTNCm,
store : FM.shareFolderCTNStore,
region : 'center',
stripeRows : true,
qInternational : true,
clicksToEdit : 1,
bbar : pagingToolbar,
selModel : new Ext.grid.RowSelectionModel(),
loadMask : {
msg : ('_SFE_LANG_COMMON_LOADING_MSG')
},
enableDragDrop : false,
enableHdMenu : false,
viewConfig : {
columnsText : _S._SFE_LANG_COMMON_DISPLAY_COLUMN,
sortAscText : 'A->Z',
sortDescText : 'Z->A',

groupKey : '',
groupColorIndex : 0,
groupColors : ['group-1', 'group-2'],
getRowClass : function(record, index, rowParams, store) {
var newGroupKey = record.data.expire_time;
if (newGroupKey != this.groupKey) {
this.groupColorIndex++;
this.groupKey = newGroupKey;
}
return this.groupColors[this.groupColorIndex % 2];
}
},
bShiftCtrlPressed : false,
listeners : {
show : function(grid) {
FM.showShareActionBtns(grid);
},
rowclick : function(grid, rowIndex, e) {
var rcd=grid.store.getAt(rowIndex);
var textEl = e.getTarget('span.enter-cls');
if(rowIndex==0){//
if(grid.store.baseParams.path=='/'){
FM.setMainScr(grid.store.from);
}else{
var fromPath;
if(grid.store.baseParams.path.split('/')<=2 ){
fromPath='/';
}else{
fromPath=grid.store.baseParams.path.substring(0, grid.store.baseParams.path.lastIndexOf('/'));
}
if(fromPath==''){
fromPath='/';
}
grid.store.baseParams.path=fromPath;
grid.store.reload();
}
}else if(textEl){
FM.share2MeGridDblclick(grid, rowIndex, e);
}else{
FM.showShareActionBtns(grid, rowIndex, e);
}
},
rowdblclick : function(grid, rowIndex, e) {
FM.share2MeGridDblclick(grid, rowIndex, e);
},
rowcontextmenu : function(grid, index, e) {
e.stopEvent();
var sm = grid.getSelectionModel();
if (!sm.isSelected(index)) {
sm.selectRow(index);
}
FM.showShare2MeRMenu(grid, index, e);
}
}
});
FM.shareFolderCTNGrid.on('activate', function() {
FM.pathPanel.hide();
});
FM.shareFolderCTNGrid.on('deactivate', function() {
FM.pathPanel.show();
});
FM.centerPanel.items.add(FM.shareFolderCTNGrid);
},//initshareFolderCTNGrid End
initShareGrid : function() {
var FM = this;
if (FM.shareGrid) {// 防止ShareGrid 重複產生
return;
}
FM.sharePagingBar = new Ext.PagingToolbar({
plugins : new QNAP.CMP.PageSize({
userConfigKey : 'wfm_file_list_page_size',
variations : [50 ,100 ,250 ,500],
defaultPageSize : 50
}),
store : FM.shareStore,
displayInfo : true
});
var columnId = Ext.id();
var shareCm = new Ext.grid.ColumnModel([{
header : '',
dataIndex : 'icon',
sortable : true,
width : 30,
sortable : false,
align : 'center',
renderer : {
fn : QNAP.QOS.fileExplorerTools.tool.showLlinkIcon,
scope : FM
}
}, {
header : _S._SFE_LANG_COMMON_FILENAME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILENAME',
dataIndex : 'link_name',
sortable : true,
width : 120,
renderer : QNAP.QOS.fileExplorerTools.tool.showLlinkName
}, {
header : _S._SFE_LANG_SHARELINK_LINK_COL,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_LINK_COL',
dataIndex : 'download_link',
id : columnId,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showDownloadLink,
editor : new Ext.form.TextField({
readOnly : true,
listeners : {
buffer : 50,
focus : function() {
this.selectText();
},
show : function() {
this.selectText();
}

}
})
}, {
header : _S._SFE_LANG_COMMON_FILESIZE,
dataIndex : 'filesize',
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILESIZE',
width : 80,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmFileSize
}, {
header : _S._SFE_LANG_COMMON_FILETYPE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILETYPE',
dataIndex : 'filetype',
width : 60,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmFileType
}, {
header : _S._SFE_LANG_SHARELINK_FROM_COL,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_FROM_COL',
dataIndex : 'start_time',
width : 150,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showExpireTime
}, {
header : _S._SFE_LANG_COMMON_TO,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_TO',
dataIndex : 'expire_time',
width : 150,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showExpireTime
}, {
header : _S._SFE_LANG_COMMON_LOCATION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_LOCATION',
dataIndex : 'filename',
width : 150,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showShareLocation
}, {
header : _S._SFE_LANG_COMMON_CREATOR,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CREATOR',
dataIndex : 'creator',
width : 90,
renderer : function(data, metadata, record, rowIndex, columnIndex,
store) {
metadata.attr = 'ext:qtip="' + data + '"';
return data;
}
}, {
header : _S._SFE_LANG_SHARELINK_ACCECC_CODE_LABEL_3,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_ACCECC_CODE_LABEL_3',
dataIndex : 'access_code',
width : 90,
renderer : QNAP.QOS.fileExplorerTools.tool.showAccessCode
}]);

FM.shareGrid = new Ext.grid.EditorGridPanel({
itemId : 'share-panel',
height : 500,
enableColumnMove : false,
bbar : FM.sharePagingBar,
autoExpandColumn : columnId,
autoExpandColumnMinWidth : 200,
cm : shareCm,
store : FM.shareStore,
region : 'center',
stripeRows : true,
qInternational : true,
clicksToEdit : 1,
selModel : new Ext.grid.RowSelectionModel(),
loadMask : {
msg : ('_SFE_LANG_COMMON_LOADING_MSG')
},
enableDragDrop : false,
enableHdMenu : false,
viewConfig : {
columnsText : _S._SFE_LANG_COMMON_DISPLAY_COLUMN,
sortAscText : 'A->Z',
sortDescText : 'Z->A',

groupKey : '',
groupColorIndex : 0,
groupColors : ['group-1', 'group-2'],
getRowClass : function(record, index, rowParams, store) {
var newGroupKey = record.data.expire_time;
if (newGroupKey != this.groupKey) {
this.groupColorIndex++;
this.groupKey = newGroupKey;
}
return this.groupColors[this.groupColorIndex % 2];
}
},
bShiftCtrlPressed : false,
getGrid : function() {
return this;
},
listeners : {
rowclick : function(grid, rowIndex, e) {
FM.showShareLinkBtn();
},
rowcontextmenu : function(grid, rowIndex, e) {
e.stopEvent();
if (grid.getSelectionModel().getSelections().length < 2)
grid.getSelectionModel().selectRow(rowIndex);
var shareContextMenu;
if(!shareContextMenu){
shareContextMenu = new Ext.menu.Menu({
itemId : 'shareContextMenu',
listeners : {
show : function(menu) {
menu.el.removeClass('qnap-menu-v2');
menu.el.removeClass('qnap-block--white');
}
},
items : [{
itemId : 'mailShareBtn',
text : _S._SFE_LANG_COMMON_RESHARE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_RESHARE',
handler : function() {
QNAP.QOS.fileExplorerAction.getShareWin15.call(FM,0,null, FM.shareGrid);
}
},{
itemId : 'gcm_del_main',
text : _S._SFE_LANG_SHARELINK_STOP_SHARE,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_STOP_SHARE',
handler : function() {
var isQsyncLink=FM.checkQsyncLink();
if(isQsyncLink){
return;
}
QNAP.QOS.fileExplorerAction.delShare(FM);
}
},{
xtype : 'copybtn',
itemId : 'copyShareBtn',
text : _S._SFE_LANG_SHARELINK_COPY,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_COPY',
cls : 'gridRightCopy-cls',
hidden : !DetectFlashVer(9),
style :'padding-left:25px',
flexCallBack : function() {
shareContextMenu.hide();
var clipboardHint=FM.shareBtns.getComponent('clipboardHint');
clipboardHint.show();
FM.shareBtns.doLayout();
clipboardHint.el.dom.style.opacity=1;
var i=0;
var opacityTask= new Ext.util.DelayedTask(function() {
if(i<20){
i++;
clipboardHint.el.dom.style.opacity=clipboardHint.el.dom.style.opacity-0.05;
opacityTask.delay(50);
}
});
opacityTask.delay(1000);
var task = new Ext.util.DelayedTask(function() {
clipboardHint.hide();
});
task.delay(2000);
},
listeners : {
afterrender : function(cmp) {

var parent=Ext.get(cmp.el.dom.parentNode);
cmp.el.dom.onmouseenter=function(){
parent.dom.className= 'x-menu-list-item x-menu-item-active';
}
cmp.el.dom.onmouseleave=function(){
parent.dom.className= 'x-menu-list-item';
}
cmp.el.select('div.x-btn')
.setSize(cmp.getWidth() - 3,
cmp.getHeight() - 3);
var task = new Ext.util.DelayedTask(function() {
var flexDiv = Ext.get(cmp.swfId + '-div');
flexDiv.dom.tabIndex=0;
Ext.QuickTips.unregister(Ext.get(cmp.swfId));
});
task.delay(100);

},
mouseover : function(cmp) {

},
mousemove : function(cmp) {
cmp.data = FM.shareGrid.data;
}
}


}]
});
}
shareContextMenu.showAt(e.getXY());
}
}
});
FM.shareGrid.on('activate', function() {
FM.pathPanel.hide();
});
FM.shareGrid.on('deactivate', function() {
FM.pathPanel.show();
});
FM.shareGrid.getSelectionModel().on('selectionchange', function() {

var selections = FM.shareGrid.getSelectionModel().getSelections();
var html = '',copyLinks='';
for (var i = 0; i < selections.length; i++) {
var r = selections[i];
html += String.format('{0}. {1}\n{2}', i + 1, r.data.link_name.replace(/.*\//, ''), r.data.download_link);
if(r.get('access_code')!='----'){
html +='\r\n'+_S._SFE_LANG_SHARELINK_ACCECC_CODE_LABEL_2+'  '+r.get('access_code');
}
copyLinks=copyLinks+r.data.download_link+'\r\n';
if (i + 1 < selections.length) {
html += '\r\n\r\n';
}
}
if(selections.length!=0){
FM.mailLinks = html;
FM.copyLinks =copyLinks;
}
FM.shareGrid.data = html;
}, null, {
buffer : 50
});
FM.centerPanel.items.add(FM.shareGrid);
},// initShareGrid End
createAdvSearch : function(from) {
var FM = this;
if (!(FM.panelA && FM.panelB)) {
FM.panelA = new Ext.Container({
flex : 1,
cls : 'panelA-cls',
labelAlign : 'right',
width : '45%',
height : '100px',
labelWidth : 94,
reset : function() {
this.items.each(function(item) {
try {
item.reset();
} catch (e) {
}
});
this.getComponent('fileSizeType').items.each(
function(item) {
try {
item.reset();
} catch (e) {
}
});
this.getComponent('qsirch').items.each(
function(item) {
try {
item.reset();
} catch (e) {
}
});
this.getComponent('keywordO').items.each(
function(item) {
try {
item.reset();
} catch (e) {
}
});
},
layout : {
type : 'form'
},
defaults : {
anchor : '-10'
},
items : [{
itemId : 'qsirch',
fieldLabel : _S._SFE_LANG_COMMON_KEYWORD,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_KEYWORD',
hidden : FM.sysSetting.qsirch_enable !=1,
cls : 'fileSizeType-cls',
height : 26,
layout : {
type : 'hbox',
pack : 'start',
align : 'stretch'
},
items : [{
xtype : 'combo',
width : 127,
height : 26,
itemId : 'qsirchType',
triggerAction : 'all',
lazyRender : true,
editable : false,
mode : 'local',
value : 1,
qInternational : true,
qInternationalFn : function(cmp) {
var value = cmp.getValue();
cmp.getStore().each(function(r) {
r.set('display', _S[r.get('qInternationalKey')]);
});
cmp.setValue(value);
},
store : new Ext.data.ArrayStore({
id : 0,
fields : ['value', 'display', 'qInternationalKey'],
data : [
[0, _S._SFE_LANG_COMMON_FILE_NAME, '_SFE_LANG_COMMON_FILE_NAME'],
[1, _S._SFE_LANG_MAIL_CONTENT, '_SFE_LANG_MAIL_CONTENT']]
}),
valueField : 'value',
displayField : 'display',
listeners : {
}
}, {
xtype : 'tbspacer',
width : 10
}, {
xtype : 'textfield',
itemId : 'qsirKeyword',
flex : 1,
cls : 'fileSize-cls'
}]
},{
itemId : 'keywordO',
hidden : FM.sysSetting.qsirch_enable==1,
fieldLabel : _S._SFE_LANG_COMMON_FILENAME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILENAME',
cls : 'fileSizeType-cls',
height : 22,
layout : {
type : 'hbox',
pack : 'start',
align : 'stretch'
},
items : [{
xtype : 'textfield',
itemId : 'keyword',
flex : 1,
fieldLabel : _S._SFE_LANG_COMMON_FILENAME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILENAME'
}, {
xtype : 'button',
style: {
paddingLeft: '10px'
},
icon :'/cgi-bin/apps/fileManager/images/common/info.png',
cls : 'none-bg-btn',
tooltip:'Qsirch support search the file content and multimedia information. <br>Please install Qsirch if you want to use this function.',
hidden : Ext.isEmpty(FM.sysSetting.qsirch_enable),
handler : function(){
QNAP.QOS.fileExplorerTools.tool.openAppCenterQSirch();
}
}]
}, {
itemId : 'fileSizeType',
fieldLabel : _S._SFE_LANG_COMMON_FILESIZE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILESIZE',
cls : 'fileSizeType-cls',
height : 26,
layout : {
type : 'hbox',
pack : 'start',
align : 'stretch'
},
data : {
fileSizeType : 0,
fileSize : 0
},
items : [ {
xtype : 'combo',
width : 127,
height : 26,
itemId : 'fileSizeType',
triggerAction : 'all',
lazyRender : true,
editable : false,
mode : 'local',
value : 0,
qInternational : true,
qInternationalFn : function(cmp) {
var value = cmp.getValue();
cmp.getStore().each(function(r) {
r.set('display',
_S[r.get('qInternationalKey')]);
});
cmp.setValue(value);
},
store : new Ext.data.ArrayStore({
id : 0,
fields : ['value', 'display',
'qInternationalKey'],
data : [
[0, _S._SFE_LANG_COMMON_ANY,
'_SFE_LANG_COMMON_ANY'],
[
2,
_S._SFE_LANG_COMMON_IS_GREATER_THAN,
'_SFE_LANG_COMMON_IS_GREATER_THAN'],
[
3,
_S._SFE_LANG_COMMON_IS_LESS_THAN,
'_SFE_LANG_COMMON_IS_LESS_THAN']]
}),
valueField : 'value',
displayField : 'display',
listeners : {
select : function(combo, record, index) {
var ownerCt = combo.ownerCt;
var filed = FM.panelA.getComponent('fileSizeType').getComponent('fileSize');
ownerCt.data.fileSizeType = combo
.getValue();
switch (index) {
case 0 :
filed.setReadOnly(true);
filed.disable();
filed.setValue('');
break;
default :
filed.setReadOnly(false);
filed.enable();
filed.focus(true, true);
break;
}
}
}
}, {
xtype : 'tbspacer',
width : 10
}, {
xtype : 'numberfield',
itemId : 'fileSize',
cls : 'fileSize-cls',
height : 18,
flex : 1,
allowDecimals : false,
allowNegative : false,
readOnly : true,
disabled : true,
enableKeyEvents : true,
listeners : {
keypress : function(event) {
if (Ext.EventObject.keyCode < 48
|| Ext.EventObject.keyCode > 57)
Ext.EventObject.returnValue = false;
}
}
}, {
xtype : 'tbspacer',
width : 16
},{
xtype : 'combo',
width : 42,
listWidth : 42,
itemId : 'CombofileSize',
triggerAction : 'all',
lazyRender : true,
editable : false,
mode : 'local',
value : 0,
store : new Ext.data.ArrayStore({
id : 0,
fields : ['value', 'display'],
data : [[0, 'K'+_S._SFE_LANG_COMMON_BYTE], [1, 'M'+_S._SFE_LANG_COMMON_BYTE],
[2, 'G'+_S._SFE_LANG_COMMON_BYTE]]
}),
valueField : 'value',
displayField : 'display',
listeners : {

}
}]
}, {
itemId : 'dateType',
xtype : 'compositefield',
fieldLabel : _S._SFE_LANG_COMMON_MODIFIED_DATE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_MODIFIED_DATE',
data : {
dateType : 0,
date : ''
},
items : [{
xtype : 'combo',
width : 127,
itemId : 'dateType',
triggerAction : 'all',
lazyRender : true,
editable : false,
mode : 'local',
value : 0,
qInternational : true,
qInternationalFn : function(cmp) {
var value = cmp.getValue();
cmp.getStore().each(function(r) {
r.set('display',
_S[r.get('qInternationalKey')]);
});
cmp.setValue(value);
},
store : new Ext.data.ArrayStore({
id : 0,
fields : ['value', 'display',
'qInternationalKey'],
data : [
[0, _S._SFE_LANG_COMMON_ANY,
'_SFE_LANG_COMMON_ANY'],
[
1,
_S._SFE_LANG_AVD_SEARCH_EXACTLY,
'_SFE_LANG_AVD_SEARCH_EXACTLY'],
[2, _S._SFE_LANG_COMMON_IS_BEFORE,
'_SFE_LANG_COMMON_IS_BEFORE'],
[3, _S._SFE_LANG_COMMON_IS_AFTER,
'_SFE_LANG_COMMON_IS_AFTER'],
[4, _S._SFE_LANG_COMMON_IS_BETWEEN,
'_SFE_LANG_COMMON_IS_BETWEEN']]
}),
valueField : 'value',
displayField : 'display',
listeners : {
select : function(combo, record, index) {
var ownerCt = combo.ownerCt.ownerCt;
var filed = ownerCt.items.itemAt(1);
var filed2 = ownerCt.items.itemAt(2);
ownerCt.data.dateType = combo
.getValue();
filed.store.removeAll();
switch (index) {
case 0 :
filed.setValue('-');
filed.disable();
break;
case 1 :
filed.enable();
break;
default :
filed.enable();
filed.store.add(reocrd0);
filed.store.add(reocrd1);
filed.store.add(reocrd2);
filed.store.add(reocrd3);
filed.store.add(reocrd4);
filed.store.add(reocrd5);
filed.onTriggerClick();
break;
}
if (index == 4) {
filed2.enable();
} else {
filed2.disable();
filed2.setValue('-');
}
}
}
}, {
xtype : 'tbspacer',
width : 1
}, {
xtype : 'combo',
flex : 1,
itemId : 'date',
format : "Y/m/d",
yFormat : "Y/01/01",
mFormat : "Y/m/01",
triggerAction : 'all',
width : 82,
editable : false,
disabled : true,
mode : 'local',
value : '-',
hideTrigger : true,
qInternational : true,
qInternationalFn : function(cmp) {
var value = cmp.getValue();
cmp.getStore().each(function(r) {
r.set('display',
_S[r.get('qInternationalKey')]);
});
cmp.setValue(value);
},
store : new Ext.data.ArrayStore({
id : 0,
fields : ['value', 'display',
'qInternationalKey'],
data : [
[0, _S._SFE_LANG_COMMON_YESTERDAY,
'_SFE_LANG_COMMON_YESTERDAY'],
[1, _S._SFE_LANG_COMMON_THIS_WEEK,
'_SFE_LANG_COMMON_THIS_WEEK'],
[2, _S._SFE_LANG_COMMON_LAST_WEEK,
'_SFE_LANG_COMMON_LAST_WEEK'],
[3, _S._SFE_LANG_COMMON_THIS_MONTH,
'_SFE_LANG_COMMON_THIS_MONTH'],
[4, _S._SFE_LANG_COMMON_THIS_YEAR,
'_SFE_LANG_COMMON_THIS_YEAR'],
[5, '...'], [6, '']]
}),
valueField : 'value',
displayField : 'display',
listeners : {
afterrender : function(combo) {
var ownerCt = combo.ownerCt.ownerCt;
combo.dateMenu = new Ext.menu.DateMenu(
{
hideOnClick : false,
focusOnSelect : false
});

combo.dateMenu.on('select', function(m,
d) {
combo
.setValue(d
.dateFormat(combo.format));
ownerCt.data.date = combo
.getValue();
combo.dateMenu.hide();
}, combo);
combo.mun(combo.el, 'click',
combo.onTriggerClick, combo);
combo.mon(combo.el, 'click',
function() {
combo.dateMenu.show(
combo.el, "tl-bl?");
});

},
select : function(combo, record, index) {
var ownerCt = combo.ownerCt.ownerCt;
var filed = ownerCt.items.itemAt(1);
var today = new Date(), inputDay;
var first = today.getDate()
- today.getDay();
switch (index) {
case 0 :
inputDay = today.add(Date.DAY,
-1);
combo
.setValue(inputDay
.dateFormat(combo.format));
break;
case 2 :
first -= 7;
case 1 :
var d = new Date(today
.setDate(first))
.dateFormat(combo.format);
combo.setValue(d);
break;
case 3 :
combo
.setValue(today
.dateFormat(combo.mFormat))
break;
case 4 :
combo
.setValue(today
.dateFormat(combo.yFormat))
break;
default :
combo.dateMenu.show(combo.el,
"tl-bl?");
return false;
break;
}

ownerCt.data.date = combo.getValue();
return false;
}
}
}, {
xtype : 'combo',
flex : 1,
itemId : 'date2',
format : "Y/m/d",
yFormat : "Y/01/01",
mFormat : "Y/m/01",
triggerAction : 'all',
width : 87,
hideTrigger : true,
editable : false,
disabled : true,
mode : 'local',
value : '-',
qInternational : true,
qInternationalFn : function(cmp) {
var value = cmp.getValue();
cmp.getStore().each(function(r) {
r.set('display',
_S[r.get('qInternationalKey')]);
});
cmp.setValue(value);
},
store : new Ext.data.ArrayStore({
id : 0,
fields : ['value', 'display',
'qInternationalKey'],
data : [
[0, _S._SFE_LANG_COMMON_YESTERDAY,
'_SFE_LANG_COMMON_YESTERDAY'],
[1, _S._SFE_LANG_COMMON_THIS_WEEK,
'_SFE_LANG_COMMON_THIS_WEEK'],
[2, _S._SFE_LANG_COMMON_LAST_WEEK,
'_SFE_LANG_COMMON_LAST_WEEK'],
[3, _S._SFE_LANG_COMMON_THIS_MONTH,
'_SFE_LANG_COMMON_THIS_MONTH'],
[4, _S._SFE_LANG_COMMON_THIS_YEAR,
'_SFE_LANG_COMMON_THIS_YEAR'],
[5, '...']]
}),
valueField : 'value',
displayField : 'display',
listeners : {
afterrender : function(combo) {
var ownerCt = combo.ownerCt.ownerCt;
combo.dateMenu = new Ext.menu.DateMenu(
{
hideOnClick : false,
focusOnSelect : false
});

combo.dateMenu.on('select', function(m,
d) {
combo
.setValue(d
.dateFormat(combo.format));
ownerCt.data.date = combo
.getValue();
combo.dateMenu.hide();
}, combo);
combo.mun(combo.el, 'click',
combo.onTriggerClick, combo);
combo.mon(combo.el, 'click',
function() {
combo.dateMenu.show(
combo.el, "tl-bl?");
});

},
select : function(combo, record, index) {
var ownerCt = combo.ownerCt.ownerCt;
var filed = ownerCt.items.itemAt(1);
var today = new Date(), inputDay;
var first = today.getDate()
- today.getDay();
switch (index) {
case 0 :
inputDay = today.add(Date.DAY,
-1);
combo
.setValue(inputDay
.dateFormat(combo.format));
break;
case 2 :
first -= 7;
case 1 :
var d = new Date(today
.setDate(first))
.dateFormat(combo.format);
combo.setValue(d);
break;
case 3 :
combo
.setValue(today
.dateFormat(combo.mFormat))
break;
case 4 :
combo
.setValue(today
.dateFormat(combo.yFormat))
break;
default :
combo.dateMenu.show(combo.el,
"tl-bl?");
return false;
break;
}

ownerCt.data.date = combo.getValue();
return false;
}
}
}]
},{
xtype : 'checkbox',
itemId : 'remFilter',
name : 'remFilter',
ctCls : 'remFilter-ctCls',
width : 290,
boxLabel : _S._SFE_LANG_FILTER_SPECIFIE,
qInternational : true,
qInternationalKey : '_SFE_LANG_FILTER_SPECIFIE',
hideLabel : true,
hidden:'filter'==from,
value : 1,
listeners : {
check:function(checkbox,checked){
}
}
}]
});// FM.panelA End (advSearch)

var dateTypeStore = FM.panelA.getComponent('dateType').items.items[1].store;
var reocrd0 = dateTypeStore.data.items[0];
var reocrd1 = dateTypeStore.data.items[1];
var reocrd2 = dateTypeStore.data.items[2];
var reocrd3 = dateTypeStore.data.items[3];
var reocrd4 = dateTypeStore.data.items[4];
var reocrd5 = dateTypeStore.data.items[5];
function queryUser() {
var cmp = this, el = cmp.el, filter = el.getValue();
var refreshBtn = cmp.pageTb.refresh, count = 0;
var store;
switch (cmp.data) {
case 1 :
store = FM.userListStore;
break;
case 2 :
store = FM.groupListStore;
break;
}
store.baseParams.domain = '';
store.baseParams.netbios = '';
store.baseParams.filter = el.getValue();
refreshBtn.disable();
function loaded(records) {
reqTime--;

var options = store.lastOptions;
count += store.totalLength;
store.totalLength = count;
cmp.pageTb.onLoad(store, records, options);
if (reqTime == 0) {
refreshBtn.enable();
} else {
refreshBtn.disable();
}
}

var reqTime = FM.adStore.getCount() + 1;
store.load({
params : {
type : cmp.data,
lower : 0,
upper : 20
},
add : true,
callback : loaded
});
}

var userQueryTask = new Ext.util.DelayedTask();

FM.panelB = new Ext.Container({
flex : 1,
labelAlign : 'right',
cls : 'panelB-cls',
height : '110px',
reset : function() {
this.items.each(function(item) {
try {
item.reset();
} catch (e) {
}
});
},
layout : {
type : 'form'
},
defaults : {
anchor : '-10'
},
items : [{
xtype : 'tbspacer',
itemId : 'spaceId',
height : 22
},{
xtype : 'combo',
fieldLabel : _S._SFE_LANG_COMMON_LOCATION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_LOCATION',
itemId : 'folders',
triggerAction : 'all',
lazyRender : true,
editable : false,
mode : 'local',
store : FM.nasRootStore,
valueField : 'path',
displayField : 'path',
width : '100%',
listeners : {
beforeselect : function(combo, record, index) {
if (record.get('type') == 'multipath') {
FM.showPathSelector();
combo.collapse();
return false;
} else {
FM.panelB.getComponent('folders').data = [combo.getValue()];
}
}
}
}, {
xtype : 'compositefield',
fieldLabel : _S._SFE_LANG_COMMON_FILETYPE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILETYPE',
itemId : 'searchType',
data : {
searchType : 0,
extensionName : ''
},
items : [{
xtype : 'combo',
itemId : 'searchType',
width : 129,
triggerAction : 'all',
editable : false,
lazyRender : true,
mode : 'local',
value : 0,
qInternational : true,
qInternationalFn : function(cmp) {
var value = cmp.getValue();
cmp.getStore().each(function(r) {
r
.set('display',
_S[r.get('qInternationalKey')]);
});
cmp.setValue(value);
},
store : new Ext.data.ArrayStore({
id : 0,
fields : ['value', 'display', 'qInternationalKey'],
data : [
[0, _S._SFE_LANG_COMMON_ANY,
'_SFE_LANG_COMMON_ANY'],
[4, _S._SFE_LANG_COMMON_MUSIC,
'_SFE_LANG_COMMON_MUSIC'],
[5, _S._SFE_LANG_COMMON_VIDEO,
'_SFE_LANG_COMMON_VIDEO'],
[6, _S._SFE_LANG_COMMON_PHOTO,
'_SFE_LANG_COMMON_PHOTO'],
[1, _S._SFE_LANG_COMMON_Extension,
'_SFE_LANG_COMMON_Extension'],
[2, _S._SFE_LANG_AVD_SEARCH_ONLY_FILE,
'_SFE_LANG_AVD_SEARCH_ONLY_FILE'],
[3, _S._SFE_LANG_AVD_SEARCH_ONLY_FOLDER,
'_SFE_LANG_AVD_SEARCH_ONLY_FOLDER']]
}),
valueField : 'value',
displayField : 'display',
listeners : {
select : function(combo, record, index) {
var ownerCt = combo.ownerCt.ownerCt;
var filed = ownerCt.items.itemAt(1);
ownerCt.data.searchType = combo.getValue();
switch (index) {
case 4 :
filed.setReadOnly(false);
filed.enable();
filed.focus(true, true);
break;
default :
filed.setReadOnly(true);
filed.disable();
break;
}
}
}
}, {
xtype : 'textfield',
itemId : 'extensionName',
height : '16px',
flex : 1,
readOnly : true,
disabled : true,
validator : function(value) {
var field = this;
var ownerData = field.ownerCt.ownerCt.data;
ownerData.extensionName = value;
return true;
}
}]
}, {
xtype : 'compositefield',
itemId : 'ownerType',
fieldLabel : _S._SFE_LANG_AVD_SEARCH_OWNER_GROUP,
qInternational : true,
qInternationalKey : '_SFE_LANG_AVD_SEARCH_OWNER_GROUP',
labelWidth : '200',
data : {
ownerType : 0,
owner : 0
},

items : [{
xtype : 'combo',
width : 129,
itemId : 'ownerType',
triggerAction : 'all',
lazyRender : true,
editable : false,
mode : 'local',
value : 0,
qInternational : true,
qInternationalFn : function(cmp) {
var value = cmp.getValue();
cmp.getStore().each(function(r) {
r
.set('display',
_S[r.get('qInternationalKey')]);
});
cmp.setValue(value);
},
store : new Ext.data.ArrayStore({
id : 0,
fields : ['value', 'display', 'dataType',
'qInternationalKey'],
data : [
[0, _S._SFE_LANG_COMMON_ANY, '',
'_SFE_LANG_COMMON_ANY'],
[1, _S._SFE_LANG_COMMON_OWNER, 1,
'_SFE_LANG_COMMON_OWNER'],
[2, _S._SFE_LANG_COMMON_GROUP, 2,
'_SFE_LANG_COMMON_GROUP']]

}),
valueField : 'value',
displayField : 'display',
listeners : {
select : function(combo, record, index) {
var ownerCt = combo.ownerCt.ownerCt;
var filed = ownerCt.items.itemAt(1);
ownerCt.data.ownerType = combo.getValue();
switch (index) {
case 0 :
filed.disable();
break;
default :
filed.enable();
filed.data = record.get('dataType');
filed.focus(true, true);
break;
}
switch (filed.data) {
case 1 :
filed.bindStore(FM.userListStore,
false);
break;
case 2 :
filed.bindStore(FM.groupListStore,
false);
break;
}
}
}
}, {
xtype : 'combo',
itemId : 'owner',
cls : 'ownerGroup-cls',
flex : 1,
disabled : true,
lazyRender : true,
pageSize : 20,
listWidth : 200,
hideTrigger : true,
loadingText : _S._SFE_LANG_COMMON_LOADING_MSG + '....',
store : FM.userListStore,
valueField : 'name',
displayField : 'name',
enableKeyEvents : true,
mode : 'local',
listeners : {
keyup : function(combo, e) {
this.store.removeAll();
userQueryTask.cancel();
userQueryTask.delay(350, queryUser, combo);
var ownerCt = combo.ownerCt.ownerCt;
ownerCt.data.owner = combo.getRawValue();
},
select : function(combo, record, index) {
var ownerCt = combo.ownerCt.ownerCt;
ownerCt.data.owner = combo.getValue();
}
}
}]
}, {
xtype : 'container',
itemId : 'advSch-btns-id',
cls : 'advSch-btn-cls',
layout : {
type : 'hbox',
pack : 'end'
},
items : [{
xtype : 'button',
itemId : 'clearBtn',
text : _S._SFE_LANG_COMMON_CLEAR,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CLEAR',
width : 80,
cls : 'advSearchBtn-cls',
handler:function(){
FM.panelA.reset();
FM.panelB.reset();
FM.panelA.getComponent('dateType').items.items[1].disable();
FM.panelA.getComponent('dateType').items.items[2].disable();
FM.panelB.getComponent('folders').setValue(FM.currentPath);
if(Ext.getCmp(FM.northPanelId).getComponent('filterBtn').pressed)
FM.clearFilter();

}
}, {
xtype : 'tbspacer',
width : 10
}, {
xtype : 'button',
id : FM.advSrBtnId,
text : _S._SFE_LANG_COMMON_SEARCH,// 'Search',
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_SEARCH',
width : 80,
cls : 'advSearchBtn-cls',
listeners : {
click : function() {
var keyword;
if (FM.sysSetting.qsirch_enable == 1) {
keyword = FM.panelA.getComponent('qsirch').getComponent('qsirKeyword').getValue();
} else {
keyword = FM.panelA.getComponent('keywordO').getComponent('keyword').getValue();
}
var fileSizeType=FM.panelA.getComponent('fileSizeType').getComponent('fileSizeType').getValue();
var dateType = FM.panelA.getComponent('dateType').items.items[0].getValue();
var searchType = FM.panelB.getComponent('searchType').items.items[0].getValue();
var ownerType = FM.panelB.getComponent('ownerType').items.items[0].getValue();
var folders = FM.panelB.getComponent('folders').getValue();
var selNode = FM.treePanel.getSelectionModel().selNode;
if(keyword=='' &&fileSizeType==0 &&dateType==0
&& searchType==0 && ownerType==0 && folders==selNode.id){
selNode.ui.elNode.click();
return;
}


this.setDisabled(true);
var remFilter=FM.panelA.getComponent('remFilter');

if(remFilter.getValue()){
FM.advSearch('adv',false,true);
}else{
FM.advSearch('adv');
}
}
}
}, {
xtype : 'button',
itemId : 'filterSaveBtn',
allowDepress : true,
text : _S._SFE_LANG_COMMON_OK,// 'filter Save',
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
width : 80,
cls : 'advSearchBtn-cls',
hidden:'filter'!=from,
allowDepress : true,
handler:function(){
var keyword;
if (FM.sysSetting.qsirch_enable == 1) {
keyword = FM.panelA.getComponent('qsirch').getComponent('qsirKeyword').getValue();
} else {
keyword = FM.panelA.getComponent('keywordO').getComponent('keyword').getValue();
}
var fileSizeType=FM.panelA.getComponent('fileSizeType').getComponent('fileSizeType').getValue();
var dateType = FM.panelA.getComponent('dateType').items.items[0].getValue();
var searchType = FM.panelB.getComponent('searchType').items.items[0].getValue();
var ownerType = FM.panelB.getComponent('ownerType').items.items[0].getValue();
if(keyword=='' &&fileSizeType==0 &&dateType==0 && searchType==0 && ownerType==0 ){
FM.panelB.getComponent('advSch-btns-id').getComponent('clearBtn').handler();
}else{
FM.advSearch('adv',false,true);
}
}
}]
}]
});// FM.panelB End (advSearch)
FM.advSearchArea.items.add(FM.panelA);
var space = new Ext.Toolbar.Spacer({
width : '5%'
});
FM.advSearchArea.items.add(space);
FM.advSearchArea.items.add(FM.panelB);
FM.advSearchArea.hide();
}

FM.panelA.getComponent('remFilter').setVisible('filter'!=from);
FM.panelA.getComponent('remFilter').setValue(!Ext.isEmpty(FM.filefilter));
FM.panelB.getComponent('folders').setValue(FM.currentPath);
FM.panelB.getComponent('folders').setVisible('filter'!=from);
if('filter'==from){
FM.panelB.getComponent('spaceId').setHeight(28);
}else{
FM.panelB.getComponent('spaceId').setHeight(0);
}
FM.panelB.getComponent('advSch-btns-id').getComponent('filterSaveBtn').setVisible('filter'==from);
Ext.getCmp(FM.advSrBtnId).setVisible('filter'!=from);
FM.advSearchArea.show();
FM.advSearchArea.show();
FM.getCenterCmp().doLayout();
FM.setFilterToPanel();
if('filter'==from){
FM.advSearchArea.cls=FM.advSearchArea.addClass('filter-cls');
}else{
FM.advSearchArea.cls=FM.advSearchArea.removeClass('filter-cls');
}

},// createAdvSearch End
createPropertyPanel : function() {
var FM = this;
if (!FM.propertyPanel) {
FM.propertyPanel = new Ext.form.FormPanel({
itemId : 'propertyPanel',
cls : 'propertyPanel-cls',
padding : '28px 0 0 21px',
autoScroll : true,
listeners :{
afterrender : function(cmp) {
cmp.mask= new Ext.LoadMask(cmp.id, {msg : (_S._SFE_LANG_SHARELINK_MSG_4 )});
}
},
buttons:[
{
text :_S._SFE_LANG_SHARELINK_APPLY,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_APPLY',
ref:'apply_property_btn',
handler : function() {
FM.propertyPanel.mask.show();
var maskNum=0;
function checkMask(){
if(maskNum==0){
FM.propertyPanel.mask.hide();
}
}
var form=FM.propertyPanel.getForm();
var Music=form.findField('Music').getValue();
var Video=form.findField('Video').getValue();
var Photo=form.findField('Photo').getValue();
var mlFolderMask=0;
if(Music){mlFolderMask=mlFolderMask+1;}
if(Video){mlFolderMask=mlFolderMask+2;}
if(Photo){mlFolderMask=mlFolderMask+4;}

var folder=FM.currentPath.replace('/','');
var selections = FM.gridPanel.getSelectionModel().getSelections();
if(selections.length==1){
folder=folder+'/'+selections[0].get('filename');
}
if(FM.propertyPanel.getComponent('mediaFolderPanel').isVisible()){
var params1={
apply:1,
ml_folder_mask:mlFolderMask,
ml_folder_secure:0
};
if(FM.propertyPanel.mediaFolder){
params1.ml_folder_edit=folder;
}else{
params1.ml_folder_add=folder;
}
if(mlFolderMask==0){
params1={
apply:1,
ml_folder_del:FM.mediaFolders[folder]
};
}
maskNum=maskNum+1;
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'application/appRequest.cgi', {subfunc: 'medialib'}),
method: 'POST',
params: params1,
success: function(resulte, rq) {
maskNum=maskNum-1;
checkMask();
},
failure: function(resulte, rq) {
maskNum=maskNum-1;
checkMask();
}
});
}
/****************************************************/
var tranMaskNum = 0;//note: 480P後來才加的所以編碼在後面(8)
if (form.findField('240p').getValue()) {tranMaskNum = tranMaskNum + 1;}
if (form.findField('360p').getValue()) {tranMaskNum = tranMaskNum + 2;}
if (form.findField('720p').getValue()) {tranMaskNum = tranMaskNum + 4;}
if (form.findField('480p').getValue()) {tranMaskNum = tranMaskNum + 8;}
if (form.findField('1080p').getValue()) {tranMaskNum = tranMaskNum + 16;}
var path = form.findField('disp_path').getValue();
if(Ext.isEmpty(path)){
path='/';
}
if(FM.propertyPanel.getComponent('resolutionPanel').isVisible()){
var params2 = {
monitor : 1,// 1:將資料夾加入媒體櫃,0:將資料夾從媒體櫃移除
op : 3,
subop : 0,
path : path,
filename : form.findField('disp_name').getValue(),
total : 1,
mask : tranMaskNum
};

if(FM.propertyPanel.originalTransValue!=tranMaskNum){
maskNum=maskNum+2;
QNAP.QOS.fileExplorerTools.tool.ajax.call(FM, {
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'video_ml_queue'),
params : params2,
handler : {
success : function(resulte, rq) {
maskNum=maskNum-2;
checkMask();
},
failure : function(errorCode) {
maskNum=maskNum-2;
checkMask();
if(errorCode!=1){
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,errorCode);
}
}
}
});
}
}
/*****************************************************/
var para={
sharename:form.findField('disp_name').getValue(),
manual_path:'/'+form.findField('disp_name').getValue(),
share_hidden:form.findField('share_hidden_yes').getValue() ? 1 : 0,
oplocks:form.findField('oplocks_1').getValue() ? 1 : 0,
mangled_names:form.findField('mangled').getValue() ? 0 : 1,
ftp_wonly:form.findField('ftp_wonly').getValue() ? 1 : 0,
recycle_bin:form.findField('recycle_bin_group').getValue() * 1,
recycle_bin_administrators_only:form.findField('recycle_bin_admin').getValue() ? 1 : 0
}
if(FM.propertyPanel.getComponent('otherSettings').getComponent('encryptData_tr').isVisible() ){
para.EncryptData = form.findField('encryptData_1').getValue() ? 1 : 0;
}
Ext.each(FM.shareFolders, function(sfd) {
if(sfd.id == para.manual_path){
para.vol_no=sfd.volume_id;
}
});
if(Ext.isEmpty(form.findField('disp_path').getValue())
|| form.findField('disp_path').getValue()=='/'){//判斷是否為share folder
maskNum=maskNum+4;
QNAP.QOS.ajax({
url : QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath
+ 'priv/privWizard.cgi', {
wiz_func : 'share_property',
action : 'share_property'
}),
method : 'POST',
params : para,
success : function(response, opts) {
maskNum=maskNum-4;
checkMask();
var xmlData = response.responseXML;
if (xmlData !== undefined) {
}
},
failure : function() {
maskNum=maskNum-4;
checkMask();
}
});
}
}
},{
text :_S._SFE_LANG_COMMON_CANCEL,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CANCEL',
handler : function() {

}
}],
items : [{
xtype : 'displayfield',
itemId : 'selItems',
itemCls : 'selItems-itemCls',
fieldLabel : _S._SFE_LANG_COMMON_SELECTED_ITEMS,// '選取項目'
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_SELECTED_ITEMS'
}, {
xtype : 'textfield',
itemId : 'disp_name',
itemCls : 'dispName-itemCls',
width : 244,
readOnly:true,
hideLabel : true
}, {
xtype : 'displayfield',
itemId : 'fImg',
ctCls : 'fileInfoLabel-cls',
value : ''
}, {
xtype : 'displayfield',
itemId : 'fType',
fieldLabel : _S._SFE_LANG_COMMON_FILETYPE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILETYPE'
}, {
xtype : 'container',
itemId : 'sizePanel',
fieldLabel : _S._SFE_LANG_COMMON_FILESIZE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILESIZE',
height : 22,
autoWidth : true,
cls : 'sizeRInfo-cls',
layout : {
type : 'hbox',
align : 'stretch'
},
items : [{
xtype : 'displayfield',
itemId : 'loadIcon',
cls : 'loadIcon-cls',
width : 76,
height: 16,
hidden:true,
value:'<img src="'+QNAP.QOS.fileExplorerTools.config.imgPath+'common/loading.gif">'
},{
xtype : 'displayfield',
itemId : 'size',
cls : 'size-cls',
width : 76
}, {
xtype : 'button',
itemId : 'getSizeBtn',
cls : 'getSizeBtn-cls',
height: 16,
text : _S._SFE_LANG_ACTION_COMPUTE_SIZE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_COMPUTE_SIZE',
handler : function() {
QNAP.QOS.fileExplorerAction
.getSize(FM.gridPanel);
}
}]
}, {
xtype : 'textfield',
itemId : 'disp_path',
itemCls : 'dispName-itemCls',
width : 170,
readOnly:true,
fieldLabel : _S._SFE_LANG_COMMON_FILE_PATH,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILE_PATH'
}, {
xtype : 'displayfield',
itemId : 'modifiedTime',
fieldLabel : _S._SFE_LANG_COMMON_MODIFIED_TIME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_MODIFIED_TIME'
}, {
xtype : 'displayfield',
itemId : 'owner',
fieldLabel : _S._SFE_LANG_COMMON_OWNER,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OWNER'
}, {
xtype : 'displayfield',
itemId : 'group',
fieldLabel : _S._SFE_LANG_COMMON_GROUP,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_GROUP'
}, {
xtype : 'displayfield',
itemId : 'pool',
fieldLabel : _S._SFE_LANG_COMMON_STORAGE_POOL,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_STORAGE_POOL'
}, {
xtype : 'displayfield',
itemId : 'volume',
fieldLabel : _S._SFE_LANG_COMMON_DISK_VOLUME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_DISK_VOLUME'
},
new Ext.Panel({
itemId:'mediaFolderPanel',
tbar:[{
text: _S._SFE_LANG_COMMON_MEDIA_FOLDER,
qInternational: true,
qInternationalFn: '_SFE_LANG_COMMON_MEDIA_FOLDER',
qInternationalKey : '_SFE_LANG_COMMON_MEDIA_FOLDER',
cls : 'moreSTBtn-cls none-bg-btn',
handler : function(thisBtn, isChecked) {
os.openApp('systemPreferences', {
fn: "mediaLibrary",
config: {focusTab:2}
});
}
},{
cls : 'none-bg-btn',
icon : 'apps/systemPreferences/images/icon_help2.gif',
tooltip :'_SFE_LANG_MSG_MEDIA_FOLDER_TIP'
}],
height : 100,
hideMode : 'visibility',
layout : {
type : 'vbox',
pack : 'start',
align : 'stretch'
},
defaults : {
xtype : 'checkbox',
cls : 'x-form-element'
},
items : [
{
xtype : 'checkbox',
boxLabel : _S._SFE_LANG_COMMON_MUSIC,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_MUSIC',
itemId : 'Music',
handler : function(thisBtn, isChecked) {
}
}, {
xtype : 'checkbox',
boxLabel : _S._SFE_LANG_COMMON_VIDEO,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_VIDEO',
itemId : 'Video',
handler : function(thisBtn, isChecked) {
}
}, {
xtype : 'checkbox',
boxLabel : _S._SFE_LANG_COMMON_PHOTO,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PHOTO',
itemId : 'Photo',
handler : function(thisBtn, isChecked) {
}
}
]
}), new Ext.Panel({
itemId : 'resolutionPanel',
labelWidth : 100,
border : false,
tbar:[{
text: _S.TRANSCODE_INFO_STR_10,
qInternational: true,
qInternationalKey : 'TRANSCODE_INFO_STR_10',
cls : 'moreSTBtn-cls none-bg-btn',
handler : function(thisBtn, isChecked) {
os.openApp('systemPreferences', {
fn: "transcodeInfo",
config: {focusTab:2}
});
}
},{
cls : ' none-bg-btn',
icon : 'apps/systemPreferences/images/icon_help2.gif',
tooltip :'_SFE_LANG_MSG_RESOLUTION_FOLDER_TIP'
}],
height : 100,
style : 'font-size:12px;',
layout : {
type : 'hbox',
pack : 'start',
align : 'stretch'
},
items:[new Ext.Container({
itemId : 'resolutionA',
height : '78px',
hideMode : 'visibility',
flex:1,
layout : {
type : 'vbox',
pack : 'start',
align : 'stretch'
},
defaults : {
xtype : 'checkbox',
cls : 'x-form-element'
},
items : [
{
xtype : 'checkbox',
boxLabel : '240p',
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_MUSIC',
itemId : '240p',
handler : function(thisBtn, isChecked) {
}
}, {
xtype : 'checkbox',
boxLabel : '480p',
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_VIDEO',
itemId : '480p',
handler : function(thisBtn, isChecked) {
}
}, {
xtype : 'checkbox',
boxLabel : '1080p',
itemId : '1080p',
handler : function(thisBtn, isChecked) {
}
}]
}),
new Ext.Container({
itemId : 'resolutionB',
height : '78px',
hideMode : 'visibility',
flex:1,

layout : {
type : 'vbox',
pack : 'start',
align : 'stretch'
},
defaults : {
xtype : 'checkbox',
cls : 'x-form-element'
},
items : [
{
boxLabel : '360p',
itemId : '360p',
handler : function(thisBtn, isChecked) {
}
}, {
xtype : 'checkbox',
boxLabel : '720p',
itemId : '720p',
handler : function(thisBtn, isChecked) {
}
}
]
})
]
}),
new Ext.Panel({
itemId : 'otherSettings',
cls : 'otherSettings-cls',
height : 200,
hideMode : 'visibility',
tbar:[{
text: _S._SFE_LANG_COMMON_MORE_SETTINGS+'>>',
qInternational: true,
qInternationalFn: function(cmp){
cmp.setText(_S._SFE_LANG_COMMON_MORE_SETTINGS+'>>');
},
cls : 'none-bg-btn',
handler : function(thisBtn, isChecked) {
var otherSettings=FM.propertyPanel.getComponent('otherSettings');
var vis = otherSettings.body.isVisible();
if (vis) {
otherSettings.body.slideOut('t', {
easing: 'easeOut',
duration: .5,
remove: false,
useDisplay: false,
callback: function () {
otherSettings.body.hide();
otherSettings.doLayout();
}
});
} else {
otherSettings.body.show();
otherSettings.body.slideIn('t', {
easing: 'easeOut',
duration: .5,
callback: function () {
otherSettings.doLayout();
}
});
}
}
}],
layout : {
type : 'vbox',
pack : 'start',
align : 'stretch'
},
defaults : {
xtype : 'checkbox',
cls : 'x-form-element'
},
items : [{
xtype : 'container',
layout : 'column',
hideLabel : true,
style : 'font-size:12px;margin-bottom:4px;padding-left:0 !important;',
border : false,
items : [{
xtype : 'checkbox',
itemId : 'share_hidden_yes',
hideLabel : true,
boxLabel : _S.IEI_NAS_SHARE77
+ ' <img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;top:-2px;" ext:qtip=\''
+ _S.USER_CREATE_WIZ_STR48 + '\'/>',
qInternational : true,
qInternationalFn : function(cmp) {
cmp.wrap.child('.x-form-cb-label')
.update(_S.IEI_NAS_SHARE77
+ ' <img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;top:-2px;" ext:qtip=\''
+ _S.USER_CREATE_WIZ_STR48 + '\'/>');
}
}]
}, {
xtype : 'checkbox',
itemId : 'oplocks_1',
boxLabel : _S.IEI_NAS_SHARE79,
qInternational : true,
qInternationalKey : 'IEI_NAS_SHARE79',
hideLabel : true,
listeners : {
afterrender : function(cmp){
Ext.get(cmp.el.dom.parentElement).addClass('otherStItem-prCls');

}
}
}, {
xtype : 'container',
itemId : 'encryptData_tr',
layout : 'column',
hidden : true,
hideLabel : true,
style : 'font-size:12px;margin-bottom:4px;padding-left:0 !important;',
border : false,
items : [{
xtype : 'checkbox',
itemId : 'encryptData_1',
boxLabel : _S.DC_ENCRYPTDATA_STR01
+ ' <img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;top:-2px;" ext:qtip=\''
+ _S.DC_ENCRYPTDATA_STR02 + '\'/>',
qInternational : true,
qInternationalFn : function(cmp) {
cmp.wrap
.child('.x-form-cb-label')
.update(_S.DC_ENCRYPTDATA_STR01
+ ' <img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;top:-2px;" ext:qtip=\''
+ _S.DC_ENCRYPTDATA_STR02 + '\'/>');
},
hideLabel : true,
handler : function(cmp) {
function AlertForBadPerformance() {
var alertWin = new QNAP.QOS.modalWindow({
layout : 'hbox',
id : 'AlertForBadPerformance',
width : 350,
autoHeight : true,
padding : '17px 17px 6px 0',
baseCls : 'wizard-small',
footer : true,
plain : true,
minimizable : false,
modal : true,
buttonAlign : 'center',
items : [{
xtype : 'container',
autoEl : {
tag : 'img',
width : 50,
height : 50,
src : '../cgi-bin/images/toolbar/icon-info.png',
style : 'padding-left: 17px;'
}
}, {
xtype : 'panel',
border : false,
autoHeight : true,
style : 'font-size:12px;padding-left: 17px;',
items : [{
xtype : 'box',
html : _S.DC_ENCRYPTDATA_STR03,
qInternational : true,
qInternationalKey : 'DC_ENCRYPTDATA_STR03',
hideLabel : true
}, {
xtype : 'displayfield',
value : '&nbsp;',
height : 10
}, {
xtype : 'checkbox',
ref : '../stopAskMe',
boxLabel : _S.IEI_NAS_CONFIRM18,
qInternational : true,
qInternationalKey : 'IEI_NAS_CONFIRM18'
}, {
xtype : 'displayfield',
value : '&nbsp;',
height : 5
}]
}],
buttons : [{
text : _S.IEI_NAS_BUTTON_OK,
qInternational : true,
qInternationalKey : 'IEI_NAS_BUTTON_OK',
handler : function() {
if (alertWin.stopAskMe.getValue()) {
QNAP.lib.cookie.set(
'Is_Samba_SMB_Encryption_Bad_Performance_'
+ QNAP.QOS.user.account, 1,
864000, '/');
}
alertWin.close();
}
}]
});
alertWin.show();
}
function checkBadPerformance() {
QNAP.QOS.ajax({
url : QNAP.QOS.lib.getCgiUrl(
QNAP.QOS.config.sitePath + 'disk/smb4.cgi',
{
func : 'get_hardware_support'
}),
method : 'POST',
success : function(response, opts) {
var xmlData = response.responseXML;
if (xmlData
&& Ext.DomQuery.selectValue(
'BadEncrypt', xmlData) == '1') {
AlertForBadPerformance();
}
},
failure : function() {
}
});
}
if (cmp.getValue()) {
if (typeof(cmp.xmlData) == 'undefined' || cmp.xmlData != 1) {
if (QNAP.lib.cookie
.get('Is_Samba_SMB_Encryption_Bad_Performance_'
+ QNAP.QOS.user.account) != '1') {
checkBadPerformance();
}
}
}
}
}]
}, {
xtype : 'checkbox',
itemId : 'recycle_bin_group',
boxLabel : _S.MISC_RECYCLE_BIN_STR02,
qInternational : true,
qInternationalKey : 'MISC_RECYCLE_BIN_STR02',
hideLabel : true,
hidden : true,
handler : function(cmp) {
var form = FM.propertyPanel.getForm();
form.findField('recycle_bin_admin').setDisabled(!cmp.getValue());
}
}, {
xtype : 'checkbox',
itemId : 'recycle_bin_admin',
boxLabel : _S.RECYCLE_BIN_STRING_01,
qInternational : true,
qInternationalKey : 'RECYCLE_BIN_STRING_01',
style : QNAP.layout.getDefaultCSS({
indent : 1
}),
hideLabel : true,
hidden : true,
listeners : {
afterrender : function(cmp){
Ext.get(cmp.el.dom.parentElement).addClass('otherStItem-prCls');

}
}
}, {
xtype : 'container',
layout : 'column',
itemId : 'ftp_wonly_div',
hideLabel : true,
style : 'font-size:12px;margin-bottom:4px;',
border : false,
items : [{
xtype : 'checkbox',
itemId : 'ftp_wonly',
boxLabel : _S.IEI_NAS_SHARE82
+ ' <img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;top:-2px;" ext:qtip=\''
+ _S.IEI_NAS_SHARE83 + '\'/>',
qInternational : true,
qInternationalFn : function(cmp) {
cmp.wrap
.child('.x-form-cb-label')
.update(_S.IEI_NAS_SHARE82
+ ' <img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;top:-2px;" ext:qtip=\''
+ _S.IEI_NAS_SHARE83 + '\'/>');
}
}]
}, {
xtype : 'container',
layout : 'column',
itemId : 'mangled_div',
hideLabel : true,
style : 'font-size:12px;margin-bottom:4px;',
border : false,
items : [{
xtype : 'checkbox',
itemId : 'mangled',
hideLabel : true,
boxLabel : _S.DC_MANGLED_STR01
+ ' <img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;top:-2px;" ext:qtip=\''
+ _S.DC_MANGLED_STR02 + '\'/>',
qInternational : true,
qInternationalFn : function(cmp) {
cmp.wrap.child('.x-form-cb-label')
.update(_S.DC_MANGLED_STR01
+ ' <img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;top:-2px;" ext:qtip=\''
+ _S.DC_MANGLED_STR02 + '\'/>');
}
}]
}]
})
]
});
FM.eastTab.getItem('propertyPanel').add(FM.propertyPanel);
}
Ext.getCmp(FM.eastPanelId).doLayout();

},// createPropertyPanel End
createShareRoot : function() {
var FM = this;
var shareRoot = new Ext.tree.TreeNode({
id : 'shareNode',
expanded : true,
draggable : true,
text : _S._SFE_LANG_COMMON_FILE_SHARING,// File Sharing
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILE_SHARING',
iconCls : 'shareRoot-cls fm-treeRoot',
cls : 'fm-treeRoot',
data : {
type : 'share'
},
listeners : {
click : function(node, event) {
FM.initShareGrid();
FM.setMainScr('share-panel');
}
}
});
var share2MeGridNode = new Ext.tree.TreeNode({
itemId : 'share2MeNode',
id : 'share2MeNode',
text : _S._SFE_LANG_COMMON_SHARED_WITH_ME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_SHARED_WITH_ME',
cls : 'fm-treeRoot',
iconCls : 'shareNode-cls fm-treeRoot',
data : {
type : 'share'
},
listeners : {
click : function(node, event) {
FM.currentHost = 'share2Me';
if(FM.share2MeGrid){
FM.share2MeGrid.store.reload();
}else{
FM.initShare2MeGrid();
FM.initshareSubListGrid();
FM.initshareFolderCTNGrid();
}
FM.setMainScr('share2MeGrid');
}
}
});
FM.treeRoot.appendChild(shareRoot);
FM.treeRoot.appendChild(share2MeGridNode);
},// createShareRoot End
createRecycleBinNode : function() {
var FM = this;
var recycleBinNode = new Ext.tree.TreeNode({
id : 'recycleBin',
text : _S._SFE_LANG_COMMON_RECYCLE_BIN,// 'Recycle Bin',
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_RECYCLE_BIN',
leaf : false,
cls : 'fm-treeRoot recycleBin-cls',
iconCls : 'recycleBin-iconCls',
data : {
type : 'recycleBin'
},
listeners:{
click: function() {
var star = FM.pathPanel.getComponent('addFavBtn');
star.disable();
star.addClass('favorite-off');
star.removeClass('favorite-on');
var info = {
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,
'get_recycle_bin_status'),
success : function(RS, RQ) {
var rs = Ext.decode(RS.responseText)
if (rs.recycle_bin_enable != 1) {
var msg = _S._SFE_LANG_NETWORK_RECYCLE_BIN_IS_NOT_ENABLED;
var reB = _S._SFE_LANG_COMMON_NETWORK_RECYCLE_BIN;
if (!FM.isWFM && QNAP.QOS.user.isAdminGroup) {
reB = '<a href="#" onclick="os.openApp(\'systemPreferences\', {fn: \'recycleBin\'});">'
+ _S._SFE_LANG_COMMON_NETWORK_RECYCLE_BIN + '</a>';
}
var msgObj = {
text : msg.replace(_S._SFE_LANG_COMMON_NETWORK_RECYCLE_BIN,
reB),
key : '_SFE_LANG_NETWORK_RECYCLE_BIN_IS_NOT_ENABLED'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,
'error', msgObj, btns);
MsgWin.show();
} else {
FM.addMemPath('recycleBin');
FM.showRecycleBinGrid();
}
},
failure : function(RS, RQ) {
}
};
QNAP.QOS.ajax(info);
}
},
onSelect : function() {
}
});
FM.treeRoot.appendChild(recycleBinNode);
},// createRecycleBinNode End
loadClientRootBack : function(nodes) {
var FM = this;
var rootNode = FM.treeRoot.findChild('id', 'clientRoot', true);
rootNode.removeAll();

Ext.each(nodes, function(nodeData) {
if (!nodeData.IS_DIRECTORY && !nodeData.IS_ROOT) {
return true;
}
var data = nodeData.ICON == '' ? '' : 'data:image/'
+ nodeData.ICON_FORMAT + ';base64,' + nodeData.ICON;
var ClientLeafNode = 'ClientLeafNode'
if (data == '') {
ClientLeafNode = '';
data = '';
}
var pathLastChar = nodeData.PATH
.charAt(nodeData.PATH.length - 1);
if (pathLastChar == '\\') {
nodeData.PATH = nodeData.PATH.substring(0,
nodeData.PATH.length - 1);
}
var node = new FM.ClientTreeNode({
text : nodeData.NAME || nodeData.PATH,
icon : data,
iconCls : ClientLeafNode,
draggable : false,
allowDrop : false,
data : {
type : 'Client'
},
id : nodeData.PATH,
leaf : !nodeData.HAS_SUBFOLDER
});
node.setTooltip(node.id);
rootNode.appendChild(node);
});

if (QNAP.QOS.user.fe_isShowFileFolder === 'true'
&& deployJava.versionCheck('1.6+') ) {
FM.treeRoot.findChild('id', 'clientRoot').ui.show();
} else {
FM.treeRoot.findChild('id', 'clientRoot').ui.hide();
rootNode.expand();
rootNode.select();
}
},// loadClientRootBack End
loadClientRoot : function() {
var FM = this;
var param = {};
FM.callApplet(FM.getId(), 'qUploadApplet', 'getClientRoots', param);
FM.treeRoot.findChild('id', 'clientRoot').ui
.removeClass('x-tree-node-disabled');
},
doAfterrender : function() {
var FM = this;
var northPanel = Ext.getCmp(FM.northPanelId);
FM.eastPanelBtn = northPanel.items.items[northPanel.items.items.length
- 1];
FM.getEastCmp().on('expand', function() {
if (FM.eastTab
&& FM.eastTab.getActiveTab().itemId == 'permissionPanel') {// 如果'permissionPanel'是被打開的狀況
FM.properties();
} else {
var selections = FM.gridPanel.getSelectionModel().getSelections();
if (FM.currentHost == 'NAS' && selections.length > 0) {
FM.setPropertyPanelInfo(selections);
} else {
FM.setPropertyPanelInfo(null, FM.currentPath);
}

}
});
QNAP.QOS.fileExplorerTools.tool.initFMData(FM);
FM.checkACL();
if (Ext.isIE10
&& document.getElementsByTagName('title')[0].text == 'File Station') {
var ie10Body = Ext.get(document.getElementsByTagName('body')[0])
ie10Body.addClass('q-fileExplorer-window WFMBody-cls')
FM.isWFM = true
}
},
initApplet : function() {
var FM = this;
FM.checkApplet();
FM.mon(os, 'appletInitComplete', function(appletId) {
if (appletId == 'qUploadApplet') {
FM.initClientOS();
FM.loadClientRoot();
}
});
if (QNAP.QOS.config.isAppletReady) {
FM.initClientOS();
FM.loadClientRoot();
}
},
checkApplet: function (){
if (QNAP.QOS.user.fe_isShowFileFolder === 'true'){
os.initApplet();
}
},
initClientOS : function() {
var FM = this;
var osName = FM.callApplet(FM.getId(), 'qUploadApplet', 'getClientOS');
QNAP.QOS.fileExplorerTools.config.osName = osName;
var separator = '';
if (osName.indexOf("win") != -1) {
separator = '\\';
} else if (osName.indexOf("mac") != -1) {
separator = '/';
} else if (osName.indexOf("nux") != -1 || osName.indexOf("nix") != -1) {
separator = '/';
}
FM.clientFileStore.separator = separator;
var clientName = FM.callApplet(FM.getId(), 'qUploadApplet',
'getHostName');
var node = FM.treeRoot.findChild('id', 'clientRoot');
if (node) {
node.setText(clientName);
node.ui.show();
}
},
laodClientTreeList : function(json, treePath) {
var FM = this;

var node = FM.treeRoot.findChildBy(function(_node) {
return _node.getPath() == treePath;
}, FM.treeRoot, true);
FM.updateClientTreeNode(node, json.CHILDREN);
},
updateClientTreeNode : function(clientNode, clientFS) {
var FM = this;
clientNode.beginUpdate();
for (var i = 0; i < clientFS.length; i++) {
var nodeData = clientFS[i];
if (!nodeData.IS_DIRECTORY && !nodeData.IS_ROOT) {
continue;
}
var data = '';
if (nodeData.ICON) {
data = 'data:image/' + nodeData.ICON_FORMAT + ';base64,'
+ nodeData.ICON;
}
var node = new FM.ClientTreeNode({
text : nodeData.NAME || nodeData.PATH,
icon : data,
iconCls : 'x-tree-node-root ClientLeafNode',
draggable : true,
allowDrop : true,
data : {
type : 'Client'
},
id : nodeData.PATH,
leaf : !nodeData.HAS_SUBFOLDER
});
clientNode.appendChild(node);
}
clientNode.eachChild(function(node) {
node.setTooltip(node.id);
node.data = {
dirPath : node.id,
type : 'Client'
};
});
clientNode.endUpdate();
if (clientNode.loadComplete) {
clientNode.loadComplete();
}

},
getQdatas : function(records, path) {
var qDatas = [];
Ext.each(records, function(r) {
var fileName = r.data.filename;
qDatas.push({
type : r.data.isfolder == '1'
? 'folder'
: 'file',
appId : 'fileManager',
fullName : fileName,
config : {
path : path + '/' + fileName
}
});
});
return qDatas;
},
createContextMenu : function() {
var me = this;
var FM = this;

var refreshDeviceItemTpl = new Ext.XTemplate(
'<a id="{id}" class="{cls} x-unselectable" hidefocus="true" unselectable="on" href="{href}"',
'<tpl if="hrefTarget">',
' target="{hrefTarget}"',
'</tpl>',
'>',
'<img alt="{altText}" src="{icon}" class="x-menu-item-icon {iconCls}"/>',
'<span class="x-menu-item-text">{text}</span>',
'<img alt="{altText}" src="{icon}" class="streamDeviceIcon refresh"/>',
'</a>'
);

me.streamDeviceMenu = new Ext.menu.Menu({
x : 1 - 10,
cls : 'FM-moreActionMenuList-cls FM-stream-menu',
shadow : false,
listeners : {
beforeshow :function (){
var isQDMS = os.getQPKG('QDMS');
if (!isQDMS && window.localStorage.FS_QDMSHinted != 'true' && !FM.isWFM) {
var msg = _S._SFE_LANG_MSG_INSTALL_STREAMING_ADD_ON;
msg = msg.replace(
'<qtag>',
'<a href="#" onClick="os.openApp(\'qpkg\',{appId : \'qpkg\',config : {install : \'QDMS\',all : true,runMore:true}})">')
.replace('</qtag>', '</a>');
var msgObj = {
text : msg,
key : '_SFE_LANG_MSG_INSTALL_STREAMING_ADD_ON',
width : 420
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
window.localStorage.FS_QDMSHinted = dontShow.getValue();;
alertWin.close();
}
}];
var alertWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM, 'info', msgObj,btns);
var dontShow = new Ext.form.Checkbox({
boxLabel : _S._SFE_LANG_ACL_ALERT_MSG02,
qInternational : true,
qInternationalKey: {
boxLabel: '_SFE_LANG_ACL_ALERT_MSG02'
},
margins : '30',
checked : false
});
alertWin.remove(1);
alertWin.add({
xtype : 'container',
width : 250,
flex : 1,
margins : {
top : 10,
left : 17,
right : 0,
bottom : 0
},
items : [{
xtype : 'displayfield',
itemId : 'msgText',
value : msgObj.text,
qInternational : true,
qInternationalFn: function (cmp){
var msg = _S._SFE_LANG_MSG_INSTALL_STREAMING_ADD_ON;
msg = msg.replace(
'<qtag>',
'<a href="#" onClick="os.openApp(\'qpkg\',{appId : \'qpkg\',config : {install : \'QDMS\',all : true,runMore:true}})">')
.replace('</qtag>', '</a>');
cmp.setValue(msg);
},
style : {
marginBottom : '20px'
}
}, dontShow]
});
alertWin.show();
}
},
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
}
},
items: [{
xtype: 'menuitem',
text: _S._SFE_LANG_LAN_DEVICES,
ctCls: 'menu-head',
width: 170,
itemTpl: refreshDeviceItemTpl,
hideOnClick:false,
activeClass:'',
listeners: {
single: true,
afterrender: function(cmp) {
cmp.on('click',function (){me.streamDeviceStore.reload()});
var refImg = cmp.el.child('img.refresh');
refImg.addClassOnOver('mouse-over');
refImg.on('click', me.streamDeviceStore.reload, me);
}
}
},
'-'
]
});

FM.gridContextMenu = new QNAP.QOS.FM.Menu({
itemId : 'theContextMenu',
cls : 'FM-createBtn-cls FM-moreActionMenuList-cls',
data : {
selected : []
},
streamFile:true,
listeners: {
beforeshow : function(menu){
},
show : function(cmp) {
cmp.el.setZIndex(Ext.getCmp(FM.fsWinId).el.zindex+1);
FM.checkHLine(cmp);
cmp.removeClass('qnap-menu-v2');
cmp.doLayout();
}
},
items : [{
itemId : 'gcm_sortBtn',
iconCls : 'menuListSortBtn-iconCls',
text : _S._SFE_LANG_COMMON_SORT_BY,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_SORT_BY',
tooltip : '_SFE_LANG_COMMON_SORT',
hideOnClick:false,
menu : {
x : 1 - 10,
cls : 'FM-moreActionMenuList-cls',
shadow : false,
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
}
},
items : [{
itemId : 'sortName',
text : _S._SFE_LANG_COMMON_FILENAME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILENAME',
handler : function() {
FM.fileListStore.singleSort('natural');
}
}, {
text : _S._SFE_LANG_COMMON_MODIFIED_TIME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_MODIFIED_TIME',
itemId : 'sortMt',
handler : function() {
FM.fileListStore.singleSort('mt');
}
}, {
text : _S._SFE_LANG_COMMON_FILETYPE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILETYPE',
itemId : 'sortType',
handler : function() {
FM.fileListStore.singleSort('filetype');
}
}, {
text : _S._SFE_LANG_COMMON_FILESIZE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILESIZE',
itemId : 'sortSize',
handler : function() {
FM.fileListStore.singleSort('filesize');
}
}]
}

}, '-', {
itemId : 'gcm_newFolderBtn',
iconCls : 'menuListAddFolderBtn-iconCls',
text : _S._SFE_LANG_ACTION_MKDIR_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_MKDIR_TITLE',
tooltip : '_SFE_LANG_ACTION_MKDIR_TITLE',
handler : function() {
QNAP.QOS.fileExplorerAction.mkdir.call(FM);
}
}, {
itemId : 'gcm_copy',
text : _S._SFE_LANG_ACTION_COPY_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_COPY_TITLE',
iconCls : 'menuListCopyBtn-iconCls',
handler : function() {
var selections = FM.gridPanel.getSelectionModel()
.getSelections();
var qDatas = [];

for (var i = 0; i < selections.length; i++) {
var data = selections[i];
qDatas.push({
newWin : false,
appId : 'fileManager',
app : '',
size : data.get('filesize'),
iconName : 'images/icon/fm_main_icon.png',
displayName : data.get('filename'),
fullName : QNAP.QOS.fileExplorerTools.tool.getFullName(FM,data.get('filename')),
type : data.get('isfolder') == 1
? 'folder'
: 'file',
config : {
path : FM.currentPath
+ '/'
+ QNAP.QOS.fileExplorerTools.tool
.getFileNamPath(data
.get('filename'))[0]
}
});
}
QNAP.QOS.fileExplorerAction.copyAction(FM, FM.currentPath,
qDatas, 'copy', FM.currentHost);

}
}, {
itemId : 'gcm_past',
text : _S._SFE_LANG_COMMON_PAST,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PAST',
iconCls : 'menuPastBtn-iconCls',
handler : function() {
FM.fncBtns.getComponent('pastBtn').handler();
}
}, '-', {
itemId : 'gcm_shareLink',
text : _S._SFE_LANG_SHARELINK_TITLE_0,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_TITLE_0',
iconCls : 'menuListShareLinkBtn-iconCls',
hideOnClick :false,
handler : function() {
},
menu : FM.shareMenu()
}, '-',{
itemId : 'gcm_streamBtn',
text : _S._SFE_LANG_PS_STREAM_01,
qInternational : true,
qInternationalKey : '_SFE_LANG_PS_STREAM_01',
iconCls : 'streamBtn-iconCls',
width : 52,
height : 29,
hideOnClick :false,
menu: FM.streamDeviceMenu
}, {
itemId : 'gcm_play_main',
text : _S._SFE_LANG_COMMON_PLAY,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PLAY',
iconCls : 'playBtn-iconCls',
handler : function() {
FM.fncBtns.getComponent('moreActionBtn').menu
.getComponent('playBtn').handler();
}
}, {
itemId : 'gcm_play2',
text : _S._SFE_LANG_COMMON_PLAY,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PLAY',
iconCls : 'playBtn-iconCls',
hideOnClick :false,
menu : FM.playSubMenu(),
}, {
itemId : 'gcm_officeOLBtn',
text : _S._SFE_LANG_ACTION_VIEW_IN_OFFICE_ONLINE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_VIEW_IN_OFFICE_ONLINE',
cls : 'menuList-Open',
iconCls : 'officeOLBtn-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.openWithOlineDocs(FM,'msOffice');
}
},{
itemId : 'gcm_googleDocBtn',
text : _S._SFE_LANG_ACTION_OPEN_GOOGLE_DOCS_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_OPEN_GOOGLE_DOCS_TITLE',
cls : 'menuList-Open',
iconCls : 'googleDocBtn-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.openWithOlineDocs(FM,'googleDoc');
}
}, {
itemId : 'gcm_extOpBtn',
text : _S._SFE_LANG_COMMON_OPEN_WITH_CHROME_EXTENSION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OPEN_WITH_CHROME_EXTENSION',
cls : 'menuList-Open',
iconCls : 'extOpBtn-iconCls',
handler : function() {
var file = FM.gridPanel.getSelectionModel().getSelections();
FM.openWidthExtension(file);
}
}, {
itemId : 'gcm_qMailBtn',
text : _S._SFE_LANG_ACT_OPEN_WITH_QMAIL,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACT_OPEN_WITH_QMAIL',
cls : 'menuList-Open',
iconCls : 'qMailBtn-iconCls',
handler : function() {
var files = FM.gridPanel.getSelectionModel().getSelections();
FM.qmailOpen(FM.currentPath,files[0]);
}
}, {
itemId : 'gcm_open_main',
text : _S._SFE_LANG_COMMON_OPEN,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OPEN',
iconCls : 'openBtn-iconCls',
handler : function() {
FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('openBtn').handler();
}
},{
itemId : 'gcm_openWithVLCBtn',
text : _S._SFE_LANG_COMMON_OPEN_WITH_VLC,
qInternational : true,
cls : 'menuList-Open',
iconCls : 'vlcBtn-iconCls',
qInternationalKey : '_SFE_LANG_COMMON_OPEN_WITH_VLC',
handler : function() {
var files = FM.gridPanel.getSelectionModel()
.getSelections();
FM.open(files,null,true);
}
}, '-', {
itemId : 'gcm_download_main',
text : _S._SFE_LANG_ACTION_DOWNLOAD_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DOWNLOAD_TITLE',
iconCls : 'downloadBtn-iconCls',
handler : function() {
FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('downloadBtn2').handler();
}
}, {
itemId : 'gcm_download2',
text : _S._SFE_LANG_ACTION_DOWNLOAD_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DOWNLOAD_TITLE',
iconCls : 'downloadBtn-iconCls',
hideOnClick :false,
menu : {
x : 1 - 10,
cls : 'FM-moreActionMenuList-cls',
shadow : false,
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
}
},
items : [{
text : '240p',
itemId : '240p',
handler : function() {
var fromPath = FM.currentPath;
var files = FM.gridPanel.getSelectionModel()
.getSelections();
var fileName = '';
fileName = files[0].get('filename');
QNAP.QOS.fileExplorerAction.download(fromPath,
files, fileName, FM, 2, 'mp4_240');
files = undefined;
}
}, {
text : '360p',
itemId : '360p',
handler : function() {
var fromPath = FM.currentPath;
var files = FM.gridPanel.getSelectionModel()
.getSelections();
var fileName = '';
fileName = files[0].get('filename');
QNAP.QOS.fileExplorerAction.download(fromPath,
files, fileName, FM, 2, 'mp4_360');
files = undefined;
}
}, {
text : '480p',
itemId : '480p',
handler : function() {
var fromPath = FM.currentPath;
var files = FM.gridPanel.getSelectionModel()
.getSelections();
var fileName = '';
fileName = files[0].get('filename');
QNAP.QOS.fileExplorerAction.download(fromPath,
files, fileName, FM, 2, 'mp4_480');
files = undefined;
}
}, {
text : '720p',
itemId : '720p',
handler : function() {
var fromPath = FM.currentPath;
var files = FM.gridPanel.getSelectionModel()
.getSelections();
var fileName = '';
fileName = files[0].get('filename');
QNAP.QOS.fileExplorerAction.download(fromPath,
files, fileName, FM, 2, 'mp4_720');
files = undefined;
}
}, {
text : '1080p',
itemId : '1080p',
handler : function() {
var fromPath = FM.currentPath;
var files = FM.gridPanel.getSelectionModel()
.getSelections();
var fileName = '';
fileName = files[0].get('filename');
QNAP.QOS.fileExplorerAction.download(fromPath,
files, fileName, FM, 2, 'mp4_1080');
files = undefined;
}
}, {
text:_S._SFE_LANG_MEDIA_06,
qInternational : true,
qInternationalKey : '_SFE_LANG_MEDIA_06',
itemId : 'oFile',
handler : function() {
FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('downloadBtn2').handler();
}
}]
}
}, '-', {
itemId : 'gcm_rename',
text : _S._SFE_LANG_ACTION_RENAME_TITLE,
iconCls : 'menuListRename-iconCls',
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_RENAME_TITLE',
handler : function() {
QNAP.QOS.fileExplorerAction.rename(FM);
}
}, {
itemId : 'gcm_move',
text :_S._SFE_LANG_ACTION_COPY_TITLE_COPY_TO+'/'+ _S._SFE_LANG_ACTION_MOVE_TITLE_MOVE_TO,
qInternational : true,
qInternationalFn : function(cmp){
cmp.setText(_S._SFE_LANG_ACTION_COPY_TITLE_COPY_TO+'/'+ _S._SFE_LANG_ACTION_MOVE_TITLE_MOVE_TO);
},
hideOnClick :false,
iconCls : 'menuListMoveBtn-iconCls',
menu :{
cls : 'FM-moreActionMenuList-cls',
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
}
},
items:[{
itemId : 'copyTo',
text :_S._SFE_LANG_ACTION_COPY_TITLE_COPY_TO,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_COPY_TITLE_COPY_TO',
handler : function() {
var paramsObj = QNAP.QOS.fileExplorerTools.tool.getCopyMoveToObj.call(FM,'copy');
QNAP.QOS.fileExplorerTools.tool.showPopTreeWin.call(FM,paramsObj,QNAP.QOS.fileExplorerAction.copyMove);
}
},{
itemId : 'moveTo',
text :_S._SFE_LANG_ACTION_MOVE_TITLE_MOVE_TO,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_MOVE_TITLE_MOVE_TO',
handler : function() {
var paramsObj = QNAP.QOS.fileExplorerTools.tool.getCopyMoveToObj.call(FM,'move');
QNAP.QOS.fileExplorerTools.tool.showPopTreeWin.call(FM,paramsObj,QNAP.QOS.fileExplorerAction.copyMove);
}
}]
}
}, {
itemId : 'gcm_del',
text : _S._SFE_LANG_ACTION_DEL_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DEL_TITLE',
iconCls : 'menuListdeleteBtn-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.del(FM);
}
}, {
itemId : 'gcm_cut',
text : _S._SFE_LANG_COMMON_CUT,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CUT',
iconCls : 'menuListCutBtn-iconCls',
handler : function() {
var selections = FM.gridPanel.getSelectionModel()
.getSelections();
var qDatas = [];

for (var i = 0; i < selections.length; i++) {
var data = selections[i];
qDatas.push({
newWin : false,
appId : 'fileManager',
app : '',
size : data.get('filesize'),
iconName : 'images/icon/fm_main_icon.png',
displayName : data.get('filename'),
fullName : QNAP.QOS.fileExplorerTools.tool.getFullName(FM,data.get('filename')),
type : data.get('isfolder') == 1
? 'folder'
: 'file',
config : {
path : FM.currentPath
+ '/'
+ QNAP.QOS.fileExplorerTools.tool
.getFileNamPath(data
.get('filename'))[0]
}
});
}
QNAP.QOS.fileExplorerAction.copyAction(FM, FM.currentPath,
qDatas, 'move', FM.currentHost);

}
}, '-', {
itemId : 'gcm_transcodeBtn_main',
text : _S._SFE_LANG_ACTION_TRANSCODE_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_TRANSCODE_TITLE',
iconCls : 'menuListShareFolderBtn-iconCls',
hidden : !QNAP.QOS.user.isAdminGroup,
handler : function() {
FM.fncBtns.getComponent('moreActionBtn').menu
.getComponent('transcodeBtn').handler();
}
}, {
itemId : 'gcm_delTmpVideoBtn',// delete transcoded
text : _S._SFE_LANG_ACTION_DELETE_TRANSCODED,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DELETE_TRANSCODED',
iconCls : 'menuListRecycleDelBtn-iconCls',
handler : function() {
FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('delTmpVideoBtn').handler();
}
}, {
itemId : 'gcm_transInfoBtn',
text : _S._SFE_LANG_ACTION_TRANSCODE_INFORMATION_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_TRANSCODE_INFORMATION_TITLE',
iconCls : 'menuListTransInfoBtn-iconCls',
hidden : FM.isWFM || !QNAP.QOS.user.isAdminGroup,
handler : function() {
os.openApp('systemPreferences', {
fn : 'transcodeInfo',
})
}
}, '-', {
itemId : 'gcm_createShortcut',
text : _S._SFE_LANG_ACTION_CREATE_SHORTCUT_TO_DESKTOP,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_CREATE_SHORTCUT_TO_DESKTOP',
iconCls : 'menuListAddFav-iconCls',
handler : function() {
var selections = FM.gridPanel.getSelectionModel().getSelections();
FM.shortcutToDesk(selections[0]);
}
}, {
itemId : 'gcm_addToFav',
text : _S._SFE_LANG_ACTION_Add_To_Favorites,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_Add_To_Favorites',
iconCls : 'menuListAddFav-iconCls',
handler : function() {
var selections = FM.gridPanel.getSelectionModel()
.getSelections();
FM.addFavorite(FM.currentPath + '/'
+ selections[0].get('filename'),
selections[0].get('filename'));
}
}, {
itemId : 'gcm_removeFav',
text : _S._SFE_LANG_ACTION_REMOVE_FROM_FAVORITES,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_REMOVE_FROM_FAVORITES',
iconCls : 'menuListRemoveFav-iconCls',
scope : this,
handler : function() {
var selections = FM.gridPanel.getSelectionModel().getSelections();
FM.removeFavorite(FM.currentPath + '/' + selections[0].get('filename'), selections[0].get('filename'));
}
}, '-', {
itemId : 'gcm_extract_main',
text : _S._SFE_LANG_ACTION_EXTRACT_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_EXTRACT_TITLE',
iconCls : 'menuListExtract-iconCls',
hideOnClick :false,
menu : new Ext.menu.Menu({
cls : 'FM-moreActionMenuList-cls',
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
},
beforeshow : function(menu) {
var file = FM.gridPanel.getSelectionModel().getSelections()[0];
var extractName=file.get('filename').substring(0, file.get('filename').lastIndexOf('.'));
menu.getComponent('gcm_extract_to').setText(_S._SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_TO+ ' /'+extractName+'/');
}
},
items : [{
itemId : 'gcm_extract',
text : _S._SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_FILES
+ '...',
qInternational : true,
qInternationalFn : function(cmp) {
cmp
.setText(_S._SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_FILES
+ '...');
},
handler : function() {
QNAP.QOS.fileExplorerAction.extract(FM);
}
}, {
itemId : 'gcm_extract_here',
text : _S._SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_HERE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_HERE',
handler : function() {
QNAP.QOS.fileExplorerAction.extractDo(FM, 'here');
}
}, {
itemId : 'gcm_extract_to',
text : _S._SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_TO,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_EXTRACT_TITLE_EXTRACT_TO',
handler : function() {
QNAP.QOS.fileExplorerAction.extractDo(FM, 'to');
}
}]
})
}, {
itemId : 'gcm_compressBtn',
text : _S._SFE_LANG_COMMON_COMPRESS,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_COMPRESS',
cls : 'gcm_compressBtn-cls',
iconCls : 'menuListCompressBtn-iconCls',
handler : function() {
FM.Compress();
}
}, '-', {
itemId : 'gcm_mount',
text : _S._SFE_LANG_ACTION_MOUNT_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_MOUNT_TITLE',
iconCls : 'menuListMount-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.mount(FM);
}
}, '-', {
itemId : 'gcm_recycleDelBtn',
text : _S._SFE_LANG_ACTION_DEL_FROM_RECYCLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DEL_FROM_RECYCLE',
cls : 'gcm_recycleDelBtn-cls',
iconCls : 'menuListRecycleDelBtn-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.del(FM);
}
}, {
itemId : 'gcm_recycleRcvBtn',
text : _S._SFE_LANG_COMMON_RECOVER,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_RECOVER',
cls : 'gcm_recycleRcvBtn-cls',
iconCls : 'menuListRecycleRcvBtn-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.recycleRcv(FM);
}
}, {
itemId : 'gcm_recycleEmptyBtn',
text : _S._SFE_LANG_ACTION_EMPTY_RECYCLE_BIN,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_EMPTY_RECYCLE_BIN',
cls : 'gcm_recycleEmptyBtn-cls',
iconCls : 'menuListRecycleEmptyBtn-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.recycleEmpty(FM);
}
}, '-', {
itemId : 'gcm_properties',
text : _S._SFE_LANG_ACTION_PROPERTIES_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_PROPERTIES_TITLE',
iconCls : 'menuListPropertiesBtn-iconCls',
handler : function() {
FM.fncBtns.getComponent('moreActionBtn').menu
.getComponent('propertiesBtn').handler();
}
},{
itemId : 'gcm_versionsBtn',
text : _S._SFE_LANG_PREVIOUS_VERSIONS,
qInternational : true,
qInternationalKey : '_SFE_LANG_PREVIOUS_VERSIONS',
cls : 'versionsBtn-cls',
iconCls : 'versionsBtn-iconCls',
handler : function(btn) {
FM.openVersions();
}
}]
}); // gridContextMenu End
me.clientGridContextMenu = new Ext.menu.Menu({
itemId : 'theContextMenu',
cls : 'FM-createBtn-cls FM-moreActionMenuList-cls',
data : {
selected : []
},
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
}
},
items : [{
itemId : 'gcm_del',
text : _S._SFE_LANG_ACTION_DEL_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DEL_TITLE',
iconCls : 'menuListdeleteBtn-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.del(FM);
}
}, {
itemId : 'gcm_rename',
text : _S._SFE_LANG_ACTION_RENAME_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_RENAME_TITLE',
iconCls : 'menuListRename-iconCls',
handler : function() {
QNAP.QOS.fileExplorerAction.rename(FM);
}
}]
});
FM.treeContextMenu = new QNAP.QOS.FM.Menu({
itemId : 'menu_tree',
cls : 'FM-createBtn-cls FM-moreActionMenuList-cls',
listeners:{
hide:function(menu,a,b){
FM.treeNodeId = null;
var el = FM.treePanel.getEl();
el.un('wheel', this.stopWhell);
el.un('mousewheel', this.stopWhell);
el.removeClass('x-tree-skip-over');
if(this.treeNode && this.treeNode.getUI())
this.treeNode.getUI().removeClass('x-tree-node-menu-target');
},
show: function (menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
var el = FM.treePanel.getEl();
el.on('wheel', this.stopWhell);
el.on('mousewheel', this.stopWhell);
el.addClass('x-tree-skip-over');
this.treeNode.getUI().addClass('x-tree-node-menu-target');
}
},
stopWhell: function (e){
e.stopEvent();
},
items : [{
text: _S._SFE_LANG_REMOTE_MOUNT,
itemId: 'tcm_mount_remote',
iconCls: 'remoteMountBtn-iconCls',
qInternational: true,
qInternationalKey: '_SFE_LANG_REMOTE_MOUNT',
handler: FM.mountRemoteDevice.bind(FM)
}, {
text: _S._SFE_LANG_REMOTE_UNMOUNT,
itemId: 'tcm_umount_remote',
iconCls: 'remoteUmountBtn-iconCls',
qInternational: true,
qInternationalKey: '_SFE_LANG_REMOTE_UNMOUNT',
handler: FM.umountRemoteDevice.bind(FM)
}, {
text: _S._SFE_LANG_REMOTE_EDIT,
itemId: 'tcm_edit_remote',
iconCls: 'menuListPropertiesBtn-iconCls',//'remoteEditBtn-iconCls',
qInternational: true,
qInternationalKey: '_SFE_LANG_REMOTE_EDIT',
handler: FM.editRemoteDevice.bind(FM)
}, {
text: _S._SFE_LANG_REMOTE_REMOVE,
itemId: 'tcm_remove_remote',
iconCls: 'remoteRemoveBtn-iconCls',
qInternational: true,
qInternationalKey: '_SFE_LANG_REMOTE_REMOVE',
handler: FM.removeRemoteDevice.bind(FM)
}, {
text: _S._SFE_LANG_COMMON_REFRESH,
itemId: 'tcm_reload_remote',
iconCls: 'remoteRefreshBtn-iconCls',
qInternational: true,
qInternationalKey: '_SFE_LANG_COMMON_REFRESH',
handler: FM.reloadRemoteTree.bind(FM)
}, '-', {
itemId : 'tcm_copyBtn',
text : _S._SFE_LANG_ACTION_COPY_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_COPY_TITLE',
iconCls : 'menuListCopyBtn-iconCls',
scope : this,
handler : function() {
var appTag = FM._getAppInfo().app,
qDatas = {
app : appTag,
from : FM.treeNode.parentNode.id,
type : 'folder',
appId : 'fileManager',
newWin : false,
iconName : 'icon-folder-{0}.png',
fullName : FM.treeNode.id,
displayName : FM.treeNode.text,
config : {
path : FM.treeNode.id
}
},
matched = /^(fav_)?(\/remote:\d+@[0-9a-f]{40}.*)$/.exec(FM.treeNode.id);
if (matched) {
var path = matched[2], from, displayName;
if (path.lastIndexOf('/') > 0) {
from = path.split('/');
displayName = from.pop();
from = from.join('/');
} else {
from = path;
displayName = FM.treeNode.text;
}
qDatas = Ext.apply(qDatas, {
from : from,
fullName : path,
displayName : displayName,
config : {
path : path
}
});
}else if(FM.treeNode.id.indexOf('fav_')==0){
var from=FM.treeNode.id.replace('fav_','');
qDatas = {
app : appTag,
from : from.substring(0, from.lastIndexOf('/')),
type : 'folder',
appId : 'fileManager',
newWin : false,
iconName : 'icon-folder-{0}.png',
fullName : FM.treeNode.id.replace('fav_',''),
displayName : FM.treeNode.text,
config : {
path : FM.treeNode.id.replace('fav_','')
}
};
}
var sourceHost;
if (FM.treeNode.id.indexOf(":\\") >= 0) {
sourceHost = 'Client';
} else {
sourceHost = 'NAS';
}
QNAP.QOS.fileExplorerAction.copyAction(FM, qDatas.from, [qDatas], 'copy', sourceHost);
}
}, {
itemId : 'tcm_cut',
text : _S._SFE_LANG_COMMON_CUT,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CUT',
disabled : false,
iconCls : 'menuListCutBtn-iconCls',
handler : function() {var qDatas = [];
var appTag = FM._getAppInfo().app;
qDatas.push({
newWin : false,
appId : 'fileManager',
app : appTag,
iconName : 'icon-folder-{0}.png',
displayName : FM.treeNode.text,
fullName : FM.treeNode.id,
type : 'folder',
from : FM.treeNode.parentNode.id,
config : {
path : FM.treeNode.id
}
});
var sourceHost;
if (FM.treeNode.id.indexOf(":\\") >= 0) {
sourceHost = 'Client';
} else {
sourceHost = 'NAS';
}
QNAP.QOS.fileExplorerAction.copyAction(FM,FM.treeNode.parentNode.id, qDatas, 'move',sourceHost);}
}, {
itemId : 'tcm_copyMove',
text :_S._SFE_LANG_ACTION_COPY_TITLE_COPY_TO+'/'+ _S._SFE_LANG_ACTION_MOVE_TITLE_MOVE_TO,
qInternational : true,
qInternationalFn : function(cmp){
cmp.setText(_S._SFE_LANG_ACTION_COPY_TITLE_COPY_TO+'/'+ _S._SFE_LANG_ACTION_MOVE_TITLE_MOVE_TO);
},
iconCls : 'menuListMoveBtn-iconCls',
hideOnClick :false,
menu : new QNAP.QOS.FM.Menu({
items: [{
itemId : 'copyTo',
text :_S._SFE_LANG_ACTION_COPY_TITLE_COPY_TO,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_COPY_TITLE_COPY_TO',
handler : function() {
var paramsObj = QNAP.QOS.fileExplorerTools.tool.getCopyMoveToObj_Tree('copy',FM.treeNode.id);
var qDatas = [{
from : paramsObj.source_path,
newWin : false,
appId : 'fileExplorer',
iconName : 'images/icon/fm_main_icon.png',
displayName : paramsObj.source_file,
fullName : paramsObj.source_path+'/'+paramsObj.source_file,
type : 'folder',
config : {
path : paramsObj.source_path+'/'+paramsObj.source_file
}
}];
paramsObj.source_file=qDatas;
QNAP.QOS.fileExplorerTools.tool.showPopTreeWin.call(FM,paramsObj,QNAP.QOS.fileExplorerAction.copyMove);
}
}, {
itemId : 'moveTo',
text :_S._SFE_LANG_ACTION_MOVE_TITLE_MOVE_TO,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_MOVE_TITLE_MOVE_TO',
handler : function() {
var paramsObj = QNAP.QOS.fileExplorerTools.tool.getCopyMoveToObj_Tree('move',FM.treeNode.id);
var qDatas = [{
from : paramsObj.source_path,
newWin : false,
appId : 'fileExplorer',
iconName : 'images/icon/fm_main_icon.png',
displayName : paramsObj.source_file,
fullName : paramsObj.source_path+'/'+paramsObj.source_file,
type : 'folder',
config : {
path : paramsObj.source_path+'/'+paramsObj.source_file
}
}];
paramsObj.source_file=qDatas;
QNAP.QOS.fileExplorerTools.tool.showPopTreeWin.call(FM,paramsObj,QNAP.QOS.fileExplorerAction.copyMove);
}
}]
})
}, {
itemId : 'tcm_past',
text : _S._SFE_LANG_COMMON_PAST,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PAST',
scope : this,
iconCls : 'menuPastBtn-iconCls',
handler : function(pastBtn,b,c) {
if (QNAP.QOS.FileClipBoard.sourcePath == FM.treeNode.id) {
QNAP.QOS.fileExplorerAction.pastAction(FM, 2);
} else {
FM.pasteFile();
}
}
}, {
itemId : 'tcm_del',
text : _S._SFE_LANG_ACTION_DEL_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DEL_TITLE',
width : 50,
iconCls : 'menuListdeleteBtn-iconCls',
tooltip : '_SFE_LANG_ACTION_DEL_TITLE',
handler : function() {
QNAP.QOS.fileExplorerAction.del(FM,FM.treeNode);
}
}, {
itemId : 'tcm_mkdir',
iconCls : 'menuListAddFolderBtn-iconCls',
text : _S._SFE_LANG_ACTION_MKDIR_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_MKDIR_TITLE',
tooltip : '_SFE_LANG_ACTION_MKDIR_TITLE',
handler : function() {
QNAP.QOS.fileExplorerAction.mkdir.call(FM,FM.treeNode);
}
}, {
itemId : 'tcm_rename',
text : _S._SFE_LANG_ACTION_RENAME_TITLE,
iconCls : 'menuListRename-iconCls',
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_RENAME_TITLE',
handler : function() {
QNAP.QOS.fileExplorerAction.rename(FM,FM.treeNode);
}
}, {
itemId : 'tcm_compressBtn',
text : _S._SFE_LANG_COMMON_COMPRESS,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_COMPRESS',
cls : 'menuList-compressBtn-cls',
iconCls : 'menuListCompressBtn-iconCls',
handler : function() {
FM.Compress(FM.treeNodeId);
}
}, {
itemId : 'tcm_download',
text : _S._SFE_LANG_ACTION_DOWNLOAD_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DOWNLOAD_TITLE',
iconCls : 'downloadBtn-iconCls',
handler : function() {
var record = new Ext.data.Record({
filename:FM.treeNode.id.split('/').pop(),
isfolder:1
});
var fromPath=FM.treeNode.id.substring(0, FM.treeNode.id.lastIndexOf('/'));
if(FM.treeNode && FM.treeNode.id.split('/').length==2 && FM.treeNode.id.indexOf('/remote:')==0){
fromPath=FM.treeNode.id;
record = new Ext.data.Record({
filename:'.',
isfolder:1
});
}
QNAP.QOS.fileExplorerAction.download(fromPath,[record], FM.treeNode.id.split('/').pop(), FM);
}
}, {
itemId : 'tcm_share',
text : _S._SFE_LANG_SHARELINK_TITLE_0,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_TITLE_0',
iconCls : 'menuListShareLinkBtn-iconCls',
hideOnClick :false,
handler : function() {
},
menu : FM.shareMenu()
}, {
itemId : 'tcm_unmount',
text : _S._SFE_LANG_ACTION_UNMOUNT_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_UNMOUNT_TITLE',
iconCls : 'menuListUnmount-iconCls',
scope : this,
handler : function() {
QNAP.QOS.fileExplorerAction.unmount(FM);
}
}, {
itemId : 'tcm_createShortcut',
text : _S._SFE_LANG_ACTION_CREATE_SHORTCUT_TO_DESKTOP,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_CREATE_SHORTCUT_TO_DESKTOP',
iconCls : 'menuListAddFav-iconCls',
handler : function() {
var fromPath=FM.treeNode.id.substring(0, FM.treeNode.id.lastIndexOf('/'));
var record= new Ext.data.Record({
filename:FM.treeNode.id.split('/').pop(),
filepath:fromPath,
isfolder:1
});

FM.shortcutToDesk(record);
}
}, {
itemId : 'tcm_addFav',
text : _S._SFE_LANG_ACTION_Add_To_Favorites,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_Add_To_Favorites',
iconCls : 'menuListAddFav-iconCls',
scope : this,
handler : function() {
var fileName = FM.treeNodeId.replace(/.*\//, '');
FM.addFavorite(FM.treeNodeId, fileName);
}
}, {
itemId : 'tcm_removeFav',
text : _S._SFE_LANG_ACTION_REMOVE_FROM_FAVORITES,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_REMOVE_FROM_FAVORITES',
iconCls : 'menuListRemoveFav-iconCls',
scope : this,
handler : function() {
FM.removeFavorite(FM.treeNodeId);
}

}, {
itemId : 'tcm_transcodeBtn_main',
text : _S._SFE_LANG_ACTION_TRANSCODE_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_TRANSCODE_TITLE',
iconCls : 'menuListShareFolderBtn-iconCls',
hidden : !QNAP.QOS.user.isAdminGroup,
disabled : !QNAP.QOS.user.isAdminGroup,
handler : function() {
FM.addToTransCode(FM.treeNodeId);
}
}, {
itemId : 'tcm_delTmpVideoBtn',// delete transcoded
text : _S._SFE_LANG_ACTION_DELETE_TRANSCODED,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DELETE_TRANSCODED',
iconCls : 'menuListRecycleDelBtn-iconCls',
hidden : !QNAP.QOS.user.isAdminGroup,
disabled : !QNAP.QOS.user.isAdminGroup,
handler : function() {
FM.delTransCode(FM.treeNodeId);
}
}, {
itemId : 'tcm_storageInfo',
text : _S._SFE_LANG_MSG_STORAGE_INFO,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_STORAGE_INFO',
cls : 'storageInfoBtn-cls',
iconCls : 'storageInfoBtn-iconCls',
handler : function(btn) {
if(FM.treeNode.id)
FM.showStorageInfoWin(FM.treeNode.id.split('/')[1]);
}
}, {
itemId : 'tcm_properties',
text : _S._SFE_LANG_ACTION_PROPERTIES_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_PROPERTIES_TITLE',
iconCls : 'menuListPropertiesBtn-iconCls',
handler : function() {
var northPanel = Ext.getCmp(FM.northPanelId);
var eastPanelBtn = northPanel.items.items[northPanel.items.items.length
- 1];
var eastcmp = FM._getMainWindow().layout.east;
if (!eastcmp.isVisible()) {
eastPanelBtn.btnEl.dom.click();
} else {
}
FM.setPropertyPanelInfo([], FM.treeNodeId);
}
}]
});
FM.playShareMenu = new Ext.menu.Menu({
x : 1 - 10,
width : 215,
cls : 'FM-moreActionMenuList-cls',
listeners : {
show : function(menu) {
menu.removeClass('qnap-menu-v2');
var grid = FM.share2MeBtns.getGrid();
var selections = grid.getSelectionModel().getSelections();
var file = selections[0];
var mediaType = QNAP.QOS.fileExplorerTools.tool
.getMultiMediaType(file.get('filename'));
if (selections.length != 1 || mediaType != 'isVideo') {
return;
}
menu.getComponent('240p').setVisible(file.get('mp4_240') != 1
&& FM.share2MeBtns.allowTrans);
menu.getComponent('360p').setVisible(file.get('mp4_360') != 1
&& FM.share2MeBtns.allowTrans);
menu.getComponent('480p').setVisible(file.get('mp4_480') != 1
&& FM.share2MeBtns.allowTrans);
menu.getComponent('720p').setVisible(file.get('mp4_720') != 1
&& FM.share2MeBtns.allowTrans);
menu.getComponent('1080p').setVisible(file.get('mp4_1080') != 1
&& FM.share2MeBtns.allowTrans);

menu.getComponent('mp4_240').setVisible(file.get('mp4_240') == 1);
menu.getComponent('mp4_360').setVisible(file.get('mp4_360') == 1);
menu.getComponent('mp4_480').setVisible(file.get('mp4_480') == 1);
menu.getComponent('mp4_720').setVisible(file.get('mp4_720') == 1);
menu.getComponent('mp4_1080').setVisible(file.get('mp4_1080') == 1);
menu.doLayout();
}
},
items : [{
itemId : '240p',
text : '240p(' + _S._SFE_LANG_ON_THE_FLY_TRANSCODING + ')',
handler : function(cmp) {
FM.share2MeBtns.playTrans(cmp.itemId);
}
}, {
itemId : 'mp4_240',
text : '240p',
handler : function(cmp) {
FM.share2MeBtns.playTrans(cmp.itemId);
}
}, {
itemId : '360p',
text : '360p(' + _S._SFE_LANG_ON_THE_FLY_TRANSCODING + ')',
handler : function(cmp) {
FM.share2MeBtns.playTrans(cmp.itemId);
}
}, {
itemId : 'mp4_360',
text : '360p',
handler : function(cmp) {
FM.share2MeBtns.playTrans(cmp.itemId);
}
}, {
itemId : '480p',
text : '480p(' + _S._SFE_LANG_ON_THE_FLY_TRANSCODING + ')',
handler : function(cmp) {
FM.share2MeBtns.playTrans(cmp.itemId);
}
}, {
itemId : 'mp4_480',
text : '480p',
handler : function(cmp) {
FM.share2MeBtns.playTrans(cmp.itemId);
}
}, {
itemId : '720p',
text : '720p(' + _S._SFE_LANG_ON_THE_FLY_TRANSCODING + ')',
handler : function(cmp) {
FM.share2MeBtns.playTrans(cmp.itemId);
}
}, {
itemId : 'mp4_720',
text : '720p',
handler : function(cmp) {
FM.share2MeBtns.playTrans(cmp.itemId);
}
}, {
itemId : '1080p',
text : '1080p(' + _S._SFE_LANG_ON_THE_FLY_TRANSCODING + ')',
handler : function(cmp) {
FM.share2MeBtns.playTrans(cmp.itemId);
}
}, {
itemId : 'mp4_1080',
text : '1080p',
handler : function(cmp) {
FM.share2MeBtns.playTrans(cmp.itemId);
}
}, {
itemId : 'originalFile',
text : _S._SFE_LANG_COMMON_ORIGINAL_FILE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_ORIGINAL_FILE',
handler : function() {
var grid = FM.share2MeBtns.getGrid();
var selections = grid.getSelectionModel().getSelections();
var file = selections[0];
var parmsStr = '';
var ep='LS0tLQ==';
if (grid.itemId == 'share2MeGrid') {
if(!Ext.isEmpty(file.get('access_code').replace('----',''))){
ep=QNAP.lib.encryption.ezEncode(file.get('access_code'));
}
parmsStr = 'ssid=' + file.get('ssid')
+ '&ep='+ep+'&open=normal';
} else if (grid.itemId == 'shareSubListGrid') {
if(FM.shareSubListStore.pwd){
ep=QNAP.lib.encryption.ezEncode(FM.shareSubListStore.pwd);
}
parmsStr = 'ssid=' + file.get('ssid') + '&fid='
+ file.get('fid') + '&ep='+ep+'&open=normal';
} else if (grid.itemId == 'shareFolderCTNGrid') {
var fid = '';
if (!Ext.isEmpty(FM.shareFolderCTNStore.baseParams.fid)) {
fid = '&fid=' + FM.shareFolderCTNStore.baseParams.fid;
}
if(FM.shareFolderCTNStore.baseParams.pwd){
ep=QNAP.lib.encryption.ezEncode(FM.shareFolderCTNStore.baseParams.pwd);
}
parmsStr = 'ssid='
+ FM.shareFolderCTNStore.baseParams.ssid
+ fid
+ '&path='
+ encodeURIComponent(FM.shareFolderCTNStore.baseParams.path)
+ '&filename='
+ encodeURIComponent(file.get('filename'))
+ '&ep='+ep+'&open=normal';
}
var dlForm = Ext.DomHelper.append(document.body, {
tag : 'form',
id : Ext.id(),
frameBorder : 0,
method : 'post',
action : '/share.cgi?' + parmsStr,
target : '_blank',
width : 0,
height : 0,
css : 'display:none;visibility:hidden;height:1px;'
}, false);
dlForm.submit();
}
}, {
itemId : 'vlcPlay',
text : _S._SFE_LANG_COMMON_OPEN_WITH_VLC,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OPEN_WITH_VLC',
hidden : Ext.isMac || Ext.isChrome,
handler : function() {
var grid = FM.share2MeBtns.getGrid();
var selections = grid.getSelectionModel().getSelections();
var file = selections[0];
var url = '';
var ep='LS0tLQ==';
if (grid.itemId == 'share2MeGrid') {
var fid = '&fid=' + file.get('ssid');
if(!Ext.isEmpty(file.get('access_code').replace('----',''))){
ep=QNAP.lib.encryption.ezEncode(file.get('access_code'));
}
url = file.get('download_link') + fid;
} else if (grid.itemId == 'shareSubListGrid') {
var fid = '&fid=' + file.get('fid');
url = '/share.cgi?ssid=' + file.get('ssid') + fid;
if(FM.shareSubListStore.pwd){
ep=QNAP.lib.encryption.ezEncode(FM.shareSubListStore.pwd);
}
} else if (grid.itemId == 'shareFolderCTNGrid') {
if(FM.shareFolderCTNStore.baseParams.pwd){
ep=QNAP.lib.encryption.ezEncode(FM.shareFolderCTNStore.baseParams.pwd);
}
var fid = '';
if (!Ext.isEmpty(FM.shareFolderCTNStore.baseParams.fid)) {
fid = '&fid='
+ FM.shareFolderCTNStore.baseParams.fid;
}
url = '/share.cgi?ssid='
+ FM.shareFolderCTNStore.baseParams.ssid
+ fid
+ '&path='
+ encodeURIComponent(FM.shareFolderCTNStore.baseParams.path)
+ '&filename='
+ encodeURIComponent(file.get('filename'))
+ '&open=normal';;
}
TMP_FN = {};
TMP_FN.getVLCInfo = function() {
return {
filePath : url+'&ep='+ep,
fileName : file.get('filename'),
downloadPath : url+'&ep='+ep,
buildYear : 2015
};
}
window.open('/cgi-bin/apps/fileManager/vlc.html', "_blank");
}
}]
});
FM.share2MeRMenu = new Ext.menu.Menu({
x : 1 - 10,
cls : 'FM-moreActionMenuList-cls',
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
}
},
items : [
{
itemId : 'copyBtn',
text : _S._SFE_LANG_ACTION_COPY_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_COPY_TITLE',
disabled : false,
height : 29,
iconCls : 'menuListCopyBtn-iconCls',
handler : function() {
FM.share2MeBtns.getComponent('copyBtn').handler();
}
}, {
itemId : 'pastBtn',
text : _S._SFE_LANG_COMMON_PAST,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PAST',
disabled : false,
height : 29,
iconCls : 'menuPastBtn-iconCls',
handler: function() {
QNAP.QOS.fileExplorerAction.pastAction(FM, 1);
}
},{
itemId : 'playShareBtn',
text : _S._SFE_LANG_COMMON_PLAY,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PLAY',
iconCls : 'playBtn-iconCls',
handler : function() {
},
menu : FM.playShareMenu
}, {
itemId : 'openBtn',
text : _S._SFE_LANG_COMMON_OPEN,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OPEN',
cls : 'menuList-Open',
iconCls : 'openBtn-iconCls',
handler : function() {
FM.share2MeBtns.getComponent('openBtn').handler();
}
}, {
text : _S._SFE_LANG_ACTION_DOWNLOAD_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DOWNLOAD_TITLE',
itemId : 'downloadBtn',
iconCls : 'downloadBtn-iconCls',
tooltip : '_SFE_LANG_ACTION_DOWNLOAD_TITLE',
width : 50,
handler : function() {
FM.share2MeBtns.getComponent('downloadBtn').handler();
}
}]
});
},
mountRemoteDevice: function() {
if (this.treeContextMenu.contextNode instanceof QNAP.QOS.FM.Remote.DeviceNode) {
this.treeContextMenu.contextNode.mountDevice();
}
},
umountRemoteDevice: function() {
if (this.treeContextMenu.contextNode instanceof QNAP.QOS.FM.Remote.DeviceNode) {
this.treeContextMenu.contextNode.umountDevice();
}
},
editRemoteDevice: function() {
if (this.treeContextMenu.contextNode instanceof QNAP.QOS.FM.Remote.DeviceNode) {
if (this.treeContextMenu.contextNode.disabled) {
this.treeContextMenu.contextNode.editDevice();
} else {
Ext.Msg.show({
msg: _S._SFE_LANG_REMOTE_WARNING_MSG_5,
icon: Ext.Msg.WARNING,
title: _S._SFE_LANG_REMOTE_WARNING_TITLE_2,
buttons: Ext.Msg.YESNO,
closable: false,
fn: (function(button) {
if (button == 'yes') {
this.treeContextMenu.contextNode.editDevice();
}
}).bind(this)
});
}
}
},
removeRemoteDevice: function() {
if (this.treeContextMenu.contextNode instanceof QNAP.QOS.FM.Remote.DeviceNode) {
this.treeContextMenu.contextNode.confirmRemoveDevice();
}
},
reloadRemoteTree: function() {
if (this.treeContextMenu.contextNode instanceof QNAP.QOS.FM.Remote.FolderNode) {
this.treeContextMenu.contextNode.reload();
}
},
loadPath : function(path, folder, expandTree, updateList) {
var FM = this;
var newPath = path;
var selNode = FM.treePanel.getSelectionModel().selNode;
if(path=='/home/.Qsync'){
FM.treeRoot.findChild('id', 'qsyncRoot').select();
}
if (folder.length > 0) {
newPath += '/' + folder;
}
if (folder.indexOf(path) >= 0) {
newPath = path + folder.split(path)[1]
}

if (selNode && (selNode.id == 'qsyncRoot' || selNode.parentNode.id == 'qsyncRoot') && FM.couldQsync == true) {
expandTree = false;
updateList = true;
}

if (expandTree) {
if(FM.currentVolTreeNode){
FM.openPath(newPath,null,FM.currentVolTreeNode.id);
}else{
FM.openPath(newPath);
}
}
if (updateList) {
FM.fileListStore.baseParams.path = newPath;
FM.fileListStore.load({
params : {
start : 0,
limit : QNAP.QOS.user.pageSize.wfm_file_list_page_size
|| 50
}
});
}
},// loadPath End
activeApp : function(config) {
var FM = this;
if(!FM.volMap){
if(config.path){
FM.activeAppConf=config;
FM.activeAppPath=config.path;
}
if(config.file){
FM.openAppFileName=config.file;
}
}else
FM.openPath(config.path, config.file);

FM.mon(os, 'serviceupdate', FM.onAppCenterMessage, FM);
FM.on('beforedestroy', function() {
FM.mun(os, 'serviceupdate', FM.onAppCenterMessage, FM);
});

FM.reloadCloudList(config);
},
onAppCenterMessage: function (appId, name, message) {
var FM = this;
message = message || {};
if (!(name == 'qpkg' && message.name == 'CloudDrive')) {
return;
}

var children = [];
FM.treeRoot.eachChild(function (node) {
if (node instanceof QNAP.QOS.FM.Remote.ServiceNode) {
switch (node.attributes.protocol) {
case 'cifs':
case 'ftpfs':
case 'davfs':
break;

default:
children.push(node);
}
}
});

while (children.length > 0) {
var node = children.pop();
FM.treeRoot.removeChild(node, true);
}
FM.reloadCloudList();
},
reloadCloudList: function(config) {
config = config || {};
var FM = this;
QNAP.QOS.FM.RPC.Remote.CloudList(function(response) {
FM.cloudDrives = response.datas || [];
for (var i = 0, size = FM.cloudDrives.length ; i < size ; ++i) {
var cloud = FM.cloudDrives[i];
cloud.auth_url = cloud.auth_url.replace(/http:\/\/<nas_ip>:<port>/, [window.location.protocol, '//', window.location.host, '/'].join(''));
var chkNode=FM.treeRoot.findChild('text',cloud.name);
if(Ext.isEmpty(chkNode)){
FM.treeRoot.insertBefore(
new QNAP.QOS.FM.Remote.ServiceNode(
{
cls: 'fm-treeRoot',
icon: cloud.icon_16,
text: cloud.name,
hidden: true,
protocol: cloud.protocol
},
FM
),
FM.treeRoot.lastChild
);
}
}
FM.fireEvent('clouddrives', FM.cloudDrives);
QNAP.QOS.FM.RPC.Remote.GetShare({
owner_name: QNAP.QOS.user.account
}, function(response) {
FM.sysSetting.remoteExceed = (response.count>=256);
if (response.status == 1) {
FM.fireEvent('remotedevice', response.datas, config.path, config.file);
}
});
});
},
openPath : function(path,fileName) {
var FM = this;
if(Ext.isEmpty(path)){// || FM.actPathIsExternal
return;
}
if (/^\/remote:\d+@[0-9a-f]{40}/.test(path)) {
if(!Ext.isEmpty(fileName)){
FM.fileListStore.baseParams.filename = fileName;
}
FM.treePanel.gotoPath(path);
return;
}
var volId=FM.volMap[path.split('/')[1]];
var volNode =FM.findVolNode(volId);
var pNode = FM.treeRoot.findChild('id', '/'+path.split('/')[1], true);
if(path.indexOf(FM.sysSetting.ubuntu_home_path)==0 || path == 'recycleBin'
|| (pNode && (pNode.attributes.iconCls=='usb-cls' || pNode.attributes.iconCls=='iso'))
){
volNode=null;
}
if (!Ext.isDefined(volNode)) {// path is disappeared
var node = FM.treeRoot.findChild('id', '/Multimedia', true);
if (Ext.isEmpty(node)) {
FM.openPath(FM.treeRoot.firstChild.firstChild.firstChild.id);
} else {
FM.openPath(node.id);
}
return;
}
FM.currentVolTreeNode=volNode;
if (path.substring(path.length - 1) == '/') {// 統一格式，最後一碼不要是'/'
path = path.substring(0, path.length - 1)
}
var nasRoot= FM.treeRoot.findChild('id', 'vol_root');

var folderPath = '';
var findFolder = false;

if (Ext.isEmpty(path) || path.trim().length == 0) {
return;
}
var findRootPath='/'+path.split('/')[1];
var root=nasRoot;
var shareFolder = '/' + (path.split('/')[1]);
QNAP.lib.cookie.set('treeRootPath' + QNAP.QOS.user.account, shareFolder, 60* 60 * 24 * 7);
if(path.indexOf('/home/.Qsync')==0){
FM.currentHost='NAS';
FM.setMainScr('file-panel');
var findNode = function() {
var node= FM.treeRoot.findChild('id', 'qsyncRoot', true);
if (node) {
node.select();
}
if(!Ext.isEmpty(fileName)){
FM.fileListStore.baseParams.filename=fileName;//會跳到指定的頁面
}
FM.fileListStore.baseParams.path = path;
FM.fileListStore.reload();
};
findNode();
}else if(path == '/home/@Recycle/.Qsync'){
FM.currentHost='NAS';
var findNode = function() {
var node= FM.treeRoot.findChild('id', 'qsyncRecycle', true);

if (node) {
node.select();
}
if(!Ext.isEmpty(fileName)){
FM.fileListStore.baseParams.filename=fileName;//會跳到指定的頁面
}
FM.fileListStore.baseParams.path = '/home/@Recycle/.Qsync';
FM.fileListStore.reload();
node.select();
};
}else if (path == 'recycleBin') {
var node= FM.treeRoot.findChild('id', 'recycleBin', true);
if (node) {
node.select();
FM.showRecycleBinGrid();
}
}else if (path != 'recycleBin' && FM.treePanel.getSelectionModel().selNode
&& FM.treePanel.getSelectionModel().selNode.id == 'recycleBin'
&& path.split('/')[2]=='@Recycle') {
FM.setMainScr('file-panel');
FM.fileListStore.baseParams.path = path;
FM.fileListStore.reload();
} else {
var swichModeBtn=Ext.getCmp(FM.northPanelId).getComponent('switchModeGroup').getComponent('mode2Btn');
if (swichModeBtn.pressed) {//for pre Step next step
FM.setMainScr('NasDataView-id');
} else {
FM.setMainScr('file-panel');
}
var folders = path.split('/');
folders.shift();
function findNode(node){
if(Ext.isEmpty(node)){
return
}
if(node.isExpanded()){
var pf=folders.shift()
var nid=node.id;
if(Ext.isDefined(nid) && Ext.isDefined(pf)){
nid=nid+'/'+pf;
}
if(Ext.isDefined(nid)){
if(path==nid){
if(!Ext.isEmpty(fileName)){
FM.fileListStore.baseParams.filename=fileName;//會跳到指定的頁面
}
var endNode=node.findChild('id',nid);
if(!Ext.isEmpty(endNode)){
endNode.select();
FM.gridPanel.store.baseParams.path=path;
FM.gridPanel.store.reload();
}else{
if(node.more2KNode){
var fldName=path.split('/').pop();
var tmpNode = new Ext.tree.AsyncTreeNode({
id : path,
text : fldName,
iconCls :'folder'
});
tmpNode.attributes.data = {
dirPath : tmpNode.id,
access : 7,
type : node.attributes.data.type,
isoFolder : 1,
noSupportACL : true
};
node.appendChild(tmpNode);
tmpNode.select();
tmpNode.fireEvent('click',tmpNode);
FM.gridPanel.store.baseParams.path=path;
FM.gridPanel.store.reload();
}else{
var pNodeId=nid.substring(0,nid.lastIndexOf('/'));
var pNode=FM.treePanel.root.findChild('id', pNodeId, true);
if(pNode){
pNode.reload();
pNode.on('expand',function(node){
node.findChild('id',nid).select();
});
}
FM.gridPanel.store.baseParams.path=path;
FM.gridPanel.store.reload();
}
}
}else{
findNode(node.findChild('id',nid));
}
}
}else{
if(folders.length>0){
node.expand();
node.on('expand',function(nd){
var subNode=node.findChild('id',node.id+'/'+folders.shift());
if(subNode){
findNode(subNode)
}else{
if(node.more2KNode){
var fldName=path.split('/').pop();
var tmpNode = new Ext.tree.AsyncTreeNode({
id : path,
text : fldName,
iconCls :'folder'
});
tmpNode.attributes.data = {
dirPath : tmpNode.id,
access : 7,
type : node.attributes.data.type,
isoFolder : 1,
noSupportACL : true
};

node.appendChild(tmpNode);
tmpNode.select();
tmpNode.fireEvent('click',tmpNode);
FM.gridPanel.store.baseParams.path=path;
FM.gridPanel.store.reload();

}else{
node.select();
node.fireEvent('click',node);
}
}
});
}else{
node.select();
node.fireEvent('click',node);
}
}
}
if(volId<0 || Ext.isEmpty(volNode)){//other folder: iso, usb......
var pt='/'+folders.shift();
var node=FM.nasRoot.findChild('id',pt);
if(path.indexOf(FM.sysSetting.ubuntu_home_path)==0){
node=FM.treeRoot.findChild('id', pt);
}
if(!Ext.isEmpty(node)){
node.expand();
findNode(node);
}
}else if(volNode.isExpanded()){
var pt='/'+folders.shift();
var node=volNode.findChild('id',pt);
if(path==node.id){
node.select();
if(!Ext.isEmpty(fileName)){
FM.fileListStore.baseParams.filename=fileName;//會跳到指定的頁面
}
FM.gridPanel.store.baseParams.path=path;
FM.gridPanel.store.reload();
}else{
findNode(node);
}
}else{
volNode.expand();
volNode.on('expand',function(Node){
var node=volNode.findChild('id','/'+folders.shift());
findNode(node);
});
}

}
FM.searchMode = false;
if(Ext.isEmpty(FM.activeAppPath)){
FM.activeAppPath=null;
}
if(Ext.isEmpty(FM.refreshPath)){
FM.refreshPath=null;
}
},// openPath End
removeFavorite : function(id, isDelFolder) {
var FM = this;
if (isDelFolder) {
var i = 0;
var delNodes = [];
FM.favoriteStore.each(function(record) {
if (record.id.trim().indexOf(id.trim()) >= 0) {
FM.favoriteStore.remove(record);
}
i++;
});
var data = [];
FM.favoriteStore.each(function(record) {
data.push(record.data);
});
QNAP.QOS.user.myFavorite = Ext.encode(data);
} else {
var index = FM.favoriteStore.indexOfId(id);
FM.favoriteStore.removeAt(index);
var data = [];
FM.favoriteStore.each(function(record) {
data.push(record.data);
});
QNAP.QOS.user.myFavorite = Ext.encode(data);
}
if (FM.favoriteStore.data.length == 0) {
FM.treeRoot.findChild('id', 'favorite_root').ui.hide();
}
FM.updateStar();
},// removeFavorite End
addFavorite : function(path, name) {
var FM = this, qtip;
if (path.indexOf('fav_') == 0) {
path = path.substring(4, path.length);
}

var node = FM.treePanel.root.findChild('id', path, true);
if (node instanceof QNAP.QOS.FM.Remote.FolderNode) {
qtip = node.attributes.qtip;
name = node.text;
}

FM.favoriteStore.loadData({
favorites : [{
path : path,
name : name,
qtip: qtip
}]
}, true);
var data = [];
FM.favoriteStore.each(function(record) {
data.push(record.data);
});
QNAP.QOS.user.myFavorite = Ext.encode(data);
FM.treeRoot.findChild('id', 'favorite_root').ui.show();
FM.treeRoot.findChild('id', 'favorite_root').expand();
FM.updateStar();
},// addFavorite End
shortcutToDesk : function(file) {
var FM = this, displayName;
var matched = /^(fav_)?(\/remote:\d+@[0-9a-f]{40})/.exec('/' + file.get('filename'));
if (matched) {
var node = FM.treePanel.root.findChild('id', matched[2], true);
if (!(node instanceof QNAP.QOS.FM.Remote.FolderNode)) {
return;
}
displayName = node.attributes.qtip;
}
var appInfo = QNAP.QOS.lib.getAppInfo('fileExplorer');
var qDatas = [{
from : file.get('filepath'),
newWin : false,
appId : 'fileExplorer',
iconName : 'images/icon/fm_main_icon.png',
displayName : displayName || file.get('filename'),
fullName : file.get('filepath')+'/'+file.get('filename'),
type : file.get('isfolder') == 1 ? 'folder' : 'file',
config : {
path : file.get('filepath')+'/'+file.get('filename')
}
}];



var hasSpace = os.desktop.shortcutsView.hasSpace(1);
if (hasSpace) {
os.desktop.shortcutsView.quickAdd(qDatas);
os.desktop.showMsg('', _S.CP_MSG_1);
} else {
os.desktop.showMsg('', _S.CP_MSG_2, false);
}
},// addFavorite End
showEastPanel : function() {
var FM = this;
if (!FM.propertyPanel)
FM.createPropertyPanel();
if (FM.currentHost == 'NAS') {
var selections = FM.gridPanel.getSelectionModel().getSelections();
if (selections.length > 0)
FM.setPropertyPanelInfo(selections);
} else if (FM.currentHost == 'Client') {
}
},// showEastPanel
closeEastPanel : function() {

},
advSearch : function(searchFlag, mediaType, saveFilter) {
var FM = this;
FM.searchFlag = searchFlag;
FM.searchMode = true;
var params = {};
var fileListPageBar=FM.centerPanel.bottomToolbar;
FM.searchComboBox.searchFlag=searchFlag;
if (searchFlag == 'adv') {
var searchType = FM.panelB.getComponent('searchType').data;
var dateType = FM.panelA.getComponent('dateType').data;
var fileSizeType, fileSizeTypeTemp = FM.panelA.getComponent('fileSizeType').getComponent('fileSizeType').getValue();
if (Ext.num(fileSizeTypeTemp) == 1) {
fileSizeType = 2;
} else {
fileSizeType = fileSizeTypeTemp;
}
var dateTypeCmpItems=FM.panelA.getComponent('dateType').items.items;
var date = dateTypeCmpItems[1].getValue();
var date2 = dateTypeCmpItems[2].getValue();
var dateType = dateTypeCmpItems[0].getValue();

if (date > date2 && dateType == 4) {
var msgObj = {
text : _S._SFE_LANG_MSG_TIME_ERROR,
key : '_SFE_LANG_MSG_TIME_ERROR'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,
'error', msgObj, btns);
MsgWin.show();
Ext.getCmp(FM.advSrBtnId).setDisabled(false);
return;
}
if (dateType == 4) {
date2 = new Date(date2).add(Date.DAY, 1);
}
var fileSize = FM.panelA.getComponent('fileSizeType').getComponent('fileSize').getValue();
var fileSize2 = FM.panelA.getComponent('fileSizeType').getComponent('fileSize').getValue()+ 1;
var CombofileSize = FM.panelA.getComponent('fileSizeType').getComponent('CombofileSize').getValue();// KB,MB or GB
for (var i = 0; i <= CombofileSize; i++) {
fileSize = fileSize * 1024;
}
for (var i = 0; i <= CombofileSize; i++) {
fileSize2 = fileSize2 * 1024;
}
var ownerType = FM.panelB.getComponent('ownerType').data;
var folders = FM.panelB.getComponent('folders').getValue()
.split(',');

var keyword;
if (FM.sysSetting.qsirch_enable == 1) {
keyword = FM.panelA.getComponent('qsirch').getComponent('qsirKeyword').getValue();
} else {
keyword = FM.panelA.getComponent('keywordO').getComponent('keyword').getValue();
}
var qsirchType=FM.panelA.getComponent('qsirch').getComponent('qsirchType').getValue();
params = {
qsirch:qsirchType,
keyword : keyword,
searchType : FM.panelB.getComponent('searchType').items.items[0].getValue(),
extensionName : searchType.extensionName,
fileSize : fileSize,
fileSizeType : fileSizeType,
owner : ownerType.owner,
ownerType : FM.panelB.getComponent('ownerType').items.items[0].getValue(),
dateType : dateType,
date : date,
date2 : date2,
dateField : '0',
sort : 'filename',
start : '0',
limit : fileListPageBar.pageSize,
folderArr : folders,
folderCount : 1, // 因多資料夾搜尋在前端實做,此參數固定為1,非寫錯
dir : 'ASC'
};

if(saveFilter){
if(params.keyword=='' &&
params.fileSizeType==0 &&
params.dateType==0 &&
params.searchType==0 &&
params.ownerType==0 ){
return;
}

params.CookiefileSizeType=fileSizeTypeTemp;
params.CookiefileSize=FM.panelA.getComponent('fileSizeType').getComponent('fileSize').getValue();
params.CookieCombofileSize=CombofileSize;
FM.saveFilter(params);
FM.searchMode=false;
FM.fileListStore.reload();
return ;
}
if (folders.length == 0 || folders[0] == '') {
params.folders = FM.currentPath;
}
} else if (searchFlag == 'smp') {
var stype = 0;
if (mediaType) {
stype = mediaType;
}
params = {
qsirch:FM.sysSetting.qsirch_enable,
keyword : FM.searchComboBox.getValue(),
searchType : stype,
extensionName : '',
fileSize : 0,
fileSizeType : 0,
owner : 0,
ownerType : 0,
dateType : 0,
date : '',
dateField : '0',
sort : 'filename',
start : '0',
limit : fileListPageBar.pageSize,
folderArr : [FM.currentPath],
folderCount : 1,
dir : 'ASC'
};
if(FM.sysSetting.qsirch_enable == 1){
delete params.folderArr;
params.folderArr=[];
FM.nasRootStore.data.each(function(item){
if(item.get('type')=='singlepath'){
params.folderArr.push(item.get('path'));
}
});
}
}
if (Ext.isEmpty(FM.sysSetting.qsirch_enable) ||　FM.sysSetting.qsirch_enable != 1){
delete params.qsirch;
}
FM.setSearchMode(true, params);
},
setPropertyPanelInfo : function(files, treeID) {
var FM = this;
var fileName, filePath;
var node = FM.treePanel.selModel.getSelectedNode();
var selNode = FM.treePanel.getSelectionModel().selNode;
if(!files && !treeID && (!selNode || selNode.id!='qsyncRoot')){
if(Ext.isEmpty(node) || (node.folderType!='shareFolder' && node.id.indexOf(FM.sysSetting.ubuntu_home_path)!=0)){
return;
}
treeID=node.id;
}
if(FM.propertyPanel && FM.propertyPanel.isVisible()){
FM.propertyPanel.getComponent('sizePanel').setHeight(22);
}
if (!FM.propertyPanel || !FM.propertyPanel.isVisible() || Ext.isEmpty(selNode)
|| ( (selNode.getPath().split('/')[2]!='vol_root' && FM.fileListStore.baseParams.path.indexOf('/remote:')<0) &&
node.id.indexOf(FM.sysSetting.ubuntu_home_path)!=0) && selNode.id!='qsyncRoot'
) {
return;
}

/**
* Bug#82758, part I
* show component
* @author Dian
*/
FM.propertyPanel.fbar.apply_property_btn.show();

var parentPath;
if (treeID) {
var parentPath = treeID.split('/')[1];
} else {
if (FM.searchMode) {
var F_P = QNAP.QOS.fileExplorerTools.tool.getFileNamPath(files[0].get('filename'));
parentPath = F_P[1].split('/')[1];
} else {
parentPath = FM.currentPath.split('/')[1];
}
}
var rnode = FM.nasRoot.findChild('id', '/' + parentPath);


if(Ext.isArray(files) && files.length==0){
files=null;
}
if(Ext.isEmpty(selNode) || (rnode && rnode.attributes.iconCls=='iso')
||(files &&( files.length>1 ||(files.length==1 && files[0].get('isfolder') == 0)
||files[0].get('filepath').split('/')[2]=='@Recycle'
||files[0].get('filename')=='@Recycle'
)
||(files && (rnode && rnode.attributes.iconCls=='usb-cls'))
||!FM.isOpenMediaLib
||!QNAP.QOS.user.isAdminGroup
||FM.isWFM

)
|| FM.fileListStore.baseParams.path.indexOf('/remote:')==0
|| FM.fileListStore.baseParams.path.indexOf(FM.sysSetting.ubuntu_home_path)==0
|| selNode.id=='qsyncRoot'
) {
FM.propertyPanel.getComponent('mediaFolderPanel').hide();
FM.propertyPanel.getComponent('resolutionPanel').hide();
FM.propertyPanel.getComponent('mediaFolderPanel').setHeight(0);
FM.propertyPanel.getComponent('resolutionPanel').setHeight(0);
FM.propertyPanel.getComponent('otherSettings').hide();
if(FM.propertyPanel.getComponent('otherSettings').body){
FM.propertyPanel.getComponent('otherSettings').body.hide();
}
FM.propertyPanel.getComponent('otherSettings').setHeight(0);
}else{
if(treeID){
if((rnode && rnode.attributes.iconCls=='usb-cls')
|| treeID.split('/')[2]=='@Recycle'
|| treeID.indexOf(FM.sysSetting.ubuntu_home_path)==0
){
FM.propertyPanel.getComponent('mediaFolderPanel').hide();
FM.propertyPanel.getComponent('resolutionPanel').hide();
FM.propertyPanel.getComponent('mediaFolderPanel').setHeight(0);
FM.propertyPanel.getComponent('resolutionPanel').setHeight(0);
FM.propertyPanel.getComponent('otherSettings').show();
FM.propertyPanel.getComponent('otherSettings').setHeight(260);
}else if(treeID.split('/')[1]=='home'){
FM.propertyPanel.getComponent('mediaFolderPanel').show();
FM.propertyPanel.getComponent('resolutionPanel').show();
FM.propertyPanel.getComponent('mediaFolderPanel').setHeight(100);
FM.propertyPanel.getComponent('resolutionPanel').setHeight(100);
FM.propertyPanel.getComponent('otherSettings').hide();
if(FM.propertyPanel.getComponent('otherSettings').body){
FM.propertyPanel.getComponent('otherSettings').body.hide();
}
FM.propertyPanel.getComponent('otherSettings').setHeight(0);
}else{
FM.propertyPanel.getComponent('mediaFolderPanel').show();
FM.propertyPanel.getComponent('resolutionPanel').show();
FM.propertyPanel.getComponent('mediaFolderPanel').setHeight(100);
FM.propertyPanel.getComponent('resolutionPanel').setHeight(100);
FM.propertyPanel.getComponent('otherSettings').show();
if(FM.propertyPanel.getComponent('otherSettings').body){
FM.propertyPanel.getComponent('otherSettings').body.show();
}
FM.propertyPanel.getComponent('otherSettings').setHeight(260);
}
FM.getShareFolderInfo(treeID);
}else if(files && files[0].get('isfolder') == 1 ){
FM.propertyPanel.getComponent('mediaFolderPanel').show();
FM.propertyPanel.getComponent('resolutionPanel').show();
FM.propertyPanel.getComponent('mediaFolderPanel').setHeight(100);
FM.propertyPanel.getComponent('resolutionPanel').setHeight(100);
FM.propertyPanel.getComponent('otherSettings').hide();
if(FM.propertyPanel.getComponent('otherSettings').body){
FM.propertyPanel.getComponent('otherSettings').body.hide();
}
FM.propertyPanel.getComponent('otherSettings').setHeight(0);
getRootShare(FM.gridPanel.store.baseParams.path+'/'+files[0].get('filename'));
}
if(FM.sysSetting.transcode_server_status <= 0){
FM.propertyPanel.getComponent('resolutionPanel').hide();
}
}
function getRootShare(path){
var params = {};
params['path'] = path;
params['is_iso'] = 0;
params['verbose'] = 1;
if(path.indexOf(FM.sysSetting.ubuntu_home_path)==0 || path=='qsyncRoot'){
if(path==FM.sysSetting.ubuntu_home_path){
FM.propertyPanel.getComponent('selItems').setValue(1);
FM.propertyPanel.getComponent('disp_name').setValue(node.text);
}
return;
}
Ext.Ajax.request({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,
'get_root_share'),
success : function(o) {

if (!QNAP.QOS.fileExplorerTools.tool
.checkResponseIfEmpty(o.responseText)) {
var rs = Ext.util.JSON.decode(o.responseText).datas[0];
FM.propertyPanel.getComponent('selItems').setValue(1);
if (rs) {
if (/^remote:\d+@[0-9a-f]{40}/.test(rs.filename)) {
var node = FM.treePanel.root.findChild('id', ['', rs.filename].join('/'), true);
FM.propertyPanel.getComponent('disp_name').setValue(node.text);
FM.propertyPanel.getComponent('disp_path').setValue(node.attributes.qtip);
} else {
FM.propertyPanel.getComponent('disp_name')
.setValue(rs.filename.split('/')
.pop());
}

FM.propertyPanel.getComponent('modifiedTime').setValue(rs.mt);
FM.propertyPanel.getComponent('owner').setValue(rs.owner);
FM.propertyPanel.getComponent('group').setValue(rs.group);
if(FM.fileListStore.baseParams.path.indexOf('/remote:')==0){
FM.propertyPanel.getComponent('owner').setValue('--');
FM.propertyPanel.getComponent('group').setValue('--');
}
}
FM.propertyPanel.getComponent('disp_name').show();
FM.propertyPanel.getComponent('fType').show();
FM.propertyPanel.getComponent('owner').show();
FM.propertyPanel.getComponent('group').show();
FM.propertyPanel.getComponent('fType')
.setValue(_S._SFE_LANG_COMMON_FOLDER);
FM.propertyPanel.getComponent('sizePanel')
.getComponent('size').setValue('');
FM.propertyPanel.getComponent('sizePanel')
.getComponent('getSizeBtn').show();
FM.propertyPanel.getComponent('fImg').hide();
var ppForm=FM.propertyPanel.getForm();
ppForm.findField('Music').setValue(rs.music==1);
ppForm.findField('Video').setValue(rs.video==1);
ppForm.findField('Photo').setValue(rs.photo==1);
ppForm.findField('240p').setValue(rs.trans_240==1);
ppForm.findField('360p').setValue(rs.trans_360==1);
ppForm.findField('480p').setValue(rs.trans_480==1);
ppForm.findField('720p').setValue(rs.trans_720==1);
ppForm.findField('1080p').setValue(rs.trans_1080==1);
FM.propertyPanel.originalTransValue=(rs.trans_240*1)+(rs.trans_360*2)+(rs.trans_480*8)+(rs.trans_720*4)+(rs.trans_1080*16);
if(!ppForm.findField('Music').getValue() &&
!ppForm.findField('Video').getValue() &&
!ppForm.findField('Photo').getValue()){
FM.propertyPanel.mediaFolder=false;
}else{
FM.propertyPanel.mediaFolder=true;
}

} else {
var msgObj = {
text : _S._SFE_LANG_COMMON_MSG_UNKNOW_ERROR,
key : '_SFE_LANG_COMMON_MSG_UNKNOW_ERROR'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg
.call(FM, 'error', msgObj, btns);
MsgWin.show();
}
},
failure : function(o) {

},
params : params
});
}
if (treeID) {
if (FM.currentHost == 'NAS' && FM.gridPanel.store.baseParams.path) {
getRootShare(treeID);
FM.getShareFolderInfo(treeID);
}
FM.propertyPanel.getComponent('disp_path').setValue(treeID.substring(0,treeID.lastIndexOf('/')));
FM.propertyPanel.doLayout();
} else if ((files == null || files.length == 0) && !treeID) {
if (FM.currentHost == 'NAS' && FM.gridPanel.store.baseParams.path) {
getRootShare(FM.currentPath);

FM.getShareFolderInfo(FM.currentPath);
} else {
FM.propertyPanel.getComponent('selItems').setValue(0);
FM.propertyPanel.getComponent('disp_name').setValue('');
FM.propertyPanel.getComponent('disp_name').hide();
FM.propertyPanel.getComponent('fType').setValue('');
FM.propertyPanel.getComponent('fType').hide();
FM.propertyPanel.getComponent('sizePanel').getComponent('size').setValue('');
FM.propertyPanel.getComponent('sizePanel').getComponent('getSizeBtn').hide();
FM.propertyPanel.getComponent('modifiedTime').setValue('');
FM.propertyPanel.getComponent('modifiedTime').hide();
FM.propertyPanel.getComponent('owner').setValue('');
FM.propertyPanel.getComponent('owner').hide();
FM.propertyPanel.getComponent('group').setValue('');
FM.propertyPanel.getComponent('group').hide();
}
var volInfo=QNAP.QOS.fileExplorerTools.tool.getfileVol.call(FM,FM.gridPanel.store.baseParams.path);
FM.propertyPanel.getComponent('volume').setValue(volInfo[0]);
FM.propertyPanel.getComponent('pool').setValue(volInfo[1]);
} else if (files.length == 1) {
FM.propertyPanel.getComponent('disp_name').show();
FM.propertyPanel.getComponent('fType').show();
FM.propertyPanel.getComponent('owner').show();
FM.propertyPanel.getComponent('group').show();
FM.propertyPanel.getComponent('selItems').setValue(1);
FM.propertyPanel.getComponent('sizePanel')
.getComponent('getSizeBtn').hide();
if (FM.searchMode) {
var F_P = QNAP.QOS.fileExplorerTools.tool
.getFileNamPath(files[0].get('filename'));
fileName = F_P[0];
filePath = F_P[1];
} else {
fileName = files[0].get('filename');
filePath = FM.currentPath;
}
var fileSize = QNAP.QOS.fileExplorerTools.tool.transformFileSize(files[0]
.get('filesize'));
var fnArr = files[0].get('filename').split('.');
var extension = fnArr[fnArr.length - 1] + ' '
+ _S._SFE_LANG_COMMON_FILE;
FM.propertyPanel.getComponent('disp_name').setValue(fileName);
if (node instanceof QNAP.QOS.FM.Remote.FolderNode) {
FM.propertyPanel.getComponent('disp_path').setValue(node.attributes.qtip);
} else {
FM.propertyPanel.getComponent('disp_path').setValue(files[0].get('filepath'));
}

FM.propertyPanel.getComponent('fType').setValue(extension);
if (files[0].get('isfolder') == 0)
FM.propertyPanel.getComponent('sizePanel').getComponent('size')
.setValue(fileSize);
else {
FM.propertyPanel.getComponent('sizePanel').getComponent('size').setValue('--');
FM.propertyPanel.getComponent('sizePanel').getComponent('getSizeBtn').show();
}
FM.propertyPanel.getComponent('modifiedTime').setValue(files[0].get('mt'));
FM.propertyPanel.getComponent('owner').setValue(files[0].get('owner'));
FM.propertyPanel.getComponent('group').setValue(files[0].get('group'));
if(FM.fileListStore.baseParams.path.indexOf('/remote:')==0){
FM.propertyPanel.getComponent('owner').setValue('--');
FM.propertyPanel.getComponent('group').setValue('--');
}
var volInfo=QNAP.QOS.fileExplorerTools.tool.getfileVol.call(FM,FM.gridPanel.store.baseParams.path);
FM.propertyPanel.getComponent('volume').setValue(volInfo[0]);
FM.propertyPanel.getComponent('pool').setValue(volInfo[1]);
} else if (files.length > 1) {
FM.propertyPanel.getComponent('selItems').setValue(files.length);

FM.propertyPanel.getComponent('disp_name').setValue('');
FM.propertyPanel.getComponent('fType').setValue('');
var haveFolder = false;
var totalSize = 0;
for (var i = 0; i < files.length; i++) {
if (parseInt(files[i].get('isfolder')) == 1) {
haveFolder = true;
} else {
totalSize += parseInt(files[i].get('filesize'));
}
}
if(!FM.searchMode){
if (node instanceof QNAP.QOS.FM.Remote.FolderNode) {
FM.propertyPanel.getComponent('disp_path').setValue(node.attributes.qtip);
} else {
FM.propertyPanel.getComponent('disp_path').setValue(files[0].get('filepath'));
}
}else{
FM.propertyPanel.getComponent('disp_path').setValue('');
}
if (!haveFolder) {
var fileSize = QNAP.QOS.fileExplorerTools.tool
.transformFileSize(totalSize);
FM.propertyPanel.getComponent('sizePanel').getComponent('size')
.setValue(fileSize);
FM.propertyPanel.getComponent('sizePanel')
.getComponent('getSizeBtn').hide();
} else {
FM.propertyPanel.getComponent('sizePanel').getComponent('size')
.setValue('--');
FM.propertyPanel.getComponent('sizePanel')
.getComponent('getSizeBtn').show();
}
FM.propertyPanel.getComponent('owner').setValue('');
FM.propertyPanel.getComponent('group').setValue('');
FM.propertyPanel.getComponent('disp_name').hide();
FM.propertyPanel.getComponent('fType').hide();
FM.propertyPanel.getComponent('owner').hide();
FM.propertyPanel.getComponent('group').hide();
}

if (/^(fav_)?\/remote:\d+@[0-9a-f]{40}/.test(node.id)) {
FM.propertyPanel.footer.hide();
var items = FM.propertyPanel.items.items;
for (var i = 9, size = items.length ; i < size ; ++i) {
items[i].hide();
}
var others = FM.propertyPanel.getComponent('otherSettings');
if (others.body) {
others.body.hide();
}
} else {
FM.propertyPanel.footer.show();
}

/**
* Bug#82758, part II
* home folder does not support media property
* @author Dian
*/
if (parentPath === 'home') {
FM.propertyPanel.current_parentPath = parentPath;
FM.propertyPanel.fbar.apply_property_btn.hide();
FM.propertyPanel.getComponent('mediaFolderPanel').hide();
FM.propertyPanel.getComponent('resolutionPanel').hide();
}

FM.propertyPanel.doLayout();
var task = new Ext.util.DelayedTask(function() {
FM.propertyPanel.doLayout();
});
task.delay(200);
},// setPropertyPanelInfo End
setSmpPermission : function(TreeNode) {
var FM = this;
if(!FM.fileListStore.folderType || FM.fileListStore.folderType!='shareFolder'){
return;
}
var params = {};
params['path'] = FM.treePanel.getSelectionModel().selNode.id;
if(TreeNode){
params['path'] =TreeNode.id;
}
if(params.path=='qsyncRoot'){
params.path='/home/.Qsync';
}
if(params.path=='qsyncRecycle'){
params.path='/home/@Recycle/.Qsync';
}
if(params.path=='recycleBin'){
params.path=FM.currentPath;
}
params['is_iso'] = 0;
FM.initMask.msg=_S._SFE_LANG_COMMON_LOADING_MSG;
FM.initMask.show();
Ext.Ajax.request({//success 沒有status無法使用共用的ajax
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'get_root_share'),
params : params,
success : function(o) {
if (!QNAP.QOS.fileExplorerTools.tool.checkResponseIfEmpty(o.responseText)) {
var SmpPermission = Ext.util.JSON.decode(o.responseText).datas;
var rs=Ext.util.JSON.decode(o.responseText);
if(!SmpPermission){//發生錯誤
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,rs.status);
}else{
var generalPanel = FM.eastTab.getItem('permissionPanel').getComponent('generalPanel');
QNAP.QOS.fileExplorerTools.tool.initPermission(
SmpPermission[0].privilege, generalPanel.form);
}
} else {
var msgObj = {
text : _S._SFE_LANG_COMMON_MSG_UNKNOW_ERROR,
key : '_SFE_LANG_COMMON_MSG_UNKNOW_ERROR'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,
'error', msgObj, btns);
MsgWin.show();
}
FM.initMask.hide();
},
failure : function(o) {
FM.initMask.hide();

}
});
},
setSearchMode : function(searchMode, params) {
var FM = this;

if (searchMode) {

for (var key in params) {
FM.gridPanel.store.baseParams[key] = params[key];
}
FM.gridPanel.store.removeAll();

var url = QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM, 'search_ext&v=1');
FM.gridPanel.loadMask.show();
var totalAjax=params.folderArr.length;
var backAjax=0;
var folderArr=params.folderArr;
delete params['folderArr'];
delete FM.gridPanel.store.baseParams['folderArr'];
Ext.each(folderArr, function(folder) {
FM.gridPanel.store.baseParams.folders = folder;

QNAP.QOS.fileExplorerTools.tool.ajax.call(FM, {
url: url,
handler: {
success: function(resulte, rq) {
if (resulte.status==QNAP.QOS.fileExplorerTools.status.SUCCESS) {
if (FM.searchMode) {
if (resulte.datas.length>0){
FM.gridPanel.store.loadData(resulte, true);
}
}
}
},
failure: function(errorCode,rs) {
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,rs.status);
if(errorCode==34){//搜尋出來的資料超過1000筆
FM.gridPanel.store.loadData(rs, true);
}

}
},
callback: function() {
backAjax++;
if (FM.gridPanel.store.getCount()>0 || totalAjax==backAjax){
FM.gridPanel.loadMask.hide();
}
try {
Ext.getCmp(FM.advSrBtnId).setDisabled(false);
FM.isFromSearch = false;
} catch (e) {}
},
params: FM.gridPanel.store.baseParams
});

FM.searchMode = searchMode;
FM.isFromSearch = true;

});
} else {}

},
showPathSelector : function() {
var FM = this;
var CheckRootUI = Ext.extend(Ext.tree.TreeNodeUI, {
constructor : function(node) {
CheckRootUI.superclass.constructor.call(this, node);
},
silentCheck : function(checked) {
var cb = this.checkbox;
cb.checked = checked;
this.checkbox.defaultChecked = checked;
this.node.attributes.checked = checked;
}
});
var tmpNode = new Ext.tree.AsyncTreeNode({
text : QNAP.QOS.config.serverName || 'NAS',
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'tree_root.png',
iconCls : 'searchFldRoot-iconCls',
draggable : false, // disable root node dragging
allowDrop : false,
expanded : true,
data : {
type : 'NAS'
},
id : 'share_root'
});
tmpNode.attributes.uiprovider = CheckRootUI;
tmpNode.attributes.checked = false;
tmpNode.on('checkchange', nodeCheckchange);
var selectedFolders = new Ext.util.MixedCollection();
function nodeCheckchange(node, checked) {
var parentNode = node.parentNode;
if (parentNode) {
if (checked) {
if (selectedFolders.indexOf(parentNode) >= 0) {
selectedFolders.remove(node);
} else {
selectedFolders.add(node.id, node);
}
} else {
selectedFolders.remove(parentNode);
parentNode.eachChild(function(child) {
if (child.ui.isChecked()) {
selectedFolders.add(child.id, child);
}
});
selectedFolders.remove(node);
}
} else {// RootNode
}
node.eachChild(function(child) {
child.ui.toggleCheck(checked);
});

}

function setSearchFolders() {
var folders = FM.panelB.getComponent('folders');
var foldersStr = '';
var fs = [];
selectedFolders.keySort('ASC', function(keyA, keyB) {

var keyAL = keyA.replace(/[^/]/ig, "").length;
var keyBL = keyB.replace(/[^/]/ig, "").length;

return keyAL > keyBL ? 1 : (keyAL < keyBL ? -1 : 0);
});
foldersStr = selectedFolders.keys.toString();
if (selectedFolders.getCount()>0){
folders.setValue(foldersStr);
folders.data = selectedFolders.keys;
}
win.close();
}
var CheckNodeUI = Ext.extend(Ext.tree.TreeNodeUI, {
constructor : function(node) {
CheckNodeUI.superclass.constructor.call(this, node);
},
silentCheck : function(checked) {
var cb = this.checkbox;
cb.checked = checked;
this.checkbox.defaultChecked = checked;
this.node.attributes.checked = checked;
}
});

var win = FM._createModalWindow({
styleVer:1,
title : _S._SFE_LANG_COMMON_PATH_SELECTOR,// 'Path
cls : 'FM-popup-cls',
width : 600,
layout : 'fit',
items : {
xtype : 'treepanel',
loader : FM.checkFileTreeLoader,
useArrows : true,
autoScroll : true,
animate : true,
containerScroll : true,
frame : true,
root : tmpNode,
fbar : [{
text : _S._SFE_LANG_COMMON_CANCEL,// 'cancel',

handler : function() {
win.close();
}
}, {
text : _S._SFE_LANG_COMMON_SELECT,// 'select',

handler : setSearchFolders
}],
listeners : {
load : function(node) {
node.eachChild(function(child) {
child.attributes.uiprovider = CheckNodeUI;
child.attributes.checked = false;
child.on('checkchange',
nodeCheckchange);
});
}
}
}
});
win.show();
},// showPathSelector End
setBottomInfo : function() {
var FM = this;
var selections = FM.gridPanel.getSelectionModel().getSelections();
var fileName, filePath;
if (selections.length == 1) {
FM.bottomArea1.getComponent('b_name').show();
FM.bottomArea1.getComponent('b_fType').show();
FM.bottomArea2.getComponent('b_size').show();
FM.bottomArea1.getComponent('b_selection').hide()
if (FM.searchMode) {
var F_P = QNAP.QOS.fileExplorerTools.tool
.getFileNamPath(selections[0].get('filename'));
fileName = F_P[0];
} else {
fileName = selections[0].get('filename');
}
var fnArr = selections[0].get('filename').split('.');
var subFnName = fnArr[fnArr.length - 1] + ' '
+ _S._SFE_LANG_COMMON_FILE;
if (selections[0].get('isfolder') == 1) {
subFnName = _S._SFE_LANG_COMMON_FOLDER;
FM.bottomArea2.getComponent('b_size').setValue('--');
} else {
FM.bottomArea2.getComponent('b_size')
.setValue(QNAP.QOS.fileExplorerTools.tool
.transformFileSize(selections[0].get('filesize')));
}
FM.bottomArea1.getComponent('b_name').setValue(fileName);

FM.bottomArea1.getComponent('b_fType').setValue(subFnName);
FM.bottomArea2.getComponent('b_modifiedTime')
.setValue(selections[0].get('mt'));
FM.bottomArea2.getComponent('b_modifiedTime').show();
} else if (selections.length > 1) {
FM.bottomArea1.getComponent('b_name').hide();// .setValue('--');
FM.bottomArea1.getComponent('b_fType').hide();// .setValue('--');
FM.bottomArea1.getComponent('b_selection').show()
FM.bottomArea1.getComponent('b_selection')
.setValue(selections.length);
var dateArr = [], totalSize = 0, haveFolder = false;
for (var i = 0; i < selections.length; i++) {
dateArr.push(selections[i].get('mt'));
if (parseInt(selections[i].get('isfolder')) == 1) {
haveFolder = true;
} else {
totalSize += parseInt(selections[i].get('filesize'));
}
}

dateArr.sort();
var mft = dateArr[0].split(' ')[0] + '~'
+ dateArr[dateArr.length - 1].split(' ')[0];
FM.bottomArea2.getComponent('b_modifiedTime').setValue(mft);
FM.bottomArea2.getComponent('b_modifiedTime').show();
if (haveFolder) {
FM.bottomArea2.getComponent('b_size').hide();// .setValue('--');
} else {
FM.bottomArea2.getComponent('b_size')
.setValue(QNAP.QOS.fileExplorerTools.tool
.transformFileSize(totalSize));
}
} else {
}

},// setInfoAndProperty End
showClientGrid : function() {
var FM = this;
FM.initClientGrid();
FM.setMainScr('clientGridPanel');
},// showClientGrid End
clickClientNode : function(node) {
var FM = this;
FM.showClientGrid();
FM.currentGrid = 'clientGrid';
FM.currentHost = 'Client';
var path = node.id;
var separator = FM.clientFileStore.separator;

FM.loadClientPath(path, '', true, true, separator);
},// clickClientNode End
loadClientPath : function(path, folder, expandTree, updateList, separator) {
var FM = this;
var newPath = path;
var folders = [], nodeId = '', node;
if (folder.length > 0) {
newPath += separator + folder;
}
if (newPath.length == 0) {
return;
}
if (expandTree) {
node = FM.treePanel.getNodeById(newPath)
if (node) {
node.select();
} else {

folders = newPath.split(separator);
Ext.each(folders, function(folder) {
if (folder.indexOf(':') == folder.length - 1) {
folder += separator;
}

if (nodeId.length > 0
&& nodeId.lastIndexOf(separator) != nodeId.length
- 1) {
nodeId += separator;
}
nodeId += folder;
var tmpNode = FM.treePanel.getNodeById(nodeId);
if (tmpNode) {
node = tmpNode;
node.attributes.data.autoSelect = newPath;
var callbackFn = Ext.createDelegate(
FM.loadClientPath, FM, [newPath, '',
expandTree, updateList,
separator]);

node.on('expand', callbackFn);
node.on('expand', function() {
node.un('expand', callbackFn);
});
node.expand();
}
});
}
}
if (updateList) {
FM.clientFileStore.baseParams.path = newPath;
var param = {
PATH : newPath
};
FM.clientFileStore.reload({
params : param
});
FM.clientGridPanel.loadMask.show();
}
},// loadClientPath End
loadClientFilelist : function(json, option) {
var FM = this;
var node = FM.treeRoot.findChild('id', 'clientRoot'), data = [];// ,
if (json.PARENT_PATH) {
data.push({
filename : '..',
filesize : 0,
filetype : '',
filepath : json.PARENT_PATH,
mt : '',
privilege : '',
owner : '',
group : '',
isfolder : '',
parentLink : true,
iscompressed : ''
});
}
for (var i = 0; i < json.CHILDREN.length; i++) {
var f = json.CHILDREN[i];
data.push({
filename : f.NAME,
filesize : f.FILE_SIZE,
filetype : '?',
filepath : f.PATH,
mt : f.LAST_MODIFED_TIME,
privilege : '?',
owner : f.OWNER,
group : f.GROUP,
isfolder : f.IS_DIRECTORY ? 1 : 0,
iscompressed : '?'
});
}

FM.clientFileStore.baseParams.path = json.PATH;
FM.clientGridPanel.loadMask.enable();
FM.clientGridPanel.loadMask.show();
FM.clientFileStore.loadData({
datas : data,
total : json.CHILDREN_COUNT
}, option);
this.fireEvent('load');
},// loadClientFilelist End
getDragEl : function(folderName) {
var appInfo = QNAP.QOS.lib.getAppInfo('fileManager');
var el = [{
tag : 'div',
cls : 'FE-drag-image',
children : [{
tag : 'img',
src : 'images/icon/fm_main_icon.png'
}]
}, {
tag : 'div',
cls : 'FE-drag-text',
html : folderName
}];
return Ext.DomHelper.markup(el);
},// getDragEl End
initDropMenu : function() {
var FM = this;
FM.menuDropToTree = new Ext.menu.Menu({
itemId : 'tcm_download_skip/tcm_download_overwrite',
cls : 'FM-moreActionMenuList-cls',
listeners : {
beforeshow : function(menu) {
FM.updateDropMenu();
FM.treeDropPath = FM.menuDropToTree.data.to;
},
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
if (/C2N|N2C|C2Q|Q2C/i.test(FM.menuDropToTree.data.type)) {
FM.menuDropToTree.hide();
}
}
},
data : {
from : {},
to : {},
items : []
},
items : [{
itemId : 'tcm_download_skip',
text :  _S._SFE_LANG_COMMON_SKIP,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_SKIP',
data : FM,
handler : function(item, event) {
FM.drop = true;
var sourcePath = FM.menuDropToTree.data.from;
var destPath = FM.menuDropToTree.data.to;
var files = FM.menuDropToTree.data.items;
var dlFileName = '';
var isOverwrite = 0;// 0:skip, 1:overwrite, 2:auto(遇到相同檔名的則更名產生另一個檔案)
var sid = QNAP.QOS.user.sid;
os.openApp('FileUploadMgr', {
sid : sid,
sourcePath:sourcePath,
path : destPath,
appendEvent : 'appletDownload',
files : files,
startUpload : true,
isOverwrite:isOverwrite,
tabNum : 2
});


}
}, {
itemId : 'tcm_download_overwrite',
text :_S._SFE_LANG_COMMON_OVERWRITE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OVERWRITE',
data : FM,
handler : function(item, event) {
FM.drop = true;
var sourcePath = FM.menuDropToTree.data.from;
var destPath = FM.menuDropToTree.data.to;
var files = FM.menuDropToTree.data.items;
var dlFileName = '';
var isOverwrite = 1;// 0:skip, 1:overwrite, 2:auto
var sid = QNAP.QOS.user.sid;
os.openApp('FileUploadMgr', {
sid : sid,
sourcePath:sourcePath,
path : destPath,
appendEvent : 'appletDownload',
files : files,
startUpload : true,
isOverwrite:isOverwrite,
tabNum : 2
});
}
}, {
itemId : 'tcm_upload_skip',
text : _S._SFE_LANG_ACTION_UPLOAD_TITLE + ' '
+ _S._SFE_LANG_COMMON_SKIP,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_SKIP',
data : FM,
handler : function(item, event) {
var destPath = FM.menuDropToTree.data.to;
if (destPath.substring(0, 4) == 'fav_') {
destPath = destPath.substring(4,
destPath.length);
}
var isOverwrite = 'false';// skip
var sourceFiles = [];
Ext.each(FM.menuDropToTree.data.items, function(
item) {
sourceFiles.push(item.fullName);
});
var sid = QNAP.QOS.user.sid;
if (destPath.indexOf('/home/.Qsync') >= 0) {
if (FM.QsyncSid) {
sid = FM.QsyncSid;
} else {
QNAP.QOS.fileExplorerTools.tool
.getQsyncSid(FM);
sid = FM.QsyncSid;
}
}
var param = {
CALLBACK : 'appletCallback',
SOURCE_FILES : sourceFiles,
DEST_PATH : destPath,
IS_OVERWRITE : isOverwrite,
SID : sid
};
FM.callApplet(FM.getId(), 'qUploadApplet',
'uploadFileNow', param);
var win = FM.getDropUploadWin();
win.show();
}
}, {
itemId : 'tcm_upload_overwrite',
text : _S._SFE_LANG_ACTION_UPLOAD_TITLE + ' '
+ _S._SFE_LANG_COMMON_OVERWRITE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OVERWRITE',
data : FM,
handler : function(item, event) {
var destPath = FM.menuDropToTree.data.to;
if (destPath.substring(0, 4) == 'fav_') {
destPath = destPath.substring(4,
destPath.length);
}
var isOverwrite = 'true';// overwrite
var sourceFiles = [];
Ext.each(FM.menuDropToTree.data.items, function(
item) {
sourceFiles.push(item.fullName);
});
var sid = QNAP.QOS.user.sid;
if (destPath.indexOf('/home/.Qsync') >= 0) {
if (FM.QsyncSid) {
sid = FM.QsyncSid;
} else {
QNAP.QOS.fileExplorerTools.tool
.getQsyncSid(FM);
sid = FM.QsyncSid;
}
}
var param = {
CALLBACK : 'appletCallback',
SOURCE_FILES : sourceFiles,
DEST_PATH : destPath,
IS_OVERWRITE : isOverwrite,
SID : sid
};

FM.callApplet(FM.getId(), 'qUploadApplet',
'uploadFileNow', param);
var win = FM.getDropUploadWin();
win.show();
}
}, {
itemId : 'tcm_copy_skip',
text : _S._SFE_LANG_ACTION_COPY_MSG_COPY_SKIP,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_COPY_MSG_COPY_SKIP',
data : FM,
handler : function(item, event) {
FM.drop = true;
var from = FM.menuDropToTree.data.from;
var to = FM.menuDropToTree.data.to;
var items = FM.menuDropToTree.data.items;
var merge1Task=FM.menuDropToTree.getComponent('merge1Task').getValue();
QNAP.QOS.fileExplorerAction
.copyMove(
from,
to,
items,
'copy',
QNAP.QOS.fileExplorerTools.constant.COPY_SKIP,
FM,merge1Task);
}
}, {
itemId : 'tcm_copy_overwrite',
text : _S._SFE_LANG_ACTION_COPY_MSG_COPY_OVERWRITE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_COPY_MSG_COPY_OVERWRITE',
handler : function() {
FM.drop = true;
var from = FM.menuDropToTree.data.from;
var to = FM.menuDropToTree.data.to;
var items = FM.menuDropToTree.data.items;
var merge1Task=FM.menuDropToTree.getComponent('merge1Task').getValue();
QNAP.QOS.fileExplorerAction
.copyMove(
from,
to,
items,
'copy',
QNAP.QOS.fileExplorerTools.constant.COPY_OVERWRITE,
FM,merge1Task);
}
}, {
itemId : 'tcm_move_skip',
text : _S._SFE_LANG_ACTION_MOVE_MSG_MOVE_SKIP,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_MOVE_MSG_MOVE_SKIP',
handler : function() {
FM.drop = true;
var from = FM.menuDropToTree.data.from;
var to = FM.menuDropToTree.data.to;
var items = FM.menuDropToTree.data.items;
var merge1Task=FM.menuDropToTree.getComponent('merge1Task').getValue();
QNAP.QOS.fileExplorerAction
.copyMove(
from,
to,
items,
'move',
QNAP.QOS.fileExplorerTools.constant.MOVE_SKIP,
FM,merge1Task);
}
}, {
itemId : 'tcm_move_overwrite',
text : _S._SFE_LANG_ACTION_MOVE_MSG_MOVE_OVERWRITE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_MOVE_MSG_MOVE_OVERWRITE',
handler : function() {
FM.drop = true;
var from = FM.menuDropToTree.data.from;
var to = FM.menuDropToTree.data.to;
var items = FM.menuDropToTree.data.items;
var merge1Task=FM.menuDropToTree.getComponent('merge1Task').getValue();
QNAP.QOS.fileExplorerAction
.copyMove(
from,
to,
items,
'move',
QNAP.QOS.fileExplorerTools.constant.MOVE_OVERWRITE,
FM,merge1Task);
}
},{
xtype : 'checkbox',
itemId : 'merge1Task',
name : 'merge1Task',
cls : 'menu-merge1Task-cls',
ctCls : 'menu-merge1Task-ctCls',
boxLabel : _S._SFE_LANG_MSG_MERGE_1_TASK,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_MERGE_1_TASK',
checked : true,
hideLabel : true
}, {
itemId : 'tcm_cancel',
text : _S._SFE_LANG_COMMON_CANCEL,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CANCEL',
handler : function() {
}
}]
});
FM.menuDropToTree.render();
},// initDropMenu End
updateDropMenu : function() {
var FM = this, menu = FM.menuDropToTree, type = menu.data.type;
switch (type) {
case 'shareRoot' :
break;
case 'N2Q' :// Q:Qsync
menu.items.get('tcm_download_skip').hide();
menu.items.get('tcm_download_overwrite').hide();
menu.items.get('tcm_upload_skip').hide();
menu.items.get('tcm_upload_overwrite').hide();
menu.items.get('tcm_copy_skip').show();
menu.items.get('tcm_copy_overwrite').show();
menu.items.get('tcm_move_skip').show();
menu.items.get('tcm_move_overwrite').show();
menu.items.get('tcm_cancel').show();
chkRW();
break;
case 'N2R' :
case 'N2N' :
menu.items.get('tcm_download_skip').hide();
menu.items.get('tcm_download_overwrite').hide();
menu.items.get('tcm_upload_skip').hide();
menu.items.get('tcm_upload_overwrite').hide();
menu.items.get('tcm_copy_skip').show();
menu.items.get('tcm_copy_overwrite').show();
menu.items.get('tcm_move_skip').show();
menu.items.get('tcm_move_overwrite').show();
menu.items.get('tcm_cancel').show();
chkRW();
break;
case 'N2F' :
menu.items.get('tcm_download_skip').hide();
menu.items.get('tcm_download_overwrite').hide();
menu.items.get('tcm_upload_skip').hide();
menu.items.get('tcm_upload_overwrite').hide();
menu.items.get('tcm_copy_skip').show();
menu.items.get('tcm_copy_overwrite').show();
menu.items.get('tcm_move_skip').show();
menu.items.get('tcm_move_overwrite').show();
menu.items.get('tcm_cancel').show();

chkRW();
break;
case 'C2F' :
callUploadMgr(menu);
chkRW();
break;
case 'C2C' :
menu.items.get('tcm_download_skip').hide();
menu.items.get('tcm_download_overwrite').hide();
menu.items.get('tcm_upload_skip').hide();
menu.items.get('tcm_upload_overwrite').hide();
menu.items.get('tcm_copy_skip').show();
menu.items.get('tcm_copy_overwrite').show();
menu.items.get('tcm_move_skip').show();
menu.items.get('tcm_move_overwrite').show();
menu.items.get('tcm_cancel').show();
break;
case 'N2C' :
callDownloadMgr(menu);
break;
case 'C2N' :
callUploadMgr(menu);
chkRW();
break;
case 'C2Q' :
callUploadMgr(menu);
chkRW();
break;
}

function callDownloadMgr(menu){
var sid = QNAP.QOS.user.sid;
var titleKey='_SFE_LANG_ACTION_DOWNLOAD_TITLE';
var msgObj = {
title: _S[titleKey],
titleKey: titleKey,
text: _S._SFE_LANG_COMMON_MSG_OVERWRITE_EX,
key: '_SFE_LANG_COMMON_MSG_OVERWRITE_EX'
};
var btns = [{
text: _S._SFE_LANG_COMMON_OK,
qInternational: true,
qInternationalKey: '_SFE_LANG_COMMON_OK',
handler: function() {
FM.config.isOverwritePast = overwriteRadio.getValue().getGroupValue();
FM.drop = true;
var menuData   = FM.menuDropToTree.data,
sourcePath = menuData.from,
destPath   = menuData.to,
files      = menuData.items,
dlFileName = '',
isOverwrite = 0,// 0:skip, 1:overwrite, 2:auto(遇到相同檔名的則更名產生另一個檔案)
sid = QNAP.QOS.user.sid;

os.openApp('FileUploadMgr', {
sid : sid,
sourcePath:sourcePath,
path : destPath,
appendEvent : 'appletDownload',
files : files,
startUpload : true,
isOverwrite:FM.config.isOverwritePast==1?0:1,
tabNum : 2
});
copyCfmMsgWin.close();
}
}, {
text: _S._SFE_LANG_COMMON_CANCEL,
qInternational: true,
qInternationalKey: '_SFE_LANG_COMMON_CANCEL',
handler: function() {
copyCfmMsgWin.close();
}
}];

var copyCfmMsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,
'question', msgObj, btns);
var overwriteRadio = new Ext.form.RadioGroup({
columns: 1,
defaults: {
name: 'overwriteMode',
},
items: [{
qInternational: true,
qInternationalKey: {
boxLabel: '_SFE_LANG_COMMON_SKIP_1'
},
boxLabel: _S._SFE_LANG_COMMON_SKIP_1,
inputValue: '1',
itemId: 'skipRadio',
checked: FM.config.isOverwritePast=='1'
}, {
qInternational: true,
qInternationalKey: {
boxLabel: '_SFE_LANG_COMMON_OVERWRITE_1'
},
boxLabel: _S._SFE_LANG_COMMON_OVERWRITE_1,
inputValue: '0',
itemId: 'overwriteRadio',
checked: FM.config.isOverwritePast=='0'
}]
});

copyCfmMsgWin.remove(1);
copyCfmMsgWin.add({
xtype: 'container',
flex: 1,
margins: {
top: 10,
left: 17,
right: 0,
bottom: 0
},
items: [{
xtype: 'displayfield',
itemId: 'msgText',
value: msgObj.text,
qInternational: true,
qInternationalKey: msgObj.key,
style: {
marginBottom: '20px'
},
},
overwriteRadio
]
});
copyCfmMsgWin.show();
copyCfmMsgWin.setHeight(350);
}

function callUploadMgr(menu){
var sid = QNAP.QOS.user.sid;
if (menu.data.to.indexOf('/home/.Qsync') >= 0) {
if (FM.QsyncSid) {
sid = FM.QsyncSid;
} else {
QNAP.QOS.fileExplorerTools.tool.getQsyncSid(FM);
sid = FM.QsyncSid;
}
}
var sourceFiles = [];
Ext.each(menu.data.items, function(item) {
sourceFiles.push(item.fullName);
});
os.openApp('FileUploadMgr', {
sid : sid,
path : menu.data.to,
appendEvent : 'applet',
files : sourceFiles,
startUpload : true,
tabNum : 1
});
}

function chkRW() {
var ToRW = QNAP.QOS.fileExplorerTools.tool.checkRW(FM,
FM.menuDropToTree.data.to);
var FromRW = QNAP.QOS.fileExplorerTools.tool.checkRW(FM,
FM.menuDropToTree.data.from);

if (ToRW == 'r') {
menu.items.get('tcm_upload_skip').hide();
menu.items.get('tcm_upload_overwrite').hide();
menu.items.get('tcm_copy_skip').hide();
menu.items.get('tcm_copy_overwrite').hide();
menu.items.get('tcm_move_skip').hide();
menu.items.get('tcm_move_overwrite').hide();
menu.items.get('tcm_cancel').hide();
}
if (FromRW == 'r') {
menu.items.get('tcm_move_skip').hide();
menu.items.get('tcm_move_overwrite').hide();
}
}
},// updateDropMenu End
getDropUploadWin : function() {
var FM = this;
if (Ext.isEmpty(FM.dropUploadWin) || FM.dropUploadWin.isDestroyed) {
var pBar = new Ext.ProgressBar({
text : _S._SFE_LANG_COMMON_PROGRESS_READY
});

var info = new Ext.form.DisplayField({
style : 'padding-top:10px;padding-left:5px;font-size:12px;',
value : ''
});
var rate = new Ext.form.DisplayField({
style : 'padding-top:10px;padding-left:5px;font-size:12px;',
value : ''
});
var fileSize = new Ext.form.DisplayField({
style : 'padding-top:10px;padding-left:5px;font-size:12px;',
value : ''
});
var uploadSize = new Ext.form.DisplayField({
style : 'padding-top:10px;padding-left:5px;font-size:12px;',
value : ''
});
var store = new Ext.data.JsonStore({
root : 'files',
fields : ['name', 'status', 'fullName']
});
FM.dropUploadWin = FM._createModalWindow({
styleVer:1,
totoCount : 0,
currentIndex : 0,
closeAction : 'hide',
cls : 'uploadWin-cls',
plugins : {
init : function(win) {
win.updateProgress = Ext.createDelegate(
pBar.updateProgress, pBar);
win.setInfoValue = Ext.createDelegate(info.setValue,
info);
win.setUploadSizeValue = Ext.createDelegate(
uploadSize.setValue, uploadSize);
win.setFileSizeValue = Ext.createDelegate(
fileSize.setValue, fileSize);
win.setRateValue = Ext.createDelegate(rate.setValue,
rate);
win.store = store;
}
},
title : _S._SFE_LANG_COMMON_PROGRESS,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PROGRESS',
items : {
xtype : 'tabpanel',
activeItem : 0,
items : [{
title : _S._SFE_LANG_ACTION_UPLOAD_TITLE,
autoHeight : true,
items : [pBar, info, rate, uploadSize, fileSize]
}, {
title : _S._SFE_LANG_ADVUPLOAD_UPLOADED_FILES,
xtype : 'listview',
store : store,
columns : [{
header : 'File',
width : .7,
dataIndex : 'name'
}, {
header : 'Status',
width : .3,
dataIndex : 'status'
}]
}]
},
fbar : [{
xtype : 'button',
itemId : 'uploadCancel',
text : _S._SFE_LANG_COMMON_CANCEL,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CANCEL',
handler : function() {
FM.callApplet(FM.getId(), 'qUploadApplet',
'stopDropUploadThread', {});
FM.dropUploadWin.close();
}
}, {
xtype : 'button',
itemId : 'uploadFinish',
text : _S._SFE_LANG_COMMON_FINISH,
qInternational : true,
hidden : true,
qInternationalKey : '_SFE_LANG_COMMON_FINISH',
handler : function() {
FM.dropUploadWin.close();
}
}],
parent : FM.win,
width : 380,
height : 280
});
}
return FM.dropUploadWin;
},// getDropUploadWin End
onFileChange : function(appId, pathArr, target, filename, action) {
var FM = this;
var isReloadFileList=false;
var nowPath=FM.fileListStore.baseParams.path;
if(Ext.isEmpty(pathArr)){
return;
}
var selNode = FM.treePanel.getSelectionModel().selNode;
if(Ext.isEmpty(selNode)){//Bug 72740
FM.nasRoot.childNodes[0].expand();
selNode=FM.nasRoot.childNodes[0].childNodes[0];
selNode.select();
selNode.fireEvent('click',selNode);
}
if(Ext.isEmpty(selNode)){
return;
}
if(!Ext.isArray(pathArr)){
pathArr=[pathArr];
}
if(pathArr.length==1 && pathArr[0]=='/'){
FM.initNasShareFolder(FM.currentPath);
return;
}
isReloadFileList=(pathArr.indexOf(FM.currentPath)>=0);
if(isReloadFileList){
FM.fileListStore.reload();
}
Ext.each(pathArr,function(path){
var node = FM.treePanel.root.findChild('id', path, true);
if(node && node.loaded){
node.reload();
}
if ((selNode.id == 'qsyncRoot' && path.indexOf('/home/.Qsync')==0) ||
(selNode.id == 'qsyncRecycle'&& path.indexOf('/home/@Recycle/.Qsync')==0)
){
FM.fileListStore.reload();
}
if(nowPath && path !=nowPath && nowPath.indexOf(path)==0){
var task = new Ext.util.DelayedTask(function() {
FM.openPath(nowPath);
});
task.delay(300);
}
});
if(pathArr.length==2){//針對move到子資料夾後收起子資料夾的狀況做修正Bug 66714
var task = new Ext.util.DelayedTask(function() {
if(pathArr[0].indexOf(pathArr[1])==0){
FM.openPath(pathArr[0],'','',false);
}
if(pathArr[1].indexOf(pathArr[0])==0){
FM.openPath(pathArr[1],'','',false);
}
});
task.delay(300);
}
},
updatePathBarN : function(path) {
var FM = this;
var fixXSS=QNAP.QOS.fileExplorerTools.tool.fixXSS;

FM.pathPanel.getComponent('preBtn').show();
FM.pathPanel.getComponent('nextBtn').show();

var remote;
if (remote = /(^\/remote:\d+@[0-9a-f]{40})/.exec(path)) {
var node = FM.treePanel.root.findChild('id', path, true);
if (node instanceof QNAP.QOS.FM.Remote.FolderNode) {
FM.pathBar.removeAll();
var path = node.getPathOfNode();
while (path.length > 0) {
node = path.shift();
FM.pathBar.add({
cls: 'none-bg-btn',
text: node.text,
height: 30,
disabled: (path.length == 0),
handler: node.fireEvent.bind(node, 'click', node, false)
});
if (path.length > 0) {
FM.pathBar.add({
cls:'pathTbs-cls',
width: 20,
xtype: 'tbspacer',
height: 22
});
}
FM.fixLongPath();
}
} else {
node = FM.treePanel.root.findChild('id', remote[0], true);
if (node instanceof QNAP.QOS.FM.Remote.FolderNode) {
var callback = [];

path = path.split(FM.treePanel.pathSeparator);
while (path.length > 2) {
callback.unshift({
fn: function(path) {
this.treePanel.gotoPath(path);
}.bind(FM, path.join(FM.treePanel.pathSeparator)),
text: path.pop()
});
}
callback.unshift({
fn: node.fireEvent.bind(node, 'click', node, false),
text: node.text
});

FM.pathBar.removeAll();
while (callback.length > 0) {
var cb = callback.shift();
FM.pathBar.add({
cls: 'none-bg-btn',
text: cb.text,
height: 30,
disabled: (callback.length == 0),
handler: cb.fn
});
if (callback.length > 0) {
FM.pathBar.add({
cls:'pathTbs-cls',
width: 20,
xtype: 'tbspacer',
height: 22
});
}
}

FM.fixLongPath();
}
}
return;
}

var selNode = FM.treePanel.getSelectionModel().selNode;
if (Ext.isString(path) && (!selNode || selNode.id != 'recycleBin')) {

if (path == '/home/@Recycle/.Qsync') {
path = '/home/.Qsync/@Recycle';
}
if (path.indexOf('@Recycle') >= 0 || path == '/home/.Qsync') {
Ext.getCmp(FM.IDS.FAV_START_BTN).setDisabled(true);
} else {
Ext.getCmp(FM.IDS.FAV_START_BTN).setDisabled(false);
}

var paths = path.split('/');
FM.pathBar.removeAll();
var myPath = '';
var i = 1;

Ext.each(paths, function(folder) {
if (folder.trim() == '') {
return true;
}
myPath = myPath + '/' + folder;
var isLastPath = false;
if (i == paths.length - 1) {
isLastPath = true;
}
var nodeId = path;
nodeId = nodeId.replace(/^fav_/, '');
if (nodeId.indexOf('/home/.Qsync') < 0 && nodeId.indexOf('/home/@Recycle/.Qsync') < 0) {
var pathBtn = {
text : fixXSS(folder),
cls : 'none-bg-btn',
disabled : isLastPath,
myPath : myPath,
height:30,
handler:function(btn){
FM.goPath(btn);
}
};
if(isLastPath){
FM.pathBar.add(pathBtn);
}else{
FM.pathBar.add(pathBtn);
FM.pathBar.add({xtype : 'tbspacer',
cls:'pathTbs-cls',
width : 20,
height: 22
});
}
} else {
if (i > 1) {
if (i == 2){
folder = folder.replace('.', '');// 顯示".Qsync"改為"Qsync"
}
if(i == 2 && folder=='@Recycle'){
folder='Qsync';
myPath='/home/.Qsync';
}
if(i == 3 && folder=='.Qsync'){
folder='@Recycle';
myPath='/home/@Recycle/.Qsync';
}

var pathBtn = {
text : fixXSS(folder),
cls : 'none-bg-btn',
disabled : isLastPath,
myPath : myPath,
height:30,
handler:function(btn){
FM.goPath(btn);
}
};
if(isLastPath){
FM.pathBar.add(pathBtn);
}else{
FM.pathBar.add(pathBtn);
FM.pathBar.add({xtype : 'tbspacer',
cls:'pathTbs-cls',
width : 20,
height: 22
});
}
}
}
i++;
});
Ext.getCmp(FM.IDS.PATH_BAR).doLayout();
}else if (selNode.id == 'recycleBin'){
var paths = path.split('/');
FM.pathBar.removeAll();
var recycleBtn = {
text : _S._SFE_LANG_COMMON_RECYCLE_BIN,
cls : 'none-bg-btn',
disabled : false,
myPath : 'recycleBin',
height:30,
handler:function(btn){
FM.showRecycleBinGrid();
}
};
FM.pathBar.add(recycleBtn);
function loadRecycle(rcyclePath){
FM.fileListStore.baseParams.path=rcyclePath;
FM.fileListStore.reload();
}
if(Ext.isString(path) &&  path.split('/')[2] == '@Recycle'){
var myPath = '';
var i = 1;

Ext.each(paths, function(folder) {
if (folder.trim() == '') {
return true;
}
myPath = myPath + '/' + folder;
var isLastPath = false;
if (i == paths.length - 1) {
isLastPath = true;
}
var pathBtn;
if(folder!=='@Recycle'){
if(paths.length==3){
pathBtn= {
text : fixXSS(folder),
cls : 'none-bg-btn',
disabled : true,
myPath : myPath,
handler:function(btn){
loadRecycle(btn.myPath);
}
};
}else{
if(myPath.split('/').length==2){
pathBtn= {
text : fixXSS(folder),
cls : 'none-bg-btn',
disabled : isLastPath,
myPath : myPath+'/@Recycle',
handler:function(btn){
loadRecycle(btn.myPath);
}
};
}else{
pathBtn= {
text : fixXSS(folder),
cls : 'none-bg-btn',
disabled : isLastPath,
myPath : myPath,
handler:function(btn){
loadRecycle(btn.myPath);
}
};
}
}
FM.pathBar.add({xtype : 'tbspacer',
cls:'pathTbs-cls',
width : 20,
height: 22
});
FM.pathBar.add(pathBtn);
}
i++;
});
}
if(FM.pathBar.items.items.length==1){
FM.pathBar.items.items[0].setDisabled(true);
}
}
FM.fixLongPath();
},
fixLongPath:function(){
var FM=this;
var tableEl = Ext.get(FM.pathBar.el.dom.childNodes[0]);
var i = 0;
var pathMenu = FM.pathPanel.getComponent('pathMenuBtn').menu;
pathMenu.removeAll();
FM.pathPanel.getComponent('pathMenuBtn').hide();
function hideFirstBtn() {
if (tableEl.getWidth() > FM.pathBar.getWidth()) {
var pItem = FM.pathBar.items.items[i];
pItem.hide();
var menuItem = new Ext.menu.Item(pItem);
if (menuItem.text)
pathMenu.add(menuItem);
i++;
FM.pathPanel.getComponent('pathMenuBtn').show();
hideFirstBtn();
} else {

}
FM.pathPanel.doLayout();
}
hideFirstBtn();
},
updatePathBarC : function(path) {
var FM = this;

FM.pathPanel.getComponent('preBtn').hide();
FM.pathPanel.getComponent('nextBtn').hide();
FM.currentPath = path;
var clientPathSeparator = FM.clientFileStore.separator;
if (Ext.isString(path)) {
var paths = path.split(clientPathSeparator);
FM.pathBar.removeAll();
var myPath = '';
for (var i = 0; i < paths.length; i++) {
if (paths[i].trim() == '' && clientPathSeparator ==='/'  && i==0) {
continue;
}
if (i == 0) {
myPath = paths[i];
} else {
myPath = myPath + clientPathSeparator + paths[i];
}
var isLastPath = false;
if (i == paths.length - 1) {
isLastPath = true;
}
var pathBtn = {
text : paths[i],
id : myPath,
disabled : isLastPath,
myPath : myPath,
scope: FM,
cls: 'none-bg-btn',
handler: FM.clickClientNode
};
if (isLastPath) {
FM.pathBar.add(pathBtn);
} else {
FM.pathBar.add(pathBtn);
FM.pathBar.add({

xtype : 'tbspacer',
cls : 'pathTbs-cls',
width : 20,
height : 22
});
}
}
Ext.getCmp(FM.IDS.PATH_BAR).doLayout();
}
},
getDropDownloadWin : function() {
var FM = this;
if (Ext.isEmpty(FM.dropDownloadWin) || FM.dropDownloadWin.isDestroyed) {
var pBar = new Ext.ProgressBar({
text : _S._SFE_LANG_COMMON_PROGRESS_READY
});
var info = new Ext.form.DisplayField({
style : 'padding-top:10px;padding-left:10px;font-size:12px;',
value : ''
});
var rate = new Ext.form.DisplayField({
style : 'padding-top:10px;padding-left:10px;font-size:12px;',
value : ''
});
var fileSize = new Ext.form.DisplayField({
style : 'padding-top:10px;padding-left:10px;font-size:12px;',
value : ''
});
var uploadSize = new Ext.form.DisplayField({
style : 'padding-top:10px;padding-left:10px;font-size:12px;',
value : ''
});
var store = new Ext.data.JsonStore({
root : 'files',
fields : ['name', 'status', 'fullName']
});
FM.dropDownloadWin = FM._createModalWindow({
styleVer:1,
totoCount : 0,
currentIndex : 0,
closeAction : 'hide',
plugins : {
init : function(win) {
win.updateProgress = Ext.createDelegate(
pBar.updateProgress, pBar);
win.setInfoValue = Ext.createDelegate(info.setValue,
info);
win.setUploadSizeValue = Ext.createDelegate(
uploadSize.setValue, uploadSize);
win.setFileSizeValue = Ext.createDelegate(
fileSize.setValue, fileSize);
win.setRateValue = Ext.createDelegate(rate.setValue,
rate);
win.store = store;
}
},
title : _S._SFE_LANG_COMMON_PROGRESS,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PROGRESS',
items : {
xtype : 'tabpanel',
activeItem : 0,
items : [{
title : _S._SFE_LANG_ACTION_DOWNLOAD_TITLE,
autoHeight : true,
items : [pBar, info, rate, uploadSize, fileSize]
}, {
title : _S._SFE_LANG_ADVUPLOAD_DOWNLOADED_FILES,
xtype : 'listview',
store : store,
cls : 'fileGridPanel-cls',
columns : [{
header : 'File',
width : .7,
dataIndex : 'name'
}, {
header : 'Status',
width : .3,
dataIndex : 'status'
}]
}]
},
fbar : [{
xtype : 'button',
itemId : 'cancel',
text : _S._SFE_LANG_COMMON_CLOSE,
qInternational : true,
hidden : false,
qInternationalKey : '_SFE_LANG_COMMON_CLOSE',
handler : function() {
FM.callApplet(FM.getId(), 'qUploadApplet',
'stopDropDownloadThread', {});
FM.dropDownloadWin.close();
FM.clientFileStore.reload();
FM.unmask();
}
}],
parent : FM.win,
width : 380,
height : 280
});
}
return FM.dropDownloadWin;
},
showNasGridContextMenu: function(event) {
var FM = this;
var contextMenu = FM.gridContextMenu;
var selections = FM.gridPanel.getSelectionModel().getSelections();
var visible = contextMenu.getItemVisible(true);
var isQFTPRoot=false;
if(FM.currentPath && FM.currentPath.indexOf('/remote:')==0){
var pathArr=FM.currentPath.split('/');
var destRoot='/'+pathArr[1];
var destRootNode = FM.treeRoot.findChild('id',destRoot,true);
var conf=destRootNode.attributes.configure;
if(conf.q_nas==1 && (pathArr.indexOf('Qsync')>0 || pathArr.indexOf('.Qsync')>0)){//阻擋複製到QNAP NAS的Qsync
}else if(conf.q_nas==1 && conf.protocol.indexOf('ftp')==0 && conf.folder=='/' && pathArr.length<=2){//阻擋複製到QNAP FTP Root (/)的動作 (FTP)
isQFTPRoot=true;
}
}
if (FM.currentPath.indexOf('@Recycle') >= 0) {
visible = {};
visible['gcm_recycleEmptyBtn'] = true;
if (selections.length >= 1) {
visible['gcm_recycleDelBtn'] = true;
visible['gcm_recycleRcvBtn'] = true;
}
} else {
if (QNAP.QOS.FileClipBoard.getFiles().length == 0) { // 如果剪貼簿裡沒有東西則隱藏貼上按鈕
delete visible['gcm_past'];
}
delete visible['gcm_recycleDelBtn'];
delete visible['gcm_recycleRcvBtn'];
delete visible['gcm_recycleEmptyBtn'];
delete visible['gcm_play2'];
delete visible['gcm_download2'];

var couldOPTrans = false,
isMMedia = true,
folderInMediaLib = true;
var mediaFolders = FM.config.mediaFolders;
Ext.each(selections, function(file) {
var mediaType = QNAP.QOS.fileExplorerTools.tool.getMultiMediaType(file.data.filename);
if (file.data.isfolder == 1 || mediaType == 'isVideo') {
couldOPTrans = true;
}
if (mediaType == 'notMultiMedia') {
isMMedia = false;
}
});

if (selections.length > 1) {
delete visible['gcm_play_main'];
delete visible['gcm_play2'];
delete visible['gcm_download2'];
delete visible['gcm_officeOLBtn'];
delete visible['gcm_googleDocBtn'];
delete visible['gcm_open_main'];
delete visible['gcm_qMailBtn'];
delete visible['gcm_extOpBtn'];
delete visible['gcm_createShortcut'];
delete visible['gcm_addToFav'];
delete visible['gcm_removeFav'];
delete visible['gcm_rename'];
delete visible['gcm_extract_main'];
delete visible['gcm_mount'];
var isTransFolder = false,isDSFile=false;
Ext.each(selections, function(file) {
if (file.data.isfolder == 1 && file.data.filename == '@Transcode') {
isTransFolder = true;
}
if(/\.(dsdownload)$/i.test(file.get('filename'))){
isDSFile=true;
}
});

if (isMMedia && folderInMediaLib) {
visible['gcm_streamBtn'] = true;
} else {
delete visible['gcm_streamBtn'];
}
if (couldOPTrans && QNAP.QOS.user.isAdminGroup
&& FM.currentPath.split('/').pop() != '@Transcode'
&& !isTransFolder && !FM.searchMode
&& !Ext.isEmpty(FM.sysSetting.transcode_server_status)
&& FM.sysSetting.transcode_server_status>0) {
visible['gcm_transcodeBtn_main'] = true;
} else {
delete visible['gcm_transcodeBtn_main'];
}
delete visible['gcm_delTmpVideoBtn'];
delete visible['gcm_transInfoBtn'];
delete visible['gcm_versionsBtn'];
delete visible['gcm_openWithVLCBtn'];
if (!QNAP.QOS.user.isAdminGroup && !FM.isAllowAllShare) {
delete visible['gcm_shareLink'];
}
if(isDSFile){
delete visible['gcm_compressBtn'];
delete visible['gcm_shareLink'];
}

} else if (selections.length == 1) {
var file = selections[0].data;
if (selections[0].data.isfolder == 0) { // 選一個檔案
var extension = file.filename.split('.')[file.filename.split('.').length - 1];
delete visible['gcm_createShortcut'];
delete visible['gcm_addToFav'];
delete visible['gcm_removeFav'];
var mediaType = QNAP.QOS.fileExplorerTools.tool.getMultiMediaType(file.filename);
if(mediaType != 'isVideo' || Ext.isMac || Ext.isChrome){
delete visible['gcm_openWithVLCBtn'];
}
if (mediaType == 'isVideo') {
/** 判斷play是否顯示 Start * */
var cldplay = FM.RTT || file.mp4_240 == 1 || file.mp4_360 == 1 || file.mp4_480 == 1 || file.mp4_720 == 1 || file.mp4_1080 == 1;
if ((DetectFlashVer(9) && cldplay) || Ext.isChrome || Ext.isSafari || (!QNAP.QOS.lib.isMobileBrowser)) {

if (file.mp4_240 == 0 && file.mp4_360 == 0 && file.mp4_480 == 0 && file.mp4_720 == 0 && file.mp4_1080 == 0) {
if(!/\.(mp4)$/i.test(file.filename)){
delete visible['gcm_play_main'];
}
visible['gcm_download_main'] = true;
var isTransFolder = file.filepath.split('/').pop() == '@Transcode';
if (isTransFolder) {
visible['gcm_play_main'] = true;
}
if (!isTransFolder && FM.RTT && QNAP.QOS.user.isAdminGroup) {
visible['gcm_play2'] = true;
delete visible['gcm_play_main'];
} else {
delete visible['gcm_play2'];
}
delete visible['gcm_download2'];
} else {
if (FM.RTT && QNAP.QOS.fileExplorerTools.tool.couldBeTrans(file) && QNAP.QOS.user.isAdminGroup) {
visible['gcm_play_main'] = true;
delete visible['gcm_play2'];
} else {
delete visible['gcm_play_main'];
visible['gcm_play2'] = true;
}
delete visible['gcm_play_main'];
delete visible['gcm_download_main'];
visible['gcm_play2'] = true;
visible['gcm_download2'] = true;
var playQVMenu = contextMenu.getComponent('gcm_play2').menu;
var downloadQVMenu = contextMenu.getComponent('gcm_download2').menu;
if (selections[0].get('mp4_240') == 1) {
playQVMenu.getComponent('240p').show();
downloadQVMenu.getComponent('240p').show();
} else {
playQVMenu.getComponent('240p').hide();
downloadQVMenu.getComponent('240p').hide();
}
if (selections[0].get('mp4_360') == 1) {
playQVMenu.getComponent('360p').show();
downloadQVMenu.getComponent('360p').show();
} else {
playQVMenu.getComponent('360p').hide();
downloadQVMenu.getComponent('360p').hide();
}
if (selections[0].get('mp4_480') == 1) {
playQVMenu.getComponent('480p').show();
downloadQVMenu.getComponent('480p').show();
} else {
playQVMenu.getComponent('480p').hide();
downloadQVMenu.getComponent('480p').hide();
}
if (selections[0].get('mp4_720') == 1) {
playQVMenu.getComponent('720p').show();
downloadQVMenu.getComponent('720p').show();
} else {
playQVMenu.getComponent('720p').hide();
downloadQVMenu.getComponent('720p').hide();
}
if (selections[0].get('mp4_1080') == 1) {
playQVMenu.getComponent('1080p').show();
downloadQVMenu.getComponent('1080p').show();
} else {
playQVMenu.getComponent('1080p').hide();
downloadQVMenu.getComponent('1080p').hide();
}
downloadQVMenu.getComponent('oFile').show();
}
if ((selections[0].data.trans == 1 || selections[0].data.mp4_240 == 1 || selections[0].data.mp4_360 == 1 || selections[0].data.mp4_480 == 1 || selections[0].data.mp4_720 == 1 || selections[0].data.mp4_1080 == 1) && QNAP.QOS.user.isAdminGroup) {
visible['gcm_delTmpVideoBtn'] = true;
} else {
delete visible['gcm_delTmpVideoBtn'];
}
if ( !Ext.isEmpty(FM.sysSetting.transcode_server_status) && FM.sysSetting.transcode_server_status <= 0){
delete visible['gcm_delTmpVideoBtn'];
}
} else {
var ua = navigator.userAgent;
var isiPad = /iPad/i.test(ua);
var isiPod = /iPod/i.test(ua);
var isiPhone = /iPhone/i.test(ua);
var isApple = isiPad || isiPod || isiPhone;
if (isApple && file.mp4_720 == 1) {
visible['gcm_play_main'] = true;
} else {
delete visible['gcm_play_main'];
}
}
/** **********判斷play是否顯示 End****************** */

if (mediaType == 'isVideo') {
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(selections[0].get('filename'))) {
var fArr = selections[0].get('filename').split('/');
if (fArr[fArr.length - 2] == '@Transcode') {
isTransFolder = true;
}
}
if (QNAP.QOS.fileExplorerTools.tool.couldBeTrans(selections[0].data)
&& QNAP.QOS.user.isAdminGroup
&& FM.currentPath.split('/').pop() != '@Transcode'
&& !isTransFolder
&& !Ext.isEmpty(FM.sysSetting.transcode_server_status)
&& FM.sysSetting.transcode_server_status>0) {
visible['gcm_transcodeBtn_main'] = true;
} else {
delete visible['gcm_transcodeBtn_main'];
}
if ((selections[0].data.trans == 1 || selections[0].data.mp4_240 == 1 || selections[0].data.mp4_360 == 1 || selections[0].data.mp4_480 == 1 || selections[0].data.mp4_720 == 1 || selections[0].data.mp4_1080 == 1) && QNAP.QOS.user.isAdminGroup) {
visible['gcm_delTmpVideoBtn'] = true;
} else {
delete visible['gcm_delTmpVideoBtn'];
}
} else {
delete visible['gcm_transcodeBtn_main'];
delete visible['gcm_delTmpVideoBtn'];
}

if (!FM.isWFM && QNAP.QOS.user.isAdminGroup) {
visible['gcm_transInfoBtn'] = true;
} else {
delete visible['gcm_transInfoBtn'];
}
if ( !Ext.isEmpty(FM.sysSetting.transcode_server_status) && FM.sysSetting.transcode_server_status <= 0){
delete visible['gcm_delTmpVideoBtn'];
delete visible['gcm_transInfoBtn'];
}
} else if (mediaType == 'isAudio') {
visible['gcm_play_main'] = true;
delete visible['gcm_transcodeBtn_main'];
delete visible['gcm_delTmpVideoBtn'];
} else if (mediaType == 'isPhoto') {
visible['gcm_play_main'] = true;
delete visible['gcm_transcodeBtn_main'];
delete visible['gcm_delTmpVideoBtn'];
} else {
delete visible['gcm_streamBtn'];
delete visible['gcm_play_main'];
delete visible['gcm_transcodeBtn_main'];
delete visible['gcm_delTmpVideoBtn'];
delete visible['gcm_transInfoBtn'];
}
if (!folderInMediaLib) {
delete visible['gcm_streamBtn'];
}
var isIsoFile = /\.(iso|nrg)$/i.test(file.filename);
if (!isIsoFile || !QNAP.QOS.user.isAdminGroup) { // 映像檔
delete visible['gcm_mount'];
}
if (!/\.(eml)$/i.test(file.filename) || FM.isWFM) {
delete visible['gcm_qMailBtn'];
}
var isZipFile = /\.(7z|gzip|gz|zip|bzip2|bz2|tar|rar|tgz)$/i.test(file.filename);
if (!isZipFile) { // 壓縮檔
delete visible['gcm_extract_main'];
} else {
if (FM.currentPath.indexOf('/home/.Qsync') >= 0) {
contextMenu.getComponent('gcm_extract_main').menu.getComponent('gcm_extract').hide();
contextMenu.getComponent('gcm_extract_main').menu.getComponent('gcm_extract_here').hide();
} else {

contextMenu.getComponent('gcm_extract_main').menu.getComponent('gcm_extract').show();
contextMenu.getComponent('gcm_extract_main').menu.getComponent('gcm_extract_here').show();
}
}
if (Ext.isChrome) {
if (!QNAP.QOS.fileExplorerTools.tool.isExtDoc(selections[0].get('filename'))) {
delete visible['gcm_extOpBtn'];
} else {
if (FM.isOfficeExtInst) delete visible['gcm_open_main'];
}
} else {
delete visible['gcm_extOpBtn'];
}
if(/\.(dsdownload)$/i.test(file.filename)){
delete visible['gcm_compressBtn'];
delete visible['gcm_shareLink'];
}
} else { // 選一個資料夾
delete visible['gcm_removeFav'];
delete visible['gcm_extract_main'];
delete visible['gcm_mount'];
delete visible['gcm_play_main'];
delete visible['gcm_streamBtn'];
var isTransFolder;
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(selections[0].get('filename'))) {
var fArr = selections[0].get('filename').split('/');
if (fArr[fArr.length - 1] == '@Transcode') {
isTransFolder = true;
}
}
delete visible['gcm_transcodeBtn_main'];
delete visible['gcm_delTmpVideoBtn'];
delete visible['gcm_transInfoBtn'];
if (QNAP.QOS.user.isAdminGroup
&& selections[0].get('filename') != '@Transcode'
&& !isTransFolder
&& !Ext.isEmpty(FM.sysSetting.transcode_server_status)
) {
if(FM.sysSetting.transcode_server_status>0){
visible['gcm_transcodeBtn_main'] = true;
}
if(FM.sysSetting.transcode_server_status>0){
visible['gcm_delTmpVideoBtn'] = true;
visible['gcm_transInfoBtn'] = true;
}
}
var fileName = QNAP.QOS.fileExplorerTools.tool.getFileNamPath(file.filename)[0];
var fullpath = FM.currentPath + '/' + fileName;
if (FM.favoriteStore.indexOfId(fullpath) >= 0) {
visible['gcm_removeFav'] = true;
delete visible['gcm_addToFav'];
} else {
delete visible['gcm_removeFav'];
visible['gcm_addToFav'] = true;
}
var isRCBFolder = QNAP.QOS.fileExplorerTools.tool.isRecycleBin(fullpath);
if (isRCBFolder) {
delete visible['gcm_addToFav'];
}
if (file.filename == '@Recycle') {
visible['gcm_recycleEmptyBtn'] = true;
}
if (!FM.isWFM && QNAP.QOS.user.isAdminGroup) {
visible['gcm_transInfoBtn'] = true;
} else {
delete visible['gcm_transInfoBtn'];
}
if(FM.isWFM){
delete visible['gcm_createShortcut'];
}
delete visible['gcm_extOpBtn'];
delete visible['gcm_openWithVLCBtn'];
delete visible['gcm_qMailBtn'];
}
if (selections[0].get('versioning_support') == 1) {
visible['gcm_versionsBtn'] = true;
} else {
delete visible['gcm_versionsBtn'];
}
if (!QNAP.QOS.user.isAdminGroup && !FM.isAllowAllShare) {
delete visible['gcm_shareLink'];
}
if (!QNAP.QOS.fileExplorerTools.tool.isGoogleDoc(file)) {
delete visible['gcm_googleDocBtn'];
}
if (!QNAP.QOS.fileExplorerTools.tool.isOfficeDoc(file)) {
delete visible['gcm_officeOLBtn'];
}
if(FM.isWFM){
delete visible['gcm_transInfoBtn'];
}

} else { // 未選任何檔案
visible = {};
visible['gcm_sortBtn'] = true;
visible['gcm_newFolderBtn'] = true;
visible['gcm_properties'] = true;
if (QNAP.QOS.FileClipBoard.getFiles().length == 0 || (QNAP.QOS.FileClipBoard.sourcePath == FM.treeNodeId)) { // 如果剪貼簿裡有東西則顯示貼上按鈕
} else {
visible['gcm_past'] = true;
}
}
}
var pathArr = FM.currentPath.split('/');
if (pathArr[1] == 'homes' && pathArr[3] == '.Qsync') {
visible = {};
visible['gcm_copy'] = true;
}
var rw = QNAP.QOS.fileExplorerTools.tool.checkRW(FM, FM.currentPath);
if (rw == 'r') { // 如果這個資料夾這個使用者只有讀取的權限。
delete visible['gcm_newFolderBtn'];
delete visible['gcm_past'];
delete visible['gcm_rename'];
delete visible['gcm_move'];
delete visible['gcm_del'];
delete visible['gcm_cut'];
delete visible['gcm_transcodeBtn_main'];
delete visible['gcm_delTmpVideoBtn'];
delete visible['gcm_transInfoBtn'];
delete visible['gcm_extract_main'];
delete visible['gcm_compressBtn'];
delete visible['gcm_recycleDelBtn'];
delete visible['gcm_recycleRcvBtn'];
delete visible['gcm_recycleEmptyBtn'];
}
if (!QNAP.QOS.user.isAdminGroup) {
delete visible['gcm_streamBtn'];
}
visible = FM.noWrtBtnControl_gridContextMenu(visible);
/* hide remote folder not support features */
var path = FM.gridPanel.store.baseParams.path,
matched = /^(fav_)?(\/remote:\d+@[0-9a-f]{40})/.exec(path);
if (matched) {
var node = FM.treePanel.root.findChild('id', matched[2], true);
if (node instanceof QNAP.QOS.FM.Remote.FolderNode && node.attributes.configure.thumbnail == 0) {
delete visible['gcm_play2'];
delete visible['gcm_play_main'];
delete visible['gcm_streamBtn'];
}
delete visible['gcm_shareLink'];
delete visible['gcm_extract_main'];
delete visible['gcm_compressBtn'];
delete visible['gcm_transInfoBtn'];
delete visible['gcm_delTmpVideoBtn'];
delete visible['gcm_transcodeBtn_main'];
}
for (var itemId in visible) {
contextMenu.setItemVisible(visible);
contextMenu.showAt(event.getXY());
break;
}
}, // showNasGridContextMenu End
noWrtBtnControl_moreBtn : function() {
var FM = this;
var funMenuBtn = FM.fncBtns.getComponent('moreActionBtn').menu;
var selections = FM.gridPanel.getSelectionModel().getSelections();
var isTransFolder = false;
Ext.each(selections, function(file) {
if (file.data.isfolder == 1 && file.data.filename == '@Transcode') {
isTransFolder = true;
}
});
if (!QNAP.QOS.user.isAdminGroup || isTransFolder
|| Ext.isEmpty(FM.sysSetting.transcode_server_status)
|| FM.sysSetting.transcode_server_status<0
) {
funMenuBtn.getComponent('delTmpVideoBtn').hide();
funMenuBtn.getComponent('transInfoBtn').hide();
}
if (!QNAP.QOS.user.isAdminGroup || isTransFolder
|| Ext.isEmpty(FM.sysSetting.transcode_server_status)
|| FM.sysSetting.transcode_server_status<=0
) {
funMenuBtn.getComponent('transcodeBtn').hide();
funMenuBtn.getComponent('transInfoBtn').hide();
funMenuBtn.getComponent('delTmpVideoBtn').hide();
}

var path=FM.gridPanel.store.baseParams.path;
if(FM.searchMode && selections.length!=1){//|| (path=='/home/.Qsync' && selections.length!=1)
FM.fncBtns.getComponent('shareBtn').hide();
}
},
noWrtBtnControl_gridContextMenu : function(visible) {
var FM = this;
if (!QNAP.QOS.user.isAdminGroup
|| Ext.isEmpty(FM.sysSetting.transcode_server_status)
|| FM.sysSetting.transcode_server_status<0) {
delete visible['gcm_delTmpVideoBtn'];
delete visible['gcm_transInfoBtn'];
}
if (!QNAP.QOS.user.isAdminGroup
|| Ext.isEmpty(FM.sysSetting.transcode_server_status)
|| FM.sysSetting.transcode_server_status<=0) {
delete visible['gcm_transcodeBtn_main'];
delete visible['gcm_transInfoBtn'];
}
var selections = FM.gridPanel.getSelectionModel().getSelections();
var path=FM.gridPanel.store.baseParams.path;
if((FM.searchMode && selections.length!=1)){
delete visible['gcm_shareLink'];
}
return visible;
},
noWrtBtnControl_treeContextMenu : function(nodeId, visible) {
var FM = this;
var isRCBFolder=QNAP.QOS.fileExplorerTools.tool.isRecycleBin(nodeId);

var rw = QNAP.QOS.fileExplorerTools.tool.checkRW(FM, nodeId);
if (rw == 'r' || isRCBFolder || nodeId.split('/').pop() == '@Transcode') {
delete visible['tcm_compressBtn'];
delete visible['tcm_past'];
delete visible['tcm_transcodeBtn_main'];
delete visible['tcm_delTmpVideoBtn'];
}else if (rw == 'w' && QNAP.QOS.user.isAdminGroup) {
}
if(isRCBFolder){
visible = {};
visible['tcm_properties'] = true;
}
return visible;
},
initFunBtn : function() {
var FM = this;
FM.fncBtns.getComponent('copyBtn').hide();
FM.fncBtns.getComponent('pastBtn').hide();
FM.fncBtns.getComponent('shareBtn').hide();
var funMenuBtn = FM.fncBtns.getComponent('moreActionBtn').menu;
Ext.each(funMenuBtn.items.items, function(btn) {
btn.hide();// 按鈕預設值:全部隱藏
});
funMenuBtn.getComponent('addToFavoritesBtn').show();
funMenuBtn.getComponent('propertiesBtn').show();
if (!FM.isWFM && QNAP.QOS.user.isAdminGroup) {
funMenuBtn.getComponent('transInfoBtn').show();
} else {
funMenuBtn.getComponent('transInfoBtn').hide();
}
funMenuBtn.getComponent('cpMvListBtn').show();
funMenuBtn.getComponent('storageInfoBtn').show();
FM.noWrtBtnControl_moreBtn();
},
showActionBtn : function() {
var FM = this;
var fncBtns = FM.fncBtns;
var funMenuBtn = FM.fncBtns.getComponent('moreActionBtn').menu;
var selections = FM.gridPanel.getSelectionModel().getSelections();
var isRecycle = false;

var isQFTPRoot=false;
if(FM.currentPath && FM.currentPath.indexOf('/remote:')==0){
var pathArr=FM.currentPath.split('/');
var destRoot='/'+pathArr[1];
var destRootNode = FM.treeRoot.findChild('id',destRoot,true);
var conf=destRootNode.attributes.configure;
if(conf.q_nas==1 && (pathArr.indexOf('Qsync')>0 || pathArr.indexOf('.Qsync')>0)){//阻擋複製到QNAP NAS的Qsync
}else if(conf.q_nas==1 && conf.protocol.indexOf('ftp')==0 && conf.folder=='/' && pathArr.length<=2){//阻擋複製到QNAP FTP Root (/)的動作 (FTP)
isQFTPRoot=true;
}
}
if (FM.currentPath.indexOf('@Recycle') >= 0) {
Ext.each(fncBtns.items.items, function(btn) {
btn.hide();// 按鈕預設值:全部隱藏
});
FM.fncBtns.getComponent('addFolderBtn').hide();
FM.fncBtns.getComponent('moreActionBtn').show();
Ext.each(funMenuBtn.items.items, function(btn) {
btn.hide();// 按鈕預設值:全部隱藏
});
funMenuBtn.getComponent('recycleEmptyBtn').show();
if (selections.length >= 1) {
funMenuBtn.getComponent('recycleDelBtn').show();
funMenuBtn.getComponent('recycleRcvBtn').show();
} else {
funMenuBtn.getComponent('recycleDelBtn').hide();
funMenuBtn.getComponent('recycleRcvBtn').hide();
}
} else {
Ext.each(fncBtns.items.items, function(btn) {
btn.show();// 按鈕預設值:全部打開
});
Ext.each(funMenuBtn.items.items, function(btn) {
btn.show();// 按鈕預設值:全部打開
});
if (FM.isWFM || !QNAP.QOS.user.isAdminGroup) {
funMenuBtn.getComponent('transInfoBtn').hide();
} else {
funMenuBtn.getComponent('transInfoBtn').show();
}
funMenuBtn.getComponent('downloadBtn2').hide();
/* 隱藏資源回收桶的三個按鈕 */
funMenuBtn.getComponent('recycleDelBtn').hide();
funMenuBtn.getComponent('recycleRcvBtn').hide();
funMenuBtn.getComponent('recycleEmptyBtn').hide();
if (QNAP.QOS.FileClipBoard.getFiles().length == 0) {// 如果剪貼簿裡有東西則顯示貼上按鈕
fncBtns.getComponent('pastBtn').hide();
} else {
fncBtns.getComponent('pastBtn').show();
}

var couldOPTrans = false,isMMedia = true,folderInMediaLib=true;
var mediaFolders = FM.config.mediaFolders;
Ext.each(selections, function(file) {
var mediaType = QNAP.QOS.fileExplorerTools.tool.getMultiMediaType(file.data.filename);
if (file.data.isfolder == 1 || mediaType == 'isVideo') {
couldOPTrans = true;
}
if(mediaType=='notMultiMedia'){
isMMedia=false;
}
});
if (selections.length > 1) {
funMenuBtn.getComponent('playBtn').hide();
funMenuBtn.getComponent('playBtn2').hide();
funMenuBtn.getComponent('delTmpVideoBtn').hide();
funMenuBtn.getComponent('createShortcut').hide();
funMenuBtn.getComponent('addToFavoritesBtn').hide();
funMenuBtn.getComponent('renameBtn').hide();
funMenuBtn.getComponent('extractBtn').hide();
funMenuBtn.getComponent('mountBtn').hide();
funMenuBtn.getComponent('downloadBtn').hide();
funMenuBtn.getComponent('downloadBtn2').show();
funMenuBtn.getComponent('officeOLBtn').hide();
funMenuBtn.getComponent('googleDocBtn').hide();
funMenuBtn.getComponent('openBtn').hide();
funMenuBtn.getComponent('qMailBtn').hide();
funMenuBtn.getComponent('extOpBtn').hide();
funMenuBtn.getComponent('openWithVLCBtn').hide();
if (couldOPTrans && QNAP.QOS.user.isAdminGroup  && !FM.searchMode
&& !Ext.isEmpty(FM.sysSetting.transcode_server_status)
&& FM.sysSetting.transcode_server_status>0
) {
funMenuBtn.getComponent('transcodeBtn').show();
funMenuBtn.getComponent('transInfoBtn').show();
} else {
funMenuBtn.getComponent('transcodeBtn').hide();
funMenuBtn.getComponent('transInfoBtn').hide();
}
if(isMMedia && folderInMediaLib){
funMenuBtn.getComponent('streamBtn').show();
}else{
funMenuBtn.getComponent('streamBtn').hide();
}
funMenuBtn.getComponent('versionsBtn').hide();
if(!QNAP.QOS.user.isAdminGroup && !FM.isAllowAllShare){
fncBtns.getComponent('shareBtn').hide();
}
var isDSFile=false;
Ext.each(selections,function(file){
if(/\.(dsdownload)$/i.test(file.get('filename'))){
isDSFile=true;
}
});
if(isDSFile){
fncBtns.getComponent('shareBtn').hide();
}
} else if (selections.length == 1) {
funMenuBtn.getComponent('delTmpVideoBtn').hide();
if (selections[0].data.isfolder == 0) {
var file = selections[0].data;
var extension = file.filename.split('.')[file.filename.split('.').length- 1];
funMenuBtn.getComponent('createShortcut').hide();
funMenuBtn.getComponent('addToFavoritesBtn').hide();
var isIsoFile = /\.(iso|nrg)$/i.test(file.filename);
if (!isIsoFile || !QNAP.QOS.user.isAdminGroup) {// 映像檔
funMenuBtn.getComponent('mountBtn').hide();
}
var isZipFile = /\.(7z|gzip|gz|zip|bzip2|bz2|tar|rar|tgz)$/i.test(file.filename);
if (!isZipFile) {// 壓縮檔
funMenuBtn.getComponent('extractBtn').hide();
} else {
if (FM.currentPath.indexOf('/home/.Qsync')>=0) {
funMenuBtn.getComponent('extractBtn').menu.getComponent('gcm_extract').hide();
funMenuBtn.getComponent('extractBtn').menu.getComponent('gcm_extract_here').hide();
} else {
funMenuBtn.getComponent('extractBtn').menu
.getComponent('gcm_extract').show();
funMenuBtn.getComponent('extractBtn').menu
.getComponent('gcm_extract_here').show();
}
}
if(/\.(dsdownload)$/i.test(file.filename)){
fncBtns.getComponent('shareBtn').hide();
}
if(/\.(eml)$/i.test(file.filename) && !FM.isWFM){
funMenuBtn.getComponent('qMailBtn').show();
}else{
funMenuBtn.getComponent('qMailBtn').hide();
}
var mediaType = QNAP.QOS.fileExplorerTools.tool.getMultiMediaType(file.filename);

funMenuBtn.getComponent('openWithVLCBtn').setVisible(mediaType == 'isVideo' && !Ext.isMac && !Ext.isChrome);
if (mediaType == 'isVideo') {
/* 判斷transcode是否顯示 */
var isTransFolder;
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(selections[0].get('filename'))) {
var fArr=selections[0].get('filename').split('/');
if(fArr[fArr.length-2]== '@Transcode'){
isTransFolder=true;
}
}
if (QNAP.QOS.fileExplorerTools.tool.couldBeTrans(file)
&& QNAP.QOS.user.isAdminGroup && !isTransFolder
&& !Ext.isEmpty(FM.sysSetting.transcode_server_status)
&& FM.sysSetting.transcode_server_status>0) {
funMenuBtn.getComponent('transcodeBtn').show();
funMenuBtn.getComponent('transInfoBtn').show();
} else {
funMenuBtn.getComponent('transcodeBtn').hide();
funMenuBtn.getComponent('transInfoBtn').hide();
}
/* 判斷play是否顯示 */
var play = FM.RTT
|| file.mp4_360 == 1 || file.mp4_240 == 1
|| file.mp4_720 == 1 || file.mp4_480 == 1
|| file.mp4_1080 == 1;
if ((DetectFlashVer(9) && play) || Ext.isChrome
|| Ext.isSafari
|| (!QNAP.QOS.lib.isMobileBrowser)) {
funMenuBtn.getComponent('playBtn').show();
if (file.mp4_240 == 0 && file.mp4_360 == 0
&& file.mp4_480 == 0 && file.mp4_720 == 0
&& file.mp4_1080 == 0) {
funMenuBtn.getComponent('playBtn').hide();
funMenuBtn.getComponent('downloadBtn').hide();
if (file.play == 1) {//在@Transcode資料夾裡面已經轉好檔的檔案
funMenuBtn.getComponent('playBtn').hide();
funMenuBtn.getComponent('playBtn2').show();
funMenuBtn.getComponent('transcodeBtn').hide();
} else {

if (FM.RTT && QNAP.QOS.user.isAdminGroup) {
funMenuBtn.getComponent('playBtn').show();
funMenuBtn.getComponent('playBtn2').hide();
} else {
funMenuBtn.getComponent('playBtn2').hide();
funMenuBtn.getComponent('playBtn').hide();
}
}
funMenuBtn.getComponent('downloadBtn2').show();
} else {
funMenuBtn.getComponent('playBtn').show();
var playQVMenu = funMenuBtn
.getComponent('playBtn').menu;
var downloadQVMenu = funMenuBtn
.getComponent('downloadBtn').menu;
if (selections[0].get('mp4_240') == 1) {
playQVMenu.getComponent('240p').show();
downloadQVMenu.getComponent('240p').show();
} else {
playQVMenu.getComponent('240p').hide();
downloadQVMenu.getComponent('240p').hide();
}
if (selections[0].get('mp4_360') == 1) {
playQVMenu.getComponent('360p').show();
downloadQVMenu.getComponent('360p').show();
} else {
playQVMenu.getComponent('360p').hide();
downloadQVMenu.getComponent('360p').hide();
}
if (selections[0].get('mp4_480') == 1) {
playQVMenu.getComponent('480p').show();
downloadQVMenu.getComponent('480p').show();
} else {
playQVMenu.getComponent('480p').hide();
downloadQVMenu.getComponent('480p').hide();
}
if (selections[0].get('mp4_720') == 1) {
playQVMenu.getComponent('720p').show();
downloadQVMenu.getComponent('720p').show();
} else {
playQVMenu.getComponent('720p').hide();
downloadQVMenu.getComponent('720p').hide();
}
if (selections[0].get('mp4_1080') == 1) {
playQVMenu.getComponent('1080p').show();
downloadQVMenu.getComponent('1080p').show();
} else {
playQVMenu.getComponent('1080p').hide();
downloadQVMenu.getComponent('1080p').hide();
}
funMenuBtn.getComponent('downloadBtn').show();
downloadQVMenu.getComponent('oFile').show();
funMenuBtn.getComponent('playBtn2').hide();
funMenuBtn.getComponent('downloadBtn2').hide();
}

} else {
var ua = navigator.userAgent;
var isiPad = /iPad/i.test(ua);
var isiPod = /iPod/i.test(ua);
var isiPhone = /iPhone/i.test(ua);
var isApple = isiPad || isiPod || isiPhone;
if (isApple && file.mp4_720 == 1) {
funMenuBtn.getComponent('playBtn').show();
funMenuBtn.getComponent('playBtn2').hide();
} else {
funMenuBtn.getComponent('playBtn').hide();
funMenuBtn.getComponent('playBtn2').hide();
}
}
if (!FM.RTT) {// CPU等級較低不論如何皆隱藏
funMenuBtn.getComponent('playBtn').hide();
var isPlay = FM.RTT
|| file.mp4_360 == 1 || file.mp4_240 == 1
|| file.mp4_720 == 1 || file.mp4_480 == 1
|| file.mp4_1080 == 1;
if(isPlay){
funMenuBtn.getComponent('playBtn').show();
}else if(/\.(mp4)$/i.test(file.filename)){
funMenuBtn.getComponent('playBtn2').show();
}else{
funMenuBtn.getComponent('playBtn2').hide();
}
}
if ((file.trans == 1  || file.mp4_240 == 1
|| file.mp4_360 == 1 || file.mp4_480 == 1
|| file.mp4_720 == 1 || file.mp4_1080 == 1)
&& QNAP.QOS.user.isAdminGroup) {
funMenuBtn.getComponent('delTmpVideoBtn').show();
} else {
funMenuBtn.getComponent('delTmpVideoBtn').hide();
}
} else if (mediaType == 'isAudio') {
funMenuBtn.getComponent('playBtn').hide();
funMenuBtn.getComponent('playBtn2').show();
funMenuBtn.getComponent('transcodeBtn').hide();
funMenuBtn.getComponent('downloadBtn2').show();
funMenuBtn.getComponent('downloadBtn').hide();
} else if (mediaType == 'isPhoto') {
funMenuBtn.getComponent('playBtn').hide();
funMenuBtn.getComponent('playBtn2').show();
funMenuBtn.getComponent('transcodeBtn').hide();
funMenuBtn.getComponent('downloadBtn2').show();
funMenuBtn.getComponent('downloadBtn').hide();
} else {
funMenuBtn.getComponent('streamBtn').hide();
funMenuBtn.getComponent('playBtn').hide();
funMenuBtn.getComponent('playBtn2').hide();
funMenuBtn.getComponent('transcodeBtn').hide();
funMenuBtn.getComponent('downloadBtn2').show();
funMenuBtn.getComponent('downloadBtn').hide();
}
if(!folderInMediaLib){
funMenuBtn.getComponent('streamBtn').hide();
}
if(!QNAP.QOS.fileExplorerTools.tool.isGoogleDoc(file)){
funMenuBtn.getComponent('googleDocBtn').hide();
}
if(!QNAP.QOS.fileExplorerTools.tool.isOfficeDoc(file)){
funMenuBtn.getComponent('officeOLBtn').hide();
}
if(Ext.isChrome){
if(!QNAP.QOS.fileExplorerTools.tool.isExtDoc(selections[0].get('filename'))){
funMenuBtn.getComponent('extOpBtn').hide();
}else{
if(FM.isOfficeExtInst)
funMenuBtn.getComponent('openBtn').hide();
}
}else{
funMenuBtn.getComponent('extOpBtn').hide();
}
} else {// 選一個資料夾
funMenuBtn.getComponent('downloadBtn2').show();
funMenuBtn.getComponent('downloadBtn').hide();
funMenuBtn.getComponent('playBtn').hide();
funMenuBtn.getComponent('playBtn2').hide();
var isTransFolder;
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(selections[0].get('filename'))) {
var fArr=selections[0].get('filename').split('/');
if(fArr[fArr.length-1]== '@Transcode'){
isTransFolder=true;
}
}
if (QNAP.QOS.user.isAdminGroup && !isTransFolder
&& !Ext.isEmpty(FM.sysSetting.transcode_server_status)
&& FM.sysSetting.transcode_server_status>0) {
funMenuBtn.getComponent('transcodeBtn').show();
funMenuBtn.getComponent('transInfoBtn').show();
} else {
funMenuBtn.getComponent('transcodeBtn').hide();
funMenuBtn.getComponent('transInfoBtn').hide();
}
if (QNAP.QOS.user.isAdminGroup && !isTransFolder
&& !Ext.isEmpty(FM.sysSetting.transcode_server_status)
&& FM.sysSetting.transcode_server_status>=0) {
funMenuBtn.getComponent('delTmpVideoBtn').show();
} else {
funMenuBtn.getComponent('delTmpVideoBtn').hide();
}
if(FM.isWFM){
funMenuBtn.getComponent('createShortcut').hide();
}
if (!Ext.isEmpty(FM.sysSetting.transcode_server_status)
&& FM.sysSetting.transcode_server_status<=0) {
funMenuBtn.getComponent('delTmpVideoBtn').hide();
}

funMenuBtn.getComponent('extractBtn').hide();
funMenuBtn.getComponent('mountBtn').hide();
funMenuBtn.getComponent('openWithVLCBtn').hide();
funMenuBtn.getComponent('streamBtn').hide();
funMenuBtn.getComponent('extOpBtn').hide();
funMenuBtn.getComponent('googleDocBtn').hide();
funMenuBtn.getComponent('officeOLBtn').hide();
funMenuBtn.getComponent('qMailBtn').hide();
}

if(selections[0].get('versioning_support')==1){
funMenuBtn.getComponent('versionsBtn').show();
}else{
funMenuBtn.getComponent('versionsBtn').hide();
}
if(!QNAP.QOS.user.isAdminGroup && !FM.isAllowAllShare){
fncBtns.getComponent('shareBtn').hide();
}
} else {// 未選任何檔案
FM.initFunBtn();
if (QNAP.QOS.FileClipBoard.getFiles().length == 0) {// 如果剪貼簿裡有東西則顯示貼上按鈕
fncBtns.getComponent('pastBtn').hide();
} else {
fncBtns.getComponent('pastBtn').show();
}
}
}


var pathArr = FM.currentPath.split('/');
if (pathArr[1] == 'homes' && pathArr[3] == '.Qsync') {
QNAP.QOS.fileExplorerTools.tool.checkToolBar(FM, null,'r');
FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('versionsBtn').hide();
}
if(FM.currentPath.indexOf('/home/.Qsync')>=0){
Ext.Ajax.request({// 確認version 功能有沒有開啟或壞掉
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'versioning_probe'),
success : function(rs, rq) {
var resulte = Ext.util.JSON.decode(rs.responseText);
FM.checkVerParam=resulte;
if (resulte.qbox_versioning_enable == 1 && resulte.versioning_enable == 1) {
funMenuBtn.getComponent('showHDFGBtn').show();
} else {
funMenuBtn.getComponent('showHDFGBtn').hide();
FM.maskVerPanel();
}
},
failure : function(resulte, rq) {
}
});
}else{
funMenuBtn.getComponent('showHDFGBtn').hide();
}
var crNode= FM.treePanel.root.findChild('id', FM.currentPath, true);
var rw;
if(crNode && crNode.attributes.cls){
rw=QNAP.QOS.fileExplorerTools.tool.convertPmis(crNode.attributes.cls);
}
QNAP.QOS.fileExplorerTools.tool.checkToolBar(FM, FM.currentPath,rw);
if (!QNAP.QOS.user.isAdminGroup){
funMenuBtn.getComponent('streamBtn').hide();
}

var path = FM.currentPath,
matched = /^(fav_)?(\/remote:\d+@[0-9a-f]{40})/.exec(path);
if (matched) {
var node = FM.treePanel.root.findChild('id', matched[2], true);
if (node instanceof QNAP.QOS.FM.Remote.FolderNode && node.attributes.configure.thumbnail == 0) {
funMenuBtn.getComponent('playBtn').hide();
funMenuBtn.getComponent('playBtn2').hide();
funMenuBtn.getComponent('streamBtn').hide();
funMenuBtn.getComponent('extractBtn').hide();

}
fncBtns.getComponent('shareBtn').hide();
}

function checkMoreActBtns(){//如果發現下拉選單全部隱藏了，則隱藏'moreActionBtn'按鈕
var isAllHidden=true;
Ext.each(funMenuBtn.items.items,function(button){
if(!button.hidden){
isAllHidden=false;
}
});
if(isAllHidden){
FM.fncBtns.getComponent('moreActionBtn').hide();
}
}
FM.checkHLine(funMenuBtn);
checkMoreActBtns();
fncBtns.doLayout();
funMenuBtn.doLayout();
FM.noWrtBtnControl_moreBtn();


},// showActionBtn End
checkHLine : function(menu) {//判斷分隔線是否要隱藏
var btnIndex=0,hLineArr=[0];
Ext.each(menu.items.items,function(btn){
if(Ext.isEmpty(btn.text)){
hLineArr.push(btnIndex);
}
btnIndex++
});
function hideHLine(){
var j=hLineArr.shift();
var k=hLineArr[0];
if(j!=0){
j++;
}
if(k){
var hideLine=true;
for(var i=j;i<k;i++){
if(!menu.items.items[i].hidden){
hideLine=false;
}
}
if(hideLine){
menu.items.items[k].hide();
}
if(hLineArr.length!=0){
hideHLine()
}
}
}

hideHLine();
},
lockStatusBtns : function() {
var FM=this;
FM.initFunBtn();
Ext.each(FM.fncBtns.items.items, function(btn) {
btn.hide();//全部隱藏
});
FM.fncBtns.getComponent('moreActionBtn').show();
var funMenuBtn = FM.fncBtns.getComponent('moreActionBtn').menu;
Ext.each(funMenuBtn.items.items, function(btn) {
btn.hide();//全部隱藏
});

funMenuBtn.getComponent('transInfoBtn').show();
funMenuBtn.getComponent('cpMvListBtn').show();
funMenuBtn.getComponent('storageInfoBtn').show();
},
maskVerPanel : function() {
var FM = this;
if(FM.checkVerParam){
var msg =_S._SFE_LANG_MSG_NO_VERSION_CONTROL.replace('<qtag>','<a href="#" onClick="QNAP.QOS.fileExplorerTools.tool.openAppQsyncVersion();">').replace('</qtag>','</a>');
if(!QNAP.QOS.user.isAdminGroup){
msg =_S._SFE_LANG_MSG_NO_VERSION_CONTROL2;
}else if(FM.isWFM){
msg =_S._SFE_LANG_MSG_NO_VERSION_CONTROL;
}
if(FM.historyPanel){
var verPanelMask = new Ext.LoadMask(FM.historyPanel.id, {msg : (msg)});
if(FM.checkVerParam.qbox_versioning_enable==1 && FM.checkVerParam.versioning_enable==1){
verPanelMask.hide();
}else{
verPanelMask.show();
}
}
}
},
clickFavorite : function(node) {
var FM = this, shareListView = true;
var swichModeBtn=Ext.getCmp(FM.northPanelId).getComponent('switchModeGroup').getComponent('mode2Btn');
if (swichModeBtn.pressed) {
FM.setMainScr('NasDataView-id');
} else {
FM.setMainScr('file-panel');
}
var dataPath;

if (!node.attributes.data.path) {
dataPath = node.id.substring(4, node.id.length);
} else {
dataPath = node.attributes.data.path;
}
FM.openPath(dataPath);
FM.currentGrid = 'fileGrid';
},// clickFavorite End
setPropertyGeneralPanelValue : function() {
var FM = this;
var selections = FM.gridPanel.getSelectionModel().getSelections();
var _pi_file_html;
if (selections.length > 1) {
var totalSize = 0, location = '', folderNum = 0, fileNum = 0;

for (var i = 0; i < selections.length; i++) {
if (parseInt(selections[i].get('isfolder')) == 1) {
params += '&name='
+ encodeURIComponent(selections[i].get('filename'));
folderNum++;
} else {
totalSize += parseInt(selections[i].get('filesize'));
fileNum++;
}
}

params += '&total=' + folderNum;

var filesize = totalSize;
var generalPanel = FM.eastTab.getItem('permissionPanel')
.getComponent('generalPanel');
generalPanel.form.findField('filesize').setValue(totalSize);

var filenameStr = (folderNum != 0 ? folderNum + ' '
+ _S._SFE_LANG_COMMON_FOLDERS : '');

if (fileNum != 0) {
if (folderNum != 0) {
filenameStr += ', ';
}

filenameStr += fileNum + ' ' + _S._SFE_LANG_COMMON_FILES;
}
_pi_file_html = filenameStr;
generalPanel.form.findField('filename').setValue(filenameStr);

if (FM.searchMode == true) {
var startIndex = selections[0].get('filename')
.indexOf(FM.fileListStore.baseParams.path);
var endIndex = selections[0].get('filename').lastIndexOf('/');

location = selections[0].get('filename').substr(startIndex,
endIndex - startIndex + 1);
} else {
location = FM.fileListStore.baseParams.path;
}
var _pi_modify = '-';
generalPanel.form.findField('location').setValue(location);
generalPanel.form.findField('mt').setValue('-');

generalPanel.form.findField('owner-read').enableTriMode(true);
generalPanel.form.findField('owner-write').enableTriMode(true);
generalPanel.form.findField('owner-excute').enableTriMode(true);
generalPanel.form.findField('group-read').enableTriMode(true);
generalPanel.form.findField('group-write').enableTriMode(true);
generalPanel.form.findField('group-excute').enableTriMode(true);
generalPanel.form.findField('other-read').enableTriMode(true);
generalPanel.form.findField('other-write').enableTriMode(true);
generalPanel.form.findField('other-excute').enableTriMode(true);

generalPanel.form.findField('owner-read').setValue(2);
generalPanel.form.findField('owner-write').setValue(2);
generalPanel.form.findField('owner-excute').setValue(2);
generalPanel.form.findField('group-read').setValue(2);
generalPanel.form.findField('group-write').setValue(2);
generalPanel.form.findField('group-excute').setValue(2);
generalPanel.form.findField('other-read').setValue(2);
generalPanel.form.findField('other-write').setValue(2);
generalPanel.form.findField('other-excute').setValue(2);
} else {
var filename = selections[0].get('filename'), location = '', filesize = '';

if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(filename)) {
filename = QNAP.QOS.fileExplorerTools.tool.getFileNamPath(filename)[0];
}
_pi_file_html = filename;
generalPanel.form.findField('filename').setValue(filename);

location = FM.currentPath;

generalPanel.form.findField('location').setValue(location);

var params = 'path=' + FM.currentPath;
if (selections[0].get('isfolder') == 1) {
filesize = '-';
} else {
filesize = QNAP.QOS.fileExplorerTools.tool
.transformFileSize(parseInt(selections[0]
.get('filesize')));
}

generalPanel.form.findField('filesize').setValue(filesize);
_pi_modify = selections[0].get('mt');
generalPanel.form.findField('mt').setValue(selections[0].get('mt'));

QNAP.QOS.fileExplorerTools.tool.initPermission(selections[0]
.get('privilege'), generalPanel.form);
}

},// setPropertyGeneralPanelValue End
checkACL : function() {
var FM = this;
/* 開啟前檢查 進階選項與ACL開始 */
var params = {};
params.func = 'check_sid';
params.sid = QNAP.QOS.user.sid;
Ext.Ajax.request({
url : QNAP.QOS.fileExplorerTools.config.cgiPath + 'utilRequest.cgi',
method : 'POST',
params : params,
success : function(o) {
var r = Ext.util.JSON.decode(o.responseText);
QNAP.QOS.fileExplorerTools.config.aclSupport = !!r.supportACL;
QNAP.QOS.fileExplorerTools.config.aclEnable = !!r.enableACL;
QNAP.QOS.fileExplorerTools.config.supportRTT = !!r.supportRTT;
QNAP.QOS.fileExplorerTools.config.serverName = r.servername;
QNAP.QOS.fileExplorerTools.config.serverName = r.servername;
QNAP.QOS.fileExplorerTools.config.supportRemote = !!r.remote_folder_is_valid_user;
if(!DetectFlashVer(9)){//20140626若未安裝flash視同不支援RTT
QNAP.QOS.fileExplorerTools.config.supportRTT=false;
}

FM.RTT = QNAP.QOS.fileExplorerTools.config.supportRTT;
FM.fireEvent('supportremote', QNAP.QOS.fileExplorerTools.config.supportRemote);
},
failure : function(o) {
}
});
},
createGenPropertiesPanel : function() {
var FM = this;
var generalPanel = new Ext.form.FormPanel({
region : "center",
border : false,
autoHeight : true,
autoScroll : false,
itemId : 'generalPanel',
cls : 'generalPanel-cls',
items : [{
xtype : 'fieldset',
title : _S._SFE_LANG_COMMON_PERMISSION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PERMISSION',
labelWidth : 50,
autoHeight : true,
cls : 'smpPMSN-cls',
items : [{
xtype : 'compositefield',
fieldLabel : _S._SFE_LANG_COMMON_OWNER,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OWNER',
style : 'overflow:hidden',
items : [new QNAP.lib.triCheckbox({
name : 'owner-read',
width : 56,
triMode : false,
boxLabel : _S._SFE_LANG_COMMON_READ,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_READ',
hideLabel : true,
value : 0
}), new QNAP.lib.triCheckbox({
name : 'owner-write',
width : 56,
triMode : false,
boxLabel : _S._SFE_LANG_COMMON_WRITE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_WRITE',
hideLabel : true,
value : 0
}), new QNAP.lib.triCheckbox({
name : 'owner-excute',
width : 56,
triMode : false,
boxLabel : _S._SFE_LANG_COMMON_EXCUTE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_EXCUTE',
hideLabel : true,
value : 0
})]
}, {
xtype : 'compositefield',
fieldLabel : _S._SFE_LANG_COMMON_GROUP,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_GROUP',
autoHeight : true,
items : [new QNAP.lib.triCheckbox({
name : 'group-read',
triMode : false,
boxLabel : _S._SFE_LANG_COMMON_READ,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_READ',
hideLabel : true,
value : 0
}), new QNAP.lib.triCheckbox({
name : 'group-write',
triMode : false,
boxLabel : _S._SFE_LANG_COMMON_WRITE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_WRITE',
hideLabel : true,
value : 0
}), new QNAP.lib.triCheckbox({
name : 'group-excute',
triMode : false,
boxLabel : _S._SFE_LANG_COMMON_EXCUTE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_EXCUTE',
hideLabel : true,
value : 0
})]
}, {
xtype : 'compositefield',
fieldLabel : _S._SFE_LANG_COMMON_PUBLIC,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PUBLIC',
items : [new QNAP.lib.triCheckbox({
name : 'other-read',
triMode : false,
boxLabel : _S._SFE_LANG_COMMON_READ,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_READ',
hideLabel : true,
value : 0
}), new QNAP.lib.triCheckbox({
name : 'other-write',
triMode : false,
boxLabel : _S._SFE_LANG_COMMON_WRITE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_WRITE',
hideLabel : true,
value : 0
}), new QNAP.lib.triCheckbox({
name : 'other-excute',
triMode : false,
boxLabel : _S._SFE_LANG_COMMON_EXCUTE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_EXCUTE',
hideLabel : true,
value : 0
})]
}]
}, {
xtype : 'compositefield',
itemId : 'recursiveBlock',
ctCls : 'recursiveBlock-ctCls',
hideLabel : true,
hidden : true,
width : 290,
items : [{
xtype : 'checkbox',
itemId : 'recursive',
name : 'recursive',
width : 290,
boxLabel : _S._SFE_LANG_ACTION_PROPERTIES_MSG_RECURSIVE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_PROPERTIES_MSG_RECURSIVE',
hideLabel : true,
value : 1
}]
}
],
buttons : [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
cls : 'cpFbar',

handler : function() {
if (false) {
win.close();
} else {
var params = {}, recursive = 0;
var hasFolder;
var selections = FM.gridPanel.getSelectionModel()
.getSelections();
if (selections.length == 0) {
hasFolder = true;
} else {
hasFolder = QNAP.QOS.fileExplorerTools.tool
.selectionHasFolder(selections);
}
if (hasFolder
&& generalPanel.form.findField('recursive').checked) {
recursive = 1;
}

params.recursive = recursive;

params.bOwn_r = generalPanel.form
.findField('owner-read').getValue();
params.bOwn_w = generalPanel.form
.findField('owner-write').getValue();
params.bOwn_x = generalPanel.form
.findField('owner-excute').getValue();

params.bGroup_r = generalPanel.form
.findField('group-read').getValue();
params.bGroup_w = generalPanel.form
.findField('group-write').getValue();
params.bGroup_x = generalPanel.form
.findField('group-excute').getValue();

params.bOther_r = generalPanel.form
.findField('other-read').getValue();
params.bOther_w = generalPanel.form
.findField('other-write').getValue();
params.bOther_x = generalPanel.form
.findField('other-excute').getValue();

Ext.apply(params, QNAP.QOS.fileExplorerTools.tool
.getFileSelections(FM, 'source_file',
'source_total'));
params.source_path = FM.fileListStore.baseParams.path;
QNAP.QOS.fileExplorerTools.tool.ajax.call(FM, {
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM, 'set_privilege'),
handler : {
success : function(resulte, rq) {
if (!resulte.success)
FM.fileListStore.reload();
FM.gridPanel.store.reload();
},
failure : function(s) {
if(s==0)
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM, 'FE10');
else
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM, s, 'properties');
}
},
params : params
});
}
}
}]
});
return generalPanel;
},// createGenPropertiesPanel End
properties : function(TreeNode) {

var FM = this;
var isRoot = 0;
var grid = FM.gridPanel;
FM.aclAry = [];
FM.delAry = []
var path = FM.fileListStore.baseParams.path;

var selections = grid.getSelectionModel().getSelections();
var hasFolder;
if (selections.length == 0) {
hasFolder = true;
} else {
hasFolder = QNAP.QOS.fileExplorerTools.tool.selectionHasFolder(selections);
}
var params = 'path=' + path, __info = [];
var _pi_file_html, _pi_location = path, _pi_size, _pi_modify;
var generalPanel;
function showGenPanel() {

if (!generalPanel) {
generalPanel = FM.createGenPropertiesPanel();
}

if (selections.length > 1) {
generalPanel.form.findField('owner-read').enableTriMode(true);
generalPanel.form.findField('owner-write').enableTriMode(true);
generalPanel.form.findField('owner-excute').enableTriMode(true);
generalPanel.form.findField('group-read').enableTriMode(true);
generalPanel.form.findField('group-write').enableTriMode(true);
generalPanel.form.findField('group-excute').enableTriMode(true);
generalPanel.form.findField('other-read').enableTriMode(true);
generalPanel.form.findField('other-write').enableTriMode(true);
generalPanel.form.findField('other-excute').enableTriMode(true);

generalPanel.form.findField('owner-read').setValue(2);
generalPanel.form.findField('owner-write').setValue(2);
generalPanel.form.findField('owner-excute').setValue(2);
generalPanel.form.findField('group-read').setValue(2);
generalPanel.form.findField('group-write').setValue(2);
generalPanel.form.findField('group-excute').setValue(2);
generalPanel.form.findField('other-read').setValue(2);
generalPanel.form.findField('other-write').setValue(2);
generalPanel.form.findField('other-excute').setValue(2);
} else if (selections.length == 1) {
QNAP.QOS.fileExplorerTools.tool.initPermission(selections[0]
.get('privilege'), generalPanel.form);
} else {

FM.setSmpPermission(TreeNode);
}
}

var enableACL = QNAP.QOS.fileExplorerTools.config.aclSupport&& QNAP.QOS.fileExplorerTools.config.aclEnable,
shareProperty = QNAP.QOS.fileExplorerTools.tool.getCurrentShareProperty(FM),
isNoSupportACL = (shareProperty.noSupportACL == true) || (shareProperty.isoFolder == true);
if (!enableACL || (isNoSupportACL == true)) {
showGenPanel();

if (hasFolder) {
generalPanel.get('recursiveBlock').show();
}
if (selections.length > 1) {
generalPanel.disable();
} else {
generalPanel.enable();
}

if (QNAP.QOS.fileExplorerTools.config.aclEnable == true
&& isNoSupportACL == true) {
var _msg = _S._SFE_LANG_ACL_ALERT_MSG01;
var warningPanel = new Ext.Panel({
width : '100%',
autoHeight : true,
items : [{
xtype : 'label',
text : _msg,
ctCls : 'USB-Prt-cls',
cls : 'USB-Prt-Msg-cls',
qInternational : true,
qInternationalKey : '_SFE_LANG_ACL_ALERT_MSG01'
}]
});
if (QNAP.lib.cookie.get('fm_not_support_acl_'
+ QNAP.QOS.user.account) != '1') {
FM.eastTab.getItem('permissionPanel').removeAll();
FM.eastTab.getItem('permissionPanel').add(warningPanel);
FM.eastTab.doLayout();
} else {
FM.eastTab.getItem('permissionPanel').removeAll();
FM.eastTab.getItem('permissionPanel').add(generalPanel);
FM.eastTab.doLayout();
}
} else {
FM.eastTab.getItem('permissionPanel').removeAll();
FM.eastTab.getItem('permissionPanel').add(generalPanel);
FM.eastTab.doLayout();
}
} else {
if (FM.isGettingACL) {
return;
}
FM.isGettingACL = true;
var len = selections.length, i;
var flName;
if (len == 0) {
flName = path.split('/').pop();
path = path.substring(0, FM.currentPath.lastIndexOf('/'));
} else {
for (i = 0; i < len; i++) {
var flNameArr = selections[i].get('filename').split('/');
flName = flNameArr[flNameArr.length - 1];
}
}
var config = QNAP.QOS.fileExplorerTools.config;
var renderUserIcon = function(val) {
var img = 'icon_privilege_' + val + '_micro.gif';
if (val == 2)
img = 'icon_privilege_' + val + '_micro.png';

return '<div style="background: url(apps/fileManager/images/common/'
+ img
+ ') no-repeat 50% 50%; width: 25px; " >&nbsp;</div>';
};
var fAry = [];
if (!FM.acl_store)
FM.acl_store = new Ext.data.JsonStore({
root : 'users',
fields : [{
name : 'dirname',
mapping : 'dirname'
}, {
name : 'groupOrUser',
mapping : 'groupOrUser'
}, {
name : 'action',
mapping : 'action'
}, {
name : 'is_ldap',
mapping : 'is_ldap'
}, {
name : 'rd',
mapping : 'rd',
type : 'bool'
}, {
name : 'rw',
mapping : 'rw',
type : 'bool'
}, {
name : 'ro',
mapping : 'ro',
type : 'bool'
}, {
name : 'sp',
mapping : 'sp',
type : 'bool'
}, {
name : 'permission',
mapping : 'permission'
}, {
name : 'admin',
mapping : 'admin'
}, {
name : 'now',
mapping : 'now'
}, {
name : 'priv',
mapping : 'preview'
}, {
name : 'preview',
mapping : 'preview'
}, {
name : 'privOld',
mapping : 'preview'
}, {
name : 'groupList',
mapping : 'groupList'
}]
});
var getPermission = function(p) {
if (/[R5]/i.test(p))
return "5";
else if (/[W7]/i.test(p))
return "7";
else if (/[I0]/i.test(p))
return "0";
return "-2";
};
var addData = function(userGroup) {
var obj = {};
obj.dirname = userGroup.name;
obj.groupOrUser = userGroup.groupOrUser;
var files=FM.gridPanel.getSelectionModel().getSelections();
if(files.length==0 || files[0].get('isfolder')==1){
obj.action = QNAP.QOS.fileExplorerTools.tool.getGuestPer(userGroup.action);
}else{
obj.action = QNAP.QOS.fileExplorerTools.tool.getGuestPerForFile(userGroup.action);
}
obj.is_ldap = userGroup.is_ldap;
obj.rd = obj.action == 'R';
obj.rw = obj.action == 'W';
obj.ro = obj.action == 'I';
obj.sp = false;
obj.permission = getPermission(userGroup.action);
obj.admin = 0;
var preview = QNAP.QOS.fileExplorerTools.tool
.chgStatuE2N(userGroup.preview || 'N');
obj.now = QNAP.QOS.fileExplorerTools.tool
.chgStatuE2N(obj.action);
obj.privOld = obj.priv = preview;
obj.groupList = userGroup.groupList || '';
return obj;
};
function parseRootData(data, now) {
var groupAry = [];
if (data.groupList != '')
groupAry = data.groupList.split(',');
groupAry.push(data.dirname);
var tmpValue = 0, special = false;
var valueAry = [];
valueAry.push(tmpValue);
Ext.each(fAry, function(rData) {
var now = rData.now;
if (data.groupOrUser == rData.groupOrUser
&& data.dirname == rData.dirname) {
if (rData.admin == '1') {
special = true;
tmpValue = now;
} else {
tmpValue = rData.now;
}
valueAry.push(tmpValue);
}
if (data.groupOrUser == '2' && rData.groupOrUser == '1'
&& groupAry.length) {
groupAry.each(function(gData) {
if (rData.dirname == gData) {
if (rData.admin == '1') {
special = true;
tmpValue = rData.now;
} else {
tmpValue = QNAP.QOS.fileExplorerTools.tool
.compareNumber(tmpValue, rData.now);
}
valueAry.push(tmpValue);
}
});
}
});
return {
value : QNAP.QOS.fileExplorerTools.tool.largest(valueAry),
special : special
};
}
var para = {};
para.share_name = '/share' + FM.currentPath;
para.root = 0;
if (FM.currentPath.split('/').length <= 2) { // 檢查是不是根目錄
para.root = 1;// 是根目錄
}
para.shareName = FM.currentPath.split('/').pop();
/* 取得root Folder的ACL Data (rootAcl) */


Ext.Ajax.request({// getACLData Root
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM, 'get_acl_control'),
method : 'POST',
params : para,
success : function(response, opts) {
var rs = Ext.decode(response.responseText);
if(rs.status && rs.status!=1){
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,rs.status);
return ;
}

var userGroup = rs.datas;
var tmpAry = [];
var rootObj = {};
var guestData;
for (var i = 0; i < userGroup.length; i++) {
if (userGroup[i].name != 'guest') {
tmpAry.push(addData(userGroup[i]));
}else{
guestData=userGroup[i];
}
}
var gpValue=99,
guestPermission=FM.advPPPanel.getComponent('acl_guest_acs').innerCt.getComponent('guest_permission');

if(para.root==1){
guestPermission.store.removeAt(3);
gpValue= QNAP.QOS.fileExplorerTools.tool.getPermission(rs.guest_type);
}else{
var record= new Ext.data.Record({
listName: _S._SFE_LANG_COMMON_NO_SET,
listValue: 99,
qInternationalKey: "_SFE_LANG_COMMON_NO_SET"
});
if(guestPermission.store.data.length == 3){
guestPermission.store.add(record);
}
if(!Ext.isEmpty(guestData)){
gpValue=QNAP.QOS.fileExplorerTools.tool.getPermission(guestData.action);
}
}

FM.advPPPanel.getComponent('acl_guest_acs').innerCt
.getComponent('guest_permission').setValue(gpValue);

Ext.each(tmpAry, function(oData) {
if (oData.groupOrUser == '2'
&& oData.groupList != '') {
oData.now = QNAP.QOS.fileExplorerTools.tool
.parseAclGroupNow(tmpAry,
oData.groupList, oData.now);
}
});
Ext.each(tmpAry, function(data) {
data.preview = QNAP.QOS.fileExplorerTools.tool
.chgStatuN2E(data.priv);
});
rootObj.data = tmpAry;
rootObj.del = [];
rootObj.old = tmpAry;
rootObj.shareName = para.shareName;
rootObj.share_name = para.share_name;
FM.aclAry.push(rootObj);
}
});
var aclParams = {};
if (selections.length == 1) {
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(selections[0].get('filename'))) {
aclParams['share_name'] = '/share' + selections[0].get('filename');
}else{
aclParams['share_name'] = '/share' + FM.currentPath + '/' + selections[0].get('filename');
}
aclParams['root'] = 0;
} else {
aclParams = para;
}
var admin_only, owner, guest_permission, stickybit;
Ext.Ajax.request({// getACLData
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'get_acl_control'),
method : 'POST',
params : aclParams,
success : function(o) {
var rs = Ext.decode(o.responseText);

if(rs.status && rs.status!=1){
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,rs.status);
return ;
}
admin_only = (rs.admin_only > 0);//noteNo.0001 (2016-06-23 admin_only is counter not 0 or 1)
FM.advPPPanel.getComponent('acl_options_01').setValue(admin_only);
stickybit = (rs.sticky == 1) ? true : false;
FM.advPPPanel.getComponent('owner_protect')
.setValue(stickybit);
FM.advPPPanel.getComponent('composite-owner').innerCt
.getComponent('owner_user').setValue(rs.owner);
if(QNAP.QOS.user.isAdminGroup)
FM.advPPPanel.getComponent('composite-owner').innerCt
.getComponent('owner_user').el.dom.setAttribute("ext:qtip",rs.owner);

FM.advPPPanel.getComponent('acl_guest_acs').innerCt
.getComponent('guest_permission').getValue();
guest_permission = rs.guest_permission;
var userGroup = rs.datas;
var obj = {}, chkValue = false, aclIndex = null, tmpAry = [], olAry = [];

var permission = '-1';
for (var i = 0; i < userGroup.length; i++) {
if (userGroup[i].name && userGroup[i].name != 'guest') {
tmpAry.push(addData(userGroup[i]));
} else {
permission = getPermission(userGroup[i].action);
}
olAry.push(addData(userGroup[i]));
}
Ext.each(tmpAry, function(oData) {
if (oData.groupOrUser == '2'
&& oData.groupList != '') {
oData.now = QNAP.QOS.fileExplorerTools.tool
.parseAclGroupNow(tmpAry,
oData.groupList, oData.now);
}
});
Ext.each(olAry, function(oData) {
if (oData.groupOrUser == '2'
&& oData.groupList != '') {
oData.now = QNAP.QOS.fileExplorerTools.tool
.parseAclGroupNow(olAry,
oData.groupList, oData.now);
}
});
var isRoot;
if (FM.gridPanel.getSelectionModel().getSelections().length == 0) {
isRoot = QNAP.QOS.fileExplorerTools.tool
.isRoot(FM.currentPath);
} else {
isRoot = false;
}
if (isRoot) {
Ext.each(tmpAry, function(oData) {
var rootTmpValue = parseRootData(oData,
oData.now);
oData.now = QNAP.QOS.fileExplorerTools.tool
.subCompareNumber(oData.now,
rootTmpValue.value);
});
Ext.each(olAry, function(oData) {
var rootTmpValue = parseRootData(oData,
oData.now);
oData.now = QNAP.QOS.fileExplorerTools.tool
.subCompareNumber(oData.now,
rootTmpValue.value);
});
}
FM.fAry = [];
var sAry = {
users : []
};
Ext.each(tmpAry, function(data) {
data.preview = QNAP.QOS.fileExplorerTools.tool
.chgStatuN2E(data.priv);
if (isRoot)
FM.fAry.push(data);
sAry.users.push(data);
});
var nodeObj = {};
nodeObj.data = tmpAry;
nodeObj.del = [];
nodeObj.old = tmpAry;

if (selections.length == 0) {
nodeObj.shareName = path.split('/').pop();
} else {
nodeObj.shareName = selections[0].get('filename');
}
nodeObj.share_name = aclParams.share_name;
FM.aclAry.push(nodeObj);
if (selections.length > 1) {
FM.acl_grid.store.removeAll();
} else {
FM.acl_grid.store.loadData(sAry);
}
FM.isGettingACL = false;
FM.advPPPanelMask.hide();
var O_selArr = [];// 取得permission 之前所點的資料
Ext.each(selections, function(selection) {
O_selArr.push(selection.id);// 取selection的ID放入陣列
});
var N_selArr = [];// 取得permission 之後所點的資料
Ext.each(FM.gridPanel.getSelectionModel().getSelections(),
function(selection) {
N_selArr.push(selection.id);// 取selection的ID放入陣列
});
if (O_selArr.length != N_selArr.length) {// 選取內容不一致,再取一次permission
FM.properties();
} else {
var isDiff;
for (var i = 0; i < N_selArr.length; i++) {
if (N_selArr[i] != O_selArr[i]) { // 比對兩個陣列內的ＩＤ是否一致
isDiff = true;
}
}
if (isDiff) {// 選取內容不一致,再取一次permission
FM.properties();
}
}
FM.advPPPanel.getComponent('acl_options_01').setDisabled(aclParams.root == 0);

},
failure : function(o) {
}
});

var autoExpandColumnId = Ext.id();
var checkColumnArray = [];
var acl_columns = [{
header : '',
dataIndex : 'groupOrUser',
renderer : renderUserIcon,
width : 30
}, {
header : _S._SFE_LANG_COMMON_FILENAME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILENAME',
dataIndex : 'dirname',
align : 'left',
id : autoExpandColumnId,
renderer : function(data, metadata, record, rowIndex,
columnIndex, store) {
metadata.attr = 'ext:qtip="' + data + '"';
return data;
}
}, {
header : _S.QTS_MSG_4,
dataIndex : 'now',
qInternationalKey : 'QTS_MSG_4',
width : 110,
renderer : function(data, metadata, record, rowIndex,
columnIndex, store) {
var color = QNAP.QOS.fileExplorerTools.tool
.getPreviewColor(data);
var tip = QNAP.QOS.fileExplorerTools.tool
.chgStatuStr(data);
tip = _S[tip] || tip;
metadata.attr = 'ext:qtip="' + tip
+ '" style="color:' + color + '"';
return tip;
}
}, {
header : '',
sortable : true,
dataIndex : 'action',
hidden : true,
width : 50
}, {
header : '',
sortable : true,
dataIndex : 'actSel',
width : 50,
hidden : !QNAP.QOS.user.isAdminGroup,
renderer : function(data, metadata, record, rowIndex, columnIndex, store) {
if (!data) {
data = record.get('action');
}
if (data == 'I' || data == 'Deny' || data == 'D') {
record.data.action = 'I';
return 'Deny';
} else if (data == 'W') {
record.data.action = 'W';
return 'RW';
} else if (data == 'R') {
record.data.action = 'R';
return 'RO';
}
},
editor : new Ext.form.ComboBox({
mode : 'local',
triggerAction : 'all',
valueField : 'pCode',
displayField : 'displayText',
disabled : !QNAP.QOS.user.isAdminGroup,
store : new Ext.data.ArrayStore({
fields : ['pCode', // numeric value is the key
'displayText'],
data : [['W', 'Write'],
['R', 'Read only'],
['D', 'Deny']]
})

})
}, {
header : '',
sortable : true,
dataIndex : 'actSel2',
hidden : QNAP.QOS.user.isAdminGroup,
width : 50,
renderer : function(data, metadata, record, rowIndex,
columnIndex, store) {
if (!data) {
data = record.get('action');
}
if (data == 'I' || data == 'Deny' || data == 'D') {
record.data.action = 'I';
return 'Deny';
} else if (data == 'W') {
record.data.action = 'W';
return 'RW';
} else if (data == 'R') {
record.data.action = 'R';
return 'RO';
}
}
}];
var attrs = FM.acl.attributes;

for (var i = 0; i < attrs.length; i++) {
checkColumnArray
.push(new Ext.grid.CheckColumn(FM.acl.columnAttrs[i]));
}
var delItem = Ext.id();
if (!FM.acl_grid) {
FM.acl_grid = new Ext.grid.EditorGridPanel({
itemId : 'acl_grid',
ctCls : 'acl_grid-ctCls',
title : _S._SFE_LANG_COMMON_PERMISSION,
qInternational : true,
enableColumnMove : false,
qInternationalKey : '_SFE_LANG_COMMON_PERMISSION',
store : FM.acl_store,
viewConfig : {
forceFit : true,
scrollOffset : 0
},
selModel : new Ext.grid.RowSelectionModel(),
clicksToEdit : 1,
colModel : new Ext.grid.ColumnModel({
defaults : {
width : 80,
sortable : false,
resizable : false,
menuDisabled : true
},
columns : acl_columns
}),
loadMask : {
msg : ('_SFE_LANG_COMMON_LOADING_MSG')
},
enableColumnMove : false,
enableColumnResize : true,
enableColumnHide : false,
autoExpandColumn : autoExpandColumnId,
frame : false,
border : true,
bodyBorder : true,
cls : 'no-dirty-cell',
bbar : [{
text : _S._SFE_LANG_CREATE_USER,
qInternational : true,
qInternationalKey : '_SFE_LANG_CREATE_USER',
xtype : 'button',
hidden : FM.isWFM,
disabled : FM.isWFM,
width : 27,
hieght : 23,
handler : function() {
os.openApp('systemPreferences', {
fn : 'users'
});
}
}, '->', {
itemId : 'add-item',
width : 50,
icon : QNAP.QOS.fileExplorerTools.config.imgPath+ 'common/add.gif',
handler : function() {
var path;
path = FM.fileListStore.baseParams.path;
QNAP.QOS.fileExplorerAction.getUserList(
FM.advPPPanel, FM.acl_grid.store,
path, FM.acl_grid, FM,
FM.advPPPanel);
}
}, '-', {
itemId : 'del-item',
id : delItem,
width : 50,
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'common/delete.gif',
handler : function() {
if (FM.acl_grid.getSelectionModel()
.getSelections()) {
FM.acl_grid.stopEditing();
for (var i = 0; i < FM.acl_grid
.getSelectionModel()
.getSelections().length; i++) {
FM.delAry.push(FM.acl_grid
.getSelectionModel()
.getSelections()[i].data);
}
FM.acl_grid.store.remove(FM.acl_grid
.getSelectionModel()
.getSelections());
FM.isAclChange = true;
Ext.each(FM.aclAry, function(aData) {
aData.data = [];
aData.del = FM.delAry;
FM.acl_grid.store.each(function(r,
sindex) {
if (r.data.groupOrUser == '2'
&& r.data.groupList != '') {
r.data.now = QNAP.QOS.fileExplorerTools.tool
.parseAclGroupNow(
FM.acl_grid.store,
r.data.groupList,
QNAP.QOS.fileExplorerTools.tool
.chkAclRWI(r));
} else {
r.data.now = QNAP.QOS.fileExplorerTools.tool
.chkAclRWI(r);
}
aData.data.push(r.data);
FM.acl_grid.store.data.items[sindex]
.afterEdit();
});
});
}
}
}],
plugins : checkColumnArray,
height : 200,
autoHeight : false,
listeners : {
afterrender : function(grid) {
if(!QNAP.QOS.user.isAdminGroup)
grid.bottomToolbar.hide()
},
rowclick : function(grid, rowIndex, e) {
var selections = grid.getSelectionModel()
.getSelections();
var disableDelDBtn = false;
Ext.each(selections, function(selections) {
if (selections.data.name == 'admin')
disableDelDBtn = true;
});
if (disableDelDBtn) {
Ext.getCmp(delItem).disable();
} else {
Ext.getCmp(delItem).enable();
}
},
afteredit : function(e) {
var indexNumber = null, indexDirNum = null;

var aclPath = '';
if (selections.length != 0) {
aclPath = '/share' + FM.currentPath + '/'
+ selections[0].get('filename');
} else {
aclPath = '/share' + FM.currentPath;
}
switch (e.value) {
case 'R' :
FM.aclAry[1].data[0].rd = e.record.data.rd = true;
FM.aclAry[1].data[0].rw = e.record.data.rw = false;
FM.aclAry[1].data[0].ro = e.record.data.ro = false;
break;
case 'W' :
FM.aclAry[1].data[0].rd = e.record.data.rd = false;
FM.aclAry[1].data[0].rw = e.record.data.rw = true;
FM.aclAry[1].data[0].ro = e.record.data.ro = false;
break;
case 'D' :
FM.aclAry[1].data[0].rd = e.record.data.rd = false;
FM.aclAry[1].data[0].rw = e.record.data.rw = false;
FM.aclAry[1].data[0].ro = e.record.data.ro = true;
break;
}
var now;
if (e.record.data.groupOrUser == '1') {
now = QNAP.QOS.fileExplorerTools.tool
.compareNumber(1,
QNAP.QOS.fileExplorerTools.tool
.chkAclRWI(e.record));
e.grid.store.each(function(sd, sindex) {
if (sd.data.groupOrUser == '2'
&& sd.data.groupList
.split(',')
.inArray(e.record.data.dirname)) {
sd.data.now = QNAP.QOS.fileExplorerTools.tool
.compareNumber(
now,
QNAP.QOS.fileExplorerTools.tool
.chkAclRWI(sd));

Ext.each(FM.aclAry[1].data, function(
adata, aindex) {
if (adata.dirname == sd.data.dirname
&& adata.groupOrUser == sd.data.groupOrUser) {
adata.now = sd.data.now;
var rootTmpValue = parseRootData(
adata, adata.now);
adata.now = QNAP.QOS.fileExplorerTools.tool
.subCompareNumber(
adata.now,
rootTmpValue.value);
return;
}
});
e.grid.store.data.items[sindex]
.afterEdit();
}
});
} else {
if (e.record.data.groupList != '') {
now = QNAP.QOS.fileExplorerTools.tool
.parseAclGroupNow(
FM.aclAry[1].data,
e.record.data.groupList,
QNAP.QOS.fileExplorerTools.tool
.chkAclRWI(e.record));
} else {
now = QNAP.QOS.fileExplorerTools.tool
.compareNumber(
1,
QNAP.QOS.fileExplorerTools.tool
.chkAclRWI(e.record));
}
}
var rootTmpValue = parseRootData(e.record.data, now);
now = QNAP.QOS.fileExplorerTools.tool
.subCompareNumber(now, rootTmpValue.value);
e.record.data.now = FM.aclAry[1].data[0].now = now;
e.grid.store.data.items[e.row].afterEdit();
e.record.commit();
FM.isAclChange = true;
}
}
});
} else {
FM.advPPPanelMask.show();
}
var removeSelections = function() {
var s = FM.acl_grid.getSelectionModel().getSelections();
FM.acl_grid.getStore().remove(s);
};

if (!FM.advPPPanel) {
FM.advPPPanel = new Ext.Panel({
frame : true,
bodyStyle : "padding: 0 5px 0; ",
region : "center",
border : false,
autoScroll : false,
autoHeight : true,
defaults : {
style : 'margin-bottom: 5px;'
},
listeners : {
afterrender : function() {
FM.advPPPanelMask = new Ext.LoadMask(
FM.advPPPanel.id, {
msg : ('_SFE_LANG_COMMON_LOADING_MSG')
});
FM.advPPPanelMask.show();
if(!QNAP.QOS.user.isAdminGroup)
FM.advPPPanel.toolbars[0].hide()
}
},
buttons : [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',

hidden : config.enableWinACL && config.aclEnable,
handler : function() {
var aclIndex = 0, currentData;
currentData = FM.aclAry[1];
function getGuestData() {
var guest_permission = FM.advPPPanel
.getComponent('acl_guest_acs').innerCt
.getComponent('guest_permission')
.getValue();
return {
admin : 0,
dirname : 'guest',
groupOrUser : '2',
is_ldap : '0',
permission : guest_permission,
rd : guest_permission == 5,
ro : guest_permission == 0,
rw : guest_permission == 7,
sp : false
};
}
function getCurrentRowData() {
var tmpGridData = [];
FM.acl_grid.store.each(function(record) {
record.data.priv = Ext
.isNumber(record.data.priv)
? record.data.priv
: QNAP.QOS.fileExplorerTools.tool
.chgStatuE2N(record.data.priv);
record.data.privOld = Ext
.isNumber(record.data.privOld)
? record.data.privOld
: QNAP.QOS.fileExplorerTools.tool
.chgStatuE2N(record.data.privOld);
tmpGridData.push(record.data);
});
tmpGridData.push(getGuestData());
return tmpGridData;
}
function isDataChanged() {
return !(Ext.encode(getCurrentRowData()) == Ext.encode(currentData.old));
}
commitAclData();
function commitAclData() {
var selections = grid.getSelectionModel()
.getSelections();
var para = {};
if (FM.gridPanel.getSelectionModel()
.getSelections().length != 0) {
para.sharename = '/share' + FM.currentPath
+ '/'
+ selections[0].get('filename');
} else {
para.sharename = '/share' + FM.currentPath;
}
if (para.sharename.split('/').length <= 3) { // 檢查是不是根目錄
para.root = 1;// 是根目錄
} else {
para.root = 0;
}
para.update_modified = FM.advPPPanel
.getComponent('acl_recursive01')
.getValue() ? 1 : 0;

para.update_all = FM.advPPPanel
.getComponent('acl_recursive02')
.getValue() ? 1 : 0;
para.recursive = (!!para.update_modified || !!para.update_all)
? 1
: 0;
para.stickybit = FM.advPPPanel
.getComponent('owner_protect')
.getValue() ? 1 : 0;
para.admin_only = FM.advPPPanel
.getComponent('acl_options_01')
.getValue() ? 1 : 0;
para.owner = FM.advPPPanel
.getComponent('composite-owner').innerCt
.getComponent('owner_user').getValue();

var _data = getCurrentAllSelection({
adminOnly : para.admin_only,
changedOnly : !!para.update_modified,
guest : {
name : "guest",
type : "1"
}
});
function getCurrentAllSelection(o) {
var data, i, len, result = {}, result2 = {};

data = (o && o.changedOnly)
? getChangeData()
: getCurrentRowData();
var getResult = function(data) {
var result = {};
result.user = {
rd : [],
rw : [],
admin_rw : [],
no : [],
empty : [],
del : [],
ad : []
};
result.group = {
rd : [],
rw : [],
admin_rw : [],
no : [],
empty : [],
del : [],
ad : []
};
result.computer = {
rd: [],
rw: [],
admin_rw: [],
no: [],
empty: [],
del: [],
ad: []
};
var getPermission = function(p) {
if (p.rd) return "5";
if (p.ro) return "0";
if (p.rw) return "7";
return "-2";
};
Ext.each(data, function(ddata) {
var d = ddata,
p, type;
switch (d.groupOrUser.toString()) {
case '3':
type = 'computer';
break;
case '2':
type = 'user';
break;
case '1':
default:
type = 'group';
break;
}

if (d.permission != '-1') d.permission = getPermission(d)
switch (d.permission.toString()) {
case '5':
p = 'rd';
break;
case '7':
p = 'rw';
break;
case '0':
p = 'no';
break;
case '-1':
p = 'del';
break;
default:
p = 'empty';
break;
}
result[type][p].push(d.dirname);
if (d.sp && p != 'del') result[type]['ad'].push(d.dirname);
});
return result;
};
result = getResult(data);
var extra = getResult(getCurrentRowData());
for (var m in extra) {
for (var k = 0; k < extra[m].ad.length; k++) {
var ad_name = extra[m].ad[k];
if (result[m].ad.inArray(ad_name) == false)
result[m].ad.push(ad_name);
}
}
var isRoot = 0;
if (FM.currentPath.split('/').length <= 2) { // 檢查是不是根目錄
isRoot = 1;// 是根目錄
}
if (isRoot) {
for (var n in extra) {
for (var i = 0; i < extra[n].rw.length; i++) {
var add = extra[n].rw[i];
result[n].admin_rw.push(add);
}
}
}
for (var key in result) {
var i = result[key];
for (var prefix in i) {
var name = prefix + "_" + key;
var nameArray = i[prefix];
result2[name + "_len"] = nameArray.length;
for (var x = 0, len = nameArray.length; x < len; x++) {
result2[name + x] = nameArray[x];
}
}
}
return result2;
}
function getCurrentRowData() {
var tmpGridData = [];
FM.acl_grid.store.each(function(record) {
record.data.priv = Ext
.isNumber(record.data.priv)
? record.data.priv
: QNAP.QOS.fileExplorerTools.tool
.chgStatuE2N(record.data.priv);
record.data.privOld = Ext
.isNumber(record.data.privOld)
? record.data.privOld
: QNAP.QOS.fileExplorerTools.tool
.chgStatuE2N(record.data.privOld);
tmpGridData.push(record.data);
});
tmpGridData.push(getGuestData());
return tmpGridData;
}
function equals(other) {// 比對兩物件內容是否相等。
var objIsEqual = true;
for (var key in other) {
if (this[key] != other[key]) {
objIsEqual = false;
}
}

return objIsEqual;
}
function getChangeData() {
var itemInArray = function(obj, list) {
var r = false;
for (var i = 0; i < list.length; i++) {
if (list[i].dirname == obj.dirname
&& list[i].groupOrUser == obj.groupOrUser) {
obj.equals = equals;
if (obj.equals(list[i])) {
r = true;
break;
}
}
}
return r;
};
var nameInArray = function(obj, list) {
var r = false;
for (var i = 0, len = list.length; i < len; i++) {
if (list[i].dirname == obj.dirname
&& list[i].groupOrUser == obj.groupOrUser) {
r = true;
break;
}
}
return r;
};

var ar = [];
if (isDataChanged()) {
var n = getCurrentRowData();
var o = currentData.old;

for (var i = 0; i < n.length; i++) {
var obj = n[i];
if (itemInArray(obj, o) == false) {
ar.push(obj);
}
}
for (var i = 0; i < o.length; i++) {
var obj = o[i];
if (itemInArray(obj, n) == false) {
var newObj = {
dirname : obj.dirname,
groupOrUser : obj.groupOrUser,
permission : -1,
admin : obj.admin
};
if (nameInArray(obj, ar) == false) {
ar.push(newObj);
}
}
}
}

return ar;
}
var _data = getCurrentAllSelection({
adminOnly: para.admin_only,
changedOnly: !!para.update_modified,
guest: {
name: "guest",
type: "1",
permission: FM.advPPPanel.getComponent('acl_guest_acs').innerCt.getComponent('guest_permission').getValue()
}
});
Ext.apply(para, _data);
Ext.Ajax.request({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM, 'set_acl_control'),
params : para,
method : 'POST',
success : function(response, opts) {
var rs = Ext.decode(response.responseText);
if(rs.status && rs.status!=1){
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,rs.status);
return ;
}

if (para.root == 1) {
commitShareData();
} else {
setAclDefaultOption();
var RS = Ext.decode(response.responseText);
if(RS.status==1){
var msgObj = {
text : _S._SFE_LANG_COMMON_FINISH,
key : '_SFE_LANG_COMMON_FINISH'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg
.call(FM, 'info', msgObj,
btns);
MsgWin.show();
}else{
var errorCode=RS.status;
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,errorCode);
}
FM.properties();
}
},
failure : function() {
winShareFolderPanel.getEl().unmask();
}
});
function setAclDefaultOption() {
FM.advPPPanel
.getComponent('acl_recursive01')
.setValue(true);
isAclChange = false;
}
function commitShareData() {
var param = {};
param.sharename = FM.currentPath.split('/')
.pop();
var files=FM.gridPanel.getSelectionModel().getSelections();
if(files.length==0 || files[0].get('isfolder')==1){
param.guestselect = QNAP.QOS.fileExplorerTools.tool.getGuestPer(FM.advPPPanel
.getComponent('acl_guest_acs').innerCt
.getComponent('guest_permission')
.getValue());
}else{
param.guestselect = QNAP.QOS.fileExplorerTools.tool.getGuestPerForFile(FM.advPPPanel
.getComponent('acl_guest_acs').innerCt
.getComponent('guest_permission')
.getValue());
}
var tmp = getCurrentAllSelection({
changedOnly : true
});
for (var item in tmp) {
if (/del_/.test(item))
tmp[(item.replace(/del_/, 'empty_'))] = tmp[item];
}
Ext.apply(param, tmp);
param.action='share_access_control';
QNAP.QOS.fileExplorerTools.tool.ajax.call(FM, {
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'share_access_control'),
params : param,
method : 'POST',
handler : {
success : function(response, opts) {
var rs = Ext.decode(response.responseText);
if(rs.status && rs.status!=1){
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,rs.status);
return ;
}

FM.delAry = [];
setAclDefaultOption();
for (var i = 0; i < FM.aclAry.length; i++) {
if (FM.aclAry[i].share_name == FM.currentPath)
FM.aclAry[i].del = [];
}
var msgObj = {
text : _S._SFE_LANG_COMMON_FINISH,
key : '_SFE_LANG_COMMON_FINISH'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg
.call(FM, 'info', msgObj,
btns);
MsgWin.show();
FM.properties();
},
failure : function() {
}
}
});
}
}
}
}],
plugins : {
init : function(p) {
this.p = p;
},
dataChange : function() {
},
disableGroup : function(val) {
var p = this.p;
switch (val) {
case 0 :// 是資料夾，全部打開
FM.acl_grid.enable();
FM.acl_grid.getBottomToolbar()
.getComponent('add-item').enable();
FM.acl_grid.getBottomToolbar()
.getComponent('del-item').enable();
FM.advPPPanel
.getComponent('composite-owner').innerCt
.getComponent('owner_user')
.enable();
FM.advPPPanel
.getComponent('composite-owner').innerCt
.getComponent('owner_edit')
.enable();
FM.advPPPanel.getComponent('owner_protect')
.enable();
FM.advPPPanel
.getComponent('acl_recursive01')
.enable();
FM.advPPPanel
.getComponent('acl_recursive02')
.enable();
FM.advPPPanel.buttons[0].enable();
break;
case 'all' :// 多選,全部關閉
FM.acl_grid.disable();
FM.acl_grid.getBottomToolbar()
.getComponent('add-item').disable();
FM.acl_grid.getBottomToolbar()
.getComponent('del-item').disable();
FM.advPPPanel
.getComponent('composite-owner').innerCt
.getComponent('owner_user')
.disable();
FM.advPPPanel
.getComponent('composite-owner').innerCt
.getComponent('owner_edit')
.disable();
FM.advPPPanel.getComponent('owner_protect')
.disable();
FM.advPPPanel
.getComponent('acl_recursive01')
.disable();
FM.advPPPanel
.getComponent('acl_recursive02')
.disable();
FM.advPPPanel.buttons[0].disable();
break;
case 34 :// 選取檔案
FM.advPPPanel.getComponent('owner_protect')
.disable();
FM.advPPPanel
.getComponent('acl_recursive01')
.disable();
FM.advPPPanel
.getComponent('acl_recursive02')
.disable();
FM.acl_grid.enable();
FM.acl_grid.getBottomToolbar()
.getComponent('add-item').enable();
FM.acl_grid.getBottomToolbar()
.getComponent('del-item').enable();
FM.advPPPanel
.getComponent('composite-owner').innerCt
.getComponent('owner_user')
.enable();
FM.advPPPanel
.getComponent('composite-owner').innerCt
.getComponent('owner_edit')
.enable();
FM.advPPPanel.buttons[0].enable();
break;
}
},
setOwnerValue : function(value) {
FM.advPPPanel.getComponent('composite-owner').innerCt
.getComponent('owner_user').setValue(value);
if(QNAP.QOS.user.isAdminGroup)
FM.advPPPanel.getComponent('composite-owner').innerCt
.getComponent('owner_user').el.dom.setAttribute("ext:qtip",value);
}
},
items : [{
xtype : 'panel',
layout : 'fit',
itemId : 'acl_header',
height : 250,
items : [FM.acl_grid]
}, {
xtype : 'compositefield',
itemId : 'acl_guest_acs',
cls : 'acl_guest_acs-cls',
height : 30,
hidden : !QNAP.QOS.user.isAdminGroup,
items : [{
xtype : 'displayfield',
value : _S.IEI_NAS_SHARE36,
qInternational : true,
qInternationalKey : 'IEI_NAS_SHARE36',
style : 'padding: 3px 0 2px 5px;',
hideLabel : true
}, {
xtype : "combo",
itemId : "guest_permission",
width : 162,
store : new Ext.data.ArrayStore({
fields : ["listName",
"listValue",
"qInternationalKey"],
data : [
[_S.IEI_NAS_SHARE15, 0,
'IEI_NAS_SHARE15'],
[_S.IEI_NAS_SHARE13, 5,
'IEI_NAS_SHARE13'],
[_S.IEI_NAS_SHARE14, 7,
'IEI_NAS_SHARE14']]
}),
value : "0",
displayField : "listName",
valueField : "listValue",
mode : "local",
editable : false,
allowBlank : false,
triggerAction : "all",
listeners : {
select : function(f, nv, index) {
FM.isAclChange = true;
}
},
qInternational : true,
qInternationalFn : function(cmp) {
var v = cmp.getValue();
cmp.getStore().each(
function(r) {
r.data.listName = _S[r.data.qInternationalKey];
r.afterEdit();
});
cmp.setValue(v);
}
}]
}, {
xtype : 'compositefield',
itemId : 'composite-owner',
cls : 'composite-owner-cls',
margins : '5 0',
styles : 'margin-top: 5px',
hidden : !QNAP.QOS.user.isAdminGroup,
items : [{
xtype : 'displayfield',
value : (_S._SFE_LANG_COMMON_OWNER + _S._SFE_LANG_COMMON_01),
qInternational : true,
qInternationalFn : function(cmp) {
cmp.setValue(_S._SFE_LANG_COMMON_OWNER
+ _S._SFE_LANG_COMMON_01);
cmp.originalValue = cmp.getValue();
}
}, {
xtype : 'displayfield',
itemId : 'owner_user',
width : 218,
style : "border-bottom:1px solid black;width:120px;display:inline-block;padding: 0 5px;overflow:hidden;text-overflow: ellipsis;",
listeners:{
change : function(cmp, newValue, oldValue){
cmp.el.dom.setAttribute("ext:qtip",newValue);
}
}
}, {
xtype : 'button',
itemId : 'owner_edit',
iconCls : 'backup_edit_btn',
width : 20,
margins : "0 15 0 0",
hidden : config.enableWinACL && config.aclEnable,
handler : function(btn) {
QNAP.QOS.fileExplorerAction.getOwnerForm(FM.advPPPanel.plugins.setOwnerValue, FM, FM.advPPPanel);
}
}]
}, {
xtype : 'checkbox',
style : 'margin:0;',
itemId : 'owner_protect',
ctCls : 'aclcheckbox-cls',
boxLabel : _S._SFE_LANG_ACL03,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACL03',
hideLabel : true,
checked : stickybit,
hidden : (config.enableWinACL && config.aclEnable) || !QNAP.QOS.user.isAdminGroup,
}, {
xtype : 'checkbox',
itemId : 'acl_options_01', // admin_only
boxLabel : _S.IEI_NAS_ACL08,
style : 'margin:0;',
qInternational : true,
qInternationalKey : 'IEI_NAS_ACL08',
hideLabel : true,
hidden : !QNAP.QOS.user.isAdminGroup,
listeners : {
check : function(f, nv, index) {
FM.isAclChange = true;
}
}
}, {
xtype : 'checkbox',
style : 'margin:0;',
itemId : 'acl_recursive01',
boxLabel : _S._SFE_LANG_ACL04,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACL04',
hideLabel : true,
checked : true,
hidden : (config.enableWinACL && config.aclEnable) || !QNAP.QOS.user.isAdminGroup,
handler : function(self, checked) {
if (checked)
FM.advPPPanel
.getComponent('acl_recursive02')
.setValue(false);
}
}, {
xtype : 'checkbox',
style : 'margin:0;',
itemId : 'acl_recursive02',
boxLabel : _S._SFE_LANG_ACL05,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACL05',
hideLabel : true,
hidden : (config.enableWinACL && config.aclEnable) || !QNAP.QOS.user.isAdminGroup,
handler : function(self, checked) {
if (checked)
FM.advPPPanel
.getComponent('acl_recursive01')
.setValue(false);
}
}, {
xtype : "label",
hidden : !(config.enableWinACL==1 && config.aclEnable==1) || !QNAP.QOS.user.isAdminGroup,
text : _S._SFE_LANG_ACL_ALERT_MSG05,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACL_ALERT_MSG05',
style : "color:red;"
}]
});
FM.eastTab.getItem('permissionPanel').add(FM.advPPPanel);
FM.eastTab.doLayout();
}


FM.acl.disableGroupItem = [];


var currentShareProperty = QNAP.QOS.fileExplorerTools.tool
.getCurrentShareProperty(FM);
if (currentShareProperty.noSupportACL == true) {
var _msg = _S._SFE_LANG_ACL_ALERT_MSG01;// 'Sub-folder
var alertWin = FM._createModalWindow({
styleVer:1,
title : _S._SFE_LANG_COMMON_SYSTEM_MSG,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_SYSTEM_MSG',
items : [{
xtype : 'label',
text : _msg,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACL_ALERT_MSG01'
}, {
xtype : 'checkbox',
itemId : 'stopAskMe',
boxLabel : _S._SFE_LANG_ACL_ALERT_MSG02,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACL_ALERT_MSG02',
hideLabel : true
}],
autoCreate : true,
constrain : true,
constrainHeader : true,
modal : true,
border : false,
plain : true,
resizable : false,
closable : false,
animateTarget : 'hd_logo',
width : 400,
height : 'auto',
buttons : [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
if (Ext.get('stopAskMe').dom.checked) {
setCookie('not_support_acl+'
+ QNAP.QOS.user.account, '1',
60 * 60 * 24 * 7, '/');
}
alertWin.close();
}
}]
});

alertWin.render(document.body);
alertWin.getEl().addClass('x-window-dlg');
FM.advPPPanel.plugins.disableGroup('all');

if (getCookie('not_support_acl+' + QNAP.QOS.user.account) != '1') {
alertWin.show();
}
}

FM.acl.grid = FM.acl_grid;
FM.acl.makeGridColumnsSelectAll(FM.acl_grid);

var dis = FM.advPPPanel.plugins.disableGroup;
if (selections.length > 1) {
dis('all');
} else {
if (QNAP.QOS.fileExplorerTools.tool.isIsoFolder(FM)) {
dis('all');
} else {
if (QNAP.QOS.user.account.toUpperCase() == 'ADMIN') {
} else {
var owner=FM.advPPPanel.getComponent('composite-owner').innerCt
.getComponent('owner_user').getValue();
if (QNAP.QOS.user.account.toUpperCase() == owner.toUpperCase()) {
dis(23);
} else {
dis('all');
}
}
}
if (selections.length != 0 && !selections[0].get('isfolder')) {
FM.advPPPanel.getComponent('owner_protect').setValue(false);
FM.advPPPanel.getComponent('acl_recursive01')
.setValue(false);
FM.advPPPanel.getComponent('acl_recursive02')
.setValue(false);
dis(34);
} else {// isfolder==1
dis(0)
}
}
}
},// properties : End
updateStar : function(path) {
var FM = this;
var star = FM.pathPanel.getComponent('addFavBtn');
if (!path) {
path = FM.fileListStore.baseParams.path;
}
if (FM.favoriteStore.indexOfId(path) >= 0) {
star.removeClass('favorite-off');
star.addClass('favorite-on');
star.setTooltip('_SFE_LANG_ACTION_REMOVE_FROM_FAVORITES');
} else {
star.addClass('favorite-off');
star.removeClass('favorite-on');
star.setTooltip('_SFE_LANG_ACTION_Add_To_Favorites');
}
},// updateStar : End
switchColumnModel : function(view,isReloadThumb) {
var FM = this;
FM.fileGridColumnModel.setHidden(6, view == 'view-1');
FM.fileGridColumnModel.setHidden(7, view == 'view-1');
if (view == 'view-2') {
FM.setMainScr('NasDataView-id',isReloadThumb);
}
FM.gridPanel.view.refresh();// 為避免有影片選單時畫面錯亂

},
open : function(selections, record, withVLC) {
var FM = this;
var ua = navigator.userAgent;
var isiPad = /iPad/i.test(ua);
var isiPod = /iPod/i.test(ua);
var isiPhone = /iPhone/i.test(ua);
var isApple = isiPad || isiPod || isiPhone;
var appleBrwFiles = ['doc', 'docx', 'ppt', 'pptx', 'xls', 'xlsx',
'txt', 'pdf', 'jpg', 'jpeg', 'png', 'gif', 'bmp', 'mp3', 'mp4',
'm4v', 'mov', 'mp3', 'wav', 'aif', 'aiff', 'm4a'];

function openFile(selections) {
Ext.each(selections, function(file) {
var path = FM.currentPath;
var fileName = file.data.filename;
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(fileName)) { // 判斷是不是搜尋出來的檔案
var arr = QNAP.QOS.fileExplorerTools.tool
.getFileNamPath(fileName);
fileName = arr[0];
path = arr[1];
}
if (path.split('/')[0] == 'fav_') {// 判斷是不是 我的最愛
path = path.substring(4, path.length);
}

var filePath= '/cgi-bin/filemanager/utilRequest.cgi/'
+ encodeURIComponent(fileName)
+ '?sid=' + QNAP.QOS.user.sid
+ '&func=get_viewer&source_path='
+ encodeURIComponent(path)
+ '&source_file='
+ encodeURIComponent(fileName);

if(path.indexOf(FM.sysSetting.ubuntu_home_path)==0){
filePath=filePath+'&src_flag=ubuntu';
}
if (withVLC){
var downloadPath = QNAP.QOS.fileExplorerAction.getDownloadPath(path, selections, fileName, FM);
TMP_FN.getVLCInfo = function() {
return {
filePath : filePath,
fileName : fileName,
msgTitle:_S._SFE_LANG_COMMON_NEED_VLC_TITLE,
msgContent:_S._SFE_LANG_COMMON_NEED_VLC_2,
downloadPath:downloadPath,
buildYear:QNAP.QOS.config.build.substr(0,4)
};
}
window.open('/cgi-bin/apps/fileManager/vlc.html',"_blank");
}else{
window.open(filePath, "_blank");
}
})
}
if (selections) {// click more Action menu into here
var fileName = selections[0].get('filename');
var mediaType = QNAP.QOS.fileExplorerTools.tool.getMultiMediaType(fileName);
var extension = QNAP.QOS.fileExplorerTools.tool
.getExtension(fileName);// 副檔名
var path = FM.currentPath;
var isPluginVLC=QNAP.QOS.fileExplorerTools.tool.isPluginVLC();
if (selections.length == 1) {
if (parseInt(selections[0].get('isfolder')) == 1) {
FM.NasFileGridOnRowDblClick(FM.gridPanel);
} else if(/\.(dsdownload)$/i.test(fileName)){
var msgObj = {
text : _S._SFE_LANG_MSG_DOWNLOAD_STATION_FILE,
key : '_SFE_LANG_MSG_DOWNLOAD_STATION_FILE'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg
.call(FM, 'info', msgObj, btns);
MsgWin.show();
} else if(QNAP.QOS.fileExplorerTools.tool.getMultiMediaType(fileName)=='isVideo' && !(window.localStorage.FS_vlcHinted=='true')){
var msgObj = {
text : _S._SFE_LANG_MSG_NO_SUPPORT_VLC,
key : '_SFE_LANG_MSG_NO_SUPPORT_VLC',
width:420
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
window.localStorage.FS_vlcHinted=dontShow.getValue();
vlcHintWin.close();
var downloadPath = QNAP.QOS.fileExplorerAction.getDownloadPath(path, selections, fileName, FM);
var path = FM.currentPath;
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(fileName)) { // 判斷是不是
var arr = QNAP.QOS.fileExplorerTools.tool
.getFileNamPath(fileName);
fileName = arr[0];
path = arr[1];
}
if (path.split('/')[0] == 'fav_') {// 判斷是不是 我的最愛
path = path.substring(4, path.length);
}

var filePath= '/cgi-bin/filemanager/utilRequest.cgi/'
+ encodeURIComponent(fileName)
+ '?sid=' + QNAP.QOS.user.sid
+ '&func=get_viewer&source_path='
+ encodeURIComponent(path)
+ '&source_file='
+ encodeURIComponent(fileName);
if(path.indexOf(FM.sysSetting.ubuntu_home_path)==0){
filePath=filePath+'&src_flag=ubuntu';
}
TMP_FN.getVLCInfo = function() {
return {
filePath : filePath,
fileName : fileName,
msgTitle:_S._SFE_LANG_COMMON_NEED_VLC_TITLE,
msgContent:_S._SFE_LANG_COMMON_NEED_VLC_2,
downloadPath:downloadPath,
buildYear:QNAP.QOS.config.build.substr(0,4)
};
}
if(withVLC){
window.open('/cgi-bin/apps/fileManager/vlc.html',"_blank");
}else{
openFile(selections);
}
}
}];
var vlcHintWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM, 'info', msgObj, btns);
var dontShow = new Ext.form.Checkbox({
boxLabel : _S._SFE_LANG_ACL_ALERT_MSG02,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACL_ALERT_MSG02',
margins : '30',
checked : false
});
vlcHintWin.remove(1);
vlcHintWin.add({
xtype: 'container',
width : 250,
flex: 1,
margins: {
top: 10,
left: 17,
right: 0,
bottom: 0
},
items: [{
xtype: 'displayfield',
itemId: 'msgText',
value: msgObj.text,
qInternational: true,
qInternationalKey: msgObj.key,
style: {
marginBottom: '20px'
},
},
dontShow
]
});
if(Ext.isGecko && isPluginVLC){
openFile(selections);
}else{
vlcHintWin.show();
vlcHintWin.setHeight(260);
}
} else {
openFile(selections);
}
} else if (selections.length >= 1) {
openFile(selections);
}
} else if (record) {// 點文字進來的
var fileName = record.get('filename');
var extension = QNAP.QOS.fileExplorerTools.tool
.getExtension(fileName);// 副檔名
var path = FM.currentPath;
if (path.split('/')[0] == 'fav_') {// 判斷是不是 我的最愛
path = path.substring(4, path.length);
}
if (fileName.indexOf(path) >= 0) { // 判斷是不是 搜尋出來的檔案
var arr = fileName.split('/');
fileName = arr[arr.length - 1];
var arr2 = record.get('filename').split(path);
path = path + arr2[arr2.length - 1].replace(fileName, '');
}
if (record.get('isfolder') == 1) {
FM.NasFileGridOnRowDblClick(FM.gridPanel);

} else {
if (isApple) {
var isOpen = false;
Ext.each(appleBrwFiles, function(item) {
if (extension.toLowerCase() == item
.toLowerCase()) {
isOpen = true;
}
})
if (!isOpen) {
var msgObj = {
text : _S._SFE_LANG_ACTION_DOESNT_SUPPORT_PREVIEWING,
key : '_SFE_LANG_ACTION_DOESNT_SUPPORT_PREVIEWING'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg
.call(FM, 'error', msgObj, btns);
MsgWin.show();
return;
}
}
var openUrl='filemanager/utilRequest.cgi/'
+ encodeURIComponent(fileName) + '?sid='
+ QNAP.QOS.user.sid
+ '&func=get_viewer&source_path='
+ encodeURIComponent(path) + '&source_file='
+ encodeURIComponent(fileName);
if(path.indexOf(FM.sysSetting.ubuntu_home_path)==0){
openUrl=openUrl+'&src_flag=ubuntu';
}
window.open(openUrl, "_newtab");
}
} else {
var msgObj = {
text : _S._SFE_LANG_COMMON_MSG_NO_SELECTION,
key : '_SFE_LANG_COMMON_MSG_NO_SELECTION'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,
'warning', msgObj, btns);
MsgWin.show();

return; // 沒有丟任何東西進來
}

},// open End
gridFileNameClick : function(isClick) {
var FM = this;
FM.isTextClick = isClick;
},// gridFileNameClick
videoMenuClick : function(isClick, img) {
var FM = this;
FM.isVideoMenuClick = isClick;
FM.videoImg = img;
},// gridFileNameClick
showRecycleBinGrid : function() {
var FM = this;
if (!FM.recycleBinGrid) {
var rclStore = new Ext.data.JsonStore({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM, 'get_tree')
+ '&node=recycle_root',
baseParams : {
list_mode : 'all'
},
status : 'status',
acl : 'acl',
fields : ['text', 'id', 'cls', 'draggable', 'isfolder'],
listeners :{
load:function(store, records, options ){
FM.fncBtns.getComponent('moreActionBtn').hide();
}
}
});
var autoExpandColumn = Ext.id();
FM.recycleBinGrid = new Ext.grid.GridPanel({
minColumnWidth : 10,
enableColumnMove : false,
store : rclStore,
itemId : 'recycleBinGrid',
width : 'auto',
cls : 'recycleBinGrid-cls',
stripeRows : true,
autoExpandColumn : autoExpandColumn,
enableDragDrop : false,
enableHdMenu : false,
columns : [
{name : 'blank',
dataIndex : 'blank',
width:45},
{
name : 'text',
dataIndex : 'text',
id : autoExpandColumn,
header : _S._SFE_LANG_COMMON_LOCATION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_LOCATION',
sortable : true,
renderer : {
fn : QNAP.QOS.fileExplorerTools.tool.recycleBinCmName,
scope : FM
}
}],
loadMask : {
msg : ('_SFE_LANG_COMMON_LOADING_MSG')
},
data : {
dirPath : '/',
type : 'Recycle'
},
listeners : {
scope : FM,
rowclick : FM.recycleBinGridOnRowDblClick,
rowdblclick : FM.recycleBinGridOnRowDblClick
}
});
FM.recycleBinGrid.on('recycleBinGrid', function() {
Ext.getCmp(FM.IDS.FAV_START_BTN).hide();
});
FM.recycleBinGrid.on('load', function() {
Ext.getCmp(FM.IDS.PATH_BAR).doLayout();
});
FM.centerPanel.items.add(FM.recycleBinGrid);
} else {

}

FM.recycleBinGrid.store.reload();
FM.updatePathBarN('/@Recycle');
FM.setMainScr('recycleBinGrid');
FM.fncBtns.getComponent('moreActionBtn').hide();
},// showRecycleBinGrid
recycleBinGridOnRowDblClick : function(grid, index) {
var FM = this;
var shFolder = grid.store.getAt(index);
var node = FM.treePanel.getNodeById('/' + shFolder.data.text);
var config = {};
config.path = '/' + shFolder.data.text + '/@Recycle';
FM.addMemPath(config.path);
FM.gridPanel.store.baseParams.path = config.path;
FM.gridPanel.store.reload();
var swichModeBtn=Ext.getCmp(FM.northPanelId).getComponent('switchModeGroup').getComponent('mode2Btn');
if (swichModeBtn.pressed) {
FM.setMainScr('NasDataView-id');
} else {
FM.setMainScr('file-panel');
}

},
Compress : function(path) {// 2013-04-10:目前只有treeMenu的右鍵選單會傳Path進來
var FM = this;
var AfileName = '';
if (path) {
AfileName = path.split('/').pop();
} else {
var selections = FM.gridPanel.getSelectionModel().getSelections();
AfileName =QNAP.QOS.fileExplorerTools.tool.getFileNamPath(selections[0].get('filename'))[0];
if(selections[0].get('isfolder')==0 && AfileName.lastIndexOf('.')>0)
AfileName = AfileName.substring(0, AfileName.lastIndexOf('.'));
}
var compressWin;
if (!compressWin) {
compressWin = FM._createModalWindow({
styleVer:1,
title : _S._SFE_LANG_ACTION_COMPRESS_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_COMPRESS_TITLE',
layout : 'fit',
width : 500,
autoHeight : true,
closeAction : 'hide',
plain : true,
padding : 20,
cls : 'compressWin-cls',
items : [{
xtype : 'fieldset',
itemId : 'ArchiveOption',
title : _S._SFE_LANG_ACTION_ARCHIVE_OPTION_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_ARCHIVE_OPTION_TITLE',
collapsible : false,
autoHeight : true,
hideBorders : false,
labelWidth : 180,
defaults : {
xtype : 'combo',
width : 200
},
items : [{
itemId : 'AfileName',
xtype : 'textfield',
fieldLabel : _S._SFE_LANG_ACTION_ARCHIVE_NAME,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_ARCHIVE_NAME',
maxLength:251,
value : AfileName
}, {
itemId : 'cLevel',
fieldLabel : _S._SFE_LANG_ACTION_COMPRESSION_LEVEL,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_COMPRESSION_LEVEL',
triggerAction : 'all',
lazyRender : true,
editable : false,
mode : 'local',
value : 'normal',
valueField : 'value',
displayField : 'display',
qInternationalFn : function(cmp) {
var value = cmp.getValue();
cmp.getStore().each(function(r) {
r.set('display',
_S[r.get('qInternationalKey')]);
});
cmp.setValue(value);
},
store : new Ext.data.ArrayStore({
id : 0,
fields : ['value', 'display',
'qInternationalKey'],
data : [
[
'normal',
_S._SFE_LANG_COMMON_NORMAL,
'_LANG_COMMON_NORMAL'],
[
'large',
_S._SFE_LANG_COMMON_LARGE,
'_LANG_COMMON_LARGE'],
[
'fast',
_S._SFE_LANG_COMMON_FAST,
'_LANG_COMMON_FAST']]
})
}, {
itemId : 'aFormat',
fieldLabel : _S._SFE_LANG_ACTION_ARCHIVE_FORMAT,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_ARCHIVE_FORMAT',
triggerAction : 'all',
lazyRender : true,
editable : false,
mode : 'local',
value : 'zip',
valueField : 'value',
displayField : 'display',
listeners :{select :function( combo, scrollIntoView){
var AfileName=compressWin.getComponent('ArchiveOption').getComponent('AfileName');
var AfileNameId=AfileName.el.dom.id;
if(combo.getValue()=='7z'){
document.getElementById(AfileNameId).maxLength=252;
AfileName.maxLength=252;
}else{
if(AfileName.getValue().length>251){
var afn=AfileName.getValue();
afn=afn.substring(0,251);
AfileName.setValue(afn);
}
document.getElementById(AfileNameId).maxLength=251;
AfileName.maxLength=251;
}
}
},
qInternationalFn : function(cmp) {
var value = cmp.getValue();
cmp.getStore().each(function(r) {
r.set('display',
_S[r.get('qInternationalKey')]);
});
cmp.setValue(value);
},
store : new Ext.data.ArrayStore({
id : 0,
fields : ['value', 'display'],
data : [['zip', 'zip'],
['7z', '7z']]
})
}, {
itemId : 'uMode',
fieldLabel : _S._SFE_LANG_ACTION_UPDATE_MODE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_UPDATE_MODE',
triggerAction : 'all',
lazyRender : true,
editable : false,
mode : 'local',
value : '1',
valueField : 'value',
displayField : 'display',
qInternational : true,
qInternationalFn : function(cmp) {
var value = cmp.getValue();
cmp.getStore().each(function(r) {
r.set('display',
_S[r.get('qInternationalKey')]);
});
cmp.setValue(value);
},
store : new Ext.data.ArrayStore({
id : 0,
fields : ['value', 'display',
'qInternationalKey'],
data : [
[
'1',
_S._SFE_LANG_ACTION_COMPRESS_ADD_AND_REPLACE_FILES,
'_SFE_LANG_ACTION_COMPRESS_ADD_AND_REPLACE_FILES'],
[
'2',
_S._SFE_LANG_ACTION_COMPRESS_UPDATE_AND_ADD_FILES,
'_SFE_LANG_ACTION_COMPRESS_UPDATE_AND_ADD_FILES'],
[
'3',
_S._SFE_LANG_ACTION_COMPRESS_UPDATE_EXISTING_FILES,
'_SFE_LANG_ACTION_COMPRESS_UPDATE_EXISTING_FILES'],
[
'4',
_S._SFE_LANG_ACTION_COMPRESS_SYNCHROIZE_FILES,
'_SFE_LANG_ACTION_COMPRESS_SYNCHROIZE_FILES']]
})
}]
}, {
xtype : 'fieldset',
columnWidth : 0.5,
itemId : 'encryption',
title : _S._SFE_LANG_COMMON_ENCRYPTION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_ENCRYPTION',
collapsible : false,
autoHeight : true,
hideBorders : false,
labelWidth : 180,
defaults : {
xtype : 'textfield',
inputType : 'password',
width : 200
},
items : [{
fieldLabel : _S._SFE_LANG_ACTION_ENTER_PASSWORD,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_ENTER_PASSWORD',
itemId : 'pswd'
}, {
fieldLabel : _S._SFE_LANG_ACTION_VERIFY_PASSWORD,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_VERIFY_PASSWORD',
itemId : 'cf_pswd'
}]
}],
buttons : [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
var AOptions = compressWin
.getComponent('ArchiveOption');
var encryption = compressWin.getComponent('encryption');
var cpsParam = {};
if (encryption.getComponent('pswd').getValue() != encryption
.getComponent('cf_pswd').getValue()) {
var msgObj = {
text : _S._SFE_LANG_THE_PASSWORD_DOSE_NOT_MATCH,
key : '_SFE_LANG_THE_PASSWORD_DOSE_NOT_MATCH'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg
.call(FM, 'error', msgObj, btns);
MsgWin.show();
return;
}
cpsParam['compress_name'] = AOptions
.getComponent('AfileName').getValue();
cpsParam['type'] = AOptions.getComponent('aFormat')
.getValue();
cpsParam['level'] = AOptions.getComponent('cLevel')
.getValue();
cpsParam['mode'] = AOptions.getComponent('uMode')
.getValue();

var compress_file = '';
if (!Ext.isEmpty(encryption.getComponent('pswd')
.getValue())) {
cpsParam['pwd'] = encryption.getComponent('pswd')
.getValue();
}
if (path) {
cpsParam['path'] = path.substring(0, path
.lastIndexOf('/'));
compress_file = '&compress_file='
+ path.split('/').pop();
cpsParam['total'] = 1;
} else {
cpsParam['path'] = FM.currentPath;
var total = 0;
if (FM.currentGrid == 'fileGrid') {
var selections = FM.gridPanel
.getSelectionModel().getSelections();
Ext.each(selections, function(file) {
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(file.get('filename'))) {
var filename='.'+QNAP.QOS.fileExplorerTools.tool.getActFile(FM.gridPanel.store.baseParams.path,file.get('filename'));
compress_file = compress_file
+ '&compress_file='
+ encodeURIComponent(filename);
} else {
var filename = file.get('filename');
compress_file = compress_file
+ '&compress_file='
+ encodeURIComponent(filename);
}
total++
});
}
cpsParam['total'] = total;
}
QNAP.QOS.fileExplorerAction.compress(cpsParam,
compress_file, compressWin, FM);
}
}, {
text : _S._SFE_LANG_COMMON_CLOSE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CLOSE',
handler : function() {
compressWin.close();
}
}]
});
}
compressWin.show();

},// Compress End
videoPlay : function(selections, record, inputVq) {// inputVq:畫質
var FM = this;
var FMTools=QNAP.QOS.fileExplorerTools.tool;
var file;
if(selections){
file=selections[0];
}else if(record){
file=record;
}

if(!file){
return;
}
var fileName=file.get('filename');
if(inputVq){
FMTools.setResolution(inputVq);
}else{
var isTransFolder=file.get('filepath').split('/').pop()=='@Transcode';
if(QNAP.QOS.fileExplorerTools.tool.getResolution() && !isTransFolder){
var res=QNAP.QOS.fileExplorerTools.tool.getResolution().toString();
var couldRtt=QNAP.QOS.user.isAdminGroup && QNAP.QOS.fileExplorerTools.config.supportRTT;
if(res=='original' && /\.(mp4)$/i.test(file.get('filename')) ){playVideo();return;}
if(res=='240' && file.get('mp4_240')==1){playVideo();return;}
if(res=='360' && file.get('mp4_360')==1){playVideo();return;}
if(res=='480' && file.get('mp4_480')==1){playVideo();return;}
if(res=='720' && file.get('mp4_720')==1){playVideo();return;}
if(res=='1080' && file.get('mp4_1080')==1){playVideo();return;}
if(res=='240-R' && couldRtt){playVideo();return;}
if(res=='360-R' && couldRtt){playVideo();return;}
if(res=='480-R' && couldRtt){playVideo();return;}
if(res=='720-R' && couldRtt){playVideo();return;}
if(res=='1080-R'&& couldRtt){playVideo();return;}
if(res=='rtt'&& couldRtt){playVideo();return;}
}
}


var streamArea=new Ext.Container({
itemId:'streamArea',
height : 50,
style : {
paddingTop : '21px',
paddingBottom : '10px'
},
defaults: {
xtype:'button',
cls:'vqBtn-cls',
style : {
marginBottom : '10px',
paddingRight : '20px'
}
},
layout : {
type : 'hbox'
},
items : [
{itemId:'240p', hidden:true, text: '240p',handler: function(){inputVq=240;FMTools.setResolution(inputVq);playVideo();}},
{itemId:'360p', hidden:true, text: '360p',handler: function(){inputVq=360;FMTools.setResolution(inputVq);playVideo();}},
{itemId:'480p', hidden:true, text: '480p',handler: function(){inputVq=480;FMTools.setResolution(inputVq);playVideo();}},
{itemId:'720p', hidden:true, text: '720p',handler: function(){inputVq=720;FMTools.setResolution(inputVq);playVideo();}},
{itemId:'1080p',hidden:true, text: '1080p',handler: function(){inputVq=1080;FMTools.setResolution(inputVq);playVideo();}},
{
itemId:'originalStream',
text:_S._SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION',
hidden : !/\.(mp4)$/i.test(fileName) ,
handler: function(){
inputVq='original';
FMTools.setResolution(inputVq);
playVideo();
},
style : {
paddingRight : 0
}
}
]
});
var onTheFlyArea=new Ext.Container({
itemId:'onTheFlyArea',
hidden : !FM.RTT,
width : 506,
style : {
paddingTop : '21px',
paddingBottom : '10px'
},
defaults: {
xtype:'button',
cls:'vqBtn-cls',
style : {
marginBottom : '10px',
paddingRight : '20px',
float: 'left'
}
},
layout : {
type : 'auto'
},
items : [
{itemId:'240p', hidden:true, text: '240p',handler: function(){inputVq='240-R';FMTools.setResolution(inputVq);playVideo();}},
{itemId:'360p', hidden:true, text: '360p',handler: function(){inputVq='360-R';FMTools.setResolution(inputVq);playVideo();}},
{itemId:'480p', hidden:true, text: '480p',handler: function(){inputVq='480-R';FMTools.setResolution(inputVq);playVideo();}},
{itemId:'720p', hidden:true, text: '720p',handler: function(){inputVq='720-R';FMTools.setResolution(inputVq);playVideo();}},
{itemId:'1080p',hidden:true, text: '1080p',handler: function(){inputVq='1080-R';FMTools.setResolution(inputVq);playVideo();}},
{
itemId:'onTheFlyBtn',
text:_S._SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION',
handler: function(){
inputVq='rtt';
FMTools.setResolution(inputVq);
playVideo();
},
style : {
paddingRight : 0
}
}
]
});
var originalArea=new Ext.Container({
itemId:'originalArea',
height : 50,
width : 505,
defaults: {
xtype:'button',
},
layout : {
type : 'hbox'
},
items : [{
itemId:'originOpenBtn',
text:_S._SFE_LANG_COMMON_OPEN,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OPEN',
handler: function(){
FM.open([file]);
}
},
{xtype : 'tbspacer',width : 20},
{
itemId:'vlcOpenBtn',
text:_S._SFE_LANG_COMMON_OPEN_WITH_VLC,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OPEN_WITH_VLC',
hidden : Ext.isMac || Ext.isChrome,
handler: function(){
FM.open([file],null,true);
}
}
]
});


var onTheFlyCfmMsgWin = FM._createModalWindow({
styleVer:1,
layout : 'fit',
width : 640,
autoScroll:false,
autoHeight : true,
cls : 'FM-Msg-cls onTheFlyCfmMsgWin-cls',
padding:'26px 60px 24px 60px',
closable : true,
items : [
{
xtype: 'tbtext',
itemId:'streamText',
text:_S._SFE_LANG_MEDIA_01+':',
qInternational : true,
qInternationalFn : function(cmp) {
cmp.setText(_S._SFE_LANG_MEDIA_01+':');
},
autoHeight :true,
labelSeparator:':',
style: {
fontSize: '14px'
}
},
{xtype : 'tbspacer',height : 26},
{
xtype: 'tbtext',//
text:_S._SFE_LANG_MEDIA_02+':',
qInternational : true,
qInternationalFn : function(cmp) {
cmp.setText(_S._SFE_LANG_MEDIA_02+':');
},
style: {
fontWeight: 'bold'
}
},
streamArea,
{
xtype: 'tbtext',
text:_S._SFE_LANG_MEDIA_03,
qInternational : true,
qInternationalFn : function(cmp) {
cmp.setText(_S._SFE_LANG_MEDIA_03);
}
},
{xtype : 'tbspacer',height : 24},
{
xtype: 'tbtext',
itemId:'onTheFlyText',
text: FM.RTT ? _S._SFE_LANG_ON_THE_FLY_TRANSCODING+':' : '',
autoHeight :true,
qInternational : true,
qInternationalFn : function(cmp) {
cmp.setText(_S._SFE_LANG_ON_THE_FLY_TRANSCODING+':');
},
style: {
fontWeight: 'bold'
}
},
onTheFlyArea,
{
xtype: 'tbtext',
text:FM.RTT ? _S._SFE_LANG_MEDIA_04 : '',
qInternational : true,
qInternationalFn : function(cmp) {
cmp.setText(_S._SFE_LANG_MEDIA_04+':');
},
style: {
color:'red'
}
},//
{xtype : 'tbspacer',height : 24},
{
xtype: 'tbtext',
text:_S._SFE_LANG_MEDIA_06+':',
qInternational : true,
qInternationalFn : function(cmp) {
cmp.setText(_S._SFE_LANG_MEDIA_06+':');
},
style: {
fontWeight: 'bold'
}
},
originalArea
],
buttons:[{
text : _S._SFE_LANG_COMMON_CANCEL,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CANCEL',
handler : function() {
onTheFlyCfmMsgWin.close();
}
}],
listeners : {
beforeshow:function(win){

for (var i = 2; i < 6; i++) {
onTheFlyCfmMsgWin.items.items[i].el.dom.style.display = 'none';
}
if(!QNAP.QOS.user.isAdminGroup || !QNAP.QOS.fileExplorerTools.config.supportRTT){
for(var i=6;i<11;i++){
onTheFlyCfmMsgWin.items.items[i].el.dom.style.display='none';
}
}else{
}
QNAP.QOS.fileExplorerAction.getVideoInfo.call(FM,onTheFlyCfmMsgWin,onTheFlyArea,file);
},
show:function(win){
win.doLayout();
}
}
});
var mediaType = QNAP.QOS.fileExplorerTools.tool.getMultiMediaType(file.get('filename'));
var data=file.data;
var hideQtMenu=false;
if(!inputVq && mediaType == 'isVideo'){
var isTransFolder=file.get('filepath').split('/').pop()=='@Transcode';
if(/\.(mp4)$/i.test(file.get('filename')) && isTransFolder){
inputVq='original';
hideQtMenu=true;
playVideo();
}else{
onTheFlyCfmMsgWin.show();
}
}else{
playVideo();
}
function playVideo(){
var ua = navigator.userAgent;
var isiPad = /iPad/i.test(ua);
var isiPod = /iPod/i.test(ua);
var isiPhone = /iPhone/i.test(ua);
var isApple = isiPad || isiPod || isiPhone;
var tool = QNAP.QOS.fileExplorerTools.tool;
var sortInfo = FM.fileListStore.sortInfo;
var fileName = file.get('filename');
var extension = tool.getExtension(fileName);// 副檔名
var path = FM.fileListStore.baseParams.path;
function openFile() {
var fileName = file.data.filename;
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(fileName)) { // 判斷是不是搜尋出來的檔案
fileName = tool.getFileNamPath(file.get('filename'))[0];
path = tool.getFileNamPath(file.get('filename'))[1];
}

if (path.split('/')[0] == 'fav_') {// 判斷是不是 我的最愛
path = path.substring(4, path.length);
}
var mediaType = tool.getMultiMediaType(fileName);
var fvq=false;
if(inputVq=='original'){
fvq='original';
}
var config = {
path: path,
file: fileName,
type: mediaType,
force_vq : fvq,
supportRTT: FM.RTT,
sort: sortInfo.field,
dir: sortInfo.direction,
mmCodex: FM.config.mmCodex,
dataSrc:'FOLDER'
};
os.openApp('MediaViewer', config);
}
openFile();
if(onTheFlyCfmMsgWin){
onTheFlyCfmMsgWin.close();
}
}
},
/**
* 其他App 發出filechange, servicestop, servicestart, serviceupdate時
* os會呼叫對應function
*
* @param appId
*            來源app
* @param source
*            檔案改變前路徑
* @param target
*            檔案改變後路徑
* @param fileName
*            檔案名稱
* @param action
*            修改動作
*            <li>move</li>
*            <li>new</li>
*            <li>delete</li>
*            <li>rename</li>
*            <li>privilage</li>
*/
/**
* @param appId
*            來源app
* @param serviceName
*            service name
* @param option
*            其他資料
* @type
*/

initVFuncMenu : function() {
var FM = this;
var adminAndRtt = QNAP.QOS.user.isAdminGroup&& FM.RTT;
FM.vFuncMenu = new Ext.menu.Menu({
itemId : 'vFuncMenu',
cls : 'FM-moreActionMenuList-cls',
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
},
beforeshow : function(menu){
var file = FM.gridPanel.getSelectionModel().getSelections()[0];
menu.getComponent('originalStream').setVisible(/\.(mp4)$/i.test(file.get('filename')));
if (file.get('mp4_240') == 0
&& file.get('mp4_360') == 0
&& file.get('mp4_480') == 0
&& file.get('mp4_720') == 0
&& file.get('mp4_1080') == 0
&& menu.getComponent('originalStream').hidden
) {
menu.getComponent('streamBtn').setVisible(false);
}else{
menu.getComponent('streamBtn').setVisible(true);
}
menu.doLayout();
if(!QNAP.QOS.user.isAdminGroup || !FM.RTT){
menu.items.items[15].hide();//分隔線
return;
}
menu.getComponent('vcm_on_the_fly_transcoding').show();

var params = {};
params.path = file.get('filepath');
params.file_name = file.get('filename');
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(file.get('filename'))) {
params.file_name = QNAP.QOS.fileExplorerTools.tool.getFileNamPath(file.get('filename'))[0];
params.path = QNAP.QOS.fileExplorerTools.tool.getFileNamPath(file.get('filename'))[1];
}
params.file_total = 1;
params.detail = 1;
params.media = 1;
var menuMask;
if(menu.el){
menuMask = new Ext.LoadMask(menu.id, {msg : ('_SFE_LANG_COMMON_LOADING_MSG')});
menuMask.show();
}
menu.getComponent('originalStream').setVisible(/\.(mp4)$/i.test(params.file_name));
params=QNAP.QOS.fileExplorerTools.tool.checkUbuntuParams(params);
Ext.Ajax.request({
params : params,
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM, 'stat'),
success : function(response) {
var RS = Ext.decode(response.responseText);

if (RS.status && RS.status != 1) {
return;
}
var data = RS.datas[0];
var shortEdge;// 短邊
if (data.height && (data.height <= data.width)) {
shortEdge = data.height;
} else if (data.width && (data.width <= data.height)) {
shortEdge = data.width;
}
menu.getComponent('240p').setVisible(data.mp4_240==1);
menu.getComponent('360p').setVisible(data.mp4_360==1);
menu.getComponent('480p').setVisible(data.mp4_480==1);
menu.getComponent('720p').setVisible(data.mp4_720==1);
menu.getComponent('1080p').setVisible(data.mp4_1080==1);

if(!menu.getComponent('240p').isVisible() &&
!menu.getComponent('360p').isVisible() &&
!menu.getComponent('480p').isVisible() &&
!menu.getComponent('720p').isVisible() &&
!menu.getComponent('1080p').isVisible()&&
!/\.(mp4)$/i.test(params.file_name)){
menu.getComponent('streamBtn').setVisible(false);
}else{
menu.getComponent('streamBtn').setVisible(true);
}

menu.getComponent('otf240p').setVisible(data.mp4_240==0);
menu.getComponent('otf360p').setVisible(data.mp4_360==0);
menu.getComponent('otf480p').setVisible(data.mp4_480==0);
menu.getComponent('otf720p').setVisible(data.mp4_720==0);
menu.getComponent('otf1080p').setVisible(data.mp4_1080==0);
if(menuMask)
menuMask.hide();
menu.doLayout();
},
failure : function(RS) {
}
});
var transcodeBtn=FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('transcodeBtn');
var delTmpVideoBtn=FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('delTmpVideoBtn');
var record = FM.gridPanel.getSelectionModel().getSelections()[0];
if ((record.get('trans') == 1 || record.get('mp4_240') == 1
|| record.get('mp4_360') == 1 || record.get('mp4_480') == 1
|| record.get('mp4_720') == 1 || record.get('mp4_1080') == 1)
&& QNAP.QOS.user.isAdminGroup) {
FM.vFuncMenu.getComponent('vcm_delTmpVideoBtn').show();
} else {
FM.vFuncMenu.getComponent('vcm_delTmpVideoBtn').hide();
}

if (!QNAP.QOS.fileExplorerTools.tool.couldBeTrans(record.data)
|| !QNAP.QOS.user.isAdminGroup
|| FM.sysSetting.transcode_server_status<=0) {
FM.vFuncMenu.getComponent('vcm_transcodeBtn').hide();
} else {
FM.vFuncMenu.getComponent('vcm_transcodeBtn').show();
}

if (FM.sysSetting.transcode_server_status<=0){
FM.vFuncMenu.getComponent('vcm_delTmpVideoBtn').hide();
}
}
},
items : [{
itemId : 'vcm_play',
text : _S._SFE_LANG_COMMON_PLAY,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PLAY',
iconCls : 'playBtn-iconCls',
handler : function() {
FM.fncBtns.getComponent('moreActionBtn').menu
.getComponent('playBtn').handler();
}
},  {
itemId : 'streamBtn',
text:_S._SFE_LANG_MEDIA_02,
qInternational : true,
qInternationalKey : '_SFE_LANG_MEDIA_02',
disabled:true,
disabledClass:'disabledMenu-cls'
},{
text : '240p',
itemId : '240p',
rtt:240,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel().getSelections(),null, cmp.rtt);
}
}, {
text : '360p',
itemId : '360p',
rtt:360,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel().getSelections(),null, cmp.rtt);
}
}, {
text : '480p',
itemId : '480p',
rtt:480,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel().getSelections(),null, cmp.rtt);
}
}, {
text : '720p',
itemId : '720p',
rtt:720,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel().getSelections(),null, cmp.rtt);
}
}, {
text : '1080p',
itemId : '1080p',
rtt:1080,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel().getSelections(),null, cmp.rtt);
}
},{
itemId:'originalStream',
text : _S._SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION',
handler : function() {
FM.videoPlay(FM.gridPanel.getSelectionModel().getSelections(), null,'original');
}
},{
itemId : 'otfTitle',
text:_S._SFE_LANG_ON_THE_FLY_TRANSCODING,
qInternational : true,
qInternationalKey : '_SFE_LANG_ON_THE_FLY_TRANSCODING',
disabled:true,
hidden : !adminAndRtt,
disabledClass:'disabledMenu-cls'
}, {
text : '240p',
itemId : 'otf240p',
rtt:'240-R',
hidden : !adminAndRtt,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel().getSelections(),null, cmp.rtt);
}
}, {
text : '360p',
itemId : 'otf360p',
rtt:'360-R',
hidden : !adminAndRtt,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel().getSelections(),null, cmp.rtt);
}
}, {
text : '480p',
itemId : 'otf480p',
rtt:'480-R',
hidden : !adminAndRtt,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel().getSelections(),null, cmp.rtt);
}
}, {
text : '720p',
itemId : 'otf720p',
rtt:'720-R',
hidden : !adminAndRtt,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel().getSelections(),null, cmp.rtt);
}
}, {
text : '1080p',
itemId : 'otf1080p',
rtt:'1080-R',
hidden : !adminAndRtt,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel().getSelections(),null, cmp.rtt);
}
},{
itemId:'vcm_on_the_fly_transcoding',
text : _S._SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION',
rtt:'rtt',
hidden : !adminAndRtt,
handler : function() {
FM.videoPlay(FM.gridPanel.getSelectionModel().getSelections(), null,'rtt');
}
},'-',
{
itemId : 'vcm_delTmpVideoBtn',// delete transcoded
text : _S._SFE_LANG_ACTION_DELETE_TRANSCODED,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DELETE_TRANSCODED',
hidden :!QNAP.QOS.user.isAdminGroup,
cls : 'noIconMenu-cls',
handler : function() {
FM.fncBtns.getComponent('moreActionBtn').menu
.getComponent('delTmpVideoBtn').handler();
}
}, {
itemId : 'vcm_transcodeBtn',
text : _S._SFE_LANG_ACTION_TRANSCODE_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_TRANSCODE_TITLE',
hidden : !QNAP.QOS.user.isAdminGroup || FM.sysSetting.transcode_server_status<=0,
cls : 'noIconMenu-cls',
handler : function() {
FM.fncBtns.getComponent('moreActionBtn').menu.getComponent('transcodeBtn').handler();
}
}]
})
},// vFuncMenu End
setMainScr : function(panelName,isReloadThumb) {
var FM = this;
var northPanel = Ext.getCmp(FM.northPanelId);
FM.centerPanel.layout.setActiveItem(panelName);
FM.centerPanel.setAutoScroll(false);
FM.centerPanel.bbar.dom.style.display='none';
FM.centerPanel.doLayout();
FM.delHistoryGridBtns.hide();
var filterBtn=Ext.getCmp(FM.northPanelId).getComponent('filterBtn');
filterBtn.hide();
FM.share2MeBtns.hide();
if (panelName == 'file-panel') {
delete FM.fileListStore.baseParams['view_repository'];
FM.searchComboBox.show();
FM.searchMenuBtn.show();
Ext.getCmp(FM.searchSpace).hide();
FM.fncBtns.show();
FM.remoteBtn.setVisible(FM.sysSetting.isUseRemote);
FM.pathPanel.show();
FM.shareBtns.hide();
FM.centerPanel.bbar.dom.style.display='';
FM.centerPanel.doLayout();
filterBtn.show();
FM.centerPanel.bottomToolbar.items.items[15].setValue(QNAP.QOS.user.pageSize.wfm_file_list_page_size || 50);
if(isReloadThumb)
FM.setFileThumb(0);
} else if (panelName == 'NasDataView-id') {
delete FM.fileListStore.baseParams['view_repository'];
FM.searchComboBox.show();
FM.searchMenuBtn.show();
Ext.getCmp(FM.searchSpace).hide();
FM.fncBtns.show();
FM.remoteBtn.setVisible(FM.sysSetting.isUseRemote);
FM.pathPanel.show();

FM.centerPanel.setAutoScroll(true);
FM.centerPanel.bbar.dom.style.display='';
FM.centerPanel.doLayout();
filterBtn.show();
var selections=FM.gridPanel.getSelectionModel().getSelections();
FM.thumbSel(selections);
FM.centerPanel.bottomToolbar.items.items[15].setValue(QNAP.QOS.user.pageSize.wfm_file_list_page_size || 50);
if(isReloadThumb)
FM.setFileThumb(0);
} else if (panelName == 'shareFolderCTNGrid' || panelName == 'shareSubListGrid' || panelName == 'share2MeGrid') {
FM.searchComboBox.hide();
FM.searchMenuBtn.hide();
Ext.getCmp(FM.searchSpace).show();
FM.advSearchArea.hide();
FM.fncBtns.hide();
FM.remoteBtn.hide();
FM.shareBtns.hide();
FM.clientfncBtns.hide();
FM.pathPanel.hide();
FM.share2MeBtns.show();
FM.centerPanel.doLayout();
} else if (panelName == 'share-panel') {
FM.searchComboBox.hide();
FM.searchMenuBtn.hide();
Ext.getCmp(FM.searchSpace).show();
FM.advSearchArea.hide();
FM.fncBtns.hide();
FM.remoteBtn.hide();
FM.shareBtns.show();
FM.clientfncBtns.hide();
FM.sharePagingBar.doRefresh();
FM.pathPanel.hide();
FM.showShareLinkBtn();
FM.sharePagingBar.items.items[15].setValue(QNAP.QOS.user.pageSize.wfm_file_list_page_size || 50);
FM.centerPanel.doLayout();
} else if (panelName == 'clientGridPanel') {
FM.searchComboBox.hide();
FM.searchMenuBtn.hide();
Ext.getCmp(FM.searchSpace).show();
FM.advSearchArea.hide();
FM.clientGridPanel.bottomToolbar.items.items[15].setValue(QNAP.QOS.user.pageSize.wfm_file_list_page_size || 50);
FM.clientfncBtns.doLayout();
} else if (panelName == 'recycleBinGrid') {
FM.searchComboBox.hide();
FM.searchMenuBtn.hide();
Ext.getCmp(FM.searchSpace).show();
FM.fncBtns.getComponent('moreActionBtn').hide();
FM.remoteBtn.hide();
FM.advSearchArea.hide();
} else if (panelName == 'delHistoryGrid') {
FM.delHistoryGrid.store.baseParams.view_repository=1;
FM.delHistoryGrid.store.reload();
FM.delHistoryGridBtns.show();
FM.fncBtns.hide();
FM.remoteBtn.hide();
FM.shareBtns.hide();
FM.clientfncBtns.hide();
FM.delHistoryGrid.bottomToolbar.items.items[15].setValue(QNAP.QOS.user.pageSize.wfm_file_list_page_size || 50);
}


var eastPanelBtn = northPanel.items.items[northPanel.items.items.length - 1];
var eastcmp = FM._getMainWindow().layout.east;
if (panelName == 'file-panel' || panelName == 'NasDataView-id' || panelName == 'delHistoryGrid') {
northPanel.getComponent('switchModeGroup').show();
if(panelName == 'delHistoryGrid'){
northPanel.getComponent('switchModeGroup').hide();
}
eastPanelBtn.show();
} else {
if (eastcmp.isVisible()) {
eastPanelBtn.btnEl.dom.click();
}
eastPanelBtn.hide();
northPanel.getComponent('switchModeGroup').hide();
}
},
addToTransCode : function(path) {// 只有treeMenu才會傳Path進來
var FM = this;

var selections=FM.gridPanel.getSelectionModel().getSelections();
var transExp;
if (FM.config.mmCodex == 0) {
var msg =_S._SFE_LANG_COMMON_MMCODEX.replace('<qtag>','<a href="#" onClick="QNAP.QOS.fileExplorerTools.tool.openAppHDStation();">').replace('</qtag>','</a>');
var msgObj = {
text : msg,//_S._SFE_LANG_COMMON_MMCODEX,
key : '_SFE_LANG_COMMON_MMCODEX'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM, 'warning',
msgObj, btns);
MsgWin.show();
return;
}
if (!path && !QNAP.QOS.fileExplorerTools.tool
.checkSelection(FM.gridPanel)) {
return false;
}
var files = FM.gridPanel.getSelectionModel().getSelections();
var j = 1, filenames = [];
var tPath = FM.fileListStore.baseParams.path;
var ttl;
if (path) {
tPath = path.substring(0, path.lastIndexOf('/'));
if (path.split('/').length <= 2) {
tPath = '/';
}
ttl = 1;
filenames.push(path.split('/').pop());
} else {
ttl = files.length;
for (var i = 0; i < ttl; i++) {
filenames.push(files[i].get('filename'));
j = 1 + i;
}
}

var tasksStore;
if(QNAP.QOS.FileUploadMgr){
tasksStore=QNAP.QOS.FileUploadMgr.prototype.getTasks();
}

var isAddingTrans=false;
Ext.each(tasksStore.data.items,function(item){
if((item.get('copying')==0 || item.get('copying')==1)  && item.get('type')==42){
if (path) {
var fromArr=item.get('from_multi');
Ext.each(fromArr,function(fromPath){
if(fromPath.indexOf(path)>=0 || path.indexOf(fromPath)>=0){
isAddingTrans=true;
}
});
}else{
Ext.each(files,function(file){
var fullPath=FM.fileListStore.baseParams.path+'/'+file.get('filename');
var fromArr=item.get('from_multi');
Ext.each(fromArr,function(fromPath){
if(fromPath.indexOf(fullPath)>=0 || fullPath.indexOf(fromPath)>=0){
isAddingTrans=true;
}
});
});
}
}
});
if(isAddingTrans){
var msgObj = {
title : _S._SFE_LANG_ACTION_TRANSCODE_TITLE,
titleKey : '_SFE_LANG_ACTION_TRANSCODE_TITLE',
text : _S._SFE_LANG_MSG_IS_DELING_TRANS,
key : '_SFE_LANG_MSG_IS_DELING_TRANS'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
erMsgWin.close();
}
}];
var erMsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,'warning', msgObj, btns);
erMsgWin.show();
return ;
}



var msgObj = {
height : 450,
width : 540,
text : _S._SFE_LANG_TRANS_CMF_MSG,
key : '_SFE_LANG_TRANS_CMF_MSG'
};
var btns = [{xtype: 'tbtext',
width:200,
style:'text-align:left;box-shadow: none;left: -77px;position: relative;padding: 0; margin: 0;'
},{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
var info = new Ext.form.DisplayField({
style : 'padding-top:5px;padding-left:5px;font-size:12px;',
value : _S._SFE_LANG_COMMON_PROGRESS_READY
});
var panel = new Ext.Panel({
items : [info],
border : false,
height : 40
});
var maskNum = 0;


if (q240p.getValue()) {
maskNum = maskNum + 1;
}
if (q360p.getValue()) {
maskNum = maskNum + 2;
}
if (q720p.getValue()) {
maskNum = maskNum + 4;
}
if (q480p.getValue()) {
maskNum = maskNum + 8;
}
if (q1080p.getValue()) {
maskNum = maskNum + 16;
}

if((!q240p.getValue() || q240p.disabled)
&& (!q360p.getValue() || q360p.disabled)
&& (!q720p.getValue() || q720p.disabled)
&& (!q480p.getValue() || q480p.disabled)
&& (!q1080p.getValue() || q1080p.disabled)){
maskNum = 0;
}


if (maskNum == 0
&& ( (document.getElementById(transFolderid) && !document.getElementById(transFolderid).checked)
||(document.getElementById(cancelTransFolderid) && !document.getElementById(cancelTransFolderid).checked)
)
){
return;
}

var url=QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'video_ml_queue');
var params;
var addtoMLib,removeFromMLib;
if(document.getElementById(transFolderid)){
addtoMLib = document.getElementById(transFolderid).checked;
}

if(document.getElementById(cancelTransFolderid)){
removeFromMLib = document.getElementById(cancelTransFolderid).checked;
}
if(!path && files.length==1 && files[0].get('isfolder')==1  && addtoMLib){
params = {
monitor:1,//1:將資料夾加入媒體櫃,0:將資料夾從媒體櫃移除
op : 4,
subop : 0,
path : tPath,
filename : files[0].get('filename'),
total : 1,
mask : maskNum
};
}else{
var hasFile=false,hasFolder=false;
Ext.each(files,function(file){
if(file.get('isfolder')==1){
hasFolder=true;
}else{
hasFile=true;
}
});
if(path){
hasFolder=true;
}
var mtr;
if(!addtoMLib && removeFromMLib==undefined){//含有檔案則傳送-1或者不傳送monitor參數
mtr=-1;
}else if(removeFromMLib==false){
mtr=1;
}else if(hasFolder && addtoMLib){//有資料夾，且要加入媒體櫃
mtr=1;
}else if(hasFolder && removeFromMLib){//有資料夾，且要從媒體櫃移除
mtr=0;
}
params = {
monitor:mtr,
op : 3,
subop : 0,
path : tPath,
filename : filenames,
total : ttl,
mask : maskNum
};
if(QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(filenames[0])){
params.total=1;
params.filename = [QNAP.QOS.fileExplorerTools.tool.getFileNamPath(filenames[0])[0]];
params.path = QNAP.QOS.fileExplorerTools.tool.getFileNamPath(filenames[0])[1];
}
}
transCfmMsgWin.close();

QNAP.QOS.fileExplorerTools.tool.ajax.call(FM, {
url : url,
params : params,
handler : {
success : function(resulte, rq) {
os.openApp('FileUploadMgr', {tabNum : 0});
},
failure : function(errorCode) {
if(errorCode!=1){
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,errorCode);
}
}
}
});
}
}, {
text : _S._SFE_LANG_COMMON_CANCEL,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CANCEL',
handler : function() {
transCfmMsgWin.close();
}
}];
var msgIcon = '<img height="50px" width="50px" src="/cgi-bin/images/toolbar/icon-question.png">';


var q240p = new Ext.form.Checkbox({
boxLabel : '240p',
value : 1,
margins : '30',
checked : false,
listeners : {
check : function( checkBox, checked ) {
transCfmMsgWin.checkQTOptions();
}
}
});
var q360p = new Ext.form.Checkbox({
boxLabel : '360p',
value : 2,
margins : '30',
checked : true,
listeners : {
check : function( checkBox, checked ) {
transCfmMsgWin.checkQTOptions();
}
}
});
var q480p = new Ext.form.Checkbox({
boxLabel : '480p SD',
value : 4,
margins : '30',
checked : false,
listeners : {
check : function( checkBox, checked ) {
transCfmMsgWin.checkQTOptions();
}
}
});
var q720p = new Ext.form.Checkbox({
boxLabel : '720p HD',
value : 8,
margins : '30',
checked : false,
listeners : {
check : function( checkBox, checked ) {
transCfmMsgWin.checkQTOptions();
}
}
});
var q1080p = new Ext.form.Checkbox({
boxLabel : '1080p FULL HD',
value : 16,
margins : '30',
checked : false,
listeners : {
check : function( checkBox, checked ) {
transCfmMsgWin.checkQTOptions();
}
}
});
var transProssId=Ext.id(), transWareId=Ext.id(),transExpId=Ext.id();
var transCfmMsgWin = FM._createModalWindow({
styleVer:1,
padding:'26px 30px 24px 30px',
title : _S._SFE_LANG_ACTION_TRANSCODE_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_TRANSCODE_TITLE',
layout : 'hbox',
width : msgObj.width || 420,
height : msgObj.height || 215,
closable : false,
cls : 'FM-Msg-cls transCfmMsgWin-cls',
msgParams:{},
items : [{
xtype : 'displayfield',
itemId : 'msgIcon',
cls : 'msgIcon-cls',
value : msgIcon
}, {
xtype : 'tbspacer',
width : 10
}, new Ext.Container({

itemId : 'msgContainer',
flex : 1,
width:412,
autoHeight :true,
layout : {
type : 'vbox'
},
items : [{
xtype : 'tbtext',
style :'border-right : 16px;',
text : _S._SFE_LANG_TRANS_CMF_MSG,
qInternational : true,
qInternationalKey : '_SFE_LANG_TRANS_CMF_MSG'
},{
xtype : 'tbspacer',
width:412,
height : 16
},{
xtype : 'displayfield',
itemId : 'codexHint',
hidden : true,
text : _S._SFE_LANG_MSG_QTRANSCODE,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_QTRANSCODE'
},{
xtype : 'tbspacer',
height : 16
},{
xtype : 'qtscheckbox',
itemId : 'transFolder',
hidden : true,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_TRANS_FOLDER',
boxLabel : _S._SFE_LANG_MSG_TRANS_FOLDER.replace('<qtag>','<a href="#" onClick="QNAP.QOS.fileExplorerTools.tool.openTransFolder();">').replace('</qtag>','</a>'),
listeners : {
check : function( checkBox, checked ) {
transCfmMsgWin.checkQTOptions();
}
}
},{
xtype: 'displayfield',
itemId : 'tansProcess',
value : _S._SFE_LANG_MSG_VIDEO_TRANSCODING_PROCESS,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_VIDEO_TRANSCODING_PROCESS'
},{
xtype: 'displayfield',
itemId : 'transExp',
value : _S._SFE_LANG_MSG_TRANSCODING_EXPLAIN,
hidden:true,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_TRANSCODING_EXPLAIN'
},{
xtype : 'tbspacer',
height : 16
},{
xtype: 'displayfield',
itemId : 'transWare',
value : _S._SFE_LANG_COMMON_DECODE+' -> '+_S._SFE_LANG_COMMON_ENCODE,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_VIDEO_TRANSCODING_PROCESS',
listeners : {
}
},{
xtype: 'displayfield',
itemId : 'codexUpdate',
value : _S._SFE_LANG_MSG_PLEASE_UPDATE_CODEXPACK
.replace('<qtag>','<a href="#" onClick="QNAP.QOS.fileExplorerTools.tool.openAppHDStation();">').replace('</qtag>','</a>')
.replace('<qtag>','<a href="#" onClick="QNAP.QOS.fileExplorerTools.tool.openAppHDStation();">').replace('</qtag>','</a>'),
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_PLEASE_UPDATE_CODEXPACK',
listeners : {
afterrender : function(cmp){
if(!FM.isWFM && os.hasNewCodexPack()){
if(FM.sysSetting.need_codexpack_standalone==1){
var codexHintMsg=_S._SFE_LANG_MSG_PLEASE_UPDATE_CODEXPACK.replace('<qtag>','<a href="#" onClick="QNAP.QOS.fileExplorerTools.tool.openAppCenterCodexPack();">').replace('</qtag>','</a>');
codexHintMsg=codexHintMsg.replace('<qtag>','<a href="#" onClick="QNAP.QOS.fileExplorerTools.tool.openAppCenterCodexPack();">').replace('</qtag>','</a>');
cmp.setValue(codexHintMsg);
}
cmp.show();
}else{
cmp.hide();
}
}
}
}],
listeners : {
afterrender : function(cmp){
if (selections.length == 1 && selections[0].get('isfolder') != 1 && !path) {
QNAP.QOS.fileExplorerTools.tool.getTransExp.call(FM,selections[0],cmp.getComponent('transWare'),cmp.getComponent('transExp'),transCfmMsgWin);
cmp.getComponent('tansProcess').show();
cmp.getComponent('transExp').show();
cmp.getComponent('transWare').show();
}else{
QNAP.QOS.fileExplorerTools.tool.testTransExp.call(FM,selections[0],transCfmMsgWin);
cmp.getComponent('tansProcess').hide();
cmp.getComponent('transExp').hide();
cmp.getComponent('transWare').hide();
}
transCfmMsgWin.checkQTOptions();
}
}
})
],
bbar : ['->', q240p, {
xtype : 'tbspacer',
width : 25,
height : 30
}, q360p, {
xtype : 'tbspacer',
width : 25
}, q480p, {
xtype : 'tbspacer',
width : 25
}, q720p, {
xtype : 'tbspacer',
width : 25
}, q1080p, {
xtype : 'tbspacer',
width : 25
}],
buttons : [btns],
checkQTOptions:function () {
var okBtn=transCfmMsgWin.buttons[1];
var cancelTransFolder=document.getElementById(cancelTransFolderid);
var transFolder=document.getElementById(transFolderid);
if((!cancelTransFolder || !cancelTransFolder.checked )
&& !q240p.checked
&& !q360p.checked
&& !q480p.checked
&& !q720p.checked
&& !q1080p.checked){
okBtn.disable();
}else{
okBtn.enable();
}
}
});
var transFolderid=Ext.id();
var cancelTransFolderid=Ext.id();
function showTransFolder(path){
var sels=FM.gridPanel.getSelectionModel().getSelections();
var params={};
if(path){
params.path=path;
params.file_name='';
}else{
params.path=FM.currentPath;
params.file_name=FM.gridPanel.getSelectionModel().getSelections()[0].get('filename');
}
params.file_total=1;
params.detail=1;
if(path || (sels.length>0 && sels[0].get('isfolder')==1)){
}else{
params.media=1;
}
transCfmMsgWin.mask.show();
transCfmMsgWin.buttons[1].disable();
Ext.Ajax.request({
params:params,
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'stat'),
success : function(response) {
transCfmMsgWin.buttons[1].enable();
var RS = Ext.decode(response.responseText);
transCfmMsgWin.msgParams.stat=RS;
if(RS.status && RS.status!=1){
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,RS.status);
transCfmMsgWin.close();
return;
}

var data=RS.datas[0];
var shortEdge;//短邊
if(data.height && (data.height<=data.width)){
shortEdge=data.height;
}else if(data.width && (data.width<=data.height)){
shortEdge=data.width;
}
if(shortEdge && sels.length==1){
transCfmMsgWin.buttons[0].setText(_S._SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION+': '+data.width+'*'+data.height);
}else{
q240p.setDisabled(false);
q360p.setDisabled(false);
q480p.setDisabled(false);
q720p.setDisabled(false);
q1080p.setDisabled(false);
}

if(data.trans_240==1 || data.trans_360==1 ||
data.trans_480==1 ||data.trans_720==1 ||
data.trans_1080==1 ||data.mp4_240==1 || data.mp4_360==1 ||
data.mp4_480==1 ||data.mp4_720==1 ||
data.mp4_1080==1
){//已加入轉檔
if(sels.length==1){
q240p.setValue(data.mp4_240==1 || data.trans_240==1);
q360p.setValue(data.mp4_360==1 || data.trans_360==1);
q480p.setValue(data.mp4_480==1 || data.trans_480==1);
q720p.setValue(data.mp4_720==1 || data.trans_720==1);
q1080p.setValue(data.mp4_1080==1 || data.trans_1080==1);

q240p.setDisabled(data.mp4_240==1 || data.trans_240==1);
q360p.setDisabled(data.mp4_360==1 || data.trans_360==1);
q480p.setDisabled(data.mp4_480==1 || data.trans_480==1);
q720p.setDisabled(data.mp4_720==1 || data.trans_720==1);
q1080p.setDisabled(data.mp4_1080==1 || data.trans_1080==1);
}else{
q240p.setDisabled(false);
q360p.setDisabled(false);
q480p.setDisabled(false);
q720p.setDisabled(false);
q1080p.setDisabled(false);
}
if(data.isfolder==1){
var msg=transCfmMsgWin.getComponent('msgText').getValue();
msg=msg+'<br><br><input type="checkbox" id="'+cancelTransFolderid+'"/>';
transCfmMsgWin.getComponent('msgText').setValue(msg);
var cancelTransFolder=new Ext.form.Checkbox({
applyTo :cancelTransFolderid,
hidden : !path && sels.length!=1,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_REMOVE_FOLDER_MONITOR',
boxLabel : _S._SFE_LANG_MSG_REMOVE_FOLDER_MONITOR.replace('<qtag>','<a href="#" onClick="QNAP.QOS.fileExplorerTools.tool.openTransFolder();">').replace('</qtag>','</a>'),
listeners : {
check : function( checkBox, checked ) {
transCfmMsgWin.checkQTOptions();
}
}
});
}
}else{
var transFolder=transCfmMsgWin.getComponent('msgContainer').getComponent('transFolder');
if(RS.medialib_enable==1){
transFolder.show();
}else{
transFolder.hide();
}
transCfmMsgWin.doLayout();
q240p.setValue(false);
q360p.setValue(data.isfolder==1 || shortEdge>=360);
q480p.setValue(false);
q720p.setValue(false);
q1080p.setValue(false);
}
transCfmMsgWin.mask.hide();
},
failure : function(RS) {
transCfmMsgWin.mask.hide();
}
});
}


var transExp;
if (selections.length == 1 && selections[0].get('isfolder') != 1) {//如果只選一個影片檔
if (selections[0].data.mp4_240 == 1 || selections[0].data.mp4_360 == 1
|| selections[0].data.mp4_480 == 1 || selections[0].data.mp4_720 == 1
|| selections[0].data.mp4_1080 == 1) {
var data = selections[0].data;
q240p.setValue(data.mp4_240 == 1);
q360p.setValue(data.mp4_360 == 1);
q480p.setValue(data.mp4_480 == 1);
q720p.setValue(data.mp4_720 == 1);
q1080p.setValue(data.mp4_1080 == 1);

q240p.setDisabled(data.mp4_240 == 1);
q360p.setDisabled(data.mp4_360 == 1);
q480p.setDisabled(data.mp4_480 == 1);
q720p.setDisabled(data.mp4_720 == 1);
q1080p.setDisabled(data.mp4_1080 == 1);
}
}

transCfmMsgWin.on('show',function(win){
transCfmMsgWin.mask = new Ext.LoadMask(transCfmMsgWin.mc.dom, {
msg : ('_SFE_LANG_COMMON_LOADING_MSG')
});
Ext.Ajax.request({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'hwts'),
success : function(response) {
var RS = Ext.decode(response.responseText);
transCfmMsgWin.msgParams.hwts=RS;
var codexHint=transCfmMsgWin.getComponent('msgContainer').getComponent('codexHint');
if(RS.medialibHWTS==1 && RS.QTranscode==0){
codexHint.show();
var codexHintMsg=_S._SFE_LANG_MSG_QTRANSCODE.replace('<qtag>','<a href="#" onClick="QNAP.QOS.fileExplorerTools.tool.openAppHDStation();">').replace('</qtag>','</a>')
if(FM.sysSetting.need_codexpack_standalone==1){
codexHintMsg=_S._SFE_LANG_MSG_QTRANSCODE.replace('<qtag>','<a href="#" onClick="QNAP.QOS.fileExplorerTools.tool.openAppCenterCodexPack();">').replace('</qtag>','</a>')
codexHintMsg=codexHintMsg.replace('HD Station','App Center');
}
codexHint.setValue(codexHintMsg);
}else{
codexHint.hide();
}
if(QNAP.QOS.user.isAdminGroup ){
var sel=FM.gridPanel.getSelectionModel().getSelections();
showTransFolder(path);
}
Ext.get(transCfmMsgWin.getComponent('msgContainer').el.dom.firstChild).removeClass('x-hide-display');
transCfmMsgWin.doLayout();
},
failure : function(RS) {
}
});
});
transCfmMsgWin.show();
},//addToTransCode end
delTransCode : function(path) {
var FM = this,params={};
var msgObj = {
title : _S._SFE_LANG_ACTION_DELETE_TRANSCODED,
titleKey : '_SFE_LANG_ACTION_DELETE_TRANSCODED',
text : _S._SFE_LANG_DEL_TRANS_CMF_MSG,
key : '_SFE_LANG_DEL_TRANS_CMF_MSG'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
delTrans();
delTransCfmMsgWin.close();
}
}, {
text : _S._SFE_LANG_COMMON_CANCEL,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CANCEL',
handler : function() {
delTransCfmMsgWin.close();
}
}];
var delTransCfmMsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,'question', msgObj, btns);
delTransCfmMsgWin.show();
function delTrans() {
var msgObj = {
title : _S._SFE_LANG_ACTION_DELETE_TRANSCODED,
titleKey : '_SFE_LANG_ACTION_DELETE_TRANSCODED',
text : _S._SFE_LANG_ACTION_DEL_DELETING,
key : '_SFE_LANG_ACTION_DEL_DELETING'
};
var btns = [];
var delMsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,
'info', msgObj, btns);
if (!path
&& !QNAP.QOS.fileExplorerTools.tool
.checkSelection(FM.gridPanel)) {
return false;
}
var files = FM.gridPanel.getSelectionModel().getSelections();
var filenameStr = '';
if (path) {
if (path.split('/').length <= 2) {
params.path='/';
} else {
params.path = encodeURIComponent(path.substring(0, path .lastIndexOf('/')));
}
params.file_total=1;
filenameStr += '&file_name=' + encodeURIComponent(path.split('/').pop());
} else {
params.path = FM.fileListStore.baseParams.path;
var j = 1;
for (var i = 0; i < files.length; i++) {
filenameStr += '&file_name=' + encodeURIComponent(files[i].get('filename'));
j = 1 + i;
}
params.file_total=j;
}
filenameStr = filenameStr + '&mode=2';
/* 進度視窗用物件↓ */
var info = new Ext.form.DisplayField({
style : 'padding-top:5px;padding-left:5px;font-size:12px;',
value : _S._SFE_LANG_COMMON_PROGRESS_READY
});
var panel = new Ext.Panel({
items : [info],
border : false,
height : 40
});
var tasksStore;

if(QNAP.QOS.FileUploadMgr){
tasksStore=QNAP.QOS.FileUploadMgr.prototype.getTasks();
}
var isAddingTrans=false;
Ext.each(tasksStore.data.items,function(item){

if((item.get('copying')==0 || item.get('copying')==1)  && item.get('type')==41){
if (path) {
var fromArr=item.get('from_multi');
Ext.each(fromArr,function(fromPath){
if(fromPath.indexOf(path)>=0 || path.indexOf(fromPath)>=0){
isAddingTrans=true;
}
});
}else{
Ext.each(files,function(file){
var fullPath=FM.fileListStore.baseParams.path+'/'+file.get('filename');
var fromArr=item.get('from_multi');
Ext.each(fromArr,function(fromPath){
if(fromPath.indexOf(fullPath)>=0 || fullPath.indexOf(fromPath)>=0){
isAddingTrans=true;
}
});

});
}
}
});
if(isAddingTrans){
var msgObj = {
title : _S._SFE_LANG_ACTION_DELETE_TRANSCODED,
titleKey : '_SFE_LANG_ACTION_DELETE_TRANSCODED',
text : _S._SFE_LANG_MSG_IS_ADDING_TO_TRANS,
key : '_SFE_LANG_MSG_IS_ADDING_TO_TRANS'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
erMsgWin.close();
}
}];
var erMsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,'warning', msgObj, btns);
erMsgWin.show();
return ;
}

QNAP.QOS.fileExplorerTools.tool.ajax.call(FM, {
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'delete_transcode') + filenameStr,
params : params,
handler : {
success : function(resulte, rq) {
delMsgWin.close();
os.openApp('FileUploadMgr', {tabNum : 0});
},
failure : function(s) {
QNAP.QOS.fileExplorerTools.tool.showErrorMsg.call(FM,s);
}
}
});
}

},
createAcl : function() {
var FM = this;
var selectWinID = 'select_form';
var selectAllCls = 'select_all';
var attributes = ['r', 'w', 'x'];
var values = [4, 7, 0];
var store = {
selection : null
};
var addSelectionJson = [0, 'local users', 0];
var ownerWin = null;
var columnAttrs = [{
align : 'center',
header : _S._SFE_LANG_COMMON_READ,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_READ',
dataIndex : attributes[0],
itemId : attributes[0]
}, {
align : 'center',
header : _S._SFE_LANG_COMMON_WRITE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_WRITE',
dataIndex : attributes[1],
itemId : attributes[1]
}, {
align : 'center',
header : _S._SFE_LANG_COMMON_EXCUTE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_EXCUTE',
dataIndex : attributes[2],
itemId : attributes[2]
}];
var selection = {
tmpStore : null,
activePage : 0,
pageData : [[], [], [], []],
allData : [[], [], [], []],
nameData : [[], [], [], []],
reset : function() {
FM.acl.selection.tmpStore = null;
FM.acl.selection.activePage = 0;
FM.acl.selection.allData = [[], [], [], []];
FM.acl.selection.nameData = [[], [], [], []];
},
getType : function() {
return FM.acl.addSelectionJson[2] || 0;
},
getSelections : function() {
var i, j, len, result = [], all = FM.acl.selection.allData;
for (i = 0, len = all.length; i < len; i++) {
var l = all[i].length;
for (j = 0; j < l; j++) {
var d = all[i][j];
if (d.selected == true) {
result.push(d);
}
}
}
return result;
},
getStoreData : function(store) {
var i, j, l, data = [], attr = FM.acl.attributes, len = store.data.length
|| 0;
for (i = 0; i < len; i++) {
var item = {};
item.name = store.getAt(i).data['name'];
for (j = 0, l = attr.length; j < l; j++) {
var at = attr[j];
item[at] = store.getAt(i).data[at] || false;
}
data.push(item);
}
return data;
},
save : function(p) {
var s = s || FM.acl.selection.tmpStore;
var p = p || FM.acl.selection.activePage;
FM.acl.selection.addStoreData(s, p);
},
addStoreData : function(store, activePage) {
var data = FM.acl.selection.getStoreData(store), sm = FM.acl.userGrid
.getSelectionModel();
var pData = FM.acl.selection.pageData, aData = FM.acl.selection.allData, nData = FM.acl.selection.nameData, type = FM.acl.addSelectionJson[2];
var iconType = (type / 2 < 1) ? 1 : 2;

if (pData[type]) {
pData[type][activePage - 1] = data;
}
for (var i = 0, len = data.length; i < len; i++) {
var d = data[i], all = aData[type], names = nData[type], index = names
.indexOf(d.name);
var s = sm.getSelections();
for (var j = 0, sl = s.length; j < sl; j++) {
if (d.name == s[j].data.name) {
d.selected = true;
break;
}
}
d.type = iconType;
if (index == -1) {
names.push(d.name);
all.push(d);
} else {
all[index] = d;
}
}
}
};
var disableGroupItem = [];
return {
selection : selection,
addSelectionJson : addSelectionJson,
attributes : attributes,
columnAttrs : columnAttrs,
getSubmitPermission : function(s, changeOnly, grid, oldAclData) {
function nameInArray(item, ar) {
var result = false;
for (var i = 0, len = ar.length; i < len; i++) {
if (ar[i][0] == item[0] && // type
ar[i][1] == item[1]) // name
{
result = true;
break;
}
}
return result;
}
function itemInArray(item, ar) {
var result = false;
var s = JSON.stringify;
for (var i = 0, len = ar.length; i < len; i++) {
if (s(ar[i]) == s(item)) {
result = true;
break;
}
}
return result;
}
changeOnly = changeOnly || false;
var users = [], groups = [], del_users = [], del_groups = [], len, i, result = {};

var n = FM.acl.getLatestData(grid);
var o = oldAclData;
if (changeOnly == true) {
for (var i = 0, len = n.length; i < len; i++) {
var obj = n[i];
if (itemInArray(obj, o) == false) {
var permission = (obj[2] * 4 + obj[3] * 2 + obj[4]
* 1);;
if (obj[0] == 1)
users.push([obj[1], permission]);
else
groups.push([obj[1], permission]);
}
}

for (var i = 0, len = o.length; i < len; i++) {
var obj = o[i];
if (itemInArray(obj, n) == false) {
if (nameInArray(obj, n) == false) {
var permission = (obj[2] * 4 + obj[3] * 2 + obj[4]
* 1);;
if (obj[0] == 1)
del_users.push([obj[1], permission]);
else
del_groups.push([obj[1], permission]);
}
}
}
} else {
for (i = 0, len = s.data.length; i < len; i++) {
var d = s.getAt(i).data;
if (d.type == 1)
users.push([d.name, FM.acl.getPermissionToInt(d)]);
else
groups.push([d.name, FM.acl.getPermissionToInt(d)]);
}
}

result.user_len = users.length;
result.group_len = groups.length;
for (i = 0, len = users.length; i < len; i++) {
result['user' + i] = users[i][0];
result['user_permission' + i] = users[i][1];
}

for (i = 0, len = groups.length; i < len; i++) {
result['group' + i] = groups[i][0];
result['group_permission' + i] = groups[i][1];
}

if (changeOnly) {
result.del_user_len = del_users.length;
result.del_group_len = del_groups.length;
for (i = 0, len = del_users.length; i < len; i++)
result['del_user' + i] = del_users[i][0];

for (i = 0, len = del_groups.length; i < len; i++)
result['del_group' + i] = del_groups[i][0];
}

return result;
},
getPermissionToInt : function(d) {
if (d.r != undefined && d.w != undefined && d.x != undefined)
return d.r * 4 + d.w * 2 + d.x * 1;
else
return 0;
},
getPermissionToArray : function(v) {
return [!!(v & 4), !!(v & 2), !!(v & 1)];
},
getAddSelectionDS : function(store, path, filter) {
var json = FM.acl.addSelectionJson;
var users = [], groups = [], p = {};
p.share_name = '/share' + path;
p.filter = filter;
p.type = json[2];
var pathArr = path.split('/');

if (pathArr > 2) {
p.root = 0;
} else {
p.root = 1;
}
if (store) {
var user_len = 1;
var group_len = 0;
for (var i = 0; i < store.getCount(); i++) {
if (store.data.items[i].data.groupOrUser == '2') {
p['user' + user_len] = store.data.items[i].data.dirname;
user_len++;
} else {
p['group' + group_len] = store.data.items[i].data.dirname;
p['grouppriv' + group_len] = store.data.items[i].data.now;
group_len++;
}
}
p.user_len = user_len;
p.group_len = group_len;

}

p.lower = 0;
p.upper = 100;
p.user0 = 'guest';
FM.getUserGroupArray = [];
return new Ext.data.JsonStore({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,
'get_acl_user_group_list_out'),
baseParams : p,
status : 'status',
totalProperty : 'count',
root : 'datas',
fields : ['name', 'groupList', 'preview'],
listeners : {
load : function(store) {
store.each(function(record, index) {
var chkValue = false;
record.data.preview = record.data.privOld = QNAP.QOS.fileExplorerTools.tool
.chgStatuE2N(record.data.preview || 'N');
if (!chkValue) {
var o = {};
o.name = record.data.name;
o.access_rd = record.data.access_rd = false;
o.access_rw = record.data.access_rw = false;
o.access_no = record.data.access_no = false;
o.type = record.data.type = parseInt(Ext
.getCmp(QNAP.QOS.fileExplorerAction.wizard_list_type)
.getValue());
o.privOld = o.preview = record.data.preview;
o.groupList = record.data.groupList || '';
o.now = record.data.now = QNAP.QOS.fileExplorerTools.tool
.compareNumber(record.data.preview,
0);
FM.getUserGroupArray.push(o);
store.data.items[index].afterEdit();
}
});
}
}
});
},
getAddSelectionParam : function(json) {
var p = {}, ps, users = [], groups = [];
p.type = v[2];
p.filter = Ext.getCmp('user_search') ? Ext
.getCmp('user_search').getValue() : '';
if (p.type == 1) {
if (!!(v[3]) && !!(v[3].netbios)) {
p.netbios = v[3].netbios;
p.domain = v[3].domain;
}
}

p.share_name = encodeURIComponent(FM.fileListStore.baseParams.path
+ "/"
+ WFM.gridPanel.getSelectionModel().getSelections()[0]
.get('filename'));
for (var i = 0, len = users.length; i < len; i++)
p['user' + i] = users[i];
for (var i = 0, len = groups.length; i < len; i++)
p['group' + i] = groups[i];
p.user_len = users.length;
p.group_len = groups.length;

ps = QNAP.QOS.fileExplorerTools.tool.getParamString(p);

return ps;
},
parseData : function(data) {
var result = [], existed = [], users = {}, groups = {}, i, len = data.length;

for (i = 0; i < len; i++) {
var d = data[i], item = [];
item.push((d.type == '2' ? 1 : 2), d.name);
item = item.concat(FM.acl.getPermissionToArray(d.mode));
if (d.type == 2)
users[d.name] = item;
else
groups[d.name] = item;
}

for (var u in users)
result.push(users[u]);

for (var g in groups)
result.push(groups[g]);

result.sort(FM.acl.sortfunc);
return result;
},
sortfunc : function(a, b) {
if (a[0] == b[0]) {
var n1 = a[1].toUpperCase();
var n2 = b[1].toUpperCase();
if (n1 == n2)
return 0;
else if (n1 < n2)
return -1;
else
return 1;
} else {
return -(parseInt(a[0]) - parseInt(b[0]));
}

},
makeGridColumnsSelectAll : function(grid) {
var grid_selector = '#' + grid.id;
},

disableGroup : function(val) {
function d(v) {
switch (v) {
case 0 :
break;
case 1 :
Ext.getCmp('acl_grid').disable();
Ext.getCmp('add-item').disable();
Ext.getCmp('del-item').disable();
break;
case 2 :
Ext.getCmp('composite-owner').disable();
Ext.getCmp('owner_edit').disable();
break;
case 3 :
Ext.getCmp('owner_protect').disable();
break;
case 4 :
Ext.getCmp('acl_recursive01').disable();
Ext.getCmp('acl_recursive02').disable();
break;
}
FM.acl.disableGroupItem.push(v);
}

if (/0/.test(val))
d(0);
if (/1/.test(val))
d(1);
if (/2/.test(val))
d(2);
if (/3/.test(val))
d(3);
if (/4/.test(val))
d(4);
if (/^all$/i.test(val))
FM.acl.disableGroup('01234');
},
getLatestData : function(grid) {
if (!grid)
grid = FM.acl.grid;
if (grid == undefined)
return [];

var data = [], selection = FM.acl.selection.getSelections();
var i, len, s = grid.getStore();
var attr = FM.acl.attributes;

data = selection;
s.data.each(function(r) {
data.push({
type : r.get('type'),
name : r.get('name'),
r : r.get([attr[0]]),
w : r.get([attr[1]]),
x : r.get([attr[2]])
});
});

var result = [];
for (i = 0, len = data.length; i < len; i++) {
var d = data[i], attr = FM.acl.attributes;
var item = [d.type, d.name];
for (var j = 0, l = attr.length; j < l; j++) {
item.push(d[attr[j]]);
}
result.push(item);
}
return result.sort();
}
};
},
showShareWin : function(shLkObj, shareGrid, fromTree,updateToSmarkLink) {
var FM = this;
var downloadTypeStore = new Ext.data.ArrayStore({
fields : ['display', 'value'],
data : [['Create Download Link', 'create_download_link'],
['Email Download Link', 'email_download_link']]
});

var i = 0, tmpValue = '', periodDayArray = [], hourArray = [], hourNo0Array = [], specificMinuteArray = [];

for (i = 0; i <= 7; i++) {
if (i < 10) {
tmpValue = '0' + i;
} else {
tmpValue = i;
}
periodDayArray.push([tmpValue, tmpValue]);
}

for (i = 0; i < 24; i++) {
if (i < 10) {
tmpValue = '0' + i;
} else {
tmpValue = i;
}
hourArray.push([tmpValue, tmpValue]);
}

for (i = 1; i < 24; i++) {
if (i < 10) {
tmpValue = '0' + i;
} else {
tmpValue = i;
}
hourNo0Array.push([tmpValue, tmpValue]);
}

var periodDayStore = new Ext.data.ArrayStore({
fields : ['display', 'value'],
data : periodDayArray
});

var periodHourStore = new Ext.data.ArrayStore({
fields : ['display', 'value'],
data : hourArray
});

var periodHourNo0Store = new Ext.data.ArrayStore({
fields : ['display', 'value'],
data : hourNo0Array
});

var specificHourStore = new Ext.data.ArrayStore({
fields : ['display', 'value'],
data : hourArray
});

for (i = 0; i < 60; i += 1) {
if (i < 10) {
tmpValue = '0' + i;
} else {
tmpValue = i;
}
specificMinuteArray.push([tmpValue, tmpValue]);
}

var specificMinuteStore = new Ext.data.ArrayStore({
fields : ['display', 'value'],
data : specificMinuteArray
});

var indentWidth = 20;
var fixSpaceIndent = function(n, s) {
return '<span style="margin-left:' + (indentWidth * n)
+ 'px"></span>' + s;
};

var enableValidDurationField = function(form, v) {
form.findField('periodDay').disable();
form.findField('periodHour').disable();
form.findField('specificDate').disable();
form.findField('specificHour').disable();
form.findField('specificMinute').disable();

switch (v) {
case 'period_of_time' :
form.findField('periodDay').enable();
form.findField('periodHour').enable();

break;
case 'specific_time' :
form.findField('specificDate').enable();
form.findField('specificHour').enable();
form.findField('specificMinute').enable();

break;
default :

}
form.findField('specificDate').validate();
};

var domainStore = new Ext.data.JsonStore({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'get_domain_ip_list'),
autoLoad : true,
root : 'domains',
fields : ['value', 'index'],
idProperty : 'value',
data : {
domains : [{
value : QNAP.QOS.config.serverHost
}]
},
listeners : {
beforeload:function(){
shareWinMask.show();
},
loadexception : function() {
var store = this;
var domains = [];
var json = store.reader.jsonData;
domainStore.domainData = store.reader.jsonData;
var ipMap = {};
if (!Ext.isEmpty(json.link_url)) {
ipMap[json.link_url] = 0;
}
if (!Ext.isEmpty(json.mycloudnas_hn)) {
ipMap[json.mycloudnas_hn] = 1;
}
if (!Ext.isEmpty(json.ddns_hn)) {
ipMap[json.ddns_hn] = 2;
}
if (!Ext.isEmpty(json.external_ip)) {
ipMap[json.external_ip] = 3;
}
if (!Ext.isEmpty(json.local_ip)) {
ipMap[json.local_ip] = 4;
}
if (!Ext.isEmpty(json.host_ip)) {
ipMap[json.host_ip] = 5;
}
if (!Ext.isEmpty(json.local_ip_list)) {
var ipArr = json.local_ip_list.split(',');
for (var i = 0; i < ipArr.length; i++) {
if(ipArr[i]!='')
ipMap[ipArr[i]] = 6 + i;
}
}
Ext.iterate(ipMap, function(key, value) {
domains.push({
value : key,
index : value
});
});
store.loadData({
domains : domains
});
store.sort('index', 'ASC');
if(FM.sysSetting.cloud_link_enable!=1){//0 : installed, but does not enable; 2 : support model but not installed
settingsPanel.getComponent('smarkLink').hide();
}else{
}
if(FM.sysSetting.myqnapcloud_enable!=1){
sharePanel.getForm().items.get('TransmissionType').store.data.removeAt(0);
}
shareWinMask.hide();
}
}
});
var html = '', params = {}, i = 0, FM = this, contentText = '', mailLinks = '',
link_name='',publishUrl='';//,onePage='&p=1' onePage:p=1：publish的時候若是單一檔案，也要出現page不直接下載
var thumbPath,thumbFile,thumbSsid;

var dis_upload = false;
var isCloudLink = false;
if (shLkObj) {// CREATE
isCloudLink=!Ext.isEmpty(QNAP.QOS.user.useSmarkLink)
&& QNAP.QOS.user.useSmarkLink.toString()=='true'
&& FM.sysSetting.cloud_link_enable==1;
var linksLen = shLkObj.links.length;
thumbPath=shLkObj.links[0].filename.substring(0,shLkObj.links[0].filename.lastIndexOf('/'));
thumbFile=shLkObj.links[0].filename.split('/').pop();
thumbSsid=shLkObj.links[0].ssid;
html = _S._SFE_LANG_SHARELINK_MSG_1 + "<br />";
var selections = FM.gridPanel.getSelectionModel().getSelections();
params.file_total = 1;
link_name=shLkObj.link_name;
for (var i = 0; i < linksLen; i++) {
html += String.format('<br />{0}. {1}<br/>{2}<br/>', i + 1,
shLkObj.links[i].filename.replace(/.*\//, ''),
shLkObj.links[i].link_url);
contentText = '<a target="_blank" href="'+shLkObj.links[i].link_url+'">'+shLkObj.links[i].link_url+'</a>';
mailLinks = mailLinks
+ '\n'
+ (i + 1)
+ '. '
+ encodeURIComponent(shLkObj.links[i].filename + '\r\n')
+ encodeURIComponent(shLkObj.links[i].link_url
+ '\r\n\r\n');
}
contentText=shLkObj.protocol+'://'+shLkObj.host+':'+shLkObj.port+'/share.cgi?ssid='+shLkObj.ssid;
FM.mailLinks='1.'+shLkObj.links[0].filename.split('/').pop()+ '\r\n'+contentText;
FM.copyLinks=contentText;
contentText='<a target="_blank" href="'+contentText+'">'+contentText+'</a>'
publishUrl=shLkObj.protocol+'://'+shLkObj.host+':'+shLkObj.port+'/share.cgi?ssid='+shLkObj.ssid;


params.ssids=shLkObj.ssid;
var selections = FM.gridPanel.getSelectionModel().getSelections();

if(fromTree){
}else{
if(linksLen>1 || selections[0].get('isfolder') == 0){
dis_upload = true;
}
}
}
var chkSSL = location.protocol=='https:', chkAllowUp = false, expire_time = 0, access_code = '', allowTrans=false;
var linksLen=0,domain_ip;

if (shareGrid) {//edit share link
var selections = FM.shareGrid.getSelectionModel().getSelections();
linksLen = selections.length;
thumbPath=selections[0].get('filename').substring(0,selections[0].get('filename').lastIndexOf('/'));
thumbFile=selections[0].get('filename').split('/').pop();
thumbSsid=selections[0].get('ssid');
var link=selections[0].get('download_link');
var link = document.createElement('a');
link.href = selections[0].get('download_link');
domain_ip=link.hostname;
html = _S._SFE_LANG_SHARELINK_MSG_1 + "<br />";
params.ssids = [];
params.file_total = linksLen;
var i = 0;
chkSSL = (selections[0].get('download_link').indexOf('https') == 0);
if (selections[0].get('isfolder') == 0) {
}
if(selections.length==1){
var optionBin=QNAP.QOS.fileExplorerTools.tool.toBin(selections[0].get('option'));
chkAllowUp=optionBin.charAt(1)=='1';
var allowTrans=optionBin.charAt(0)=='1';
}

expire_time = selections[0].get('expire_time');
access_code = selections[0].get('access_code');
if(linksLen==1 && !Ext.isEmpty(access_code)){
params.include_access_code=true;
params.access_code = access_code;
}
link_name = selections[0].get('link_name');

isCloudLink=true;
Ext.each(selections, function(record) {
if (record.get('isfolder') == 0) {// 有任何一個是檔案的話就不允許上傳。
dis_upload = true;
}
if ((record.get('download_link').indexOf('https') == 0) != (selections[0]
.get('download_link').indexOf('https') == 0)) {
chkSSL = false;
}
if (record.get('option') != selections[0].get('option')) {
chkAllowUp = false;
}
if (record.get('expire_time') != selections[0]
.get('expire_time')) {
expire_time = 0;
}
if (record.get('access_code') != selections[0]
.get('access_code')) {
access_code = '';
}
if (record.get('ht') != 11) {
isCloudLink = false;
}

html += String.format('<br />{0}', record.get('download_link'));
params.ssids.push(record.get('ssid'));
publishUrl=record.get('download_link');
if(i<3){
contentText = contentText
+'<a target="_blank" href="'+record.get('download_link')+'">'
+ record.get('download_link')+'</a><br>' + '\n\n';
}
mailLinks = mailLinks
+ '\n'
+ encodeURIComponent(record.get('download_link')
+ '\r\n\r\n');
i++;
});
if(i>3){
contentText = contentText +'...'
}
}
var sharePanel;
if(!sharePanel){
sharePanel = new Ext.form.FormPanel({
title : _S._SFE_LANG_COMMON_SEND,
itemId:'sendMailPanel',
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_SEND',
border : false,
autoHeight : true,
autoWidth : true,
autoScroll : true,
bodyStyle : {
padding : '8px 60px 0px 60px',
'overflow-x' : 'hidden',
'overflow-y' : 'auto'
},
shadow : false,
defaults : {
itemCls : 'bigGap',
labelStyle: 'width:100%',
},
items : [{
xtype : 'textfield',
itemId : 'mailaddres',
fieldLabel : fixSpaceIndent(1, _S._SFE_LANG_SHARELINK_TO_COL),
width : 460,
itemCls : 'shareLink-popup-itemCls',
blankText : _S._SFE_LANG_SHARELINK_MAIL_ERROR_3,
qInternational : true,
qInternationalFn : function(cmp) {
cmp.label.update(fixSpaceIndent(1,
_S._SFE_LANG_SHARELINK_TO_COL));
cmp.blankText = _S._SFE_LANG_SHARELINK_MAIL_ERROR_3;
},
emptyText : 'user1@email.com, user2@email.com',
validator : function(value, field) {
value = value.replace(/\s/g, '');
var emails = value.split(/,|;/), emailNum = emails.length, i = 0;
var re = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
if(value)
for (i = 0; i < emailNum; i++) {
if (!re.test(emails[i])) {
win.buttons[1].disable();
return _S._SFE_LANG_SHARELINK_MAIL_ERROR_3;
}
}
if (emailNum > 5) {
win.buttons[1].disable();
return false;
}
if(value)
win.buttons[1].enable();
return true;
}
}, {
xtype : 'textfield',
itemId : 'subject',
itemCls : 'shareLink-popup-itemCls',
fieldLabel : fixSpaceIndent(1, _S._SFE_LANG_MAIL_SUBJECT),
qInternational : true,
qInternationalFn : function(cmp) {
cmp.label.update(fixSpaceIndent(1,
_S._SFE_LANG_MAIL_SUBJECT));
if (!cmp.isDirty()) {
cmp.setValue(_S._SFE_LANG_SHARELINK_MAIL_TITLE);
cmp.originalValue = _S._SFE_LANG_SHARELINK_MAIL_TITLE;
}
},
value : _S._SFE_LANG_SHARELINK_MAIL_TITLE,
width : 460,
maxLength : 200,
allowBlank : false
}, {
xtype : 'textarea',
width : 460,
height:45,
itemId : 'messageText',
itemCls : 'shareLink-popup-itemCls',
value : _S._SFE_LANG_SHARELINK_MAIL_CONTENT_1,
fieldLabel : fixSpaceIndent(1, _S._SFE_LANG_COMMON_MESSAGE),
qInternational : true,
qInternationalFn : function(cmp) {
cmp.label.update(fixSpaceIndent(1,
_S._SFE_LANG_COMMON_MESSAGE));
}
},{
xtype : 'textfield',
itemId : 'link_name',
itemCls : 'shareLink-popup-itemCls',
fieldLabel : fixSpaceIndent(1, _S._SFE_LANG_SHARELINK_LINK_NAME),
qInternational : true,
width : 460,
maxLength : 200,
value:link_name,
readOnly:linksLen>1,
allowBlank : true,
listeners : {
blur:function(cmp){
settingsPanel.getComponent('link_name').setValue(cmp.getValue());
}
}
},{
xtype : 'displayfield',
labelStyle : 'margin-top: 1px;float:left;width:auto',
preventMark:false,
fieldLabel : fixSpaceIndent(1, _S._SFE_LANG_COMMON_LINKS),
value : contentText,
itemId : 'contentText',
itemCls : 'shareLink-popup-itemCls',
style:'-webkit-user-select: auto;-moz-user-select: auto;-ms-user-select: auto;-user-select: auto;position: relative;top: 3px;padding-left: 66px;',
qInternational : true,
qInternationalFn : function(cmp) {
cmp.label.update(fixSpaceIndent(1,
_S._SFE_LANG_COMMON_LINKS));
},
listeners:{
afterrender:function(cmp){
var bodyOnselEvent=document.body.onselectstart;
cmp.el.dom.onmousedown=function(){
document.body.onselectstart=null;
}
cmp.el.dom.onmouseup=function(){
document.body.onselectstart=bodyOnselEvent;
}
cmp.el.dom.onmouseleave=function(){
document.body.onselectstart=bodyOnselEvent;
}

}
}

}, {
xtype : 'copybtn',
itemId : 'copyLinkBtn',
tooltip : '_SFE_LANG_SHARELINK_COPY',
icon : QNAP.QOS.fileExplorerTools.config.imgPath + 'funcBtn/moreActionIcons.png',
iconCls : 'copyLinkBtn-iconCls',
cls : 'copyLinkBtn-cls',
hidden : !DetectFlashVer(9),
width:26,
overCls : ['copy-share-btn-over', 'x-btn-over'],
flexCallBack : function() {
var clipboardHint = win.buttons[0];
clipboardHint.show();
clipboardHint.el.dom.style.opacity = 1;
var i = 0;
var opacityTask = new Ext.util.DelayedTask(function() {
if (i < 20) {
i++;
clipboardHint.el.dom.style.opacity = clipboardHint.el.dom.style.opacity- 0.05;
opacityTask.delay(50);
}
});
opacityTask.delay(1000);
var task = new Ext.util.DelayedTask(function() {
clipboardHint.hide();
});
task.delay(2000);

},
listeners : {
afterrender : function(cmp) {
cmp.el.select('div.x-btn').setSize(cmp.getWidth() - 3,
cmp.getHeight() - 3);
var task = new Ext.util.DelayedTask(function() {
var flexDiv = Ext.get(cmp.swfId + '-div');
flexDiv.dom.tabIndex = 0;
});
task.delay(100);
},
mousemove : function(cmp) {
cmp.data = FM.copyLinks;
}
}
},
new Ext.Container({
itemId:'sendArea-itemId',
cls:'sendArea-cls',
height : '30px',
hideMode : 'visibility',
style : 'padding-top: 7px;with:auto;',
layout : {
type : 'hbox',
pack : 'start',
align : 'stretch'
},
items :  [
{
xtype : 'combo',
width : 370,
itemId : 'TransmissionType',
triggerAction : 'all',
lazyRender : true,
editable : false,
mode : 'local',
value : 1,
qInternational : true,
qInternationalFn : function(cmp) {
var value = cmp.getValue();
cmp.getStore().each(function(r) {
r.set('display', _S[r.get('qInternationalKey')]);
});
cmp.setValue(value);
},
store : new Ext.data.ArrayStore({
fields : ['value', 'display', 'qInternationalKey'],
data : [
[3, _S._SFE_LANG_SEND_FROM_MYQNAPCLOUD, '_SFE_LANG_SEND_FROM_MYQNAPCLOUD'],
[1, _S._SFE_LANG_USE_NAS_TO_MAIL, '_SFE_LANG_USE_NAS_TO_MAIL'],
[2, _S._SFE_LANG_USE_PC_TO_MAIL, '_SFE_LANG_USE_PC_TO_MAIL']
]
}),
valueField : 'value',
displayField : 'display',
listeners:{
afterrender:function(cmp){
shareWinMask = new Ext.LoadMask(
shareTab.id, {
msg : (_S._SFE_LANG_COMMON_LOADING_MSG)
});
domainStore.reload();
}
}
}
]
})
]
});
}//if(!sharePanel)的

var checkForm = function(form) {
var accessCodeFiled = sharePanel.find('itemId', 'accessCodeFiled')[0];
accessCodeFiled.validate();
if (form.isValid()) {
return true;
}
return false;
};
var publishPanel = new Ext.form.FormPanel({
itemId:'pubPanel',
cls:'pubPanel-cls',
title : _S._SFE_LANG_COMMON_PUBLISH,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PUBLISH',
border : false,
autoHeight : true,
autoWidth : true,
bodyStyle : {
padding : '8px 60px 0px 60px',
'overflow-x' : 'hidden',
'overflow-y' : 'auto'
},
shadow : false,
defaults : {
itemCls : 'bigGap'
},
items : [{
xtype : 'textfield',
itemId : 'subject',
itemCls : 'shareLink-popup-itemCls',
fieldLabel : fixSpaceIndent(1, _S._SFE_LANG_MAIL_SUBJECT),
qInternational : true,
qInternationalFn : function(cmp) {
cmp.label.update(fixSpaceIndent(1,
_S._SFE_LANG_MAIL_SUBJECT));
if (!cmp.isDirty()) {
cmp.setValue(_S._SFE_LANG_SHARELINK_MAIL_TITLE);
cmp.originalValue = _S._SFE_LANG_SHARELINK_MAIL_TITLE;
}
},
value : _S._SFE_LANG_SHARELINK_MAIL_TITLE,
width : 440,
maxLength : 200,
allowBlank : false
}, {
xtype : 'textarea',
width : 440,
height:170,
itemId : 'publishText',
itemCls : 'shareLink-popup-itemCls',
value : _S._SFE_LANG_SHARELINK_MAIL_CONTENT_1,
fieldLabel : fixSpaceIndent(1, _S._SFE_LANG_COMMON_MESSAGE),
qInternational : true,
qInternationalFn : function(cmp) {
cmp.label.update(fixSpaceIndent(1,
_S._SFE_LANG_COMMON_MESSAGE));
}
},
{
xtype : 'displayfield',
hideLabel : true,
border : false,
qInternational : true,
qInternationalFn : function(cmp) {
cmp
.update(_S._SFE_LANG_MSG_PUBLISH_TO+' : ');
},
html : _S._SFE_LANG_MSG_PUBLISH_TO+' : '
}],
bbar:[{
xtype : 'tbspacer',
width : 52
},
{
icon : QNAP.QOS.fileExplorerTools.config.imgPath+'sharePage/publish.png',
iconCls:'facebook-iconCls',
tooltip:'FB',
handler:function(){
var dataObj={
title : publishPanel.getComponent('subject').getValue(),
text : publishPanel.getComponent('publishText').getValue(),
url : publishUrl
};
var popURL = QNAP.QOS.fileExplorerTools.tool.getShareURL('facebook', dataObj);
var whj = QNAP.QOS.fileExplorerTools.tool.cmWindowWH['facebook'];
var pubObj={popURL:popURL,whj:whj,dataObj:dataObj};
QNAP.QOS.fileExplorerAction.updateShareLink.call(FM, win, settingsPanel, params, false, pubObj);
}
},
{iconCls:'twitter-iconCls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath+'sharePage/publish.png',
tooltip:'Twitter',
handler:function(){
var dataObj={
title : publishPanel.getComponent('subject').getValue(),
text : publishPanel.getComponent('publishText').getValue(),
url : publishUrl
};
var popURL = QNAP.QOS.fileExplorerTools.tool.getShareURL('twitter', dataObj);
var whj = QNAP.QOS.fileExplorerTools.tool.cmWindowWH['twitter'];
var pubObj={popURL:popURL,whj:whj,dataObj:dataObj};
QNAP.QOS.fileExplorerAction.updateShareLink.call(FM, win, settingsPanel, params, false, pubObj);
}},
{
iconCls:'weibo-iconCls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath+'sharePage/publish.png',
tooltip:'_SFE_LANG_TOOLTIP_WEIBO',
handler:function(){
var dataObj={
title : publishPanel.getComponent('subject').getValue(),
text : publishPanel.getComponent('publishText').getValue(),
url : publishUrl
};
var popURL = QNAP.QOS.fileExplorerTools.tool.getShareURL('weibo',dataObj);
var whj = QNAP.QOS.fileExplorerTools.tool.cmWindowWH['weibo'];
var pubObj={popURL:popURL,whj:whj,dataObj:dataObj};
QNAP.QOS.fileExplorerAction.updateShareLink.call(FM, win, settingsPanel, params, false, pubObj);
}},
{
iconCls:'googleplus-iconCls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath+'sharePage/publish.png',
tooltip:'Google+',
handler:function(){
var dataObj={
title : publishPanel.getComponent('subject').getValue(),
text : publishPanel.getComponent('publishText').getValue(),
url : publishUrl
};
var popURL = QNAP.QOS.fileExplorerTools.tool.getShareURL('googleplus', dataObj);
var whj = QNAP.QOS.fileExplorerTools.tool.cmWindowWH['googleplus'];
var pubObj={popURL:popURL,whj:whj,dataObj:dataObj};
QNAP.QOS.fileExplorerAction.updateShareLink.call(FM, win, settingsPanel, params, false, pubObj);
}},
{
iconCls:'plurk-iconCls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath+'sharePage/publish.png',
tooltip:'_SFE_LANG_TOOLTIP_PLURK',
handler:function(){
var dataObj={
title : publishPanel.getComponent('subject').getValue(),
text : publishPanel.getComponent('publishText').getValue(),
url : publishUrl
};
var popURL = QNAP.QOS.fileExplorerTools.tool.getShareURL('plurk', dataObj);
var whj = QNAP.QOS.fileExplorerTools.tool.cmWindowWH['plurk'];
var pubObj={popURL:popURL,whj:whj,dataObj:dataObj};
QNAP.QOS.fileExplorerAction.updateShareLink.call(FM, win, settingsPanel, params, false, pubObj);
}},
{
iconCls:'renren-iconCls',
icon : QNAP.QOS.fileExplorerTools.config.imgPath+'sharePage/publish.png',
tooltip:'_SFE_LANG_TOOLTIP_RENREN',
handler:function(){
var dataObj={
title : publishPanel.getComponent('subject').getValue(),
text : publishPanel.getComponent('publishText').getValue(),
url : publishUrl
};
var popURL = QNAP.QOS.fileExplorerTools.tool.getShareURL('renren', dataObj);
var whj = QNAP.QOS.fileExplorerTools.tool.cmWindowWH['renren'];
var pubObj={popURL:popURL,whj:whj,dataObj:dataObj};
QNAP.QOS.fileExplorerAction.updateShareLink.call(FM, win, settingsPanel, params, false, pubObj);
}}
]
});
var smarkLink;
var settingsPanel = new Ext.form.FormPanel({
itemId : 'settingsPanel',
title : _S._SFE_LANG_COMMON_SETTINGS,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_SETTINGS',
border : false,
autoHeight : true,
autoWidth : true,
bodyStyle : {
padding : '8px 60px 0px 60px',
'overflow-x' : 'hidden',
'overflow-y' : 'auto'
},
shadow : false,
defaults : {
itemCls : 'bigGap'
},
plugins : {
dirty : false,
onsubmit : false,
init : function(p) {
this.parent = p;
},
checkMailStatus : function() {

},
showAdvanced : function(show) {
var thispanel = this.parent;

var includeAccCode = thispanel
.getComponent('includeAccCode');
includeAccCode.setVisible(!show);
},
checkAccessCode : function() {
var p = this.parent;
var accessCodeFiled = p.find('itemId', 'accessCodeFiled')[0];
var originalAccessCode = p.find('itemId','originalAccessCode')[0];
var value = accessCodeFiled.getValue();
var includeAccCode = p.getComponent('includeAccCode');
if (value == originalAccessCode.value) {
includeAccCode.originalValue = includeAccCode.getValue();
return;
}

if (value.length == 0) {
includeAccCode.setValue(false);
includeAccCode.setDisabled(true);
} else {
includeAccCode.setDisabled(false);
if (this.onsubmit == false) {
includeAccCode.setValue(true);
}
}
},
switchURL : function(url) {
var p = this.parent;
p.getComponent('urlField').innerCt.getComponent('urlLabel')
.setText(url);
},
editForm : function() {
var p = this.parent;
var action = p.getComponent('action').getValue();
}
},
items : [{
xtype : 'textfield',
itemId : 'link_name',
value:link_name,
itemCls : 'shareLink-popup-itemCls',
labelStyle: 'width:100%',
fieldLabel : fixSpaceIndent(1, _S._SFE_LANG_SHARELINK_LINK_NAME),
qInternational : true,
width : 460,
maxLength : 200,
allowBlank : false,
readOnly:linksLen>1,
enableKeyEvents : true,
listeners : {
blur:function(cmp){
sharePanel.getComponent('link_name').setValue(cmp.getValue());
}
}
}, {
xtype : 'combo',
name : 'domainList',
itemId : 'domainList',
valueField : 'value',
displayField : 'value',
triggerAction : 'all',
editable : false,
fieldLabel : _S._SFE_LANG_SHARELINK_LINK_LABEL,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_LINK_LABEL',
labelStyle : 'width:35%',
labelSeparator : '',
emptyText : '-',
lazyInit : false,
allowBlank : false,
enableKeyEvents : false,
store : domainStore,
width : 250,
value : QNAP.QOS.config.serverHost,
listeners : {
afterrender : function(cmp) {
this.store.un('exception', this.collapse, this);
cmp.initQuery();
if(domain_ip){
cmp.originalValue=domain_ip;
cmp.setValue(domain_ip);
}
},
select : function() {
settingsPanel.plugins.editForm();
},
keypress : function() {
settingsPanel.plugins.editForm();
},
change : function(combo, newValue, oldValue) {
var oldText = sharePanel.getComponent('contentText')
.getValue();
var newText = QNAP.QOS.fileExplorerTools.tool
.replaceAll(oldText, oldValue, newValue);
publishUrl = QNAP.QOS.fileExplorerTools.tool
.replaceAll(publishUrl, oldValue, newValue);
sharePanel.getComponent('contentText')
.setValue(newText);
settingsPanel.plugins.editForm();
}
}
}, {
xtype : 'checkbox',
itemId : 'smarkLink',
name : 'smarkLink',
hideLabel : true,
boxLabel : _S._SFE_LANG_SMART_LINK_SHARE,
qInternational : true,
qInternationalKey : '_SFE_LANG_SMART_LINK_SHARE',
linkValue:'',
checked : isCloudLink,
listeners : {
afterrender : function(cmp) {
if(isCloudLink){
settingsPanel.getComponent('domainList').disable();
}else{
settingsPanel.getComponent('domainList').enable();
}
},
check : function( checkBox, checked ) {
if(checked){
settingsPanel.getComponent('domainList').disable();
}else{
settingsPanel.getComponent('domainList').enable();
}
os.saveConfig('useSmarkLink', checked);
QNAP.QOS.user.useSmarkLink=checked;
}
}
}, {
xtype : 'checkbox',
itemId : 'allowUpload',
name : 'allowUpload',
hideLabel : true,
boxLabel : _S._SFE_LANG_SHARE_ALLOW_UPLOAD,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARE_ALLOW_UPLOAD',
listeners : {
afterrender : function(cmp) {
settingsPanel.getComponent('allowUpload').setValue(chkAllowUp);
settingsPanel.getComponent('allowUpload').setDisabled(dis_upload);
if(!dis_upload && QNAP.QOS.user.isAdminGroup){
var params={};
params.file_total=1;
params.ssids=thumbSsid;
QNAP.QOS.fileExplorerTools.tool.ajax.call(FM, {
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'check_upload_permission'),
handler : {
success : function(RS, RQ) {
settingsPanel.getComponent('allowUpload').setDisabled(RS.status!=1);
settingsPanel.getComponent('allowUpload').setVisible(RS.status==1);
},
failure : function(RS, RQ) {
}
},
params : params
});
}else{
settingsPanel.getComponent('allowUpload').hide();
}
}
}
}, {
xtype : 'checkbox',
itemId : 'sslLink',
name : 'sslLink',
hideLabel : true,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHOW_SSL_IN_URL',
boxLabel : _S._SFE_LANG_SHOW_SSL_IN_URL,
listeners : {
check : function() {
var domainData=domainStore.domainData;
if(!domainData){
return;
}
var newProtocol,newPort,domainIPName;
var domainIP=settingsPanel.getComponent('domainList').getValue();
Ext.iterate(domainData, function(key, value) {
if(domainIP==value){
domainIPName=key;
}
});
if (this.getValue()) {
newProtocol='https:';
if(domainData)
if(domainIPName=='external_ip'){
newPort=domainData.extSslPort;
}else if(domainIPName=='ddns_hn'){
newPort=domainData.extSslPort;
}else if(domainIPName=='local_ip'){
newPort=domainData.sslPort;
}else if(domainIPName=='mycloudnas_hn'){
newPort=domainData.sslPort;
}else{
newPort=domainData.sslPort;
}
}else{
newProtocol='http:';
if(domainData)
if(domainIPName=='external_ip'){
newPort=domainData.extPort;
}else if(domainIPName=='ddns_hn'){
newPort=domainData.extPort;
}else if(domainIPName=='local_ip'){
newPort=domainData.port;
}else if(domainIPName=='mycloudnas_hn'){
newPort=domainData.port;
}else{
newPort=domainData.port;
}
}
var UrlObj={};
UrlObj.protocol=newProtocol;
UrlObj.port=newPort;
UrlObj.hostname=domainIP;
var contentText='';
if(shLkObj){
shLkObj.links[0].link_url
var newHref=QNAP.QOS.fileExplorerTools.tool.replaceHref(shLkObj.links[0].link_url,UrlObj);
contentText =contentText+ '<a target="_blank" href="'+newHref+'">'+newHref+'</a><br>';
}else{
var selections = FM.shareGrid.getSelectionModel().getSelections();
Ext.each(selections,function(item){
var newHref=QNAP.QOS.fileExplorerTools.tool.replaceHref(item.get('download_link'),UrlObj);
contentText =contentText+ '<a target="_blank" href="'+newHref+'">'+newHref+'</a><br>';
});
}
sharePanel.getComponent('contentText').setValue(contentText);
}
}
}, {
xtype : 'checkbox',
itemId : 'allowTrans',
name : 'allowTrans',
hideLabel : true,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARE_SETTING_ALLOW_TRANS',
boxLabel : _S._SFE_LANG_SHARE_SETTING_ALLOW_TRANS,
hidden : !QNAP.QOS.user.isAdminGroup || !FM.RTT,
checked : allowTrans,
listeners : {
check : function() {
}
}
}, {
xtype : 'radiogroup',
itemId : 'changeSSLLink',
style : 'margin-left: 20px;',
hideLabel : true,
vertical : true,
columns : 1,
name : 'changeSSLLink',
defaults : {
width : 30
},
items : [{
hidden : true,
width : 80,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_DISABLE',
boxLabel : _S._SFE_LANG_SHARELINK_DISABLE
}],
listeners : {
change : function() {
settingsPanel.plugins.editForm();
}
}
},{
html : _S._SFE_LANG_SHARELINK_EXPIRATION,
style : 'margin-bottom: 8px;margin-top: 12px;',
qInternational : true,
qInternationalFn : function(cmp) {
cmp.update(_S._SFE_LANG_SHARELINK_EXPIRATION);
},
baseCls : 'x-plain bigGap'
}, new Ext.Container({
itemId : 'expiration-id',
height : '78px',
hideMode : 'visibility',
layout : {
type : 'vbox',
pack : 'start',
align : 'stretch'
},
listeners : {
afterrender:function(cmp){
cmp.doLayout();
}
},
items : [ new Ext.Container({
height: 26,
layout : {
type : 'hbox',
pack : 'start',
align : 'stretch'
},
listeners : {
afterrender:function(cmp){
cmp.doLayout();
}
},
items : [{
xtype : 'radio',
name : 'valid_duration',
itemId : 'period_of_time',
inputValue : 'period_of_time',
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_PERIOD_RADIO',
boxLabel : _S._SFE_LANG_SHARELINK_PERIOD_RADIO,
hideLabel : true,
listeners : {
check : function(radio) {
settingsPanel.plugins.editForm();
if (radio.checked) {
enableValidDurationField(
settingsPanel.getForm(),
radio.inputValue);
}
},
afterrender : function(radio) {
if (expire_time != 0) {
radio.originalValue = 'specific_time';
} else {
radio.originalValue = 'forever';
}
}
}
},{
xtype : 'combo',
itemId : 'periodDay',
name : 'periodDay',
width : 65,
hideLabel : true,
store : periodDayStore,
value : '07',
editable : false,
displayField : 'display',
valueField : 'value',
mode : 'local',
allowBlank : false,
enabled : false,
triggerAction : 'all',
style : 'position: relative;left: 15px;',
listeners : {
select : function(f, nv, ov) {
settingsPanel.plugins.editForm();
var form = settingsPanel.getForm(), hourField = form
.findField('periodHour'), hour = hourField
.getValue();

if (f.getValue() == '00') {
hourField
.bindStore(periodHourNo0Store);

if (hour != '00') {
hourField.setValue(hour);
} else {
hourField.setValue('01');
}
} else {
hourField
.bindStore(periodHourStore);
hourField.setValue(hour);
}
}
}
}, {
xtype : 'displayfield',
hideLabel : true,
border : false,
style : 'text-align:center;margin-left: 5px;',
qInternational : true,
qInternationalFn : function(cmp) {
cmp
.update(_S._SFE_LANG_SHARELINK_TIME_DAY);
},
html : _S._SFE_LANG_SHARELINK_TIME_DAY
}, {
xtype : 'displayfield',
width : 10,
hideLabel : true,
border : false,
style : 'text-align:center;',
html : '&nbsp;&nbsp;'
}, {
xtype : 'combo',
itemId : 'periodHour',
name : 'periodHour',
width : 50,
hideLabel : true,
store : periodHourNo0Store,
value : '00',
editable : false,
displayField : 'display',
valueField : 'value',
mode : 'local',
allowBlank : false,
enabled : false,
triggerAction : 'all',
listeners : {
select : function() {
settingsPanel.plugins.editForm();
}
}
}, {
xtype : 'displayfield',
hideLabel : true,
border : false,
style : 'text-align:left;margin-left: 5px;',
qInternational : true,
qInternationalFn : function(cmp) {
cmp.update(_S._SFE_LANG_SHARELINK_TIME_HOUR);
},
html : _S._SFE_LANG_SHARELINK_TIME_HOUR,
flex :1
} ]
}), new Ext.Container({
height: 26,
hideMode : 'visibility',
layout : {
type : 'hbox',
pack : 'start',
align : 'stretch'
},
listeners : {
afterrender:function(cmp){
cmp.doLayout();
}
},
items : [ {
xtype : 'radio',
name : 'valid_duration',
itemId : 'specific_time',
ctCls : 'specific_time-cls',
inputValue : 'specific_time',
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_SPECIFIC_RADIO',
boxLabel : _S._SFE_LANG_SHARELINK_SPECIFIC_RADIO,
hideLabel : true,
labelStyle : 'with:auto',
listeners : {
check : function(radio) {
settingsPanel.plugins.editForm();
if (radio.checked) {
enableValidDurationField(
settingsPanel.getForm(),
radio.inputValue);
}
},
afterrender : function(radio) {
if (expire_time != 0) {
radio.originalValue = 'specific_time';
} else {
radio.originalValue = 'forever';
}
}
}
},{
xtype : 'datefield',
itemId : 'specificDate',
name : 'specificDate',
width : 115,
editable : false,
showToday : false,
hideLabel : true,
format : 'Y/m/d',
allowBlank : false,
value : new Date(),
style : 'position: relative;left: 15px;',
validator : function() {
settingsPanel.plugins.editForm();
if (typeof this.systemTime !== 'undefined') {

var filedTime = new Date(this
.getValue())

filedTime.setHours(sharePanel
.getForm()
.findField('specificHour')
.getValue());
filedTime
.setMinutes(sharePanel
.getForm()
.findField('specificMinute')
.getValue());
filedTime = filedTime.getTime()
/ 1000;

if (filedTime <= this.systemTime) {
return _S._SFE_LANG_SHARELINK_MSG_5;
} else {
return true;
}
}
}
}, {
xtype : 'displayfield',
width : 10,
hideLabel : true,
border : false,
html : '&nbsp;'
}, {
xtype : 'combo',
itemId : 'specificHour',
name : 'specificHour',
width : 50,
hideLabel : true,
store : specificHourStore,
value : '23',
editable : false,
displayField : 'display',
valueField : 'value',
mode : 'local',
allowBlank : false,
enabled : false,
triggerAction : 'all',
listeners : {
select : function() {
settingsPanel.plugins.editForm();
}
}
}, {
xtype : 'displayfield',
width : 10,
hideLabel : true,
border : false,
style : 'text-align:center;',
html : ':'
}, {
xtype : 'combo',
itemId : 'specificMinute',
name : 'specificMinute',
width : 50,
hideLabel : true,
store : specificMinuteStore,
value : '59',
editable : false,
displayField : 'display',
valueField : 'value',
mode : 'local',
allowBlank : false,
enabled : false,
triggerAction : 'all',
flex : 1,
listeners : {
select : function() {
settingsPanel.plugins.editForm();
}
}
}, {
xtype : "displayfield",
width : 10,
hideLabel : true,
border : false
} ]
}), {
xtype : 'radio',
name : 'valid_duration',
itemId : 'forever',
inputValue : 'forever',
value : 'forever',
qValue : 'forever',
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_FOREVER_RADIO',
boxLabel : _S._SFE_LANG_SHARELINK_FOREVER_RADIO,
hideLabel : true,
listeners : {
check : function(radio) {
settingsPanel.plugins.editForm();
if (radio.checked) {
enableValidDurationField(
settingsPanel.getForm(),
radio.inputValue);
}
},
afterrender : function(radio) {
if (expire_time != 0) {
radio.originalValue = 'specific_time';
} else {
radio.originalValue = 'forever';
}
}
}
}]
}), {
itemId : 'passwordArea-id',
baseCls : 'x-plain bigGap',
layout : 'hbox',
hideLabel : true,
fieldLabel : _S._SFE_LANG_SHARELINK_LINK_LABEL,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_LINK_LABEL',
items : [{
xtype : 'displayfield',
style : 'font-size:12px;',
hideLabel : true,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_ACCECC_CODE_LABEL',
value : _S._SFE_LANG_SHARELINK_ACCECC_CODE_LABEL
}, {
xtype : 'textfield',
itemId : 'accessCodeFiled',
name : 'accessCodeFiled',
keepStr : _S._SFE_LANG_SHARELINK_USE_ORIGINAL,
mode : 'local',
style : 'position: relative;left: 15px;',
store : new Ext.data.ArrayStore({
fields : ['value', 'type'],
data : []
}),
valueField : 'value',
displayField : 'value',
maskRe : /[a-zA-Z0-9]+/,
maxLength : 16,
width : 136,
enableKeyEvents : true,
validator : function(value) {
var cmp = this;
if (!Ext.isEmpty(cmp.maskRe)) {
value = value.replace(/[\W_]/g, '');
cmp.setRawValue(value);
cmp.value = value;
}
if (value == '') {
cmp.changeType = 'clear';
} else if (value == cmp.keepStr) {
cmp.changeType = 'keep';
} else {
cmp.changeType = 'new';
}
settingsPanel.plugins.editForm();
cmp.ownerCt.ownerCt.plugins.checkAccessCode();
return true;
},
listeners : {
afterrender : function(cmp) {
if(access_code=='----'){
cmp.originalValue='';
cmp.setValue('');
}else{
cmp.originalValue=access_code;
}
},
keydown : function(cmp, e) {
var value = cmp.getRawValue();

var mix = cmp.getStore().query('value', value, 0,
false, true);
if (mix.getCount() > 0) {
var type = mix.itemAt(0).get('type');
if (type == 'clear') {
cmp.value = '';
cmp.setValue('');
cmp.maskRe = /[a-zA-Z0-9]+/;
}
}
}
}
}, {
xtype : 'button',
itemId : 'accessCodeBtn',
style : "margin-left: 15px;",
text : _S._SFE_LANG_SHARELINK_RANDOM,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_RANDOM',
listeners : {
click : function(cmp) {
var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
var string_length = 8;
var randomstring = '';
for (var i = 0; i < string_length; i++) {
var rnum = Math.floor(Math.random()
* chars.length);
randomstring += chars.substring(rnum, rnum + 1);
}
var accessCodeFiled = settingsPanel.find('itemId',
'accessCodeFiled')[0];
accessCodeFiled.setValue(randomstring);
accessCodeFiled.changeType = 'new';

var includeAccCode = settingsPanel
.getComponent('includeAccCode');
includeAccCode.setValue(true);
}
}
}]
}, {
xtype : 'checkbox',
itemId : 'includeAccCode',
name : 'includeAccCode',
itemCls : 'bigGap2',
boxLabel : _S._SFE_LANG_MSG_INCLUDE_PWD,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_INCLUDE_PWD',
hideLabel : true
}, {
xtype : 'tbspacer',
height : 3
}, {
xtype : 'button',
itemId : 'saveShareBtn',
text :_S._SFE_LANG_SHARELINK_APPLY,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_APPLY',
cls:'capsule-btn',
style:'margin-left: 0;',
listeners:{
afterrender : function(btn) {
}
},
handler:function(){
if (QNAP.QOS.fileExplorerTools.constant.FILENAME_RE.test(settingsPanel
.getComponent('link_name').getValue())) {// 檢查link name有無特殊符號
var msgObj = {
text : _S._SFE_LANG_COMMON_MSG_NAME_ILLEGAL,
key : '_SFE_LANG_COMMON_MSG_NAME_ILLEGAL'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM, 'error', msgObj,
btns);
MsgWin.show();
return;
}
QNAP.QOS.fileExplorerAction.updateShareLinkO.call(FM, win, settingsPanel, params, false);// null:path,fasle:不寄送email
}
}, {
xtype : 'hidden',
itemId : 'action',
name : 'action',
value : 'update'
}, {
xtype : 'hidden',
itemId : 'originalAccessCode',
name : 'originalAccessCode'
}]
});
var msgIsShowed=false;
var msgObj = {
title : '',
titleKey : '',
text : _S._SFE_LANG_MSG_CONFIRM_EXIT,
key : '_SFE_LANG_MSG_CONFIRM_EXIT'
};
var btns = [{
text : _S._SFE_LANG_COMMON_YES,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
settingsPanel.getComponent('saveShareBtn').handler();
exitCfmMsgWin.hide();
msgIsShowed=true;
if(closeShareWin){
win.close();
}
}
}, {
text : _S._SFE_LANG_COMMON_NO,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CANCEL',
handler : function() {
msgIsShowed=true;
exitCfmMsgWin.hide();
if(closeShareWin){
win.close();
}
}
}];
var exitCfmMsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM, 'question', msgObj, btns);
var shareTab = new Ext.TabPanel({
activeItem : 0,
width : '100%',
ctCls : 'shareTab-ctCls',
cls : 'shareTab-cls',
height : 390,
autoScroll : true,
items : [sharePanel,publishPanel,settingsPanel],
listeners:{
afterrender : function(tabpanel) {

},
beforetabchange:function(TabPanel, newTab, currentTab){
if(newTab.itemId=='settingsPanel'){
var isQsyncLink=FM.checkQsyncLink();
if(isQsyncLink){
newTab.setDisabled(isQsyncLink);
var task = new Ext.util.DelayedTask(function() {
shareTab.setActiveTab(currentTab);
});
task.delay(100);
}
}
},
tabchange:function(obj, panel){
if (panel.itemId == 'pubPanel') {
if(settingsPanel.getForm().isDirty() && !msgIsShowed){
exitCfmMsgWin.show();
}
win.buttons[1].hide();
}else if (panel.itemId == 'sendMailPanel') {
if(settingsPanel.getForm().isDirty() && !msgIsShowed){
exitCfmMsgWin.show();
}
win.buttons[1].show();
}else{
msgIsShowed=false;
win.buttons[1].hide();
}
}
}
});
var closeShareWin=false;
var shareWinMask;
var win = {
y : 50,
title : _S._SFE_LANG_SHARELINK_TITLE_0,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_TITLE_0',
cls : 'FM-popup-cls',
items : [shareTab],
width : 600,
height : 565,
closable : false,
autoHeight : true,
buttons : [{
xtype : 'displayfield',
itemId : 'clipboardHint',
value : _S._SFE_LANG_SHARELINK_COPIED_MSG,
style : 'color:blue',
hidden : true,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_COPIED_MSG'
}, {
xtype : 'button',
itemId : 'sendBtn',
cls:'sendMailBtn-cls capsule-btn',
text : _S._SFE_LANG_COMMON_SEND,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_SEND',
height:'22px',
disabled :true,
handler : function() {
if(link_name!=settingsPanel.getComponent('link_name').getValue()){
settingsPanel.getComponent('saveShareBtn').handler();
}


var tType=sharePanel.getComponent('sendArea-itemId').getComponent('TransmissionType');
if(tType.getValue()==1){
if (!mailStatus) {// 如果沒有設定smtp server
var MSGText = _S._SFE_LANG_MSG_NO_SMTP;
if (QNAP.QOS.user.isAdminGroup) {
MSGText = MSGText
.replace('SMTP','<a href="#" target="_blank" onClick="QNAP.QOS.fileExplorerTools.tool.openNotification();">SMTP</a>');
}
var msgObj = {
title : _S._SFE_LANG_COMMON_SEND,
titleKey : '_SFE_LANG_COMMON_SEND',
text : MSGText,
key : '_SFE_LANG_MSG_NO_SMTP'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM, 'error', msgObj,
btns);

MsgWin.show();
return;
}
settingsPanel.plugins.onsubmit=true;
if (settingsPanel.getForm().isValid()) {
if(settingsPanel.getForm().isDirty()){//存檔後寄送Email
QNAP.QOS.fileExplorerAction.updateShareLink.call(FM, win, settingsPanel, params, true, false);
}else{
QNAP.QOS.fileExplorerAction.mailShareLinkO.call(FM, win, sharePanel, params);
}
}
}else if(tType.getValue()==2){//用PC傳送
if (shLkObj) {
var form = settingsPanel.getForm();
var accessCodeFiled = settingsPanel.find('itemId','accessCodeFiled')[0];
if(settingsPanel && form.findField('includeAccCode').checked){
FM.mailLinks += _S._SFE_LANG_SHARELINK_ACCECC_CODE_LABEL_2+'  '+accessCodeFiled.getValue();
}
}
var popURL = 'mailto:'+sharePanel.getComponent('mailaddres').getValue()+'?subject='+
sharePanel.getComponent('subject').getValue()+'&body='+encodeURIComponent(FM.mailLinks);
var winReloadfunc = window.onbeforeunload;
window.onbeforeunload=null;
var dlForm = Ext.DomHelper.append(document.body, {
tag : 'form',
id : Ext.id(),
frameBorder : 0,
method : 'post',
action : popURL,
width : 0,
height : 0,
css : 'display:none;visibility:hidden;height:1px;'
}, false);
dlForm.submit();
var task = new Ext.util.DelayedTask(function() {
window.onbeforeunload=winReloadfunc;
});
task.delay(50);
}else if(tType.getValue()==3){//使用myQnapCloud傳送
QNAP.QOS.fileExplorerAction.mailByCloudNas.call(FM, win, sharePanel, params);
}

}
}, {
text : _S._SFE_LANG_COMMON_CLOSE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CLOSE',
handler : function() {
if(settingsPanel.getForm(),settingsPanel.getForm().isDirty() && !msgIsShowed){
closeShareWin=true;
exitCfmMsgWin.show();
}else{
win.close();
}
}
}],
listeners : {
show : function() {
var form = settingsPanel.getForm();
if (expire_time != 0) {
var keyDate = new Date(parseInt(expire_time) * 1000);
form.findField('specificDate').setValue(keyDate);
form.findField('specificHour').setValue(keyDate
.getHours());
form.findField('specificMinute').setValue(keyDate
.getMinutes());
enableValidDurationField(form, 'specific_time');
form.findField('specific_time').setValue(true);
} else {
form.findField('forever').setValue(true);
}

if(linksLen!=1){
settingsPanel.getComponent('link_name').allowBlank=true;
}
settingsPanel.getComponent('link_name').setValue(link_name);
settingsPanel.getComponent('sslLink').setValue(chkSSL);
settingsPanel.getComponent('passwordArea-id').getComponent('accessCodeFiled').setValue(access_code);
if(updateToSmarkLink || chkSSL){
QNAP.QOS.fileExplorerAction.updateShareLink.call(FM, win, settingsPanel, params, false);

}
}
}
};


var viewSize = Ext.getBody().getViewSize();

if (viewSize.height < 650) {
win.autoScroll = true;
}

win = FM._createModalWindow(win);
var viewSize = Ext.getBody().getViewSize();
if (viewSize.height < 650) {
sharePanel.autoScroll = true;
win.autoScroll = true;
win.autoHeight = false;
}
win.show();
var mailStatus;
Ext.Ajax.request({//get_sys_setting 回傳沒有status=1這個參數，不適用共用
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'get_sys_setting'),
success : function(response) {
var RS=Ext.util.JSON.decode(response.responseText);

var smtpHost = RS.SMTPServer;
mailStatus = /.*\..*/.test(smtpHost);

},
failure : function(res) {

}
});

},// showShareWin End
showShareLinkBtn : function() {
var FM = this;
var selections = FM.shareGrid.getSelectionModel().getSelections();
var sLength = selections.length;

FM.shareBtns.show();
if (sLength == 0) {
FM.shareBtns.hide();
} else if (sLength > 1) {
} else {
Ext.each(FM.shareBtns.items.items, function(btn) {
if(btn.itemId!=='clipboardHint')
btn.show();
});
}
},
pasteFile : function() {
var FM = this;
if (QNAP.QOS.FileClipBoard.fileList.length==0){
return ;
}
var treeNodeId=FM.treeNodeId;
var compareFrom = QNAP.QOS.FileClipBoard.sourcePath;
var compareTo = FM.treeNodeId;
if(!compareTo){
compareTo=FM.currentPath;
}
if (compareFrom.split('/')[1] == 'home') {
compareFrom = compareFrom.replace('/home', '/homes/' + QNAP.QOS.user.account);
}
if (compareTo.split('/')[1] == 'home') {
compareTo = compareTo.replace('/home', '/homes/' + QNAP.QOS.user.account);
}
if (compareFrom == compareTo) {
if(QNAP.QOS.FileClipBoard.copyMove=='move'){
var msgObj = {
text : _S._SFE_LANG_COMMON_MSG_THE_SAME_FOLDER,
key : '_SFE_LANG_COMMON_MSG_THE_SAME_FOLDER'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM, 'warning', msgObj,
btns);
MsgWin.show();
return;
}else{
QNAP.QOS.fileExplorerAction.pastAction(FM, 2);
}
} else {
if (QNAP.QOS.FileClipBoard.sourceHost == 'NAS' && FM.currentHost == 'Client') { // download
titleKey = '_SFE_LANG_ACTION_DOWNLOAD_TITLE';
}else{
titleKey = '_SFE_LANG_COMMON_PAST';
}
var msgObj = {
title   : _S[titleKey],
titleKey: titleKey,
text    : _S._SFE_LANG_COMMON_MSG_OVERWRITE_EX,
key     : '_SFE_LANG_COMMON_MSG_OVERWRITE_EX'
};
var btns = [{
text: _S._SFE_LANG_COMMON_OK,
qInternational: true,
qInternationalKey: '_SFE_LANG_COMMON_OK',
handler: function() {
FM.config.isOverwritePast = overwriteRadio.getValue().getGroupValue();
var merge1Task=copyCfmMsgWin.items.items[1].getComponent('merge1Task').getValue();
QNAP.QOS.fileExplorerAction.pastAction(FM, FM.config.isOverwritePast, treeNodeId,merge1Task);
copyCfmMsgWin.close();
}
}, {
text: _S._SFE_LANG_COMMON_CANCEL,
qInternational: true,
qInternationalKey: '_SFE_LANG_COMMON_CANCEL',
handler: function() {
copyCfmMsgWin.close();
}
}];
var copyCfmMsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,
'question', msgObj, btns);

var overwriteRadio = new Ext.form.RadioGroup({
columns: 1,
defaults: {
name: 'overwriteMode',
},
items: [{
qInternational: true,
qInternationalKey: {
boxLabel: '_SFE_LANG_COMMON_SKIP_1'
},
boxLabel: _S._SFE_LANG_COMMON_SKIP_1,
inputValue: '1',
itemId: 'skipRadio',
checked: FM.config.isOverwritePast=='1'
}, {
qInternational: true,
qInternationalKey: {
boxLabel: '_SFE_LANG_COMMON_OVERWRITE_1'
},
boxLabel: _S._SFE_LANG_COMMON_OVERWRITE_1,
inputValue: '0',
itemId: 'overwriteRadio',
checked: FM.config.isOverwritePast=='0'
}]
});
copyCfmMsgWin.remove(1);
copyCfmMsgWin.add({
xtype: 'container',
flex: 1,
margins: {
top: 10,
left: 17,
right: 0,
bottom: 0
},
items: [{
xtype: 'displayfield',
itemId: 'msgText',
value: msgObj.text,
qInternational: true,
qInternationalKey: msgObj.key,
style: {
marginBottom: '20px'
},
},
overwriteRadio,
{
xtype            : 'checkbox',
itemId           : 'merge1Task',
boxLabel         : _S._SFE_LANG_MSG_MERGE_1_TASK,
qInternational   : true,
qInternationalKey: '_SFE_LANG_MSG_MERGE_1_TASK',
labelSeparator   : '',
hideLabel        : true,
checked : true,
listeners : {
check : function(cmp, checked){
}
}
}
]
});
if (QNAP.QOS.FileClipBoard.sourceHost == 'Client' && FM.currentHost == 'NAS'){
QNAP.QOS.fileExplorerAction.pastAction(FM, FM.config.isOverwritePast, FM.treeNodeId);
}else{
copyCfmMsgWin.show();
}
copyCfmMsgWin.setHeight(270);
}
},
createHistoryPanel:function(){
var FM=this;
if(!FM.historyPanel){
var historyStore = new Ext.data.JsonStore({
url :QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'versioning_stat'),
totalProperty : 'number',
root : 'datas',
fields : ['version_id','time', 'size', 'status', 'action', 'user', 'comp','ip'],
listeners : {
beforeload : function(store, options) {
},
load:function(store, records, opt){
var hBbarId=FM.historyPanel.bbar.dom.firstChild.id;
var hBbar=Ext.getCmp(hBbarId);
hBbar.getComponent('hRestoreBtn').hide();
hBbar.getComponent('hDownloadBtn').hide();
hBbar.getComponent('hDelAllBtn').hide();
var verPanelMask= new Ext.LoadMask(
FM.historyPanel.id, {
msg : (_S._SFE_LANG_VERSION_LOCKED_MSG)
});
var isLocked=(store.reader.jsonData.lock_status=='TRUE');
var hgBbar=Ext.getCmp(historyGrid.bbar.dom.firstChild.id);
if(isLocked){
hgBbar.show();
verPanelMask.show();
var getPercent = function() {
var stparams={};
stparams.source_file=encodeURIComponent(store.baseParams.source_file);
stparams.source_path=encodeURIComponent(store.baseParams.source_path);
Ext.Ajax.request({
params:stparams,
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl
.call(FM, 'versioning_get_progress'),
success : function(o) {
if (!QNAP.QOS.fileExplorerTools.tool
.checkResponseIfEmpty(o.responseText)) {
var r = Ext.util.JSON
.decode(o.responseText);
var fCurrent_Size=r.Current_Size;
var fsize=r.Total_Size;
var percent=r.percentage;
var pBar=Ext.getCmp(historyGrid.bbar.dom.firstChild.id).getComponent('restorePBar');
pBar.show();
pBar.reset();
if (r.status == QNAP.QOS.fileExplorerTools.status.SUCCESS) {
pBar.updateProgress(percent/100,percent
+ ' % '
+ _S._SFE_LANG_COMMON_PROGRESS_COMPLETED
+ '...');
if (percent == 100) {
pBar.updateProgress(1, _S._SFE_LANG_COMMON_FINISH);
var task = new Ext.util.DelayedTask(function() {
Ext.getCmp(historyGrid.bbar.dom.firstChild.id).hide();//隱藏進度條
});
task.delay(3000);
} else {
var task = new Ext.util.DelayedTask(function() {
getPercent();
});
task.delay(1000);
}

} else {
}
} else {
var msgObj = {
text : _S._SFE_LANG_COMMON_MSG_UNKNOW_ERROR,
key : '_SFE_LANG_COMMON_MSG_UNKNOW_ERROR'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg
.call(FM, 'error', msgObj, btns);
MsgWin.show();
}
},
failure : function(o) {
}
});
};

getPercent();
}else{
hgBbar.hide();
verPanelMask.hide();
if(records.length>0){
hBbar.getComponent('hDelAllBtn').show();
}
}
var i=0;
Ext.each(records,function(record){
var tipHtml='<table>'+
'	<tr>'+
'		<td>'+_S._SFE_LANG_COMMON_DATE_TIME+':　</td>'+
'		<td>　'+new Date(parseInt(record.data.time) * 1000).format('Y/m/d H:i:s')+'</td>'+
'	</tr>'+
'	<tr>'+
'		<td>'+_S._SFE_LANG_COMMON_FILESIZE+':　</td>'+
'		<td>　'+QNAP.QOS.fileExplorerTools.tool.transformFileSize(record.get('size'))+'</td>'+
'	</tr>'+
'	<tr>'+
'		<td>'+_S._SFE_LANG_COMMON_USER+':　</td>'+
'		<td>　'+record.get('user')+'</td>'+
'	</tr>'+
'	<tr>'+
'		<td>'+_S._SFE_LANG_COMMON_DEVICE+':</td>'+
'		<td>　'+record.get('comp')+'</td>'+
'	</tr>'+
'	<tr>'+
'		<td>IP:</td>'+
'		<td>　'+record.get('ip')+'</td>'+
'	</tr>'+
'</table>';
new Ext.ToolTip({
target: historyGrid.getView().getRow(i),
html: tipHtml,
anchor : 'top',
dismissDelay:60*60*1000,
cls: 'fsTip-cls'
});
i++;
});
}
}
});
var pBar = new Ext.ProgressBar({
hidden:true,
itemId:'restorePBar',
width:260
});
var historyGrid= new Ext.grid.GridPanel({
minColumnWidth : 30,
enableColumnMove : false,
store : historyStore,
itemId : 'historyGrid-id',
width : 'auto',
height:300,
cls : 'nasGridPanel-cls',
stripeRows : true,
autoExpandColumn : 0,
enableHdMenu : false,
flex:1,
qInternational : true,
bbar:[pBar],
sm: new Ext.grid.RowSelectionModel({singleSelect:true}),
loadMask : {msg : ('_SFE_LANG_COMMON_LOADING_MSG')},
cm : new Ext.grid.ColumnModel([{
dataIndex : 'time',
header : _S._SFE_LANG_COMMON_DATE_TIME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_DATE_TIME',
sortable : true,
width : 190,
renderer : QNAP.QOS.fileExplorerTools.tool.showExpireTime
}, {
header : _S._SFE_LANG_COMMON_FILESIZE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILESIZE',
dataIndex : 'size',// 將'filename'改成'natural'因為配合自然排序，排序後要顯示箭頭
sortable : true,
width : 80,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmFileSize
}]),
listeners : {
containerclick : function(grid) {
},
rowclick : function(row, rowIndex, e){
var hBbarId=FM.historyPanel.bbar.dom.firstChild.id;
var hBbar=Ext.getCmp(hBbarId);
var selections=historyGrid.getSelectionModel().getSelections();
if(selections.length==1){
Ext.each(hBbar.items.items,function(btn){
btn.show();
});
}else{//理論上不會跑到這裡
}
},
afterrender:function(grid){
QNAP.QOS.fileExplorerAction.getVersionList.call(FM);
}
}
});
FM.historyPanel = new Ext.Panel({
itemId : 'historyPanel',
cls : 'historyPanel-cls',
padding : '28px 21px 6px 21px',
autoHeight :true,
listeners:{
afterrender:function(Panel){
FM.maskVerPanel();
}
},
items : [{
xtype : 'button',
itemId : 'verRfsBtn-id',
iconCls : 'verRfsBtn-cls',
itemCls : 'verRfsBtn-itemCls',
style: 'float:right;position:relative;top:-11px;',
width:25,
height:25,
hidden : true,
handler:function(){
historyGrid.store.reload();
}
},{
xtype : 'displayfield',
itemId : 'verHstr-id',
itemCls : 'verHstr-itemCls',
value : _S._SFE_LANG_VERSION_HISTORY,
qInternational : true,
qInternationalKey : '_SFE_LANG_VERSION_HISTORY'
},{
xtype : 'displayfield',
itemId : 'verHstrMsg-id',
itemCls : 'verHstrMsg-itemCls',
padding : '0 0 28px 0',
style:'padding: 10px 0 10px 0;',
value : _S._SFELANG_MSG_RESTORE,
qInternational : true,
qInternationalKey : '_SFELANG_MSG_RESTORE'
},historyGrid]
,
bbar:[{
xtype : 'tbspacer',
width : 19,
height:30
}, {
text : _S._SFE_LANG_COMMON_RESTORE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_RESTORE',
itemId : 'hRestoreBtn',
tooltip : _S._SFE_LANG_COMMON_RESTORE,
width : 50,
hidden :true,
cls : 'barUpBtn-cls',
handler : function() {
FM.showRestorePathTree();
}
},{
xtype : 'tbspacer',
width : 12
}, {
text : _S._SFE_LANG_ACTION_DOWNLOAD_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_DOWNLOAD_TITLE',
itemId : 'hDownloadBtn',
tooltip : '_SFE_LANG_ACTION_DOWNLOAD_TITLE',
width : 50,
hidden :true,
cls : 'barUpBtn-cls',
handler : function() {
QNAP.QOS.fileExplorerAction.downloadVer.call(FM,historyGrid);
}
},'->','-',{
text : _S._SFE_LANG_SHARELINK_DELETE_ALL,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_DELETE_ALL',
itemId : 'hDelAllBtn',
tooltip : '_SFE_LANG_SHARELINK_DELETE_ALL',
width : 50,
hidden :true,
cls : 'barUpBtn-cls',
handler : function() {
var msgObj = {
title : _S._SFE_LANG_SHARELINK_DELETE_ALL,
titleKey : '_SFE_LANG_SHARELINK_DELETE_ALL',
text : _S._SFE_LANG_VERSION_DEL_CONFIRM_MSG,
key : '_SFE_LANG_VERSION_DEL_CONFIRM_MSG'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
QNAP.QOS.fileExplorerAction.delAllVer.call(FM);
verDelMsgWin.close();
}
}, {
text : _S._SFE_LANG_COMMON_CANCEL,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CANCEL',
handler : function() {
verDelMsgWin.close();
}
}];
var verDelMsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM,
'question', msgObj, btns);
verDelMsgWin.show();
}
},{
xtype : 'tbspacer',
width : 15
}
]
});
FM.eastTab.getItem('historyTab').add(FM.historyPanel);
}
Ext.getCmp(FM.eastPanelId).doLayout();
},//createHistoryPanel End
openVersions:function(){
var FM=this;
var northPanel = Ext.getCmp(FM.northPanelId);
var eastPanelBtn = northPanel.items.items[northPanel.items.items.length - 1];
var eastcmp = FM._getMainWindow().layout.east;
if (!eastcmp.isVisible()) {
eastPanelBtn.btnEl.dom.click();
}
FM.eastTab.setActiveTab(FM.eastTab.getItem('historyTab'));
QNAP.QOS.fileExplorerAction.getVersionList.call(FM);
},
showHistoryGrid:function(){
var FM=this;
if(!FM.delHistoryGrid){
var nameColumnId = Ext.id();
var dhgCM= new Ext.grid.ColumnModel([{
dataIndex : 'icon',
sortable : false,
width : 30,
align : 'center',
renderer : {
fn : QNAP.QOS.fileExplorerTools.tool.showCmName,
scope : FM
}
}, {
id : nameColumnId,
header : _S._SFE_LANG_COMMON_FILENAME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILENAME',
dataIndex : 'natural',// 將'filename'改成'natural'因為配合自然排序，排序後要顯示箭頭
sortable : true,
renderer : {
fn : QNAP.QOS.fileExplorerTools.tool.showCmName2,
scope : FM
}
}, {
header : _S._SFE_LANG_COMMON_MODIFIED_TIME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_MODIFIED_TIME',
dataIndex : 'mt',
width : 205,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmMt
}, {
header : _S._SFE_LANG_COMMON_FILETYPE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILETYPE',
dataIndex : 'filetype',
width : 116,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmFileType
}, {
header : _S._SFE_LANG_COMMON_FILESIZE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FILESIZE',
dataIndex : 'filesize',
width : 105,
align : 'right',
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showCmFileSize
}, {
header : _S._SFE_LANG_COMMON_PERMISSION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_PERMISSION',
dataIndex : 'privilege',
width : 120,
hidden : true,
sortable : true,
renderer : QNAP.QOS.fileExplorerTools.tool.showPermission
}, {
header : _S._SFE_LANG_COMMON_OWNER,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OWNER',
dataIndex : 'owner',
width : 110,
hidden : true,
sortable : true
}, {
header : _S._SFE_LANG_COMMON_GROUP,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_GROUP',
dataIndex : 'group',
width : 110,
hidden : true,
sortable : true
},{
dataIndex : 'thumbIcon',
sortable : false,
width : 30,
align : 'center',
hidden : true,
renderer : {
fn : QNAP.QOS.fileExplorerTools.tool.thumbIcon,
scope : FM
}
}]);
var pagingToolbar = new Ext.PagingToolbar({
plugins : new QNAP.CMP.PageSize({
userConfigKey : 'wfm_file_list_page_size',
variations : [50 ,100 ,250 ,500],
defaultPageSize : 50
}),
store : FM.fileListStore,
displayInfo : true
});
var sm = new Ext.grid.RowSelectionModel({
singleSelect:true,
listeners:{
rowselect : function(SelectionModel, rowIndex, record) {
QNAP.QOS.fileExplorerAction.getVersionList.call(FM);
}
}
});
FM.delHistoryGrid= new Ext.grid.GridPanel({
minColumnWidth : 30,
enableColumnMove : false,
store : FM.fileListStore,
itemId : 'delHistoryGrid',
cls : 'delHistoryGrid-cls',
width : 'auto',
stripeRows : true,
autoExpandColumn : 0,
autoExpandColumnMinWidth : 196,
enableHdMenu : false,
flex:1,
qInternational : true,
bbar:pagingToolbar,
cm : dhgCM,
autoExpandColumn : nameColumnId,
autoExpandColumnMinWidth : 196,
loadMask : {
msg : ('_SFE_LANG_COMMON_LOADING_MSG')
},
viewConfig : {
columnsText : _S._SFE_LANG_COMMON_DISPLAY_COLUMN,
sortAscText : 'A->Z',
sortDescText : 'Z->A'
},
listeners : {
containerclick : function(grid) {
},
rowclick : function(row, rowIndex, e){
var record = FM.delHistoryGrid.store.getAt(rowIndex);
var textEl = e.getTarget('span.fileNameText-cls');
if (textEl) {
FM.isTextClick = true;
}
if (FM.isTextClick) {// 如果是點選文字進來的
if (record.get('isfolder') == 1) {
var fn = record.get('filename');
var newPath = QNAP.QOS.fileExplorerTools.tool
.getDirPath(FM.currentPath)
+ fn;
FM.fileListStore.baseParams.path = newPath;
FM.delHistoryGrid.store.load({
params : {
start : 0,
limit : QNAP.QOS.user.pageSize.wfm_file_list_page_size
|| 50
},
callback : function() {
}
});
}
FM.isTextClick = false;
}
if(record.get('filename')=='..'){
var parent = FM.delHistoryGrid.store.baseParams.path;// record.data.filepath;
parent=parent.substring(0,parent.lastIndexOf('/'));
FM.delHistoryGrid.store.baseParams.path=parent;
FM.delHistoryGrid.store.reload();
}
},
rowcontextmenu : function(grid, index, e) {
e.stopEvent();
var contextMenu = FM.delHistoryGridBtns.getComponent('moreActionBtn').menu;
contextMenu.showAt(e.getXY());
},
afterrender : function() {
if(FM.eastTab.isVisible())
FM.versionSwich(FM.eastTab.getWidth());
}
},
sm:sm
});
FM.centerPanel.items.add(FM.delHistoryGrid);
FM.setMainScr('delHistoryGrid');
}else{
FM.setMainScr('delHistoryGrid');
if(FM.eastTab.isVisible())
FM.versionSwich(FM.eastTab.getWidth());
}
},//showHistoryGrid End
showRestorePathTree:function(){
var FM=this;
var treePanel = new Ext.tree.TreePanel({
cls : 'popup-treePanel-cls',
height : 280,
useArrows : true,
autoScroll : true,
style:'margin-top:8px;',
loader : new Ext.tree.TreeLoader({
dataUrl : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM, 'get_tree'),
listeners : {
load : function(treeLoader, nodes, response) {
QNAP.QOS.fileExplorerTools.tool.checkStatus(response);
var i = nodes.childNodes.length - 1;

for (; i >= 0; i--) {
if (nodes.childNodes[i].attributes.cls != 'w'
&& nodes.childNodes[i].attributes.cls != '7') {
nodes.childNodes[i].remove();
}
}
}
}
}),
border : false,
autoScroll : true,
containerScroll : true
});
var treeRoot = new Ext.tree.AsyncTreeNode({
text : QNAP.QOS.fileExplorerTools.config.serverName,
icon : QNAP.QOS.fileExplorerTools.config.imgPath
+ 'tree_root.png',
iconCls : 'x-tree-node-root',
id : 'share_root'
});

treePanel.setRootNode(treeRoot);
treePanel.getSelectionModel().on('beforeselect', function(s, node) {
if ((typeof node !== 'undefined')
&& node.id == 'share_root') {
return false;
} else {
return true;
}
});

treeRoot.expand(false, false);
var onExpand = function() {
treeRoot.removeListener('expand', onExpand);
var firstNode = treePanel.getNodeById(treePanel.getRootNode()
.item(0).id);
treePanel.getSelectionModel().select(firstNode);
};

treeRoot.addListener('expand', onExpand);
var win = FM._createModalWindow({
styleVer:1,
title : _S._SFE_LANG_SELECT_RESTORE_PATH,
qInternational : true,
qInternationalKey : '_SFE_LANG_SELECT_RESTORE_PATH',
padding:10,
layout : 'auto',
parent : FM.win,
width : 400,
height : 420,
cls : 'FM-popup-cls',
items : [{
xtype : 'radio',
name : 'restorePath',
itemId : 'oPath',
inputValue : 'oPath',
boxLabel : _S._SFE_LANG_RESTORE_TO_ORIGINAL_PATH,
qInternational : true,
qInternationalKey : '_SFE_LANG_RESTORE_TO_ORIGINAL_PATH',
flex : 1,
checked:true,
listeners : {
check : function(radio) {
}
}
},{
xtype : 'textfield',
itemId : 'toPtah',
fieldLabel : _S._SFE_LANG_COMMON_LOCATION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_LOCATION',
width:350,
readOnly:true,
hideLabel : false,
style:'margin:8px 16px 16px 16px;',
value:FM.currentPath
},{
xtype : 'radio',
name : 'restorePath',
itemId : 'nPath',
inputValue : 'nPath',
boxLabel : _S._SFE_LANG_RESTORE_TO,
qInternational : true,
qInternationalKey : '_SFE_LANG_RESTORE_TO',
flex : 1,
listeners : {
check : function(radio) {
}
}

}, treePanel],
listeners:{
show:function(win){
var historyGrid=FM.eastTab.getItem('historyTab').getComponent('historyPanel').getComponent('historyGrid-id');
var data=historyGrid.store.reader.jsonData;
if(data.parent_exist!=1){
win.getComponent('oPath').hide();
win.getComponent('toPtah').hide();
win.getComponent('nPath').setValue(true);
}else{
win.getComponent('oPath').show();
win.getComponent('toPtah').show();
win.getComponent('oPath').setValue(true);
}
}
},
buttons : [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
var destPath = treePanel.getSelectionModel().selNode.id;

if(win.getComponent('oPath').checked){
destPath=win.getComponent('toPtah').getValue();
}

if (destPath == 'vol_root') {
destPath = '/';
}
if (destPath != '') {
FM.destPath=destPath;
QNAP.QOS.fileExplorerAction.restore.call(FM,destPath);
treePanel.destroy();
win.close();
} else {
var msgObj = {
text : _S._SFE_LANG_COMMON_MSG_SELECT_FOLDER,
key : '_SFE_LANG_COMMON_MSG_SELECT_FOLDER'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg
.call(FM, 'warning', msgObj, btns);
MsgWin.show();
}
}
}, {
text : _S._SFE_LANG_COMMON_CANCEL,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CANCEL',
handler : function() {
treePanel.destroy();
win.close();
}
}]
});
win.show();
},//showRestorePathTree End
versionSwich:function(adjWidth){
var FM=this;
if (!FM.treePanel || !FM.treePanel.selModel || !FM.treePanel.selModel.getSelectedNode()) {
return;
}
if(FM.eastTab.header){
if(FM.delHistoryGrid && FM.delHistoryGrid.isVisible()){
Ext.get(FM.eastTab.header.dom.childNodes[0].childNodes[0].childNodes[0]).setWidth(0);
Ext.get(FM.eastTab.header.dom.childNodes[0].childNodes[0].childNodes[1]).setWidth(0);
Ext.get(FM.eastTab.header.dom.childNodes[0].childNodes[0].childNodes[2]).setWidth(adjWidth);
FM.eastTab.setActiveTab(FM.eastTab.getComponent('historyTab'));
}else if(FM.fileListStore.baseParams.path.indexOf('/home/.Qsync') >= 0){
Ext.get(FM.eastTab.header.dom.childNodes[0].childNodes[0].childNodes[0]).setWidth((adjWidth/3)-1);
Ext.get(FM.eastTab.header.dom.childNodes[0].childNodes[0].childNodes[1]).setWidth((adjWidth/3)-1);
Ext.get(FM.eastTab.header.dom.childNodes[0].childNodes[0].childNodes[2]).setWidth((adjWidth/3));
}else{
Ext.get(FM.eastTab.header.dom.childNodes[0].childNodes[0].childNodes[0]).setWidth((adjWidth/2)-1);
Ext.get(FM.eastTab.header.dom.childNodes[0].childNodes[0].childNodes[1]).setWidth((adjWidth/2)-1);
Ext.get(FM.eastTab.header.dom.childNodes[0].childNodes[0].childNodes[2]).setWidth(0);
if(FM.eastTab.getActiveTab().itemId == 'historyTab'){
FM.eastTab.setActiveTab(FM.eastTab.getComponent('propertyPanel'));
var northPanel = Ext.getCmp(FM.northPanelId);
var eastPanelBtn = northPanel.items.items[northPanel.items.items.length - 1];
var eastcmp = FM._getMainWindow().layout.east;
if (eastcmp.isVisible()) {
eastPanelBtn.btnEl.dom.click();
}
}
}
}
},
WFMDefaultAct:function(params){
var FM=this;
FM.act=params.act;
var path=decodeURIComponent(params.path), file=decodeURIComponent(params.file);
if(params.act=='versioning'){
if(params.file){
FM.openAppFileName=file;
}
this.openPath(path,file);
}
},
getPath:function(){
var FM=this;
return FM.currentPath;
},
saveFilter:function(parms){
var FM=this;
delete parms['limit'];
delete parms['start'];
delete parms['folderArr'];
FM.filefilter= Ext.encode(parms);
FM.setFilterStatus();
},
clearFilter:function(){
var FM=this;
os.saveConfig('filefilter', null);
QNAP.QOS.user.filefilter=null;
FM.filefilter=null;
delete FM.fileListStore.baseParams['date'];
delete FM.fileListStore.baseParams['date2'];
delete FM.fileListStore.baseParams['dateField'];
delete FM.fileListStore.baseParams['dateType'];
delete FM.fileListStore.baseParams['dir'];
delete FM.fileListStore.baseParams['extensionName'];
delete FM.fileListStore.baseParams['fileSize'];
delete FM.fileListStore.baseParams['fileSizeType'];
delete FM.fileListStore.baseParams['folderCount'];
delete FM.fileListStore.baseParams['keyword'];
delete FM.fileListStore.baseParams['owner'];
delete FM.fileListStore.baseParams['ownerType'];
delete FM.fileListStore.baseParams['searchType'];
delete FM.fileListStore.baseParams['sort'];
delete FM.fileListStore.baseParams['CookiefileSizeType'];
delete FM.fileListStore.baseParams['CookiefileSize'];
delete FM.fileListStore.baseParams['CookieCombofileSize'];
FM.fileListStore.baseParams.list_mode= 'all';
FM.setFilterStatus();
FM.fileListStore.reload();
},
setFilterToPanel:function(){
var FM=this;
var filters=Ext.decode(FM.filefilter);
if(Ext.isEmpty(filters)){
return;
}
FM.panelA.getComponent('keywordO').getComponent('keyword').setValue(filters.keyword);
var fileSizeType=FM.panelA.getComponent('fileSizeType');
fileSizeType.getComponent('fileSizeType').setValue(filters.CookiefileSizeType);
fileSizeType.getComponent('fileSize').setValue(filters.CookiefileSize);
fileSizeType.getComponent('CombofileSize').setValue(filters.CookieCombofileSize);// KB,MB or GB
if(fileSizeType.getComponent('fileSizeType').getValue()!=0){
fileSizeType.getComponent('fileSize').setReadOnly(false);
fileSizeType.getComponent('fileSize').enable();
}
var dateType=FM.panelA.getComponent('dateType');
dateType.items.items[0].setValue(filters.dateType);
dateType.items.items[1].setValue(filters.date);
dateType.items.items[2].setValue(filters.date2);
if(dateType.items.items[0].getValue()==4){
dateType.items.items[1].enable();
dateType.items.items[2].enable();
}else if(dateType.items.items[0].getValue()>0){
dateType.items.items[1].enable();
}
var searchType=FM.panelB.getComponent('searchType');
searchType.items.items[0].setValue(filters.searchType);
searchType.items.items[1].setValue(filters.extensionName);
var ownerType=FM.panelB.getComponent('ownerType');
ownerType.items.items[0].setValue(filters.ownerType);
ownerType.items.items[1].setValue(filters.owner);
if(ownerType.items.items[0].getValue()!=0){
ownerType.items.items[1].enable();
}
},
setFilterStatus:function(){
var FM=this;
var filterBtn=Ext.getCmp(FM.northPanelId).getComponent('filterBtn');
if (!Ext.isEmpty(FM.filefilter)) {
filterBtn.addClass('filtered-cls');
}else{
filterBtn.removeClass('filtered-cls');
}
},
switchViewMode:function(VM,isReloadThumb){
var FM=this;
if(VM=='V1'){
FM.switchColumnModel('view-1',isReloadThumb);
FM.setMainScr('file-panel',isReloadThumb);
os.saveConfig('viewMode', 'V1');
}else if(VM=='V2'){
FM.initNasDataView();
FM.switchColumnModel('view-2',isReloadThumb);
os.saveConfig('viewMode', 'V2');
}else{
FM.switchColumnModel('view-3');
FM.setMainScr('file-panel',isReloadThumb);
os.saveConfig('viewMode', 'V3');
}
QNAP.QOS.user.viewMode=VM;
},
getBgTaskStatus : function(){
var FM=this;
var statusNum=0;
if(QNAP.QOS.FileUploadMgr){
statusNum=QNAP.QOS.FileUploadMgr.prototype.getTaskStatus();
}
if(Ext.getCmp(FM.northPanelId)){
var bgTaskBtn = Ext.getCmp(FM.northPanelId).getComponent('bgTaskBtn');
if(statusNum==0){
bgTaskBtn.hide();
bgTaskBtn.tooltip.setTitle('');
bgTaskBtn.tooltip.hide();
}else{
bgTaskBtn.show();
var actTaskNum=QNAP.QOS.FileUploadMgr.prototype.getActionTasks();
if(actTaskNum>10){
bgTaskBtn.tooltip.setTitle(_S._SFE_LANG_COMMON_TASKS+'10+');
}else{
bgTaskBtn.tooltip.setTitle(_S._SFE_LANG_COMMON_TASKS+actTaskNum);
}
if(bgTaskBtn.isVisible()){
bgTaskBtn.tooltip.show();
}else{
bgTaskBtn.tooltip.hide();
}
if(statusNum<0){
bgTaskBtn.setIcon('/cgi-bin/apps/fileManager/images/funcBtn/alert.gif');
}else{
bgTaskBtn.setIcon('/cgi-bin/apps/fileManager/images/funcBtn/bgTask.gif');
}
}
var task = new Ext.util.DelayedTask(function() {
FM.getBgTaskStatus();
});
task.delay(3000);
}
},
checkQsyncLink : function(){
var FM=this;
var qsyncNoSupport=false;
if(FM.shareGrid && FM.shareGrid.isVisible()){
var selections = FM.shareGrid.getSelectionModel().getSelections();
Ext.each(selections,function(item){
if(item.get('qsync')==1){
qsyncNoSupport=true;
}
});
if(qsyncNoSupport){
var msgObj = {
text : _S._SFE_LANG_MSG_QSYNC_NOT_SUPPORT,
key : '_SFE_LANG_MSG_QSYNC_NOT_SUPPORT'
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM, 'info', msgObj, btns);
MsgWin.show();
}
}
return qsyncNoSupport;
},
getMediaFolderStat: function (){
var FM=this;
var ajax={
url:QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM, 'media_folder_list'),
handler:{
success: function(jsonData) {
FM.mediaFolders={};
Ext.each(jsonData.datas,function (data){
var mfolder=data.folder_path.substring(0,data.folder_path.length-1);
mfolder=mfolder;
var realPath=data.path.substring(0,data.path.length-1);
FM.mediaFolders[mfolder]=realPath;
});
},
failure: function(res) {

}
}
}

QNAP.QOS.fileExplorerTools.tool.ajax.call(FM, ajax);
},
thumbSel:function(selections){
var FM=this;
if(FM.NasDataView){
FM.NasDataView.clearSelections();
Ext.each(selections,function(record){
FM.NasDataView.select(record,true);
});
}
},
ctrVerPanelBtn:function(){
var FM=this;
if(FM.historyPanel){
var selections = FM.gridPanel.getSelectionModel().getSelections();
if(selections.length==1 && selections[0].get('versioning_support')==1){
FM.historyPanel.getComponent('verRfsBtn-id').show();
FM.historyPanel.bbar.show();
}else{
FM.historyPanel.getComponent('verRfsBtn-id').hide();
FM.historyPanel.bbar.hide();
}
}
},
showTreeRecycle:function(visible){
var FM=this;
Ext.each(FM.nasRoot.childNodes,function(rootNode){
Ext.each(rootNode.childNodes,function(subNode){
if(subNode.id.split('/')[2]=='@Recycle'){
if(visible){
subNode.ui.show();
if(rootNode.childNodes.length==1){
rootNode.expand();
}
}else{
subNode.ui.hide();
if(rootNode.childNodes.length==1){
rootNode.collapse();
}
}
}
});
});
},
hideAllActBtn:function(){
var FM=this;
FM.searchComboBox.hide();
FM.searchMenuBtn.hide();
Ext.getCmp(FM.searchSpace).show();
FM.advSearchArea.hide();
FM.fncBtns.hide();
FM.clientfncBtns.hide();
FM.pathPanel.hide();
var swichModeBtn = Ext.getCmp(FM.northPanelId).getComponent('switchModeGroup');
swichModeBtn.hide();
Ext.getCmp(FM.northPanelId).getComponent('filterBtn').hide();
Ext.getCmp(FM.northPanelId).getComponent('refreshBtn').hide();
var northPanel = Ext.getCmp(FM.northPanelId);
var eastPanelBtn = northPanel.items.items[northPanel.items.items.length - 1];
eastPanelBtn.hide();
},
playSubMenu : function() {
var FM=this;
var playSubMenu;
if(!playSubMenu){
playSubMenu = new Ext.menu.Menu({
x : 1 - 10,
cls : 'FM-moreActionMenuList-cls',
shadow : false,
listeners : {
show : function(menu){
menu.removeClass('qnap-menu-v2');
menu.doLayout();
},
beforeshow : function(menu) {
if (!QNAP.QOS.user.isAdminGroup || !FM.RTT) {
menu.getComponent('onTheFlyTrans').hide();
for (var i = 6; i < menu.items.items.length; i++) {
menu.items.items[i].hide();
}
return;
}
menu.getComponent('onTheFlyTrans').show();
var file = FM.gridPanel.getSelectionModel().getSelections()[0];
var params = {};
params.path = file.get('filepath');
params.file_name = file.get('filename');
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(file.get('filename'))) {
params.file_name = QNAP.QOS.fileExplorerTools.tool.getFileNamPath(file.get('filename'))[0];
params.path = QNAP.QOS.fileExplorerTools.tool.getFileNamPath(file.get('filename'))[1];
}
params.file_total = 1;
params.detail = 1;
params.media = 1;
var menuMask = new Ext.LoadMask(menu.id, {
msg : ('_SFE_LANG_COMMON_LOADING_MSG')
});
menuMask.show();

menu.getComponent('originalStream').setVisible(/\.(mp4)$/i.test(params.file_name));
if (file.get('mp4_240') == 0 && file.get('mp4_360') == 0
&& file.get('mp4_480') == 0
&& file.get('mp4_720') == 0
&& file.get('mp4_1080') == 0
&& !/\.(mp4)$/i.test(params.file_name)
) {
menu.getComponent('streamBtn').setVisible(false);
} else {
menu.getComponent('streamBtn').setVisible(true);
}

params=QNAP.QOS.fileExplorerTools.tool.checkUbuntuParams(params);
Ext.Ajax.request({
params : params,
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl
.call(FM, 'stat'),
success : function(response) {
var RS = Ext.decode(response.responseText);

if (RS.status && RS.status != 1) {
return;
}
var data = RS.datas[0];
var shortEdge;// 短邊
if (data.height
&& (data.height <= data.width)) {
shortEdge = data.height;
} else if (data.width
&& (data.width <= data.height)) {
shortEdge = data.width;
}
menu.getComponent('240p').setVisible(data.mp4_240==1);
menu.getComponent('360p').setVisible(data.mp4_360==1);
menu.getComponent('480p').setVisible(data.mp4_480==1);
menu.getComponent('720p').setVisible(data.mp4_720==1);
menu.getComponent('1080p').setVisible(data.mp4_1080==1);
if (!menu.getComponent('240p').isVisible()
&& !menu.getComponent('360p').isVisible()
&& !menu.getComponent('480p').isVisible()
&& !menu.getComponent('720p').isVisible()
&& !menu.getComponent('1080p').isVisible()
&& !menu.getComponent('originalStream').isVisible()
) {
menu.getComponent('streamBtn').setVisible(false);
} else {
menu.getComponent('streamBtn').setVisible(true);
}
menu.getComponent('otf240p').setVisible(data.mp4_240==0);
menu.getComponent('otf360p').setVisible(data.mp4_360==0);
menu.getComponent('otf480p').setVisible(data.mp4_480==0);
menu.getComponent('otf720p').setVisible(data.mp4_720==0);
menu.getComponent('otf1080p').setVisible(data.mp4_1080==0);
menuMask.hide();
menu.doLayout();
},
failure : function(RS) {
}
});
}
},
items : [{
text : _S._SFE_LANG_MEDIA_02,
itemId : 'streamBtn',
qInternational : true,
qInternationalKey : '_SFE_LANG_MEDIA_02',
disabled : true,
disabledClass : 'disabledMenu-cls'
}, {
text : '240p',
itemId : '240p',
rtt : 240,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel()
.getSelections(), null, cmp.rtt);
}
}, {
text : '360p',
itemId : '360p',
rtt : 360,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel()
.getSelections(), null, cmp.rtt);
}
}, {
text : '480p',
itemId : '480p',
rtt : 480,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel()
.getSelections(), null, cmp.rtt);
}
}, {
text : '720p',
itemId : '720p',
rtt : 720,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel()
.getSelections(), null, cmp.rtt);
}
}, {
text : '1080p',
itemId : '1080p',
rtt : 1080,
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel()
.getSelections(), null, cmp.rtt);
}
}, {
itemId : 'originalStream',
text : _S._SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION',
rtt : 'rtt',
handler : function() {
FM.videoPlay(FM.gridPanel.getSelectionModel()
.getSelections(), null, 'original');
}
}, {
itemId : 'otfTitle',
text : _S._SFE_LANG_ON_THE_FLY_TRANSCODING,
qInternational : true,
qInternationalKey : '_SFE_LANG_ON_THE_FLY_TRANSCODING',
disabled : true,
disabledClass : 'disabledMenu-cls'
}, {
text : '240p',
itemId : 'otf240p',
rtt : '240-R',
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel()
.getSelections(), null, cmp.rtt);
}
}, {
text : '360p',
itemId : 'otf360p',
rtt : '360-R',
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel()
.getSelections(), null, cmp.rtt);
}
}, {
text : '480p',
itemId : 'otf480p',
rtt : '480-R',
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel()
.getSelections(), null, cmp.rtt);
}
}, {
text : '720p',
itemId : 'otf720p',
rtt : '720-R',
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel()
.getSelections(), null, cmp.rtt);
}
}, {
text : '1080p',
itemId : 'otf1080p',
rtt : '1080-R',
handler : function(cmp) {
FM.videoPlay(FM.gridPanel.getSelectionModel()
.getSelections(), null, cmp.rtt);
}
}, {
itemId : 'onTheFlyTrans',
text : _S._SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CURRENT_FILE_RESOLUTION',
rtt : 'rtt',
handler : function() {
FM.videoPlay(FM.gridPanel.getSelectionModel()
.getSelections(), null, 'rtt');
}
}]
});
return playSubMenu;
}
},//playSubMenu END
initNasShareFolder : function(goPath){
var FM=this;
if(!Ext.isEmpty(goPath)){//refresh all
FM.initMask.show();
}
FM.nasRoot.loadImgId=Ext.id();
var img='<img id="'+FM.nasRoot.loadImgId+'" style="padding-left: 10px;top: 2px;position: relative;" class="FS-loadImg-cls" src="'+QNAP.QOS.fileExplorerTools.config.loadingImg+'" height="16px" width="16px">';
FM.nasRoot.setText((QNAP.QOS.config.serverName || document.title || 'NAS')+img);
if(Ext.get(FM.nasRoot.loadImgId)){
Ext.get(FM.nasRoot.loadImgId).show();
}
Ext.Ajax.request({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'get_tree'),
params : {
node : 'share_root',
vol : 1
},
success : function(response) {
FM.nasRoot.removeAll(true);
FM.shareFolders = Ext.util.JSON.decode(response.responseText);
var RS = Ext.util.JSON.decode(response.responseText);
var volumeIds=[],volumes=[];
FM.volMap = {};
var data={};
data.root=[];
FM.actPathIsExternal=false;
var isoArr = [], extDiskArr = [];
Ext.each(FM.shareFolders, function(shareFolder) {
FM.volMap[shareFolder.id] = shareFolder.volume_id.toString();
data.root.push({
text : shareFolder.text,
path : shareFolder.id,
type : 'singlepath',
iconCls:shareFolder.iconCls
});
if((shareFolder.volume_avail ==1 || !Ext.isDefined(shareFolder.volume_avail)) && volumeIds.indexOf(shareFolder.volume_id)<0 && shareFolder.iconCls=='folder'){//get volumes
volumeIds.push(shareFolder.volume_id);
volumes.push({
capacity : shareFolder.capacity,
free_size : shareFolder.free_size,
pool_id : shareFolder.pool_id,
pool_name : shareFolder.pool_name,
pool_status : shareFolder.pool_status,
raid_count : shareFolder.raid_count,
raid_disk_cnt : shareFolder.raid_disk_cnt,
raid_disk_list : shareFolder.raid_disk_list,
raid_id1 : shareFolder.raid_id1,
raid_level : shareFolder.raid_level,
used_size : shareFolder.used_size,
volume_encrypt : shareFolder.volume_encrypt,
volume_id : shareFolder.volume_id,
volume_lock : shareFolder.volume_lock,
volume_name : shareFolder.volume_name,
volume_status : shareFolder.volume_status,
volume_unit : shareFolder.volume_unit
});
}

if (shareFolder.iconCls == 'iso') {
var node = new Ext.tree.AsyncTreeNode(shareFolder);
node.attributes.data = {
dirPath : node.id,
access : node.cls || 0,
type : 'NAS',
isoFolder : 1,
noSupportACL : false
};
isoArr.push(node);
} else if (shareFolder.iconCls == 'external') {
shareFolder.iconCls = 'usb-cls';
var node = new Ext.tree.AsyncTreeNode(shareFolder);
node.attributes.data = {
dirPath : node.id,
access : node.cls || 0,
type : 'NAS',
isoFolder : 1,
noSupportACL : false
};
extDiskArr.push(node);
}

});
volumes.sort(function(a, b) {//sort by volume_name asc
var keyA = a.volume_name, keyB = b.volume_name;
if (keyA < keyB)
return -1;
if (keyA > keyB)
return 1;
return 0;
});
data.root.push({
text : '...',
path : '...',
type : 'multipath'
});
FM.nasRootStore.loadData(data);
if (Ext.isArray(FM.shareFolders) && FM.shareFolders.length > 0
&& parseInt(RS[0].id.lastIndexOf('/')) == 0) {
FM.shareAccess = [];
FM.shareNoSupportACL = [];
FM.recycleMap={};
for (var i = 0; i < FM.shareFolders.length; i++) {
FM.shareAccess[i] = {
id : FM.shareFolders[i].id,
access : FM.shareFolders[i].cls,
isoFolder : (FM.shareFolders[i].iconCls == 'iso'),
noSupportACL : (FM.shareFolders[i].noSupportACL == '1')
};
if (FM.shareFolders[i].noSupportACL == '1') {
FM.shareNoSupportACL.push(FM.shareFolders[i].id);
}
FM.recycleMap[FM.shareFolders[i].id.split('/').pop()]=FM.shareFolders[i].recycle_bin;
}
}

FM.volMap={};

Ext.each(volumes,function(vol){//append volume Node
var nodeText=vol.volume_name;
if(Ext.isEmpty(nodeText)){
nodeText=_S._SFE_LANG_COMMON_DISK_VOLUME + ' ' + vol.volume_id.toString();
}
var imgId = Ext.id();
var plusImg = '&nbsp;<span id="{0}" class="plusImg-cls"/></span>';
if (!QNAP.QOS.user.isAdminGroup || FM.isWFM) {
plusImg = '';
}
(function initEvent() {
var imgEl = Ext.fly(imgId);
if (Ext.isEmpty(imgEl)) {
return;
}
imgEl.on('click', function() {
QNAP.QOS.fileExplorerTools.tool.callCreatshareFolder(FM,vol.volume_id.toString());
});
}).defer(10);
var volNode = new Ext.tree.TreeNode({
id : vol.volume_id.toString(),
text : nodeText+ String.format(plusImg, imgId),
iconCls : 'volume',
cls : 'vol-cls',
draggable : true, // disable root node dragging
allowDrop : true
});


volNode.folderType='volumeNode';
Ext.applyIf(volNode.attributes,vol);
FM.nasRoot.appendChild(volNode);
var htmltip = document.createAttribute("data-htmltip");
htmltip.value = true;
volNode.ui.textNode.attributes.setNamedItem(htmltip);

var vlmName = '';
if (!Ext.isEmpty(vol.pool_id)) {
if (Ext.isEmpty(vol.volume_name) && vol.iconCls == 'usb-cls') {
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + vol.id.replace('/', '');
} else {
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + vol.volume_name;
}
} else {
if (Ext.isEmpty(vol.volume_name)) {
if (vol.iconCls == 'usb-cls') {
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + vol.id.replace('/', '');
} else {
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + _S._SFE_LANG_COMMON_DRIVE + ' ' + vol.raid_disk_list;
}
} else {
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + vol.volume_name;
}
}

var tipStr = '';
if (!Ext.isEmpty(vol.pool_id) && vol.pool_id > 0) {
tipStr = tipStr + _S._SFE_LANG_COMMON_STORAGE_POOL + ':' + vol.pool_id + '<br>'
}
tipStr = tipStr + vlmName + '<br>';
if (vol.volume_lock == 1 || vol.iconCls == 'iso') {
volNode.setTooltip(volNode.id.replace('/', ''));
} else {
tipStr += _S._SFE_LANG_COMMON_CAPACITY + ': ' + vol.capacity + ' '
+ vol.volume_unit + ' ' + _S._SFE_LANG_COMMON_FREE_SIZE + ': '
+ vol.free_size + ' ' + vol.volume_unit;
volNode.setTooltip(tipStr);
volNode.attributes.tipText=tipStr;
if(FM.sysSetting.ubuntu && QNAP.QOS.user.account == 'admin'){
if(volNode.id.toString()==FM.sysSetting.ubuntu_vol_id.toString()){
var htmltip = document.createAttribute("data-htmltip");
htmltip.value = true;
FM.ubuntu.ui.textNode.attributes.setNamedItem(htmltip);
FM.ubuntu.setTooltip(tipStr);
}
}
}


Ext.each(FM.shareFolders, function(shareFolder) {//append share folder node
if(volNode.id==shareFolder.volume_id){
FM.volMap[shareFolder.id.replace('/', '')]=shareFolder.volume_id.toString();
var node = new Ext.tree.AsyncTreeNode(shareFolder);
node.folderType='shareFolder';
node.attributes.data = {
dirPath : node.id,
access : shareFolder.cls || 0,
type : 'NAS',//parentAttributes.data.type,
isoFolder : 1,
noSupportACL : shareFolder.noSupportACL == '0'
? false
: true
};
node.on('click', function(node) {
FM.nasTreeNodeClick(node);
});
node.setTooltip(node.id.replace('/',''));
volNode.appendChild(node);


}
});
});
Ext.each(extDiskArr, function(node) {//append usb Node
node.on('click', function(node) {
FM.nasTreeNodeClick(node);
});
node.setTooltip(node.id.replace('/',''));
FM.nasRoot.appendChild(node);
});
Ext.each(isoArr, function(node) {//append iso Node
node.on('click', function(node) {
FM.nasTreeNodeClick(node);
});
node.setTooltip(node.id.replace('/',''));
FM.nasRoot.appendChild(node);
});
var cNode=FM.nasRoot.findChild('id', goPath,true);
if(Ext.isEmpty(goPath)){
FM.goInitPath();
}else{
FM.openPath(goPath);
}
function checkVolume(){
Ext.Ajax.request({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'get_tree'),
params : {
node : 'vol_root',
is_iso:0,
hidden_file:0,
recycle:0
},
success : function(response) {
var RS = Ext.util.JSON.decode(response.responseText);
if(RS.length>volumes.length){
Ext.each(RS,function(volData){
if(volumeIds.indexOf(volData.volume_id)<0){
var nodeText=volData.volume_name;
if(Ext.isEmpty(nodeText)){
nodeText=_S._SFE_LANG_COMMON_DISK_VOLUME + ' ' + volData.volume_id.toString();
}

var imgId = Ext.id();
var plusImg = '&nbsp;<span id="{0}" class="plusImg-cls"/></span>';
if (volData.volume_avail!=1 || !QNAP.QOS.user.isAdminGroup || FM.isWFM) {
plusImg = '';
}
(function initEvent() {
var imgEl = Ext.fly(imgId);
if (Ext.isEmpty(imgEl)) {
return;
}
imgEl.on('click', function() {
QNAP.QOS.fileExplorerTools.tool.callCreatshareFolder(FM,volData.volume_id.toString());
});
}).defer(10);
var volNode = new Ext.tree.TreeNode({
id : volData.volume_id.toString(),
text : nodeText+ String.format(plusImg, imgId),
iconCls : 'volume',
cls : 'vol-cls emptyVol-cls',
draggable : false, // disable root node dragging
allowDrop : false
});
volNode.folderType='volumeNode';
Ext.applyIf(volNode.attributes,volData);
if(extDiskArr.length>0){
FM.nasRoot.insertBefore(volNode,extDiskArr[0]);
}else if(isoArr.length>0){
FM.nasRoot.insertBefore(volNode,isoArr[0]);
}else{
FM.nasRoot.appendChild(volNode);
}
if (volData.volume_avail!=1){
volNode.disable();
}else{
volNode.attributes.volume_avail=1;
}
}else{

}
});
}
Ext.each(RS,function(volInfo){// fix bug 72830 (get tree no raid_disk_list data)
var htmltip = document.createAttribute("data-htmltip");
htmltip.value = true;

var volNode = FM.nasRoot.findChild('id', volInfo.volume_id ,false);
Ext.applyIf(volNode.attributes,volInfo);
volNode.ui.textNode.attributes.setNamedItem(htmltip);
var vol=volNode.attributes;
var vlmName = '';
if (!Ext.isEmpty(vol.pool_id)) {
if (Ext.isEmpty(vol.volume_name) && vol.iconCls == 'usb-cls') {
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + vol.id.replace('/', '');
} else {
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + vol.volume_name;
}
} else {
if (Ext.isEmpty(vol.volume_name)) {
if (vol.iconCls == 'usb-cls') {
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + vol.id.replace('/', '');
} else {
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + _S._SFE_LANG_COMMON_DRIVE + ' ' + volInfo.raid_disk_list;
}
} else {
vlmName = _S._SFE_LANG_COMMON_DISK_VOLUME + ': ' + vol.volume_name;
}
}
if(volInfo.pool_vjbod==1){
var nodeText=volInfo.volume_name;
if(Ext.isEmpty(nodeText)){
nodeText=_S._SFE_LANG_COMMON_DISK_VOLUME + ' ' + volInfo.volume_id.toString();
}
var imgId = Ext.id();
var plusImg = '&nbsp;<span id="{0}" class="plusImg-cls"/></span>';
if (volInfo.volume_avail!=1 || !QNAP.QOS.user.isAdminGroup || FM.isWFM) {
plusImg = '';
}
(function initEvent() {
var imgEl = Ext.fly(imgId);
if (Ext.isEmpty(imgEl)) {
return;
}
imgEl.on('click', function() {
QNAP.QOS.fileExplorerTools.tool.callCreatshareFolder(FM,volInfo.volume_id.toString());
});
}).defer(10);

nodeText=nodeText+'('+_S._SFE_LANG_COMMON_VIRTUAL_JBOD+')'+ String.format(plusImg, imgId);
volNode.setText(nodeText);
vlmName=vlmName+'('+_S._SFE_LANG_COMMON_VIRTUAL_JBOD+')';
}
var tipStr = '';
if (!Ext.isEmpty(vol.pool_id) && vol.pool_id > 0) {
tipStr = tipStr + _S._SFE_LANG_COMMON_STORAGE_POOL + ':' + vol.pool_id + '<br>';
}
tipStr = tipStr + vlmName + '<br>';
tipStr += _S._SFE_LANG_COMMON_CAPACITY + ': ' + vol.capacity + ' '
+ vol.volume_unit + ' ' + _S._SFE_LANG_COMMON_FREE_SIZE + ': '
+ vol.free_size + ' ' + vol.volume_unit;
volNode.setTooltip(tipStr);
volNode.attributes.tipText=tipStr;
for(var i=0;i<FM.shareFolders.length;i++){//Bug 72849
if(FM.shareFolders[i].volume_id==volInfo.volume_id){
FM.shareFolders[i].raid_disk_list=volInfo.raid_disk_list;
}
}

});
},
failure : function(res) {
}
});
}
checkVolume();
Ext.get(FM.nasRoot.loadImgId).hide();
},
failure : function(res) {
Ext.get(FM.nasRoot.loadImgId).hide();
}
});
},// initNasShareFolder End
getShareFolders : function(successFn){
var FM=this;
Ext.Ajax.request({
url : QNAP.QOS.fileExplorerTools.tool.getActionUrl.call(FM,'get_tree'),
params : {
node : 'share_root',
vol : 1
},
success : function(response) {
FM.shareFolders = Ext.util.JSON.decode(response.responseText);
var RS = Ext.util.JSON.decode(response.responseText);
FM.volMap = {};
var data={};
data.root=[];
FM.actPathIsExternal=false;
Ext.each(FM.shareFolders, function(shareFolder) {
FM.volMap[shareFolder.id] = shareFolder.volume_id.toString();
data.root.push({
text : shareFolder.text,
path : shareFolder.id,
type : 'singlepath',
iconCls:shareFolder.iconCls
});
if(FM.activeAppPath && shareFolder.iconCls=='external' && shareFolder.id==FM.activeAppPath){
FM.actPathIsExternal=true;
}
});

data.root.push({
text : '...',
path : '...',
type : 'multipath'
});
FM.nasRootStore.loadData(data);

if (Ext.isArray(RS) && RS.length > 0
&& parseInt(RS[0].id.lastIndexOf('/')) == 0) {
FM.shareAccess = [];
FM.shareNoSupportACL = [];
FM.recycleMap={};
for (var i = 0; i < RS.length; i++) {
FM.shareAccess[i] = {
id : RS[i].id,
access : RS[i].cls,
isoFolder : (RS[i].iconCls == 'iso'),
noSupportACL : (RS[i].noSupportACL == '1')
};
if (RS[i].noSupportACL == '1') {
FM.shareNoSupportACL.push(RS[i].id);
}
FM.recycleMap[RS[i].id.split('/').pop()]=RS[i].recycle_bin;
}
}

if(successFn){
successFn(RS);
}
if(FM.actPathIsExternal){
var node = FM.treeRoot.findChild('id', FM.activeAppPath, true);
if (node) {
node.select();
}
FM.fileListStore.baseParams.path = FM.activeAppPath;
FM.fileListStore.reload();
}
},
failure : function(res) {
}
});
},
showStorageInfoWin : function(path){
var FM = this;
var storageInfoWin;
if (!storageInfoWin) {
var autoCMId=Ext.id();
var storageInfoCM = new Ext.grid.ColumnModel([{
id:autoCMId,
header : _S._SFE_LANG_ACTION_SHARE_FOLDER,
qInternational : true,
qInternationalKey : '_SFE_LANG_ACTION_SHARE_FOLDER',
dataIndex : 'name',
width : 124,
sortable : true
}, {
header : _S._SFE_LANG_COMMON_DISK_USED,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_DISK_USED',
dataIndex : 'used_size',
width : 105,
align : 'right',
sortable : true,
resizable : false
}, {
header : _S._SFE_LANG_COMMON_STORAGE_POOL,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_DISK_USED',
dataIndex : 'pool_id',
width : 105,
align : 'center',
hidden : !FM.sysSetting.isHAL,
sortable : true,
resizable : false
}, {
header : _S._SFE_LANG_COMMON_DISK_VOLUME,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_DISK_VOLUME',
dataIndex : 'volume',
align : 'center',
width : 100,
sortable : true,
resizable : false
}, {
header : _S._SFE_LANG_COMMON_CAPACITY,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CAPACITY',
dataIndex : 'capacity',
align : 'right',
width : 105,
sortable : true,
resizable : false
}, {
header : _S._SFE_LANG_COMMON_FREE_SIZE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_FREE_SIZE',
dataIndex : 'free_size',
align : 'right',
width : 105,
sortable : true,
resizable : false
}, {
header : _S._SFE_LANG_MSG_STORAGE_VOLUME_STATUS,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_STORAGE_VOLUME_STATUS',
dataIndex : 'status',
width : 120,
align : 'center',
sortable : true,
resizable : false
}]);
var fnClick = 0;
var storageInfoStore = new Ext.data.ArrayStore({
remoteSort : false,
singleSort : function(fieldName, dir) {
var field = this.fields.get(fieldName);
if (!field) {
return false;
}
var name = field.name,
sortInfo = this.sortInfo || null,
sortToggle = this.sortToggle ? this.sortToggle[name] : null;

if (!dir) {
if (sortInfo && sortInfo.field == name) { // toggle sort dir
dir = (this.sortToggle[name] || 'DESC').toggle('DESC', 'ASC');
} else {
dir = (field.sortDir || 'DESC').toggle('DESC', 'ASC');
}
}

if (fieldName == 'used_size') {
name = 'usedSizeBit';
if (fnClick % 2 == 0) {
field.sortDir = 'ASC';
} else {
field.sortDir = 'DESC';
}
dir = field.sortDir;
fnClick++;
}

var task = new Ext.util.DelayedTask(function() {
var fnHeader = Ext.get(storageInfoGrid.view.getHeaderCell(1));
if (fieldName == 'used_size') {
if (fnClick % 2 == 0) {
fnHeader.removeClass('sort-asc');
fnHeader.addClass('sort-desc');
} else {
fnHeader.removeClass('sort-desc');
fnHeader.addClass('sort-asc');
}
} else {
fnHeader.removeClass('sort-asc');
fnHeader.removeClass('sort-desc');
}
});
task.delay(10);

this.sortToggle[name] = dir;
this.sortInfo = {
field : name,
direction :dir
};
this.applySort();
this.fireEvent('datachanged', this);
return true;
},
load:function (params){
var start=params.params.start,
end  =params.params.start+10,
goPage=params.params.start/10+1;
storagePagingbar.cursor=start;
storagePagingbar.inputItem.setValue(goPage);
storageInfoStore.removeAll();
if(end>dataArr.length){
end=dataArr.length;
storagePagingbar.next.disable();
storagePagingbar.last.disable();
}
storagePagingbar.setDispInfo(start+1,end,dataArr.length);
if(goPage<pages){
storagePagingbar.next.enable();
storagePagingbar.last.enable();
}
for(var i=start;i<end;i++){
storageInfoStore.add(dataArr[i]);
}
if(storagePagingbar.inputItem.getValue()>1){
storagePagingbar.prev.enable();
storagePagingbar.first.enable();
}else{
storagePagingbar.prev.disable();
storagePagingbar.first.disable();
}
getStgInfo();
},
fields : ['volume','name','unit','used_size','pool_id',
'volume_unit','capacity','free_size','volume_status',
'volume_encrypt','volume_mng_status','usedSizeBit']
});
var dataArr=[];
Ext.each(FM.shareFolders,function(sfolder){
if(sfolder.iconCls=='folder' && sfolder.text!=='home'){
var loadImg='<img src="/cgi-bin/apps/systemPreferences/images/spinner.gif" height="11px" width="11px"/>';
var record= new Ext.data.Record({
volume     :loadImg,
unit       :loadImg,
used_size  :loadImg,
volume_unit:loadImg,
capacity   :loadImg,
free_size  :loadImg,
status     :loadImg,
name       :sfolder.text});
dataArr.push(record);
}
})
var pages= Math.ceil(dataArr.length/10);
var len=dataArr.length;
if(len>10){
len=10;
}
for(var i=0;i<len;i++){
storageInfoStore.add(dataArr[i]);
}


var storagePagingbar = new Ext.PagingToolbar({
pageSize :10,
store : storageInfoStore,
displayInfo : true,
setDispInfo :function (v1,v2,v3) {
var d = "", displayItem = storagePagingbar.displayItem;
if (Ext.isArray(displayItem.displayMsg)) {
for (var e = 0; e < displayItem.displayMsg.length; e++) {
d += _S[displayItem.displayMsg[e]] || displayItem.displayMsg[e];
}
} else {
d = displayItem.displayMsg;
}
var msg = String.format(d,v1,v2,v3);
displayItem.setText(msg);
},
listeners : {
beforechange : function(pagingBar, params){
},
afterrender : function(bar) {
bar.refresh.hide();
}
}
});
function getStgInfo() {
storageInfoStore.each(function(record) {
Ext.Ajax.request({
url : QNAP.QOS.fileExplorerTools.tool
.getActionUrl('get_shared_folder_info'),
params : {
name : record.get('name'),
refresh : 1
},
success : function(resulte, rq) {
var data = Ext.util.JSON.decode(resulte.responseText).datas[0];
var rIndex = storageInfoStore.find('name', data.name);
var rcd = storageInfoStore.getAt(rIndex);
var vlmName = '';
if (FM.sysSetting.isHAL) {
vlmName = data.volume_name;
} else {
if (data.volume_name == '') {
vlmName = _S._SFE_LANG_COMMON_DRIVE + ' '
+ data.raid_disk_list;
} else {
vlmName = data.volume_name;
}
}
rcd.set('volume', vlmName);
rcd.set('unit', data.unit);
rcd.set('used_size', data.used_size + ' ' + data.unit);
rcd.set('usedSizeBit', QNAP.QOS.fileExplorerTools.tool.convertSize(data.used_size,data.unit));

if (data.pool_id && data.pool_id > 0) {
if (data.pool_id && data.pool_id > 0) {
rcd.set('pool_id', '<font color="#4396ce"><b>'
+ data.pool_id + '</b></font>');
} else {
rcd.set('pool_id', data.pool_id);
}
} else {
rcd.set('pool_id', '--');
}
rcd.set('volume_unit', data.volume_unit);
rcd.set('capacity', data.capacity + ' ' + data.volume_unit);
rcd.set('free_size', data.free_size + ' ' + data.volume_unit);
var vStatus = QNAP.QOS.fileExplorerTools.storageInfoStatusMap[data.volume_status];
if (data.volume_lock == 1) {
rcd.set('used_size', '--');
rcd.set('capacity', '--');
rcd.set('free_size', '--');
vStatus = _S._SFE_LANG_COMMON_LOCKED;
}
rcd.set('status', vStatus);
rcd.commit();
if (data.pool_id && data.pool_id > 0) {
var raidGrpStr = '';
var i = 0;
for (var key in data) {
if (key.indexOf('raid_id') == 0) {
var grpNum = key.substr(7, key.length);
raidGrpStr = raidGrpStr
+ _S._SFE_LANG_COMMON_RAID_GROUP + ' '
+ grpNum + '(RAID ' + data[key] + ')<br>';
}

}
var pool_status = '';
if (data.pool_status == 0) {
pool_status = _S._SFE_LANG_COMMON_READY;
} else if (data.pool_status == -1) {
pool_status = _S._SFE_LANG_COMMON_WARNING;
} else if (data.pool_status == -2) {
pool_status = _S._SFE_LANG_COMMON_NOT_READY;
} else if (data.pool_status == -3) {
pool_status = _S._SFE_LANG_COMMON_ERROR;
}
var vRcd = storageInfoGrid.getView().getRow(rIndex);
var tipHtml = '<table>' + '	<tr>' + '		<td>'
+ _S._SFE_LANG_COMMON_POOL_CAPACITY + ':　</td>'
+ '		<td>' + data.pool_capacity + '</td>'
+ '	</tr>' + '	<tr>' + '		<td>'
+ _S._SFE_LANG_COMMON_POOL_STATUS + ':　</td>'
+ '		<td>' + pool_status + '</td>' + '	</tr>'
+ '	<tr>' + '		<td style="vertical-align: top;">'
+ _S._SFE_LANG_COMMON_RAID_GROUP + ':</td>'
+ '		<td>' + raidGrpStr + '</td>' + '	</tr>'
+ '</table>';
new Ext.ToolTip({
target : Ext.get(vRcd).dom.childNodes[0].childNodes[0].childNodes[0].childNodes[2],
html : tipHtml,
dismissDelay : 60 * 60 * 1000,
cls : 'fsTip-cls'
});
}
},
failure : function(s) {
}
});
});
}
var storageInfoGrid = new Ext.grid.GridPanel({
title : _S._SFE_LANG_MSG_STORAGE_TITLE,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_STORAGE_TITLE',
minColumnWidth : 30,
enableColumnMove : false,
cm : storageInfoCM,
store : storageInfoStore,
itemId : 'storageInfoGrid',
width : 'auto',
autoHeight : true,
stripeRows : true,
autoExpandColumn : autoCMId,
enableHdMenu : false,
bbar : storagePagingbar,
viewConfig : {
scrollOffset :21//消除橫向scrollBar
},
listeners : {
show : function(grid) {

},
afterrender : function(grid) {
if(path){
var selIndex=storageInfoStore.find('name',path);
storageInfoGrid.getSelectionModel().selectRow(selIndex);
var view = grid.getView();
view.findRow(view.getRow(selIndex));
var task = new Ext.util.DelayedTask(function() {
view.focusRow(selIndex);
});
task.delay(500);
}
getStgInfo();
if(dataArr.length>10){
storagePagingbar.next.enable();
storagePagingbar.last.enable();
}
storagePagingbar.setDispInfo(1,len,dataArr.length);
storagePagingbar.afterTextItem.setText('/'+pages);
storagePagingbar.inputItem.setMaxValue(pages);
storagePagingbar.inputItem.setMinValue(1);
storageInfoStore.totalLength=dataArr.length;
}

}
});

storageInfoWin = FM._createModalWindow({
styleVer:1,
title : _S._SFE_LANG_MSG_STORAGE_INFO,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_STORAGE_INFO',
layout : 'fit',
width : 900,
autoHeight : true,
closeAction : 'hide',
cls : 'FM-Msg-cls onTheFlyCfmMsgWin-cls',
padding:'26px 60px 24px 60px',
plain : true,
resizable :true,
autoExpandColumn : 1,
items : [storageInfoGrid],
animCollapse : true,
listeners : {
resize : function(win, width, height) {
win.syncShadow();
}
},
buttons : [{
text : _S._SFE_LANG_COMMON_CLOSE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CLOSE',
handler : function() {
storageInfoWin.close();
}
}]
});
}
storageInfoWin.show();
},
showHtml5UPloadArea:function(maskel,position,size){
var FM=this;
if(!FM.html5DropWin){
var ufolderId=Ext.id();
FM.html5DropWin= new Ext.Window({
closable : false,
header : false,
border : false,
frame : false,
shadow : false,
resizable : false,
layout : 'fit',
width : 500,
height : 300,
html : _S._SFE_LANG_MSG_DRAG_FILE_HERE,
style : {
'background-color' : '#DDD',
border : '5px',
'border-style' : 'dashed',
'font-size' : '30px',
'text-align' : 'center',
display : 'table',
opacity : 0.5
},
listeners : {
afterrender : function(win) {
win.el.dom.childNodes[1].childNodes[0].style.display = 'table-cell';
win.el.dom.childNodes[1].childNodes[0].style['vertical-align'] = 'middle';
if (Ext.isIE10 || !Ext.isIE) {
document.getElementById(FM.html5DropWin.id)
.addEventListener('dragleave', function(e) {
e.preventDefault();
FM.html5DropWin.hide();
}, false);
document.getElementById(FM.html5DropWin.id)
.addEventListener('dragover', function(e) {
e.preventDefault();
e.dataTransfer.dropEffect = 'copy';
}, false);
document.getElementById(FM.html5DropWin.id)
.addEventListener('drop', function(event) {
event.preventDefault();
FM.html5DropWin.hide();
var inputFiles = event.dataTransfer.files;
var inputItems = event.dataTransfer.items;
var files = [];
if (inputFiles.length == 0) {
return;
}
os.openApp('FileUploadMgr', {
sid : FM.QsyncSid,
path : FM.fileListStore.baseParams.path,
appendEvent : 'html5',
files : inputItems || inputFiles,
e : event,
startUpload : true,
tabNum : 1,
autoShow : false
});

}, false);
}
},
beforeshow : function(win) {
FM.html5DropWin.setPosition(maskel.getXY());
var winW = maskel.getSize().width, winH = maskel
.getSize().height;
if (winW + maskel.getXY()[0] > document.documentElement.clientWidth) {
winW = document.documentElement.clientWidth
- maskel.getXY()[0];
}
FM.html5DropWin.setSize(winW - 5, winH - 5);
},
show : function(win) {
var fsWinEl = Ext.get(FM.fsWinId);
FM.html5DropWin.el.dom.style.zIndex = Ext
.num(fsWinEl.dom.style.zIndex)
+ 1;
}
}
});
}
if(FM.gridPanel.isVisible() || (FM.NasDataView && FM.NasDataView.isVisible())){
FM.html5DropWin.show();
}
},
hideSwitchBtn:function(btnName){
var FM = this;
var swichModeBtn=Ext.getCmp(FM.northPanelId).getComponent('switchModeGroup');
if(btnName){
if(btnName=='mode2Btn'){
swichModeBtn.getComponent('mode2Btn').hide();
swichModeBtn.getComponent('mode1Btn').addClass('switchModeBtnL-cls');
swichModeBtn.getComponent('mode1Btn').removeClass('switchModeBtnM-cls');
swichModeBtn.getComponent('mode1Btn').removeClass('switchModeBtnM-cls');
}else{
swichModeBtn.getComponent('mode1Btn').addClass('switchModeBtnM-cls');
swichModeBtn.getComponent('mode1Btn').removeClass('switchModeBtnL-cls');
}
if(QNAP.QOS.user.viewMode=='V2'){
FM.switchViewMode('V3');
swichModeBtn.getComponent('mode3Btn').pressed=true;
swichModeBtn.getComponent('mode3Btn').addClass('x-btn-pressed');
swichModeBtn.getComponent('mode2Btn').pressed=false;
swichModeBtn.getComponent('mode2Btn').removeClass('x-btn-pressed');
}else{
FM.switchViewMode(QNAP.QOS.user.viewMode);
}
}else{
Ext.each(swichModeBtn.items.items,function(btn){
btn.show()
});
swichModeBtn.getComponent('mode1Btn').addClass('switchModeBtnM-cls');
swichModeBtn.getComponent('mode1Btn').removeClass('switchModeBtnL-cls');
}

Ext.getCmp(FM.northPanelId).doLayout();
},
setCopyMoveCls : function(){//剪貼簿中的檔案掛上不同的style
var FM=this;
var i=0;
Ext.each(FM.fileListStore.data.items,function(record){
Ext.get(FM.gridPanel.getView().getRow(i)).removeClass('copy-cls');
Ext.get(FM.gridPanel.getView().getRow(i)).removeClass('move-cls');
var fullfileName = FM.currentPath + '/' + record.get('filename');
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(record.get('filename'))) {
fullfileName = record.get('filename');
}
if (!Ext.isEmpty(QNAP.QOS.FileClipBoard.fileList)
&& !Ext.isEmpty(QNAP.QOS.FileClipBoard.filePathMap[fullfileName])) {
Ext.get(FM.gridPanel.getView().getRow(i)).addClass(QNAP.QOS.FileClipBoard.copyMove + '-cls');
}
i++;
});



},
goPath:function(btn){
var FM=this;
var selNode = FM.treePanel.getSelectionModel().selNode;
if (selNode.id == 'recycleBin') {
if (btn.myPath == 'recycleBin') {
FM.showRecycleBinGrid();
} else {
FM.fileListStore.baseParams.path = btn.myPath;
FM.fileListStore.reload();
}
} else {
if (FM.currentHost == 'NAS') {
FM.loadPath(btn.myPath, '', true, true);
} else if (FM.currentHost == 'Client') {
var separator = FM.clientFileStore.separator;
FM.loadClientPath(btn.myPath, '', true, true, separator);
}
FM.addMemPath(btn.myPath);
}
var swichModeBtn = Ext.getCmp(FM.northPanelId).getComponent('switchModeGroup');
if (swichModeBtn.hidden && FM.gridPanel && FM.gridPanel.isVisible()) {
FM.setMainScr('file-panel');
}
if (swichModeBtn.hidden && FM.NasDataView && FM.NasDataView.isVisible()) {
FM.setMainScr('NasDataView-id');
}

},
addMemPath:function(path){

var FM=this;
if(!path || path==FM.memPthsArr[FM.memPthsArr.length-1]){
return;
}

if(FM.memPthsArr.length!=0 && (FM.stepIndex != FM.memPthsArr.length-1)){
var popNum=FM.memPthsArr.length-1-FM.stepIndex;
for(var i=0;i<popNum;i++){
FM.memPthsArr.pop();
}
}
FM.memPthsArr.push(path);
FM.stepIndex=FM.memPthsArr.length-1;
FM.checkStepIndex();
},
preStep:function(){
var FM=this;
FM.openPath(FM.memPthsArr[FM.stepIndex-1]);
FM.stepIndex=FM.stepIndex-1;
FM.checkStepIndex();
},
nextStep:function(){
var FM=this;
FM.openPath(FM.memPthsArr[FM.stepIndex+1]);
FM.stepIndex=FM.stepIndex+1;
FM.checkStepIndex();
},
checkStepIndex:function(){
var FM=this;
FM.pathPanel.getComponent('preBtn').enable();
FM.pathPanel.getComponent('nextBtn').enable();
if(FM.stepIndex == FM.memPthsArr.length-1){
FM.pathPanel.getComponent('nextBtn').disable();
}
if(FM.stepIndex == 0){
FM.pathPanel.getComponent('preBtn').disable();
}

},
openWidthExtension:function(file){
var FM=this;
if (FM.isOfficeExtInst) {
FM.open(file);
} else {
var msgTxt = _S._SFE_LANG_MSG_INSTALL_CHROME_EXTENTION
.replace('<qtag>','<br><a target="_blank" href="https://chrome.google.com/webstore/detail/office-editing-for-docs-s/gbkeegbaiigmenfmjfclcdgdpimamgkj">')
.replace('</qtag>','</a>');
var msgObj = {
text : msgTxt
};
var btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM, 'info', msgObj,
btns);
MsgWin.show();
}
},
shareMenu :function(){
var Menu;
var FM=this;
if(!Menu){
Menu =new Ext.menu.Menu({
x : 1 - 10,
cls : 'FM-moreActionMenuList-cls',
listeners : {
show : function(cmp){
cmp.removeClass('qnap-menu-v2');
if(FM.isWFM || (!QNAP.QOS.user.isAdminGroup && FM.sysSetting.share_nas_user==1)){
cmp.getComponent('share2uer').hide();
}else{
cmp.getComponent('share2uer').show();
}
cmp.doLayout();
}
},
items : [{
itemId : 'viaEmailBtn',
text : _S._SFE_LANG_COMMON_VIA_EMAIL,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_VIA_EMAIL',
handler : function() {
var pathFiles = QNAP.QOS.fileExplorerTools.tool.getPathFiles(FM.gridPanel,Menu.parentMenu,FM.treeNodeId);
QNAP.QOS.fileExplorerAction.getShareWin15.call(FM,0,pathFiles);
}
}, {
itemId : 'toSocialBtn',
text : _S._SFE_LANG_COMMON_TO_SOCIAL_NETWORK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_TO_SOCIAL_NETWORK',
handler : function() {
var pathFiles = QNAP.QOS.fileExplorerTools.tool.getPathFiles(FM.gridPanel,Menu.parentMenu,FM.treeNodeId);
QNAP.QOS.fileExplorerAction.getShareWin15.call(FM,1,pathFiles);
}
}, {
itemId : 'createLinkBtn',
text : _S._SFE_LANG_COMMON_CREATE_LINK_ONLY,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CREATE_LINK_ONLY',
handler : function() {
var pathFiles = QNAP.QOS.fileExplorerTools.tool.getPathFiles(FM.gridPanel,Menu.parentMenu,FM.treeNodeId);
QNAP.QOS.fileExplorerAction.getShareWin15.call(FM,2,pathFiles);
}
}, {
itemId : 'share2uer',
text : _S._SFE_LANG_COMMON_TO_NAS_USER,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_TO_NAS_USER',
handler : function(cmp) {
var pathFiles = QNAP.QOS.fileExplorerTools.tool.getPathFiles(FM.gridPanel,Menu.parentMenu,FM.treeNodeId);
QNAP.QOS.fileExplorerAction.getShareWin15.call(FM,3,pathFiles);
}
}]
});
}
return Menu;
},
nasTreeNodeClick : function(node){
var FM = this;
if (node.folderType == 'volumeNode') {
if(node.expanded){
node.collapse();
}else{
node.expand();
}
return;
}
FM.actPathIsExternal=(node.attributes.iconCls=='usb-cls');

FM.fileListStore.baseParams.noSupportACL = node.attributes.data.noSupportACL;
FM.fileListStore.baseParams.path = node.id;
FM.fileListStore.baseParams.is_iso = node.attributes.data.isoFolder;
FM.fileListStore.baseParams.access = node.attributes.data.access;
FM.fileListStore.folderType = node.folderType;
FM.currentHost = 'NAS';
FM.searchMode = false;
var northPanel = Ext.getCmp(FM.northPanelId);
var eastPanelBtn = northPanel.items.items[northPanel.items.items.length - 1];
if (eastPanelBtn.pressed) {
FM.setPropertyPanelInfo(null, node.id);
}
if (FM.volMap) {
var volId = FM.volMap['/' + node.id.split('/')[1]];
FM.currentVolTreeNode = FM.findVolNode(volId);
}
if (node.folderType == 'rmtFolder') {
FM.RTT = false;
FM.isOpenMediaLib = false;
} else {
FM.isOpenMediaLib = QNAP.QOS.fileExplorerTools.config.isOpenMediaLib;
FM.RTT = QNAP.QOS.fileExplorerTools.config.supportRTT;
}

var swichModeBtn = Ext.getCmp(FM.northPanelId).getComponent('switchModeGroup')
.getComponent('mode2Btn');
if (swichModeBtn.pressed) {
FM.setMainScr('NasDataView-id');
} else {
FM.setMainScr('file-panel');
}
FM.fileListStore.load({
params : {
start : 0,
limit : QNAP.QOS.user.pageSize.wfm_file_list_page_size || 50
}
});
var shareFolder = '/' + (node.id.split('/')[1]);
QNAP.lib.cookie.set('treeRootPath' + QNAP.QOS.user.account, shareFolder, 60* 60 * 24 * 7);
FM.addMemPath(node.id);
if (node.folderType != 'shareFolder') {
FM.eastTab.getComponent('permissionPanel').disable();
if (FM.eastTab.getActiveTab()
&& FM.eastTab.getActiveTab().itemId == 'permissionPanel') {
FM.eastTab.setActiveTab(0);
}
} else {
FM.eastTab.getComponent('permissionPanel').enable();
}
var selNode = FM.treePanel.getSelectionModel().selNode;
if (node.attributes.iconCls != 'folder') {
if (FM.eastTab) {
FM.eastTab.getComponent('permissionPanel').disable();
if (FM.eastTab.getActiveTab()&& FM.eastTab.getActiveTab().itemId == 'permissionPanel') {
FM.eastTab.setActiveTab(0);
}
}
} else {
FM.eastTab.getComponent('permissionPanel').enable();
}
if (node instanceof QNAP.QOS.FM.Remote.FolderNode) {
FM.eastTab.getComponent('permissionPanel').disable();
FM.eastTab.setActiveTab(0);
}

},
findVolNode : function(volId) {
var FM=this;
var volNode;
Ext.each(FM.nasRoot.childNodes, function(vn) {
if (volId == vn.id) {
volNode = vn;
}
});
return volNode;
},
getShareFolderInfo : function(shareFolder) {

var FM=this;
var treeNode;

Ext.each(FM.shareFolders, function(sfd) {
if(sfd.id == shareFolder){
treeNode=sfd;
}
});
if(!treeNode){
if(FM.propertyPanel.getComponent('otherSettings') && FM.propertyPanel.getComponent('otherSettings').isVisible()){
FM.propertyPanel.getComponent('otherSettings').hide();
FM.propertyPanel.getComponent('otherSettings').body.hide();
FM.propertyPanel.getComponent('otherSettings').setHeight(0);
}
return;
}
var data=treeNode;
if (!Ext.isEmpty(data.pool_id)) {
if (Ext.isEmpty(data.volume_name) && data.iconCls == 'usb-cls') {
vlmName = data.id.replace('/', '');
} else {
vlmName = data.volume_name;
}
} else {
if (Ext.isEmpty(data.volume_name)) {
if (data.iconCls == 'usb-cls') {
vlmName = data.id.replace('/', '');
} else {
vlmName = _S._SFE_LANG_COMMON_DRIVE + ' ' + data.raid_disk_list;
}
} else {
vlmName = + data.volume_name;
}
}
FM.propertyPanel.getComponent('volume').setValue(vlmName);
var pool_id='';
if (data.pool_id && data.pool_id > 0) {
pool_id=data.pool_id;
} else {
pool_id='--';
}
FM.propertyPanel.getComponent('pool').setValue(pool_id);
var chkTypeValue = (treeNode.iconCls=='folder' || treeNode.iconCls=='external');
if(!Ext.isDefined(FM.propertyPanel) || !Ext.isDefined(shareFolder)){
return;
}

if(shareFolder && shareFolder.split('/').length==2 && FM.propertyPanel.isVisible()
&& treeNode.iconCls!='iso' && treeNode.id.split('/')[1]!='home'
&& QNAP.QOS.user.isAdminGroup && !FM.isWFM){
FM.propertyPanel.getComponent('otherSettings').show();
FM.propertyPanel.getComponent('otherSettings').body.show();
FM.propertyPanel.getComponent('otherSettings').setHeight(260);
var form=FM.propertyPanel.getForm();

var obj1={
share_name:shareFolder,
successFn:Ext.emptyFn//setFolderInfo
};
QNAP.QOS.fileExplorerTools.tool.getFolderInfo(obj1);
function encryptData_trFn(rps){
if (rps.SupportSamba4 == 'yes') {
FM.propertyPanel.getComponent('otherSettings').getComponent('encryptData_tr').show();
form.findField('encryptData_1').setDisabled(!(rps.SupportSMBEncrypt == 'yes'));
} else {
FM.propertyPanel.getComponent('otherSettings').getComponent('encryptData_tr').hide();
}

form.findField('recycle_bin_group').setVisible(treeNode.recycle_folder=='yes');
form.findField('recycle_bin_admin').setVisible(treeNode.recycle_folder=='yes');
form.findField('recycle_bin_group').setValue(rps.recyclePerShare==1);
form.findField('recycle_bin_admin').setValue(rps.recycleAdministratorsOnly==1);
if(rps.recyclePerShare==1){
form.findField('recycle_bin_admin').enable();
}else{
form.findField('recycle_bin_admin').disable();
}
form.findField('share_hidden_yes').setValue(rps.hidden==1);
form.findField('oplocks_1').setValue(rps.oplocks==1);
form.findField('ftp_wonly').setValue(rps.ftp_wonly==1);
FM.propertyPanel.getComponent('otherSettings').getComponent('ftp_wonly_div').setVisible(chkTypeValue);
form.findField('mangled').setValue(rps.mangled!='yes');
FM.propertyPanel.getComponent('otherSettings').doLayout();
}
var obj2={
shareName:shareFolder,
successFn:encryptData_trFn
};

QNAP.QOS.fileExplorerTools.tool.getSMB_Encryp(obj2);
}else{
if(FM.propertyPanel.isVisible()){
FM.propertyPanel.getComponent('otherSettings').hide();
FM.propertyPanel.getComponent('otherSettings').setHeight(0);
}
}
},// getShareFolderInfo End
showShare2MeRMenu : function(grid, index, e) {
var FM=this;
var selections=grid.getSelectionModel().getSelections();
var file=selections[0];
Ext.each(FM.share2MeRMenu.items.items,function(btn){
btn.hide();
});
if(selections.length==1){
FM.share2MeRMenu.getComponent('copyBtn').show();
FM.share2MeRMenu.getComponent('openBtn').show();
FM.share2MeRMenu.getComponent('downloadBtn').show();
}
var mediaType = QNAP.QOS.fileExplorerTools.tool.getMultiMediaType(file.get('filename'));
if(mediaType == 'isVideo') {
FM.share2MeRMenu.getComponent('playShareBtn').show();
}else{
FM.share2MeRMenu.getComponent('playShareBtn').hide();
}
FM.share2MeRMenu.showAt(e.getXY());
FM.share2MeRMenu.doLayout();
},
onBroadcast : function(parms) {
var FM = this;
if(parms.data=='personal_email' && FM.shareWin15 && FM.shareWin15.getComponent('shareTab')){
FM.shareWin15.getComponent('shareTab').getComponent('emailPanel').getComponent('sendByEmail').store.reload();
}
if(parms.action=='quotaChange'){
FM.sysSetting.enableQuota=parms.data;
if(!Ext.isEmpty(Ext.getCmp(FM.IDS.QUOTA))){
var qtField=Ext.getCmp(FM.IDS.QUOTA);
qtField.enable();
qtField.setDisabled(!FM.sysSetting.enableQuota);
if(!FM.sysSetting.enableQuota){
qtField.setValue('');
}
}
}
},
setFileThumb:function(index){
var FM=this;
var thumbStatus=QNAP.QOS.fileExplorerTools.config.getThumbStatus;
var records=FM.fileListStore.data.items;
if (index >= records.length) {
return;
}
var record = records[index];
var rowIndex=index;
if (record.get('thumbStatus') != thumbStatus.watting) {
rowIndex++;
FM.setFileThumb(rowIndex);
return;
}

record.data.thumbStatus = thumbStatus.getting;
var gridView = FM.gridPanel.getView();
var thumbViewChildNodes;
if(FM.NasDataView && FM.NasDataView.isVisible()){
thumbViewChildNodes=FM.NasDataView.el.dom.childNodes;
}
var tmpFilename = record.get('filename');
var path = FM.currentPath;
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(tmpFilename)) {
var fp = QNAP.QOS.fileExplorerTools.tool.getFileNamPath(tmpFilename);
tmpFilename = fp[0];
path = fp[1];
}
if(path=='qsyncRoot'){
path='/home/.Qsync';
}
var mimeImage = '/cgi-bin/filemanager/utilRequest.cgi?sid='
+ QNAP.QOS.user.sid + '&func=get_thumb&path='
+ encodeURIComponent(path) + '&name='
+ encodeURIComponent(tmpFilename) + '&size='
+ FM.defineds.thumbnailSizes.small + '&radno=' + record.get('filesize')
+ record.get('randno');
if(path.indexOf(FM.sysSetting.ubuntu_home_path)==0){
mimeImage=mimeImage+'&src_flag=ubuntu';
}
var Img = new Image();
Ext.get(Img).addClass('MultiMedia-icon');
Img.src = mimeImage;
Img.timeOutFn = new Ext.util.DelayedTask(function() {
if (Img.isloaded) {
return;
}
var errorImg = new Image(16, 16);
errorImg.src = '/v3_menu/pic/s100photo.png';
Ext.get(gridView.getCell(index, 1).firstChild.firstChild).remove();
gridView.getCell(index, 1).firstChild.appendChild(errorImg);
if (FM.NasDataView && FM.NasDataView.isVisible()) {
Ext
.get(thumbViewChildNodes[index].firstChild.firstChild.firstChild)
.remove();
thumbViewChildNodes[index].firstChild.firstChild
.appendChild(errorImg);
}
record.data.thumbStatus = thumbStatus.fail;
});
Img.timeOutFn.delay(10000);
Img.onload = function() {
Img.isloaded = true;
record.set('thumbStatus', 2);
record.commit();
var htmltip = document.createAttribute("data-htmltip");
htmltip.value = true;
Img.attributes.setNamedItem(htmltip);// tip改為 支援HTML與法
var addTipImage = '/cgi-bin/filemanager/utilRequest.cgi?sid='
+ QNAP.QOS.user.sid + '&func=get_thumb&path='
+ encodeURIComponent(path) + '&name='
+ encodeURIComponent(tmpFilename) + '&size='
+ FM.defineds.thumbnailSizes.large + '&radno=' + record.get('filesize')
+ record.get('randno');
if(path.indexOf(FM.sysSetting.ubuntu_home_path)==0){
addTipImage=addTipImage+'&src_flag=ubuntu';
}
var addTip = '<div class=\'q-fileExplorer-qtip\'><img src="'
+ addTipImage
+ '" '
+ 'onload=\'\' class=\'FSqtip\' width=\'Ext.get(this).dom.width\'></div>';
Img.setAttribute('ext:qtitle', '');
Img.setAttribute('ext:qwidth', 'auto');
Img.setAttribute('ext:qtip', addTip);
if (gridView.getCell(index, 1).firstChild.firstChild) {
Ext.get(gridView.getCell(index, 1).firstChild.firstChild).remove();
}
gridView.getCell(index, 1).firstChild.appendChild(Img);
if(FM.NasDataView && FM.NasDataView.isVisible()){
Ext.get(thumbViewChildNodes[index].firstChild.firstChild.firstChild).remove();
thumbViewChildNodes[index].firstChild.firstChild.appendChild(Img);
}
rowIndex++;
FM.setFileThumb(rowIndex);
}

},//setFileThumb
setShareThumb :function(index,grid){
var FM=this;
var thumbStatus=QNAP.QOS.fileExplorerTools.config.getThumbStatus;
var store=grid.store;
var records=store.data.items;
if (index >= records.length) {
return;
}
var record = records[index];
var rowIndex=index;
if (record.get('thumbStatus') != thumbStatus.watting) {
rowIndex++;
FM.setShareThumb(rowIndex,grid);
return;
}

record.data.thumbStatus = thumbStatus.getting;
var gridView = grid.getView();
var tmpFilename = record.get('filename');
var path = FM.currentPath;
if (QNAP.QOS.fileExplorerTools.tool.isSearchOutFile(tmpFilename)) {
var fp = QNAP.QOS.fileExplorerTools.tool.getFileNamPath(tmpFilename);
tmpFilename = fp[0];
path = fp[1];
}
var ssid = record.get('ssid'), fid = '', param = '';
if (store.itemId == 'share2MeStore') {
fid = record.get('ssid');
} else if (store.itemId == 'shareFolderCTNStore') {
ssid = store.baseParams.ssid;
fid = store.baseParams.fid;
if (Ext.isEmpty(fid)) {
fid = store.baseParams.ssid;
}
param = '&name=' + encodeURIComponent(record.get('filename')) + '&path='
+ store.baseParams.path;
} else if (store.itemId == 'shareSubListStore') {
fid = record.get('fid');
}
imgHtml =  QNAP.QOS.fileExplorerTools.config.shareCgi
+ '?func=get_thumb&size=100&ssid=' + ssid + '&fid=' + fid + param;
var Img = new Image();
Ext.get(Img).addClass('MultiMedia-icon');
Img.src = imgHtml;
Img.timeOutFn = new Ext.util.DelayedTask(function() {
if (Img.isloaded) {
return;
}
var errorImg = new Image(16, 16);
errorImg.src = '/v3_menu/pic/s100photo.png';
Ext.get(gridView.getCell(index, 0).firstChild.firstChild).remove();
gridView.getCell(index, 0).firstChild.appendChild(errorImg);
if(FM.NasDataView && FM.NasDataView.isVisible()){
Ext.get(thumbViewChildNodes[index].firstChild.firstChild.firstChild).remove();
thumbViewChildNodes[index].firstChild.firstChild.appendChild(errorImg);
}
record.data.thumbStatus = thumbStatus.fail;
});
Img.timeOutFn.delay(10000);
Img.onload = function() {
Img.isloaded = true;
record.set('thumbStatus', 2);
record.commit();
var htmltip = document.createAttribute("data-htmltip");
htmltip.value = true;
Img.attributes.setNamedItem(htmltip);// tip改為 支援HTML與法
var addTipImage = '/cgi-bin/filemanager/utilRequest.cgi?sid='
+ QNAP.QOS.user.sid + '&func=get_thumb&path='
+ encodeURIComponent(path) + '&name='
+ encodeURIComponent(tmpFilename) + '&size='
+ FM.defineds.thumbnailSizes.large + '&radno=' + record.get('filesize')
+ record.get('mt');
var addTip = '<div class=\'q-fileExplorer-qtip\'><img src=\''
+ addTipImage
+ '\' '
+ 'onload=\'\' class=\'FSqtip\' width=\'Ext.get(this).dom.width\'></div>';
Img.setAttribute('ext:qtitle', '');
Img.setAttribute('ext:qwidth', 'auto');
Img.setAttribute('ext:qtip', addTip);
if (gridView.getCell(index, 0).firstChild.firstChild) {
Ext.get(gridView.getCell(index, 0).firstChild.firstChild).remove();
}
gridView.getCell(index, 0).firstChild.appendChild(Img);
if(FM.NasDataView && FM.NasDataView.isVisible()){
Ext.get(thumbViewChildNodes[index].firstChild.firstChild.firstChild).remove();
thumbViewChildNodes[index].firstChild.firstChild.appendChild(Img);
}
rowIndex++;
FM.setShareThumb(rowIndex,grid);
}

},//setShareThumb end
showSettingWin : function(goTabIndex){
var FM=this;
var OptionWin, permission;
if (!OptionWin) {
OptionWin = FM._createModalWindow({
styleVer:1,
title : _S._SFE_LANG_COMMON_OPTION,// Options',
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OPTION',
width : 500,
autoHeight : true,
closeAction : 'hide',
plain : true,
items : {
xtype : 'tabpanel',
itemId : 'settingTab',
activeItem : 0,
autoHeight : true,
listeners : {
tabchange : function(tabpanel, tab) {
if (tab instanceof QNAP.QOS.FM.Remote.PermissionManagement) {
if (OptionWin.buttons[0] instanceof Ext.Button) {
OptionWin.buttons[0].show();
}
} else {
if (OptionWin.buttons[0] instanceof Ext.Button) {
OptionWin.buttons[0].hide();
}
}
},
afterrender : function(cmp) {
if(!Ext.isEmpty(goTabIndex))
cmp.setActiveTab(goTabIndex);
}
},
items : (function() {
var items = [new Ext.form.FormPanel({
xtype : 'form',
itemId : 'middlePanel',
layout : 'form',
labelWidth : 100,
border : false,
autoHeight : true,
style : 'font-size:12px;',
title : _S._SFE_LANG_COMMON_GENERAL,// 'GENERAL',
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_GENERAL',
bodyStyle : {
padding : '30px 60px 30px 60px',
'overflow-x' : 'hidden',
'overflow-y' : 'auto'
},
items : [{
xtype : 'fieldset',
cls : 'fieldset1-cls',
items : [{
xtype : 'checkbox',
name : 'isShowFileFolder',
cls : 'isShowFileFolder-cls',
boxLabel : _S._SFE_LANG_OPTIONS_SHOW_FILE_FOLDER,
qInternational : true,
qInternationalKey : '_SFE_LANG_OPTIONS_SHOW_FILE_FOLDER',
hideLabel : true,
disabled : !deployJava.versionCheck('1.6+'),
checked : QNAP.QOS.user.fe_isShowFileFolder === 'true'
&& deployJava.versionCheck('1.6+'),
handler : function() {
var cmp = this;
if (this.getValue()) {
FM.treeRoot.findChild('id', 'clientRoot').ui
.show();
} else {
FM.treeRoot.findChild('id', 'clientRoot').ui
.hide();
}
os.saveConfig('fe_isShowFileFolder', this
.getValue());
QNAP.QOS.user.fe_isShowFileFolder = this
.getValue().toString();
FM.checkApplet();
}
}, {
xtype : 'checkbox',
name : 'isShowHideFile',
ctCls : 'isShowHideFile-cls',
boxLabel : _S._SFE_LANG_OPTIONS_SHOW_HIDE_FILE,
qInternational : true,
qInternationalKey : '_SFE_LANG_OPTIONS_SHOW_HIDE_FILE',
cmargins : '0 23 0 0',
hideLabel : true,
checked : !Ext
.isEmpty(QNAP.QOS.user.fe_isShowHideFile)
&& QNAP.QOS.user.fe_isShowHideFile !== 'false',
handler : function() {
os.saveConfig('fe_isShowHideFile', this
.getValue());
QNAP.QOS.user.fe_isShowHideFile = this
.getValue().toString();
FM.gridPanel.store.reload();
var selNode = FM.treePanel.getSelectionModel().selNode;
if(selNode)
selNode.reload();
}
}, {
xtype : 'checkbox',
name : 'shareLinkAllowAll',
ctCls : 'isShowHideFile-cls',
boxLabel : _S._SFE_LANG_SHARE_LINK_SETTING,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARE_LINK_SETTING',
cmargins : '0 23 0 0',
hideLabel : true,
hidden : !QNAP.QOS.user.isAdminGroup,
checked : FM.sysSetting.share_link_allow_all_create == 1,
handler : function(checked) {
QNAP.QOS.fileExplorerAction.setIsAllowAllShare
.call(FM, this.getValue());
},
listeners : {
afterrender : function(cmp) {
QNAP.QOS.fileExplorerAction
.getIsAllowAllShare(FM, cmp);
}
}
}, {
xtype : 'checkbox',
name : 'isShowThumbnail',
ctCls : 'isShowHideFile-cls',
boxLabel : _S._SFE_LANG_COMMON_GENERATE_THUMBNAILS,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_GENERATE_THUMBNAILS',
cmargins : '0 23 0 0',
hideLabel : true,
hidden : QNAP.QOS.user.account != 'admin',
checked : FM.sysSetting.thumbnail == 1,
handler : function(checked) {
QNAP.QOS.fileExplorerAction.setIsShowThumbnail
.call(FM, this.getValue());
},
listeners : {
afterrender : function(cmp) {
}
}
}, {
xtype : 'checkbox',
name : 'isShowNetworkRecycleBin',
cls : 'isShowNetworkRecycleBin-cls',
boxLabel : _S._SFE_LANG_OPTIONS_SHOW_NETWORK_RECYCLE_BIN,
qInternational : true,
qInternationalKey : '_SFE_LANG_OPTIONS_SHOW_NETWORK_RECYCLE_BIN',
hideLabel : true,
checked : QNAP.QOS.user.fe_isShowNetworkRecycleBin != 'false',
handler : function() {
var qNode = FM.treeRoot.findChild('id',
'qsyncRoot');
if (!this.getValue()) {
qNode.findChild('id', 'qsyncRecycle').ui.hide();
} else if (this.getValue()) {
qNode.findChild('id', 'qsyncRecycle').ui.show();
}
os.saveConfig('fe_isShowNetworkRecycleBin',this.getValue());
QNAP.QOS.user.fe_isShowNetworkRecycleBin = this.getValue().toString();
Ext.getCmp(FM.northPanelId).getComponent('refreshBtn').handler();
FM.showTreeRecycle(this.getValue());
}
}, {
xtype : 'checkbox',
cls : 'isShowNetworkRecycleBin-cls',
boxLabel : _S._SFE_LANG_MSG_ONLY_ALLOW_ADMIN,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_ONLY_ALLOW_ADMIN',
hideLabel : true,
checked : FM.sysSetting.share_nas_user == 1,
hidden : !QNAP.QOS.user.isAdminGroup,
handler : function() {
QNAP.QOS.fileExplorerAction.setEveryoneShare.call(FM, this.getValue());
}
}, {
xtype : 'checkbox',
cls : 'isShowNetworkRecycleBin-cls',
boxLabel : _S._SFE_LANG_MSG_ONLY_ADMIN_DEL_PERMANENTLY,
qInternational : true,
qInternationalKey : '_SFE_LANG_MSG_ONLY_ADMIN_DEL_PERMANENTLY',
qInternationalFn : function(cmp){
Ext.QuickTips.register({
target : cmp.hintImgId,
text : _S._SFE_LANG_MSG_ENABLE_RECYCLE_BIN,
enabled : true
});
},
hideLabel : true,
checked : FM.sysSetting.delete_permanently_admins_only == 1,
hidden : !QNAP.QOS.user.isAdminGroup,
disabled : FM.sysSetting.recycle_bin_enable != 1,
listeners : {
afterrender : function(cmp) {
if (FM.sysSetting.recycle_bin_enable != 1) {
cmp.hintImgId=Ext.id();
cmp.positionEl.dom.innerHTML = cmp.positionEl.dom.innerHTML
+ '  <img id="'+cmp.hintImgId+'" data-htmltip="true" src="'
+ QNAP.QOS.fileExplorerTools.config.infoImg
+ '" ext:qtip="'
+ _S._SFE_LANG_MSG_ENABLE_RECYCLE_BIN
+ '"/>';
}
}
},
handler : function() {
QNAP.QOS.fileExplorerAction.setDelPermission.call(FM, this.getValue());
}
}]
}]
})];
if (QNAP.QOS.user.account == 'admin' && !FM.isWFM) {
items.push((permission = new QNAP.QOS.FM.Remote.PermissionManagement));
}
return items;
})()
},
buttons : [{
text : _S._SFE_LANG_SHARELINK_APPLY,
qInternational : true,
qInternationalKey : '_SFE_LANG_SHARELINK_APPLY',
handler : function() {
permission.apply();
}
}, {
text : _S._SFE_LANG_COMMON_CLOSE,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_CLOSE',
handler : function() {
OptionWin.close();
}
}]
});
}
OptionWin.show();
},//showSettingWin end
qmailOpen : function (path,file){
var FM=this;

var gUser_msgObj = {
text : _S._SFE_LANG_MSG_NO_QMAIL_CALL_ADMIN,
key : '_SFE_LANG_MSG_NO_QMAIL_CALL_ADMIN'
};
var gUser_btns = [{
text : _S._SFE_LANG_COMMON_OK,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_OK',
handler : function() {
gUser_MsgWin.close();
}
}];
var gUser_MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM, 'info', gUser_msgObj, gUser_btns);
if(os.getQPKG('qmail') && os.getQPKG('qmail').data.enable=='TRUE'){
FM.sysSetting.qmail=1;
}else if(os.getQPKG('qmail') && os.getQPKG('qmail').data.enable=='FALSE'){
FM.sysSetting.qmail=0;
}else{
FM.sysSetting.qmail=-1;
}
if(FM.sysSetting.qmail==1){
os.openURL(FM.sysSetting.qmail_open_url+encodeURIComponent(path)+'/'+encodeURIComponent(file.get('filename')));
}else if(FM.sysSetting.qmail==0){
if(QNAP.QOS.user.isAdminGroup){
var msgObj = {
text : _S._SFE_LANG_MSG_NO_ENABLE_QMAIL,
key : '_SFE_LANG_MSG_NO_ENABLE_QMAIL'
};
var btns = [{
text : _S._SFE_LANG_COMMON_YES,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_YES',
handler : function() {
os.openApp('qpkg',{appId : 'qpkg',config : {install : 'qmail',all : true,runMore:true}});
MsgWin.close();
}
},{
text : _S._SFE_LANG_COMMON_NO,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_NO',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM, 'info', msgObj, btns);
MsgWin.show();
}else{
gUser_MsgWin.show();
}
}else {// -1 : not install
if(QNAP.QOS.user.isAdminGroup){
var msgObj = {
text : _S._SFE_LANG_MSG_INSTALL_QMAIL,
key : '_SFE_LANG_MSG_INSTALL_QMAIL'
};
var btns = [{
text : _S._SFE_LANG_COMMON_YES,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_YES',
handler : function() {
os.openApp('qpkg',{appId : 'qpkg',config : {install : 'qmail',all : true,runMore:true}});
MsgWin.close();
}
},{
text : _S._SFE_LANG_COMMON_NO,
qInternational : true,
qInternationalKey : '_SFE_LANG_COMMON_NO',
handler : function() {
MsgWin.close();
}
}];
var MsgWin = QNAP.QOS.fileExplorerTools.tool.Msg.call(FM, 'info', msgObj, btns);
MsgWin.show();
}else{
gUser_MsgWin.show();
}
}
},
onServiceStop : Ext.emptyFn,
/**
* @param appId
*            來源app
* @param serviceName
*            service name
* @param option
*            其他資料
* @type
*/
onServiceStart : Ext.emptyFn,
/**
* @param appId
*            來源app
* @param serviceName
*            service name
* @param option
*            其他資料
* @type
*/
onServiceUpdate : function(appId, serviceName, parms) {
var FM = this;
if (serviceName == 'aclChange') {
FM.checkACL();
}
if((parms.displayName && parms.displayName=='qmail')||
(parms.name  && parms.name=='qmail')){
FM.loadNasSetting(true);
}
},
closeApp : function() {
},
closeWin : function() {
}

});
