Ext.ns('QNAP.QOS.quickWizard', 'Ext.ux.grid');

Array.prototype.inArray = function (value) {
for (var i = 0; i < this.length; i++) {
if (this[i] === value) return true;
}
return false;
};

Array.prototype.replace = function (reg, rpby) {
var ta = this.slice(0),
d = '\0';
var str = ta.join(d);
str = str.replace(reg, rpby);
return str.split(d);
}

Ext.quickWizPagingToolbar = Ext.extend(Ext.PagingToolbar, {
doLoad: function (start, refresh) {
var o = {},
pn = this.getParams();
if (!Ext.isEmpty(refresh)) o.refreshBtn = 1;
o[pn.start] = start;
o[pn.limit] = parseInt(this.pageSize) + parseInt(start);
if (this.fireEvent('beforechange', this, o) !== false) {
this.store.load({
params: o
});
}
},
doRefresh: function() {
this.doLoad(this.cursor, this.refreshValue);
}
});

QNAP.QOS.quickWizard = {
wizard: {
aUser: 0,
mUser: 0,
uGroup: 0,
aShardFolder: 0,
ftpService: 0,
remoteReplication: 0,
myColudNAS: 0,
cloudBackup: 0
},
rulesConfig: new Array(0, 0, 0, 0),
setPwdStr: function () {
var fn = this;
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'authLogin.cgi'),
method: 'POST',
success: function (response, opts) {
var xmlData = response.responseXML;
fn.rulesConfig[0] = parseInt(Ext.DomQuery.selectValue('passwdConstraint01', xmlData)) || 0;
fn.rulesConfig[1] = parseInt(Ext.DomQuery.selectValue('passwdConstraint02', xmlData)) || 0;
fn.rulesConfig[2] = parseInt(Ext.DomQuery.selectValue('passwdConstraint03', xmlData)) || 0;
fn.rulesConfig[3] = parseInt(Ext.DomQuery.selectValue('passwdConstraint04', xmlData)) || 0;
},
failure: function () {}
});
},
isValidPassword: function (username, password) {
var fn = this,
errs = [];
if (fn.rulesConfig[0] == 1 && !fn.strictPasswordBaselineCheck(password, 3)) errs.push(_S.IEI_NAS_PASSSTRENGTH1);
if (fn.rulesConfig[1] == 1 && !fn.noRepeatedCharsCheck(password, 3)) errs.push(_S.IEI_NAS_PASSSTRENGTH2);
if (fn.rulesConfig[2] == 1 && !fn.noUsernameCheck(password, username)) errs.push(_S.IEI_NAS_PASSSTRENGTH3);
if (fn.rulesConfig[3] == 1 && !fn.noCiscoVariationsCheck(password)) errs.push(_S.IEI_NAS_PASSSTRENGTH4);
if (errs.length) {
var errTitle = [_S.IEI_NAS_ALERT_BAD_PWD];
return errTitle.concat(errs);
} else {
return errs;
}
},
strictPasswordBaselineCheck: function (str, threshold) {
var pwdBaselineCount = 0;
if (/[a-z]+/.test(str)) pwdBaselineCount++;
if (/[A-Z]+/.test(str)) pwdBaselineCount++;
if (/[0-9]+/.test(str)) pwdBaselineCount++;
if (/[!"#$%&'()*+,-.\/:;<=>?@\[\\\]\^_`{|}~]+/.test(str)) pwdBaselineCount++;
return (pwdBaselineCount >= threshold);
},
noRepeatedCharsCheck: function (str, threshold) {
var suffix = '';
for (i = 1; i < threshold; i++) {
suffix += '\\1';
}
var filter = new RegExp('(.{1})' + suffix, '');
return !filter.test(str);
},
noUsernameCheck: function (str, username) {
var temp = '';
temp = (typeof username == 'object') ? username.getValue() : username;
if (temp.length > 0) {
var filter = new RegExp(this.escapeSpecialChars(temp) + '|' + this.escapeSpecialChars(this.reverseStr(temp)), 'i');
return !filter.test(str);
}
return true;
},
escapeSpecialChars: function (str) {
str = str.replace(/\[/, '\\[');
str = str.replace(/\\/, '\\\\');
str = str.replace(/\^/, '\\^');
str = str.replace(/\$/, '\\$');
str = str.replace(/\./, '\\.');
str = str.replace(/\|/, '\\|');
str = str.replace(/\?/, '\\?');
str = str.replace(/\*/, '\\*');
str = str.replace(/\+/, '\\+');
str = str.replace(/\(/, '\\(');
str = str.replace(/\)/, '\\)');
return str;
},
reverseStr: function (str) {
var length = str.length;
var ret = '';
for (var x = length; x >= 0; x--) {
ret += str.charAt(x);
}
return ret;
},
noCiscoVariationsCheck: function (str) {
return !/cisco|ocsic/i.test(str.replace(/[1!|]{1}/g, 'i').replace(/0/g, 'o').replace(/\$/g, 's'));
},
countStrLen: function (str) {
return QNAP.lib.countStrLen(str);
},
getCusLenStr: function (str, n) {
return QNAP.lib.getCusLenStr(str, n);
},
GenVolumeSelect: function (type, el, xmlData, none_vdd) {
var default_option = 0,
hidden_vdd = false;
var volume = Ext.DomQuery.select('volume', xmlData);
var storeData = [];
var bIsStorageV2 = QNAP.QOS.config.bIsStorageV2;
if (el) {
Ext.each(volume, function (node, i) {
var vol_stat = Ext.DomQuery.selectValue('volumeStat', node),
vol_disks = Ext.DomQuery.selectValue('volumeDisks', node),
vol_fstype = Ext.DomQuery.selectValue('fstype', node),
vol_status = Ext.DomQuery.selectValue('volumeStatus', node),
pool_vjbod = Ext.DomQuery.selectValue('pool_vjbod', node, '0'),
str = '',
strStr = '';
if (vol_stat == 'single') strStr = 'IEI_NAS_STORAGE33';
else if (vol_stat == 'linear') strStr = 'IEI_NAS_STORAGE15';
else if (vol_stat == 'strip') strStr = 'IEI_NAS_STORAGE16';
else if (vol_stat == 'mirror') strStr = 'IEI_NAS_STORAGE17';
else if (vol_stat == 'raid5') strStr = 'IEI_NAS_STORAGE18';
else if (vol_stat == 'raid6') strStr = 'IEI_NAS_STORAGE171';
else if (vol_stat == 'raid10') strStr = 'IEI_NAS_STORAGE_RAID10_DRIVES';
else strStr = 'Unknown';
str = _S[strStr] || strStr;
str += ' ' + vol_disks;
if (vol_stat == 'vdd') {
if (typeof none_vdd != 'undefined' && none_vdd == true) {
hidden_vdd = true;
} else {
str = vol_disks;
if (Ext.DomQuery.selectValue('spare', node) == '1') str += ' ' + Ext.DomQuery.selectValue('spareDisk', node);
}
}
if (hidden_vdd == false) {
var tmp = [],
volumeValue = Ext.DomQuery.selectValue('volumeValue', node),
freeSize = parseInt(Ext.DomQuery.selectValue('freeSize', node, '')),
freeAry = [],
freeSizeTrns = !Ext.isEmpty(freeSize) ? Ext.util.Format.fileSize(parseInt(freeSize), _S.IEI_NAS_SYSINFO_GB) : 0;
if (bIsStorageV2 && vol_stat != 'vdd') {
var volumeLabel = strStr = Ext.DomQuery.selectValue('volumeLabel', node);
if (pool_vjbod == '1') {
volumeLabel += ' (' + _S.SMB_VIRTUAL_DISK_MENU + ')';
}
if (type == 'v2-freeSize' && !Ext.isEmpty(freeSize)) {
volumeLabel += ' (' + _S.IEI_NAS_STORAGE74 + _S.QUICK09_STR01 + ' ' + freeSizeTrns + ')';
}
tmp.push(volumeLabel);
} else {
if (type == 'v2-freeSize' && !Ext.isEmpty(freeSize)) {
str += ' (' + _S.IEI_NAS_STORAGE74 + _S.QUICK09_STR01 + ' ' + freeSizeTrns + ')';
}
tmp.push(str);
}
tmp.push(volumeValue);
tmp.push(strStr);
tmp.push(vol_disks);
tmp.push(vol_fstype);
if (type == 'v2-freeSize' && !Ext.isEmpty(freeSize)) {
tmp.push(freeSizeTrns);
} else {
tmp.push('');
}
if (bIsStorageV2 && vol_stat != 'vdd') {
if (pool_vjbod == '1') {
tmp.push('1');
}
}
if (type == 'v1' || type == 'v2' || type == 'v2-freeSize') {
if (!bIsStorageV2 || (vol_fstype != 0 && vol_status != -3)) {
storeData.push(tmp);
if (i == 0) default_option = parseInt(volumeValue);
}
} else if (type == 'v3') {
storeData.push(tmp);
if (i == 0) default_option = parseInt(volumeValue);
} else if (type == 'cancelVdd') {
if (vol_stat != 'vdd') {
if (!bIsStorageV2 || (vol_fstype != 0 && vol_status != -3)) {
storeData.push(tmp);
if (i == 0) default_option = parseInt(volumeValue);
}
}
}
}
});
if( storeData.length == 0) {
if (type == 'v2-freeSize') storeData.push(['--', '0', '--', '', '', '', '', '']);
else storeData.push(['--', '0', '--', '', '']);
}
el.store.loadData(storeData);
el.setValue(default_option);
el.originalValue = el.getValue();
}
},
GenVolumeSelectValue: function (xmlData, none_vdd) {
var default_option = 0,
hidden_vdd = false;
var volume = Ext.DomQuery.select('volume', xmlData);
var bIsStorageV2 = QNAP.QOS.config.bIsStorageV2;
Ext.each(volume, function (node, i) {
var vol_fstype = Ext.DomQuery.selectValue('fstype', node);
var vol_status = Ext.DomQuery.selectValue('volumeStatus', node);
if (Ext.DomQuery.selectValue('volumeStat', node) == 'vdd') {
if (typeof none_vdd != 'undefined' && none_vdd == true) hidden_vdd = true;
}
if (hidden_vdd == false) {
if( !bIsStorageV2 || (vol_fstype != 0 && vol_status != -3)) {
if (i == 0) default_option = parseInt(Ext.DomQuery.selectValue('volumeValue', node));
}
}
});
return default_option;
},
isNotValidChar: function (string) {
for (var i = 0; i < string.length; i++) {
if ('\/|\\:=\+?\"<>*[];,%\'\`'.indexOf(string.charAt(i)) != -1) return false;
}
return true;
},
isNotValidChar_4: function (string) {
for (var i = 0; i < string.length; i++) {
if ('`*|\\;:?,"\'<>'.indexOf(string.charAt(i)) != -1) return false;
}
return true;
},
isReservedShareName: function (s) {
return (s.substring(0, 7).toLowerCase() == 'usbdisk' || s.substring(0, 9).toLowerCase() == 'esatadisk');
},
q_check_port: function (s_val, except_port, is_ftp_passive) {
if (s_val == '') return _S.NIC_WAN_ALERT07;
n_port = parseInt(s_val);
if (is_ftp_passive) {
if (n_port > 65535 || n_port < 1025) return _S.FTP_STR22;
}
if (n_port > 65535 || n_port < 1) return _S.NIC_WAN_ALERT07;
if (!this.isPortLegal(n_port, except_port)) return _S.IEI_DEVICE_MSG160;
return true;
},
isPortLegal: function (portNum, exceptionPort) {
exceptionPort = exceptionPort + '';
var portNumReg = new RegExp('(^' + portNum + '$)|([ ]{1}' + portNum + '$)|(^' + portNum + '[ ]{1})|([ ]{1}' + portNum + '[ ]{1})', '');
var SystemPreservePort = QNAP.QOS.config.SystemPreservePort;
if (portNum >= 6881 && portNum <= 6999 && exceptionPort != -1) return false;
if (portNum >= 55536 && portNum <= 56559 && exceptionPort != -2) return false;
for (i = 0; i < SystemPreservePort.length; i++)
if (!portNumReg.test(exceptionPort) && portNum == SystemPreservePort[i]) return false;
return true;
},
isValidEmailServerName: function (b) {
var a = b.match(/[A-Za-z0-9/!#$%&'*+=?^_`{|}~-]+(?:\.[A-Za-z0-9/!#$%&'*+=?^_`{|}~-]+)*@(?:[A-Za-z0-9/!#$%&'*+=?^_`{|}~-](?:[A-Za-z0-9/!#$%&'*+=?^_`{|}~-]*[A-Za-z0-9/!#$%&'*+=?^_`{|}~-])?\.)+(?:[A-Za-z0-9/!#$%&'*+=?^_`{|}~-](?:[A-Za-z0-9/!#$%&'*+=?^_`{|}~-]*[A-Za-z0-9/!#$%&'*+=?^_`{|}~-]))\b/);
for (var d = 0; d < b.length; d++) {
if ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz@/.!#$%&'*+-=?^_`{|}~".indexOf(b.charAt(d)) == -1) return false;
if (b.charAt(0) == '.') return false;
}
if (a != b) return false;
return true
},
getNodeFullPath: function (node) {
var fullPath = (node.parentNode) ? this.getNodeFullPath(node.parentNode) : '';
if (fullPath.length > 0 && !/\/$/.test(fullPath)) fullPath += '/';
fullPath += node.text;
return fullPath;
},
pathValidator: function (path) {
var tester = /\/\//;
if (path.trim() == '') return _S.IEI_NAS_ALERT28;
if (/[`*|\\;:?,"'<>]/.test(path)) return _S.IEI_NAS_ALERT30;
if (path == '//' || path == '/' || tester.test(path)) return _S.IEI_NAS_ALERT33;
if (path == '.' || path == '..') return _S.IEI_NAS_ALERT32;
if (path == '/.' || path == '/..') return _S.IEI_NAS_ALERT32_1;
return true;
},
getPreviewColor: function (num) {
switch (parseInt(num)) {
case 2:
return 'green';
case 1:
return 'orange';
case 0:
case 3:
default:
return 'red';
}
},
chgStatuStr: function (num, style) {
num = parseInt(num) ? parseInt(num) : num;
if (style == '2') {
switch (num) {
case 2:
case 'W':
return 'ISCSI_LUN_ACCESS_RW';
case 1:
case 'R':
return 'IEI_DEVICE_MSG62';
case 3:
case 'I':
return 'USER_CREATE_WIZ_STR20';
case 0:
case 'N':
default:
return 'USER_CREATE_WIZ_STR20_1';
}
} else {
switch (num) {
case 2:
case 'W':
return 'ISCSI_LUN_ACCESS_RW';
case 1:
case 'R':
return 'IEI_DEVICE_MSG62';
case 3:
case 'I':
case 0:
case 'N':
default:
return 'USER_CREATE_WIZ_STR20';
}
}
},
chgStatuE2N: function (num) {
switch (num) {
case 'I':
return 3;
case 'W':
return 2;
case 'R':
return 1;
default:
return 0;
}
},
compareNumber: function (prevNum, nextNum) {
if (prevNum == null || prevNum == -1) return -1;
if (nextNum == null || nextNum == -1) return -1;
return (prevNum >= nextNum) ? prevNum : nextNum;
},
chkAccessRWI: function (record) {
if (record.data.access_rd == true) return 1;
if (record.data.access_rw == true) return 2;
if (record.data.access_no == true) return 3;
return 0;
},
chkShareRWI: function (record) {
if (record.data.share_rd == true) return 1;
if (record.data.share_rw == true) return 2;
if (record.data.share_no == true) return 3;
return 0;
},
aUserAdd: {},
uGroupAdd: {},
aShardFolderAdd: {},
Used_GroupArray: [],
procStr: function (content) {
var contentStr = '';
if (Ext.isArray(content)) {
if (content[0] == 'replace') {
contentStr = _S[content[1]].replace(content[2], content[3]);
} else {
Ext.each(content, function (data) {
data = data.replace(/\n/gi, '<br>');
contentStr += _S[data] || data;
});
}
} else {
contentStr = _S[content] || content;
}
return contentStr;
},
winPrompt: null,
winGroupPrompt: function (app, fn, data, name, ok_callback, base, modal) {
var me = this,
titleStr = '',
contentStr = '',
setData = data,
userGroupAry = [];
var Default_GroupArray = new Array('guest', 'everyone', 'administrators', 'xmail', 'dovecot');

if (Ext.isObject(data)) {
titleStr = me.procStr(data.title);
setData = data.content;
}
contentStr = me.procStr(setData);

var tmpSet = {
xtype: 'container',
itemId: 'column',
layout: 'column',
width: 450,
autoHeight: true,
plain: true,
minimizable: false,
items: [{
xtype: 'displayfield',
value: contentStr,
data: setData,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.update(me.procStr(this.data));
},
style: 'padding:3px 11px 0 0;',
hideLabel: true
}, {
xtype: 'textfield',
itemId: name,
name: name,
maxLength: 128,
enableKeyEvents: true,
listeners: {
buffer: 500,
keyup: function (f, e) {
if (me.countStrLen(f.getValue()) > f.maxLength) f.setValue(me.getCusLenStr(f.getValue(), f.maxLength));
}
},
validator: function (v) {
if (v.length == 0) return _S.ERROR_EMPTY_GROUP_NAME;
else if (!me.isNotValidChar(v) || v.indexOf(' ') != -1 || v.indexOf('@') != -1) return _S.USER_GROUP_GREATE_WIZ_STR18;
else if (Default_GroupArray.inArray(v.toLowerCase())) return _S.ERROR_RESERVED_GROUP;
else if (me.Used_GroupArray.inArray(v.toLowerCase())) return _S.IEI_IDS_STRING108;
else if (v.charAt(0) == '#' || v.charAt(0) == '-') return _S.ERROR_BAD_GROUPNAME_FIRST_CHAR;
return true;
}
}],
buttons: [{
xtype: 'button',
text: _S.QUICK_DEF_NAME11,
qInternational: true,
qInternationalKey: 'QUICK_DEF_NAME11',
cls: 'qts-button q-default',
handler: function () {
if (ok_callback) ok_callback.apply();
}
}, {
xtype: 'button',
text: _S.IEI_NAS_BUTTON_CANCEL,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_CANCEL',
cls: 'qts-button q-default',
handler: function () {
me.winPrompt.close();
}
}],
listeners: {
afterlayout: function (cmp) {
cmp.getComponent(name).focus(true, 100);
}
}
};
if (titleStr != '') {
Ext.apply(tmpSet, {
title: titleStr,
data: data,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setTitle(me.procStr(data.title));
}
});
}
if (!(fn == '' || Ext.isEmpty(fn))) tmpSet.parent = fn;
if (!(base == '' || Ext.isEmpty(base))) tmpSet.baseWin = base;
if (!(modal == '' || Ext.isEmpty(modal))) tmpSet.modal = modal;
Ext.apply(tmpSet, {
cls: 'wizard-small',
footer: true
});
return app._getApp()._createModalWindow(tmpSet);
},
winAlert: function (app, fn, data, iconStyle, ok_callback, base, modal, params) {
var me = this,
title = false,
setData = data,
items = '',
fbar = [],
ok_str = 'IEI_NAS_BUTTON_OK',
icon = me._INFO_ICON;
if (Ext.isObject(data)) {
title = data.title;
if (!Ext.isEmpty(data.content)) setData = data.content;
}
if (!Ext.isEmpty(iconStyle)) {
switch(iconStyle) {
case 'error': icon = me._ERROR_ICON; break;
case 'warning': icon = me._WARNING_ICON; break;
case 'question': icon = me._QUESTION_ICON; break;
case 'question_blue': icon = me._QUESTION_BLUE_ICON; break;
case 'info':
default: icon = me._INFO_ICON; break;
}
}
if (!Ext.isEmpty(setData)) {
items = {
xtype: 'displayfield',
value: me.procStr(setData),
qInternational: true,
data: setData,
qInternationalFn: function (cmp) {
cmp.setValue(me.procStr(cmp.data));
},
hideLabel: true
};
if (Ext.isArray(setData) && (setData.indexOf('replace') >= 0 || setData.indexOf('replaceLink') >= 0)) items.cls = 'link_into_str_line';
}
if (!Ext.isEmpty(params)) {
if (params.YESNO == 1) ok_str = 'IEI_NAS_BUTTON_YES';
if (!Ext.isEmpty(params.ok_str)) ok_str = params.ok_str;
}
fbar = [{
xtype: 'button',
text: _S[ok_str],
qInternational: true,
qInternationalKey: ok_str,
handler: function () {
if (ok_callback) ok_callback.apply();
winAlert.close();
}
}];
if (!Ext.isEmpty(params)) {
if (!Ext.isEmpty(params.items)) items = params.items;
if (!Ext.isEmpty(params.fbar)) fbar = params.fbar;
}
var winAlert = app._alertWindow(title, items, fbar, icon, fn);
winAlert.show();
return winAlert;
},
chkServicesEnable: function (pIndex) {
var tmpdisabled = document.getElementById('wizSvcEnable' + pIndex).checked != true;
if (document.getElementById('wizSvcPublish' + pIndex)) {
document.getElementById('wizSvcPublish' + pIndex).disabled = tmpdisabled;
}
},
qAddUser: function (me, runFinish) {
var fn = this,
app = me;
if (Ext.isDefined(me.app)) app = me.app;
var user_count = 0,
max_count = 0,
group_count = 0,
group_max_count = 0,
quota_enable = 0,
recycleBinEnable = 1;
var w_obj_user = null,
w_share_obj = null,
errStr = null;
var Used_ShareArray = [],
tmpRdArray = [],
tmpRwArray = [],
tmpNoArray = [],
groupArray = [];
var black_list = ['anonymous', 'root', 'guest', 'httpdusr', 'timemachine', 'admin', 'xmail', 'ssods', 'dovecot'];
var black_share_list = ['global', 'printers'];

var checkAccount = function (e) {
var v = step2Form.findField('new_username').getValue();
if (typeof v != 'undefined') {
if (v == '') return _S.USER_CREATE_WIZ_STR35;
if (!fn.isNotValidChar(v)) return _S.MISC_BACKUP_ERROR_MSG303;
if (v.charAt(0) == '-' || v.charAt(0) == '#' || v.charAt(0) == '@' || v.charAt(0) == ' ') return _S.USER_GROUP_GREATE_WIZ_STR25;
if (black_list.inArray(v.toLowerCase())) return _S.QNAP_PS_MSG19;

QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_create'
}, {
action: 'check_user',
uname: encodeURIComponent(v)
}),
method: 'POST',
validationEvent: 'blur',
success: function (response, opts) {
if (Ext.DomQuery.selectValue('ownContent/return', response.responseXML) == '-1') errStr = _S.QNAP_PS_MSG17;
else errStr = true;
},
failure: function () {}
});
return errStr;
} else return true;
}

var step1 = new QNAP.QOS.wizard.formPanel({
itemId: 'step1',
nextId: 'step2',
headerTitle: _S.HOME_STR01,
qInternational: true,
qInternationalKey: 'HOME_STR01',
hideLabels: true,
defaults: {
xtype: 'displayfield'
},
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
items: [{
value: _S.USER_CREATE_WIZ_STR1,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR1',
hideLabel: true
}, {
value: '● ' + _S.USER_CREATE_WIZ_STR45,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('● ' + _S.USER_CREATE_WIZ_STR45);
}
}, {
value: '● ' + _S.USER_CREATE_WIZ_STR53,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('● ' + _S.USER_CREATE_WIZ_STR53);
}
}, {
value: '● ' + _S.USER_CREATE_WIZ_STR5,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('● ' + _S.USER_CREATE_WIZ_STR5);
}
}, {
value: '● ' + _S.USER_CREATE_WIZ_STR50,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('● ' + _S.USER_CREATE_WIZ_STR50);
}
}, {
value: '● ' + _S.USER_CREATE_WIZ_STR52,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('● ' + _S.USER_CREATE_WIZ_STR52);
}
}, {
height: 15
}, {
itemId: 'UserCountErr',
value: _S.ERROR_NEW_USER_TITLE + _S.QUICK09_STR01 + _S.ERROR_USERNUM_EXCEED_ACCOUNT,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.ERROR_NEW_USER_TITLE + _S.QUICK09_STR01 + _S.ERROR_USERNUM_EXCEED_ACCOUNT);
},
style: 'color:red;',
hidden: true
}],
onNext: function () {
if (parseInt(user_count) >= parseInt(max_count)) return false;
step2Form.findField('new_username').focus(true, 100);
if (fn.rulesConfig[0] == 1) {
step2Form.findField('uc_pwd1').allowBlank = false;
step2Form.findField('uc_pwd1').blankText = _S.IEI_NAS_PASSSTRENGTH1;
} else {
step2Form.findField('uc_pwd1').allowBlank = true;
}
return true;
}
});

var step2 = new QNAP.QOS.wizard.formPanel({
itemId: 'step2',
nextId: 'step3',
headerTitle: _S.USER_CREATE_WIZ_STR45,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR45',
defaults: {
xtype: 'textfield'
},
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 170,
items: [{
itemId: 'new_username',
name: 'new_username',
maxLength: 32,
fieldLabel: _S.IEI_DEVICE_MSG133,
qInternational: true,
qInternationalKey: 'IEI_DEVICE_MSG133',
labelSeparator: '',
allowBlank: false,
validator: checkAccount,
enableKeyEvents: true,
listeners: {
buffer: 500,
keyup: function (f, e) {
if (fn.countStrLen(f.getValue()) > f.maxLength) f.setValue(fn.getCusLenStr(f.getValue(), f.maxLength));
}
}
}, {
itemId: 'uc_pwd1',
name: 'uc_pwd1',
maxLength: 16,
fieldLabel: _S.IEI_DEVICE_MSG135,
qInternational: true,
qInternationalKey: 'IEI_DEVICE_MSG135',
inputType: 'password',
labelSeparator: '',
validator: function (v) {
var errs = fn.isValidPassword(step2Form.findField('new_username').getValue(), v);
return errs.length == 0 ? true : '<ul style="list-style:inside;" ><li>' + errs.join('</li><li>') + '</li></ul>';
}
}, {
itemId: 'uc_pwd2',
name: 'uc_pwd2',
maxLength: 16,
fieldLabel: _S.QDOWNLOAD_STRING16,
qInternational: true,
qInternationalKey: 'QDOWNLOAD_STRING16',
inputType: 'password',
labelSeparator: '',
validator: function (v) {
if (step2Form.findField('uc_pwd1').getValue() != v) return _S.USER_GROUP_GREATE_WIZ_STR26;
return true;
}
}, {
itemId: 'email',
name: 'email',
maxLength: 80,
fieldLabel: _S.USER_CREATE_WIZ_STR7,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR7',
labelSeparator: '',
hidden: true,
validator: function (v) {
var ans = v.match(/^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/);
if (!fn.isNotValidChar(v)) return _S.MISC_BACKUP_ERROR_MSG303;
else if (v != '' && !ans) return _S.IEI_NAS_ALERT35;
return true;
}
}, {
itemId: 'ps',
name: 'ps',
maxLength: 128,
fieldLabel: _S.USER_CREATE_WIZ_STR8,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR8',
labelSeparator: '',
hidden: true
}, {
xtype: 'textfield',
itemId: 'new_description',
name: 'new_description',
fieldLabel: _S.SHARE_CREATE_WIZ_STR6,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR6',
labelSeparator: '',
maxLength: 50,
enableKeyEvents: true,
listeners: {
buffer: 500,
keypress: function (cmp, e) {
if (QNAP.lib.countStrLen_ex(cmp.getValue()) > cmp.maxLength) cmp.setValue(QNAP.lib.getCusLenStr_ex(cmp.getValue(), cmp.maxLength));
}
},
validator: function (v) {
if (/[:,]/.test(v)) return _S.USER_GROUP_GREATE_WIZ_STR23;
return true;
}
}, {
xtype: 'textfield',
itemId: 'new_email',
name: 'new_email',
fieldLabel: _S.USER_CREATE_WIZ_STR7,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR7',
maxLength: 80,
labelSeparator: '',
validator: function (v) {
if (!fn.isNotValidChar(v)) return _S.IEI_NAS_ALERT35;
else if (v != '' && !fn.isValidEmailServerName(v)) return _S.IEI_NAS_ALERT35;
else if (step2Form.findField('chk_send_mail').getValue() && v == '') return _S.IEI_NAS_ALERT35;
return true;
}
}, {
xtype: 'checkbox',
itemId: 'chk_send_mail',
name: 'chk_send_mail',
boxLabel: _S.USER_CREATE_WIZ_STR46,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR46',
hideLabel: true,
listeners: {
check: function (cmp) {
var str = cmp.getValue() ? 'IMBOT_EMAIL_INPUT' : 'USER_CREATE_WIZ_STR7';
var mailCmp = step2Form.findField('new_email');
mailCmp.fieldLabel = _S[str];
mailCmp.qInternationalKey = str;
if (mailCmp.label) mailCmp.label.update(_S[str]);
mailCmp.validate();
}
}
}, {
xtype: 'container',
layout: 'hbox',
items: [{
xtype: 'displayfield',
value: _S.COMMON_NOTE,
qInternational: true,
qInternationalKey: 'COMMON_NOTE',
hideLabel: true,
cls: 'note-color',
style: 'font-weight: bold;padding-right:5px;'
}, {
xtype: 'container',
items: [{
xtype: 'displayfield',
value: '1.' + _S.IEI_NAS_USER_QUOTA06,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('1.' + _S.IEI_NAS_USER_QUOTA06);
},
hideLabel: true,
cls: 'note-color number-indent-line'
}, {
xtype: 'displayfield',
value: '2.' + _S.IEI_NAS_USER_QUOTA07,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('2.' + _S.IEI_NAS_USER_QUOTA07);
},
hideLabel: true,
cls: 'note-color number-indent-line'
}]
}]
}, {
xtype: 'displayfield',
style: 'height:30px;',
hidden: !Ext.isGecko
}],
onNext: function () {
return step2Form.findField('new_username').isValid() && step2Form.findField('uc_pwd1').isValid() && step2Form.findField('uc_pwd2').isValid() && step2Form.findField('email').isValid() && step2Form.findField('ps').isValid() && step2Form.findField('new_email').isValid() && step2Form.findField('new_description').isValid();
},
getNextId: function () {
return (quota_enable == 1) ? 'step3' : 'step4';
}
});

var step3 = new QNAP.QOS.wizard.formPanel({
itemId: 'step3',
nextId: 'step4',
headerTitle: _S.USER_CREATE_WIZ_STR54,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR54',
bodyStyle: 'padding: 20px 60px 30px;',
labelWidth: 150,
autoScroll: true,
items: [{
xtype: 'container',
layout: 'column',
hideLabel: true,
border: false,
style: 'font-size:12px;padding-bottom:5px;',
items: [{
xtype: 'displayfield',
value: _S.IEI_NAS_USER_QUOTA + _S.QUICK09_STR01,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.IEI_NAS_USER_QUOTA + _S.QUICK09_STR01);
},
style: 'padding: 1px 11px 0 0'
}, {
xtype: 'displayfield',
itemId: 'quota_sts',
name: 'quota_sts',
qInternational: true
}]
}, {
xtype: 'radiogroup',
itemId: 'quotasize_t_group',
style: QNAP.layout.getDefaultCSS({
indent: 1
}),
hideLabel: true,
columns: 1,
items: [{
boxLabel: _S.IEI_NAS_USER_QUOTA4,
qInternational: true,
qInternationalKey: 'IEI_NAS_USER_QUOTA4',
hideLabel: true,
name: 'quotasize_t',
inputValue: 'nolimit'
}, {
boxLabel: _S.USER_CREATE_WIZ_STR12,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR12',
hideLabel: true,
name: 'quotasize_t',
inputValue: 'custom',
checked: true
}],
listeners: {
change: function (cmp, chkCmp) {
if (cmp.getValue().inputValue == 'nolimit') {
step3Form.findField('custom_quotasize').disable();
step3Form.findField('quotasize_lbl').disable();
} else {
step3Form.findField('custom_quotasize').setDisabled(!quota_enable);
step3Form.findField('quotasize_lbl').setDisabled(!quota_enable);
}
step3Form.findField('custom_quotasize').validate();
},
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}, {
layout: 'column',
itemId: 'quota_set',
hideLabel: true,
border: false,
style: QNAP.layout.getDefaultCSS({
indent: 2
}) + 'font-size:12px;',
items: [{
xtype: 'numberfield',
itemId: 'custom_quotasize',
name: 'custom_quotasize',
maxLength: 7,
width: 70,
allowDecimals: false,
allowNegative: false,
validator: function (v) {
if (v == '') return _S.IEI_NAS_ALERT70;
else if (parseInt(v) < 1 || parseInt(v) > 2000000) return _S.FTP_STR43;
return true;
}
}, {
xtype: 'displayfield',
itemId: 'quotasize_lbl',
name: 'quotasize_lbl',
value: '&nbsp;MB',
style: 'padding-top:4px;'
}]
}, {
xtype: 'displayfield',
itemId: 'quota_message',
name: 'quota_message',
value: _S.USER_CREATE_WIZ_STR42,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR42',
cls: 'note-color',
hideLabel: true
}],
onNext: function () {
if (quota_enable) return step3Form.findField('custom_quotasize').isValid();
return true;
}
});

var groupCheckColumn = new Ext.grid.CheckboxSelectionModel({
dataIndex: 'checkbox',
checkOnly: true,
listeners: {
beforerowselect: function (SelectionModel, rowIndex, keepExisting, record) {
if (record.data.groupname == 'everyone') return false;
},
rowdeselect: function (sm, rowIndex, record) {
Ext.each(groupArray, function (data) {
if (data.groupname == record.data.groupname) {
data.checkbox = record.data.checkbox = false;
}
});
record.afterEdit();
},
rowselect: function (sm, rowIndex, record) {
Ext.each(groupArray, function (data) {
if (data.groupname == record.data.groupname) {
data.checkbox = record.data.checkbox = true;
}
});
record.afterEdit();
}
},
renderer: function (v, p, record) {
if (record.data.groupname == 'everyone') return '<div class="x-grid3-row-checkbox-disabled-on">&#160;</div>';
return '<div class="x-grid3-row-checker">&#160;</div>';
}
});

var groupStore = new Ext.data.Store({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: 'user_group_edit'
}, {
getdata: 1,
refresh: 0,
sort: 13
}),
remoteSort: true,
method: 'POST',
baseParams: {
filter: '',
type: 0,
lower: 0,
upper: 10
},
defaultParamNames: {
limit: 'upper',
start: 'lower'
},
reader: new Ext.data.XmlReader({
root: 'data',
totalProperty: 'grouproot > count',
record: 'group'
}, [{
name: 'groupname',
mapping: 'groupname'
}, {
name: 'checkbox',
mapping: 'checkbox',
type: 'bool'
}]),
listeners: {
beforeload: function (store, o) {
o.params.lower = o.params.lower || 0;
o.params.upper = o.params.lower + 10;
o.filter = gridsSearch.field ? gridsSearch.field.getValue() : '';
},
load: function (store) {
var tmpSel = [];
store.each(function (record, index) {
var chkValue = false;
if (record.data.groupname == 'everyone') {
record.data.checkbox = true;
store.data.items[index].afterEdit();
}
Ext.each(groupArray, function (data) {
if (data.groupname == record.data.groupname) {
record.data.checkbox = data.checkbox == true;
chkValue = true;
store.data.items[index].afterEdit();
}
});
if (!chkValue) {
groupArray.push({
groupname: record.data.groupname,
checkbox: record.data.checkbox
});
}
if (record.data.checkbox == true && record.data.groupname != 'everyone') tmpSel.push(index);
});
if (tmpSel.length) {
if (!Ext.isEmpty(gridGroup.selModel)) gridGroup.selModel.selectRows(tmpSel);
}
delete store.reader.xmlData;
}
}
});

var gridsSearch = new Ext.ux.grid.wizSearch({
mode: 'remote',
idFilter: 'uGroupFilter',
iconCls: false,
readonlyIndexes: ['groupname'],
minChars: 1,
autoFocus: true
});

var gridGroup = new Ext.grid.GridPanel({
store: groupStore,
enableHdMenu: false,
enableColumnMove: false,
disableSelection: true,
trackMouseOver: false,
autoExpandColumn: 'checkbox',
height: Ext.isDefined(runFinish) ? runFinish.groupGridHeight : 348,
qInternational: true,
colModel: new Ext.grid.ColumnModel({
qInternational: true,
columns: [groupCheckColumn,
{
header: _S.USER_GROUP_GREATE_WIZ_STR19,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR19',
sortable: false,
dataIndex: 'groupname',
value2Tip: true
}]
}),
viewConfig: {
forceFit: true,
scrollOffset: 0
},
buttonAlign: 'left',
frame: true,
tbar: [{
xtype: 'button',
itemId: 'addGroup',
text: _S.USER_GROUP_GREATE_WIZ_WELCOME,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_WELCOME',
cls: 'limitMinWidth',
ctCls: 'x-btn-over',
handler: function (cmp) {
var target = '';
if (Ext.isDefined(runFinish)) target = runFinish.targetWin.apply();
if (parseInt(group_count) >= parseInt(group_max_count)) {
me.winAlert(app, target, 'ERROR_GROUPNUM_EXCEED_ACCOUNT', 'info', '', app._getMainWindow());
return;
}
fn.winPrompt = fn.winGroupPrompt(app, target, {
title: 'IEI_NAS_SECURITY64',
content: 'USER_GROUP_GREATE_WIZ_STR03'
}, 'create_group_name', function () {
if (fn.winPrompt.getComponent('create_group_name').isValid()) {
QNAP.QOS.lib.MaskMgr.mask(target.getEl(), 'APPLY_MSG', _S.APPLY_MSG);
var para = {
group_remark: '',
select_user: 0,
new_groupname: fn.winPrompt.getComponent('create_group_name').getValue(),
users_count: 'undefined'
};
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_group_create'
}, {
action: 'add_group'
}),
method: 'POST',
params: para,
success: function (response, opts) {
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_group_create'
}),
method: 'POST',
success: function (response, opts) {
var xmlData = response.responseXML;
if (xmlData != undefined) {
if (Ext.DomQuery.selectNode('QDocRoot', xmlData)) {
group_count = Ext.DomQuery.selectValue('GroupNum/count', xmlData);
group_max_count = Ext.DomQuery.selectValue('GroupNum/max_count', xmlData);
fn.Used_GroupArray = [];
Ext.each(Ext.DomQuery.select('groupList/group/name', xmlData), function (node) {
fn.Used_GroupArray.push(node.firstChild.data);
});
}
}
fn.winPrompt.close();
var o = {};
groupArray.push({
groupname: para.new_groupname,
checkbox: true
});
groupStore.reload({
callback: function (store, record, options) {
target.getEl().unmask();
}
});
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'groups');
},
failure: function () {
target.getEl().unmask();
}
});
},
failure: function () {
target.getEl().unmask();
}
});
}
}, target != '' ? app._getMainWindow() : null);
fn.winPrompt.show();
}
}, {
xtype: 'tbspacer',
itemId: 'space',
width: 250
}],
bbar: new Ext.wizardPagingToolbar({
pageSize: 10,
store: groupStore,
displayInfo: true
}),
sm: groupCheckColumn,
plugins: [gridsSearch],
listeners: {
afteredit: function (e) {
Ext.each(groupArray, function(data) {
if (data.groupname == e.record.data.groupname) {
data.checkbox = e.record.data.checkbox;
e.record.commit();
}
});
},
afterrender: function (cmp) {
setGridTopBtnPos();
}
}
});

function setGridTopBtnPos() {
var spaceCmp = gridGroup.getTopToolbar().getComponent('space');
var addGroupCmp = gridGroup.getTopToolbar().getComponent('addGroup');
if (Ext.isEmpty(addGroupCmp)) return;
if (addGroupCmp.getWidth() == 0) {
setTimeout(function () {
setGridTopBtnPos();
}, 10);
} else {
spaceCmp.setWidth(gridGroup.getWidth() - addGroupCmp.getWidth() - 130);
}
}

var step4 = new QNAP.QOS.wizard.formPanel({
itemId: 'step4',
nextId: 'step5',
headerTitle: _S.IEI_NAS_SECURITY9,
qInternational: true,
qInternationalKey: 'IEI_NAS_SECURITY9',
bodyStyle: 'padding: 10px 60px 30px;',
autoScroll: true,
items: gridGroup
});

var manualLoader = new Ext.tree.TreeLoader({
dataUrl: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'get_dirs'
}),
baseParams: {
dir: '/share',
vol_no: 1
},
listeners: {
load: function (loader, parentNode, res) {
var nodes = [];
var ary = res.responseText.split(new RegExp(/<ul.+?>\s*<li .+?>\s*<a .+?>|<\/a><\/li><\/ul>/));
var pathAry = res.responseText.split(new RegExp(/<ul.+?>\s*<li .+?>\s*<a href="#" rel=\"|\">.+?<\/a><\/li><\/ul>/));
Ext.each(ary, function (data, i) {
if (!Ext.isEmpty(data)) {
var obj = {};
obj.text = data;
obj.fullPath = pathAry[i];
var tmpAry = pathAry[i].split('/');
obj.dir = pathAry[i].replace(tmpAry.splice(0, 3).join('/'), '');
nodes.push(obj);
}
});
parentNode.appendChild(nodes);
},
beforeload: function (loader, node, callback) {
var bp = loader.baseParams;
bp.dir = QNAP.QOS.quickWizard.getNodeFullPath(node) == '/' ? '/share' : node.attributes.fullPath;
bp.vol_no = step5Form.findField('disks_list_user').getValue();
}
}
});
var manualPathTree = new Ext.tree.TreePanel({
loader: manualLoader,
border: false,
rootVisible: false,
root: new Ext.tree.AsyncTreeNode({
text: '/',
id: '0',
dir: '/share'
}),
listeners: {
click: function (node, e) {
/* var value = node.attributes.dir;
manualPathTreeCombo.setValue(value);
var chkPathAry = value.split('/');
var chkDis = chkManualPath(false, chkPathAry);
step5Form.findField('recycle_bin_group').setDisabled(chkDis);
manualPathTreeCombo.collapse(); */
var value = node.attributes.dir;
manualPathTreeCombo.setValue(value);
var chkPathAry = value.split('/');
var chkDis = chkManualPath(false, chkPathAry);
var recycleGroup = step5Form.findField('recycle_bin_group');
var recycleAdmin = step5Form.findField('recycle_bin_admin');
recycleGroup.setDisabled(chkDis);
if (chkDis) recycleAdmin.setDisabled(chkDis);
else recycleAdmin.setDisabled(recycleGroup.getValue().inputValue !== 1);
manualPathTreeCombo.collapse();
},
load: function () {
manualPathTree.setHeight(manualPathTreeCombo.list.getHeight() - 2);
}
}
});
var comboId = Ext.id();
var manualPathTreeCombo = new Ext.form.ComboBox({
store: new Ext.data.SimpleStore({
fields: [],
data: [
[]
]
}),
itemId: 'path',
mode: 'local',
width: 230,
triggerAction: 'all',
tpl: "<tpl for='.'><div style='height:200px'><div id='" + comboId + "'></div></div></tpl>",
selectedClass: '',
onSelect: Ext.emptyFn,
allowBlank: false,
maxLength: 256,
hidden: true,
validator: function (v) {
if (v == '') return _S.FTP_STR41;
if (!fn.isNotValidChar_4(v)) return _S.IEI_NAS_ALERT30;
if (v == '//' || /\/\//.test(v)) return _S.IEI_NAS_ALERT33;
if (v == '.' || v == '..') return _S.IEI_NAS_ALERT32;
if (v == '/.' || v == '/..') return _S.IEI_NAS_ALERT32_1;
},
fileTree: manualPathTree,
enableKeyEvents: true,
listeners: {
expand: function () {
manualPathTree.render(comboId);
},
afterrender: function (e) {
this.mon(this.el, 'click', this.onTriggerClick, this);
/* },
change: function (cmp, value, ovalue) {
var chkPathAry = value.split('/');
var chkDis = chkManualPath(false, chkPathAry);
step5Form.findField('recycle_bin_group').setDisabled(chkDis);
},
keypress: function (cmp, e) {
var value = cmp.getValue();
var chkPathAry = value.split('/');
var chkDis = chkManualPath(false, chkPathAry);
step5Form.findField('recycle_bin_group').setDisabled(chkDis); */
}
},
onViewClick: function (doFocus) {
var index = this.view.getSelectedIndexes()[0],
s = this.store,
r = s.getAt(index);
if (r) this.onSelect(r, index);
if (doFocus != false) this.el.focus();
},
initQuery: function () {
this.doQuery(this.getRawValue(), true);
}
});

var chkManualPath = function (dis, ary) {
var chk = false;
if (ary.length > 3) chk = true
else if (ary.length == 3 && ary[2] != '') chk = true
return !dis && chk;
};

var step5 = new QNAP.QOS.wizard.formPanel({
itemId: 'step5',
nextId: 'step6',
headerTitle: _S.USER_CREATE_WIZ_STR5,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR5',
labelWidth: 210,
bodyStyle: 'padding: 10px 60px 30px;',
autoScroll: true,
items: [{
xtype: 'radiogroup',
itemId: 'create_priv_group',
fieldLabel: _S.USER_CREATE_WIZ_STR14,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR14',
labelSeparator: '',
columns: 3,
items: [{
boxLabel: _S.IEI_NAS_BUTTON_YES,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_YES',
hideLabel: true,
name: 'create_priv',
inputValue: 'yes'
}, {
boxLabel: _S.IEI_NAS_BUTTON_NO + '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;" ext:qtip="' + _S.USER_CREATE_WIZ_STR47 + '">',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.wrap.child('.x-form-cb-label').update(_S.IEI_NAS_BUTTON_NO + '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;" ext:qtip="' + _S.USER_CREATE_WIZ_STR47 + '"/>');
},
hideLabel: true,
name: 'create_priv',
inputValue: 'no',
listeners: {
check: function (f) {
var recycleGroup = step5Form.findField('recycle_bin_group');
var recycleAdmin = step5Form.findField('recycle_bin_admin');
step5Form.findField('path_type_group').setDisabled(f.getValue());
step5Form.findField('share_name_user').setDisabled(f.getValue());
step5Form.findField('hidden_group').setDisabled(f.getValue());
step5Form.findField('oplocks_group').setDisabled(f.getValue());
step5Form.findField('comment_user').setDisabled(f.getValue());
step5Form.findField('disks_list_user').setDisabled(f.getValue());
if (f.getValue()) {
recycleGroup.disable();
recycleAdmin.disable();
manualPathTreeCombo.disable();
} else {
step5Form.findField('share_name_user').focus(true, 100);
if (step5Form.findField('path_type_group').getValue().disabled == false && step5Form.findField('path_type_group').getValue().inputValue == 'manual') manualPathTreeCombo.enable();
var chkDis = chkManualPath(false, manualPathTreeCombo.getValue().split('/'));
recycleGroup.setDisabled(chkDis);
if (chkDis) recycleAdmin.setDisabled(chkDis);
else recycleAdmin.setDisabled(recycleGroup.getValue().inputValue !== 1);
}
step5Form.findField('share_name_user').validate();
manualPathTreeCombo.validate();
}
}
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
if (!Ext.isEmpty(dCmp.qInternationalKey)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
} else if (Ext.isFunction(dCmp.qInternationalFn)) {
dCmp.qInternationalFn(dCmp);
}
}
});
}
}
}, {
xtype: 'textfield',
itemId: 'share_name_user',
name: 'share_name_user',
maxLength: 64,
fieldLabel: _S.USER_CREATE_WIZ_STR49,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR49',
width: 230,
labelSeparator: '',
validator: function (v) {
function check_used_share(sharename) {
for (var i = 0; i < Used_ShareArray.length; i++) {
if (Used_ShareArray[i] == sharename) return false;
}
return true;
}
if (v.length == 0) return _S.FTP_STR41;
else if (!fn.isNotValidChar(v)) return _S.MISC_BACKUP_ERROR_MSG303;
else if (v.indexOf('_sn_') == 0 || v.indexOf('_sn_bk') == 0) return _S.IEI_IDS_STRING190;
else if (!check_used_share(v)) return _S.IEI_NAS_ERR_MSG06;
else if (black_share_list.inArray(v.toLowerCase())) return _S.IEI_NAS_ERR_MSG13;
return true;
},
listeners: {
keyup: function (f, e) {
if (fn.countStrLen(f.getValue()) > f.maxLength) f.setValue(fn.getCusLenStr(f.getValue(), f.maxLength));
}
}
}, {
xtype: 'combo',
itemId: 'disks_list_user',
name: 'disks_list_user',
fieldLabel: _S.IEI_NAS_SECURITY43,
qInternational: true,
qInternationalKey: 'IEI_NAS_SECURITY43',
width: 230,
store: new Ext.data.ArrayStore({
fields: ['listName', 'listValue', 'qInternationalKey', 'diskNumber', 'fstype']
}),
value: '1',
displayField: 'listName',
valueField: 'listValue',
mode: 'local',
editable: false,
allowBlank: false,
triggerAction: 'all',
qInternationalFn: function (cmp) {
if (QNAP.QOS.config.bIsStorageV2) return;
var v = cmp.getValue();
cmp.getStore().each(function (r) {
var a = '';
if (r.data.qInternationalKey != '') a = _S[r.data.qInternationalKey] || r.data.qInternationalKey;
r.data.listName = a + r.data.diskNumber;
r.afterEdit();
});
cmp.setValue(v);
},
listeners: {
select: function (combo, record, index) {
/*
* GQ feature: when create GQ share disbale the path edit
*/
var vol_no = step5Form.findField('disks_list_user').findRecord(step5Form.findField('disks_list_user').valueField, step5Form.findField('disks_list_user').getValue()).data.listValue;
var path_type_group = step5Form.findField('path_type_group');
if (QNAP.GQ.isGQVol(vol_no)) {
path_type_group.disable();
manualPathTreeCombo.disable();
}
else{
path_type_group.enable();
manualPathTreeCombo.setDisabled(path_type_group.getValue().inputValue == 'auto');
if (path_type_group.getValue().inputValue != 'auto' && !manualPathTreeCombo.isVisible()) setForm5Adv();
}
manualPathTreeCombo.fileTree.setRootNode(new Ext.tree.AsyncTreeNode({
text: '/',
id: '0',
dir: '/share'
}));
manualPathTreeCombo.setValue('');
}
}
}, {
xtype: 'textfield',
itemId: 'comment_user',
name: 'comment_user',
disabled: true,
maxLength: 128,
fieldLabel: _S.MISC_SMART_STR75,
qInternational: true,
qInternationalKey: 'MISC_SMART_STR75',
width: 230
}, {
xtype: 'label',
text: _S.MISC_SCH_NEW_STR82,
qInternational: true,
qInternationalKey: 'MISC_SCH_NEW_STR82',
cls: 'link_line',
style: 'cursor:pointer;',
listeners: {
render: function (o, e) {
o.getEl().on({
click: function () {
setForm5Adv();
},
scope: o
})
}
}
}, {
xtype: 'radiogroup',
itemId: 'hidden_group',
fieldLabel: _S.USER_CREATE_WIZ_STR16,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR16',
labelSeparator: '',
columns: 3,
hidden: true,
style: 'padding-top:6px;',
labelStyle: 'padding-top:11px;',
items: [{
boxLabel: _S.IEI_NAS_BUTTON_YES,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_YES',
hideLabel: true,
name: 'hidden',
inputValue: 'yes'
}, {
boxLabel: _S.IEI_NAS_BUTTON_NO + '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;" ext:qtip="' + _S.USER_CREATE_WIZ_STR48 + '">',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.wrap.child('.x-form-cb-label').update(_S.IEI_NAS_BUTTON_NO + '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;" ext:qtip="' + _S.USER_CREATE_WIZ_STR48 + '"/>');
},
hideLabel: true,
name: 'hidden',
inputValue: 'no',
checked: true
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
if (!Ext.isEmpty(dCmp.qInternationalKey)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
} else if (Ext.isFunction(dCmp.qInternationalFn)) {
dCmp.qInternationalFn(dCmp);
}
}
});
}
}
}, {
xtype: 'radiogroup',
itemId: 'oplocks_group',
fieldLabel: _S.IEI_NAS_SHARE79,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE79',
columns: 3,
hidden: true,
items: [{
boxLabel: _S.IEI_NAS_BUTTON_YES,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_YES',
hideLabel: true,
name: 'oplocks',
inputValue: '1',
checked: true
}, {
boxLabel: _S.IEI_NAS_BUTTON_NO,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_NO',
hideLabel: true,
name: 'oplocks',
inputValue: '0'
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}, {
xtype: 'radiogroup',
itemId: 'recycle_bin_group',
fieldLabel: _S.RECYCLE_BIN_STRING,
qInternational: true,
qInternationalKey: 'RECYCLE_BIN_STRING',
columns: 3,
hidden: true,
disabled: true,
items: [{
boxLabel: _S.QNAP_PS_ADMIN_ENABLE,
qInternational: true,
qInternationalKey: 'QNAP_PS_ADMIN_ENABLE',
hideLabel: true,
name: 'recycle_bin',
inputValue: 1
}, {
boxLabel: _S.QNAP_PS_ADMIN_DISABLE,
qInternational: true,
qInternationalKey: 'QNAP_PS_ADMIN_DISABLE',
hideLabel: true,
name: 'recycle_bin',
inputValue: 0,
checked: true
}],
listeners: {
change: function (cmp, checked) {
step5Form.findField('recycle_bin_admin').setDisabled(checked.inputValue !== 1);
}
}
}, {
xtype: 'checkbox',
itemId: 'recycle_bin_admin',
boxLabel: _S.RECYCLE_BIN_STRING_01,
qInternational: true,
qInternationalKey: 'RECYCLE_BIN_STRING_01',
hideLabel: true,
disabled: true,
hidden: true
}, {
xtype: 'radiogroup',
itemId: 'path_type_group',
fieldLabel: _S.USER_CREATE_WIZ_STR17,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR17',
labelSeparator: '',
columns: 1,
hidden: true,
items: [{
boxLabel: _S.IEI_NAS_SHARE41,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE41',
hideLabel: true,
name: 'path_type',
inputValue: 'auto',
checked: true,
listeners: {
check: function (f, nv, ov) {
if (f.getValue()) {
step5Form.findField('recycle_bin_group').enable();
} else {
var chkPathAry = manualPathTreeCombo.getValue().split('/');
var chkDis = chkManualPath(true, chkPathAry);
step5Form.findField('recycle_bin_group').setDisabled(chkDis);
}
manualPathTreeCombo.setDisabled(f.getValue());
manualPathTreeCombo.validate();
}
}
}, {
boxLabel: _S.IEI_NAS_SHARE42,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE42',
hideLabel: true,
name: 'path_type',
inputValue: 'manual'
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
},
manualPathTreeCombo,
{
xtype: 'displayfield',
style: 'height:30px;',
hidden: !Ext.isGecko
}],
onNext: function () {
if (step5Form.findField('share_name_user').isValid() && manualPathTreeCombo.isValid()) {
setTimeout(function () {
shareGrid.getTopToolbar().getComponent('space').setWidth(shareGrid.getWidth() - 130);
}, 10);
shareFolderStore.reload();
return true;
}
}
});

var chkFilterReg = function (name, filter) {
return (filter != '') ? new RegExp(filter).test(name) : true;
};

var shareFolderStore = new Ext.data.Store({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: 'user_share_edit'
}, {
getdata: 1,
userName: ''
}),
remoteSort: true,
method: 'POST',
baseParams: {
filter: '',
type: 0,
lower: 0,
upper: 10
},
defaultParamNames: {
limit: 'upper',
start: 'lower'
},
reader: new Ext.data.XmlReader({
root: 'data',
totalProperty: 'count',
record: 'share'
}, [{
name: 'sharename',
mapping: 'sharename'
}, {
name: 'share_rd',
mapping: 'share_rd'
}, {
name: 'share_rw',
mapping: 'share_rw'
}, {
name: 'share_no',
mapping: 'share_no'
}, {
name: 'now',
mapping: 'now'
}, {
name: 'priv',
mapping: 'preview'
}]),
listeners: {
beforeload: function (store, o) {
o.params.filter = usersSearch.field ? usersSearch.field.getValue() : '';
o.params.lower = o.params.lower || 0;
if (step5Form.findField('create_priv_group').getValue().inputValue == 'yes' & chkFilterReg(step5Form.findField('share_name_user').getValue(), o.params.filter)) {
o.params.upper = o.params.lower + 9;
if (o.params.lower != 0) {
o.params.lower = (o.params.lower % 10 == 0) ? o.params.lower - 1 : o.params.lower;
o.params.upper = o.params.lower + 10;
}
store.addVirtualData = true;
} else {
o.params.upper = o.params.lower + 10;
store.addVirtualData = false;
}

var tmp = [];
Ext.each(groupArray, function (data) {
var value = data.groupname;
if (data.checkbox == true || value == 'everyone') tmp.push(value);
});
o.params.groupList = tmp.join(',');
store.each(function (record, index) {
Ext.each(shareArray, function (data) {
if (data.sharename == record.data.sharename) {
data.share_rd = record.data.share_rd;
data.share_rw = record.data.share_rw;
data.share_no = record.data.share_no;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
}
});
});
},
load: function (store, records, event) {
store.each(function (record, index) {
var chkValue = false;
var priv = record.data.priv;
record.data.priv = fn.chgStatuE2N(priv || 'N');
Ext.each(shareArray, function (data) {
if (data.sharename == record.data.sharename) {
record.data.share_rd = data.share_rd == true;
record.data.share_rw = data.share_rw == true;
record.data.share_no = data.share_no == true;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
chkValue = true;
store.data.items[index].afterEdit();
}
});
if (!chkValue) {
var o = {};
o.sharename = record.data.sharename;
o.share_rd = record.data.share_rd == true;
o.share_rw = record.data.share_rw == true;
o.share_no = record.data.share_no == true;
o.change = false;
if (record.data.sharename === 'Multimedia' && (record.data.priv === 0 || record.data.priv === 1 || record.data.priv === 2)) {
o.share_rw = record.data.share_rw = true;
o.change = true;
} else {
switch (priv) {
case 'R':
o.share_rd = record.data.share_rd = true;
break;
case 'W':
o.share_rw = record.data.share_rw = true;
break;
case 'I':
o.share_no = record.data.share_no = true;
break;
}
}
if (step5Form.findField('share_name_user').getValue() != o.sharename) shareArray.push(o);
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
store.data.items[index].afterEdit();
}
});
if (step5Form.findField('create_priv_group').getValue().inputValue == 'yes' && event.params.lower == 0 & chkFilterReg(step5Form.findField('share_name_user').getValue(), shareGrid.getTopToolbar().getComponent('shareGridFilter').getValue() || '')) {
store.insert(0, new store.recordType({
sharename: step5Form.findField('share_name_user').getValue(),
share_rd: false,
share_rw: true,
share_no: false,
now: 2,
priv: 'N'
}));
}
delete store.reader.xmlData;
}
}
});

var share_rd = new Ext.grid.CheckColumn({
header: '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>';
},
width: 30,
dataIndex: "share_rd",
renderer: function (value, tpl, record) {
if (record.data.sharename == step5Form.findField('share_name_user').getValue()) return String.format('<div class="x-grid3-row-checkbox-disabled {0}">&#160;</div>', this.createId());
return String.format('<div class="x-grid3-check-col{0} {1}">&#160;</div>', value ? '-on' : '', this.createId());
}
});
var share_rw = new Ext.grid.CheckColumn({
header: '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>';
},
width: 30,
dataIndex: "share_rw",
renderer: function (value, tpl, record) {
if (record.data.sharename == step5Form.findField('share_name_user').getValue()) return String.format('<div class="x-grid3-row-checkbox-disabled-on {0}">&#160;</div>', this.createId());
return String.format('<div class="x-grid3-check-col{0} {1}">&#160;</div>', value ? '-on' : '', this.createId());
}
});
var share_no = new Ext.grid.CheckColumn({
header: '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>';
},
width: 30,
dataIndex: "share_no",
renderer: function (value, tpl, record) {
if (record.data.sharename == step5Form.findField('share_name_user').getValue()) return String.format('<div class="x-grid3-row-checkbox-disabled {0}">&#160;</div>', this.createId());
return String.format('<div class="x-grid3-check-col{0} {1}">&#160;</div>', value ? '-on' : '', this.createId());
}
});
var shareArray = [];
var usersSearch = new Ext.ux.grid.wizSearch({
mode: 'remote',
idFilter: 'shareGridFilter',
iconCls: false,
readonlyIndexes: ['sharename'],
minChars: 1,
autoFocus: true
});
var shareGrid = new Ext.grid.GridPanel({
store: shareFolderStore,
enableHdMenu: false,
enableColumnMove: false,
disableSelection: true,
trackMouseOver: false,
height: Ext.isDefined(runFinish) ? runFinish.shareGridHeight : 376,
qInternational: true,
colModel: new Ext.grid.ColumnModel({
qInternational: true,
defaults: {
qInternational: true,
sortable: false
},
columns: [{
header: _S.USER_CREATE_WIZ_STR38,
qInternationalKey: 'USER_CREATE_WIZ_STR38',
dataIndex: 'sharename',
value2Tip: true
}, {
header: _S.QTS_MSG_4,
qInternationalKey: 'QTS_MSG_4',
dataIndex: 'now',
renderer: function (data, metadata, record, rowIndex, columnIndex, store) {
data = parseInt(data);
var color = fn.getPreviewColor(data);
var tip = fn.chgStatuStr(data);
tip = _S[tip] || tip;
metadata.attr = 'ext:qtip="' + tip + '" style="color:' + color + '"';
return tip;
}
},
share_rd, share_rw, share_no]
}),
viewConfig: {
forceFit: true,
scrollOffset: 0
},
buttonAlign: 'left',
frame: true,
tbar: [{
xtype: 'tbspacer',
itemId: 'space',
width: 328
}],
bbar: new Ext.wizardPagingToolbar({
pageSize: 10,
store: shareFolderStore,
displayInfo: true
}),
plugins: [usersSearch, share_rd, share_rw, share_no],
listeners: {
headerclick: function (grid, columnIndex, e) {
switch (columnIndex) {
case 2:
if (!me.sg_rd) {
me.sg_rd = true;
me.sg_rw = false;
me.sg_no = false;
} else {
me.sg_rd = false;
}
Ext.each(ary, function (data) {
grid.store.each(function (record) {
if (data.sharename == record.data.sharename) {
data.share_rd = record.data.share_rd = me.sg_rd;
if (me.sg_rd) data.share_rw = record.data.share_rw = false;
if (me.sg_rd) data.share_no = record.data.share_no = false;
data.change = true;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
record.afterEdit();
}
});
});
break;
case 3:
if (!me.sg_rw) {
me.sg_rd = false;
me.sg_rw = true;
me.sg_no = false;
} else {
me.sg_rw = false;
}
Ext.each(ary, function (data) {
grid.store.each(function (record) {
if (data.sharename == record.data.sharename) {
if (me.sg_rw) data.share_rd = record.data.share_rd = false;
data.share_rw = record.data.share_rw = me.sg_rw;
if (me.sg_rw) data.share_no = record.data.share_no = false;
data.change = true;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
record.afterEdit();
}
});
});
break;
case 4:
if (!me.sg_no) {
me.sg_rd = false;
me.sg_rw = false;
me.sg_no = true;
} else {
me.sg_no = false;
}
Ext.each(ary, function (data) {
grid.store.each(function (record) {
if (data.sharename == record.data.sharename) {
if (me.sg_no) data.share_rd = record.data.share_rd = false;
if (me.sg_no) data.share_rw = record.data.share_rw = false;
data.share_no = record.data.share_no = me.sg_no;
data.change = true;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
record.afterEdit();
}
});
});
break;
}
},
afteredit: function (e) {
if (e.record.data.sharename != step5Form.findField('share_name_user').getValue()) {
switch (e.field) {
case 'share_rd':
e.record.data.share_rw = false;
e.record.data.share_no = false;
break;
case 'share_rw':
e.record.data.share_rd = false;
e.record.data.share_no = false;
break;
case 'share_no':
e.record.data.share_rd = false;
e.record.data.share_rw = false;
break;
}
e.record.data.now = fn.compareNumber(e.record.data.priv, fn.chkShareRWI(e.record));
e.grid.store.data.items[e.row].afterEdit();
Ext.each(shareArray, function (data) {
if (data.sharename == e.record.data.sharename) {
data.share_rd = e.record.data.share_rd;
data.share_rw = e.record.data.share_rw;
data.share_no = e.record.data.share_no;
data.change = true;
}
});
}
e.record.commit();
}
}
});

var step6 = new QNAP.QOS.wizard.formPanel({
itemId: 'step6',
nextId: 'step7_1',
headerTitle: _S.USER_CREATE_WIZ_STR50,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR50',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
items: [
shareGrid,
{
xtype: 'checkbox',
itemId: 'acl_recursive_user_add',
boxLabel: _S.IEI_NAS_ACL15,
qInternational: true,
qInternationalKey: 'IEI_NAS_ACL15',
checked: true,
hideLabel: true
}, {
xtype: 'container',
layout: 'hbox',
items: [{
xtype: 'displayfield',
value: _S.COMMON_NOTE,
qInternational: true,
qInternationalKey: 'COMMON_NOTE',
hideLabel: true,
cls: 'note-color',
style: 'font-weight: bold;padding-right:5px;'
}, {
xtype: 'container',
items: [{
xtype: 'displayfield',
value: _S.PREVIEW_NOTE_STR01,
qInternational: true,
qInternationalKey: 'PREVIEW_NOTE_STR01',
hideLabel: true,
cls: 'note-color number-indent-line'
}, {
xtype: 'displayfield',
value: _S.PREVIEW_NOTE_STR02,
qInternational: true,
qInternationalKey: 'PREVIEW_NOTE_STR02',
qInternationalFn: function (cmp) {
cmp.ownerCt.ownerCt.doLayout();
},
hideLabel: true,
cls: 'note-color number-indent-line'
}]
}]
}, {
xtype: 'displayfield',
style: 'height:30px;',
hidden: !Ext.isGecko
}],
onNext: function () {
function proccessStr(ary) {
var gp_len = ary.length;
var oldStr = ary.join(', ');
var liststr = '',
showPoint = false;
for (var i = 0; i < gp_len; i++) {
if (gp_len < 3) {
if ((i + 1) < gp_len) liststr += ary[i] + ', '
else if ((i + 1) == gp_len) liststr += ary[i];
} else {
if (i < 2) liststr += ary[i] + ', ';
else if (i == 2) {
showPoint = true;
liststr += ' ---';
}
}
}
if (showPoint) liststr = '<div ext:qtip="' + oldStr + '">' + liststr + '</div>';
return liststr;
}

shareGrid.store.each(function (record) {
var chkValue = false;
Ext.each(shareArray, function (data) {
if (data.sharename == record.data.sharename) {
data.share_rd = record.data.share_rd;
data.share_rw = record.data.share_rw;
data.share_no = record.data.share_no;
chkValue = true;
}
});
if (!chkValue) {
if (step5Form.findField('share_name_user').getValue() != o.sharename) {
shareArray.push({
sharename: record.data.sharename,
share_rd: record.data.share_rd,
share_rw: record.data.share_rw,
share_no: record.data.share_no
});
}
}
});
if (shareArray.length === 0) return false;

step7Form.findField('username_info').setValue(step2Form.findField('new_username').getValue());

var ps_info = (step2Form.findField('ps').getValue() != '') ? step2Form.findField('ps').getValue() : '---';
step7Form.findField('ps_info').setValue(ps_info);

var email_info = (step2Form.findField('email').getValue() != '') ? step2Form.findField('email').getValue() : '---';
step7Form.findField('email_info').setValue('---')

if (quota_enable == 1) {
var quota_size_result = step3Form.findField('quotasize_t_group').getValue().inputValue == 'nolimit' ? _S.IEI_NAS_USER_QUOTA4 : step3Form.findField('custom_quotasize').getValue() + ' MB';
step7Form.findField('quota_sts_result').setValue(_S.QNAP_PS_ADMIN_ENABLE + ' / ' + quota_size_result);
step7Form.findField('quota_sts_result').qInternationalFn = function (cmp) {
cmp.setValue(_S.QNAP_PS_ADMIN_ENABLE + ' / ' + quota_size_result);
}
} else {
step7Form.findField('quota_sts_result').setValue(_S.USER_CREATE_WIZ_STR34);
step7Form.findField('quota_sts_result').qInternationalFn = function (cmp) {
cmp.setValue(_S.USER_CREATE_WIZ_STR34);
}
}

var tmpTrueGroup = [];
Ext.each(groupArray, function (data) {
var value = data.groupname;
if (data.checkbox == true || value == 'everyone') tmpTrueGroup.push(value);
});
var gp_list = '---';
if (tmpTrueGroup.length > 0) gp_list = proccessStr(tmpTrueGroup);
step7Form.findField('gp_list').setValue(gp_list);

tmpRdArray = [];
tmpRwArray = [];
tmpNoArray = [];

tmpRdAry = [];
tmpRwAry = [];
tmpNoAry = [];

if (step5Form.findField('create_priv_group').getValue().inputValue == 'yes' & step5Form.findField('share_name_user').getValue() != '') {
tmpRwAry.push(step5Form.findField('share_name_user').getValue());
}

Ext.each(shareArray, function (data) {
if (data.share_rd) tmpRdAry.push(data.sharename);
if (data.share_rw) tmpRwAry.push(data.sharename);
if (data.share_no) tmpNoAry.push(data.sharename);
if (data.sharename == step5Form.findField('share_name_user').getValue() || data.change != true) {
} else {
if (data.share_rd) tmpRdArray.push(data.sharename);
if (data.share_rw) tmpRwArray.push(data.sharename);
if (data.share_no) tmpNoArray.push(data.sharename);
}
});

var rd_list = '---';
if (tmpRdAry.length > 0) rd_list = proccessStr(tmpRdAry);
step7Form.findField('rd_list').setValue(rd_list);

var rw_list = '---';
if (tmpRwAry.length > 0) rw_list = proccessStr(tmpRwAry);
step7Form.findField('rw_list').setValue(rw_list);

var no_list = '---';
if (tmpNoAry.length > 0) no_list = proccessStr(tmpNoAry);
step7Form.findField('no_list').setValue(no_list);
return true;
}
});

var privCheckColumn = new Ext.grid.CheckColumn({
header: '<div style="text-align:center;">' + _S.SHARE_WEBDAV_WIZ_STR03 + '</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div style="text-align:center;">' + _S.SHARE_WEBDAV_WIZ_STR03 + '</div>';
},
width: 126,
id: "checkbox",
name: "checkbox",
dataIndex: "checkbox"
});
var privStore = new Ext.data.GroupingStore({
reader: new Ext.data.ArrayReader({}, [{
name: 'nvalue'
}, {
name: 'name'
}, {
name: 'checkbox',
type: 'boolean'
}, {
name: 'GroupName'
}]),
remoteGroup: true,
groupField: 'GroupName'
});
var privGrid = new Ext.grid.GridPanel({
region: "center",
store: privStore,
title: _S.USER_CREATE_WIZ_STR55,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR55',
enableHdMenu: false,
enableColumnMove: false,
border: false,
autoHeight: true,
autoScroll: false,
disableSelection: true,
trackMouseOver: false,
plugins: [privCheckColumn],
view: new Ext.grid.GroupingView({
forceFit: true,
scrollOffset: 0,
initTemplates: function () {
Ext.grid.GroupingView.superclass.initTemplates.call(this);
this.state = {};
var sm = this.grid.getSelectionModel();
sm.on(sm.selectRow ? 'beforerowselect' : 'beforecellselect', this.onBeforeRowSelect, this);
if (!this.startGroup) {
this.startGroup = new Ext.XTemplate('<div id="{groupId}" class="x-grid-group {cls}">', '<div id="{groupId}-hd" class="x-grid-group-hd" style="{style};background-color:#EEE;"><div class="x-grid-group-title" style="padding:0px;background:none;">', this.groupTextTpl, '</div></div>', '<div id="{groupId}-bd" class="x-grid-group-body">', {
chkGroupStyle: function (records, groupName) {
var chkValue = true;
Ext.each(records, function (record) {
if (record.data.checkbox == false && record.data.GroupName == groupName) chkValue = false;
});
return chkValue ? '-on' : '';
}
});
}
this.startGroup.compile();
if (!this.endGroup) this.endGroup = '</div></div>';
},
groupTextTpl: '<div style="float:left;"><div style="margin:1px 4px 4px;">{[_S[values.rs[0].data.GroupName] || values.rs[0].data.GroupName]}</div></div><div style="display:table"><div style="margin:0 1px 4px;" class="x-grid3-check-col{[this.chkGroupStyle(values.rs, values.rs[0].data.GroupName)]}" groupName="{[values.rs[0].data.GroupName]}"></div></div><div class="q-clear"></div>',
showGroupName: false,
hideGroupedColumn: true,
toggleGroup: function (group) {},
updateGroupWidths: function () {
var view = this;
if (!this.canGroup() || !this.hasRows()) return;
var tw = Math.max(this.cm.getTotalWidth(), this.el.dom.offsetWidth - this.getScrollOffset()) + 'px';
var gs = this.getGroups();
Ext.each(gs, function (node) {
node.firstChild.style.width = tw;
var groupColumn = node.firstChild.firstChild.childNodes;
Ext.each(groupColumn, function (column, cindex) {
if ((groupColumn.length - 1) == cindex) return;
var obj = {
width: view.grid.colModel.columns[cindex].width + 'px'
};
if (cindex == 0) obj.cursor = 'auto';
column.setStyle(obj);
if (cindex == 1) {
column.onclick = function () {
var chkCmp = groupColumn[cindex].firstChild;
var chkValue = chkCmp.hasClassName('x-grid3-check-col-on');
chkCmp[!chkValue ? 'removeClassName' : 'addClassName']('x-grid3-check-col');
chkCmp[chkValue ? 'removeClassName' : 'addClassName']('x-grid3-check-col-on');
var groupName = node.firstChild.firstChild.firstChild.firstChild.textContent;
privStore.each(function (record, index) {
if ((_S[record.data.GroupName] || record.data.GroupName) == groupName) {
record.data.checkbox = !chkValue;
privStore.data.items[index].afterEdit();
}
});
};
}
});
});
}
}),
colModel: new Ext.grid.ColumnModel({
qInternational: true,
defaults: {
qInternational: true
},
columns: [{
header: _S.MISC_QSYNC_CLIENT_WIZ86,
qInternationalKey: 'MISC_QSYNC_CLIENT_WIZ86',
width: 448,
dataIndex: 'name',
groupable: false,
renderer: function (data, metadata, record, rowIndex, columnIndex, store) {
var tip = _S[data] || data;
metadata.attr = 'ext:qtip="' + tip + '"';
return tip;
}
},
privCheckColumn,
{
header: '',
dataIndex: 'GroupName'
}],
}),
listeners: {
afteredit: function (e) {
var chkValue = true;
e.grid.store.each(function (record) {
if (record.data.checkbox == false && e.record.data.GroupName == record.data.GroupName) chkValue = false;
});
Ext.each(e.grid.getView().getGroups(), function (node) {
var chkCmp = node.firstChild.firstChild.childNodes[e.column].firstChild;
if (chkCmp.getAttribute('groupName') == e.record.data.GroupName) {
chkCmp[chkValue ? 'removeClassName' : 'addClassName']('x-grid3-check-col');
chkCmp[!chkValue ? 'removeClassName' : 'addClassName']('x-grid3-check-col-on');
}
});
e.grid.store.data.items[e.row].afterEdit();
e.record.commit();
}
}
});

var step7_1 = new QNAP.QOS.wizard.formPanel({
itemId: 'step7_1',
nextId: 'step7',
headerTitle: _S.USER_CREATE_WIZ_STR52,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR52',
defaults: {
xtype: 'displayfield',
style: 'padding-top:3px;'
},
bodyStyle: 'padding: 10px 60px 30px;',
autoScroll: true,
items: [privGrid,
{
xtype: 'displayfield',
style: 'height:30px;',
hidden: !Ext.isGecko
}]
});

var step7 = new QNAP.QOS.wizard.formPanel({
itemId: 'step7',
nextId: 'finish',
headerTitle: _S.USER_CREATE_WIZ_STR23,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR23',
defaults: {
xtype: 'displayfield',
style: 'padding-top:3px;'
},
bodyStyle: 'padding: 10px 60px 30px;',
autoScroll: true,
labelWidth: 170,
items: [{
value: _S.USER_CREATE_WIZ_STR24,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR24',
hideLabel: true
}, {
height: 10,
value: '&nbsp;'
}, {
itemId: 'username_info',
name: 'username_info',
fieldLabel: _S.IEI_DEVICE_MSG133,
qInternational: true,
qInternationalKey: 'IEI_DEVICE_MSG133',
labelSeparator: '',
value: 'test'
}, {
itemId: 'ps_info',
name: 'ps_info',
fieldLabel: _S.USER_CREATE_WIZ_STR25,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR25',
labelSeparator: '',
value: 'test',
hidden: true
}, {
itemId: 'email_info',
name: 'email_info',
fieldLabel: 'E-Mail',
labelSeparator: '',
value: 'test',
hidden: true
}, {
itemId: 'quota_sts_result',
name: 'quota_sts_result',
fieldLabel: _S.USER_CREATE_WIZ_STR26,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR26',
labelSeparator: '',
value: 'test'
}, {
itemId: 'gp_list',
name: 'gp_list',
fieldLabel: _S.USER_CREATE_WIZ_STR27,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR27',
labelSeparator: ''
}, {
itemId: 'rd_list',
name: 'rd_list',
fieldLabel: _S.USER_CREATE_WIZ_STR32,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR32',
labelSeparator: ''
}, {
itemId: 'rw_list',
name: 'rw_list',
fieldLabel: _S.USER_CREATE_WIZ_STR43,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR43',
labelSeparator: ''
}, {
itemId: 'no_list',
name: 'no_list',
fieldLabel: _S.USER_CREATE_WIZ_STR33,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR33',
labelSeparator: ''
}],
onNext: function () {
var para = {};
para.set_application_privilege = 1;
para.rd_share_len = tmpRdArray.length;
Ext.each(tmpRdArray, function (data, i) {
para['rd_share' + i] = data;
});
para.rw_share_len = tmpRwArray.length;
Ext.each(tmpRwArray, function (data, i) {
para['rw_share' + i] = data;
});
para.no_share_len = tmpNoArray.length;
Ext.each(tmpNoArray, function (data, i) {
para['no_share' + i] = data;
});
para.email = step2Form.findField('email').getValue();
para.ps = step2Form.findField('ps').getValue();
if (quota_enable == 1) {
var t_val = 'custom';
if (step3Form.findField('quotasize_t_group').getValue().inputValue == 'nolimit') t_val = 'nolimit';
else para.custom_quotasize = step3Form.findField('custom_quotasize').getValue();
para.quota_en = 1;
para.quota_type = t_val;
}
para.gp_len = 0;
Ext.each(groupArray, function (data) {
var value = data.groupname
if (data.checkbox == true || value == 'everyone') {
para['gp' + para.gp_len] = value;
para.gp_len++;
}
});
var c_val = '0';
var create_priv_group = step5Form.findField('create_priv_group').getValue().inputValue;
if (create_priv_group == 'yes') {
c_val = '1';
para.priv_sname = step5Form.findField('share_name_user').getValue();
para.path_type = step5Form.findField('path_type_group').getValue().inputValue;
if (para.path_type == 'manual') {
para.path = manualPathTreeCombo.getValue();
if (para.path.substring(0, 1) != '/') {
para.path = '/' + para.path;
}
}
}
para.hidden = step5Form.findField('hidden_group').getValue().inputValue;
para.oplocks = step5Form.findField('oplocks_group').getValue().inputValue;
para.create_priv = c_val;
para.comment = step5Form.findField('comment_user').getValue();
para.vol_no = step5Form.findField('disks_list_user').getValue();
para.a_username = step2Form.findField('new_username').getValue();
para.a_passwd = QNAP.lib.encryption.ezEncode(QNAP.lib.encryption.utf16to8(step2Form.findField('uc_pwd1').getValue()));
para.a_email = step2Form.findField('new_email').getValue();
para.a_description = step2Form.findField('new_description').getValue();
para.recursive = step6.getComponent('acl_recursive_user_add').getValue() ? 1 : 0;
para.send_mail = step2Form.findField('chk_send_mail').getValue() ? 1 : 0;
privStore.each(function (record) {
para[record.data.nvalue] = record.data.checkbox * 1;
});
var recycle_bin_status = 1;
if (step5Form.findField('path_type_group').getValue().inputValue != 'auto') {
para.manual_path = manualPathTreeCombo.getValue();
var chkPathAry = para.manual_path.split('/');
var chkDis = chkManualPath(false, chkPathAry);
if (chkDis) recycle_bin_status = 0;
}
if (recycleBinEnable == 1 && create_priv_group == 'yes') {
para.recycle_bin = recycle_bin_status == 1 ? step5Form.findField('recycle_bin_group').getValue().inputValue : 0;
} else {
para.recycle_bin = 0;
}
var recycleAdmin = step5Form.findField('recycle_bin_admin').getValue() ? 1 : 0;
para.recycle_bin_administrators_only = para.recycle_bin !== 0 ? recycleAdmin : 0;
if (Ext.isDefined(runFinish)) runFinish.setMask.apply();
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_create'
}, {
action: 'add_user'
}),
method: 'POST',
params: para,
success: function (response, opts) {
if (para.create_priv == '1') app._getApp().fireEvent('filechange', app._getApp().id, '/', '/', para.priv_sname, 'new');
Ext.each(shareArray, function (data) {
app._getApp().fireEvent('filechange', app._getApp().id, '/', '/', data.sharename, 'privilage');
});
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'users');
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'users-a');
if (Ext.isDefined(runFinish)) runFinish.gridReload.apply();
else {
finish7Form.findField('list').setValue(_S.USER_CREATE_WIZ_STR51);
finish7Form.findField('list').qInternationalFn = function (cmp) {
cmp.setValue(_S.USER_CREATE_WIZ_STR51);
};
}
},
failure: function () {
if (Ext.isDefined(runFinish)) runFinish.setUMask.apply();
}
});
return true;
}
});

var finish = new QNAP.QOS.wizard.formPanel({
itemId: 'finish',
headerTitle: _S.HOME_STR01,
qInternational: true,
qInternationalKey: 'HOME_STR01',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
items: [{
xtype: 'displayfield',
itemId: 'list',
name: 'list',
value: _S.IEI_NAS_STORAGE27 + '&nbsp; <img src="apps/systemPreferences/images/running.gif" />',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.IEI_NAS_STORAGE27 + '&nbsp; <img src="apps/systemPreferences/images/running.gif" />')
},
hideLabel: true
}]
});

var step2Form = step2.getForm();
var step3Form = step3.getForm();
var step4Form = step4.getForm();
var step5Form = step5.getForm();
var step6Form = step6.getForm();
var step7Form = step7.getForm();
var finish7Form = finish.getForm();

var supportACL = false,
ACLEnabled = false;

items = {
winHeight: 540,
height: 540,
shareFolderStore: shareFolderStore,
groupStore: groupStore,
steps: [step1, step2, step3, step4, step5, step6, step7_1, step7, finish]
};
fn.setPwdStr();

ajax_info = {
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_create'
}),
method: 'POST',
success: function (response, opts) {
var xmlData = response.responseXML;
if (xmlData != undefined) {
recycleBinEnable = Ext.DomQuery.selectValue('recycleBinEnable', xmlData);
step2Form.findField('new_username').validate();
if (Ext.DomQuery.selectNode('UserNum', xmlData)) {
user_count = parseInt(Ext.DomQuery.selectValue('count', xmlData));
max_count = parseInt(Ext.DomQuery.selectValue('max_count', xmlData));
}
step5.getForm().findField('create_priv_group').setValue('no');
var quota_stsStr = '',
chkValue = Ext.DomQuery.selectValue('quotaInfo/enable', xmlData) == '1';
quota_enable = chkValue * 1;
step3Form.findField('quota_message').setVisible(!chkValue);
quota_stsStr = chkValue ? 'QNAP_PS_ADMIN_ENABLE' : 'USER_CREATE_WIZ_STR34';
step3Form.findField('quotasize_t_group').setDisabled(!chkValue);
step3Form.findField('quotasize_lbl').setDisabled(!chkValue);
step3Form.findField('custom_quotasize').setValue(chkValue ? Ext.DomQuery.selectValue('quotaInfo/quotaSize', xmlData) : '');
step3Form.findField('quota_sts').setValue(_S[quota_stsStr]);
step3Form.findField('quota_sts').qInternationalFn = function (cmp) {
cmp.setValue(_S[quota_stsStr]);
}
step3Form.findField('custom_quotasize').setDisabled((step3Form.findField('quotasize_t_group').getValue().inputValue == 'nolimit' || quota_enable == 0));
step3Form.findField('custom_quotasize').validate();
var volList = Ext.DomQuery.selectNode('volumeList', xmlData);
if (volList) fn.GenVolumeSelect('v2', step5Form.findField('disks_list_user'), volList, step5Form);
Ext.each(Ext.DomQuery.select('ShareList/sharename', xmlData), function (node) {
Used_ShareArray.push(node.firstChild.data);
});
if (recycleBinEnable == '1') {
step5Form.findField('recycle_bin_admin').setDisabled(step5.getComponent('recycle_bin_group').getValue().inputValue !== '1');
}
/* GQ feature:
* add Gluster volume to volume list when add user create share
*/
if (QNAP.GQ.isMaster()) {
data = step5Form.findField('disks_list_user').store.data.items;
new_data = QNAP.GQ.addGlusterVol(data);
step5Form.findField('disks_list_user').store.loadData(new_data);
}
}
if (parseInt(user_count) >= parseInt(max_count)) step1.getComponent('UserCountErr').show();
groupStore.reload();
step6.getComponent('acl_recursive_user_add').setVisible(me.ACLEnabled);
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: 'get_application_privilege'
}, {
username: ''
}),
method: 'POST',
success: function (response, opts) {
var tmpAry = [];
Ext.each(Ext.DomQuery.select('Group', response.responseXML), function (data, index) {
var GroupName = Ext.DomQuery.selectValue('Name', data);
Ext.each(Ext.DomQuery.select('app', data), function (cdata) {
var valueAry = [];
valueAry = cdata.firstChild.data.split(',');
valueAry[2] = 1;
valueAry.push(GroupName);
tmpAry.push(valueAry);
});
});
privStore.loadData(tmpAry);
},
failure: function () {}
});

QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_group_create'
}),
method: 'POST',
success: function (response, opts) {
var xmlData = response.responseXML;
if (xmlData != undefined) {
if (Ext.DomQuery.selectNode('QDocRoot', xmlData)) {
group_count = Ext.DomQuery.selectValue('GroupNum/count', xmlData);
group_max_count = Ext.DomQuery.selectValue('GroupNum/max_count', xmlData);
fn.Used_GroupArray = [];
Ext.each(Ext.DomQuery.select('groupList/group/name', xmlData), function (node) {
fn.Used_GroupArray.push(node.firstChild.data);
});
}
}
},
failure: function () {}
});
},
failure: function () {}
};
var setForm5Adv = function () {
var hidden_group = step5.getComponent('hidden_group');
hidden_group.setVisible(!hidden_group.isVisible());
var oplocks_group = step5.getComponent('oplocks_group');
oplocks_group.setVisible(!oplocks_group.isVisible());
var recycle_bin_group = step5.getComponent('recycle_bin_group');
var recycle_bin_admin = step5Form.findField('recycle_bin_admin');
if (recycleBinEnable == 1) {
recycle_bin_group.setVisible(!recycle_bin_group.isVisible());
recycle_bin_admin.setVisible(!recycle_bin_admin.isVisible());
} else {
recycle_bin_group.setVisible(false);
}
var path_type_group = step5.getComponent('path_type_group');
if (path_type_group.isVisible()) {
if (manualPathTreeCombo.getValue() == '') path_type_group.setValue('auto');
} else step5.doLayout();
path_type_group.setVisible(!path_type_group.isVisible());
var path = step5.getComponent('path');
path.setVisible(!path.isVisible());
};
return {
items: items,
ajax_info: ajax_info
};
},
procAry2StrLen: function (ary, limit, showName, check) {
var count = 0, oldStr = '', tmpStr = '';
Ext.each(ary, function (data) {
if (data[check]) {
if (count != 0) oldStr += ', ';
oldStr += data[showName];
if ((limit - 1) >= count) {
if (count != 0) tmpStr += ', ';
tmpStr += data[showName];
}
count++;
}
});
return {
oldStr: oldStr,
procStr: tmpStr,
total: count,
limit: limit
}
},
procAry2StrLenS: function (ary, limit, showName, check) {
var count = 0, oldStr = '', tmpStr = '';
Ext.each(ary, function (data) {
if (data[check]) {
if (count != 0) oldStr += ', ';
oldStr += _S[data[showName]];
if ((limit - 1) >= count) {
if (count != 0) tmpStr += ', ';
tmpStr += _S[data[showName]];
}
count++;
}
});
return {
oldStr: oldStr,
procStr: tmpStr,
total: count,
limit: limit
}
},
procAry2StrLenRWO: function (ary, limit, showName, check) {
var rcount = 0, wcount = 0, ocount = 0,
roldStr = '', woldStr = '', ooldStr = '',
rtmpStr = '', wtmpStr = '', otmpStr = '';
Ext.each(ary, function (data) {
if (data[check.r]) {
if (rcount != 0) roldStr += ', ';
roldStr += data[showName];
if ((limit - 1) >= rcount) {
if (rcount != 0) rtmpStr += ', ';
rtmpStr += data[showName];
}
rcount++;
}
if (data[check.w]) {
if (wcount != 0) woldStr += ', ';
woldStr += data[showName];
if ((limit - 1) >= wcount) {
if (wcount != 0) wtmpStr += ', ';
wtmpStr += data[showName];
}
wcount++;
}
if (data[check.o]) {
if (ocount != 0) ooldStr += ', ';
ooldStr += data[showName];
if ((limit - 1) >= ocount) {
if (ocount != 0) otmpStr += ', ';
otmpStr += data[showName];
}
ocount++;
}
});
return {
roldStr: roldStr,
woldStr: woldStr,
ooldStr: ooldStr,
rprocStr: rtmpStr,
wprocStr: wtmpStr,
oprocStr: otmpStr,
rtotal: rcount,
wtotal: wcount,
ototal: ocount,
limit: limit
}
},
checkStrong: function(string) {
var modes = 0;
if (string.length < 6) return modes;
if (/\d/.test(string)) modes++;
if (/[a-z]/.test(string)) modes++;
if (/[A-Z]/.test(string)) modes++;
if (/\W/.test(string)) modes++;
switch (modes) {
case 1:
return 1;
break;
case 2:
return 2;
case 3:
case 4:
return string.length < 12 ? 3 : 4
break;
}
},
uploadImg: function (form, callback, win) {
var me = this, imageName;
imageName = 'portrait.jpg';
win.getEl().mask(_S.QNAP_PS_LOGIN_STATUS);
if (Ext.isEmpty(callback)) callback = {};
form.doAction(new me.uploadImgAction(form, {
success: callback.success,
failure: function (form, action) {
win.getEl().unmask();
var msg = '';
var result;
try {
result = parseInt(action.result.result);
} catch (e) {
result = 2
}
switch (result) {
case 1:
msg = _S.QTS_IMG_UPLOAD_MSG1;
break;
case 2:
case 3:
case 4:
case 5:
case 7:
case 8:
msg = _S.QTS_IMG_UPLOAD_MSG2;
break;
case 6:
msg = _S.QTS_IMG_UPLOAD_MSG3;
break;
}
os.Msg.alert(win.title, msg);
}
}));
},
uploadImgAction: Ext.extend(Ext.form.Action.Submit, {
constructor: function (form, opts) {
Ext.form.Action.DirectSubmit.superclass.constructor.call(
this, form, opts);
},
success: function (response) {
var result = this.processResponse(response);
if (result.result == 0) {
this.form.afterAction(this, true);
return;
}
if (result.errors) this.form.markInvalid(result.errors);
this.failureType = Ext.form.Action.SERVER_INVALID;
this.form.afterAction(this, false);
}
}),
qAddUserPanel: function (me, runFinish) {
var fn = this,
app = me;
if (Ext.isDefined(me.app)) app = me.app;
var user_count = 0,
max_count = 0,
group_count = 0,
group_max_count = 0,
quota_enable = 0,
recycleBinEnable = 1;
var w_obj_user = null,
w_share_obj = null,
errStr = null;
var Used_ShareArray = [],
tmpRdArray = [],
tmpRwArray = [],
tmpNoArray = [],
groupArray = [];
var black_list = ['anonymous', 'root', 'guest', 'httpdusr', 'timemachine', 'admin', 'xmail', 'ssods', 'dovecot'];
var black_share_list = ['global', 'printers'];
var chkFileSize = false;

var ids = {
btnUserGroup: Ext.id(),
btnUserSharedFolder: Ext.id(),
btnUserPrivilege: Ext.id(),
btnUserQuota: Ext.id()
};

fn.AU_UPLOAD_IMG = Ext.id();
fn.AU_UPLOAD_BT = Ext.id();
fn.AU_UPLOAD_DIV = Ext.id();
var PASSWORD_EL = {
tag: 'input',
type: 'checkbox',
autocomplete: 'off',
'data-flag': 'true'
};
var step2 = new QNAP.QOS.wizard.formPanel({
defaults: {
xtype: 'textfield',
width: 170
},
bodyStyle: 'background-color: #d9e1e9',
cls: 'wiz-field-label-bold add-user-panel',
fileUpload: true,
urlTpl: 'userConfig.cgi?imgbgName=portrait.jpg&func=uploadCreateUserImg&myphoto=1',
url: 'userConfig.cgi?imgbgName=portrait.jpg&func=uploadCreateUserImg&myphoto=1',
autoScroll: false,
labelWidth: 170,
width: 390,
autoHeight: true,
padding: 20,
items: [{
xtype: 'container',
layout: 'column',
cls: 'x-form-item',
width: 350,
height: 100,
items: [{
xtype: 'container',
layout: 'absolute',
width: 175,
items: [{
xtype: 'container',
width: 170,
height: 100,
style: 'margin-right: 5px;',
items: [{
xtype: 'box',
id: fn.AU_UPLOAD_IMG,
autoEl: {
tag: 'img',
cls: 'portrait-img',
style: {
width: '100px',
height: '100px'
},
src: QNAP.QOS.config.defaultPortraitUrl
}
}]
}, {
xtype: 'box',
id: fn.AU_UPLOAD_DIV,
hidden: true,
autoEl: {
tag: 'img',
cls: 'portrait-img',
style: {
width: '100px',
height: '100px'
}
}
}, {
xtype: 'fileuploadfield',
hideLabel: true,
height: 100,
width: 100,
wrapCls: 'portrait-view',
accept: 'image/png,image/gif,image/bmp,image/jpeg',
itemId: 'uploadImg',
id: fn.AU_UPLOAD_BTN,
name: 'filename',
buttonCfg: {
width: '100%',
cls: 'none-bg-btn upload-portrait-btn',
style: 'left:0;',
text: _S.IEI_NAS_BUTTON_CHANGE,
qInternational: true,
qInternationalFn: function(cmp) {
cmp.setText(_S.IEI_NAS_BUTTON_CHANGE);
}
},
listeners: {
afterrender: function(cmp) {
var img = new Image(),
imgView = Ext.getCmp(fn.AU_UPLOAD_IMG);
img.onload = function() {
cmp.fileInput.setStyle({
height: '100%',
top: 0
});
imgView.el.set({
src: QNAP.QOS.config.defaultPortraitUrl
});
}
img.onerror = function() {
cmp.fileInput.setStyle({
height: '100%',
top: 0
});
cmp.wrap.addClass('empty-portrait-view');
}
img.src = QNAP.QOS.config.defaultPortraitUrl;
function clacImgZoomParam(maxWidth, maxHeight, width, height) {
var param = {
top: 0,
left: 0,
width: width,
height: height
};
if (width > maxWidth || height > maxHeight) {
rateWidth = width / maxWidth;
rateHeight = height / maxHeight;
if (rateWidth > rateHeight) {
param.width = maxWidth;
param.height = Math.round(height / rateWidth);
} else {
param.width = Math.round(width / rateHeight);
param.height = maxHeight;
}
}
param.left = Math.round((maxWidth - param.width) / 2);
param.top = Math.round((maxHeight - param.height) / 2);
return param;
}
function previewImage(file, img) {
var MAXWIDTH = 100;
var MAXHEIGHT = 100;
if (file.files && file.files[0]) {
img.onload = function () {
var rect = clacImgZoomParam(MAXWIDTH, MAXHEIGHT, img.offsetWidth, img.offsetHeight);
img.width = rect.width || 100;
img.height = rect.height || 100;
}
if (Ext.isSafari) {
} else {
var reader = new FileReader();
reader.onload = function (evt) {
var rect = clacImgZoomParam(MAXWIDTH, MAXHEIGHT, img.offsetWidth, img.offsetHeight);
if (evt.total > 10485760) {
os.Msg.alert(app._getMainWindow().title, _S.QTS_IMG_UPLOAD_MSG3);
return;
}
img.src = evt.target.result;
imgView.el.set({
width: rect.width || 100,
height: rect.height || 100,
src: evt.target.result
})
}
reader.readAsDataURL(file.files[0]);
}
} else {
var divCmp = Ext.getCmp(fn.AU_UPLOAD_DIV);
var div = divCmp.el.dom;
var sFilter = 'filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(sizingMethod=scale,src="';
file.select();
file.blur();
var src = Ext.isIE6 ? file.value : document.selection.createRange().text;
div.innerHTML = "<img id='" + fn.AU_UPLOAD_DIV + "' class='portrait-img' style='width:100px;height:100px;'>";
var img = document.getElementById(fn.AU_UPLOAD_DIV);
img.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(sizingMethod=scale)";
img.filters.item('DXImageTransform.Microsoft.AlphaImageLoader').src = src;
var sh = setInterval(function () {
var fileSize = Ext.isIE9 ? 1 : img.fileSize;
if (fileSize > 0) {
if (fileSize > 10485760) {
chkFileSize = false;
os.Msg.alert(app._getMainWindow().title, _S.QTS_IMG_UPLOAD_MSG3);
divCmp.hide();
imgView.show();
} else {
chkFileSize = true;
divCmp.show();
imgView.hide();
var rect = clacImgZoomParam(MAXWIDTH, MAXHEIGHT, img.offsetWidth, img.offsetHeight);
status = ('rect:' + rect.top + ',' + rect.left + ',' + rect.width + ',' + rect.height);
div.innerHTML = "<div '" + fn.AU_UPLOAD_DIV + "' class='portrait-img' style='width:" + rect.width + "px;height:" + rect.height + "px;margin-top:" + rect.top + "px;margin-left:" + rect.left + "px;" + sFilter + src + "\"'></div>";
}
clearInterval(sh);
}
}, 100);
}
}
cmp.fileInput.on('change', function() {
if (Ext.isIE9 || Ext.isIE8 || Ext.isIE7) {
previewImage(this.dom, img);
return;
}
if (cmp.fileInput.dom.files.item(0).size > 10485760) {
chkFileSize = false;
imgView.el.set({
src: QNAP.QOS.config.defaultPortraitUrl
});
os.Msg.alert(app._getMainWindow().title, _S.QTS_IMG_UPLOAD_MSG3);
} else {
chkFileSize = true;
previewImage(this.dom, img);
}
});
cmp.on('show', cmp.button.show, cmp.button);
cmp.on('hide', cmp.button.hide, cmp.button);
if(cmp.hidden) cmp.button.hide();
}
}
}]
}, {
xtype: 'textarea',
itemId: 'new_description',
name: 'new_description',
emptyText: _S.WIZ_USER_STR_08,
qInternational: true,
qInternationalKey: {emptyText: 'WIZ_USER_STR_08'},
width: 170,
height: 100,
maxLength: 50,
enableKeyEvents: true,
listeners: {
buffer: 500,
keypress: function (cmp, e) {
if (QNAP.lib.countStrLen_ex(cmp.getValue()) > cmp.maxLength) cmp.setValue(QNAP.lib.getCusLenStr_ex(cmp.getValue(), cmp.maxLength));
}
},
validator: function (v) {
if (/[:,]/.test(v)) return _S.USER_GROUP_GREATE_WIZ_STR23;
return true;
}
}]
}, {
itemId: 'new_username',
name: 'new_username',
maxLength: 32,
fieldLabel: _S.IEI_DEVICE_MSG133,
qInternational: true,
qInternationalKey: 'IEI_DEVICE_MSG133',
labelSeparator: '',
allowBlank: false,
validator: function (v) {
if (typeof v != 'undefined') {
if (v.charAt(0) == ' ') return _S.MISC_QSYNC_ERRMSG18;
v = v.replace(/([\s]*$)/g, '');
if (v == '') return _S.USER_CREATE_WIZ_STR35;
if (!fn.isNotValidChar(v)) return _S.MISC_BACKUP_ERROR_MSG303;
if (v.charAt(0) == '-' || v.charAt(0) == '#' || v.charAt(0) == '@') return _S.USER_GROUP_GREATE_WIZ_STR25;
if (black_list.inArray(v.toLowerCase())) return _S.QNAP_PS_MSG19;
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_create'
}, {
action: 'check_user',
uname: encodeURIComponent(v)
}),
method: 'POST',
buffer: 500,
success: function (response, opts) {
var xmlData = response.responseXML;
if (Ext.DomQuery.selectValue('ownContent/return', xmlData) == '-1') {
errStr = _S.QNAP_PS_MSG17;
step2Form.findField('new_username').markInvalid(errStr);
} else {
errStr = true;
step2Form.findField('new_username').clearInvalid();
}
},
failure: function () {}
});
return errStr;
} else return true;
},
enableKeyEvents: true,
listeners: {
buffer: 500,
keyup: function (f, e) {
if (fn.countStrLen(f.getValue()) > f.maxLength) f.setValue(fn.getCusLenStr(f.getValue(), f.maxLength));
}
}
}, {
itemId: 'uc_pwd1',
name: 'uc_pwd1',
maxLength: 64, //Local user password length extends to 64 chars
fieldLabel: _S.IEI_DEVICE_MSG135,
defaultAutoCreate: PASSWORD_EL,
qInternational: true,
qInternationalKey: 'IEI_DEVICE_MSG135',
inputType: 'password',
labelSeparator: '',
validator: function (v) {
var errs = fn.isValidPassword(step2Form.findField('new_username').getValue().replace(/([\s]*$)/g, ''), v);
var strongNum = fn.checkStrong(v);
var txtColor = ['#808e99', '#ff002a', '#d88f01', '#0067a8', '#007b1f'];
var txtStr = ['WIZ_USER_STR_03', 'WIZ_USER_STR_04', 'WIZ_USER_STR_05', 'WIZ_USER_STR_06', 'WIZ_USER_STR_07'];
var barColor = ['#c2cfd9', '#ff002a', '#fca600', '#0078c4', '#01a72c'];
Ext.query('.strong_txt')[0].innerHTML = _S[txtStr[strongNum]] || txtStr[strongNum];
Ext.query('.strong_txt')[0].setStyle({
color: txtColor[strongNum],
'line-height': '12px'
});
Ext.query('.strongPWD span').each(function (tag, index) {
tag.setStyle({'background': barColor[0]});
if (index < strongNum) tag.setStyle({'background': barColor[strongNum]});
});
return errs.length == 0 ? true : '<ul style="list-style:inside;" ><li>' + errs.join('</li><li>') + '</li></ul>';
},
enableKeyEvents: true,
listeners: {
buffer: 500,
keyup: function (f, e) {
if (fn.countStrLen(f.getValue()) > f.maxLength) f.setValue(fn.getCusLenStr(f.getValue(), f.maxLength));
}
}
}, {
xtype: 'displayfield',
value: '<div class="strongPWD">' +
'<div style="font-size:11px;line-height:12px;color:#818181;">' + _S.WIZ_USER_STR_02.replace('16', '64') + '</div>' + //Local user password length extends to 64 chars
'<div class="strong_txt" style="line-height:12px;">' + _S.WIZ_USER_STR_03 + '</div>' +
'<span></span>' +
'<span></span>' +
'<span></span>' +
'<span></span>' +
'</div>',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<div class="strongPWD">' +
'<div style="font-size:11px;line-height:12px;color:#818181;">' + _S.WIZ_USER_STR_02.replace('16', '64') + '</div>' + //Local user password length extends to 64 chars
'<div class="strong_txt" style="line-height:12px;">' + _S.WIZ_USER_STR_03 + '</div>' +
'<span></span>' +
'<span></span>' +
'<span></span>' +
'<span></span>' +
'</div>');
step2Form.findField('uc_pwd1').validator(step2Form.findField('uc_pwd1').getValue());
}
}, {
itemId: 'uc_pwd2',
name: 'uc_pwd2',
maxLength: 64, //Local user password length extends to 64 chars
fieldLabel: _S.QDOWNLOAD_STRING16,
defaultAutoCreate: PASSWORD_EL,
qInternational: true,
qInternationalKey: 'QDOWNLOAD_STRING16',
inputType: 'password',
labelSeparator: '',
validator: function (v) {
if (step2Form.findField('uc_pwd1').getValue() != v) return _S.USER_GROUP_GREATE_WIZ_STR26;
return true;
},
enableKeyEvents: true,
listeners: {
buffer: 500,
keyup: function (f, e) {
if (fn.countStrLen(f.getValue()) > f.maxLength) f.setValue(fn.getCusLenStr(f.getValue(), f.maxLength));
}
}
}, {
xtype: 'qtscheckbox',
boxLabel: _S.QTS_SHOW_PASSWORD,
qInternational: true,
qInternationalKey: {
boxLabel: 'QTS_SHOW_PASSWORD'
},
isDirty: function () {
return false;
},
handler: function (checkbox, checked) {
var inputs = checkbox.ownerCt.getEl().select('input[data-flag="true"]');
inputs.set({
type: checked ? 'text' : 'password'
});
}
}, {
vtype: 'email',
vtypeText: _S.IEI_NAS_ALERT35,
itemId: 'email',
name: 'email',
maxLength: 80,
fieldLabel: _S.USER_CREATE_WIZ_STR7,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR7',
qInternationalFn: function (cmp) {
cmp.vtypeText = _S.IEI_NAS_ALERT35;
},
labelSeparator: '',
hidden: true
}, {
itemId: 'ps',
name: 'ps',
maxLength: 128,
fieldLabel: _S.USER_CREATE_WIZ_STR8,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR8',
labelSeparator: '',
hidden: true
}, {
itemId: 'tel',
name: 'tel',
fieldLabel: _S.QTS_USER_TEL + ' ' + _S.SHARE_CREATE_WIZ_STR7,
qInternational: true,
qInternationalFn: function (cmp) {
if (cmp.label) cmp.label.update(_S.QTS_USER_TEL + ' ' + _S.SHARE_CREATE_WIZ_STR7 + (Ext.isString(cmp.labelSeparator) ? cmp.labelSeparator : cmp.ownerCt.layout.labelSeparator));
},
stripCharsRe: new RegExp('[^0123456789#()+-]', 'gi'),
autoStripChars: true,
maxLength: 32
}, {
xtype: 'textfield',
vtype: 'email',
vtypeText: _S.IEI_NAS_ALERT35,
itemId: 'new_email',
name: 'new_email',
fieldLabel: _S.USER_CREATE_WIZ_STR7,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR7',
qInternationalFn: function (cmp) {
cmp.vtypeText = _S.IEI_NAS_ALERT35;
},
maxLength: 254,
labelSeparator: '',
validator: function (v) {
if (step2Form.findField('chk_send_mail').getValue() && v == '') return _S.IEI_NAS_ALERT35;
return true;
}
}, {
xtype: 'qtscheckbox',
itemId: 'chk_send_mail',
name: 'chk_send_mail',
boxLabel: _S.USER_CREATE_WIZ_STR46,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.wrap.child('.x-form-cb-label').update(_S.USER_CREATE_WIZ_STR46);
},
width: 326,
hideLabel: true,
listeners: {
check: function (cmp) {
var str = cmp.getValue() ? 'IMBOT_EMAIL_INPUT' : 'USER_CREATE_WIZ_STR7';
var mailCmp = step2Form.findField('new_email');
mailCmp.fieldLabel = _S[str];
mailCmp.qInternationalKey = str;
if (mailCmp.label) mailCmp.label.update(_S[str]);
mailCmp.validate();
}
}
}],
onNext: function () {
return step2Form.findField('new_username').isValid() && step2Form.findField('uc_pwd1').isValid() && step2Form.findField('uc_pwd2').isValid() && step2Form.findField('email').isValid() && step2Form.findField('ps').isValid() && step2Form.findField('new_email').isValid() && step2Form.findField('new_description').isValid();
},
getNextId: function () {
return (quota_enable == 1) ? 'step3' : 'step4';
}
});

var step3 = new QNAP.QOS.wizard.formPanel({
labelWidth: 150,
border: false,
hidden: true,
items:　[{
xtype: 'displayfield',
name: 'lbl_List',
value: _S.IEI_NAS_USER_QUOTA4,
qInternational: true,
qInternationalKey: 'IEI_NAS_USER_QUOTA4',
cls: 'detial-txt-style',
hideLabel: true
}, {
xtyep: 'container',
itemId: 'lbl_area',
style:　'font-size:12px;',
border: false,
hidden: true,
items: [{
xtype: 'container',
layout: 'column',
hideLabel: true,
border: false,
cls: 'x-form-item',
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
value: _S.IEI_NAS_USER_QUOTA + _S.QUICK09_STR01,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.IEI_NAS_USER_QUOTA + _S.QUICK09_STR01);
},
style: 'padding-right:11px;'
}, {
xtype: 'displayfield',
itemId: 'quota_sts',
name: 'quota_sts',
qInternational: true
}]
}, {
xtype: 'qtsradiogroup',
itemId: 'quotasize_t_group',
style: QNAP.layout.getDefaultCSS({
indent: 1
}),
hideLabel: true,
columns: 1,
cls: 'x-form-item',
items: [{
boxLabel: _S.IEI_NAS_USER_QUOTA4,
qInternational: true,
qInternationalKey: 'IEI_NAS_USER_QUOTA4',
hideLabel: true,
name: 'quotasize_t',
inputValue: 'nolimit'
}, {
boxLabel: _S.USER_CREATE_WIZ_STR12,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR12',
hideLabel: true,
name: 'quotasize_t',
inputValue: 'custom',
checked: true
}],
listeners: {
change: function (cmp, chkCmp) {
if (cmp.getValue().inputValue == 'nolimit') {
step3Form.findField('custom_quotasize').disable();
step3Form.findField('sizeUnit').disable();
} else {
step3Form.findField('custom_quotasize').setDisabled(!quota_enable);
step3Form.findField('sizeUnit').setDisabled(!quota_enable);
}
step3Form.findField('custom_quotasize').validate();
},
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}, {
xtype: 'panel',
layout: 'column',
itemId: 'quota_set',
hideLabel: true,
border: false,
cls: 'x-form-item',
style: QNAP.layout.getDefaultCSS({
indent: 2
}) + 'font-size:12px;',
items: [{
xtype: 'numberfield',
itemId: 'custom_quotasize',
name: 'custom_quotasize',
maxLength: 7,
width: 75,
allowDecimals: false,
allowNegative: false,
validator: function (v) {
var unit = step3Form.findField('sizeUnit').getValue() == 'MB' ? 1 : 1024;
var value = parseInt(v) * unit;
if (v == "") return _S.IEI_NAS_ALERT70;
else if (parseInt(value) < 100 || parseInt(value) > 2 * 1024 * 1024) return _S.FTP_STR43_1;
return true;
}
}, {
xtype: 'displayfield',
width: 5,
height: 5
}, {
xtype: 'combo',
itemId: 'sizeUnit',
name: 'sizeUnit',
store: new Ext.data.ArrayStore({
fields: ['listName'],
data: [
['MB'],
['GB']
]
}),
width: 60,
listWidth: 60,
value: 'MB',
displayField: 'listName',
valueField: 'listName',
mode: 'local',
editable: false,
allowBlank: false,
triggerAction: 'all',
listeners: {
select: function () {
step3Form.findField('custom_quotasize').validate();
}
}
}]
}, {
xtype: 'displayfield',
itemId: 'quota_message',
name: 'quota_message',
value: _S.USER_CREATE_WIZ_STR42,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR42',
cls: 'note-color',
hideLabel: true
}]
}],
tbar: [{
xtype: 'displayfield',
value: _S.WIZ_USER_STR_10,
qInternational: true,
qInternationalKey: {value: 'WIZ_USER_STR_10'},
cls: 'title-bar-style'
}, {
xtype: 'tbfill'
}, {
xtype: 'button',
itemId: 'btnChange',
id: ids.btnUserQuota,
text: _S.NIC_WEB_BTN_EDIT,
qInternational: true,
qInternationalKey: 'NIC_WEB_BTN_EDIT',
cls: 'qts-button q-default',
handler: function (cmp) {
var btnText;
var lbl_area = step3.getComponent('lbl_area');
var vis = lbl_area.isVisible();
step3Form.findField('lbl_List').setVisible(vis);
if (vis) {
step3.procList();
lbl_area.getEl().slideOut('t', {
easing: 'easeOut',
duration: .5,
remove: false,
useDisplay: false,
callback: function () {
lbl_area.setVisible(!vis);
lbl_area.doLayout();
}
});
btnText = 'NIC_WEB_BTN_EDIT';
} else {
lbl_area.setVisible(!vis);
step3Form.findField('sizeUnit').setSize(step3Form.findField('sizeUnit').getWidth());
lbl_area.getEl().slideIn('t', {
easing: 'easeOut',
duration: .5,
callback: function () {
lbl_area.doLayout();
}
});
btnText = 'IEI_NAS_BUTTON_CLOSE';
}
cmp[ !vis ? 'addClass' : 'removeClass']('btn-blue');
cmp.setText(_S[btnText]);
cmp.qInternationalKey = btnText;
}
}],
procList: function () {
var lbl_List = step3Form.findField('lbl_List');
if (quota_enable == 1) {
var quota_size_result = step3Form.findField('quotasize_t_group').getValue().inputValue == 'nolimit' ? _S.IEI_NAS_USER_QUOTA4 : step3Form.findField('custom_quotasize').getValue() + step3Form.findField('sizeUnit').getValue();
lbl_List.setValue(_S.ISCSI_TARGET_LUN_STATUS_1 + ' / ' + quota_size_result);
lbl_List.qInternationalFn = function (cmp) {
cmp.setValue(_S.ISCSI_TARGET_LUN_STATUS_1 + ' / ' + quota_size_result);
}
} else {
lbl_List.setValue(_S.ISCSI_TARGET_LUN_STATUS_0);
lbl_List.qInternationalFn = function (cmp) {
cmp.setValue(_S.ISCSI_TARGET_LUN_STATUS_0);
}
}
},
onNext: function () {
if (quota_enable) return step3Form.findField('custom_quotasize').isValid();
return true;
}
});

var groupCheckColumn = new Ext.grid.CheckboxSelectionModel({
dataIndex: "checkbox",
checkOnly: true,
listeners: {
beforerowselect: function (SelectionModel, rowIndex, keepExisting, record) {
if (record.data.groupname == 'everyone') return false;
},
rowdeselect: function (sm, rowIndex, record) {
Ext.each(groupArray, function (data) {
if (data.groupname == record.data.groupname) {
data.checkbox = record.data.checkbox = false;
}
});
record.afterEdit();
},
rowselect: function (sm, rowIndex, record) {
Ext.each(groupArray, function (data) {
if (data.groupname == record.data.groupname) {
data.checkbox = record.data.checkbox = true;
}
});
record.afterEdit();
},
selectionchange: {
buffer: 100,
fn: function (SelectionModel) {
shareFolderStore.reload();
}
}
},
renderer: function (v, p, record) {
return String.format('<div class="x-grid3-row-{0}">&#160;</div>', record.data.groupname == 'everyone' ? 'checkbox-disabled-on' : 'checker')
}
});

var groupStore = new Ext.data.Store({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: 'user_group_edit'
}, {
getdata: 1,
refresh: 0,
sort: 13
}),
remoteSort: true,
method: 'POST',
baseParams: {
filter: '',
type: 0,
lower: 0,
upper: 10
},
defaultParamNames: {
limit: 'upper',
start: 'lower'
},
reader: new Ext.data.XmlReader({
root: 'data',
totalProperty: 'grouproot > count',
record: 'group'
}, [{
name: 'groupname',
mapping: 'groupname'
}, {
name: 'checkbox',
mapping: 'checkbox',
type: 'bool'
}]),
listeners: {
beforeload: function (store, o) {
o.params.lower = o.params.lower || 0;
o.params.upper = o.params.lower + 10;
o.params.filter = gridsSearch.field ? gridsSearch.field.getValue() : '';
},
load: function (store) {
var tmpSel = [];
store.each(function (record, index) {
var chkValue = false;
if (record.data.groupname == 'everyone') {
record.data.checkbox = true;
store.data.items[index].afterEdit();
}

Ext.each(groupArray, function (data) {
if (data.groupname == record.data.groupname) {
record.data.checkbox = data.checkbox == true;
chkValue = true;
store.data.items[index].afterEdit();
}
});
if (!chkValue) {
groupArray.push({
groupname: record.data.groupname,
checkbox: record.data.checkbox
});
}
if (record.data.checkbox == true && record.data.groupname != 'everyone') tmpSel.push(index);
});
if (tmpSel.length) {
if (!Ext.isEmpty(gridGroup.selModel)) gridGroup.selModel.selectRows(tmpSel);
}
delete store.reader.xmlData;
}
}
});

var gridsSearch = new Ext.ux.grid.wizSearch({
mode: 'remote',
idFilter: 'uGroupFilter',
iconCls: false,
readonlyIndexes: ['groupname'],
minChars: 1,
autoFocus: true
});

var gridGroup = new Ext.grid.GridPanel({
store: groupStore,
enableHdMenu: false,
enableColumnMove: false,
disableSelection: true,
trackMouseOver: false,
autoExpandColumn: "checkbox",
height: Ext.isDefined(runFinish) ? runFinish.groupGridHeight : 402,
hidden: true,
qInternational: true,
cls: 'grid-none-bottom',
colModel: new Ext.grid.ColumnModel({
qInternational: true,
columns: [groupCheckColumn,
{
header: _S.USER_GROUP_GREATE_WIZ_STR19,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR19',
sortable: false,
dataIndex: 'groupname',
value2Tip: true
}]
}),
viewConfig: {
forceFit: true,
scrollOffset: 0
},
buttonAlign: 'left',
frame: true,
tbar: [{
xtype: 'button',
itemId: 'addGroup',
text: _S.USER_GROUP_GREATE_WIZ_WELCOME,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_WELCOME',
cls: 'qts-button q-default',
style: 'margin-bottom:0;',
handler: function (cmp) {
var target = '';
if (Ext.isDefined(runFinish)) target = runFinish.targetWin.apply();
if (parseInt(group_count) >= parseInt(group_max_count)) {
me.winAlert(app, target, 'ERROR_GROUPNUM_EXCEED_ACCOUNT', 'info', '', app._getMainWindow());
return;
}
fn.winPrompt = fn.winGroupPrompt(app, target, {
title: 'IEI_NAS_SECURITY64',
content: 'USER_GROUP_GREATE_WIZ_STR03'
}, 'create_group_name', function () {
if (fn.winPrompt.getComponent('create_group_name').isValid()) {
QNAP.QOS.lib.MaskMgr.mask(target.getEl(), 'APPLY_MSG', _S.APPLY_MSG);
var para = {
group_remark: '',
select_user: 0,
new_groupname: fn.winPrompt.getComponent('create_group_name').getValue(),
users_count: 'undefined'
};
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_group_create'
}, {
action: 'add_group'
}),
method: 'POST',
params: para,
success: function (response, opts) {
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_group_create'
}),
method: 'POST',
success: function (response, opts) {
var xmlData = response.responseXML;
if (xmlData != undefined) {
if (Ext.DomQuery.selectNode('QDocRoot', xmlData)) {
group_count = Ext.DomQuery.selectValue('GroupNum/count', xmlData);
group_max_count = Ext.DomQuery.selectValue('GroupNum/max_count', xmlData);
fn.Used_GroupArray = [];
Ext.each(Ext.DomQuery.select('groupList/group/name', xmlData), function (node) {
fn.Used_GroupArray.push(node.firstChild.data);
});
}
}
fn.winPrompt.close();
groupArray.push({
groupname: para.new_groupname,
checkbox: true
});
groupStore.reload({
callback: function (store, record, options) {
target.getEl().unmask();
}
});
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'groups');
},
failure: function () {
target.getEl().unmask();
}
});
},
failure: function () {
target.getEl().unmask();
}
});
}
}, target != '' ? app._getMainWindow() : null);
fn.winPrompt.show();
}
}, {
xtype: 'tbspacer',
itemId: 'space',
width: 247
}],
bbar: new Ext.wizardPagingToolbar({
pageSize: 10,
store: groupStore,
displayInfo: true
}),
sm: groupCheckColumn,
plugins: [gridsSearch],
listeners: {
afteredit: function (e) {
Ext.each(groupArray, function (data) {
if (data.groupname == e.record.data.groupname) {
data.checkbox = e.record.data.checkbox;
e.record.commit();
}
});
},
afterrender: function (cmp) {
setGridTopBtnPos();
}
}
});

function setGridTopBtnPos() {
var spaceCmp = gridGroup.getTopToolbar().getComponent('space');
var addGroupCmp = gridGroup.getTopToolbar().getComponent('addGroup');
if (Ext.isEmpty(addGroupCmp)) return;
if (addGroupCmp.getWidth() == 0) {
setTimeout(function () {
setGridTopBtnPos();
}, 10);
} else {
spaceCmp.setWidth(gridGroup.getWidth() - addGroupCmp.getWidth() - 147);
}
}

var step4 = new QNAP.QOS.wizard.formPanel({
border: false,
cls: 'panel-border-bottom',
style: 'padding-bottom:15px;',
items: [{
xtype: 'displayfield',
name: 'lbl_List',
value: 'everyone',
cls: 'detial-txt-style',
hideLabel: true
}, gridGroup],
tbar: [{
xtype: 'displayfield',
value: _S.IEI_NAS_SHARE11,
qInternational: true,
qInternationalKey: {value: 'IEI_NAS_SHARE11'},
cls: 'title-bar-style'
}, {
xtype: 'tbfill'
}, {
xtype: 'button',
id: ids.btnUserGroup,
text: _S.NIC_WEB_BTN_EDIT,
qInternational: true,
qInternationalKey: 'NIC_WEB_BTN_EDIT',
cls: 'qts-button q-default',
handler: function (cmp) {
var btnText;
var lbl_List = step4Form.findField('lbl_List');
var vis = gridGroup.isVisible();
lbl_List.setVisible(vis);
if (vis) {
var limitNum = 3;
var obj = fn.procAry2StrLen(groupArray, limitNum, 'groupname', 'checkbox');
var str = '';
if (obj.total > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, obj.procStr, obj.total - obj.limit);
str = '<div ext:qtip="' + obj.oldStr + '">' + tmp + '</div>';
} else {
str = obj.procStr;
}
lbl_List.setValue(str);
lbl_List.objData = obj;
lbl_List.qInternationalFn = function (cmp) {
var tmpStr = '';
if (cmp.objData.total > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, cmp.objData.procStr, cmp.objData.total - cmp.objData.limit);
tmpStr = '<div ext:qtip="' + cmp.objData.oldStr + '">' + tmp + '</div>';
} else {
tmpStr = cmp.objData.procStr;
}
cmp.setValue(tmpStr);
}
gridGroup.getEl().slideOut('t', {
easing: 'easeOut',
duration: .5,
remove: false,
useDisplay: false,
callback: function () {
gridGroup.setVisible(!vis);
gridGroup.doLayout();
}
});
btnText = 'NIC_WEB_BTN_EDIT';
} else {
gridGroup.setVisible(!vis);
gridGroup.getEl().slideIn('t', {
easing: 'easeOut',
duration: .5,
callback: function () {
gridGroup.doLayout();
}
});
btnText = 'IEI_NAS_BUTTON_CLOSE';
}
cmp[ !vis ? 'addClass' : 'removeClass']('btn-blue');
cmp.setText(_S[btnText]);
cmp.qInternationalKey = btnText;
}
}]
});

var manualLoader = new Ext.tree.TreeLoader({
dataUrl: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'get_dirs'
}),
baseParams: {
dir: '/share',
vol_no: 1
},
listeners: {
load: function (loader, parentNode, res) {
var nodes = [];
var ary = res.responseText.split(new RegExp(/<ul.+?>\s*<li .+?>\s*<a .+?>|<\/a><\/li><\/ul>/));
var pathAry = res.responseText.split(new RegExp(/<ul.+?>\s*<li .+?>\s*<a href="#" rel=\"|\">.+?<\/a><\/li><\/ul>/));
Ext.each(ary, function (data, i) {
if (!Ext.isEmpty(data)) {
var obj = {};
obj.text = data;
obj.fullPath = pathAry[i];
var tmpAry = pathAry[i].split('/');
obj.dir = pathAry[i].replace(tmpAry.splice(0, 3).join('/'), '');
nodes.push(obj);
}
});
parentNode.appendChild(nodes);
},
beforeload: function (loader, node, callback) {
var bp = loader.baseParams;
bp.dir = QNAP.QOS.quickWizard.getNodeFullPath(node) == '/' ? '/share' : node.attributes.fullPath;
bp.vol_no = fn.addUserPanelVolumeValue;
}
}
});
var manualPathTree = new Ext.tree.TreePanel({
loader: manualLoader,
border: false,
rootVisible: false,
root: new Ext.tree.AsyncTreeNode({
text: '/',
id: '0',
dir: '/share'
}),
listeners: {
click: function (node, e) {
var value = node.attributes.dir;
manualPathTreeCombo.setValue(value);
var chkPathAry = value.split('/');
var chkDis = chkManualPath(false, chkPathAry);
manualPathTreeCombo.collapse();
},
load: function () {
manualPathTree.setHeight(manualPathTreeCombo.list.getHeight() - 2);
}
}
});
var comboId = Ext.id();
var manualPathTreeCombo = new Ext.form.ComboBox({
store: new Ext.data.SimpleStore({
fields: [],
data: [
[]
]
}),
itemId: 'path',
mode: 'local',
width: 230,
triggerAction: 'all',
tpl: "<tpl for='.'><div style='height:200px'><div id='" + comboId + "'></div></div></tpl>",
selectedClass: '',
onSelect: Ext.emptyFn,
allowBlank: false,
maxLength: 256,
hidden: true,
validator: function (v) {
if (v == "") return _S.FTP_STR41;
if (!fn.isNotValidChar_4(v)) return _S.IEI_NAS_ALERT30;
if (v == '//' || /\/\//.test(v)) return _S.IEI_NAS_ALERT33;
if (v == "." || v == "..") return _S.IEI_NAS_ALERT32;
if (v == "/." || v == "/..") return _S.IEI_NAS_ALERT32_1;
},
fileTree: manualPathTree,
enableKeyEvents: true,
listeners: {
expand: function () {
manualPathTree.render(comboId);
},
afterrender: function (e) {
this.mon(this.el, 'click', this.onTriggerClick, this);
/* },
change: function (cmp, value, ovalue) {
var chkPathAry = value.split('/');
var chkDis = chkManualPath(false, chkPathAry);
step5Form.findField('recycle_bin_group').setDisabled(chkDis);
},
keypress: function (cmp, e) {
var value = cmp.getValue();
var chkPathAry = value.split('/');
var chkDis = chkManualPath(false, chkPathAry);
step5Form.findField('recycle_bin_group').setDisabled(chkDis); */
}
},
onViewClick: function (doFocus) {
var index = this.view.getSelectedIndexes()[0],
s = this.store,
r = s.getAt(index);
if (r) this.onSelect(r, index);
if (doFocus != false) this.el.focus();
},
initQuery: function () {
this.doQuery(this.getRawValue(), true);
}
});

var chkManualPath = function (dis, ary) {
var chk = false;
if (ary.length > 3) chk = true
else if (ary.length == 3 && ary[2] != '') chk = true
return !dis && chk;
};

var chkFilterReg = function (name, filter) {
return (filter != '') ? new RegExp(filter).test(name) : true;
};

var shareFolderStore = new Ext.data.Store({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: "user_share_edit"
}, {
getdata: 1,
userName: ''
}),
remoteSort: true,
method: 'POST',
baseParams: {
filter: '',
type: 0,
lower: 0,
upper: 10
},
defaultParamNames: {
limit: 'upper',
start: 'lower'
},
reader: new Ext.data.XmlReader({
root: 'data',
totalProperty: 'count',
record: 'share'
}, [{
name: 'sharename',
mapping: 'sharename'
}, {
name: 'share_rd',
mapping: 'share_rd'
}, {
name: 'share_rw',
mapping: 'share_rw'
}, {
name: 'share_no',
mapping: 'share_no'
}, {
name: 'now',
mapping: 'now'
}, {
name: 'priv',
mapping: 'preview'
}]),
listeners: {
beforeload: function (store, o) {
o.params.filter = usersSearch.field ? usersSearch.field.getValue() : '';
o.params.lower = o.params.lower || 0;
o.params.upper = o.params.lower + 10;
store.addVirtualData = false;
var tmp = [];
Ext.each(groupArray, function (data) {
var value = data.groupname;
if (data.checkbox == true || value == 'everyone') tmp.push(value);
});
o.params.groupList = tmp.join(',');
store.each(function (record, index) {
Ext.each(shareArray, function (data) {
if (data.sharename == record.data.sharename) {
data.share_rd = record.data.share_rd;
data.share_rw = record.data.share_rw;
data.share_no = record.data.share_no;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
}
});
});
},
load: function (store, records, event) {
store.each(function (record, index) {
var chkValue = false;
var priv = record.data.priv;
record.data.priv = fn.chgStatuE2N(priv || 'N');
Ext.each(shareArray, function (data) {
if (data.sharename == record.data.sharename) {
record.data.share_rd = data.share_rd == true;
record.data.share_rw = data.share_rw == true;
record.data.share_no = data.share_no == true;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
chkValue = true;
store.data.items[index].afterEdit();
}
});
if (!chkValue) {
var o = {};
o.sharename = record.data.sharename;
o.share_rd = record.data.share_rd == true;
o.share_rw = record.data.share_rw == true;
o.share_no = record.data.share_no == true;
o.change = false;
if (record.data.sharename === 'Multimedia' && (record.data.priv === 0 || record.data.priv === 1 || record.data.priv === 2)) {
o.share_rw = record.data.share_rw = true;
o.change = true;
}else if (record.data.sharename == 'Public') {
o.share_rd = record.data.share_rd = true;
o.change = true;
} else {
switch (priv) {
case 'R':
o.share_rd = record.data.share_rd = true;
break;
case 'W':
o.share_rw = record.data.share_rw = true;
break;
case 'I':
o.share_no = record.data.share_no = true;
break;
}
}
/* if (step5Form.findField('share_name_user').getValue() != o.sharename) */
shareArray.push(o);
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
store.data.items[index].afterEdit();
}
});
delete store.reader.xmlData;
}
}
});

var share_rd = new Ext.grid.CheckColumn({
header: '<div class="check_column_header" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div class="check_column_header" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>';
},
width: 30,
dataIndex: "share_rd",
renderer: function (value, tpl, record) {
return String.format('<div class="x-grid3-check-col{0} {1}">&#160;</div>', value ? '-on' : '', this.createId());
}
});
var share_rw = new Ext.grid.CheckColumn({
header: '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>';
},
width: 30,
dataIndex: "share_rw",
renderer: function (value, tpl, record) {
return String.format('<div class="x-grid3-check-col{0} {1}">&#160;</div>', value ? '-on' : '', this.createId());
}
});
var share_no = new Ext.grid.CheckColumn({
header: '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>';
},
width: 30,
dataIndex: "share_no",
renderer: function (value, tpl, record) {
return String.format('<div class="x-grid3-check-col{0} {1}">&#160;</div>', value ? '-on' : '', this.createId());
}
});
var shareArray = [];
var usersSearch = new Ext.ux.grid.wizSearch({
mode: 'remote',
idFilter: 'shareGridFilter',
iconCls: false,
readonlyIndexes: ['sharename'],
minChars: 1,
autoFocus: true
});
var shareGrid = new Ext.grid.GridPanel({
store: shareFolderStore,
enableHdMenu: false,
enableColumnMove: false,
disableSelection: true,
trackMouseOver: false,
height: Ext.isDefined(runFinish) ? runFinish.shareGridHeight : 402,
qInternational: true,
colModel: new Ext.grid.ColumnModel({
qInternational: true,
defaults: {
qInternational: true,
sortable: false
},
columns: [{
header: _S.USER_CREATE_WIZ_STR38,
qInternationalKey: 'USER_CREATE_WIZ_STR38',
dataIndex: 'sharename',
value2Tip: true
}, {
header: _S.QTS_MSG_4,
qInternationalKey: 'QTS_MSG_4',
dataIndex: 'now',
renderer: function (data, metadata, record, rowIndex, columnIndex, store) {
data = parseInt(data);
var tip = fn.chgStatuStr(data);
if (tip == 'USER_CREATE_WIZ_STR20' && !record.data.share_no) tip = 'USER_CREATE_WIZ_STR20_1';
tip = _S[tip] || tip;
metadata.attr = 'ext:qtip="' + tip + '" style="color:' + fn.getPreviewColor(data) + '"';
return tip;
}
},
share_rd, share_rw, share_no]
}),
viewConfig: {
forceFit: true,
scrollOffset: 0
},
buttonAlign: 'left',
frame: true,
tbar: [{
xtype: 'tbfill'
}],
bbar: new Ext.wizardPagingToolbar({
pageSize: 10,
store: shareFolderStore,
displayInfo: true
}),
plugins: [usersSearch, share_rd, share_rw, share_no],
listeners: {
headerclick: function (grid, columnIndex, e) {
switch (columnIndex) {
case 2:
if (!me.sg_rd) {
me.sg_rd = true;
me.sg_rw = false;
me.sg_no = false;
} else {
me.sg_rd = false;
}
Ext.each(shareArray, function (data) {
grid.store.each(function (record) {
if (data.sharename == record.data.sharename) {
data.share_rd = record.data.share_rd = me.sg_rd;
if (me.sg_rd) data.share_rw = record.data.share_rw = false;
if (me.sg_rd) data.share_no = record.data.share_no = false;
data.change = true;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
record.afterEdit();
}
});
});
break;
case 3:
if (!me.sg_rw) {
me.sg_rd = false;
me.sg_rw = true;
me.sg_no = false;
} else {
me.sg_rw = false;
}
Ext.each(shareArray, function (data) {
grid.store.each(function (record) {
if (data.sharename == record.data.sharename) {
if (me.sg_rw) data.share_rd = record.data.share_rd = false;
data.share_rw = record.data.share_rw = me.sg_rw;
if (me.sg_rw) data.share_no = record.data.share_no = false;
data.change = true;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
record.afterEdit();
}
});
});
break;
case 4:
if (!me.sg_no) {
me.sg_rd = false;
me.sg_rw = false;
me.sg_no = true;
} else {
me.sg_no = false;
}
Ext.each(shareArray, function (data) {
grid.store.each(function (record) {
if (data.sharename == record.data.sharename) {
if (me.sg_no) data.share_rd = record.data.share_rd = false;
if (me.sg_no) data.share_rw = record.data.share_rw = false;
data.share_no = record.data.share_no = me.sg_no;
data.change = true;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
record.afterEdit();
}
});
});
break;
}
},
afteredit: function (e) {
/* if (e.record.data.sharename != step5Form.findField('share_name_user').getValue()) { */
switch (e.field) {
case 'share_rd':
e.record.data.share_rw = false;
e.record.data.share_no = false;
break;
case 'share_rw':
e.record.data.share_rd = false;
e.record.data.share_no = false;
break;
case 'share_no':
e.record.data.share_rd = false;
e.record.data.share_rw = false;
break;
}
e.record.data.now = fn.compareNumber(e.record.data.priv, fn.chkShareRWI(e.record));
e.grid.store.data.items[e.row].afterEdit();
Ext.each(shareArray, function (data) {
if (data.sharename == e.record.data.sharename) {
data.share_rd = e.record.data.share_rd;
data.share_rw = e.record.data.share_rw;
data.share_no = e.record.data.share_no;
data.change = true;
}
});
/* } */
e.record.commit();
}
}
});

var step6 = new QNAP.QOS.wizard.formPanel({
border: false,
cls: 'panel-border-bottom',
style: 'padding: 6px 0 15px;',
items: [{
xtype: 'container',
itemId: 'lbl_area',
items: [{
xtype: 'container',
layout: 'column',
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
cls: 'icon-read-only',
style: 'margin-top:5px;'
}, {
xtype: 'displayfield',
value: _S.USER_CREATE_WIZ_STR28,
qInternational: true,
qInternationalKey: {value: 'USER_CREATE_WIZ_STR28'},
style: 'padding-right:11px;'
}, {
xtype: 'displayfield',
name: 'lbl_roList',
cls: 'detial-txt-style',
value:'--'
}]
}, {
xtype: 'container',
layout: 'column',
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
cls: 'icon-read-write',
style: 'margin-top:5px;'
}, {
xtype: 'displayfield',
value: _S.USER_CREATE_WIZ_STR31,
qInternational: true,
qInternationalKey: {value: 'USER_CREATE_WIZ_STR31'},
style: 'padding-right:11px;'
}, {
xtype: 'displayfield',
name: 'lbl_rwList',
cls: 'detial-txt-style',
value:'--'
}]
}, {
xtype: 'container',
layout: 'column',
itemId: 'no',
style: 'font-size:12px;',
hidden: true,
items: [{
xtype: 'displayfield',
cls: 'icon-no-access',
style: 'margin-top:5px;'
}, {
xtype: 'displayfield',
value: _S.USER_CREATE_WIZ_STR33,
qInternational: true,
qInternationalKey: {value: 'USER_CREATE_WIZ_STR33'},
style: 'padding-right:11px;'
}, {
xtype: 'displayfield',
name: 'lbl_noList',
cls: 'detial-txt-style',
value:'--'
}]
}]
}, {
xtype: 'container',
itemId: 'grid_area',
style: 'font-size:12px;',
items: [shareGrid, {
xtype: 'qtscheckbox',
itemId: 'acl_recursive_user_add',
boxLabel: _S.IEI_NAS_ACL15,
qInternational: true,
qInternationalKey: 'IEI_NAS_ACL15',
checked: true,
hideLabel: true
}]
}],
tbar: [{
xtype: 'displayfield',
value: _S.WIZ_USER_STR_09,
qInternational: true,
qInternationalKey: {value: 'WIZ_USER_STR_09'},
cls: 'title-bar-style'
}, {
xtype: 'tbfill'
}, {
xtype: 'button',
id: ids.btnUserSharedFolder,
text: _S.NIC_WEB_BTN_EDIT,
qInternational: true,
qInternationalKey: 'NIC_WEB_BTN_EDIT',
cls: 'qts-button q-default',
hidden: QNAP.QOS.config.ha_enabled,
handler: function (cmp) {
var btnText;
var lbl_area = step6.getComponent('lbl_area');
var grid_area = step6.getComponent('grid_area');
var vis = grid_area.isVisible();
lbl_area.setVisible(vis);
if (vis) {
step6.procList();
grid_area.getEl().slideOut('t', {
easing: 'easeOut',
duration: .5,
remove: false,
useDisplay: false,
callback: function () {
grid_area.setVisible(!vis);
grid_area.doLayout();
}
});
btnText = 'NIC_WEB_BTN_EDIT';
} else {
grid_area.setVisible(!vis);
grid_area.getEl().slideIn('t', {
easing: 'easeOut',
duration: .5,
callback: function () {
grid_area.doLayout();
}
});
btnText = 'IEI_NAS_BUTTON_CLOSE';
}
cmp[ !vis ? 'addClass' : 'removeClass']('btn-blue');
cmp.setText(_S[btnText]);
cmp.qInternationalKey = btnText;
}
}],
procList: function () {
var limitNum = 3;
var obj = fn.procAry2StrLenRWO(shareArray, limitNum, 'sharename', {r: 'share_rd', w: 'share_rw', o: 'share_no'});
var rtmpStr = '', wtmpStr = '', otmpStr = '';
if (obj.rtotal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, obj.rprocStr, obj.rtotal - obj.limit);
rtmpStr = '<div ext:qtip="' + obj.roldStr + '">' + tmp + '</div>';
} else {
rtmpStr = obj.rprocStr || '--';
}
step6Form.findField('lbl_roList').setValue(rtmpStr);
step6Form.findField('lbl_roList').objData = obj;
step6Form.findField('lbl_roList').qInternational = true;
step6Form.findField('lbl_roList').qInternationalFn = function (cmp) {
var value = '';
if (cmp.objData.rtotal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, cmp.objData.rprocStr, cmp.objData.rtotal - cmp.objData.limit);
value = '<div ext:qtip="' + cmp.objData.roldStr + '">' + tmp + '</div>';
} else {
value = cmp.objData.rprocStr || '--';
}
cmp.setValue(value);
};
if (obj.wtotal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, obj.wprocStr, obj.wtotal - obj.limit);
wtmpStr = '<div ext:qtip="' + obj.woldStr + '">' + tmp + '</div>';
} else {
wtmpStr = obj.wprocStr || '--';
}
step6Form.findField('lbl_rwList').setValue(wtmpStr);
step6Form.findField('lbl_rwList').objData = obj;
step6Form.findField('lbl_rwList').qInternational = true;
step6Form.findField('lbl_rwList').qInternationalFn = function (cmp) {
var value = '';
if (cmp.objData.wtotal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, cmp.objData.wprocStr, cmp.objData.wtotal - cmp.objData.limit);
value = '<div ext:qtip="' + cmp.objData.woldStr + '">' + tmp + '</div>';
} else {
value = cmp.objData.wprocStr || '--';
}
cmp.setValue(value);
};
if (obj.ototal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, obj.oprocStr, obj.ototal - obj.limit);
otmpStr = '<div ext:qtip="' + obj.ooldStr + '">' + tmp + '</div>';
} else {
otmpStr = obj.oprocStr || '--';
}
step6Form.findField('lbl_noList').setValue(otmpStr);
step6Form.findField('lbl_noList').objData = obj;
step6Form.findField('lbl_noList').qInternational = true;
step6Form.findField('lbl_noList').qInternationalFn = function (cmp) {
var value = '';
if (cmp.objData.ototal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, cmp.objData.oprocStr, cmp.objData.ototal - cmp.objData.limit);
value = '<div ext:qtip="' + cmp.objData.ooldStr + '">' + tmp + '</div>';
} else {
value = cmp.objData.oprocStr || '--';
}
cmp.setValue(value);
};
step6.getComponent('lbl_area').getComponent('no').setVisible(otmpStr !== '--');
},
onNext: function () {
function proccessStr(ary) {
var gp_len = ary.length;
var oldStr = ary.join(', ');
var liststr = '',
showPoint = false;
for (var i = 0; i < gp_len; i++) {
if (gp_len < 3) {
if ((i + 1) < gp_len) liststr += ary[i] + ', '
else if ((i + 1) == gp_len) liststr += ary[i];
} else {
if (i < 2) liststr += ary[i] + ', ';
else if (i == 2) {
showPoint = true;
liststr += ' ---';
}
}
}
if (showPoint) liststr = '<div ext:qtip="' + oldStr + '">' + liststr + '</div>';
return liststr;
}
shareGrid.store.each(function (record) {
var chkValue = false;
Ext.each(shareArray, function (data) {
if (data.sharename == record.data.sharename) {
data.share_rd = record.data.share_rd;
data.share_rw = record.data.share_rw;
data.share_no = record.data.share_no;
chkValue = true;
}
});
/* if (!chkValue) {
var o = {};
o.sharename = record.data.sharename;
o.share_rd = record.data.share_rd;
o.share_rw = record.data.share_rw;
o.share_no = record.data.share_no;
if (step5Form.findField('share_name_user').getValue() != o.sharename) shareArray.push(o);
} */
})
if (shareArray.length === 0) return false;

/* step7Form.findField('username_info').setValue(step2Form.findField('new_username').getValue()); */

/* var ps_info = (step2Form.findField('ps').getValue() != '') ? step2Form.findField('ps').getValue() : '---';
step7Form.findField('ps_info').setValue(ps_info); */

/* var email_info = (step2Form.findField('email').getValue() != '') ? step2Form.findField('email').getValue() : '---';
step7Form.findField('email_info').setValue('---') */

/* if (quota_enable == 1) {
var quota_size_result = step3Form.findField('quotasize_t_group').getValue().inputValue == 'nolimit' ? _S.IEI_NAS_USER_QUOTA4 : step3Form.findField('custom_quotasize').getValue() + ' MB';
step7Form.findField('quota_sts_result').setValue(_S.QNAP_PS_ADMIN_ENABLE + ' / ' + quota_size_result);
step7Form.findField('quota_sts_result').qInternationalFn = function (cmp) {
cmp.setValue(_S.QNAP_PS_ADMIN_ENABLE + ' / ' + quota_size_result);
}
} else {
step7Form.findField('quota_sts_result').setValue(_S.USER_CREATE_WIZ_STR34);
step7Form.findField('quota_sts_result').qInternationalFn = function (cmp) {
cmp.setValue(_S.USER_CREATE_WIZ_STR34);
}
} */

var tmpTrueGroup = [];
Ext.each(groupArray, function (data) {
var value = data.groupname;
if (data.checkbox == true || value == 'everyone') tmpTrueGroup.push(value);
});
/* if (step5Form.findField('create_priv_group').getValue().inputValue == 'yes' & step5Form.findField('share_name_user').getValue() != '') {
tmpRwAry.push(step5Form.findField('share_name_user').getValue());
} */
/* var gp_list = '---';
if (tmpTrueGroup.length > 0) gp_list = proccessStr(tmpTrueGroup);
step7Form.findField('gp_list').setValue(gp_list); */

/* tmpRdArray = [];
tmpRwArray = [];
tmpNoArray = [];

tmpRdAry = [];
tmpRwAry = [];
tmpNoAry = [];

for (var i = 0; i < shareArray.length; i++) {
if (shareArray[i].share_rd) tmpRdAry.push(shareArray[i].sharename);
if (shareArray[i].share_rw) tmpRwAry.push(shareArray[i].sharename);
if (shareArray[i].share_no) tmpNoAry.push(shareArray[i].sharename);
if (shareArray[i].sharename == step5Form.findField('share_name_user').getValue() || shareArray[i].change != true) continue;
if (shareArray[i].share_rd) tmpRdArray.push(shareArray[i].sharename);
if (shareArray[i].share_rw) tmpRwArray.push(shareArray[i].sharename);
if (shareArray[i].share_no) tmpNoArray.push(shareArray[i].sharename);
}

var rd_list = '---';
if (tmpRdAry.length > 0) rd_list = proccessStr(tmpRdAry);
step7Form.findField('rd_list').setValue(rd_list);

var rw_list = '---';
if (tmpRwAry.length > 0) rw_list = proccessStr(tmpRwAry);
step7Form.findField('rw_list').setValue(rw_list);

var no_list = '---';
if (tmpNoAry.length > 0) no_list = proccessStr(tmpNoAry);
step7Form.findField('no_list').setValue(no_list); */
return true;
}
});

var privCheckColumn = new Ext.grid.CheckColumn({
header: '<div style="text-align:center;">' + _S.SHARE_WEBDAV_WIZ_STR03 + '</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div style="text-align:center;">' + _S.SHARE_WEBDAV_WIZ_STR03 + '</div>';
},
width: 126,
id: "checkbox",
name: "checkbox",
dataIndex: "checkbox"
});
var privStore = new Ext.data.GroupingStore({
reader: new Ext.data.ArrayReader({}, [{
name: 'nvalue'
}, {
name: 'name'
}, {
name: 'checkbox',
type: 'boolean'
}, {
name: 'GroupName'
}]),
remoteGroup: true,
groupField: 'GroupName'
});
var privGrid = new Ext.grid.GridPanel({
region: "center",
store: privStore,
title: _S.USER_CREATE_WIZ_STR55,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR55',
enableHdMenu: false,
enableColumnMove: false,
border: false,
autoHeight: true,
autoScroll: false,
disableSelection: true,
trackMouseOver: false,
plugins: [privCheckColumn],
viewConfig: {
forceFit: true
},
view: new Ext.grid.GroupingView({
forceFit: true,
scrollOffset: 0,
initTemplates: function () {
Ext.grid.GroupingView.superclass.initTemplates.call(this);
this.state = {};
var sm = this.grid.getSelectionModel();
sm.on(sm.selectRow ? 'beforerowselect' : 'beforecellselect', this.onBeforeRowSelect, this);
if (!this.startGroup) {
this.startGroup = new Ext.XTemplate('<div id="{groupId}" class="x-grid-group {cls} {[this.chkGroupDisabled(values.rs, values.rs[0].data.GroupName)]}">', '<div id="{groupId}-hd" class="x-grid-group-hd" style="background-color:#EEE;padding:4px 0;"><div class="x-grid-group-title" style="padding:0px;background:none;">', this.groupTextTpl, '</div></div>', '<div id="{groupId}-bd" class="x-grid-group-body">', {
chkGroupDisabled: function (records, groupName) {
if (!QNAP.QOS.config.ha_enabled) return '';

var chkValue = false;
Ext.each(records, function (record) {
if (record.data.GroupName == 'MENU_5') {
chkValue = true;
return false;
}
});
return chkValue ? '' : 'x-item-disabled';
},
chkGroupStyle: function (records, groupName) {
var chkValue = true;
Ext.each(records, function (record) {
if (record.data.checkbox == false && record.data.GroupName == groupName) chkValue = false;
});
return chkValue ? '-on' : '';
}
});
}
this.startGroup.compile();
if (!this.endGroup) this.endGroup = '</div></div>';
},
groupTextTpl: '<div style="float:left;width:374px;"><div style="margin:3px 12px;">{[_S[values.rs[0].data.GroupName] || values.rs[0].data.GroupName]}</div></div><div style="display:table;padding: 4px 0px;"><div class="x-grid3-check-col{[this.chkGroupStyle(values.rs, values.rs[0].data.GroupName)]}" groupName="{[values.rs[0].data.GroupName]}"></div></div><div class="q-clear"></div>',
showGroupName: false,
hideGroupedColumn: true,
toggleGroup: function (group) {},
updateGroupWidths: function () {
var view = this;
if (!this.canGroup() || !this.hasRows()) return;
var gs = this.getGroups();
Ext.each(gs, function (node) {
var groupColumn = node.firstChild.firstChild.childNodes;
Ext.each(groupColumn, function (column, cindex) {
if ((groupColumn.length - 1) == cindex) return;
var obj = {
width: view.grid.colModel.columns[cindex].width + 'px'
};
if (cindex == 0) obj.cursor = 'auto';
column.setStyle(obj);
if (cindex == 1) {
column.onclick = function () {
var chkCmp = groupColumn[cindex].firstChild,
GroupNameValue = chkCmp.getAttribute('groupName'),
groupName = node.firstChild.firstChild.firstChild.firstChild.textContent;
if (QNAP.QOS.config.ha_enabled && GroupNameValue != 'MENU_5') return;
var chkValue = chkCmp.hasClassName('x-grid3-check-col-on');
chkCmp[!chkValue ? 'removeClassName' : 'addClassName']('x-grid3-check-col');
chkCmp[chkValue ? 'removeClassName' : 'addClassName']('x-grid3-check-col-on');
privStore.each(function (record, index) {
if ((_S[record.data.GroupName] || record.data.GroupName) == groupName) {
record.data.checkbox = !chkValue;
record.afterEdit();
}
});
var chgGroupName = '',
setGroup = true;
if (chkValue) {
if (GroupNameValue == 'MENU_6') {
privStore.each(function (record, index) {
if (record.data.nvalue == 'QBOX') {
record.data.checkbox = !chkValue;
chgGroupName = 'MENU_5';
setGroup = false;
record.afterEdit();
}
});
}
} else {
if (GroupNameValue == 'MENU_5') {
privStore.each(function (record, index) {
if (record.data.nvalue == 'WFM') {
record.data.checkbox = !chkValue;
chgGroupName = 'MENU_6';
record.afterEdit();
}
if (record.data.checkbox == false && record.data.GroupName == 'MENU_6') setGroup = false;
});
}
}
if (!Ext.isEmpty(chgGroupName)) {
Ext.each(privGrid.getView().getGroups(), function (node) {
var chkCmp = node.firstChild.firstChild.childNodes[1].firstChild;
if (chkCmp.getAttribute('groupName') == chgGroupName) {
chkCmp[setGroup ? 'removeClassName' : 'addClassName']('x-grid3-check-col');
chkCmp[!setGroup ? 'removeClassName' : 'addClassName']('x-grid3-check-col-on');
}
});
}
};
}
});
});
}
}),
cls: 'grid-none-bottom',
colModel: new Ext.grid.ColumnModel({
qInternational: true,
defaults: {
qInternational: true
},
columns: [{
header: _S.MISC_QSYNC_CLIENT_WIZ86,
qInternationalKey: 'MISC_QSYNC_CLIENT_WIZ86',
width: 448,
dataIndex: 'name',
groupable: false,
renderer: function (data, metadata, record, rowIndex, columnIndex, store) {
var tip = _S[data] || data;
metadata.attr = 'ext:qtip="' + tip + '"';
return tip;
}
},
privCheckColumn,
{
header: '',
dataIndex: 'GroupName'
}],
}),
listeners: {
afterrender: function (cmp) {
cmp.hide();
},
afteredit: function (e) {
if (QNAP.QOS.config.ha_enabled && e.record.data.GroupName != 'MENU_5') {
e.record.reject();
return;
}
var chkValue = true,
setGroup = true,
GroupName = '';
if (e.record.data.checkbox) {
if (e.record.data.nvalue == 'QBOX') {
e.grid.store.each(function (record) {
if (record.data.nvalue == 'WFM') {
record.data.checkbox = true;
GroupName = record.data.GroupName;
record.afterEdit();
record.commit();
}
});
e.grid.store.each(function (record) {
if (record.data.checkbox == false && GroupName == record.data.GroupName) setGroup = false;
});
}
} else {
if (e.record.data.nvalue == 'WFM') {
e.grid.store.each(function (record) {
if (record.data.nvalue == 'QBOX') {
record.data.checkbox = false;
GroupName = record.data.GroupName;
setGroup = false;
record.afterEdit();
record.commit();
}
});
}
}
if (!Ext.isEmpty(GroupName)) {
Ext.each(e.grid.getView().getGroups(), function (node) {
var chkCmp = node.firstChild.firstChild.childNodes[e.column].firstChild;
if (chkCmp.getAttribute('groupName') == GroupName) {
chkCmp[setGroup ? 'removeClassName' : 'addClassName']('x-grid3-check-col');
chkCmp[!setGroup ? 'removeClassName' : 'addClassName']('x-grid3-check-col-on');
}
});
}
e.grid.store.each(function (record) {
if (record.data.checkbox == false && e.record.data.GroupName == record.data.GroupName) chkValue = false;
});
Ext.each(e.grid.getView().getGroups(), function (node) {
var chkCmp = node.firstChild.firstChild.childNodes[e.column].firstChild;
if (chkCmp.getAttribute('groupName') == e.record.data.GroupName) {
chkCmp[chkValue ? 'removeClassName' : 'addClassName']('x-grid3-check-col');
chkCmp[!chkValue ? 'removeClassName' : 'addClassName']('x-grid3-check-col-on');
}
});
e.record.afterEdit();
e.record.commit();
}
}
});
var step7_1 = new QNAP.QOS.wizard.formPanel({
border: false,
cls: 'panel-border-bottom',
style: 'padding: 6px 0 15px;',
items: [{
xtype: 'displayfield',
name: 'lbl_List',
value: _S.WIZ_USER_STR_01,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.WIZ_USER_STR_01);
},
cls: 'detial-txt-style',
hideLabel: true
}, privGrid],
tbar: [{
xtype: 'displayfield',
value: _S.USER_APPLICATION_PRIVILEGE,
qInternational: true,
qInternationalKey: {value: 'USER_APPLICATION_PRIVILEGE'},
cls: 'title-bar-style'
}, {
xtype: 'tbfill'
}, {
xtype: 'button',
id: ids.btnUserPrivilege,
text: _S.NIC_WEB_BTN_EDIT,
qInternational: true,
qInternationalKey: 'NIC_WEB_BTN_EDIT',
cls: 'qts-button q-default',
handler: function (cmp) {
var btnText;
var lbl_List = step7_1Form.findField('lbl_List');
var vis = privGrid.isVisible();
lbl_List.setVisible(vis);
if (vis) {
cmp.parserData()
privGrid.getEl().slideOut('t', {
easing: 'easeOut',
duration: .5,
remove: false,
useDisplay: false,
callback: function () {
privGrid.setVisible(!vis);
privGrid.doLayout();
}
});
btnText = 'NIC_WEB_BTN_EDIT';
} else {
privGrid.setVisible(!vis);
privGrid.setWidth(480);
privGrid.getEl().slideIn('t', {
easing: 'easeOut',
duration: .5,
callback: function () {
privGrid.doLayout();
}
});
btnText = 'IEI_NAS_BUTTON_CLOSE';
}
cmp[ !vis ? 'addClass' : 'removeClass']('btn-blue');
cmp.setText(_S[btnText]);
cmp.qInternationalKey = btnText;
},
parserData: function () {
var lbl_List = step7_1Form.findField('lbl_List');
var tmpAry = [], chk = false, oldStr, limitNum = 3, str = 'WIZ_USER_STR_01';
privStore.each(function (record) {
if (record.data.checkbox * 1 == 0) chk = true;
tmpAry.push(record.data);
});
if (chk) {
var obj = fn.procAry2StrLenS(tmpAry, limitNum, 'name', 'checkbox');
if (obj.total > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, obj.procStr, obj.total - obj.limit);
str = '<div ext:qtip="' + obj.oldStr + '">' + tmp + '</div>';
} else if (obj.total == 0) {
str  = 'WIZ_USER_STR_11';
} else {
str = obj.procStr;
}
}
lbl_List.setValue(_S[str] || str);
lbl_List.chk = chk;
lbl_List.tmpAry = tmpAry;
lbl_List.qInternationalFn = function (cmp) {
var str = 'WIZ_USER_STR_01';
if (cmp.chk) {
var obj = fn.procAry2StrLenS(cmp.tmpAry, limitNum, 'name', 'checkbox');
if (obj.total > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, obj.procStr, obj.total - obj.limit);
str = '<div ext:qtip="' + obj.oldStr + '">' + tmp + '</div>';
} else if (obj.total == 0) {
str  = 'WIZ_USER_STR_11';
} else {
str = obj.procStr;
}
}
cmp.setValue(_S[str] || str);
}
}
}]
});

var step7 = new QNAP.QOS.wizard.formPanel({
itemId: 'step7',
nextId: 'finish',
headerTitle: _S.USER_CREATE_WIZ_STR23,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR23',
defaults: {
xtype: 'displayfield',
style: 'padding-top:3px;'
},
bodyStyle: 'padding: 10px 60px 30px;',
autoScroll: true,
labelWidth: 170,
items: [{
value: _S.USER_CREATE_WIZ_STR24,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR24',
hideLabel: true
}, {
height: 10,
value: '&nbsp;'
}, {
itemId: 'username_info',
name: 'username_info',
fieldLabel: _S.IEI_DEVICE_MSG133,
qInternational: true,
qInternationalKey: 'IEI_DEVICE_MSG133',
labelSeparator: '',
value: 'test'
}, {
itemId: 'ps_info',
name: 'ps_info',
fieldLabel: _S.USER_CREATE_WIZ_STR25,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR25',
labelSeparator: '',
value: 'test',
hidden: true
}, {
itemId: 'email_info',
name: 'email_info',
fieldLabel: 'E-Mail',
labelSeparator: '',
value: 'test',
hidden: true
}, {
itemId: 'quota_sts_result',
name: 'quota_sts_result',
fieldLabel: _S.USER_CREATE_WIZ_STR26,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR26',
labelSeparator: '',
value: 'test'
}, {
itemId: 'gp_list',
name: 'gp_list',
fieldLabel: _S.USER_CREATE_WIZ_STR27,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR27',
labelSeparator: ''
}, {
itemId: 'rd_list',
name: 'rd_list',
fieldLabel: _S.USER_CREATE_WIZ_STR32,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR32',
labelSeparator: ''
}, {
itemId: 'rw_list',
name: 'rw_list',
fieldLabel: _S.USER_CREATE_WIZ_STR43,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR43',
labelSeparator: ''
}, {
itemId: 'no_list',
name: 'no_list',
fieldLabel: _S.USER_CREATE_WIZ_STR33,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR33',
labelSeparator: ''
}],
onNext: function () {
createUserApply();
return true;
}
});

var createUserApply = function (win) {
var para = {};
para.set_application_privilege = 1;

tmpRdArray = [];
tmpRwArray = [];
tmpNoArray = [];

Ext.each(shareArray, function (record) {
if (record.change == true) {
if (record.share_rd) tmpRdArray.push(record.sharename);
if (record.share_rw) tmpRwArray.push(record.sharename);
if (record.share_no) tmpNoArray.push(record.sharename);
}
})

para.rd_share_len = tmpRdArray.length;
Ext.each(tmpRdArray, function (data, i) {
para['rd_share' + i] = data;
});
para.rw_share_len = tmpRwArray.length;
Ext.each(tmpRwArray, function (data, i) {
para['rw_share' + i] = data;
});
para.no_share_len = tmpNoArray.length;
Ext.each(tmpNoArray, function (data, i) {
para['no_share' + i] = data;
});
para.a_tel = step2Form.findField('tel').getValue();
para.email = step2Form.findField('email').getValue();
para.ps = step2Form.findField('ps').getValue();
if (quota_enable == 1) {
var t_val = 'custom';
if (step3Form.findField('quotasize_t_group').getValue().inputValue == 'nolimit') t_val = 'nolimit';
else {
var unit = step3Form.findField('sizeUnit').getValue() == 'MB' ? 1 : 1024;
para.custom_quotasize = step3Form.findField('custom_quotasize').getValue() * unit;
}
para.quota_en = 1;
para.quota_type = t_val;
}

para.gp_len = 0;
Ext.each(groupArray, function (data) {
var value = data.groupname
if (data.checkbox == true || value == 'everyone') {
para['gp' + para.gp_len] = value;
para.gp_len++;
}
});

var c_val = '0';
/* var create_priv_group = step5Form.findField('create_priv_group').getValue().inputValue;
if (create_priv_group == 'yes') {
c_val = '1';
para.priv_sname = step5Form.findField('share_name_user').getValue();
para.path_type = step5Form.findField('path_type_group').getValue().inputValue;
if (para.path_type == 'manual') {
para.path = manualPathTreeCombo.getValue();
if (para.path.substring(0, 1) != '/') {
para.path = '/' + para.path;
}
}
} */

para.hidden = 'no'/* step5Form.findField('hidden_group').getValue().inputValue */;
para.oplocks = '1'/* step5Form.findField('oplocks_group').getValue().inputValue */;
para.create_priv = c_val;
para.comment = ''/* step5Form.findField('comment_user').getValue() */;
para.vol_no = fn.addUserPanelVolumeValue;/* step5Form.findField('disks_list_user').getValue(); */
para.a_username = step2Form.findField('new_username').getValue().replace(/([\s]*$)/g, '');
para.a_passwd = QNAP.lib.encryption.ezEncode(QNAP.lib.encryption.utf16to8(step2Form.findField('uc_pwd1').getValue()));
para.a_email = step2Form.findField('new_email').getValue();
para.a_description = step2Form.findField('new_description').getValue();
if (!Ext.isEmpty(para.a_description)) para.a_description = para.a_description.replace(/\n|\t|\r/g, ' ');
para.recursive = step6Form.findField('acl_recursive_user_add').getValue() ? 1 : 0;
para.send_mail = step2Form.findField('chk_send_mail').getValue() ? 1 : 0;
privStore.each(function (record) {
para[record.data.nvalue] = record.data.checkbox * 1;
});
var recycle_bin_status = 1;
/* if (step5Form.findField('path_type_group').getValue().inputValue != 'auto') {
para.manual_path = manualPathTreeCombo.getValue();
var chkPathAry = para.manual_path.split('/');
var chkDis = chkManualPath(false, chkPathAry);
if (chkDis) recycle_bin_status = 0;
} */
/* if (recycleBinEnable == 1 && create_priv_group == 'yes') {
para.recycle_bin = recycle_bin_status == 1 ? step5Form.findField('recycle_bin_group').getValue().inputValue : 0;
} else { */
para.recycle_bin = 0;
/* }
var recycleAdmin = step5Form.findField('recycle_bin_admin').getValue() ? 1 : 0; */
para.recycle_bin_administrators_only = para.recycle_bin !== 0 ? recycleAdmin : 0;
if (Ext.isDefined(runFinish)) runFinish.setMask.apply();
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_create'
}, {
action: 'add_user'
}),
method: 'POST',
params: para,
success: function (response, opts) {
if (para.create_priv == '1') app._getApp().fireEvent('filechange', app._getApp().id, '/', '/', para.priv_sname, 'new');
Ext.each(shareArray, function (data) {
app._getApp().fireEvent('filechange', app._getApp().id, '/', '/', data.sharename, 'privilage');
});
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'users');
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'users-a');
if (Ext.isEmpty(step2Form.findField('filename').getValue())) {
if (Ext.isDefined(runFinish)) runFinish.gridReload.apply();
else if (Ext.isDefined(win)) win.close();
} else {
step2Form.url = step2Form.urlTpl + '&username=' + para.a_username + '&sid=' + QNAP.QOS.user.sid;
fn.uploadImg(step2Form, null, win);
if (Ext.isDefined(runFinish)) runFinish.gridReload.apply();
else if (Ext.isDefined(win)) win.close();
}
},
failure: function () {
if (Ext.isDefined(runFinish)) runFinish.setUMask.apply();
}
});
}

var step2Form = step2.getForm();
var step3Form = step3.getForm();
var step4Form = step4.getForm();
var step6Form = step6.getForm();
var step7_1Form = step7_1.getForm();

var supportACL = false,
ACLEnabled = false;

items = {
title: _S.IEI_NAS_SECURITY15,
qInternational: true,
qInternationalKey: 'IEI_NAS_SECURITY15',
layout: 'border',
cls: 'utility-window win-form wiz-non-tbar-style',
items: [{
xtype: 'panel',
region: 'center',
layout: 'column',
border: false,
autoScroll: false,
items: [{
xtype: 'container',
style: 'padding: 20px;',
items: step2
}, {
xtype: 'container',
width: 520,
height: 436,
style: 'padding: 20px 0;overflow-y:scroll;',
items: [{
xtype: 'panel',
border: false,
cls: 'wiz-non-tbar-style',
style: 'padding-right:20px;',
items: [step4, step6, step7_1, step3]
}]
}]
}],
fbar: [{
xtype: 'button',
itemId: 'createBtn',
text: _S.IEI_NAS_BUTTON_CREATE,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_CREATE',
disabled: true,
handler: function (cmp) {
if (!step2.onNext() || !step3.onNext()) {
if (!step3.onNext()) {
var lbl_area = step3.getComponent('lbl_area');
var vis = lbl_area.isVisible();
if (!vis) {
var btn = step3.getTopToolbar().getComponent('btnChange');
btn.handler(btn);
}
}
return;
}
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
createUserApply(target);
}
}, {
xtype: 'button',
text: _S.IEI_NAS_BUTTON_CANCEL,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_CANCEL',
handler: function (cmp) {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
target.close();
}
}],
listeners: {
afterrender: function () {
step6.getComponent('grid_area').hide();
}
}
};
fn.setPwdStr();

ajax_info = {
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_create'
}),
method: 'POST',
success: function (response, opts) {
var xmlData = response.responseXML;
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
if (xmlData != undefined) {
recycleBinEnable = Ext.DomQuery.selectValue('recycleBinEnable', xmlData);
if (Ext.DomQuery.selectNode('UserNum', xmlData)) {
user_count = parseInt(Ext.DomQuery.selectValue('count', xmlData));
max_count = parseInt(Ext.DomQuery.selectValue('max_count', xmlData));
}
/* step5.getForm().findField('create_priv_group').setValue('no'); */
var quota_stsStr = '',
chkValue = Ext.DomQuery.selectValue('quotaInfo/enable', xmlData) == '1',
quotaSize = Ext.DomQuery.selectValue('quotaInfo/quotaSize', xmlData, 0),
quotaSizeUnit = 'MB';
if (chkValue) {
if (quotaSize / 1024 == parseInt(quotaSize / 1024)) {
quotaSize = quotaSize / 1024;
quotaSizeUnit = 'GB';
}
}
quota_enable = chkValue * 1;
step3Form.findField('quota_message').setVisible(!chkValue);
quota_stsStr = chkValue ? 'ISCSI_TARGET_LUN_STATUS_1' : 'ISCSI_TARGET_LUN_STATUS_0';
step3Form.findField('quotasize_t_group').setDisabled(!chkValue);
step3Form.findField('custom_quotasize').setValue(chkValue ? quotaSize : '');
step3Form.findField('sizeUnit').setValue(quotaSizeUnit);
step3Form.findField('sizeUnit').setDisabled(!chkValue);
step3.setVisible(quota_enable == 1);
step3.procList();
step3Form.findField('quota_sts').setValue(_S[quota_stsStr]);
step3Form.findField('quota_sts').qInternationalFn = function (cmp) {
cmp.setValue(_S[quota_stsStr]);
};
step3Form.findField('custom_quotasize').setDisabled((step3Form.findField('quotasize_t_group').getValue().inputValue == 'nolimit' || quota_enable == 0));
step3Form.findField('custom_quotasize').validate();
/* var volList = Ext.DomQuery.selectNode('volumeList', xmlData);
if (volList) fn.GenVolumeSelect('v2', step5Form.findField('disks_list_user'), volList, step5Form); */
fn.addUserPanelVolumeValue = fn.GenVolumeSelectValue(Ext.DomQuery.selectNode('volumeList', xmlData));
Ext.each(Ext.DomQuery.select('ShareList/sharename', xmlData), function (node) {
Used_ShareArray.push(node.firstChild.data);
});
/* if (recycleBinEnable == '1') {
step5Form.findField('recycle_bin_admin').setDisabled(step5.getComponent('recycle_bin_group').getValue().inputValue !== '1');
} */
var smptyEnable = Ext.DomQuery.selectValue('SMTPEnable', xmlData) != '0',
chk_send_mail = step2Form.findField('chk_send_mail');
chk_send_mail.boxLabel = smptyEnable ? _S.USER_CREATE_WIZ_STR46 : _S.USER_CREATE_WIZ_STR46 + "&nbsp;<img src='apps/systemPreferences/images/icon_help2.gif' ext:qtip='" + _S.USER_CREATE_WIZ_STR56 + "'/>";
chk_send_mail.qInternationalFn = function (cmp) {
cmp.wrap.child('.x-form-cb-label').update(smptyEnable ? _S.USER_CREATE_WIZ_STR46 : _S.USER_CREATE_WIZ_STR46 + "&nbsp;<img src='apps/systemPreferences/images/icon_help2.gif' ext:qtip='" + _S.USER_CREATE_WIZ_STR56 + "'/>");
};
chk_send_mail.wrap.child('.x-form-cb-label').update(chk_send_mail.boxLabel);
}
var chkCreatBtn = false, countAjax = 0;
if (parseInt(user_count) >= parseInt(max_count)) {
/* step1.getComponent('UserCountErr').show(); */
fn.winAlert(app, target, ['ERROR_NEW_USER_TITLE', 'QUICK09_STR01', 'ERROR_USERNUM_EXCEED_ACCOUNT'], 'info', '', target != '' ? target : null);
} else {
chkCreatBtn = true;
}
var setCreateBtn
groupStore.reload();
shareFolderStore.load({
callback: function () {
countAjax++;
if (Ext.isEmpty(target.getFooterToolbar().getComponent('createBtn'))) return false;
if (countAjax == 3 && chkCreatBtn) target.getFooterToolbar().getComponent('createBtn').enable();
step6.procList();
}
});
step6Form.findField('acl_recursive_user_add').setVisible(me.ACLEnabled);
step2Form.findField('new_username').focus(true, 100);
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: 'get_application_privilege'
}, {
username: ''
}),
method: 'POST',
success: function (response, opts) {
countAjax++;
if (Ext.isEmpty(target.getFooterToolbar().getComponent('createBtn'))) return false;
if (countAjax == 3 && chkCreatBtn) target.getFooterToolbar().getComponent('createBtn').enable();
var tmpAry = [];
Ext.each(Ext.DomQuery.select('Group', response.responseXML), function (data, index) {
var GroupName = Ext.DomQuery.selectValue('Name', data);
Ext.each(Ext.DomQuery.select('app', data), function (cdata) {
var valueAry = [];
valueAry = cdata.firstChild.data.split(',');
/* if (valueAry[0] == 'DOWNLOAD_STATION') {
} else {
valueAry[2] = 1;
} */
valueAry[2] = 1; //Bug 68066
valueAry.push(GroupName);
tmpAry.push(valueAry);
});
});
privStore.loadData(tmpAry);
},
failure: function () {}
});

QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_group_create'
}),
method: 'POST',
success: function (response, opts) {
countAjax++;
if (Ext.isEmpty(target.getFooterToolbar().getComponent('createBtn'))) return false;
if (countAjax == 3 && chkCreatBtn) target.getFooterToolbar().getComponent('createBtn').enable();
var xmlData = response.responseXML;
if (xmlData != undefined) {
if (Ext.DomQuery.selectNode('QDocRoot', xmlData)) {
group_count = Ext.DomQuery.selectValue('GroupNum/count', xmlData);
group_max_count = Ext.DomQuery.selectValue('GroupNum/max_count', xmlData);
fn.Used_GroupArray = [];
Ext.each(Ext.DomQuery.select('groupList/group/name', xmlData), function (node) {
fn.Used_GroupArray.push(node.firstChild.data);
});
}
}
},
failure: function () {}
});
if (Ext.isDefined(runFinish)) {
if (!Ext.isEmpty(runFinish.runBtnName)) {
Ext.each(runFinish.runBtnName, function (data) {
var btn = Ext.getCmp(ids[data]);
btn.handler(btn);
});
}
}
},
failure: function () {}
};
var setForm5Adv = function () {
var hidden_group = step5.getComponent('hidden_group');
hidden_group.setVisible(!hidden_group.isVisible());
var oplocks_group = step5.getComponent('oplocks_group');
oplocks_group.setVisible(!oplocks_group.isVisible());
var recycle_bin_group = step5.getComponent('recycle_bin_group');
var recycle_bin_admin = step5Form.findField('recycle_bin_admin');
if (recycleBinEnable == 1) {
recycle_bin_group.setVisible(!recycle_bin_group.isVisible());
recycle_bin_admin.setVisible(!recycle_bin_admin.isVisible());
} else {
recycle_bin_group.setVisible(false);
}
var path_type_group = step5.getComponent('path_type_group');
if (path_type_group.isVisible()) {
if (manualPathTreeCombo.getValue() == '') path_type_group.setValue('auto');
} else step5.doLayout();
path_type_group.setVisible(!path_type_group.isVisible());
var path = step5.getComponent('path');
path.setVisible(!path.isVisible());
};
return {
items: items,
ajax_info: ajax_info
};
},
qEditPrivate: function(me, runFinish) {
var fn = this,
app = me;
if (Ext.isDefined(me.app)) app = me.app;
var record = Ext.isDefined(runFinish) ? runFinish.record : {},
s_rd = false,
s_rw = false,
s_no = false,
editShareAry = [];
var editShareFolderStore = new Ext.data.Store({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: "user_share_edit"
}, {
getdata: 1,
userName: encodeURIComponent(encodeURIComponent(record.data.username))
}),
remoteSort: true,
method: 'POST',
baseParams: {
filter: '',
type: 0,
lower: 0,
upper: 10
},
defaultParamNames: {
limit: 'upper',
start: 'lower'
},
reader: new Ext.data.XmlReader({
root: 'data',
totalProperty: 'count',
record: 'share'
}, [{
name: 'sharename',
mapping: 'sharename'
}, {
name: 'share_rd',
mapping: 'share_rd'
}, {
name: 'share_rw',
mapping: 'share_rw'
}, {
name: 'share_no',
mapping: 'share_no'
}, {
name: 'type',
mapping: 'type'
}, {
name: 'now',
mapping: 'now'
}, {
name: 'priv',
mapping: 'preview'
}, {
name: 'is_gq',
mapping: 'is_gq'
}]),
listeners: {
beforeload: function(store, o) {
o.params.lower = o.params.lower || 0;
o.params.upper = o.params.lower + 10;
o.params.filter = editShareGrid.getTopToolbar().getComponent('editShareFilter') ? editShareGrid.getTopToolbar().getComponent('editShareFilter').getValue() : ''
store.each(function(record, index) {
var row = editShareGrid.getView().getRow(index);
Ext.each(editShareAry, function(data) {
if (data.sharename == record.data.sharename) {
data.share_rd = record.data.share_rd;
data.share_rw = record.data.share_rw;
data.share_no = record.data.share_no;
}
});
});
},
load: function(store) {
store.each(function(record, index) {
var row = editShareGrid.getView().getRow(index);
var chkValue = false;
var priv = record.data.priv;
record.data.priv = fn.chgStatuE2N(priv || 'N');
Ext.each(editShareAry, function(data) {
if (data.sharename == record.data.sharename) {
record.data.share_rd = data.share_rd == true;
record.data.share_rw = data.share_rw == true;
record.data.share_no = data.share_no == true;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
chkValue = true;
store.data.items[index].afterEdit();
}
});
if (!chkValue) {
var o = {
sharename: record.data.sharename,
share_rd: record.data.share_rd,
share_rw: record.data.share_rw,
share_no: record.data.share_no,
change: false,
is_gq: record.data.is_gq == '1'
};
switch (record.data.type) {
case 'R':
o.share_rd = record.data.share_rd = true;
break;
case 'W':
o.share_rw = record.data.share_rw = true;
break;
case 'I':
o.share_no = record.data.share_no = true;
break;
}
editShareAry.push(o);
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
store.data.items[index].afterEdit();
}
});
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
target.getEl().unmask();
delete store.reader.xmlData;
}
}
});
var edit_share_rd = new Ext.grid.CheckColumn({
header: '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>',
qInternationalFn: function(cmp) {
cmp.header = '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>';
},
width: 30,
dataIndex: "share_rd",
onMouseDown: function(e, t) {
if (Ext.fly(t).hasClass(this.createId())) {
e.stopEvent();
var index = this.grid.getView().findRowIndex(t);
var cindex = this.grid.getView().findCellIndex(t);
var record = this.grid.store.getAt(index);
var value = record.data[this.dataIndex];

if (QNAP.GQ.actionForbidden() && record.get("is_gq") == true) return;

record.set(this.dataIndex, !value);
var e = {
grid: this.grid,
record: record,
field: this.grid.colModel.getDataIndex(cindex),
originalValue: value,
value: !value,
row: index,
column: cindex
};
this.grid.fireEvent("afteredit", e);
}
},
renderer: function(value, attr, record, rowNum, colNum, store) {
attr.css += ' x-grid3-check-col-td';
if (QNAP.GQ.actionForbidden() && record.get("is_gq") == true) {
/* disable checkbox */
return String.format('<div class="x-grid3-check-col-disabled{0} {1}">&#160;</div>', value ? '-on' : '', this.createId());
} else {
attr.style += 'cursor:pointer';
return String.format('<div class="x-grid3-check-col{0} {1}">&#160;</div>', value ? '-on' : '', this.createId());
}
}
});
var edit_share_rw = new Ext.grid.CheckColumn({
header: '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>',
qInternationalFn: function(cmp) {
cmp.header = '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>';
},
width: 30,
dataIndex: "share_rw",
onMouseDown: function(e, t) {
if (Ext.fly(t).hasClass(this.createId())) {
e.stopEvent();
var index = this.grid.getView().findRowIndex(t);
var cindex = this.grid.getView().findCellIndex(t);
var record = this.grid.store.getAt(index);
var value = record.data[this.dataIndex];

if (QNAP.GQ.actionForbidden() && record.get("is_gq") == true) return;

record.set(this.dataIndex, !value);
var e = {
grid: this.grid,
record: record,
field: this.grid.colModel.getDataIndex(cindex),
originalValue: value,
value: !value,
row: index,
column: cindex
};
this.grid.fireEvent("afteredit", e);
}
},
renderer: function(value, attr, record, rowNum, colNum, store) {
attr.css += ' x-grid3-check-col-td';
if (QNAP.GQ.actionForbidden() && record.get("is_gq") == true) {
/* disable checkbox */
return String.format('<div class="x-grid3-check-col-disabled{0} {1}">&#160;</div>', value ? '-on' : '', this.createId());
} else {
attr.style += 'cursor:pointer';
return String.format('<div class="x-grid3-check-col{0} {1}">&#160;</div>', value ? '-on' : '', this.createId());
}
}
});
var edit_share_no = new Ext.grid.CheckColumn({
header: '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>',
qInternationalFn: function(cmp) {
cmp.header = '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>';
},
width: 30,
dataIndex: "share_no",
onMouseDown: function(e, t) {
if (Ext.fly(t).hasClass(this.createId())) {
e.stopEvent();
var index = this.grid.getView().findRowIndex(t);
var cindex = this.grid.getView().findCellIndex(t);
var record = this.grid.store.getAt(index);
var value = record.data[this.dataIndex];

if (QNAP.GQ.actionForbidden() && record.get("is_gq") == true) return;

record.set(this.dataIndex, !value);
var e = {
grid: this.grid,
record: record,
field: this.grid.colModel.getDataIndex(cindex),
originalValue: value,
value: !value,
row: index,
column: cindex
};
this.grid.fireEvent("afteredit", e);
}
},
renderer: function(value, attr, record, rowNum, colNum, store) {
attr.css += ' x-grid3-check-col-td';
if (QNAP.GQ.actionForbidden() && record.get("is_gq") == true) {
/* disable checkbox */
return String.format('<div class="x-grid3-check-col-disabled{0} {1}">&#160;</div>', value ? '-on' : '', this.createId());
} else {
attr.style += 'cursor:pointer';
return String.format('<div class="x-grid3-check-col{0} {1}">&#160;</div>', value ? '-on' : '', this.createId());
}
}
});
var editShareGrid = new Ext.grid.GridPanel({
title: '&nbsp;' + _S.QUICK04_STR08 + _S.QUICK09_STR01 + ' ' + record.data.username,
store: editShareFolderStore,
enableHdMenu: false,
enableColumnMove: false,
disableSelection: true,
trackMouseOver: false,
height: 390,
qInternational: true,
qInternationalFn: function(cmp) {
cmp.setTitle('&nbsp;' + _S.QUICK04_STR08 + _S.QUICK09_STR01 + ' ' + record.data.username);
},
cls: 'grid-none-bottom',
colModel: new Ext.grid.ColumnModel({
qInternational: true,
defaults: {
qInternational: true,
sortable: false
},
columns: [{
header: _S.USER_CREATE_WIZ_STR38,
qInternationalKey: 'USER_CREATE_WIZ_STR38',
dataIndex: 'sharename',
value2Tip: true
}, {
header: _S.QTS_MSG_4,
qInternationalKey: 'QTS_MSG_4',
dataIndex: 'now',
renderer: function(data, metadata, record, rowIndex, columnIndex, store) {
data = parseInt(data);
var tip = fn.chgStatuStr(data);
if (tip == 'USER_CREATE_WIZ_STR20' && !record.data.share_no) tip = 'USER_CREATE_WIZ_STR20_1';
tip = _S[tip] || tip;
metadata.attr = 'ext:qtip="' + tip + '" style="color:' + fn.getPreviewColor(data) + '"';
return tip;
}
},
edit_share_rd, edit_share_rw, edit_share_no
]
}),
viewConfig: {
forceFit: true,
scrollOffset: 0
},
columnLines: true,
buttonAlign: 'left',
frame: true,
tbar: [{
xtype: 'tbspacer',
itemId: 'space',
width: 345
}],
bbar: new Ext.quickWizPagingToolbar({
pageSize: 10,
store: editShareFolderStore,
displayInfo: true
}),
plugins: [
new Ext.ux.grid.userSearch({
mode: 'remote',
idFilter: 'editShareFilter',
iconCls: false,
readonlyIndexes: ['sharename'],
minChars: 1,
autoFocus: true
}), edit_share_rd, edit_share_rw, edit_share_no
],
listeners: {
scope: this,
headerclick: function(grid, columnIndex, e) {
switch (columnIndex) {
case 2:
srdCheckAll();
break;
case 3:
srwCheckAll();
break;
case 4:
snoCheckAll();
break;
}
},
afteredit: function(e) {
switch (e.field) {
case 'share_rd':
e.record.data.share_rw = false;
e.record.data.share_no = false;
break;
case 'share_rw':
e.record.data.share_rd = false;
e.record.data.share_no = false;
break;
case 'share_no':
e.record.data.share_rd = false;
e.record.data.share_rw = false;
break;
}
e.record.data.now = fn.compareNumber(e.record.data.priv, fn.chkShareRWI(e.record));
e.grid.store.data.items[e.row].afterEdit();

Ext.each(editShareAry, function(data) {
if (data.sharename == e.record.data.sharename) {
data.share_rd = e.record.data.share_rd;
data.share_rw = e.record.data.share_rw;
data.share_no = e.record.data.share_no;
data.change = true;
}
});
e.record.commit();
}
}
});

var items = {
title: _S.USER_MANAGEMENT_STR08,
qInternational: true,
qInternationalKey: 'USER_MANAGEMENT_STR08',
width: 620,
height: 515,
plain: true,
closable: true,
layout: "border",
items: [{
xtype: "form",
itemId: 'form',
region: "center",
autoScroll: true,
border: false,
items: [
editShareGrid, {
xtype: 'container',
style: 'padding-left:10px;',
items: [{
xtype: 'qtscheckbox',
itemId: 'acl_recursive_user_edit',
name: 'acl_recursive_user_edit',
boxLabel: _S.IEI_NAS_ACL15,
qInternational: true,
qInternationalKey: 'IEI_NAS_ACL15',
checked: true,
hideLabel: true
}]
}, {
xtype: 'container',
itemId: 'container',
layout: 'hbox',
style: 'padding:0 10px;',
items: [{
xtype: 'displayfield',
value: _S.COMMON_NOTE,
qInternational: true,
qInternationalKey: 'COMMON_NOTE',
hideLabel: true,
cls: 'note-color',
style: 'font-weight: bold;padding-right:5px;'
}, {
xtype: 'container',
items: [{
xtype: 'displayfield',
value: _S.PREVIEW_NOTE_STR01,
qInternational: true,
qInternationalKey: 'PREVIEW_NOTE_STR01',
hideLabel: true,
cls: 'note-color number-indent-line'
}, {
xtype: 'displayfield',
value: _S.PREVIEW_NOTE_STR02,
qInternational: true,
qInternationalKey: 'PREVIEW_NOTE_STR02',
qInternationalFn: function(cmp) {
cmp.ownerCt.ownerCt.doLayout();
setEditShareGrid();
},
hideLabel: true,
cls: 'note-color number-indent-line'
}]
}]
}
]
}],
buttons: [{
xtype: 'button',
text: _S.IEI_NAS_BUTTON_APPLY,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_APPLY',
cls: 'fbarBtn',
overCls: 'ofbarBtn',
handler: function() {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow(),
form = target.getComponent('form').getForm(),
empty_share_len = 0,
rd_share_len = 0,
rw_share_len = 0,
no_share_len = 0;
var para = {
username: record.data.username
};
target.getEl().mask(_S.APPLY_MSG);
Ext.each(editShareAry, function(data) {
if (data.change == true) {
if (data.share_rd) {
para['rd_share' + rd_share_len] = data.sharename;
rd_share_len++;
} else if (data.share_rw) {
para['rw_share' + rw_share_len] = data.sharename;
rw_share_len++;
} else if (data.share_no) {
para['no_share' + no_share_len] = data.sharename;
no_share_len++;
} else {
para['empty_share' + empty_share_len] = data.sharename;
empty_share_len++;
}
}
});
para.rd_share_len = rd_share_len;
para.rw_share_len = rw_share_len;
para.no_share_len = no_share_len;
para.empty_share_len = empty_share_len;
para.recursive = form.findField('acl_recursive_user_edit').getValue() ? 1 : 0;

QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: 'user_share_edit'
}, {
action: 'user_share_edit'
}),
method: 'POST',
params: para,
success: Ext.emptyFn,
failure: Ext.emptyFn,
callback: function() {
if (Ext.isDefined(runFinish)) runFinish.gridReload.apply();
target.close();
app._getApp().fireEvent('filechange', app._getApp().id, '/', '/', '', 'privilage');
}
});
}
}, {
xtype: 'button',
text: _S.CANCEL,
qInternational: true,
qInternationalKey: 'CANCEL',
cls: 'fbarBtn',
overCls: 'ofbarBtn',
handler: function() {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
target.close();
}
}],
listeners: {
scope: this,
afterlayout: function() {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
target.getComponent('form').getForm().findField('acl_recursive_user_edit').setVisible(me.ACLEnabled);
},
show: function() {
setEditShareGrid();
},
afterrender: function() {
editShareFolderStore.reload();
editShareGrid.getTopToolbar().getComponent('space').setWidth(editShareGrid.getWidth() - 135);
}
}
};

function srdCheckAll() {
if (!s_rd) {
s_rd = true;
s_rw = false;
s_no = false;
} else {
s_rd = false;
}
Ext.each(editShareAry, function(data) {
editShareGrid.store.each(function(record) {
if (QNAP.GQ.actionForbidden() && data.is_gq) {
_D("skip RO checked");
} else if (data.sharename == record.data.sharename) {
data.share_rd = record.data.share_rd = s_rd;
if (s_rd) data.share_rw = record.data.share_rw = false;
if (s_rd) data.share_no = record.data.share_no = false;
data.change = true;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
record.afterEdit();
}
});
});
}
function srwCheckAll() {
if (!s_rw) {
s_rd = false;
s_rw = true;
s_no = false;
} else {
s_rw = false;
}
Ext.each(editShareAry, function(data) {
editShareGrid.store.each(function(record) {
if (QNAP.GQ.actionForbidden() && data.is_gq) {
_D("skip RW checked");
} else if (data.sharename == record.data.sharename) {
if (s_rw) data.share_rd = record.data.share_rd = false;
data.share_rw = record.data.share_rw = s_rw;
if (s_rw) data.share_no = record.data.share_no = false;
data.change = true;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
record.afterEdit();
}
});
});
}
function snoCheckAll() {
if (!s_no) {
s_rd = false;
s_rw = false;
s_no = true;
} else {
s_no = false;
}
Ext.each(editShareAry, function(data) {
editShareGrid.store.each(function(record) {
if (QNAP.GQ.actionForbidden() && data.is_gq) {
_D("skip Deny checked");
} else if (data.sharename == record.data.sharename) {
if (s_no) data.share_rd = record.data.share_rd = false;
if (s_no) data.share_rw = record.data.share_rw = false;
data.share_no = record.data.share_no = s_no;
data.change = true;
record.data.now = fn.compareNumber(record.data.priv, fn.chkShareRWI(record));
record.afterEdit();
}
});
});
}
function setEditShareGrid() {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
editShareGrid.setHeight(target.getHeight() - target.getComponent('form').getForm().findField('acl_recursive_user_edit').getHeight() - target.getComponent('form').getComponent('container').getHeight() - 116);
}
return {
items: items
};
},
qMAddUser: function (me, runFinish) {
var fn = this,
app = me;
if (Ext.isDefined(me.app)) app = me.app;
var max_count = 0,
user_count = 0;

function set_multi_user_create() {
var para = {};
para.NAME = step2Form.findField('NAME_MU').getValue();
para.ACCOUNT = step2Form.findField('ACCOUNT_MU').getValue();
para.USER_NUM = step2Form.findField('USER_NUM_MU').getValue();
para.PASSWD = QNAP.lib.encryption.ezEncode(QNAP.lib.encryption.utf16to8(step2Form.findField('PASSWD_MU').getValue()));
para.VERIFY = QNAP.lib.encryption.ezEncode(QNAP.lib.encryption.utf16to8(step2Form.findField('VERIFY_MU').getValue()));
para.create_net_share = step3.get('create_net_share_group').getValue().inputValue;

if (para.create_net_share == 1) {
para.nowATE = 1;
para.hidden_share = step4.get('hidden_share_group').getValue().inputValue;
para.oplocks_share = step4.get('oplocks_share_group').getValue().inputValue;
para.DISKS = step4.getComponent('DISKS').getValue();
para.PRIVATE = 1;
}
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'multi_user_create'
}, {
action: 'add_multi_user'
}),
method: 'POST',
params: para,
success: function (response, opts) {
if (Ext.isDefined(runFinish)) runFinish.clearAry.apply();
},
failure: function () {}
});
}

function final_info(createFolder) {
var name_num = 0,
counter = 0,
user_list_string = '';
if (Ext.isDefined(runFinish)) runFinish.setMask.apply();
else QNAP.QOS.lib.MaskMgr.mask(app._getMainWindow().getEl(), 'APPLY_MSG', _S.APPLY_MSG);
var name = step2Form.findField('NAME_MU').getValue();
var account = step2Form.findField('ACCOUNT_MU').getValue();
var user_num = step2Form.findField('USER_NUM_MU').getValue();

for (var i = 0; i < user_num; i++) {
if (i != 0) user_list_string += ', ';
if (i > 9) break;
name_num = parseInt(account, 10) + i;
if (user_num < 10) {
user_list_string += name + name_num;
} else if (user_num > 9 && user_num < 100) {
user_list_string += (name_num < 10) ? name + '0' + name_num : name + name_num;
} else if (user_num > 99 && user_num < 1000) {
if (name_num < 10) user_list_string += name + '00' + name_num;
else if (name_num < 100 && name_num > 9) user_list_string += name + '0' + name_num;
else user_list_string += name + name_num;
} else if (user_num > 999 && user_num < 10000) {
if (name_num < 10) user_list_string += name + '000' + name_num;
else if (name_num < 100 && name_num > 9) user_list_string += name + '00' + name_num;
else if (name_num < 1000 && name_num > 99) user_list_string += name + '0' + name_num;
else user_list_string += name + name_num;
}
}
if (i != user_num) {
name_num = parseInt(account) + parseInt(user_num) - 1;
user_list_string += ' ...., ' + name + name_num;
}
finishForm.findField('new_user_list').setValue(user_list_string);

var progress_bar_timer = setInterval(function () {
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'multi_user_create'
}, {
action: 'get_upload_progress'
}),
method: 'POST',
success: function (response, opts) {
var xmlData = response.responseXML;
if (xmlData != undefined) {
var root = Ext.DomQuery.selectNode('QDocRoot', xmlData);
if (root) {
var uploadprogressbar = finish.getComponent('uploadprogressbar');
uploadprogressbar.show();
uploadprogressbar.setWidth(200);
uploadprogressbar.progressBar.setHeight(18);
var Result = parseInt(Ext.DomQuery.selectValue('MultiUserUpload/Result', xmlData));
var Status = Ext.DomQuery.selectValue('MultiUserUpload/status', xmlData);
if (Result == 100) {
clearInterval(progress_bar_timer);
if (createFolder) {
for (var i = account; i < (parseInt(account) + parseInt(user_num)); i++) {
app._getApp().fireEvent('filechange', app._getApp().id, '/', '/', name + i, 'new');
}
}
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'users');
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'users-a');
}

var ms = 1000 / Result;
for (var i = counter; i < Result; i++) {
/* Ext.TaskMgr.start.defer(i * ms, this, [{
run: function () {
if (counter < 100) updateProgressPercent();
},
interval: i * ms,
repeat: 1
}]); */
setTimeout(function () {
if (counter < 100) updateProgressPercent();
}, i * ms);
}

function updateProgressPercent() {
counter++;
var prc = counter / 100;
uploadprogressbar.updateProgress(prc, counter + '%');
uploadprogressbar.setSize(200, 20);
if (counter == 100) {
finishForm.findField('create_error').setVisible(Status != "0");
if (Ext.isDefined(runFinish)) runFinish.gridReload.apply();
else app._getMainWindow().getEl().unmask();
}
}
}
}
},
failure: function () {
if (Ext.isDefined(runFinish)) runFinish.setUMask.apply();
else app._getMainWindow().getEl().unmask();
}
});
}, 2000);
}

var step1 = new QNAP.QOS.wizard.formPanel({
itemId: 'step1',
nextId: 'step2',
headerTitle: _S.HOME_STR02,
qInternational: true,
qInternationalKey: 'HOME_STR02',
hideLabels: true,
autoScroll: true,
items: [{
xtype: 'displayfield',
value: _S.MULTI_USER_WIZ_STR04,
qInternational: true,
qInternationalKey: 'MULTI_USER_WIZ_STR04',
hideLabel: true
}, {
xtype: 'displayfield',
value: _S.MULTI_USER_WIZ_STR05,
qInternational: true,
qInternationalKey: 'MULTI_USER_WIZ_STR05',
hideLabel: true
}]
});
var PASSWORD_EL = {
tag: 'input',
type: 'checkbox',
autocomplete: 'off',
'data-flag': 'true'
};
var step2 = new QNAP.QOS.wizard.formPanel({
itemId: 'step2',
nextId: 'step3',
headerTitle: _S.HOME_STR02,
qInternational: true,
qInternationalKey: 'HOME_STR02',
labelWidth: 160,
autoScroll: true,
items: [{
xtype: 'textfield',
itemId: 'NAME_MU',
name: 'NAME_MU',
maxLength: 23,
fieldLabel: _S.IEI_NAS_SECURITY72,
qInternational: true,
qInternationalKey: 'IEI_NAS_SECURITY72',
validator: function (v) {
if (v.length == 0) return _S.FTP_STR41;
else if (!fn.isNotValidChar(v) || v.indexOf(' ') != -1 || v.indexOf('@') != -1) return _S.USER_GROUP_GREATE_WIZ_STR18;
else if (v.charAt(0) == '-' || v.charAt(0) == '#' || v.charAt(0) == '@') return _S.USER_GROUP_GREATE_WIZ_STR25;
return true;
}
}, {
xtype: 'numberfield',
itemId: 'ACCOUNT_MU',
name: 'ACCOUNT_MU',
maxLength: 8,
fieldLabel: _S.IEI_NAS_SECURITY69,
qInternational: true,
qInternationalKey: 'IEI_NAS_SECURITY69',
allowDecimals: false,
allowNegative: false,
validator: function (v) {
if (v.length == 0) return _S.FTP_STR41;
else if (parseInt(v) < 0) return _S.USER_GROUP_GREATE_WIZ_STR28;
return true;
}
}, {
xtype: 'numberfield',
itemId: 'USER_NUM_MU',
name: 'USER_NUM_MU',
maxLength: 4,
fieldLabel: _S.IEI_NAS_SECURITY70,
qInternational: true,
qInternationalKey: 'IEI_NAS_SECURITY70',
allowDecimals: false,
allowNegative: false,
validator: function (v) {
if (v.length == 0) return _S.FTP_STR41;
if (max_count - user_count <= 0) return _S.ERROR_MULTI_USERNUM_EXCEED01 + _S.ERROR_MULTI_USERNUM_EXCEED02;
if (parseInt(v) > (max_count - user_count)) return String.format(_S.IEI_NAS_ALERT88_8, max_count - user_count);
return true;
}
}, {
xtype: 'textfield',
itemId: 'PASSWD_MU',
name: 'PASSWD_MU',
maxLength: 64,
fieldLabel: _S.IEI_DEVICE_MSG135,
defaultAutoCreate: PASSWORD_EL,
qInternational: true,
qInternationalKey: 'IEI_DEVICE_MSG135',
labelSeparator: '',
inputType: 'password',
validator: function (v) {
var errs = fn.isValidPassword(step2Form.findField('NAME_MU').getValue(), v);
return errs.length == 0 ? true : '<ul style="list-style:inside;" ><li>' + errs.join('</li><li>') + '</li></ul>';
},
enableKeyEvents: true,
listeners: {
buffer: 500,
keyup: function (f, e) {
if (fn.countStrLen(f.getValue()) > f.maxLength) f.setValue(fn.getCusLenStr(f.getValue(), f.maxLength));
}
}
}, {
xtype: 'textfield',
itemId: 'VERIFY_MU',
name: 'VERIFY_MU',
maxLength: 64,
fieldLabel: _S.IEI_NAS_SECURITY28,
defaultAutoCreate: PASSWORD_EL,
qInternational: true,
qInternationalKey: 'IEI_NAS_SECURITY28',
inputType: 'password',
validator: function (v) {
if (step2Form.findField('PASSWD_MU').getValue() != v) return _S.USER_GROUP_GREATE_WIZ_STR26;
return true;
},
enableKeyEvents: true,
listeners: {
buffer: 500,
keyup: function (f, e) {
if (fn.countStrLen(f.getValue()) > f.maxLength) f.setValue(fn.getCusLenStr(f.getValue(), f.maxLength));
}
}
}, {
xtype: 'qtscheckbox',
boxLabel: _S.QTS_SHOW_PASSWORD,
qInternational: true,
qInternationalKey: {
boxLabel: 'QTS_SHOW_PASSWORD'
},
isDirty: function () {
return false;
},
handler: function (checkbox, checked) {
var inputs = checkbox.ownerCt.getEl().select('input[data-flag="true"]');
inputs.set({
type: checked ? 'text' : 'password'
});
}
}, {
xtype: 'displayfield',
value: _S.IEI_NAS_SECURITY29.replace('16', '64'),
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.IEI_NAS_SECURITY29.replace('16', '64'));
},
cls: 'note-color',
hideLabel: true
}],
onNext: function () {
return step2Form.findField('NAME_MU').isValid() && step2Form.findField('ACCOUNT_MU').isValid() && step2Form.findField('PASSWD_MU').isValid() && step2Form.findField('USER_NUM_MU').isValid() && step2Form.findField('VERIFY_MU').isValid();
}
});
var step3 = new QNAP.QOS.wizard.formPanel({
itemId: 'step3',
nextId: 'step4',
headerTitle: _S.MULTI_USER_WIZ_STR08,
qInternational: true,
qInternationalKey: 'MULTI_USER_WIZ_STR08',
labelWidth: 120,
autoScroll: true,
items: [{
xtype: 'displayfield',
value: _S.MULTI_USER_WIZ_STR09,
qInternational: true,
qInternationalKey: 'MULTI_USER_WIZ_STR09',
hideLabel: true
}, {
xtype: 'qtsradiogroup',
itemId: 'create_net_share_group',
hideLabel: true,
columns: 1,
items: [{
boxLabel: _S.USER_GROUP_GREATE_WIZ_STR07,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR07',
hideLabel: true,
name: 'create_net_share',
inputValue: '1'
}, {
boxLabel: _S.USER_GROUP_GREATE_WIZ_STR08,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR08',
hideLabel: true,
name: 'create_net_share',
inputValue: '0',
checked: true
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}, {
xtype: 'displayfield',
value: _S.USER_GROUP_GREATE_WIZ_STR09,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR09',
cls: 'note-color',
hideLabel: true
}],
onNext: function () {
if (step3.items.get('create_net_share_group').getValue().getGroupValue() != '1') {
set_multi_user_create();
final_info(false);
}
return true;
},
getNextId: function () {
if (step3.items.get('create_net_share_group').getValue().getGroupValue() == '1') {
return 'step4';
} else {
return 'finish';
}
}
});
var step4 = new QNAP.QOS.wizard.formPanel({
itemId: 'step4',
nextId: 'finish',
headerTitle: _S.MULTI_USER_WIZ_STR08,
qInternational: true,
qInternationalKey: 'MULTI_USER_WIZ_STR08',
labelWidth: 150,
autoScroll: true,
items: [{
xtype: 'qtsradiogroup',
itemId: 'hidden_share_group',
fieldLabel: _S.IEI_NAS_SHARE77,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE77',
columns: 5,
items: [{
boxLabel: _S.USER_GROUP_GREATE_WIZ_STR07,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR07',
hideLabel: true,
name: 'hidden_share',
inputValue: '0'
}, {
boxLabel: _S.USER_GROUP_GREATE_WIZ_STR08,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR08',
hideLabel: true,
name: 'hidden_share',
inputValue: '1',
checked: true
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}, {
xtype: 'qtsradiogroup',
itemId: 'oplocks_share_group',
fieldLabel: _S.IEI_NAS_SHARE79,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE79',
columns: 5,
items: [{
boxLabel: _S.IEI_NAS_BUTTON_YES,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_YES',
hideLabel: true,
name: 'oplocks_share',
inputValue: '1',
checked: true
}, {
boxLabel: _S.IEI_NAS_BUTTON_NO,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_NO',
hideLabel: true,
name: 'oplocks_share',
inputValue: '0'
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}, {
xtype: 'combo',
itemId: 'DISKS',
name: 'DISKS',
fieldLabel: _S.IEI_NAS_SHARE39,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE39',
width: 220,
store: new Ext.data.ArrayStore({
fields: ['listName', 'listValue', 'qInternationalKey', 'diskNumber', 'fstype']
}),
value: "1",
displayField: 'listName',
valueField: 'listValue',
mode: 'local',
editable: false,
allowBlank: false,
triggerAction: 'all',
qInternationalFn: function (cmp) {
if (QNAP.QOS.config.bIsStorageV2) return;
var v = cmp.getValue();
cmp.getStore().each(function (r) {
var a = '';
if (r.data.qInternationalKey != '') a = _S[r.data.qInternationalKey] || r.data.qInternationalKey;
r.data.listName = a + r.data.diskNumber;
r.afterEdit();
});
cmp.setValue(v);
}
}],
onNext: function () {
set_multi_user_create();
final_info(true);
return true;
},
listeners: {
show: function () {
step4.getComponent('DISKS').setSize(step4.getComponent('DISKS').getWidth());
}
}
});
var finish = new QNAP.QOS.wizard.formPanel({
itemId: 'finish',
headerTitle: _S.MULTI_USER_WIZ_STR11,
qInternational: true,
qInternationalKey: 'MULTI_USER_WIZ_STR11',
hideLabels: true,
autoScroll: true,
items: [{
xtype: 'displayfield',
value: _S.MULTI_USER_WIZ_STR12,
qInternational: true,
qInternationalKey: 'MULTI_USER_WIZ_STR12',
hideLabel: true
}, {
xtype: 'container',
layout: 'column',
border: false,
cls: 'x-form-item',
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
value: _S.MULTI_USER_WIZ_STR13,
qInternational: true,
qInternationalKey: 'MULTI_USER_WIZ_STR13',
hideLabel: true
}, {
xtype: 'displayfield',
itemId: 'new_user_list',
name: 'new_user_list'
}]
}, {
xtype: 'progress',
itemId: 'uploadprogressbar',
text: '0%',
width: 200,
height: 20
}, {
xtype: 'container',
height: 10
}, {
xtype: 'displayfield',
itemId: 'create_error',
name: 'create_error',
value: _S.MULTI_USER_WIZ_STR14,
qInternational: true,
qInternationalKey: 'MULTI_USER_WIZ_STR14',
hideLabel: true,
style: 'background-color:#FEF1F0;border:1px solid #990000;color:red;padding:10px;',
hidden: true
}]
});
var step2Form = step2.getForm();
var finishForm = finish.getForm();

items = {
ver: 2,
cls: 'utility-window win-form',
height: 450,
steps: [step1, step2, step3, step4, finish],
};
fn.setPwdStr();
ajax_info = {
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'multi_user_create'
}),
method: 'POST',
success: function (response, opts) {
var xmlData = response.responseXML;
if (xmlData != undefined) {
var root = Ext.DomQuery.selectNode('QDocRoot', xmlData);
if (root) {
user_count = Ext.DomQuery.selectValue('count', xmlData);
max_count = Ext.DomQuery.selectValue('max_count', xmlData);
var volList = Ext.DomQuery.selectNode('volumeList', xmlData);
if (volList) fn.GenVolumeSelect('v2', step4.getComponent('DISKS'), volList);
}
}
},
failure: function () {}
};
return {
items: items,
ajax_info: ajax_info
};
},
qAddGroup: function (me, runFinish) {
var fn = this,
app = me;
if (Ext.isDefined(me.app)) app = me.app;
var group_count = 0,
max_count = 0,
userGroupAry = [];
var Default_GroupArray = new Array("guest", "everyone", "administrators", "xmail", "dovecot");

function set_user_group_create() {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
QNAP.QOS.lib.MaskMgr.mask(target.getEl(), 'APPLY_MSG', _S.APPLY_MSG);
var para = {};
para.new_groupname = step1Form.findField('new_groupname').getValue();
para.group_remark = step1Form.findField('group_remark').getValue();
para.select_user = step2Form.findField('select_user_group').getValue().inputValue;
if (step2Form.findField('select_user_group').getValue().inputValue == '0') {
para.users_count = 0;
} else {
var choiceTotal = 0;
Ext.each(userGroupAry, function (data) {
if (data.checkbox) {
para['user' + choiceTotal] = data.username;
choiceTotal++;
}
});
para.users_count = choiceTotal;
}
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_group_create'
}, {
action: 'add_group'
}),
method: 'POST',
params: para,
success: function (response, opts) {
finishPanel.headerTitle = _S.USER_GROUP_GREATE_WIZ_STR13;
finishPanel.qInternational = true;
finishPanel.qInternationalKey = 'USER_GROUP_GREATE_WIZ_STR13';
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'groups');
},
failure: function () {},
callback: function () {
target.getEl().unmask();
}
});
}

var step1 = new QNAP.QOS.wizard.formPanel({
itemId: 'step1',
nextId: 'step2',
headerTitle: _S.HOME_STR03,
qInternational: true,
qInternationalKey: 'HOME_STR03',
labelWidth: 150,
defaults: {
xtype: 'displayfield'
},
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
items: [{
value: _S.USER_GROUP_GREATE_WIZ_STR01,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR01',
hideLabel: true
}, {
xtype: 'container',
layout: 'column',
hideLabel: true,
border: false,
style: 'font-size:12px;padding-bottom:5px;',
items: [{
xtype: 'displayfield',
value: _S.USER_GROUP_GREATE_WIZ_STR03,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR03',
hideLabel: true,
style: 'padding: 3px 11px 0 0;'
}, {
xtype: 'textfield',
itemId: 'new_groupname',
name: 'new_groupname',
maxLength: 128,
enableKeyEvents: true,
listeners: {
buffer: 500,
keyup: function (f, e) {
if (fn.countStrLen(f.getValue()) > f.maxLength) f.setValue(fn.getCusLenStr(f.getValue(), f.maxLength));
}
},
validator: function (v) {
if (v.length == 0) return _S.ERROR_EMPTY_GROUP_NAME;
else if (!fn.isNotValidChar(v) || v.indexOf(' ') != -1 || v.indexOf('@') != -1) return _S.USER_GROUP_GREATE_WIZ_STR18;
else if (Default_GroupArray.inArray(v.toLowerCase())) return _S.ERROR_RESERVED_GROUP;
else if (fn.Used_GroupArray.inArray(v.toLowerCase())) return _S.IEI_IDS_STRING108;
else if (v.charAt(0) == '#' || v.charAt(0) == '-') return _S.ERROR_BAD_GROUPNAME_FIRST_CHAR;
return true;
}
}]
}, {
xtype: 'textfield',
itemId: 'group_remark',
name: 'group_remark',
maxLength: 128,
fieldLabel: QNAP.layout.fixSpaceIndent(1, _S.USER_GROUP_GREATE_WIZ_STR04),
qInternational: true,
qInternationalFn: function (cmp) {
cmp.label.update(QNAP.layout.fixSpaceIndent(1, _S.USER_GROUP_GREATE_WIZ_STR04));
},
labelSeparator: '',
hidden: true,
validator: function (v) {
if (!fn.isNotValidChar(v)) return _S.USER_GROUP_GREATE_WIZ_STR23;
return true;
}
}, {
itemId: 'GroupCountErr',
name: 'GroupCountErr',
value: _S.ERROR_NEW_GROUP_TITLE + ' ' + _S.QUICK09_STR01 + ' ' + _S.ERROR_GROUPNUM_EXCEED_ACCOUNT,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.ERROR_NEW_GROUP_TITLE + ' ' + _S.QUICK09_STR01 + ' ' + _S.ERROR_GROUPNUM_EXCEED_ACCOUNT);
},
style: 'color:red;',
hideLabel: true,
hidden: true
}],
onNext: function () {
return (step1Form.findField('new_groupname').isValid() && step1Form.findField('group_remark').isValid());
}
});

var step2 = new QNAP.QOS.wizard.formPanel({
itemId: 'step2',
nextId: 'step3',
headerTitle: _S.USER_GROUP_GREATE_WIZ_STR05,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR05',
labelWidth: 120,
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
items: [{
xtype: 'displayfield',
value: _S.USER_GROUP_GREATE_WIZ_STR06,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR06',
hideLabel: true
}, {
xtype: 'radiogroup',
itemId: 'select_user_group',
hideLabel: true,
columns: 1,
items: [{
boxLabel: _S.USER_GROUP_GREATE_WIZ_STR07,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR07',
hideLabel: true,
name: 'select_user',
inputValue: '1',
checked: true
}, {
boxLabel: _S.USER_GROUP_GREATE_WIZ_STR08,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR08',
hideLabel: true,
name: 'select_user',
inputValue: '0'
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}],
onNext: function () {
finishForm.findField('new_groupname2').setValue(step1Form.findField('new_groupname').getValue().replace(/\&/, '&amp;'));
if (step2Form.findField('select_user_group').getValue().inputValue == '0') {
finishForm.findField('users_in_group').setValue('---');
set_user_group_create();
}
return true;
},
getNextId: function () {
if (step2Form.findField('select_user_group').getValue().inputValue == '1') {
setTimeout(function () {
try {
gridUserGroup.getTopToolbar().getComponent('space').setWidth(gridUserGroup.getWidth() - 130);
} catch (e) {}
}, 10);
return 'step3'
} else {
return 'finish';
}
}
});

var groupCheckColumn = new Ext.grid.CheckboxSelectionModel({
dataIndex: "checkbox",
checkOnly: true,
listeners: {
rowdeselect: function (sm, rowIndex, record) {
Ext.each(userGroupAry, function (data) {
if (data.username == record.data.username) {
data.checkbox = record.data.checkbox = false;
}
});
record.afterEdit();
},
rowselect: function (sm, rowIndex, record) {
Ext.each(userGroupAry, function (data) {
if (data.username == record.data.username) {
data.checkbox = record.data.checkbox = true;
}
});
record.afterEdit();
}
}
});

var userGroupStore = new Ext.data.Store({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: "group_user_edit"
}, {
getdata: 1
}),
remoteSort: true,
method: 'POST',
baseParams: {
filter: '',
type: 0,
lower: 0,
upper: 10
},
defaultParamNames: {
limit: 'upper',
start: 'lower'
},
reader: new Ext.data.XmlReader({
root: 'data',
totalProperty: 'userroot > count',
record: 'user'
}, [{
name: 'username',
mapping: 'username'
}, {
name: 'checkbox',
mapping: 'checkbox',
type: 'bool'
}]),
listeners: {
beforeload: function (store, o) {
o.params.lower = o.params.lower || 0;
o.params.upper = o.params.lower + 10;
o.params.filter = userGroupFilter.field ? userGroupFilter.field.getValue() : ''
},
load: function (store) {
var tmpSel = [];
store.each(function (record, index) {
var chkValue = false;
Ext.each(userGroupAry, function (data) {
if (data.username == record.data.username) {
record.data.checkbox = data.checkbox == true;
chkValue = true;
store.data.items[index].afterEdit();
}
});
if (!chkValue) {
userGroupAry.push({
username: record.data.username,
checkbox: record.data.checkbox
});
}
if (record.data.checkbox == true) tmpSel.push(index);
});
if (tmpSel.length) gridUserGroup.selModel.selectRows(tmpSel);
delete store.reader.xmlData;
}
}
});

var userGroupFilter = new Ext.ux.grid.wizSearch({
mode: 'remote',
idFilter: 'userGroupFilter',
iconCls: false,
readonlyIndexes: ['username'],
minChars: 1,
autoFocus: true
});

var gridUserGroup = new Ext.grid.GridPanel({
store: userGroupStore,
enableHdMenu: false,
disableSelection: true,
trackMouseOver: false,
autoExpandColumn: "checkbox",
height: Ext.isDefined(runFinish) ? runFinish.groupGridHeight : 348,
qInternational: true,
colModel: new Ext.grid.ColumnModel({
qInternational: true,
columns: [groupCheckColumn,
{
header: _S.QUICK04_STR08,
qInternational: true,
qInternationalKey: 'QUICK04_STR08',
sortable: false,
dataIndex: 'username',
value2Tip: true
}]
}),
viewConfig: {
forceFit: true,
scrollOffset: 0
},
columnLines: true,
buttonAlign: 'left',
frame: true,
tbar: [{
xtype: 'tbspacer',
itemId: 'space',
width: 345
}],
bbar: new Ext.wizardPagingToolbar({
pageSize: 10,
store: userGroupStore,
displayInfo: true
}),
sm: groupCheckColumn,
plugins: [userGroupFilter],
listeners: {
afteredit: function (e) {
e.record.commit();
}
}
});

var step3 = new QNAP.QOS.wizard.formPanel({
itemId: 'step3',
nextId: 'finish',
headerTitle: _S.USER_GROUP_GREATE_WIZ_STR05,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR05',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
items: gridUserGroup,
onNext: function () {
gridUserGroup.store.each(function (record) {
var chkValue = false;
Ext.each(userGroupAry, function (data) {
if (data.username == record.data.username) {
data.checkbox = record.data.checkbox;
chkValue = true;
}
});
if (!chkValue) {
userGroupAry.push({
username: record.data.username,
checkbox: record.data.checkbox
});
}
});

var user_list_string = '';
var chkCount = 0;
Ext.each(userGroupAry, function (data) {
if (data.checkbox) {
if (chkCount != 0) user_list_string += ', ';
user_list_string += data.username;
if (chkCount > 300) {
user_list_string += ', ...';
return;
}
chkCount++;
}
});
if (user_list_string == '') user_list_string = '--';
finishForm.findField('users_in_group').setValue(user_list_string);
set_user_group_create();
return true;
}
});

var finishPanel = new QNAP.QOS.wizard.formPanel({
itemId: 'finish',
headerTitle: _S.GROUP_STRING_01,
qInternational: true,
qInternationalKey: 'GROUP_STRING_01',
hideLabels: true,
defaults: {
xtype: 'displayfield',
hideLabel: true
},
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 150,
items: [{
value: _S.USER_GROUP_GREATE_WIZ_STR14,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR14'
}, {
value: _S.USER_GROUP_GREATE_WIZ_STR15,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR15'
}, {
style: 'padding-top:10px;'
}, {
xtype: 'container',
layout: 'column',
border: false,
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
value: '<b>' + _S.IEI_NAS_SHARE11 + _S.QUICK09_STR01 + '<b>',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<b>' + _S.IEI_NAS_SHARE11 + _S.QUICK09_STR01 + '<b>');
},
style: 'padding-right: 11px;'
}, {
xtype: 'displayfield',
itemId: 'new_groupname2',
name: 'new_groupname2'
}]
}, {
xtype: 'container',
layout: 'column',
border: false,
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
value: '<b>' + _S.USER_GROUP_GREATE_WIZ_STR17 + '<b>',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<b>' + _S.USER_GROUP_GREATE_WIZ_STR17 + '<b>');
},
style: 'padding-right: 11px;'
}, {
xtype: 'displayfield',
itemId: 'users_in_group',
name: 'users_in_group'
}]
}]
});

var step1Form = step1.getForm();
var step2Form = step2.getForm();
var finishForm = finishPanel.getForm();

items = {
winHeight: 540,
steps: [step1, step2, step3, finishPanel]
};
ajax_info = {
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_group_create'
}),
method: 'POST',
success: function (response, opts) {
userGroupStore.load();
var xmlData = response.responseXML;
if (xmlData != undefined) {
if (Ext.DomQuery.selectNode('QDocRoot', xmlData)) {
group_count = Ext.DomQuery.selectValue('GroupNum/count', xmlData);
max_count = Ext.DomQuery.selectValue('GroupNum/max_count', xmlData);
fn.Used_GroupArray = [];
Ext.each(Ext.DomQuery.select('groupList/group/name', xmlData), function (node) {
fn.Used_GroupArray.push(node.firstChild.data);
});
}
}
if (parseInt(group_count) >= parseInt(max_count)) step1Form.findField('GroupCountErr').show();
var delayTime = 500;
if (Ext.isDefined(runFinish)) delayTime = runFinish.delayTime;
step1Form.findField('new_groupname').focus(true, delayTime);
},
failure: function () {}
};
return {
items: items,
ajax_info: ajax_info
};
},
qAddGroupPanel: function (me, runFinish) {
var fn = this,
app = me;
if (Ext.isDefined(me.app)) app = me.app;
var group_count = 0,
max_count = 0,
userGroupAry = [];
var Default_GroupArray = new Array('guest', 'everyone', 'administrators', 'xmail', 'dovecot');

function set_user_group_create(fun) {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
QNAP.QOS.lib.MaskMgr.mask(target.getEl(), 'APPLY_MSG', _S.APPLY_MSG);
var para = {};
para.new_groupname = step1Form.findField('new_groupname').getValue();
para.a_description = step1Form.findField('a_description').getValue();
var choiceTotal = 0;
Ext.each(userGroupAry, function (data) {
if (data.checkbox) {
para['user' + choiceTotal] = data.username;
choiceTotal++;
}
});
para.users_count = choiceTotal;
para.select_user = para.users_count > 0 ? 1 : 0;
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_group_create'
}, {
action: 'add_group'
}),
method: 'POST',
params: para,
success: function (response, opts) {
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'groups');
if (Ext.isFunction(fun)) {
fun.apply();
} else {
target.groupStore.reload({
callback: function (store, record, options) {
target.getEl().unmask();
target.close();
}
});
}
},
failure: function () {
target.getEl().unmask();
}
});
}

var step1 = new QNAP.QOS.wizard.formPanel({
labelWidth: 150,
cls: 'panel-border-bottom',
style: 'padding:8px 0 15px;',
items: [{
xtype: 'textfield',
itemId: 'new_groupname',
name: 'new_groupname',
fieldLabel: _S.USER_GROUP_GREATE_WIZ_STR03,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR03',
labelSeparator: '',
maxLength: 128,
width: 220,
enableKeyEvents: true,
listeners: {
buffer: 500,
keyup: function (f, e) {
if (fn.countStrLen(f.getValue()) > f.maxLength) f.setValue(fn.getCusLenStr(f.getValue(), f.maxLength));
}
},
validator: function (v) {
if (v.length == 0) return _S.ERROR_EMPTY_GROUP_NAME;
else if (!fn.isNotValidChar(v) || v.indexOf(' ') != -1 || v.indexOf('@') != -1) return _S.USER_GROUP_GREATE_WIZ_STR18;
else if (Default_GroupArray.inArray(v.toLowerCase())) return _S.ERROR_RESERVED_GROUP;
else if (fn.Used_GroupArray.inArray(v.toLowerCase())) return _S.IEI_IDS_STRING108;
else if (v.charAt(0) == '#' || v.charAt(0) == '-') return _S.ERROR_BAD_GROUPNAME_FIRST_CHAR;
return true;
}
}, {
xtype: 'textfield',
itemId: 'a_description',
name: 'a_description',
fieldLabel: _S.MISC_SMART_STR75,
qInternational: true,
qInternationalKey: 'MISC_SMART_STR75',
maxLength: 128,
width: 220,
enableKeyEvents: true,
listeners: {
buffer: 500,
keyup: function (f, e) {
if (fn.countStrLen(f.getValue()) > f.maxLength) f.setValue(fn.getCusLenStr(f.getValue(), f.maxLength));
}
}
}, {
xtype: 'textfield',
itemId: 'group_remark',
name: 'group_remark',
fieldLabel: _S.USER_GROUP_GREATE_WIZ_STR04,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR04',
labelSeparator: '',
maxLength: 128,
width: 220,
hidden: true,
validator: function (v) {
if (!fn.isNotValidChar(v)) return _S.USER_GROUP_GREATE_WIZ_STR23;
return true;
}
}, {
xtype: 'displayfield',
itemId: 'GroupCountErr',
name: 'GroupCountErr',
value: _S.ERROR_NEW_GROUP_TITLE + ' ' + _S.QUICK09_STR01 + ' ' + _S.ERROR_GROUPNUM_EXCEED_ACCOUNT,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.ERROR_NEW_GROUP_TITLE + ' ' + _S.QUICK09_STR01 + ' ' + _S.ERROR_GROUPNUM_EXCEED_ACCOUNT);
},
style: 'color:red;',
hideLabel: true,
hidden: true
}],
tbar: [{
xtype: 'displayfield',
value: _S.WIZ_GROUP_STR_01,
qInternational: true,
qInternationalKey: {value: 'WIZ_GROUP_STR_01'},
cls: 'title-bar-style'
}],
onNext: function () {
return (step1Form.findField('new_groupname').isValid() && step1Form.findField('group_remark').isValid());
}
});

var groupCheckColumn = new Ext.grid.CheckboxSelectionModel({
dataIndex: "checkbox",
checkOnly: true,
listeners: {
rowdeselect: function (sm, rowIndex, record) {
Ext.each(userGroupAry, function (data) {
if (data.username == record.data.username) {
data.checkbox = record.data.checkbox = false;
}
});
record.afterEdit();
},
rowselect: function (sm, rowIndex, record) {
Ext.each(userGroupAry, function (data) {
if (data.username == record.data.username) {
data.checkbox = record.data.checkbox = true;
}
});
record.afterEdit();
}
}
});

var userGroupStore = new Ext.data.Store({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: "group_user_edit"
}, {
getdata: 1
}),
remoteSort: true,
method: 'POST',
baseParams: {
filter: '',
type: 0,
lower: 0,
upper: 10
},
defaultParamNames: {
limit: 'upper',
start: 'lower'
},
reader: new Ext.data.XmlReader({
root: 'data',
totalProperty: 'userroot > count',
record: 'user'
}, [{
name: 'username',
mapping: 'username'
}, {
name: 'checkbox',
mapping: 'checkbox',
type: 'bool'
}]),
listeners: {
beforeload: function (store, o) {
o.params.lower = o.params.lower || 0;
o.params.upper = o.params.lower + 10;
o.params.filter = userGroupFilter.field ? userGroupFilter.field.getValue() : ''
},
load: function (store) {
var tmpSel = [];
store.each(function (record, index) {
var chkValue = false;
Ext.each(userGroupAry, function (data) {
if (data.username == record.data.username) {
record.data.checkbox = data.checkbox == true;
chkValue = true;
store.data.items[index].afterEdit();
}
});
if (!chkValue) {
userGroupAry.push({
username: record.data.username,
checkbox: record.data.checkbox
});
}
if (record.data.checkbox == true) tmpSel.push(index);
});
if (tmpSel.length) gridUserGroup.selModel.selectRows(tmpSel);
delete store.reader.xmlData;
}
}
});

var userGroupFilter = new Ext.ux.grid.wizSearch({
mode: 'remote',
idFilter: 'userGroupFilter',
iconCls: false,
readonlyIndexes: ['username'],
minChars: 1,
autoFocus: true
});

var gridUserGroup = new Ext.grid.GridPanel({
store: userGroupStore,
enableHdMenu: false,
disableSelection: true,
trackMouseOver: false,
autoExpandColumn: "checkbox",
height: Ext.isDefined(runFinish) ? runFinish.groupGridHeight : 402,
style: 'margin-bottom:6px;',
hidden: true,
qInternational: true,
cls: 'grid-none-bottom',
colModel: new Ext.grid.ColumnModel({
qInternational: true,
columns: [groupCheckColumn,
{
header: _S.QUICK04_STR08,
qInternational: true,
qInternationalKey: 'QUICK04_STR08',
sortable: false,
dataIndex: 'username',
value2Tip: true
}]
}),
viewConfig: {
forceFit: true,
scrollOffset: 0
},
columnLines: true,
buttonAlign: 'left',
frame: true,
tbar: [{xtype: 'tbfill'}],
bbar: new Ext.wizardPagingToolbar({
pageSize: 10,
store: userGroupStore,
displayInfo: true
}),
sm: groupCheckColumn,
plugins: [userGroupFilter],
listeners: {
afteredit: function (e) {
e.record.commit();
}
}
});

var step3 = new QNAP.QOS.wizard.formPanel({
cls: 'panel-border-bottom',
style: 'padding: 6px 0 15px;',
items:  [{
xtype: 'displayfield',
name: 'lbl_List',
value: _S.WIZ_GROUP_STR_03,
qInternational: true,
qInternationalKey: {value: 'WIZ_GROUP_STR_03'},
cls: 'detial-txt-style',
hideLabel: true
}, gridUserGroup],
tbar: [{
xtype: 'displayfield',
value: _S.WIZ_GROUP_STR_02,
qInternational: true,
qInternationalKey: {value:'WIZ_GROUP_STR_02'},
cls: 'title-bar-style'
}, {
xtype: 'tbfill'
}, {
xtype: 'button',
text: _S.NIC_WEB_BTN_EDIT,
qInternational: true,
qInternationalKey: 'NIC_WEB_BTN_EDIT',
cls: 'qts-button q-default',
handler: function (cmp) {
var btnText;
var lbl_List = step3Form.findField('lbl_List');
var vis = gridUserGroup.isVisible();
lbl_List.setVisible(vis);
if (vis) {
btnText = 'NIC_WEB_BTN_EDIT';
var limitNum = 3;
var obj = fn.procAry2StrLen(userGroupAry, limitNum, 'username', 'checkbox');
var str = '';
if (obj.total == 0) {
str = _S.WIZ_GROUP_STR_03;
} else if (obj.total > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, obj.procStr, obj.total - obj.limit);
str = '<div ext:qtip="' + obj.oldStr + '">' + tmp + '</div>';
} else {
str = obj.procStr;
}
lbl_List.setValue(str);
lbl_List.objData = obj;
lbl_List.qInternationalFn = function (cmp) {
var tmpStr = '';
if (cmp.objData.total == 0) {
tmpStr = _S.WIZ_GROUP_STR_03;
} else if (cmp.objData.total > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, cmp.objData.procStr, cmp.objData.total - cmp.objData.limit);
tmpStr = '<div ext:qtip="' + cmp.objData.oldStr + '">' + tmp + '</div>';
} else {
tmpStr = cmp.objData.procStr;
}
cmp.setValue(tmpStr);
}
gridUserGroup.getEl().slideOut('t', {
easing: 'easeOut',
duration: .5,
remove: false,
useDisplay: false,
callback: function () {
gridUserGroup.setVisible(!vis);
gridUserGroup.doLayout();
}
});
} else {
btnText = 'IEI_NAS_BUTTON_CLOSE';
gridUserGroup.setVisible(!vis);
gridUserGroup.getEl().slideIn('t', {
easing: 'easeOut',
duration: .5,
callback: function () {
gridUserGroup.doLayout();
}
});
}
cmp[ !vis ? 'addClass' : 'removeClass']('btn-blue');
cmp.setText(_S[btnText]);
cmp.qInternationalKey = btnText;
}
}],
onNext: function () {
gridUserGroup.store.each(function (record) {
var chkValue = false;
Ext.each(userGroupAry, function (data) {
if (data.username == record.data.username) {
data.checkbox = record.data.checkbox;
chkValue = true;
}
});
if (!chkValue) {
userGroupAry.push({
username: record.data.username,
checkbox: record.data.checkbox
});
}
});

var user_list_string = '';
var chkCount = 0;
Ext.each(userGroupAry, function (data) {
if (data.checkbox) {
if (chkCount != 0) user_list_string += ', ';
user_list_string += data.username;
if (chkCount > 300) {
user_list_string += ', ...';
return;
}
chkCount++;
}
});
if (user_list_string == '') user_list_string = '--';
finishForm.findField('users_in_group').setValue(user_list_string);
set_user_group_create();
return true;
}
});

var editShareAry = [];
var editShareFolderStore = new Ext.data.Store({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: "user_share_edit"
}, {
getdata: 1,
groupName: ''
}),
remoteSort: true,
method: 'POST',
baseParams: {
filter: '',
type: 0,
lower: 0,
upper: 10
},
defaultParamNames: {
limit: 'upper',
start: 'lower'
},
reader: new Ext.data.XmlReader({
root: 'data',
totalProperty: 'count',
record: 'share'
}, [{
name: 'sharename',
mapping: 'sharename'
}, {
name: 'share_rd',
mapping: 'share_rd'
}, {
name: 'share_rw',
mapping: 'share_rw'
}, {
name: 'share_no',
mapping: 'share_no'
}, {
name: 'type',
mapping: 'type'
}, {
name: 'now',
mapping: 'now'
}, {
name: 'priv',
mapping: 'preview'
}]),
listeners: {
beforeload: function (store, o) {
Ext.apply(o.params, {
filter: editShareGrid.getTopToolbar().getComponent('editShareFilter') ? editShareGrid.getTopToolbar().getComponent('editShareFilter').getValue() : ''
});
store.each(function (record, index) {
Ext.each(editShareAry, function (data) {
if (data.sharename == record.data.sharename) {
data.share_rd = record.data.share_rd;
data.share_rw = record.data.share_rw;
data.share_no = record.data.share_no;
}
});
});
},
load: function (store, o) {
store.each(function (record, index) {
var chkValue = false;
record.data.priv = me.chgStatuE2N(record.data.priv || 'N');
Ext.each(editShareAry, function (data) {
if (data.sharename == record.data.sharename) {
record.data.share_rd = data.share_rd;
record.data.share_rw = data.share_rw;
record.data.share_no = data.share_no;
record.data.now = me.compareNumber(record.data.priv, me.chkShareRWI(record));
chkValue = true;
store.data.items[index].afterEdit();
}
});
if (!chkValue) {
var o = {};
o.sharename = record.data.sharename;
o.share_rd = record.data.share_rd;
o.share_rw = record.data.share_rw;
o.share_no = record.data.share_no;
switch (record.data.type) {
case 'R':
o.share_rd = record.data.share_rd = true;
break;
case 'W':
o.share_rw = record.data.share_rw = true;
break;
case 'I':
o.share_no = record.data.share_no = true;
break;
}
/* if (record.data.sharename == 'Public') {
o.share_rd = record.data.share_rd = true;
o.share_rw = record.data.share_rw = false;
o.share_no = record.data.share_no = false;
} */
editShareAry.push(o);
record.data.now = me.compareNumber(record.data.priv, me.chkShareRWI(record));
store.data.items[index].afterEdit();
}
});
delete store.reader.xmlData;
}
}
});
var edit_share_rd = new Ext.grid.CheckColumn({
header: '<div class="check_column_header" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div class="check_column_header" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>';
},
width: 30,
dataIndex: "share_rd"
});
var edit_share_rw = new Ext.grid.CheckColumn({
header: '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>';
},
width: 30,
dataIndex: "share_rw"
});
var edit_share_no = new Ext.grid.CheckColumn({
header: '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>';
},
width: 30,
dataIndex: "share_no"
});
var editShareGrid = new Ext.grid.GridPanel({
store: editShareFolderStore,
enableHdMenu: false,
disableSelection: true,
trackMouseOver: false,
height: Ext.isDefined(runFinish) ? runFinish.shareGridHeight : 402,
style: 'padding-bottom:6px;',
cls: 'grid-none-bottom',
colModel: new Ext.grid.ColumnModel({
defaults: {
qInternational: true,
sortable: false
},
qInternational: true,
columns: [{
header: _S.USER_CREATE_WIZ_STR38,
qInternationalKey: 'USER_CREATE_WIZ_STR38',
dataIndex: 'sharename',
value2Tip: true
}, {
header: _S.QTS_MSG_4,
qInternationalKey: 'QTS_MSG_4',
dataIndex: 'now',
renderer: function (data, metadata, record, rowIndex, columnIndex, store) {
data = parseInt(data);
var tip = me.chgStatuStr(data);
if (tip == 'USER_CREATE_WIZ_STR20' && !record.data.share_no) tip = 'USER_CREATE_WIZ_STR20_1';
tip = _S[tip] || tip;
metadata.attr = 'ext:qtip="' + tip + '" style="color:' + me.getPreviewColor(data) + '"';
return tip;
}
},
edit_share_rd, edit_share_rw, edit_share_no]
}),
viewConfig: {
forceFit: true,
scrollOffset: 0
},
columnLines: true,
buttonAlign: 'left',
frame: true,
tbar: [{xtype: 'tbfill'}],
bbar: new Ext.wizardPagingToolbar({
pageSize: 10,
store: editShareFolderStore,
displayInfo: true
}),
plugins: [
new Ext.ux.grid.wizSearch({
mode: 'remote',
idFilter: 'editShareFilter',
iconCls: false,
readonlyIndexes: ['sharename'],
minChars: 1,
autoFocus: true
}), edit_share_rd, edit_share_rw, edit_share_no],
listeners: {
headerclick: function (grid, columnIndex, e) {
switch (columnIndex) {
case 2:
if (!fn.h_rd) {
fn.h_rd = true;
fn.h_rw = false;
fn.h_no = false;
} else {
fn.h_rd = false;
}
Ext.each(editShareAry, function (data) {
editShareGrid.store.each(function (record) {
if (data.sharename == record.data.sharename) {
data.share_rd = record.data.share_rd = fn.h_rd;
if (fn.h_rd) data.share_rw = record.data.share_rw = false;
if (fn.h_rd) data.share_no = record.data.share_no = false;
record.data.now = me.compareNumber(record.data.priv, me.chkShareRWI(record));
record.afterEdit();
}
});
});
break;
case 3:
if (!fn.h_rw) {
fn.h_rd = false;
fn.h_rw = true;
fn.h_no = false;
} else {
fn.h_rw = false;
}
Ext.each(editShareAry, function (data) {
editShareGrid.store.each(function (record) {
if (data.sharename == record.data.sharename) {
if (fn.h_rw) data.share_rd = record.data.share_rd = false;
data.share_rw = record.data.share_rw = fn.h_rw;
if (fn.h_rw) data.share_no = record.data.share_no = false;
record.data.now = me.compareNumber(record.data.priv, me.chkShareRWI(record));
record.afterEdit();
}
});
});
break;
case 4:
if (!fn.h_no) {
fn.h_rd = false;
fn.h_rw = false;
fn.h_no = true;
} else {
fn.h_no = false;
}
Ext.each(editShareAry, function (data) {
editShareGrid.store.each(function (record) {
if (data.sharename == record.data.sharename) {
if (fn.h_no) data.share_rd = record.data.share_rd = false;
if (fn.h_no) data.share_rw = record.data.share_rw = false;
data.share_no = record.data.share_no = fn.h_no;
record.data.now = me.compareNumber(record.data.priv, me.chkShareRWI(record));
record.afterEdit();
}
});
});
break;
}
},
afteredit: function (e) {
switch (e.field) {
case 'share_rd':
e.record.data.share_rw = false;
e.record.data.share_no = false;
break;
case 'share_rw':
e.record.data.share_rd = false;
e.record.data.share_no = false;
break;
case 'share_no':
e.record.data.share_rd = false;
e.record.data.share_rw = false;
break;
}
e.record.data.now = me.compareNumber(e.record.data.priv, me.chkShareRWI(e.record));
e.grid.store.data.items[e.row].afterEdit();
Ext.each(editShareAry, function (data) {
if (data.sharename == e.record.data.sharename) {
data.share_rd = e.record.data.share_rd;
data.share_rw = e.record.data.share_rw;
data.share_no = e.record.data.share_no;
}
});
e.record.commit();
}
}
});
var rwPublicStr = 'WIZ_GROUP_STR_04';
var stepEdit = new QNAP.QOS.wizard.formPanel({
cls: 'panel-border-bottom',
style: 'padding: 6px 0 15px;',
items:  [{
xtype: 'displayfield',
name: 'lbl_List',
value: _S[rwPublicStr],
qInternational: true,
qInternationalKey: {value: rwPublicStr},
cls: 'detial-txt-style',
hideLabel: true
}, {
xtype: 'container',
itemId: 'lbl_area',
hidden: true,
items: [{
xtype: 'container',
layout: 'column',
style: 'font-size: 12px;padding:1px 0;',
items: [{
xtype: 'displayfield',
cls: 'icon-read-only'
}, {
xtype: 'displayfield',
value: _S.USER_CREATE_WIZ_STR28,
qInternational: true,
qInternationalKey: {value: 'USER_CREATE_WIZ_STR28'},
style: 'padding-right:11px;'
}, {
xtype: 'displayfield',
name: 'lbl_roList',
cls: 'detial-txt-style',
value:'--'
}]
}, {
xtype: 'container',
layout: 'column',
style: 'font-size: 12px;padding:1px 0;',
items: [{
xtype: 'displayfield',
cls: 'icon-read-write'
}, {
xtype: 'displayfield',
value: _S.USER_CREATE_WIZ_STR31,
qInternational: true,
qInternationalKey: {value: 'USER_CREATE_WIZ_STR31'},
style: 'padding-right:11px;'
}, {
xtype: 'displayfield',
name: 'lbl_rwList',
cls: 'detial-txt-style',
value:'--'
}]
}, {
xtype: 'container',
layout: 'column',
itemId: 'no',
style: 'font-size: 12px;padding:1px 0;',
items: [{
xtype: 'displayfield',
cls: 'icon-no-access'
}, {
xtype: 'displayfield',
value: _S.USER_CREATE_WIZ_STR33,
qInternational: true,
qInternationalKey: {value: 'USER_CREATE_WIZ_STR33'},
style: 'padding-right:11px;'
}, {
xtype: 'displayfield',
name: 'lbl_noList',
cls: 'detial-txt-style',
value:'--'
}]
}]
}, {
xtype: 'panel',
itemId: 'gridArea',
border: false,
items: [editShareGrid,
{
xtype: 'checkbox',
name: 'acl_recursive',
boxLabel: _S.IEI_NAS_ACL15,
qInternational: true,
qInternationalKey: 'IEI_NAS_ACL15',
hideLabel: true,
checked: true
}]
}],
tbar: [{
xtype: 'displayfield',
value: _S.WIZ_GROUP_STR_05,
qInternational: true,
qInternationalKey: {value:'WIZ_GROUP_STR_05'},
cls: 'title-bar-style'
}, {
xtype: 'tbfill'
}, {
xtype: 'button',
text: _S.NIC_WEB_BTN_EDIT,
qInternational: true,
qInternationalKey: 'NIC_WEB_BTN_EDIT',
cls: 'qts-button q-default',
handler: function (cmp) {
var btnText;
var lbl_List = stepEditForm.findField('lbl_List');
var lbl_area = stepEdit.getComponent('lbl_area');
var gridArea = stepEdit.getComponent('gridArea');
var vis = gridArea.isVisible();
lbl_List.setVisible(vis);
lbl_area.setVisible(vis);
if (vis) {
btnText = 'NIC_WEB_BTN_EDIT';
stepEdit.procList();
gridArea.getEl().slideOut('t', {
easing: 'easeOut',
duration: .5,
remove: false,
useDisplay: false,
callback: function () {
gridArea.setVisible(!vis);
gridArea.doLayout();
}
});
} else {
btnText = 'IEI_NAS_BUTTON_CLOSE';
gridArea.setVisible(!vis);
gridArea.getEl().slideIn('t', {
easing: 'easeOut',
duration: .5,
callback: function () {
gridArea.doLayout();
}
});
}
cmp[ !vis ? 'addClass' : 'removeClass']('btn-blue');
cmp.setText(_S[btnText]);
cmp.qInternationalKey = btnText;
}
}],
procList: function () {
var limitNum = 3;
var obj = fn.procAry2StrLenRWO(editShareAry, limitNum, 'sharename', {r: 'share_rd', w: 'share_rw', o: 'share_no'});
var rtmpStr = '', wtmpStr = '', otmpStr = '';
if (obj.rtotal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, obj.rprocStr, obj.rtotal - obj.limit);
rtmpStr = '<div ext:qtip="' + obj.roldStr + '">' + tmp + '</div>';
} else {
rtmpStr = obj.rprocStr || '--';
}
stepEditForm.findField('lbl_roList').setValue(rtmpStr);
stepEditForm.findField('lbl_roList').objData = obj;
stepEditForm.findField('lbl_roList').qInternational = true;
stepEditForm.findField('lbl_roList').qInternationalFn = function (cmp) {
var value = '';
if (cmp.objData.rtotal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, cmp.objData.rprocStr, cmp.objData.rtotal - cmp.objData.limit);
value = '<div ext:qtip="' + cmp.objData.roldStr + '">' + tmp + '</div>';
} else {
value = cmp.objData.rprocStr || '--';
}
cmp.setValue(value);
};
if (obj.wtotal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, obj.wprocStr, obj.wtotal - obj.limit);
wtmpStr = '<div ext:qtip="' + obj.woldStr + '">' + tmp + '</div>';
} else {
wtmpStr = obj.wprocStr || '--';
}
stepEditForm.findField('lbl_rwList').setValue(wtmpStr);
stepEditForm.findField('lbl_rwList').objData = obj;
stepEditForm.findField('lbl_rwList').qInternational = true;
stepEditForm.findField('lbl_rwList').qInternationalFn = function (cmp) {
var value = '';
if (cmp.objData.wtotal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, cmp.objData.wprocStr, cmp.objData.wtotal - cmp.objData.limit);
value = '<div ext:qtip="' + cmp.objData.woldStr + '">' + tmp + '</div>';
} else {
value = cmp.objData.wprocStr || '--';
}
cmp.setValue(value);
};
if (obj.ototal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, obj.oprocStr, obj.ototal - obj.limit);
otmpStr = '<div ext:qtip="' + obj.ooldStr + '">' + tmp + '</div>';
} else {
otmpStr = obj.oprocStr || '--';
}
stepEditForm.findField('lbl_noList').setValue(otmpStr);
stepEditForm.findField('lbl_noList').objData = obj;
stepEditForm.findField('lbl_noList').qInternational = true;
stepEditForm.findField('lbl_noList').qInternationalFn = function (cmp) {
var value = '';
if (cmp.objData.ototal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, cmp.objData.oprocStr, cmp.objData.ototal - cmp.objData.limit);
value = '<div ext:qtip="' + cmp.objData.ooldStr + '">' + tmp + '</div>';
} else {
value = cmp.objData.oprocStr || '--';
}
cmp.setValue(value);
};
stepEdit.getComponent('lbl_area').getComponent('no').setVisible(otmpStr !== '--');
if (obj.rtotal == 0 && obj.wtotal == 0 && obj.ototal == 0) {
stepEdit.getComponent('lbl_area').hide();
} else {
stepEditForm.findField('lbl_List').hide();
}
}
});

/* function setEditShareGrid() {
editShareGrid.setHeight(winUserPrivate.getHeight() - acl_recursive.getHeight() - winUserPrivate.getComponent('form').getComponent('container').getHeight() - 90);
}
winUserPrivate.show('', function () {
setEditShareGrid();
});
winUserPrivate.getEl().mask(_S.LOADING); */
fn.h_rd = fn.h_rw = fn.h_no = false;
/* setTimeout(function () {
editShareGrid.getTopToolbar().getComponent('space').setWidth(editShareGrid.getWidth() - 135);
}, 10); */

/* var finishPanel = new QNAP.QOS.wizard.formPanel({
itemId: 'finish',
headerTitle: _S.GROUP_STRING_01,
qInternational: true,
qInternationalKey: 'GROUP_STRING_01',
hideLabels: true,
defaults: {
xtype: 'displayfield',
hideLabel: true
},
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 150,
items: [{
value: _S.USER_GROUP_GREATE_WIZ_STR14,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR14'
}, {
value: _S.USER_GROUP_GREATE_WIZ_STR15,
qInternational: true,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR15'
}, {
style: 'padding-top:10px;'
}, {
xtype: 'container',
layout: 'column',
border: false,
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
value: '<b>' + _S.IEI_NAS_SHARE11 + _S.QUICK09_STR01 + '<b>',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<b>' + _S.IEI_NAS_SHARE11 + _S.QUICK09_STR01 + '<b>');
},
style: 'padding-right: 11px;'
}, {
xtype: 'displayfield',
itemId: 'new_groupname2',
name: 'new_groupname2'
}]
}, {
xtype: 'container',
layout: 'column',
border: false,
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
value: '<b>' + _S.USER_GROUP_GREATE_WIZ_STR17 + '<b>',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<b>' + _S.USER_GROUP_GREATE_WIZ_STR17 + '<b>');
},
style: 'padding-right: 11px;'
}, {
xtype: 'displayfield',
itemId: 'users_in_group',
name: 'users_in_group'
}]
}]
}); */

var step1Form = step1.getForm();
/* var step2Form = step2.getForm(); */
var step3Form = step3.getForm();
var stepEditForm = stepEdit.getForm();
/* var finishForm = finishPanel.getForm(); */

/* items = {
winHeight: 540,
steps: [step1, step2, step3, finishPanel]
}; */
items = {
title: _S.IEI_NAS_SECURITY15,
qInternational: true,
qInternationalKey: 'IEI_NAS_SECURITY15',
layout: 'border',
cls: 'wiz-non-tbar-style utility-window win-form',
items: [{
xtype: 'panel',
region: 'center',
border: false,
bodyStyle: 'overflow-y:scroll;',
items: [{
xtype: 'container',
border: false,
style: 'padding:30px 60px;',
items: [step1, step3, stepEdit]
}]
}],
fbar: [{
xtype: 'button',
itemId: 'createBtn',
text: _S.IEI_NAS_BUTTON_CREATE,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_CREATE',
handler: function (cmp) {
if (!step1.onNext()) return;
set_user_group_create(function () {
var para = {};
var empty_share_len = 0,
rd_share_len = 0,
rw_share_len = 0,
no_share_len = 0;
para.groupname = step1Form.findField('new_groupname').getValue();
Ext.each(editShareAry, function (data) {
if (data.share_rd) {
para['rd_share' + rd_share_len] = data.sharename;
rd_share_len++;
} else if (data.share_rw) {
para['rw_share' + rw_share_len] = data.sharename;
rw_share_len++;
} else if (data.share_no) {
para['no_share' + no_share_len] = data.sharename;
no_share_len++;
} else {
para['empty_share' + empty_share_len] = data.sharename;
empty_share_len++;
}
});
para.rd_share_len = rd_share_len;
para.rw_share_len = rw_share_len;
para.no_share_len = no_share_len;
para.empty_share_len = empty_share_len;
if (stepEditForm.findField('acl_recursive').getValue()) para.recursive = 1;
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
if (rd_share_len == 0 && rw_share_len == 0 && no_share_len == 0) {
target.getEl().unmask();
target.close();
return false;
}
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: 'group_share_edit'
}, {
action: 'group_share_edit'
}),
method: 'POST',
params: para,
success: function (response, opts) {},
failure: function () {},
callback: function () {
if (!Ext.isEmpty(target.groupStore)) {
target.groupStore.reload({
callback: function (store, record, options) {
target.getEl().unmask();
target.close();
}
});
} else {
target.getEl().unmask();
target.close();
}
}
});
});
}
}, {
xtype: 'button',
text: _S.IEI_NAS_BUTTON_CANCEL,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_CANCEL',
handler: function (cmp) {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
target.close();
}
}],
listeners: {
afterrender: function () {
stepEdit.getComponent('gridArea').hide();
}
}
};
fn.ACLEnabled = false;
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'ajaxRequest.cgi'),
method: 'POST',
success: function (response, opts) {
var xmlData = response.responseXML;
if (xmlData !== undefined) {
fn.ACLEnabled = Ext.DomQuery.selectValue('ACLEnabled', xmlData) == '1';
stepEditForm.findField('acl_recursive').setVisible(me.ACLEnabled);
}
},
failure: function () {}
});
ajax_info = {
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'user_group_create'
}),
method: 'POST',
success: function (response, opts) {
userGroupStore.load();
editShareFolderStore.reload();
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
var xmlData = response.responseXML;
if (xmlData != undefined) {
if (Ext.DomQuery.selectNode('QDocRoot', xmlData)) {
group_count = Ext.DomQuery.selectValue('GroupNum/count', xmlData);
max_count = Ext.DomQuery.selectValue('GroupNum/max_count', xmlData);
fn.Used_GroupArray = [];
Ext.each(Ext.DomQuery.select('groupList/group/name', xmlData), function (node) {
fn.Used_GroupArray.push(node.firstChild.data);
});
}
}

var chkCreatBtn = false, countAjax = 0;
if (parseInt(group_count) >= parseInt(max_count)) {
/* step1Form.findField('GroupCountErr').show(); */
fn.winAlert(app, target, ['ERROR_NEW_GROUP_TITLE', 'QUICK09_STR01', 'ERROR_GROUPNUM_EXCEED_ACCOUNT'], 'info', '', target != '' ? target : null);
} else {
chkCreatBtn = true;
}

var delayTime = 500;
if (Ext.isDefined(runFinish)) delayTime = runFinish.delayTime;
step1Form.findField('new_groupname').focus(true, delayTime);
if (countAjax == 1 && chkCreatBtn) target.getFooterToolbar().getComponent('createBtn').enable();
},
failure: function () {}
};
return {
items: items,
ajax_info: ajax_info
};
},
qAddSharedFolder: function (me, runFinish) {
var fn = this,
app = me;
if (Ext.isDefined(me.app)) app = me.app;
var max_count = 0,
share_count = 0,
is_imageShare = 0,
bManualPath = false,
accessUserArray = [],
accessGroupArray = [],
Used_ShareArray = [],
projectlName = '',
errStr = null,
recycleBinEnable = 1;
accessUserArray.push({
username: QNAP.QOS.user.account,
access_rd: false,
access_rw: true,
access_no: false
});
var black_share_list = ['global', 'printers', 'tmbackup', 'qsync'];
var globalShareArray = [];
var share_create_step1 = new QNAP.QOS.wizard.formPanel({
itemId: 'share_create_step1',
nextId: 'share_create_step2',
headerTitle: _S.HOME_STR04,
qInternational: true,
qInternationalKey: 'HOME_STR04',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
hideLabels: true,
items: [{
xtype: 'displayfield',
value: _S.USER_CREATE_WIZ_STR1,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR1',
hideLabel: true
}, {
xtype: 'displayfield',
value: '● ' + _S.SHARE_CREATE_WIZ_STR2,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('● ' + _S.SHARE_CREATE_WIZ_STR2);
},
style: 'padding-top:10px;'
}, {
xtype: 'displayfield',
value: '● ' + _S.USER_CREATE_WIZ_STR6,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('● ' + _S.USER_CREATE_WIZ_STR6);
}
}, {
xtype: 'displayfield',
value: _S.FTP_SERVICE_WIZ_STR05,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR05',
hideLabel: true,
style: 'padding:10px 0 15px;'
}, {
xtype: 'displayfield',
itemId: 'ShareCountErrAdd',
value: _S.ERROR_USER_SHARE_TITLE + _S.QUICK09_STR01 + _S.ERROR_SHARENUM_EXCEED_ACCOUNT,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.ERROR_USER_SHARE_TITLE + _S.QUICK09_STR01 + _S.ERROR_SHARENUM_EXCEED_ACCOUNT);
},
style: 'color:red;',
hidden: true
}],
onNext: function () {
if (parseInt(share_count) >= parseInt(max_count)) return false;
step2Form.findField('share_name_shareFolder').focus(true, 100);
return true;
}
});

var isGlobalShareDup = function (v) {
return globalShareArray.inArray(v.toLowerCase());
}

var checkShareName = function (e) {
var v = step2Form.findField('share_name_shareFolder').getValue();
while (v.length > 0 && v.charAt(0) == ' ') {
v = v.substr(1);
}
if (v == "") return _S.FTP_STR41;
if (!fn.isNotValidChar(v)) return _S.IEI_IDS_STRING190;
if (v.indexOf("_sn_") == 0 || v.indexOf("_sn_bk") == 0) return _S.IEI_IDS_STRING190;
if (fn.isReservedShareName(v)) return _S.IEI_NAS_SHARE16;
if (black_share_list.inArray(v.toLowerCase())) return _S.IEI_NAS_ERR_MSG13;
var vol_no = step2Form.findField('disks_list_shareFolder').findRecord(step2Form.findField('disks_list_shareFolder').valueField, step2Form.findField('disks_list_shareFolder').getValue()).data.listValue;
if (QNAP.GQ.isGQVol(vol_no) && QNAP.GQ.isDefShareName(v)) return _S.GQ_SHAREFOLDER_CREATE_WIZ_MSG3;
if (QNAP.GQ.isGQVol(vol_no) && isGlobalShareDup(v)) return _S.GQ_SHAREFOLDER_CREATE_WIZ_MSG1;
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'share_create'
}, {
action: 'check_share',
sname: encodeURIComponent(v)
}),
method: 'POST',
success: function (response, opts) {
var xmlData = response.responseXML;
var ret = parseInt(Ext.DomQuery.selectValue('return', xmlData));
if (ret == -1) errStr = _S.IEI_NAS_ERR_MSG06;
else if (ret == -2) errStr = _S.IEI_NAS_ERR_MSG13;
else errStr = true;
if (errStr == true) {
step2Form.findField('share_name_shareFolder').clearInvalid();
} else {
step2Form.findField('share_name_shareFolder').markInvalid(errStr);
}
},
failure: function () {}
});
return errStr;
};

var manualLoader = new Ext.tree.TreeLoader({
dataUrl: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'get_dirs'
}),
baseParams: {
dir: '/share',
vol_no: 1
},
listeners: {
load: function (loader, parentNode, res) {
var nodes = [];
var ary = res.responseText.split(new RegExp(/<ul.+?>\s*<li .+?>\s*<a .+?>|<\/a><\/li><\/ul>/));
var pathAry = res.responseText.split(new RegExp(/<ul.+?>\s*<li .+?>\s*<a href="#" rel=\"|\">.+?<\/a><\/li><\/ul>/));
Ext.each(ary, function (data, i) {
if (!Ext.isEmpty(data)) {
var obj = {};
obj.text = data;
obj.dir = pathAry[i];
obj.fullPath = pathAry[i];
var tmpAry = pathAry[i].split('/');
obj.dir = pathAry[i].replace(tmpAry.splice(0, 3).join('/'), '');
nodes.push(obj);
}
});
parentNode.appendChild(nodes);
},
beforeload: function (loader, node, callback) {
var bp = loader.baseParams;
bp.dir = QNAP.QOS.quickWizard.getNodeFullPath(node) == '/' ? '/share' : node.attributes.fullPath;
bp.vol_no = step2Form.findField('disks_list_shareFolder').getValue();
}
}
});
var manualPathTree = new Ext.tree.TreePanel({
loader: manualLoader,
border: false,
rootVisible: false,
root: new Ext.tree.AsyncTreeNode({
text: '/',
id: 0,
dir: '/share'
}),
listeners: {
click: function (node, e) {
/* var value = node.attributes.dir;
manualPathTreeCombo.setValue(value);
var chkPathAry = value.split('/');
var chkDis = chkManualPath(false, chkPathAry);
step2Form.findField('recycle_bin_group').setDisabled(chkDis);
manualPathTreeCombo.collapse(); */
var value = node.attributes.dir;
manualPathTreeCombo.setValue(value);
var chkPathAry = value.split('/');
var chkDis = chkManualPath(false, chkPathAry);
var recycleGroup = step2Form.findField('recycle_bin_group');
var recycleAdmin = step2Form.findField('recycle_bin_admin');
recycleGroup.setDisabled(chkDis);
if (chkDis) recycleAdmin.setDisabled(chkDis);
else recycleAdmin.setDisabled(recycleGroup.getValue().inputValue !== 1);
manualPathTreeCombo.collapse();
},
load: function () {
manualPathTree.setHeight(manualPathTreeCombo.list.getHeight() - 2);
}
}
});
var comboIdsf = Ext.id();
var manualPathTreeCombo = new Ext.form.ComboBox({
store: new Ext.data.SimpleStore({
fields: [],
data: [
[]
]
}),
itemId: 'path',
mode: 'local',
width: 220,
hidden: true,
triggerAction: 'all',
tpl: "<tpl for='.'><div style='height:200px'><div id='" + comboIdsf + "'></div></div></tpl>",
selectedClass: '',
onSelect: Ext.emptyFn,
allowBlank: false,
disabled: true,
validator: function (v) {
if (v == "") return _S.FTP_STR41;
if (!fn.isNotValidChar_4(v)) return _S.IEI_NAS_ALERT30;
if (v == '//' || /\/\//.test(v)) return _S.IEI_NAS_ALERT33;
if (v == "." || v == "..") return _S.IEI_NAS_ALERT32;
if (v == "/." || v == "/..") return _S.IEI_NAS_ALERT32_1;
},
fileTree: manualPathTree,
enableKeyEvents: true,
listeners: {
expand: function () {
manualPathTree.render(comboIdsf);
},
afterrender: function (e) {
this.mon(this.el, 'click', this.onTriggerClick, this);
/* },
change: function (cmp, value, ovalue) {
var chkPathAry = value.split('/');
var chkDis = chkManualPath(false, chkPathAry);
step2Form.findField('recycle_bin_group').setDisabled(chkDis);
},
keypress: function (cmp, e) {
var value = cmp.getValue();
var chkPathAry = value.split('/');
var chkDis = chkManualPath(false, chkPathAry);
step2Form.findField('recycle_bin_group').setDisabled(chkDis); */
}
},
onViewClick: function (doFocus) {
var index = this.view.getSelectedIndexes()[0],
s = this.store,
r = s.getAt(index);
if (r) this.onSelect(r, index);
if (doFocus != false) this.el.focus();
},
initQuery: function () {
this.doQuery(this.getRawValue(), true);
}
});
var chkManualPath = function (dis, ary) {
var chk = false;
if (ary.length > 3) chk = true
else if (ary.length == 3 && ary[2] != '') chk = true
return !dis && chk;
};
var share_create_step2 = new QNAP.QOS.wizard.formPanel({
itemId: 'share_create_step2',
nextId: 'share_create_step3',
headerTitle: _S.SHARE_CREATE_WIZ_STR2,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR2',
labelWidth: 200,
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
items: [{
xtype: 'textfield',
itemId: 'share_name_shareFolder',
name: 'share_name_shareFolder',
id: 'share_create_step2_share_name_shareFolder',
maxLength: 64,
fieldLabel: _S.SHARE_CREATE_WIZ_STR14,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR14',
labelSeparator: '',
width: 220,
enableKeyEvents: true,
validator: checkShareName,
listeners: {
buffer: 500,
keyup: function (f, e) {
if (fn.countStrLen(f.getValue()) > f.maxLength) f.setValue(fn.getCusLenStr(f.getValue(), f.maxLength));
}
}
}, {
xtype: 'combo',
itemId: 'disks_list_shareFolder',
name: 'vol_num',
width: 220,
fieldLabel: _S.SHARE_CREATE_WIZ_STR23,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR23',
qInternationalFn: function (cmp) {
var v = cmp.getValue();
if( QNAP.QOS.config.bIsStorageV2 ){
cmp.getStore().each(function (r) {
if(r.data.listValue == QNAP.GQ.GlusterVolID){
var a = '';
if (r.data.qInternationalKey != '') a = _S[r.data.qInternationalKey] || r.data.qInternationalKey;
if (r.data.qInternationalKey == 'Unknown') a = '';
r.data.listName = a + r.data.diskNumber;
r.afterEdit();
}
});
}
else{
cmp.getStore().each(function (r) {
var a = '';
if (r.data.qInternationalKey != '') a = _S[r.data.qInternationalKey] || r.data.qInternationalKey;
if (r.data.qInternationalKey == 'Unknown') a = '';
r.data.listName = a + r.data.diskNumber;
r.afterEdit();
});
}
cmp.setValue(v);
},
labelSeparator: '',
store: new Ext.data.ArrayStore({
fields: ['listName', 'listValue', 'qInternationalKey', 'diskNumber', 'fstype']
}),
displayField: 'listName',
valueField: 'listValue',
mode: 'local',
editable: false,
allowBlank: false,
triggerAction: 'all',
listeners: {
select: function () {
/*
* GQ feature: when create share if gq volume is selected, check share name by gq; when create GQ share disbale the path edit
*/
var vol_no = step2Form.findField('disks_list_shareFolder').findRecord(step2Form.findField('disks_list_shareFolder').valueField, step2Form.findField('disks_list_shareFolder').getValue()).data.listValue;
var path_type_group = step2Form.findField('path_type_group');

Ext.getCmp("share_create_step2_share_name_shareFolder").validate();
if (QNAP.GQ.isGQVol(vol_no)) {
path_type_group.disable();
manualPathTreeCombo.disable();
}
else {
path_type_group.enable();
manualPathTreeCombo.setDisabled(path_type_group.getValue().inputValue == 'auto');
}
manualPathTreeCombo.fileTree.setRootNode(new Ext.tree.AsyncTreeNode({
text: '/',
id: 0,
dir: '/share'
}));
manualPathTreeCombo.setValue('');
}
}
}, {
xtype: 'textfield',
itemId: 'comment_shareFolder',
fieldLabel: _S.MISC_SMART_STR75,
qInternational: true,
qInternationalKey: 'MISC_SMART_STR75',
width: 220,
maxLength: 128
}, {
xtype: 'label',
text: _S.MISC_SCH_NEW_STR82,
qInternational: true,
qInternationalKey: 'MISC_SCH_NEW_STR82',
cls: 'link_line',
style: 'cursor:pointer;',
listeners: {
render: function (o, e) {
o.getEl().on({
click: function () {
setForm2Adv();
},
scope: o
})
}
}
}, {
xtype: 'radiogroup',
itemId: 'hidden_group',
fieldLabel: _S.USER_CREATE_WIZ_STR16,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR16',
labelSeparator: '',
columns: 3,
hidden: true,
style: 'padding-top:6px;',
labelStyle: 'padding-top:11px;',
items: [{
boxLabel: _S.IEI_NAS_BUTTON_YES,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_YES',
hideLabel: true,
name: 'hidden',
inputValue: '1'
}, {
boxLabel: _S.IEI_NAS_BUTTON_NO + '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;" ext:qtip="' + _S.USER_CREATE_WIZ_STR48 + '"/>',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.wrap.child('.x-form-cb-label').update(_S.IEI_NAS_BUTTON_NO + '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;" ext:qtip="' + _S.USER_CREATE_WIZ_STR48 + '"/>');
},
hideLabel: true,
name: 'hidden',
inputValue: '0',
checked: true
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
if (!Ext.isEmpty(dCmp.qInternationalKey)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
} else if (Ext.isFunction(dCmp.qInternationalFn)) {
dCmp.qInternationalFn(dCmp);
}
}
});
}
}
}, {
xtype: 'radiogroup',
itemId: 'quotaRadio_group',
fieldLabel: _S.USER_CREATE_WIZ_STR26,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR26',
labelSeparator: '',
columns: 3,
hidden: true,
items: [{
boxLabel: _S.IEI_NAS_BUTTON_YES,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_YES',
name: 'quotaRadio',
inputValue: 1,
listeners: {
check: function (f, nv, ov) {
if (f.getValue()) {
is_imageShare = 1;
step2Form.findField('imageFileList').show();
manualPathTreeCombo.hide();
var path_type_auto = step2Form.findField('path_type_group').getValue().inputValue == 'auto';
step2Form.findField('imageFileList').setDisabled(path_type_auto);
step2Form.findField('quotaSettings').setDisabled(!path_type_auto);
step2Form.findField('quotaSettings').validate();
}
}
}
}, {
boxLabel: _S.IEI_NAS_BUTTON_NO,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_NO',
name: 'quotaRadio',
inputValue: 0,
checked: true,
listeners: {
check: function (f, nv, ov) {
if (f.getValue()) {
is_imageShare = 0;
manualPathTreeCombo.show();
step2Form.findField('imageFileList').hide();
step2Form.findField('quotaSettings').disable();
}
}
}
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}, {
layout: 'column',
itemId: 'quotaRadioDiv2u',
border: false,
hidden: true,
items: [{
xtype: 'displayfield',
value: '&nbsp;',
width: 205,
style: 'padding:3px 0 6px 0;'
}, {
xtype: 'numberfield',
itemId: 'quotaSettings',
name: 'quotaSettings',
maxLength: 5,
width: 45,
disabled: true,
allowDecimals: false,
validator: function (v) {
var maxsize = 2000;
var fstype = step2Form.findField('disks_list_shareFolder').findRecord(step2Form.findField('disks_list_shareFolder').valueField, step2Form.findField('disks_list_shareFolder').getValue()).data.fstype;
if (fstype == '104') maxsize = 16000;
if (v == '') return _S.FTP_STR41;
if (parseInt(v) < 1 || parseInt(v) > maxsize) return _S.USER_SHARE_ALERT03;
step45Form.findField('step6_quota_size_asf').show();
step45Form.findField('step6_quota_size_asf').setValue(v + ' GB');
return true;
}
}, {
xtype: 'displayfield',
value: '&nbsp;GB' + '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;" ext:qtip="' + _S.USER_SHARE_STR30 + '"/>',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('&nbsp;GB' + '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;" ext:qtip="' + _S.USER_SHARE_STR30 + '"/>');
},
style: 'padding:3px 6px 0 0;'
}]
}, {
xtype: 'radiogroup',
itemId: 'oplocks_group',
fieldLabel: _S.IEI_NAS_SHARE79,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE79',
columns: 3,
hidden: true,
items: [{
boxLabel: _S.IEI_NAS_BUTTON_YES,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_YES',
hideLabel: true,
name: 'oplocks',
inputValue: 1,
checked: true
}, {
boxLabel: _S.IEI_NAS_BUTTON_NO,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_NO',
hideLabel: true,
name: 'oplocks',
inputValue: 0
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}, {
xtype: 'radiogroup',
itemId: 'recycle_bin_group',
fieldLabel: _S.RECYCLE_BIN_STRING,
qInternational: true,
qInternationalKey: 'RECYCLE_BIN_STRING',
columns: 3,
hidden: true,
items: [{
boxLabel: _S.QNAP_PS_ADMIN_ENABLE,
qInternational: true,
qInternationalKey: 'QNAP_PS_ADMIN_ENABLE',
hideLabel: true,
name: 'recycle_bin',
inputValue: 1
}, {
boxLabel: _S.QNAP_PS_ADMIN_DISABLE,
qInternational: true,
qInternationalKey: 'QNAP_PS_ADMIN_DISABLE',
hideLabel: true,
name: 'recycle_bin',
inputValue: 0,
checked: true
}],
listeners: {
change: function (cmp, checked) {
step2Form.findField('recycle_bin_admin').setDisabled(checked.inputValue !== 1);
}
}
}, {
xtype: 'checkbox',
itemId: 'recycle_bin_admin',
boxLabel: _S.RECYCLE_BIN_STRING_01,
qInternational: true,
qInternationalKey: 'RECYCLE_BIN_STRING_01',
hideLabel: true,
disabled: true,
hidden: true
}, {
xtype: 'radiogroup',
itemId: 'path_type_group',
fieldLabel: _S.USER_CREATE_WIZ_STR17,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR17',
labelSeparator: '',
columns: 1,
hidden: true,
items: [{
boxLabel: _S.IEI_NAS_SHARE41,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE41',
name: 'path_type',
inputValue: 'auto',
checked: true,
listeners: {
check: function (f, nv, ov) {
if (f.getValue()) {
manualPathTreeCombo.disable();
manualPathTreeCombo.validate();
var recycleGroup = step2Form.findField('recycle_bin_group')
recycleGroup.enable();
step2Form.findField('recycle_bin_admin').setDisabled(recycleGroup.getValue().inputValue !== 1);
bManualPath = false;
if (is_imageShare) {
step2Form.findField('imageFileList').disable();
step2Form.findField('quotaSettings').enable();
step2Form.findField('quotaSettings').show();
step2Form.findField('quotaSettings').validate();
}
}
}
}
}, {
boxLabel: _S.IEI_NAS_SHARE42,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE42',
name: 'path_type',
inputValue: 'manual',
listeners: {
check: function (f, nv, ov) {
if (f.getValue()) {
manualPathTreeCombo.enable();
var chkPathAry = manualPathTreeCombo.getValue().split('/');
var chkDis = chkManualPath(true, chkPathAry);
var recycleGroup = step2Form.findField('recycle_bin_group')
var recycleAdmin = step2Form.findField('recycle_bin_admin');
recycleGroup.setDisabled(chkDis);
if (chkDis) recycleAdmin.setDisabled(chkDis);
else recycleAdmin.setDisabled(recycleGroup.getValue().inputValue !== 1);
bManualPath = true;
if (is_imageShare) {
step2Form.findField('imageFileList').enable();
step2Form.findField('quotaSettings').disable();
step2Form.findField('quotaSettings').hide();
step2Form.findField('quotaSettings').validate();
step2Form.findField('imageFileList').validate();
} else {
manualPathTreeCombo.validate();
}
}
}
}
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
},
manualPathTreeCombo,
{
xtype: 'textfield',
name: 'imageFileList',
width: 220,
enableKeyEvents: true,
maxLength: 256,
disabled: true,
hidden: true,
validator: function (v) {
if (v == "") return _S.FTP_STR41;
if (!fn.isNotValidChar_4(v)) return _S.IEI_NAS_ALERT30;
if (v == '//' || /\/\//.test(v)) return _S.IEI_NAS_ALERT33;
if (v == "." || v == "..") return _S.IEI_NAS_ALERT32;
if (v == "/." || v == "/..") return _S.IEI_NAS_ALERT32_1;
return true;
}
}, {
xtype: 'displayfield',
style: 'height:30px;',
hidden: !Ext.isGecko
}],
onNext: function () {
if (!step2Form.findField('share_name_shareFolder').isValid()) return false;
if (!step2Form.findField('quotaSettings').isValid()) return false;
if (is_imageShare) {
if (bManualPath && !step2Form.findField('imageFileList').isValue()) return false;
} else {
if (bManualPath && !manualPathTreeCombo.isValid()) return false;
}
return true;
}
});

var share_create_step3 = new QNAP.QOS.wizard.formPanel({
itemId: 'share_create_step3',
nextId: 'share_create_step4_op1',
headerTitle: _S.USER_CREATE_WIZ_STR6,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR6',
hideLabels: true,
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
items: [{
xtype: 'displayfield',
value: _S.USER_CREATE_WIZ_STR9,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR9',
hideLabel: true
}, {
xtype: 'radiogroup',
itemId: 'access_r_group',
hideLabel: true,
columns: 1,
items: [{
boxLabel: _S.IEI_NAS_SHARE14 + _S.SHARE_CREATE_WIZ_STR10,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.wrap.child('.x-form-cb-label').update(_S.IEI_NAS_SHARE14 + _S.SHARE_CREATE_WIZ_STR10);
},
name: 'access_r',
inputValue: 'nolimit'
}, {
boxLabel: _S.SHARE_CREATE_WIZ_STR11,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR11',
hideLabel: true,
name: 'access_r',
inputValue: 'setup_users',
checked: true
}, {
boxLabel: _S.SHARE_CREATE_WIZ_STR12,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR12',
hideLabel: true,
name: 'access_r',
inputValue: 'setup_groups'
}, {
boxLabel: _S.SHARE_CREATE_WIZ_STR13,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR13',
hideLabel: true,
name: 'access_r',
inputValue: 'admin_only'
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
if (!Ext.isEmpty(dCmp.qInternationalKey)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
} else if (Ext.isFunction(dCmp.qInternationalFn)) {
dCmp.qInternationalFn(dCmp);
}
}
});
}
}
}, {
xtype: 'displayfield',
value: _S.IEI_NAS_SHARE36,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE36',
hideLabel: true,
style: 'padding-top:5px;'
}, {
xtype: 'radiogroup',
itemId: 'guest_group',
hideLabel: true,
columns: 3,
items: [{
boxLabel: _S.USER_CREATE_WIZ_STR20,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR20',
hideLabel: true,
name: 'guest',
inputValue: 'deny',
checked: true
}, {
boxLabel: _S.IEI_NAS_SHARE13,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE13',
hideLabel: true,
name: 'guest',
inputValue: 'rd_only'
}, {
boxLabel: _S.USER_SHARE_STR05,
qInternational: true,
qInternationalKey: 'USER_SHARE_STR05',
hideLabel: true,
name: 'guest',
inputValue: 'full'
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}],
getNextId: function () {
var subpath;
var sname = step2Form.findField('share_name_shareFolder').getValue();
while (sname.length > 0 && sname.charAt(0) == ' ') {
sname = sname.substr(1);
}
while (sname.length > 0 && sname.charAt(sname.length - 1) == ' ') {
sname = sname.substring(0, sname.length - 1);
}
step2Form.findField('share_name_shareFolder').setValue(sname);
step45Form.findField('sname_asf').setValue(sname);
if (step2Form.findField('path_type_group').getValue().inputValue == 'auto') {
subpath = '/' + sname;
} else {
subpath = (is_imageShare) ? step2Form.findField('imageFileList').getValue() : manualPathTreeCombo.getValue();
if (subpath.charAt(0) != '/') subpath = '/' + subpath;
}

var whole_path_asf = step45Form.findField('whole_path_asf');
whole_path_asf.setValue(is_imageShare ? subpath : step2Form.findField('disks_list_shareFolder').getRawValue() + subpath);
whole_path_asf.qInternational = true;
whole_path_asf.is_imageShare = is_imageShare;
whole_path_asf.subpath = subpath;
whole_path_asf.qInternationalFn = function (cmp) {
var str = '',
cmpStr = '';
step2Form.findField('disks_list_shareFolder').getStore().each(function (r) {
if (step2Form.findField('disks_list_shareFolder').getValue() == r.data.listValue) {
qInternationalKey = r.data.qInternationalKey;
var tmp = _S[qInternationalKey] || qInternationalKey;
cmpStr = tmp + ' ' + r.data.diskNumber;
}
});
if (this.is_imageShare) str = this.subpath;
else str = cmpStr + this.subpath;
cmp.setValue(str);
};
var ishiddenValue = step2Form.findField('hidden_group').getValue().inputValue == '1' ? 'IEI_NAS_BUTTON_YES' : 'IEI_NAS_BUTTON_NO';
var ishidden_asf = step45Form.findField('ishidden_asf');
ishidden_asf.setValue(_S[ishiddenValue]);
ishidden_asf.qInternational = true;
ishidden_asf.qInternationalFn = function (cmp) {
cmp.setValue(_S[ishiddenValue]);
};

var isoplocksValue = step2Form.findField('oplocks_group').getValue().inputValue == '1' ? 'IEI_NAS_BUTTON_YES' : 'IEI_NAS_BUTTON_NO';
var isoplocks_asf = step45Form.findField('isoplocks_asf');
isoplocks_asf.setValue(_S[isoplocksValue]);
isoplocks_asf.qInternational = true;
isoplocks_asf.qInternationalFn = function (cmp) {
cmp.setValue(_S[isoplocksValue]);
};

var isrecycle_bin_asf = step45Form.findField('isrecycle_bin_asf');
if (recycleBinEnable == 1) {
var recycle_bin_status = 1, recycle_bin = 0;
if (step2Form.findField('path_type_group').getValue().inputValue != 'auto') {
var chkPathAry = manualPathTreeCombo.getValue().split('/');
var chkDis = chkManualPath(false, chkPathAry);
if (chkDis) recycle_bin_status = 0;
}
recycle_bin = recycle_bin_status == 1 ? step2Form.findField('recycle_bin_group').getValue().inputValue : 0;
var isrecycleBinValue = recycle_bin == 1 ? 'QNAP_PS_ADMIN_ENABLE' : 'QNAP_PS_ADMIN_DISABLE';
isrecycle_bin_asf.setValue(_S[isrecycleBinValue]);
isrecycle_bin_asf.qInternational = true;
isrecycle_bin_asf.qInternationalFn = function (cmp) {
cmp.setValue(_S[isrecycleBinValue]);
};
} else {
isrecycle_bin_asf.hide();
}

var comment = step2Form.findField('comment_shareFolder').getValue();
if (comment.length > 23) {
comment = '<div ext:qtip="' + comment + '">' + comment.substring(0, 22) + '...</div>';
} else if (comment == '') comment = '---';
step45Form.findField('cmt_asf').setValue(comment);

var access_type_str = null;
var access_r_group = step3Form.findField('access_r_group').getValue().inputValue;
switch (access_r_group) {
case 'nolimit':
access_type_str = ['IEI_NAS_SHARE14', 'SHARE_CREATE_WIZ_STR10'];
break;
case 'setup_users':
access_type_str = 'SHARE_CREATE_WIZ_STR11';
break;
case 'setup_groups':
access_type_str = 'SHARE_CREATE_WIZ_STR12';
break;
case 'admin_only':
access_type_str = 'SHARE_CREATE_WIZ_STR13';
break;
}

var access_typeStr = '';
if (Ext.isArray(access_type_str)) {
Ext.each(access_type_str, function (data) {
access_typeStr += _S[data];
});
} else {
access_typeStr = _S[access_type_str];
}
var access_type_asf = step45Form.findField('access_type_asf');
access_type_asf.setValue(access_typeStr);
access_type_asf.qInternational = true;
access_type_asf.setStr = access_type_str;
access_type_asf.qInternationalFn = function (cmp) {
var str = '';
if (Ext.isArray(this.setStr)) {
Ext.each(this.setStr, function (data) {
str += _S[data];
});
} else str = _S[this.setStr];
cmp.setValue(str);
};

var step6_quota_size_asf = step45Form.findField('step6_quota_size_asf');
if (is_imageShare == 0) step6_quota_size_asf.hide();
else if (is_imageShare && step2Form.findField('path_type_group').getValue().inputValue == 'manual') {
step6_quota_size_asf.show();
step6_quota_size_asf.setValue('---');
}
switch (access_r_group) {
case 'nolimit':
step45Form.findField('access_list_asf').setValue('everyone');
return 'share_create_step45';
case 'admin_only':
step45Form.findField('access_list_asf').setValue('---');
return 'share_create_step45';
case 'setup_users':
setTimeout(function () {
try {
accessUserGrid.getTopToolbar().getComponent('space').setWidth(accessUserGrid.getWidth() - 130);
} catch (e) {}
}, 10);
return 'share_create_step4_op1';
case 'setup_groups':
setTimeout(function () {
try {
accessGroupGrid.getTopToolbar().getComponent('space').setWidth(accessGroupGrid.getWidth() - 130);
} catch (e) {}
}, 10);
return 'share_create_step4_op2';
}
}
});

var accessUserStore = new Ext.data.Store({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: "share_access_control"
}, {
getdata: 1,
shareName: ''
}),
remoteSort: true,
method: 'POST',
baseParams: {
filter: '',
type: 0,
lower: 0,
upper: 10
},
defaultParamNames: {
limit: 'upper',
start: 'lower'
},
reader: new Ext.data.XmlReader({
root: 'data',
totalProperty: 'userroot > count',
record: 'user'
}, [{
name: 'username',
mapping: 'username'
}, {
name: 'access_rd',
mapping: 'access_rd'
}, {
name: 'access_rw',
mapping: 'access_rw'
}, {
name: 'access_no',
mapping: 'access_no'
}, {
name: 'now',
mapping: 'now'
}, {
name: 'priv',
mapping: 'preview'
}]),
listeners: {
beforeload: function (store, o) {
o.params.lower = o.params.lower || 0;
Ext.apply(o.params, {
upper: o.params.lower + 10,
filter: uSearch.field ? uSearch.field.getValue() : '',
type: 0
});
store.each(function (record) {
Ext.each(accessUserArray, function (data) {
if (data.username == record.data.username) {
data.access_rd = record.data.access_rd;
data.access_rw = record.data.access_rw;
data.access_no = record.data.access_no;
}
});
});
},
load: function (store) {
store.each(function (record, index) {
var chkValue = false;
record.data.priv = fn.chgStatuE2N(record.data.priv || 'N');
Ext.each(accessUserArray, function (data) {
if (data.username == record.data.username) {
record.data.access_rd = data.access_rd == true;
record.data.access_rw = data.access_rw == true;
record.data.access_no = data.access_no == true;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
chkValue = true;
store.data.items[index].afterEdit();
}
});
if (!chkValue) {
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
accessUserArray.push({
username: record.data.username,
access_rd: record.data.access_rd,
access_rw: record.data.access_rw,
access_no: record.data.access_no
});
store.data.items[index].afterEdit();
}
});
delete store.reader.xmlData;
}
}
});

var access_rd = new Ext.grid.CheckColumn({
header: '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>';
},
width: 30,
dataIndex: "access_rd"
});
var access_rw = new Ext.grid.CheckColumn({
header: '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>';
},
width: 30,
dataIndex: "access_rw"
});
var access_no = new Ext.grid.CheckColumn({
header: '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>';
},
width: 30,
dataIndex: "access_no"
});
var uSearch = new Ext.ux.grid.wizSearch({
mode: 'remote',
idFilter: 'user_wizard_filter',
iconCls: false,
readonlyIndexes: ['access_no'],
minChars: 1,
autoFocus: true
});
var accessUserGrid = new Ext.grid.GridPanel({
store: accessUserStore,
enableHdMenu: false,
enableColumnMove: false,
autoExpandColumn: "username",
height: Ext.isDefined(runFinish) ? runFinish.gridHeight : 346,
qInternational: true,
colModel: new Ext.grid.ColumnModel({
qInternational: true,
defaults: {
qInternational: true
},
columns: [{
header: _S.QNAP_PS_USER_NAME,
qInternationalKey: 'QNAP_PS_USER_NAME',
sortable: false,
dataIndex: 'username',
value2Tip: true
}, {
header: _S.QTS_MSG_4,
qInternationalKey: 'QTS_MSG_4',
dataIndex: 'now',
renderer: function (data, metadata, record, rowIndex, columnIndex, store) {
var color = fn.getPreviewColor(data);
var tip = fn.chgStatuStr(data);
tip = _S[tip] || tip;
metadata.attr = 'ext:qtip="' + tip + '" style="color:' + color + '"';
return tip;
}
},
access_rd, access_rw, access_no]
}),
viewConfig: {
forceFit: true,
scrollOffset: 0
},
columnLines: true,
buttonAlign: 'left',
frame: true,
tbar: [{
xtype: 'tbspacer',
itemId: 'space',
width: 345
}],
bbar: new Ext.wizardPagingToolbar({
pageSize: 10,
store: accessUserStore,
displayInfo: true
}),
plugins: [
uSearch, access_rd, access_rw, access_no],
listeners: {
headerclick: function (grid, columnIndex, e) {
switch (columnIndex) {
case 2:
if (!me.wiz_u_access_rdCheck) {
me.wiz_u_access_rdCheck = true;
me.wiz_u_access_rwCheck = false;
me.wiz_u_access_noCheck = false;
} else {
me.wiz_u_access_rdCheck = false;
}
Ext.each(accessUserArray, function (data) {
grid.store.each(function (record) {
if (data.username == record.data.username) {
data.access_rd = record.data.access_rd = me.wiz_u_access_rdCheck;
if (me.wiz_u_access_rdCheck) data.access_rw = record.data.access_rw = false;
if (me.wiz_u_access_rdCheck) data.access_no = record.data.access_no = false;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
record.afterEdit();
}
});
});
break;
case 3:
if (!me.wiz_u_access_rwCheck) {
me.wiz_u_access_rdCheck = false;
me.wiz_u_access_rwCheck = true;
me.wiz_u_access_noCheck = false;
} else {
me.wiz_u_access_rwCheck = false;
}
Ext.each(accessUserArray, function (data) {
grid.store.each(function (record) {
if (data.username == record.data.username) {
if (me.wiz_u_access_rwCheck) data.access_rd = record.data.access_rd = false;
data.access_rw = record.data.access_rw = me.wiz_u_access_rwCheck;
if (me.wiz_u_access_rwCheck) data.access_no = record.data.access_no = false;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
record.afterEdit();
}
});
});
break;
case 4:
if (!me.wiz_u_access_noCheck) {
me.wiz_u_access_rdCheck = false;
me.wiz_u_access_rwCheck = false;
me.wiz_u_access_noCheck = true;
} else {
me.wiz_u_access_noCheck = false;
}
Ext.each(accessUserArray, function (data) {
grid.store.each(function (record) {
if (data.username == record.data.username) {
if (me.wiz_u_access_noCheck) data.access_rd = record.data.access_rd = false;
if (me.wiz_u_access_noCheck) data.access_rw = record.data.access_rw = false;
data.access_no = record.data.access_no = me.wiz_u_access_noCheck;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
record.afterEdit();
}
});
});
break;
}
},
afteredit: function (e) {
switch (e.field) {
case 'access_rd':
e.record.data.access_rw = false;
e.record.data.access_no = false;
break;
case 'access_rw':
e.record.data.access_rd = false;
e.record.data.access_no = false;
break;
case 'access_no':
e.record.data.access_rd = false;
e.record.data.access_rw = false;
break;
}
e.record.data.now = fn.compareNumber(e.record.data.priv || 0, fn.chkAccessRWI(e.record));
e.grid.store.data.items[e.row].afterEdit();
e.record.commit();
}
}
});

me.wiz_u_access_rdCheck = false;
me.wiz_u_access_rwCheck = false;
me.wiz_u_access_noCheck = false;

function fillDataList(ary, style) {
var count = 0,
everyone_group_rw = 0,
all_list = '',
tmp_array = [];
Ext.each(ary, function (data) {
if (data.access_rd || data.access_rw || data.access_no) {
tmp_array.push(data[style ? 'groupname' : 'username']);
}
});

if (style) {
if (projectlName == 'Athens') {
Ext.each(ary, function (data) {
if (data.groupname == 'everyone' && data.access_rw) everyone_group_rw = 1;
});
}
}

for (var i = 0; i < tmp_array.length; i++) {
if (i > 0) all_list += ', ';
all_list += tmp_array[i];
if (i > 4) {
all_list += ' ...';
all_list = '<div ext:qtip="' + tmp_array.join(', ') + '">' + all_list + '</div>';
break;
}
}
step45Form.findField('everyone_group_rw_note_asf').setVisible(style && everyone_group_rw);
if (all_list == '') all_list = '---';
step45Form.findField('access_list_asf').setValue(all_list);
if (style == 0) return all_list;
}

var share_create_step4_op1 = new QNAP.QOS.wizard.formPanel({
itemId: 'share_create_step4_op1',
nextId: 'share_create_step45',
headerTitle: _S.SHARE_CREATE_WIZ_STR21,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR21',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
items: [
accessUserGrid,
{
xtype: 'container',
layout: 'hbox',
style: 'padding-top:6px;',
items: [{
xtype: 'displayfield',
value: _S.COMMON_NOTE,
qInternational: true,
qInternationalKey: 'COMMON_NOTE',
hideLabel: true,
cls: 'note-color',
style: 'font-weight: bold;padding-right:5px;'
}, {
xtype: 'container',
items: [{
xtype: 'displayfield',
value: _S.PREVIEW_NOTE_STR01,
qInternational: true,
qInternationalKey: 'PREVIEW_NOTE_STR01',
hideLabel: true,
cls: 'note-color number-indent-line'
}, {
xtype: 'displayfield',
value: _S.PREVIEW_NOTE_STR02,
qInternational: true,
qInternationalKey: 'PREVIEW_NOTE_STR02',
hideLabel: true,
cls: 'note-color number-indent-line'
}]
}]
}, {
xtype: 'displayfield',
style: 'height:30px;',
hidden: !Ext.isGecko
}],
onNext: function () {
accessUserGrid.store.each(function (record) {
var chkValue = false;
Ext.each(accessUserArray, function (data) {
if (data.username == record.data.username) {
data.access_rd = record.data.access_rd;
data.access_rw = record.data.access_rw;
data.access_no = record.data.access_no;
chkValue = true;
}
});
if (!chkValue) {
accessUserArray.push({
username: record.data.username,
access_rd: record.data.access_rd,
access_rw: record.data.access_rw,
access_no: record.data.access_no
});
}
});
var chk = fillDataList(accessUserArray, 0);
if (chk == '---') {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
fn.winAlert(app, target, 'SHARED_FOLDER_14', 'info', '', target != '' ? target : null);
return false;
}
return true;
}
});

var accessGroupStore = new Ext.data.Store({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: "share_access_control"
}, {
getdata: 1,
shareName: ''
}),
remoteSort: true,
method: 'POST',
baseParams: {
filter: '',
type: 2,
lower: 0,
upper: 10
},
defaultParamNames: {
limit: 'upper',
start: 'lower'
},
reader: new Ext.data.XmlReader({
root: 'data',
totalProperty: 'grouproot > count',
record: 'group'
}, [{
name: 'groupname',
mapping: 'groupname'
}, {
name: 'access_rd',
mapping: 'access_rd'
}, {
name: 'access_rw',
mapping: 'access_rw'
}, {
name: 'access_no',
mapping: 'access_no'
}, {
name: 'now',
mapping: 'now'
}, {
name: 'priv',
mapping: 'preview'
}]),
listeners: {
beforeload: function (store, o) {
o.params.lower = o.params.lower || 0;
Ext.apply(o.params, {
upper: o.params.lower + 10,
filter: gSearch.field ? gSearch.field.getValue() : '',
type: 2
});
store.each(function (record) {
Ext.each(accessGroupArray, function (data) {
if (data.groupname == record.data.groupname) {
data.access_rd = record.data.access_rd;
data.access_rw = record.data.access_rw;
data.access_no = record.data.access_no;
}
});
});
},
load: function (store) {
var xmlData = store.reader.xmlData;
projectlName = Ext.DomQuery.selectValue('projectlName', xmlData) || '';
store.each(function (record, index) {
var chkValue = false;
record.data.priv = fn.chgStatuE2N(record.data.priv || 'N');
Ext.each(accessGroupArray, function (data) {
if (data.groupname == record.data.groupname) {
record.data.access_rd = data.access_rd;
record.data.access_rw = data.access_rw;
record.data.access_no = data.access_no;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
chkValue = true;
store.data.items[index].afterEdit();
}
});
if (!chkValue) {
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
accessGroupArray.push({
groupname: record.data.groupname,
access_rd: record.data.access_rd,
access_rw: record.data.access_rw,
access_no: record.data.access_no
});
store.data.items[index].afterEdit();
}
});
delete store.reader.xmlData;
}
}
});

var access_rd = new Ext.grid.CheckColumn({
header: '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>';
},
width: 30,
dataIndex: "access_rd"
});
var access_rw = new Ext.grid.CheckColumn({
header: '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>';
},
width: 30,
dataIndex: "access_rw"
});
var access_no = new Ext.grid.CheckColumn({
header: '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div style="width:100%;text-align:center;cursor:pointer;" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>';
},
width: 30,
dataIndex: "access_no"
});
var gSearch = new Ext.ux.grid.wizSearch({
mode: 'remote',
idFilter: 'group_wizard_filter',
iconCls: false,
readonlyIndexes: ['groupname'],
minChars: 1,
autoFocus: true
});
var accessGroupGrid = new Ext.grid.GridPanel({
store: accessGroupStore,
enableHdMenu: false,
enableColumnMove: false,
disableSelection: true,
trackMouseOver: false,
autoExpandColumn: "groupname",
height: Ext.isDefined(runFinish) ? runFinish.gridHeight : 346,
qInternational: true,
colModel: new Ext.grid.ColumnModel({
qInternational: true,
defaults: {
qInternational: true,
sortable: false
},
columns: [{
header: _S.USER_GROUP_GREATE_WIZ_STR19,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR19',
dataIndex: 'groupname',
value2Tip: true
}, {
header: _S.QTS_MSG_4,
qInternationalKey: 'QTS_MSG_4',
dataIndex: 'now',
renderer: function (data, metadata, record, rowIndex, columnIndex, store) {
var color = fn.getPreviewColor(data);
var tip = fn.chgStatuStr(data);
tip = _S[tip] || tip;
metadata.attr = 'ext:qtip="' + tip + '" style="color:' + color + '"';
return tip;
}
},
access_rd, access_rw, access_no]
}),
viewConfig: {
forceFit: true,
scrollOffset: 0
},
columnLines: true,
buttonAlign: 'left',
frame: true,
tbar: [{
xtype: 'tbspacer',
itemId: 'space',
width: 345
}],
bbar: new Ext.wizardPagingToolbar({
pageSize: 10,
store: accessGroupStore,
displayInfo: true
}),
plugins: [
gSearch, access_rd, access_rw, access_no],
listeners: {
headerclick: function (grid, columnIndex, e) {
switch (columnIndex) {
case 2:
if (!me.wiz_g_access_rdCheck) {
me.wiz_g_access_rdCheck = true;
me.wiz_g_access_rwCheck = false;
me.wiz_g_access_noCheck = false;
} else {
me.wiz_g_access_rdCheck = false;
}
Ext.each(accessGroupArray, function (data) {
grid.store.each(function (record) {
if (data.groupname == record.data.groupname) {
data.access_rd = record.data.access_rd = me.wiz_g_access_rdCheck;
if (me.wiz_g_access_rdCheck) data.access_rw = record.data.access_rw = false;
if (me.wiz_g_access_rdCheck) data.access_no = record.data.access_no = false;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
record.afterEdit();
}
});
});
break;
case 3:
if (!me.wiz_g_access_rwCheck) {
me.wiz_g_access_rdCheck = false;
me.wiz_g_access_rwCheck = true;
me.wiz_g_access_noCheck = false;
} else {
me.wiz_g_access_rwCheck = false;
}
Ext.each(accessGroupArray, function (data) {
grid.store.each(function (record) {
if (data.groupname == record.data.groupname) {
if (me.wiz_g_access_rwCheck) data.access_rd = record.data.access_rd = false;
data.access_rw = record.data.access_rw = me.wiz_g_access_rwCheck;
if (me.wiz_g_access_rwCheck) data.access_no = record.data.access_no = false;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
record.afterEdit();
}
});
});
break;
case 4:
if (me.wiz_u_access_noCheck == false) {
me.wiz_g_access_rdCheck = false;
me.wiz_g_access_rwCheck = false;
me.wiz_u_access_noCheck = true;
} else {
me.wiz_u_access_noCheck = false;
}
Ext.each(accessGroupArray, function (data) {
grid.store.each(function (record) {
if (data.groupname == record.data.groupname) {
if (me.wiz_u_access_noCheck) data.access_rd = record.data.access_rd = false;
if (me.wiz_u_access_noCheck) data.access_rw = record.data.access_rw = false;
data.access_no = record.data.access_no = me.wiz_u_access_noCheck;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
record.afterEdit();
}
});
});
break;
}
},
afteredit: function (e) {
switch (e.field) {
case 'access_rd':
e.record.data.access_rw = false;
e.record.data.access_no = false;
break;
case 'access_rw':
e.record.data.access_rd = false;
e.record.data.access_no = false;
break;
case 'access_no':
e.record.data.access_rd = false;
e.record.data.access_rw = false;
break;
}
e.record.data.now = fn.compareNumber(e.record.data.priv || 0, fn.chkAccessRWI(e.record));
e.grid.store.data.items[e.row].afterEdit();
e.record.commit();
}
}
});

var share_create_step4_op2 = new QNAP.QOS.wizard.formPanel({
itemId: 'share_create_step4_op2',
nextId: 'share_create_step45',
headerTitle: _S.SHARE_CREATE_WIZ_STR22,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR22',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
items: [
accessGroupGrid,
{
xtype: 'container',
layout: 'hbox',
style: 'padding-top:6px;',
items: [{
xtype: 'displayfield',
value: _S.COMMON_NOTE,
qInternational: true,
qInternationalKey: 'COMMON_NOTE',
hideLabel: true,
cls: 'note-color',
style: 'font-weight: bold;padding-right:5px;'
}, {
xtype: 'container',
items: [{
xtype: 'displayfield',
value: _S.PREVIEW_NOTE_STR01,
qInternational: true,
qInternationalKey: 'PREVIEW_NOTE_STR01',
hideLabel: true,
cls: 'note-color number-indent-line'
}, {
xtype: 'displayfield',
value: _S.PREVIEW_NOTE_STR02,
qInternational: true,
qInternationalKey: 'PREVIEW_NOTE_STR02',
hideLabel: true,
cls: 'note-color number-indent-line'
}]
}]
}, {
xtype: 'displayfield',
style: 'height:30px;',
hidden: !Ext.isGecko
}],
onNext: function () {
accessGroupGrid.store.each(function (record) {
var chkValue = false;
Ext.each(accessGroupArray, function (data) {
if (data.groupname == record.data.groupname) {
data.access_rd = record.data.access_rd;
data.access_rw = record.data.access_rw;
data.access_no = record.data.access_no;
chkValue = true;
}
});
if (!chkValue) {
accessGroupArray.push({
groupname: record.data.groupname,
access_rd: record.data.access_rd,
access_rw: record.data.access_rw,
access_no: record.data.access_no
});
}
});
fillDataList(accessGroupArray, 1);
return true;
}
});

var share_create_step45 = new QNAP.QOS.wizard.formPanel({
itemId: 'share_create_step45',
nextId: 'finish',
headerTitle: _S.USER_CREATE_WIZ_STR23,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR23',
bodyStyle: 'padding: 20px 60px 30px;',
labelWidth: 190,
autoScroll: true,
defaults: {
xtype: 'displayfield',
style: 'padding-top:3px;'
},
items: [{
itemId: 'sname_asf',
name: 'sname_asf',
fieldLabel: _S.SHARE_CREATE_WIZ_STR14,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR14',
labelSeparator: ''
}, {
itemId: 'ishidden_asf',
name: 'ishidden_asf',
fieldLabel: _S.USER_CREATE_WIZ_STR16,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR16',
labelSeparator: ''
}, {
itemId: 'isoplocks_asf',
name: 'isoplocks_asf',
fieldLabel: _S.IEI_NAS_SHARE79,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE79'
}, {
itemId: 'step6_quota_size_asf',
name: 'step6_quota_size_asf',
fieldLabel: _S.USER_CREATE_WIZ_STR26,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR26',
labelSeparator: ''
}, {
itemId: 'whole_path_asf',
name: 'whole_path_asf',
fieldLabel: _S.USER_CREATE_WIZ_STR17,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR17',
labelSeparator: ''
}, {
itemId: 'isrecycle_bin_asf',
name: 'isrecycle_bin_asf',
fieldLabel: _S.RECYCLE_BIN_STRING,
qInternational: true,
qInternationalKey: 'RECYCLE_BIN_STRING'
}, {
itemId: 'cmt_asf',
name: 'cmt_asf',
fieldLabel: _S.MISC_SMART_STR75,
qInternational: true,
qInternationalKey: 'MISC_SMART_STR75'
}, {
itemId: 'access_type_asf',
name: 'access_type_asf',
fieldLabel: _S.SHARE_CREATE_WIZ_STR15,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR15',
labelSeparator: ''
}, {
itemId: 'access_list_asf',
name: 'access_list_asf',
fieldLabel: _S.SHARE_CREATE_WIZ_STR16,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR16',
labelSeparator: ''
}, {
itemId: 'everyone_group_rw_note_asf',
name: 'everyone_group_rw_note_asf',
hidden: true,
value: _S.SHARE_CREATE_WIZ_STR26,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR26',
hideLabel: true
}],
onNext: function () {
var para = {};
var urd_len = 0,
urw_len = 0,
uno_len = 0;
var grd_len = 0,
grw_len = 0,
gno_len = 0;
para.comment = step2Form.findField('comment_shareFolder').getValue();
para.guest = step3Form.findField('guest_group').getValue().inputValue;
para.hidden = step2Form.findField('hidden_group').getValue().inputValue;
para.oplocks = step2Form.findField('oplocks_group').getValue().inputValue;
para.share_name = step2Form.findField('share_name_shareFolder').getValue();
para.access_r = step3Form.findField('access_r_group').getValue().inputValue;
if (para.access_r == 'setup_users') {
para.user_wizard_filter = para.wizard_filter = uSearch.field ? uSearch.field.getValue() : '';
Ext.each(accessUserArray, function (data) {
if (data.access_rd) {
para['userd' + urd_len] = data.username;
urd_len++;
} else if (data.access_rw) {
para['userw' + urw_len] = data.username;
urw_len++;
} else if (data.access_no) {
para['useno' + uno_len] = data.username;
uno_len++;
}
});
para.userd_len = urd_len;
para.userw_len = urw_len;
para.useno_len = uno_len;
} else if (para.access_r == 'setup_groups') {
para.group_wizard_filter = para.wizard_filter = gSearch.field ? gSearch.field.getValue() : '';
Ext.each(accessGroupArray, function (data) {
if (data.access_rd) {
para['grouprd' + grd_len] = data.groupname;
grd_len++;
} else if (data.access_rw) {
para['grouprw' + grw_len] = data.groupname;
grw_len++;
} else if (data.access_no) {
para['groupno' + gno_len] = data.groupname;
gno_len++;
}
});
para.grouprd_len = grd_len;
para.grouprw_len = grw_len;
para.groupno_len = gno_len;
}
para.img_file_path = step2Form.findField('imageFileList').getValue();
para.path_type = step2Form.findField('path_type_group').getValue().inputValue;
var recycle_bin_status = 1;
if (step2Form.findField('path_type_group').getValue().inputValue != 'auto') {
para.manual_path = manualPathTreeCombo.getValue();
var chkPathAry = para.manual_path.split('/');
var chkDis = chkManualPath(false, chkPathAry);
if (chkDis) recycle_bin_status = 0;
}
if (recycleBinEnable == 1) {
para.recycle_bin = recycle_bin_status == 1 ? step2Form.findField('recycle_bin_group').getValue().inputValue : 0;
} else {
para.recycle_bin = 0;
}
var recycleAdmin = step2Form.findField('recycle_bin_admin').getValue() ? 1 : 0;
para.recycle_bin_administrators_only = para.recycle_bin !== 0 ? recycleAdmin : 0;
para.quotaRadio = step2Form.findField('quotaRadio_group').getValue().inputValue;
para.quotaSettings = step2Form.findField('quotaSettings').getValue();
para.quota_size = '';
if (is_imageShare) para.quota_size = step2Form.findField('path_type_group').getValue().inputValue == 'manual' ? '1' : step2Form.findField('quotaSettings').getValue();
para.vol_no = step2Form.findField('disks_list_shareFolder').getValue();
finishPanel.headerTitle = _S.SHARE_CREATE_WIZ;
finishPanel.qInternational = true;
finishPanel.qInternationalKey = 'SHARE_CREATE_WIZ';
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
QNAP.QOS.lib.MaskMgr.mask(target.getEl(), 'LOADING', _S.LOADING);
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'share_create'
}, {
action: 'add_share'
}),
method: 'POST',
params: para,
success: function (response, opts) {
var xmlData = response.responseXML;
function runSuccess() {
var runfilechg = false;
var sc_failed_asf = finishForm.findField('sc_failed_asf');
var sc_finish_asf = finishForm.findField('sc_finish_asf');
if (Ext.DomQuery.selectNode('return', xmlData)) {
var ret = Ext.DomQuery.selectValue('return', xmlData);
if (ret != '') {
ret = parseInt(ret);
var chkValue = ret < 0;
sc_failed_asf.setVisible(chkValue);
sc_finish_asf.setVisible(!chkValue);
if (chkValue) {
if (!Ext.isDefined(runFinish)) target = '';
fn.winAlert(app, target, 'SHARE_CREATE_WIZ_STR32', 'info', '', target != '' ? target : null);
} else {
if (para.access_r == 'nolimit' || para.access_r == 'admin_only') runfilechg = true;
else if (para.access_r == 'setup_users' && (para.userd_len > 0 || para.userw_len > 0 || para.useno_len > 0)) runfilechg = true;
else if (para.access_r == 'setup_groups' && (para.grouprd_len > 0 || para.grouprw_len > 0 || para.groupno_len > 0)) runfilechg = true;
if (runfilechg){
app._getApp().fireEvent('filechange', app._getApp().id, '/', '/', para.share_name, 'new');
}
}
}
} else {
sc_failed_asf.hide();
sc_finish_asf.show();
if (para.access_r == 'nolimit' || para.access_r == 'admin_only') runfilechg = true;
else if (para.access_r == 'setup_users' && (para.userd_len > 0 || para.userw_len > 0 || para.useno_len > 0)) runfilechg = true;
else if (para.access_r == 'setup_groups' && (para.grouprd_len > 0 || para.grouprw_len > 0 || para.groupno_len > 0)) runfilechg = true;
if (runfilechg){
if (Ext.isDefined(runFinish.shareFolderStore)) {//從Control Panel進來的。
app._getApp().fireEvent('filechange', app._getApp().id, '/', '/', para.share_name, 'new');
}else if (Ext.isDefined(runFinish.fileManager)){//從fileManager進來的。
var FM=runFinish.fileManager;
app=runFinish.fileManager;
app._getApp().fireEvent('filechange', app._getApp().id, '/', '/', para.share_name, 'new');
FM.openPath(FM.currentPath);
}
}
}
target.getEl().unmask();
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'updateSharedFolderGrid');
}
if (Ext.isDefined(runFinish)) {
if (Ext.isDefined(runFinish.shareFolderStore)) {//從Control Panel進來的。
runFinish.shareFolderStore.reload({
callback: function (store, record, options) {
runSuccess();
}
});
runFinish.selSharedFolderAry = [];
}else if (Ext.isDefined(runFinish.fileManager)){//從fileManager進來的。
var FM=runFinish.fileManager;
runSuccess();
}
} else {
runSuccess();
}
},
failure: function () {
finishForm.findField('sc_failed_asf').show();
finishForm.findField('sc_finish_asf').hide();
target.getEl().unmask();
}
});
return true;
}
});

var finishPanel = new QNAP.QOS.wizard.formPanel({
itemId: 'finish',
headerTitle: _S.SHARE_CREATE_WIZ_STR17,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR17',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
hideLabels: true,
defaults: {
xtype: 'displayfield'
},
items: [{
itemId: 'sc_finish_asf',
name: 'sc_finish_asf',
hidden: true,
value: _S.SHARE_CREATE_WIZ_STR18,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR18',
hideLabel: true
}, {
itemId: 'sc_failed_asf',
name: 'sc_failed_asf',
hidden: true,
value: _S.SHARE_CREATE_WIZ_STR32,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR32',
hideLabel: true,
style: 'color:red;'
}, {
value: _S.SHARE_CREATE_WIZ_STR19,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR19',
hideLabel: true
}]
});

var step1Form = share_create_step1.getForm();
var step2Form = share_create_step2.getForm();
var step3Form = share_create_step3.getForm();
var step45Form = share_create_step45.getForm();
var finishForm = finishPanel.getForm();
var osupportImageShare = 'no';

items = {
height: 540,
winHeight: 540,
accessUserStore: accessUserStore,
accessGroupStore: accessGroupStore,
steps: [share_create_step1, share_create_step2, share_create_step3, share_create_step4_op1, share_create_step4_op2, share_create_step45, finishPanel]
};

ajax_info = {
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'share_create'
}),
method: 'POST',
success: function (response, opts) {
var xmlData = response.responseXML;
if (xmlData != undefined) {
recycleBinEnable = Ext.DomQuery.selectValue('recycleBinEnable', xmlData);
QNAP.GQ.parseGQMaster(xmlData);
var volList = Ext.DomQuery.selectNode('volumeList', xmlData);
if (volList) fn.GenVolumeSelect('v2', step2Form.findField('disks_list_shareFolder'), volList);
/* GQ feature:
* add Gluster volume to volume list when create share
*/
if(QNAP.GQ.isMaster()){
data = step2Form.findField('disks_list_shareFolder').store.data.items;
new_data = QNAP.GQ.addGlusterVol(data);
step2Form.findField('disks_list_shareFolder').store.loadData(new_data);
}
var oShareNum = Ext.DomQuery.selectNode('ShareNum', xmlData);
if (oShareNum) {
share_count = parseInt(Ext.DomQuery.selectValue('ShareNum/count', xmlData));
max_count = parseInt(Ext.DomQuery.selectValue('ShareNum/max_count', xmlData));
}
osupportImageShare = Ext.DomQuery.selectValue('supportImageShare', xmlData);
bManualPath = false;
Ext.each(Ext.DomQuery.select('NASShareList/share', xmlData), function (node) {
Used_ShareArray.push(Ext.DomQuery.selectValue('name', node));
});
if (parseInt(share_count) >= parseInt(max_count)) step1Form.findField('ShareCountErrAdd').show();
accessUserStore.load();
accessGroupStore.load();
if (recycleBinEnable == '1') {
step2Form.findField('recycle_bin_admin').setDisabled(share_create_step2.getComponent('recycle_bin_group').getValue().inputValue !== '1');
}
}
},
failure: function () {}
};

var setForm2Adv = function () {
var step2 = share_create_step2;
var hidden_group = step2.getComponent('hidden_group');
hidden_group.setVisible(!hidden_group.isVisible());
var oplocks_group = step2.getComponent('oplocks_group');
oplocks_group.setVisible(!oplocks_group.isVisible());
var recycle_bin_group = step2.getComponent('recycle_bin_group');
var recycle_bin_admin = step2Form.findField('recycle_bin_admin');
if (recycleBinEnable == 1) {
recycle_bin_group.setVisible(!recycle_bin_group.isVisible());
recycle_bin_admin.setVisible(!recycle_bin_admin.isVisible());
} else {
recycle_bin_group.setVisible(false);
}
var path_type_group = step2.getComponent('path_type_group');
var quotaRadio_group = step2.getComponent('quotaRadio_group');
var quotaSettings = step2Form.findField('quotaSettings');
if (path_type_group.isVisible()) {
quotaRadio_group.hide();
step2.getComponent('quotaRadioDiv2u').hide();
quotaSettings.disable();
quotaRadio_group.setValue(0);
if (manualPathTreeCombo.getValue() == '') path_type_group.setValue('auto');
} else {
var chkValue = osupportImageShare == 'yes';
me.imageShareSupport = chkValue * 1;
quotaRadio_group.setVisible(chkValue);
if (chkValue) {
quotaSettings.disable();
quotaSettings.validate();
}
step2.doLayout();
}
path_type_group.setVisible(!path_type_group.isVisible());
manualPathTreeCombo.setVisible(!manualPathTreeCombo.isVisible());
};

var updateGlobalShare = function () {
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'gq.cgi/gq/v1/share'),
method: 'GET',
params : {all_shares: null},
success: function (response, opts) {
var rsp = Ext.decode(response.responseText);
Ext.each(rsp, function (item) {
globalShareArray.push(item.shareName.toLowerCase());
});
},
failure: function () {}
});
}
updateGlobalShare();
return {
items: items,
ajax_info: ajax_info
};
},
qAddSharedFolderPanel: function (me, runFinish) {
var fn = this,
app = me;
if (Ext.isDefined(me.app)) app = me.app;

var folderEncryption = false;
var encryptfsSupport = 0;
/*
folderEncryption = true;
*/

if (folderEncryption) {
var passIcon = '<img src="/cgi-bin/apps/systemPreferences/images/folderEncryption/pass.png">';
var failIcon = '<img src="/cgi-bin/apps/systemPreferences/images/folderEncryption/fail.png">';
}

var max_count = 0,
share_count = 0,
is_imageShare = 0,
bManualPath = false,
accessUserArray = [],
accessGroupArray = [],
Used_ShareArray = [],
projectlName = '',
errStr = null,
recycleBinEnable = 1;
var hideHF = false;
var ids = {
btnSharedFolderPriv: Ext.id(),
btnSharedFolderAdvSet: Ext.id()
};
accessUserArray.push({
username: QNAP.QOS.user.account,
access_rd: false,
access_rw: true,
access_no: false
});
var black_share_list = ['global', 'printers', 'tmbackup', 'qsync'];
var globalShareArray = [];
var updateGlobalShareFailed = false;

var isGlobalShareDup = function (v) {
return globalShareArray.inArray(v.toLowerCase());
}

var checkShareName = function (e) {
var v = step2Form.findField('share_name_shareFolder').getValue();
while (v.length > 0 && v.charAt(0) == ' ') {
v = v.substr(1);
}
if (v == "") return _S.FTP_STR41;
if (/[\s\.]$/.test(v)) return _S.FOLDER_ERROR_STR_02;
if (/\s(?=\s)/.test(v)) return _S.FOLDER_ERROR_STR_03;
if (!fn.isNotValidChar(v)) return _S.FOLDER_ERROR_STR_03;
if (v.indexOf("_sn_") == 0 || v.indexOf("_sn_bk") == 0) return _S.FOLDER_ERROR_STR_03;
if (fn.isReservedShareName(v)) return _S.IEI_NAS_SHARE16;
if (black_share_list.inArray(v.toLowerCase())) return _S.IEI_NAS_ERR_MSG13;
var vol_no = step2Form.findField('disks_list_shareFolder').findRecord(step2Form.findField('disks_list_shareFolder').valueField, step2Form.findField('disks_list_shareFolder').getValue()).data.listValue;
if (QNAP.GQ.isGQVol(vol_no)) {
if (QNAP.GQ.getSpaceStatus() !== 'Healthy' || updateGlobalShareFailed)
return _S.GQ_SHAREFOLDER_CREATE_WIZ_MSG2;
if (QNAP.GQ.isDefShareName(v)){
return _S.GQ_SHAREFOLDER_CREATE_WIZ_MSG3;
}
if (isGlobalShareDup(v))
return _S.GQ_SHAREFOLDER_CREATE_WIZ_MSG1;
}
var params = { wiz_func: 'share_create', action: 'check_share', sname: encodeURIComponent(v) };
var url = 'wizReq.cgi'
if( QNAP.QOS.config.ha_enabled ){
if( step2.haSyncCgiCall ){
return errStr;
}else{
url = QNAP.QOS.config.ha_CGI_FILENAME;
params.ha_action = 'wizReq';
params.ha_cluster = 'clusterA';//me.app.HASelector;
}
}
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl( QNAP.QOS.config.sitePath + url, params ),
method: 'POST',
buffer: 500,
success: function (response, opts) {
var xmlData = response.responseXML;
var ret = parseInt(Ext.DomQuery.selectValue('return', xmlData));
if (ret == -1) errStr = _S.IEI_NAS_ERR_MSG06;
else if (ret == -2) errStr = _S.IEI_NAS_ERR_MSG13;
else errStr = true;
if (errStr == true) {
if( QNAP.QOS.config.ha_enabled ){
params.ha_cluster = 'clusterB';
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl( QNAP.QOS.config.sitePath + url, params ),
method: 'POST',
buffer: 500,
success: function (response, opts) {
var xmlData = response.responseXML;
var ret = parseInt(Ext.DomQuery.selectValue('return', xmlData));
if (ret == -1) errStr = _S.IEI_NAS_ERR_MSG06;
else if (ret == -2) errStr = _S.IEI_NAS_ERR_MSG13;
else errStr = true;
if (errStr == true) {
step2Form.findField('share_name_shareFolder').clearInvalid();
} else {
step2Form.findField('share_name_shareFolder').markInvalid(errStr);
}
},
failure: function () {}
});
} else {
step2Form.findField('share_name_shareFolder').clearInvalid();
}
} else {
step2Form.findField('share_name_shareFolder').markInvalid(errStr);
}
},
failure: function () {}
});
return errStr;
};

var params = { wiz_func: 'get_dirs' };
var url = 'wizReq.cgi'
if( QNAP.QOS.config.ha_enabled ){
url = QNAP.QOS.config.ha_CGI_FILENAME
params.ha_action = 'wizReq';
params.ha_cluster = me.app.HASelector;
}
var manualLoader = new Ext.tree.TreeLoader({
dataUrl: QNAP.QOS.lib.getCgiUrl( QNAP.QOS.config.sitePath + url, params ),
baseParams: {
dir: '/share',
vol_no: 1
},
listeners: {
load: function (loader, parentNode, res) {
var nodes = [];
var ary = res.responseText.split(new RegExp(/<ul.+?>\s*<li .+?>\s*<a .+?>|<\/a><\/li><\/ul>/));
var pathAry = res.responseText.split(new RegExp(/<ul.+?>\s*<li .+?>\s*<a href="#" rel=\"|\">.+?<\/a><\/li><\/ul>/));
Ext.each(ary, function (data, i) {
if (!Ext.isEmpty(data)) {
var obj = {};
obj.text = data;
obj.fullPath = pathAry[i];
var tmpAry = pathAry[i].split('/');
if (tmpAry[2] == 'external') {
obj.dir = pathAry[i].replace(tmpAry.splice(0, 4).join('/'), '');
} else {
obj.dir = pathAry[i].replace(tmpAry.splice(0, 3).join('/'), '');
}
nodes.push(obj);
}
});
parentNode.appendChild(nodes);
},
beforeload: function (loader, node, callback) {
var bp = loader.baseParams;
bp.dir = QNAP.QOS.quickWizard.getNodeFullPath(node) == '/' ? '/share' : node.attributes.fullPath;
bp.vol_no = step2Form.findField('disks_list_shareFolder').getValue();
}
}
});
var manualPathTree = new Ext.tree.TreePanel({
loader: manualLoader,
border: false,
rootVisible: false,
root: new Ext.tree.AsyncTreeNode({
text: '/',
id: 0,
dir: '/share'
}),
listeners: {
click: function (node, e) {
var value = node.attributes.dir,
chkPathAry = value.split('/'),
chkDis = chkManualPath(false, chkPathAry),
recycleGroup = step2AdvForm.findField('recycle_bin_group'),
recycleAdmin = step2AdvForm.findField('recycle_bin_admin');
manualPathTreeCombo.setValue(value);
recycleGroup.setDisabled(chkDis);
if (chkDis) recycleAdmin.setDisabled(chkDis);
else recycleAdmin.setDisabled(recycleGroup.getValue().inputValue !== 1);
manualPathTreeCombo.collapse();
},
load: function () {
manualPathTree.setHeight(manualPathTreeCombo.list.getHeight() - 2);
}
}
});
var comboIdsf = Ext.id();
var manualPathTreeCombo = new Ext.form.ComboBox({
store: new Ext.data.SimpleStore({
fields: [],
data: [
[]
]
}),
itemId: 'path',
mode: 'local',
width: 300,
triggerAction: 'all',
tpl: "<tpl for='.'><div style='height:200px'><div id='" + comboIdsf + "'></div></div></tpl>",
selectedClass: '',
onSelect: Ext.emptyFn,
allowBlank: false,
disabled: true,
validator: function (v) {
if (v == "") return _S.FTP_STR41;
if (!fn.isNotValidChar_4(v)) return _S.IEI_NAS_ALERT30;
if (v == '//' || /\/\//.test(v)) return _S.IEI_NAS_ALERT33;
if (v == "." || v == "..") return _S.IEI_NAS_ALERT32;
if (v == "/." || v == "/..") return _S.IEI_NAS_ALERT32_1;
if (v == '/' ){
if( folderEncryption && fdEncryForm.findField('folderEncryptionCheck').getValue() ){
return _S.IEI_NAS_ALERT71;
}
}
},
fileTree: manualPathTree,
listeners: {
expand: function () {
manualPathTree.render(comboIdsf);
},
afterrender: function (e) {
this.mon(this.el, 'click', this.onTriggerClick, this);
}
},
onViewClick: function (doFocus) {
var index = this.view.getSelectedIndexes()[0],
s = this.store,
r = s.getAt(index);
if (r) this.onSelect(r, index);
if (doFocus != false) this.el.focus();
},
initQuery: function () {
this.doQuery(this.getRawValue(), true);
}
});
var chkManualPath = function (dis, ary) {
var chk = false;
if (ary.length > 3) chk = true
else if (ary.length == 3 && ary[2] != '') chk = true
return !dis && chk;
};
var step2 = new QNAP.QOS.wizard.formPanel({
labelWidth: 200,
cls: 'panel-border-bottom',
style: 'padding: 0 0 15px;',
tbar: [{
xtype: 'displayfield',
value: _S.WIZ_SHARED_STR_01,
qInternational: true,
qInternationalKey: {value: 'WIZ_SHARED_STR_01'},
cls: 'title-bar-style'
}],
items: [{
xtype: 'textfield',
itemId: 'share_name_shareFolder',
name: 'share_name_shareFolder',
maxLength: 64,
fieldLabel: _S.SHARE_CREATE_WIZ_STR14,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR14',
labelSeparator: '',
width: 300,
enableKeyEvents: true,
validator: checkShareName,
listeners: {
buffer: 500,
keyup: function (f, e) {
if (fn.countStrLen(f.getValue()) > f.maxLength) f.setValue(fn.getCusLenStr(f.getValue(), f.maxLength));
}
}
}, {
xtype: 'textfield',
itemId: 'comment_shareFolder',
fieldLabel: _S.USER_SHARE_STR10,
qInternational: true,
qInternationalKey: 'USER_SHARE_STR10',
maxLength: 128,
width: 300,
labelSeparator: ''
}, {
xtype: 'combo',
itemId: 'disks_list_shareFolder',
name: 'vol_num',
width: 300,
fieldLabel: _S.SHARE_CREATE_WIZ_STR23,
qInternational: true,
qInternationalKey: 'SHARE_CREATE_WIZ_STR23',
qInternationalFn: function (cmp) {
var v = cmp.getValue();
if( QNAP.QOS.config.bIsStorageV2 ){
cmp.getStore().each(function (r) {
var a = '', tmpStr = '';
if (r.data.qInternationalKey != '') a = _S[r.data.qInternationalKey] || r.data.qInternationalKey;
if (r.data.qInternationalKey == 'Unknown') a = '';
if (!Ext.isEmpty(r.data.pool_vjbod)) {
tmpStr += ' (' + _S.SMB_VIRTUAL_DISK_MENU + ')';
}
if (!Ext.isEmpty(r.data.freeSize)) {
tmpStr += ' (' + _S.IEI_NAS_STORAGE74 + _S.QUICK09_STR01 + ' ' + r.data.freeSize + ')';
}
if(r.data.listValue == QNAP.GQ.GlusterVolID){
r.data.listName = a + r.data.diskNumber + tmpStr;
} else {
r.data.listName = a + tmpStr;
}
r.afterEdit();
});
}
else{
cmp.getStore().each(function (r) {
var a = '', tmpStr = '';
if (r.data.qInternationalKey != '') a = _S[r.data.qInternationalKey] || r.data.qInternationalKey;
if (r.data.qInternationalKey == 'Unknown') a = '';
if (!Ext.isEmpty(r.data.pool_vjbod)) {
tmpStr += ' (' + _S.SMB_VIRTUAL_DISK_MENU + ')';
}
if (!Ext.isEmpty(r.data.freeSize)) {
tmpStr += ' (' + _S.IEI_NAS_STORAGE74 + _S.QUICK09_STR01 + ' ' + r.data.freeSize + ')';
}
r.data.listName = a + r.data.diskNumber + tmpStr;
r.afterEdit();
});
}
cmp.setValue(v);
},
labelSeparator: '',
store: new Ext.data.ArrayStore({
fields: ['listName', 'listValue', 'qInternationalKey', 'diskNumber', 'fstype', 'freeSize', 'pool_vjbod']
}),
displayField: 'listName',
valueField: 'listValue',
mode: 'local',
editable: false,
allowBlank: false,
triggerAction: 'all',
validator: function (v) {
if (v == '--' && (this.getValue() == '--' || this.getValue() == '0')) return _S.SMB_EMPTY_VOL_STR01;
return true;
},
listeners: {
select: function () {
/*
* GQ feature: when create share if gq volume is selected, check share name by gq; when create GQ share disbale the path edit
*/
var disks_list_shareFolder = step2Form.findField('disks_list_shareFolder');
var vol_no = disks_list_shareFolder.findRecord(disks_list_shareFolder.valueField, disks_list_shareFolder.getValue()).data.listValue;
var path_type_group = step2Form.findField('path_type_group');

step2Form.findField('share_name_shareFolder').validate();
if (QNAP.GQ.isGQVol(vol_no)){
path_type_group.disable();
manualPathTreeCombo.disable();
}
else {
path_type_group.enable();
manualPathTreeCombo.setDisabled(path_type_group.getValue().inputValue == 'auto');
}
manualPathTreeCombo.fileTree.setRootNode(new Ext.tree.AsyncTreeNode({
text: '/',
id: 0,
dir: '/share'
}));
manualPathTreeCombo.setValue('');

if (folderEncryption) {
var VIRTUAL_VOL_BASE = QNAP.QOS.config.bIsStorageV2 ? 1000 : 100;
var USB_DISK_BASE    = QNAP.QOS.config.bIsStorageV2 ? 2000 : 200;
var ESATA_DISK_BASE  = QNAP.QOS.config.bIsStorageV2 ? 3000 : 300;
var encryptCheckbox = fdEncryForm.findField('folderEncryptionCheck');

if (encryptfsSupport == 1) {
if (vol_no >= VIRTUAL_VOL_BASE) {
encryptCheckbox.setValue(false);
folderEncryptionForm.hide();
} else {
folderEncryptionForm.show();
}
}
}
}
}
}, {
xtype: 'qtsradiogroup',
itemId: 'path_type_group',
fieldLabel: _S.USER_CREATE_WIZ_STR17,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR17',
labelSeparator: '',
columns: 1,
items: [{
boxLabel: _S.IEI_NAS_SHARE41,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE41',
name: 'path_type',
inputValue: 'auto',
disabled: QNAP.QOS.config.ha_enabled,
checked: true,
listeners: {
check: function (f, nv, ov) {
if (f.getValue()) {
manualPathTreeCombo.disable();
manualPathTreeCombo.validate();
var recycleGroup = step2AdvForm.findField('recycle_bin_group')
recycleGroup.enable();
step2AdvForm.findField('recycle_bin_admin').setDisabled(!recycleGroup.getValue());
bManualPath = false;
if (is_imageShare) {
step2Form.findField('imageFileList').disable();
step2AdvForm.findField('quotaSettings').enable();
step2AdvForm.findField('quotaSettings').show();
step2AdvForm.findField('quotaSettings').validate();
}
step2Form.findField('imageFileList').validate();
}
}
}
}, {
boxLabel: _S.IEI_NAS_SHARE42,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE42',
name: 'path_type',
inputValue: 'manual',
disabled: QNAP.QOS.config.ha_enabled,
listeners: {
check: function (f, nv, ov) {
if (f.getValue()) {
manualPathTreeCombo.enable();
var chkPathAry = manualPathTreeCombo.getValue().split('/'),
chkDis = chkManualPath(true, chkPathAry),
recycleGroup = step2AdvForm.findField('recycle_bin_group'),
recycleAdmin = step2AdvForm.findField('recycle_bin_admin'),
quotaSettings = step2AdvForm.findField('quotaSettings'),
imageFileList = step2Form.findField('imageFileList');
recycleGroup.setDisabled(chkDis);
if (chkDis) recycleAdmin.setDisabled(chkDis);
else recycleAdmin.setDisabled(!recycleGroup.getValue());
bManualPath = true;
if (is_imageShare) {
quotaSettings.disable();
quotaSettings.validate();
imageFileList.enable();
} else {
manualPathTreeCombo.validate();
}
imageFileList.validate();
}
}
}
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
},
manualPathTreeCombo,
{
xtype: 'textfield',
name: 'imageFileList',
width: 300,
enableKeyEvents: true,
maxLength: 256,
disabled: true,
hidden: true,
validator: function (v) {
if (v == "") return _S.FTP_STR41;
if (!fn.isNotValidChar_4(v)) return _S.IEI_NAS_ALERT30;
if (v == '//' || /\/\//.test(v)) return _S.IEI_NAS_ALERT33;
if (v == "." || v == "..") return _S.IEI_NAS_ALERT32;
if (v == "/." || v == "/..") return _S.IEI_NAS_ALERT32_1;
return true;
}
}, {
xtype: 'displayfield',
name: 'lbl_none_vol',
value: _S.WIZ_SHARED_STR_09,
qInternational: true,
qInternationalKey: {value: 'WIZ_SHARED_STR_09'},
hidden: true,
hideLabel: true
}],
onNext: function () {
if (!step2Form.findField('share_name_shareFolder').isValid()) {
step2Form.findField('share_name_shareFolder').focus()
return false;
}
if (!step2Form.findField('vol_num').isValid()) {
step2Form.findField('vol_num').focus();
return false;
}
if (!step2AdvForm.findField('quotaSettings').isValid()) {
step2AdvForm.findField('quotaSettings').focus();
return false;
}
if (is_imageShare) {
if (bManualPath && !step2Form.findField('imageFileList').isValue()) {
step2Form.findField('imageFileList').focus();
return false;
}
} else {
if (bManualPath && !manualPathTreeCombo.isValid()) {
manualPathTreeCombo.focus();
return false;
}
}
return true;
}
});
var strWord = 'WIZ_SHARED_STR_05';
var privilegeStr0 = 'ISCSI_TARGET_LUN_STATUS_0';
var step2Adv = new QNAP.QOS.wizard.formPanel({
cls: 'panel-border-bottom',
style: 'padding: 6px 0 15px;',
tbar: [{
xtype: 'displayfield',
value: _S.MISC_SCH_NEW_STR82,
qInternational: true,
qInternationalKey: {
value: 'MISC_SCH_NEW_STR82'
},
cls: 'title-bar-style'
}, {
xtype: 'tbfill'
}, {
xtype: 'button',
id: ids.btnSharedFolderAdvSet,
text: _S.IEI_NAS_BUTTON_CLOSE,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_CLOSE',
cls: 'qts-button q-default btn-blue',
handler: function (cmp) {
var btnText;
var guest_group = step2AdvForm.findField('guest_group');
/* var lbl_List = step2AdvForm.findField('lbl_List'); */
var cmpArea = step2Adv.getComponent('cmpArea');
var lbl_area = step2Adv.getComponent('lbl_area');
var vis = cmpArea.isVisible();
lbl_area.setVisible(vis);
if (vis) {
btnText = 'NIC_WEB_BTN_EDIT';
/* switch (guest_group.getValue().inputValue) {
case 'rd_only':
privilegeStr0 = 'WIZ_ONEPAGE_RO';
break;
case 'full':
privilegeStr0 = 'WIZ_ONEPAGE_RW';
break;
default:
privilegeStr0 = 'WIZ_ONEPAGE_NO';
break;
}
lbl_List.setValue(String.format(_S[strWord], _S[privilegeStr0]));
lbl_List.qInternational = true;
lbl_List.qInternationalFn = function (cmp) {
cmp.setValue(String.format(_S[strWord], _S[privilegeStr0]));
} */
cmpArea.getEl().slideOut('t', {
easing: 'easeOut',
duration: .5,
remove: false,
useDisplay: false,
callback: function () {
setForm2Adv(false);
cmpArea.setVisible(!vis);
cmpArea.doLayout();
}
});
} else {
btnText = 'IEI_NAS_BUTTON_CLOSE';
setForm2Adv(true);
cmpArea.setVisible(!vis);
cmpArea.getEl().slideIn('t', {
easing: 'easeOut',
duration: .5,
callback: function () {
cmpArea.doLayout();
}
});
}
cmp[ !vis ? 'addClass' : 'removeClass']('btn-blue');
cmp.setText(_S[btnText]);
cmp.qInternationalKey = btnText;
}
}],
items: [{
xtype: 'container',
itemId: 'lbl_area',
style: 'font-size:12px;',
hidden: true,
items: [{
xtype: 'displayfield',
name: 'lbl_List',
/* value: String.format(_S[strWord], _S[privilegeStr0]),
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(String.format(_S[strWord], _S[privilegeStr0]));
}, */
value: _S.WIZ_SHARED_STR_06,
qInternational: true,
qInternationalKey: {value: 'WIZ_SHARED_STR_06'},
cls: 'detial-txt-style',
}]
}, {
xtype: 'container',
itemId: 'cmpArea',
layout: 'form',
labelWidth: 200,
layout: 'form',
border: false,
style: 'font-size:12px;',
items: [{
xtype: 'combo',
itemId: 'guest_group',
name: 'guest',
fieldLabel: _S.IEI_NAS_SHARE36 + '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;top:-2px;" ext:qtip="' + _S.WIZ_SHARED_STR_07 + '"/>',
labelSeparator: '',
width: 300,
store: new Ext.data.ArrayStore({
fields: ['listName', 'listValue', 'qInternationalKey'],
data: [
[_S.USER_CREATE_WIZ_STR20, 'deny','USER_CREATE_WIZ_STR20'],
[_S.IEI_NAS_SHARE13, 'rd_only','IEI_NAS_SHARE13'],
[_S.USER_SHARE_STR05, 'full', 'USER_SHARE_STR05']
]
}),
qInternational: true,
qInternationalFn: function (cmp) {
var v = cmp.getValue();
cmp.getStore().each(function (r) {
r.data.listName = _S[r.data.qInternationalKey] || r.data.qInternationalKey;
r.afterEdit();
});
cmp.setValue(v);
cmp.label.update(_S.IEI_NAS_SHARE36 + '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;top:-2px;" ext:qtip="' + _S.WIZ_SHARED_STR_07 + '"/>');
},
value: 'deny',
displayField: 'listName',
valueField: 'listValue',
mode: 'local',
editable: false,
allowBlank: false,
enabled: false,
hidden: true,
triggerAction: 'all'
}, {
xtype: 'qtscheckbox',
itemId: 'media_group',
name: 'media',
boxLabel: _S.MEDIA_LIB_STR_15,
qInternational: true,
qInternationalKey: 'MEDIA_LIB_STR_15',
hidden: true,
hideLabel: true
}, {
xtype: 'qtscheckbox',
itemId: 'hidden_group',
boxLabel: _S.IEI_NAS_SHARE77 + ' <img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;top:-2px;" ext:qtip=\'' + _S.USER_CREATE_WIZ_STR48 + '\'/>',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.wrap.child('.x-form-cb-label').update(_S.IEI_NAS_SHARE77 + ' <img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;top:-2px;" ext:qtip=\'' + _S.USER_CREATE_WIZ_STR48 + '\'/>');
},
hidden: true,
hideLabel: true
}, {
layout: 'column',
itemId: 'quotaRadioDiv2u',
border: false,
hidden: true,
cls: 'x-form-item',
items: [{
xtype: 'qtscheckbox',
itemId: 'quotaRadio_group',
name: 'quotaRadio',
boxLabel: _S.USER_CREATE_WIZ_STR26,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR26',
hidden: true,
hideLabel: true,
handler: function (checkbox, checked) {
var imageFileList = step2Form.findField('imageFileList'),
quotaSettings = step2AdvForm.findField('quotaSettings');
if (checked) {
is_imageShare = 1;
imageFileList.show();
manualPathTreeCombo.hide();
var path_type_auto = step2Form.findField('path_type_group').getValue().inputValue == 'auto';
imageFileList.setDisabled(path_type_auto);
quotaSettings.setDisabled(!path_type_auto);
if (quotaSettings.getValue() == 0) quotaSettings.setValue(1);
} else {
is_imageShare = 0;
manualPathTreeCombo.show();
imageFileList.hide();
quotaSettings.disable();
}
quotaSettings.validate();
}
}, {
xtype: 'container',
width: 11,
height: 11
}, {
xtype: 'numberfield',
itemId: 'quotaSettings',
name: 'quotaSettings',
maxLength: 5,
width: 60,
disabled: true,
allowDecimals: false,
validator: function (v) {
var maxsize = 2000;
var disks_list_shareFolder = step2Form.findField('disks_list_shareFolder');
var fstype = disks_list_shareFolder.findRecord(disks_list_shareFolder.valueField, disks_list_shareFolder.getValue()).data.fstype;
if (fstype == '104') maxsize = 16000;
if (v == '') return _S.FTP_STR41;
if (parseInt(v) < 1 || parseInt(v) > maxsize) return _S.USER_SHARE_ALERT03;
return true;
}
}, {
xtype: 'displayfield',
value: '&nbsp;GB' + '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;top:-2px;" ext:qtip="' + _S.USER_SHARE_STR30 + '"/>',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('&nbsp;GB' + '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;top:-2px;" ext:qtip="' + _S.USER_SHARE_STR30 + '"/>');
},
style: 'padding:3px 6px 0 0;'
}]
}, {
xtype: 'qtscheckbox',
itemId: 'oplocks_group',
name: 'oplocks',
boxLabel: _S.IEI_NAS_SHARE79,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE79',
checked: true,
hidden: true,
hideLabel: true
}, {
xtype: 'qtscheckbox',
itemId: 'encryptData_group',
name: 'encryptData',
boxLabel: _S.DC_ENCRYPTDATA_STR01
+ '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;top:-2px;" ext:qtip="'
+ _S.DC_ENCRYPTDATA_STR02 + '"/>',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.wrap.child('.x-form-cb-label').update( _S.DC_ENCRYPTDATA_STR01
+ '<img src="apps/systemPreferences/images/icon_help2.gif" style="vertical-align:middle;position:relative;left:5px;top:-2px;" ext:qtip="'
+ _S.DC_ENCRYPTDATA_STR02 + '"/>');
},
hidden: true,
hideLabel: true,
handler: function(_cmp) {
function AlertForBadPerformance() {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
var alertWin = fn.winAlert(app, target, '', 'info', function () {
if (alertWin.stopAskMe.getValue()) {
QNAP.lib.cookie.set('Is_Samba_SMB_Encryption_Bad_Performance_' + QNAP.QOS.user.account, 1, 864000, '/');
}
}, target != '' ? target : null, '', {
items: [{
xtype: 'box',
html: _S.DC_ENCRYPTDATA_STR03,
qInternational: true,
qInternationalKey: 'DC_ENCRYPTDATA_STR03',
hideLabel: true
}, {
xtype: 'displayfield',
value: '&nbsp;',
height: 10
}, {
xtype: 'qtscheckbox',
ref: '../stopAskMe',
boxLabel: _S.IEI_NAS_CONFIRM18,
qInternational: true,
qInternationalKey: 'IEI_NAS_CONFIRM18'
}]
});
}
function checkBadPerformance() {
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'disk/smb4.cgi', {
func: 'get_hardware_support'
}),
method: 'POST',
success: function(response, opts) {
var xmlData = response.responseXML;
if (xmlData && Ext.DomQuery.selectValue('BadEncrypt', xmlData) == '1') {
AlertForBadPerformance();
}
},
failure: function() {}
});
}
if (_cmp.getValue()) {
if (QNAP.lib.cookie.get('Is_Samba_SMB_Encryption_Bad_Performance_' + QNAP.QOS.user.account) != '1') {
checkBadPerformance();
}
}
}
}, {
xtype: 'qtscheckbox',
itemId: 'recycle_bin_group',
name: 'recycle_bin',
boxLabel: _S.MISC_RECYCLE_BIN_STR02,
qInternational: true,
qInternationalKey: 'MISC_RECYCLE_BIN_STR02',
checked: true,
hideLabel: true,
hidden: true,
handler: function (checkbox, checked) {
step2AdvForm.findField('recycle_bin_admin').setDisabled(!checked);
}
}, {
xtype: 'qtscheckbox',
itemId: 'recycle_bin_admin',
boxLabel: _S.RECYCLE_BIN_STRING_01,
qInternational: true,
qInternationalKey: 'RECYCLE_BIN_STRING_01',
disabled: true,
hidden: true,
style: QNAP.layout.getDefaultCSS({
indent: 1
}),
hideLabel: true
},{
xtype: 'qtscheckbox',
itemId: 'qsync_share_folder_sync',
name: 'share_folder_sync',
boxLabel: _S.QSYNC_SHARED_FOLDER_SYNC_STR03,
qInternational: true,
qInternationalKey: 'QSYNC_SHARED_FOLDER_SYNC_STR03',
checked: false,
hideLabel: true,
hidden: false,
handler: function (checkbox, checked) {
}
}]
}]
});

/* var step3 = new QNAP.QOS.wizard.formPanel({
cls: 'panel-border-bottom',
style: 'padding: 6px 0 15px;',
tbar: [{
xtype: 'displayfield',
value: 'Set access privilege to guest user',
cls: 'title-bar-style'
}, {
xtype: 'tbfill'
}, {
xtype: 'button',
cls: 'none-bg-btn edit-style',
itemCls: 'edit-style',
handler: function (cmp) {
var lbl_area = step3.getComponent('lbl_area');
var guest_group = step3Form.findField('guest_group');
var lbl_List = step3Form.findField('lbl_List');
var vis = guest_group.isVisible();
lbl_area.setVisible(vis);
if (vis) {
switch (guest_group.getValue().inputValue) {
case 'rd_only':
privilegeStr0 = 'WIZ_ONEPAGE_RO';
break;
case 'full':
privilegeStr0 = 'WIZ_ONEPAGE_RW';
break;
default:
privilegeStr0 = 'WIZ_ONEPAGE_NO';
break;
}
lbl_List.setValue(String.format(_S[strWord], _S[privilegeStr0]));
lbl_List.qInternational = true;
lbl_List.qInternationalFn = function (cmp) {
cmp.setValue(String.format(_S[strWord], _S[privilegeStr0]));
}
guest_group.getEl().slideOut('t', {
easing: 'easeOut',
duration: .2,
remove: false,
useDisplay: false,
callback: function () {
guest_group.setVisible(!vis);
guest_group.doLayout();
}
});
} else {
guest_group.setVisible(!vis);
guest_group.getEl().slideIn('t', {
easing: 'easeOut',
duration: .2,
callback: function () {
guest_group.doLayout();
}
});
}
}
}],
items: [{
xtype: 'container',
itemId: 'lbl_area',
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
name: 'lbl_List',
value: String.format(_S[strWord], _S[privilegeStr0]),
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(String.format(_S[strWord], _S[privilegeStr0]));
},
cls: 'detial-txt-style',
}]
}, {
xtype: 'radiogroup',
itemId: 'guest_group',
columns: 3,
hideLabel: true,
hidden: true,
items: [{
boxLabel: _S.USER_CREATE_WIZ_STR20,
qInternational: true,
qInternationalKey: 'USER_CREATE_WIZ_STR20',
hideLabel: true,
name: 'guest',
inputValue: 'deny',
checked: true
}, {
boxLabel: _S.IEI_NAS_SHARE13,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE13',
hideLabel: true,
name: 'guest',
inputValue: 'rd_only'
}, {
boxLabel: _S.USER_SHARE_STR05,
qInternational: true,
qInternationalKey: 'USER_SHARE_STR05',
hideLabel: true,
name: 'guest',
inputValue: 'full'
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}]
}); */

var params = { wiz_func: "share_access_control", getdata: 1, shareName: ''};
var url = 'priv/privWizard.cgi'
if( QNAP.QOS.config.ha_enabled ){
url = QNAP.QOS.config.ha_CGI_FILENAME
params.ha_action = 'privWizard';
params.ha_cluster = me.app.HASelector;
}
var accessUserStore = new Ext.data.Store({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + url, params),
remoteSort: true,
method: 'POST',
baseParams: {
filter: '',
type: 0,
lower: 0,
upper: 10
},
defaultParamNames: {
limit: 'upper',
start: 'lower'
},
reader: new Ext.data.XmlReader({
root: 'data',
totalProperty: 'userroot > count',
record: 'user'
}, [{
name: 'username',
mapping: 'username'
}, {
name: 'access_rd',
mapping: 'access_rd'
}, {
name: 'access_rw',
mapping: 'access_rw'
}, {
name: 'access_no',
mapping: 'access_no'
}, {
name: 'now',
mapping: 'now'
}, {
name: 'priv',
mapping: 'preview'
}]),
listeners: {
beforeload: function (store, o) {
o.params.lower = o.params.lower || 0;
Ext.apply(o.params, {
upper: o.params.lower + 10,
filter: uSearch.field ? uSearch.field.getValue() : '',
type: 0
});
store.each(function (record) {
Ext.each(accessUserArray, function (data) {
if (data.username == record.data.username) {
data.access_rd = record.data.access_rd;
data.access_rw = record.data.access_rw;
data.access_no = record.data.access_no;
}
});
});
},
load: function (store) {
store.each(function (record, index) {
var chkValue = false;
record.data.priv = fn.chgStatuE2N(record.data.priv || 'N');
Ext.each(accessUserArray, function (data) {
if (data.username == record.data.username) {
record.data.access_rd = data.access_rd == true;
record.data.access_rw = data.access_rw == true;
record.data.access_no = data.access_no == true;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
chkValue = true;
store.data.items[index].afterEdit();
}
});
if (!chkValue) {
var o = {};
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
accessUserArray.push({
username: record.data.username,
access_rd: record.data.access_rd,
access_rw: record.data.access_rw,
access_no: record.data.access_no
});
store.data.items[index].afterEdit();
}
});
delete store.reader.xmlData;
}
}
});

var access_rd = new Ext.grid.CheckColumn({
header: '<div class="check_column_header" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div class="check_column_header" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>';
},
width: 30,
dataIndex: "access_rd"
});
var access_rw = new Ext.grid.CheckColumn({
header: '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>';
},
width: 30,
dataIndex: "access_rw"
});
var access_no = new Ext.grid.CheckColumn({
header: '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>';
},
width: 30,
dataIndex: "access_no"
});
var uSearch = new Ext.ux.grid.wizSearch({
mode: 'remote',
idFilter: 'user_wizard_filter',
iconCls: false,
readonlyIndexes: ['access_no'],
minChars: 1,
autoFocus: true
});
var accessUserGrid = new Ext.grid.GridPanel({
store: accessUserStore,
enableHdMenu: false,
enableColumnMove: false,
autoExpandColumn: "username",
height: Ext.isDefined(runFinish) ? runFinish.gridHeight : 346,
qInternational: true,
colModel: new Ext.grid.ColumnModel({
qInternational: true,
defaults: {
qInternational: true
},
columns: [{
header: _S.QNAP_PS_USER_NAME,
qInternationalKey: 'QNAP_PS_USER_NAME',
sortable: false,
dataIndex: 'username',
value2Tip: true
}, {
header: _S.QTS_MSG_4,
qInternationalKey: 'QTS_MSG_4',
dataIndex: 'now',
renderer: function (data, metadata, record, rowIndex, columnIndex, store) {
var tip = fn.chgStatuStr(data);
if (tip == 'USER_CREATE_WIZ_STR20' && !record.data.access_no) tip = 'USER_CREATE_WIZ_STR20_1';
tip = _S[tip] || tip;
metadata.attr = 'ext:qtip="' + tip + '" style="color:' + fn.getPreviewColor(data) + '"';
return tip;
}
},
access_rd, access_rw, access_no]
}),
viewConfig: {
forceFit: true,
scrollOffset: 0
},
columnLines: true,
buttonAlign: 'left',
frame: true,
tbar: [{
xtype: 'tbfill'
}],
bbar: new Ext.wizardPagingToolbar({
pageSize: 10,
store: accessUserStore,
displayInfo: true
}),
plugins: [
uSearch, access_rd, access_rw, access_no],
listeners: {
headerclick: function (grid, columnIndex, e) {
switch (columnIndex) {
case 2:
if (!me.wiz_u_access_rdCheck) {
me.wiz_u_access_rdCheck = true;
me.wiz_u_access_rwCheck = false;
me.wiz_u_access_noCheck = false;
} else {
me.wiz_u_access_rdCheck = false;
}
Ext.each(accessUserArray, function (data) {
grid.store.each(function (record) {
if (data.username == record.data.username) {
data.access_rd = record.data.access_rd = me.wiz_u_access_rdCheck;
if (me.wiz_u_access_rdCheck) data.access_rw = record.data.access_rw = false;
if (me.wiz_u_access_rdCheck) data.access_no = record.data.access_no = false;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
record.afterEdit();
}
});
});
break;
case 3:
if (!me.wiz_u_access_rwCheck) {
me.wiz_u_access_rdCheck = false;
me.wiz_u_access_rwCheck = true;
me.wiz_u_access_noCheck = false;
} else {
me.wiz_u_access_rwCheck = false;
}
Ext.each(accessUserArray, function (data) {
grid.store.each(function (record) {
if (data.username == record.data.username) {
if (me.wiz_u_access_rwCheck) data.access_rd = record.data.access_rd = false;
data.access_rw = record.data.access_rw = me.wiz_u_access_rwCheck;
if (me.wiz_u_access_rwCheck) data.access_no = record.data.access_no = false;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
record.afterEdit();
}
});
});
break;
case 4:
if (!me.wiz_u_access_noCheck) {
me.wiz_u_access_rdCheck = false;
me.wiz_u_access_rwCheck = false;
me.wiz_u_access_noCheck = true;
} else {
me.wiz_u_access_noCheck = false;
}
Ext.each(accessUserArray, function (data) {
grid.store.each(function (record) {
if (data.username == record.data.username) {
if (me.wiz_u_access_noCheck) data.access_rd = record.data.access_rd = false;
if (me.wiz_u_access_noCheck) data.access_rw = record.data.access_rw = false;
data.access_no = record.data.access_no = me.wiz_u_access_noCheck;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
record.afterEdit();
}
});
});
break;
}
},
afteredit: function (e) {
switch (e.field) {
case 'access_rd':
e.record.data.access_rw = false;
e.record.data.access_no = false;
break;
case 'access_rw':
e.record.data.access_rd = false;
e.record.data.access_no = false;
break;
case 'access_no':
e.record.data.access_rd = false;
e.record.data.access_rw = false;
break;
}
e.record.data.now = fn.compareNumber(e.record.data.priv || 0, fn.chkAccessRWI(e.record));
e.grid.store.data.items[e.row].afterEdit();
Ext.each(accessUserArray, function (data) {
if (data.username == e.record.data.username) {
data.access_rd = e.record.data.access_rd;
data.access_rw = e.record.data.access_rw;
data.access_no = e.record.data.access_no;
}
});
e.record.commit();
}
}
});

me.wiz_u_access_rdCheck = false;
me.wiz_u_access_rwCheck = false;
me.wiz_u_access_noCheck = false;

function fillDataList(ary, style) {
var count = 0,
everyone_group_rw = 0,
all_list = '',
tmp_array = [];
Ext.each(ary, function (data) {
if (data.access_rd || data.access_rw || data.access_no) {
tmp_array.push(data[style ? 'groupname' : 'username']);
}
});

if (style) {
if (projectlName == 'Athens') {
Ext.each(ary, function (data) {
if (data.groupname == 'everyone' && data.access_rw) everyone_group_rw = 1;
});
}
}

for (var i = 0; i < tmp_array.length; i++) {
if (i > 0) all_list += ', ';
all_list += tmp_array[i];
if (i > 4) {
all_list += ' ...';
all_list = '<div ext:qtip="' + tmp_array.join(', ') + '">' + all_list + '</div>';
break;
}
}
if (all_list == '') all_list = '---';
if (style == 0) return all_list;
}

/* var accessGroupStore = new Ext.data.Store({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'priv/privWizard.cgi', {
wiz_func: "share_access_control"
}, {
getdata: 1,
shareName: ''
}),
remoteSort: true,
method: 'POST',
baseParams: {
filter: '',
type: 2,
lower: 0,
upper: 10
},
defaultParamNames: {
limit: 'upper',
start: 'lower'
},
reader: new Ext.data.XmlReader({
root: 'data',
totalProperty: 'grouproot > count',
record: 'group'
}, [{
name: 'groupname',
mapping: 'groupname'
}, {
name: 'access_rd',
mapping: 'access_rd'
}, {
name: 'access_rw',
mapping: 'access_rw'
}, {
name: 'access_no',
mapping: 'access_no'
}, {
name: 'now',
mapping: 'now'
}, {
name: 'priv',
mapping: 'preview'
}]),
listeners: {
beforeload: function (store, o) {
o.params.lower = o.params.lower || 0;
Ext.apply(o.params, {
upper: o.params.lower + 10,
filter: gSearch.field ? gSearch.field.getValue() : '',
type: 2
});
store.each(function (record) {
for (var i = 0; i < accessGroupArray.length; i++) {
if (accessGroupArray[i].groupname == record.data.groupname) {
accessGroupArray[i].access_rd = record.data.access_rd;
accessGroupArray[i].access_rw = record.data.access_rw;
accessGroupArray[i].access_no = record.data.access_no;
continue;
}
}
});
},
load: function (store) {
var xmlData = store.reader.xmlData;
projectlName = Ext.DomQuery.selectValue('projectlName', xmlData) || '';
store.each(function (record, index) {
var chkValue = false;
record.data.priv = fn.chgStatuE2N(record.data.priv || 'N');
for (var i = 0; i < accessGroupArray.length; i++) {
if (accessGroupArray[i].groupname == record.data.groupname) {
record.data.access_rd = accessGroupArray[i].access_rd;
record.data.access_rw = accessGroupArray[i].access_rw;
record.data.access_no = accessGroupArray[i].access_no;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
chkValue = true;
store.data.items[index].afterEdit();
continue;
}
}
if (!chkValue) {
var o = {};
o.groupname = record.data.groupname;
o.access_rd = record.data.access_rd;
o.access_rw = record.data.access_rw;
o.access_no = record.data.access_no;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
accessGroupArray.push(o);
store.data.items[index].afterEdit();
}
});
delete store.reader.xmlData;
}
}
});
var access_rd = new Ext.grid.CheckColumn({
header: '<div class="check_column_header" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div class="check_column_header" ext:qtip="' + _S.IEI_DEVICE_MSG62 + '">RO</div>';
},
width: 30,
dataIndex: "access_rd"
});
var access_rw = new Ext.grid.CheckColumn({
header: '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR30 + '">RW</div>';
},
width: 30,
dataIndex: "access_rw"
});
var access_no = new Ext.grid.CheckColumn({
header: '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>',
qInternationalFn: function (cmp) {
cmp.header = '<div class="check_column_header" ext:qtip="' + _S.USER_CREATE_WIZ_STR20 + '">Deny</div>';
},
width: 30,
dataIndex: "access_no"
});
var gSearch = new Ext.ux.grid.wizSearch({
mode: 'remote',
idFilter: 'group_wizard_filter',
iconCls: false,
readonlyIndexes: ['groupname'],
minChars: 1,
autoFocus: true
});
var accessGroupGrid = new Ext.grid.GridPanel({
store: accessGroupStore,
enableHdMenu: false,
enableColumnMove: false,
disableSelection: true,
trackMouseOver: false,
autoExpandColumn: "groupname",
height: Ext.isDefined(runFinish) ? runFinish.gridHeight : 346,
qInternational: true,
colModel: new Ext.grid.ColumnModel({
qInternational: true,
defaults: {
qInternational: true,
sortable: false
},
columns: [{
header: _S.USER_GROUP_GREATE_WIZ_STR19,
qInternationalKey: 'USER_GROUP_GREATE_WIZ_STR19',
dataIndex: 'groupname',
value2Tip: true
}, {
header: _S.QTS_MSG_4,
qInternationalKey: 'QTS_MSG_4',
dataIndex: 'now',
renderer: function (data, metadata, record, rowIndex, columnIndex, store) {
var color = fn.getPreviewColor(data);
var tip = fn.chgStatuStr(data);
tip = _S[tip] || tip;
metadata.attr = 'ext:qtip="' + tip + '" style="color:' + color + '"';
return tip;
}
},
access_rd, access_rw, access_no]
}),
viewConfig: {
forceFit: true,
scrollOffset: 0
},
columnLines: true,
buttonAlign: 'left',
frame: true,
tbar: [{
xtype: 'tbfill'
}],
bbar: new Ext.wizardPagingToolbar({
pageSize: 10,
store: accessGroupStore,
displayInfo: true
}),
plugins: [
gSearch, access_rd, access_rw, access_no],
listeners: {
headerclick: function (grid, columnIndex, e) {
var ary = accessGroupArray;
switch (columnIndex) {
case 2:
if (!me.wiz_g_access_rdCheck) {
me.wiz_g_access_rdCheck = true;
me.wiz_g_access_rwCheck = false;
me.wiz_g_access_noCheck = false;
} else {
me.wiz_g_access_rdCheck = false;
}
for (var i = 0; i < ary.length; i++) {
grid.store.each(function (record) {
if (ary[i].groupname == record.data.groupname) {
ary[i].access_rd = record.data.access_rd = me.wiz_g_access_rdCheck;
if (me.wiz_g_access_rdCheck) ary[i].access_rw = record.data.access_rw = false;
if (me.wiz_g_access_rdCheck) ary[i].access_no = record.data.access_no = false;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
record.afterEdit();
}
});
}
break;
case 3:
if (!me.wiz_g_access_rwCheck) {
me.wiz_g_access_rdCheck = false;
me.wiz_g_access_rwCheck = true;
me.wiz_g_access_noCheck = false;
} else {
me.wiz_g_access_rwCheck = false;
}
for (var i = 0; i < ary.length; i++) {
grid.store.each(function (record) {
if (ary[i].groupname == record.data.groupname) {
if (me.wiz_g_access_rwCheck) ary[i].access_rd = record.data.access_rd = false;
ary[i].access_rw = record.data.access_rw = me.wiz_g_access_rwCheck;
if (me.wiz_g_access_rwCheck) ary[i].access_no = record.data.access_no = false;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
record.afterEdit();
}
});
}
break;
case 4:
if (me.wiz_u_access_noCheck == false) {
me.wiz_g_access_rdCheck = false;
me.wiz_g_access_rwCheck = false;
me.wiz_u_access_noCheck = true;
} else {
me.wiz_u_access_noCheck = false;
}
for (var i = 0; i < ary.length; i++) {
grid.store.each(function (record) {
if (ary[i].groupname == record.data.groupname) {
if (me.wiz_u_access_noCheck) ary[i].access_rd = record.data.access_rd = false;
if (me.wiz_u_access_noCheck) ary[i].access_rw = record.data.access_rw = false;
ary[i].access_no = record.data.access_no = me.wiz_u_access_noCheck;
record.data.now = fn.compareNumber(record.data.priv || 0, fn.chkAccessRWI(record));
record.afterEdit();
}
});
}
break;
}
},
afteredit: function (e) {
switch (e.field) {
case 'access_rd':
e.record.data.access_rw = false;
e.record.data.access_no = false;
break;
case 'access_rw':
e.record.data.access_rd = false;
e.record.data.access_no = false;
break;
case 'access_no':
e.record.data.access_rd = false;
e.record.data.access_rw = false;
break;
}
e.record.data.now = fn.compareNumber(e.record.data.priv || 0, fn.chkAccessRWI(e.record));
e.grid.store.data.items[e.row].afterEdit();
Ext.each(accessGroupArray, function (data) {
if (data.groupname == e.record.data.groupname) {
data.access_rd = e.record.data.access_rd;
data.access_rw = e.record.data.access_rw;
data.access_no = e.record.data.access_no;
}
});
e.record.commit();
}
}
});
var menuSelValue = '',
menuStatus = false; */
var menuSelValue = 'user',
menuStatus = false;
var noAdminStr = 'WIZ_SHARED_STR_04';
var step4 = new QNAP.QOS.wizard.formPanel({
cls: 'panel-border-bottom',
style: 'padding: 6px 0 15px;',
items: [{
xtype: 'displayfield',
name: 'lbl_List',
value: _S[noAdminStr],
qInternational: true,
qInternationalKey: {value: noAdminStr},
cls: 'detial-txt-style',
hideLabel: true
}, {
xtype: 'container',
itemId: 'lbl_area',
hidden: true,
items: [{
xtype: 'container',
layout: 'column',
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
cls: 'icon-read-only',
style: 'margin-top:5px'
}, {
xtype: 'displayfield',
value: _S.USER_CREATE_WIZ_STR28,
qInternational: true,
qInternationalKey: {value: 'USER_CREATE_WIZ_STR28'},
style: 'padding-right:11px;'
}, {
xtype: 'displayfield',
name: 'lbl_roList',
cls: 'detial-txt-style',
value: '--'
}]
}, {
xtype: 'container',
layout: 'column',
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
cls: 'icon-read-write',
style: 'margin-top:5px'
}, {
xtype: 'displayfield',
value: _S.USER_CREATE_WIZ_STR31,
qInternational: true,
qInternationalKey: {value: 'USER_CREATE_WIZ_STR31'},
style: 'padding-right:11px;'
}, {
xtype: 'displayfield',
name: 'lbl_rwList',
cls: 'detial-txt-style',
value: '--'
}]
}, {
xtype: 'container',
layout: 'column',
itemId: 'no',
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
cls: 'icon-no-access',
style: 'margin-top:5px'
}, {
xtype: 'displayfield',
value: _S.USER_CREATE_WIZ_STR33,
qInternational: true,
qInternationalKey: {value: 'USER_CREATE_WIZ_STR33'},
style: 'padding-right:11px;'
}, {
xtype: 'displayfield',
name: 'lbl_noList',
cls: 'detial-txt-style',
value: '--'
}]
}]
}, {
xtype: 'panel',
itemId: 'gridArea',
border: false,
items: [accessUserGrid
/* , accessGroupGrid */
]
}],
tbar: [{
xtype: 'displayfield',
value: _S.WIZ_SHARED_STR_08,
qInternational: true,
qInternationalKey: {value: 'WIZ_SHARED_STR_08'},
cls: 'title-bar-style'
}, {
xtype: 'tbfill'
}, {
xtype: 'button',
id: ids.btnSharedFolderPriv,
text: _S.NIC_WEB_BTN_EDIT,
qInternational: true,
qInternationalKey: 'NIC_WEB_BTN_EDIT',
cls: 'qts-button q-default',
/* menu: new Ext.menu.Menu({
cls: 'edit-style-menu-item',
iconCls: 'no-icon',
items: [{
text: _S.IEI_NAS_SHARE12,
qInternational: true,
qInternationalKey: 'IEI_NAS_SHARE12',
iconCls: 'no-icon',
handler: function () {
if (!menuStatus) {
var btnText = 'IEI_NAS_BUTTON_CLOSE';
Ext.getCmp(ids.btnSharedFolderPriv).setText(_S[btnText]);
Ext.getCmp(ids.btnSharedFolderPriv).qInternationalKey = btnText;
menuStatus = true;
menuSelValue = 'user';
var lbl_List = step4Form.findField('lbl_List');
var lbl_area = step4.getComponent('lbl_area');
var gridArea = step4.getComponent('gridArea');
var vis = gridArea.isVisible();
lbl_List.setVisible(vis);
lbl_area.setVisible(vis);
accessUserGrid.show();
accessGroupGrid.hide();
if (!vis) {
gridArea.setVisible(!vis);
gridArea.getEl().slideIn('t', {
easing: 'easeOut',
duration: .5,
callback: function () {
gridArea.doLayout();
}
});
}
}
}
}, {
text: _S.USER_MANAGEMENT_STR01,
qInternational: true,
qInternationalKey: 'USER_MANAGEMENT_STR01',
iconCls: 'no-icon',
handler: function () {
if (!menuStatus) {
var btnText = 'IEI_NAS_BUTTON_CLOSE';
Ext.getCmp(ids.btnSharedFolderPriv).setText(_S[btnText]);
Ext.getCmp(ids.btnSharedFolderPriv).qInternationalKey = btnText;
menuStatus = true;
menuSelValue = 'group';
var lbl_List = step4Form.findField('lbl_List');
var lbl_area = step4.getComponent('lbl_area');
var gridArea = step4.getComponent('gridArea');
var vis = gridArea.isVisible();
lbl_List.setVisible(vis);
lbl_area.setVisible(vis);
accessUserGrid.hide();
accessGroupGrid.show();
if (!vis) {
gridArea.setVisible(!vis);
gridArea.getEl().slideIn('t', {
easing: 'easeOut',
duration: .5,
callback: function () {
gridArea.doLayout();
}
});
}
}
}
}]
}), */
handler: function (cmp) {
var btnText;
if (menuStatus) {
menuStatus = false;
/* cmp.menu.hide(); */
var lbl_List = step4Form.findField('lbl_List');
var lbl_area = step4.getComponent('lbl_area');
var gridArea = step4.getComponent('gridArea');
step4.procList();
gridArea.getEl().slideOut('t', {
easing: 'easeOut',
duration: .5,
remove: false,
useDisplay: false,
callback: function () {
accessUserGrid.hide();
/* accessGroupGrid.hide(); */
gridArea.hide();
gridArea.doLayout();
}
});
/* var btnText = 'NIC_WEB_BTN_EDIT';
cmp.setText(_S[btnText]);
cmp.qInternationalKey = btnText; */
btnText = 'NIC_WEB_BTN_EDIT';
} else {
menuStatus = true;
menuSelValue = 'user';
var lbl_List = step4Form.findField('lbl_List');
var lbl_area = step4.getComponent('lbl_area');
var gridArea = step4.getComponent('gridArea');
var vis = gridArea.isVisible();
lbl_List.setVisible(vis);
lbl_area.setVisible(vis);
accessUserGrid.show();
/* accessGroupGrid.hide(); */
if (!vis) {
gridArea.setVisible(!vis);
gridArea.getEl().slideIn('t', {
easing: 'easeOut',
duration: .5,
callback: function () {
gridArea.doLayout();
}
});
}
btnText = 'IEI_NAS_BUTTON_CLOSE';
}
cmp[ menuStatus ? 'addClass' : 'removeClass']('btn-blue');
cmp.setText(_S[btnText]);
cmp.qInternationalKey = btnText;
}
}],
procList: function () {
var limitNum = 3,
obj = {};
if (menuSelValue == 'user') {
obj = fn.procAry2StrLenRWO(accessUserArray, limitNum, 'username', {
r: 'access_rd',
w: 'access_rw',
o: 'access_no'
});
}
if (menuSelValue == 'group') {
obj = fn.procAry2StrLenRWO(accessGroupArray, limitNum, 'groupname', {
r: 'access_rd',
w: 'access_rw',
o: 'access_no'
});
}
var rtmpStr = '',
wtmpStr = '',
otmpStr = '';
if (obj.rtotal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, obj.rprocStr, obj.rtotal - obj.limit);
rtmpStr = '<div ext:qtip="' + obj.roldStr + '">' + tmp + '</div>';
} else {
rtmpStr = obj.rprocStr || '--';
}
step4Form.findField('lbl_roList').setValue(rtmpStr);
step4Form.findField('lbl_roList').objData = obj;
step4Form.findField('lbl_roList').qInternational = true;
step4Form.findField('lbl_roList').qInternationalFn = function (cmp) {
var value = '';
if (cmp.objData.rtotal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, cmp.objData.rprocStr, cmp.objData.rtotal - cmp.objData.limit);
value = '<div ext:qtip="' + cmp.objData.roldStr + '">' + tmp + '</div>';
} else {
value = cmp.objData.rprocStr || '--';
}
cmp.setValue(value);
};
if (obj.wtotal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, obj.wprocStr, obj.wtotal - obj.limit);
wtmpStr = '<div ext:qtip="' + obj.woldStr + '">' + tmp + '</div>';
} else {
wtmpStr = obj.wprocStr || '--';
}
step4Form.findField('lbl_rwList').setValue(wtmpStr);
step4Form.findField('lbl_rwList').objData = obj;
step4Form.findField('lbl_rwList').qInternational = true;
step4Form.findField('lbl_rwList').qInternationalFn = function (cmp) {
var value = '';
if (cmp.objData.wtotal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, cmp.objData.wprocStr, cmp.objData.wtotal - cmp.objData.limit);
value = '<div ext:qtip="' + cmp.objData.woldStr + '">' + tmp + '</div>';
} else {
value = cmp.objData.wprocStr || '--';
}
cmp.setValue(value);
};
if (obj.ototal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, obj.oprocStr, obj.ototal - obj.limit);
otmpStr = '<div ext:qtip="' + obj.ooldStr + '">' + tmp + '</div>';
} else {
otmpStr = obj.oprocStr || '--';
}
step4Form.findField('lbl_noList').setValue(otmpStr);
step4Form.findField('lbl_noList').objData = obj;
step4Form.findField('lbl_noList').qInternational = true;
step4Form.findField('lbl_noList').qInternationalFn = function (cmp) {
var value = '';
if (cmp.objData.ototal > limitNum) {
var tmp = String.format(_S.WIZ_ONEPAGE_OTHER_ETC, cmp.objData.oprocStr, cmp.objData.ototal - cmp.objData.limit);
value = '<div ext:qtip="' + cmp.objData.ooldStr + '">' + tmp + '</div>';
} else {
value = cmp.objData.oprocStr || '--';
}
cmp.setValue(value);
};
step4.getComponent('lbl_area').getComponent('no').setVisible(otmpStr !== '--');
var lbl_List = step4Form.findField('lbl_List');
var lbl_area = step4.getComponent('lbl_area');
var str, vis;
if (menuSelValue == 'user') {
vis = obj.rtotal == 0 && obj.wtotal == 1 && obj.wprocStr == 'admin' && obj.ototal == 0
str = noAdminStr;
}
lbl_List.setValue(_S[str]);
lbl_List.qInternational = !Ext.isEmpty(str);
lbl_List.setVisible(vis)
lbl_area.setVisible(!vis);
}
});

var step2Form = step2.getForm();
var step2AdvForm = step2Adv.getForm();
var cmpArea = step2Adv.getComponent('cmpArea');
var step4Form = step4.getForm();
var osupportImageShare = 'no';

if (folderEncryption) {
var folderEncryptionForm = new QNAP.QOS.wizard.formPanel({
itemId : 'folderEncryptionSetting',
cls    : 'panel-border-bottom',
style  : 'padding: 6px 0 15px;',
tbar   : [{
xtype             : 'displayfield',
value             : _S.FOLDER_ENCRYPTION_CREATE_CONFIRM_TITLE,
qInternational    : true,
qInternationalKey : {value: 'FOLDER_ENCRYPTION_CREATE_CONFIRM_TITLE'},
cls               : 'title-bar-style'
}, {
xtype : 'tbfill'
}, {
xtype             : 'button',
text              : _S.NIC_WEB_BTN_EDIT,
qInternational    : true,
qInternationalKey : 'NIC_WEB_BTN_EDIT',
cls               : 'qts-button q-default',
handler           : function (cmp) {
var encryptCheckbox = fdEncryForm.findField('folderEncryptionCheck');
var btnText;
var cmpArea = folderEncryptionForm.find('itemId', 'folderEncryptionCmpArea')[0];
var lbl_area = folderEncryptionForm.find('itemId', 'lbl_area')[0];
var encryptOn_area = folderEncryptionForm.find('itemId', 'encryptOn_area')[0];
var vis = cmpArea.isVisible();

if (encryptCheckbox.checked) {
lbl_area.setVisible(false);
folderEncryptionForm.folderEncryptOnNext(false);
encryptOn_area.setVisible(vis);
} else {
lbl_area.setVisible(vis);
encryptOn_area.setVisible(false);
}
if (vis) {
btnText = 'NIC_WEB_BTN_EDIT';
cmpArea.getEl().slideOut('t', {
easing     : 'easeOut',
duration   : .5,
remove     : false,
useDisplay : false,
callback   : function () {
cmpArea.setVisible(!vis);
cmpArea.doLayout();
}
});
} else {
btnText = 'IEI_NAS_BUTTON_CLOSE';
cmpArea.setVisible(!vis);
cmpArea.getEl().slideIn('t', {
easing   : 'easeOut',
duration : .5,
callback : function () {
cmpArea.doLayout();
}
});
}
cmp[ !vis ? 'addClass' : 'removeClass']('btn-blue');
cmp.setText(_S[btnText]);
cmp.qInternationalKey = btnText;
}
}],
folderEncryptOnNext : function (doCreate) {
var encryptCheckbox     = fdEncryForm.findField('folderEncryptionCheck');
var encryptPasswordText = fdEncryForm.findField('folderEncryptionPassword');
var encryptVerifyText   = fdEncryForm.findField('folderEncryptionVerify');
var encryptSaveCheckbox = fdEncryForm.findField('folderEncryptionSave');
var toolbarBtn          = folderEncryptionForm.topToolbar.items.items[2];
var encryptOn_area      = folderEncryptionForm.find('itemId', 'encryptOn_area')[0];
var encryptOn           = folderEncryptionForm.find('itemId', 'encryptOn')[0];
var ret                 = 0;
var invalidCmp          = [];

if (!encryptPasswordText.validate()) {
ret += 1;
invalidCmp.push(encryptPasswordText);
}
if (!encryptVerifyText.validate()) {
ret += 2;
invalidCmp.push(encryptVerifyText);
}

if (!doCreate) {
if (ret == 0) {
encryptOn.setValue(passIcon);
} else {
encryptOn.setValue(failIcon);
}
return;
}

if (ret != 0) {
var btnText;
var cmpArea  = folderEncryptionForm.find('itemId', 'folderEncryptionCmpArea')[0];
var lbl_area = folderEncryptionForm.find('itemId', 'lbl_area')[0];
var vis      = cmpArea.isVisible();
if (!vis) {
lbl_area.setVisible(false);
encryptOn_area.setVisible(vis);
btnText = 'IEI_NAS_BUTTON_CLOSE';
cmpArea.setVisible(!vis);
cmpArea.getEl().slideIn('t', {
easing   : 'easeOut',
duration : .5,
callback : function () {
cmpArea.doLayout();
invalidCmp[0].focus();  // always focus on the first invalid component
}
});
toolbarBtn[ !vis ? 'addClass' : 'removeClass']('btn-blue');
toolbarBtn.setText(_S[btnText]);
toolbarBtn.qInternationalKey = btnText;
}
else {
invalidCmp[0].focus();
}

return false;
}
else {
return true;
}
},
items : [
{
xtype  : 'container',
itemId : 'lbl_area',
style  : 'font-size:12px;',
cls    : 'x-form-item',
items  : [{
xtype             : 'displayfield',
name              : 'lbl_List',
value             : _S.FOLDER_ENCRYPTION_CREATE_LABEL,
qInternational    : true,
qInternationalKey : {value: 'FOLDER_ENCRYPTION_CREATE_LABEL'},
cls               : 'detial-txt-style'
}]
}
,
{
xtype  : 'container',
itemId : 'encryptOn_area',
layout : 'column',
style  : 'font-size: 12px;',
cls    : 'x-form-item',
hidden : true,
items  : [{
xtype             : 'displayfield',
value             : _S.VPN_STR13,
qInternational    : true,
qInternationalKey : {value: 'VPN_STR13'},
style             : 'padding-right:11px;'
}, {
xtype  : 'displayfield',
itemId : 'encryptOn',
name   : 'encryptOn',
value  : passIcon
}]
}
,
{
xtype      : 'container',
itemId     : 'folderEncryptionCmpArea',
layout     : 'form',
labelWidth : 200,
border     : false,
cls        : 'x-form-item',
style      : 'font-size:12px;',
hidden     : true,
items      : [
{//Encryption
'xtype'             : 'panel'
,   'layout'            : 'column'
,   'border'            : false
,padding            : '0px 0px 6px 0px'
,   'items'             : [
{
xtype               : 'qtscheckbox',
ref                 : '../folderEncryptionCheck',
name                : 'folderEncryptionCheck',
hideLabel           : true,
boxLabel            : _S.IEI_NAS_WIRELESS_STR14,
qInternational      : true,
qInternationalFn    : function( cmp ){
cmp.wrap.child('.x-form-cb-label').update( _S.IEI_NAS_WIRELESS_STR14);
},
inputValue          : 'checkbox',
listeners           : {
check           : function (cmp, checked) {
var fdEncryCmpArea = folderEncryptionForm.find('itemId', 'folderEncryptionCmpArea')[0];

if(checked) {
fdEncryCmpArea.folderEncryptionPassword.enable();
fdEncryCmpArea.folderEncryptionVerify.enable();
fdEncryCmpArea.folderEncryptionSave.enable();
}
else {
fdEncryCmpArea.folderEncryptionPassword.disable();
fdEncryCmpArea.folderEncryptionPassword.clearInvalid();
fdEncryCmpArea.folderEncryptionVerify.disable();
fdEncryCmpArea.folderEncryptionVerify.clearInvalid();
fdEncryCmpArea.folderEncryptionSave.disable();
}
}
}
},
{
'xtype'           : 'box'
,   'html'            : '&nbsp;<img style="cursor:pointer; position:relative; top:1px;" ext:qtip="'+_S.FOLDER_ENCRYPTION_CREATE_LABEL+'" src="apps/systemPreferences/images/icon_help2.gif">'
,   'qInternational'  : true
,   'qInternationalFn': function( cmp ){
cmp.update('&nbsp;<img style="cursor:pointer; position:relative; top:1px;" ext:qtip="'+_S.FOLDER_ENCRYPTION_CREATE_LABEL+'" src="apps/systemPreferences/images/icon_help2.gif">');
},
} ]
}
,
{
xtype  : 'container',
layout : 'form',
border : false,
style  : 'font-size:12px;',
items  : [
{//Input Encryption Password
xtype                   : 'textfield',
itemId                  : 'folderEncryptionPassword',
ref                 	: '../folderEncryptionPassword',
name                    : 'folderEncryptionPassword',
maxLength               : 32,
width                   : 150,
fieldLabel              : _S.IEI_PASSWORD_INPUT,//Encryption Password:',
qInternational          : true,
qInternationalKey       : 'IEI_PASSWORD_INPUT',
labelSeparator          : '',
inputType               : 'password',
labelStyle              : 'width:170px; padding-left: 20px;padding-top:6px;',
disabled                : true,
validator               : function (value) {
var checkInUtf8Bytes = function(str) {
var m = encodeURIComponent(str).match(/%[89ABab]/g);
var length = str.length + (m ? m.length : 0);
if (length < 8 || length > 32 || str.indexOf(' ') != -1 ){
return false;
} else {
return true;
}
}

if ( !checkInUtf8Bytes(value) || /\u0020/.test(value) )
return _S.IEI_PASSWORD_ALERT2.replace('16','32').replace('１６','３２');;
if (/[^\u0021-\u007E]/.test(value))
return _S.FOLDER_ENCRYPTION_STR24;
if (/[\u0022\u0024\u003A\u003D\u005C]/.test(value))
return _S.FOLDER_ENCRYPTION_STR24;
return true;
}
}
,
{//Verify Encryption Password
xtype                   : 'textfield',
itemId                  : 'folderEncryptionVerify',
ref                 	: '../folderEncryptionVerify',
name                    : 'folderEncryptionVerify',
maxLength               : 32,
width                   : 150,
labelWidth              : 170,
fieldLabel              : _S.IEI_NAS_SECURITY28,
qInternational          : true,
qInternationalKey       : 'IEI_NAS_SECURITY28',
labelSeparator          : '',
inputType               : 'password',
labelStyle              : 'width:170px; padding-left: 20px;padding-top:6px;',
disabled                : true,
validationDelay         : 100,
validationEvent         : 'blur',
validator               : function (value) {
if(fdEncryForm.findField('folderEncryptionPassword').getValue() != value ) return _S.IEI_DEVICE_MSG156;
return true;
}
}
,
{//Save encryption key
xtype                   : 'qtscheckbox',
itemId                  : 'folderEncryptionSave',
ref                 	: '../folderEncryptionSave',
name                    : 'folderEncryptionSave',
fieldLabel              : _S.IEI_NAS_STORAGE188,
qInternational          : true,
qInternationalKey       : 'IEI_NAS_STORAGE188',
labelStyle              : 'padding-left: 20px;',
style                   : 'padding-left: 20px;',
inputValue              : 'checkbox',
disabled                : true,
}
]
}
]
}
]
});

var fdEncryForm = folderEncryptionForm.getForm();  // for access form easily

var encryptFoldConfirmCreate = function (me, parentWin, ajaxInfo) {
var layoutConfig = function (me) {
return Ext.apply({
'title'                : _S.FOLDER_ENCRYPTION_CREATE_CONFIRM_TITLE
,'headerTitle'          : _S.FOLDER_ENCRYPTION_CREATE_CONFIRM_TITLE
,'parent'			    : parentWin
,'baseWin'			    : me.app._getMainWindow()
,'qInternational'       : true
,'qInternationalKey'    : 'FOLDER_ENCRYPTION_CREATE_CONFIRM_TITLE'
,'width'                : 500
,'height'               : 420
,'cls'                  : 'utility-window win-form'
,'items'                : [{
xtype       : 'panel'
,layout     : 'form'
,border  	: false
,autoScroll : true
,labelWidth : 13
,items   	: [
{
xtype              : 'displayfield'
,itemId            : 'encryptFoldConfirmNote'
,hideLabel         : true
,value             : _S.COMMON_NOTE
,qInternational    : true
,qInternationalKey : 'COMMON_NOTE'
,style             : {'font-size': '16px'}
}
,
{
xtype              : 'displayfield'
,itemId            : 'encryptFoldConfirmNote1'
,value             : _S.FOLDER_ENCRYPTION_CREATE_CONFIRM_NOTE1
,fieldLabel        : '1'
,labelSeparator    : '.'
,style             : 'font-size: 13px; color: #AD1804;'
,labelStyle        : 'font-size: 13px; color: #AD1804; padding: 0px;'
,qInternational    : true
,qInternationalKey : {value: 'FOLDER_ENCRYPTION_CREATE_CONFIRM_NOTE1'}
}
,
{
xtype              : 'displayfield'
,itemId            : 'encryptFoldConfirmNote2'
,value             : _S.FOLDER_ENCRYPTION_CREATE_CONFIRM_NOTE2
,fieldLabel        : '2'
,labelSeparator    : '.'
,style             : 'font-size: 13px;'
,labelStyle        : 'font-size: 13px; padding: 0px;'
,qInternational    : true
,qInternationalKey : {value: 'FOLDER_ENCRYPTION_CREATE_CONFIRM_NOTE2'}
}
,
{
xtype              : 'displayfield'
,itemId            : 'encryptFoldConfirmNote3'
,value             : _S.FOLDER_ENCRYPTION_CREATE_CONFIRM_NOTE3
,fieldLabel        : '3'
,labelSeparator    : '.'
,style             : 'font-size: 13px;'
,labelStyle        : 'font-size: 13px; padding: 0px;'
,qInternational    : true
,qInternationalKey : {value: 'FOLDER_ENCRYPTION_CREATE_CONFIRM_NOTE3'}
}
,
{
xtype  : 'container',
height : 15
}
,
{
xtype              : 'displayfield'
,itemId            : 'encryptFoldConfirmNote4'
,value             : _S.FOLDER_ENCRYPTION_CREATE_CONFIRM_NOTE4
,hideLabel         : true
,style             : 'font-size: 13px;'
,qInternational    : true
,qInternationalKey : 'FOLDER_ENCRYPTION_CREATE_CONFIRM_NOTE4'
}
]
}]
,'buttons'	: [
{    'xtype'                : 'qtsbutton'
,'text'                 : _S.IEI_NAS_BUTTON_YES
,'qInternational'       : true
,'qInternationalKey'    : 'IEI_NAS_BUTTON_YES'
,'handler'              :  function(obj) {
QNAP.QOS.ajax(ajaxInfo);
obj.ownerCt.ownerCt.close();
QNAP.QOS.lib.MaskMgr.mask(parentWin.getEl(), 'LOADING', _S.LOADING);
}
}
,
{    'xtype'                : 'qtsbutton'
,'text'                 : _S.IEI_NAS_BUTTON_NO
,'qInternational'       : true
,'qInternationalKey'    : 'IEI_NAS_BUTTON_NO'
,'handler'              :  function(obj) {
obj.ownerCt.ownerCt.close();
}
}
]
}, config);
};

var config = new layoutConfig(me);
var encryptFoldConfirmWizard = me.app._createModalWindow(config);
encryptFoldConfirmWizard.show();
};
}  // if(folderEncryption)

var itemsForm = [step2, step4];
if (folderEncryption) itemsForm.push(folderEncryptionForm);
itemsForm.push(step2Adv);

items = {
title: _S.IEI_NAS_SECURITY15,
qInternational: true,
qInternationalKey: 'IEI_NAS_SECURITY15',
layout: 'border',
cls: 'wiz-non-tbar-style utility-window win-form',
items: [{
xtype: 'panel',
region: 'center',
border: false,
bodyStyle: 'overflow-y:scroll;',
items: [{
xtype: 'container',
border: false,
style: 'padding:30px 60px;',
items: itemsForm
}]
}],
fbar: [{
xtype: 'button',
itemId: 'createBtn',
text: _S.IEI_NAS_BUTTON_CREATE,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_CREATE',
disabled: true,
handler: function (cmp) {
step2.haSyncCgiCall = true;
if (!step2.onNext()){
step2.haSyncCgiCall = false;
return;
}
step2.haSyncCgiCall = false;
var para = {};
var urd_len = 0,
urw_len = 0,
uno_len = 0;
var grd_len = 0,
grw_len = 0,
gno_len = 0;
para.share_name = step2Form.findField('share_name_shareFolder').getValue().replace(/(^[\s]*)/g, '');
para.comment = step2Form.findField('comment_shareFolder').getValue();
para.guest = step2AdvForm.findField('guest_group').getValue();
para.hidden = step2AdvForm.findField('hidden_group').getValue() * 1;
para.oplocks = step2AdvForm.findField('oplocks_group').getValue() * 1;
if( step2AdvForm.findField('encryptData_group').isVisible() )
para.EncryptData = step2AdvForm.findField('encryptData_group').getValue() * 1;
var access_r = 'admin_only'; //nolimit
if (menuSelValue == 'user') {
para.user_wizard_filter = para.wizard_filter = uSearch.field ? uSearch.field.getValue() : '';
Ext.each(accessUserArray, function (data) {
if (data.access_rd) {
para['userd' + urd_len] = data.username;
urd_len++;
} else if (data.access_rw) {
para['userw' + urw_len] = data.username;
urw_len++;
} else if (data.access_no) {
para['useno' + uno_len] = data.username;
uno_len++;
}
});
para.userd_len = urd_len;
para.userw_len = urw_len;
para.useno_len = uno_len;
access_r = 'setup_users';
}
if (menuSelValue == 'group') {
para.group_wizard_filter = para.wizard_filter = gSearch.field ? gSearch.field.getValue() : '';
Ext.each(accessGroupArray, function (data) {
if (data.access_rd) {
para['grouprd' + grd_len] = data.groupname;
grd_len++;
} else if (data.access_rw) {
para['grouprw' + grw_len] = data.groupname;
grw_len++;
} else if (data.access_no) {
para['groupno' + gno_len] = data.groupname;
gno_len++;
}
});
para.grouprd_len = grd_len;
para.grouprw_len = grw_len;
para.groupno_len = gno_len;
access_r = 'setup_groups';
}
para.access_r = access_r;
para.img_file_path = step2Form.findField('imageFileList').getValue();
para.path_type = step2Form.findField('path_type_group').getValue().inputValue;
para.quotaSettings = step2AdvForm.findField('quotaSettings').getValue();
para.quota_size = '';
if (is_imageShare) para.quota_size = para.path_type == 'manual' ? '1' : para.quotaSettings;
var recycle_bin_status = 1;
if (para.path_type != 'auto') {
para.manual_path = manualPathTreeCombo.getValue();
var chkPathAry = para.manual_path.split('/');
var chkDis = chkManualPath(false, chkPathAry);
if (chkDis) recycle_bin_status = 0;
}
if (recycleBinEnable == 1) {
para.recycle_bin = recycle_bin_status == 1 ? step2AdvForm.findField('recycle_bin_group').getValue() * 1 : 0;
} else {
para.recycle_bin = 0;
}
para.recycle_bin_administrators_only = para.recycle_bin !== 0 ? step2AdvForm.findField('recycle_bin_admin').getValue() * 1 : 0;
para.quotaRadio = step2AdvForm.findField('quotaRadio_group').getValue() * 1;
para.vol_no = step2Form.findField('disks_list_shareFolder').getValue();

para.addToMediaFolder = step2AdvForm.findField('media_group').getValue() ? 7 : 0;
para.qsync = step2AdvForm.findField('qsync_share_folder_sync').getValue() * 1;
if (QNAP.QOS.config.bIsStorageV2) {
if (hideHF) para.addToMediaFolder = 0;
}

if (folderEncryption) {
var encryptCheckbox = fdEncryForm.findField('folderEncryptionCheck');
var encryptPasswordText = fdEncryForm.findField('folderEncryptionPassword');
var encryptVerifyText = fdEncryForm.findField('folderEncryptionVerify');
var encryptSaveCheckbox = fdEncryForm.findField('folderEncryptionSave');
var toolbarBtn = folderEncryptionForm.topToolbar.items.items[2];

if (encryptCheckbox.checked) {
if (!folderEncryptionForm.folderEncryptOnNext(true)) return;
para.keyStr = encryptPasswordText.getValue();
para.saveKey = encryptSaveCheckbox.checked ? 'yes' : 'no';
}
}

var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
QNAP.QOS.lib.MaskMgr.mask(target.getEl(), 'LOADING', _S.LOADING);
var url = '';
if( QNAP.QOS.config.ha_enabled ){
url = QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + QNAP.QOS.config.ha_CGI_FILENAME, {
wiz_func	: 'share_create',
action		: 'add_share',
ha_cluster	: me.app.HASelector,
ha_action   : 'wizReq',
ha_sync     : 1
});
}else{
url = QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func	: 'share_create',
action		: 'add_share'
});
}
var ajaxInfo = {
url: url,
method: 'POST',
params: para,
success: function (response, opts) {
var xmlData = response.responseXML;

function runSuccess() {
var runfilechg = false;
if (Ext.DomQuery.selectNode('return', xmlData)) {
var ret = Ext.DomQuery.selectValue('return', xmlData);
if (ret != '') {
ret = parseInt(ret);
if (ret < 0) {
target.getEl().unmask();
if (!Ext.isDefined(runFinish)) target = '';
fn.winAlert(app, target, 'SHARE_CREATE_WIZ_STR32', 'info', '', target != '' ? target : null);
} else {
if (para.access_r == 'nolimit' || para.access_r == 'admin_only') runfilechg = true;
else if (para.access_r == 'setup_users' && (para.userd_len > 0 || para.userw_len > 0 || para.useno_len > 0)) runfilechg = true;
else if (para.access_r == 'setup_groups' && (para.grouprd_len > 0 || para.grouprw_len > 0 || para.groupno_len > 0)) runfilechg = true;
if (runfilechg) {
app._getApp().fireEvent('filechange', app._getApp().id, '/', '/', para.share_name, 'new');
}
target.close();
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'updateSharedFolderGrid');
}
} else {
target.getEl().unmask();
if (!Ext.isDefined(runFinish)) target = '';
fn.winAlert(app, target, 'SHARE_CREATE_WIZ_STR32', 'info', '', target != '' ? target : null);
}
} else {
if (para.access_r == 'nolimit' || para.access_r == 'admin_only') runfilechg = true;
else if (para.access_r == 'setup_users' && (para.userd_len > 0 || para.userw_len > 0 || para.useno_len > 0)) runfilechg = true;
else if (para.access_r == 'setup_groups' && (para.grouprd_len > 0 || para.grouprw_len > 0 || para.groupno_len > 0)) runfilechg = true;
if (runfilechg && Ext.isDefined(runFinish)) {
if (Ext.isDefined(runFinish.shareFolderStore)) { //從Control Panel進來的。
app._getApp().fireEvent('filechange', app._getApp().id, '/', '/', para.share_name, 'new');
} else if (Ext.isDefined(runFinish.fileManager)) { //從fileManager進來的。
var FM = runFinish.fileManager;
app = runFinish.fileManager;
app._getApp().fireEvent('filechange', app._getApp().id, '/', '/', para.share_name, 'new');
FM.openPath(FM.currentPath);
} else if( Ext.isDefined(runFinish.volumeMgmt) ){
app._getApp().fireEvent('filechange', app._getApp().id, '/', '/', para.share_name, 'new');
}
}
if (folderEncryption) {
var encrypt_ret, errStr;
if (encryptCheckbox.checked) {
encrypt_ret = parseInt(Ext.DomQuery.selectValue('Encrypt_Share_return_value', xmlData));
if (encrypt_ret < 0) {
errStr = 'FOLDER_ENCRYPTION_STR08';
if (encrypt_ret == -17) {
errStr = 'FOLDER_ENCRYPTION_STR26';
}
if (Ext.isDefined(runFinish.volumeMgmt)) {  // from volumeMgmt
fn.winAlert(app, app._getMainWindow()._getSubWin().get(0), errStr, 'error', '', target != '' ? target : null);
} else {
fn.winAlert(app, target, errStr, 'error', '', target != '' ? target : null);
}
}
else {
target.close();
}
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'updateSharedFolderGrid');
}  //if (encryptCheckbox.checked)
else {
encrypt_ret = parseInt(Ext.DomQuery.selectValue('Error_code', xmlData));
if (encrypt_ret < 0) {
errStr = 'FOLDER_ENCRYPTION_STR08';
if (encrypt_ret == -7) {
errStr = 'FOLDER_ENCRYPTION_STR25';
}
if (Ext.isDefined(runFinish.volumeMgmt)) {  // from volumeMgmt
fn.winAlert(app, app._getMainWindow()._getSubWin().get(0), errStr, 'error', '', target != '' ? target : null);
} else {
fn.winAlert(app, target, errStr, 'error', '', target != '' ? target : null);
}
} else {
target.close();
}
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'updateSharedFolderGrid');
}  //if (encryptCheckbox.checked)
}  // if (folderEncryption)
else {
target.close();
app._getApp().fireEvent('serviceupdate', app._getApp().id, 'updateSharedFolderGrid');
}  // if (folderEncryption)
}
}
if (Ext.isDefined(runFinish)) {
if (Ext.isDefined(runFinish.shareFolderStore)) { //從Control Panel進來的。
runFinish.shareFolderStore.reload({
callback: function (store, record, options) {
runSuccess();
}
});
runFinish.selSharedFolderAry = [];
} else if (Ext.isDefined(runFinish.fileManager)) { //從fileManager進來的。
var FM = runFinish.fileManager;
runSuccess();
} else if( Ext.isDefined(runFinish.volumeMgmt) ) {//從volumeMgmt進來的。 storage V2.1 從storage space 進來的.
runFinish.volumeMgmt.folderRefresh( runFinish.volumeMgmt );
target.getEl().unmask();
target.close();
runSuccess();
}else{
runSuccess();
}
} else {
runSuccess();
}
},
failure: function () {
fn.winAlert(app, target, 'SHARE_CREATE_WIZ_STR32', 'info', '', target != '' ? target : null);
target.getEl().unmask();
}
}
if (folderEncryption) {
if (encryptCheckbox.checked) {
encryptFoldConfirmCreate(me, cmp.ownerCt.ownerCt, ajaxInfo);
}
else {
QNAP.QOS.ajax(ajaxInfo);
}
}
else {
QNAP.QOS.ajax(ajaxInfo);
}

}
}, {
xtype: 'button',
text: _S.IEI_NAS_BUTTON_CANCEL,
qInternational: true,
qInternationalKey: 'IEI_NAS_BUTTON_CANCEL',
handler: function (cmp) {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
target.close();
}
}],
listeners: {
afterrender: function (win) {
accessUserGrid.hide();
/* accessGroupGrid.hide(); */
step4.getComponent('gridArea').hide();
win.getEl().mask(_S.LOADING, '', 'transparent-mask');
}
}
};

var params = {wiz_func: 'share_create'};
var url = 'wizReq.cgi';
if( QNAP.QOS.config.ha_enabled ){
url = QNAP.QOS.config.ha_CGI_FILENAME;
params.ha_cluster = me.app.HASelector;
params.ha_action = 'wizReq';
}
ajax_info = {
url: QNAP.QOS.lib.getCgiUrl( QNAP.QOS.config.sitePath + url, params ),
method: 'POST',
success: function (response, opts) {
var xmlData = response.responseXML;
var disks_list_shareFolder = step2Form.findField('disks_list_shareFolder');
hideHF = Ext.DomQuery.selectValue('hideHF', xmlData, '0') == '1';
if (xmlData != undefined) {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
recycleBinEnable = Ext.DomQuery.selectValue('recycleBinEnable', xmlData);
QNAP.GQ.parseGQMaster(xmlData);
var volList = Ext.DomQuery.selectNode('volumeList', xmlData);
if (volList) fn.GenVolumeSelect('v2-freeSize', disks_list_shareFolder, volList);
/* GQ feature:
* add Gluster volume to volume list when create share
*/
if (QNAP.GQ.isMaster()) {
data = disks_list_shareFolder.store.data.items;
new_data = QNAP.GQ.addGlusterVol(data);
disks_list_shareFolder.store.loadData(new_data);
}
var oShareNum = Ext.DomQuery.selectNode('ShareNum', xmlData);
if (oShareNum) {
share_count = parseInt(Ext.DomQuery.selectValue('ShareNum/count', xmlData));
max_count = parseInt(Ext.DomQuery.selectValue('ShareNum/max_count', xmlData));
}
osupportImageShare = Ext.DomQuery.selectValue('supportImageShare', xmlData);
bManualPath = false;
Ext.each(Ext.DomQuery.select('NASShareList/share', xmlData), function (node) {
Used_ShareArray.push(Ext.DomQuery.selectValue('name', node));
});
var chkCreatBtn = true;
if (parseInt(share_count) >= parseInt(max_count)) {
chkCreatBtn = false;
fn.winAlert(app, target, ['ERROR_USER_SHARE_TITLE', 'QUICK09_STR01', 'ERROR_SHARENUM_EXCEED_ACCOUNT'], 'info', '', target != '' ? target : null);
}
accessUserStore.load();
/* accessGroupStore.load(); */
if (recycleBinEnable == '1') {
step2AdvForm.findField('recycle_bin_admin').setDisabled(!step2AdvForm.findField('recycle_bin_group').getValue());
}

if (QNAP.QOS.config.bIsStorageV2) {
step2AdvForm.findField('media_group').setDisabled(hideHF);
}

if (Ext.isDefined(runFinish)) {
if (Ext.isDefined(runFinish.vol_no)) {
var vol_no = runFinish.vol_no,
comboFirst = '--',
isFind = false;
disks_list_shareFolder.getStore().each(function (r, index) {
if (index === 0) {
comboFirst = r.data.listValue;
}
if (r.data.listValue == vol_no) {
isFind = true;
return false;
}
});
if (!isFind) {
vol_no = comboFirst;
}
disks_list_shareFolder.setValue(vol_no);
var path_type_group = step2Form.findField('path_type_group');
if (QNAP.GQ.isGQVol(vol_no)){
step2Form.findField('share_name_shareFolder').validate();
path_type_group.disable();
manualPathTreeCombo.disable();
}
else {
path_type_group.enable();
manualPathTreeCombo.setDisabled(path_type_group.getValue().inputValue == 'auto');
}
manualPathTreeCombo.fileTree.setRootNode(new Ext.tree.AsyncTreeNode({
text: '/',
id: 0,
dir: '/share'
}));
manualPathTreeCombo.setValue('');
}
}
if (chkCreatBtn) target.getFooterToolbar().getComponent('createBtn').enable();
setForm2Adv(true);
var encryptData_group = step2AdvForm.findField('encryptData_group');
var chkValue = Ext.DomQuery.selectValue('supportSamba4', xmlData) == 'yes';
encryptData_group.setVisible(chkValue);
if (chkValue) encryptData_group.setDisabled(Ext.DomQuery.selectValue('supportSMBEncrypt', xmlData) != 'yes');
var volumeValue = disks_list_shareFolder.getValue();
step2Form.findField('lbl_none_vol').setVisible(Ext.isEmpty(volumeValue) || volumeValue == '0');
if (folderEncryption) {
var VIRTUAL_VOL_BASE = QNAP.QOS.config.bIsStorageV2 ? 1000 : 100;
var USB_DISK_BASE    = QNAP.QOS.config.bIsStorageV2 ? 2000 : 200;
var ESATA_DISK_BASE  = QNAP.QOS.config.bIsStorageV2 ? 3000 : 300;

encryptfsSupport = Ext.DomQuery.selectNumber('encryptfsSupported', xmlData);
if (encryptfsSupport == 0 || volumeValue >= VIRTUAL_VOL_BASE) {
if (!Ext.isEmpty(folderEncryptionForm)) folderEncryptionForm.hide();
}
}
}
step2Form.findField('share_name_shareFolder').focus(true, 100);
},
failure: function () {},
callback: function () {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
target.getEl().unmask();
if (Ext.isDefined(runFinish)) {
if (!Ext.isEmpty(runFinish.runBtnName)) {
Ext.each(runFinish.runBtnName, function (data) {
var btn = Ext.getCmp(ids[data]);
btn.handler(btn);
});
}
}
}
};

var setForm2Adv = function (isVisible) {
var guest_group = cmpArea.getComponent('guest_group'),
media_group = cmpArea.getComponent('media_group'),
hidden_group = cmpArea.getComponent('hidden_group'),
oplocks_group = cmpArea.getComponent('oplocks_group'),
quotaRadioDiv2u = cmpArea.getComponent('quotaRadioDiv2u'),
quotaSettings = step2AdvForm.findField('quotaSettings'),
quotaRadio_group = step2AdvForm.findField('quotaRadio_group'),
recycle_bin_group = step2AdvForm.findField('recycle_bin_group'),
recycle_bin_admin = step2AdvForm.findField('recycle_bin_admin'),
path_type_group = step2Form.findField('path_type_group');
guest_group.setVisible(!guest_group.isVisible());
if (QNAP.QOS.config.bIsStorageV2 && hideHF) {
media_group.setVisible(false);
} else {
media_group.setVisible(!media_group.isVisible());
}
hidden_group.setVisible(!hidden_group.isVisible());
oplocks_group.setVisible(!oplocks_group.isVisible());
if (recycleBinEnable == 1) {
recycle_bin_group.setVisible(!recycle_bin_group.isVisible());
recycle_bin_admin.setVisible(!recycle_bin_admin.isVisible());
} else {
recycle_bin_group.setVisible(false);
}
if (!isVisible) {
quotaRadioDiv2u.hide();
quotaSettings.disable();
quotaRadio_group.hide();
} else {
var chkValue = osupportImageShare == 'yes';
me.imageShareSupport = chkValue * 1;
quotaRadio_group.setVisible(chkValue);
quotaRadioDiv2u.setVisible(chkValue);
if (chkValue) {
quotaSettings.setDisabled(!quotaRadio_group.getValue());
var imageFileList = step2Form.findField('imageFileList'),
quotaSettings = step2AdvForm.findField('quotaSettings');
if (quotaRadio_group.getValue()) {
is_imageShare = 1;
imageFileList.show();
manualPathTreeCombo.hide();
var path_type_auto = path_type_group.getValue().inputValue == 'auto';
imageFileList.setDisabled(path_type_auto);
quotaSettings.setDisabled(!path_type_auto);
}
} else quotaSettings.disable();
quotaSettings.validate();
cmpArea.doLayout();
}
};

var updateGlobalShare = function () {
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'gq.cgi/gq/v1/share'),
method: 'GET',
params : {all_shares: null,
allow_error: false},
success: function (response, opts) {
var rsp = Ext.decode(response.responseText);
Ext.each(rsp, function (item) {
globalShareArray.push(item.shareName.toLowerCase());
});
updateGlobalShareFailed = false;
},
failure: function () {
_D('can not get global share list');
updateGlobalShareFailed = true;
}
});
}
updateGlobalShare();

return {
items: items,
ajax_info: ajax_info
};
},
qMyCloudNAS: function (me, runFinish) {
QNAP.QOS.quickWizard.myColudNAS = this;
var fn = this,
app = me;
if (Ext.isDefined(me.app)) app = me.app;
var tmpPublicAry = [],
radio_selection = 'express',
isInitializing = 1,
isInitializing2 = 1,
isfinan = 0,
okdnsDomain = '',
okUsername = '',
isHostNameOK = 0,
upnpError = 0,
ddnsError = 0;

var upnpData = [{
index: 0,
enable: false,
portNum: '8080',
portName: 'HTTP',
category: 'HTTP(8080)',
nasServices: _S.NIC_APPLE_STR05 + '<br>' + _S.NIC_VIEW_STR08,
nasServicesStr: ['NIC_APPLE_STR05', '<br>', 'NIC_VIEW_STR08']
}, {
index: 5,
enable: false,
portNum: '80',
portName: 'HTTP',
category: 'HTTP(80)',
nasServices: _S.NIC_NAS_SERVICE_STR16 + '<br>' + _S.NIC_PHOTO_STR01 + '/' + _S.MYCLOUDNAS_WIZARD_QMOBILE,
nasServicesStr: ['NIC_NAS_SERVICE_STR16', '<br>', 'NIC_PHOTO_STR01', '/', 'MYCLOUDNAS_WIZARD_QMOBILE']
}, {
index: 2,
enable: false,
portNum: '20,21',
portName: 'FTP/FTPS',
category: 'FTP/FTPS(20,21)',
nasServices: 'FTP/FTPS'
}, {
index: 1,
enable: false,
portNum: '443',
portName: 'SSL',
category: 'SSL(443)',
nasServices: _S.UPNPC_SVC_LIST_STR02 + '<br>' + _S.MYCLOUDNAS_WIZARD_SECURE_WFM,
nasServicesStr: ['UPNPC_SVC_LIST_STR02', '<br>', 'MYCLOUDNAS_WIZARD_SECURE_WFM']
}, {
index: 3,
enable: false,
portNum: '23',
portName: 'Telnet',
category: 'Telnet(23)',
nasServices: _S.UPNPC_SVC_LIST_STR04,
nasServicesStr: 'UPNPC_SVC_LIST_STR04'
}, {
index: 4,
enable: false,
portNum: '22',
portName: 'SSH',
category: 'SSH(22)',
nasServices: _S.UPNPC_SVC_LIST_STR05,
nasServicesStr: 'UPNPC_SVC_LIST_STR05'
}, {
index: 6,
enable: false,
portNum: '8081',
portName: 'SSL',
category: 'SSL(8081)',
nasServices: _S.UPNPC_SVC_LIST_STR07,
nasServicesStr: 'UPNPC_SVC_LIST_STR07'
}, {
index: 8,
enable: false,
portNum: '873',
portName: 'RSync',
category: 'RSync(873)',
nasServices: _S.UPNPC_SVC_LIST_STR09,
nasServicesStr: 'UPNPC_SVC_LIST_STR09'
}, {
index: 9,
enable: false,
portNum: '1723',
portName: 'PPTP',
category: 'PPTP(1723)',
nasServices: _S.UPNPC_SVC_LIST_STR10,
nasServicesStr: 'UPNPC_SVC_LIST_STR10'
}, {
index: 10,
enable: false,
portNum: '1194',
portName: 'OpenVPN',
category: 'OpenVPN(1194)',
nasServices: _S.UPNPC_SVC_LIST_STR11,
nasServicesStr: 'UPNPC_SVC_LIST_STR11'
}];

var publishData = [{
index: 0,
enable: true,
name: _S.NIC_APPLE_STR05,
nameStr: 'NIC_APPLE_STR05',
publish: 0,
private: 0,
portIndex: 0,
portOpen: 0,
id: Ext.id()
}, {
index: 1,
enable: false,
name: _S.NIC_NAS_SERVICE_STR08,
nameStr: 'NIC_NAS_SERVICE_STR08',
publish: 0,
private: 0,
portIndex: 0,
portOpen: 0,
id: Ext.id()
}, {
index: 9,
enable: false,
name: _S.NIC_NAS_SERVICE_STR16,
nameStr: 'NIC_NAS_SERVICE_STR16',
publish: 0,
private: 0,
portIndex: 5,
portOpen: 0,
id: Ext.id()
}, {
index: 10,
enable: false,
name: _S.NIC_PHOTO_STR01,
nameStr: 'NIC_PHOTO_STR01',
publish: 0,
private: 0,
portIndex: 5,
portOpen: 0,
id: Ext.id()
}, {
index: 16,
enable: false,
name: _S.QNAP_PS_STR01,
nameStr: 'QNAP_PS_STR01',
publish: 0,
private: 0,
portIndex: 5,
portOpen: 0,
id: Ext.id()
}, {
index: 17,
enable: false,
name: _S.MUSIC_STR01,
nameStr: 'MUSIC_STR01',
publish: 0,
private: 0,
portIndex: 5,
portOpen: 0,
id: Ext.id()
}, {
index: 11,
enable: false,
name: _S.UPNPC_SVC_LIST_STR07,
nameStr: 'UPNPC_SVC_LIST_STR07',
publish: 0,
private: 0,
portIndex: 6,
portOpen: 0,
id: Ext.id()
}, {
index: 12,
enable: false,
name: _S.MYCLOUDNAS_WIZARD_SECURE_MS,
nameStr: 'MYCLOUDNAS_WIZARD_SECURE_MS',
publish: 0,
private: 0,
portIndex: 6,
portOpen: 0,
id: Ext.id()
}, {
index: 18,
enable: false,
name: _S.MYCLOUDNAS_WIZARD_SECURE_PHOTOSTATION,
nameStr: 'MYCLOUDNAS_WIZARD_SECURE_PHOTOSTATION',
publish: 0,
private: 0,
portIndex: 6,
portOpen: 0,
id: Ext.id()
}, {
index: 19,
enable: false,
name: _S.MYCLOUDNAS_WIZARD_SECURE_MUSICSTATION,
nameStr: 'MYCLOUDNAS_WIZARD_SECURE_MUSICSTATION',
publish: 0,
private: 0,
portIndex: 6,
portOpen: 0,
id: Ext.id()
}, {
index: 4,
enable: false,
name: 'FTP',
nameStr: 'FTP',
publish: -1,
private: 0,
portIndex: 2,
portOpen: 0,
id: Ext.id()
}, {
index: 5,
enable: false,
name: _S.FTP_STR15,
nameStr: 'FTP_STR15',
publish: -1,
private: 0,
portIndex: 2,
portOpen: 0,
id: Ext.id()
}, {
index: 2,
enable: false,
name: _S.UPNPC_SVC_LIST_STR02,
nameStr: 'UPNPC_SVC_LIST_STR02',
publish: 0,
private: 0,
portIndex: 1,
portOpen: 0,
id: Ext.id()
}, {
index: 3,
enable: false,
name: _S.MYCLOUDNAS_WIZARD_SECURE_WFM,
nameStr: 'MYCLOUDNAS_WIZARD_SECURE_WFM',
publish: 0,
private: 0,
portIndex: 1,
portOpen: 0,
id: Ext.id()
}, {
index: 6,
enable: false,
name: _S.UPNPC_SVC_LIST_STR04,
nameStr: 'UPNPC_SVC_LIST_STR04',
publish: -1,
private: 0,
portIndex: 3,
portOpen: 0,
id: Ext.id()
}, {
index: 7,
enable: false,
name: 'SSH',
publish: -1,
private: 0,
portIndex: 4,
portOpen: 0,
id: Ext.id()
}, {
index: 8,
enable: false,
name: 'SFTP',
publish: -1,
private: 0,
portIndex: 4,
portOpen: 0,
id: Ext.id()
}, {
index: 13,
enable: false,
name: _S.UPNPC_SVC_LIST_STR09,
nameStr: 'UPNPC_SVC_LIST_STR09',
publish: -1,
private: 0,
portIndex: 8,
portOpen: 0,
id: Ext.id()
}, {
index: 14,
enable: false,
name: _S.UPNPC_SVC_LIST_STR10,
nameStr: 'UPNPC_SVC_LIST_STR10',
publish: 0,
private: 0,
portIndex: 9,
portOpen: 0,
id: Ext.id()
}, {
index: 15,
enable: false,
name: _S.UPNPC_SVC_LIST_STR11,
nameStr: 'UPNPC_SVC_LIST_STR11',
publish: 0,
private: 0,
portIndex: 10,
portOpen: 0,
id: Ext.id()
}];

var serviceName = {
"0": "NIC_APPLE_STR05",
"1": "NIC_NAS_SERVICE_STR08",
"9": "NIC_NAS_SERVICE_STR16",
"10": ["NIC_PHOTO_STR01", "MYCLOUDNAS_WIZARD_QMOBILE"],
"16": "QNAP_PS_STR01",
"17": "MUSIC_STR01",
"11": "UPNPC_SVC_LIST_STR07",
"12": "MYCLOUDNAS_WIZARD_SECURE_MS",
"18": "MYCLOUDNAS_WIZARD_SECURE_PHOTOSTATION",
"19": "MYCLOUDNAS_WIZARD_SECURE_MUSICSTATION",
"4": 'FTP',
"5": "FTP_STR15",
"2": "UPNPC_SVC_LIST_STR02",
"3": "MYCLOUDNAS_WIZARD_SECURE_WFM",
"6": "UPNPC_SVC_LIST_STR04",
"7": 'SSH',
"8": 'SFTP',
"13": "UPNPC_SVC_LIST_STR09",
"14": "UPNPC_SVC_LIST_STR10",
"15": "UPNPC_SVC_LIST_STR11"
};

var wizSelectAllPortsId = 'wizSelectAllPorts' + Ext.id();

var upnpPortListCheckColumn = new Ext.grid.CheckColumn({
header: '<div style="text-align:center"><input type="checkbox" id="' + wizSelectAllPortsId + '" style="align:center;"></div>',
qInternational: false,
width: 20,
dataIndex: "enable"
});

var upnpPortListGridStore = new Ext.data.ArrayStore({
fields: [{
name: 'index',
mapping: 'index'
}, {
name: 'enable',
mapping: 'enable',
type: 'bool'
}, {
name: 'nasServices',
mapping: 'nasServices'
}, {
name: 'category',
mapping: 'category'
}, {
name: 'portNum',
mapping: 'portNum'
}, {
name: 'portName',
mapping: 'portName'
}, {
name: 'nasServicesStr',
mapping: 'nasServicesStr'
}]
});

var upnpPortListGrid = new Ext.grid.EditorGridPanel({
store: upnpPortListGridStore,
enableHdMenu: true,
autoExpandColumn: "index",
height: 195,
enableHdMenu: false,
enableColumnMove: false,
qInternational: true,
qInternationalFn: function (cmp) {
upnpPortListGridStore.each(function (r) {
if (r.data.nasServicesStr != '') {
var tmpStr = '';
if (Ext.isArray(r.data.nasServicesStr)) {
Ext.each(r.data.nasServicesStr, function (data) {
if (data == '<br>' || data == '/') tmpStr += data;
else tmpStr += _S[data];
});
} else {
tmpStr = _S[r.data.nasServicesStr];
}
r.data.nasServices = tmpStr
r.afterEdit();
}
});
},
colModel: new Ext.grid.ColumnModel({
defaults: {
qInternational: true,
sortable: false
},
qInternational: true,
columns: [
upnpPortListCheckColumn,
{
header: _S.MYCLOUDNAS_WIZARD_CATEGORY + '<br />' + _S.MYCLOUDNAS_WIZARD_PORT_NUMBER,
qInternationalFn: function (col) {
col.header = _S.MYCLOUDNAS_WIZARD_CATEGORY + '<br />' + _S.MYCLOUDNAS_WIZARD_PORT_NUMBER;
},
width: 150,
renderer: function (data, metadata, record, rowIndex, columnIndex, store) {
var tip = record.data.portName + '(' + record.data.portNum + ')';
metadata.attr = 'ext:qtip="' + tip + '"';
return tip;
}
}, {
header: _S.MYCLOUDNAS_WIZARD_SERVICES,
qInternationalKey: 'MYCLOUDNAS_WIZARD_SERVICES',
dataIndex: 'nasServices',
value2Tip: true
}]
}),
viewConfig: {
forceFit: true
},
columnLines: true,
buttonAlign: 'left',
frame: true,
plugins: [
upnpPortListCheckColumn],
listeners: {
afteredit: function (e) {
e.record.commit();
},
headerclick: function (grid, index, e) {
grid.store.each(function (record) {
record.data.enable = document.getElementById(wizSelectAllPortsId).checked;
record.afterEdit();
});
}
}
});

var servicesEnableCheckColumn = new Ext.grid.CheckColumn({
header: _S.IEI_NAS_STORAGE159,
qInternationalKey: 'IEI_NAS_STORAGE159',
width: 20,
dataIndex: "enable",
renderer: function (v, p, record) {
var tr_id = 'wizSvcEnable' + record.data.index + record.data.id;
var recordenable = record.data.enable;
var portIndex = record.data.portIndex;
if (recordenable == 1) {
return '<div style="text-align:center;"><input type="checkbox" value="1" id="' + tr_id + '" style="display:none;" checked ><span style="color: green;white-space: nowrap;">' + _S.MYCLOUDNAS_WIZARD_IN_SERVICE + '</span></div>';
} else {
return '<div style="text-align:center;"><input type="checkbox" value="1" id="' + tr_id + '" onclick="QNAP.QOS.quickWizard.chkServicesEnable(\'' + record.data.index + record.data.id + '\')" style="align:center;"></div>';
}
}
});

var servicesPublishCheckColumn = new Ext.grid.CheckColumn({
header: _S.MYCLOUDNAS_WIZARD_PUBLISH,
qInternationalKey: 'MYCLOUDNAS_WIZARD_PUBLISH',
width: 20,
dataIndex: "publish",
renderer: function (v, p, record) {
var recordPublish = record.data.publish;
var tr_id = 'wizSvcPublish' + record.data.index + record.data.id;
var recordenable = record.data.enable;
var portIndex = record.data.portIndex;
var isDisabled = (recordenable != 1) ? 'disabled="true"' : '';
if (recordPublish == 1) {
return '<div style="text-align:center;"><input type="checkbox" id="' + tr_id + '" ' + isDisabled + ' checked  style="align:center;"></div>';
} else if (recordPublish == 0) {
return '<div style="text-align:center;"><input type="checkbox" id="' + tr_id + '" ' + isDisabled + ' style="align:center;"></div>';
} else {
return '<div style="text-align:center;">-&nbsp;-<input type="checkbox" value="0" id="' + tr_id + '" disabled="disabled" style="visibility: hidden;"></div>';
}
}
});

var publishServicesGridStore = new Ext.data.ArrayStore({
fields: [{
name: 'index',
mapping: 'index'
}, {
name: 'enable',
mapping: 'enable',
type: 'bool'
}, {
name: 'name',
mapping: 'name'
}, {
name: 'publish',
mapping: 'publish'
}, {
name: 'private',
mapping: 'private'
}, {
name: 'portOpen',
mapping: 'portOpen'
}, {
name: 'portIndex',
mapping: 'portIndex'
}, {
name: 'nameStr',
mapping: 'nameStr'
}, {
name: 'id',
mapping: 'id'
}]
});

var publishServicesGrid = new Ext.grid.EditorGridPanel({
store: publishServicesGridStore,
enableHdMenu: false,
autoExpandColumn: "index",
height: 200,
enableHdMenu: false,
enableColumnMove: false,
qInternational: true,
qInternationalFn: function (cmp) {
publishServicesGridStore.each(function (r) {
if (r.data.nameStr != '') {
r.data.name = _S[r.data.nameStr] || r.data.nameStr;
r.afterEdit();
}
});
},
colModel: new Ext.grid.ColumnModel({
defaults: {
qInternational: true
},
qInternational: true,
columns: [{
header: _S.MYCLOUDNAS_WIZARD_SERVICES,
qInternationalKey: 'MYCLOUDNAS_WIZARD_SERVICES',
sortable: false,
dataIndex: 'name',
value2Tip: true
},
servicesEnableCheckColumn, servicesPublishCheckColumn]
}),
viewConfig: {
forceFit: true
},
columnLines: true,
buttonAlign: 'left',
frame: true,
plugins: [
servicesEnableCheckColumn, servicesPublishCheckColumn],
listeners: {
afteredit: function (e) {
e.record.commit();
}
}
});

var step1 = new QNAP.QOS.wizard.formPanel({
itemId: 'setp1',
nextId: 'setp2',
headerhide: true,
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 400,
items: [{
xtype: 'panel',
layout: 'table',
padding: '2px',
border: false,
layoutConfig: {
columns: 2
},
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
html: {
tag: 'img',
width: "294",
height: "118",
src: "apps/easeOfAccess/images/cloudnasintro.png"
},
width: 294
}, {
xtype: 'displayfield',
value: _S.MYCLOUDNAS_WIZARD_INTRO_NOTE,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_INTRO_NOTE',
cls: 'note-color',
hideLabel: true
}]
}, {
xtype: 'panel',
border: false,
itemId: 'ddnsOptionsTable',
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
value: _S.MYCLOUDNAS_WIZARD_INTRO,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_INTRO',
hideLabel: true,
style: "padding-left:7px;color:#5A5A59;"
}, {
xtype: 'displayfield',
value: _S.MYCLOUDNAS_WIZARD_INTRO1,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_INTRO1',
hideLabel: true,
style: "padding-left:7px;color:#5A5A59;text-indent: -16px; margin-left: 16px;"
}, {
xtype: 'displayfield',
value: _S.MYCLOUDNAS_WIZARD_INTRO2,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_INTRO2',
hideLabel: true,
style: "padding-left:7px;color:#5A5A59;text-indent: -16px; margin-left: 16px;"
}, {
xtype: 'displayfield',
value: _S.MYCLOUDNAS_WIZARD_INTRO3,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_INTRO3',
hideLabel: true,
style: "padding-left:7px;color:#5A5A59;text-indent: -16px; margin-left: 16px;"
}, {
xtype: 'radiogroup',
itemId: 'rdo_selection',
hideLabel: true,
labelSeparator: '',
columns: 2,
style: 'padding:9px 0 9px 7px;',
items: [{
boxLabel: _S.MYCLOUDNAS_WIZARD_STEP1_OPTION1,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_STEP1_OPTION1',
name: 'selection',
inputValue: 'express',
checked: true
}, {
boxLabel: _S.MYCLOUDNAS_WIZARD_STEP1_OPTION2,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_STEP1_OPTION2',
name: 'selection',
inputValue: 'manual'
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}, {
xtype: 'panel',
itemId: 'saveURL1',
border: false,
style: "border-top: 1px dotted #ccc;padding-top: 15px;",
items: {
xtype: 'button',
text: _S.MYCLOUDNAS_WIZARD_SAVE_URL,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_SAVE_URL',
cls: 'qos-systemPreferences-btn',
handler: function () {
if (!Ext.fly('frmDummy')) {
var frm = document.createElement('form');
frm.id = 'tmp_save_url';
frm.name = 'tmp_save_url';
frm.className = 'x-hidden';
frm.action = QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'mycloudnas_wiz'
}, {
action: 'saveServiceURL'
});
frm.method = 'post';
document.body.appendChild(frm);
}
Ext.fly('tmp_save_url').dom.submit();
}
}
}]
}, {
xtype: 'panel',
border: false,
itemId: 'ddnsErrorLists',
style: 'font-size:12px;',
hidden: true,
items: [{
xtype: 'displayfield',
value: '<img src="apps/systemLogs/images/msg_warning.gif" style="float: left;margin: 0 5px;">' + _S.MYCLOUDNAS_WARNING05,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<img src="apps/systemLogs/images/msg_warning.gif" style="float: left;margin: 0 5px;">' + _S.MYCLOUDNAS_WARNING05);
},
hideLabel: true,
itemId: 'ddnsError',
style: 'color:red;'
}, {
xtype: 'displayfield',
value: '<img src="apps/systemLogs/images/msg_warning.gif" style="float: left;margin: 0 5px;">' + _S.UPNPC_STR_12,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<img src="apps/systemLogs/images/msg_warning.gif" style="float: left;margin: 0 5px;">' + _S.UPNPC_STR_12);
},
hideLabel: true,
itemId: 'upnpError',
style: "color:red;padding-top:5px;"
}, {
xtype: 'displayfield',
value: _S.MYCLOUDNAS_WIZARD_ERROR_NOTE,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_ERROR_NOTE',
hideLabel: true,
style: 'padding-left:5px;padding-top:15px;'
}]
}],
onNext: function () {
if (step1Form.findField('rdo_selection').getValue() == null) {
step1Form.findField('rdo_selection').show();
return false;
}
radio_selection = step1Form.findField('rdo_selection').getValue().inputValue;
step2.nextId = (radio_selection == 'express') ? 'setp4' : 'setp3';
setTimeout(function () {
step2.ownerCt.ownerCt.doLayout();
}, 1);
if (isInitializing2 == 0) {
step1.getComponent('ddnsOptionsTable').show();
step1.getComponent('ddnsErrorLists').hide();
return true;
}
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
QNAP.QOS.lib.MaskMgr.mask(target.getEl(), 'LOADING', _S.LOADING);
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'mycloudnas_wiz'
}),
method: 'POST',
success: function (response, opts) {
var xData = response.responseXML;
if (Ext.DomQuery.selectNode('qnapDDNS', xData)) {
var qnapDDNSXml = Ext.DomQuery.selectNode('qnapDDNS', xData);
var dnsName = Ext.DomQuery.selectValue('dname', qnapDDNSXml) || '';
var dnsDomain = Ext.DomQuery.selectValue('qname', qnapDDNSXml) || '';
step2Form.findField('dnsUsername').setValue(dnsName);
step2Form.findField('dnsDomain').setValue(dnsDomain);
}
if (Ext.DomQuery.selectNode('upnpc_port_list', xData)) {
var upnpc_port_list = Ext.DomQuery.selectNode('upnpc_port_list', xData);
var total = Ext.DomQuery.select('portSvc', upnpc_port_list).length;
for (var i = 0; i < total; i++) {
var thisPortSvc = Ext.DomQuery.select('portSvc', upnpc_port_list)[i];
if (thisPortSvc) {
var portIndex = parseInt(Ext.DomQuery.selectValue('portIndex', thisPortSvc));
var portEnabled = Ext.DomQuery.selectValue('portEnable', thisPortSvc);
var tcpPortNum = Ext.DomQuery.selectValue('tcpPorts', thisPortSvc);
var udpPortNum = Ext.DomQuery.selectValue('udpPorts', thisPortSvc);
Ext.each(upnpData, function (data) {
if (data.index == portIndex) {
if (radio_selection == 'express') {
switch (data.index) {
case 0:
case 5:
case 2:
data.enable = true;
break;
default:
data.enable = false;
break;
}
} else {
data.enable = (portIndex == '0' || portIndex == '5') ? true : portEnabled;
}
if (tcpPortNum != '') {
data.portNum = tcpPortNum;
} else if (udpPortNum != '') {
data.portNum = udpPortNum;
}
}
});
for (var m = 0; m < upnpData.length; m++) {
var idx = upnpData[m].index;
var portSvc = Ext.DomQuery.selectNode("portSvc:has(portIndex:nodeValue(" + idx + "))", upnpc_port_list);
var arr = [];
Ext.each(Ext.DomQuery.select("svc:has(svcSupport:nodeValue(1))", portSvc), function (obj, j) {
var tempstr = serviceName[Ext.DomQuery.selectValue("svcIndex", obj)];
if (tempstr.sort) {
for (var m = 0; m < tempstr.length; m++) {
arr.push(tempstr[m]);
arr.push("/");
}
arr.pop();
} else {
arr.push(tempstr);
}
arr.push("<br/>");
});
arr.pop();
me.nasServicesStr = arr;
upnpData[m].nasServices = "";
Ext.each(arr, function (data) {
upnpData[m].nasServices += (data == "<br/>" || data == "/" ? data : _S[data] || data);
});
}
for (var m = publishData.length - 1; m >= 0; m--) {
var idx = publishData[m].index;
var svc = Ext.DomQuery.selectNode("svc:has(svcIndex:nodeValue(" + idx + "))", upnpc_port_list);
if (Ext.DomQuery.selectValue("svcSupport", svc) != "1") {
publishData.splice(m, 1);
continue;
}
publishData[m].enable = Ext.DomQuery.selectValue("svcEnable", svc);
publishData[m].publish = Ext.DomQuery.selectValue("svcPublish", svc);
publishData[m].nowate = Ext.DomQuery.selectValue("svcPrivate", svc);
}
}
}
}
var errorFree = 1;
if (Ext.DomQuery.selectValue('connectMyCloudNAS', xData) == '0') {
ddnsError = 1;
step1Form.findField('ddnsError').show();
errorFree = 0;
}
if (Ext.DomQuery.selectValue('connectUPnPRouter', xData) == '0') {
upnpError = 1;
errorFree = 0;
step1Form.findField('upnpError').show();
}
isInitializing2 = 0;
upnpPortListGridStore.loadData(upnpData);
publishServicesGridStore.loadData(publishData);
target.getEl().unmask();
if (errorFree == 0) {
step1.getComponent('ddnsOptionsTable').hide();
step1.getComponent('ddnsErrorLists').show();
return false;
}
app._getMainWindow().onNext();
return true;
},
failure: function () {
isInitializing2 = 0;
target.getEl().unmask();
return false;
}
});
}
});

var checkDnsUsername = function (e) {
function isValidDNSName(string) {
var rule = /[^a-zA-Z0-9]+/;
if (rule.test(string) || string.length < 3 || string.length > 30) {
return false;
}
return true;
}
var v = step2Form.findField('dnsUsername').getValue();
while (v.length > 0 && v.charAt(0) == ' ') {
var ssname = v.substr(1);
v = ssname;
}
if (v == "") return (e == true) ? 'FTP_STR41' : _S.FTP_STR41;
if (!isValidDNSName(v)) return (e == true) ? 'MYCLOUDNAS_WARNING03' : _S.MYCLOUDNAS_WARNING03;
return true;
};

var step2 = new QNAP.QOS.wizard.formPanel({
itemId: 'setp2',
nextId: 'setp3',
headerTitle: _S.MYCLOUDNAS_WIZARD_STEP2_TITLE,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_STEP2_TITLE',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 400,
items: [{
xtype: 'displayfield',
value: _S.MYCLOUDNAS_WIZARD_STEP2_INTRO,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_STEP2_INTRO',
hideLabel: true
}, {
xtype: 'displayfield',
value: '',
height: 20
}, {
xtype: 'panel',
layout: 'hBox',
border: false,
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
value: 'http://',
style: 'padding-top:4px;'
}, {
xtype: 'textfield',
itemId: 'dnsUsername',
name: 'dnsUsername',
labelSeparator: '',
maxLength: 64,
width: 120,
enableKeyEvents: true,
validator: checkDnsUsername,
defaultValue: ''
}, {
xtype: 'displayfield',
value: '.',
style: 'padding-top:4px;'
}, {
xtype: 'combo',
itemId: "dnsDomain",
name: "dnsDomain",
width: 140,
style: 'padding-left:5px;',
store: new Ext.data.ArrayStore({
fields: ['listName'],
data: [
['mycloudnas.com'],
['myqnapnas.com'],
['qcloudnas.com']
]
}),
displayField: 'listName',
valueField: 'listName',
mode: 'local',
editable: false,
allowBlank: false,
enabled: false,
triggerAction: 'all',
defaultValue: 'mycloudnas.com'
}, {
xtype: 'button',
text: _S.MYCLOUDNAS_STR04,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_STR04',
cls: 'qos-systemPreferences-btn',
style: 'padding-left:11px;',
handler: function () {
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
QNAP.QOS.lib.MaskMgr.mask(target.getEl(), 'IEI_NAS_STORAGE35', _S.IEI_NAS_STORAGE35);
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'mycloudnas_wiz'
}),
params: {
action: 'check_dname',
myCloudHostName: step2Form.findField('dnsUsername').getValue(),
myCloudNasDomainNameServer: step2Form.findField('dnsDomain').getValue()
},
method: 'POST',
validationEvent: 'blur',
success: function (response, opts) {
target.getEl().unmask();
var xData = response.responseXML;
var responseCode = Ext.DomQuery.selectValue('isHostNameOK', xData) || '0';
var errStr = true,
goodName = step2Form.findField('goodName'),
badName = step2Form.findField('badName');
if (responseCode == '4') {
goodName.hide();
badName.show();
errStr = _S.MYCLOUDNAS_WARNING04;
fn.winAlert(app, target, 'MYCLOUDNAS_WARNING04', 'info', '', target != '' ? target : null);
} else if (responseCode == '3') {
goodName.hide();
badName.show();
errStr = _S.MYCLOUDNAS_WARNING03;
fn.winAlert(app, target, 'MYCLOUDNAS_WARNING03', 'info', '', target != '' ? target : null);
} else {
goodName.show();
badName.hide();
}
return errStr;
},
failure: function () {
target.getEl().unmask();
step2Form.findField('goodName').hide();
step2Form.findField('badName').show();
return _S.MYCLOUDNAS_WARNING05;
}
});
}
}, {
layout: 'column',
hideLabel: true,
border: false,
style: 'margin-left:10px;margin-top:5px;',
items: [{
xtype: 'displayfield',
itemId: 'goodName',
value: '<img src="apps/backupRestore/images/msg_ok.gif">',
hidden: true
}, {
xtype: 'displayfield',
itemId: 'badName',
value: '<img src="apps/systemLogs/images/msg_warning.gif">',
hidden: true
}]
}]
}],
onNext: function () {
if (okUsername != step2Form.findField('dnsUsername').getValue()) isHostNameOK = 0;
if (okdnsDomain != step2Form.findField('dnsUsername').getValue()) isHostNameOK = 0;
if (isHostNameOK) {
if (radio_selection == 'express') step3.onNext();
return true;
}
var retcheck = checkDnsUsername(true);
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
var goodName = step2Form.findField('goodName'),
badName = step2Form.findField('badName');
if (retcheck != true) {
goodName.hide();
badName.show();
fn.winAlert(app, target, retcheck, 'info', '', target != '' ? target : null);
isHostNameOK = 0;
return false;
}
goodName.show();
badName.hide();
QNAP.QOS.lib.MaskMgr.mask(target.getEl(), 'IEI_NAS_STORAGE35', _S.IEI_NAS_STORAGE35);
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'mycloudnas_wiz'
}),
params: {
action: 'check_dname',
myCloudHostName: step2Form.findField('dnsUsername').getValue(),
myCloudNasDomainNameServer: step2Form.findField('dnsDomain').getValue()
},
method: 'POST',
validationEvent: 'blur',
success: function (response, opts) {
var xData = response.responseXML;
var responseCode = Ext.DomQuery.selectValue('isHostNameOK', xData) || '0';
var goodName = step2Form.findField('goodName'),
badName = step2Form.findField('badName');
if (responseCode == '4') {
goodName.hide();
badName.show();
fn.winAlert(app, target, 'MYCLOUDNAS_WARNING04', 'info', '', target != '' ? target : null);
isHostNameOK = 0;
} else if (responseCode == '3') {
goodName.hide();
badName.show();
fn.winAlert(app, target, 'MYCLOUDNAS_WARNING03', 'info', '', target != '' ? target : null);
isHostNameOK = 0;
} else {
goodName.show();
badName.hide();
isHostNameOK = 1;
okUsername = step2Form.findField('dnsUsername').getValue();
okdnsDomain = step2Form.findField('dnsUsername').getValue();
}
target.getEl().unmask();
if (isHostNameOK) {
target.onNext();
return true;
} else {
return false;
}
},
failure: function () {
step2Form.findField('goodName').hide();
step2Form.findField('badName').show();
target.getEl().unmask();
return false;
}
});
}
});

var step3 = new QNAP.QOS.wizard.formPanel({
itemId: 'setp3',
nextId: 'setp4',
headerTitle: _S.MYCLOUDNAS_WIZARD_STEP3_TITLE,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_STEP3_TITLE',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 400,
items: [{
xtype: 'displayfield',
value: _S.MYCLOUDNAS_WIZARD_STEP3_INTRO + '&nbsp;(' + _S.MYCLOUDNAS_WIZARD_UPNP + ')',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.MYCLOUDNAS_WIZARD_STEP3_INTRO + '&nbsp;(' + _S.MYCLOUDNAS_WIZARD_UPNP + ')');
},
hideLabel: true
},
upnpPortListGrid],
onNext: function () {
var k = 0;
var tmpPublishData = [];
upnpPortListGrid.store.each(function (record) {
Ext.each(publishData, function (data) {
if (data.portIndex == record.data.index) {
if (record.data.enable) {
data.portOpen = 1;
tmpPublishData.push(data);
}
}
});
});
publishServicesGridStore.loadData(tmpPublishData);
return true;
}
});

var step4 = new QNAP.QOS.wizard.formPanel({
itemId: 'setp4',
nextId: 'setp5',
headerTitle: _S.MYCLOUDNAS_WIZARD_STEP4_TITLE,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_STEP4_TITLE',
bodyStyle: 'padding: 10px 60px 30px;',
autoScroll: true,
labelWidth: 400,
items: [{
xtype: 'displayfield',
value: _S.MYCLOUDNAS_WIZARD_STEP4_INTRO,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_STEP4_INTRO',
hideLabel: true
},
publishServicesGrid],
onNext: function () {
step5.onNext();
return true;
}
});

var step5 = new QNAP.QOS.wizard.formPanel({
itemId: 'setp5',
nextId: 'setp6',
headerTitle: _S.IEI_IDS_STRING75,
qInternational: true,
qInternationalKey: 'IEI_IDS_STRING75',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 400,
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
value: _S.APPLY_MSG,
qInternational: true,
qInternationalKey: 'APPLY_MSG',
hideLabel: true,
itemId: 'processText'
}, {
xtype: 'displayfield',
value: '<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.IEI_NAS_ERR_MSG99,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.IEI_NAS_ERR_MSG99);
},
hideLabel: true,
hidden: true,
itemId: 'error99',
style: 'color:red;'
}, {
xtype: 'displayfield',
value: '<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.MYCLOUDNAS_WARNING03,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.MYCLOUDNAS_WARNING03);
},
hideLabel: true,
hidden: true,
itemId: 'error13',
style: 'color:red;'
}, {
xtype: 'displayfield',
value: '<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.MYCLOUDNAS_WARNING05,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.MYCLOUDNAS_WARNING05);
},
hideLabel: true,
hidden: true,
itemId: 'error14',
style: 'color:red;'
}, {
xtype: 'displayfield',
value: '<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.MYCLOUDNAS_WARNING06,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.MYCLOUDNAS_WARNING06);
},
hideLabel: true,
hidden: true,
itemId: 'error15',
style: 'color:red;'
}, {
xtype: 'displayfield',
value: '<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.MYCLOUDNAS_WARNING07,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.MYCLOUDNAS_WARNING07);
},
hideLabel: true,
hidden: true,
itemId: 'error16',
style: 'color:red;'
}, {
xtype: 'displayfield',
value: '<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.MYCLOUDNAS_WARNING04,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.MYCLOUDNAS_WARNING04);
},
hideLabel: true,
hidden: true,
itemId: 'error10',
style: 'color:red;'
}, {
xtype: 'panel',
hideLabel: true,
border: false,
itemId: 'error11',
hidden: true,
style: '',
items: [{
xtype: 'displayfield',
value: '<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.UPNPC_STR_04,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.UPNPC_STR_04);
},
hideLabel: true,
style: "padding-bottom:5px;color:red;font-size:12px;"
}, {
xtype: 'displayfield',
style: QNAP.layout.getDefaultCSS({
indent: 1
}) + 'font-size:12px;padding-top:5px;',
value: _S.UPNPC_STR_12,
qInternational: true,
qInternationalKey: 'UPNPC_STR_12',
hideLabel: true
}, {
xtype: 'displayfield',
style: QNAP.layout.getDefaultCSS({
indent: 1
}) + 'cursor:pointer;font-size:12px;',
value: _S.MYCLOUDNAS_WIZARD_TROUBLESHOOT,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_TROUBLESHOOT',
hideLabel: true,
itemId: 'errorLink11',
cls: 'link_line note_color'
}]
}, {
xtype: 'panel',
hideLabel: true,
border: false,
itemId: 'error12',
hidden: true,
style: '',
items: [{
xtype: 'displayfield',
value: '<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.UPNPC_STR_13,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('<img src="apps/systemLogs/images/msg_warning.gif" style="margin: 0 5px;"/>' + _S.UPNPC_STR_13);
},
hideLabel: true,
style: "padding-bottom:5px;color:red;font-size:12px;"
}, {
xtype: 'displayfield',
style: QNAP.layout.getDefaultCSS({
indent: 1
}) + 'cursor:pointer;font-size:12px;',
value: _S.MYCLOUDNAS_WIZARD_TROUBLESHOOT,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_TROUBLESHOOT',
hideLabel: true,
itemId: 'errorLink12',
cls: 'link_line note_color'
}, {
xtype: 'displayfield',
style: QNAP.layout.getDefaultCSS({
indent: 1
}) + 'font-size:12px;',
value: _S.MYCLOUDNAS_WIZARD_TROUBLESHOOT_TEXT,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_TROUBLESHOOT_TEXT',
hideLabel: true
}]
}, {
xtype: 'displayfield',
hideLabel: true,
itemId: 'errorTip',
value: _S.MYCLOUDNAS_WIZARD_ERROR_NOTE2,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_ERROR_NOTE2',
style: 'padding-top:9px;'
}],
onNext: function () {
if (isfinan) return true;
tmpPublicAry = [];
step5Form.findField('errorTip').hide();
step5Form.findField('processText').show();
var target = Ext.isDefined(runFinish) ? runFinish.targetWin.apply() : app._getMainWindow();
QNAP.QOS.lib.MaskMgr.mask(target.getEl(), 'APPLY_MSG', _S.APPLY_MSG);
var paraStr = '';
paraStr += 'action=apply';
paraStr += '&myCloudHostName=' + step2Form.findField('dnsUsername').getValue();
paraStr += '&myCloudNasDomainNameServer=' + step2Form.findField('dnsDomain').getValue();
upnpPortListGrid.store.each(function (record) {
var tmpstr = '&portEnable' + record.data.index + '=';
tmpstr += record.data.enable ? 1 : 0;
paraStr += tmpstr;
});
Ext.each(publishData, function (data) {
tmpstr = '&svcEnable' + data.index + '='; // j;
if (document.getElementById('wizSvcEnable' + data.index + data.id)) {
tmpstr += (document.getElementById('wizSvcEnable' + data.index + data.id).checked) ? 1 : 0;
} else {
tmpstr += (data.enable) ? 1 : 0;
}
paraStr += tmpstr;
tmpstr = '&svcPublish' + data.index + '=';
if (document.getElementById('wizSvcPublish' + data.index + data.id)) {
if (document.getElementById('wizSvcPublish' + data.index + data.id).checked == true) {
tmpstr += 1;
tmpPublicAry.push(data.nameStr);
} else {
tmpstr += 0;
}
} else {
tmpstr += data.publish;
}
paraStr += tmpstr;
});
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'mycloudnas_wiz'
}),
params: paraStr,
method: 'POST',
validationEvent: 'blur',
success: function (response, opts) {
isfinan = 1;
var xData = response.responseXML;
var returnCode = Ext.DomQuery.selectValue('returnMyCloudNasWiz', xData) || '0';
target.getEl().unmask();
var h = returnCode.split(",");
for (index = 0; index < h.length; index++) {
var g = h[index];
var errStr = '';
modOK1 = false, modOK2 = false, modGood = false;
switch (g) {
case "0":
app._getMainWindow().onNext();
return true;
break;
case "10":
/* The name is in use. Please try another one. */
modOK1 = true;
modOK2 = true;
step5Form.findField('error10').show();
errStr = 'MYCLOUDNAS_WARNING04';
break;
case "11":
/* No UPnP router found on the network */
modOK2 = true;
modGood = true;
step5.getComponent('error11').show();
Ext.EventManager.removeAll(step5Form.findField('errorLink11').getEl());
step5Form.findField('errorLink11').getEl().on("click", function () {
window.open('http://www.qnap.com/go/mycloudnas.html');
});
errStr = 'UPNPC_STR_04';
break;
case "12":
/* Auto router configuration faild. */
modOK2 = true;
modGood = true;
step5.getComponent('error12').show();
Ext.EventManager.removeAll(step5Form.findField('errorLink12').getEl());
step5Form.findField('errorLink12').getEl().on("click", function () {
window.open('http://www.qnap.com/go/mycloudnas.html');
});
errStr = 'UPNPC_STR_13';
break;
case "13":
/* MyCloudNAS name must be 3-30 characters long and can only contain a-z, A-Z, 0-9, and dot (.). */
modOK1 = true;
modOK2 = true;
isfinan = 0;
step5.getComponent('error12').show();
errStr = 'MYCLOUDNAS_WARNING03';
break;
case "14":
/* The NAS cannot connect to MyCloudNAS server, please check your Internet connection or DNS server settings. */
modOK1 = true;
modOK2 = true;
step5Form.findField('error14').show();
errStr = 'MYCLOUDNAS_WARNING05';
break;
case "15":
/* MyCloudNAS server is busy or temporarily unavailable. Please try again an hour later. If the problem persists, please contact the technical support. */
modOK1 = true;
modOK2 = true;
step5Form.findField('error15').show();
errStr = 'MYCLOUDNAS_WARNING06';
break;
case "16":
/* The NAS has connected to MyCloudNAS server, but the settings cannot be registered. Please restart the NAS and try again. If the problem persists, please contact the technical support. */
modOK1 = true;
modOK2 = true
step5Form.findField('error16').show();
errStr = 'MYCLOUDNAS_WARNING07';
break;
default:
step5Form.findField('error99').show();
errStr = 'IEI_NAS_ERR_MSG99';
break
}
if (modOK1) {
var ddnsOK1 = step6Form.findField('ddnsOK1');
ddnsOK1.setValue(_S.MYCLOUDNAS_WIZARD_MYCLOUDNAS_NAME + '<img src="apps/systemLogs/images/msg_warning.gif" ext:qtip="' + _S[errStr] + '">');
ddnsOK1.qInternational = true;
ddnsOK1.qInternationalFn = function (cmp) {
cmp.setValue(_S.MYCLOUDNAS_WIZARD_MYCLOUDNAS_NAME + '<img src="apps/systemLogs/images/msg_warning.gif" ext:qtip="' + _S[errStr] + '">');
};
}
if (modOK2) {
var ddnsOK2 = step6Form.findField('ddnsOK2');
ddnsOK2.setValue(_S.MYCLOUDNAS_WIZARD_SERVICES_LIST + '<img src="apps/systemLogs/images/msg_warning.gif" ext:qtip="' + _S[errStr] + '">');
ddnsOK2.qInternational = true;
ddnsOK2.qInternationalFn = function (cmp) {
cmp.setValue(_S.MYCLOUDNAS_WIZARD_SERVICES_LIST + '<img src="apps/systemLogs/images/msg_warning.gif" ext:qtip="' + _S[errStr] + '">');
};
}
if (modGood) {
var upnpGood = step6Form.findField('upnpGood');
upnpGood.setValue(_S.MYCLOUDNAS_WIZARD_UPNP_CONFIG + '<img src="apps/systemLogs/images/msg_warning.gif" ext:qtip="' + _S[errStr] + '">');
upnpGood.qInternational = true;
upnpGood.qInternationalFn = function (cmp) {
cmp.setValue(_S.MYCLOUDNAS_WIZARD_UPNP_CONFIG + '<img src="apps/systemLogs/images/msg_warning.gif" ext:qtip="' + _S[errStr] + '">');
};
}

step5Form.findField('processText').setValue(_S.IEI_IDS_STRING75);
step5Form.findField('processText').qInternational = true;
step5Form.findField('processText').qInternationalFn = function (cmp) {
cmp.setValue(_S.IEI_IDS_STRING75);
};
}
step5Form.findField('errorTip').show();
step5Form.findField('processText').hide();
return false;
},
failure: function () {
return _S.MYCLOUDNAS_WARNING05;
}
});
step6Form.findField('remoteAccessName').setValue(step2Form.findField('dnsUsername').getValue());
step6Form.findField('remoteAccessLinkHref').setValue(' (http://www.' + step2Form.findField('dnsDomain').getValue() + ')');
Ext.EventManager.removeAll(step6Form.findField('remoteAccessLinkHref').getEl());
step6Form.findField('remoteAccessLinkHref').getEl().on("click", function () {
window.open('http://www.' + step2Form.findField('dnsDomain').getValue());
});

var tmpStr = '';
Ext.each(tmpPublicAry, function (data, i) {
if (i > 0) tmpStr += ',';
tmpStr += _S[data] || data;
});

step6Form.findField('servicesList').setValue(tmpStr);
step6Form.findField('servicesList').qInternationalFn = function (cmp) {
var tag = '',
tmpStr = '';
Ext.each(tmpPublicAry, function (data, i) {
if (i) tmpStr += ',';
tmpStr += _S[data] || data;
});
cmp.setValue(tmpStr);
};
}
});

var step6 = new QNAP.QOS.wizard.formPanel({
itemId: 'setp6',
headerTitle: _S.MYCLOUDNAS_WIZARD_FINAL_STEP_TITLE,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_FINAL_STEP_TITLE',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 400,
items: [{
xtype: 'displayfield',
value: _S.MYCLOUDNAS_WIZARD_FINAL_GREETING,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_FINAL_GREETING',
hideLabel: true
}, {
xtype: 'displayfield',
value: _S.MYCLOUDNAS_WIZARD_MYCLOUDNAS_NAME + '<img src="apps/backupRestore/images/msg_ok.gif">',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.MYCLOUDNAS_WIZARD_MYCLOUDNAS_NAME + '<img src="apps/backupRestore/images/msg_ok.gif">');
},
itemId: 'ddnsOK1',
hideLabel: true
}, {
xtype: 'panel',
layout: 'column',
border: false,
style: QNAP.layout.getDefaultCSS({
indent: 1
}) + 'font-size:12px;',
items: [{
xtype: 'displayfield',
itemId: 'remoteAccessName'
}, {
xtype: 'displayfield',
itemId: 'remoteAccessLinkHref',
style: 'cursor:pointer;',
cls: 'link_line'
}]
}, {
xtype: 'displayfield',
value: _S.MYCLOUDNAS_WIZARD_SERVICES_LIST + '<img src="apps/backupRestore/images/msg_ok.gif">',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.MYCLOUDNAS_WIZARD_SERVICES_LIST + '<img src="apps/backupRestore/images/msg_ok.gif">');
},
itemId: 'ddnsOK2',
hideLabel: true
}, {
xtype: 'displayfield',
itemId: 'servicesList',
qInternational: true,
style: QNAP.layout.getDefaultCSS({
indent: 1
}),
hideLabel: true
}, {
xtype: 'panel',
border: false,
items: {
xtype: 'button',
text: _S.MYCLOUDNAS_WIZARD_SAVE_URL,
qInternational: true,
qInternationalKey: 'MYCLOUDNAS_WIZARD_SAVE_URL',
itemId: 'saveURL2',
style: "padding-top: 5px;float:right;",
cls: 'qos-systemPreferences-btn',
handler: function () {
if (!Ext.fly('frmDummy')) {
var frm = document.createElement('form');
frm.id = 'tmp_save_url';
frm.name = 'tmp_save_url';
frm.className = 'x-hidden';
frm.action = QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'mycloudnas_wiz'
}, {
action: 'saveServiceURL'
});
frm.method = 'post';
document.body.appendChild(frm);
}
Ext.fly('tmp_save_url').dom.submit();
}
}
}, {
xtype: 'displayfield',
value: _S.MYCLOUDNAS_WIZARD_UPNP_CONFIG + '<img src="apps/backupRestore/images/msg_ok.gif">',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.MYCLOUDNAS_WIZARD_UPNP_CONFIG + '<img src="apps/backupRestore/images/msg_ok.gif">');
},
itemId: 'upnpGood',
style: 'padding-top:12px;',
hideLabel: true
}],
onNext: function () {
return true;
}
});

var step1Form = step1.getForm();
var step2Form = step2.getForm();
var step5Form = step5.getForm();
var step6Form = step6.getForm();
items = {
height: 425,
steps: [step1, step2, step3, step4, step5, step6]
};

var svaeURL1 = step1.getComponent('ddnsOptionsTable').getComponent('saveURL1');
ajax_info = {
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'mycloudnas_wiz'
}, {
action: 'saveServiceURLCheck'
}),
method: 'POST',
success: function (response, opts) {
app._getMainWindow().setTitle(_S.MYCLOUDNAS_WIZARD_TITLE);
app._getMainWindow().defaultTitle = _S.MYCLOUDNAS_WIZARD_TITLE;
app._getMainWindow().qInternationalKey = 'MYCLOUDNAS_WIZARD_TITLE';
var xmlData = response.responseXML;
var returnValue = Ext.DomQuery.selectValue('retValue', xmlData) || '0';
if (returnValue == '1') svaeURL1.show();
else svaeURL1.hide();
isInitializing = 0;
},
failure: function () {
svaeURL1.hide();
isInitializing = 0;
}
};
return {
items: items,
ajax_info: ajax_info
};
}
};

Ext.ux.grid.wizSearch = function (config) {
Ext.apply(this, config);
Ext.ux.grid.wizSearch.superclass.constructor.call(this);
};
Ext.extend(Ext.ux.grid.wizSearch, Ext.util.Observable, {
xtype: 'search',
width: 120,
paramNames: {
fields: 'fields',
query: 'filter'
},
shortcutKey: 'r',
shortcutModifier: 'alt',
labelStr: undefined,
idCombo: undefined,
idComboHide: false,
comboStore: null,
comboValue: null,
idFilter: undefined,
gridTbar: undefined,
cookieName: undefined,
comboWidth: 120,
init: function (grid) {
this.grid = grid;
grid.onRender = grid.onRender.createSequence(this.onRender, this);
},
onRender: function () {
var panel = this.toolbarContainer || this.grid;
var tb = panel.topToolbar;
var fn = this;
if (fn.labelStr != undefined) tb.add(new Ext.form.Label({
text: fn.labelStr
}));
if (fn.comboStore != null) {
fn.selectCombo = new Ext.form.ComboBox({
itemId: fn.idCombo,
hidden: fn.idComboHide,
width: fn.comboWidth,
store: fn.comboStore,
lazyRender: false,
qInternational: true,
qInternationalFn: function (cmp) {
var v = cmp.getValue();
cmp.getStore().each(function (r) {
if (r.data.qInternationalKey) {
r.data.listName = _S[r.data.qInternationalKey] || r.data.qInternationalKey;
r.afterEdit();
}
});
cmp.setValue(v);
cmp.originalValue = cmp.getValue();
},
value: fn.comboValue,
displayField: 'listName',
valueField: 'listValue',
mode: 'local',
editable: false,
allowBlank: false,
triggerAction: 'all',
listeners: {
select: function (cmp) {
fn.onTriggerSearch();
}
}
});
tb.add(fn.selectCombo);
}

if (fn.comboStore != null && fn.idFilter != undefined) tb.add(new Ext.form.Label({
text: '　'
}));

if (fn.idFilter != undefined) {
fn.field = new Ext.form.TwinTriggerField({
initComponent: function () {
Ext.form.TwinTriggerField.superclass.initComponent.call(this);
this.triggerConfig = {
tag: 'span',
cls: 'x-form-twin-triggers',
cn: [{
tag: "img",
src: Ext.BLANK_IMAGE_URL,
alt: "",
cls: "x-form-trigger " + this.trigger1Class
}]
};
},
width: this.width,
id: this.idFilter,
selectOnFocus: undefined == this.selectOnFocus ? true : this.selectOnFocus,
trigger1Class: 'x-form-search-trigger',
onTrigger1Click: this.onTriggerSearch.createDelegate(this),
minLength: this.minLength,
enableKeyEvents: true,
listeners: {
buffer: 500,
keyup: function () {
fn.onTriggerSearch();
}
}
});

fn.field.on('render', function () {
var map = new Ext.KeyMap(fn.field.el, [{
key: Ext.EventObject.ENTER,
scope: this,
fn: fn.onTriggerSearch
}, {
key: Ext.EventObject.ESC,
scope: this,
fn: fn.onTriggerClear
}]);
map.stopEvent = true;
}, this, {
single: true
});
tb.add(fn.field);
if (fn.shortcutKey && fn.shortcutModifier) {
var shortcutEl = fn.grid.getEl();
var shortcutCfg = [{
key: fn.shortcutKey,
scope: this,
stopEvent: true,
fn: function () {
fn.field.focus();
}
}];
shortcutCfg[0][fn.shortcutModifier] = true;
fn.keymap = new Ext.KeyMap(shortcutEl, shortcutCfg);
}
}

if (fn.gridTbar != undefined) {
new Ext.Toolbar({
renderTo: panel.tbar,
items: fn.gridTbar
});
}
},
onTriggerClear: function () {
this.field.setValue('');
this.field.focus();
this.onTriggerSearch();
},
onTriggerSearch: function () {
if (!this.field.isValid()) return;
var val = this.field.getValue();
var store = this.grid.store;

if (store.lastOptions && store.lastOptions.params) {
store.lastOptions.params[store.paramNames.start] = 0;
store.lastOptions.params[store.paramNames.limit] = 10;
}

store.baseParams[this.paramNames.query] = encodeURIComponent(val);
store.baseParams['type'] = this.comboStore != null ? this.selectCombo.getValue() : 0;
store.baseParams['lower'] = 0;
store.baseParams['upper'] = 10;
store.reload();
},
setDisabled: function () {
this.field.setDisabled.apply(this.field, arguments);
},
enable: function () {
this.setDisabled(false);
},
disable: function () {
this.setDisabled(true);
}
});

Ext.wizardPagingToolbar = Ext.extend(
Ext.PagingToolbar, {
doLoad: function (start) {
var o = {},
pn = this.getParams();
o[pn.start] = start;
o[pn.limit] = parseInt(this.pageSize) + parseInt(start);
if (this.fireEvent('beforechange', this, o) != false) {
this.store.load({
params: o
});
}
},
updateInfo: function () {
if (this.displayItem) {
var firstNum = this.cursor,
totalRecordNum = this.store.getTotalCount();
if (this.store.addVirtualData) {
if (this.cursor != 0) firstNum += 1;
totalRecordNum += 1;
}
var count = this.store.getCount();
var msg = count == 0 ? this.emptyMsg : String.format(
this.displayMsg, firstNum + 1, firstNum + count, totalRecordNum);
var tmpStr = '';
Ext.each(msg, function (data) {
tmpStr += _S[data] || data;
});
this.displayItem.setText(tmpStr);
this.displayItem.qInternational = true;
this.displayItem.msg = msg;
this.displayItem.qInternationalFn = function (cmp) {
var tmpStr = '';
Ext.each(this.msg, function (data) {
tmpStr += _S[data] || data;
});
cmp.setText(tmpStr);
};
}
}
});

QNAP.QOS.quickWizard.main = Ext.extend(QNAP.QOS.app, {
defaultTitle: "Wizard",
tag: 'quickWizard',
contentId: 'win-wizard-content',
defaultWidth: 600,
defaultHeight: 400,
initApp: function () {},
closeWin: function () {},
getMainWinParams: function (config) {
var fn = this,
items = {},
ajax_info;

if (config.category == 'wUser') {
var tplData = QNAP.QOS.quickWizard.qAddUser(fn);
items = tplData.items;
ajax_info = tplData.ajax_info;
Ext.apply(items, {
onCancel: function () {
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.close();
},
finish: function () {
try {
var activeItem = this.content.layout.activeItem;
activeItem.onSave();
} catch (e) {}
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.onFinish();
this.close();
},
onServiceUpdate: function (appId, eventName) {
if (eventName == 'password_strength') QNAP.QOS.quickWizard.setPwdStr();
if (eventName == 'groups') items.groupStore.reload();
},
onFileChange: function (appId, source, target, filename, action) {
items.shareFolderStore.reload();
}
});
config.title = _S.HOME_STR01;
config.defaultTitle = _S.HOME_STR01;
config.qInternationalKey = 'HOME_STR01';
} else if (config.category == 'wMultipleUsers') {
var tplData = QNAP.QOS.quickWizard.qMAddUser(fn);
items = tplData.items;
ajax_info = tplData.ajax_info;
Ext.apply(items, {
onCancel: function () {
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.close();
},
finish: function () {
try {
var activeItem = this.content.layout.activeItem;
activeItem.onSave();
} catch (e) {}
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.onFinish();
this.close();
},
onServiceUpdate: function (appId, eventName) {
if (eventName == 'password_strength') QNAP.QOS.quickWizard.setPwdStr();
}
});
config.title = _S.MULTI_USER_WIZ;
config.defaultTitle = _S.MULTI_USER_WIZ;
config.qInternationalKey = 'MULTI_USER_WIZ';
} else if (config.category == 'wUserGroup') {
var tplData = QNAP.QOS.quickWizard.qAddGroup(fn);
items = tplData.items;
ajax_info = tplData.ajax_info;
Ext.apply(items, {
onCancel: function () {
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.close();
},
finish: function () {
try {
var activeItem = this.content.layout.activeItem;
activeItem.onSave();
} catch (e) {}
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.onFinish();
this.close();
},
onServiceUpdate: function (appId, eventName) {
if (eventName == 'password_strength') QNAP.QOS.quickWizard.setPwdStr();
}
});
config.title = _S.HOME_STR03;
config.defaultTitle = _S.HOME_STR03;
config.qInternationalKey = 'HOME_STR03';
} else if (config.category == 'wShardFolder') {
var tplData = QNAP.QOS.quickWizard.qAddSharedFolder(fn);
items = tplData.items;
ajax_info = tplData.ajax_info;
Ext.apply(items, {
onCancel: function () {
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.close();
},
finish: function () {
try {
var activeItem = this.content.layout.activeItem;
activeItem.onSave();
} catch (e) {}
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.onFinish();
this.close();
},
onServiceUpdate: function (appId, eventName) {
if (eventName == 'users') this.accessUserStore.reload();
/* if (eventName == 'groups') this.accessGroupStore.reload(); */
}
});
config.title = _S.SHARE_CREATE_WIZ;
config.defaultTitle = _S.SHARE_CREATE_WIZ;
config.qInternationalKey = 'SHARE_CREATE_WIZ';
} else if (config.category == 'ftpService') {
var ftpServerEnabledValue = 0;

function check_Protocol_Type() {
var btn = step4.get('div_Protocol_Type').get('div_regular');
if (!step4Form.findField('regular').getValue() && !step4Form.findField('sslv3').getValue()) btn.show();
else btn.hide();
}
var step1 = new QNAP.QOS.wizard.formPanel({
itemId: 'step1',
nextId: 'step2',
headerTitle: _S.FTP_SERVICE_WIZ_STR08,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR08',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
hideLabels: true,
items: [{
xtype: 'displayfield',
value: _S.FTP_SERVICE_WIZ_STR02,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR02',
hideLabel: true
}, {
xtype: 'displayfield',
value: '● ' + _S.FTP_SERVICE_WIZ_STR03,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('● ' + _S.FTP_SERVICE_WIZ_STR03);
},
style: QNAP.layout.getDefaultCSS({
indent: 1
}) + 'padding-top:10px;'
}, {
xtype: 'displayfield',
value: '● ' + _S.FTP_SERVICE_WIZ_STR04,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue('● ' + _S.FTP_SERVICE_WIZ_STR04);
},
style: QNAP.layout.getDefaultCSS({
indent: 1
}) + 'padding-buttom:10px;'
}, {
xtype: 'displayfield',
value: _S.FTP_SERVICE_WIZ_STR05,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR05',
hideLabel: true
}],
getNextId: function () {
if (ftpServerEnabledValue == 0) return 'step2';
else if (ftpServerEnabledValue == 1) return 'step3';
}
});
var step2 = new QNAP.QOS.wizard.formPanel({
itemId: 'step2',
nextId: 'step3',
headerTitle: _S.FTP_SERVICE_WIZ_STR08,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR08',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
hideLabels: true,
items: [{
xtype: 'displayfield',
value: _S.FTP_SERVICE_WIZ_STR09,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR09',
hideLabel: true,
style: 'font-weight:bold;'
}, {
xtype: 'displayfield',
value: _S.FTP_SERVICE_WIZ_STR10,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR10',
hideLabel: true
}, {
xtype: 'displayfield',
value: _S.FTP_SERVICE_WIZ_STR11,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR11',
hideLabel: true
}]
});
var step3 = new QNAP.QOS.wizard.formPanel({
itemId: 'step3',
nextId: 'step4',
headerTitle: _S.FTP_SERVICE_WIZ_STR01,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR01',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
defaults: {
xtype: 'displayfield',
qInternational: true,
labelSeparator: ''
},
hideLabels: true,
items: [{
value: _S.FTP_SERVICE_WIZ_STR12,
qInternationalKey: 'FTP_SERVICE_WIZ_STR12',
style: 'padding-bottom:20px;font-weight:bold;'
}, {
value: _S.FTP_SERVICE_WIZ_STR13,
qInternationalKey: 'FTP_SERVICE_WIZ_STR13'
}]
});
var step4 = new QNAP.QOS.wizard.formPanel({
itemId: 'step4',
nextId: 'step5',
headerTitle: _S.FTP_SERVICE_WIZ_STR01,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR01',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 180,
items: [{
layout: 'column',
itemId: 'div_Protocol_Type',
border: false,
fieldLabel: _S.FTP_STR27,
qInternational: true,
qInternationalKey: 'FTP_STR27',
labelSeparator: '',
items: [{
xtype: 'checkbox',
itemId: 'regular',
name: 'regular',
boxLabel: _S.FTP_STR14,
qInternational: true,
qInternationalKey: 'FTP_STR14',
hideLabel: true,
inputValue: 'checkbox',
listeners: {
check: function (f, nv, ov) {
check_Protocol_Type();
}
}
}, {
xtype: 'button',
itemId: 'div_regular',
tooltip: 'FTP_STR26',
text: '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',
iconCls: 'ftp1',
template: new Ext.Template('<table cellspacing="0" class="x-btn {3}"><tbody class="{4}">', '<tr><td height="4px;"></td><td></td><td></td></tr>', '<tr><td width="3px;"></td><td><em class="{5}" unselectable="on"><button>{0}</button></a></em></td><td></td></tr>', '<tr><td></td><td></td><td></td></tr>', '</tbody></table>').compile(),
hidden: true
}]
}, {
layout: 'column',
fieldLabel: '&nbsp;',
labelSeparator: '',
border: false,
items: [{
xtype: 'checkbox',
itemId: 'sslv3',
name: 'sslv3',
boxLabel: _S.FTP_STR15,
qInternational: true,
qInternationalKey: 'FTP_STR15',
hideLabel: true,
inputValue: 'checkbox',
listeners: {
check: function (f, nv, ov) {
check_Protocol_Type();
}
}
}]
}, {
xtype: 'numberfield',
itemId: 'ftp_port',
name: 'ftp_port',
fieldLabel: _S.FTP_STR03,
qInternational: true,
qInternationalKey: 'FTP_STR03',
labelSeparator: '',
maxLength: 5,
allowDecimals: false,
validator: function (v) {
return QNAP.QOS.quickWizard.q_check_port(v, 21);
}
}, {
xtype: 'radiogroup',
itemId: 'ftp_unicode_group',
fieldLabel: _S.FTP_STR10,
qInternational: true,
qInternationalKey: 'FTP_STR10',
labelSeparator: '',
columns: 1,
items: [{
boxLabel: _S.FTP_STR11,
qInternational: true,
qInternationalKey: 'FTP_STR11',
hideLabel: true,
name: 'ftp_unicode',
inputValue: 1
}, {
boxLabel: _S.FTP_STR12,
qInternational: true,
qInternationalKey: 'FTP_STR12',
hideLabel: true,
name: 'ftp_unicode',
inputValue: 0
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}, {
xtype: 'radiogroup',
itemId: 'ftp_allowanonymous_group',
fieldLabel: _S.FTP_STR05,
qInternational: true,
qInternationalKey: 'FTP_STR05',
labelSeparator: '',
columns: 1,
items: [{
boxLabel: _S.FTP_STR11,
qInternational: true,
qInternationalKey: 'FTP_STR11',
hideLabel: true,
name: 'ftp_allowanonymous',
inputValue: 1
}, {
boxLabel: _S.FTP_STR12,
qInternational: true,
qInternationalKey: 'FTP_STR12',
hideLabel: true,
name: 'ftp_allowanonymous',
inputValue: 0
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}],
onNext: function () {
return step4Form.findField('ftp_port').isValid() && (step4Form.findField('regular').getValue() || step4Form.findField('sslv3').getValue());
}
});
var step5 = new QNAP.QOS.wizard.formPanel({
itemId: 'step5',
nextId: 'step6',
headerTitle: _S.FTP_SERVICE_WIZ_STR04,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR04',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 180,
items: [{
xtype: 'numberfield',
itemId: 'ftp_maxinstances',
name: 'ftp_maxinstances',
fieldLabel: _S.FTP_STR31,
qInternational: true,
qInternationalKey: 'FTP_STR31',
labelSeparator: '',
maxLength: 3,
width: 40,
allowDecimals: false,
validator: function (v) {
if (v.length == 0) return _S.FTP_STR41;
if (parseInt(v) > 256 || parseInt(v) < 2) return _S.FTP_STR45;
return true;
}
}, {
xtype: 'numberfield',
itemId: 'ftp_maxconn_per_acount',
name: 'ftp_maxconn_per_acount',
fieldLabel: _S.FTP_STR28,
qInternational: true,
qInternationalKey: 'FTP_STR28',
labelSeparator: '',
maxLength: 3,
width: 40,
allowDecimals: false,
validator: function (v) {
if (v.length == 0) return _S.FTP_STR41;
if (parseInt(v) > 256 || parseInt(v) < 2) return _S.FTP_STR45;
if (parseInt(v) > parseInt(step5Form.findField('ftp_maxinstances').getValue())) return _S.FTP_STR42;
return true;
}
}, {
xtype: 'radiogroup',
itemId: 'ftp_bandwidth_en_group',
fieldLabel: _S.FTP_SERVICE_WIZ_STR20,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR20',
labelSeparator: '',
columns: 1,
items: [{
boxLabel: _S.FTP_STR11,
qInternational: true,
qInternationalKey: 'FTP_STR11',
hideLabel: true,
name: 'ftp_bandwidth_en',
inputValue: 1
}, {
boxLabel: _S.FTP_STR12,
qInternational: true,
qInternationalKey: 'FTP_STR12',
hideLabel: true,
name: 'ftp_bandwidth_en',
inputValue: 0
}],
listeners: {
afterrender: function (rdo) {
Ext.each(rdo.items.items, function (dCmp) {
if (Ext.isDefined(dCmp)) {
dCmp.wrap.child('.x-form-cb-label').update(_S[dCmp.qInternationalKey] || dCmp.qInternationalKey);
}
});
}
}
}, {
layout: 'column',
hideLabel: true,
border: false,
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
value: _S.FTP_SERVICE_WIZ_STR21,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR21',
name: 'lbl_per_conn_up',
hideLabel: true,
width: 185,
style: "padding-top:4px;"
}, {
xtype: 'numberfield',
itemId: 'per_conn_up',
name: 'per_conn_up',
maxLength: 5,
width: 70,
allowDecimals: false,
validator: function (v) {
if (v.length == 0) return _S.FTP_STR25;
return true;
}
}, {
xtype: 'displayfield',
value: 'KB/s',
style: "padding-top:4px;padding-left:4px;"
}]
}, {
layout: 'column',
hideLabel: true,
border: false,
style: 'font-size:12px;padding-top:5px;',
items: [{
xtype: 'displayfield',
value: _S.FTP_SERVICE_WIZ_STR22,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR22',
hideLabel: true,
width: 185,
style: "padding-top:4px;"
}, {
xtype: 'numberfield',
itemId: 'per_conn_down',
name: 'per_conn_down',
maxLength: 5,
width: 70,
allowDecimals: false,
validator: function (v) {
if (v.length == 0) return _S.FTP_STR25;
return true;
}
}, {
xtype: 'displayfield',
value: ' KB/s',
style: "padding-top:4px;padding-left:4px;"
}]
}],
onNext: function () {
var type_str = [];
if (step4Form.findField('regular').getValue()) type_str.push('FTP_STR14');
if (step4Form.findField('sslv3').getValue()) type_str.push('FTP_STR15');
var tmpAry = [];
Ext.each(type_str, function (data) {
tmpAry.push(_S[data]);
});
step6Form.findField("ftp_type_str").setValue(tmpAry.join());
step6Form.findField("ftp_type_str").qInternationalFn = function (cmp) {
var tmpAry = [];
Ext.each(type_str, function (data) {
tmpAry.push(_S[data]);
});
cmp.setValue(tmpAry.join());
};
step6Form.findField("ftp_port_str").setValue(step4Form.findField('ftp_port').getValue());
var unicode_str = (step4Form.findField('ftp_unicode_group').getValue().inputValue == '1') ? 'FTP_STR11' : 'FTP_STR12';
step6Form.findField("ftp_unicode_str").setValue(_S[unicode_str]);
step6Form.findField("ftp_unicode_str").qInternationalFn = function (cmp) {
cmp.setValue(_S[unicode_str]);
};

var allowanonymous_str = (step4Form.findField('ftp_allowanonymous_group').getValue().inputValue == '1') ? 'FTP_STR11' : 'FTP_STR12';
step6Form.findField("ftp_allowanonymous_str").setValue(_S[allowanonymous_str]);
step6Form.findField("ftp_allowanonymous_str").qInternationalFn = function (cmp) {
cmp.setValue(_S[allowanonymous_str]);
};

var ftp_maxinstances = step5Form.findField('ftp_maxinstances');
step6Form.findField("ftp_maxinstances_str").setValue(ftp_maxinstances.getValue());
step6Form.findField("ftp_maxinstances_str").qInternationalFn = function (cmp) {
cmp.setValue(ftp_maxinstances.getValue());
};

var ftp_maxconn_per_acount = step5Form.findField('ftp_maxconn_per_acount');
step6Form.findField("ftp_maxconn_per_acount_str").setValue(ftp_maxconn_per_acount.getValue());
step6Form.findField("ftp_maxconn_per_acount_str").qInternationalFn = function (cmp) {
cmp.setValue(ftp_maxconn_per_acount.getValue());
};

var per_conn_up = step5Form.findField('per_conn_up');
var per_conn_down = step5Form.findField('per_conn_down');
var conn_up_str = '',
conn_down_str = '',
bandwidth_str = '';
if (step5Form.findField('ftp_bandwidth_en_group').getValue().inputValue == '1') {
bandwidth_str = 'FTP_STR11';
conn_up_str = per_conn_up.getValue();
conn_down_str = per_conn_down.getValue();
} else {
bandwidth_str = 'FTP_STR12';
conn_up_str = conn_down_str = '---';
}
step6Form.findField("per_conn_up_str").setValue(conn_up_str);
step6Form.findField("per_conn_up_str").qInternationalFn = function (cmp) {
cmp.setValue(conn_up_str);
};
step6Form.findField("per_conn_down_str").setValue(conn_down_str);
step6Form.findField("per_conn_down_str").qInternationalFn = function (cmp) {
cmp.setValue(conn_down_str);
};

step6Form.findField("ftp_bandwidth_en_str").setValue(_S[bandwidth_str]);
step6Form.findField("ftp_bandwidth_en_str").qInternationalFn = function (cmp) {
cmp.setValue(_S[bandwidth_str]);
};
return ftp_maxinstances.isValid() && ftp_maxconn_per_acount.isValid() && per_conn_up.isValid() && per_conn_down.isValid();
}
});
var step6 = new QNAP.QOS.wizard.formPanel({
itemId: 'step6',
nextId: 'finish',
headerTitle: _S.FTP_SERVICE_WIZ_STR01,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR01',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
defaults: {
xtype: 'displayfield',
qInternational: true,
labelSeparator: ''
},
labelWidth: 200,
autoScroll: true,
items: [{
itemId: 'ftp_type_str',
name: 'ftp_type_str',
fieldLabel: _S.FTP_STR27,
qInternationalKey: 'FTP_STR27'
}, {
itemId: 'ftp_port_str',
name: 'ftp_port_str',
fieldLabel: _S.FTP_SERVICE_WIZ_STR15,
qInternationalKey: 'FTP_SERVICE_WIZ_STR15'
}, {
itemId: 'ftp_unicode_str',
name: 'ftp_unicode_str',
fieldLabel: _S.FTP_SERVICE_WIZ_STR16,
qInternationalKey: 'FTP_SERVICE_WIZ_STR16'
}, {
xtype: 'displayfield',
itemId: 'ftp_allowanonymous_str',
name: 'ftp_allowanonymous_str',
fieldLabel: _S.FTP_SERVICE_WIZ_STR17,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR17'
}, {
itemId: 'ftp_maxinstances_str',
name: 'ftp_maxinstances_str',
fieldLabel: _S.FTP_SERVICE_WIZ_STR18,
qInternationalKey: 'FTP_SERVICE_WIZ_STR18'
}, {
itemId: 'ftp_maxconn_per_acount_str',
name: 'ftp_maxconn_per_acount_str',
fieldLabel: _S.FTP_SERVICE_WIZ_STR19,
qInternationalKey: 'FTP_SERVICE_WIZ_STR19'
}, {
itemId: 'ftp_bandwidth_en_str',
name: 'ftp_bandwidth_en_str',
fieldLabel: _S.FTP_SERVICE_WIZ_STR24,
qInternationalKey: 'FTP_SERVICE_WIZ_STR24'
}, {
itemId: 'per_conn_up_str',
name: 'per_conn_up_str',
fieldLabel: _S.FTP_SERVICE_WIZ_STR21,
qInternationalKey: 'FTP_SERVICE_WIZ_STR21'
}, {
itemId: 'per_conn_down_str',
name: 'per_conn_down_str',
fieldLabel: _S.FTP_SERVICE_WIZ_STR22,
qInternationalKey: 'FTP_SERVICE_WIZ_STR22'
}],
onNext: function () {
var para = {};
if (step4Form.findField('regular').getValue()) para.regular = 1;
if (step4Form.findField('sslv3').getValue()) para.sslv3 = 1;
para.ftp_port = step4Form.findField('ftp_port').getValue();
para.ftp_unicode = step4Form.findField('ftp_unicode_group').getValue().inputValue;
para.ftp_allowanonymous = step4Form.findField('ftp_allowanonymous_group').getValue().inputValue;
para.ftp_maxinstances = step5Form.findField('ftp_maxinstances').getValue();
para.ftp_maxconn_per_acount = step5Form.findField('ftp_maxconn_per_acount').getValue();
if (step5Form.findField('ftp_bandwidth_en_group').getValue().inputValue == '1') {
para.ftp_bandwidth_en = 1;
para.per_conn_up = step5Form.findField('per_conn_up').getValue();
para.per_conn_down = step5Form.findField('per_conn_down').getValue();
}
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'ftp_service'
}, {
action: 'add_ftp_service'
}),
method: 'POST',
params: para,
success: function (response, opts) {
fn._getApp().fireEvent('serviceupdate', fn._getApp().id, 'ftpUpdate');
},
failure: function () {}
});
return true;
}
});
var finishPanel = new QNAP.QOS.wizard.formPanel({
itemId: 'finish',
headerTitle: _S.FTP_SERVICE_WIZ_STR03,
qInternational: true,
qInternationalKey: 'FTP_SERVICE_WIZ_STR03',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
defaults: {
xtype: 'displayfield',
qInternational: true,
labelSeparator: ''
},
hideLabels: true,
items: [{
value: _S.FTP_SERVICE_WIZ_STR25,
qInternationalKey: 'FTP_SERVICE_WIZ_STR25',
style: 'font-weight:bold;'
}, {
value: _S.FTP_SERVICE_WIZ_STR26,
qInternationalKey: 'FTP_SERVICE_WIZ_STR26'
}]
});

var step4Form = step4.getForm();
var step5Form = step5.getForm();
var step6Form = step6.getForm();

items = {
steps: [step1, step2, step3, step4, step5, step6, finishPanel],
onCancel: function () {
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.close();
},
finish: function () {
try {
var activeItem = this.content.layout.activeItem;
activeItem.onSave();
} catch (e) {}
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.onFinish();
this.close();
}
};

ajax_info = {
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi', {
wiz_func: 'ftp_service'
}),
method: 'POST',
success: function (response, opts) {
fn._getMainWindow().setTitle(_S.FTP_SERVICE_WIZ);
fn._getMainWindow().defaultTitle = _S.FTP_SERVICE_WIZ;
fn._getMainWindow().qInternationalKey = 'FTP_SERVICE_WIZ';
var xmlData = response.responseXML;
if (xmlData != undefined) {
ftpServerEnabledValue = Ext.DomQuery.selectValue('ftpServerEnabled', xmlData);
step4Form.findField('regular').setValue(Ext.DomQuery.selectValue('regular', xmlData) == '1');
step4Form.findField('sslv3').setValue(Ext.DomQuery.selectValue('sslv3', xmlData) == '1');
step4Form.findField('ftp_port').setValue(Ext.DomQuery.selectValue('ftp_port', xmlData));
step4Form.findField('ftp_unicode_group').setValue(Ext.DomQuery.selectValue('ftp_unicode', xmlData));
step4Form.findField('ftp_allowanonymous_group').setValue(Ext.DomQuery.selectValue('ftp_allowanonymous', xmlData));
step5Form.findField('ftp_bandwidth_en_group').setValue(Ext.DomQuery.selectValue('ftp_bandwidth_en', xmlData));
step5Form.findField('ftp_maxinstances').setValue(Ext.DomQuery.selectValue('ftp_maxinstances', xmlData));
step5Form.findField('ftp_maxconn_per_acount').setValue(Ext.DomQuery.selectValue('ftp_maxconn_per_acount', xmlData));
step5Form.findField('per_conn_up').setValue(Ext.DomQuery.selectValue('per_conn_up', xmlData));
step5Form.findField('per_conn_down').setValue(Ext.DomQuery.selectValue('per_conn_down', xmlData));
}
},
failure: function () {}
};

config.title = _S.FTP_SERVICE_WIZ;
config.defaultTitle = _S.FTP_SERVICE_WIZ;
config.qInternationalKey = 'FTP_SERVICE_WIZ';
} else if (config.category == 'wRemoteReplication') {
function getRemotePathFreeSpace(path) {
var para = {
subfunc: 'remote_rep',
get_remote_path_free_space: 1,
count: _dc,
path: path,
SMB_USERNAME: step2Form.findField('userName').getValue(),
SMB_PASSWD: step2Form.findField('userPassword').getValue(),
RR_CLIENT_PORT: step2Form.findField('bkRsyncPort').getValue(),
SMB_LOCATION: step2Form.findField('serverLocation').getValue()
};

QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'backup/backupRequest.cgi'),
method: 'POST',
params: para,
success: function (response, opts) {
var result = Ext.DomQuery.selectValue('freesize', response.responseXML);
var errorCode = Ext.DomQuery.selectValue('errorCode', response.responseXML);
var msg = '';
if (result == 'Error') {
switch (errorCode) {
case -44:
msg = _S.MISC_SCH_TITLE_STR19;
break;
case -7:
msg = _S.MISC_SCH_TITLE_STR18;
break;
case -3:
msg = _S.MISC_SCH_TITLE_STR20;
break;
default:
msg = _S.MISC_SCH_TITLE_STR12;
break;
}
} else {
if (result >= 1024) {
var size = result / 1024;
msg = size.toFixed(3) + " GB";
} else {
msg = result + " MB";
}
}
step3Form.findField('removePathFreeSpace').setValue(msg);
},
failure: function () {}
});
}

function rrScheduleChange(radio, checked) {
if (!checked) return;
var c = radio.ownerCt.ownerCt;
c.getComponentEx('comboHour').setDisabled(true);
c.getComponentEx('comboMin').setDisabled(true);
c.getComponentEx('comboWeekly').setDisabled(true);
c.getComponentEx('comboMonthly').setDisabled(true);

switch (radio.itemId) {
case "Day":
c.getComponentEx('comboHour').setDisabled(false);
c.getComponentEx('comboMin').setDisabled(false);
break;
case "week":
c.getComponentEx('comboWeekly').setDisabled(false);
c.getComponentEx('comboHour').setDisabled(false);
c.getComponentEx('comboMin').setDisabled(false);
break;
case "month":
c.getComponentEx('comboHour').setDisabled(false);
c.getComponentEx('comboMin').setDisabled(false);
c.getComponentEx('comboMonthly').setDisabled(false);
break;
}
}

function deepSearchComponent(item, itemId) {
var c;
if (item && item.items) {
c = item.get(itemId);
var index = 0;
if (c) return c;
Ext.each(item.items, function (item) {
c = deepSearchComponent(item.items, itemId);
if (c) return false;
});
}
return c;
}

var status = {
rsync: [],
rtrr: new Ext.util.MixedCollection(),
ed: new Ext.util.MixedCollection()
};

var rsyncSm = new Ext.grid.CheckboxSelectionModel({
dataIndex: 'check',
checkOnly: true,
renderer: function (v, p, record) {
var pidstatus = record.get('pidStatus');
if (pidstatus == 1 || pidstatus == 3) {
return '<div class="x-grid3-row-checker x-grid3-row-checker-disabled">&#160;</div>';
} else {
return '<div class="x-grid3-row-checker">&#160;</div>';
}
},
listeners: {
rowdeselect: function (sm) {
status.rsync = sm.getSelections();
},
rowselect: function (sm) {
status.rsync = sm.getSelections();
},
beforerowselect: function (sm, rowIndex, keep, r) {
var pidstatus = r.get('pidStatus')
if (pidstatus == 1 || pidstatus == 3) return false;
}
}
});

var rsyncStoreParams = {
params: {
subfunc: 'remote_rep',
count: _dc,
sid: QNAP.QOS.user.sid
},
add: false
};

var rsyncStore = new Ext.data.XmlStore({
autoDestroy: true,
storeId: "rsyncStore",
remoteSort: true,
url: "../cgi-bin/backup/backupRequest.cgi?",
record: 'backupJob',
totalProperty: 'count',
fields: ['name', 'bk_pid', 'bkRsyncMode', 'bkType', 'bkMonth', 'bkWeek', 'bkHour', 'bkMinute', 'bkOption', 'bkRsyncPort', 'bkSSHPort', 'bkStatus', 'bktime', 'pidStatus', 'piProgress', 'pnsRemain', 'pidError', 'bSparse', 'bSuspedned', 'bktime_start', 'bktime_finish', 'bkTimeString', 'bkStatusString', 'pidStatus', 'pidError', 'serverLocation', 'userName', 'userPassword',
{
name: 'remotePath',
mapping: 'remoteBackupNAS/path'
}, {
name: 'remoteVolume',
mapping: 'remoteBackupNAS/volume'
}, {
name: 'localPath',
mapping: 'localBackupNAS/path'
}, {
name: 'localVolume',
mapping: 'localBackupNAS/volume'
}],
listeners: {
beforeload: function (s, params) {
Ext.applyIf(params, rsyncStoreParams);
Ext.applyIf(params.params, rsyncStoreParams.params);
},
load: function (store, records, options) {
Ext.each(status.rsync, function (selected) {
var rs = store.query('bk_pid', selected.data.bk_pid);
rsyncSm.selectRecords(rs.items, true);
});
}
}
});

var editStep1 = new QNAP.QOS.wizard.formPanel({
itemId: 'editStep1',
nextId: 'editStep2',
headerTitle: _S.BACKUP_STR_0,
qInternational: true,
qInternationalKey: 'BACKUP_STR_0',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 190,
labelSeparator: '',
items: [{
xtype: 'displayfield',
itemId: 'wizInfo',
value: _S.BACKUP_STR_1 + _S.BACKUP_STR03,
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setValue(_S.BACKUP_STR_1 + _S.BACKUP_STR03);
},
hideLabel: true
}, {
xtype: 'combo',
itemId: 'bkRsyncMode',
mode: 'local',
triggerAction: 'all',
fieldLabel: _S.MISC_SCH_NEW_STR04,
qInternational: true,
qInternationalKey: 'MISC_SCH_NEW_STR04',
qInternationalFn: function (cmp) {
var v = cmp.getValue();
cmp.getStore().each(function (r) {
r.set('text', _S[r.data.qInternationalKey]);
});
cmp.setValue(v);
},
labelSeparator: '',
editable: false,
valueField: 'key',
displayField: 'text',
width: 150,
store: new Ext.data.SimpleStore({
fields: ['value', 'text', 'key', 'qInternationalKey'],
data: [
['QNAP_mode', _S.MISC_SCH_NEW_STR05, '1', 'MISC_SCH_NEW_STR05'],
['normal_mode', _S.MISC_SCH_NEW_STR06, '0', 'MISC_SCH_NEW_STR06']
]
}),
value: '1'
}, {
xtype: 'textfield',
itemId: 'name',
maxLength: 16,
width: 150,
qInternational: true,
qInternationalKey: 'BACKUP_STR05',
fieldLabel: _S.BACKUP_STR05,
labelSeparator: '',
allowBlank: false,
validator: function (value) {
this.blankText = _S.MISC_BACKUP_ERROR_MSG201;
if (/[`*|\\;:?,"'<>]/.test(value)) return _S.MISC_BACKUP_ERROR_MSG303;
var index = rsyncStore.find('name', new RegExp('^' + value + '$'));
return (index == -1) ? true : _S.MISC_BACKUP_ERROR_MSG10;
}
}, {
xtype: 'hidden',
itemId: 'oldName',
value: ''
}, {
xtype: 'hidden',
itemId: 'oldStatus',
value: ''
}],
onNext: function () {
return step1Form.isValid();
}
});

var editStep2 = new QNAP.QOS.wizard.formPanel({
itemId: 'editStep2',
nextId: 'editStep3',
headerTitle: _S.MISC_SCH_NEW_STR13,
qInternational: true,
qInternationalKey: 'MISC_SCH_NEW_STR13',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 230,
labelSeparator: '',
items: [{
xtype: 'textfield',
itemId: 'serverLocation',
fieldLabel: _S.MISC_SCH_NEW_STR09,
allowBlank: false,
qInternational: true,
qInternationalKey: 'MISC_SCH_NEW_STR09',
labelSeparator: '',
validator: function () {
this.blankText = _S.MISC_BACKUP_ERROR_MSG205;
return true;
}
}, {
xtype: 'textfield',
itemId: 'userName',
qInternational: true,
qInternationalKey: 'IEI_NAS_SECURITY42',
labelSeparator: '',
validator: function () {
var rMode = editStep1.getComponent('bkRsyncMode').getValue();
this.allowBlank = (rMode == '0');
this.blankText = _S.MISC_BACKUP_ERROR_MSG206;
return true;
},
fieldLabel: _S.IEI_NAS_SECURITY42,
allowBlank: false,
blankText: _S.MISC_BACKUP_ERROR_MSG206
}, {
xtype: 'textfield',
itemId: 'userPassword',
inputType: 'password',
qInternational: true,
qInternationalKey: 'IEI_DEVICE_MSG135',
labelSeparator: '',
validator: function (value) {
var rMode = editStep1.getComponent('bkRsyncMode').getValue();
var userName = editStep2.getComponent('userName').getValue();
this.allowBlank = (rMode == '0');
this.blankText = _S.QUICK04_ALERT09;
if (userName != 'guest' && rMode == '0') {
if (userName == '' && value != '') return _S.ERROR_INPUT;
}
return true;
},
fieldLabel: _S.IEI_DEVICE_MSG135
}, {
xtype: 'numberfield',
itemId: 'bkRsyncPort',
value: 873,
fieldLabel: _S.MISC_SCH_TITLE_STR04,
qInternational: true,
allowNegative: false,
qInternationalKey: 'MISC_SCH_TITLE_STR04',
labelSeparator: '',
validator: function () {
this.maxText = _S.NIC_WAN_ALERT07;
this.minText = _S.NIC_WAN_ALERT07;
this.blankText = _S.FTP_STR41;
this.nanText = _S.IEI_NAS_ALERT89;
return true;
},
maxLength: 6,
maxValue: 65535,
minValue: 1,
decimalPrecision: 0,
allowBlank: false
}, {
xtype: 'button',
itemId: 'name',
qInternational: true,
qInternationalKey: 'IEI_IDS_STRING64',
qInternationalFn: function (cmp) {
cmp.label.update(_S.MISC_SCH_NEW_STR54 + (Ext.isString(cmp.labelSeparator) ? cmp.labelSeparator : cmp.ownerCt.layout.labelSeparator));
},
fieldLabel: _S.MISC_SCH_NEW_STR54,
labelSeparator: '',
text: _S.IEI_IDS_STRING64,
cls: 'qos-systemPreferences-btn',
handler: function () {
Ext.Msg.wait(_S.NIC_ITUNES_STR036);
var s = step1Form.findField('bkRsyncMode').getStore();
var para = {
wiz_func: 'backup',
action: 'test_server',
count: _dc,
RR_CLIENT_MODE: s.query('key', step1Form.findField('bkRsyncMode').getValue()).items[0].data.value,
SMB_LOCATION: step2Form.findField('serverLocation').getValue(),
RR_CLIENT_PORT: step2Form.findField('bkRsyncPort').getValue(),
REMOTE_VOL: 'undefined',
REMOTE_PATH: '/',
SMB_USERNAME: step2Form.findField('userName').getValue(),
SMB_PASSWD: step2Form.findField('userPassword').getValue(),
No_vol_info: 'yes'
};

QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi'),
method: 'POST',
params: para,
success: function (response, opts) {
var result = Ext.DomQuery.selectValue('Result', response.responseXML);
var msg = '';
switch (result) {
case '0':
msg = _S.MISC_SCH_NEW_STR59;
break;
case '1':
msg = _S.MISC_SCH_NEW_STR62;
break;
case '2':
msg = _S.MISC_SCH_NEW_STR61;
break;
}
Ext.Msg.alert('', msg);
},
failure: function () {}
});
}
}],
onNext: function () {
return step2Form.isValid();
}
});

var remotPathTreeLoader = new Ext.tree.TreeLoader({
dataUrl: '../cgi-bin/wizReq.cgi?',
baseParams: {
sid: QNAP.QOS.user.sid,
count: _dc,
wiz_func: 'get_remote_dirs',
dir: '/'
},
listeners: {
beforeload: function (loader, node, callback) {
var s = step1Form.findField('bkRsyncMode').getStore();
var bp = loader.baseParams;
bp.dir = QNAP.QOS.quickWizard.getNodeFullPath(node);
bp.SMB_LOCATION = step2Form.findField('serverLocation').getValue();
bp.RR_CLIENT_PORT = step2Form.findField('bkRsyncPort').getValue();
bp.SMB_USERNAME = step2Form.findField('userName').getValue();
bp.SMB_PASSWD = step2Form.findField('userPassword').getValue();
bp.RR_CLIENT_MODE = s.query('key', step1Form.findField('bkRsyncMode').getValue()).items[0].data.value;
},
load: function (loader, parentNode, res) {
var errorMsgStr = '';
if (Ext.isEmpty(res) || Ext.isEmpty(res.responseText)) {
if (parentNode.id == '0' || remotePathTreeCombo.getValue().trim() == '') {
errorMsgStr = _S.NIC_WEB_STR04 + _S.QUICK09_STR01 + _S.MISC_SCH_TITLE_STR15;
}
}
remotePathTreeCombo.ownerCt.getComponent('errorMsg').setValue(errorMsgStr);
var nodes = [];
Ext.each(res.responseText.split(new RegExp(/<ul.+?>\s*<li .+?>\s*<a .+?>|<\/a><\/li><\/ul>/)), function (node) {
Ext.isEmpty(node) ? Ext.emptyFn() : nodes.push({
text: node,
fullPath: parentNode.fullPath + node
});
});
parentNode.appendChild(nodes);
connecting.setVisible(false);
},
loadexception: function (loader, parentNode, res) {
var errorMsgStr = '';
if (Ext.isEmpty(res) || Ext.isEmpty(res.responseText)) {
if (remotePathTreeCombo.getValue().trim() == '') {
errorMsgStr = _S.NIC_WEB_STR04 + _S.QUICK09_STR01 + _S.MISC_SCH_TITLE_STR15;
}
}
remotePathTreeCombo.ownerCt.getComponent('errorMsg').setValue(errorMsgStr);
}
}
});

var remotePathTree = new Ext.tree.TreePanel({
loader: remotPathTreeLoader,
border: false,
rootVisible: false,
root: new Ext.tree.AsyncTreeNode({
text: '/',
id: '0',
fullPath: '/'
}),
listeners: {
click: function (node, e) {
remotePathTreeCombo.setValue(QNAP.QOS.quickWizard.getNodeFullPath(node));
getRemotePathFreeSpace(remotePathTreeCombo.getRawValue());
},
load: function () {
remotePathTree.setHeight(remotePathTreeCombo.list.getHeight() - 2);
}
}
});
var connecting = new Ext.form.Label({
text: _S.NIC_VIEW_STR44,
itemId: 'connecting'
});

var remoteComboId = Ext.id();
var remotePathTreeCombo = new Ext.form.ComboBox({
store: new Ext.data.SimpleStore({
fields: [],
data: [
[]
]
}),
qInternational: true,
qInternationalKey: 'MISC_RTRR_STR10',
fieldLabel: _S.MISC_RTRR_STR10,
initQuery: function () {
this.doQuery(this.getRawValue(), true);
},
id: remoteComboId,
itemId: 'path',
mode: 'local',
width: 150,
triggerAction: 'all',
tpl: "<tpl for='.'><div style='height:200px'><div id='" + remoteComboId + "_tree' style='height:200px'></div></div></tpl>",
selectedClass: '',
onSelect: Ext.emptyFn,
validator: QNAP.QOS.quickWizard.pathValidator,
fileTree: remotePathTree,
loadingLabel: connecting,
allowBlank: false,
blankText: _S.IEI_NAS_ALERT28,
listeners: {
expand: {
fn: function (cmp) {
remotePathTree.mon(cmp.list, 'resize', function () {
remotePathTree.setHeight(cmp.list.getHeight());
});
connecting.render(remoteComboId + '_tree');
remotePathTree.render(remoteComboId + '_tree');
},
single: true
},
afterrender: function (e) {
this.mon(this.el, 'click', this.onTriggerClick, this);
}
},
onViewClick: function (doFocus) {
var index = this.view.getSelectedIndexes()[0],
s = this.store,
r = s.getAt(index);
if (r) {
this.onSelect(r, index);
}
if (doFocus != false) {
this.el.focus();
}
}
});

var editStep3 = new QNAP.QOS.wizard.formPanel({
itemId: 'editStep3',
nextId: 'editStep4',
headerTitle: _S.MISC_SCH_NEW_STR13,
qInternational: true,
qInternationalKey: 'MISC_SCH_NEW_STR13',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 200,
items: [remotePathTreeCombo,
{
xtype: 'displayfield',
hideLabel: true,
qInternational: true,
qInternationalKey: 'MISC_SCH_TITLE_STR14',
value: _S.MISC_SCH_TITLE_STR14
}, {
xtype: 'displayfield',
hideLabel: true,
itemId: 'errorMsg',
style: {
color: 'red'
}
}, {
xtype: 'displayfield',
itemId: 'removePathFreeSpace',
qInternational: true,
qInternationalKey: 'MISC_SCH_TITLE_STR13',
fieldLabel: _S.MISC_SCH_TITLE_STR13
}],
onNext: function () {
return step3Form.isValid();
},
listeners: {
show: function () {
editStep3.getComponent('path').fileTree.setRootNode(new Ext.tree.AsyncTreeNode({
text: '/',
id: '0',
fullPath: '/'
}));
editStep3.getComponent('path').loadingLabel.setVisible(true);
}
}
});

var localPathTreeLoader = new Ext.tree.TreeLoader({
dataUrl: '../cgi-bin/wizReq.cgi?',
baseParams: {
sid: QNAP.QOS.user.sid,
count: _dc,
wiz_func: 'get_local_dirs',
dir: '/'
},
listeners: {
beforeload: function (loader, node, callback) {
var s = step1Form.findField('bkRsyncMode').getStore();
var bp = loader.baseParams;
bp.dir = QNAP.QOS.quickWizard.getNodeFullPath(node);
},
load: function (loader, parentNode, res) {
var nodes = [];
Ext.each(res.responseText.split(new RegExp(/<ul.+?>\s*<li .+?>\s*<a .+?>|<\/a><\/li><\/ul>/)), function (node) {
Ext.isEmpty(node) ? Ext.emptyFn() : nodes.push({
text: node,
fullPath: parentNode.fullPath + node
});
});
parentNode.appendChild(nodes);
connecting.setVisible(false);
}
}
});

var localPathTree = new Ext.tree.TreePanel({
loader: localPathTreeLoader,
border: false,
rootVisible: false,
root: new Ext.tree.AsyncTreeNode({
text: '/',
id: '0',
fullPath: '/'
}),
listeners: {
click: function (node, e) {
localPathTreeCombo.setValue(QNAP.QOS.quickWizard.getNodeFullPath(node));
}
}
});

var connecting = new Ext.form.Label({
text: _S.NIC_VIEW_STR44,
itemId: 'connecting'
});
var localComboId = Ext.id();
var localPathTreeCombo = new Ext.form.ComboBox({
store: new Ext.data.SimpleStore({
fields: [],
data: [
[]
]
}),
qInternational: true,
qInternationalKey: 'MISC_SCH_NEW_STR78',
fieldLabel: _S.MISC_SCH_NEW_STR78,
initQuery: function () {
this.doQuery(this.getRawValue(), true);
},
id: localComboId,
itemId: 'path',
mode: 'local',
width: 150,
triggerAction: 'all',
tpl: "<tpl for='.'><div style='height:200px'><div id='" + localComboId + "_tree'></div></div></tpl>",
selectedClass: '',
onSelect: Ext.emptyFn,
validator: QNAP.QOS.quickWizard.pathValidator,
fileTree: localPathTree,
loadingLabel: connecting,
allowBlank: false,
blankText: _S.IEI_NAS_ALERT28,
listeners: {
expand: function () {
connecting.render(localComboId + '_tree');
localPathTree.render(localComboId + '_tree');
},
afterrender: function (e) {
this.mon(this.el, 'click', this.onTriggerClick, this);
}
},
onViewClick: function (doFocus) {
var index = this.view.getSelectedIndexes()[0],
s = this.store,
r = s.getAt(index);
if (r) {
this.onSelect(r, index);
}
if (doFocus != false) {
this.el.focus();
}
}
});

var editStep4 = new QNAP.QOS.wizard.formPanel({
itemId: 'editStep4',
nextId: 'editStep5',
headerTitle: _S.BACKUP_STR06,
qInternational: true,
qInternationalKey: 'BACKUP_STR06',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 200,
items: [localPathTreeCombo,
{
xtype: 'displayfield',
hideLabel: true,
qInternational: true,
qInternationalKey: 'MISC_SCH_TITLE_STR14',
value: _S.MISC_SCH_TITLE_STR14
}],
onNext: function () {
return step4Form.isValid();
},
listeners: {
show: function () {
editStep4.getComponent('path').fileTree.setRootNode(new Ext.tree.AsyncTreeNode({
text: '/',
id: '0',
fullPath: '/'
}));
editStep4.getComponent('path').loadingLabel.setVisible(true);
}
}
});

var editStep5 = new QNAP.QOS.wizard.formPanel({
itemId: 'editStep5',
nextId: 'editStep6',
headerTitle: _S.BACKUP_STR10,
qInternational: true,
qInternationalKey: 'BACKUP_STR10',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 200,
items: [{
xtype: 'fieldset',
title: _S.BACKUP_STR11,
qInternational: true,
qInternationalKey: 'BACKUP_STR11',
layout: 'column',
itemId: 'fieldset',
cls: 'bottom-fieldset',
anchor: '100%',
items: [{
columnWidth: 1,
layout: 'form',
itemId: 'redioNowForm',
border: false,
items: {
xtype: 'radio',
itemId: 'immediate',
checked: true,
hideLabel: true,
boxLabel: _S.MISC_SCH_NEW_STR27,
qInternational: true,
qInternationalKey: {
boxLabel: 'MISC_SCH_NEW_STR27'
},
name: 'backup_type',
inputValue: 'immediate',
handler: function (radio, checked) {
rrScheduleChange(radio, checked);
}
}
}, {
columnWidth: 1,
layout: 'form',
border: false,
itemId: 'redioDailyForm',
items: {
xtype: 'radio',
hideLabel: true,
qInternational: true,
qInternationalKey: {
boxLabel: 'MISC_SCH_NEW_STR29'
},
boxLabel: _S.MISC_SCH_NEW_STR29,
columnWidth: 1,
name: 'backup_type',
itemId: 'Day',
inputValue: 'Day',
handler: function (radio, checked) {
rrScheduleChange(radio, checked);
}
}
}, {
columnWidth: .3,
layout: 'form',
itemId: 'radioWeeklyForm',
border: false,
items: {
xtype: 'radio',
hideLabel: true,
qInternational: true,
qInternationalKey: {
boxLabel: 'MISC_SCH_NEW_STR18'
},
boxLabel: _S.MISC_SCH_NEW_STR18,
itemId: 'week',
name: 'backup_type',
inputValue: 'week',
handler: function (radio, checked) {
rrScheduleChange(radio, checked);
}
}
}, {
columnWidth: .7,
layout: 'form',
itemId: 'comboWeeklyForm',
border: false,
items: {
xtype: 'combo',
itemId: 'comboWeekly',
hideLabel: true,
disabled: true,
qInternational: true,
qInternationalFn: function (cmp) {
var v = cmp.getValue();
cmp.getStore().each(function (r) {
r.set('text', _S[r.data.qInternationalKey]);
});
cmp.setValue(v);
},
store: new Ext.data.SimpleStore({
fields: ['value', 'key', 'text', 'qInternationalKey'],
data: [
[1, 0, _S.MISC_SCH_NEW_STR20, 'MISC_SCH_NEW_STR20'],
[2, 1, _S.MISC_SCH_NEW_STR21, 'MISC_SCH_NEW_STR21'],
[3, 2, _S.MISC_SCH_NEW_STR22, 'MISC_SCH_NEW_STR22'],
[4, 3, _S.MISC_SCH_NEW_STR23, 'MISC_SCH_NEW_STR23'],
[5, 4, _S.MISC_SCH_NEW_STR24, 'MISC_SCH_NEW_STR24'],
[6, 5, _S.MISC_SCH_NEW_STR25, 'MISC_SCH_NEW_STR25'],
[7, 6, _S.MISC_SCH_NEW_STR26, 'MISC_SCH_NEW_STR26']
]
}),
value: '0',
valueField: 'key',
displayField: 'text',
editable: false,
mode: 'local',
triggerAction: 'all',
width: 100
}
}, {
columnWidth: .3,
layout: 'form',
itemId: 'radioMonthlyForm',
border: false,
items: {
xtype: 'radio',
hideLabel: true,
boxLabel: _S.MISC_SCH_NEW_STR19,
qInternational: true,
qInternationalKey: {
boxLabel: 'MISC_SCH_NEW_STR19'
},
itemId: 'month',
name: 'backup_type',
inputValue: 'month',
handler: function (radio, checked) {
rrScheduleChange(radio, checked);
}
}
}, {
columnWidth: .7,
itemId: 'comboMonthlyForm',
layout: 'form',
border: false,
items: {
xtype: 'combo',
itemId: 'comboMonthly',
hideLabel: true,
disabled: true,
store: new Ext.data.SimpleStore({
fields: ['value', 'key', 'text'],
data: [
[1, 0, '01'],
[2, 1, '02'],
[3, 2, '03'],
[4, 3, '04'],
[5, 4, '05'],
[6, 5, '06'],
[7, 6, '07'],
[8, 7, '08'],
[9, 8, '09'],
[10, 9, '10'],
[11, 10, '11'],
[12, 11, '12'],
[13, 12, '13'],
[14, 13, '14'],
[15, 14, '15'],
[16, 15, '16'],
[17, 16, '17'],
[18, 17, '18'],
[19, 18, '19'],
[20, 19, '20'],
[21, 20, '21'],
[22, 21, '22'],
[23, 22, '23'],
[24, 23, '24'],
[25, 24, '25'],
[26, 25, '26'],
[27, 26, '27'],
[28, 27, '28'],
[29, 28, '29'],
[30, 29, '30'],
[31, 30, '31']
]
}),
value: '0',
valueField: 'key',
displayField: 'text',
editable: false,
mode: 'local',
triggerAction: 'all',
width: 50,
listWidth: 50
}
}, {
xtype: 'displayfield',
hideLabel: false,
style: QNAP.layout.getDefaultCSS({
indent: 1
}),
columnWidth: .3,
qInternational: true,
qInternationalKey: {
value: 'BACKUP_STR12'
},
value: _S.BACKUP_STR12
}, {
columnWidth: .6,
layout: 'hbox',
itemId: 'timeBox',
border: false,
items: [{
xtype: 'combo',
itemId: 'comboHour',
hideLabel: true,
disabled: true,
store: new Ext.data.SimpleStore({
fields: ['value', 'text'],
data: [
[0, '00'],
[1, '01'],
[2, '02'],
[3, '03'],
[4, '04'],
[5, '05'],
[6, '06'],
[7, '07'],
[8, '08'],
[9, '09'],
[10, '10'],
[11, '11'],
[12, '12'],
[13, '13'],
[14, '14'],
[15, '15'],
[16, '16'],
[17, '17'],
[18, '18'],
[19, '19'],
[20, '20'],
[21, '21'],
[22, '22'],
[23, '23']
]
}),
value: '0',
valueField: 'value',
displayField: 'text',
editable: false,
mode: 'local',
triggerAction: 'all',
width: 50,
listWidth: 50
}, {
xtype: 'displayfield',
value: ':',
style: 'padding:3px;'
}, {
xtype: 'combo',
itemId: 'comboMin',
hideLabel: true,
disabled: true,
store: new Ext.data.SimpleStore({
fields: ['value', 'text'],
data: [
[0, '00'],
[1, '01'],
[2, '02'],
[3, '03'],
[4, '04'],
[5, '05'],
[6, '06'],
[7, '07'],
[8, '08'],
[9, '09'],
[10, '10'],
[11, '11'],
[12, '12'],
[13, '13'],
[14, '14'],
[15, '15'],
[16, '16'],
[17, '17'],
[18, '18'],
[19, '19'],
[20, '20'],
[21, '21'],
[22, '22'],
[23, '23'],
[24, '24'],
[25, '25'],
[26, '26'],
[27, '27'],
[28, '28'],
[29, '29'],
[30, '30'],
[31, '31'],
[32, '32'],
[33, '33'],
[34, '34'],
[35, '35'],
[36, '36'],
[37, '37'],
[38, '38'],
[39, '39'],
[40, '40'],
[41, '41'],
[42, '42'],
[43, '43'],
[44, '44'],
[45, '45'],
[46, '46'],
[47, '47'],
[48, '48'],
[49, '49'],
[50, '50'],
[51, '51'],
[52, '52'],
[53, '53'],
[54, '54'],
[55, '55'],
[56, '56'],
[57, '57'],
[58, '58'],
[59, '59']
]
}),
value: '0',
valueField: 'value',
displayField: 'text',
editable: false,
mode: 'local',
triggerAction: 'all',
width: 50,
listWidth: 50
}]
}],
getComponentEx: function (comp) {
var c = this.getComponent(comp);
c = deepSearchComponent(this.items, comp);
return c;
}
}],
onNext: function () {
return step5Form.isValid();
}
});

var editStep6 = new QNAP.QOS.wizard.formPanel({
itemId: 'editStep6',
nextId: 'editStep7',
headerTitle: _S.BACKUP_STR13,
qInternational: true,
qInternationalKey: 'BACKUP_STR13',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 230,
labelSeparator: '',
defaults: {
hideLabel: true
},
items: [{
xtype: 'container',
layout: 'column',
itemId: 'compositefield',
style: 'font-size:12px;',
items: [{
xtype: 'checkbox',
itemId: 'USE_OF_SSH',
boxLabel: _S.MISC_SCH_NEW_STR67,
qInternational: true,
qInternationalKey: {
boxLabel: 'MISC_SCH_NEW_STR67'
},
disabled: true,
handler: function (ckBox, checked) {
ckBox.ownerCt.getComponent('RR_SSH_PORT').setDisabled(!checked);
}
}, {
xtype: 'displayfield',
style: 'padding-left:11px;'
}, {
xtype: 'numberfield',
itemId: 'RR_SSH_PORT',
value: 22,
width: 70,
allowBlank: false,
disabled: true,
decimalPrecision: 0,
allowNegative: false,
allowDecimals: false,
minValue: 1,
maxValue: 65535,
maxLength: 5,
validator: function (value) {
this.blankText = _S.NIC_WAN_ALERT07;
this.minText = _S.NIC_WAN_ALERT07;
this.maxText = _S.NIC_WAN_ALERT07;
if (value != 22 && Ext.form.VTypes.reservedPort(value)) {
return _S.IEI_DEVICE_MSG160;
}
return true;
}
}]
}, {
xtype: 'displayfield',
value: _S.MISC_SCH_NEW_STR68,
qInternational: true,
qInternationalKey: {
value: 'MISC_SCH_NEW_STR68'
},
cls: 'note-color'
}, {
xtype: 'checkbox',
itemId: 'COMPRESS',
qInternational: true,
qInternationalKey: {
boxLabel: 'MISC_SCH_NEW_STR12'
},
boxLabel: _S.MISC_SCH_NEW_STR12
}, {
xtype: 'checkbox',
itemId: 'STOP_SERVICE',
qInternational: true,
qInternationalKey: {
boxLabel: 'MISC_SCH_NEW_STR52'
},
boxLabel: _S.MISC_SCH_NEW_STR52
}, {
xtype: 'checkbox',
itemId: 'INCREMENTAL_COPY',
qInternational: true,
qInternationalKey: {
boxLabel: 'MISC_SCH_NEW_STR55'
},
boxLabel: _S.MISC_SCH_NEW_STR55
}, {
xtype: 'checkbox',
itemId: 'REMOVE_EX_FILE',
qInternational: true,
qInternationalKey: {
boxLabel: 'MISC_SCH_NEW_STR56'
},
boxLabel: _S.MISC_SCH_NEW_STR56
}, {
xtype: 'checkbox',
itemId: 'SUPPORT_SPARSE_FILE',
qInternational: true,
qInternationalKey: {
boxLabel: 'MISC_SCH_NEW_STR90'
},
boxLabel: _S.MISC_SCH_NEW_STR90
}, {
xtype: 'container',
layout: 'column',
itemId: 'rrSrateDiv',
style: 'font-size:12px;',
items: [{
xtype: 'displayfield',
value: _S.BACKUP_SERVER_STRING05,
qInternational: true,
qInternationalKey: 'BACKUP_SERVER_STRING05',
style: 'padding: 3px 11px 3px 0;',
hideLabel: true
}, {
xtype: 'numberfield',
itemId: 'rrSrate',
qInternational: true,
hidden: true,
hideLabel: false,
decimalPrecision: 0,
allowNegative: false,
allowDecimals: false,
value: 0,
maxValue: 999999,
maxLength: 6,
width: 70
}]
}],
onNext: function () {
var s = step1Form.findField('bkRsyncMode').getStore();
var sshItems = step6Form.findField('compositefield').items;
var remoteVol = step3Form.findField('path').getValue().split(/\\|\//)[1];
var remotePath = step3Form.findField('path').getValue().split(remoteVol)[1].replace(/^\//, '');
var localVol = step4Form.findField('path').getValue().split(/\\|\//)[1];
var localPath = step4Form.findField('path').getValue().split(localVol)[1].replace(/^\//, '');

var para = {
count: _dc,
NAME: step1Form.findField('name').getValue(),
old_schedule_name: step1Form.findField('oldName').getValue(),
old_schedule_status: step1Form.findField('oldStatus').getValue(),
RR_CLIENT_MODE: s.query('key', step1Form.findField('bkRsyncMode').getValue()).items[0].data.value,
SMB_LOCATION: step2Form.findField('serverLocation').getValue(),
RR_CLIENT_PORT: step2Form.findField('bkRsyncPort').getValue(),
SMB_USERNAME: step2Form.findField('userName').getValue(),
SMB_PASSWD: step2Form.findField('userPassword').getValue(),
REMOTE_VOL: remoteVol,
REMOTE_PATH: remotePath,
LOCAL_VOL: localVol,
LOCAL_PATH: localPath,
backup_type: step5Form.findField('immediate').getGroupValue(),
b_week: step5Form.findField('comboWeekly').getValue() + 1,
b_day: step5Form.findField('comboMonthly').getValue(),
TIME_HOUR: step5Form.findField('comboHour').getValue(),
TIME_MIN: step5Form.findField('comboMin').getValue(),
RR_SSH_PORT: sshItems.itemAt(sshItems.findIndex('itemId', 'RR_SSH_PORT')).getValue(),
USE_OF_SSH: sshItems.itemAt(sshItems.findIndex('itemId', 'USE_OF_SSH')).getValue() ? '1' : '0',
RR_SRATE: step6Form.findField('rrSrate').getValue()
};

step6Form.findField('COMPRESS').getValue() ? para.COMPRESS = 1 : true;
step6Form.findField('STOP_SERVICE').getValue() ? para.STOP_SERVICE = 1 : true;
step6Form.findField('INCREMENTAL_COPY').getValue() ? para.INCREMENTAL_COPY = 1 : true;
step6Form.findField('REMOVE_EX_FILE').getValue() ? para.REMOVE_EX_FILE = 1 : true;
step6Form.findField('SUPPORT_SPARSE_FILE').getValue() ? para.SUPPORT_SPARSE_FILE = 1 : true;

para.action = 'add_backup';
para.wiz_func = 'backup';
QNAP.QOS.ajax({
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'wizReq.cgi'),
method: 'POST',
params: para,
success: function (response, opts) {
fn._getApp().fireEvent('serviceupdate', fn._getApp().id, 'rsyncUpdate');
},
failure: function () {}
});
return true;
},
listeners: {
activate: function () {
var sshItems = editStep6.getComponent('compositefield').items;
switch (editStep1.getComponent('bkRsyncMode').getValue()) {
case '0':
sshItems.itemAt(sshItems.findIndex('itemId', 'USE_OF_SSH')).setDisabled(true);
break;
case '1':
sshItems.itemAt(sshItems.findIndex('itemId', 'USE_OF_SSH')).setDisabled(false);
break;
}
}
}
});

var editStep7 = new QNAP.QOS.wizard.formPanel({
itemId: 'editStep7',
headerTitle: _S.BACKUP_STR14,
qInternational: true,
qInternationalKey: 'BACKUP_STR14',
bodyStyle: 'padding: 20px 60px 30px;',
autoScroll: true,
labelWidth: 230,
labelSeparator: '',
hideLabels: true,
items: [{
xtype: 'displayfield',
value: _S.BACKUP_STR15,
qInternational: true,
qInternationalKey: 'BACKUP_STR15'
}]
});

var step1Form = editStep1.getForm();
var step2Form = editStep2.getForm();
var step3Form = editStep3.getForm();
var step4Form = editStep4.getForm();
var step5Form = editStep5.getForm();
var step6Form = editStep6.getForm();

items = {
steps: [editStep1, editStep2, editStep3, editStep4, editStep5, editStep6, editStep7],
onCancel: function () {
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.close();
},
finish: function () {
try {
var activeItem = this.content.layout.activeItem;
activeItem.onSave();
} catch (e) {}
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.onFinish();
this.close();
}
};
ajax_info = {
url: QNAP.QOS.lib.getCgiUrl(QNAP.QOS.config.sitePath + 'backup/backupRequest.cgi'),
method: 'POST',
params: {
subfunc: 'remote_rep',
count_rrjob: '1',
count: _dc
},
success: function (response, opts) {
fn._getMainWindow().setTitle(_S.S_MENU_63);
fn._getMainWindow().defaultTitle = _S.S_MENU_63;
fn._getMainWindow().qInternationalKey = 'S_MENU_63';
var xmlData = response.responseXML;
if (Ext.DomQuery.selectValue('counter', xmlData) >= 64) {
Ext.Msg.alert('', _S.MISC_SCH_TITLE_STR11);
} else {
step6Form.findField('rrSrate').setVisible((Ext.DomQuery.selectValue('supportLimitRate', xmlData) == '1'))
}
},
failure: function () {}
};

config.title = _S.S_MENU_63;
config.defaultTitle = _S.S_MENU_63;
config.qInternationalKey = 'S_MENU_63';
} else if (config.category == 'wMyColudNAS') {
var tplData = QNAP.QOS.quickWizard.qMyCloudNAS(fn);
items = tplData.items;
ajax_info = tplData.ajax_info;
Ext.apply(items, {
onCancel: function () {
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.close();
},
finish: function () {
fn._getApp().fireEvent('serviceupdate', fn._getApp().id, 'myColudNASUpdate');
try {
var activeItem = this.content.layout.activeItem;
activeItem.onSave();
} catch (e) {}
this.mun(this, 'filechange', this.onFileChange, this);
this.mun(this, 'serviceupdate', this.onServiceUpdate, this);
this.onFinish();
this.close();
}
});
config.title = _S.MYCLOUDNAS_WIZARD_TITLE;
config.defaultTitle = _S.MYCLOUDNAS_WIZARD_TITLE;
config.qInternationalKey = 'MYCLOUDNAS_WIZARD_TITLE';
}

Ext.applyIf(items, {
maximizable: false,
minimizable: false,
layout: 'border',
stepIds: [],
modal: true,
cls: 'wizard-modal',
buttonAlign: 'left',
showStepInfo: true,
fbar: {
style: 'padding-left: 7px;',
items: [{
xtype: 'tbtext',
itemId: 'stepInfo',
qInternational: true,
qInternationalFn: function (cmp) {
cmp.setStepInfo();
},
data: {
stdFormat: '{0} {1}/{2}',
stepKey: 'NIC_MS_AD_QUICK_STEP01',
currentStep: 1,
totalStep: 0
},
style: 'font-size:12px;font-weight: bold;color: #7B7B7B;padding-left: 33px;',
setStepInfo: function () {
var step = this;
var data = step.data;
if (data.showStepInfo) {
step.setText(String.format(data.stdFormat, _S[data.stepKey], data.currentStep, data.totalStep));
}
},
text: ''
}, '->',
{
itemId: 'back',
text: _S.QUICK09_STR08,
hidden: true,
qInternational: true,
qInternationalKey: 'QUICK09_STR08',
cls: 'fbarBtn',
overCls: 'ofbarBtn',
hidden: true
}, {
itemId: 'next',
text: _S.QUICK09_STR09,
qInternationalKey: 'QUICK09_STR09',
qInternational: true,
cls: 'fbarBtn',
overCls: 'ofbarBtn'
}, {
itemId: 'cancel',
text: _S.IEI_NAS_BUTTON_CANCEL,
qInternationalKey: 'IEI_NAS_BUTTON_CANCEL',
qInternational: true,
cls: 'fbarBtn',
overCls: 'ofbarBtn'
}, {
itemId: 'finish',
text: _S.QUICK11_TITLE,
qInternationalKey: 'QUICK11_TITLE',
qInternational: true,
cls: 'fbarBtn',
overCls: 'ofbarBtn',
hidden: true
}]
},
listeners: {
beforeshow: function (win) {
var header = win.contentHeader.items.get('header-title');
if (Ext.isEmpty(win.steps[0].headerTitle)) {
header.ownerCt.hide();
} else {
header.ownerCt.show();
header.setValue(win.steps[0].headerTitle);
}
header.ownerCt.ownerCt.doLayout();
win.stepIds.push(win.steps[0].itemId);
if (!Ext.isEmpty(win.winHeight)) win.setSize(600, win.winHeight);
},
activate: function (win) {
win.doLayout();
},
afterrender: function (win) {
var fBar = win.getFooterToolbar();
win.stepInfo = fBar.getComponent('stepInfo');
win.stepInfo.data.showStepInfo = win.showStepInfo;
win.stepInfo.data.totalStep = win.steps.length;
win.stepInfo.setStepInfo();

fBar.getComponent('back').handler = Ext.createDelegate(win.onBack, win);
fBar.getComponent('next').handler = Ext.createDelegate(win.onNext, win);
fBar.getComponent('cancel').handler = Ext.createDelegate(win.onCancel, win);
fBar.getComponent('finish').handler = Ext.createDelegate(win.finish, win);

win.contentHeader = win.items.get('header');
win.content = win.items.get('content');
}
},
items: [{
xtype: 'panel',
itemId: 'header',
region: 'north',
border: false,
height: 58,
items: [{
xtype: 'displayfield',
itemId: 'header-title',
style: 'font-size:14px;font-weight:bold;color:#64AB01;padding: 26px 6px 0px 60px;',
value: 'header'
}, {
xtype: 'displayfield',
html: {
tag: 'img',
src: 'images/toolbar/wizard_line.png'
},
style: 'padding-left:60px;',
width: 4
}]
}, {
xtype: 'panel',
itemId: 'content',
region: 'center',
layout: 'card',
border: false,
activeItem: 0,
items: items.steps
}],
qInternational: true,
qInternationalFn: function (cmp) {
Ext.each(this.steps, function (step) {
step.headerTitle = _S[step.qInternationalKey] || step.qInternationalKey;
});
this.contentHeader.items.get('header-title').setValue(cmp.content.layout.activeItem.headerTitle);
},
setModalWin: function (win) {
this.modalWin = win;
},
stepIndex: 0,
width: 600,
onNext: function () {
var activeItem = this.content.layout.activeItem,
nextId = this.getNextId(activeItem);

if (nextId) {
if (!activeItem.onNext()) return false;
this.content.layout.setActiveItem(nextId);
activeItem = this.content.layout.activeItem;
var stepIndex = this.content.items.indexOf(activeItem);
this.stepInfo.data.currentStep = stepIndex + 1;
this.stepInfo.setStepInfo();
nextId = this.getNextId(activeItem);
var header = this.contentHeader.items.get('header-title');
if (Ext.isEmpty(activeItem.headerTitle)) {
header.ownerCt.hide();
} else {
header.ownerCt.show();
header.setValue(activeItem.headerTitle);
}
header.ownerCt.ownerCt.doLayout();
if (!nextId) {
if (!activeItem.btnBackChk) this.fbar.get('back').hide();
else this.fbar.get('back').show();
this.fbar.get('next').hide();
this.fbar.get('cancel').hide();
this.fbar.get('finish').show();
} else {
this.fbar.get('back').show();
if (activeItem.onNextText) {
this.fbar.get('next').setText(_S[activeItem.onNextText]);
this.fbar.get('next').qInternationalKey = activeItem.onNextText;
} else {
this.fbar.get('next').setText(_S.QUICK09_STR09);
this.fbar.get('next').qInternationalKey = 'QUICK09_STR09';
}
}
this.stepIndex++;
this.stepIds.push(activeItem.itemId);
}
},
onBack: function () {
this.stepIndex--;
this.content.layout.setActiveItem(this.stepIds[this.stepIds.length - 2]);
activeItem = this.content.layout.activeItem;
var header = this.contentHeader.items.get('header-title');
if (Ext.isEmpty(activeItem.headerTitle)) {
header.ownerCt.hide();
} else {
header.ownerCt.show();
header.setValue(activeItem.headerTitle);
}
header.ownerCt.ownerCt.doLayout();
var stepIndex = this.content.items.indexOf(activeItem);
this.stepInfo.data.currentStep = stepIndex + 1;
this.stepInfo.setStepInfo();
this.stepIds.pop();
if (this.stepIndex == 0) {
this.fbar.get('back').hide();
} else {
this.fbar.get('next').show();
this.fbar.get('cancel').show();
this.fbar.get('finish').hide();
}
if (activeItem.onNextText) {
this.fbar.get('next').setText(_S[activeItem.onNextText]);
this.fbar.get('next').qInternationalKey = activeItem.onNextText;
} else {
this.fbar.get('next').setText(_S.QUICK09_STR09);
this.fbar.get('next').qInternationalKey = 'QUICK09_STR09';
}
},
onCancel: function () {
this.close();
},
finish: function () {
try {
var activeItem = this.content.layout.activeItem;
activeItem.onSave();
} catch (e) {}
this.onFinish();
this.close();
},
onFinish: function () {
this.stepIndex = 0;
this.stepIds = [];
},
getNextId: function (item) {
if (Ext.isFunction(item.getNextId)) {
return item.getNextId();
} else {
return item.nextId;
}
},
app: this,
icon: String.format(QNAP.QOS.lib.getAppInfo(this.tag).icon, 24),
minimizable: true,
minWidth: 300,
width: this.defaultWidth,
minHeight: 200,
height: this.defaultHeight,
qInternational: true,
minimizable: false
});
Ext.apply(config, items);
Ext.applyIf(config, {
baseCls: 'wizard-middle',
footer: true,
closable: false,
bodyCfg: {
children: [{
tag: 'div',
cls: 'body-under-line'
}]
}
});
if (Ext.isObject(ajax_info)) QNAP.QOS.ajax(ajax_info);
return config;
},
activeApp: function (config) {
var me = this;

switch (config.category) {
case 'wUser':
me._getMainWindow().setTitle(_S.HOME_STR01);
me._getMainWindow().defaultTitle = _S.HOME_STR01;
me._getMainWindow().qInternationalKey = 'HOME_STR01';
break;
case 'wMultipleUsers':
me._getMainWindow().setTitle(_S.MULTI_USER_WIZ);
me._getMainWindow().defaultTitle = _S.MULTI_USER_WIZ;
me._getMainWindow().qInternationalKey = 'MULTI_USER_WIZ';
break;
case 'wUserGroup':
me._getMainWindow().setTitle(_S.HOME_STR03);
me._getMainWindow().defaultTitle = _S.HOME_STR03;
me._getMainWindow().qInternationalKey = 'HOME_STR03';
break;
case 'wShardFolder':
me._getMainWindow().setTitle(_S.SHARE_CREATE_WIZ);
me._getMainWindow().defaultTitle = _S.SHARE_CREATE_WIZ;
me._getMainWindow().qInternationalKey = 'SHARE_CREATE_WIZ';
break;
case 'wRemoteReplication':
me._getMainWindow().setTitle(_S.S_MENU_63);
me._getMainWindow().defaultTitle = _S.S_MENU_63;
me._getMainWindow().qInternationalKey = 'S_MENU_63';
break;
case 'wMyColudNAS':
me._getMainWindow().setTitle(_S.MYCLOUDNAS_WIZARD_TITLE);
me._getMainWindow().defaultTitle = _S.MYCLOUDNAS_WIZARD_TITLE;
me._getMainWindow().qInternationalKey = 'MYCLOUDNAS_WIZARD_TITLE';
break;
}
},
initComplete: function () {
this.winApp = this._getApp();
this.win = this.winApp._getMainWindow();
}
});

QNAP.QOS.quickWizard.fn = Ext.extend(
Object, {
panel: null,
constructor: Ext.emptyFn,
initFn: Ext.emptyFn,
beforeLoad: Ext.emptyFn,
loadForm: Ext.emptyFn,
createPanel: Ext.emptyFn,
getPanelMain: Ext.emptyFn,
beforeAction: Ext.emptyFn,
reload: Ext.emptyFn,
onClose: Ext.emptyFn,
getPanel: function () {
return this.panel
}
});

QNAP.QOS.quickWizard.RaidStatus = {
"-13": 'IEI_DEVICE_MSG61',//Stopping...
"-9" : 'IEI_NAS_STORAGE167',//Disk Read/Write Error
"-7" : 'VOLUME_MANAGEMENT_STR_05',//"degraded";
"-6" : 'IEI_NAS_STORAGE23',//Invalid
"-5" : 'IEI_NAS_STORAGE22',//No Disk
"-3" : 'IEI_NAS_STORAGE21',//unmounted
"-2" : 'IEI_NAS_STORAGE20',//"Error - Not Active",
"-1" : 'IEI_NAS_STORAGE30',//Uninitialized
"0"  : 'IEI_NAS_STORAGE14',//ready
"1"  : 'IEI_NAS_STORAGE24',//Not Ready - Initializing...'
"2"  : 'IEI_NAS_STORAGE25',
"3"  : 'IEI_NAS_STORAGE35',//Checking...
"4"  : 'IEI_NAS_STORAGE27',//Creating...
"5"  : 'IEI_NAS_STORAGE28',//Removing...
"6"  : 'IEI_NAS_STORAGE29',//rebuilding
"12" : 'IEI_NAS_STORAGE209',//Global Spare
"15" : 'IEI_NAS_STORAGE173',//Synchronizing
"16" : 'IEI_DEVICE_MSG62',//Read-only
"17" : 'IEI_NAS_STORAGE174',//Expanding…
"18" : 'IEI_NAS_STORAGE183',//Migrating…
"19" : 'IEI_NAS_STORAGE208',//Not Ready - Recovering…
"20" : 'IEI_NAS_STORAGE183',//Migrating…
"30" : 'VOLUME_MANAGEMENT_STR_02'//Error - Missing Mode
}
